/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],le=function(x){for(var e=[],n=0,r=x.length;n<r;n++)e[n]=ce[x[n]];return e};define(ce[138],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.LoaderEventType=e.$S=e.$R=void 0,e.$R=!1,e.$S=!0;var n;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(n||(e.LoaderEventType=n={}));class r{static get(){const A=new Map,O=new Map,I=new Map,p=new Map;function c(f,d){f.has(d.detail)||f.set(d.detail,-d.timestamp)}function g(f,d){const v=f.get(d.detail);v&&(v>=0||f.set(d.detail,v+d.timestamp))}let u=[];typeof x=="function"&&typeof x.getStats=="function"&&(u=x.getStats().slice(0).sort((f,d)=>f.timestamp-d.timestamp));for(const f of u)switch(f.type){case n.BeginLoadingScript:c(A,f);break;case n.EndLoadingScriptOK:case n.EndLoadingScriptError:g(A,f);break;case n.BeginInvokeFactory:c(O,f);break;case n.EndInvokeFactory:g(O,f);break;case n.NodeBeginNativeRequire:c(I,f);break;case n.NodeEndNativeRequire:g(I,f);break;case n.NodeBeginEvaluatingScript:c(p,f);break;case n.NodeEndEvaluatingScript:g(p,f);break}let m=0;I.forEach(f=>m+=f);function w(f){const d=[];return f.forEach((v,b)=>d.push([b,v])),d}return{amdLoad:w(A),amdInvoke:w(O),nodeRequire:w(I),nodeEval:w(p),nodeRequireTotal:m}}static toMarkdownTable(A,O){let I="";const p=[];return A.forEach((c,g)=>{p[g]=c.length}),O.forEach(c=>{c.forEach((g,u)=>{typeof g>"u"&&(g=c[u]="-");const m=g.toString().length;p[u]=Math.max(m,p[u])})}),A.forEach((c,g)=>{I+=`| ${c+" ".repeat(p[g]-c.toString().length)} `}),I+=`|
`,A.forEach((c,g)=>{I+=`| ${"-".repeat(p[g])} `}),I+=`|
`,O.forEach(c=>{c.forEach((g,u)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(p[u]-g.toString().length)} `)}),I+=`|
`}),I}}e.$T=r}),define(ce[139],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=r,e.$hb=E,e.$ib=A,e.$jb=O,e.$kb=I,e.$lb=p,e.$nb=g,e.$ob=u,e.$pb=m,e.$qb=w,e.$rb=f;function n(d,v){const b=r(d,v);if(b!==-1)return d[b]}function r(d,v,b=d.length-1){for(let $=b;$>=0;$--){const k=d[$];if(v(k))return $}return-1}function E(d,v){const b=A(d,v);return b===-1?void 0:d[b]}function A(d,v,b=0,$=d.length){let k=b,S=$;for(;k<S;){const i=Math.floor((k+S)/2);v(d[i])?k=i+1:S=i}return k-1}function O(d,v){const b=I(d,v);return b===d.length?void 0:d[b]}function I(d,v,b=0,$=d.length){let k=b,S=$;for(;k<S;){const i=Math.floor((k+S)/2);v(d[i])?S=i:k=i+1}return k}function p(d,v,b=0,$=d.length){const k=I(d,v,b,$);return k===d.length?-1:k}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=A(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$mb=c;function g(d,v){if(d.length===0)return;let b=d[0];for(let $=1;$<d.length;$++){const k=d[$];v(k,b)>0&&(b=k)}return b}function u(d,v){if(d.length===0)return;let b=d[0];for(let $=1;$<d.length;$++){const k=d[$];v(k,b)>=0&&(b=k)}return b}function m(d,v){return g(d,(b,$)=>-v(b,$))}function w(d,v){if(d.length===0)return-1;let b=0;for(let $=1;$<d.length;$++){const k=d[$];v(k,d[b])>0&&(b=$)}return b}function f(d,v){for(const b of d){const $=v(b);if($!==void 0)return $}}}),define(ce[39],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ce[140],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=E,e.$e=A,e.$f=O;function r(p,c){const g=Object.create(null);for(const u of p){const m=c(u);let w=g[m];w||(w=g[m]=[]),w.push(u)}return g}function E(p,c){const g=[],u=[];for(const m of p)c.has(m)||g.push(m);for(const m of c)p.has(m)||u.push(m);return{removed:g,added:u}}function A(p,c){const g=[],u=[];for(const[m,w]of p)c.has(m)||g.push(w);for(const[m,w]of c)p.has(m)||u.push(w);return{removed:g,added:u}}function O(p,c){const g=new Set;for(const u of c)p.has(u)&&g.add(u);return g}class I{static{n=Symbol.toStringTag}constructor(c,g){this.b=g,this.a=new Map,this[n]="SetWithKey";for(const u of c)this.add(u)}get size(){return this.a.size}add(c){const g=this.b(c);return this.a.set(g,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,g){this.a.forEach(u=>c.call(g,u,u,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(ce[141],le([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$qu=e.$pu=e.$ou=void 0;function r(p,c){const g=Math.pow(10,c);return Math.round(p*g)/g}class E{constructor(c,g,u,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.r===g.r&&c.g===g.g&&c.b===g.b&&c.a===g.a}}e.$ou=E;class A{constructor(c,g,u,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.l=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.l===g.l&&c.a===g.a}static fromRGBA(c){const g=c.r/255,u=c.g/255,m=c.b/255,w=c.a,f=Math.max(g,u,m),d=Math.min(g,u,m);let v=0,b=0;const $=(d+f)/2,k=f-d;if(k>0){switch(b=Math.min($<=.5?k/(2*$):k/(2-2*$),1),f){case g:v=(u-m)/k+(u<m?6:0);break;case u:v=(m-g)/k+2;break;case m:v=(g-u)/k+4;break}v*=60,v=Math.round(v)}return new A(v,b,$,w)}static i(c,g,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?c+(g-c)*6*u:u<1/2?g:u<2/3?c+(g-c)*(2/3-u)*6:c}static toRGBA(c){const g=c.h/360,{s:u,l:m,a:w}=c;let f,d,v;if(u===0)f=d=v=m;else{const b=m<.5?m*(1+u):m+u-m*u,$=2*m-b;f=A.i($,b,g+1/3),d=A.i($,b,g),v=A.i($,b,g-1/3)}return new E(Math.round(f*255),Math.round(d*255),Math.round(v*255),w)}}e.$pu=A;class O{constructor(c,g,u,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.v=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.v===g.v&&c.a===g.a}static fromRGBA(c){const g=c.r/255,u=c.g/255,m=c.b/255,w=Math.max(g,u,m),f=Math.min(g,u,m),d=w-f,v=w===0?0:d/w;let b;return d===0?b=0:w===g?b=((u-m)/d%6+6)%6:w===u?b=(m-g)/d+2:b=(g-u)/d+4,new O(Math.round(b*60),v,w,c.a)}static toRGBA(c){const{h:g,s:u,v:m,a:w}=c,f=m*u,d=f*(1-Math.abs(g/60%2-1)),v=m-f;let[b,$,k]=[0,0,0];return g<60?(b=f,$=d):g<120?(b=d,$=f):g<180?($=f,k=d):g<240?($=d,k=f):g<300?(b=d,k=f):g<=360&&(b=f,k=d),b=Math.round((b+v)*255),$=Math.round(($+v)*255),k=Math.round((k+v)*255),new E(b,$,k,w)}}e.$qu=O;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,g){return!c&&!g?!0:!c||!g?!1:c.equals(g)}get hsla(){return this.i?this.i:A.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof E)this.rgba=c;else if(c instanceof A)this.i=c,this.rgba=A.toRGBA(c);else if(c instanceof O)this.j=c,this.rgba=O.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&E.equals(this.rgba,c.rgba)&&A.equals(this.hsla,c.hsla)&&O.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),g=I.k(this.rgba.g),u=I.k(this.rgba.b),m=.2126*c+.7152*g+.0722*u;return r(m,4)}static k(c){const g=c/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(c){const g=this.getRelativeLuminance(),u=c.getRelativeLuminance();return g>u?(g+.05)/(u+.05):(u+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const g=this.getRelativeLuminance(),u=c.getRelativeLuminance();return g>u}isDarkerThan(c){const g=this.getRelativeLuminance(),u=c.getRelativeLuminance();return g<u}lighten(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:g,g:u,b:m,a:w}=this.rgba;return new I(new E(g,u,m,w*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new E(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const g=c.rgba,u=this.rgba.a,m=g.a,w=u+m*(1-u);if(w<1e-6)return I.transparent;const f=this.rgba.r*u/w+g.r*m*(1-u)/w,d=this.rgba.g*u/w+g.g*m*(1-u)/w,v=this.rgba.b*u/w+g.b*m*(1-u)/w;return new I(new E(f,d,v,w))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:g,g:u,b:m,a:w}=this.rgba;return new I(new E(c.rgba.r-w*(c.rgba.r-g),c.rgba.g-w*(c.rgba.g-u),c.rgba.b-w*(c.rgba.b-m),1))}flatten(...c){const g=c.reduceRight((u,m)=>I.o(m,u));return I.o(this,g)}static o(c,g){const u=1-c.rgba.a;return new I(new E(u*g.rgba.r+c.rgba.a*c.rgba.r,u*g.rgba.g+c.rgba.a*c.rgba.g,u*g.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,g,u){if(c.isLighterThan(g))return c;u=u||.5;const m=c.getRelativeLuminance(),w=g.getRelativeLuminance();return u=u*(w-m)/w,c.lighten(u)}static getDarkerColor(c,g,u){if(c.isDarkerThan(g))return c;u=u||.5;const m=c.getRelativeLuminance(),w=g.getRelativeLuminance();return u=u*(m-w)/m,c.darken(u)}static{this.white=new I(new E(255,255,255,1))}static{this.black=new I(new E(0,0,0,1))}static{this.red=new I(new E(255,0,0,1))}static{this.blue=new I(new E(0,0,255,1))}static{this.green=new I(new E(0,255,0,1))}static{this.cyan=new I(new E(0,255,255,1))}static{this.lightgrey=new I(new E(211,211,211,1))}static{this.transparent=new I(new E(0,0,0,0))}}e.$ru=I,function(p){let c;(function(g){let u;(function(m){function w(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:p.Format.CSS.formatRGBA(t)}m.formatRGB=w;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=f;function d(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(t)}m.formatHSL=d;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=v;function b(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}`}m.formatHex=$;function k(t,o=!1){return o&&t.rgba.a===1?p.Format.CSS.formatHex(t):`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}${b(Math.round(t.rgba.a*255))}`}m.formatHexA=k;function S(t){return t.isOpaque()?p.Format.CSS.formatHex(t):p.Format.CSS.formatRGBA(t)}m.format=S;function i(t){const o=t.length;if(o===0||t.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),a=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),l=16*h(t.charCodeAt(5))+h(t.charCodeAt(6));return new p(new E(s,a,l,1))}if(o===9){const s=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),a=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),l=16*h(t.charCodeAt(5))+h(t.charCodeAt(6)),P=16*h(t.charCodeAt(7))+h(t.charCodeAt(8));return new p(new E(s,a,l,P/255))}if(o===4){const s=h(t.charCodeAt(1)),a=h(t.charCodeAt(2)),l=h(t.charCodeAt(3));return new p(new E(16*s+s,16*a+a,16*l+l))}if(o===5){const s=h(t.charCodeAt(1)),a=h(t.charCodeAt(2)),l=h(t.charCodeAt(3)),P=h(t.charCodeAt(4));return new p(new E(16*s+s,16*a+a,16*l+l,(16*P+P)/255))}return null}m.parseHex=i;function h(t){switch(t){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(u=g.CSS||(g.CSS={}))})(c=p.Format||(p.Format={}))}(I||(e.$ru=I={}))}),define(ce[54],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=r,e.$_h=E,e.$ai=A;function n(O){return(I,p,c)=>{let g=null,u=null;if(typeof c.value=="function"?(g="value",u=c.value):typeof c.get=="function"&&(g="get",u=c.get),!u)throw new Error("not supported");c[g]=O(u,p)}}function r(O,I,p){let c=null,g=null;if(typeof p.value=="function"?(c="value",g=p.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",g=p.get),!g)throw new Error("not supported");const u=`$memoize$${I}`;p[c]=function(...m){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[u]}}function E(O,I,p){return n((c,g)=>{const u=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...w){this[m]||(this[m]=p?p():void 0),clearTimeout(this[u]),I&&(this[m]=I(this[m],...w),w=[this[m]]),this[u]=setTimeout(()=>{c.apply(this,w),this[m]=p?p():void 0},O)}})}function A(O,I,p){return n((c,g)=>{const u=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,w=`$throttle$lastRun$${g}`,f=`$throttle$pending$${g}`;return function(...d){if(this[m]||(this[m]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...d)),this[f])return;const v=this[w]+O;v<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[m]]),this[m]=p?p():void 0):(this[f]=!0,this[u]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),c.apply(this,[this[m]]),this[m]=p?p():void 0},v-Date.now()))}})}}),define(ce[15],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$W=e.$V=void 0,e.setUnexpectedErrorHandler=r,e.$Y=E,e.$Z=A,e.$1=O,e.$2=I,e.$3=p,e.$4=g,e.$6=m,e.$7=w,e.$8=f,e.$0=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?S.isErrorNoTelemetry(t)?new S(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=n,e.$W=new n;function r(h){e.$W.setUnexpectedErrorHandler(h)}function E(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(h){g(h)||e.$W.onUnexpectedError(h)}function O(h){g(h)||e.$W.onUnexpectedExternalError(h)}function I(h){if(h instanceof Error){const{name:t,message:o}=h,s=h.stacktrace||h.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:S.isErrorNoTelemetry(h)}}return h}function p(h){let t;return h.noTelemetry?t=new S:(t=new Error,t.name=h.name),t.message=h.message,t.stack=h.stack,t}const c="Canceled";function g(h){return h instanceof u?!0:h instanceof Error&&h.name===c&&h.message===c}class u extends Error{constructor(){super(c),this.name=this.message}}e.$5=u;function m(){const h=new Error(c);return h.name=h.message,h}function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function v(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=b;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=k;class S extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof S)return t;const o=new S;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=S;class i extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,i.prototype)}}e.$cb=i}),define(ce[21],le([0,1,15,139]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=E,e.$tb=A,e.$ub=O,e.$vb=I,e.$wb=p,e.$xb=c,e.$yb=g,e.$zb=u,e.$Ab=m,e.$Bb=w,e.$Cb=f,e.$Db=d,e.$Eb=v,e.top=b,e.$Gb=$,e.$Hb=S,e.$Ib=i,e.$Jb=h,e.$Kb=t,e.$Lb=o,e.$Mb=s,e.$Nb=a,e.$Ob=l,e.$Pb=P,e.$Qb=y,e.$Rb=D,e.$Sb=L,e.$Tb=R,e.$Ub=T,e.$Vb=N,e.$Wb=V,e.$Xb=H,e.$Yb=Y,e.$Zb=de,e.$1b=q,e.$2b=Q,e.$3b=U,e.$4b=Z,e.$5b=W,e.$6b=X,e.$7b=oe,e.$0b=re,e.$bc=_;function E(z,ie=0){return z[z.length-(1+ie)]}function A(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function O(z,ie,K=(B,te)=>B===te){if(z===ie)return!0;if(!z||!ie||z.length!==ie.length)return!1;for(let B=0,te=z.length;B<te;B++)if(!K(z[B],ie[B]))return!1;return!0}function I(z,ie){const K=z.length-1;ie<K&&(z[ie]=z[K]),z.pop()}function p(z,ie,K){return c(z.length,B=>K(z[B],ie))}function c(z,ie){let K=0,B=z-1;for(;K<=B;){const te=(K+B)/2|0,he=ie(te);if(he<0)K=te+1;else if(he>0)B=te-1;else return te}return-(K+1)}function g(z,ie,K){if(z=z|0,z>=ie.length)throw new TypeError("invalid index");const B=ie[Math.floor(ie.length*Math.random())],te=[],he=[],me=[];for(const we of ie){const Ie=K(we,B);Ie<0?te.push(we):Ie>0?he.push(we):me.push(we)}return z<te.length?g(z,te,K):z<te.length+me.length?me[0]:g(z-(te.length+me.length),he,K)}function u(z,ie){const K=[];let B;for(const te of z.slice(0).sort(ie))!B||ie(B[0],te)!==0?(B=[te],K.push(B)):B.push(te);return K}function*m(z,ie){let K,B;for(const te of z)B!==void 0&&ie(B,te)?K.push(te):(K&&(yield K),K=[te]),B=te;K&&(yield K)}function w(z,ie){for(let K=0;K<=z.length;K++)ie(K===0?void 0:z[K-1],K===z.length?void 0:z[K])}function f(z,ie){for(let K=0;K<z.length;K++)ie(K===0?void 0:z[K-1],z[K],K+1===z.length?void 0:z[K+1])}function d(z,ie,K){const B=[];function te(we,Ie,Ce){if(Ie===0&&Ce.length===0)return;const De=B[B.length-1];De&&De.start+De.deleteCount===we?(De.deleteCount+=Ie,De.toInsert.push(...Ce)):B.push({start:we,deleteCount:Ie,toInsert:Ce})}let he=0,me=0;for(;;){if(he===z.length){te(he,0,ie.slice(me));break}if(me===ie.length){te(he,z.length-he,[]);break}const we=z[he],Ie=ie[me],Ce=K(we,Ie);Ce===0?(he+=1,me+=1):Ce<0?(te(he,1,[]),he+=1):Ce>0&&(te(he,0,[Ie]),me+=1)}return B}function v(z,ie,K){const B=d(z,ie,K),te=[],he=[];for(const me of B)te.push(...z.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:te,added:he}}function b(z,ie,K){if(K===0)return[];const B=z.slice(0,K).sort(ie);return k(z,ie,B,K,z.length),B}function $(z,ie,K,B,te){return K===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const we=z.length,Ie=z.slice(0,K).sort(ie);for(let Ce=K,De=Math.min(K+B,we);Ce<we;Ce=De,De=Math.min(De+B,we)){if(Ce>K&&await new Promise(ve=>setTimeout(ve)),te&&te.isCancellationRequested)throw new n.$5;k(z,ie,Ie,Ce,De)}return Ie})().then(he,me)})}function k(z,ie,K,B,te){for(const he=K.length;B<te;B++){const me=z[B];if(ie(me,K[he-1])<0){K.pop();const we=(0,r.$kb)(K,Ie=>ie(me,Ie)<0);K.splice(we,0,me)}}}function S(z){return z.filter(ie=>!!ie)}function i(z){let ie=0;for(let K=0;K<z.length;K++)z[K]&&(z[ie]=z[K],ie+=1);z.length=ie}function h(z,ie,K){z.splice(K,0,z.splice(ie,1)[0])}function t(z){return!Array.isArray(z)||z.length===0}function o(z){return Array.isArray(z)&&z.length>0}function s(z,ie=K=>K){const K=new Set;return z.filter(B=>{const te=ie(B);return K.has(te)?!1:(K.add(te),!0)})}function a(z){const ie=new Set;return K=>{const B=z(K);return ie.has(B)?!1:(ie.add(B),!0)}}function l(z,ie){return z.length>0?z[0]:ie}function P(z,ie){return z.length>0?z[z.length-1]:ie}function y(z,ie,K=(B,te)=>B===te){let B=0;for(let te=0,he=Math.min(z.length,ie.length);te<he&&K(z[te],ie[te]);te++)B++;return B}function D(z,ie){let K=typeof ie=="number"?z:0;typeof ie=="number"?K=z:(K=0,ie=z);const B=[];if(K<=ie)for(let te=K;te<ie;te++)B.push(te);else for(let te=K;te>ie;te--)B.push(te);return B}function L(z,ie,K){return z.reduce((B,te)=>(B[ie(te)]=K?K(te):te,B),Object.create(null))}function R(z,ie){return z.push(ie),()=>T(z,ie)}function T(z,ie){const K=z.indexOf(ie);if(K>-1)return z.splice(K,1),ie}function N(z,ie,K){const B=z.slice(0,ie),te=z.slice(ie);return B.concat(K,te)}function V(z,ie){let K;if(typeof ie=="number"){let B=ie;K=()=>{const te=Math.sin(B++)*179426549;return te-Math.floor(te)}}else K=Math.random;for(let B=z.length-1;B>0;B-=1){const te=Math.floor(K()*(B+1)),he=z[B];z[B]=z[te],z[te]=he}}function H(z,ie){const K=z.indexOf(ie);K>-1&&(z.splice(K,1),z.unshift(ie))}function Y(z,ie){const K=z.indexOf(ie);K>-1&&(z.splice(K,1),z.push(ie))}function de(z,ie){for(const K of ie)z.push(K)}function q(z,ie){return Array.isArray(z)?z.map(ie):ie(z)}function Q(z){return Array.isArray(z)?z:[z]}function U(z){return z[Math.floor(Math.random()*z.length)]}function Z(z,ie,K){const B=j(z,ie),te=z.length,he=K.length;z.length=te+he;for(let me=te-1;me>=B;me--)z[me+he]=z[me];for(let me=0;me<he;me++)z[me+B]=K[me]}function W(z,ie,K,B){const te=j(z,ie);let he=z.splice(te,K);return he===void 0&&(he=[]),Z(z,te,B),he}function j(z,ie){return ie<0?Math.max(ie+z.length,0):Math.min(ie,z.length)}var C;(function(z){function ie(he){return he<0}z.isLessThan=ie;function K(he){return he<=0}z.isLessThanOrEqual=K;function B(he){return he>0}z.isGreaterThan=B;function te(he){return he===0}z.isNeitherLessOrGreaterThan=te,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(C||(e.CompareResult=C={}));function X(z,ie){return(K,B)=>ie(z(K),z(B))}function oe(...z){return(ie,K)=>{for(const B of z){const te=B(ie,K);if(!C.isNeitherLessOrGreaterThan(te))return te}return C.neitherLessOrGreaterThan}}const G=(z,ie)=>z-ie;e.$8b=G;const ue=(z,ie)=>(0,e.$8b)(z?1:0,ie?1:0);e.$9b=ue;function re(z){return(ie,K)=>-z(ie,K)}class J{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let K=this.c;for(;K<this.g.length&&ie(this.g[K]);)K++;const B=K===this.c?null:this.g.slice(this.c,K);return this.c=K,B}takeFromEndWhile(ie){let K=this.d;for(;K>=0&&ie(this.g[K]);)K--;const B=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const K=this.g.slice(this.c,this.c+ie);return this.c+=ie,K}}e.$$b=J;class M{static{this.empty=new M(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(K=>(ie(K),!0))}toArray(){const ie=[];return this.iterate(K=>(ie.push(K),!0)),ie}filter(ie){return new M(K=>this.iterate(B=>ie(B)?K(B):!0))}map(ie){return new M(K=>this.iterate(B=>K(ie(B))))}some(ie){let K=!1;return this.iterate(B=>(K=ie(B),!K)),K}findFirst(ie){let K;return this.iterate(B=>ie(B)?(K=B,!1):!0),K}findLast(ie){let K;return this.iterate(B=>(ie(B)&&(K=B),!0)),K}findLastMaxBy(ie){let K,B=!0;return this.iterate(te=>((B||C.isGreaterThan(ie(te,K)))&&(B=!1,K=te),!0)),K}}e.$_b=M;class F{constructor(ie){this.c=ie}static createSortPermutation(ie,K){const B=Array.from(ie.keys()).sort((te,he)=>K(ie[te],ie[he]));return new F(B)}apply(ie){return ie.map((K,B)=>ie[this.c[B]])}inverse(){const ie=this.c.slice();for(let K=0;K<this.c.length;K++)ie[this.c[K]]=K;return new F(ie)}}e.$ac=F;async function _(z,ie){return(await Promise.all(z.map(async(B,te)=>({element:B,ok:await ie(B,te)})))).find(B=>B.ok)?.element}}),define(ce[142],le([0,1,15]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$fd=E,e.$gd=A,e.$hd=O,e.$id=I,e.$jd=p;function r(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function E(c,g="Unreachable"){throw new Error(g)}function A(c,g="unexpected state"){if(!c)throw new n.$cb(`Assertion Failed: ${g}`)}function O(c){c||(0,n.$Z)(new n.$cb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Z)(new n.$cb("Assertion Failed"))}}function p(c,g){let u=0;for(;u<c.length-1;){const m=c[u],w=c[u+1];if(!g(m,w))return!1;u++}return!0}}),define(ce[89],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(r,E){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,E)try{I=r.apply(A,arguments)}finally{E()}else I=r.apply(A,arguments);return I}}}),define(ce[77],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=E;const A=Object.freeze([]);function O(){return A}r.empty=O;function*I(t){yield t}r.single=I;function p(t){return E(t)?t:I(t)}r.wrap=p;function c(t){return t||A}r.from=c;function*g(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=g;function u(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=u;function m(t){return t[Symbol.iterator]().next().value}r.first=m;function w(t,o){let s=0;for(const a of t)if(o(a,s++))return!0;return!1}r.some=w;function f(t,o){for(const s of t)if(o(s))return s}r.find=f;function*d(t,o){for(const s of t)o(s)&&(yield s)}r.filter=d;function*v(t,o){let s=0;for(const a of t)yield o(a,s++)}r.map=v;function*b(t,o){let s=0;for(const a of t)yield*o(a,s++)}r.flatMap=b;function*$(...t){for(const o of t)yield*o}r.concat=$;function k(t,o,s){let a=s;for(const l of t)a=o(a,l);return a}r.reduce=k;function*S(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}r.slice=S;function i(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const a=t[Symbol.iterator]();for(let l=0;l<o;l++){const P=a.next();if(P.done)return[s,r.empty()];s.push(P.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=i;async function h(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}r.asyncToArray=h})(n||(e.Iterable=n={}))}),define(ce[43],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=O,e.$Yn=u,e.$Zn=m,e.$1n=w,e.$2n=f,e.$3n=d,e.$4n=v,e.$5n=b,e.$6n=$,e.$7n=k,e.$8n=S;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(i,h=!1){let t=0;const o=i.length;let s="",a=0,l=r.Unknown,P=n.None;function y(H){let Y=0,de=0;for(;Y<H;){const q=i.charCodeAt(t);if(q>=g._0&&q<=g._9)de=de*16+q-g._0;else if(q>=g.A&&q<=g.F)de=de*16+q-g.A+10;else if(q>=g.a&&q<=g.f)de=de*16+q-g.a+10;else break;t++,Y++}return Y<H&&(de=-1),de}function D(H){t=H,s="",a=0,l=r.Unknown,P=n.None}function L(){const H=t;if(i.charCodeAt(t)===g._0)t++;else for(t++;t<i.length&&c(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===g.dot)if(t++,t<i.length&&c(i.charCodeAt(t)))for(t++;t<i.length&&c(i.charCodeAt(t));)t++;else return P=n.UnexpectedEndOfNumber,i.substring(H,t);let Y=t;if(t<i.length&&(i.charCodeAt(t)===g.E||i.charCodeAt(t)===g.e))if(t++,(t<i.length&&i.charCodeAt(t)===g.plus||i.charCodeAt(t)===g.minus)&&t++,t<i.length&&c(i.charCodeAt(t))){for(t++;t<i.length&&c(i.charCodeAt(t));)t++;Y=t}else P=n.UnexpectedEndOfNumber;return i.substring(H,Y)}function R(){let H="",Y=t;for(;;){if(t>=o){H+=i.substring(Y,t),P=n.UnexpectedEndOfString;break}const de=i.charCodeAt(t);if(de===g.doubleQuote){H+=i.substring(Y,t),t++;break}if(de===g.backslash){if(H+=i.substring(Y,t),t++,t>=o){P=n.UnexpectedEndOfString;break}switch(i.charCodeAt(t++)){case g.doubleQuote:H+='"';break;case g.backslash:H+="\\";break;case g.slash:H+="/";break;case g.b:H+="\b";break;case g.f:H+="\f";break;case g.n:H+=`
`;break;case g.r:H+="\r";break;case g.t:H+="	";break;case g.u:{const Q=y(4);Q>=0?H+=String.fromCharCode(Q):P=n.InvalidUnicode;break}default:P=n.InvalidEscapeCharacter}Y=t;continue}if(de>=0&&de<=31)if(p(de)){H+=i.substring(Y,t),P=n.UnexpectedEndOfString;break}else P=n.InvalidCharacter;t++}return H}function T(){if(s="",P=n.None,a=t,t>=o)return a=o,l=r.EOF;let H=i.charCodeAt(t);if(I(H)){do t++,s+=String.fromCharCode(H),H=i.charCodeAt(t);while(I(H));return l=r.Trivia}if(p(H))return t++,s+=String.fromCharCode(H),H===g.carriageReturn&&i.charCodeAt(t)===g.lineFeed&&(t++,s+=`
`),l=r.LineBreakTrivia;switch(H){case g.openBrace:return t++,l=r.OpenBraceToken;case g.closeBrace:return t++,l=r.CloseBraceToken;case g.openBracket:return t++,l=r.OpenBracketToken;case g.closeBracket:return t++,l=r.CloseBracketToken;case g.colon:return t++,l=r.ColonToken;case g.comma:return t++,l=r.CommaToken;case g.doubleQuote:return t++,s=R(),l=r.StringLiteral;case g.slash:{const Y=t-1;if(i.charCodeAt(t+1)===g.slash){for(t+=2;t<o&&!p(i.charCodeAt(t));)t++;return s=i.substring(Y,t),l=r.LineCommentTrivia}if(i.charCodeAt(t+1)===g.asterisk){t+=2;const de=o-1;let q=!1;for(;t<de;){if(i.charCodeAt(t)===g.asterisk&&i.charCodeAt(t+1)===g.slash){t+=2,q=!0;break}t++}return q||(t++,P=n.UnexpectedEndOfComment),s=i.substring(Y,t),l=r.BlockCommentTrivia}return s+=String.fromCharCode(H),t++,l=r.Unknown}case g.minus:if(s+=String.fromCharCode(H),t++,t===o||!c(i.charCodeAt(t)))return l=r.Unknown;case g._0:case g._1:case g._2:case g._3:case g._4:case g._5:case g._6:case g._7:case g._8:case g._9:return s+=L(),l=r.NumericLiteral;default:for(;t<o&&N(H);)t++,H=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(H),t++,l=r.Unknown}}function N(H){if(I(H)||p(H))return!1;switch(H){case g.closeBrace:case g.closeBracket:case g.openBrace:case g.openBracket:case g.doubleQuote:case g.colon:case g.comma:case g.slash:return!1}return!0}function V(){let H;do H=T();while(H>=r.LineCommentTrivia&&H<=r.Trivia);return H}return{setPosition:D,getPosition:()=>t,scan:h?V:T,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>P}}function I(i){return i===g.space||i===g.tab||i===g.verticalTab||i===g.formFeed||i===g.nonBreakingSpace||i===g.ogham||i>=g.enQuad&&i<=g.zeroWidthSpace||i===g.narrowNoBreakSpace||i===g.mathematicalSpace||i===g.ideographicSpace||i===g.byteOrderMark}function p(i){return i===g.lineFeed||i===g.carriageReturn||i===g.lineSeparator||i===g.paragraphSeparator}function c(i){return i>=g._0&&i<=g._9}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function u(i,h){const t=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(y,D,L,R){a.value=y,a.offset=D,a.length=L,a.type=R,a.colonOffset=void 0,s=a}try{k(i,{onObjectBegin:(y,D)=>{if(h<=y)throw o;s=void 0,l=h>y,t.push("")},onObjectProperty:(y,D,L)=>{if(h<D||(P(y,D,L,"property"),t[t.length-1]=y,h<=D+L))throw o},onObjectEnd:(y,D)=>{if(h<=y)throw o;s=void 0,t.pop()},onArrayBegin:(y,D)=>{if(h<=y)throw o;s=void 0,t.push(0)},onArrayEnd:(y,D)=>{if(h<=y)throw o;s=void 0,t.pop()},onLiteralValue:(y,D,L)=>{if(h<D||(P(y,D,L,S(y)),h<=D+L))throw o},onSeparator:(y,D,L)=>{if(h<=D)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=D,l=!1,s=void 0;else if(y===","){const R=t[t.length-1];typeof R=="number"?t[t.length-1]=R+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:t,previousNode:s,isAtPropertyKey:l,matches:y=>{let D=0;for(let L=0;D<y.length&&L<t.length;L++)if(y[D]===t[L]||y[D]==="*")D++;else if(y[D]!=="**")return!1;return D===y.length}}}function m(i,h=[],t=A.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return k(i,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,D,L)=>{h.push({error:y,offset:D,length:L})}},t),s[0]}function w(i,h=[],t=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}k(i,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,D,L)=>{o=a({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:D,length:L,parent:o})},onObjectEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onArrayBegin:(y,D)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onLiteralValue:(y,D,L)=>{a({type:S(y),offset:D,length:L,parent:o,value:y}),s(D+L)},onSeparator:(y,D,L)=>{o.type==="property"&&(y===":"?o.colonOffset=D:y===","&&s(D))},onError:(y,D,L)=>{h.push({error:y,offset:D,length:L})}},t);const P=o.children[0];return P&&delete P.parent,P}function f(i,h){if(!i)return;let t=i;for(const o of h)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===o){t=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function d(i){if(!i.parent||!i.parent.children)return[];const h=d(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;h.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&h.push(t)}return h}function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const h=Object.create(null);for(const t of i.children){const o=t.children[1];o&&(h[t.children[0].value]=v(o))}return h}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function b(i,h,t=!1){return h>=i.offset&&h<i.offset+i.length||t&&h===i.offset+i.length}function $(i,h,t=!1){if(b(i,h,t)){const o=i.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=h;s++){const a=$(o[s],h,t);if(a)return a}return i}}function k(i,h,t=A.DEFAULT){const o=O(i,!1);function s(X){return X?()=>X(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(X){return X?oe=>X(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(h.onObjectBegin),P=a(h.onObjectProperty),y=s(h.onObjectEnd),D=s(h.onArrayBegin),L=s(h.onArrayEnd),R=a(h.onLiteralValue),T=a(h.onSeparator),N=s(h.onComment),V=a(h.onError),H=t&&t.disallowComments,Y=t&&t.allowTrailingComma;function de(){for(;;){const X=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:q(E.InvalidUnicode);break;case n.InvalidEscapeCharacter:q(E.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:q(E.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:H||q(E.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:q(E.UnexpectedEndOfString);break;case n.InvalidCharacter:q(E.InvalidCharacter);break}switch(X){case r.LineCommentTrivia:case r.BlockCommentTrivia:H?q(E.InvalidCommentToken):N();break;case r.Unknown:q(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return X}}}function q(X,oe=[],G=[]){if(V(X),oe.length+G.length>0){let ue=o.getToken();for(;ue!==r.EOF;){if(oe.indexOf(ue)!==-1){de();break}else if(G.indexOf(ue)!==-1)break;ue=de()}}}function Q(X){const oe=o.getTokenValue();return X?R(oe):P(oe),de(),!0}function U(){switch(o.getToken()){case r.NumericLiteral:{let X=0;try{X=JSON.parse(o.getTokenValue()),typeof X!="number"&&(q(E.InvalidNumberFormat),X=0)}catch{q(E.InvalidNumberFormat)}R(X);break}case r.NullKeyword:R(null);break;case r.TrueKeyword:R(!0);break;case r.FalseKeyword:R(!1);break;default:return!1}return de(),!0}function Z(){return o.getToken()!==r.StringLiteral?(q(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(Q(!1),o.getToken()===r.ColonToken?(T(":"),de(),C()||q(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):q(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function W(){l(),de();let X=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||q(E.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBraceToken&&Y)break}else X&&q(E.CommaExpected,[],[]);Z()||q(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),X=!0}return y(),o.getToken()!==r.CloseBraceToken?q(E.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function j(){D(),de();let X=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||q(E.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBracketToken&&Y)break}else X&&q(E.CommaExpected,[],[]);C()||q(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),X=!0}return L(),o.getToken()!==r.CloseBracketToken?q(E.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function C(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return W();case r.StringLiteral:return Q(!0);default:return U()}}return de(),o.getToken()===r.EOF?t.allowEmptyContent?!0:(q(E.ValueExpected,[],[]),!1):C()?(o.getToken()!==r.EOF&&q(E.EndOfFileExpected,[],[]),!0):(q(E.ValueExpected,[],[]),!1)}function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[143],le([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=r,e.$0n=E,e.$$n=I,e.$_n=p;function r(c,g,u){let m,w,f,d,v;if(g){for(d=g.offset,v=d+g.length,f=d;f>0&&!p(c,f-1);)f--;let P=v;for(;P<c.length&&!p(c,P);)P++;w=c.substring(f,P),m=O(w,u)}else w=c,m=0,f=0,d=0,v=c.length;const b=I(u,c);let $=!1,k=0,S;u.insertSpaces?S=A(" ",u.tabSize||4):S="	";const i=(0,n.$Xn)(w,!1);let h=!1;function t(){return b+A(S,m+k)}function o(){let P=i.scan();for($=!1;P===n.SyntaxKind.Trivia||P===n.SyntaxKind.LineBreakTrivia;)$=$||P===n.SyntaxKind.LineBreakTrivia,P=i.scan();return h=P===n.SyntaxKind.Unknown||i.getTokenError()!==n.ScanError.None,P}const s=[];function a(P,y,D){!h&&y<v&&D>d&&c.substring(y,D)!==P&&s.push({offset:y,length:D-y,content:P})}let l=o();if(l!==n.SyntaxKind.EOF){const P=i.getTokenOffset()+f,y=A(S,m);a(y,f,P)}for(;l!==n.SyntaxKind.EOF;){let P=i.getTokenOffset()+i.getTokenLength()+f,y=o(),D="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const R=i.getTokenOffset()+f;a(" ",P,R),P=i.getTokenOffset()+i.getTokenLength()+f,D=y===n.SyntaxKind.LineCommentTrivia?t():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(k--,D=t());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(k--,D=t());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:k++,D=t();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:D=t();break;case n.SyntaxKind.BlockCommentTrivia:$?D=t():D=" ";break;case n.SyntaxKind.ColonToken:D=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){D="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?D=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(h=!0);break;case n.SyntaxKind.Unknown:h=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(D=t())}const L=i.getTokenOffset()+f;a(D,P,L),l=y}return s}function E(c,g){const u=JSON.stringify(c,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?u.replace(/\r\n|\r|\n/g,g.eol):u}function A(c,g){let u="";for(let m=0;m<g;m++)u+=c;return u}function O(c,g){let u=0,m=0;const w=g.tabSize||4;for(;u<c.length;){const f=c.charAt(u);if(f===" ")m++;else if(f==="	")m+=w;else break;u++}return Math.floor(m/w)}function I(c,g){for(let u=0;u<g.length;u++){const m=g.charAt(u);if(m==="\r")return u+1<g.length&&g.charAt(u+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return c&&c.eol||`
`}function p(c,g){return`\r
`.indexOf(c.charAt(g))!==-1}}),define(ce[107],le([0,1,43,143]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=E,e.$bo=A,e.$co=O,e.$do=I,e.$eo=p;function E(c,g,u){return A(c,g,void 0,u)}function A(c,g,u,m,w){const f=g.slice(),d=[],v=(0,n.$1n)(c,d);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$2n)(v,f),b===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const k=(0,n.$2n)(b,[$]);if(k!==void 0)if(u===void 0){if(!k.parent)throw new Error("Malformed AST");const S=b.children.indexOf(k.parent);let i,h=k.parent.offset+k.parent.length;if(S>0){const t=b.children[S-1];i=t.offset+t.length}else i=b.offset+1,b.children.length>1&&(h=b.children[1].offset);return O(c,{offset:i,length:h-i,content:""},m)}else return O(c,{offset:k.offset,length:k.length,content:JSON.stringify(u)},m);else{if(u===void 0)return[];const S=`${JSON.stringify($)}: ${JSON.stringify(u)}`,i=w?w(b.children.map(t=>t.children[0].value)):b.children.length;let h;if(i>0){const t=b.children[i-1];h={offset:t.offset+t.length,length:0,content:","+S}}else b.children.length===0?h={offset:b.offset+1,length:0,content:S}:h={offset:b.offset+1,length:0,content:S+","};return O(c,h,m)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(u!==void 0){const k=`${JSON.stringify(u)}`;let S;if(b.children.length===0||$===0)S={offset:b.offset+1,length:0,content:b.children.length===0?k:k+","};else{const i=$===-1||$>b.children.length?b.children.length:$,h=b.children[i-1];S={offset:h.offset+h.length,length:0,content:","+k}}return O(c,S,m)}else{const k=$,S=b.children[k];let i;if(b.children.length===1)i={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===k){const h=b.children[k-1],t=h.offset+h.length,o=b.offset+b.length;i={offset:t,length:o-2-t,content:""}}else i={offset:S.offset,length:b.children[k+1].offset-S.offset,content:""};return O(c,i,m)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return u===void 0?[]:O(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(u)},m)}function O(c,g,u){let m=I(c,g),w=g.offset,f=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;w>0&&!(0,r.$_n)(m,w-1);)w--;for(;f<m.length&&!(0,r.$_n)(m,f);)f++}const d=(0,r.$9n)(m,{offset:w,length:f-w},u);for(let b=d.length-1;b>=0;b--){const $=d[b];m=I(m,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(m.length-f)-w;return[{offset:w,length:v,content:m.substring(w,f)}]}function I(c,g){return c.substring(0,g.offset)+g.content+c.substring(g.offset+g.length)}function p(c,g){const u=g.slice(0).sort((w,f)=>{const d=w.offset-f.offset;return d===0?w.length-f.length:d});let m=c.length;for(let w=u.length-1;w>=0;w--){const f=u[w];if(f.offset+f.length<=m)c=I(c,f);else throw new Error("Overlapping edit");m=f.offset}return c}}),define(ce[144],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=n;function n(A){let O=!1;const I=new Map,p=new Map;if(E(A,d=>{if(A===d)return!0;const v=JSON.stringify(d);if(v.length<30)return!0;const b=I.get(v);if(!b){const $={schemas:[d]};return I.set(v,$),p.set(d,$),!0}return b.schemas.push(d),p.set(d,b),O=!0,!1}),I.clear(),!O)return JSON.stringify(A);let g="$defs";for(;A.hasOwnProperty(g);)g+="_";const u=[];function m(d){return JSON.stringify(d,(v,b)=>{if(b!==d){const $=p.get(b);if($&&$.schemas.length>1)return $.id||($.id=`_${u.length}`,u.push($.schemas[0])),{$ref:`#/${g}/${$.id}`}}return b})}const w=m(A),f=[];for(let d=0;d<u.length;d++)f.push(`"_${d}":${m(u[d])}`);return f.length?`${w.substring(0,w.length-1)},"${g}":{${f.join(",")}}}`:w}function r(A){return typeof A=="object"&&A!==null}function E(A,O){if(!A||typeof A!="object")return;const I=(...w)=>{for(const f of w)r(f)&&u.push(f)},p=(...w)=>{for(const f of w)if(r(f))for(const d in f){const v=f[d];r(v)&&u.push(v)}},c=(...w)=>{for(const f of w)if(Array.isArray(f))for(const d of f)r(d)&&u.push(d)},g=w=>{if(Array.isArray(w))for(const f of w)r(f)&&u.push(f);else r(w)&&u.push(w)},u=[A];let m=u.pop();for(;m;)O(m)&&(I(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),p(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),c(m.anyOf,m.allOf,m.oneOf,m.prefixItems),g(m.items)),m=u.pop()}}),function(){function x(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(E){return E.replace(e,function(A,O,I,p,c,g){if(p)return"";if(c){const u=c.length;return c[u-1]===`
`?c[u-2]==="\r"?`\r
`:`
`:""}else return g?A.substring(1):A})}function r(E){const A=n(E);try{return JSON.parse(A)}catch{const I=A.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:n,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[65],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class n{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=n}),define(ce[108],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(A){this.element=A,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let A=this.a;for(;A!==n.Undefined;){const O=A.next;A.prev=n.Undefined,A.next=n.Undefined,A=O}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new n(A);if(this.a===n.Undefined)this.a=I,this.b=I;else if(O){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==n.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==n.Undefined&&A.next!==n.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===n.Undefined&&A.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):A.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):A.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==n.Undefined;)yield A.element,A=A.next}}e.$6c=r}),define(ce[31],le([0,1]),function(x,e){"use strict";var n,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=O,e.$Ac=I,e.$Jc=S;function A(i,h,t){let o=i.get(h);return o===void 0&&(o=t,i.set(h,o)),o}function O(i){const h=[];return i.forEach((t,o)=>{h.push(`${o} => ${t}`)}),`Map(${i.size}) {${h.join(", ")}}`}function I(i){const h=[];return i.forEach(t=>{h.push(t)}),`Set(${i.size}) {${h.join(", ")}}`}class p{constructor(h,t){this.uri=h,this.value=t}}function c(i){return Array.isArray(i)}class g{static{this.c=h=>h.toString()}constructor(h,t){if(this[n]="ResourceMap",h instanceof g)this.d=new Map(h.d),this.e=t??g.c;else if(c(h)){this.d=new Map,this.e=t??g.c;for(const[o,s]of h)this.set(o,s)}else this.d=new Map,this.e=h??g.c}set(h,t){return this.d.set(this.e(h),new p(h,t)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,t){typeof t<"u"&&(h=h.bind(t));for(const[o,s]of this.d)h(s.value,s.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Bc=g;class u{constructor(h,t){this[r]="ResourceSet",!h||typeof h=="function"?this.c=new g(h):(this.c=new g(t),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,t){this.c.forEach((o,s)=>h.call(t,s,s,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=u;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class w{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,t=m.None){const o=this.c.get(h);if(o)return t!==m.None&&this.m(o,t),o.value}set(h,t,o=m.None){let s=this.c.get(h);if(s)s.value=t,o!==m.None&&this.m(s,o);else{switch(s={key:h,value:t,next:void 0,previous:void 0},o){case m.None:this.k(s);break;case m.AsOld:this.j(s);break;case m.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(h,s),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const t=this.c.get(h);if(t)return this.c.delete(h),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,t){const o=this.g;let s=this.d;for(;s;){if(t?h.bind(t)(s.value,s.key,this):h(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let t=this.d,o=this.size;for(;t&&o>h;)this.c.delete(t.key),t=t.next,o--;this.d=t,this.f=o,t&&(t.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let t=this.e,o=this.size;for(;t&&o>h;)this.c.delete(t.key),t=t.previous,o--;this.e=t,this.f=o,t&&(t.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const t=h.next,o=h.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}h.next=void 0,h.previous=void 0,this.g++}m(h,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==m.AsOld&&t!==m.AsNew)){if(t===m.AsOld){if(h===this.d)return;const o=h.next,s=h.previous;h===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(t===m.AsNew){if(h===this.e)return;const o=h.next,s=h.previous;h===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((t,o)=>{h.push([o,t])}),h}fromJSON(h){this.clear();for(const[t,o]of h)this.set(t,o)}}e.$Dc=w;class f extends w{constructor(h,t=1){super(),this.n=h,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,t=m.AsNew){return super.get(h,t)}peek(h){return super.get(h,m.None)}set(h,t){return super.set(h,t,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends f{constructor(h,t=1){super(h,t)}q(h){this.h(h)}set(h,t){return super.set(h,t),this.p(),this}}e.$Ec=d;class v extends f{constructor(h,t=1){super(h,t)}q(h){this.i(h)}set(h,t){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,t),this}}e.$Fc=v;class b{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let t=this.c.get(h)||0;return t===0?!1:(t--,t===0?this.c.delete(h):this.c.set(h,t),!0)}has(h){return this.c.has(h)}}e.$Gc=b;class ${constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[t,o]of h)this.set(t,o)}clear(){this.c.clear(),this.d.clear()}set(h,t){this.c.set(h,t),this.d.set(t,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const t=this.c.get(h);return t===void 0?!1:(this.c.delete(h),this.d.delete(t),!0)}forEach(h,t){this.c.forEach((o,s)=>{h.call(t,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=$;class k{constructor(){this.c=new Map}add(h,t){let o=this.c.get(h);o||(o=new Set,this.c.set(h,o)),o.add(t)}delete(h,t){const o=this.c.get(h);o&&(o.delete(t),o.size===0&&this.c.delete(h))}forEach(h,t){const o=this.c.get(h);o&&o.forEach(t)}get(h){const t=this.c.get(h);return t||new Set}}e.$Ic=k;function S(i,h){if(i===h)return!0;if(i.size!==h.size)return!1;for(const[t,o]of i)if(!h.has(t)||h.get(t)!==o)return!1;for(const[t]of h)if(!i.has(t))return!1;return!0}}),define(ce[2],le([0,1,21,140,31,89,77]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=g,e.$Mc=u,e.$Nc=m,e.$Oc=d,e.$Pc=v,e.$Qc=b,e.$Rc=$,e.$Sc=k,e.$Tc=S,e.$4c=D;const I=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(T){let N=this.b.get(T);return N||(N={parent:null,source:null,isSingleton:!1,value:T,idx:c.a++},this.b.set(T,N)),N}trackDisposable(T){const N=this.c(T);N.source||(N.source=new Error().stack)}setParent(T,N){const V=this.c(T);V.parent=N}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,N){const V=N.get(T);if(V)return V;const H=T.parent?this.f(this.c(T.parent),N):T;return N.set(T,H),H}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,T).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(T=10,N){let V;if(N)V=N;else{const Q=new Map,U=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,Q).isSingleton);if(U.length===0)return;const Z=new Set(U.map(W=>W.value));if(V=U.filter(W=>!(W.parent&&Z.has(W.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function H(Q){function U(W,j){for(;W.length>0&&j.some(C=>typeof C=="string"?C===W[0]:W[0].match(C));)W.shift()}const Z=Q.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return U(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const Y=new E.$Ic;for(const Q of V){const U=H(Q);for(let Z=0;Z<=U.length;Z++)Y.add(U.slice(0,Z).join(`
`),Q)}V.sort((0,n.$6b)(Q=>Q.idx,n.$8b));let de="",q=0;for(const Q of V.slice(0,T)){q++;const U=H(Q),Z=[];for(let W=0;W<U.length;W++){let j=U[W];j=`(shared with ${Y.get(U.slice(0,W+1).join(`
`)).size}/${V.length} leaks) at ${j}`;const X=Y.get(U.slice(0,W).join(`
`)),oe=(0,r.$c)([...X].map(G=>H(G)[W]),G=>G);delete oe[U[W]];for(const[G,ue]of Object.entries(oe))Z.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${G}`);Z.unshift(j)}de+=`


==================== Leaking disposable ${q}/${V.length}: ${Q.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return V.length>T&&(de+=`


... and ${V.length-T} more leaking disposables

`),{leaks:V,details:de}}}e.$Kc=c;function g(R){p=R}if(I){const R="__is_disposable_tracked__";g(new class{trackDisposable(T){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[R]||console.log(N)},3e3)}setParent(T,N){if(T&&T!==h.None)try{T[R]=!0}catch{}}markAsDisposed(T){if(T&&T!==h.None)try{T[R]=!0}catch{}}markAsSingleton(T){}})}function u(R){return p?.trackDisposable(R),R}function m(R){p?.markAsDisposed(R)}function w(R,T){p?.setParent(R,T)}function f(R,T){if(p)for(const N of R)p.setParent(N,T)}function d(R){return p?.markAsSingleton(R),R}function v(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function b(R){if(O.Iterable.is(R)){const T=[];for(const N of R)if(N)try{N.dispose()}catch(V){T.push(V)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function $(R){for(const T of R)v(T)&&T.dispose();return[]}function k(...R){const T=S(()=>b(R));return f(R,T),T}function S(R){const T=u({dispose:(0,A.$db)(()=>{m(T),R()})});return T}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return w(T,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),w(T,null))}}e.$Uc=i;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,u(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}e.$Vc=h;class t{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&w(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&w(T,null),T}}e.$Wc=t;class o{constructor(T){this.a=new t,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=o;class s{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(T){let N=T;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Zc=a;class l{constructor(){this.a=new Map}acquire(T,...N){let V=this.a.get(T);V||(V={counter:0,object:this.b(T,...N)},this.a.set(T,V));const{object:H}=V,Y=(0,A.$db)(()=>{--V.counter===0&&(this.c(T,V.object),this.a.delete(T))});return V.counter++,{object:H,dispose:Y}}}e.$1c=l;class P{constructor(T){this.a=T}async acquire(T,...N){const V=this.a.acquire(T,...N);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(H){throw V.dispose(),H}}}e.$2c=P;class y{constructor(T){this.object=T}dispose(){}}e.$3c=y;function D(R){const T=new i;try{R(T)}finally{T.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,N,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(T)?.dispose(),this.a.set(T,N)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}deleteAndLeak(T){const N=this.a.get(T);return this.a.delete(T),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=L}),define(ce[90],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ce[78],le([0,1,31]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0,e.$om=E,e.$pm=O;const r=new n.$Ec(1e4);function E(c){return p(c,"NFC",r)}const A=new n.$Ec(1e4);function O(c){return p(c,"NFD",A)}const I=/[^\u0000-\u0080]/;function p(c,g,u){if(!c)return c;const m=u.get(c);if(m)return m;let w;return I.test(c)?w=c.normalize(g):w=c,u.set(c,w),w}e.$qm=function(){const c=/[\u0300-\u036f]/g;return function(g){return O(g).replace(c,"")}}()}),define(ce[145],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0,e.$Mm=n,e.rot=r,e.$Rm=I;function n(p,c,g){return Math.min(Math.max(p,c),g)}function r(p,c){return(c+p%c)%c}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Om=E;class A{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pm=A;class O{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const g=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Qm=O;function I(p,c,g,u,m,w,f,d){const v=f-g,b=d-u,$=m-g,k=w-u,S=p-g,i=c-u,h=v*v+b*b,t=v*$+b*k,o=v*S+b*i,s=$*$+k*k,a=$*S+k*i,l=1/(h*s-t*t),P=(s*o-t*a)*l,y=(h*a-t*o)*l;return P>=0&&y>=0&&P+y<1}}),function(){function x(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function O(p){A.push(p,Date.now())}function I(){const p=[];for(let c=0;c<A.length;c+=2)p.push({name:A[c],startTime:A[c+1]});return p}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(E+O.startTime)});return A}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(ce[3],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=P,e.$K=y,e.$h="en";let n=!1,r=!1,E=!1,A=!1,O=!1,I=!1,p=!1,c=!1,g=!1,u=!1,m,w=e.$h,f=e.$h,d,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const k=typeof $?.versions?.electron=="string",S=k&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",E=$.platform==="linux",A=E&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=k,g=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$h,w=e.$h;const D=$.env.VSCODE_NLS_CONFIG;if(D)try{const L=JSON.parse(D);m=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,d=L.languagePack?.translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!S?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=v.indexOf("Linux")>=0,u=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,m=navigator.language.toLowerCase(),f=m):console.error("Unable to resolve platform.");var i;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(i||(e.Platform=i={}));function h(D){switch(D){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let t=i.Web;r?t=i.Mac:n?t=i.Windows:E&&(t=i.Linux),e.$j=n,e.$k=r,e.$l=E,e.$m=A,e.$n=O,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=c,e.$t=u,e.$u=g,e.$v=t,e.$w=v,e.$x=w;var o;(function(D){function L(){return e.$x}D.value=L;function R(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=R;function T(){return e.$x==="en"}D.isDefault=T})(o||(e.Language=o={})),e.$y=m,e.$z=f,e.$A=d,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const D=[];b.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let T=0,N=D.length;T<N;T++){const V=D[T];if(V.id===R.data.vscodeScheduleAsyncWork){D.splice(T,1),V.callback();return}}});let L=0;return R=>{const T=++L;D.push({id:T,callback:R}),b.postMessage({vscodeScheduleAsyncWork:T},"*")}}return D=>setTimeout(D)})();var s;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function P(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,a=new Uint16Array(D.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(D){return parseFloat(D)>=20}}),define(ce[36],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const A=E.process;r={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$ec=r.platform,e.$fc=r.arch});var At=this&&this.__createBinding||(Object.create?function(x,e,n,r){r===void 0&&(r=n);var E=Object.getOwnPropertyDescriptor(e,n);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,r,E)}:function(x,e,n,r){r===void 0&&(r=n),x[r]=e[n]}),Rt=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),Pe=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&At(e,x,n);return Rt(e,x),e};define(ce[9],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,n=Pe(n);const r=65,E=97,A=90,O=122,I=46,p=47,c=92,g=58,u=63;class m extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const P=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${P} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,o){if(t===null||typeof t!="object")throw new m(o,"Object",t)}function f(t,o){if(typeof t!="string")throw new m(o,"string",t)}const d=n.$ec==="win32";function v(t){return t===p||t===c}function b(t){return t===p}function $(t){return t>=r&&t<=A||t>=E&&t<=O}function k(t,o,s,a){let l="",P=0,y=-1,D=0,L=0;for(let R=0;R<=t.length;++R){if(R<t.length)L=t.charCodeAt(R);else{if(a(L))break;L=p}if(a(L)){if(!(y===R-1||D===1))if(D===2){if(l.length<2||P!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const T=l.lastIndexOf(s);T===-1?(l="",P=0):(l=l.slice(0,T),P=l.length-1-l.lastIndexOf(s)),y=R,D=0;continue}else if(l.length!==0){l="",P=0,y=R,D=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",P=2)}else l.length>0?l+=`${s}${t.slice(y+1,R)}`:l=t.slice(y+1,R),P=R-y-1;y=R,D=0}else L===I&&D!==-1?++D:D=-1}return l}function S(t){return t?`${t[0]==="."?"":"."}${t}`:""}function i(t,o){w(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${S(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${t}${a}`:a}e.$gc={resolve(...t){let o="",s="",a=!1;for(let l=t.length-1;l>=-1;l--){let P;if(l>=0){if(P=t[l],f(P,`paths[${l}]`),P.length===0)continue}else o.length===0?P=n.cwd():(P=n.env[`=${o}`]||n.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==o.toLowerCase()&&P.charCodeAt(2)===c)&&(P=`${o}\\`));const y=P.length;let D=0,L="",R=!1;const T=P.charCodeAt(0);if(y===1)v(T)&&(D=1,R=!0);else if(v(T))if(R=!0,v(P.charCodeAt(1))){let N=2,V=N;for(;N<y&&!v(P.charCodeAt(N));)N++;if(N<y&&N!==V){const H=P.slice(V,N);for(V=N;N<y&&v(P.charCodeAt(N));)N++;if(N<y&&N!==V){for(V=N;N<y&&!v(P.charCodeAt(N));)N++;(N===y||N!==V)&&(L=`\\\\${H}\\${P.slice(V,N)}`,D=N)}}}else D=1;else $(T)&&P.charCodeAt(1)===g&&(L=P.slice(0,2),D=2,y>2&&v(P.charCodeAt(2))&&(R=!0,D=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${P.slice(D)}\\${s}`,a=R,R&&o.length>0)break}return s=k(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){f(t,"path");const o=t.length;if(o===0)return".";let s=0,a,l=!1;const P=t.charCodeAt(0);if(o===1)return b(P)?"\\":t;if(v(P))if(l=!0,v(t.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(t.charCodeAt(D));)D++;if(D<o&&D!==L){const R=t.slice(L,D);for(L=D;D<o&&v(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(t.charCodeAt(D));)D++;if(D===o)return`\\\\${R}\\${t.slice(L)}\\`;D!==L&&(a=`\\\\${R}\\${t.slice(L,D)}`,s=D)}}}else s=1;else $(P)&&t.charCodeAt(1)===g&&(a=t.slice(0,2),s=2,o>2&&v(t.charCodeAt(2))&&(l=!0,s=3));let y=s<o?k(t.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(t.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(t){f(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return v(s)||o>2&&$(s)&&t.charCodeAt(1)===g&&v(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let P=0;P<t.length;++P){const y=t[P];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const P=s.length;P>1&&v(s.charCodeAt(1))&&(++l,P>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$gc.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o)return"";const s=e.$gc.resolve(t),a=e.$gc.resolve(o);if(s===a||(t=s.toLowerCase(),o=a.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===c;)l++;let P=t.length;for(;P-1>l&&t.charCodeAt(P-1)===c;)P--;const y=P-l;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let L=o.length;for(;L-1>D&&o.charCodeAt(L-1)===c;)L--;const R=L-D,T=y<R?y:R;let N=-1,V=0;for(;V<T;V++){const Y=t.charCodeAt(l+V);if(Y!==o.charCodeAt(D+V))break;Y===c&&(N=V)}if(V!==T){if(N===-1)return a}else{if(R>T){if(o.charCodeAt(D+V)===c)return a.slice(D+V+1);if(V===2)return a.slice(D+V)}y>T&&(t.charCodeAt(l+V)===c?N=V:V===2&&(N=3)),N===-1&&(N=0)}let H="";for(V=l+N+1;V<=P;++V)(V===P||t.charCodeAt(V)===c)&&(H+=H.length===0?"..":"\\..");return D+=N,H.length>0?`${H}${a.slice(D,L)}`:(a.charCodeAt(D)===c&&++D,a.slice(D,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==u&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){f(t,"path");const o=t.length;if(o===0)return".";let s=-1,a=0;const l=t.charCodeAt(0);if(o===1)return v(l)?t:".";if(v(l)){if(s=a=1,v(t.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&v(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(t.charCodeAt(D));)D++;if(D===o)return t;D!==L&&(s=a=D+1)}}}}else $(l)&&t.charCodeAt(1)===g&&(s=o>2&&v(t.charCodeAt(2))?3:2,a=s);let P=-1,y=!0;for(let D=o-1;D>=a;--D)if(v(t.charCodeAt(D))){if(!y){P=D;break}}else y=!1;if(P===-1){if(s===-1)return".";P=s}return t.slice(0,P)},basename(t,o){o!==void 0&&f(o,"suffix"),f(t,"path");let s=0,a=-1,l=!0,P;if(t.length>=2&&$(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,D=-1;for(P=t.length-1;P>=s;--P){const L=t.charCodeAt(P);if(v(L)){if(!l){s=P+1;break}}else D===-1&&(l=!1,D=P+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=P):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=t.length),t.slice(s,a)}for(P=t.length-1;P>=s;--P)if(v(t.charCodeAt(P))){if(!l){s=P+1;break}}else a===-1&&(l=!1,a=P+1);return a===-1?"":t.slice(s,a)},extname(t){f(t,"path");let o=0,s=-1,a=0,l=-1,P=!0,y=0;t.length>=2&&t.charCodeAt(1)===g&&$(t.charCodeAt(0))&&(o=a=2);for(let D=t.length-1;D>=o;--D){const L=t.charCodeAt(D);if(v(L)){if(!P){a=D+1;break}continue}l===-1&&(P=!1,l=D+1),L===I?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":t.slice(s,l)},format:i.bind(null,"\\"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let a=0,l=t.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(v(l)){if(a=1,v(t.charCodeAt(1))){let N=2,V=N;for(;N<s&&!v(t.charCodeAt(N));)N++;if(N<s&&N!==V){for(V=N;N<s&&v(t.charCodeAt(N));)N++;if(N<s&&N!==V){for(V=N;N<s&&!v(t.charCodeAt(N));)N++;N===s?a=N:N!==V&&(a=N+1)}}}}else if($(l)&&t.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=t,o;if(a=2,v(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;a=3}}a>0&&(o.root=t.slice(0,a));let P=-1,y=a,D=-1,L=!0,R=t.length-1,T=0;for(;R>=a;--R){if(l=t.charCodeAt(R),v(l)){if(!L){y=R+1;break}continue}D===-1&&(L=!1,D=R+1),l===I?P===-1?P=R:T!==1&&(T=1):P!==-1&&(T=-1)}return D!==-1&&(P===-1||T===0||T===1&&P===D-1&&P===y+1?o.base=o.name=t.slice(y,D):(o.name=t.slice(y,P),o.base=t.slice(y,D),o.ext=t.slice(P,D))),y>0&&y!==a?o.dir=t.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(d){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let o="",s=!1;for(let a=t.length-1;a>=-1&&!s;a--){const l=a>=0?t[a]:h();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=k(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===p,s=t.charCodeAt(t.length-1)===p;return t=k(t,!o,"/",b),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const a=t[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const s=1,a=t.length,l=a-s,P=1,y=o.length-P,D=l<y?l:y;let L=-1,R=0;for(;R<D;R++){const N=t.charCodeAt(s+R);if(N!==o.charCodeAt(P+R))break;N===p&&(L=R)}if(R===D)if(y>D){if(o.charCodeAt(P+R)===p)return o.slice(P+R+1);if(R===0)return o.slice(P+R)}else l>D&&(t.charCodeAt(s+R)===p?L=R:R===0&&(L=0));let T="";for(R=s+L+1;R<=a;++R)(R===a||t.charCodeAt(R)===p)&&(T+=T.length===0?"..":"/..");return`${T}${o.slice(P+L)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===p;let s=-1,a=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===p){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let s=0,a=-1,l=!0,P;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,D=-1;for(P=t.length-1;P>=0;--P){const L=t.charCodeAt(P);if(L===p){if(!l){s=P+1;break}}else D===-1&&(l=!1,D=P+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=P):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=t.length),t.slice(s,a)}for(P=t.length-1;P>=0;--P)if(t.charCodeAt(P)===p){if(!l){s=P+1;break}}else a===-1&&(l=!1,a=P+1);return a===-1?"":t.slice(s,a)},extname(t){f(t,"path");let o=-1,s=0,a=-1,l=!0,P=0;for(let y=t.length-1;y>=0;--y){const D=t.charCodeAt(y);if(D===p){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),D===I?o===-1?o=y:P!==1&&(P=1):o!==-1&&(P=-1)}return o===-1||a===-1||P===0||P===1&&o===a-1&&o===s+1?"":t.slice(o,a)},format:i.bind(null,"/"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===p;let a;s?(o.root="/",a=1):a=0;let l=-1,P=0,y=-1,D=!0,L=t.length-1,R=0;for(;L>=a;--L){const T=t.charCodeAt(L);if(T===p){if(!D){P=L+1;break}continue}y===-1&&(D=!1,y=L+1),T===I?l===-1?l=L:R!==1&&(R=1):l!==-1&&(R=-1)}if(y!==-1){const T=P===0&&s?1:P;l===-1||R===0||R===1&&l===y-1&&l===P+1?o.base=o.name=t.slice(T,y):(o.name=t.slice(T,l),o.base=t.slice(T,y),o.ext=t.slice(l,y))}return P>0?o.dir=t.slice(0,P-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=d?e.$gc.normalize:e.$hc.normalize,e.$jc=d?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=d?e.$gc.join:e.$hc.join,e.$lc=d?e.$gc.resolve:e.$hc.resolve,e.$mc=d?e.$gc.relative:e.$hc.relative,e.$nc=d?e.$gc.dirname:e.$hc.dirname,e.$oc=d?e.$gc.basename:e.$hc.basename,e.$pc=d?e.$gc.extname:e.$hc.extname,e.$qc=d?e.$gc.format:e.$hc.format,e.$rc=d?e.$gc.parse:e.$hc.parse,e.$sc=d?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=d?e.$gc.sep:e.$hc.sep,e.$uc=d?e.$gc.delimiter:e.$hc.delimiter}),define(ce[79],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=A,e.$nm=O;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function A(I,...p){const c=p.reduce((m,w)=>(m[w]=!0,m),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!c[m]).forEach(m=>{for(let w=0;w<g.length;w++)if(m.search(g[w])!==-1){delete I[m];break}})}function O(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:x)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return x[r].call(E.exports,E,E.exports,n),E.l=!0,E.exports}return n.m=x,n.c=e,n.d=function(r,E,A){n.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:A})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,E){if(1&E&&(r=n(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var A=Object.create(null);if(n.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var O in r)n.d(A,O,function(I){return r[I]}.bind(null,O));return A},n.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(E,"a",E),E},n.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},n.p="",n(n.s=0)}([function(x,e,n){(function(r){var E;e=x.exports=ue,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],c=0,g=c++;p[g]="0|[1-9]\\d*";var u=c++;p[u]="[0-9]+";var m=c++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;p[w]="("+p[g]+")\\.("+p[g]+")\\.("+p[g]+")";var f=c++;p[f]="("+p[u]+")\\.("+p[u]+")\\.("+p[u]+")";var d=c++;p[d]="(?:"+p[g]+"|"+p[m]+")";var v=c++;p[v]="(?:"+p[u]+"|"+p[m]+")";var b=c++;p[b]="(?:-("+p[d]+"(?:\\."+p[d]+")*))";var $=c++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var k=c++;p[k]="[0-9A-Za-z-]+";var S=c++;p[S]="(?:\\+("+p[k]+"(?:\\."+p[k]+")*))";var i=c++,h="v?"+p[w]+p[b]+"?"+p[S]+"?";p[i]="^"+h+"$";var t="[v=\\s]*"+p[f]+p[$]+"?"+p[S]+"?",o=c++;p[o]="^"+t+"$";var s=c++;p[s]="((?:<|>)?=?)";var a=c++;p[a]=p[u]+"|x|X|\\*";var l=c++;p[l]=p[g]+"|x|X|\\*";var P=c++;p[P]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[S]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[$]+")?"+p[S]+"?)?)?";var D=c++;p[D]="^"+p[s]+"\\s*"+p[P]+"$";var L=c++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var R=c++;p[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=c++;p[T]="(?:~>?)";var N=c++;p[N]="(\\s*)"+p[T]+"\\s+",I[N]=new RegExp(p[N],"g");var V=c++;p[V]="^"+p[T]+p[P]+"$";var H=c++;p[H]="^"+p[T]+p[y]+"$";var Y=c++;p[Y]="(?:\\^)";var de=c++;p[de]="(\\s*)"+p[Y]+"\\s+",I[de]=new RegExp(p[de],"g");var q=c++;p[q]="^"+p[Y]+p[P]+"$";var Q=c++;p[Q]="^"+p[Y]+p[y]+"$";var U=c++;p[U]="^"+p[s]+"\\s*("+t+")$|^$";var Z=c++;p[Z]="^"+p[s]+"\\s*("+h+")$|^$";var W=c++;p[W]="(\\s*)"+p[s]+"\\s*("+t+"|"+p[P]+")",I[W]=new RegExp(p[W],"g");var j=c++;p[j]="^\\s*("+p[P]+")\\s+-\\s+("+p[P]+")\\s*$";var C=c++;p[C]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var X=c++;p[X]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)E(oe,p[oe]),I[oe]||(I[oe]=new RegExp(p[oe]));function G(ee,ae){if(ee instanceof ue)return ee;if(typeof ee!="string"||ee.length>A||!(ae?I[o]:I[i]).test(ee))return null;try{return new ue(ee,ae)}catch{return null}}function ue(ee,ae){if(ee instanceof ue){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ue))return new ue(ee,ae);E("SemVer",ee,ae),this.loose=ae;var fe=ee.trim().match(ae?I[o]:I[i]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ae=+be;if(Ae>=0&&Ae<O)return Ae}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(ee,ae){var fe=G(ee,ae);return fe?fe.version:null},e.clean=function(ee,ae){var fe=G(ee.trim().replace(/^[=v]+/,""),ae);return fe?fe.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(ee){return E("SemVer.compare",this.version,this.loose,ee),ee instanceof ue||(ee=new ue(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ue.prototype.compareMain=function(ee){return ee instanceof ue||(ee=new ue(ee,this.loose)),J(this.major,ee.major)||J(this.minor,ee.minor)||J(this.patch,ee.patch)},ue.prototype.comparePre=function(ee){if(ee instanceof ue||(ee=new ue(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var fe=this.prerelease[ae],be=ee.prerelease[ae];if(E("prerelease compare",ae,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return J(fe,be)}while(++ae)},ue.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new ue(ee,fe).inc(ae,be).version}catch{return null}},e.diff=function(ee,ae){if(z(ee,ae))return null;var fe=G(ee),be=G(ae);if(fe.prerelease.length||be.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return Ae},e.compareIdentifiers=J;var re=/^[0-9]+$/;function J(ee,ae){var fe=re.test(ee),be=re.test(ae);return fe&&be&&(ee=+ee,ae=+ae),fe&&!be?-1:be&&!fe?1:ee<ae?-1:ee>ae?1:0}function M(ee,ae,fe){return new ue(ee,fe).compare(new ue(ae,fe))}function F(ee,ae,fe){return M(ee,ae,fe)>0}function _(ee,ae,fe){return M(ee,ae,fe)<0}function z(ee,ae,fe){return M(ee,ae,fe)===0}function ie(ee,ae,fe){return M(ee,ae,fe)!==0}function K(ee,ae,fe){return M(ee,ae,fe)>=0}function B(ee,ae,fe){return M(ee,ae,fe)<=0}function te(ee,ae,fe,be){var Ae;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Ae=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Ae=ee!==fe;break;case"":case"=":case"==":Ae=z(ee,fe,be);break;case"!=":Ae=ie(ee,fe,be);break;case">":Ae=F(ee,fe,be);break;case">=":Ae=K(ee,fe,be);break;case"<":Ae=_(ee,fe,be);break;case"<=":Ae=B(ee,fe,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ae}function he(ee,ae){if(ee instanceof he){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof he))return new he(ee,ae);E("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(ee,ae){return J(ae,ee)},e.major=function(ee,ae){return new ue(ee,ae).major},e.minor=function(ee,ae){return new ue(ee,ae).minor},e.patch=function(ee,ae){return new ue(ee,ae).patch},e.compare=M,e.compareLoose=function(ee,ae){return M(ee,ae,!0)},e.rcompare=function(ee,ae,fe){return M(ae,ee,fe)},e.sort=function(ee,ae){return ee.sort(function(fe,be){return e.compare(fe,be,ae)})},e.rsort=function(ee,ae){return ee.sort(function(fe,be){return e.rcompare(fe,be,ae)})},e.gt=F,e.lt=_,e.eq=z,e.neq=ie,e.gte=K,e.lte=B,e.cmp=te,e.Comparator=he;var me={};function we(ee,ae){if(ee instanceof we)return ee.loose===ae?ee:new we(ee.raw,ae);if(ee instanceof he)return new we(ee.value,ae);if(!(this instanceof we))return new we(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ie(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Ce(ee,ae,fe,be,Ae,Ne,Me,Re,Be,Ke,Ze,qe,Xe){return((ae=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(Ae)?">="+fe+"."+be+".0":">="+ae)+" "+(Re=Ie(Be)?"":Ie(Ke)?"<"+(+Be+1)+".0.0":Ie(Ze)?"<"+Be+"."+(+Ke+1)+".0":qe?"<="+Be+"."+Ke+"."+Ze+"-"+qe:"<="+Re)).trim()}function De(ee,ae){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(ae))return!1;if(ae.prerelease.length){for(fe=0;fe<ee.length;fe++)if(E(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var be=ee[fe].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function ve(ee,ae,fe){try{ae=new we(ae,fe)}catch{return!1}return ae.test(ee)}function $e(ee,ae,fe,be){var Ae,Ne,Me,Re,Be;switch(ee=new ue(ee,be),ae=new we(ae,be),fe){case">":Ae=F,Ne=B,Me=_,Re=">",Be=">=";break;case"<":Ae=_,Ne=K,Me=F,Re="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ee,ae,be))return!1;for(var Ke=0;Ke<ae.set.length;++Ke){var Ze=ae.set[Ke],qe=null,Xe=null;if(Ze.forEach(function(Je){Je.semver===me&&(Je=new he(">=0.0.0")),qe=qe||Je,Xe=Xe||Je,Ae(Je.semver,qe.semver,be)?qe=Je:Me(Je.semver,Xe.semver,be)&&(Xe=Je)}),qe.operator===Re||qe.operator===Be||(!Xe.operator||Xe.operator===Re)&&Ne(ee,Xe.semver)||Xe.operator===Be&&Me(ee,Xe.semver))return!1}return!0}he.prototype.parse=function(ee){var ae=this.loose?I[U]:I[Z],fe=ee.match(ae);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ue(fe[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(ee){return E("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ue(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ee,ae){if(!(ee instanceof he))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(ee.value,ae),ve(this.value,fe,ae);if(ee.operator==="")return fe=new we(this.value,ae),ve(ee.semver,fe,ae);var be=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Ne=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Re=te(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=te(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return be||Ae||Ne&&Me||Re||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),E("range",ee,ae);var fe=ae?I[C]:I[j];ee=ee.replace(fe,Ce),E("hyphen replace",ee),ee=ee.replace(I[W],"$1$2$3"),E("comparator trim",ee,I[W]),ee=(ee=(ee=ee.replace(I[N],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var be=ae?I[U]:I[Z],Ae=ee.split(" ").map(function(Ne){return function(Me,Re){return E("comp",Me),Me=function(Be,Ke){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Xe){E("caret",qe,Xe);var Je=Xe?I[Q]:I[q];return qe.replace(Je,function(Qe,We,ne,ge,pe){var ye;return E("caret",qe,Qe,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=We==="0"?">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+".0 <"+(+We+1)+".0.0":pe?(E("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+pe+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+pe+" <"+(+We+1)+".0.0"):(E("no pr"),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+" <"+(+We+1)+".0.0"),E("caret return",ye),ye})}(Ze,Ke)}).join(" ")}(Me,Re),E("caret",Me),Me=function(Be,Ke){return Be.trim().split(/\s+/).map(function(Ze){return function(qe,Xe){var Je=Xe?I[H]:I[V];return qe.replace(Je,function(Qe,We,ne,ge,pe){var ye;return E("tilde",qe,Qe,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":pe?(E("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0"):ye=">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0",E("tilde return",ye),ye})}(Ze,Ke)}).join(" ")}(Me,Re),E("tildes",Me),Me=function(Be,Ke){return E("replaceXRanges",Be,Ke),Be.split(/\s+/).map(function(Ze){return function(qe,Xe){qe=qe.trim();var Je=Xe?I[L]:I[D];return qe.replace(Je,function(Qe,We,ne,ge,pe,ye){E("xRange",qe,Qe,We,ne,ge,pe,ye);var je=Ie(ne),Ue=je||Ie(ge),_e=Ue||Ie(pe);return We==="="&&_e&&(We=""),je?Qe=We===">"||We==="<"?"<0.0.0":"*":We&&_e?(Ue&&(ge=0),_e&&(pe=0),We===">"?(We=">=",Ue?(ne=+ne+1,ge=0,pe=0):_e&&(ge=+ge+1,pe=0)):We==="<="&&(We="<",Ue?ne=+ne+1:ge=+ge+1),Qe=We+ne+"."+ge+"."+pe):Ue?Qe=">="+ne+".0.0 <"+(+ne+1)+".0.0":_e&&(Qe=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),E("xRange return",Qe),Qe})}(Ze,Ke)}).join(" ")}(Me,Re),E("xrange",Me),Me=function(Be,Ke){return E("replaceStars",Be,Ke),Be.trim().replace(I[X],"")}(Me,Re),E("stars",Me),Me}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Ne){return!!Ne.match(be)})),Ae=Ae.map(function(Ne){return new he(Ne,ae)})},we.prototype.intersects=function(ee,ae){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ee.set.some(function(Ae){return Ae.every(function(Ne){return be.intersects(Ne,ae)})})})})},e.toComparators=function(ee,ae){return new we(ee,ae).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ue(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(De(this.set[ae],ee))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ee,ae,fe){var be=null,Ae=null;try{var Ne=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&Ae.compare(Me)!==-1||(Ae=new ue(be=Me,fe)))}),be},e.minSatisfying=function(ee,ae,fe){var be=null,Ae=null;try{var Ne=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Ne.test(Me)&&(be&&Ae.compare(Me)!==1||(Ae=new ue(be=Me,fe)))}),be},e.validRange=function(ee,ae){try{return new we(ee,ae).range||"*"}catch{return null}},e.ltr=function(ee,ae,fe){return $e(ee,ae,"<",fe)},e.gtr=function(ee,ae,fe){return $e(ee,ae,">",fe)},e.outside=$e,e.prerelease=function(ee,ae){var fe=G(ee,ae);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,ae,fe){return ee=new we(ee,fe),ae=new we(ae,fe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof ue)return ee;if(typeof ee!="string")return null;var ae=ee.match(I[R]);return ae==null?null:G((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,n(1))},function(x,e){var n,r,E=x.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===A||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:A}catch{n=A}try{r=typeof clearTimeout=="function"?clearTimeout:O}catch{r=O}})();var p,c=[],g=!1,u=-1;function m(){g&&p&&(g=!1,p.length?c=p.concat(c):u=-1,c.length&&w())}function w(){if(!g){var v=I(m);g=!0;for(var b=c.length;b;){for(p=c,c=[];++u<b;)p&&p[u].run();u=-1,b=c.length}p=null,g=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===O||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function d(){}E.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];c.push(new f(v,b)),c.length!==1||g||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=d,E.addListener=d,E.once=d,E.off=d,E.removeListener=d,E.removeAllListeners=d,E.emit=d,E.prependListener=d,E.prependOnceListener=d,E.listeners=function(v){return[]},E.binding=function(v){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(v){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(ce[146],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class r{constructor(I,p,c){this.level=I,this.key=p,this.value=c,this.forward=[]}}const E=void 0;class A{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,p){return A.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=A.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let c=this.e.forward[0];for(;c;)I.call(p,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,c){let g=I.e;for(let u=I.d-1;u>=0;u--)for(;g.forward[u]&&c(g.forward[u].key,p)<0;)g=g.forward[u];if(g=g.forward[0],g&&c(g.key,p)===0)return g}static h(I,p,c,g){const u=[];let m=I.e;for(let w=I.d-1;w>=0;w--){for(;m.forward[w]&&g(m.forward[w].key,p)<0;)m=m.forward[w];u[w]=m}if(m=m.forward[0],m&&g(m.key,p)===0)return m.value=c,!1;{const w=A.j(I);if(w>I.d){for(let f=I.d;f<w;f++)u[f]=I.e;I.d=w}m=new r(w,p,c);for(let f=0;f<w;f++)m.forward[f]=u[f].forward[f],u[f].forward[f]=m;return!0}}static j(I,p=.5){let c=1;for(;Math.random()<p&&c<I.c;)c+=1;return c}static k(I,p,c){const g=[];let u=I.e;for(let m=I.d-1;m>=0;m--){for(;u.forward[m]&&c(u.forward[m].key,p)<0;)u=u.forward[m];g[m]=u}if(u=u.forward[0],!u||c(u.key,p)!==0)return!1;for(let m=0;m<I.d&&g[m].forward[m]===u;m++)g[m].forward[m]=u.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===E;)I.d-=1;return!0}}e.$Ws=A}),define(ce[66],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(A){return new r(A)}constructor(A){this.c=n&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=r}),define(ce[4],le([0,1,15,89,2,108,66]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=w;const I=!1,p=!1,c=!1;var g;(function(H){H.None=()=>E.$Vc.None;function Y(De){if(c){const{onDidAddListener:ve}=De,$e=d.create();let ee=0;De.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ve?.()}}}function de(De,ve){return G(De,()=>{},0,void 0,!0,void 0,ve)}H.defer=de;function q(De){return(ve,$e=null,ee)=>{let ae=!1,fe;return fe=De(be=>{if(!ae)return fe?fe.dispose():ae=!0,ve.call($e,be)},null,ee),ae&&fe.dispose(),fe}}H.once=q;function Q(De,ve,$e){return X((ee,ae=null,fe)=>De(be=>ee.call(ae,ve(be)),null,fe),$e)}H.map=Q;function U(De,ve,$e){return X((ee,ae=null,fe)=>De(be=>{ve(be),ee.call(ae,be)},null,fe),$e)}H.forEach=U;function Z(De,ve,$e){return X((ee,ae=null,fe)=>De(be=>ve(be)&&ee.call(ae,be),null,fe),$e)}H.filter=Z;function W(De){return De}H.signal=W;function j(...De){return(ve,$e=null,ee)=>{const ae=(0,E.$Sc)(...De.map(fe=>fe(be=>ve.call($e,be))));return oe(ae,ee)}}H.any=j;function C(De,ve,$e,ee){let ae=$e;return Q(De,fe=>(ae=ve(ae,fe),ae),ee)}H.reduce=C;function X(De,ve){let $e;const ee={onWillAddFirstListener(){$e=De(ae.fire,ae)},onDidRemoveLastListener(){$e?.dispose()}};ve||Y(ee);const ae=new t(ee);return ve?.add(ae),ae.event}function oe(De,ve){return ve instanceof Array?ve.push(De):ve&&ve.add(De),De}function G(De,ve,$e=100,ee=!1,ae=!1,fe,be){let Ae,Ne,Me,Re=0,Be;const Ke={leakWarningThreshold:fe,onWillAddFirstListener(){Ae=De(qe=>{Re++,Ne=ve(Ne,qe),ee&&!Me&&(Ze.fire(Ne),Ne=void 0),Be=()=>{const Xe=Ne;Ne=void 0,Me=void 0,(!ee||Re>1)&&Ze.fire(Xe),Re=0},typeof $e=="number"?(clearTimeout(Me),Me=setTimeout(Be,$e)):Me===void 0&&(Me=0,queueMicrotask(Be))})},onWillRemoveListener(){ae&&Re>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,Ae.dispose()}};be||Y(Ke);const Ze=new t(Ke);return be?.add(Ze),Ze.event}H.debounce=G;function ue(De,ve=0,$e){return H.debounce(De,(ee,ae)=>ee?(ee.push(ae),ee):[ae],ve,void 0,!0,void 0,$e)}H.accumulate=ue;function re(De,ve=(ee,ae)=>ee===ae,$e){let ee=!0,ae;return Z(De,fe=>{const be=ee||!ve(fe,ae);return ee=!1,ae=fe,be},$e)}H.latch=re;function J(De,ve,$e){return[H.filter(De,ve,$e),H.filter(De,ee=>!ve(ee),$e)]}H.split=J;function M(De,ve=!1,$e=[],ee){let ae=$e.slice(),fe=De(Ne=>{ae?ae.push(Ne):Ae.fire(Ne)});ee&&ee.add(fe);const be=()=>{ae?.forEach(Ne=>Ae.fire(Ne)),ae=null},Ae=new t({onWillAddFirstListener(){fe||(fe=De(Ne=>Ae.fire(Ne)),ee&&ee.add(fe))},onDidAddFirstListener(){ae&&(ve?setTimeout(be):be())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return ee&&ee.add(Ae),Ae.event}H.buffer=M;function F(De,ve){return(ee,ae,fe)=>{const be=ve(new z);return De(function(Ae){const Ne=be.evaluate(Ae);Ne!==_&&ee.call(ae,Ne)},void 0,fe)}}H.chain=F;const _=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(ve){return this.f.push(ve),this}forEach(ve){return this.f.push($e=>(ve($e),$e)),this}filter(ve){return this.f.push($e=>ve($e)?$e:_),this}reduce(ve,$e){let ee=$e;return this.f.push(ae=>(ee=ve(ee,ae),ee)),this}latch(ve=($e,ee)=>$e===ee){let $e=!0,ee;return this.f.push(ae=>{const fe=$e||!ve(ae,ee);return $e=!1,ee=ae,fe?ae:_}),this}evaluate(ve){for(const $e of this.f)if(ve=$e(ve),ve===_)break;return ve}}function ie(De,ve,$e=ee=>ee){const ee=(...Ae)=>be.fire($e(...Ae)),ae=()=>De.on(ve,ee),fe=()=>De.removeListener(ve,ee),be=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}H.fromNodeEventEmitter=ie;function K(De,ve,$e=ee=>ee){const ee=(...Ae)=>be.fire($e(...Ae)),ae=()=>De.addEventListener(ve,ee),fe=()=>De.removeEventListener(ve,ee),be=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}H.fromDOMEventEmitter=K;function B(De){return new Promise(ve=>q(De)(ve))}H.toPromise=B;function te(De){const ve=new t;return De.then($e=>{ve.fire($e)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}H.fromPromise=te;function he(De,ve){return De($e=>ve.fire($e))}H.forward=he;function me(De,ve,$e){return ve($e),De(ee=>ve(ee))}H.runAndSubscribe=me;class we{constructor(ve,$e){this._observable=ve,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{ve.addObserver(this)},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};$e||Y(ee),this.emitter=new t(ee),$e&&$e.add(this.emitter)}beginUpdate(ve){this.f++}handlePossibleChange(ve){}handleChange(ve,$e){this.g=!0}endUpdate(ve){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(De,ve){return new we(De,ve).emitter.event}H.fromObservable=Ie;function Ce(De){return(ve,$e,ee)=>{let ae=0,fe=!1;const be={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(De.reportChanges(),fe&&(fe=!1,ve.call($e)))},handlePossibleChange(){},handleChange(){fe=!0}};De.addObserver(be),De.reportChanges();const Ae={dispose(){De.removeObserver(be)}};return ee instanceof E.$Uc?ee.add(Ae):Array.isArray(ee)&&ee.push(Ae),Ae}}H.fromObservableLight=Ce})(g||(e.Event=g={}));class u{static{this.all=new Set}static{this.f=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${u.f++}`,u.all.add(this)}start(Y){this.g=new O.$ge,this.listenerCount=Y}stop(){if(this.g){const Y=this.g.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this.g=void 0}}}e.$ie=u;let m=-1;function w(H){const Y=m;return m=H,{dispose(){m=Y}}}class f{static{this.f=1}constructor(Y,de,q=(f.f++).toString(16).padStart(3,"0")){this.j=Y,this.threshold=de,this.name=q,this.h=0}dispose(){this.g?.clear()}check(Y,de){const q=this.threshold;if(q<=0||de<q)return;this.g||(this.g=new Map);const Q=this.g.get(Y.value)||0;if(this.g.set(Y.value,Q+1),this.h-=1,this.h<=0){this.h=q*.5;const[U,Z]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${Z}):`;console.warn(W),console.warn(U);const j=new v(W,U);this.j(j)}return()=>{const U=this.g.get(Y.value)||0;this.g.set(Y.value,U-1)}}getMostFrequentStack(){if(!this.g)return;let Y,de=0;for(const[q,Q]of this.g)(!Y||de<Q)&&(Y=[q,Q],de=Q);return Y}}class d{static create(){const Y=new Error;return new d(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(Y,de){super(Y),this.name="ListenerLeakError",this.stack=de}}e.$ke=v;class b extends Error{constructor(Y,de){super(Y),this.name="ListenerRefusalError",this.stack=de}}e.$le=b;let $=0;class k{constructor(Y){this.value=Y,this.id=$++}}const S=2,i=(H,Y)=>{if(H instanceof k)Y(H);else for(let de=0;de<H.length;de++){const q=H[de];q&&Y(q)}};let h;if(I){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),h=new FinalizationRegistry(Y=>{typeof Y=="string"&&H.push(Y)})}class t{constructor(Y){this.z=0,this.f=Y,this.g=m>0||this.f?.leakWarningThreshold?new f(Y?.onListenerError??n.$Z,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const Y=this.u;queueMicrotask(()=>{i(Y,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Y,de,q)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const C=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],X=new b(`${j}. HINT: Stack shows most frequent listener (${C[1]}-times)`,C[0]);return(this.f?.onListenerError||n.$Z)(X),E.$Vc.None}if(this.m)return E.$Vc.None;de&&(Y=Y.bind(de));const Q=new k(Y);let U,Z;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Q.stack=d.create(),U=this.g.check(Q.stack,this.z+1)),p&&(Q.stack=Z??d.create()),this.u?this.u instanceof k?(this.w??=new s,this.u=[this.u,Q]):this.u.push(Q):(this.f?.onWillAddFirstListener?.(this),this.u=Q,this.f?.onDidAddFirstListener?.(this)),this.z++;const W=(0,E.$Tc)(()=>{h?.unregister(W),U?.(),this.A(Q)});if(q instanceof E.$Uc?q.add(W):Array.isArray(q)&&q.push(W),h){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),C=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);h.register(W,C?.[2]??j,W)}return W},this.q}A(Y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,q=de.indexOf(Y);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[q]=void 0;const Q=this.w.current===this;if(this.z*S<=de.length){let U=0;for(let Z=0;Z<de.length;Z++)de[Z]?de[U++]=de[Z]:Q&&(this.w.end--,U<this.w.i&&this.w.i--);de.length=U}}B(Y,de){if(!Y)return;const q=this.f?.onListenerError||n.$Z;if(!q){Y.value(de);return}try{Y.value(de)}catch(Q){q(Q)}}C(Y){const de=Y.current.u;for(;Y.i<Y.end;)this.B(de[Y.i++],Y.value);Y.reset()}fire(Y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof k)this.B(this.u,Y);else{const de=this.w;de.enqueue(this,Y,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=t;const o=()=>new s;e.$ne=o;class s{constructor(){this.i=-1,this.end=0}enqueue(Y,de,q){this.i=0,this.end=q,this.current=Y,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends t{async fireAsync(Y,de,q){if(this.u)for(this.h||(this.h=new A.$6c),i(this.u,Q=>this.h.push([Q.value,Y]));this.h.size>0&&!de.isCancellationRequested;){const[Q,U]=this.h.shift(),Z=[],W={...U,token:de,waitUntil:j=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");q&&(j=q(j,Q)),Z.push(j)}};try{Q(W)}catch(j){(0,n.$Z)(j);continue}Object.freeze(Z),await Promise.allSettled(Z).then(j=>{for(const C of j)C.status==="rejected"&&(0,n.$Z)(C.reason)})}}}e.$oe=a;class l extends t{get isPaused(){return this.h!==0}constructor(Y){super(Y),this.h=0,this.s=new A.$6c,this.t=Y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Y=Array.from(this.s);this.s.clear(),super.fire(this.t(Y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Y){this.z&&(this.h!==0?this.s.push(Y):super.fire(Y))}}e.$pe=l;class P extends l{constructor(Y){super(Y),this.k=Y.delay??100}fire(Y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Y)}}e.$qe=P;class y extends t{constructor(Y){super(Y),this.h=[],this.k=Y?.merge}fire(Y){this.hasListeners()&&(this.h.push(Y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$re=y;class D{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Y){const de={event:Y,listener:null};this.h.push(de),this.g&&this.m(de);const q=()=>{this.g&&this.o(de);const Q=this.h.indexOf(de);this.h.splice(Q,1)};return(0,E.$Tc)((0,r.$db)(q))}j(){this.g=!0,this.h.forEach(Y=>this.m(Y))}k(){this.g=!1,this.h.forEach(Y=>this.o(Y))}m(Y){Y.listener=Y.event(de=>this.f.fire(de))}o(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.f.dispose();for(const Y of this.h)Y.listener?.dispose();this.h=[]}}e.$se=D;class L{constructor(Y,de,q,Q){this.f=new E.$Uc;const U=this.f.add(new D),Z=this.f.add(new E.$5c);function W(j){Z.set(j,U.add(Q(j)))}for(const j of Y)W(j);this.f.add(de(j=>{W(j)})),this.f.add(q(j=>{Z.deleteAndDispose(j)})),this.event=U.event}dispose(){this.f.dispose()}}e.$te=L;class R{constructor(){this.f=[]}wrapEvent(Y,de,q){return(Q,U,Z)=>Y(W=>{const j=this.f[this.f.length-1];if(!de){j?j.buffers.push(()=>Q.call(U,W)):Q.call(U,W);return}const C=j;if(!C){Q.call(U,de(q,W));return}C.items??=[],C.items.push(W),C.buffers.length===0&&j.buffers.push(()=>{C.reducedResult??=q?C.items.reduce(de,q):C.items.reduce(de),Q.call(U,C.reducedResult)})},void 0,Z)}bufferEvents(Y){const de={buffers:new Array};this.f.push(de);const q=Y();return this.f.pop(),de.buffers.forEach(Q=>Q()),q}}e.$ue=R;class T{constructor(){this.f=!1,this.g=g.None,this.h=E.$Vc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Y){this.g=Y,this.f&&(this.h.dispose(),this.h=Y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=T;class N{static const(Y){return new V(Y)}constructor(Y){this.g=Y,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(Y){Y!==this.g&&(this.g=Y,this.f.fire(void 0))}}e.$we=N;class V{constructor(Y){this.value=Y,this.onDidChange=g.None}}}),define(ce[22],le([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=I;const r=Object.freeze(function(p,c){const g=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(g)}}});var E;(function(p){function c(g){return g===p.None||g===p.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=E.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=E.None}}e.$xe=O;function I(p){const c=new O;return p.add({dispose(){c.cancel()}}),c.token}}),define(ce[147],le([0,1,22]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=E;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$xe,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$0e=r;function E(I){return I}class A{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=E):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$_e=A;class O{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=E):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const g=this.c(p);return this.a.set(p,g),this.b.set(c,g),g}}e.$af=O}),define(ce[67],le([0,1,15,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=E,e.$Ae=A,e.$Be=O,e.$Ce=I,e.$De=c,e.$Ee=g,e.$Fe=u,e.$Ge=m,e.$He=w,e.$Ie=f,e.$Je=d,e.$Ke=v,e.$Le=b,e.$Me=$,e.$Ne=k;function E(S){const i=S;return i?typeof i.read=="function":!1}function A(S){const i=S;return i?[i.on,i.pause,i.resume,i.destroy].every(h=>typeof h=="function"):!1}function O(S){const i=S;return i?A(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function I(S,i){return new p(S,i)}class p{constructor(i,h){this.e=i,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(h=>h(i))}h(i){this.c.error.length===0?(0,n.$Z)(i):this.c.error.slice(0).forEach(h=>h(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,h){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(i,h){if(this.a.destroyed)return;let t;switch(i){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const o=t.indexOf(h);o>=0&&t.splice(o,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,i){const h=[];let t;for(;(t=S.read())!==null;)h.push(t);return i(h)}function g(S,i,h){const t=[];let o;for(;(o=S.read())!==null&&t.length<h;)t.push(o);return o===null&&t.length>0?i(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return S.read()}}}function u(S,i){return new Promise((h,t)=>{const o=[];m(S,{onData:s=>{i&&o.push(s)},onError:s=>{i?t(s):h(void 0)},onEnd:()=>{h(i?i(o):void 0)}})})}function m(S,i,h){S.on("error",t=>{h?.isCancellationRequested||i.onError(t)}),S.on("end",()=>{h?.isCancellationRequested||i.onEnd()}),S.on("data",t=>{h?.isCancellationRequested||i.onData(t)})}function w(S,i){return new Promise((h,t)=>{const o=new r.$Uc,s=[],a=y=>{if(s.push(y),s.length>i)return o.dispose(),S.pause(),h({stream:S,buffer:s,ended:!1})},l=y=>(o.dispose(),t(y)),P=()=>(o.dispose(),h({stream:S,buffer:s,ended:!0}));o.add((0,r.$Tc)(()=>S.removeListener("error",l))),S.on("error",l),o.add((0,r.$Tc)(()=>S.removeListener("end",P))),S.on("end",P),o.add((0,r.$Tc)(()=>S.removeListener("data",a))),S.on("data",a)})}function f(S,i){const h=I(i);return h.end(S),h}function d(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function v(S){let i=!1;return{read:()=>i?null:(i=!0,S)}}function b(S,i,h){const t=I(h);return m(S,{onData:o=>t.write(i.data(o)),onError:o=>t.error(i.error?i.error(o):o),onEnd:()=>t.end()}),t}function $(S,i,h){let t=!1;return{read:()=>{const o=i.read();return t?o:(t=!0,o!==null?h([S,o]):S)}}}function k(S,i,h){let t=!1;const o=I(h);return m(i,{onData:s=>t?o.write(s):(t=!0,o.write(h([S,s]))),onError:s=>o.error(s),onEnd:()=>{t||(t=!0,o.write(S)),o.end()}}),o}}),define(ce[17],le([0,1,65,67]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=g,e.$Re=u,e.$Se=m,e.$Te=w,e.$Ue=f,e.$Ve=d,e.$We=v,e.$Xe=b,e.$Ye=$,e.$Ze=k,e.$1e=S,e.$2e=i,e.$3e=h,e.$4e=t,e.$5e=o,e.$6e=s,e.$7e=a,e.$8e=l,e.$9e=D,r=Pe(r);const E=typeof Buffer<"u",A=new n.$U(()=>new Uint8Array(256));let O,I;class p{static alloc(R){return E?new p(Buffer.allocUnsafe(R)):new p(new Uint8Array(R))}static wrap(R){return E&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new p(R)}static fromString(R,T){return!(T?.dontUseNodeBuffer||!1)&&E?new p(Buffer.from(R)):(O||(O=new TextEncoder),new p(O.encode(R)))}static fromByteArray(R){const T=p.alloc(R.length);for(let N=0,V=R.length;N<V;N++)T.buffer[N]=R[N];return T}static concat(R,T){if(typeof T>"u"){T=0;for(let H=0,Y=R.length;H<Y;H++)T+=R[H].byteLength}const N=p.alloc(T);let V=0;for(let H=0,Y=R.length;H<Y;H++){const de=R[H];N.set(de,V),V+=de.byteLength}return N}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=p.alloc(this.byteLength);return R.set(this),R}toString(){return E?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(R,T){return new p(this.buffer.subarray(R,T))}set(R,T){if(R instanceof p)this.buffer.set(R.buffer,T);else if(R instanceof Uint8Array)this.buffer.set(R,T);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),T);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return m(this.buffer,R)}writeUInt32BE(R,T){w(this.buffer,R,T)}readUInt32LE(R){return f(this.buffer,R)}writeUInt32LE(R,T){d(this.buffer,R,T)}readUInt8(R){return v(this.buffer,R)}writeUInt8(R,T){b(this.buffer,R,T)}indexOf(R,T=0){return c(this.buffer,R instanceof p?R.buffer:R,T)}}e.$Oe=p;function c(L,R,T=0){const N=R.byteLength,V=L.byteLength;if(N===0)return 0;if(N===1)return L.indexOf(R[0]);if(N>V-T)return-1;const H=A.value;H.fill(R.length);for(let Q=0;Q<R.length;Q++)H[R[Q]]=R.length-Q-1;let Y=T+R.length-1,de=Y,q=-1;for(;Y<V;)if(L[Y]===R[de]){if(de===0){q=Y;break}Y--,de--}else Y+=Math.max(R.length-de,H[L[Y]]),de=R.length-1;return q}function g(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0}function u(L,R,T){L[T+0]=R&255,R=R>>>8,L[T+1]=R&255}function m(L,R){return L[R]*2**24+L[R+1]*2**16+L[R+2]*2**8+L[R+3]}function w(L,R,T){L[T+3]=R,R=R>>>8,L[T+2]=R,R=R>>>8,L[T+1]=R,R=R>>>8,L[T]=R}function f(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0|L[R+2]<<16>>>0|L[R+3]<<24>>>0}function d(L,R,T){L[T+0]=R&255,R=R>>>8,L[T+1]=R&255,R=R>>>8,L[T+2]=R&255,R=R>>>8,L[T+3]=R&255}function v(L,R){return L[R]}function b(L,R,T){L[T]=R}function $(L){return r.$De(L,R=>p.concat(R))}function k(L){return r.$Ke(L)}function S(L){return r.$Fe(L,R=>p.concat(R))}async function i(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await S(L.stream)])}function h(L){return r.$Ie(L,R=>p.concat(R))}function t(L){return r.$Le(L,{data:R=>typeof R=="string"?p.fromString(R):p.wrap(R)},R=>p.concat(R))}function o(L){return r.$Ce(R=>p.concat(R),L)}function s(L,R){return r.$Me(L,R,T=>p.concat(T))}function a(L,R){return r.$Ne(L,R,T=>p.concat(T))}function l(L){let R=0,T=0,N=0;const V=new Uint8Array(Math.floor(L.length/4*3)),H=de=>{switch(T){case 3:V[N++]=R|de,T=0;break;case 2:V[N++]=R|de>>>2,R=de<<6,T=3;break;case 1:V[N++]=R|de>>>4,R=de<<4,T=2;break;default:R=de<<2,T=1}};for(let de=0;de<L.length;de++){const q=L.charCodeAt(de);if(q>=65&&q<=90)H(q-65);else if(q>=97&&q<=122)H(q-97+26);else if(q>=48&&q<=57)H(q-48+52);else if(q===43||q===45)H(62);else if(q===47||q===95)H(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const Y=N;for(;T>0;)H(0);return p.wrap(V).slice(0,Y)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:L},R=!0,T=!1){const N=T?y:P;let V="";const H=L.byteLength%3;let Y=0;for(;Y<L.byteLength-H;Y+=3){const de=L[Y+0],q=L[Y+1],Q=L[Y+2];V+=N[de>>>2],V+=N[(de<<4|q>>>4)&63],V+=N[(q<<2|Q>>>6)&63],V+=N[Q&63]}if(H===1){const de=L[Y+0];V+=N[de>>>2],V+=N[de<<4&63],R&&(V+="==")}else if(H===2){const de=L[Y+0],q=L[Y+1];V+=N[de>>>2],V+=N[(de<<4|q>>>4)&63],V+=N[q<<2&63],R&&(V+="=")}return V}}),define(ce[148],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ce[11],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=n,e.$gg=r,e.$hg=E,e.$ig=A,e.$jg=O,e.$kg=I,e.$lg=p,e.$mg=c,e.$ng=g,e.$og=u,e.$pg=m,e.$qg=w,e.$rg=f,e.$sg=v,e.$tg=b,e.$ug=$,e.$vg=k,e.$wg=S,e.$xg=i;function n(h){return typeof h=="string"}function r(h){return Array.isArray(h)&&h.every(t=>n(t))}function E(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function A(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}function O(h){return typeof h=="number"&&!isNaN(h)}function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}function p(h){return h===!0||h===!1}function c(h){return typeof h>"u"}function g(h){return!u(h)}function u(h){return c(h)||h===null}function m(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function w(h){if(u(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function f(...h){const t=[];for(let o=0;o<h.length;o++){const s=h[o];if(u(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}const d=Object.prototype.hasOwnProperty;function v(h){if(!E(h))return!1;for(const t in h)if(d.call(h,t))return!1;return!0}function b(h){return typeof h=="function"}function $(...h){return h.length>0&&h.every(b)}function k(h,t){const o=Math.min(h.length,t.length);for(let s=0;s<o;s++)S(h[s],t[s])}function S(h,t){if(n(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(h instanceof t)return}catch{}if(!u(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function i(h){return h}}),define(ce[109],le([0,1,11]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=E,e.$2j=A;const r=Object.create(null);function E(O,I){if((0,n.$fg)(I)){const p=r[I];if(p===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=p}return r[O]=I,{id:O}}function A(){return r}}),define(ce[149],le([0,1,109]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,n.$1j)("add",6e4),plus:(0,n.$1j)("plus",6e4),gistNew:(0,n.$1j)("gist-new",6e4),repoCreate:(0,n.$1j)("repo-create",6e4),lightbulb:(0,n.$1j)("lightbulb",60001),lightBulb:(0,n.$1j)("light-bulb",60001),repo:(0,n.$1j)("repo",60002),repoDelete:(0,n.$1j)("repo-delete",60002),gistFork:(0,n.$1j)("gist-fork",60003),repoForked:(0,n.$1j)("repo-forked",60003),gitPullRequest:(0,n.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$1j)("record-keys",60005),keyboard:(0,n.$1j)("keyboard",60005),tag:(0,n.$1j)("tag",60006),gitPullRequestLabel:(0,n.$1j)("git-pull-request-label",60006),tagAdd:(0,n.$1j)("tag-add",60006),tagRemove:(0,n.$1j)("tag-remove",60006),person:(0,n.$1j)("person",60007),personFollow:(0,n.$1j)("person-follow",60007),personOutline:(0,n.$1j)("person-outline",60007),personFilled:(0,n.$1j)("person-filled",60007),gitBranch:(0,n.$1j)("git-branch",60008),gitBranchCreate:(0,n.$1j)("git-branch-create",60008),gitBranchDelete:(0,n.$1j)("git-branch-delete",60008),sourceControl:(0,n.$1j)("source-control",60008),mirror:(0,n.$1j)("mirror",60009),mirrorPublic:(0,n.$1j)("mirror-public",60009),star:(0,n.$1j)("star",60010),starAdd:(0,n.$1j)("star-add",60010),starDelete:(0,n.$1j)("star-delete",60010),starEmpty:(0,n.$1j)("star-empty",60010),comment:(0,n.$1j)("comment",60011),commentAdd:(0,n.$1j)("comment-add",60011),alert:(0,n.$1j)("alert",60012),warning:(0,n.$1j)("warning",60012),search:(0,n.$1j)("search",60013),searchSave:(0,n.$1j)("search-save",60013),logOut:(0,n.$1j)("log-out",60014),signOut:(0,n.$1j)("sign-out",60014),logIn:(0,n.$1j)("log-in",60015),signIn:(0,n.$1j)("sign-in",60015),eye:(0,n.$1j)("eye",60016),eyeUnwatch:(0,n.$1j)("eye-unwatch",60016),eyeWatch:(0,n.$1j)("eye-watch",60016),circleFilled:(0,n.$1j)("circle-filled",60017),primitiveDot:(0,n.$1j)("primitive-dot",60017),closeDirty:(0,n.$1j)("close-dirty",60017),debugBreakpoint:(0,n.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$1j)("primitive-square",60018),edit:(0,n.$1j)("edit",60019),pencil:(0,n.$1j)("pencil",60019),info:(0,n.$1j)("info",60020),issueOpened:(0,n.$1j)("issue-opened",60020),gistPrivate:(0,n.$1j)("gist-private",60021),gitForkPrivate:(0,n.$1j)("git-fork-private",60021),lock:(0,n.$1j)("lock",60021),mirrorPrivate:(0,n.$1j)("mirror-private",60021),close:(0,n.$1j)("close",60022),removeClose:(0,n.$1j)("remove-close",60022),x:(0,n.$1j)("x",60022),repoSync:(0,n.$1j)("repo-sync",60023),sync:(0,n.$1j)("sync",60023),clone:(0,n.$1j)("clone",60024),desktopDownload:(0,n.$1j)("desktop-download",60024),beaker:(0,n.$1j)("beaker",60025),microscope:(0,n.$1j)("microscope",60025),vm:(0,n.$1j)("vm",60026),deviceDesktop:(0,n.$1j)("device-desktop",60026),file:(0,n.$1j)("file",60027),fileText:(0,n.$1j)("file-text",60027),more:(0,n.$1j)("more",60028),ellipsis:(0,n.$1j)("ellipsis",60028),kebabHorizontal:(0,n.$1j)("kebab-horizontal",60028),mailReply:(0,n.$1j)("mail-reply",60029),reply:(0,n.$1j)("reply",60029),organization:(0,n.$1j)("organization",60030),organizationFilled:(0,n.$1j)("organization-filled",60030),organizationOutline:(0,n.$1j)("organization-outline",60030),newFile:(0,n.$1j)("new-file",60031),fileAdd:(0,n.$1j)("file-add",60031),newFolder:(0,n.$1j)("new-folder",60032),fileDirectoryCreate:(0,n.$1j)("file-directory-create",60032),trash:(0,n.$1j)("trash",60033),trashcan:(0,n.$1j)("trashcan",60033),history:(0,n.$1j)("history",60034),clock:(0,n.$1j)("clock",60034),folder:(0,n.$1j)("folder",60035),fileDirectory:(0,n.$1j)("file-directory",60035),symbolFolder:(0,n.$1j)("symbol-folder",60035),logoGithub:(0,n.$1j)("logo-github",60036),markGithub:(0,n.$1j)("mark-github",60036),github:(0,n.$1j)("github",60036),terminal:(0,n.$1j)("terminal",60037),console:(0,n.$1j)("console",60037),repl:(0,n.$1j)("repl",60037),zap:(0,n.$1j)("zap",60038),symbolEvent:(0,n.$1j)("symbol-event",60038),error:(0,n.$1j)("error",60039),stop:(0,n.$1j)("stop",60039),variable:(0,n.$1j)("variable",60040),symbolVariable:(0,n.$1j)("symbol-variable",60040),array:(0,n.$1j)("array",60042),symbolArray:(0,n.$1j)("symbol-array",60042),symbolModule:(0,n.$1j)("symbol-module",60043),symbolPackage:(0,n.$1j)("symbol-package",60043),symbolNamespace:(0,n.$1j)("symbol-namespace",60043),symbolObject:(0,n.$1j)("symbol-object",60043),symbolMethod:(0,n.$1j)("symbol-method",60044),symbolFunction:(0,n.$1j)("symbol-function",60044),symbolConstructor:(0,n.$1j)("symbol-constructor",60044),symbolBoolean:(0,n.$1j)("symbol-boolean",60047),symbolNull:(0,n.$1j)("symbol-null",60047),symbolNumeric:(0,n.$1j)("symbol-numeric",60048),symbolNumber:(0,n.$1j)("symbol-number",60048),symbolStructure:(0,n.$1j)("symbol-structure",60049),symbolStruct:(0,n.$1j)("symbol-struct",60049),symbolParameter:(0,n.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$1j)("symbol-type-parameter",60050),symbolKey:(0,n.$1j)("symbol-key",60051),symbolText:(0,n.$1j)("symbol-text",60051),symbolReference:(0,n.$1j)("symbol-reference",60052),goToFile:(0,n.$1j)("go-to-file",60052),symbolEnum:(0,n.$1j)("symbol-enum",60053),symbolValue:(0,n.$1j)("symbol-value",60053),symbolRuler:(0,n.$1j)("symbol-ruler",60054),symbolUnit:(0,n.$1j)("symbol-unit",60054),activateBreakpoints:(0,n.$1j)("activate-breakpoints",60055),archive:(0,n.$1j)("archive",60056),arrowBoth:(0,n.$1j)("arrow-both",60057),arrowDown:(0,n.$1j)("arrow-down",60058),arrowLeft:(0,n.$1j)("arrow-left",60059),arrowRight:(0,n.$1j)("arrow-right",60060),arrowSmallDown:(0,n.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$1j)("arrow-small-left",60062),arrowSmallRight:(0,n.$1j)("arrow-small-right",60063),arrowSmallUp:(0,n.$1j)("arrow-small-up",60064),arrowUp:(0,n.$1j)("arrow-up",60065),bell:(0,n.$1j)("bell",60066),bold:(0,n.$1j)("bold",60067),book:(0,n.$1j)("book",60068),bookmark:(0,n.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$1j)("briefcase",60076),broadcast:(0,n.$1j)("broadcast",60077),browser:(0,n.$1j)("browser",60078),bug:(0,n.$1j)("bug",60079),calendar:(0,n.$1j)("calendar",60080),caseSensitive:(0,n.$1j)("case-sensitive",60081),check:(0,n.$1j)("check",60082),checklist:(0,n.$1j)("checklist",60083),chevronDown:(0,n.$1j)("chevron-down",60084),chevronLeft:(0,n.$1j)("chevron-left",60085),chevronRight:(0,n.$1j)("chevron-right",60086),chevronUp:(0,n.$1j)("chevron-up",60087),chromeClose:(0,n.$1j)("chrome-close",60088),chromeMaximize:(0,n.$1j)("chrome-maximize",60089),chromeMinimize:(0,n.$1j)("chrome-minimize",60090),chromeRestore:(0,n.$1j)("chrome-restore",60091),circleOutline:(0,n.$1j)("circle-outline",60092),circle:(0,n.$1j)("circle",60092),debugBreakpointUnverified:(0,n.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$1j)("circle-slash",60093),circuitBoard:(0,n.$1j)("circuit-board",60094),clearAll:(0,n.$1j)("clear-all",60095),clippy:(0,n.$1j)("clippy",60096),closeAll:(0,n.$1j)("close-all",60097),cloudDownload:(0,n.$1j)("cloud-download",60098),cloudUpload:(0,n.$1j)("cloud-upload",60099),code:(0,n.$1j)("code",60100),collapseAll:(0,n.$1j)("collapse-all",60101),colorMode:(0,n.$1j)("color-mode",60102),commentDiscussion:(0,n.$1j)("comment-discussion",60103),creditCard:(0,n.$1j)("credit-card",60105),dash:(0,n.$1j)("dash",60108),dashboard:(0,n.$1j)("dashboard",60109),database:(0,n.$1j)("database",60110),debugContinue:(0,n.$1j)("debug-continue",60111),debugDisconnect:(0,n.$1j)("debug-disconnect",60112),debugPause:(0,n.$1j)("debug-pause",60113),debugRestart:(0,n.$1j)("debug-restart",60114),debugStart:(0,n.$1j)("debug-start",60115),debugStepInto:(0,n.$1j)("debug-step-into",60116),debugStepOut:(0,n.$1j)("debug-step-out",60117),debugStepOver:(0,n.$1j)("debug-step-over",60118),debugStop:(0,n.$1j)("debug-stop",60119),debug:(0,n.$1j)("debug",60120),deviceCameraVideo:(0,n.$1j)("device-camera-video",60121),deviceCamera:(0,n.$1j)("device-camera",60122),deviceMobile:(0,n.$1j)("device-mobile",60123),diffAdded:(0,n.$1j)("diff-added",60124),diffIgnored:(0,n.$1j)("diff-ignored",60125),diffModified:(0,n.$1j)("diff-modified",60126),diffRemoved:(0,n.$1j)("diff-removed",60127),diffRenamed:(0,n.$1j)("diff-renamed",60128),diff:(0,n.$1j)("diff",60129),diffSidebyside:(0,n.$1j)("diff-sidebyside",60129),discard:(0,n.$1j)("discard",60130),editorLayout:(0,n.$1j)("editor-layout",60131),emptyWindow:(0,n.$1j)("empty-window",60132),exclude:(0,n.$1j)("exclude",60133),extensions:(0,n.$1j)("extensions",60134),eyeClosed:(0,n.$1j)("eye-closed",60135),fileBinary:(0,n.$1j)("file-binary",60136),fileCode:(0,n.$1j)("file-code",60137),fileMedia:(0,n.$1j)("file-media",60138),filePdf:(0,n.$1j)("file-pdf",60139),fileSubmodule:(0,n.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$1j)("file-symlink-file",60142),fileZip:(0,n.$1j)("file-zip",60143),files:(0,n.$1j)("files",60144),filter:(0,n.$1j)("filter",60145),flame:(0,n.$1j)("flame",60146),foldDown:(0,n.$1j)("fold-down",60147),foldUp:(0,n.$1j)("fold-up",60148),fold:(0,n.$1j)("fold",60149),folderActive:(0,n.$1j)("folder-active",60150),folderOpened:(0,n.$1j)("folder-opened",60151),gear:(0,n.$1j)("gear",60152),gift:(0,n.$1j)("gift",60153),gistSecret:(0,n.$1j)("gist-secret",60154),gist:(0,n.$1j)("gist",60155),gitCommit:(0,n.$1j)("git-commit",60156),gitCompare:(0,n.$1j)("git-compare",60157),compareChanges:(0,n.$1j)("compare-changes",60157),gitMerge:(0,n.$1j)("git-merge",60158),githubAction:(0,n.$1j)("github-action",60159),githubAlt:(0,n.$1j)("github-alt",60160),globe:(0,n.$1j)("globe",60161),grabber:(0,n.$1j)("grabber",60162),graph:(0,n.$1j)("graph",60163),gripper:(0,n.$1j)("gripper",60164),heart:(0,n.$1j)("heart",60165),home:(0,n.$1j)("home",60166),horizontalRule:(0,n.$1j)("horizontal-rule",60167),hubot:(0,n.$1j)("hubot",60168),inbox:(0,n.$1j)("inbox",60169),issueReopened:(0,n.$1j)("issue-reopened",60171),issues:(0,n.$1j)("issues",60172),italic:(0,n.$1j)("italic",60173),jersey:(0,n.$1j)("jersey",60174),json:(0,n.$1j)("json",60175),kebabVertical:(0,n.$1j)("kebab-vertical",60176),key:(0,n.$1j)("key",60177),law:(0,n.$1j)("law",60178),lightbulbAutofix:(0,n.$1j)("lightbulb-autofix",60179),linkExternal:(0,n.$1j)("link-external",60180),link:(0,n.$1j)("link",60181),listOrdered:(0,n.$1j)("list-ordered",60182),listUnordered:(0,n.$1j)("list-unordered",60183),liveShare:(0,n.$1j)("live-share",60184),loading:(0,n.$1j)("loading",60185),location:(0,n.$1j)("location",60186),mailRead:(0,n.$1j)("mail-read",60187),mail:(0,n.$1j)("mail",60188),markdown:(0,n.$1j)("markdown",60189),megaphone:(0,n.$1j)("megaphone",60190),mention:(0,n.$1j)("mention",60191),milestone:(0,n.$1j)("milestone",60192),gitPullRequestMilestone:(0,n.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$1j)("mortar-board",60193),move:(0,n.$1j)("move",60194),multipleWindows:(0,n.$1j)("multiple-windows",60195),mute:(0,n.$1j)("mute",60196),noNewline:(0,n.$1j)("no-newline",60197),note:(0,n.$1j)("note",60198),octoface:(0,n.$1j)("octoface",60199),openPreview:(0,n.$1j)("open-preview",60200),package:(0,n.$1j)("package",60201),paintcan:(0,n.$1j)("paintcan",60202),pin:(0,n.$1j)("pin",60203),play:(0,n.$1j)("play",60204),run:(0,n.$1j)("run",60204),plug:(0,n.$1j)("plug",60205),preserveCase:(0,n.$1j)("preserve-case",60206),preview:(0,n.$1j)("preview",60207),project:(0,n.$1j)("project",60208),pulse:(0,n.$1j)("pulse",60209),question:(0,n.$1j)("question",60210),quote:(0,n.$1j)("quote",60211),radioTower:(0,n.$1j)("radio-tower",60212),reactions:(0,n.$1j)("reactions",60213),references:(0,n.$1j)("references",60214),refresh:(0,n.$1j)("refresh",60215),regex:(0,n.$1j)("regex",60216),remoteExplorer:(0,n.$1j)("remote-explorer",60217),remote:(0,n.$1j)("remote",60218),remove:(0,n.$1j)("remove",60219),replaceAll:(0,n.$1j)("replace-all",60220),replace:(0,n.$1j)("replace",60221),repoClone:(0,n.$1j)("repo-clone",60222),repoForcePush:(0,n.$1j)("repo-force-push",60223),repoPull:(0,n.$1j)("repo-pull",60224),repoPush:(0,n.$1j)("repo-push",60225),report:(0,n.$1j)("report",60226),requestChanges:(0,n.$1j)("request-changes",60227),rocket:(0,n.$1j)("rocket",60228),rootFolderOpened:(0,n.$1j)("root-folder-opened",60229),rootFolder:(0,n.$1j)("root-folder",60230),rss:(0,n.$1j)("rss",60231),ruby:(0,n.$1j)("ruby",60232),saveAll:(0,n.$1j)("save-all",60233),saveAs:(0,n.$1j)("save-as",60234),save:(0,n.$1j)("save",60235),screenFull:(0,n.$1j)("screen-full",60236),screenNormal:(0,n.$1j)("screen-normal",60237),searchStop:(0,n.$1j)("search-stop",60238),server:(0,n.$1j)("server",60240),settingsGear:(0,n.$1j)("settings-gear",60241),settings:(0,n.$1j)("settings",60242),shield:(0,n.$1j)("shield",60243),smiley:(0,n.$1j)("smiley",60244),sortPrecedence:(0,n.$1j)("sort-precedence",60245),splitHorizontal:(0,n.$1j)("split-horizontal",60246),splitVertical:(0,n.$1j)("split-vertical",60247),squirrel:(0,n.$1j)("squirrel",60248),starFull:(0,n.$1j)("star-full",60249),starHalf:(0,n.$1j)("star-half",60250),symbolClass:(0,n.$1j)("symbol-class",60251),symbolColor:(0,n.$1j)("symbol-color",60252),symbolConstant:(0,n.$1j)("symbol-constant",60253),symbolEnumMember:(0,n.$1j)("symbol-enum-member",60254),symbolField:(0,n.$1j)("symbol-field",60255),symbolFile:(0,n.$1j)("symbol-file",60256),symbolInterface:(0,n.$1j)("symbol-interface",60257),symbolKeyword:(0,n.$1j)("symbol-keyword",60258),symbolMisc:(0,n.$1j)("symbol-misc",60259),symbolOperator:(0,n.$1j)("symbol-operator",60260),symbolProperty:(0,n.$1j)("symbol-property",60261),wrench:(0,n.$1j)("wrench",60261),wrenchSubaction:(0,n.$1j)("wrench-subaction",60261),symbolSnippet:(0,n.$1j)("symbol-snippet",60262),tasklist:(0,n.$1j)("tasklist",60263),telescope:(0,n.$1j)("telescope",60264),textSize:(0,n.$1j)("text-size",60265),threeBars:(0,n.$1j)("three-bars",60266),thumbsdown:(0,n.$1j)("thumbsdown",60267),thumbsup:(0,n.$1j)("thumbsup",60268),tools:(0,n.$1j)("tools",60269),triangleDown:(0,n.$1j)("triangle-down",60270),triangleLeft:(0,n.$1j)("triangle-left",60271),triangleRight:(0,n.$1j)("triangle-right",60272),triangleUp:(0,n.$1j)("triangle-up",60273),twitter:(0,n.$1j)("twitter",60274),unfold:(0,n.$1j)("unfold",60275),unlock:(0,n.$1j)("unlock",60276),unmute:(0,n.$1j)("unmute",60277),unverified:(0,n.$1j)("unverified",60278),verified:(0,n.$1j)("verified",60279),versions:(0,n.$1j)("versions",60280),vmActive:(0,n.$1j)("vm-active",60281),vmOutline:(0,n.$1j)("vm-outline",60282),vmRunning:(0,n.$1j)("vm-running",60283),watch:(0,n.$1j)("watch",60284),whitespace:(0,n.$1j)("whitespace",60285),wholeWord:(0,n.$1j)("whole-word",60286),window:(0,n.$1j)("window",60287),wordWrap:(0,n.$1j)("word-wrap",60288),zoomIn:(0,n.$1j)("zoom-in",60289),zoomOut:(0,n.$1j)("zoom-out",60290),listFilter:(0,n.$1j)("list-filter",60291),listFlat:(0,n.$1j)("list-flat",60292),listSelection:(0,n.$1j)("list-selection",60293),selection:(0,n.$1j)("selection",60293),listTree:(0,n.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$1j)("circle-small-filled",60298),debugStackframeDot:(0,n.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$1j)("symbol-string",60301),debugReverseContinue:(0,n.$1j)("debug-reverse-continue",60302),debugStepBack:(0,n.$1j)("debug-step-back",60303),debugRestartFrame:(0,n.$1j)("debug-restart-frame",60304),debugAlt:(0,n.$1j)("debug-alt",60305),callIncoming:(0,n.$1j)("call-incoming",60306),callOutgoing:(0,n.$1j)("call-outgoing",60307),menu:(0,n.$1j)("menu",60308),expandAll:(0,n.$1j)("expand-all",60309),feedback:(0,n.$1j)("feedback",60310),gitPullRequestReviewer:(0,n.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$1j)("ungroup-by-ref-type",60312),account:(0,n.$1j)("account",60313),gitPullRequestAssignee:(0,n.$1j)("git-pull-request-assignee",60313),bellDot:(0,n.$1j)("bell-dot",60314),debugConsole:(0,n.$1j)("debug-console",60315),library:(0,n.$1j)("library",60316),output:(0,n.$1j)("output",60317),runAll:(0,n.$1j)("run-all",60318),syncIgnored:(0,n.$1j)("sync-ignored",60319),pinned:(0,n.$1j)("pinned",60320),githubInverted:(0,n.$1j)("github-inverted",60321),serverProcess:(0,n.$1j)("server-process",60322),serverEnvironment:(0,n.$1j)("server-environment",60323),pass:(0,n.$1j)("pass",60324),issueClosed:(0,n.$1j)("issue-closed",60324),stopCircle:(0,n.$1j)("stop-circle",60325),playCircle:(0,n.$1j)("play-circle",60326),record:(0,n.$1j)("record",60327),debugAltSmall:(0,n.$1j)("debug-alt-small",60328),vmConnect:(0,n.$1j)("vm-connect",60329),cloud:(0,n.$1j)("cloud",60330),merge:(0,n.$1j)("merge",60331),export:(0,n.$1j)("export",60332),graphLeft:(0,n.$1j)("graph-left",60333),magnet:(0,n.$1j)("magnet",60334),notebook:(0,n.$1j)("notebook",60335),redo:(0,n.$1j)("redo",60336),checkAll:(0,n.$1j)("check-all",60337),pinnedDirty:(0,n.$1j)("pinned-dirty",60338),passFilled:(0,n.$1j)("pass-filled",60339),circleLargeFilled:(0,n.$1j)("circle-large-filled",60340),circleLarge:(0,n.$1j)("circle-large",60341),circleLargeOutline:(0,n.$1j)("circle-large-outline",60341),combine:(0,n.$1j)("combine",60342),gather:(0,n.$1j)("gather",60342),table:(0,n.$1j)("table",60343),variableGroup:(0,n.$1j)("variable-group",60344),typeHierarchy:(0,n.$1j)("type-hierarchy",60345),typeHierarchySub:(0,n.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$1j)("git-pull-request-create",60348),runAbove:(0,n.$1j)("run-above",60349),runBelow:(0,n.$1j)("run-below",60350),notebookTemplate:(0,n.$1j)("notebook-template",60351),debugRerun:(0,n.$1j)("debug-rerun",60352),workspaceTrusted:(0,n.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$1j)("workspace-unknown",60355),terminalCmd:(0,n.$1j)("terminal-cmd",60356),terminalDebian:(0,n.$1j)("terminal-debian",60357),terminalLinux:(0,n.$1j)("terminal-linux",60358),terminalPowershell:(0,n.$1j)("terminal-powershell",60359),terminalTmux:(0,n.$1j)("terminal-tmux",60360),terminalUbuntu:(0,n.$1j)("terminal-ubuntu",60361),terminalBash:(0,n.$1j)("terminal-bash",60362),arrowSwap:(0,n.$1j)("arrow-swap",60363),copy:(0,n.$1j)("copy",60364),personAdd:(0,n.$1j)("person-add",60365),filterFilled:(0,n.$1j)("filter-filled",60366),wand:(0,n.$1j)("wand",60367),debugLineByLine:(0,n.$1j)("debug-line-by-line",60368),inspect:(0,n.$1j)("inspect",60369),layers:(0,n.$1j)("layers",60370),layersDot:(0,n.$1j)("layers-dot",60371),layersActive:(0,n.$1j)("layers-active",60372),compass:(0,n.$1j)("compass",60373),compassDot:(0,n.$1j)("compass-dot",60374),compassActive:(0,n.$1j)("compass-active",60375),azure:(0,n.$1j)("azure",60376),issueDraft:(0,n.$1j)("issue-draft",60377),gitPullRequestClosed:(0,n.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$1j)("git-pull-request-draft",60379),debugAll:(0,n.$1j)("debug-all",60380),debugCoverage:(0,n.$1j)("debug-coverage",60381),runErrors:(0,n.$1j)("run-errors",60382),folderLibrary:(0,n.$1j)("folder-library",60383),debugContinueSmall:(0,n.$1j)("debug-continue-small",60384),beakerStop:(0,n.$1j)("beaker-stop",60385),graphLine:(0,n.$1j)("graph-line",60386),graphScatter:(0,n.$1j)("graph-scatter",60387),pieChart:(0,n.$1j)("pie-chart",60388),bracket:(0,n.$1j)("bracket",60175),bracketDot:(0,n.$1j)("bracket-dot",60389),bracketError:(0,n.$1j)("bracket-error",60390),lockSmall:(0,n.$1j)("lock-small",60391),azureDevops:(0,n.$1j)("azure-devops",60392),verifiedFilled:(0,n.$1j)("verified-filled",60393),newline:(0,n.$1j)("newline",60394),layout:(0,n.$1j)("layout",60395),layoutActivitybarLeft:(0,n.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$1j)("layout-panel-right",60401),layoutPanel:(0,n.$1j)("layout-panel",60402),layoutSidebarLeft:(0,n.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$1j)("layout-statusbar",60405),layoutMenubar:(0,n.$1j)("layout-menubar",60406),layoutCentered:(0,n.$1j)("layout-centered",60407),target:(0,n.$1j)("target",60408),indent:(0,n.$1j)("indent",60409),recordSmall:(0,n.$1j)("record-small",60410),errorSmall:(0,n.$1j)("error-small",60411),terminalDecorationError:(0,n.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$1j)("layout-sidebar-left-off",60418),blank:(0,n.$1j)("blank",60419),heartFilled:(0,n.$1j)("heart-filled",60420),map:(0,n.$1j)("map",60421),mapHorizontal:(0,n.$1j)("map-horizontal",60421),foldHorizontal:(0,n.$1j)("fold-horizontal",60421),mapFilled:(0,n.$1j)("map-filled",60422),mapHorizontalFilled:(0,n.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$1j)("fold-horizontal-filled",60422),circleSmall:(0,n.$1j)("circle-small",60423),bellSlash:(0,n.$1j)("bell-slash",60424),bellSlashDot:(0,n.$1j)("bell-slash-dot",60425),commentUnresolved:(0,n.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$1j)("search-fuzzy",60429),commentDraft:(0,n.$1j)("comment-draft",60430),send:(0,n.$1j)("send",60431),sparkle:(0,n.$1j)("sparkle",60432),insert:(0,n.$1j)("insert",60433),mic:(0,n.$1j)("mic",60434),thumbsdownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$1j)("thumbsup-filled",60436),coffee:(0,n.$1j)("coffee",60437),snake:(0,n.$1j)("snake",60438),game:(0,n.$1j)("game",60439),vr:(0,n.$1j)("vr",60440),chip:(0,n.$1j)("chip",60441),piano:(0,n.$1j)("piano",60442),music:(0,n.$1j)("music",60443),micFilled:(0,n.$1j)("mic-filled",60444),repoFetch:(0,n.$1j)("repo-fetch",60445),copilot:(0,n.$1j)("copilot",60446),lightbulbSparkle:(0,n.$1j)("lightbulb-sparkle",60447),robot:(0,n.$1j)("robot",60448),sparkleFilled:(0,n.$1j)("sparkle-filled",60449),diffSingle:(0,n.$1j)("diff-single",60450),diffMultiple:(0,n.$1j)("diff-multiple",60451),surroundWith:(0,n.$1j)("surround-with",60452),share:(0,n.$1j)("share",60453),gitStash:(0,n.$1j)("git-stash",60454),gitStashApply:(0,n.$1j)("git-stash-apply",60455),gitStashPop:(0,n.$1j)("git-stash-pop",60456),vscode:(0,n.$1j)("vscode",60457),vscodeInsiders:(0,n.$1j)("vscode-insiders",60458),codeOss:(0,n.$1j)("code-oss",60459),runCoverage:(0,n.$1j)("run-coverage",60460),runAllCoverage:(0,n.$1j)("run-all-coverage",60461),coverage:(0,n.$1j)("coverage",60462),githubProject:(0,n.$1j)("github-project",60463),mapVertical:(0,n.$1j)("map-vertical",60464),foldVertical:(0,n.$1j)("fold-vertical",60464),mapVerticalFilled:(0,n.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$1j)("fold-vertical-filled",60465),goToSearch:(0,n.$1j)("go-to-search",60466),percentage:(0,n.$1j)("percentage",60467),sortPercentage:(0,n.$1j)("sort-percentage",60467),attach:(0,n.$1j)("attach",60468)}}),define(ce[80],le([0,1,109,149]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=E;function E(){return Object.values(e.$6j)}e.$5j={dialogError:(0,n.$1j)("dialog-error","error"),dialogWarning:(0,n.$1j)("dialog-warning","warning"),dialogInfo:(0,n.$1j)("dialog-info","info"),dialogClose:(0,n.$1j)("dialog-close","close"),treeItemExpanded:(0,n.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$1j)("tree-filter-clear","close"),treeItemLoading:(0,n.$1j)("tree-item-loading","loading"),menuSelection:(0,n.$1j)("menu-selection","check"),menuSubmenu:(0,n.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$1j)("toolbar-more","more"),quickInputBack:(0,n.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$1j)("drop-down-button",60084),symbolCustomColor:(0,n.$1j)("symbol-customcolor",60252),exportIcon:(0,n.$1j)("export",60332),workspaceUnspecified:(0,n.$1j)("workspace-unspecified",60355),newLine:(0,n.$1j)("newline",60394),thumbsDownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$1j)("thumbsup-filled",60436),gitFetch:(0,n.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$1j)("debug-breakpoint-pending",60377)},e.$6j={...r.$3j,...e.$5j}}),define(ce[37],le([0,1,11]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=r,e.$go=E,e.$ho=O,e.$io=p,e.$jo=c,e.$ko=g,e.$lo=u,e.$mo=m,e.$no=w,e.$oo=f,e.$po=d,e.$qo=v,e.$ro=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const k=Array.isArray($)?[]:{};return Object.entries($).forEach(([S,i])=>{k[S]=i&&typeof i=="object"?r(i):i}),k}function E($){if(!$||typeof $!="object")return $;const k=[$];for(;k.length>0;){const S=k.shift();Object.freeze(S);for(const i in S)if(A.call(S,i)){const h=S[i];typeof h=="object"&&!Object.isFrozen(h)&&!(0,n.$ig)(h)&&k.push(h)}}return $}const A=Object.prototype.hasOwnProperty;function O($,k){return I($,k,new Set)}function I($,k,S){if((0,n.$og)($))return $;const i=k($);if(typeof i<"u")return i;if(Array.isArray($)){const h=[];for(const t of $)h.push(I(t,k,S));return h}if((0,n.$hg)($)){if(S.has($))throw new Error("Cannot clone recursive data-structure");S.add($);const h={};for(const t in $)A.call($,t)&&(h[t]=I($[t],k,S));return S.delete($),h}return $}function p($,k,S=!0){return(0,n.$hg)($)?((0,n.$hg)(k)&&Object.keys(k).forEach(i=>{i in $?S&&((0,n.$hg)($[i])&&(0,n.$hg)(k[i])?p($[i],k[i],S):$[i]=k[i]):$[i]=k[i]}),$):k}function c($,k){if($===k)return!0;if($==null||k===null||k===void 0||typeof $!=typeof k||typeof $!="object"||Array.isArray($)!==Array.isArray(k))return!1;let S,i;if(Array.isArray($)){if($.length!==k.length)return!1;for(S=0;S<$.length;S++)if(!c($[S],k[S]))return!1}else{const h=[];for(i in $)h.push(i);h.sort();const t=[];for(i in k)t.push(i);if(t.sort(),!c(h,t))return!1;for(S=0;S<h.length;S++)if(!c($[h[S]],k[h[S]]))return!1}return!0}function g($){const k=new Set;return JSON.stringify($,(S,i)=>{if((0,n.$hg)(i)||Array.isArray(i)){if(k.has(i))return"[Circular]";k.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u($,k){const S=Object.create(null);return!$||!k||Object.keys(k).forEach(h=>{const t=$[h],o=k[h];c(t,o)||(S[h]=o)}),S}function m($,k){const S=k.toLowerCase(),i=Object.keys($).find(h=>h.toLowerCase()===S);return i?$[i]:$[k]}function w($,k){const S=Object.create(null);for(const[i,h]of Object.entries($))k(i,h)&&(S[i]=h);return S}function f($){let k=[];for(;Object.prototype!==$;)k=k.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return k}function d($){const k=[];for(const S of f($))typeof $[S]=="function"&&k.push(S);return k}function v($,k){const S=h=>function(){const t=Array.prototype.slice.call(arguments,0);return k(h,t)},i={};for(const h of $)i[h]=S(h);return i}function b($,k){const S={};for(const[i,h]of Object.entries($))S[i]=k(h,i);return S}}),define(ce[110],le([0,1,80]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=E;var r;(function(O){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}O.isThemeColor=I})(r||(e.ThemeColor=r={}));function E(O){return{id:O}}var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function p($){const k=I.exec($.id);if(!k)return p(n.$6j.error);const[,S,i]=k,h=["codicon","codicon-"+S];return i&&h.push("codicon-modifier-"+i.substring(1)),h}O.asClassNameArray=p;function c($){return p($).join(" ")}O.asClassName=c;function g($){return"."+p($).join(".")}O.asCSSSelector=g;function u($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}O.isThemeIcon=u;const m=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function w($){const k=m.exec($);if(!k)return;const[,S]=k;return{id:S}}O.fromString=w;function f($){return{id:$}}O.fromId=f;function d($,k){let S=$.id;const i=S.lastIndexOf("~");return i!==-1&&(S=S.substring(0,i)),k&&(S=`${S}~${k}`),{id:S}}O.modify=d;function v($){const k=$.id.lastIndexOf("~");if(k!==-1)return $.id.substring(k+1)}O.getModifier=v;function b($,k){return $.id===k.id&&$.color?.id===k.color?.id}O.isEqual=b})(A||(e.ThemeIcon=A={}))}),define(ce[150],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=r,e.$cf=E;var n;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(A){return A<0?0:A>n.MAX_UINT_8?n.MAX_UINT_8:A|0}function E(A){return A<0?0:A>n.MAX_UINT_32?n.MAX_UINT_32:A|0}}),define(ce[25],le([0,1,147,39,65,150]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=O,e.$ef=p,e.$ff=g,e.$gf=u,e.$hf=m,e.$if=w,e.$jf=f,e.$kf=d,e.$lf=v,e.$mf=b,e.$nf=$,e.$of=k,e.$pf=S,e.$qf=i,e.$rf=h,e.$sf=t,e.$tf=o,e.$uf=s,e.$vf=a,e.$wf=l,e.$xf=P,e.$yf=y,e.$zf=D,e.$Af=L,e.$Bf=R,e.$Cf=T,e.$Df=N,e.$Ef=V,e.$Ff=H,e.$Gf=Y,e.$Hf=de,e.$If=q,e.$Jf=Q,e.$Kf=U,e.$Lf=Z,e.$Mf=W,e.$Nf=j,e.$Qf=G,e.$Rf=ue,e.$Sf=re,e.$Tf=J,e.$Uf=_,e.$Vf=ie,e.$Xf=K,e.$Yf=B,e.$Zf=te,e.$1f=he,e.$2f=we,e.$3f=Ie,e.$4f=De,e.$6f=ve,e.$7f=$e,e.$8f=ee,e.$9f=ae,e.$0f=fe,e.$$f=be,e.$_f=Ae,e.$ag=Ne,e.$bg=Ze;function O(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function p(ne,...ge){return ge.length===0?ne:ne.replace(I,function(pe,ye){const je=parseInt(ye,10);return isNaN(je)||je<0||je>=ge.length?pe:ge[je]})}const c=/{([^}]+)}/g;function g(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(pe,ye)=>ge[ye]??pe)}function u(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let pe=0,ye=ne.indexOf(ge);for(;ye!==-1;)pe++,ye=ne.indexOf(ge,ye+ge.length);return pe}function d(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function v(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-pe.length/2,je=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,ye)}${pe}${ne.substr(ne.length-je)}`}function b(ne,ge=" "){const pe=$(ne,ge);return k(pe,ge)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+pe;return ne.substring(ye)}function k(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,ye=ne.length;if(pe===0||ye===0)return ne;let je=ye,Ue=-1;for(;Ue=ne.lastIndexOf(ge,je-1),!(Ue===-1||Ue+pe!==je);){if(Ue===0)return"";je=Ue}return ne.substring(0,je)}function S(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(ne){return ne.replace(/\*/g,"")}function h(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=w(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ne,ye)}function t(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function s(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const ye=ne.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ne,ge=0,pe=ne.length){for(let ye=ge;ye<pe;ye++){const je=ne.charCodeAt(ye);if(je!==r.CharCode.Space&&je!==r.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,pe)}function P(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const ye=ne.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ne,ge,pe){const ye=[];let je=0;for(const Ue of ne.matchAll(ge)){if(ye.push(ne.slice(je,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");je=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ne,Ue.groups))}return ye.push(ne.slice(je)),Promise.all(ye).then(Ue=>Ue.join(""))}function D(ne,ge){return ne<ge?-1:ne>ge?1:0}function L(ne,ge,pe=0,ye=ne.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){const rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt<at)return-1;if(rt>at)return 1}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function R(ne,ge){return T(ne,ge,0,ne.length,0,ge.length)}function T(ne,ge,pe=0,ye=ne.length,je=0,Ue=ge.length){for(;pe<ye&&je<Ue;pe++,je++){let rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt===at)continue;if(rt>=128||at>=128)return L(ne.toLowerCase(),ge.toLowerCase(),pe,ye,je,Ue);V(rt)&&(rt-=32),V(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=ye-pe,lt=Ue-je;return _e<lt?-1:_e>lt?1:0}function N(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function V(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function H(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function Y(ne,ge){return ne.length===ge.length&&T(ne,ge)===0}function de(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:T(ne,ge,0,pe)===0}function q(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function Q(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;const je=ne.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(je-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function U(ne){return 55296<=ne&&ne<=56319}function Z(ne){return 56320<=ne&&ne<=57343}function W(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function j(ne,ge,pe){const ye=ne.charCodeAt(pe);if(U(ye)&&pe+1<ge){const je=ne.charCodeAt(pe+1);if(Z(je))return W(ye,je)}return ye}function C(ne,ge){const pe=ne.charCodeAt(ge-1);if(Z(pe)&&ge>1){const ye=ne.charCodeAt(ge-2);if(U(ye))return W(ye,pe)}return pe}class X{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=C(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Of=X;class oe{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new X(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(je,_e)){pe.setOffset(Ue);break}je=_e}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,_e=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(_e,je)){pe.setOffset(Ue);break}je=_e}return ye-pe.offset}eol(){return this.c.eol()}}e.$Pf=oe;function G(ne,ge){return new oe(ne,ge).nextGraphemeLength()}function ue(ne,ge){return new oe(ne,ge).prevGraphemeLength()}function re(ne,ge){ge>0&&Z(ne.charCodeAt(ge))&&ge--;const pe=ge+G(ne,ge);return[pe-ue(ne,pe),pe]}function J(ne){const ge=new oe(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let M;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(ne){return M||(M=F()),M.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function ie(ne){return z.test(ne)}e.$Wf=/[\u2028\u2029]/;function K(ne){return e.$Wf.test(ne)}function B(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function te(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function he(ne,ge,pe=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const je=/\b/g;let Ue=0;for(;je.test(ye)&&!(ye.length-je.lastIndex<ge);)Ue=je.lastIndex,je.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const pe of ne.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ne.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function Ie(ne){return ne&&(ne=ne.replace(me,"")),ne}const Ce=/\\\[.*?\\\]/g;function De(ne){return Ie(ne).replace(Ce,"")}e.$5f=String.fromCharCode(r.CharCode.UTF8_BOM);function ve(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ne){return ve(ne)?ne.substr(1):ne}function ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,ye=ne.toLowerCase();let je=0,Ue=-1;for(;je<pe;){const _e=ye.indexOf(ge[je],Ue+1);if(_e<0)return!1;Ue=_e,je++}return!0}function ae(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function be(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function Ae(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function Ne(ne){return Be.getInstance().getGraphemeBreakType(ne)}function Me(ne,ge){return ne===Re.Other?ge!==Re.Extend&&ge!==Re.SpacingMark:ne===Re.CR&&ge===Re.LF?!1:ne===Re.Control||ne===Re.CR||ne===Re.LF||ge===Re.Control||ge===Re.CR||ge===Re.LF?!0:!(ne===Re.L&&(ge===Re.L||ge===Re.V||ge===Re.LV||ge===Re.LVT)||(ne===Re.LV||ne===Re.V)&&(ge===Re.V||ge===Re.T)||(ne===Re.LVT||ne===Re.T)&&ge===Re.T||ge===Re.Extend||ge===Re.ZWJ||ge===Re.SpacingMark||ne===Re.Prepend||ne===Re.ZWJ&&ge===Re.Extended_Pictographic||ne===Re.Regional_Indicator&&ge===Re.Regional_Indicator)}var Re;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ke()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Re.LF:ge===r.CharCode.CarriageReturn?Re.CR:Re.Control;if(ge<127)return Re.Other;const pe=this.d,ye=pe.length/3;let je=1;for(;je<=ye;)if(ge<pe[3*je])je=2*je;else if(ge>pe[3*je+1])je=2*je+1;else return pe[3*je+2];return Re.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(ne,ge){if(ne===0)return 0;const pe=qe(ne,ge);if(pe!==void 0)return pe;const ye=new X(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const pe=new X(ge,ne);let ye=pe.prevCodePoint();for(;Xe(ye)||ye===Je.emojiVariantSelector||ye===Je.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!te(ye))return;let je=pe.offset;return je>0&&pe.prevCodePoint()===Je.zwj&&(je=pe.offset),je}function Xe(ne){return 127995<=ne&&ne<=127999}var Je;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.$cg="\xA0";class Qe{static{this.c=new E.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$_e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function je(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=pe(Ue[tt]);lt=je(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Qe(at)})}static getInstance(ge){return Qe.d.get(Array.from(ge))}static{this.e=new E.$U(()=>Object.keys(Qe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Qe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=Qe;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ge){return We.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&We.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return We.e()}}e.$eg=We}),define(ce[32],le([0,1,39,9,3,25,11]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=I,e.$zg=p,e.$Ag=c,e.$Bg=g,e.$Cg=u,e.$Dg=d,e.$Eg=v,e.$Fg=b,e.$Gg=$,e.$Hg=k,e.$Ig=S,e.$Jg=i,e.$Kg=h,e.$Lg=t,e.$Mg=o,e.$Ng=s,e.$Og=P;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$hc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function g(y,D=r.$hc.sep){if(!y)return"";const L=y.length,R=y.charCodeAt(0);if(I(R)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let N=3;const V=N;for(;N<L&&!I(y.charCodeAt(N));N++);if(V!==N&&!I(y.charCodeAt(N+1))){for(N+=1;N<L;N++)if(I(y.charCodeAt(N)))return y.slice(0,N+1).replace(/[\\/]/g,D)}}return D}else if($(R)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+D:y.slice(0,2);let T=y.indexOf("://");if(T!==-1){for(T+=3;T<L;T++)if(I(y.charCodeAt(T)))return y.slice(0,T+1)}return""}function u(y){if(!E.$j||!y||y.length<5)return!1;let D=y.charCodeAt(0);if(D!==n.CharCode.Backslash||(D=y.charCodeAt(1),D!==n.CharCode.Backslash))return!1;let L=2;const R=L;for(;L<y.length&&(D=y.charCodeAt(L),D!==n.CharCode.Backslash);L++);return!(R===L||(D=y.charCodeAt(L+1),isNaN(D)||D===n.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(y,D=E.$j){const L=D?m:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||D&&f.test(y)||y==="."||y===".."||D&&y[y.length-1]==="."||D&&y.length!==y.trim().length||y.length>255)}function v(y,D,L){const R=y===D;return!L||R?R:!y||!D?!1:(0,A.$Gf)(y,D)}function b(y,D,L,R=r.sep){if(y===D)return!0;if(!y||!D||D.length>y.length)return!1;if(L){if(!(0,A.$Hf)(y,D))return!1;if(D.length===y.length)return!0;let N=D.length;return D.charAt(D.length-1)===R&&N--,y.charAt(N)===R}return D.charAt(D.length-1)!==R&&(D+=R),y.indexOf(D)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function k(y,D){return E.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$jc)(y)||(y=(0,r.$kc)(D,y)),y=(0,r.$ic)(y),S(y)}function S(y){return E.$j?(y=(0,A.$of)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,A.$of)(y,r.sep),y||(y=r.sep)),y}function i(y){const D=(0,r.$ic)(y);return E.$j?y.length>3?!1:h(D)&&(y.length===2||D.charCodeAt(2)===n.CharCode.Backslash):D===r.$hc.sep}function h(y,D=E.$j){return D?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function t(y,D=E.$j){return h(y,D)?y[0]:void 0}function o(y,D,L){return D.length>y.length?-1:y===D?0:(L&&(y=y.toLowerCase(),D=D.toLowerCase()),y.indexOf(D))}function s(y){const D=y.split(":");let L,R,T;for(const N of D){const V=Number(N);(0,O.$jg)(V)?R===void 0?R=V:T===void 0&&(T=V):L=L?[L,N].join(":"):N}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:R!==void 0?R:void 0,column:T!==void 0?T:R!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(y,D,L=8){let R="";for(let N=0;N<L;N++){let V;N===0&&E.$j&&!D&&(L===3||L===4)?V=l:V=a,R+=V.charAt(Math.floor(Math.random()*V.length))}let T;return D?T=`${D}-${R}`:T=R,y?(0,r.$kc)(y,T):T}}),define(ce[46],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=r,e.$vj=E,e.$wj=A,e.$xj=I,e.$zj=d,n=Pe(n);function r(b){return E(b,0)}function E(b,$){switch(typeof b){case"object":return b===null?A(349,$):Array.isArray(b)?p(b,$):c(b,$);case"string":return I(b,$);case"boolean":return O(b,$);case"number":return A(b,$);case"undefined":return A(937,$);default:return A(617,$)}}function A(b,$){return($<<5)-$+b|0}function O(b,$){return A(b?433:863,$)}function I(b,$){$=A(149417,$);for(let k=0,S=b.length;k<S;k++)$=A(b.charCodeAt(k),$);return $}function p(b,$){return $=A(104579,$),b.reduce((k,S)=>E(S,k),$)}function c(b,$){return $=A(181387,$),Object.keys(b).sort().reduce((k,S)=>(k=I(S,k),E(b[S],k)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=E($,this.g),this.g}}e.$yj=g;var u;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function m(b,$,k=32){const S=k-$,i=~((1<<S)-1);return(b<<$|(i&b)>>>S)>>>0}function w(b,$=0,k=b.byteLength,S=0){for(let i=0;i<k;i++)b[$+i]=S}function f(b,$,k="0"){for(;b.length<$;)b=k+b;return b}function d(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(k=>k.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const k=$.length;if(k===0)return;const S=this.p;let i=this.r,h=this.u,t,o;for(h!==0?(t=h,o=-1,h=0):(t=$.charCodeAt(0),o=0);;){let s=t;if(n.$Kf(t))if(o+1<k){const a=$.charCodeAt(o+1);n.$Lf(a)?(o++,s=n.$Mf(t,a)):s=u.UNICODE_REPLACEMENT}else{h=t;break}else n.$Lf(t)&&(s=u.UNICODE_REPLACEMENT);if(i=this.w(S,i,s),o++,o<k)t=$.charCodeAt(o);else break}this.r=i,this.u=h}w($,k,S){return S<128?$[k++]=S:S<2048?($[k++]=192|(S&1984)>>>6,$[k++]=128|(S&63)>>>0):S<65536?($[k++]=224|(S&61440)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0):($[k++]=240|(S&1835008)>>>18,$[k++]=128|(S&258048)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0),k>=u.BLOCK_SIZE&&(this.y(),k-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,k=this.q;for(let P=0;P<64;P+=4)$.setUint32(P,k.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)$.setUint32(P,m($.getUint32(P-12,!1)^$.getUint32(P-32,!1)^$.getUint32(P-56,!1)^$.getUint32(P-64,!1),1),!1);let S=this.h,i=this.l,h=this.m,t=this.n,o=this.o,s,a,l;for(let P=0;P<80;P++)P<20?(s=i&h|~i&t,a=1518500249):P<40?(s=i^h^t,a=1859775393):P<60?(s=i&h|i&t|h&t,a=2400959708):(s=i^h^t,a=3395469782),l=m(S,5)+s+o+a+$.getUint32(P*4,!1)&4294967295,o=t,t=h,h=m(i,30),i=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+i&4294967295,this.m=this.m+h&4294967295,this.n=this.n+t&4294967295,this.o=this.o+o&4294967295}}e.$Aj=v}),define(ce[81],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Pe(n);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const A="error",O="warning",I="warn",p="info",c="ignore";function g(m){return m?n.$Gf(A,m)?E.Error:n.$Gf(O,m)||n.$Gf(I,m)?E.Warning:n.$Gf(p,m)?E.Info:E.Ignore:E.Ignore}E.fromValue=g;function u(m){switch(m){case E.Error:return A;case E.Warning:return O;case E.Info:return p;default:return c}}E.toString=u}(r||(r={})),e.default=r}),define(ce[60],le([0,1,21,39,25]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class A{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$Ii=A;class O{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,E.$Af)(f,this.b,0,f.length,this.c,this.d):(0,E.$Cf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=O;class I{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===r.CharCode.Slash||this.f&&d===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,E.$Af)(f,this.b,0,f.length,this.d,this.e):(0,E.$Cf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,E.$Bf)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,E.$Bf)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,E.$zf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,E.$zf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Li=c;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(u||(u={}));class m{static forUris(f=()=>!1,d=()=>!1){return new m(new c(f,d))}static forPaths(f=!1){return new m(new I(void 0,!f))}static forStrings(){return new m(new A)}static forConfigKeys(){return new m(new O)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,n.$Wb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Wb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,d){const v=this.b.reset(f);let b;this.c||(this.c=new g,this.c.segment=v.value());const $=[];for(b=this.c;;){const S=v.cmp(b.segment);if(S>0)b.left||(b.left=new g,b.left.segment=v.value()),$.push([u.Left,b]),b=b.left;else if(S<0)b.right||(b.right=new g,b.right.segment=v.value()),$.push([u.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new g,b.mid.segment=v.value()),$.push([u.Mid,b]),b=b.mid;else break}const k=b.value;b.value=d,b.key=f;for(let S=$.length-1;S>=0;S--){const i=$[S][1];i.updateHeight();const h=i.balanceFactor();if(h<-1||h>1){const t=$[S][0],o=$[S+1][0];if(t===u.Right&&o===u.Right)$[S][1]=i.rotateLeft();else if(t===u.Left&&o===u.Left)$[S][1]=i.rotateRight();else if(t===u.Right&&o===u.Left)i.right=$[S+1][1]=$[S+1][1].rotateRight(),$[S][1]=i.rotateLeft();else if(t===u.Left&&o===u.Right)i.left=$[S+1][1]=$[S+1][1].rotateLeft(),$[S][1]=i.rotateRight();else throw new Error;if(S>0)switch($[S-1][0]){case u.Left:$[S-1][1].left=$[S][1];break;case u.Right:$[S-1][1].right=$[S][1];break;case u.Mid:$[S-1][1].mid=$[S][1];break}else this.c=$[0][1]}}return k}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const b=d.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const k=v.cmp($.segment);if(k>0)b.push([u.Left,$]),$=$.left;else if(k<0)b.push([u.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([u.Mid,$]),$=$.mid;else break}if($){if(d?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const k=this.f($.right);if(k.key){const{key:S,value:i,segment:h}=k;this.e(k.key,!1),$.key=S,$.value=i,$.segment=h}}else{const k=$.left??$.right;if(b.length>0){const[S,i]=b[b.length-1];switch(S){case u.Left:i.left=k;break;case u.Mid:i.mid=k;break;case u.Right:i.right=k;break}}else this.c=k}for(let k=b.length-1;k>=0;k--){const S=b[k][1];S.updateHeight();const i=S.balanceFactor();if(i>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),b[k][1]=S.rotateLeft()):i<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),b[k][1]=S.rotateRight()),k>0)switch(b[k-1][0]){case u.Left:b[k-1][1].left=b[k][1];break;case u.Right:b[k-1][1].right=b[k][1];break;case u.Mid:b[k-1][1].mid=b[k][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,b;for(;v;){const $=d.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(d.hasNext())d.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):d?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){f&&(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.$Mi=m}),define(ce[7],le([0,1,39,90,9,3]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=h,E=Pe(E);const O=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function c(l,P){if(!l.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!O.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(l,P){return!l&&!P?"file":l}function u(l,P){switch(l){case"https":case"http":case"file":P?P[0]!==w&&(P=w+P):P=w;break}return P}const m="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(P){return P instanceof d?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,y,D,L,R,T=!1){typeof P=="object"?(this.scheme=P.scheme||m,this.authority=P.authority||m,this.path=P.path||m,this.query=P.query||m,this.fragment=P.fragment||m):(this.scheme=g(P,T),this.authority=y||m,this.path=u(this.scheme,D||m),this.query=L||m,this.fragment=R||m,c(this,T))}get fsPath(){return h(this,!1)}with(P){if(!P)return this;let{scheme:y,authority:D,path:L,query:R,fragment:T}=P;return y===void 0?y=this.scheme:y===null&&(y=m),D===void 0?D=this.authority:D===null&&(D=m),L===void 0?L=this.path:L===null&&(L=m),R===void 0?R=this.query:R===null&&(R=m),T===void 0?T=this.fragment:T===null&&(T=m),y===this.scheme&&D===this.authority&&L===this.path&&R===this.query&&T===this.fragment?this:new $(y,D,L,R,T)}static parse(P,y=!1){const D=f.exec(P);return D?new $(D[2]||m,a(D[4]||m),a(D[5]||m),a(D[7]||m),a(D[9]||m),y):new $(m,m,m,m,m)}static file(P){let y=m;if(A.$j&&(P=P.replace(/\\/g,w)),P[0]===w&&P[1]===w){const D=P.indexOf(w,2);D===-1?(y=P.substring(2),P=w):(y=P.substring(2,D),P=P.substring(D)||w)}return new $("file",y,P,m,m)}static from(P,y){return new $(P.scheme,P.authority,P.path,P.query,P.fragment,y)}static joinPath(P,...y){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return A.$j&&P.scheme==="file"?D=d.file(E.$gc.join(h(P,!0),...y)).path:D=E.$hc.join(P.path,...y),P.with({path:D})}toString(P=!1){return t(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof d)return P;{const y=new $(P);return y._formatted=P.external??null,y._fsPath=P._sep===b?P.fsPath??null:null,y}}else return P}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=d;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=A.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(P=!1){return P?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const P={$mid:r.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=b),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const k={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function S(l,P,y){let D,L=-1;for(let R=0;R<l.length;R++){const T=l.charCodeAt(R);if(T>=n.CharCode.a&&T<=n.CharCode.z||T>=n.CharCode.A&&T<=n.CharCode.Z||T>=n.CharCode.Digit0&&T<=n.CharCode.Digit9||T===n.CharCode.Dash||T===n.CharCode.Period||T===n.CharCode.Underline||T===n.CharCode.Tilde||P&&T===n.CharCode.Slash||y&&T===n.CharCode.OpenSquareBracket||y&&T===n.CharCode.CloseSquareBracket||y&&T===n.CharCode.Colon)L!==-1&&(D+=encodeURIComponent(l.substring(L,R)),L=-1),D!==void 0&&(D+=l.charAt(R));else{D===void 0&&(D=l.substr(0,R));const N=k[T];N!==void 0?(L!==-1&&(D+=encodeURIComponent(l.substring(L,R)),L=-1),D+=N):L===-1&&(L=R)}}return L!==-1&&(D+=encodeURIComponent(l.substring(L))),D!==void 0?D:l}function i(l){let P;for(let y=0;y<l.length;y++){const D=l.charCodeAt(y);D===n.CharCode.Hash||D===n.CharCode.QuestionMark?(P===void 0&&(P=l.substr(0,y)),P+=k[D]):P!==void 0&&(P+=l[y])}return P!==void 0?P:l}function h(l,P){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?P?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,A.$j&&(y=y.replace(/\//g,"\\")),y}function t(l,P){const y=P?i:S;let D="",{scheme:L,authority:R,path:T,query:N,fragment:V}=l;if(L&&(D+=L,D+=":"),(R||L==="file")&&(D+=w,D+=w),R){let H=R.indexOf("@");if(H!==-1){const Y=R.substr(0,H);R=R.substr(H+1),H=Y.lastIndexOf(":"),H===-1?D+=y(Y,!1,!1):(D+=y(Y.substr(0,H),!1,!1),D+=":",D+=y(Y.substr(H+1),!1,!0)),D+="@"}R=R.toLowerCase(),H=R.lastIndexOf(":"),H===-1?D+=y(R,!1,!0):(D+=y(R.substr(0,H),!1,!0),D+=R.substr(H))}if(T){if(T.length>=3&&T.charCodeAt(0)===n.CharCode.Slash&&T.charCodeAt(2)===n.CharCode.Colon){const H=T.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(T=`/${String.fromCharCode(H+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===n.CharCode.Colon){const H=T.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(T=`${String.fromCharCode(H+32)}:${T.substr(2)}`)}D+=y(T,!0,!1)}return N&&(D+="?",D+=y(N,!1,!1)),V&&(D+="#",D+=P?V:S(V,!1,!1)),D}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,P=>o(P)):l}}),define(ce[151],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=r,e.$hr=E,e.$ir=A,e.log=I;function r(c){const g=c;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function E(c){const g=[];let u;try{const m=JSON.parse(c.arguments),w=m[m.length-1];w&&w.__$stack&&(m.pop(),u=w.__$stack),g.push(...m)}catch{g.push("Unable to log remote console arguments",c.arguments)}return{args:g,stack:u}}function A(c){if(typeof c!="string")return A(E(c).stack);const g=c;if(g){const u=O(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(m&&m.length===4)return{uri:n.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function O(c){if(!c)return c;const g=c.indexOf(`
`);return g===-1?c:c.substring(0,g)}function I(c,g){const{args:u,stack:m}=E(c),w=typeof u[0]=="string"&&u.length===1;let f=O(m);f&&(f=`(${f.trim()})`);let d=[];if(typeof u[0]=="string"?f&&w?d=[`%c[${g}] %c${u[0]} %c${f}`,p("blue"),p(""),p("grey")]:d=[`%c[${g}] %c${u[0]}`,p("blue"),p(""),...u.slice(1)]:d=[`%c[${g}]%`,p("blue"),...u],f&&!w&&d.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,d)}function p(c){return`color: ${c}`}}),define(ce[82],le([0,1,17,7,90]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=A,e.$ci=O,e.$di=p;function A(c){return JSON.stringify(c,I)}function O(c){let g=JSON.parse(c);return g=p(g),g}function I(c,g){return g instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:g.source,flags:g.flags}:g}function p(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case E.MarshalledId.Uri:return r.URI.revive(c);case E.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case E.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=p(c[u],g+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=p(c[u],g+1))}return c}}),define(ce[12],le([0,1,15,3,25,7,9]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=p,e.$Qg=c,e.$Ug=u,n=Pe(n),r=Pe(r),O=Pe(O);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,d){return A.URI.isUri(f)?(0,E.$Gf)(f.scheme,d):(0,E.$Hf)(f,d+":")}function c(f,...d){return d.some(v=>p(f,v))}e.$Rg="vscode-tkn",e.$Sg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,v){this.f=u(d,v)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,I.vscodeRemoteResource)}set(d,v,b){this.a[d]=v,this.b[d]=b}setConnectionToken(d,v){this.c[d]=v}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(i){return n.$Z(i),d}const v=d.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],k=this.c[v];let S=`path=${encodeURIComponent(d.path)}`;return typeof k=="string"&&(S+=`&${e.$Sg}=${encodeURIComponent(k)}`),A.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:S})}}e.$Tg=new g;function u(f,d){return O.$hc.join(d??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class m{static{this.a=e.$Zg}asBrowserUri(d){const v=this.b(d,x);return this.uriToBrowserUri(v)}uriToBrowserUri(d){return d.scheme===I.vscodeRemote?e.$Tg.rewrite(d):d.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${m.a}`)?d.with({scheme:I.vscodeFileResource,authority:d.authority||m.a,query:null,fragment:null}):d}asFileUri(d){const v=this.b(d,x);return this.uriToFileUri(v)}uriToFileUri(d){return d.scheme===I.vscodeFileResource?d.with({scheme:I.file,authority:d.authority!==m.a?d.authority:null,query:null,fragment:null}):d}b(d,v){return A.URI.isUri(d)?d:A.URI.parse(v.toUrl(d))}}e.$1g=new m;var w;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const v="vscode-coi";function b(k){let S;typeof k=="string"?S=new URL(k).searchParams:k instanceof URL?S=k.searchParams:A.URI.isUri(k)&&(S=new URL(k.toString(!0)).searchParams);const i=S?.get(v);if(i)return d.get(i)}f.getHeadersFromQuery=b;function $(k,S,i){if(!globalThis.crossOriginIsolated)return;const h=S&&i?"3":i?"2":"1";k instanceof URLSearchParams?k.set(v,h):k[v]=h}f.addSearchParam=$})(w||(e.COI=w={}))}),define(ce[152],le([0,1,138,12,3,11,7]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=u,e.$vq=m,E=Pe(E);class I{constructor(f,d,v){this.id=f,this.dependencies=d,this.callback=v}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,d,v)=>{typeof f!="string"&&(v=d,d=f,f=null),(typeof d!="object"||!Array.isArray(d))&&(v=d,d=null),this.c.push(new I(f,d,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const d=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!d)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(f){return new Promise((d,v)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const $=()=>{b.removeEventListener("load",k),b.removeEventListener("error",S)},k=i=>{$(),d(this.c.pop())},S=i=>{$(),v(i)};b.addEventListener("load",k),b.addEventListener("error",S),this.f&&(f=this.f.createScriptURL(f)),b.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(b)})}async i(f){return this.f&&(f=this.f.createScriptURL(f)),n.$R?await new Promise((d,v)=>{x([f],d,v)}).then(Pe):importScripts(f),this.c.pop()}async j(f){try{const d=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,$=O.URI.parse(f).fsPath,k=d.readFileSync($).toString(),S=b.wrap(k.replace(/^#!.*/,""));return new v.Script(S).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const c=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function u(w,f,d){if(n.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[w]&&(w=g[w]);const v=f?`${w}/${f}`:w;if(c.has(v))return c.get(v);let b;if(/^\w[\w\d+.-]*:\/\//.test(v))b=v;else{const i=`${n.$S&&d&&!E.$p?r.$Xg:r.$Wg}/${v}`;b=r.$1g.asBrowserUri(i).toString(!0)}const $=p.INSTANCE.load(b);return c.set(v,$),$}else return await new Promise((v,b)=>{x([w],v,b)}).then(Pe)}function m(w,f){(0,A.$pg)(n.$R);const v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,b=n.$S&&v&&!E.$p,$=`${w}/${f}`,S=`${b?r.$Xg:r.$Wg}/${$}`;return r.$1g.asBrowserUri(S).toString(!0)}}),define(ce[18],le([0,1,39,32,12,9,3,25,7]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=c,e.$qh=u,e.$rh=w,r=Pe(r),A=Pe(A);function c(f){return(0,p.$xc)(f,!0)}class g{constructor(d){this.a=d}compare(d,v,b=!1){return d===v?0:(0,I.$zf)(this.getComparisonKey(d,b),this.getComparisonKey(v,b))}isEqual(d,v,b=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,b)===this.getComparisonKey(v,b)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,b=!1){if(d.scheme===v.scheme){if(d.scheme===E.Schemas.file)return r.$Fg(c(d),c(v),this.a(d))&&d.query===v.query&&(b||d.fragment===v.fragment);if((0,e.$mh)(d.authority,v.authority))return r.$Fg(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(b||d.fragment===v.fragment)}return!1}joinPath(d,...v){return p.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$eh)(d)||d.authority}basename(d){return A.$hc.basename(d.path)}extname(d){return A.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===E.Schemas.file?v=p.URI.file(A.$nc(c(d))).path:(v=A.$hc.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===E.Schemas.file?v=p.URI.file(A.$ic(c(d))).path:v=A.$hc.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$mh)(d.authority,v.authority))return;if(d.scheme===E.Schemas.file){const k=A.$mc(c(d),c(v));return O.$j?r.$zg(k):k}let b=d.path||"/";const $=v.path||"/";if(this.a(d)){let k=0;for(const S=Math.min(b.length,$.length);k<S&&!(b.charCodeAt(k)!==$.charCodeAt(k)&&b.charAt(k).toLowerCase()!==$.charAt(k).toLowerCase());k++);b=$.substr(0,k)+b.substr(k)}return A.$hc.relative(b,$)}resolvePath(d,v){if(d.scheme===E.Schemas.file){const b=p.URI.file(A.$lc(c(d),v));return d.with({authority:b.authority,path:b.path})}return v=r.$Ag(v),d.with({path:A.$hc.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,I.$Gf)(d,v)}hasTrailingPathSeparator(d,v=A.sep){if(d.scheme===E.Schemas.file){const b=c(d);return b.length>r.$Bg(b).length&&b[b.length-1]===v}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=A.sep){return(0,e.$nh)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=A.sep){let b=!1;if(d.scheme===E.Schemas.file){const $=c(d);b=$!==void 0&&$.length===r.$Bg($).length&&$[$.length-1]===v}else{v="/";const $=d.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$nh)(d,v)?d.with({path:d.path+"/"}):d}}e.$9g=g,e.$0g=new g(()=>!1),e.$$g=new g(f=>f.scheme===E.Schemas.file?!O.$l:!0),e.$_g=new g(f=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function u(f,d){const v=[];for(let b=0;b<f.length;b++){const $=d(f[b]);f.some((k,S)=>S===b?!1:(0,e.$bh)($,d(k)))||v.push(f[b])}return v}var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(S=>{const[i,h]=S.split(":");i&&h&&b.set(i,h)});const k=v.path.substring(0,v.path.indexOf(";"));return k&&b.set(f.META_DATA_MIME,k),b}f.parseMetaData=d})(m||(e.DataUri=m={}));function w(f,d,v){if(d){let b=f.path;return b&&b[0]!==A.$hc.sep&&(b=A.$hc.sep+b),f.with({scheme:v,authority:d,path:b})}return f.with({scheme:v})}}),define(ce[8],le([0,1,22,15,4,2,18,3,148,65]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=g,e.$th=u,e.$uh=m,e.$vh=w,e.$wh=f,e.$xh=d,e.$yh=v,e.$zh=b,e.$Hh=l,e.$Ih=P,e.$Jh=y,e.$Kh=D,e.$Lh=L,e.$1h=j,e.$9h=z;function g(K){return!!K&&typeof K.then=="function"}function u(K){const B=new n.$xe,te=K(B.token),he=new Promise((me,we)=>{const Ie=B.token.onCancellationRequested(()=>{Ie.dispose(),we(new r.$5)});Promise.resolve(te).then(Ce=>{Ie.dispose(),B.dispose(),me(Ce)},Ce=>{Ie.dispose(),B.dispose(),we(Ce)})});return new class{cancel(){B.cancel(),B.dispose()}then(me,we){return he.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function m(K,B,te){return new Promise((he,me)=>{const we=B.onCancellationRequested(()=>{we.dispose(),he(te)});K.then(he,me).finally(()=>we.dispose())})}function w(K,B){return new Promise((te,he)=>{const me=B.onCancellationRequested(()=>{me.dispose(),he(new r.$5)});K.then(te,he).finally(()=>me.dispose())})}async function f(K){let B=-1;const te=K.map((he,me)=>he.then(we=>(B=me,we)));try{return await Promise.race(te)}finally{K.forEach((he,me)=>{me!==B&&he.cancel()})}}function d(K,B,te){let he;const me=setTimeout(()=>{he?.(void 0),te?.()},B);return Promise.race([K.finally(()=>clearTimeout(me)),new Promise(we=>he=we)])}function v(K){return new Promise((B,te)=>{const he=K();g(he)?he.then(B,te):B(he)})}function b(){let K,B;return{promise:new Promise((he,me)=>{K=he,B=me}),resolve:K,reject:B}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const te=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(te,te).then(he)})}return new Promise((te,he)=>{this.b.then(te,he)})}return this.a=B(),new Promise((te,he)=>{this.a.then(me=>{this.a=null,te(me)},me=>{this.a=null,he(me)})})}dispose(){this.f=!0}}e.$Ah=$;class k{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Bh=k;class S{constructor(){this.a=new Map}queue(B,te){const me=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(B)===me&&this.a.delete(B)});return this.a.set(B,me),me}}e.$Ch=S;const i=(K,B)=>{let te=!0;const he=setTimeout(()=>{te=!1,B()},K);return{isTriggered:()=>te,dispose:()=>{clearTimeout(he),te=!1}}},h=K=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,K())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class t{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,te=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=te===p.$he?h(he):i(te,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=t;class o{constructor(B){this.a=new t(B),this.b=new $}trigger(B,te){return this.a.trigger(()=>this.b.queue(B),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=o;class s{constructor(){this.a=!1,this.b=new Promise((B,te)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=s;class a extends s{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$Gh=a;function l(K,B){return B?new Promise((te,he)=>{const me=setTimeout(()=>{we.dispose(),te()},K),we=B.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),he(new r.$5)})}):u(te=>l(K,te))}function P(K,B=0,te){const he=setTimeout(()=>{K(),te&&me.dispose()},B),me=(0,A.$Tc)(()=>{clearTimeout(he),te?.deleteAndLeak(me)});return te?.add(me),me}function y(K){const B=[];let te=0;const he=K.length;function me(){return te<he?K[te++]():null}function we(Ie){Ie!=null&&B.push(Ie);const Ce=me();return Ce?Ce.then(we):Promise.resolve(B)}return Promise.resolve(null).then(we)}function D(K,B=he=>!!he,te=null){let he=0;const me=K.length,we=()=>{if(he>=me)return Promise.resolve(te);const Ie=K[he++];return Promise.resolve(Ie()).then(De=>B(De)?Promise.resolve(De):we())};return we()}function L(K,B=he=>!!he,te=null){if(K.length===0)return Promise.resolve(te);let he=K.length;const me=()=>{he=-1;for(const we of K)we.cancel?.()};return new Promise((we,Ie)=>{for(const Ce of K)Ce.then(De=>{--he>=0&&B(De)?(me(),we(De)):he===0&&we(te)}).catch(De=>{--he>=0&&(me(),Ie(De))})})}class R{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new E.$me}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,he)=>{this.g.push({factory:B,c:te,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const te=B.factory();te.then(B.c,B.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=R;class T extends R{constructor(){super(1)}}e.$Nh=T;class N{constructor(){this.a=new C,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$Oh=N;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new G;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,te=O.$0g){const he=te.getComparisonKey(B);return this.a.get(he)?.size??0}queueFor(B,te,he=O.$0g){const me=he.getComparisonKey(B);let we=this.a.get(me);if(!we){we=new T;const Ie=this.f++,Ce=E.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$5c),this.d.set(Ie,Ce),this.a.set(me,we)}return we.queue(te)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=V;class H{constructor(B,te){this.b=!1,this.a=-1,typeof B=="function"&&typeof te=="number"&&this.setIfNotSet(B,te)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,te){if(this.b)throw new r.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},te)}setIfNotSet(B,te){if(this.b)throw new r.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},te))}}e.$Qh=H;class Y{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,te,he=globalThis){if(this.f)throw new r.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=he.setInterval(()=>{B()},te);this.d=(0,A.$Tc)(()=>{he.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=Y;class de{constructor(B,te){this.b=-1,this.a=B,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=de;class q{constructor(B,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=B,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=q;class Q extends de{constructor(B,te){super(B,te),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$Uh=Q;class U extends A.$Vc{constructor(B,te){super(),this.g=B,this.h=te,this.a=[],this.b=this.B(new A.$Wc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of B)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(K,B)=>{(0,I.$C)(()=>{if(te)return;const he=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Xh=(K,B,te)=>{const he=K.requestIdleCallback(B,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,K.cancelIdleCallback(he))}}},e.$Wh=K=>(0,e.$Xh)(globalThis,K)}();class Z{constructor(B,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Xh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=Z;class W extends Z{constructor(B){super(globalThis,B)}}e.$Zh=W;async function j(K,B,te){let he;for(let me=0;me<te;me++)try{return await K()}catch(we){he=we,await l(B)}throw he}class C{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,te,he){return this.a={taskId:B,cancel:()=>he?.(),promise:te},te.then(()=>this.d(B),()=>this.d(B)),te}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:te,resolve:he,reject:me}=b();this.b={run:B,promise:te,promiseResolve:he,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=C;class X{constructor(B,te=()=>Date.now()){this.d=B,this.f=te,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$3h=X;var oe;(function(K){K[K.Resolved=0]="Resolved",K[K.Rejected=1]="Rejected"})(oe||(oe={}));class G{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((B,te)=>{this.a=B,this.b=te})}complete(B){return new Promise(te=>{this.a(B),this.d={outcome:oe.Resolved,value:B},te()})}error(B){return new Promise(te=>{this.b(B),this.d={outcome:oe.Rejected,value:B},te()})}cancel(){return this.error(new r.$5)}}e.$4h=G;var ue;(function(K){async function B(he){let me;const we=await Promise.all(he.map(Ie=>Ie.then(Ce=>Ce,Ce=>{me||(me=Ce)})));if(typeof me<"u")throw me;return we}K.settled=B;function te(he){return new Promise(async(me,we)=>{try{await he(me,we)}catch(Ie){we(Ie)}})}K.withAsyncBody=te})(ue||(e.Promises=ue={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new r.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=re;class J{constructor(B){this.b=B,this.a=new c.$U(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=J;var M;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(M||(M={}));class F{static fromArray(B){return new F(te=>{te.emitMany(B)})}static fromPromise(B){return new F(async te=>{te.emitMany(await B)})}static fromPromises(B){return new F(async te=>{await Promise.all(B.map(async he=>te.emitOne(await he)))})}static merge(B){return new F(async te=>{await Promise.all(B.map(async he=>{for await(const me of he)te.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(B,te){this.a=M.Initial,this.b=[],this.d=null,this.f=te,this.g=new E.$me,queueMicrotask(async()=>{const he={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(B(he)),this.k()}catch(me){this.l(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(B,te){return new F(async he=>{for await(const me of B)he.emitOne(te(me))})}map(B){return F.map(this,B)}static filter(B,te){return new F(async he=>{for await(const me of B)te(me)&&he.emitOne(me)})}filter(B){return F.filter(this,B)}static coalesce(B){return F.filter(B,te=>!!te)}coalesce(){return F.coalesce(this)}static async toPromise(B){const te=[];for await(const he of B)te.push(he);return te}toPromise(){return F.toPromise(this)}h(B){this.a===M.Initial&&(this.b.push(B),this.g.fire())}j(B){this.a===M.Initial&&(this.b=this.b.concat(B),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(B){this.a===M.Initial&&(this.a=M.DoneError,this.d=B,this.g.fire())}}e.$7h=F;class _ extends F{constructor(B,te){super(te),this.m=B}cancel(){this.m.cancel()}}e.$8h=_;function z(K){const B=new n.$xe,te=K(B.token);return new _(B,async he=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),B.dispose(),he.reject(new r.$5)});try{for await(const we of te){if(B.token.isCancellationRequested)return;he.emitOne(we)}me.dispose(),B.dispose()}catch(we){me.dispose(),B.dispose(),he.reject(we)}})}class ie{constructor(B){this.a=new G,this.b=new F(me=>{if(te){me.reject(te);return}return he&&me.emitMany(he),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},B);let te,he;this.f=me=>{he||(he=[]),he.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$0h=ie}),define(ce[111],le([0,1,21,8,39,32,31,9,3,25]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=void 0,e.$wk=g,e.$zk=d,e.$Ak=N,e.$Bk=V,e.$Ck=H,e.$Dk=Y,e.$Ek=de,e.$Fk=Z;function g(){return Object.create(null)}e.$xk="**",e.$yk="/";const u="[/\\\\]",m="[^/\\\\]",w=/\//g;function f(W,j){switch(W){case 0:return"";case 1:return`${m}*?`;default:return`(?:${u}|${m}+${u}${j?`|${u}${m}+`:""})*?`}}function d(W,j){if(!W)return[];const C=[];let X=!1,oe=!1,G="";for(const ue of W){switch(ue){case j:if(!X&&!oe){C.push(G),G="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}G+=ue}return G&&C.push(G),C}function v(W){if(!W)return"";let j="";const C=d(W,e.$yk);if(C.every(X=>X===e.$xk))j=".*";else{let X=!1;C.forEach((oe,G)=>{if(oe===e.$xk){if(X)return;j+=f(2,G===C.length-1)}else{let ue=!1,re="",J=!1,M="";for(const F of oe){if(F!=="}"&&ue){re+=F;continue}if(J&&(F!=="]"||!M)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!M?_="^":F===e.$yk?_="":_=(0,c.$if)(F),M+=_;continue}switch(F){case"{":ue=!0;continue;case"[":J=!0;continue;case"}":{const z=`(?:${d(re,",").map(ie=>v(ie)).join("|")})`;j+=z,ue=!1,re="";break}case"]":{j+="["+M+"]",J=!1,M="";break}case"?":j+=m;continue;case"*":j+=f(1);continue;default:j+=(0,c.$if)(F)}}G<C.length-1&&(C[G+1]!==e.$xk||G+2<C.length)&&(j+=u)}X=oe===e.$xk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),o=function(){return!1},s=function(){return null};function a(W,j){if(!W)return s;let C;typeof W!="string"?C=W.pattern:C=W,C=C.trim();const X=`${C}_${!!j.trimForExclusions}`;let oe=t.get(X);if(oe)return l(oe,W);let G;return b.test(C)?oe=y(C.substr(4),C):(G=$.exec(P(C,j)))?oe=D(G[1],C):(j.trimForExclusions?S:k).test(C)?oe=L(C,j):(G=i.exec(P(C,j)))?oe=R(G[1].substr(1),C,!0):(G=h.exec(P(C,j)))?oe=R(G[1],C,!1):oe=T(C),t.set(X,oe),l(oe,W)}function l(W,j){if(typeof j=="string")return W;const C=function(X,oe){return(0,A.$Fg)(X,j.base,!p.$l)?W((0,c.$nf)(X.substr(j.base.length),I.sep),oe):null};return C.allBasenames=W.allBasenames,C.allPaths=W.allPaths,C.basenames=W.basenames,C.patterns=W.patterns,C}function P(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function y(W,j){return function(C,X){return typeof C=="string"&&C.endsWith(W)?j:null}}function D(W,j){const C=`/${W}`,X=`\\${W}`,oe=function(ue,re){return typeof ue!="string"?null:re?re===W?j:null:ue===W||ue.endsWith(C)||ue.endsWith(X)?j:null},G=[W];return oe.basenames=G,oe.patterns=[j],oe.allBasenames=G,oe}function L(W,j){const C=U(W.slice(1,-1).split(",").map(re=>a(re,j)).filter(re=>re!==s),W),X=C.length;if(!X)return s;if(X===1)return C[0];const oe=function(re,J){for(let M=0,F=C.length;M<F;M++)if(C[M](re,J))return W;return null},G=C.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const ue=C.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function R(W,j,C){const X=I.sep===I.$hc.sep,oe=X?W:W.replace(w,I.sep),G=I.sep+oe,ue=I.$hc.sep+W;let re;return C?re=function(J,M){return typeof J=="string"&&(J===oe||J.endsWith(G)||!X&&(J===W||J.endsWith(ue)))?j:null}:re=function(J,M){return typeof J=="string"&&(J===oe||!X&&J===W)?j:null},re.allPaths=[(C?"*/":"./")+W],re}function T(W){try{const j=new RegExp(`^${v(W)}$`);return function(C){return j.lastIndex=0,typeof C=="string"&&j.test(C)?W:null}}catch{return s}}function N(W,j,C){return!W||typeof j!="string"?!1:V(W)(j,void 0,C)}function V(W,j={}){if(!W)return o;if(typeof W=="string"||H(W)){const C=a(W,j);if(C===s)return o;const X=function(oe,G){return!!C(oe,G)};return C.allBasenames&&(X.allBasenames=C.allBasenames),C.allPaths&&(X.allPaths=C.allPaths),X}return q(W,j)}function H(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function Y(W){return W.allBasenames||[]}function de(W){return W.allPaths||[]}function q(W,j){const C=U(Object.getOwnPropertyNames(W).map(re=>Q(re,W[re],j)).filter(re=>re!==s)),X=C.length;if(!X)return s;if(!C.some(re=>!!re.requiresSiblings)){if(X===1)return C[0];const re=function(F,_){let z;for(let ie=0,K=C.length;ie<K;ie++){const B=C[ie](F,_);if(typeof B=="string")return B;(0,r.$sh)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const ie of z){const K=await ie;if(typeof K=="string")return K}return null})():null},J=C.find(F=>!!F.allBasenames);J&&(re.allBasenames=J.allBasenames);const M=C.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return M.length&&(re.allPaths=M),re}const oe=function(re,J,M){let F,_;for(let z=0,ie=C.length;z<ie;z++){const K=C[z];K.requiresSiblings&&M&&(J||(J=(0,I.$oc)(re)),F||(F=J.substr(0,J.length-(0,I.$pc)(re).length)));const B=K(re,J,F,M);if(typeof B=="string")return B;(0,r.$sh)(B)&&(_||(_=[]),_.push(B))}return _?(async()=>{for(const z of _){const ie=await z;if(typeof ie=="string")return ie}return null})():null},G=C.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const ue=C.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function Q(W,j,C){if(j===!1)return s;const X=a(W,C);if(X===s)return s;if(typeof j=="boolean")return X;if(j){const oe=j.when;if(typeof oe=="string"){const G=(ue,re,J,M)=>{if(!M||!X(ue,re))return null;const F=oe.replace("$(basename)",()=>J),_=M(F);return(0,r.$sh)(_)?_.then(z=>z?W:null):_?W:null};return G.requiresSiblings=!0,G}}return X}function U(W,j){const C=W.filter(re=>!!re.basenames);if(C.length<2)return W;const X=C.reduce((re,J)=>{const M=J.basenames;return M?re.concat(M):re},[]);let oe;if(j){oe=[];for(let re=0,J=X.length;re<J;re++)oe.push(j)}else oe=C.reduce((re,J)=>{const M=J.patterns;return M?re.concat(M):re},[]);const G=function(re,J){if(typeof re!="string")return null;if(!J){let F;for(F=re.length;F>0;F--){const _=re.charCodeAt(F-1);if(_===E.CharCode.Slash||_===E.CharCode.Backslash)break}J=re.substr(F)}const M=X.indexOf(J);return M!==-1?oe[M]:null};G.basenames=X,G.patterns=oe,G.allBasenames=X;const ue=W.filter(re=>!re.basenames);return ue.push(G),ue}function Z(W,j){return(0,n.$ub)(W,j,(C,X)=>typeof C=="string"&&typeof X=="string"?C===X:typeof C!="string"&&typeof X!="string"?C.base===X.base&&C.pattern===X.pattern:!1)}}),define(ce[47],le([0,1,21,32,9,3,18,25]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4w=p,e.$5w=g,e.$6w=m,e.$7w=w,e.$8w=b,e.$9w=k,e.$0w=S,e.$$w=i,e.$_w=h,e.$ax=t;function p(s,a){const{os:l,tildify:P,relative:y}=a;if(y){const R=c(s,y,l);if(typeof R=="string")return R}let D=s.fsPath;if(l===A.OperatingSystem.Windows&&!A.$j?D=D.replace(/\//g,"\\"):l!==A.OperatingSystem.Windows&&A.$j&&(D=D.replace(/\\/g,"/")),l!==A.OperatingSystem.Windows&&P?.userHome){const R=P.userHome.fsPath;let T;s.scheme!==P.userHome.scheme&&s.path[0]===E.$hc.sep&&s.path[1]!==E.$hc.sep?T=P.userHome.with({path:s.path}).fsPath:T=D,D=m(T,R,l)}return(l===A.OperatingSystem.Windows?E.$gc:E.$hc).normalize(g(D,l===A.OperatingSystem.Windows))}function c(s,a,l){const P=l===A.OperatingSystem.Windows?E.$gc:E.$hc,y=l===A.OperatingSystem.Linux?O.$0g:O.$_g,D=a.getWorkspace(),L=(0,n.$Ob)(D.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===E.$hc.sep&&s.path[1]!==E.$hc.sep&&(s=L.uri.with({path:s.path}));const R=a.getWorkspaceFolder(s);if(!R)return;let T;if(y.isEqual(R.uri,s)?T="":T=y.relativePath(R.uri,s)??"",T&&(T=P.normalize(T)),D.folders.length>1&&!a.noPrefix){const N=R.name?R.name:y.basenameOrAuthority(R.uri);T=T?`${N} \u2022 ${T}`:N}return T}function g(s,a=A.$j){return(0,r.$Kg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let u=Object.create(null);function m(s,a,l=A.OS){if(l===A.OperatingSystem.Windows||!s||!a)return s;let P=u.original===a?u.normalized:void 0;P||(P=a,A.$j&&(P=(0,r.$zg)(P)),P=`${(0,I.$of)(P,E.$hc.sep)}${E.$hc.sep}`,u={original:a,normalized:P});let y=s;return A.$j&&(y=(0,r.$zg)(y)),(l===A.OperatingSystem.Linux?y.startsWith(P):(0,I.$Hf)(y,P))?`~/${y.substr(P.length)}`:s}function w(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",d="\\\\",v="~";function b(s,a=E.sep){const l=new Array(s.length);let P=!1;for(let y=0;y<s.length;y++){const D=s[y];if(D===""){l[y]=`.${a}`;continue}if(!D){l[y]=D;continue}P=!0;let L="",R=D;R.indexOf(d)===0?(L=R.substr(0,R.indexOf(d)+d.length),R=R.substr(R.indexOf(d)+d.length)):R.indexOf(a)===0?(L=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(v)===0&&(L=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const T=R.split(a);for(let N=1;P&&N<=T.length;N++)for(let V=T.length-N;P&&V>=0;V--){P=!1;let H=T.slice(V,V+N).join(a);for(let Y=0;!P&&Y<s.length;Y++)if(Y!==y&&s[Y]&&s[Y].indexOf(H)>-1){const de=V+N===T.length,q=V>0&&s[Y].indexOf(a)>-1?a+H:H,Q=s[Y].endsWith(q);P=!de||Q}if(!P){let Y="";(T[0].endsWith(":")||L!=="")&&(V===1&&(V=0,N++,H=T[0]+a+H),V>0&&(Y=T[0]+a),Y=L+Y),V>0&&(Y=Y+f+a),Y=Y+H,V+N<T.length&&(Y=Y+a+f),l[y]=Y}}P&&(l[y]=D)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function k(s,a=Object.create(null)){const l=[];let P=!1,y="";for(const D of s)if(D==="$"||P&&D==="{")y&&l.push({value:y,type:$.TEXT}),y="",P=!0;else if(D==="}"&&P){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const R=l[l.length-1];(!R||R.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",P=!1}else y+=D;return y&&!P&&l.push({value:y,type:$.TEXT}),l.filter((D,L)=>{if(D.type===$.SEPARATOR){const R=l[L-1],T=l[L+1];return[R,T].every(N=>N&&(N.type===$.VARIABLE||N.type===$.TEXT)&&N.value.length>0)}return!0}).map(D=>D.value).join("")}function S(s,a){return A.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function i(s,a){return A.$k||a?s.replace(/\(&&\w\)|&&/g,""):A.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function h(s){return s.replace(/&/g,"&&")}function t(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),P=s.substring(a);return{name:l.name+P,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?E.$hc:E.$gc,l=a.basename(s),P=a.dirname(s);return l.length?{name:l,parentPath:P}:{name:P,parentPath:""}}}),define(ce[153],le([0,1,17,90,7]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=p,e.$Qn=g,e.$Rn=u;function A(m){return m.toJSON()}class O{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:A(E.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:A(E.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:E.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Nn=O,e.$On=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function I(m,w,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof E.URI)return w.transformOutgoing(m);for(const d in m)if(Object.hasOwnProperty.call(m,d)){const v=I(m[d],w,f+1);v!==null&&(m[d]=v)}}return null}function p(m,w){const f=I(m,w,0);return f===null?m:f}function c(m,w,f,d){if(!m||d>200)return null;if(typeof m=="object"){if(m.$mid===r.MarshalledId.Uri)return f?E.URI.revive(w.transformIncoming(m)):w.transformIncoming(m);if(m instanceof n.$Oe)return null;for(const v in m)if(Object.hasOwnProperty.call(m,v)){const b=c(m[v],w,f,d+1);b!==null&&(m[v]=b)}}return null}function g(m,w){const f=c(m,w,!1,0);return f===null?m:f}function u(m,w){const f=c(m,w,!0,0);return f===null?m:f}}),define(ce[33],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return n.test(E)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,c="";return c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c}}()}),define(ce[154],le([0,1,91,26,89]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TX=A,n=Pe(n),r=Pe(r);async function A(O,I){if(await new Promise((g,u)=>{const m=r.createReadStream(O),w=n.createHash("sha256");m.pipe(w);const f=(0,E.$db)((d,v)=>{m.removeAllListeners(),w.removeAllListeners(),d?u(d):g(v)});m.once("error",f),m.once("end",f),w.once("error",f),w.once("data",d=>f(void 0,d.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(ce[155],le([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=A;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(O){const I=O.replace(/\-/g,":").toLowerCase();return!r.has(I)}function A(){const O=(0,n.networkInterfaces)();for(const I in O){const p=O[I];if(p){for(const{mac:c}of p)if(E(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[92],le([0,1,27,60,33,155,3]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0,e.$Un=p,e.$Vn=u,e.$Wn=m,E=Pe(E),e.$Tn=new class{c(w){return this.a||(this.a=r.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const d=(0,n.networkInterfaces)();for(const v in d){const b=d[v];if(b)for(const{mac:$,internal:k}of b)k||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await c(w)||E.$3g())()),I}async function c(w){try{const f=await new Promise((v,b)=>{x(["crypto"],v,b)}).then(Pe),d=(0,A.$Sn)();return f.createHash("sha256").update(d,"utf8").digest("hex")}catch(f){w(f);return}}const g="Software\\Microsoft\\SQMClient";async function u(w){if(O.$j){const f=await new Promise((d,v)=>{x(["@vscode/windows-registry"],d,v)}).then(Pe);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return w(d),""}}return""}async function m(w){try{return await(await new Promise((v,b)=>{x(["@vscode/deviceid"],v,b)}).then(Pe)).getDeviceId()}catch(f){return w(f),""}}}),define(ce[23],le([0,1,26,27,156,8,32,78,9,3,18,7]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=k,e.whenDeleted=h,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Pe(n);var m;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function w(q,Q=m.UNLINK,U){if((0,O.$Jg)(q))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?d(q):f(q,U)}async function f(q,Q=(0,O.$Og)((0,r.tmpdir)())){try{try{await n.promises.rename(q,Q)}catch(U){return U.code==="ENOENT"?void 0:d(q)}d(Q).catch(U=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function d(q){return n.promises.rm(q,{recursive:!0,force:!0,maxRetries:3})}function v(q){if((0,O.$Jg)(q))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}async function b(q,Q){return S(await(Q?$(q):n.promises.readdir(q)))}async function $(q){try{return await n.promises.readdir(q,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const Q=[],U=await b(q);for(const Z of U){let W=!1,j=!1,C=!1;try{const X=await n.promises.lstat((0,p.$kc)(q,Z));W=X.isFile(),j=X.isDirectory(),C=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}Q.push({name:Z,isFile:()=>W,isDirectory:()=>j,isSymbolicLink:()=>C})}return Q}function k(q){return S(n.readdirSync(q))}function S(q){return q.map(Q=>typeof Q=="string"?c.$k?(0,I.$om)(Q):Q:(Q.name=c.$k?(0,I.$om)(Q.name):Q.name,Q))}async function i(q){const Q=await b(q),U=[];for(const Z of Q)await t.existsDirectory((0,p.$kc)(q,Z))&&U.push(Z);return U}function h(q,Q=1e3){return new Promise(U=>{let Z=!1;const W=setInterval(()=>{Z||(Z=!0,n.access(q,j=>{Z=!1,j&&(clearInterval(W),U(void 0))}))},Q)})}var t;(function(q){async function Q(W){let j;try{if(j=await n.promises.lstat(W),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(W),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&C.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw C}}q.stat=Q;async function U(W){try{const{stat:j,symbolicLink:C}=await q.stat(W);return j.isFile()&&C?.dangling!==!0}catch{}return!1}q.existsFile=U;async function Z(W){try{const{stat:j,symbolicLink:C}=await q.stat(W);return j.isDirectory()&&C?.dangling!==!0}catch{}return!1}q.existsDirectory=Z})(t||(e.SymlinkSupport=t={}));const o=new A.$Ph;function s(q,Q,U){return o.queueFor(u.URI.file(q),()=>{const Z=D(U);return new Promise((W,j)=>P(q,Q,Z,C=>C?j(C):W()))},g.$$g)}let a=!0;function l(q){a=q}function P(q,Q,U,Z){if(!a)return n.writeFile(q,Q,{mode:U.mode,flag:U.flag},Z);n.open(q,U.flag,U.mode,(W,j)=>{if(W)return Z(W);n.writeFile(j,Q,C=>{if(C)return n.close(j,()=>Z(C));n.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),l(!1)),n.close(j,oe=>Z(oe))))})})}function y(q,Q,U){const Z=D(U);if(!a)return n.writeFileSync(q,Q,{mode:Z.mode,flag:Z.flag});const W=n.openSync(q,Z.flag,Z.mode);try{n.writeFileSync(W,Q);try{n.fdatasyncSync(W)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(W)}}function D(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function L(q,Q,U=6e4){if(q!==Q)try{c.$j&&typeof U=="number"?await R(q,Q,Date.now(),U):await n.promises.rename(q,Q)}catch(Z){if(q.toLowerCase()!==Q.toLowerCase()&&Z.code==="EXDEV"||q.endsWith("."))await T(q,Q,{preserveSymlinks:!1}),await w(q,m.MOVE);else throw Z}}async function R(q,Q,U,Z,W=0){try{return await n.promises.rename(q,Q)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-U>=Z)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${j}`),j;if(W===0){let C=!1;try{const{stat:X}=await t.stat(Q);X.isFile()||(C=!0)}catch{}if(C)throw j}return await(0,A.$Hh)(Math.min(100,W*10)),R(q,Q,U,Z,W+1)}}async function T(q,Q,U){return V(q,Q,{root:{source:q,target:Q},options:U,handledSourcePaths:new Set})}const N=511;async function V(q,Q,U){if(U.handledSourcePaths.has(q))return;U.handledSourcePaths.add(q);const{stat:Z,symbolicLink:W}=await t.stat(q);if(W){if(U.options.preserveSymlinks)try{return await de(q,Q,U)}catch{}if(W.dangling)return}return Z.isDirectory()?H(q,Q,Z.mode&N,U):Y(q,Q,Z.mode&N)}async function H(q,Q,U,Z){await n.promises.mkdir(Q,{recursive:!0,mode:U});const W=await b(q);for(const j of W)await V((0,p.$kc)(q,j),(0,p.$kc)(Q,j),Z)}async function Y(q,Q,U){await n.promises.copyFile(q,Q),await n.promises.chmod(Q,U)}async function de(q,Q,U){let Z=await n.promises.readlink(q);(0,O.$Fg)(Z,U.root.source,!c.$l)&&(Z=(0,p.$kc)(U.root.target,Z.substr(U.root.source.length+1))),await n.promises.symlink(Z,Q)}e.Promises=new class{get read(){return(q,Q,U,Z,W)=>new Promise((j,C)=>{n.read(q,Q,U,Z,W,(X,oe,G)=>X?C(X):j({bytesRead:oe,buffer:G}))})}get write(){return(q,Q,U,Z,W)=>new Promise((j,C)=>{n.write(q,Q,U,Z,W,(X,oe,G)=>X?C(X):j({bytesWritten:oe,buffer:G}))})}get fdatasync(){return(0,E.promisify)(n.fdatasync)}get open(){return(0,E.promisify)(n.open)}get close(){return(0,E.promisify)(n.close)}get realpath(){return(0,E.promisify)(n.realpath)}async exists(q){try{return await n.promises.access(q),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return i}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return T}}}),define(ce[112],le([0,1,26,9,3,25,23]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=I,e.$pr=p,e.$qr=c,e.$rr=g,n=Pe(n);function I(m){if(E.$l)return m;const w=(0,r.$nc)(m);if(m===w)return m;const f=((0,r.$oc)(m)||m).toLowerCase();try{const v=(0,O.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$kc)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$kc)($,v[b])}}}catch{}return null}async function p(m,w){if(E.$l)return m;const f=(0,r.$nc)(m);if(m===f)return m;const d=((0,r.$oc)(m)||m).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await O.Promises.readdir(f)).filter($=>$.toLowerCase()===d);if(b.length===1){const $=await p(f,w);if($)return(0,r.$kc)($,b[0])}else if(b.length>1){const $=b.indexOf(d);if($>=0){const k=await p(f,w);if(k)return(0,r.$kc)(k,b[$])}}}catch{}return null}async function c(m){try{return await O.Promises.realpath(m)}catch{const f=u(m);return await n.promises.access(f,n.constants.R_OK),f}}function g(m){try{return n.realpathSync(m)}catch{const f=u(m);return n.accessSync(f,n.constants.R_OK),f}}function u(m){return(0,A.$of)((0,r.$ic)(m),r.sep)}}),define(ce[113],le([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=r,e.$7g=A,n=Pe(n);function r(I,p,c,g=1){let u=!1;return new Promise(m=>{const w=setTimeout(()=>{if(!u)return u=!0,m(0)},c);E(I,p,g,f=>{if(!u)return u=!0,clearTimeout(w),m(f)})})}function E(I,p,c,g){if(p===0)return g(0);const u=new n.Socket;u.once("connect",()=>(O(u),E(I+c,p-1,c,g))),u.once("data",()=>{}),u.once("error",m=>(O(u),m.code!=="ECONNREFUSED"?E(I+c,p-1,c,g):g(I))),u.connect(I,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,p,c,g="127.0.0.1"){let u=!1,m,w=1;const f=n.createServer({pauseOnConnect:!0});function d(v,b){u||(u=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),b(v))}return new Promise(v=>{m=setTimeout(()=>{d(0,v)},c),f.on("listening",()=>{d(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,g)):d(0,v)}),f.on("close",()=>{d(0,v)}),f.listen(I,g)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(ce[114],le([0,1,27,9,23]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=$,e.$ym=k,n=Pe(n),r=Pe(r),E=Pe(E);const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=p.x86:g=p.x64;class u{constructor(i,h,t){this.exePath=i,this.displayName=h,this.a=t}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:S=!1}={}){return S?c===p.x64?process.env["ProgramFiles(x86)"]||null:g===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:S=!1,findPreview:i=!1}={}){const h=m({useAlternateBitness:S});if(!h)return null;const t=r.$kc(h,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(t))return null;let o=-1,s=null;for(const P of await E.Promises.readdir(t)){let y=-1;if(i){const L=P.indexOf("-");if(L<0)continue;const R=P.substring(0,L);if(!A.test(R)||P.substring(L+1)!=="preview")continue;y=parseInt(R,10)}else{if(!A.test(P))continue;y=parseInt(P,10)}if(y<=o)continue;const D=r.$kc(t,P,"pwsh.exe");await E.SymlinkSupport.existsFile(D)&&(s=D,o=y)}if(!s)return null;const a=h.includes("x86")?" (x86)":"",l=i?" Preview":"";return new u(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const i=r.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:h,pwshMsixName:t}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const o of await E.Promises.readdir(i))if(h.test(o)){const s=r.$kc(i,o,"pwsh.exe");return new u(s,t)}return null}function d(){const S=r.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new u(S,".NET Core PowerShell Global Tool")}function v(){const S=r.$kc(process.env.windir,c===p.x86&&g!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(S,"Windows PowerShell",!0)}async function*b(){let S=await w();S&&(yield S),S=await w({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=d(),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await w({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*$(){for await(const S of b())await S.exists()&&(yield S)}async function k(){for await(const S of $())return S;return null}}),define(ce[94],le([0,1,26,9,3,36,79,11,23]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$zm=c,e.$Am=g,r=Pe(r),E=Pe(E),A=Pe(A),I=Pe(I),p=Pe(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(m=A.env){return m.comspec||"cmd.exe"}function g(m){let w=[],f=!1;const d=function(v){if(f){w.push(v);return}(!m.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const k=w.slice(0);w=[],k.forEach(S=>d(S))}})||E.$j)&&(f=!0)};return{send:d}}var u;(function(m){async function w(f,d,v){if(r.$jc(f))return f;if(d===void 0&&(d=A.cwd()),r.$nc(f)!=="."||(v===void 0&&I.$fg(A.env.PATH)&&(v=A.env.PATH.split(r.$uc)),v===void 0||v.length===0))return r.$kc(d,f);async function $(k){if(await p.Promises.exists(k)){let S;try{S=await n.promises.stat(k)}catch(i){i.message.startsWith("EACCES")&&(S=await n.promises.lstat(k))}return S?!S.isDirectory():!1}return!1}for(const k of v){let S;if(r.$jc(k)?S=r.$kc(k,f):S=r.$kc(d,k,f),await $(S))return S;let i=S+".com";if(await $(i)||(i=S+".exe",await $(i)))return i}return r.$kc(d,f)}m.findExecutable=w})(u||(e.win32=u={}))}),define(ce[115],le([0,1,48,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=E;function E(O){return new Promise((I,p)=>{let c;const g=new Map;function u(w,f,d,v,b){const $=g.get(f);if(w===O||$){const k={name:m(d),cmd:d,pid:w,ppid:f,load:v,mem:b};g.set(w,k),w===O&&(c=k),$&&($.children||($.children=[]),$.children.push(k),$.children.length>1&&($.children=$.children.sort((S,i)=>S.pid-i.pid)))}}function m(w){const f=/--utility-sub-type=network/i,d=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let k=$.exec(w);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const S=/[a-zA-Z-]+\.js/g;let i="";do k=S.exec(w),k&&(i+=k+" ");while(k);return i&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${i})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,d)=>{x(["@vscode/windows-process-tree"],f,d)}).then(Pe).then(f=>{f.getProcessList(O,d=>{if(!d){p(new Error(`Root process ${O} not found`));return}f.getProcessCpuUsage(d,v=>{const b=new Map;v.forEach($=>{const k=w($.commandLine||"");b.set($.pid,{name:m(k),cmd:k,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=b.get(O),c?(b.forEach($=>{const k=b.get($.ppid);k&&(k.children||(k.children=[]),k.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((k,S)=>k.pid-S.pid))}),I(c)):p(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[c];const d=[];for(;f.length;){const b=f.shift();b&&(d.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+d.join(" "),(0,n.exec)(v,{},(b,$,k)=>{if(b||k)p(b||new Error(k.toString()));else{const S=$.toString().split(`
`);for(let i=0;i<d.length;i++){const h=g.get(d[i]);h.load=parseFloat(S[i])}if(!c){p(new Error(`Root process ${O} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,d,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,k,S)=>{$||S?p($||new Error(S.toString())):(A(k,u),w())})}else{const b=d.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,i)=>{k||i&&!i.includes("screen size is bogus")?p(k||new Error(i.toString())):(A(S,u),process.platform==="linux"?w():c?I(c):p(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=O.toString().split(`
`);for(const g of c){const u=p.exec(g.trim());u&&u.length===6&&I(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(ce[116],le([0,1,27,3,114,94]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=O,r=Pe(r),A=Pe(A);async function O(u,m){return u===r.OperatingSystem.Windows?r.$j?g():A.$zm(m):p(u,m)}let I=null;function p(u,m){if(r.$l&&u===r.OperatingSystem.Macintosh||r.$k&&u===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=m.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function g(){return c||(c=(await(0,E.$ym)()).exePath),c}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(p){const c=new Set;if(Array.isArray(p))for(const g of p)typeof g=="string"&&c.add(g);return Array.from(c)}function r(){const p=e();return p?Array.from(p):[]}function E(p){if(process.platform!=="win32")return;const c=e();if(c)if(typeof p=="string")c.add(p.toLowerCase());else for(const g of n(p))E(g)}function A(p){if(typeof p!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const u of c){if(p.indexOf(u)!==0)continue;const w=p.indexOf("\\",u.length);if(w===-1)continue;const f=p.substring(u.length,w);if(f){g=f;break}}return g}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:A,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[157],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZX=e.$YX=void 0,e.$YX="vscode:contextmenu",e.$ZX="vscode:onCloseContextMenu"});var Se=this&&this.__decorate||function(x,e,n,r){var E=arguments.length,A=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(x,e,n,r);else for(var I=x.length-1;I>=0;I--)(O=x[I])&&(A=(E<3?O(A):E>3?O(e,n,A):O(e,n))||A);return E>3&&A&&Object.defineProperty(e,n,A),A};define(ce[44],le([0,1,21,8,17,22,54,15,4,2,82,25,11]),function(x,e,n,r,E,A,O,I,p,c,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=l,e.$hi=P,e.$mi=N,e.$ni=V,u=Pe(u);var w;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(w||(w={}));function f(W){switch(W){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var d;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(d||(d={}));function v(W){switch(W){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var b;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(b||(b={}));function $(W){let j=0;for(let C=0;;C+=7){const X=W.read(1);if(j|=(X.buffer[0]&127)<<C,!(X.buffer[0]&128))return j}}const k=o(0);function S(W,j){if(j===0){W.write(k);return}let C=0;for(let oe=j;oe!==0;oe=oe>>>7)C++;const X=E.$Oe.alloc(C);for(let oe=0;j!==0;oe++)X.buffer[oe]=j&127,j=j>>>7,j>0&&(X.buffer[oe]|=128);W.write(X)}class i{constructor(j){this.b=j,this.a=0}read(j){const C=this.b.slice(this.a,this.a+j);return this.a+=C.byteLength,C}}e.$ei=i;class h{constructor(){this.a=[]}get buffer(){return E.$Oe.concat(this.a)}write(j){this.a.push(j)}}e.$fi=h;var t;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(t||(t={}));function o(W){const j=E.$Oe.alloc(1);return j.writeUInt8(W,0),j}const s={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},a=typeof Buffer<"u";function l(W,j){if(typeof j>"u")W.write(s.Undefined);else if(typeof j=="string"){const C=E.$Oe.fromString(j);W.write(s.String),S(W,C.byteLength),W.write(C)}else if(a&&Buffer.isBuffer(j)){const C=E.$Oe.wrap(j);W.write(s.Buffer),S(W,C.byteLength),W.write(C)}else if(j instanceof E.$Oe)W.write(s.VSBuffer),S(W,j.byteLength),W.write(j);else if(Array.isArray(j)){W.write(s.Array),S(W,j.length);for(const C of j)l(W,C)}else if(typeof j=="number"&&(j|0)===j)W.write(s.Uint),S(W,j);else{const C=E.$Oe.fromString(JSON.stringify(j));W.write(s.Object),S(W,C.byteLength),W.write(C)}}function P(W){switch(W.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return W.read($(W)).toString();case t.Buffer:return W.read($(W)).buffer;case t.VSBuffer:return W.read($(W));case t.Array:{const C=$(W),X=[];for(let oe=0;oe<C;oe++)X.push(P(W));return X}case t.Object:return JSON.parse(W.read($(W)).toString());case t.Int:return $(W)}}class y{constructor(j,C,X=null,oe=1e3){this.h=j,this.j=C,this.k=X,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:d.Initialize})}registerChannel(j,C){this.b.set(j,C),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case d.Initialize:{const C=this.o([j.type]);this.k?.logOutgoing(C,0,D.OtherSide,v(j.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const C=this.o([j.type,j.id],j.data);this.k?.logOutgoing(C,j.id,D.OtherSide,v(j.type),j.data);return}}}o(j,C=void 0){const X=new h;return l(X,j),l(X,C),this.p(X.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const C=new i(j),X=P(C),oe=P(C),G=X[0];switch(G){case w.Promise:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(G)}: ${X[2]}.${X[3]}`,oe),this.s({type:G,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.EventListen:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(G)}: ${X[2]}.${X[3]}`,oe),this.t({type:G,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(G)}`),this.u({type:G,id:X[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,X[1],D.OtherSide,`${f(G)}`),this.u({type:G,id:X[1]})}}s(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=new A.$xe;let oe;try{oe=C.call(this.j,j.name,j.arg,X.token)}catch(re){oe=Promise.reject(re)}const G=j.id;oe.then(re=>{this.m({id:G,data:re,type:d.PromiseSuccess})},re=>{re instanceof Error?this.m({id:G,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:G,data:re,type:d.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.d.delete(j.id)});const ue=(0,c.$Tc)(()=>X.cancel());this.d.set(j.id,ue)}t(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=j.id,G=C.listen(this.j,j.name,j.arg)(ue=>this.m({id:X,data:ue,type:d.EventFire}));this.d.set(j.id,G)}u(j){const C=this.d.get(j.id);C&&(C.dispose(),this.d.delete(j.id))}v(j){let C=this.g.get(j.channelName);C||(C=[],this.g.set(j.channelName,C));const X=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);C.push({request:j,timeoutTimer:X})}w(j){const C=this.g.get(j);if(C){for(const X of C)switch(clearTimeout(X.timeoutTimer),X.request.type){case w.Promise:this.s(X.request);break;case w.EventListen:this.t(X.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ii=y;var D;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class L{constructor(j,C=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=C}getChannel(j){const C=this;return{call(X,oe,G){return C.a?Promise.reject(new I.$5):C.m(j,X,oe,G)},listen(X,oe){return C.a?p.Event.None:C.o(j,X,oe)}}}m(j,C,X,oe=A.CancellationToken.None){const G=this.g++,ue=w.Promise,re={id:G,type:ue,channelName:j,name:C,arg:X};if(oe.isCancellationRequested)return Promise.reject(new I.$5);let J;return new Promise((F,_)=>{if(oe.isCancellationRequested)return _(new I.$5);const z=()=>{const te=he=>{switch(he.type){case d.PromiseSuccess:this.f.delete(G),F(he.data);break;case d.PromiseError:{this.f.delete(G);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,_(me);break}case d.PromiseErrorObj:this.f.delete(G),_(he.data);break}};this.f.set(G,te),this.p(re)};let ie=null;this.b===b.Idle?z():(ie=(0,r.$th)(te=>this.u()),ie.then(()=>{ie=null,z()}));const K=()=>{ie?(ie.cancel(),ie=null):this.p({id:G,type:w.PromiseCancel}),_(new I.$5)},B=oe.onCancellationRequested(K);J=(0,c.$Sc)((0,c.$Tc)(K),B),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(j,C,X){const oe=this.g++,G=w.EventListen,ue={id:oe,type:G,channelName:j,name:C,arg:X};let re=null;const J=new p.$me({onWillAddFirstListener:()=>{re=(0,r.$th)(F=>this.u()),re.then(()=>{re=null,this.d.add(J),this.p(ue)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(J),this.p({id:oe,type:w.EventDispose}))}}),M=F=>J.fire(F.data);return this.f.set(oe,M),J.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const C=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(C,j.id,D.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const C=this.q([j.type,j.id]);this.j?.logOutgoing(C,j.id,D.LocalSide,f(j.type));return}}}q(j,C=void 0){const X=new h;return l(X,j),l(X,C),this.r(X.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const C=new i(j),X=P(C),oe=P(C),G=X[0];switch(G){case d.Initialize:return this.j?.logIncoming(j.byteLength,0,D.LocalSide,v(G)),this.t({type:X[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,X[1],D.LocalSide,v(G),oe),this.t({type:X[0],id:X[1],data:oe})}}t(j){if(j.type===d.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ji=L,Se([O.$$h],L.prototype,"onDidInitializePromise",null);class R{get connections(){const j=[];return this.f.forEach(C=>j.push(C)),j}constructor(j,C,X){this.a=new Map,this.f=new Set,this.g=new p.$me,this.onDidAddConnection=this.g.event,this.h=new p.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Uc,this.j.add(j(({protocol:oe,onDidClientDisconnect:G})=>{const ue=p.Event.once(oe.onMessage);this.j.add(ue(re=>{const J=new i(re),M=P(J),F=new y(oe,M,C,X),_=new L(oe,C);this.a.forEach((ie,K)=>F.registerChannel(K,ie));const z={channelServer:F,channelClient:_,ctx:M};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{F.dispose(),_.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,C){const X=this;return{call(oe,G,ue){let re;if((0,m.$tg)(C)){const M=(0,n.$3b)(X.connections.filter(C));re=M?Promise.resolve(M):p.Event.toPromise(p.Event.filter(X.onDidAddConnection,C))}else re=C.routeCall(X,oe,G);const J=re.then(M=>M.channelClient.getChannel(j));return N(J).call(oe,G,ue)},listen(oe,G){if((0,m.$tg)(C))return X.k(j,C,oe,G);const ue=C.routeEvent(X,oe,G).then(re=>re.channelClient.getChannel(j));return N(ue).listen(oe,G)}}}k(j,C,X,oe){const G=this;let ue;const re=new p.$me({onWillAddFirstListener:()=>{ue=new c.$Uc;const J=new p.$se,M=new Map,F=z=>{const K=z.channelClient.getChannel(j).listen(X,oe),B=J.add(K);M.set(z,B)},_=z=>{const ie=M.get(z);ie&&(ie.dispose(),M.delete(z))};G.connections.filter(C).forEach(F),p.Event.filter(G.onDidAddConnection,C)(F,void 0,ue),G.onDidRemoveConnection(_,void 0,ue),J.event(re.fire,re,ue),ue.add(J)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return re.event}registerChannel(j,C){this.a.set(j,C);for(const X of this.f)X.channelServer.registerChannel(j,C)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=R;class T{constructor(j,C,X=null){const oe=new h;l(oe,C),j.send(oe.buffer),this.a=new L(j,X),this.d=new y(j,C,X)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,C){this.d.registerChannel(j,C)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=T;function N(W){return{call(j,C,X){return W.then(oe=>oe.call(j,C,X))},listen(j,C){const X=new p.$ve;return W.then(oe=>X.input=oe.listen(j,C)),X.event}}}function V(W){let j=!1;return{call(C,X,oe){return j?W.call(C,X,oe):(0,r.$Hh)(0).then(()=>j=!0).then(()=>W.call(C,X,oe))},listen(C,X){if(j)return W.listen(C,X);const oe=new p.$ve;return(0,r.$Hh)(0).then(()=>j=!0).then(()=>oe.input=W.listen(C,X)),oe.event}}}class H{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const C of j.connections)if(await Promise.resolve(this.a(C.ctx)))return Promise.resolve(C);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$oi=H;var Y;(function(W){function j(G,ue,re){const J=G,M=re&&re.disableMarshalling,F=new Map;for(const _ in J)X(_)&&F.set(_,p.Event.buffer(J[_],!0,void 0,ue));return new class{listen(_,z,ie){const K=F.get(z);if(K)return K;const B=J[z];if(typeof B=="function"){if(oe(z))return B.call(J,ie);if(X(z))return F.set(z,p.Event.buffer(J[z],!0,void 0,ue)),F.get(z)}throw new I.$bb(`Event not found: ${z}`)}call(_,z,ie){const K=J[z];if(typeof K=="function"){if(!M&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,g.$di)(ie[te]);let B=K.apply(J,ie);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new I.$bb(`Method not found: ${z}`)}}}W.fromService=j;function C(G,ue){const re=ue&&ue.disableMarshalling;return new Proxy({},{get(J,M){if(typeof M=="string")return ue?.properties?.has(M)?ue.properties.get(M):oe(M)?function(F){return G.listen(M,F)}:X(M)?G.listen(M):async function(...F){let _;ue&&!(0,m.$og)(ue.context)?_=[ue.context,...F]:_=F;const z=await G.call(M,_);return re?z:(0,g.$di)(z)};throw new I.$bb(`Property not found: ${String(M)}`)}})}W.toService=C;function X(G){return G[0]==="o"&&G[1]==="n"&&u.$Ff(G.charCodeAt(2))}function oe(G){return/^onDynamic/.test(G)&&u.$Ff(G.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const j=W.toString();if(j!=="[object Object]")return j}return W}function Q(W){return Array.isArray(W)?W.map(q):q(W)}function U(W,j,C,X,oe,G,ue){ue=Q(ue);const re=de[oe],J=re[X%re.length];let M=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(G)?(M=M.concat(ue),M.push(")")):M.push(ue),console.log.apply(console,M)}class Z{constructor(j,C){this.d=j,this.f=C,this.a=0,this.b=0}logOutgoing(j,C,X,oe,G){this.b+=j,U(this.d,this.b,j,C,X,oe,G)}logIncoming(j,C,X,oe,G){this.a+=j,U(this.f,this.a,j,C,X,oe,G)}}e.$pi=Z}),define(ce[158],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7X=void 0;class n{constructor(E,A){this.a=E,this.onMessage=A}send(E){try{this.a.send("vscode:message",E.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$7X=n}),define(ce[159],le([0,1,17,4,44]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5X=e.$4X=void 0;class A{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Oe.wrap(c.data):n.$Oe.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$4X=A;class O extends E.$li{constructor(p,c){const g=new A(p);super(g,c),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$5X=O}),define(ce[117],le([0,1,17,4,2,44]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function P(D,L){if(!a.has(D)){const R=String(++l);a.set(D,R)}return a.get(D)}function y(D,L,R,T){if(!s.enableDiagnostics)return;const N=P(D,L);if(T instanceof n.$Oe||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const V=n.$Oe.alloc(T.byteLength);V.set(T),s.records.push({timestamp:Date.now(),id:N,label:L,type:R,buff:V})}else s.records.push({timestamp:Date.now(),id:N,label:L,type:R,data:T})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function g(){return c||(c=n.$Oe.alloc(0)),c}class u{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return g();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const P=n.$Oe.alloc(a);let y=0,D=0;for(;a>0;){const L=this.a[D];if(L.byteLength>a){const R=L.slice(0,a);P.set(R,y),y+=a,l&&(this.a[D]=L.slice(a),this.b-=a),a-=a}else P.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):D++,a-=L.byteLength}return P}}e.$qi=u;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function w(s){switch(s){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class d{constructor(a,l,P,y){this.type=a,this.id=l,this.ack=P,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends E.$Vc{constructor(a){super(),this.f=this.B(new r.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:m.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new u,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const P=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,l),this.f.fire(new d(P,y,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Oe.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const P=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,P}h(){const a=n.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends E.$Vc{constructor(a){super(),this.f=new r.$me,this.onMessage=this.f.event,this.g=new r.$me,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===m.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new d(m.Regular,0,0,a))}}e.$ri=$;class k extends A.$li{static fromSocket(a,l){return new k(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,P=null){super(a,l,P),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$si=k;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$ti=S;class i{constructor(a){this.data=a,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,P=this.a;for(;P;)a[l++]=P.data,P=P.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new i(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<t.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=t.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+t.a)*1e3;let P=0;for(let y=0;y<t.a;y++)a-this.c[y]<=l&&P++;return 1-P/t.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new S,this.onControlMessage=this.v.event,this.w=new S,this.onMessage=this.w.event,this.x=new S,this.onDidDispose=this.x.event,this.y=new S,this.onSocketClose=this.y.event,this.z=new S,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??t.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Uc,this.p=a.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new d(m.Disconnect,0,0,g());this.q.write(a),this.q.flush()}}sendPause(){const a=new d(m.Pause,0,0,g());this.q.write(a)}sendResume(){const a=new d(m.Resume,0,0,g());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new E.$Uc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(P=>this.A(P))),this.s.add(this.p.onClose(P=>this.y.fire(P))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new d(m.Ack,0,this.j,g());this.q.write(a);const l=this.c.toArray();for(let P=0,y=l.length;P<y;P++)this.q.write(l[P]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case m.None:break;case m.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new d(m.ReplayRequest,0,0,g())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case m.Control:{this.v.fire(a.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const l=this.c.toArray();for(let P=0,y=l.length;P<y;P++)this.q.write(l[P]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const P=new d(m.Regular,l,this.j,a);this.c.push(P),this.a||(this.q.write(P),this.C())}sendControl(a){const l=new d(m.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,P=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&P>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:P});return}const D=Math.max(f.TimeoutTime-l,f.TimeoutTime-P,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new d(m.Ack,0,this.j,g());this.q.write(a)}E(){this.j=this.h;const a=new d(m.KeepAlive,0,this.j,g());this.q.write(a)}}e.$ui=o});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[35],le([0,1,13,15,12]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1X=void 0,n=Ge(n);class A{constructor(){this.a=new WeakMap}on(I,p){const c=(g,...u)=>{this.b(I,g)&&p(g,...u)};return this.a.set(p,c),n.default.ipcMain.on(I,c),this}once(I,p){return n.default.ipcMain.once(I,(c,...g)=>{this.b(I,c)&&p(c,...g)}),this}handle(I,p){return n.default.ipcMain.handle(I,(c,...g)=>this.b(I,c)?p(c,...g):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.default.ipcMain.removeHandler(I),this}removeListener(I,p){const c=this.a.get(p);return c&&(n.default.ipcMain.removeListener(I,c),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Z)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=p.senderFrame,g=c.url;if(!g||g==="about:blank")return!0;let u="unknown";try{u=new URL(g).host}catch{return(0,r.$Z)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${g}'.`),!1}return u!==E.$Zg?((0,r.$Z)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${u}'.`),!1):c.parent!==null?((0,r.$Z)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.$1X=new A}),define(ce[160],le([0,1,13,35,157]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2X=A;function A(){r.$1X.on(E.$YX,(I,p,c,g,u)=>{const m=O(I,g,c);m.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{m&&I.sender.send(E.$ZX,p)}})})}function O(I,p,c){const g=new n.Menu;return c.forEach(u=>{let m;u.type==="separator"?m=new n.MenuItem({type:u.type}):Array.isArray(u.submenu)?m=new n.MenuItem({submenu:O(I,p,u.submenu),label:u.label}):m=new n.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(w,f,d)=>I.sender.send(p,u.id,d)}),g.append(m)}),g}}),define(ce[161],le([0,1,35,17,4,2,44,158]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8X=void 0;function p(g,u){const m=E.Event.fromNodeEventEmitter(n.$1X,u,(f,d)=>({event:f,message:d})),w=E.Event.filter(m,({event:f})=>f.sender.id===g);return E.Event.map(w,({message:f})=>f&&r.$Oe.wrap(f))}class c extends O.$ki{static{this.b=new Map}static d(){const u=E.Event.fromNodeEventEmitter(n.$1X,"vscode:hello",({sender:m})=>m);return E.Event.map(u,m=>{const w=m.id;c.b.get(w)?.dispose();const d=new E.$me;c.b.set(w,(0,A.$Tc)(()=>d.fire()));const v=p(w,"vscode:message"),b=E.Event.any(E.Event.signal(p(w,"vscode:disconnect")),d.event);return{protocol:new I.$7X(m,v),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$8X=c}),define(ce[118],le([0,1,35,4,33,159]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9X=void 0,e.$0X=I;class O extends A.$5X{constructor(c,g){super({addEventListener:(u,m)=>c.addListener(u,m),removeEventListener:(u,m)=>c.removeListener(u,m),postMessage:u=>c.postMessage(u),start:()=>c.start(),close:()=>c.close()},g)}}e.$9X=O;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,E.$3g)();p.webContents.send("vscode:createMessageChannel",c);const g=r.Event.fromNodeEventEmitter(n.$1X,"vscode:createMessageChannelResult",(m,w)=>({nonce:w,port:m.ports[0]})),{port:u}=await r.Event.toPromise(r.Event.once(r.Event.filter(g,m=>m.nonce===c)));return u}}),define(ce[162],le([0,1,48,8,17,22,151,15,4,2,37,94,79,44]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0,I=Pe(I);class f extends w.$ii{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>E.$Oe.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$kr=f;class d{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$me,this.onDidProcessExit=this.h.event;const k=$&&$.timeout?$.timeout:6e4;this.b=new r.$Dh(k),this.d=null,this.f=null}getChannel(b){const $=this;return{call(k,S,i){return $.k(b,k,S,i)},listen(k,S){return $.l(b,k,S)}}}k(b,$,k,S=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const i=this.n(b),h=(0,r.$th)(s=>i.call($,k,s)),t=S.onCancellationRequested(()=>h.cancel()),o=(0,c.$Tc)(()=>h.cancel());return this.c.add(o),h.finally(()=>{t.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(b,$,k){if(!this.b)return p.Event.None;this.b.cancel();let S;const i=new p.$me({onWillAddFirstListener:()=>{S=this.n(b).listen($,k)(i.fire,i),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,g.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,m.$nm)($.env),this.d=(0,n.fork)(this.i,b,$);const k=new p.$me,i=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,O.$gr)(l)){(0,O.log)(l,`IPC Library: ${this.j.serverName}`);return}k.fire(E.$Oe.wrap(Buffer.from(l,"base64")))}),h=this.j.useQueue?(0,u.$Am)(this.d):this.d,t=l=>this.d&&this.d.connected&&h.send(l.buffer.toString("base64")),o=k.event,s={send:t,onMessage:o};this.f=new w.$ji(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,P)=>{process.removeListener("exit",a),i.dispose(),this.c.forEach(y=>(0,c.$Qc)(y)),this.c.clear(),l!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+P),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:P})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$lr=d}),define(ce[119],le([0,1,8,4,2,82,11]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=p;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class g extends E.$Vc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Eh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,d)=>this.w(d,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===c.Closed)return;let d=!1;(0,O.$og)(f)?d=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),d=!0),d&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const d=this.f.get(w);return(0,O.$og)(d)?f:d}getBoolean(w,f){const d=this.get(w);return(0,O.$og)(d)?f:d==="true"}getNumber(w,f){const d=this.get(w);return(0,O.$og)(d)?f:parseInt(d,10)}getObject(w,f){const d=this.get(w);return(0,O.$og)(d)?f:(0,A.$ci)(d)}async set(w,f,d=!1){if(this.c===c.Closed)return;if((0,O.$og)(f))return this.delete(w,d);const v=(0,O.$hg)(f)||Array.isArray(f)?(0,A.$bi)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:d}),this.D()}async delete(w,f=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$fq=g;class u{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,d)=>this.a.set(d,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$gq=u}),define(ce[163],le([0,1,26,8,4,31,9,23]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tY=void 0,n=Pe(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return E.Event.None}static{this.a=2e3}static{this.b=256}constructor(u,m=Object.create(null)){this.g=u,this.h=m,this.c=(0,O.$oc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const u=await this.f,m=new Map;return(await this.s(u,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(u){const m=await this.f;return this.j(m,u)}j(u,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,A.$zc)(m.insert):"0"}), delete(${m.delete?(0,A.$Ac)(m.delete):"0"})`),this.t(u,()=>{const w=m.insert,f=m.delete;if(w&&w.size>0){const d=[];d.push([]);let v=0;w.forEach((b,$)=>{let k=d[v];k.length>p.b&&(v++,k=[],d.push(k)),k.push($,b)}),d.forEach(b=>{this.u(u,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let k=0;return w.forEach((S,i)=>{$.push(i),k+=S.length}),`Keys: ${$.join(", ")} Length: ${k}`})})}if(f&&f.size){const d=[];d.push([]);let v=0;f.forEach(b=>{let $=d[v];$.length>p.b&&(v++,$=[],d.push($)),$.push(b)}),d.forEach(b=>{this.u(u,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(k=>{$.push(k)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const u=await this.f;return this.q(u,"VACUUM")}async close(u){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,u)}k(u,m){return new Promise((w,f)=>{u.db.close(d=>(d&&this.o(u,`[storage ${this.c}] close(): ${d}`),this.g===p.IN_MEMORY_PATH?w():!u.isErroneous&&!u.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof m=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:m()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const u=this.m(this.g);return I.Promises.copy(this.g,u,{preserveSymlinks:!1})}m(u){return`${u}.backup`}async checkIntegrity(u){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${u})`);const m=await this.f,w=await this.r(m,u?"PRAGMA integrity_check":"PRAGMA quick_check"),f=u?w.integrity_check:w.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(u,m=!0){this.d.trace(`[storage ${this.c}] open(${u}, retryOnBusy: ${m})`);try{return await this.p(u)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&m)return await(0,r.$Hh)(p.a),this.n(u,!1);try{await n.promises.unlink(u);try{await I.Promises.rename(this.m(u),u,!1)}catch{}return await this.p(u)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(u,m){u.isErroneous=!0,u.lastError=m,this.d.error(m)}p(u){return new Promise((m,w)=>{new Promise((f,d)=>{x(["@vscode/sqlite3"],f,d)}).then(Pe).then(f=>{const d=this.d.isTracing?f.verbose().Database:f.Database,v={db:new d(u,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>w(b)):w(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(v),$=>v.db.close(()=>w($)))),isInMemory:u===p.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},w)})}q(u,m){return new Promise((w,f)=>{u.db.exec(m,d=>d?(this.o(u,`[storage ${this.c}] exec(): ${d}`),f(d)):w())})}r(u,m){return new Promise((w,f)=>{u.db.get(m,(d,v)=>d?(this.o(u,`[storage ${this.c}] get(): ${d}`),f(d)):w(v))})}s(u,m){return new Promise((w,f)=>{u.db.all(m,(d,v)=>d?(this.o(u,`[storage ${this.c}] all(): ${d}`),f(d)):w(v))})}t(u,m){return new Promise((w,f)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),m(),u.db.run("END TRANSACTION",d=>d?(this.o(u,`[storage ${this.c}] transaction(): ${d}`),f(d)):w())})})}u(u,m,w,f){const d=u.db.prepare(m),v=b=>{this.o(u,`[storage ${this.c}] prepare(): ${b} (${m}). Details: ${f()}`)};d.on("error",v),w(d),d.finalize(b=>{b&&v(b),d.removeListener("error",v)})}}e.$tY=p;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[c.a]&&(this.b=u.logTrace),u&&typeof u.logError=="function"&&(this.c=u.logError)}get isTracing(){return!!this.b}trace(u){this.b?.(u)}error(u){this.c?.(u)}}}),define(ce[10],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=E,e.localize2=O;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let c;return p.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(g,u)=>{const m=u[0],w=p[m];let f=g;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function E(I,p,...c){return r(typeof I=="number"?A(I,p):p,c)}function A(I,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function O(I,p,...c){let g;typeof I=="number"?g=A(I,p):g=p;const u=r(g,c);return{value:u,original:p===g?u:r(p,c)}}}),define(ce[164],le([0,1,10]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=c,e.$4m=g,e.$5m=u;const r=60,E=r*60,A=E*24,O=A*7,I=A*30,p=A*365;function c(m,w,f,d){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,n.localize)(40,null,c(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,n.localize)(41,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(42,null,b):(0,n.localize)(43,null,b):f?(0,n.localize)(44,null,b):(0,n.localize)(45,null,b):b===1?f?(0,n.localize)(46,null,b):(0,n.localize)(47,null,b):f?(0,n.localize)(48,null,b):(0,n.localize)(49,null,b)):v<E?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(50,null,b):(0,n.localize)(51,null,b):f?(0,n.localize)(52,null,b):(0,n.localize)(53,null,b):b===1?f?(0,n.localize)(54,null,b):(0,n.localize)(55,null,b):f?(0,n.localize)(56,null,b):(0,n.localize)(57,null,b)):v<A?(b=Math.floor(v/E),w?b===1?f?(0,n.localize)(58,null,b):(0,n.localize)(59,null,b):f?(0,n.localize)(60,null,b):(0,n.localize)(61,null,b):b===1?f?(0,n.localize)(62,null,b):(0,n.localize)(63,null,b):f?(0,n.localize)(64,null,b):(0,n.localize)(65,null,b)):v<O?(b=Math.floor(v/A),w?b===1?(0,n.localize)(66,null,b):(0,n.localize)(67,null,b):b===1?(0,n.localize)(68,null,b):(0,n.localize)(69,null,b)):v<I?(b=Math.floor(v/O),w?b===1?f?(0,n.localize)(70,null,b):(0,n.localize)(71,null,b):f?(0,n.localize)(72,null,b):(0,n.localize)(73,null,b):b===1?f?(0,n.localize)(74,null,b):(0,n.localize)(75,null,b):f?(0,n.localize)(76,null,b):(0,n.localize)(77,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(78,null,b):(0,n.localize)(79,null,b):f?(0,n.localize)(80,null,b):(0,n.localize)(81,null,b):b===1?f?(0,n.localize)(82,null,b):(0,n.localize)(83,null,b):f?(0,n.localize)(84,null,b):(0,n.localize)(85,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(86,null,b):(0,n.localize)(87,null,b):f?(0,n.localize)(88,null,b):(0,n.localize)(89,null,b):b===1?f?(0,n.localize)(90,null,b):(0,n.localize)(91,null,b):f?(0,n.localize)(92,null,b):(0,n.localize)(93,null,b))}function g(m,w){const f=Math.abs(m/1e3);return f<1?w?(0,n.localize)(94,null,m):(0,n.localize)(95,null,m):f<r?w?(0,n.localize)(96,null,Math.round(m)/1e3):(0,n.localize)(97,null,Math.round(m)/1e3):f<E?w?(0,n.localize)(98,null,Math.round(m/(1e3*r))):(0,n.localize)(99,null,Math.round(m/(1e3*r))):f<A?w?(0,n.localize)(100,null,Math.round(m/(1e3*E))):(0,n.localize)(101,null,Math.round(m/(1e3*E))):(0,n.localize)(102,null,Math.round(m/(1e3*A)))}function u(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[55],le([0,1,21,11,10]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=p,e.$sj=c,e.$tj=g,n=Pe(n),r=Pe(r),E=Pe(E);function A(u,m){return m&&(u.stack||u.stacktrace)?E.localize(103,null,I(u),O(u.stack)||O(u.stacktrace)):I(u)}function O(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?E.localize(104,null,u.message):u.message||E.localize(105,null)}function p(u=null,m=!1){if(!u)return E.localize(106,null);if(Array.isArray(u)){const w=n.$Hb(u),f=p(w[0],m);return w.length>1?E.localize(107,null,f,w.length):f}if(r.$fg(u))return u;if(u.detail){const w=u.detail;if(w.error)return A(w.error,m);if(w.exception)return A(w.exception,m)}return u.stack?A(u,m):u.message?u.message:E.localize(108,null)}function c(u){const m=u;return m instanceof Error&&Array.isArray(m.actions)}function g(u,m){let w;return typeof u=="string"?w=new Error(u):w=u,w.actions=m,w}}),define(ce[165],le([0,1,10,43]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=E;function E(A){switch(A){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(109,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(110,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(111,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(112,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(113,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(114,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(115,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(116,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(117,null);default:return""}}}),define(ce[166],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iib=n,e.$jib=r;function n(E){return E&&E.hasOwnProperty("folderUri")}function r(E){return E&&E.hasOwnProperty("workspace")}}),define(ce[167],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=r,e.$7fc=E,e.$8fc=A;function r(O){return typeof O?.backupFolder=="string"}function E(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function A(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(ce[168],le([0,1,39,15,10]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...g){switch(g.length){case 1:return(0,E.localize)(1684,null,g[0]);case 2:return(0,E.localize)(1685,null,g[0],g[1]);case 3:return(0,E.localize)(1686,null,g[0],g[1],g[2]);default:return}}const I=(0,E.localize)(1687,null),p=(0,E.localize)(1688,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return u.isTripleEq?"===":"==";case A.NotEq:return u.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return u.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return u.lexeme;case A.QuotedStr:return u.lexeme;case A.Error:return u.lexeme;case A.EOF:return"EOF";default:throw(0,r.$8)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(A.LParen);break;case n.CharCode.CloseParen:this.k(A.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:m})}else this.k(A.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:m})}else this.h(n.CharCode.Tilde)?this.k(A.RegexOp):this.l(O("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?A.LtEq:A.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?A.GtEq:A.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(A.And):this.l(O("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(A.Or):this.l(O("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const m=this.d,w=this.c.substring(this.d,this.e),f={type:A.Error,offset:this.d,lexeme:w};this.g.push({offset:m,lexeme:w,additionalInfo:u}),this.f.push(f)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const m=this.c.substring(this.d,this.e),w=c.b.get(m);w?this.k(w):this.f.push({type:A.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,m=!1,w=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(p);return}const d=this.c.charCodeAt(u);if(m)m=!1;else if(d===n.CharCode.Slash&&!w){u++;break}else d===n.CharCode.OpenSquareBracket?w=!0:d===n.CharCode.Backslash?m=!0:d===n.CharCode.CloseSquareBracket&&(w=!1);u++}for(;u<this.c.length&&c.a.has(this.c.charCodeAt(u));)u++;this.e=u;const f=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=c}),define(ce[169],le([0,1,4,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=void 0;class E{constructor(){this.a=new n.$me,this.b=new n.$me,this.c=new n.$me,this.d=new n.$me}static{this.ChannelName="extensionhostdebugservice"}call(I,p,c){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,p,c){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$1o=E;class A extends r.$Vc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,c){this.b.call("attach",[I,p,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$2o=A}),define(ce[170],le([0,1,164,54,12,9,36,18,7]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$8m=g,e.$9m=u,e.$6m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,A.$nc)(E.$1g.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$hh)(p.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=O.env.VSCODE_PORTABLE;return w?p.URI.file((0,A.$kc)(w,"argv.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,A.$lc)(w):(0,A.$ic)((0,A.$kc)(E.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,A.$lc)(w)):p.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,A.$lc)(w);const f=O.env.VSCODE_EXTENSIONS;if(f)return f;const d=O.env.VSCODE_PORTABLE;return d?(0,A.$kc)(d,"extensions"):(0,I.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,A.$ic)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,A.$ic)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$6m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const d=e.$6m.exec(f);d&&d[1]&&d[2]&&w.push([d[1],d[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$hh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=O.env.VSCODE_PORTABLE;return w?p.URI.file((0,A.$kc)(w,"policy.json")):(0,I.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,d){this.a=w,this.b=f,this.c=d,this.editSessionId=this.args.editSessionId}}e.$7m=c,Se([r.$$h],c.prototype,"appRoot",null),Se([r.$$h],c.prototype,"userHome",null),Se([r.$$h],c.prototype,"userDataPath",null),Se([r.$$h],c.prototype,"appSettingsHome",null),Se([r.$$h],c.prototype,"tmpDir",null),Se([r.$$h],c.prototype,"cacheHome",null),Se([r.$$h],c.prototype,"stateResource",null),Se([r.$$h],c.prototype,"userRoamingDataHome",null),Se([r.$$h],c.prototype,"userDataSyncHome",null),Se([r.$$h],c.prototype,"sync",null),Se([r.$$h],c.prototype,"machineSettingsResource",null),Se([r.$$h],c.prototype,"workspaceStorageHome",null),Se([r.$$h],c.prototype,"localHistoryHome",null),Se([r.$$h],c.prototype,"keyboardLayoutResource",null),Se([r.$$h],c.prototype,"argvResource",null),Se([r.$$h],c.prototype,"isExtensionDevelopment",null),Se([r.$$h],c.prototype,"untitledWorkspacesHome",null),Se([r.$$h],c.prototype,"builtinExtensionsPath",null),Se([r.$$h],c.prototype,"extensionsPath",null),Se([r.$$h],c.prototype,"extensionDevelopmentLocationURI",null),Se([r.$$h],c.prototype,"extensionDevelopmentKind",null),Se([r.$$h],c.prototype,"extensionTestsLocationURI",null),Se([r.$$h],c.prototype,"debugExtensionHost",null),Se([r.$$h],c.prototype,"logLevel",null),Se([r.$$h],c.prototype,"extensionLogLevel",null),Se([r.$$h],c.prototype,"serviceMachineIdResource",null),Se([r.$$h],c.prototype,"disableTelemetry",null),Se([r.$$h],c.prototype,"disableWorkspaceTrust",null),Se([r.$$h],c.prototype,"useInMemorySecretStorage",null),Se([r.$$h],c.prototype,"policyFile",null);function g(m,w){return u(m["inspect-extensions"],m["inspect-brk-extensions"],5870,w,m.debugId,m.extensionEnvironment)}function u(m,w,f,d,v,b){const k=Number(w||m)||(d?null:f),S=k?!!w:!1;let i;if(b)try{i=JSON.parse(b)}catch{}return{port:k,break:S,debugId:v,env:i}}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[120],le([0,1,282,3,10]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=void 0,e.$Em=I,e.$Fm=c,e.$Gm=w,e.$Hm=f,n=Ge(n);const A={o:(0,E.localize)(1704,null),e:(0,E.localize)(1705,null),t:(0,E.localize)(1706,null)};e.$Cm=["tunnel","serve-web"],e.$Dm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1707,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1708,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(1709,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(1710,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(1711,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(1712,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(1713,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(1714,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(1715,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(1716,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(1717,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(1718,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(1719,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(1720,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1721,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(1722,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(1723,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(1724,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(1725,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(1726,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1727,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(1728,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(1729,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(1730,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(1731,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(1732,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(1733,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(1734,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(1735,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(1736,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1737,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1738,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(1739,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(1740,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(1741,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(1742,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,v,b=O){const $=d.find(l=>l.length>0&&l[0]!=="-"),k={},S=["_"],i=[],h={};let t;for(const l in v){const P=v[l];P.type==="subcommand"?l===$&&(t=P):(P.alias&&(k[l]=P.alias),P.type==="string"||P.type==="string[]"?(S.push(l),P.deprecates&&S.push(...P.deprecates)):P.type==="boolean"&&(i.push(l),P.deprecates&&i.push(...P.deprecates)),P.global&&(h[l]=P))}if(t&&$){const l=h;for(const L in t.options)l[L]=t.options[L];const P=d.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,D=I(P,l,y);return{[$]:D,_:[]}}const o=(0,n.default)(d,{string:S,boolean:i,alias:k}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const P=v[l];if(P.type==="subcommand")continue;P.alias&&delete a[P.alias];let y=a[l];if(P.deprecates)for(const D of P.deprecates)a.hasOwnProperty(D)&&(y||(y=a[D],y&&b.onDeprecatedOption(D,P.deprecationMessage||(0,E.localize)(1743,null,l))),delete a[D]);if(typeof y<"u"){if(P.type==="string[]"){if(Array.isArray(y)||(y=[y]),!P.allowEmptyValue){const D=y.filter(L=>L.length>0);D.length!==y.length&&(b.onEmptyValue(l),y=D.length>0?D:void 0)}}else P.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!P.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,P.deprecationMessage&&b.onDeprecatedOption(l,P.deprecationMessage)}delete a[l]}for(const l in a)b.onUnknownOption(l);return s}function p(d,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${d}${b}`:`--${d}${b}`}function c(d,v){const b=[];for(const $ in d){const k=d[$],S=p($,k);b.push([S,k.description])}return g(b,v)}function g(d,v){const $=d.reduce((i,h)=>Math.max(i,h[0].length),12)+2+1;if(v-$<25)return d.reduce((i,h)=>i.concat([`  ${h[0]}`,`      ${h[1]}`]),[]);const k=v-$-1,S=[];for(const i of d){const h=i[0],t=m(i[1],k),o=u($-h.length-2);S.push("  "+h+o+t[0]);for(let s=1;s<t.length;s++)S.push(u($)+t[s])}return S}function u(d){return" ".repeat(d)}function m(d,v){const b=[];for(;d.length;){const $=d.length<v?d.length:d.lastIndexOf(" ",v),k=d.slice(0,$).trim();d=d.slice($),b.push(k)}return b}function w(d,v,b,$,k){const S=process.stdout.isTTY&&process.stdout.columns||80,i=k?.noInputFiles!==!0?`[${(0,E.localize)(1744,null)}...]`:"",h=[`${d} ${b}`];h.push(""),h.push(`${(0,E.localize)(1745,null)}: ${v} [${(0,E.localize)(1746,null)}]${i}`),h.push(""),k?.noPipe!==!0&&(r.$j?h.push((0,E.localize)(1747,null,v)):h.push((0,E.localize)(1748,null,v)),h.push(""));const t={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=t[a.cat];l||(t[a.cat]=l={}),l[s]=a}}for(const s in t){const a=s,l=t[a];l&&(h.push(A[a]),h.push(...c(l,S)),h.push(""))}return o.length&&(h.push((0,E.localize)(1749,null)),h.push(...g(o.map(s=>[s.command,s.description]),S)),h.push("")),h.join(`
`)}function f(d,v){return`${d||(0,E.localize)(1750,null)}
${v||(0,E.localize)(1751,null)}
${process.arch}`}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[68],le([0,1,283,10,120]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=I,e.$Jm=p,e.$Km=c,e.$Lm=g,n=Ge(n);function A(u,m){const w=(k,S)=>{console.warn((0,r.localize)(1752,null,k,S))},f=k=>{console.warn((0,r.localize)(1753,null,k))},d=(k,S)=>{console.warn((0,r.localize)(1754,null,k,S))},v=k=>({onUnknownOption:S=>{E.$Cm.includes(k)||console.warn((0,r.localize)(1755,null,S,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:E.$Cm.includes(k)?v:void 0}),b={onUnknownOption:k=>{console.warn((0,r.localize)(1756,null,k))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:v},$=(0,E.$Em)(u,E.$Dm,m?b:void 0);return $.goto&&$._.forEach(k=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(k),(0,r.localize)(1757,null))),$}function O(u){const m=u.findIndex(w=>!/^-/.test(w));if(m>-1)return[...u.slice(0,m),...u.slice(m+1)]}function I(u){let[,...m]=u;process.env.VSCODE_DEV&&(m=O(m)||[]);const w=!g(process.env);return A(m,w)}function p(u){let[,,...m]=u;return process.env.VSCODE_DEV&&(m=O(m)||[]),A(m,!0)}function c(u,...m){const w=u.indexOf("--");return w===-1?u.push(...m):u.splice(w,0,...m),u}function g(u){return u.VSCODE_CLI==="1"}}),function(){function x(e,n,r){function E(O,I){const p=A(O,I),c=[p];return e.isAbsolute(p)||c.unshift(r),e.resolve(...c)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const g=O["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(u,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:E}}if(typeof define=="function")define(ce[171],le([121,27,36]),function(e,n,r){return x(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,170,171]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$$m=O,e.$_m=I;class A extends r.$7m{constructor(c,g){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,E.getUserDataPath)(c,g.nameShort)},g)}}e.$0m=A;function O(p,c){return(0,r.$9m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function I(p,c){return(0,r.$9m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(ce[172],le([0,1,26,27,32]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=A;function A(O){const I=(0,E.$Og)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){O&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(ce[173],le([0,1,11,10]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=E;function E(O,I,p,c){try{A(O,I,p,c)}catch(g){O.error(g?.message??g)}return I}function A(O,I,p,c){const g=(u,m,w)=>{const f=u[m];if((0,n.$fg)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const b=d.substr(1,v-2);let $=p[b];$===void 0&&c&&($=c[b]);const k=typeof $=="string"?$:$?.message,S=c?.[b],i=typeof S=="string"?S:S?.message;if(!k){i||O.warn(`[${I.name}]: ${(0,r.localize)(1805,null,b)}`);return}if(w&&(m==="title"||m==="category")&&i&&i!==k){const h={value:k,original:i};u[m]=h}else u[m]=k}}else if((0,n.$hg)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?g(f,d,!0):g(f,d,w));else if(Array.isArray(f))for(let d=0;d<f.length;d++)g(f,d,w)};for(const u in I)I.hasOwnProperty(u)&&g(I,u)}}),define(ce[174],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:3},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ce[83],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(E,A=[],O=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Di=n}),define(ce[175],le([0,1,83]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Us=A,e.$Vs=O;const r=[];var E;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function A(I,p,c){p instanceof n.$Di||(p=new n.$Di(p,[],!!c)),r.push([I,p])}function O(){return r}}),define(ce[176],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;class n{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$xr=n;class r{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(O);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new n(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),p=this.c(O,I);if(p)return p}}c(A,O){for(const[I,p]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const c=this.c(p,O);if(c)return c;O.delete(I)}}}e.$yr=r}),define(ce[6],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=E,e.$Hi=A;var n;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(n||(e._util=n={})),e.$Fi=E("instantiationService");function r(O,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:O,index:p}):(I[n.DI_DEPENDENCIES]=[{id:O,index:p}],I[n.DI_TARGET]=I)}function E(O){if(n.serviceIds.has(O))return n.serviceIds.get(O);const I=function(p,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,g)};return I.toString=()=>O,n.serviceIds.set(O,I),I}function A(O){return O}}),define(ce[84],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0,e.$1gc=(0,n.$Gi)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0,e.$9fc=(0,n.$Gi)("backupMainService")}),define(ce[16],le([0,1,11,7,6]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=A,e.$cj=O,e.$dj=p,e.$ej=c,e.$fj=g,e.$gj=u,e.$hj=m,e.$ij=f,e.$jj=d,e.$kj=v,n=Pe(n),e.$aj=(0,E.$Gi)("configurationService");function A(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function O(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function g(b,$){const k=Object.create(null);for(const S in b)u(k,S,b[S],$);return k}function u(b,$,k,S){const i=$.split("."),h=i.pop();let t=b;for(let o=0;o<i.length;o++){const s=i[o];let a=t[s];switch(typeof a){case"undefined":a=t[s]=Object.create(null);break;case"object":if(a===null){S(`Ignoring ${$} as ${i.slice(0,o+1).join(".")} is null`);return}break;default:S(`Ignoring ${$} as ${i.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[h]=k}catch{S(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(t)}`)}function m(b,$){const k=$.split(".");w(b,k)}function w(b,$){const k=$.shift();if($.length===0){delete b[k];return}if(Object.keys(b).indexOf(k)!==-1){const S=b[k];typeof S=="object"&&!Array.isArray(S)&&(w(S,$),Object.keys(S).length===0&&delete b[k])}}function f(b,$,k){function S(t,o){let s=t;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const i=$.split("."),h=S(b,i);return typeof h>"u"?k:h}function d(b,$,k){Object.keys($).forEach(S=>{S!=="__proto__"&&(S in b?n.$hg(b[S])&&n.$hg($[S])?d(b[S],$[S],k):k&&(b[S]=$[S]):b[S]=$[S])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(ce[122],le([0,1,39,3,25,168,6,10,15]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=g,e.$Fj=o,e.$Gj=s,e.$Zj=G;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function g(J,M){if(c.get(J)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(J,M)}const u=Object.prototype.hasOwnProperty;var m;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(1664,null),d=(0,I.localize)(1665,null),v=(0,I.localize)(1666,null),b=(0,I.localize)(1667,null),$=(0,I.localize)(1668,null),k=(0,I.localize)(1669,null),S=(0,I.localize)(1670,null),i=(0,I.localize)(1671,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=w){this.k=M,this.d=new A.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),z=_.type===A.TokenType.Str?k:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:A.$Bj.getLexeme(_),additionalInfo:z}),h.c}return F}catch(F){if(F!==h.c)throw F;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(A.TokenType.Or);){const F=this.o();M.push(F)}return M.length===1?M[0]:t.or(...M)}o(){const M=[this.s()];for(;this.y(A.TokenType.And);){const F=this.s();M.push(F)}return M.length===1?M[0]:t.and(...M)}s(){if(this.y(A.TokenType.Neg)){const M=this.D();switch(M.type){case A.TokenType.True:return this.z(),l.INSTANCE;case A.TokenType.False:return this.z(),P.INSTANCE;case A.TokenType.LParen:{this.z();const F=this.l();return this.A(A.TokenType.RParen,b),F?.negate()}case A.TokenType.Str:return this.z(),N.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case A.TokenType.True:return this.z(),t.true();case A.TokenType.False:return this.z(),t.false();case A.TokenType.LParen:{this.z();const F=this.l();return this.A(A.TokenType.RParen,b),F}case A.TokenType.Str:{const F=M.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==A.TokenType.RegexStr)throw this.B("REGEX",z);const ie=z.lexeme,K=ie.lastIndexOf("/"),B=K===ie.length-1?void 0:this.w(ie.substring(K+1));let te;try{te=new RegExp(ie.substring(1,K),B)}catch{throw this.B("REGEX",z)}return Q.create(F,te)}switch(z.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const ie=[z.lexeme];this.z();let K=this.D(),B=0;for(let Ie=0;Ie<z.lexeme.length;Ie++)z.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?B++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&B--;for(;!this.E()&&K.type!==A.TokenType.And&&K.type!==A.TokenType.Or;){switch(K.type){case A.TokenType.LParen:B++;break;case A.TokenType.RParen:B--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ie=0;Ie<K.lexeme.length;Ie++)K.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?B++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&B--}if(B<0)break;ie.push(A.$Bj.getLexeme(K)),this.z(),K=this.D()}const te=ie.join(""),he=te.lastIndexOf("/"),me=he===te.length-1?void 0:this.w(te.substring(he+1));let we;try{we=new RegExp(te.substring(1,he),me)}catch{throw this.B("REGEX",z)}return t.regex(F,we)}case A.TokenType.QuotedStr:{const ie=z.lexeme;this.z();let K=null;if(!(0,E.$df)(ie)){const B=ie.indexOf("/"),te=ie.lastIndexOf("/");if(B!==te&&B>=0){const he=ie.slice(B+1,te),me=ie[te+1]==="i"?"i":"";try{K=new RegExp(he,me)}catch{throw this.B("REGEX",z)}}}if(K===null)throw this.B("REGEX",z);return Q.create(F,K)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,v);const z=this.u();return t.notIn(F,z)}switch(this.D().type){case A.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===A.TokenType.QuotedStr)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case A.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===A.TokenType.QuotedStr)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case A.TokenType.Lt:return this.z(),de.create(F,this.u());case A.TokenType.LtEq:return this.z(),q.create(F,this.u());case A.TokenType.Gt:return this.z(),H.create(F,this.u());case A.TokenType.GtEq:return this.z(),Y.create(F,this.u());case A.TokenType.In:return this.z(),t.in(F,this.u());default:return t.has(F)}}case A.TokenType.EOF:throw this.h.push({message:S,offset:M.offset,lexeme:"",additionalInfo:i}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),M.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,F){if(this.C(M))return this.z();throw this.B(F,this.D())}B(M,F,_){const z=(0,I.localize)(1672,null,M,A.$Bj.getLexeme(F)),ie=F.offset,K=A.$Bj.getLexeme(F);return this.h.push({message:z,offset:ie,lexeme:K,additionalInfo:_}),h.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Dj=h;class t{static false(){return l.INSTANCE}static true(){return P.INSTANCE}static has(M){return y.create(M)}static equals(M,F){return D.create(M,F)}static notEquals(M,F){return T.create(M,F)}static regex(M,F){return Q.create(M,F)}static in(M,F){return L.create(M,F)}static notIn(M,F){return R.create(M,F)}static not(M){return N.create(M)}static and(...M){return W.create(M,null,!0)}static or(...M){return j.create(M,null,!0)}static greater(M,F){return H.create(M,F)}static greaterEquals(M,F){return Y.create(M,F)}static smaller(M,F){return de.create(M,F)}static smallerEquals(M,F){return q.create(M,F)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Ej=t;function o(J){const M=new h({regexParsingWithErrorRecovery:!1});return J.map(F=>(M.parse(F),M.lexingErrors.length>0?M.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,I.localize)(1673,null,_.additionalInfo):(0,I.localize)(1674,null),offset:_.offset,length:_.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(J,M){const F=J?J.substituteConstants():void 0,_=M?M.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}function a(J,M){return J.cmp(M)}class l{static{this.INSTANCE=new l}constructor(){this.type=m.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return P.INSTANCE}}e.$Hj=l;class P{static{this.INSTANCE=new P}constructor(){this.type=m.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Ij=P;class y{static create(M,F=null){const _=c.get(M);return typeof _=="boolean"?_?P.INSTANCE:l.INSTANCE:new y(M,F)}constructor(M,F){this.key=M,this.c=F,this.type=m.Defined}cmp(M){return M.type!==this.type?this.type-M.type:X(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=c.get(this.key);return typeof M=="boolean"?M?P.INSTANCE:l.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Jj=y;class D{static create(M,F,_=null){if(typeof F=="boolean")return F?y.create(M,_):N.create(M,_);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?P.INSTANCE:l.INSTANCE:new D(M,F,_)}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.Equals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?P.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Kj=D;class L{static create(M,F){return new L(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.f),_=M.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?u.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$Lj=L;class R{static create(M,F){return new R(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.NotIn,this.c=L.create(M,F)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=R;class T{static create(M,F,_=null){if(typeof F=="boolean")return F?N.create(M,_):y.create(M,_);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:P.INSTANCE:new T(M,F,_)}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?l.INSTANCE:P.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Nj=T;class N{static create(M,F=null){const _=c.get(M);return typeof _=="boolean"?_?l.INSTANCE:P.INSTANCE:new N(M,F)}constructor(M,F){this.c=M,this.d=F,this.type=m.Not}cmp(M){return M.type!==this.type?this.type-M.type:X(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=c.get(this.c);return typeof M=="boolean"?M?l.INSTANCE:P.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Oj=N;function V(J,M){if(typeof J=="string"){const F=parseFloat(J);isNaN(F)||(J=F)}return typeof J=="string"||typeof J=="number"?M(J):l.INSTANCE}class H{static create(M,F,_=null){return V(F,z=>new H(M,z,_))}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.Greater}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Pj=H;class Y{static create(M,F,_=null){return V(F,z=>new Y(M,z,_))}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Qj=Y;class de{static create(M,F,_=null){return V(F,z=>new de(M,z,_))}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Rj=de;class q{static create(M,F,_=null){return V(F,z=>new q(M,z,_))}constructor(M,F,_){this.c=M,this.d=F,this.f=_,this.type=m.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Sj=q;class Q{static create(M,F){return new Q(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const F=this.f?this.f.source:"",_=M.f?M.f.source:"";return F<_?-1:F>_?1:0}equals(M){if(M.type===this.type){const F=this.f?this.f.source:"",_=M.f?M.f.source:"";return this.d===M.d&&F===_}return!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Tj=Q;class U{static create(M){return new U(M)}constructor(M){this.c=M,this.type=m.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new U(this.c.map(M))}negate(){return this.c}}e.$Uj=U;function Z(J){let M=null;for(let F=0,_=J.length;F<_;F++){const z=J[F].substituteConstants();if(J[F]!==z&&M===null){M=[];for(let ie=0;ie<F;ie++)M[ie]=J[ie]}M!==null&&(M[F]=z)}return M===null?J:M}class W{static create(M,F,_){return W.d(M,F,_)}constructor(M,F){this.expr=M,this.c=F,this.type=m.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:W.create(M,this.c,!1)}evaluate(M){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(M))return!1;return!0}static d(M,F,_){const z=[];let ie=!1;for(const K of M)if(K){if(K.type===m.True){ie=!0;continue}if(K.type===m.False)return l.INSTANCE;if(K.type===m.And){z.push(...K.expr);continue}z.push(K)}if(z.length===0&&ie)return P.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let K=1;K<z.length;K++)z[K-1].equals(z[K])&&(z.splice(K,1),K--);if(z.length===1)return z[0];for(;z.length>1;){const K=z[z.length-1];if(K.type!==m.Or)break;z.pop();const B=z.pop(),te=z.length===0,he=j.create(K.expr.map(me=>W.create([me,B],null,_)),null,te);he&&(z.push(he),z.sort(a))}if(z.length===1)return z[0];if(_){for(let K=0;K<z.length;K++)for(let B=K+1;B<z.length;B++)if(z[K].negate().equals(z[B]))return l.INSTANCE;if(z.length===1)return z[0]}return new W(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new W(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());this.c=j.create(M,this,!0)}return this.c}}e.$Vj=W;class j{static create(M,F,_){return j.d(M,F,_)}constructor(M,F){this.expr=M,this.c=F,this.type=m.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:j.create(M,this.c,!1)}evaluate(M){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(M))return!0;return!1}static d(M,F,_){let z=[],ie=!1;if(M){for(let K=0,B=M.length;K<B;K++){const te=M[K];if(te){if(te.type===m.False){ie=!0;continue}if(te.type===m.True)return P.INSTANCE;if(te.type===m.Or){z=z.concat(te.expr);continue}z.push(te)}}if(z.length===0&&ie)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let K=1;K<z.length;K++)z[K-1].equals(z[K])&&(z.splice(K,1),K--);if(z.length===1)return z[0];if(_){for(let K=0;K<z.length;K++)for(let B=K+1;B<z.length;B++)if(z[K].negate().equals(z[B]))return P.INSTANCE;if(z.length===1)return z[0]}return new j(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new j(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());for(;M.length>1;){const F=M.shift(),_=M.shift(),z=[];for(const ie of re(F))for(const K of re(_))z.push(W.create([ie,K],null,!1));M.unshift(j.create(z,null,!1))}this.c=j.create(M,this,!0)}return this.c}}e.$Wj=j;class C extends y{static{this.d=[]}static all(){return C.d.values()}constructor(M,F,_){super(M,null),this.f=F,typeof _=="object"?C.d.push({..._,key:M}):_!==!0&&C.d.push({key:M,description:_,type:F!=null?typeof F:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return D.create(this.key,M)}notEqualsTo(M){return T.create(this.key,M)}}e.$Xj=C,e.$Yj=(0,O.$Gi)("contextKeyService");function X(J,M){return J<M?-1:J>M?1:0}function oe(J,M,F,_){return J<F?-1:J>F?1:M<_?-1:M>_?1:0}function G(J,M){if(J.type===m.False||M.type===m.True)return!0;if(J.type===m.Or)return M.type===m.Or?ue(J.expr,M.expr):!1;if(M.type===m.Or){for(const F of M.expr)if(G(J,F))return!0;return!1}if(J.type===m.And){if(M.type===m.And)return ue(M.expr,J.expr);for(const F of J.expr)if(G(F,M))return!0;return!1}return J.equals(M)}function ue(J,M){let F=0,_=0;for(;F<J.length&&_<M.length;){const z=J[F].cmp(M[_]);if(z<0)return!1;z===0&&F++,_++}return F===J.length}function re(J){return J.type===m.Or?J.expr:[J]}}),define(ce[96],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Um=e.ID=void 0,e.$Vm=r,e.ID="diagnosticsService",e.$Um=(0,n.$Gi)(e.ID);function r(A){return!!A.hostName&&!!A.errorMessage}class E{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Wm=E});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[123],le([0,1,18,81,10,6,47,3,37]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$dx=e.$cx=e.$bx=void 0,e.$ex=w,e.$fx=f,r=Ge(r),e.$bx=(0,A.$Gi)("dialogService");var c;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(c||(c={}));class g{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,b){const $=[];switch(b){case c.Confirmation:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,E.localize)(1689,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,E.localize)(1690,null));break}case c.Prompt:{const k=v;Array.isArray(k.buttons)&&k.buttons.length>0&&$.push(...k.buttons.map(S=>S.label)),k.cancelButton&&(k.cancelButton===!0?$.push((0,E.localize)(1691,null)):typeof k.cancelButton=="string"?$.push(k.cancelButton):k.cancelButton.label?$.push(k.cancelButton.label):$.push((0,E.localize)(1692,null))),$.length===0&&$.push((0,E.localize)(1693,null));break}case c.Input:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,E.localize)(1694,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,E.localize)(1695,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const k=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&k.push(v.cancelButton);let S=k[b]?.run({checkboxChecked:$});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:$}}}e.$cx=g,e.$dx=(0,A.$Gi)("fileDialogService");var u;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const m=10;function w(d){const v=[];return v.push(...d.slice(0,m).map(b=>typeof b=="string"?b:(0,n.$eh)(b))),d.length>m&&(d.length-m===1?v.push((0,E.localize)(1696,null)):v.push((0,E.localize)(1697,null,d.length-m))),v.push(""),v.join(`
`)}function f(d,v){const b=(0,p.$fo)(d);let $=(b.buttons??[]).map(h=>(0,O.$$w)(h)),k=(d.buttons||[]).map((h,t)=>t),S=0,i=b.cancelId??$.length-1;if($.length>1){const h=typeof i=="number"?$[i]:void 0;if(I.$l||I.$k){if(typeof h=="string"&&$.length>1&&i!==1){$.splice(i,1),$.splice(1,0,h);const t=k[i];k.splice(i,1),k.splice(1,0,t),i=1}I.$l&&$.length>1&&($=$.reverse(),k=k.reverse(),S=$.length-1,typeof h=="string"&&(i=S-1))}else if(I.$j&&typeof h=="string"&&$.length>1&&i!==$.length-1){$.splice(i,1),$.push(h);const t=k[i];k.splice(i,1),k.push(t),i=$.length-1}}return b.buttons=$,b.defaultId=S,b.cancelId=i,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:k}}}),define(ce[97],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$JY=e.$IY=void 0,e.$KY=A,e.$LY=O,e.$IY=(0,n.$Gi)("encryptionService"),e.$JY=(0,n.$Gi)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var E;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(E||(e.KnownStorageProvider=E={}));function A(I){return I===E.kwallet||I===E.kwallet5||I===E.kwallet6}function O(I){return I===E.gnomeAny||I===E.gnomeLibsecret||I===E.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,n.$Gi)("environmentService"),e.$Oi=(0,n.$Hi)(e.$Ni)}),define(ce[177],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,n.$Gi)("extensionHostStarter"),e.$Qgc="extensionHostStarter"}),define(ce[178],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0,e.$30b=(0,n.$Gi)("externalTerminal"),e.$40b="Terminal.app"}),define(ce[179],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0,e.$Sgc=(0,n.$Gi)("externalTerminal")}),define(ce[180],le([0,1,48,54,12,9,3,79,23,94,10,178]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=void 0,n=Pe(n),A=Pe(A),O=Pe(O),p=Pe(p),c=Pe(c),g=Pe(g);const m=g.localize(1842,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(i,h){return this.spawnTerminal(n,i,c.$zm(),h)}spawnTerminal(i,h,t,o){const s=h.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=A.$oc(s,".exe").toLowerCase();if(a==="cmder")return i.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push(s),l.push(s),a==="wt"&&l.push("-d ."),new Promise((P,y)=>{const D=b(process),L=i.spawn(t,l,{cwd:o,env:D,detached:!0});L.on("error",y),L.on("exit",()=>P())})}async runInTerminal(i,h,t,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((P,y)=>{const D=`"${h} - ${m}"`,L=`"${t.join('" "')}" & pause`,R=Object.assign({},b(process),o);Object.keys(R).filter(Y=>R[Y]===null).forEach(Y=>delete R[Y]);const T={cwd:h,env:R,windowsVerbatimArguments:!0};let N,V;A.$oc(a,".exe")==="wt"?(N=a,V=["-d",".",f.b,"/c",L]):l?(N=l,V=["-d",".",a,"/c",L]):(N=f.b,V=["/c","start",D,"/wait",a,"/c",`"${L}"`]),n.spawn(N,V,T).on("error",Y=>{y($(Y))}),P(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const i=await c.win32.findExecutable("wt");return await p.Promises.exists(i)?i:void 0}catch{return}}}e.$Tgc=f,Se([r.$$h],f,"f",null);class d extends w{static{this.b="/usr/bin/osascript"}openTerminal(i,h){return this.spawnTerminal(n,i,h)}runInTerminal(i,h,t,o,s){const a=s.osxExec||u.$40b;return new Promise((l,P)=>{if(a===u.$40b||a==="iTerm.app"){const y=a===u.$40b?"TerminalHelper":"iTermHelper",L=[E.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",i||m,"-w",h];for(const N of t)L.push("-a"),L.push(N);if(o){const N=Object.assign({},b(process),o);for(const V in N){const H=N[V];H===null?(L.push("-u"),L.push(V)):(L.push("-e"),L.push(`${V}=${H}`))}}let R="";const T=n.spawn(d.b,L);T.on("error",N=>{P($(N))}),T.stderr.on("data",N=>{R+=N.toString()}),T.on("exit",N=>{if(N===0)l(void 0);else if(R){const V=R.split(`
`,1);P(new Error(V[0]))}else P(new Error(g.localize(1843,null,y,N)))})}else P(new Error(g.localize(1844,null,a)))})}spawnTerminal(i,h,t){const o=h.osxExec||u.$40b;return new Promise((s,a)=>{const l=["-a",o];t&&l.push(t);const P=b(process),y=i.spawn("/usr/bin/open",l,{cwd:t,env:P});y.on("error",a),y.on("exit",()=>s())})}}e.$Ugc=d;class v extends w{static{this.b=g.localize(1845,null)}openTerminal(i,h){return this.spawnTerminal(n,i,h)}runInTerminal(i,h,t,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,P)=>{const y=[];a.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${k(t)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const R=Object.assign({},b(process),o);Object.keys(R).filter(H=>R[H]===null).forEach(H=>delete R[H]);const T={cwd:h,env:R};let N="";const V=n.spawn(D,y,T);V.on("error",H=>{P($(H))}),V.stderr.on("data",H=>{N+=H.toString()}),V.on("exit",H=>{if(H===0)l(void 0);else if(N){const Y=N.split(`
`,1);P(new Error(Y[0]))}else P(new Error(g.localize(1846,null,D,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!O.$l)v.d=Promise.resolve("xterm");else{const i=await p.Promises.exists("/etc/debian_version");v.d=new Promise(h=>{i?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return v.d}spawnTerminal(i,h,t){const o=h.linuxExec?Promise.resolve(h.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const P=b(process),y=i.spawn(l,[],{cwd:t,env:P});y.on("error",a),y.on("exit",()=>s())})})}}e.$Vgc=v;function b(S){const i={...S.env};return(0,I.$mm)(i),i}function $(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(1847,null,S.path)):S}function k(S){let i="";for(const h of S)h.indexOf(" ")>=0?i+='"'+h+'"':i+=h,i+=" ";return i}}),define(ce[14],le([0,1,60,9,25,11,7,10,6,3,12,65]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Gl=e.FileKind=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.FileOperationResult=e.$yl=e.$xl=e.$wl=e.$ul=e.FileChangeType=e.$tl=e.FileOperation=e.$nl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$bl=void 0,e.$cl=m,e.$dl=v,e.$el=$,e.$fl=k,e.$gl=S,e.$hl=i,e.$il=h,e.$jl=t,e.$kl=o,e.$ll=s,e.$ml=a,e.$ol=y,e.$pl=D,e.$ql=L,e.$rl=R,e.$sl=T,e.$vl=de,e.$Hl=j,e.$Il=C,e.$Kl=oe,e.$bl=(0,p.$Gi)("fileService");function m(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var d;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function v(G){const ue=G;return!!ue&&typeof ue.onDidChange=="function"}var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(G){return!!(G.capabilities&b.FileReadWrite)}function k(G){return!!(G.capabilities&b.FileFolderCopy)}function S(G){return!!(G.capabilities&b.FileClone)}function i(G){return!!(G.capabilities&b.FileOpenReadWriteClose)}function h(G){return!!(G.capabilities&b.FileReadStream)}function t(G){return $(G)?!!(G.capabilities&b.FileAtomicRead):!1}function o(G){return $(G)?!!(G.capabilities&b.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&b.FileAtomicDelete)}function a(G){return!!(G.capabilities&b.Readonly)}var l;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class P extends Error{static create(ue,re){const J=new P(ue.toString(),re);return L(J,re),J}constructor(ue,re){super(ue),this.code=re}}e.$nl=P;function y(G,ue){return P.create(G,ue)}function D(G){return G||y((0,I.localize)(1856,null),l.Unknown)}function L(G,ue){return G.name=ue?`${ue} (FileSystemError)`:"FileSystemError",G}function R(G){if(!G)return l.Unknown;if(G instanceof P)return G.code;const ue=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!ue)return l.Unknown;switch(ue[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function T(G){if(G instanceof q)return G.fileOperationResult;switch(R(G)){case l.FileNotFound:return Z.FILE_NOT_FOUND;case l.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case l.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case l.NoPermissions:return Z.FILE_PERMISSION_DENIED;case l.FileExists:return Z.FILE_MOVE_CONFLICT;case l.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var N;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class V{constructor(ue,re,J){this.resource=ue,this.operation=re,this.target=J}isOperation(ue){return this.operation===ue}}e.$tl=V;var H;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class Y{static{this.a=null}constructor(ue,re){this.c=re,this.b=void 0,this.d=new u.$U(()=>{const J=n.$Mi.forUris(()=>this.c);return J.fill(this.rawAdded.map(M=>[M,!0])),J}),this.f=new u.$U(()=>{const J=n.$Mi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(M=>[M,!0])),J}),this.g=new u.$U(()=>{const J=n.$Mi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(M=>[M,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ue){switch(J.type){case H.ADDED:this.rawAdded.push(J.resource);break;case H.UPDATED:this.rawUpdated.push(J.resource);break;case H.DELETED:this.rawDeleted.push(J.resource);break}this.b!==Y.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(ue,...re){return this.h(ue,{includeChildren:!1},...re)}affects(ue,...re){return this.h(ue,{includeChildren:!0},...re)}h(ue,re,...J){if(!ue)return!1;const M=J.length>0;return!!((!M||J.includes(H.ADDED))&&(this.d.value.get(ue)||re.includeChildren&&this.d.value.findSuperstr(ue))||(!M||J.includes(H.UPDATED))&&(this.f.value.get(ue)||re.includeChildren&&this.f.value.findSuperstr(ue))||(!M||J.includes(H.DELETED))&&(this.g.value.findSubstr(ue)||re.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$ul=Y;function de(G,ue,re){return!G||!ue||G===ue||ue.length>G.length?!1:(ue.charAt(ue.length-1)!==r.sep&&(ue+=r.sep),re?(0,E.$Hf)(G,ue):G.indexOf(ue)===0)}class q extends Error{constructor(ue,re,J){super(ue),this.fileOperationResult=re,this.options=J}}e.$wl=q;class Q extends q{constructor(ue,re,J,M){super(ue,re,M),this.fileOperationResult=re,this.size=J}}e.$xl=Q;class U extends q{constructor(ue,re,J){super(ue,Z.FILE_NOT_MODIFIED_SINCE,J),this.stat=re}}e.$yl=U;var Z;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bl="files.associations",e.$Cl="files.exclude",e.$Dl="files.readonlyInclude",e.$El="files.readonlyExclude",e.$Fl="files.readonlyFromPermissions";var W;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$Gl="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function C(G,ue){if(!ue.hasProvider(O.URI.from({scheme:G.scheme})))return new Promise(re=>{const J=ue.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===G.scheme&&M.added&&(J.dispose(),re())})})}class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ue){return(0,A.$jg)(ue)||(ue=0),ue<X.KB?(0,I.localize)(1857,null,ue.toFixed(0)):ue<X.MB?(0,I.localize)(1858,null,(ue/X.KB).toFixed(2)):ue<X.GB?(0,I.localize)(1859,null,(ue/X.MB).toFixed(2)):ue<X.TB?(0,I.localize)(1860,null,(ue/X.GB).toFixed(2)):(0,I.localize)(1861,null,(ue/X.TB).toFixed(2))}}e.$Jl=X;function oe(G){const ue=typeof G=="string"||G?.scheme===g.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===g.Schemas.file?1024*X.MB:ue?10*X.MB:c.$p?50*X.MB:1024*X.MB}}),define(ce[124],le([0,1,17,15,10,14]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=O;async function O(g,u,m,w,f,d){let v;try{await I(g,u,m,w,f,d)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&m.error(v),m.end()}}async function I(g,u,m,w,f,d){p(d);const v=await g.open(u,{create:!1});try{p(d);let b=0,$=0,k=f&&typeof f.length=="number"?f.length:void 0,S=n.$Oe.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),i=f&&typeof f.position=="number"?f.position:0,h=0;do $=await g.read(v,i,S.buffer,h,S.byteLength-h),i+=$,h+=$,b+=$,typeof k=="number"&&(k-=$),h===S.byteLength&&(await m.write(w(S)),S=n.$Oe.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),h=0);while($>0&&(typeof k!="number"||k>0)&&p(d)&&c(b,f));if(h>0){let t=h;typeof k=="number"&&(t=Math.min(h,k)),m.write(w(S.slice(0,t)))}}catch(b){throw(0,A.$pl)(b)}finally{await g.close(v)}}function p(g){if(g.isCancellationRequested)throw(0,r.$6)();return!0}function c(g,u){if(typeof u?.limits?.size=="number"&&g>u.limits.size)throw(0,A.$ol)((0,E.localize)(1889,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[61],le([0,1,111,2,9,3,7,14]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=void 0,e.$7q=p,e.$8q=c,e.$_q=w,e.$ar=f,e.$br=d,e.$cr=v,e.$dr=$,e.$er=k;function p(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class g extends r.$Vc{static{this.a=5}constructor(i,h,t,o){super(),this.h=i,this.j=h,this.m=t,this.n=o,this.c=this.B(new r.$Wc),this.f=void 0,this.g=0}s(){const i=new r.$Uc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(h=>this.h(h))),i.add(this.b.onDidLogMessage(h=>this.j(h))),i.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(i,h){this.u(i,h)?this.g<g.a&&this.f?(this.y(`restarting watcher after unexpected error: ${i}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${i}`):this.y(i)}u(i,h){return!(!this.n.restartOnError||h||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}w(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}y(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}z(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$9q=g;class u extends g{constructor(i,h,t){super(i,h,t,{type:"node.js",restartOnError:!1})}}e.$0q=u;class m extends g{constructor(i,h,t){super(i,h,t,{type:"universal",restartOnError:!0})}}e.$$q=m;function w(S){return S.map(i=>({type:i.type,resource:O.URI.revive(i.resource),cId:i.cId}))}function f(S){const i=new b;for(const h of S)i.processEvent(h);return i.coalesce()}function d(S,i){return typeof i=="string"&&!i.startsWith(n.$xk)&&!(0,E.$jc)(i)?{base:S,pattern:i}:i}function v(S,i){const h=[];for(const t of i)h.push((0,n.$Bk)(d(S,t)));return h}class b{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$l?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const h=this.b.get(this.c(i));let t=!1;if(h){const o=h.type,s=i.type;h.resource.fsPath!==i.resource.fsPath&&(i.type===I.FileChangeType.DELETED||i.type===I.FileChangeType.ADDED)?t=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(h)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?h.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(h.type=s)}else t=!0;t&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],h=[];return Array.from(this.a).filter(t=>t.type!==I.FileChangeType.DELETED?(i.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>h.some(o=>(0,I.$vl)(t.resource.fsPath,o,!A.$l))?!1:(h.push(t.resource.fsPath),!0)).concat(i)}}function $(S,i){if(typeof i=="number")switch(S.type){case I.FileChangeType.ADDED:return(i&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(i&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(i&I.FileChangeFilter.UPDATED)===0}return!1}function k(S){if(typeof S=="number"){const i=[];return S&I.FileChangeFilter.ADDED&&i.push("Added"),S&I.FileChangeFilter.DELETED&&i.push("Deleted"),S&I.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(ce[181],le([0,1,17,55,15,4,2,67,33,14,61]),function(x,e,n,r,E,A,O,I,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=e.$wR=void 0,e.$wR="localFilesystem";class u extends O.$Vc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$me),this.onDidWatchError=this.g.event,this.h=(0,p.$3g)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:d}=await this.a.call("readFile",[w,f]);return d}readFileStream(w,f,d){const v=(0,I.$Ce)($=>n.$Oe.concat($.map(k=>n.$Oe.wrap(k))).buffer),b=new O.$Uc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Oe)v.write($.buffer);else{if($==="end")v.end();else{let k;if($ instanceof Error)k=$;else{const S=$;k=(0,c.$ol)(S.message??(0,r.$rj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}v.error(k),v.end()}b.dispose()}})),b.add(d.onCancellationRequested(()=>{v.error((0,E.$6)()),v.end(),b.dispose()})),v}writeFile(w,f,d){return this.a.call("writeFile",[w,n.$Oe.wrap(f),d])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,d,v,b){const[$,k]=await this.a.call("read",[w,f,b]);return d.set($.buffer.slice(0,k),v),k}write(w,f,d,v,b){return this.a.call("write",[w,f,n.$Oe.wrap(d),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,d){return this.a.call("rename",[w,f,d])}copy(w,f,d){return this.a.call("copy",[w,f,d])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,g.$_q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const d=(0,p.$3g)();return this.a.call("watch",[this.h,d,w,f]),(0,O.$Tc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$xR=u}),define(ce[182],le([0,1,26,2,61,4,14,7,8]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class c extends r.$Vc{constructor(){super(),this.a=this.B(new A.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$5c),this.m=new Set,this.n=this.B(new p.$Eh(this.y())),this.r=5007,this.s=new p.$4h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,E.$7q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new p.$4h;try{this.h.clear(),this.g.clear();for(const m of u)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const m=new r.$Uc;this.j.set(u.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(u,m),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,m){this.F(u,m)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,m),this.m.add(u.correlationId))}F(u,m){const w=this.O?.subscribe(u.path,(f,d)=>{m.isDisposed||(f?this.D(u,m):d?.type===O.FileChangeType.ADDED&&this.H(u))});return w?(m.add(w),!0):!1}G(u,m){let w=!1;const f=(d,v)=>{if(m.isDisposed)return;const b=this.I(d),$=this.I(v),k=w;w=b,!b&&($||k)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.watchFile)(u.path,{persistent:!1,interval:this.r},f)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${u.path} (correlationId: ${u.correlationId})`)}m.add((0,r.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.unwatchFile)(u.path,f)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const m={resource:I.URI.file(u.path),type:O.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([m]),this.J(m,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,m){if(this.R){const w=` >> normalized ${u.type===O.FileChangeType.ADDED?"[ADDED]":u.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(w,m)}}L(u,m){this.R&&this.P(`${u}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,E.$er)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$nr=c}),define(ce[183],le([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0,e.$tr=b;class v extends O.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(k,S,i,h,t,o){super(),this.s=k,this.t=S,this.u=i,this.w=h,this.y=t,this.z=o,this.c=this.B(new r.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Uh(s=>this.M(s),v.b)),this.g=(0,d.$cr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$cr)(this.s.path,this.s.includes):void 0,this.j=(0,d.$7q)(this.s)?this.s.filter:void 0,this.m=new E.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const k=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await n.promises.stat(k);if(this.m.token.isCancellationRequested)return;this.B(await this.G(k,S.isDirectory()))}catch(k){k.code!=="ENOENT"?this.O(k):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${k})`),this.D()}}D(){this.r=!0,this.w?.()}async F(k){let S=k.path;try{S=await w.Promises.realpath(k.path),k.path===S&&(S=await(0,m.$pr)(k.path,this.m.token)??k.path),k.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${k.path}, real: ${S})`)}catch{}return S}async G(k,S){const i=new O.$Uc;return this.H(k,S,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(k,S,i)),i}H(k,S,i){if(S)return!1;const h=u.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,s)=>{if(!i.isDisposed)if(o){const a=await this.G(k,S);i.isDisposed?a.dispose():i.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:s.type,cId:this.s.correlationId},!0)});return t?(i.add(t),!0):!1}async I(k,S,i){if(c.$k&&(0,A.$Fg)(k,"/Volumes/",!0)){this.O(`Refusing to watch ${k} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new E.$xe(this.m.token);i.add((0,O.$Tc)(()=>h.dispose(!0)));const t=new O.$Uc;i.add(t);try{const o=u.URI.file(this.s.path),s=(0,p.$oc)(k),a=(0,n.watch)(k);t.add((0,O.$Tc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${k}'`);const l=new Set;if(S)try{for(const y of await w.Promises.readdir(k))l.add(y)}catch(y){this.O(y)}if(h.token.isCancellationRequested)return;const P=new Map;t.add((0,O.$Tc)(()=>{for(const[,y]of P)y.dispose();P.clear()})),a.on("error",(y,D)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${k} for changes using fs.watch() (${y}, ${D})`),this.D())}),a.on("change",(y,D)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${D}`);let L="";if(D&&(L=D.toString(),c.$k&&(L=(0,I.$om)(L))),!(!L||y!=="change"&&y!=="rename"))if(S)if(y==="rename"){P.get(L)?.dispose();const R=setTimeout(async()=>{if(P.delete(L),L===s&&!await w.Promises.exists(k)){this.J(o);return}if(h.token.isCancellationRequested)return;const T=await this.N((0,p.$kc)(k,L));if(h.token.isCancellationRequested)return;let N;T?l.has(L)?N=f.FileChangeType.UPDATED:(N=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),N=f.FileChangeType.DELETED),this.L({resource:(0,g.$hh)(o,L),type:N,cId:this.s.correlationId})},v.a);P.set(L,(0,O.$Tc)(()=>clearTimeout(R)))}else{let R;l.has(L)?R=f.FileChangeType.UPDATED:(R=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,g.$hh)(o,L),type:R,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const R=setTimeout(async()=>{const T=await w.Promises.exists(k);h.token.isCancellationRequested||(T?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(k,!1))):this.J(o))},v.a);t.clear(),t.add((0,O.$Tc)(()=>clearTimeout(R)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){h.token.isCancellationRequested||this.O(`Failed to watch ${k} for changes using fs.watch() (${o.toString()})`),this.D()}}J(k){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:k,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(k,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${k.type===f.FileChangeType.ADDED?"[ADDED]":k.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`),!S&&this.g.some(i=>i(k.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${k.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(i=>i(k.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${k.resource.fsPath}`):this.f.work(k))}M(k){const S=(0,d.$ar)(k),i=[];for(const t of S){if((0,d.$dr)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}i.push(t)}if(i.length===0)return;if(this.z)for(const t of i)this.R(` >> normalized ${t.type===f.FileChangeType.ADDED?"[ADDED]":t.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(k){if(c.$l)return w.Promises.exists(k);try{const S=(0,p.$oc)(k);return(await w.Promises.readdir((0,p.$nc)(k))).some(h=>h===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(k){this.z=k}O(k){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${k}`})}P(k){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${k}`})}Q(k){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${k}`})}R(k){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${k}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$sr=v;async function b($,k,S,i,h=512){const t=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(h),s=new E.$xe(i);let a,l=!1;const P={path:$,excludes:[],recursive:!1},y=new v(P,void 0,D=>{(async()=>{for(const{type:L}of D)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:R}=await w.Promises.read(t,o,0,h,null);if(!R||s.token.isCancellationRequested)break;k(o.slice(0,R))}}catch(R){a=new Error(R),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,S(),new Promise((D,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(t)}catch(R){a=new Error(R)}a?L(a):D()})})}}),define(ce[184],le([0,1,4,111,182,3,183,32]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class p extends E.$nr{constructor(g){super(),this.O=g,this.onDidError=n.Event.None,this.watchers=new Set}async N(g){g=this.Z(g);const u=[],m=new Set(Array.from(this.watchers));for(const w of g){const f=this.W(w);f&&(0,r.$Fk)(f.request.excludes,w.excludes)&&(0,r.$Fk)(f.request.includes,w.includes)?m.delete(f):u.push(w)}u.length&&this.P(`Request to start watching: ${u.map(w=>this.M(w)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(w=>this.M(w.request)).join(",")}`);for(const w of m)this.Y(w);for(const w of u)this.X(w)}W(g){for(const u of this.watchers)if(typeof g.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===g.correlationId)return u}else if((0,I.$Eg)(u.request.path,g.path,!A.$l))return u}X(g){const u=new O.$sr(g,this.O,w=>this.a.fire(w),()=>this.c.fire(g),w=>this.b.fire(w),this.R),m={request:g,instance:u};this.watchers.add(m)}async stop(){await super.stop();for(const g of this.watchers)this.Y(g)}Y(g){this.P("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}Z(g){const u=new Map;for(const m of g){const w=A.$l?m.path:m.path.toLowerCase();let f=u.get(m.correlationId);f||(f=new Map,u.set(m.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),f.set(w,m)}return Array.from(u.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(g){super.setVerboseLogging(g);for(const u of this.watchers)u.instance.setVerboseLogging(g)}P(g,u){this.R&&this.b.fire({type:"trace",message:this.bb(g,u)})}Q(g){this.b.fire({type:"warn",message:this.bb(g)})}bb(g,u){return u?`[File Watcher (node.js)] ${g} (${this.M(u.request)})`:`[File Watcher (node.js)] ${g}`}}e.$ur=p}),define(ce[185],le([0,1,61,184]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class E extends n.$0q{constructor(O,I,p){super(O,I,p),this.s()}r(O){return O.add(new r.$ur(void 0))}}e.$vr=E}),define(ce[186],le([0,1,12,44,162,61]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class O extends A.$$q{constructor(p,c,g){super(p,c,g),this.s()}r(p){const c=p.add(new E.$lr(n.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:g,signal:u})=>this.t(`terminated by itself with code ${g}, signal: ${u} (ETERM)`))),r.ProxyChannel.toService((0,r.$ni)(c.getChannel("watcher")))}}e.$mr=O}),define(ce[98],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class n{constructor(...E){this.a=new Map;for(const[A,O]of E)this.set(A,O)}set(E,A){const O=this.a.get(E);return this.a.set(E,A),O}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ei=n}),define(ce[187],le([0,1,8,15,2,83,176,6,98,108]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;const g=!1;class u extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class m{constructor(v=new p.$Ei,b=!1,$,k=g){this.i=v,this.j=b,this.k=$,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Fi,this),this._globalGraph=k?$?._globalGraph??new O.$yr(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Qc)(this.h),this.h.clear();for(const v of this.g)(0,E.$Pc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,k=new class extends m{dispose(){$.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),b?.add(k),k}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let k=!1;try{return v({get:i=>{if(k)throw(0,r.$8)("service accessor is only valid during the invocation of its target method");const h=this.s(i,$);if(!h)throw new Error(`[invokeFunction] unknown service '${i}'`);return h}},...b)}finally{k=!0,$.stop()}}createInstance(v,...b){this.m();let $,k;return v instanceof A.$Di?($=f.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),k=this.o(v,b,$)),$.stop(),k}o(v,b=[],$){const k=I._util.getServiceDependencies(v).sort((h,t)=>h.index-t.index),S=[];for(const h of k){const t=this.s(h.id,$);t||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${h.id}.`,!1),S.push(t)}const i=k.length>0?k[0].index:b.length;if(b.length!==i){console.trace(`[createInstance] First service dependency of ${v.name} at position ${i+1} conflicts with ${b.length} static arguments`);const h=i-b.length;h>0?b=b.concat(new Array(h)):b=b.slice(0,i)}return Reflect.construct(v,b.concat(S))}q(v,b){if(this.i.get(v)instanceof A.$Di)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof A.$Di?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const k=new O.$yr(t=>t.id.toString());let S=0;const i=[{id:v,desc:b,_trace:$}],h=new Set;for(;i.length;){const t=i.pop();if(!h.has(String(t.id))){if(h.add(String(t.id)),k.lookupOrInsertNode(t),S++>1e3)throw new u(k);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof A.$Di){const a={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};k.insertEdge(t,a),i.push(a)}}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new u(k);break}for(const{data:o}of t){if(this.r(o.id)instanceof A.$Di){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}k.removeNode(o)}}return this.r(v)}w(v,b,$=[],k,S){if(this.i.get(v)instanceof A.$Di)return this.x(v,b,$,k,S,this.g);if(this.k)return this.k.w(v,b,$,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],k,S,i){if(k){const h=new m(void 0,this.j,this,this.l);h.c=String(v);const t=new Map,o=new n.$Zh(()=>{const s=h.o(b,$,S);for(const[a,l]of t){const P=s[a];if(typeof P=="function")for(const y of l)y.disposable=P.apply(s,y.listener)}return t.clear(),i.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=t.get(a);return y||(y=new c.$6c,t.set(a,y)),(L,R,T)=>{if(o.isInitialized)return o.value[a](L,R,T);{const N={listener:[L,R,T],disposable:void 0},V=y.push(N);return(0,E.$Tc)(()=>{V(),N.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let P=l[a];return typeof P!="function"||(P=P.bind(l),s[a]=P),P},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const h=this.o(b,$,S);return i.add(h),h}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$zr=m;var w;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(S,i){const h=[],t=new Array(S+1).join("	");for(const[o,s,a]of i.h)if(s&&a){b=!0,h.push(`${t}CREATES -> ${o}`);const l=$(S+1,a);l&&h.push(l)}else h.push(`${t}uses -> ${o}`);return h.join(`
`)}const k=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(k.join(`
`))}}e.$Ar=f}),define(ce[188],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=e.IssueSource=e.OldIssueType=void 0;var r;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(r||(e.OldIssueType=r={}));var E;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(E||(e.IssueSource=E={})),e.$wac=(0,n.$Gi)("issueService"),e.$xac=(0,n.$Gi)("processService")}),define(ce[5],le([0,1,10,55,4,46,2,31,3,18,11,7,122,6]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=d,e.log=b,e.$pk=P,e.$qk=y,e.$rk=D,e.$sk=L,n=Pe(n),e.$bk=(0,w.$Gi)("logService"),e.$ck=(0,w.$Gi)("loggerService");function f(){return new Date().toISOString()}function d(R){return(0,g.$jg)(R)}var v;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$ek=v.Info;function b(R,T,N){switch(T){case v.Trace:R.trace(N);break;case v.Debug:R.debug(N);break;case v.Info:R.info(N);break;case v.Warning:R.warn(N);break;case v.Error:R.error(N);break;case v.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function $(R,T=!1){let N="";for(let V=0;V<R.length;V++){let H=R[V];if(H instanceof Error&&(H=(0,r.$rj)(H,T)),typeof H=="object")try{H=JSON.stringify(H)}catch{}N+=(V>0?" ":"")+H}return N}class k extends O.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new E.$me),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==v.Off&&this.b<=T}}e.$gk=k;class S extends k{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...N){this.f(v.Trace)&&this.g(v.Trace,$([T,...N],!0))}debug(T,...N){this.f(v.Debug)&&this.g(v.Debug,$([T,...N]))}info(T,...N){this.f(v.Info)&&this.g(v.Info,$([T,...N]))}warn(T,...N){this.f(v.Warning)&&this.g(v.Warning,$([T,...N]))}error(T,...N){if(this.f(v.Error))if(T instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=T.stack,this.g(v.Error,$(V))}else this.g(v.Error,$([T,...N]))}flush(){}}e.$hk=S;class i extends k{constructor(T=e.$ek){super(),this.setLevel(T),this.g=!p.$j}trace(T,...N){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...N):console.log(`[main ${f()}]`,T,...N))}debug(T,...N){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...N):console.log(`[main ${f()}]`,T,...N))}info(T,...N){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,T,...N):console.log(`[main ${f()}]`,T,...N))}warn(T,...N){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,T,...N):console.warn(`[main ${f()}]`,T,...N))}error(T,...N){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,T,...N):console.error(`[main ${f()}]`,T,...N))}flush(){}}e.$ik=i;class h extends k{constructor(T=e.$ek,N=!0){super(),this.g=N,this.setLevel(T)}trace(T,...N){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...N):console.log(T,...N))}debug(T,...N){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...N):console.log(T,...N))}info(T,...N){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...N):console.log(T,...N))}warn(T,...N){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...N):console.log(T,...N))}error(T,...N){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...N):console.error(T,...N))}flush(){}}e.$jk=h;class t extends k{constructor(T,N=e.$ek){super(),this.g=T,this.setLevel(N)}trace(T,...N){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(T),...N])}debug(T,...N){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(T),...N])}info(T,...N){this.f(v.Info)&&this.g.log(v.Info,[this.h(T),...N])}warn(T,...N){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(T),...N])}error(T,...N){this.f(v.Error)&&this.g.log(v.Error,[this.h(T),...N])}h(T){return typeof T=="string"?T:(0,r.$rj)(T,this.f(v.Trace))}flush(){}}e.$kk=t;class o extends k{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const N of this.g)N.setLevel(T);super.setLevel(T)}trace(T,...N){for(const V of this.g)V.trace(T,...N)}debug(T,...N){for(const V of this.g)V.debug(T,...N)}info(T,...N){for(const V of this.g)V.info(T,...N)}warn(T,...N){for(const V of this.g)V.warn(T,...N)}error(T,...N){for(const V of this.g)V.error(T,...N)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose();super.dispose()}}e.$lk=o;class s extends O.$Vc{constructor(T,N,V){if(super(),this.h=T,this.j=N,this.b=new I.$Bc,this.c=this.B(new E.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$me),this.onDidChangeVisibility=this.g.event,V)for(const H of V)this.b.set(H.resource,{logger:void 0,info:H})}m(T){return(0,g.$fg)(T)?[...this.b.values()].find(N=>N.info.id===T):this.b.get(T)}getLogger(T){return this.m(T)?.logger}createLogger(T,N){const V=this.n(T),H=(0,g.$fg)(T)?T:N?.id??(0,A.$uj)(V.toString()).toString(16);let Y=this.b.get(V)?.logger;const de=N?.logLevel==="always"?v.Trace:N?.logLevel;Y||(Y=this.s(V,de??this.getLogLevel(V)??this.h,{...N,id:H}));const q={logger:Y,info:{resource:V,id:H,logLevel:de,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(q.info),this.b.set(V,q),Y}n(T){return(0,g.$fg)(T)?(0,c.$hh)(this.j,`${T}.log`):T}setLogLevel(T,N){if(u.URI.isUri(T)){const V=T,H=N,Y=this.b.get(V);Y&&H!==Y.info.logLevel&&(Y.info.logLevel=H===this.h?void 0:H,Y.logger?.setLevel(H),this.b.set(Y.info.resource,Y),this.f.fire([V,H]))}else{this.h=T;for(const[V,H]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,N){const V=this.m(T);V&&N!==!V.info.hidden&&(V.info.hidden=!N,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,N]))}getLogLevel(T){let N;return T&&(N=this.b.get(T)?.info.logLevel),N??this.h}registerLogger(T){const N=this.b.get(T.resource);N?N.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const N=this.b.get(T);N&&(N.logger&&N.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=s;class a{constructor(){this.onDidChangeLogLevel=new E.$me().event}setLevel(T){}getLevel(){return v.Info}trace(T,...N){}debug(T,...N){}info(T,...N){}warn(T,...N){}error(T,...N){}critical(T,...N){}dispose(){}flush(){}}e.$nk=a;class l extends a{}e.$ok=l;function P(R){if(R.verbose)return v.Trace;if(typeof R.logLevel=="string"){const T=L(R.logLevel.toLowerCase());if(T!==void 0)return T}return e.$ek}function y(R){switch(R){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function D(R){switch(R){case v.Trace:return{original:"Trace",value:n.localize(1950,null)};case v.Debug:return{original:"Debug",value:n.localize(1951,null)};case v.Info:return{original:"Info",value:n.localize(1952,null)};case v.Warning:return{original:"Warning",value:n.localize(1953,null)};case v.Error:return{original:"Error",value:n.localize(1954,null)};case v.Off:return{original:"Off",value:n.localize(1955,null)}}}function L(R){switch(R){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$tk=new m.$Xj("logLevel",y(v.Info))});var se=this&&this.__param||function(x,e){return function(n,r){e(n,r,x)}};define(ce[189],le([0,1,13,3,97,5]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;const O=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===E.PasswordStoreCLIOption.basic&&(this.a.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption?.(!0),this.a.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value...");try{const g=JSON.stringify(O.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),g}catch(g){throw this.a.error(g),g}}async decrypt(c){let g;try{if(g=JSON.parse(c),!g.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const u=Buffer.from(g.data);this.a.trace("[EncryptionMainService] Decrypting value...");const m=O.decryptString(u);return this.a.trace("[EncryptionMainService] Decrypted value."),m}catch(u){throw this.a.error(u),u}}isEncryptionAvailable(){this.a.trace("[EncryptionMainService] Checking if encryption is available...");const c=O.isEncryptionAvailable();return this.a.trace("[EncryptionMainService] Encryption is available: ",c),Promise.resolve(c)}getKeyStorageProvider(){if(r.$j)return Promise.resolve(E.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(E.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{this.a.trace("[EncryptionMainService] Getting selected storage backend...");const c=O.getSelectedStorageBackend();return this.a.trace("[EncryptionMainService] Selected storage backend: ",c),Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(E.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.a.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption(!0),this.a.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.$Ogc=I,e.$Ogc=I=Se([se(0,A.$bk)],I)}),define(ce[190],le([0,1,21,8,15,4,32,2,9,61,5]),function(x,e,n,r,E,A,O,I,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class u extends I.$Vc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new A.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Eh(0)),this.w=[],this.y=this.B(new r.$Eh(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const d={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Tb)(this.j,d);return this.r(),(0,I.$Tc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,E.$Z)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$_q)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,c.$8q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,c.$8q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const d={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Tb)(this.w,d);return this.C(),(0,I.$Tc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,E.$Z)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$_q)(w)),w=>this.G(w),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$ic)(w.fsPath)}J(w){const f=this.I(w);return(0,O.$Ig)(f)}}e.$fr=u}),define(ce[191],le([0,1,21,8,17,22,4,46,77,2,60,12,70,18,67,10,14,124,5,15]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let i=class extends c.$Vc{static{S=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$me),this.Y=this.B(new O.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Ph)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const s=new c.$Uc;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$ul(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,c.$Tc)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,c.$Qc)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(s){o.push(s)}}),!this.h.has(t)&&await r.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,w.$lh)(t))throw new v.$wl((0,d.localize)(1862,null,this.sb(t)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const s=new k.$bb;throw s.message=(0,d.localize)(1863,null,t.toString()),s}return o}async m(t){const o=await this.j(t);if((0,v.$hl)(o)||(0,v.$el)(o)||(0,v.$il)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const o=await this.j(t);if((0,v.$hl)(o)||(0,v.$el)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.s(t,o)}catch(s){throw(0,v.$rl)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$wl((0,d.localize)(1864,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$pl)(s)}}async s(t,o){const s=await this.j(t),a=this.S(s),l=o?.resolveTo,P=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,D=await s.stat(t);let L;return this.t(s,t,D,void 0,!!y,(R,T)=>(L||(L=g.$Mi.forUris(()=>!a),L.set(t,!0),l&&L.fill(!0,l)),L.get(R.resource)||L.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&P?T===1:!1))}async t(t,o,s,a,l,P){const{providerExtUri:y}=this.R(t),D={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(t.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Hl)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&P(D,a)){try{const L=await t.readdir(o),R=await r.Promises.settled(L.map(async([T,N])=>{try{const V=y.joinPath(o,T),H=l?await t.stat(V):{type:N};return await this.t(t,V,H,L.length,l,P)}catch(V){return this.b.trace(V),null}}));D.children=(0,n.$Hb)(R)}catch(L){this.b.trace(L),D.children=[]}return D}return D}async resolveAll(t){return r.Promises.settled(t.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),s=await o.stat(t);return this.t(o,t,s,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.u(t,o)}catch(s){return s}return!0}async u(t,o){if(!o?.overwrite&&await this.exists(t))throw new v.$wl((0,d.localize)(1865,null,this.sb(t)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=E.$Oe.fromString(""),s){await this.u(t,s);const a=await this.writeFile(t,o);return this.r.fire(new v.$tl(t,v.FileOperation.CREATE,a)),a}async writeFile(t,o,s){const a=this.qb(await this.n(t),t),{providerExtUri:l}=this.R(a);let P=s;if((0,v.$kl)(a)&&!P?.atomic){const y=a.enforceAtomicWriteFile?.(t);y&&(P={...s,atomic:y})}try{await this.w(a,t,P)||await this.U(a,l.dirname(t));let D;if((0,v.$el)(a)&&!(o instanceof E.$Oe))if((0,f.$Ae)(o)){const L=await(0,f.$He)(o,3);L.ended?D=E.$Oe.concat(L.buffer):D=L}else D=(0,f.$Ee)(o,L=>E.$Oe.concat(L),3);else D=o;!(0,v.$hl)(a)||(0,v.$el)(a)&&D instanceof E.$Oe||(0,v.$el)(a)&&(0,v.$kl)(a)&&P?.atomic?await this.hb(a,t,P,D):await this.db(a,t,P,D instanceof E.$Oe?(0,E.$Ze)(D):D),this.r.fire(new v.$tl(t,v.FileOperation.WRITE))}catch(y){throw new v.$wl((0,d.localize)(1866,null,this.sb(t),(0,v.$pl)(y).toString()),(0,v.$sl)(y),P)}return this.resolve(t,{resolveMetadata:!0})}async w(t,o,s){const a=!!s?.unlock;if(a&&!(t.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(1867,null,this.sb(o)));if(!!s?.atomic){if(!(t.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(1868,null,this.sb(o)));if(!(t.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(1869,null,this.sb(o)));if(a)throw new Error((0,d.localize)(1870,null,this.sb(o)))}let P;try{P=await t.stat(o)}catch{return}if(P.type&v.FileType.Directory)throw new v.$wl((0,d.localize)(1871,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,P),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Gl&&typeof P.mtime=="number"&&typeof P.size=="number"&&s.mtime<P.mtime&&s.etag!==(0,v.$Hl)({mtime:s.mtime,size:P.size}))throw new v.$wl((0,d.localize)(1872,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return P}async readFile(t,o,s){const a=await this.m(t);return o?.atomic?this.z(a,t,o,s):this.C(a,t,o,s)}async z(t,o,s,a){return new Promise((l,P)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(t,o,s,a);l(y)}catch(y){P(y)}},this.R(t).providerExtUri)})}async C(t,o,s,a){const l=await this.D(t,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,E.$1e)(l.value)}}async readFileStream(t,o,s){const a=await this.m(t);return this.D(a,t,o,s)}async D(t,o,s,a){const l=new A.$xe(a);let P=s;(0,v.$jl)(t)&&t.enforceAtomicReadFile?.(o)&&(P={...s,atomic:!0});const y=this.J(o,P).then(L=>L,L=>{throw l.dispose(!0),L});let D;try{return typeof P?.etag=="string"&&P.etag!==v.$Gl&&await y,P?.atomic&&(0,v.$jl)(t)||!((0,v.$hl)(t)||(0,v.$il)(t))||(0,v.$el)(t)&&P?.preferUnbuffered?D=this.I(t,o,P):(0,v.$il)(t)?D=this.G(t,o,l.token,P):D=this.H(t,o,l.token,P),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await y,value:D}}catch(L){throw D&&await(0,f.$Fe)(D),this.F(L,o,P)}}F(t,o,s){const a=(0,d.localize)(1873,null,this.sb(o),(0,v.$pl)(t).toString());return t instanceof v.$yl?new v.$yl(a,t.stat,s):t instanceof v.$xl?new v.$xl(a,t.fileOperationResult,t.size,t.options):new v.$wl(a,(0,v.$sl)(t),s)}G(t,o,s,a=Object.create(null)){const l=t.readFileStream(o,a,s);return(0,f.$Le)(l,{data:P=>P instanceof E.$Oe?P:E.$Oe.wrap(P),error:P=>this.F(P,o,a)},P=>E.$Oe.concat(P))}H(t,o,s,a=Object.create(null)){const l=(0,E.$5e)();return(0,b.$5q)(t,o,l,P=>P,{...a,bufferSize:this.a,errorTransformer:P=>this.F(P,o,a)},s),l}I(t,o,s){const a=(0,f.$Ce)(l=>E.$Oe.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$jl)(t)?l=await t.readFile(o,{atomic:!0}):l=await t.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(E.$Oe.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(t,o){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new v.$wl((0,d.localize)(1874,null,this.sb(t)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Gl&&o.etag===s.etag)throw new v.$yl((0,d.localize)(1875,null),s,o);return this.L(t,s.size,o),s}L(t,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$xl((0,d.localize)(1876,null,this.sb(t)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(t,o,s){return this.M(t,o,"move",s)}async canCopy(t,o,s){return this.M(t,o,"copy",s)}async M(t,o,s,a){if(t.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(t),t):await this.m(t),P=this.qb(await this.n(o),o);await this.Q(l,t,P,o,s,a)}catch(l){return l}return!0}async move(t,o,s){const a=this.qb(await this.n(t),t),l=this.qb(await this.n(o),o),P=await this.N(a,t,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$tl(t,P==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(t,o,s){const a=await this.m(t),l=this.qb(await this.n(o),o),P=await this.N(a,t,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$tl(t,P==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(t,o,s,a,l,P){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:D}=await this.Q(t,o,s,a,l,P);if(y&&!D&&P&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(t===s&&(0,v.$fl)(t))await t.copy(o,a,{overwrite:P});else{const L=await this.resolve(o);L.isDirectory?await this.P(t,L,s,a):await this.O(t,o,s,a)}return l}else return t===s?(await t.rename(o,a,{overwrite:P}),l):(await this.N(t,o,s,a,"copy",P),await this.del(o,{recursive:!0}),"copy")}async O(t,o,s,a){if((0,v.$hl)(t)&&(0,v.$hl)(s))return this.jb(t,o,s,a);if((0,v.$hl)(t)&&(0,v.$el)(s))return this.pb(t,o,s,a);if((0,v.$el)(t)&&(0,v.$hl)(s))return this.nb(t,o,s,a);if((0,v.$el)(t)&&(0,v.$el)(s))return this.lb(t,o,s,a)}async P(t,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const P=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(t,await this.resolve(l.resource),s,P):this.O(t,l.resource,s,P)}))}async Q(t,o,s,a,l,P){let y=!1;if(t===s){const{providerExtUri:L,isPathCaseSensitive:R}=this.R(t);if(R||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,d.localize)(1877,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,d.localize)(1878,null,this.sb(o),this.sb(a)))}const D=await this.exists(a);if(D&&!y){if(!P)throw new v.$wl((0,d.localize)(1879,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(t===s){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(o,a))throw new Error((0,d.localize)(1880,null,this.sb(o),this.sb(a)))}}return{exists:D,isSameResourceWithDifferentPathCase:y}}R(t){const o=this.S(t);return{providerExtUri:o?w.$0g:w.$_g,isPathCaseSensitive:o}}S(t){return!!(t.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.qb(await this.j(t),t);await this.U(o,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$tl(t,v.FileOperation.CREATE,s)),s}async U(t,o){const s=[],{providerExtUri:a}=this.R(t);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await t.stat(o)).type&v.FileType.Directory))throw new Error((0,d.localize)(1881,null,this.sb(o)));break}catch(l){if((0,v.$rl)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await t.mkdir(o)}catch(P){if((0,v.$rl)(P)!==v.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(t,o){try{await this.W(t,o)}catch(s){return s}return!0}async W(t,o){const s=this.qb(await this.j(t),t),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(1882,null,this.sb(t)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(1883,null,this.sb(t)));if(a&&l)throw new Error((0,d.localize)(1884,null,this.sb(t)));let P;try{P=await s.stat(t)}catch{}if(P)this.rb(t,P);else throw new v.$wl((0,d.localize)(1885,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,d.localize)(1886,null,this.sb(t)))}return s}async del(t,o){const s=await this.W(t,o);let a=o;if((0,v.$ll)(s)&&!a?.atomic){const D=s.enforceAtomicDelete?.(t);D&&(a={...o,atomic:D})}const l=!!a?.useTrash,P=!!a?.recursive,y=a?.atomic??!1;await s.delete(t,{recursive:P,useTrash:l,atomic:y}),this.r.fire(new v.$tl(t,v.FileOperation.DELETE))}async cloneFile(t,o){const s=await this.j(t),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(t,o)))return s===a&&(0,v.$gl)(s)?s.cloneFile(t,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$fl)(s)?this.cb.queueFor(t,()=>s.copy(t,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(t,()=>this.O(s,t,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:S.ab++})}watch(t,o={recursive:!1,excludes:[]}){const s=new c.$Uc;let a=!1,l=()=>{a=!0};s.add((0,c.$Tc)(()=>l())),(async()=>{try{const y=await this.bb(t,o);a?(0,c.$Qc)(y):l=()=>(0,c.$Qc)(y)}catch(y){this.b.error(y)}})();const P=o.correlationId;if(typeof P=="number"){const y=s.add(new O.$me);return s.add(this.X.event(L=>{L.correlates(P)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(t,o){const s=await this.j(t),a=(0,I.$uj)([this.R(s).providerExtUri.getComparisonKey(t),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(t,o)},this.$.set(a,l)),l.count+=1,(0,c.$Tc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Qc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,c.$Qc)(t.disposable);this.$.clear()}async db(t,o,s,a){return this.cb.queueFor(o,async()=>{const l=await t.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$Ae)(a)||(0,f.$Be)(a)?await this.eb(t,l,a):await this.fb(t,l,a)}catch(P){throw(0,v.$pl)(P)}finally{await t.close(l)}},this.R(t).providerExtUri)}async eb(t,o,s){let a=0,l;if((0,f.$Be)(s)){if(s.buffer.length>0){const P=E.$Oe.concat(s.buffer);await this.gb(t,o,P,P.byteLength,a,0),a+=P.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((P,y)=>{(0,f.$Ge)(l,{onData:async D=>{l.pause();try{await this.gb(t,o,D,D.byteLength,a,0)}catch(L){return y(L)}a+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>y(D),onEnd:()=>P()})})}async fb(t,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(t,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(t,o,s,a,l,P){let y=0;for(;y<a;){const D=await t.write(o,l+y,s.buffer,P+y,a-y);y+=D}}async hb(t,o,s,a){return this.cb.queueFor(o,()=>this.ib(t,o,s,a),this.R(t).providerExtUri)}async ib(t,o,s,a){let l;a instanceof E.$Oe?l=a:(0,f.$Ae)(a)?l=await(0,E.$1e)(a):(0,f.$Be)(a)?l=await(0,E.$2e)(a):l=(0,E.$Ye)(a),await t.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(t,o,s,a){return this.cb.queueFor(a,()=>this.kb(t,o,s,a),this.R(s).providerExtUri)}async kb(t,o,s,a){let l,P;try{l=await t.open(o,{create:!1}),P=await s.open(a,{create:!0,unlock:!1});const y=E.$Oe.alloc(this.a);let D=0,L=0,R=0;do R=await t.read(l,D,y.buffer,L,y.byteLength-L),await this.gb(s,P,y,R,D,L),D+=R,L+=R,L===y.byteLength&&(L=0);while(R>0)}catch(y){throw(0,v.$pl)(y)}finally{await r.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof P=="number"?s.close(P):Promise.resolve()])}}async lb(t,o,s,a){return this.cb.queueFor(a,()=>this.mb(t,o,s,a),this.R(s).providerExtUri)}async mb(t,o,s,a){return s.writeFile(a,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,o,s,a){return this.cb.queueFor(a,()=>this.ob(t,o,s,a),this.R(s).providerExtUri)}async ob(t,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const P=await t.readFile(o);await this.gb(s,l,E.$Oe.wrap(P),P.byteLength,0,0)}catch(P){throw(0,v.$pl)(P)}finally{await s.close(l)}}async pb(t,o,s,a){const l=await(0,E.$1e)(this.H(t,o,A.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(t,o){if(t.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$wl((0,d.localize)(1887,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$wl((0,d.localize)(1888,null,this.sb(t)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.$6q=i,e.$6q=i=S=Se([se(0,$.$bk)],i)}),define(ce[99],le([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,190,186,185]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class S extends b.$fr{static{this.L=!1}constructor(h,t){super(h,t),this.onDidChangeCapabilities=O.Event.None,this.P=new E.$Bc(o=>u.$$g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,g.$l&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:t,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(h));return{type:this.O(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:d.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const t=await w.Promises.readdir(this.I(h),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,u.$hh)(h,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(t){throw this.hb(t)}}O(h,t){let o;return t?.dangling?o=d.FileType.Unknown:h.isFile()?o=d.FileType.File:h.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async Q(h){const t=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const s=new r.$Fh;return this.P.set(h,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,p.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(h)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(h,t){let o;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),o=await this.Q(h));const s=this.I(h);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(h){S.L&&this.a.trace(h)}readFileStream(h,t,o){const s=(0,m.$Ce)(a=>A.$Oe.concat(a.map(l=>A.$Oe.wrap(l))).buffer);return(0,v.$5q)(this,h,s,a=>a.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(h,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(h)?this.U(h,(0,u.$hh)((0,u.$gh)(h),`${(0,u.$eh)(h)}${o.atomic.postfix}`),t,o):this.W(h,t,o)}async S(h){try{const t=this.I(h),{symbolicLink:o}=await w.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async U(h,t,o,s){const a=new p.$Uc;try{a.add(await this.Q(h)),a.add(await this.Q(t)),await this.W(t,o,s,!0);try{await this.rename(t,h,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(h,t,o,s){let a;try{const l=this.I(h);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,d.$ol)((0,f.localize)(1892,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.$ol)((0,f.localize)(1893,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(h,{create:!0,unlock:o.unlock},s),await this.write(a,0,t,0,t.byteLength)}catch(l){throw await this.ib(h,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(h){S.$=h}async open(h,t,o){const s=this.I(h);let a;(0,d.$cl)(t)&&!o&&(a=await this.Q(h));let l;try{if((0,d.$cl)(t)&&t.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let P;if((0,d.$cl)(t)){if(g.$j)try{await n.promises.truncate(s,0),P="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}P||(P="w")}else P="r";l=await w.Promises.open(s,P)}catch(P){throw a?.dispose(),(0,d.$cl)(t)?await this.ib(h,P):this.hb(P)}if(this.X.set(l,0),(0,d.$cl)(t)&&this.Z.set(l,h),a){const P=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),P&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),P.dispose())}return l}async close(h){const t=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&S.$)try{await w.Promises.fdatasync(h)}catch(o){S.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(h)}catch(o){throw this.hb(o)}finally{t&&(this.Y.get(h)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),t.dispose())}}async read(h,t,o,s,a){const l=this.ab(h,t);let P=null;try{P=(await w.Promises.read(h,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(h,l,P)}return P}ab(h,t){return t===this.X.get(h)?null:t}bb(h,t,o){const s=this.X.get(h);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.X.set(h,s+o):this.X.delete(h)))}async write(h,t,o,s,a){return(0,r.$1h)(()=>this.cb(h,t,o,s,a),100,3)}async cb(h,t,o,s,a){const l=this.ab(h,t);let P=null;try{P=(await w.Promises.write(h,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(h),y)}finally{this.bb(h,l,P)}return P}async mkdir(h){try{await n.promises.mkdir(this.I(h))}catch(t){throw this.hb(t)}}async delete(h,t){try{const o=this.I(h);if(t.recursive){let s;t?.atomic!==!1&&t.atomic.postfix&&(s=(0,c.$kc)((0,c.$nc)(o),`${(0,c.$oc)(o)}${t.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:P}=await w.SymlinkSupport.stat(o);a=l.isDirectory()&&!P}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(h,t,o){const s=this.I(h),a=this.I(t);if(s!==a)try{await this.db(h,t,"move",o.overwrite),await w.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(1894,null,(0,c.$oc)(s),(0,c.$oc)((0,c.$nc)(a)),l.toString()))),this.hb(l)}}async copy(h,t,o){const s=this.I(h),a=this.I(t);if(s!==a)try{await this.db(h,t,"copy",o.overwrite),await w.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(1895,null,(0,c.$oc)(s),(0,c.$oc)((0,c.$nc)(a)),l.toString()))),this.hb(l)}}async db(h,t,o,s){const a=this.I(h),l=this.I(t);let P=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(P=(0,I.$Eg)(a,l,!0)),P){if(o==="copy")throw(0,d.$ol)((0,f.localize)(1896,null),d.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const D=await this.N(h);if(!D)throw(0,d.$ol)((0,f.localize)(1897,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(t);if(L){if(!s)throw(0,d.$ol)((0,f.localize)(1898,null),d.FileSystemProviderErrorCode.FileExists);D.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,t){return this.eb(h,t,!1)}async eb(h,t,o){const s=this.I(h),a=this.I(t),l=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Eg)(s,a,!l))return;const P=new p.$Uc;try{P.add(await this.Q(h)),P.add(await this.Q(t)),o&&await n.promises.mkdir((0,c.$nc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(h,t,!0);throw this.hb(y)}finally{P.dispose()}}t(h,t,o){return new $.$mr(s=>h(s),s=>t(s),o)}F(h,t,o){return new k.$vr(s=>h(s),s=>t(s),o)}hb(h){if(h instanceof d.$nl)return h;let t=h,o;switch(h.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=d.FileSystemProviderErrorCode.Unknown;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.$ol)(t,o)}async ib(h,t){let o=this.hb(t);if(h&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(h));s.mode&128||(o=(0,d.$ol)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$wr=S}),define(ce[192],le([0,1,4,99,2,17,67,22]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=void 0;class p extends E.$Vc{constructor(u,m){super(),this.a=u,this.b=m,this.F=new Map,this.G=new Map}call(u,m,w){const f=this.c(u);switch(m){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${m} not found`)}listen(u,m,w){const f=this.c(u);switch(m){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${m}`)}g(u,m){const w=this.f(u,m,!0);return this.a.stat(w)}h(u,m){const w=this.f(u,m);return this.a.readdir(w)}async j(u,m,w){const f=this.f(u,m,!0),d=await this.a.readFile(f,w);return A.$Oe.wrap(d)}m(u,m,w){const f=this.f(u,m,!0),d=new I.$xe,v=new n.$me({onDidRemoveLastListener:()=>{d.cancel()}}),b=this.a.readFileStream(f,w,d.token);return(0,O.$Ge)(b,{onData:$=>v.fire(A.$Oe.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),d.dispose()}}),v.event}n(u,m,w,f){const d=this.f(u,m);return this.a.writeFile(d,w.buffer,f)}r(u,m,w){const f=this.f(u,m,!0);return this.a.open(f,w)}s(u){return this.a.close(u)}async t(u,m,w){const f=A.$Oe.alloc(w),v=await this.a.read(u,m,f.buffer,0,w);return[f,v]}u(u,m,w,f,d){return this.a.write(u,m,w.buffer,f,d)}w(u,m){const w=this.f(u,m);return this.a.mkdir(w)}y(u,m,w){const f=this.f(u,m);return this.a.delete(f,w)}z(u,m,w,f){const d=this.f(u,m),v=this.f(u,w);return this.a.rename(d,v,f)}C(u,m,w,f){const d=this.f(u,m),v=this.f(u,w);return this.a.copy(d,v,f)}D(u,m,w){const f=this.f(u,m),d=this.f(u,w);return this.a.cloneFile(f,d)}H(u,m){const w=new n.$me({onWillAddFirstListener:()=>{this.F.set(m,this.L(u,w))},onDidRemoveLastListener:()=>{(0,E.$Qc)(this.F.get(m)),this.F.delete(m)}});return w.event}async I(u,m,w,f,d){const v=this.F.get(m);if(v){const b=this.f(u,f),$=v.watch(w,b,d);this.G.set(m+w,$)}}async J(u,m){const w=u+m,f=this.G.get(w);f&&((0,E.$Qc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,u]of this.G)u.dispose();this.G.clear();for(const[,u]of this.F)u.dispose();this.F.clear()}}e.$7s=p;class c extends E.$Vc{constructor(u,m,w,f){super(),this.c=u,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$wr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(m)}h(u){const m=this.B(new n.$me);this.B(m.event(w=>{u.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>m.fire(w))),this.B(this.b.onDidWatchError(w=>u.fire(w)))}j(u){}m(u){}watch(u,m,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(u,this.b.watch(m,w)),(0,E.$Tc)(()=>{(0,E.$Qc)(this.a.get(u)),this.a.delete(u)})}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),super.dispose()}}e.$8s=c}),define(ce[193],le([0,1,13,10,3,7,14,9,192,153,55]),function(x,e,n,r,E,A,O,I,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class u extends p.$7s{constructor(f,d,v){super(f,d),this.M=v}c(f){return c.$On}f(f,d){return A.URI.revive(d)}async y(f,d,v){if(!v.useTrash)return super.y(f,d,v);const b=this.f(f,d),$=(0,I.$ic)(b.fsPath);try{await n.shell.trashItem($)}catch(k){throw(0,O.$ol)(E.$j?(0,r.localize)(1890,null,(0,I.$oc)($),(0,g.$rj)(k)):(0,r.localize)(1891,null,(0,I.$oc)($),(0,g.$rj)(k)),O.FileSystemProviderErrorCode.Unknown)}}L(f,d){return new m(f,d,this.b,this.M)}}e.$Wgc=u;class m extends p.$8s{watch(f,d,v){if(v.recursive)throw(0,O.$ol)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,v)}}}),define(ce[194],le([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class r extends n.$hk{constructor(A=n.$ek){super(),this.m=[],this.n=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(A){this.n=A;for(const{level:O,message:I}of this.m)(0,n.log)(A,O,I);this.m=[]}g(A,O){this.n?(0,n.log)(this.n,A,O):this.getLevel()<=A&&this.m.push({level:A,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Bdc=r}),define(ce[195],le([0,1,7,4,5,2]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=void 0;class O extends E.$mk{constructor(u,m,w,f,d){super(m,w,f),this.r=u,this.t=d,this.B(d.listen("onDidChangeLogLevel",u)(v=>{(0,E.$dk)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(d.listen("onDidChangeVisibility",u)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(d.listen("onDidChangeLoggers",u)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new E.$kk({log:(u,m)=>{this.t.call("consoleLog",[u,m])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,m){super.setLogLevel(u,m),this.t.call("setLogLevel",[u,m])}setVisibility(u,m){super.setVisibility(u,m),this.t.call("setVisibility",[this.n(u),m])}s(u,m,w){return new I(this.t,u,m,w,this.r)}static setLogLevel(u,m,w){return u.call("setLogLevel",[m,w])}}e.$ws=O;class I extends E.$hk{constructor(u,m,w,f,d){super(f?.logLevel==="always"),this.r=u,this.s=m,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[m,f,d]).then(()=>{this.u(this.n),this.m=!0})}g(u,m){const w=[[u,m]];this.m?this.u(w):this.n.push(...w)}u(u){this.r.call("log",[this.s,u])}}class p{constructor(u,m){this.a=u,this.b=m}listen(u,m){const w=this.b(u);switch(m){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(d=>this.c(d,w)),removed:[...f.removed].map(d=>this.c(d,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,E.$dk)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(u,m,w){const f=this.b(u);switch(m){case"setLogLevel":return(0,E.$dk)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,f)))}throw new Error(`Call not found: ${m}`)}c(u,m){return{...u,resource:m.transformOutgoingURI(u.resource)}}}e.$xs=p;class c extends A.$Vc{constructor(u,m){super(),m.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(w=>m.call("setLogLevel",[w]))),m.call("getRegisteredLoggers").then(w=>{for(const f of w)u.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(m.listen("onDidChangeVisibility")(([w,f])=>u.setVisibility(n.URI.revive(w),f))),this.B(m.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const d of w)u.registerLogger({...d,resource:n.URI.revive(d.resource)});for(const d of f)u.deregisterLogger(d.resource)}))}}e.$ys=c}),define(ce[196],le([0,1,2,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class E extends n.$Vc{constructor(O,I=[]){super(),this.a=new r.$lk([O,...I]),this.B(O.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$OR=E}),define(ce[197],le([0,1,31,7,5]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class A{constructor(I){this.b=I,this.a=new n.$Bc}listen(I,p,c){switch(p){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,c){switch(p){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,E.$dk)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,c){this.a.set(I,this.b.createLogger(I,p,c))}d(I,p){let c=console.log;switch(I){case E.LogLevel.Error:c=console.error;break;case E.LogLevel.Warning:c=console.warn;break;case E.LogLevel.Info:c=console.info;break}c.call(console,...p)}e(I,p){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[g,u]of p)(0,E.log)(c,g,u)}}e.$Uhc=A}),define(ce[198],le([0,1,14,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;var E;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(E||(E={}));async function A(c,g,u,m,w){try{const f=await new Promise((v,b)=>{x(["@vscode/spdlog"],v,b)}).then(Pe);f.setFlushOn(E.Trace);const d=await f.createAsyncRotatingLogger(c,g,u,m);return w?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(f){console.error(f)}return null}function O(c,g,u){switch(g){case r.LogLevel.Trace:c.trace(u);break;case r.LogLevel.Debug:c.debug(u);break;case r.LogLevel.Info:c.info(u);break;case r.LogLevel.Warning:c.warn(u);break;case r.LogLevel.Error:c.error(u);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function I(c,g){switch(g){case r.LogLevel.Trace:c.setLevel(E.Trace);break;case r.LogLevel.Debug:c.setLevel(E.Debug);break;case r.LogLevel.Info:c.setLevel(E.Info);break;case r.LogLevel.Warning:c.setLevel(E.Warning);break;case r.LogLevel.Error:c.setLevel(E.Error);break;case r.LogLevel.Off:c.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class p extends r.$hk{constructor(g,u,m,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(g,u,m,w),this.B(this.onDidChangeLogLevel(d=>{this.r&&I(this.r,d)}))}async s(g,u,m,w){const f=m?6:1,d=30/f*n.$Jl.MB,v=await A(g,u,d,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)O(this.r,b,$);this.m=[]}}g(g,u){this.r?O(this.r,g,u):this.getLevel()<=g&&this.m.push({level:g,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DR=p}),define(ce[199],le([0,1,33,5,198]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class A extends r.$mk{s(I,p,c){return new E.$DR((0,n.$3g)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}e.$ER=A}),define(ce[71],le([0,1,31,4,6,5,199]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=void 0,e.$qgc=(0,E.$Hi)(A.$ck);class I extends O.$ER{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(c,g,u){u!==void 0&&this.u.set(this.n(c),u);try{return super.createLogger(c,g)}catch(m){throw this.u.delete(this.n(c)),m}}registerLogger(c,g){g!==void 0&&this.u.set(c.resource,g),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const g=[];for(const u of super.getRegisteredLoggers())c===this.u.get(u.resource)&&g.push(u);return g}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,g=>(0,A.$dk)(g)||this.w(g[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(m=>this.w(m.resource,c)),removed:[...g.removed].filter(m=>this.w(m.resource,c))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(c){for(const[g,u]of this.u)u===c&&this.deregisterLogger(g)}w(c,g){const u=this.u.get(c);return u===void 0||u===g}dispose(){super.dispose(),this.u.clear()}}e.$rgc=I}),define(ce[200],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=n,e.$_gc=r,e.$ahc=E,e.$bhc=A;function n(O){return O.submenu!==void 0}function r(O){return O.id==="vscode.menubar.separator"}function E(O){return O.uri!==void 0}function A(O){return!n(O)&&!r(O)&&!E(O)}}),define(ce[40],le([0,1,4,77,2,6]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,A.$Gi)("policy");class O extends E.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const g=Object.keys(this.f).length;return this.f={...c,...this.f},g!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(u,[m,w])=>({...u,[m]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[g,u])=>({...c,[g]:{definition:u,value:this.g.get(g)}}),{})}}e.$vo=O;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$wo=I}),define(ce[201],le([0,1,8,4,77,11,14,5,40]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;function c(u,m){const w=[];for(const f of new Set(E.Iterable.concat(u.keys(),m.keys())))u.get(f)!==m.get(f)&&w.push(f);return w}let g=class extends p.$vo{constructor(m,w,f){super(),this.m=m,this.n=w,this.s=f,this.c=this.B(new n.$Eh(500));const d=r.Event.filter(w.onDidFilesChange,v=>v.affects(m));this.B(w.watch(m)),this.B(d(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,A.$hg)(f))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(f))this.f[d]&&m.set(d,f[d])}catch(w){w.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return m}async w(){const m=await this.u(),w=c(this.g,m);this.g=m,w.length>0&&this.h.fire(w)}};e.$bic=g,e.$bic=g=Se([se(1,O.$bl),se(2,I.$bk)],g)}),define(ce[202],le([0,1,4,2,40]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0;class A{constructor(p){this.b=p,this.a=new r.$Uc}listen(p,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,g=>g.reduce((u,m)=>({...u,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(p,c,g){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$Jhc=A;class O extends E.$vo{constructor(p,c){super(),this.a=c;for(const g in p){const{definition:u,value:m}=p[g];this.f[g]=u,m!==void 0&&this.g.set(g,m)}this.a.listen("onDidChange")(g=>{for(const u in g){const m=g[u];m===null?this.g.delete(u):this.g.set(u,m)}this.h.fire(Object.keys(g))})}async j(p){const c=await this.a.call("updatePolicyDefinitions",p);for(const g in c)this.g.set(g,c[g])}}e.$Khc=O}),define(ce[203],le([0,1,40,8,2,5]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let O=class extends n.$vo{constructor(p,c){super(),this.m=p,this.n=c,this.a=new r.$Ah,this.b=this.B(new E.$Wc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((g,u)=>{x(["@vscode/policy-watcher"],g,u)}).then(Pe);await this.a.queue(()=>new Promise((g,u)=>{try{this.b.value=c(this.n,p,m=>{this.t(m),g()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),u(m)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const g=p[c];g===void 0?this.g.delete(c):this.g.set(c,g)}this.h.fire(Object.keys(p))}};e.$aic=O,e.$aic=O=Se([se(0,A.$bk)],O)}),define(ce[72],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const A=E.context.configuration();if(A)r=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:A.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ce[28],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,n.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"}),define(ce[204],le([0,1,8,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;let E=class{constructor(O,I,p){this.a=O,this.b=I,this.c=p}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Hh)(O);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$Zgc=E,e.$Zgc=E=Se([se(2,r.$bk)],E)}),define(ce[73],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0,e.$_fc=(0,n.$Gi)("protocolMainService")}),define(ce[45],le([0,1,142,11]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,n=Pe(n),r=Pe(r);class E{constructor(){this.a=new Map}add(O,I){n.ok(r.$fg(O)),n.ok(r.$hg(I)),n.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$so=new E}),define(ce[205],le([0,1,4,144,45]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,E=Pe(E),e.$to={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new n.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,g){this.a[A(c)]=g,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const g=this.a[c];return g?(0,r.$9j)(g):void 0}hasSchemaContent(c){return!!this.a[c]}}const I=new O;E.$so.add(e.$to.JSONContribution,I)}),define(ce[56],le([0,1,21,4,11,10,16,205,45]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=d,e.$Jo=v,e.$Ko=b,e.$Lo=k,e.$Mo=S,e.$No=i,e.$Oo=h,E=Pe(E),A=Pe(A);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$xo={Configuration:"base.contributions.configuration"};var g;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const u=p.$so.as(I.$to.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new r.$me,this.onDidSchemaChange=this.j.event,this.k=new r.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:P}of o)for(const y in l){s.add(y);const D=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(D.configurationDefaultOverrides.push({value:L,source:P}),e.$Ho.test(y)){const R=this.o(y,L,P,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R,this.n(y,R,P),a.push(...d(y))}else{const R=this.p(y,L,P,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R;const T=this.e[y];T&&(this.A(y,T),this.w(y,T))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const P in a){const y=this.b.get(P);if(!y)continue;const D=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[P]);if(D!==-1){if(y.configurationDefaultOverrides.splice(D,1),y.configurationDefaultOverrides.length===0&&this.b.delete(P),e.$Ho.test(P)){let L;for(const R of y.configurationDefaultOverrides)L=this.o(P,R.value,R.source,L);L&&!E.$sg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(P,L,l)):(this.b.delete(P),delete this.e[P],delete this.c.properties[P])}else{let L;for(const T of y.configurationDefaultOverrides)L=this.p(P,T.value,T.source,L);y.configurationDefaultOverrideValue=L;const R=this.e[P];R&&(this.A(P,R),this.w(P,R))}s.add(P)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:A.localize(1654,null,(0,O.$kj)(o)),$ref:e.$Eo,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const P=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(s)){const L=s[D];if(E.$hg(L)&&(E.$mg(P[D])||E.$hg(P[D]))){if(P[D]={...P[D]??{},...L},a)for(const T in L)y.set(`${D}.${T}`,a)}else P[D]=L,a?y.set(D,a):y.delete(D)}return{value:P,source:y}}p(o,s,a,l){const P=this.e[o],y=l?.value??P?.defaultDefaultValue;let D=a;if(E.$hg(s)&&(P!==void 0&&P.type==="object"||P===void 0&&(E.$mg(y)||E.$hg(y)))){if(D=l?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const R in s)a&&D.set(`${o}.${R}`,a);s={...E.$hg(y)?y:{},...s}}return{value:s,source:D}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const P in l.properties){s.add(P);const y=this.e[P];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[P],this.x(P,l.properties[P])}l.allOf?.forEach(P=>a(P))};for(const l of o){a(l);const P=this.d.indexOf(l);P!==-1&&this.d.splice(P,1)}}u(o,s=!0,a,l,P=g.WINDOW,y){P=E.$og(o.scope)?P:o.scope;const D=o.properties;if(D)for(const R in D){const T=D[R];if(s&&k(R,T)){delete D[R];continue}if(T.source=a,T.defaultDefaultValue=D[R].default,this.A(R,T),e.$Ho.test(R)?T.scope=void 0:(T.scope=E.$og(T.scope)?P:T.scope,T.restricted=E.$og(T.restricted)?!!l?.includes(R):T.restricted),D[R].hasOwnProperty("included")&&!D[R].included){this.g[R]=D[R],delete D[R];continue}else this.e[R]=D[R],D[R].policy?.name&&this.f.set(D[R].policy.name,R);!D[R].deprecationMessage&&D[R].markdownDeprecationMessage&&(D[R].deprecationMessage=D[R].markdownDeprecationMessage),y.add(R)}const L=o.allOf;if(L)for(const R of L)this.u(R,s,a,l,P,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$yo.properties[o]=s,s.scope){case g.APPLICATION:e.$zo.properties[o]=s;break;case g.MACHINE:e.$Ao.properties[o]=s;break;case g.MACHINE_OVERRIDABLE:e.$Bo.properties[o]=s;break;case g.WINDOW:e.$Co.properties[o]=s;break;case g.RESOURCE:e.$Do.properties[o]=s;break;case g.LANGUAGE_OVERRIDABLE:e.$Do.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$yo.properties[o],s.scope){case g.APPLICATION:delete e.$zo.properties[o];break;case g.MACHINE:delete e.$Ao.properties[o];break;case g.MACHINE_OVERRIDABLE:delete e.$Bo.properties[o];break;case g.WINDOW:delete e.$Co.properties[o];break;case g.RESOURCE:case g.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:A.localize(1655,null),errorMessage:A.localize(1656,null),$ref:e.$Eo};this.A(s,a),e.$yo.properties[s]=a,e.$zo.properties[s]=a,e.$Ao.properties[s]=a,e.$Bo.properties[s]=a,e.$Co.properties[s]=a,e.$Do.properties[s]=a}}z(){const o={type:"object",description:A.localize(1657,null),errorMessage:A.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=o,e.$zo.patternProperties[e.$Go]=o,e.$Ao.patternProperties[e.$Go]=o,e.$Bo.patternProperties[e.$Go]=o,e.$Co.patternProperties[e.$Go]=o,e.$Do.patternProperties[e.$Go]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,P;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,P=a.source),E.$mg(l)&&(l=s.defaultDefaultValue,P=void 0),E.$mg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=P}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Go=`^(${w})+$`,e.$Ho=new RegExp(e.$Go);function d(t){const o=[];if(e.$Ho.test(t)){let s=f.exec(t);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(t)}}return(0,n.$Mb)(o)}function v(t){return t.reduce((o,s)=>`${o}[${s}]`,"")}function b(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new m;p.$so.add(e.$xo.Configuration,$);function k(t,o){return t.trim()?e.$Ho.test(t)?A.localize(1660,null,t):$.getConfigurationProperties()[t]!==void 0?A.localize(1661,null,t):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(1662,null,t,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(1659,null)}function S(){const t=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))t.push([s,o[s].scope]);return t.push(["launch",g.RESOURCE]),t.push(["task",g.RESOURCE]),t}function i(t){const o={};for(const s of t){const a=s.properties;if(E.$hg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,i(s.allOf))}return o}function h(t){switch(t){case"application":return g.APPLICATION;case"machine":return g.MACHINE;case"resource":return g.RESOURCE;case"machine-overridable":return g.MACHINE_OVERRIDABLE;case"language-overridable":return g.LANGUAGE_OVERRIDABLE;default:return g.WINDOW}}}),define(ce[125],le([0,1,21,4,43,2,31,37,11,7,16,56,14,45]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=S,n=Pe(n),E=Pe(E),I=Pe(I),p=Pe(p);function f(o){return Object.isFrozen(o)?o:I.$go(o)}class d{static createEmptyModel(s){return new d({},[],[],void 0,s)}constructor(s,a,l,P,y){this.b=s,this.c=a,this.d=l,this.raw=P,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof d)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$ij)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const P=[];for(const{contents:y,identifiers:D,keys:L}of l.rawConfiguration.overrides){const R=new d(y,L,[],void 0,l.f).getValue(s);R!==void 0&&P.push({identifiers:D,value:R})}return P.length?f(P):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,g.$ij)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Mb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Mb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$fo(this.contents),l=I.$fo(this.overrides),P=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const D of s)if(y.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(a,D.contents);for(const L of D.overrides){const[R]=l.filter(T=>n.$ub(T.identifiers,L.identifiers));R?(this.i(R.contents,L.contents),R.keys.push(...L.keys),R.keys=n.$Mb(R.keys)):l.push(I.$fo(L))}for(const L of D.keys)P.indexOf(L)===-1&&P.push(L)}return new d(a,P,l,y.every(D=>D instanceof d)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const P of n.$Mb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[P];const D=a[P];D&&(typeof y=="object"&&typeof D=="object"?(y=I.$fo(y),this.i(y,D)):y=D),l[P]=y}return new d(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&p.$hg(s[l])&&p.$hg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$fo(a[l])}}j(s){let a=null,l=null;const P=y=>{y&&(l?this.i(l,y):l=I.$fo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&P(y.contents);return P(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,g.$hj)(this.contents,s),u.$Ho.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$ub(l.identifiers,(0,u.$Io)(s))),1))}k(s,a,l){if((0,g.$gj)(this.contents,s,a,P=>this.f.error(P)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),u.$Ho.test(s)){const P=(0,u.$Io)(s),y={identifiers:P,keys:Object.keys(this.contents[s]),contents:(0,g.$fj)(this.contents[s],L=>this.f.error(L))},D=this.overrides.findIndex(L=>n.$ub(L.identifiers,P));D!==-1?this.overrides[D]=y:this.overrides.push(y)}}}e.$Po=d;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!p.$og(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:P,overrides:y,restricted:D,hasExcludedProperties:L}=this.i(s,a);this.b=new d(l,P,y,L?[s]:void 0,this.g),this.c=D||[]}h(s){let a={},l=null,P=[];const y=[],D=[];function L(T){Array.isArray(P)?P.push(T):l!==null&&(P[l]=T)}const R={onObjectBegin:()=>{const T={};L(T),y.push(P),P=T,l=null},onObjectProperty:T=>{l=T},onObjectEnd:()=>{P=y.pop()},onArrayBegin:()=>{const T=[];L(T),y.push(P),P=T,l=null},onArrayEnd:()=>{P=y.pop()},onLiteralValue:L,onError:(T,N,V)=>{D.push({error:T,offset:N,length:V})}};if(s)try{E.$7n(s,R),a=P[0]||{}}catch(T){this.g.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return a}i(s,a){const l=w.$so.as(u.$xo.Configuration).getConfigurationProperties(),P=this.j(s,l,!0,a);s=P.raw;const y=(0,g.$fj)(s,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`)),D=Object.keys(s),L=this.l(s,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:y,keys:D,overrides:L,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(s,a,l,P){let y=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const D={},L=[];for(const R in s)if(u.$Ho.test(R)&&l){const T=this.j(s[R],a,!1,P);D[R]=T.raw,y=y||T.hasExcludedProperties,L.push(...T.restricted)}else{const T=a[R],N=T?typeof T.scope<"u"?T.scope:u.ConfigurationScope.WINDOW:void 0;T?.restricted&&L.push(R),!P.exclude?.includes(R)&&(P.include?.includes(R)||(N===void 0||P.scopes===void 0||P.scopes.includes(N))&&!(P.skipRestricted&&T?.restricted))?D[R]=s[R]:y=!0}return{raw:D,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const P of Object.keys(s))if(u.$Ho.test(P)){const y={};for(const D in s[P])y[D]=s[P][D];l.push({identifiers:(0,u.$Io)(P),keys:Object.keys(y),contents:(0,g.$fj)(y,a)})}return l}}e.$Qo=v;class b extends A.$Vc{constructor(s,a,l,P,y){super(),this.c=s,this.f=a,this.g=P,this.h=y,this.b=this.B(new r.$me),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(m.FileOperation.CREATE)||D.isOperation(m.FileOperation.COPY)||D.isOperation(m.FileOperation.DELETE)||D.isOperation(m.FileOperation.WRITE))&&l.isEqual(D.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=b;class ${constructor(s,a,l,P,y,D,L,R,T,N,V,H,Y){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=P,this.d=y,this.f=D,this.g=L,this.h=R,this.i=T,this.j=N,this.k=V,this.l=H,this.m=Y}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(s,a,l,P,y,D,L,R,T,N){this.j=s,this.l=a,this.m=l,this.n=P,this.p=y,this.q=D,this.r=L,this.s=R,this.t=T,this.u=N,this.h=null,this.i=new O.$Bc,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let P;l.resource?(P=this.t.get(l.resource),P||(P=d.createEmptyModel(this.u),this.t.set(l.resource,P))):P=this.s,a===void 0?P.removeValue(s):P.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const P=this.w(s,a,l),y=this.A(a.resource,l),D=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const R of P.overrides)for(const T of R.identifiers)P.getOverrideValue(s,T)!==void 0&&L.add(T);return new $(s,a,P.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,D)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:P,updated:y,removed:D}=h(this.j,s);a=[...P,...y,...D]}for(const P of a)for(const y of(0,u.$Io)(P)){const D=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),R=[...L.filter(T=>D.indexOf(T)===-1),...D.filter(T=>L.indexOf(T)===-1),...D.filter(T=>!I.$jo(this.j.override(y).getValue(T),s.override(y).getValue(T)))];l.push([y,R])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:P}=h(this.l,s),y=[...a,...l,...P];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:P,overrides:y}=h(this.applicationConfiguration,s),D=[...a,...l,...P];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:P,overrides:y}=h(this.localUserConfiguration,s),D=[...a,...l,...P];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:P,overrides:y}=h(this.remoteUserConfiguration,s),D=[...a,...l,...P];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:P,overrides:y}=h(this.workspaceConfiguration,s),D=[...a,...l,...P];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:P,updated:y,removed:D,overrides:L}=h(l,a),R=[...P,...y,...D];return(R.length||!l)&&this.updateFolderConfiguration(s,a),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:P,removed:y,overrides:D}=h(a,void 0);return{keys:[...l,...P,...y],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let P=this.x(a,l);return a.overrideIdentifier&&(P=P.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(P=P.merge(this.l)),P}x({resource:s},a){let l=this.y();if(a&&s){const P=a.getFolder(s);P&&(l=this.z(P.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),P=this.r.get(s);P?(a=l.merge(P),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:P,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:P,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(P=>a.add(P))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),P=this.E(s.policy,a),y=this.E(s.application,a),D=this.E(s.user,a),L=this.E(s.workspace,a),R=s.folders.reduce((T,N)=>(T.set(c.URI.revive(N[0]),this.E(N[1],a)),T),new O.$Bc);return new k(l,P,y,D,d.createEmptyModel(a),L,R,d.createEmptyModel(a),new O.$Bc,a)}static E(s,a){return new d(s.contents,s.keys,s.overrides,void 0,a)}}e.$So=k;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const P of o)P.keys.forEach(y=>s.add(y)),P.overrides.forEach(([y,D])=>{const L=(0,O.$yc)(a,y,new Set);D.forEach(R=>L.add(R))});const l=[];return a.forEach((P,y)=>l.push([y,[...P.values()]])),{keys:[...s.values()],overrides:l}}class i{constructor(s,a,l,P,y){this.change=s,this.f=a,this.g=l,this.h=P,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of s.keys)this.affectedKeys.add(D);for(const[,D]of s.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,P=this.d.indexOf(l);if(P<0)return!1;const y=P+l.length;if(y>=this.d.length)return!1;const D=this.d.charCodeAt(y);if(D!==this.b&&D!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,R=this.g.getValue(s,a,this.h);return!I.$jo(L,R)}return!0}}e.$Uo=i;function h(o,s){const{added:a,removed:l,updated:P}=t(s?.rawConfiguration,o?.rawConfiguration),y=[],D=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const R=L.filter(T=>!D.includes(T));for(const T of R)y.push([T,s.getKeysForOverrideIdentifier(T)])}if(o){const R=D.filter(T=>!L.includes(T));for(const T of R)y.push([T,o.getKeysForOverrideIdentifier(T)])}if(s&&o){for(const R of D)if(L.includes(R)){const T=t({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:s.getOverrideValue(void 0,R)||{},keys:s.getKeysForOverrideIdentifier(R)});y.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:a,removed:l,updated:P,overrides:y}}function t(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],P=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const D=(0,g.$ij)(s.contents,y),L=(0,g.$ij)(o.contents,y);I.$jo(D,L)||P.push(y)}}return{added:a,removed:l,updated:P}}}),define(ce[206],le([0,1,21,4,2,37,11,125,56,5,40,45]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=void 0;class m extends E.$Vc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Po.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$so.as(p.$xo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,u.$so.as(p.$xo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Po.createEmptyModel(this.c);const v=u.$so.as(p.$xo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const k of v){const S=$[k],i=b[k];S!==void 0?this.b.setValue(k,S):i?this.b.setValue(k,i.default):this.b.removeValue(k)}}}e.$Vo=m;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Po.createEmptyModel(new c.$ok)}async initialize(){return this.configurationModel}}e.$Wo=w;let f=class extends E.$Vc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Po.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],k=u.$so.as(p.$xo.Configuration).getConfigurationProperties();for(const S of v){const i=k[S];if(!i){$.push(S);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}$.push(S),b[i.policy.name]={type:i.type}}}return(0,O.$sg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=u.$so.as(p.$xo.Configuration).getPolicyConfigurations(),$=(0,n.$Hb)(v.map(k=>b.get(k)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=u.$so.as(p.$xo.Configuration).getConfigurationProperties(),k=[],S=this.b.isEmpty();for(const i of v){const h=$[i]?.policy?.name;if(h){const t=this.f.getPolicyValue(h);(S?t!==void 0:!(0,A.$jo)(this.b.getValue(i),t))&&k.push([i,t])}else this.b.getValue(i)!==void 0&&k.push([i,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const i=this.b;this.b=I.$Po.createEmptyModel(this.g);for(const h of i.keys)this.b.setValue(h,i.getValue(h));for(const[h,t]of k)t===void 0?this.b.removeValue(h):this.b.setValue(h,t);b&&this.a.fire(this.b)}}};e.$Xo=f,e.$Xo=f=Se([se(1,g.$uo),se(2,c.$bk)],f)}),define(ce[207],le([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,56,206,14,40]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;class k extends p.$Vc{constructor(h,t,o,s){super(),this.m=h,this.n=s,this.h=this.B(new A.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Vo(s)),this.c=o instanceof $.$wo?new v.$Wo:this.B(new v.$Xo(this.b,o,s)),this.f=this.B(new f.$Ro(this.m,{},m.$$g,t,s)),this.a=new f.$So(this.b.configurationModel,this.c.configurationModel,f.$Po.createEmptyModel(s),f.$Po.createEmptyModel(s),f.$Po.createEmptyModel(s),f.$Po.createEmptyModel(s),new c.$Bc,f.$Po.createEmptyModel(s),new c.$Bc,s),this.j=new S(h,t,this),this.g=this.B(new r.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$So(h,t,f.$Po.createEmptyModel(this.n),o,f.$Po.createEmptyModel(this.n),f.$Po.createEmptyModel(this.n),new c.$Bc,f.$Po.createEmptyModel(this.n),new c.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,t){const o=typeof h=="string"?h:void 0,s=(0,w.$bj)(h)?h:(0,w.$bj)(t)?t:{};return this.a.getValue(o,s,void 0)}async updateValue(h,t,o,s,a){const l=(0,w.$cj)(o)?o:(0,w.$bj)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,P=l?s:o;if(P!==void 0&&P!==w.ConfigurationTarget.USER_LOCAL&&P!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${P}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Mb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(h,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,g.$jo)(t,y.defaultValue)&&(t=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(T=>(0,n.$ub)([...T.identifiers].sort(),L));R&&(l.overrideIdentifiers=R.identifiers)}const D=l?.overrideIdentifiers?.length?[(0,d.$Jo)(l.overrideIdentifiers),h]:[h];await this.j.write(D,t),await this.reloadConfiguration()}inspect(h,t={}){return this.a.inspect(h,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(o,t,w.ConfigurationTarget.USER)}s(h,t){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(h,t);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(h){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(h);this.u(o,t,w.ConfigurationTarget.DEFAULT)}u(h,t,o){const s=new f.$Uo(h,{data:t},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Yo=k;class S{constructor(h,t,o){this.b=h,this.c=t,this.d=o,this.a=new r.$Nh}write(h,t){return this.a.queue(()=>this.e(h,t))}async e(h,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,O.$Zn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,h,t);o=(0,I.$eo)(o,a),await this.c.writeFile(this.b,E.$Oe.fromString(o))}f(h,t,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!t.length){const P=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:P,length:P.length,offset:0}]}return(0,I.$bo)(h,t,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let h=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(h=t),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[208],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=e.$Zhc=void 0,e.$Zhc="request",e.$1hc="remoteResourceHandler";class n{async routeCall(E,A,O){if(A!==e.$Zhc)throw new Error(`Call not found: ${A}`);const I=O[0];if(I?.authority){const p=E.connections.find(c=>c.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(E,A){throw new Error(`Event not found: ${A}`)}}e.$2hc=n}),define(ce[209],le([0,1,15,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.RemoteAuthorityResolverErrorCode=e.$Ul=e.$Tl=e.RemoteConnectionType=e.$Sl=void 0,e.$Wl=c,e.$Sl=(0,r.$Gi)("remoteAuthorityResolverService");var E;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class A{constructor(u){this.id=u,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Tl=A;class O{constructor(u,m){this.host=u,this.port=m,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ul=O;var I;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$bb{static isNotAvailable(u){return u instanceof p&&u._code===I.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof p&&u._code===I.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof p&&u._code===I.NoResolverFound}static isInvalidAuthority(u){return u instanceof p&&u._code===I.InvalidAuthority}static isHandled(u){return u instanceof p&&u.isHandled}constructor(u,m=I.Unknown,w){super(u),this._message=u,this._code=m,this._detail=w,this.isHandled=m===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Vl=p;function c(g){const u=g.indexOf("+");return u===-1?g:g.substring(0,u)}}),define(ce[210],le([0,1,8,17,22,15,4,2,12,70,66,33,117,209]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$2l=y,e.$3l=D,e.$4l=R,c=Pe(c);const f=30*1e3;var d;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function v(re){switch(re){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function b(re){const J=new E.$xe;return setTimeout(()=>J.cancel(),re),J.token}function $(re,J){if(re.isCancellationRequested||J.isCancellationRequested)return E.CancellationToken.Cancelled;const M=new E.$xe;return re.onCancellationRequested(()=>M.cancel()),J.onCancellationRequested(()=>M.cancel()),M.token}class k{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new I.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$zh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function S(re,J){const M=new k(J);return M.registerDisposable(re.onControlMessage(F=>{const _=JSON.parse(F.toString()),z=j(_);z?M.reject(z):M.resolve(_)})),M.promise}function i(re,J,M,F,_,z,ie,K){const B=new k(K),te=g.$ge.create(!1);return re.info(`Creating a socket (${ie})...`),c.mark(`code/willCreateSocket/${z}`),J.connect(M,F,_,ie).then(he=>{B.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),re.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),B.resolve(he))},he=>{c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),re.error(he),B.reject(he)}),B.promise}function h(re,J){const M=new k(J);return re.then(F=>{M.didTimeout||M.resolve(F)},F=>{M.didTimeout||M.reject(F)}),M.promise}async function t(re,J,M,F){const _=G(re,J);re.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let z;try{z=await i(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$Tg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,v(J),`renderer-${v(J)}-${re.reconnectionToken}`,F)}catch(he){throw re.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let ie,K;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(z,null),ie=re.reconnectionProtocol,K=!1):(ie=new m.$ui({socket:z}),K=!0),re.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const B=await h(re.signService.createNewMessage((0,u.$3g)()),F),te={type:"auth",auth:re.connectionToken||"00000000000000000000",data:B.data};ie.sendControl(r.$Oe.fromString(JSON.stringify(te)));try{const he=await S(ie,$(F,b(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(re.logService.trace(`${_} 4/6. received SignRequest control message.`),!await h(re.signService.validate(B,he.signedData),F)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const we=await h(re.signService.sign(he.data),F),Ie={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:J};return M&&(Ie.args=M),re.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Oe.fromString(JSON.stringify(Ie))),{protocol:ie,ownsProtocol:K}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${_} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${_} received error control message when negotiating connection. Error:`),re.logService.error(he)),K&&W(ie),he}}async function o(re,J,M,F){const _=Date.now(),z=G(re,J),{protocol:ie,ownsProtocol:K}=await t(re,J,M,F),B=new k(F);return B.registerDisposable(ie.onControlMessage(te=>{const he=JSON.parse(te.toString()),me=j(he);me?(re.logService.error(`${z} received error control message when negotiating connection. Error:`),re.logService.error(me),K&&W(ie),B.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ue(_)}!`),B.resolve({protocol:ie,firstMessage:he}))})),B.promise}async function s(re,J){const{protocol:M}=await o(re,d.Management,void 0,J);return{protocol:M}}async function a(re,J,M){const{protocol:F,firstMessage:_}=await o(re,d.ExtensionHost,J,M),z=_&&_.debugPort;return{protocol:F,debugPort:z}}async function l(re,J,M){const F=Date.now(),_=G(re,d.Tunnel),{protocol:z}=await t(re,d.Tunnel,J,M);return re.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ue(F)}!`),z}async function P(re,J,M){const{connectTo:F,connectionToken:_}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:F,connectionToken:_,reconnectionToken:J,reconnectionProtocol:M,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function y(re,J,M){return L(re,async F=>{const{protocol:_}=await s(F,E.CancellationToken.None);return new U(re,J,M,F.reconnectionToken,_)})}async function D(re,J){return L(re,async M=>{const{protocol:F,debugPort:_}=await a(M,J,E.CancellationToken.None);return new Z(re,J,M.reconnectionToken,F,_)})}async function L(re,J){for(let F=1;;F++)try{const _=(0,u.$3g)(),z=await P(re,_,null);return await J(z)}catch(_){if(F<5)re.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(_);else throw re.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(_),Q.triggerPermanentFailure(0,0,w.$Vl.isHandled(_)),_}}async function R(re,J,M){const F=await P(re,(0,u.$3g)(),null);return await l(F,{host:J,port:M},E.CancellationToken.None)}function T(re){return(0,n.$th)(J=>new Promise((M,F)=>{const _=setTimeout(M,re*1e3);J.onCancellationRequested(()=>{clearTimeout(_),M()})}))}var N;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class V{constructor(J,M){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.type=N.ConnectionLost}}e.$5l=V;class H{constructor(J,M,F,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.durationSeconds=F,this.c=_,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$6l=H;class Y{constructor(J,M,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=N.ReconnectionRunning}}e.$7l=Y;class de{constructor(J,M,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=N.ConnectionGain}}e.$8l=de;class q{constructor(J,M,F,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=F,this.handled=_,this.type=N.ReconnectionPermanentFailure}}e.$9l=q;class Q extends I.$Vc{static triggerPermanentFailure(J,M,F){this._permanentFailure=!0,this.f=J,this.g=M,this.h=F,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(J,M,F,_,z){super(),this.t=J,this.u=M,this.reconnectionToken=F,this.protocol=_,this.w=z,this.m=this.B(new O.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(_.onSocketClose(ie=>{const K=oe(this.t,this.reconnectionToken,!0);ie?ie.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${K} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${K} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${K} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(ie=>{const K=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${K} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,I.$Tc)(()=>{const ie=Q.j.indexOf(this);ie>=0&&Q.j.splice(ie,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const _=F<M.length?M[F]:M[M.length-1];try{if(_>0){const ie=T(_);this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,ie)),this.u.logService.info(`${J} waiting for ${_} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${J} resolving connection...`);const z=await P(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${z.connectTo}...`),await this.G(z,b(f)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(w.$Vl.isTemporarilyNotAvailable(z)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,A.$4)(z)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof w.$Vl){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,w.$Vl.isHandled(z));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(J,M,F){this.w?Q.triggerPermanentFailure(J,M,F):this.D(J,M,F)}D(J,M,F){this.m.fire(new q(this.reconnectionToken,J,M,F)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0l=Q;class U extends Q{constructor(J,M,F,_,z){super(d.Management,J,_,z,!0),this.client=this.B(new m.$si(z,{remoteAuthority:M,clientId:F},J.ipcLogger))}async G(J,M){await s(J,M)}}e.$$l=U;class Z extends Q{constructor(J,M,F,_,z){super(d.ExtensionHost,J,F,_,!1),this.H=M,this.debugPort=z}async G(J,M){await a(J,this.H,M)}}e.$_l=Z;function W(re){try{re.acceptDisconnect();const J=re.getSocket();re.dispose(),J.dispose()}catch(J){(0,A.$Z)(J)}}function j(re){if(re&&re.type==="error"){const J=new Error(`Connection error: ${re.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function C(re,J){for(;re.length<J;)re+=" ";return re}function X(re,J){return`[remote-connection][${C(v(re),13)}][${J.substr(0,5)}\u2026]`}function oe(re,J,M){return`${X(re,J)}[${M?"reconnect":"initial"}]`}function G(re,J){return`${oe(J,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ue(re){return`${Date.now()-re} ms`}}),define(ce[74],le([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=r,e.$jn=E,e.$kn=A,e.$ln=O;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function E(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function A(p){const{host:c,port:g}=I(p);if(typeof g>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:g}}function O(p,c){let{host:g,port:u}=I(p);return typeof u>"u"&&(u=c),{host:g,port:u}}function I(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const g=p.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const u=p.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:p,port:void 0}}}),define(ce[85],le([0,1,25,6,74]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=A,e.$vn=u,e.$wn=m,e.$xn=w,e.$yn=f,e.$zn=d,e.$An=v,n=Pe(n),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,k){if(typeof $>"u"||$===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof $=="string"||typeof k=="string"){const S=typeof $=="string"?$:$.value,i=typeof k=="string"?k:k.value;return n.$Gf(S,i)}return $._lower===k._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$sn=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const k of $)this.add(k)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$tn=c;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,k){this.c.set(p.toKey($),k)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=g;function u(b){return m(b)}function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const k=`onResolveRemoteAuthority:${(0,E.$jn)($)}`;return!!b.activationEvents?.includes(k)}return!1}function d(b){return b.map($=>{const[k,S]=$.split("@");return{proposalName:k,version:S?parseInt(S):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$Bn=(0,r.$Gi)("IBuiltinExtensionsScannerService")}),define(ce[126],le([0,1,3,10,85,6]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=I,e.$hp=p,e.$ip=c,e.$jp=g,e.$kp=u,e.$lp=m,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var O;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(i){switch(i){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function p(i){switch(i){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function c(i,h){switch(i){case n.Platform.Windows:return h==="x64"?E.TargetPlatform.WIN32_X64:h==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Linux:return h==="x64"?E.TargetPlatform.LINUX_X64:h==="arm64"?E.TargetPlatform.LINUX_ARM64:h==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?E.TargetPlatform.ALPINE_X64:h==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Mac:return h==="x64"?E.TargetPlatform.DARWIN_X64:h==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Web:return E.TargetPlatform.WEB}}function g(i,h){return h===E.TargetPlatform.WEB&&!i.includes(E.TargetPlatform.WEB)}function u(i,h,t){return g(h,t)?!1:i===E.TargetPlatform.UNDEFINED||i===E.TargetPlatform.UNIVERSAL?!0:i===E.TargetPlatform.UNKNOWN?!1:i===t}function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var w;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var d;(function(i){i.Install="install",i.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$mp=(0,A.$Gi)("extensionGalleryService");var b;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(h,t){super(h),this.code=t,this.name=t}}e.$np=$;var k;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));class S extends Error{constructor(h,t){super(h),this.code=t,this.name=t}}e.$op=S,e.$pp=(0,A.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,A.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,A.$Gi)("IExtensionTipsService"),e.$up=(0,r.localize2)(1771,"Extensions"),e.$vp=(0,r.localize2)(1772,"Preferences")});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[211],le([0,1,18,81,10,212,85,174]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=g,e.$2p=u,e.$3p=m,e.$4p=w,e.$5p=f,e.$6p=d,e.$7p=v,e.$8p=b,r=Ge(r),E=Pe(E),A=Pe(A);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function g(S){return S=S.trim(),S==="*"||p.test(S)}function u(S){if(!g(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=S.match(p);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function m(S){if(!S)return null;const i=S.majorBase,h=S.majorMustEqual,t=S.minorBase;let o=S.minorMustEqual;const s=S.patchBase;let a=S.patchMustEqual;S.hasCaret&&(i===0||(o=!1),a=!1);let l=0;if(S.preRelease){const P=c.exec(S.preRelease);if(P){const[,y,D,L]=P;l=Date.UTC(Number(y),Number(D)-1,Number(L))}}return{majorBase:i,majorMustEqual:h,minorBase:t,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:S.hasGreaterEquals,notBefore:l}}function w(S,i,h){let t;typeof S=="string"?t=m(u(S)):t=S;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let s;if(typeof h=="string"?s=m(u(h)):s=h,!t||!s)return!1;const a=t.majorBase,l=t.minorBase,P=t.patchBase;let y=s.majorBase,D=s.minorBase,L=s.patchBase;const R=s.notBefore;let T=s.majorMustEqual,N=s.minorMustEqual,V=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>D?!0:l<D||o&&o<R?!1:P>=L:(a===1&&y===0&&(!T||!N||!V)&&(y=1,D=0,L=0,T=!0,N=!1,V=!1),a<y?!1:a>y?!T:l<D?!1:l>D?!N:P<L?!1:P>L?!V:!(o&&o<R))}function f(S,i,h,t,o,s){const a=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return a.push([r.default.Error,E.localize(1823,null)]),a;if(typeof t.name!="string")return a.push([r.default.Error,E.localize(1824,null,"name")]),a;if(typeof t.version!="string")return a.push([r.default.Error,E.localize(1825,null,"version")]),a;if(!t.engines)return a.push([r.default.Error,E.localize(1826,null,"engines")]),a;if(typeof t.engines.vscode!="string")return a.push([r.default.Error,E.localize(1827,null,"engines.vscode")]),a;if(typeof t.extensionDependencies<"u"&&!k(t.extensionDependencies))return a.push([r.default.Error,E.localize(1828,null,"extensionDependencies")]),a;if(typeof t.activationEvents<"u"){if(!k(t.activationEvents))return a.push([r.default.Error,E.localize(1829,null,"activationEvents")]),a;if(typeof t.main>"u"&&typeof t.browser>"u")return a.push([r.default.Error,E.localize(1830,null,"activationEvents","main","browser")]),a}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&a.push([r.default.Warning,E.localize(1831,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return a.push([r.default.Error,E.localize(1832,null,"main")]),a;{const y=(0,n.$hh)(h,t.main);(0,n.$bh)(y,h)||a.push([r.default.Warning,E.localize(1833,null,y.path,h.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return a.push([r.default.Error,E.localize(1834,null,"browser")]),a;{const y=(0,n.$hh)(h,t.browser);(0,n.$bh)(y,h)||a.push([r.default.Warning,E.localize(1835,null,y.path,h.path)])}}if(!A.valid(t.version))return a.push([r.default.Error,E.localize(1836,null)]),a;const l=[];if(!d(S,i,t,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&t.enabledApiProposals?.length){const y=[];if(!b([...t.enabledApiProposals],y))for(const D of y)a.push([r.default.Error,D])}return a}function d(S,i,h,t,o){return t||typeof h.main>"u"&&typeof h.browser>"u"?!0:$(S,i,h.engines.vscode,o)}function v(S,i,h){return S==="*"||$(i,h,S)}function b(S,i){if(S.length===0)return!0;const h=Array.isArray(i)?i:void 0,t=(h?void 0:i)??I.allApiProposals,o=[],s=(0,O.$zn)(S);for(const{proposalName:a,version:l}of s){const P=t[a];P&&l&&P.version!==l&&o.push(E.localize(1837,null,a))}return h?.push(...o),o.length===0}function $(S,i,h,t=[]){const o=m(u(h));if(!o)return t.push(E.localize(1838,null,h)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(E.localize(1839,null,h)),!1}else if(!o.majorMustEqual)return t.push(E.localize(1840,null,h)),!1;return w(S,i,o)?!0:(t.push(E.localize(1841,null,S,h)),!1)}function k(S){if(!Array.isArray(S))return!1;for(let i=0,h=S.length;i<h;i++)if(typeof S[i]!="string")return!1;return!0}}),define(ce[213],le([0,1,2,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl=(0,r.$Gi)("remoteSocketFactoryService");class E{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,n.$Tc)(()=>{const p=this.a[O]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[O]?.splice(p,1)})}b(O){return(this.a[O.type]||[]).find(p=>p.supports(O))}connect(O,I,p,c){const g=this.b(O);if(!g)throw new Error(`No socket factory found for ${O}`);return g.connect(O,I,p,c)}}e.$Yl=E}),define(ce[214],le([0,1,26,27,48,121]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=I,n=Pe(n),r=Pe(r),E=Pe(E),A=Pe(A);let O;async function I(w=!1){return(O===void 0||w)&&(O=p()),O}async function p(){const w=c();if(w===void 0)return!1;if(w>=22e3){const f=u();if(f)return new Promise(d=>{E.execFile(f,["--status"],v=>d(!v))})}else{const f=m();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function g(w){const f=process.env.SystemRoot;if(f){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(f,d?"Sysnative":"System32",w)}}function u(){return g("wsl.exe")}function m(){return g("lxss\\LxssManager.dll")}}),define(ce[49],le([0,1,17,15,2,10,56,6,5,45]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=m,e.$_p=w,e.$aq=f,e.$bq=d,e.$cq=v,e.$dq=b,e.$9p=(0,I.$Gi)("requestService");class g{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?i[h]="*****":i[h]=this.b[h];this.a=i}return this.a}}class u extends E.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,A.localize)(2041,null),when:p.$tk.isEqualTo((0,p.$qk)(p.LogLevel.Trace)).serialize()})}async c(i,h,t){const o=`${i} #${++this.b}: ${h.url}`;this.a.trace(`${o} - begin`,h.type,new g(h.headers??{}));try{const s=await t();return this.a.trace(`${o} - end`,h.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,h.type,(0,r.$0)(s)),s}}}e.$0p=u;function m(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function w(S){return S.res.statusCode===204}async function f(S){return w(S)?null:(await(0,n.$1e)(S.stream)).toString()}async function d(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);return f(S)}async function v(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);if(w(S))return null;const h=(await(0,n.$1e)(S.stream)).toString();try{return JSON.parse(h)}catch(t){throw t.message+=`:
`+h,t}}function b(S){k(S)}let $;function k(S){const i=c.$so.as(O.$xo.Configuration),h=$;$={id:"http",order:15,title:(0,A.localize)(2042,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2048,null),(0,A.localize)(2049,null),(0,A.localize)(2050,null),(0,A.localize)(2051,null)],default:"override",description:(0,A.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2054,null),restricted:!0}}},i.updateConfigurations({add:[$],remove:h?[h]:[]})}k(O.ConfigurationScope.APPLICATION)}),define(ce[215],le([0,1,17,22]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=void 0;class E{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,c,g=r.CancellationToken.None){switch(p){case"request":return this.a.request(c[0],g).then(async({res:u,stream:m})=>{const w=await(0,n.$1e)(m);return[{statusCode:u.statusCode,headers:u.headers},w]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$fs=E;class A{constructor(I){this.a=I}async request(I,p){const[c,g]=await this.a.call("request",[I],p);return{res:c,stream:(0,n.$3e)(g)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$gs=A}),define(ce[216],le([0,1,217,11]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=A;function E(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(O,I,p={}){const c=(0,n.parse)(O),g=p.proxyUrl||E(c,I);if(!g)return null;const u=(0,n.parse)(g);if(!/^https?:$/.test(u.protocol||""))return null;const m={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,r.$lg)(p.strictSSL)?p.strictSSL:!0};if(c.protocol==="http:"){const w=await new Promise((f,d)=>{x(["http-proxy-agent"],f,d)}).then(Pe);return new w.HttpProxyAgent(g,m)}else{const w=await new Promise((f,d)=>{x(["https-proxy-agent"],f,d)}).then(Pe);return new w.HttpsProxyAgent(g,m)}}}),define(ce[218],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=e.$hhc=void 0,e.$hhc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$ihc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jhc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[100],le([0,1,48,9,10,22,55,15,3,33,116,68,8,145]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=d;let f;async function d(b,$,k,S){return k["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Lm)(S)&&!k["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Lm)(S)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(i,h)=>{const t=new A.$xe;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Mm)(s,1,120)*1e3);const a=setTimeout(()=>{t.dispose(!0),h(new Error((0,E.localize)(2055,null)))},o);try{i(await v($,t.token))}catch(l){!(0,I.$4)(l)&&!t.token.isCancellationRequested?h(new Error((0,E.localize)(2056,null,(0,O.$rj)(l)))):i({})}finally{clearTimeout(a),t.dispose()}})),f)}async function v(b,$){const k=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",S);const i=(0,c.$3g)().replace(/-/g,"").substr(0,12),h=new RegExp(i+"({.*})"+i),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",t);const o=await(0,g.$Bm)(p.OS,t);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$5);const l=(0,r.$oc)(o);let P,y;const D="";/^pwsh(-preview)?$/.test(l)?(P=`& '${process.execPath}' ${D} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,y=["-Login","-Command"]):l==="nu"?(P=`^'${process.execPath}' ${D} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,y=["-i","-l","-c"]):l==="xonsh"?(P=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,y=["-i","-l","-c"]):(P=`'${process.execPath}' ${D} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),P);const L=(0,n.spawn)(o,[...y,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});$.onCancellationRequested(()=>(L.kill(),a(new I.$5))),L.on("error",N=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,O.$rj)(N)),a(N)});const R=[];L.stdout.on("data",N=>R.push(N));const T=[];L.stderr.on("data",N=>T.push(N)),L.on("close",(N,V)=>{const H=Buffer.concat(R).toString("utf8");b.trace("getUnixShellEnvironment#raw",H);const Y=Buffer.concat(T).toString("utf8");if(Y.trim()&&b.trace("getUnixShellEnvironment#stderr",Y),N||V)return a(new Error((0,E.localize)(2057,null,N,V)));const de=h.exec(H),q=de?de[1]:"{}";try{const Q=JSON.parse(q);k?Q.ELECTRON_RUN_AS_NODE=k:delete Q.ELECTRON_RUN_AS_NODE,S?Q.ELECTRON_NO_ATTACH_CONSOLE=S:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",Q),s(Q)}catch(Q){b.error("getUnixShellEnvironment#errorCaught",(0,O.$rj)(Q)),a(Q)}})})}}),define(ce[219],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(E){try{const A=await this.c();if(A){const O=String(n.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(E)}}}catch(A){console.error(A)}return{id:"",data:E}}async validate(E,A){if(!E.id)return!0;const O=this.b.get(E.id);if(!O)return!1;this.b.delete(E.id);try{return O.validate(A)==="ok"}catch(I){return console.error(I),!1}finally{O.dispose?.()}}async sign(E){try{return await this.d(E)}catch(A){console.error(A)}return E}}e.$4cc=n}),define(ce[101],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl="signService",e.$1l=(0,n.$Gi)(e.$Zl)}),define(ce[220],le([0,1,152,219]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class E extends r.$4cc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(I=>new I.signer().sign(O))}h(){return(0,n.$uq)("vsda","index.js")}}e.$_hc=E}),define(ce[34],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GR=e.$FR=void 0,e.$FR=(0,n.$Gi)("stateReadService"),e.$GR=(0,n.$Gi)("stateService")}),define(ce[127],le([0,1,8,17,2,11,38,14,5]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=e.$IR=e.$HR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class g extends E.$Vc{constructor(f,d,v,b){super(),this.h=f,this.j=d,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Eh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,d){const v=this.a[f];return(0,A.$og)(v)?d:v}setItem(f,d){this.setItems([{key:f,data:d}])}setItems(f){let d=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,A.$og)(b)?(0,A.$mg)(this.a[v])||(this.a[v]=void 0,d=!0):(this.a[v]=b,d=!0));d&&this.s()}removeItem(f){(0,A.$mg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Oe.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(d){this.m.error(d)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$HR=g;let u=class extends E.$Vc{constructor(f,d,v,b){super(),this.a=this.B(new g(d.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,d){return this.a.getItem(f,d)}};e.$IR=u,e.$IR=u=Se([se(1,O.$Ni),se(2,p.$bk),se(3,I.$bl)],u);class m extends u{setItem(f,d){this.a.setItem(f,d)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$JR=m}),define(ce[128],le([0,1,3,36,33]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=O,e.$xp=I;function A(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function O(p,c,g,u,m,w,f,d,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=d,$.sessionID=(0,E.$3g)()+Date.now(),$.commitHash=u,$.version=m,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$ec,$["common.nodeArch"]=g,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let k=0;const S=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const i=A(c);return i&&($["common.platformDetail"]=i),$}function I(p){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const g=c.toLowerCase();return p.some(u=>g===u)}}),define(ce[24],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,n.$Gi)("telemetryService"),e.$bm=(0,n.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var r;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(ce[221],le([0,1,26,27,8,43,12,9,3,66,7,92,23,115,96,14,28,24]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$2s=k,e.$3s=i,e.$4s=h,n=Pe(n),r=Pe(r);const $=new Map;async function k(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const P=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,D=new Map,L=2e4;function R(N,V,H,Y){const de=V.substring(N.length+1);return E.Promises.withAsyncBody(async q=>{let Q;Y.readdirCount++;try{Q=await m.Promises.readdir(V,{withFileTypes:!0})}catch{q();return}if(Y.count>=L){Y.count+=Q.length,Y.maxReached=!0,q();return}let U=Q.length;if(U===0){q();return}let Z=Q;Y.count+Q.length>L&&(Y.maxReached=!0,U=L-Y.count,Z=Q.slice(0,U)),Y.count+=Q.length;for(const W of Z)if(W.isDirectory()){if(H.includes(W.name)||await R(N,(0,I.$kc)(V,W.name),H,Y),--U===0){q();return}}else{const j=W.name.lastIndexOf(".");if(j>=0){const C=W.name.substring(j+1);C&&y.set(C,(y.get(C)??0)+1)}for(const C of P)C.relativePathPattern?.test(de)!==!1&&C.filePattern.test(W.name)&&D.set(C.tag,(D.get(C.tag)??0)+1);if(--U===0){q();return}}})}const T=E.Promises.withAsyncBody(async N=>{const V={count:0,maxReached:!1,readdirCount:0},H=new c.$ge(!0);await R(o,o,s,V);const Y=await h(o);N({configFiles:S(D),fileTypes:S(y),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:Y,totalScanTime:H.elapsed(),totalReaddirCount:V.readdirCount})});return $.set(a,T),T}function S(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function i(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/d.$Jl.GB).toFixed(2)}GB (${(r.freemem()/d.$Jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Tn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function h(o){try{const s=new Map,a=(0,I.$kc)(o,".vscode","launch.json"),l=await n.promises.readFile(a),P=[],y=(0,A.$Zn)(l.toString(),P);if(P.length)return console.log(`Unable to parse ${a}`),[];if((0,A.$8n)(y)==="object"&&y.configurations)for(const D of y.configurations){const L=D.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return S(s)}catch{return[]}}let t=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/d.$Jl.GB).toFixed(2)}GB (${(r.freemem()/d.$Jl.GB).toFixed(2)}GB free)`),p.$j||a.push(`Load (avg):       ${r.loadavg().map(P=>Math.round(P)).join(", ")}`),a.push(`VM:               ${Math.round(u.$Tn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,w.$1s)(s.mainPID),this.k(s)]).then(async l=>{let[P,y]=l,D=this.m(s,P);return a.forEach(L=>{if((0,f.$Vm)(L))D+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(D+=`

Remote: ${L.hostName}`,L.processes&&(D+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const R of Object.keys(L.workspaceMetadata)){const T=L.workspaceMetadata[R];let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),y+=`|    Folder (${R}): ${N}`,y+=this.h(T)}}}),{processInfo:D,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:P,os:y,cpus:D}=i(),L={os:y,memory:l,cpus:D,vmHint:P,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return p.$j||(L.load=`${r.loadavg().map(R=>Math.round(R)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,w.$1s)(s.mainPID).then(async P=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,P)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Vm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const D of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[D];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),l.push(`Folder (${D}): ${R}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let P=0;const y=(T,N)=>{const V=` ${T}(${N})`;P+V.length>60?(a.push(D),D="|                 ",P=D.length):P+=V.length,D+=V};let D="|      File types:";const L=10,R=s.fileTypes.length>L?L:s.fileTypes.length;for(let T=0;T<R;T++){const N=s.fileTypes[T];y(N.name,N.count)}if(a.push(D),s.configFiles.length>=0&&(D="|      Conf files:",P=0,s.configFiles.forEach(T=>{y(T.name,T.count)}),a.push(D)),s.launchConfigFiles.length>0){let T="|      Launch Configs:";s.launchConfigFiles.forEach(N=>{const V=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`;T+=V}),a.push(T)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(P=>{P.folderURIs.length===0||P.remoteAuthority||(a.push(`|  Window (${P.title})`),P.folderURIs.forEach(y=>{const D=g.URI.revive(y);if(D.scheme===O.Schemas.file){const L=D.fsPath;l.push(k(L,["node_modules",".git"]).then(R=>{let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),a.push(`|    Folder (${(0,I.$oc)(L)}): ${T}`),a.push(this.h(R))}).catch(R=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${R.toString()})`)}))}else a.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(P=>a.join(`
`)).catch(P=>`Unable to collect workspace stats: ${P}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:D})=>l.set(y,D));const P=[];return P.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,P,a,0),P.join(`
`)}n(s,a,l,P,y){const D=y===0;let L;D?L=P.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(P.pid)?L=a.get(P.pid):L=`${"  ".repeat(y)} ${P.name}`;const R=process.platform==="win32"?P.mem:r.totalmem()*(P.mem/100);l.push(`${P.load.toFixed(0).padStart(5," ")}	${(R/d.$Jl.MB).toFixed(0).padStart(6," ")}	${P.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(P.children)&&P.children.forEach(T=>this.n(s,a,l,T,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const P=g.URI.revive(l);if(P.scheme!==O.Schemas.file)continue;const y=P.fsPath;try{(await k(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=g.URI.revive(a);if(l.scheme!==O.Schemas.file)continue;const P=l.fsPath;try{const y=await k(P,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$5s=t,e.$5s=t=Se([se(0,b.$am),se(1,v.$uk)],t)}),define(ce[222],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=void 0;class n{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:p}){return this.b.forEach(c=>c.log(I,p)),Promise.resolve(null)}}e.$mhc=n;class r{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$nhc=r}),define(ce[57],le([0,1,37,11,74,128,24]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=g,e.$Gp=u,e.$Hp=m,e.$Ip=w,e.$Jp=d,e.$Kp=b,e.$Lp=$,e.$Mp=i;class I{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$yp=I;class p{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=p,e.$Ap=new p;class c{async publicLog(t,o,s){}async publicLogError(t,o,s){}}e.$Bp=c,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function g(h,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!h.enableTelemetry)}function u(h,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function m(h){const t=h.getValue(O.$jm),o=h.getValue(O.$km);if(h.getValue(O.$lm)===!1||o===!1)return O.TelemetryLevel.NONE;switch(t??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function w(h){const t={},o={},s={};v(h,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),t[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(t[a]=l)}return{properties:t,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(h){if(!h)return"none";const t=(0,E.$jn)(h);return f.has(t)?t:"other"}function v(h,t,o=0,s){if(h)for(const a of Object.getOwnPropertyNames(h)){const l=h[a],P=s?s+a:a;Array.isArray(l)?t[P]=(0,n.$ko)(l):l instanceof Date?t[P]=l.toISOString():(0,r.$hg)(l)?o<2?v(l,t,o+1,P+"."):t[P]=(0,n.$ko)(l):t[P]=l}}function b(h,t){const o=h.msftInternalDomains||[],s=t.getValue("telemetry.internalTesting");return(0,A.$xp)(o)||s}function $(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function k(h,t){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let o=h;const s=[];for(const y of t)for(;;){const D=y.exec(h);if(!D)break;s.push([D.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const y=l.exec(h);if(!y)break;const D=s.some(([L,R])=>y.index<R&&L<l.lastIndex);!a.test(y[0])&&!D&&(o+=h.substring(P,y.index)+"<REDACTED: user-file-path>",P=l.lastIndex)}return P<h.length&&(o+=h.substr(P)),o}function S(h){if(!h)return h;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(h))return`<REDACTED: ${o.label}>`;return h}function i(h,t){return(0,n.$ho)(h,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=k(s,t);for(const a of t)s=s.replace(a,"");return s=S(s),s}})}}),define(ce[129],le([0,1,25,126,85,3,7,15,36,57]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=g,e.$Pp=f,e.$Qp=d,e.$Rp=v,e.$Sp=b,e.$Tp=$,e.$Up=k,e.$Vp=S,e.$Xp=i,e.$Yp=t;function g(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$Bf)(o.id,s.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,a,l)}static parse(s){const a=u.exec(s);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=E.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?g(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Op=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function d(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(d(o??E.$on,s))}function $(o,s){const a=[],l=P=>{for(const y of a)if(y.some(D=>g(s(D),s(P))))return y;return null};for(const P of o){const y=l(P);y?y.push(P):a.push([P])}return a}function k(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function S(o){return{id:new c.$yp(o.identifier.id),name:new c.$yp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Wp=new E.$sn("pprice.better-merge");function i(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const P=l.shift();if(P&&a.every(y=>!g(y.identifier,{id:P}))){const y=o.filter(D=>g(D.identifier,{id:P}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function h(o,s){if(!A.$l)return!1;let a;try{a=(await o.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){s.debug("Error while getting the os-release file.",(0,I.$0)(P))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,s){const a=await h(o,s),l=(0,r.$ip)(a?"alpine":A.$v,p.$fc);return s.debug("ComputeTargetPlatform:",l),l}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[223],le([0,1,2,37,3,25,10,16,56,72,28,45,24,57]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0,c=Ge(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,k){this.k=$,this.l=k,this.d={},this.i=new n.$Uc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,A.$if)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$if)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(m.$jm)||S.affectsConfiguration(m.$lm)||S.affectsConfiguration(m.$km))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Hp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const k=$.usage?m.TelemetryLevel.USAGE:$.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;b=Math.min(b,k)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,k){this.g<$||(k=(0,r.$io)(k,this.d),k=(0,w.$Mp)(k,this.j),k=(0,r.$io)(k,this.c),this.b.forEach(S=>S.log(b,k)))}publicLog(b,$){this.n(b,m.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,m.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$ks=f,e.$ks=f=Se([se(1,I.$aj),se(2,g.$uk)],f);function d(){const v=(0,O.localize)(2059,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,O.localize)(2061,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,O.localize)(2060,null,"https://aka.ms/vscode-telemetry"),$=E.$p?"":(0,O.localize)(2062,null),k=(0,O.localize)(2063,null),S=(0,O.localize)(2064,null),i=(0,O.localize)(2065,null),h=(0,O.localize)(2066,null),t=`
|       | ${k} | ${S} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,O.localize)(2067,null);return`
${v} ${b} ${$}

&nbsp;

${h}
${t}

&nbsp;

${o}
`}u.$so.as(p.$xo.Configuration).registerConfiguration({id:m.$im,order:1,type:"object",title:(0,O.localize)(2068,null),properties:{[m.$jm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(2069,null),(0,O.localize)(2070,null),(0,O.localize)(2071,null),(0,O.localize)(2072,null)],markdownDescription:d(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$so.as(p.$xo.Configuration).registerConfiguration({id:m.$im,order:110,type:"object",title:(0,O.localize)(2073,null),properties:{[m.$lm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,O.localize)(2075,null,c.default.nameLong,c.default.privacyStatementUrl):(0,O.localize)(2074,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(2076,null,`\`#${m.$jm}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[224],le([0,1,3,92,24]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=A,e.$Phc=O,e.$Qhc=I;async function A(p,c){let g=p.getItem(E.$fm);return(typeof g!="string"||n.$k&&g==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(g=await(0,r.$Un)(c.error.bind(c))),g}async function O(p,c){let g=p.getItem(E.$gm);return typeof g!="string"&&(g=await(0,r.$Vn)(c.error.bind(c))),g}async function I(p,c){let g=p.getItem(E.$hm);return typeof g!="string"&&(g=await(0,r.$Wn)(c.error.bind(c))),g}}),define(ce[225],le([0,1,24,224]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=E,e.$Shc=A,e.$Thc=O;async function E(I,p){const c=await(0,r.$Ohc)(I,p);return I.setItem(n.$fm,c),c}async function A(I,p){const c=await(0,r.$Phc)(I,p);return I.setItem(n.$gm,c),c}async function O(I,p){const c=await(0,r.$Qhc)(I,p);return I.setItem(n.$hm,c),c}}),define(ce[130],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ce[226],le([0,1,3,130]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((u,m)=>{this.d(u,m);const w=u.map.entries();let f=w.next();for(;!f.done;){const d=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:m,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(g,u,m){let w;n.$j&&(w={},Object.keys(g).forEach(f=>w[f.toLowerCase()]=f));for(const[f,d]of this.getVariableMap(u)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of d){const $=m?await m(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:g[v]=(g[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:g[v]=$+(g[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:g[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const k=`VSCODE_ENV_${E.get(b.type)}`;g[k]=(g[k]?g[k]+":":"")+f+"="+this.c($)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,u){const m=new Map,w=new Map,f=new Map;if(g.getVariableMap(u).forEach((d,v)=>{const b=this.getVariableMap(u).get(v),$=I(d,b);$&&m.set(v,$)}),this.getVariableMap(u).forEach((d,v)=>{const b=g.getVariableMap(u).get(v),$=I(d,b);$&&f.set(v,$)}),this.getVariableMap(u).forEach((d,v)=>{const b=g.getVariableMap(u).get(v),$=p(d,b);$&&w.set(v,$)}),!(m.size===0&&w.size===0&&f.size===0))return{added:m,changed:w,removed:f}}getVariableMap(g){const u=new Map;for(const m of this.a.values()){const w=m.filter(f=>O(f,g));w.length>0&&u.set(w[0].variable,w)}return u}getDescriptionMap(g){const u=new Map;for(const m of this.b.values()){const w=m.filter(f=>O(f,g,!0));for(const f of w)u.set(f.extensionIdentifier,f.description)}return u}d(g,u){if(!g.descriptionMap)return;const m=g.descriptionMap.entries();let w=m.next();for(;!w.done;){const f=w.value[1],d=w.value[0];let v=this.b.get(d);v||(v=[],this.b.set(d,v));const b={extensionIdentifier:u,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=m.next()}}}e.$Os=A;function O(c,g,u=!1){return c.scope?!!(c.scope.workspaceFolder&&g?.workspaceFolder&&c.scope.workspaceFolder.index===g.workspaceFolder.index):u?g===c.scope:!0}function I(c,g){if(!g)return c;const u=new Set;g.forEach(w=>u.add(w.extensionIdentifier));const m=[];return c.forEach(w=>{u.has(w.extensionIdentifier)||m.push(w)}),m.length===0?void 0:m}function p(c,g){if(!g)return;const u=new Map;g.forEach(w=>u.set(w.extensionIdentifier,w));const m=[];return c.forEach(w=>{const f=u.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&m.push(f)}),m.length===0?void 0:m}}),define(ce[227],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=n,e.$Js=r,e.$Ks=E,e.$Ls=A,e.$Ms=O,e.$Ns=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function E(p){return new Map(p)}function A(p){return new Map(p??[])}function O(p){return Array.from(p.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(p){return new Map(p.map(c=>[c[0],{map:E(c[1]),descriptionMap:A(c[2])}]))}}),define(ce[228],le([0,1,8,22,4,2,5]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;let I=class extends A.$Vc{constructor(c,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$me),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,A.$Tc)(()=>{for(const u of this.f.values())(0,A.$Qc)(u)}))}createRequest(c){return new Promise((g,u)=>{const m=++this.a;this.c.set(m,g),this.g.fire({requestId:m,...c});const w=new r.$xe;(0,n.$Hh)(this.b,w.token).then(()=>u(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,A.$Tc)(()=>w.cancel())])})}acceptReply(c,g){const u=this.c.get(c);u?(this.c.delete(c),(0,A.$Qc)(this.f.get(c)||[]),this.f.delete(c),u(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$zs=I,e.$zs=I=Se([se(1,O.$bk)],I)}),define(ce[75],le([0,1,6,122,45]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ss=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$rs=void 0,e.$rs=new r.$Xj("terminalTabFocusMode",!1,!0);var A;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var O;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var g;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$ss=(0,n.$Gi)("ptyService");var m;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var w;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(i){i.TerminalView="view",i.Editor="editor"})(f||(e.TerminalLocationString=f={}));var d;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var v;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var k;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$ts={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(h){const t=this.b(h.remoteAuthority);if(this.a.has(t))throw new Error(`A terminal backend with remote authority '${t}' was already registered.`);this.a.set(t,h)}getTerminalBackend(h){return this.a.get(this.b(h))}b(h){return h?.toLowerCase()??""}}E.$so.add(e.$ts.Backend,new S),e.$us=(0,n.$Gi)("localPtyService"),e.$vs=(0,n.$Gi)("terminalLogService")}),define(ce[229],le([0,1,80,7,10,110]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=O,e.$Bs=c,e.$Cs=g,e.$Ds=u;function O(m,w){const f=[{name:null,description:(0,E.localize)(2109,null)}];return f.push(...m.map(d=>({name:d.profileName,description:I(d)}))),w&&f.push(...w.map(d=>({name:d.title,description:p(d)}))),{values:f.map(d=>d.name),markdownDescriptions:f.map(d=>d.description)}}function I(m){let w=`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$6j.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?w+=`
- args: "${m.args}"`:w+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(w+=`
- overrideName: ${m.overrideName}`),m.color&&(w+=`
- color: ${m.color}`),m.env&&(w+=`
- env: ${JSON.stringify(m.env)}`),w}function p(m){return`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$6j.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function c(m,w){if(!m&&!w)return!0;if(typeof m=="string"&&typeof w=="string")return m===w;if(Array.isArray(m)&&Array.isArray(w)){if(m.length!==w.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==w[f])return!1;return!0}return!1}function g(m,w){if(!m&&!w)return!0;if(!m||!w)return!1;if(A.ThemeIcon.isThemeIcon(m)&&A.ThemeIcon.isThemeIcon(w))return m.id===w.id&&m.color===w.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof w=="object"&&"light"in w&&"dark"in w){const f=m,d=w;if((r.URI.isUri(f.light)||u(f.light))&&(r.URI.isUri(f.dark)||u(f.dark))&&(r.URI.isUri(d.light)||u(d.light))&&(r.URI.isUri(d.dark)||u(d.dark)))return f.light.path===d.light.path&&f.dark.path===d.dark.path}if(r.URI.isUri(m)&&r.URI.isUri(w)||u(m)||u(w)){const f=m,d=w;return f.path===d.path&&f.scheme===d.scheme}return!1}function u(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}}),define(ce[230],le([0,1,80,3,10,56,45,75,229]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.$Es=void 0,e.$Gs=f,e.$Hs=v,e.$Es={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Fs={type:"string",enum:Array.from((0,n.$4j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$4j)(),b=>`$(${b.id})`)};const c={args:{description:(0,E.localize)(2078,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(2079,null),type:"boolean"},icon:{description:(0,E.localize)(2080,null),...e.$Fs},color:{description:(0,E.localize)(2081,null),...e.$Es},env:{markdownDescription:(0,E.localize)(2082,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2083,null),type:["string","array"],items:{type:"string"}},...c}},u={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2084,null),type:["string"],items:{type:"string"}},...c}};function m(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,E.localize)(2085,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,E.localize)(2086,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2087,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2088,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2089,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:m(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(2090,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2091,null),type:"string"},id:{description:(0,E.localize)(2092,null),type:"string"},title:{description:(0,E.localize)(2093,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:m(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2094,null),type:"string"},id:{description:(0,E.localize)(2095,null),type:"string"},title:{description:(0,E.localize)(2096,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:m(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2097,null),type:"string"},id:{description:(0,E.localize)(2098,null),type:"string"},title:{description:(0,E.localize)(2099,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(2100,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:A.ConfigurationScope.APPLICATION,description:(0,E.localize)(2101,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:A.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(2102,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:A.ConfigurationScope.APPLICATION,description:(0,E.localize)(2103,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(2104,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){O.$so.as(A.$xo.Configuration).registerConfiguration(w),v()}let d;function v(b,$){const k=O.$so.as(A.$xo.Configuration);let S;b&&(S=(0,p.$As)(b?.profiles,$));const i=d;d={id:"terminal",order:100,title:(0,E.localize)(2105,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2106,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2107,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2108,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},k.updateConfigurations({add:[d],remove:i?[i]:[]})}}),define(ce[231],le([0,1,27,12,37,9,3,36,25,11,23,130,227,226]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=f,e.$Qs=d,e.$Rs=v,n=Pe(n),A=Pe(A),I=Pe(I),g=Pe(g);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let P=0;return l&&l.length===4&&(P=parseInt(l[3])),P}async function d(l,P,y,D=I.env,L=g.Promises.exists){if(A.$jc(l))return await L(l)?l:void 0;if(P===void 0&&(P=I.cwd()),A.$nc(l)!=="."){const V=A.$kc(P,l);return await L(V)?V:void 0}const T=(0,E.$mo)(D,"PATH");if(y===void 0&&(0,c.$fg)(T)&&(y=T.split(A.$uc)),y===void 0||y.length===0){const V=A.$kc(P,l);return await L(V)?V:void 0}for(const V of y){let H;if(A.$jc(V)?H=A.$kc(V,l):H=A.$kc(P,V,l),await L(H))return H;if(O.$j){let Y=H+".com";if(await L(Y)||(Y=H+".exe",await L(Y)))return Y}}const N=A.$kc(P,l);return await L(N)?N:void 0}function v(l,P,y,D,L){const R=O.$j&&(!P.windowsEnableConpty||f()<18309);if(!P.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||R)return;const T=l.args,N=I.$ec==="win32"?A.$oc(l.executable).toLowerCase():A.$oc(l.executable),V=A.$nc(r.$1g.asFileUri("").fsPath);let H;const Y={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(Y.VSCODE_NONCE=P.shellIntegration.nonce),O.$j){if(N==="pwsh.exe"||N==="powershell.exe")return!T||s(T)?H=k.get($.WindowsPwsh):o(T)&&(H=k.get($.WindowsPwshLogin)),H?(H=[...H],H[H.length-1]=(0,p.$ef)(H[H.length-1],V,""),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:H,envMixin:Y}):void 0;if(N==="bash.exe")return!T||T.length===0?H=k.get($.Bash):a(T)&&(Y.VSCODE_SHELL_LOGIN="1",b(P,Y),H=k.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,p.$ef)(H[H.length-1],V),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(N){case"bash":return!T||T.length===0?H=k.get($.Bash):a(T)&&(Y.VSCODE_SHELL_LOGIN="1",b(P,Y),H=k.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,p.$ef)(H[H.length-1],V),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;case"fish":{const de=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",q=A.$kc(V,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${de}:${q}`,b(P,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!T||s(T)?H=k.get($.Pwsh):o(T)&&(H=k.get($.PwshLogin)),H?(P.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),H=[...H],H[H.length-1]=(0,p.$ef)(H[H.length-1],V,""),Y.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:Y}):void 0;case"zsh":{if(!T||T.length===0?H=k.get($.Zsh):a(T)?(H=k.get($.ZshLogin),b(P,Y)):(T===k.get($.Zsh)||T===k.get($.ZshLogin))&&(H=T),!H)return;H=[...H],H[H.length-1]=(0,p.$ef)(H[H.length-1],V);let de;try{de=n.userInfo().username}catch{de="unknown"}const q=A.$kc(n.tmpdir(),`${de}-${L.applicationName}-zsh`);Y.ZDOTDIR=q;const Q=y?.ZDOTDIR??n.homedir()??"~";Y.USER_ZDOTDIR=Q;const U=[];return U.push({source:A.$kc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$kc(q,".zshrc")}),U.push({source:A.$kc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$kc(q,".zprofile")}),U.push({source:A.$kc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$kc(q,".zshenv")}),U.push({source:A.$kc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$kc(q,".zlogin")}),{newArgs:H,envMixin:Y,filesToCopy:U}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,P){if(O.$k&&l.environmentVariableCollections){const y=(0,m.$Ns)(l.environmentVariableCollections),L=new w.$Os(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),R=[];if(L)for(const T of L)T.type===u.EnvironmentVariableMutatorType.Prepend&&R.push(T.value);R.length>0&&(P.VSCODE_PATH_PREFIX=R.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const k=new Map;k.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),k.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),k.set($.Zsh,["-i"]),k.set($.ZshLogin,["-il"]),k.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],i=["--login","-l"],h=["-i","--interactive"],t=["-nol","-nologo"];function o(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(t.includes(l[0].toLowerCase())||t.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?t.includes(l.toLowerCase()):l.length===0||l?.length===1&&t.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(P=>!h.includes(P.toLowerCase()))),l==="string"&&i.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&i.includes(l[0].toLowerCase())}}),define(ce[232],le([0,1,26,48,80,9,3,11,23,114,75,231,121]),function(x,e,n,r,E,A,O,I,p,c,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=v,n=Pe(n),r=Pe(r),p=Pe(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,d=!0;function v(y,D,L,R,T=process.env,N,V,H,Y){return N=N||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},O.$j?b(L,N,T,V,R.getValue(g.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:R.getValue(g.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:R.getValue(g.TerminalSettingId.DefaultProfileWindows),Y,H):a(N,V,L,y&&typeof y=="object"?{...y}:R.getValue(O.$l?g.TerminalSettingId.ProfilesLinux:g.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:R.getValue(O.$l?g.TerminalSettingId.DefaultProfileLinux:g.TerminalSettingId.DefaultProfileMacOs),Y,H,T)}async function b(y,D,L,R,T,N,V,H,Y){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let Q=!1;(0,u.$Ps)()>=16299&&(Q=!0),await i(H);const U=new Map;if(y){U.set("PowerShell",{source:g.ProfileSource.Pwsh,icon:E.$6j.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$6j.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:g.ProfileSource.GitBash,isAutoDetected:!0}),U.set("Command Prompt",{path:`${q}\\cmd.exe`,icon:E.$6j.terminalCmd,isAutoDetected:!0}),U.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),U.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$6j.terminalBash,isAutoDetected:!0});const W=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;U.set("Cmder",{path:`${q}\\cmd.exe`,args:["/K",W],requiresPath:process.env.CMDER_ROOT?W:{path:W,isUnsafe:!0},isAutoDetected:!0})}l(N,U);const Z=await $(U.entries(),V,D,L,R,Y);if(y&&T)try{const W=await o(`${q}\\${Q?"wsl":"bash"}.exe`,V);for(const j of W)(!N||!(j.profileName in N))&&Z.push(j)}catch{d&&(R?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return Z}async function $(y,D,L,R=process.env,T,N){const V=[];for(const[H,Y]of y)V.push(k(H,Y,D,L,R,T,N));return(await Promise.all(V)).filter(H=>!!H)}async function k(y,D,L,R,T=process.env,N,V){if(D===null)return;let H,Y,de;if("source"in D&&!("path"in D)){const Z=f?.get(D.source);if(!Z)return;H=Z.paths,Y=D.args||Z.args,D.icon?de=S(D.icon):Z.icon&&(de=Z.icon)}else H=Array.isArray(D.path)?D.path:[D.path],Y=O.$j||Array.isArray(D.args)?D.args:void 0,de=S(D.icon);let q;if(V){const Z=H.map(j=>typeof j=="string"?j:j.path),W=await V(Z);q=new Array(H.length);for(let j=0;j<H.length;j++)typeof H[j]=="string"?q[j]=W[j]:q[j]={path:W[j],isUnsafe:!0}}else q=H.slice();let Q;if(D.requiresPath){let Z;if((0,I.$fg)(D.requiresPath)?Z=D.requiresPath:(Z=D.requiresPath.path,D.requiresPath.isUnsafe&&(Q=Z)),!await R.existsFile(Z))return}const U=await P(y,L,q,R,T,Y,D.env,D.overrideName,D.isAutoDetected,Q);if(!U){N?.debug("Terminal profile not validated",y,H);return}return U.isAutoDetected=D.isAutoDetected,U.icon=de,U.color=D.color,U}function S(y){return typeof y=="string"?{id:y}:y}async function i(y){if(f&&!y)return;const[D,L]=await Promise.all([h(),y||t()]);f=new Map,f.set(g.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),f.set(g.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:E.$6j.terminalPowershell})}async function h(){const y=new Set,D=await(0,u.$Qs)("git.exe");if(D){const T=(0,m.dirname)(D);y.add((0,m.resolve)(T,"../.."))}function L(T,N){N&&T.add(N)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const R=[];for(const T of y)R.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function t(){const y=[];for await(const D of(0,c.$xm)())y.push(D.exePath);return y}async function o(y,D){const L=[],R=await new Promise((V,H)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Y,de)=>{if(Y)return H("Problem occurred when getting wsl distros");V(de)})});if(!R)return[];const T=new RegExp(/[\r?\n]/),N=R.split(T).filter(V=>V.trim().length>0&&V!=="");for(const V of N){if(V===""||V.startsWith("docker-desktop"))continue;const H=`${V} (WSL)`,Y={profileName:H,path:y,args:["-d",`${V}`],isDefault:H===D,icon:s(V),isAutoDetected:!1};L.push(Y)}return L}function s(y){return y.includes("Ubuntu")?E.$6j.terminalUbuntu:y.includes("Debian")?E.$6j.terminalDebian:E.$6j.terminalLinux}async function a(y,D,L,R,T,N,V,H){const Y=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const de=(await y.readFile(w.UnixShellsPath)).toString(),q=(N||de.split(`
`)).map(U=>{const Z=U.indexOf("#");return Z===-1?U:U.substring(0,Z)}).filter(U=>U.trim().length>0),Q=new Map;for(const U of q){let Z=(0,A.$oc)(U),W=Q.get(Z)||0;W++,W>1&&(Z=`${Z} (${W})`),Q.set(Z,W),Y.set(Z,{path:U,isAutoDetected:!0})}}return l(R,Y),await $(Y.entries(),T,y,H,D,V)}function l(y,D){if(y)for(const[L,R]of Object.entries(y))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?D.delete(L):(R.icon=R.icon||D.get(L)?.icon,D.set(L,R))}async function P(y,D,L,R,T,N,V,H,Y,de){if(L.length===0)return Promise.resolve(void 0);const q=L.shift();if(q==="")return P(y,D,L,R,T,N,V,H,Y);const Q=typeof q!="string"&&q.isUnsafe,U=typeof q=="string"?q:q.path,Z={profileName:y,path:U,args:N,env:V,overrideName:H,isAutoDetected:Y,isDefault:y===D,isUnsafePath:Q,requiresUnsafePath:de};if((0,A.$oc)(U)===U){const j=T.PATH?T.PATH.split(A.$uc):void 0,C=await(0,u.$Qs)(U,void 0,j,void 0,R.existsFile);return C?(Z.path=C,Z.isFromPath=!0,Z):P(y,D,L,R,T,N)}return await R.existsFile((0,A.$ic)(U))?Z:P(y,D,L,R,T,N,V,H,Y)}}),define(ce[233],le([0,1,4,2,3,44,16,5,195,100,228,75,230,232,116,66]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(k,S,i,h){super(),this.M=k,this.N=S,this.O=i,this.P=h,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$me),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$me),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$me),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$me),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$me),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$me),this.onProcessData=this.D.event,this.F=this.B(new n.$me),this.onProcessReady=this.F.event,this.G=this.B(new n.$me),this.onProcessReplay=this.G.event,this.H=this.B(new n.$me),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$me),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$me),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$me),this.onProcessExit=this.L.event,(0,m.$Gs)(),this.B(this.M),this.B((0,r.$Tc)(()=>this.W())),this.j=this.B(new g.$zs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(u.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$j)return process.env;try{return await(0,c.$Sm)(this.N,this.O,{_:[]},process.env)}catch(k){return this.O.error("ptyHost was unable to resolve shell environment",k),{}}}U(){const k=this.M.start(),S=k.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(S.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(k.onDidProcessExit(t=>{this.u.fire(t.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const h=A.ProxyChannel.toService(S.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(h.onProcessData(t=>this.D.fire(t))),this.B(h.onProcessReady(t=>this.F.fire(t))),this.B(h.onProcessExit(t=>this.L.fire(t))),this.B(h.onDidChangeProperty(t=>this.J.fire(t))),this.B(h.onProcessReplay(t=>this.G.fire(t))),this.B(h.onProcessOrphanQuestion(t=>this.H.fire(t))),this.B(h.onDidRequestDetach(t=>this.I.fire(t))),this.B(new p.$ys(this.P,S.getChannel(u.TerminalIpcChannels.Logger))),this.a=k,this.b=h,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[k,h]}async createProcess(k,S,i,h,t,o,s,a,l,P,y){const D=setTimeout(()=>this.$(),u.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(k,S,i,h,t,o,s,a,l,P,y);return clearTimeout(D),L}updateTitle(k,S,i){return this.f.updateTitle(k,S,i)}updateIcon(k,S,i,h){return this.f.updateIcon(k,S,i,h)}attachToProcess(k){return this.f.attachToProcess(k)}detachFromProcess(k,S){return this.f.detachFromProcess(k,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(k){return this.f.start(k)}shutdown(k,S){return this.f.shutdown(k,S)}input(k,S){return this.f.input(k,S)}processBinary(k,S){return this.f.processBinary(k,S)}resize(k,S,i){return this.f.resize(k,S,i)}clearBuffer(k){return this.f.clearBuffer(k)}acknowledgeDataEvent(k,S){return this.f.acknowledgeDataEvent(k,S)}setUnicodeVersion(k,S){return this.f.setUnicodeVersion(k,S)}getInitialCwd(k){return this.f.getInitialCwd(k)}getCwd(k){return this.f.getCwd(k)}async getLatency(){const k=new d.$ge,S=await this.f.getLatency();return k.stop(),[{label:"ptyhostservice<->ptyhost",latency:k.elapsed()},...S]}orphanQuestionReply(k){return this.f.orphanQuestionReply(k)}installAutoReply(k,S){return this.f.installAutoReply(k,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(k){return this.f.uninstallAutoReply(k)}getDefaultSystemShell(k){return this.g?.getDefaultSystemShell(k)??(0,f.$Bm)(k??E.OS,process.env)}async getProfiles(k,S,i,h=!1){const t=await this.S();return(0,w.$Ss)(S,i,h,this.N,t,void 0,this.O,this.bb.bind(this,k))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(k,S){return this.f.getWslPath(k,S)}getRevivedPtyNewId(k,S){return this.f.getRevivedPtyNewId(k,S)}setTerminalLayoutInfo(k){return this.f.setTerminalLayoutInfo(k)}async getTerminalLayoutInfo(k){return this.g?.getTerminalLayoutInfo(k)}async requestDetachInstance(k,S){return this.f.requestDetachInstance(k,S)}async acceptDetachInstanceReply(k,S){return this.f.acceptDetachInstanceReply(k,S)}async freePortKillProcess(k){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(k)}async serializeTerminalState(k){return this.f.serializeTerminalState(k)}async reviveTerminalProcesses(k,S,i){return this.f.reviveTerminalProcesses(k,S,i)}async refreshProperty(k,S){return this.f.refreshProperty(k,S)}async updateProperty(k,S,i){return this.f.updateProperty(k,S,i)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(k){this.ab(),this.s=setTimeout(()=>this.Y(),k?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(k,S){return this.j.createRequest({workspaceId:k,originalText:S})}async acceptPtyHostResolvedVariables(k,S){this.j.acceptReply(k,S)}};e.$Ts=b,e.$Ts=b=Se([se(1,O.$aj),se(2,I.$bk),se(3,I.$ck)],b)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[76],le([0,1,13,4,2,3,16,6,34]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=void 0,n=Ge(n);const c="#FFFFFF",g="#1E1E1E",u="#000000",m="#FFFFFF",w="theme",f="themeBackground",d="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$agc=(0,I.$Gi)("themeMainService");let b=class extends E.$Vc{constructor(k,S){super(),this.b=k,this.c=S,this.a=this.B(new r.$me),this.onDidChangeColorScheme=this.a.event,A.$l||this.B(this.c.onDidChangeConfiguration(i=>{(i.affectsConfiguration(v.SYSTEM_COLOR_THEME)||i.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(A.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.$j){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.$k){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.$l&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const k=this.getColorScheme();if(k.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return k.dark?u:m;let S=this.b.getItem(f,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=u;break;case"hc-light":S=m;break;default:S=g}return A.$k&&S.toUpperCase()===g&&(S="#171717"),S}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(k,S){this.b.setItems([{key:w,data:S.baseTheme},{key:f,data:S.colorInfo.background},{key:d,data:S}]),typeof k=="number"&&this.h(k,S),this.f()}h(k,S){for(const i of n.default.BrowserWindow.getAllWindows())if(i.id===k){i.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};e.$bgc=b,e.$bgc=b=Se([se(0,p.$GR),se(1,O.$aj)],b)}),define(ce[131],le([0,1,4,2,3,7,16,6,5]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Pw=e.$Nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Jw=e.$Iw=void 0,e.$Kw=u,e.$Lw=w,e.$Mw=f,e.$Ow=d,e.$Qw=v,e.$Rw=b,e.$Iw=(0,I.$Gi)("tunnelService"),e.$Jw=(0,I.$Gi)("sharedTunnelsService");var c;(function(S){S.Http="http",S.Https="https"})(c||(e.TunnelProtocol=c={}));var g;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(g||(e.TunnelPrivacyId=g={}));function u(S){return!!S.forwardPort}var m;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function w(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(i)return{address:i[1],port:+i[2]}}function f(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const i=S.query.split("&");for(const h of i){const t=h.split("=")[1];if(/^https?:/.exec(t)){const o=w(A.URI.parse(t));if(o)return o}}}e.$Nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(S){return e.$Nw.indexOf(S)>=0}e.$Pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(S){return e.$Pw.indexOf(S)>=0}function b(S,i,h,t){if(h===E.OperatingSystem.Windows)return!1;if(h===E.OperatingSystem.Macintosh&&v(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return S<1024}class ${constructor(i,h,t){this.remoteAddress=i,this.localAddress=h,this.b=t,this.a=new n.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sw=$;let k=class extends r.$Vc{constructor(i,h){super(),this.r=i,this.s=h,this.a=new n.$me,this.onTunnelOpened=this.a.event,this.b=new n.$me,this.onTunnelClosed=this.b.event,this.c=new n.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],h=Array.from(this.f.values());for(const t of h){const o=Array.from(t.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:h}of i.values())await h.then(t=>typeof t!="string"?t?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,h,t,o,s){this.z(i,h,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:h,localAddress:t,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,h){(v(i)||d(i))&&(i=e.$Nw[0]);const t=this.D(i,h);if(t)return++t.refcount,t.value}openTunnel(i,h,t,o,s,a=!1,l,P){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${t} on local port ${s}.`);const y=this.g??i;if(!y)return;if(h||(h="localhost"),o||(o=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(y,h,t,o,s,a,l,P);return D?D.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const R=this.w(L);return(L.tunnelRemoteHost!==h||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(R),R}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const h=this.f.get(i.tunnelRemoteHost);if(h){const t=h.get(i.tunnelRemotePort);t&&(t.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,t))}}}}async y(i,h,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${h}.`);const o=t.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(h),o}}async closeTunnel(i,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${h} `);const t=this.f.get(i);if(t&&t.has(h)){const o=t.get(h);o.refcount=0,await this.y(i,h,o)}}z(i,h,t){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(h,{refcount:1,value:t})}async C(i,h){const t=this.f.get(i);if(t){const o=t.get(h),s=o?await o.value:void 0;(!s||typeof s=="string")&&t.delete(h),t.size===0&&this.f.delete(i)}}D(i,h){const t=[i];d(i)?(t.push(...e.$Nw),t.push(...e.$Pw)):v(i)&&t.push(...e.$Pw);const o=t.map(s=>this.f.get(s));for(const s of o){const a=s?.get(h);if(a)return a}}canTunnel(i){return!!w(i)}G(i,h,t,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${t} on local port ${o}.`);const P=t;this.n.add(P);const y=o===void 0?t:o,D={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:h,port:t},localAddressPort:o,privacy:a,public:a?a!==g.Private:void 0,protocol:l},R=i.forwardPort(L,D);return R?(this.z(h,t,R),R.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(P)})):this.n.delete(P),R}};e.$Tw=k,e.$Tw=k=Se([se(0,p.$bk),se(1,O.$aj)],k)}),define(ce[50],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZY=e.$YY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(r||(e.StateType=r={}));var E;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(E||(e.UpdateType=E={}));var A;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.$YY={Uninitialized:{type:r.Uninitialized},Disabled:O=>({type:r.Disabled,reason:O}),Idle:(O,I)=>({type:r.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:r.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:r.AvailableForDownload,update:O}),Downloading:{type:r.Downloading},Downloaded:O=>({type:r.Downloaded,update:O}),Updating:O=>({type:r.Updating,update:O}),Ready:O=>({type:r.Ready,update:O})},e.$ZY=(0,n.$Gi)("updateService")}),define(ce[234],le([0,1,3,10,56,45]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.$so.as(E.$xo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(2418,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2419,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2420,null),(0,r.localize)(2421,null),(0,r.localize)(2422,null),(0,r.localize)(2423,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2424,null),deprecationMessage:(0,r.localize)(2425,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,title:(0,r.localize)(2426,null),description:(0,r.localize)(2427,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(2428,null),tags:["usesOnlineServices"]}}})}),define(ce[235],le([0,1,4,50]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0;class E{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${p}`)}}e.$ohc=E;class A{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$me,this.onStateChange=this.a.event,this.b=r.$YY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$phc=A}),define(ce[41],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,n.$Gi)("IUriIdentityService")}),define(ce[236],le([0,1,41,175,14,18,146,4,2]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let g=class{constructor(m){this.g=m,this.c=new p.$Uc,this.f=2**16;const w=new Map,f=d=>{let v=w.get(d.scheme);return v===void 0&&(v=m.hasProvider(d)&&!this.g.hasCapability(d,E.FileSystemProviderCapabilities.PathCaseSensitive),w.set(d.scheme,v)),v};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(d=>{w.delete(d.scheme)})),this.extUri=new A.$9g(f),this.d=new O.$Ws((d,v)=>this.extUri.compare(d,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$ih)(m));const w=this.d.get(m);return w?w.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((f,d)=>f[1].time<d[1].time?1:f[1].time>d[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(m[f][0],m[f][1].touch())}};e.$Xs=g,e.$Xs=g=Se([se(0,E.$bl)],g),(0,r.$Us)(n.$Ll,g,r.InstantiationType.Delayed)}),define(ce[132],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PY=void 0,e.$PY=(0,n.$Gi)("urlService")}),define(ce[237],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.$whc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${p}`)}}e.$whc=r;class E{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$xhc=E;class A{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,c,g){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(c)&&c.length>0){const u=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const m=/\bwindowId=(\d+)/.exec(u.query);if(m){const w=m[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,u.toString(!0));const f=new RegExp(`window:${w}`),d=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(d)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),d;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,c,g)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$yhc=A}),define(ce[238],le([0,1,8,2,7,28]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RY=e.$QY=void 0;class O extends r.$Vc{constructor(){super(...arguments),this.a=new Set}open(c,g){const u=[...this.a.values()];return(0,n.$Kh)(u.map(m=>()=>m.handleURL(c,g)),void 0,!1).then(m=>m||!1)}registerHandler(c){return this.a.add(c),(0,r.$Tc)(()=>this.a.delete(c))}}e.$QY=O;let I=class extends O{constructor(c){super(),this.b=c}create(c){let{authority:g,path:u,query:m,fragment:w}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&u&&u.indexOf("/")!==0&&(u=`/${u}`),E.URI.from({scheme:this.b.urlProtocol,authority:g,path:u,query:m,fragment:w})}};e.$RY=I,e.$RY=I=Se([se(0,A.$uk)],I)}),define(ce[239],le([0,1,13,8,4,2,3,7]),function(x,e,n,r,E,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class p extends A.$Vc{constructor(g,u,m,w,f,d){if(super(),this.c=u,this.f=d,this.a=[],this.b=0,g&&(d.trace("ElectronURLListener initialUrisToHandle:",g.map($=>$.originalUrl)),this.a=g),O.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=E.Event.map(E.Event.fromNodeEventEmitter(n.app,"open-url",($,k)=>({event:$,url:k})),({event:$,url:k})=>($.preventDefault(),k));this.B(v($=>{const k=this.g($);k&&this.c.open(k,{originalUrl:$})})),m.getWindows().filter($=>$.isReady).length>0?(d.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(d.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(E.Event.once(m.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return I.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const u of this.a)await this.c.open(u.uri,{originalUrl:u.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),g.push(u));g.length!==0&&(this.a=g,(0,r.$Ih)(()=>this.h(),500,this.q))}}e.$zhc=p}),define(ce[240],le([0,1,4,2,14,60,31]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class I extends r.$Vc{constructor(c,g,u,m,w,f){super(),this.f=c,this.g=g,this.h=u,this.j=m,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$me),this.onDidChangeFile=this.a.event,this.b=A.$Mi.forUris(()=>!(this.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Cc(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,g){return this.g.open(this.t(c),g)}close(c){return this.g.close(c)}read(c,g,u,m,w){return this.g.read(c,g,u,m,w)}write(c,g,u,m,w){return this.g.write(c,g,u,m,w)}watch(c,g){this.b.set(c,c);const u=this.g.watch(this.t(c),g);return(0,r.$Tc)(()=>{this.b.delete(c),u.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,g,u){return this.g.rename(this.t(c),this.t(g),u)}readFile(c,g){return this.g.readFile(this.t(c),g)}readFileStream(c,g,u){return this.g.readFileStream(this.t(c),g,u)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,g,u){return this.g.writeFile(this.t(c),g,u)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,g){return this.g.delete(this.t(c),g)}copy(c,g,u){if((0,E.$fl)(this.g))return this.g.copy(this.t(c),this.t(g),u);throw new Error("copy not supported")}cloneFile(c,g){if((0,E.$gl)(this.g))return this.g.cloneFile(this.t(c),this.t(g));throw new Error("clone not supported")}s(c){const g=[];for(const u of c){if(u.resource.scheme!==this.f)continue;const m=this.u(u.resource);this.b.findSubstr(m)&&g.push({resource:m,type:u.type,cId:u.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$cic=I}),define(ce[241],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0,e.$Vhc="utilityProcessWorker"}),define(ce[242],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0,e.$Ahc=(0,n.$Gi)("webviewManagerService")}),define(ce[243],le([0,1,13,2,12,7]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class O extends r.$Vc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(E.Schemas.vscodeWebview,p)}b(p,c){try{const g=A.URI.parse(p.url),u=O.a.get(g.path);if(typeof u=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${u}`,w=E.$1g.asFileUri(m);return c({path:w.fsPath,headers:{...E.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$Bhc=O}),define(ce[51],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$_D=void 0,e.$aE=r,e.$bE=E,e.$cE=A,e.$dE=O,e.$eE=I,e.$fE=u,e.$gE=m,e.$hE=w,e.$jE=f,e.$kE=d,e.$lE=v,e.$_D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function E(b){return!!b.workspaceUri}function A(b){return!!b.folderUri}function O(b){return!!b.fileUri}function I(b){const $=m(b),k=b.getValue("window.menuBarVisibility");return k==="default"||$&&k==="compact"||n.$k&&n.$n?"classic":k}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var g;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function u(b,$){return!0}function m(b,$){return $||($=w(b)),$===c.NATIVE}function w(b){if(n.$p)return c.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const i=$.titleBarStyle;if(i===c.NATIVE||i===c.CUSTOM)return i}return n.$l?c.NATIVE:c.CUSTOM}e.$iE=35;function f(b){return!(!n.$j||n.$p||m(b))}function d(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[52],le([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$5fc=e.$4fc=e.UnloadReason=e.LoadReason=void 0,n=Ge(n);var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var E;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(E||(e.UnloadReason=E={}));const A=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$4fc=A;const O=function(){const u=n.default.screen.getPrimaryDisplay().workArea,m=Math.max(u.x+u.width/2-800/2,0),w=Math.max(u.y+u.height/2-600/2,0);return{x:m,y:w,width:800,height:600,mode:I.Normal}};e.$5fc=O;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var p;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(ce[244],le([0,1,8,4,2]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class A extends E.$Vc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:c}){super(),this.a=this.B(new E.$Uc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$th)(()=>c()),(async()=>{try{const u=await this.b;this.c=typeof this.c=="number"?this.c:u}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hhc=A}),define(ce[30],le([0,1,10,9,60,18,7,6,12]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=c,e.$Ri=g,e.$Ui=u,e.$Vi=m,e.$Wi=w,e.$Xi=d,e.$Yi=v,e.$2i=k,e.$7i=S,e.$8i=i,e.$0i=h,e.$$i=t,e.$_i=o,e.$Pi=(0,I.$Gi)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&O.URI.isUri(a.uri)}function g(s){return typeof s?.id=="string"&&!c(s)&&!m(s)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function u(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$oc)(s)}:a?e.$Si:e.$Ti;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function m(s){const a=s;return typeof a?.id=="string"&&O.URI.isUri(a.configPath)}function w(s){const a=s;if(a?.uri)return{id:a.id,uri:O.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:O.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function d(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&O.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class b{constructor(a,l,P,y,D){this.h=a,this.j=P,this.k=y,this.l=D,this.c=E.$Mi.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=E.$Mi.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=b;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$hh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=$;function k(s){return new $({uri:s,index:0,name:(0,A.$dh)(s)},{uri:s.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,n.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function S(s,a){return A.$$g.isEqualOrParent(s,a.untitledWorkspacesHome)}function i(s){let a;return O.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(s){return s.id===e.$9i}function t(s,a){return!S(s,a)&&!i(s)}function o(s){return(typeof s=="string"?(0,r.$pc)(s):(0,A.$fh)(s))===e.$4i}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[53],le([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0,n=Ge(n),e.$0fc=(0,m.$Gi)("dialogMainService");let v=class{constructor($,k){this.d=$,this.e=k,this.a=new Map,this.b=new Map,this.c=new r.$Nh}pickFileFolder($,k){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(1698,null)},k)}pickFolder($,k){return this.f({...$,pickFolders:!0,title:(0,g.localize)(1699,null)},k)}pickFile($,k){return this.f({...$,pickFiles:!0,title:(0,g.localize)(1700,null)},k)}pickWorkspace($,k){const S=(0,g.localize)(1701,null),i=(0,A.$$w)((0,g.localize)(1702,null)),h=d.$5i;return this.f({...$,pickFiles:!0,title:S,filters:h,buttonLabel:i},k)}async f($,k){const S={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(S.properties=void 0,$.pickFiles&&$.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&S.properties.push("treatPackageAsDirectory");const i=await this.showOpenDialog(S,(k||n.default.BrowserWindow.getFocusedWindow())??void 0);if(i&&i.filePaths&&i.filePaths.length>0)return i.filePaths}g($){if($){let k=this.b.get($.id);return k||(k=new r.$Nh,this.b.set($.id,k)),k}else return this.c}showMessageBox($,k){return this.g(k).queue(async()=>{const{options:S,buttonIndeces:i}=(0,u.$fx)($,this.e);let h;return k?h=await n.default.dialog.showMessageBox(k,S):h=await n.default.dialog.showMessageBox(S),{response:i[h.response],checkboxChecked:h.checkboxChecked}})}async showSaveDialog($,k){const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(k).queue(async()=>{let i;return k?i=await n.default.dialog.showSaveDialog(k,$):i=await n.default.dialog.showSaveDialog($),i.filePath=this.h(i.filePath),i})}finally{(0,O.$Qc)(S)}}h($){return $&&p.$k&&($=(0,I.$om)($)),$}i($){return $.map(k=>this.h(k))}async showOpenDialog($,k){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let i;return k?i=await n.default.dialog.showOpenDialog(k,$):i=await n.default.dialog.showOpenDialog($),i.filePaths=this.i(i.filePaths),i})}finally{(0,O.$Qc)(S)}}j($,k){if(!k)return O.$Vc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let S=this.a.get(k.id);S||(S=new Set,this.a.set(k.id,S));const i=(0,E.$uj)($);if(!S.has(i))return this.d.trace("[DialogMainService]: new file dialog lock created",$),S.add(i),(0,O.$Tc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),S?.delete(i),S?.size===0&&this.a.delete(k.id)})}};e.$$fc=v,e.$$fc=v=Se([se(0,w.$bk),se(1,f.$uk)],v)}),define(ce[245],le([0,1,4,2,82,30]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class O extends r.$Vc{static{this.a=100}constructor(p,c){super(),this.f=p,this.g=c,this.b=this.B(new n.$me),this.c=new Map,this.h(c.applicationStorage,this.b)}h(p,c){this.B(n.Event.debounce(p.onDidChangeStorage,(g,u)=>(g?g.push(u):g=[u],g),O.a)(g=>{g.length&&c.fire(this.j(g,p))}))}j(p,c){const g=new Map,u=new Set;return p.forEach(m=>{const w=c.get(m.key);typeof w=="string"?g.set(m.key,w):u.add(m.key)}),{changed:Array.from(g.entries()),deleted:Array.from(u.values())}}listen(p,c,g){switch(c){case"onDidChangeStorage":{const u=g.profile?(0,E.$di)(g.profile):void 0;if(!u)return this.b.event;let m=this.c.get(u.id);return m||(m=this.B(new n.$me),this.h(this.g.profileStorage(u),m),this.c.set(u.id,m)),m.event}}throw new Error(`Event not found: ${c}`)}async call(p,c,g){const u=g.profile?(0,E.$di)(g.profile):void 0,m=(0,A.$Wi)(g.workspace),w=await this.m(u,m);switch(c){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=g;if(f.insert)for(const[d,v]of f.insert)w.set(d,v);f.delete?.forEach(d=>w.delete(d));break}case"optimize":return w.optimize();case"isUsed":{const f=g.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(p,c){let g;c?g=this.g.workspaceStorage(c):p?g=this.g.profileStorage(p):g=this.g.applicationStorage;try{await g.init()}catch(u){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":p?"profile":"application"} storage due to ${u}`)}return g}}e.$lhc=O}),define(ce[42],le([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,11]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=S,e.$Ol=i,e.$Pl=h;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function S(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&O.URI.isUri(a.location)&&O.URI.isUri(a.globalStorageHome)&&O.URI.isUri(a.settingsResource)&&O.URI.isUri(a.keybindingsResource)&&O.URI.isUri(a.tasksResource)&&O.URI.isUri(a.snippetsHome)&&O.URI.isUri(a.extensionsResource))}e.$Nl=(0,g.$Gi)("IUserDataProfilesService");function i(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:a}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function h(s,a,l,P,y,D){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:D&&y?.useDefaultFlags?.globalState?D.globalStorageHome:(0,A.$hh)(l,"globalStorage"),settingsResource:D&&y?.useDefaultFlags?.settings?D.settingsResource:(0,A.$hh)(l,"settings.json"),keybindingsResource:D&&y?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,A.$hh)(l,"keybindings.json"),tasksResource:D&&y?.useDefaultFlags?.tasks?D.tasksResource:(0,A.$hh)(l,"tasks.json"),snippetsHome:D&&y?.useDefaultFlags?.snippets?D.snippetsHome:(0,A.$hh)(l,"snippets"),extensionsResource:D&&y?.useDefaultFlags?.extensions?D.extensionsResource:(0,A.$hh)(l,"extensions.json"),cacheHome:(0,A.$hh)(P,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let t=class extends E.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,P,y){super(),this.t=a,this.u=l,this.w=P,this.y=y,this.f=!0,this.h=this.B(new r.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Bc,workspaces:new w.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,$.$fg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(h((0,A.$eh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},a))}}catch(D){this.y.error(D)}const P=new w.$Bc,y=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[L,R]of Object.entries(D.workspaces)){const T=O.URI.parse(L),N=l.find(V=>V.id===R);N&&P.set(T,N)}if(D.emptyWindows)for(const[L,R]of Object.entries(D.emptyWindows)){const T=l.find(N=>N.id===R);T&&y.set(L,T)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:P,emptyWindows:y}}return this.z}D(){const a=h("__default__profile__",(0,I.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",P=new RegExp(`${(0,b.$if)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const R=P.exec(L.name),T=R?parseInt(R[1]):0;y=T>y?T:y}const D=`${l} ${y+1}`;return this.createProfile((0,n.$uj)((0,v.$3g)()).toString(16),D,{transient:!0},a)}async createNamedProfile(a,l,P){return this.createProfile((0,n.$uj)((0,v.$3g)()).toString(16),a,l,P)}async createProfile(a,l,P,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(a,l,P);return y&&await this.setProfileForWorkspace(y,D),D}async F(a,l,P){if(!(0,$.$fg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(T=>T.name===l||T.id===a))throw new Error(`Profile with ${l} name already exists`);const L=h(a,l,(0,A.$hh)(this.profilesHome,a),this.g,P,this.defaultProfile);await this.u.createFolder(L.location);const R=[];return this.j.fire({profile:L,join(T){R.push(T)}}),await d.Promises.settled(R),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(y=>y.id===a.id);if(!P)throw new Error(`Profile '${a.name}' does not exist`);return P=h(P.id,l.name??P.name,P.location,this.g,{shortName:l.shortName??P.shortName,icon:l.icon===null?void 0:l.icon??P.icon,transient:l.transient??P.isTransient,useDefaultFlags:l.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.I([],[],[P]),P}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const P=[];this.m.fire({profile:l,join(y){P.push(y)}});try{await Promise.allSettled(P)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$sl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(y=>y.id===l.id);if(!P)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,P)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(P=>!this.w.extUri.isEqual(P.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),P=O.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return P||((0,m.$Qi)(a)?this.s.folders.get(a.uri):(0,m.$Vi)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,m.$Qi)(a)?a.uri:(0,m.$Vi)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,P){const y=[...this.profiles,...a],D=[],L=this.s.profiles;this.s.profiles=[];for(let R of y){if(R.isDefault||l.some(N=>R.id===N.id))continue;R=P.find(N=>R.id===N.id)??R;const T=L.find(N=>R.id===N.id);if(R.isTransient)this.s.profiles.push(R);else{if(T){for(const[N,V]of this.s.emptyWindows.entries())if(R.id===V.id){this.L({id:N},R);break}for(const[N,V]of this.s.workspaces.entries())if(R.id===V.id){this.L({id:"",configPath:N},R);break}for(const[N,V]of this.s.folders.entries())if(R.id===V.id){this.L({id:"",uri:N},R);break}}D.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(a,l,P)}J(a,l,P){this.h.fire({added:a,removed:l,updated:P,all:this.profiles})}L(a,l,P){if(P=l?.isTransient?!0:P,P)(0,m.$Qi)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,m.$Vi)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);O.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[P,y]of this.C.workspaces.entries())a[P.toString()]=y.id;const l={};for(const[P,y]of this.C.emptyWindows.entries())l[P.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},P=this.D();if(a.workspaces)for(const[D,L]of Object.entries(a.workspaces)){const R=O.URI.parse(L);l[D]=this.w.extUri.isEqual(R,P.location)?P.id:this.w.extUri.basename(R)}const y={};if(a.emptyWindows)for(const[D,L]of Object.entries(a.emptyWindows)){const R=O.URI.parse(L);y[D]=this.w.extUri.isEqual(R,P.location)?P.id:this.w.extUri.basename(R)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Ql=t,e.$Ql=t=Se([se(0,p.$Ni),se(1,c.$bl),se(2,f.$Ll),se(3,u.$bk)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Rl=o}),define(ce[86],le([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,11,15,24]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class k extends Error{constructor(o,s){super(o),this.code=s}}e.$Lq=k,e.$Mq=(0,u.$Gi)("IExtensionsProfileScannerService");let S=class extends E.$Vc{constructor(o,s,a,l,P,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=P,this.t=y,this.b=this.B(new A.$me),this.onAddExtensions=this.b.event,this.c=this.B(new A.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$me),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],P=[];try{return await this.u(s,y=>{const D=[];if(a)D.push(...y);else for(const L of y)o.some(([R])=>(0,c.$Np)(R.identifier,L.identifier)&&R.manifest.version!==L.version)?l.push(L):D.push(L);for(const[L,R]of o){const T=D.findIndex(V=>(0,c.$Np)(V.identifier,L.identifier)&&V.version===L.manifest.version),N={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:R};T===-1?(P.push(N),D.push(N)):D.splice(T,1,N)}return P.length&&this.b.fire({extensions:P,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),D}),P.length&&this.c.fire({extensions:P,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),P}catch(y){throw P.length&&this.c.fire({extensions:P,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const P=[];for(const y of l){const D=o.find(([L])=>(0,c.$Np)(L.identifier,y.identifier)&&L.manifest.version===y.version);D&&(y.metadata={...y.metadata,...D[1]},a.push(y)),P.push(y)}return P}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const P=[];for(const y of l)(0,c.$Np)(y.identifier,o.identifier)?a.push(y):P.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),P}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],P;try{const y=await this.m.readFile(o);P=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,g.$sl)(y)!==g.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(P=await this.D()),!P&&a?.bailOutWhenFileNotFound)throw new k((0,v.$0)(y),$.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.w(o);let y=!1;for(const D of P){i(D)||this.w(o);let L;if((0,d.$fg)(D.relativeLocation)&&D.relativeLocation)L=this.z(D.relativeLocation);else if((0,d.$fg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{L=I.URI.revive(D.location);const R=this.y(L);R&&(y=!0,D.relativeLocation=R)}(0,d.$mg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(y=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:L,version:D.version,metadata:D.metadata})}y&&await this.m.writeFile(o,r.$Oe.fromString(JSON.stringify(P)))}if(s){l=s(l);const y=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,r.$Oe.fromString(JSON.stringify(y)))}return l})}w(o){const s=new k(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(P){if((0,g.$sl)(P)===g.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const P=JSON.parse(a);Array.isArray(P)&&P.every(y=>i(y))?l=P:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.t.error(P)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Oe.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(P){if((0,g.$sl)(P)===g.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw P}try{await this.m.del(o)}catch(P){(0,g.$sl)(P)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}try{await this.m.del(s)}catch(P){(0,g.$sl)(P)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Nh,this.h.set(o,s)),s}};e.$Nq=S,e.$Nq=S=Se([se(1,g.$bl),se(2,w.$Nl),se(3,f.$Ll),se(4,b.$am),se(5,m.$bk)],S);function i(t){return(0,d.$hg)(t)&&(0,p.$lp)(t.identifier)&&(h(t.location)||(0,d.$fg)(t.location)&&t.location)&&((0,d.$mg)(t.relativeLocation)||(0,d.$fg)(t.relativeLocation))&&t.version&&(0,d.$fg)(t.version)}function h(t){return t?(0,d.$fg)(t.path)&&(0,d.$fg)(t.scheme):!1}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[133],le([0,1,21,8,37,17,15,43,165,2,12,9,3,18,212,81,11,7,10,38,129,85,211,14,6,5,28,4,82,86,42,41,173]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Sq=e.$Rq=e.$Qq=e.Translations=void 0,e.$Tq=de,E=Pe(E),u=Pe(u),m=Pe(m),f=Pe(f),d=Ge(d);var T;(function(Q){function U(Z,W){if(Z===W)return!0;const j=Object.keys(Z),C=new Set;for(const X of Object.keys(W))C.add(X);if(j.length!==C.size)return!1;for(const X of j){if(Z[X]!==W[X])return!1;C.delete(X)}return C.size===0}Q.equals=U})(T||(e.Translations=T={})),e.$Qq=(0,o.$Gi)("IExtensionsScannerService");let N=class extends c.$Vc{constructor(U,Z,W,j,C,X,oe,G,ue,re,J,M){super(),this.systemExtensionsLocation=U,this.userExtensionsLocation=Z,this.r=W,this.s=j,this.t=C,this.u=X,this.w=oe,this.y=G,this.z=ue,this.C=re,this.D=J,this.F=M,this.g=this.B(new l.$me),this.onDidChangeCache=this.g.event,this.h=(0,w.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(H,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Yp)(this.w,this.y)),this.G}async scanAllExtensions(U,Z,W){const[j,C]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(Z)]),X=W?await this.scanExtensionsUnderDevelopment(U,[...j,...C]):[];return this.L(j,C,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const Z=[];Z.push(this.M(!!U.useCache,U.language)),Z.push(this.N(U.language,!!U.checkControlFile));const[W,j]=await Promise.all(Z);return this.J([...W,...j],i.ExtensionType.System,U,!1)}async scanUserExtensions(U){const Z=U.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const W=this.D.extUri.isEqual(U.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(Z,!!U.profileLocation,i.ExtensionType.User,!U.includeUninstalled,U.language,!0,W,U.productVersion??this.R()),C=U.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let X;try{X=await C.scanExtensions(j)}catch(oe){if(oe instanceof y.$Lq&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await C.scanExtensions(j);else throw oe}return X=await this.J(X,i.ExtensionType.User,U,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(U,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===g.Schemas.file).map(async j=>{const C=await this.P(j,!1,i.ExtensionType.User,!0,U.language,!1,void 0,U.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(C)).map(oe=>(oe.type=Z.find(G=>(0,S.$Np)(G.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,C)))}))).flat();return this.J(W,"development",U,!0)}return[]}async scanExistingExtension(U,Z,W){const j=await this.P(U,!1,Z,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanExtension(j);return!C||!W.includeInvalid&&!C.isValid?null:C}async scanOneOrMultipleExtensions(U,Z,W){const j=await this.P(U,!1,Z,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanOneOrMultipleExtensions(j);return this.J(C,Z,W,!0)}async scanMultipleExtensions(U,Z,W){const j=[];return await Promise.all(U.map(async C=>{const X=await this.scanOneOrMultipleExtensions(C,Z,W);j.push(...X)})),this.J(j,Z,W,!0)}async scanMetadata(U){const Z=(0,w.$hh)(U,"package.json"),W=(await this.w.readFile(Z)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(U,Z){const W=(0,w.$hh)(U,"package.json"),j=(await this.w.readFile(W)).value.toString(),C=JSON.parse(j);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,C.__metadata={...C.__metadata,...Z},await this.w.writeFile((0,w.$hh)(U,"package.json"),A.$Oe.fromString(JSON.stringify(C,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(U){if(U instanceof y.$Lq&&U.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw U}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const U=await this.scanUserExtensions({includeInvalid:!0});if(U.length)await this.u.addExtensionsToProfile(U.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Oe.fromString(JSON.stringify([])))}catch(Z){(0,t.$sl)(Z)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(U){this.y.error(U)}finally{this.H=void 0}})()),this.H}async J(U,Z,W,j){return W.includeAllVersions||(U=this.L(Z===i.ExtensionType.System?U:void 0,Z===i.ExtensionType.User?U:void 0,Z==="development"?U:void 0,await this.getTargetPlatform(),j)),W.includeInvalid||(U=U.filter(C=>C.isValid)),U.sort((C,X)=>{const oe=u.$oc(C.location.fsPath),G=u.$oc(X.location.fsPath);return oe<G?-1:oe>G?1:0})}L(U,Z,W,j,C){const X=(G,ue,re)=>{if(G.isValid&&!ue.isValid)return!1;if(G.isValid===ue.isValid){if(C&&f.gt(G.manifest.version,ue.manifest.version))return this.y.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(f.eq(G.manifest.version,ue.manifest.version)){if(G.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${ue.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return re?this.y.warn(`Overwriting user extension ${G.location.path} with ${ue.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${ue.location.path}.`),!0},oe=new i.$un;return U?.forEach(G=>{const ue=oe.get(G.identifier.id);(!ue||X(ue,G,!1))&&oe.set(G.identifier.id,G)}),Z?.forEach(G=>{const ue=oe.get(G.identifier.id);if(!ue&&U&&G.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!ue||X(ue,G,!1))&&oe.set(G.identifier.id,G)}),W?.forEach(G=>{const ue=oe.get(G.identifier.id);(!ue||X(ue,G,!0))&&oe.set(G.identifier.id,G),oe.set(G.identifier.id,G)}),[...oe.values()]}async M(U,Z){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.R()),C=await(U&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",C.length),C}async N(U,Z){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const j=Z?await this.O():{},C=[],X=b.URI.file(u.$ic(u.$kc(g.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of W){const ue=j[G.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":C.push((0,w.$hh)(X,G.name));break;default:C.push(b.URI.file(ue));break}}const oe=await Promise.all(C.map(async G=>this.n.scanExtension(await this.P(G,!1,i.ExtensionType.System,!0,U,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Hb)(oe)}async O(){try{const U=await this.w.readFile(this.r);return JSON.parse(U.value.toString())}catch{return{}}}async P(U,Z,W,j,C,X,oe,G){const ue=await this.f(C??m.$x),re=await this.Q(U),J=Z&&!this.D.extUri.isEqual(U,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=J?await this.Q(J):void 0;return new V(U,re,J,M,Z,oe,W,j,X,G.version,G.date,this.C.commit,!this.z.isBuilt,C,ue)}async Q(U){try{const Z=await this.w.stat(U);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Rq=N,e.$Rq=N=Se([se(4,D.$Nl),se(5,y.$Mq),se(6,t.$bl),se(7,s.$bk),se(8,k.$Ni),se(9,a.$uk),se(10,L.$Ll),se(11,o.$Fi)],N);class V{constructor(U,Z,W,j,C,X,oe,G,ue,re,J,M,F,_,z){this.location=U,this.mtime=Z,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=j,this.profile=C,this.profileScanOptions=X,this.type=oe,this.excludeObsolete=G,this.validate=ue,this.productVersion=re,this.productDate=J,this.productCommit=M,this.devMode=F,this.language=_,this.translations=z}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,Z){return(0,w.$ah)(U.location,Z.location)&&U.mtime===Z.mtime&&(0,w.$ah)(U.applicationExtensionslocation,Z.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&U.profile===Z.profile&&E.$jo(U.profileScanOptions,Z.profileScanOptions)&&U.type===Z.type&&U.excludeObsolete===Z.excludeObsolete&&U.validate===Z.validate&&U.productVersion===Z.productVersion&&U.productDate===Z.productDate&&U.productCommit===Z.productCommit&&U.devMode===Z.devMode&&U.language===Z.language&&T.equals(U.translations,Z.translations)}}e.$Sq=V;let H=class extends c.$Vc{constructor(U,Z,W,j,C,X,oe){super(),this.g=U,this.h=Z,this.j=W,this.m=j,this.n=X,this.r=oe,this.f=C.extensionsEnabledWithApiProposalVersion?.map(G=>G.toLowerCase())??[]}async scanExtensions(U){const Z=U.profile?await this.t(U):await this.s(U);let W={};if(U.excludeObsolete&&U.type===i.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();W=JSON.parse(j)}catch{}return(0,v.$sg)(W)?Z:Z.filter(j=>!W[S.$Op.create(j).toString()])}async s(U){const Z=await this.m.resolve(U.location);if(!Z.children?.length)return[];const W=await Promise.all(Z.children.map(async j=>{if(!j.isDirectory||U.type===i.ExtensionType.User&&(0,w.$eh)(j.resource).indexOf(".")===0)return null;const C=new V(j.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(C)}));return(0,n.$Hb)(W).sort((j,C)=>j.location.path<C.location.path?-1:1)}async t(U){let Z=await this.u(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.j.extUri.isEqual(U.location,U.applicationExtensionslocation)){Z=Z.filter(j=>!j.metadata?.isApplicationScoped);const W=await this.u(U.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,U);Z.push(...W)}return Z}async u(U,Z,W){const j=await this.h.scanProfileExtensions(U,W.profileScanOptions);if(!j.length)return[];const C=await Promise.all(j.map(async X=>{if(Z(X)){const oe=new V(X.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(oe,X.metadata)}return null}));return(0,n.$Hb)(C)}async scanOneOrMultipleExtensions(U){try{if(await this.m.exists((0,w.$hh)(U.location,"package.json"))){const Z=await this.scanExtension(U);return Z?[Z]:[]}else return await this.scanExtensions(U)}catch(Z){return this.r.error(`Error scanning extensions at ${U.location.path}:`,(0,O.$0)(Z)),[]}}async scanExtension(U,Z){try{let W=await this.w(U.location);if(W){W.publisher||(W.publisher=i.$on),Z=Z??W.__metadata,delete W.__metadata;const j=(0,S.$Sp)(W.publisher,W.name),C=Z?.id?{id:j,uuid:Z.id}:{id:j},X=Z?.isSystem?i.ExtensionType.System:U.type,oe=X===i.ExtensionType.System||!!Z?.isBuiltin;W=await this.y(U.location,W,V.createNlsConfiguration(U));let G={type:X,identifier:C,manifest:W,location:U.location,isBuiltin:oe,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return U.validate&&(G=this.validate(G,U)),W.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(W.originalEnabledApiProposals=W.enabledApiProposals,W.enabledApiProposals=(0,i.$An)([...W.enabledApiProposals])),G}}catch(W){U.type!==i.ExtensionType.System&&this.r.error(W)}return null}validate(U,Z){let W=!0;const j=this.n.isBuilt&&this.f.includes(U.identifier.id.toLowerCase()),C=(0,h.$5p)(Z.productVersion,Z.productDate,Z.location,U.manifest,U.isBuiltin,j);for(const[X,oe]of C)X===d.default.Error&&(W=!1,this.r.error(this.F(Z.location,oe)));return U.isValid=W,U.validations=C,U}async w(U){const Z=(0,w.$hh)(U,"package.json");let W;try{W=(await this.m.readFile(Z)).value.toString()}catch(C){return(0,t.$sl)(C)!==t.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(U,(0,$.localize)(1806,null,Z.path,C.message))),null}let j;try{j=JSON.parse(W)}catch{const X=[];(0,I.$Zn)(W,X);for(const oe of X)this.r.error(this.F(U,(0,$.localize)(1807,null,Z.path,oe.offset,oe.length,(0,p.$Oq)(oe.error))));return null}return(0,I.$8n)(j)!=="object"?(this.r.error(this.F(U,(0,$.localize)(1808,null,Z.path))),null):j}async y(U,Z,W){const j=await this.z(U,Z,W);if(j)try{const C=[],X=await this.C(j.default,C);if(C.length>0)return C.forEach(G=>{this.r.error(this.F(U,(0,$.localize)(1809,null,j.default?.path,(0,p.$Oq)(G.error))))}),Z;if((0,I.$8n)(j)!=="object")return this.r.error(this.F(U,(0,$.localize)(1810,null,j.default?.path))),Z;const oe=j.values||Object.create(null);return(0,R.$Pq)(this.r,Z,oe,X)}catch{}return Z}async z(U,Z,W){const j=(0,w.$hh)(U,"package.nls.json"),C=(ue,re)=>{re.forEach(J=>{this.r.error(this.F(U,(0,$.localize)(1811,null,ue?.path,(0,p.$Oq)(J.error))))})},X=ue=>{this.r.error(this.F(U,(0,$.localize)(1812,null,ue?.path)))},oe=`${Z.publisher}.${Z.name}`,G=W.translations[oe];if(G)try{const ue=b.URI.file(G),re=(await this.m.readFile(ue)).value.toString(),J=[],M=(0,I.$Zn)(re,J);return J.length>0?(C(ue,J),{values:void 0,default:j}):(0,I.$8n)(M)!=="object"?(X(ue),{values:void 0,default:j}):{values:M.contents?M.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let re;try{re=await this.D(U,W)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const J=(await this.m.readFile(re.localized)).value.toString(),M=[],F=(0,I.$Zn)(J,M);return M.length>0?(C(re.localized,M),{values:void 0,default:re.original}):(0,I.$8n)(F)!=="object"?(X(re.localized),{values:void 0,default:re.original}):{values:F,default:re.original}}catch{return{values:void 0,default:re.original}}}}async C(U,Z){if(U)try{const W=(await this.m.readFile(U)).value.toString();return(0,I.$Zn)(W,Z)}catch{}}D(U,Z){return new Promise((W,j)=>{const C=X=>{const oe=(0,w.$hh)(U,`package.nls.${X}.json`);this.m.exists(oe).then(G=>{G&&W({localized:oe,original:(0,w.$hh)(U,"package.nls.json")});const ue=X.lastIndexOf("-");ue===-1?W({localized:(0,w.$hh)(U,"package.nls.json"),original:null}):(X=X.substring(0,ue),C(X))})};if(Z.devMode||Z.pseudo||!Z.language)return W({localized:(0,w.$hh)(U,"package.nls.json"),original:null});C(Z.language)})}F(U,Z){return`[${U.path}]: ${Z}`}};H=Se([se(1,y.$Mq),se(2,L.$Ll),se(3,t.$bl),se(4,a.$uk),se(5,k.$Ni),se(6,s.$bk)],H);let Y=class extends H{constructor(U,Z,W,j,C,X,oe,G,ue){super(Z,j,C,X,oe,G,ue),this.J=U,this.L=W,this.H=this.B(new r.$Eh(3e3)),this.I=this.B(new l.$me),this.onDidChangeCache=this.I.event}async scanExtensions(U){const Z=this.P(U),W=await this.M(Z);if(this.G=U,W&&W.input&&V.equals(W.input,this.G))return this.r.debug("Using cached extensions scan result",U.type===i.ExtensionType.System?"system":"user",U.location.toString()),this.H.trigger(()=>this.O()),W.result.map(C=>(C.location=b.URI.revive(C.location),C));const j=await super.scanExtensions(U);return await this.N(Z,{input:U,result:j}),j}async M(U){try{const Z=await this.m.readFile(U),W=JSON.parse(Z.value.toString());return{result:W.result,input:(0,P.$di)(W.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",U.path,(0,O.$0)(Z))}return null}async N(U,Z){try{await this.m.writeFile(U,A.$Oe.fromString(JSON.stringify(Z)))}catch(W){this.r.debug("Error while writing the extension cache file:",U.path,(0,O.$0)(W))}}async O(){if(!this.G)return;const U=this.P(this.G),Z=await this.M(U);if(!Z)return;const W=Z.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$jo(j,W))try{this.r.info("Invalidating Cache",W,j),await this.m.del(U),this.I.fire()}catch(C){this.r.error(C)}}P(U){const Z=this.Q(U);return this.j.extUri.joinPath(Z.cacheHome,U.type===i.ExtensionType.System?i.$nn:i.$mn)}Q(U){return U.type===i.ExtensionType.System?this.L.defaultProfile:U.profile?this.j.extUri.isEqual(U.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(U.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};Y=Se([se(2,D.$Nl),se(3,y.$Mq),se(4,L.$Ll),se(5,t.$bl),se(6,a.$uk),se(7,k.$Ni),se(8,s.$bk)],Y);function de(Q,U){const Z=(0,S.$Qp)(Q.manifest.publisher,Q.manifest.name);return{id:Z,identifier:new i.$sn(Z),isBuiltin:Q.type===i.ExtensionType.System,isUserBuiltin:Q.type===i.ExtensionType.User&&Q.isBuiltin,isUnderDevelopment:U,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class q extends N{constructor(U,Z,W,j,C,X,oe,G,ue,re,J,M){super(U,Z,(0,w.$hh)(W,".vscode-oss-dev","extensions","control.json"),j,C,X,oe,G,ue,re,J,M),this.S=(async()=>{if(m.$A)try{const F=await this.w.readFile(b.URI.file(m.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(U){return this.S}}e.$Uq=q}),define(ce[246],le([0,1,5,42,41,24,86,14,38,7]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NR=void 0;let g=class extends O.$Nq{constructor(m,w,f,d,v,b){super(c.URI.file(m.extensionsPath),w,f,d,v,b)}};e.$NR=g,e.$NR=g=Se([se(0,p.$Oi),se(1,I.$bl),se(2,r.$Nl),se(3,E.$Ll),se(4,A.$am),se(5,n.$bk)],g)}),define(ce[247],le([0,1,7,38,86,133,14,6,5,28,41,42]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let m=class extends A.$Uq{constructor(f,d,v,b,$,k,S,i){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,d,v,b,$,k,S,i)}};e.$Lhc=m,e.$Lhc=m=Se([se(0,u.$Nl),se(1,E.$Mq),se(2,O.$bl),se(3,p.$bk),se(4,r.$Oi),se(5,c.$uk),se(6,g.$Ll),se(7,I.$Fi)],m)}),define(ce[248],le([0,1,13,2,12,9,3,60,7,33,35,38,5,42]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;let f=class extends r.$Vc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Mi.forPaths(!O.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(E.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(E.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Tc)(()=>{v.protocol.unregisterProtocol(E.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(E.Schemas.file)}))}addValidFileRoot(v){const b=(0,A.$ic)(v);return this.a.get(b)?r.$Vc.None:(this.a.set(b,!0),(0,r.$Tc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${E.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let k;return this.c.crossOriginIsolated&&((0,A.$oc)($)==="workbench.html"||(0,A.$oc)($)==="workbench-dev.html"?k=E.COI.CoopAndCoep:k=E.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:k}):this.b.has((0,A.$pc)($).toLowerCase())?b({path:$}):(this.f.error(`${E.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${E.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=E.$1g.uriToFileUri(b);return(0,A.$ic)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,c.$3g)()}),$=b.toString(),k=async()=>v;return g.$1X.handle($,k),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:S=>v=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),g.$1X.removeHandler($)}}}};e.$6hc=f,e.$6hc=f=Se([se(0,u.$Oi),se(1,w.$Nl),se(2,m.$bk)],f)}),define(ce[62],le([0,1,8,4,2,70,11,119,6,42]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=w,e.$mq=d,e.$oq=b,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,p.$Gi)("storageService");var g;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var m;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function w($){const k=$.get(e.$iq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class f extends E.$Vc{static{this.a=60*1e3}constructor(k={flushInterval:f.a}){super(),this.m=k,this.b=this.B(new r.$pe),this.c=this.B(new r.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$me),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,S,i){return r.Event.filter(this.b.event,h=>h.scope===k&&(S===void 0||h.key===S),i)}n(){this.j.value=(0,n.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,S){const{key:i,external:h}=S;if(i===e.$iq){switch(k){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:i,target:this.J(k)[i],external:h})}w(k){this.f.fire({reason:k})}get(k,S,i){return this.P(S)?.get(k,i)}getBoolean(k,S,i){return this.P(S)?.getBoolean(k,i)}getNumber(k,S,i){return this.P(S)?.getNumber(k,i)}getObject(k,S,i){return this.P(S)?.getObject(k,i)}storeAll(k,S){this.y(()=>{for(const i of k)this.store(i.key,i.value,i.scope,i.target,S)})}store(k,S,i,h,t=!1){if((0,O.$og)(S)){this.remove(k,i,t);return}this.y(()=>{this.z(k,i,h),this.P(i)?.set(k,S,t)})}remove(k,S,i=!1){this.y(()=>{this.z(k,S,void 0),this.P(S)?.delete(k,i)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const i=[],h=this.J(k);for(const t of Object.keys(h))h[t]===S&&i.push(t);return i}z(k,S,i,h=!1){const t=this.J(S);typeof i=="number"?t[k]!==i&&(t[k]=i,this.P(S)?.set(e.$iq,JSON.stringify(t),h)):typeof t[k]=="number"&&(delete t[k],this.P(S)?.set(e.$iq,JSON.stringify(t),h))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(k){switch(k){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(k){const S=this.P(k);return S?w(S):Object.create(null)}isNew(k){return this.getBoolean(e.$hq,k)===!0}async flush(k=g.NONE){this.f.fire({reason:k});const S=this.P(u.APPLICATION),i=this.P(u.PROFILE),h=this.P(u.WORKSPACE);switch(k){case g.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(u.APPLICATION)?.items??new Map,S=this.P(u.PROFILE)?.items??new Map,i=this.P(u.WORKSPACE)?.items??new Map;return b(k,S,i,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,S){return this.w(g.NONE),(0,c.$Ml)(k)?this.R(k,S):this.S(k,S)}M(k,S){return!(k.id===S.id||d(S)&&d(k))}N(k,S,i){this.y(()=>{const h=new Set;for(const[t,o]of k)h.add(t),S.get(t)!==o&&this.u(i,{key:t,external:!0});for(const[t]of S.items)h.has(t)||this.u(i,{key:t,external:!0})})}}e.$lq=f;function d($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$fq(new I.$gq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$fq(new I.$gq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$fq(new I.$gq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(u.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(u.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(u.APPLICATION,k)))}P(k){switch(k){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$nq=v;async function b($,k,S,i,h,t){const o=T=>{try{return JSON.parse(T)}catch{return T}},s=new Map,a=new Map;$.forEach((T,N)=>{s.set(N,T),a.set(N,o(T))});const l=new Map,P=new Map;k.forEach((T,N)=>{l.set(N,T),P.set(N,o(T))});const y=new Map,D=new Map;S.forEach((T,N)=>{y.set(N,T),D.set(N,o(T))}),console.group(i!==h?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const L=[];if(s.forEach((T,N)=>{L.push({key:N,value:T})}),console.table(L),console.groupEnd(),console.log(a),i!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const T=[];l.forEach((N,V)=>{T.push({key:V,value:N})}),console.table(T),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${t})`);const R=[];y.forEach((T,N)=>{R.push({key:N,value:T})}),console.table(R),console.groupEnd(),console.log(D)}}),define(ce[249],le([0,1,17,33,62]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=A;async function A(O,I,p){let c=p&&p.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await I.readFile(O.serviceMachineIdResource)).value.toString();c=(0,r.$2g)(u)?u:null}catch{c=null}if(!c){c=(0,r.$3g)();try{await I.writeFile(O.serviceMachineIdResource,n.$Oe.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),c}}),define(ce[250],le([0,1,249,24,57]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=A;async function A(O,I,p,c,g,u,m){const w={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,E.$Fp)(I,p)&&(0,E.$Hp)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$pq)(p,g,u);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=m.machineId||f}return w}}),define(ce[251],le([0,1,26,21,8,4,2,9,66,7,23,119,163,5,62,24,30,12]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=e.$zgc=e.$ygc=e.$xgc=void 0,n=Pe(n);class $ extends O.$Vc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new A.$me),this.onDidChangeStorage=this.b.event,this.c=this.B(new A.$me),this.onDidCloseStorage=this.c.event,this.f=this.B(new u.$fq(new u.$gq,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new E.$4h,this.whenInit=this.h.p,this.j=u.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===u.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$hq);a===void 0?s.set(f.$hq,!0):a&&s.set(f.$hq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=u.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$ge(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([P,y])=>({key:P,length:y.length})),(P,y)=>y.length-P.length,5).map(P=>`${P.key}:${P.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=u.StorageState.Closed,await this.f.close()}}class k extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$kc)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,k.y)}constructor(s,a,l,P){super(l,P),this.z=s,this.C=a}async t(){return new u.$fq(new m.$tY(this.path??m.$tY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class S extends k{constructor(s,a,l,P){super(s,a,l,P)}}e.$xgc=S;class i extends k{constructor(s,a,l,P){super(a.defaultProfile,s,l,P)}async s(s){await super.s(s),this.G(s)}G(s){s.get(d.$dm,void 0)===void 0&&s.set(d.$dm,new Date().toUTCString());const l=s.get(d.$cm,void 0),P=new Date().toUTCString();s.set(d.$em,typeof l>"u"?null:l),s.set(d.$cm,P)}}e.$ygc=i;class h extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$kc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,h.y)}constructor(s,a,l,P,y){super(l,y),this.C=s,this.D=a,this.F=P}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new u.$fq(new m.$tY(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:a?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:m.$tY.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$kc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),a=(0,I.$kc)(s,h.y);return await g.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Qi)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Vi)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$kc)(s,h.z);await g.Promises.exists(l)||await g.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$zgc=h;class t extends ${get path(){}async t(){return new u.$fq(new u.$gq,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.$Agc=t}),define(ce[252],le([0,1,4,2,62]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class A extends r.$Vc{constructor(I,p,c){super(),this.b=I,this.c=p,this.f=c;const g=this.B(new r.$Wc);this.a=this.B(new n.$me({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Uc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,c)=>(p?p.push(c.key):p=[c.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,c)=>{p||(p=new Map);let g=p.get(c.profile.id);return g||p.set(c.profile.id,g={profile:c.profile,keys:[],storage:c.storage}),g.keys.push(c.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(E.$iq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(g=>g!==E.$iq),I.length){const g=(0,E.$kq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(u=>({key:u,scope:E.StorageScope.PROFILE,target:g[u]}))})}this.m(p,c)}j(I){const p=[],c=new Map;for(const[g,u]of I.entries()){u.keys.includes(E.$iq)&&p.push(u.profile);const m=u.keys.filter(w=>w!==E.$iq);if(m.length){const w=(0,E.$kq)(u.storage.storage);c.set(g,{profile:u.profile,changes:m.map(f=>({key:f,scope:E.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...c.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,c){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$Nhc=A}),define(ce[253],le([0,1,7,38,14,5,34,41,42,11,127]),function(x,e,n,r,E,A,O,I,p,c,g){"use strict";var u,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$MR=e.$LR=e.$KR=void 0;let w=class extends p.$Ql{static{u=this}static{this.a="profileAssociationsMigration"}constructor(b,$,k,S,i){super(k,S,$,i),this.U=b,this.W=k}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,c.$fg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$KR=w,e.$KR=w=u=Se([se(0,O.$FR),se(1,I.$Ll),se(2,r.$Oi),se(3,E.$bl),se(4,A.$bk)],w);let f=m=class extends w{constructor(b,$,k,S,i){super(b,$,k,S,i),this.$=b}P(b){b.length?this.$.setItem(m.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(m.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(m.c,b):this.$.removeItem(m.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const S=$.reduce((i,{workspace:h,profile:t})=>(i[n.URI.revive(h).toString()]=n.URI.revive(t).toString(),i),{});this.$.setItem(m.c,{workspaces:S})}const k=super.Q();return this.$.getItem(m.a,!1)||(this.R(k),this.$.setItem(m.a,!0)),k}};e.$LR=f,e.$LR=f=m=Se([se(0,O.$GR),se(1,I.$Ll),se(2,r.$Oi),se(3,E.$bl),se(4,A.$bk)],f);let d=class extends f{constructor(b,$,k,S){super(new g.$JR(g.SaveStrategy.IMMEDIATE,$,S,k),b,$,k,S)}async init(){return await this.$.init(),super.init()}};e.$MR=d,e.$MR=d=Se([se(0,I.$Ll),se(1,r.$Oi),se(2,E.$bl),se(3,A.$bk)],d)}),define(ce[58],le([0,1,38,14,6,5,41,42,253,34]),function(x,e,n,r,E,A,O,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0,e.$fgc=(0,E.$Hi)(I.$Nl);let g=class extends p.$LR{constructor(m,w,f,d,v){super(m,w,f,d,v)}getAssociatedEmptyWindows(){const m=[];for(const w of this.C.emptyWindows.keys())m.push({id:w});return m}};e.$ggc=g,e.$ggc=g=Se([se(0,c.$GR),se(1,O.$Ll),se(2,n.$Oi),se(3,r.$bl),se(4,A.$bk)],g)}),define(ce[134],le([0,1,18,7,30]),function(x,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=A,e.$igc=O,e.$jgc=I;async function A(p,c,g){for(const m of p){const w=m.openedWorkspace;if((0,E.$Vi)(w)){const f=await g(w);if(f){if(f.folders.some(d=>n.$$g.isEqualOrParent(c,d.uri)))return m}else if(n.$$g.isEqualOrParent(c,w.configPath))return m}}const u=p.filter(m=>(0,E.$Qi)(m.openedWorkspace)&&n.$$g.isEqualOrParent(c,m.openedWorkspace.uri));if(u.length)return u.sort((m,w)=>-(m.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function O(p,c){for(const g of p)if((0,E.$Vi)(g.openedWorkspace)&&n.$$g.isEqual(g.openedWorkspace.configPath,c)||(0,E.$Qi)(g.openedWorkspace)&&n.$$g.isEqual(g.openedWorkspace.uri,c))return g}function I(p,c){const g=u=>c.some(m=>n.$$g.isEqual(r.URI.file(m),r.URI.file(u)));for(const u of p)if(u.config?.extensionDevelopmentPath?.some(m=>g(m)))return u}}),define(ce[102],le([0,1,32,43,107,47,12,9,3,18,7,6,74,30]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kib=void 0,e.$lib=f,e.$mib=d,e.$nib=v,e.$oib=b,e.$pib=S,e.$qib=h,e.$rib=t,e.$sib=P,e.$tib=y,r=Pe(r),E=Pe(E),e.$kib=(0,u.$Gi)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function d(D){return D.hasOwnProperty("folderUri")}function v(D){return D.hasOwnProperty("fileUri")}function b(D){return $(D)||k(D)}function $(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(D,L,R,T,N){if(D.scheme!==T.scheme)return{name:R,uri:D.toString(!0)};let V=L?void 0:N.relativePath(T,D);if(V!==void 0)V.length===0?V=".":p.$j&&(V=i(V));else if(D.scheme===O.Schemas.file)V=D.fsPath,p.$j&&(V=i(V));else if(N.isEqualAuthority(D.authority,T.authority))V=D.path;else return{name:R,uri:D.toString(!0)};return{name:R,path:V}}function i(D){return D=(0,A.$5w)(D),(0,n.$Cg)(D)||(D=(0,n.$zg)(D)),D}function h(D,L,R){const T=[],N=new Set,V=R.dirname(L);for(const H of D){let Y;if($(H))H.path&&(Y=R.resolvePath(V,H.path));else if(k(H))try{Y=g.URI.parse(H.uri),Y.path[0]!==I.$hc.sep&&(Y=Y.with({path:I.$hc.sep+Y.path}))}catch(de){console.warn(de)}if(Y){const de=R.getComparisonKey(Y);if(!N.has(de)){N.add(de);const q=H.name||R.basenameOrAuthority(Y);T.push(new w.$1i({uri:Y,name:q,index:T.length},H))}}}return T}function t(D,L,R,T,N){const V=o(L,D),H=N.dirname(L),Y=N.dirname(T),de=[];for(const Z of V.folders){const W=$(Z)?N.resolvePath(H,Z.path):g.URI.parse(Z.uri);let j;R?j=!1:j=!$(Z)||(0,I.$jc)(Z.path),de.push(S(W,j,Z.name,Y,N))}const q={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},Q=E.$bo(D,["folders"],de,q);let U=E.$eo(D,Q);return(0,c.$mh)(V.remoteAuthority,(0,m.$in)(T))&&(U=E.$eo(U,E.$ao(U,["remoteAuthority"],q))),U}function o(D,L){const R=r.$Zn(L);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(T=>b(T));else throw new Error(`${D} looks like an invalid workspace file.`);return R}function s(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function P(D,L){const R={workspaces:[],files:[]};if(D){const T=function(V,H){for(let Y=0;Y<V.length;Y++)try{H(V[Y],Y)}catch(de){L.warn(`Error restoring recent entry ${JSON.stringify(V[Y])}: ${de.toString()}. Skip entry.`)}},N=D;Array.isArray(N.entries)&&T(N.entries,V=>{const H=V.label,Y=V.remoteAuthority;s(V)?R.workspaces.push({label:H,remoteAuthority:Y,workspace:{id:V.workspace.id,configPath:g.URI.parse(V.workspace.configPath)}}):a(V)?R.workspaces.push({label:H,remoteAuthority:Y,folderUri:g.URI.parse(V.folderUri)}):l(V)&&R.files.push({label:H,remoteAuthority:Y,fileUri:g.URI.parse(V.fileUri)})})}return R}function y(D){const L={entries:[]};for(const R of D.workspaces)d(R)?L.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):L.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of D.files)L.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return L}}),define(ce[103],le([0,1,91,12,3,18]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0,e.$lgc=O,e.$mgc=I,e.$ngc=p,e.$kgc=128/4;function O(c){function g(){let u=c.scheme===r.Schemas.file?(0,A.$8g)(c):c.toString();return E.$l||(u=u.toLowerCase()),(0,n.createHash)("md5").update(u).digest("hex")}return{id:g(),configPath:c}}function I(c,g){function u(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!g)return;let w;return E.$l?w=g.ino:E.$k?w=g.birthtime.getTime():E.$j&&(typeof g.birthtimeMs=="number"?w=Math.floor(g.birthtimeMs):w=g.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(w?String(w):"").digest("hex")}const m=u();if(typeof m=="string")return{id:m,uri:c}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[104],le([0,1,91,93,27,254,17,15,4,2,9,3,33,44,117]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=s,e.$zi=a,e.$Bi=y,e.$Ci=D;const d=3e4;class v{traceSocketEvent(R,T){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}constructor(R,T=""){this.f=!0,this.debugLabel=T,this.socket=R,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=V=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:V?.code,message:V?.message}),V){if(V.code==="EPIPE")return;(0,I.$Z)(V)}},this.socket.on("error",this.a);let N;this.b=V=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:V}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>R.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(R){const T=N=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,N),R(O.$Oe.wrap(N))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=N=>{R({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,I.$Z)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,I.$Z)(T)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),R();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),R()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$vi=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class k extends c.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}constructor(R,T,N,V){super(),this.f=this.B(new p.$me),this.g=this.B(new p.$me),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=R,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:N?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new S(this,T,N,V,this.f,(H,Y)=>this.m(H,Y))),this.B(this.a.onError(H=>{console.error(H),(0,I.$Z)(H),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:H})})),this.b=new f.$qi,this.B(this.socket.onData(H=>this.n(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this.f.event(R)}onClose(R){return this.g.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){let T=0;for(;T<R.byteLength;)this.a.writeMessage(R.slice(T,Math.min(T+b.MaxWebSocketMessageLength,R.byteLength)),{compressed:!0,opcode:2}),T+=b.MaxWebSocketMessageLength}m(R,{compressed:T,opcode:N}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,R);let V=b.MinHeaderByteSize;R.byteLength<126?V+=0:R.byteLength<2**16?V+=2:V+=8;const H=O.$Oe.alloc(V),Y=T?64:0,de=N&15;if(H.writeUInt8(128|Y|de,0),R.byteLength<126)H.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){H.writeUInt8(126,1);let q=1;H.writeUInt8(R.byteLength>>>8&255,++q),H.writeUInt8(R.byteLength>>>0&255,++q)}else{H.writeUInt8(127,1);let q=1;H.writeUInt8(0,++q),H.writeUInt8(0,++q),H.writeUInt8(0,++q),H.writeUInt8(0,++q),H.writeUInt8(R.byteLength>>>24&255,++q),H.writeUInt8(R.byteLength>>>16&255,++q),H.writeUInt8(R.byteLength>>>8&255,++q),H.writeUInt8(R.byteLength>>>0&255,++q)}this.socket.write(O.$Oe.concat([H,R]))}end(){this.h=!0,this.socket.end()}n(R){if(R.byteLength!==0){for(this.b.acceptChunk(R);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const T=this.b.peek(this.j.readLen),N=T.readUInt8(0),V=(N&128)>>>7,H=(N&64)>>>6,Y=N&15,de=T.readUInt8(1),q=(de&128)>>>7,Q=de&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(q?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=Y,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const T=this.b.read(this.j.readLen),N=T.readUInt8(1),V=(N&128)>>>7;let H=N&127,Y=1;H===126?H=T.readUInt8(++Y)*2**8+T.readUInt8(++Y):H===127&&(H=T.readUInt8(++Y)*0+T.readUInt8(++Y)*0+T.readUInt8(++Y)*0+T.readUInt8(++Y)*0+T.readUInt8(++Y)*2**24+T.readUInt8(++Y)*2**16+T.readUInt8(++Y)*2**8+T.readUInt8(++Y));let de=0;V&&(de=T.readUInt8(++Y)*2**24+T.readUInt8(++Y)*2**16+T.readUInt8(++Y)*2**8+T.readUInt8(++Y)),this.j.state=$.ReadBody,this.j.readLen=H,this.j.mask=de,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const T=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,T),t(T,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,T),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(T,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(T,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=k;class S extends c.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Oe.alloc(0)}constructor(R,T,N,V,H,Y){super(),this.n=R,this.r=H,this.s=Y,this.a=this.B(new p.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,T?(this.b=this.B(new i(this.n,V,N,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(R,T){this.g.push({data:R,options:T}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:R,options:T}=this.g.shift();if(this.f&&T.compressed){const N=await this.w(this.f,R);this.s(N,T)}else this.s(R,{...T,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(R,T){return new Promise((N,V)=>{R.write(T),R.flush(H=>N(H))})}acceptFrame(R,T,N){this.h.push({data:R,isCompressed:T,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const R=this.h.shift();if(this.b&&R.isCompressed){const T=await this.C(this.b,R.data,R.isLastFrameOfMessage);this.r.fire(T)}else this.r.fire(R.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(R,T,N){return new Promise((V,H)=>{R.write(T),N&&R.write(O.$Oe.fromByteArray([0,0,255,255])),R.flush(Y=>V(Y))})}}class i extends c.$Vc{get recordedInflateBytes(){return this.j?O.$Oe.concat(this.f):O.$Oe.alloc(0)}constructor(R,T,N,V){super(),this.h=R,this.j=T,this.a=this.B(new p.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(V),this.b.on("error",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,H),this.g.push(O.$Oe.wrap(H))}),N&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(R){this.j&&this.f.push(R.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,R),this.b.write(R.buffer)}flush(R){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const T=O.$Oe.concat(this.g);this.g.length=0,R(T)})}}class h extends c.$Vc{constructor(R,T){super(),this.g=R,this.a=this.B(new p.$me),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(O.$Oe.wrap(N))})}write(R){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,R.buffer),this.b.write(R.buffer)}flush(R){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let T=O.$Oe.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function t(L,R){if(R===0)return;const T=L.byteLength>>>2;for(let q=0;q<T;q++){const Q=L.readUInt32BE(q*4);L.writeUInt32BE(Q^R,q*4)}const N=T*4,V=L.byteLength-N,H=R>>>24&255,Y=R>>>16&255,de=R>>>8&255;V>=1&&L.writeUInt8(L.readUInt8(N)^H,N),V>=2&&L.writeUInt8(L.readUInt8(N+1)^Y,N+1),V>=3&&L.writeUInt8(L.readUInt8(N+2)^de,N+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function s(){const L=(0,m.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const R=process.platform!=="darwin"&&e.$xi?e.$xi:(0,E.tmpdir)(),T=(0,g.$kc)(R,`vscode-ipc-${L}.sock`);return l(T),T}function a(L,R,T){const V=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${T}-${R}-sock`;const H=T.substr(0,4),Y=R.substr(0,6);let de;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?de=(0,g.$kc)(e.$xi,`vscode-${V}-${H}-${Y}.sock`):de=(0,g.$kc)(L,`${H}-${Y}.sock`),l(de),de}function l(L){const R=o[u.$v];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class P extends w.$ki{static b(R){const T=p.Event.fromNodeEventEmitter(R,"connection");return p.Event.map(T,N=>({protocol:new f.$ri(new v(N,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(N,"close"))}))}constructor(R){super(P.b(R)),this.d=R}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=P;function y(L){return new Promise((R,T)=>{const N=(0,r.createServer)();N.on("error",T),N.listen(L,()=>{N.removeListener("error",T),R(new P(N))})})}function D(L,R){return new Promise((T,N)=>{const V=(0,r.createConnection)(L,()=>{V.removeListener("error",N),T(f.$si.fromSocket(new v(V,`ipc-client${R}`),R))});V.once("error",N)})}}),define(ce[20],le([0,1,54,9,3,104,38,95,6]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0,e.$2fc=(0,p.$Hi)(O.$Ni);class c extends I.$0m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.$zi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(E.$l){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const m=u.slice(0,-17);if(this.d[m])continue;process.env[m]&&(this.d[m]=process.env[m]),process.env[u]?process.env[m]=process.env[u]:delete process.env[m]}}}restoreSnapExportedVariables(){if(E.$l)for(const u in this.d)process.env[u]=this.d[u],delete this.d[u]}}e.$3fc=c,Se([n.$$h],c.prototype,"backupHome",null),Se([n.$$h],c.prototype,"mainIPCHandle",null),Se([n.$$h],c.prototype,"mainLockfile",null),Se([n.$$h],c.prototype,"disableUpdates",null),Se([n.$$h],c.prototype,"crossOriginIsolated",null),Se([n.$$h],c.prototype,"codeCachePath",null),Se([n.$$h],c.prototype,"useCodeCache",null)}),define(ce[255],le([0,1,91,32,12,9,3,18,23,167,16,20,34,14,5,166,30,103]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;let k=class{static{$=this}static{this.a="backupWorkspaces"}constructor(i,h,t,o){this.j=i,this.k=h,this.l=t,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$$g,this.i={isEqual:(s,a)=>(0,r.$Eg)(s,a,!O.$l)}}async initialize(){const i=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(i.emptyWindows),this.d=await this.u((0,c.$7fc)(i)),this.e=await this.v((0,c.$8fc)(i)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$Al.OFF}q(){return this.s()===w.$Al.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$Al.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(i,h){this.d.some(o=>i.workspace.id===o.workspace.id)||(this.d.push(i),this.C());const t=(0,A.$kc)(this.c,i.workspace.id);return h?this.t(t,h).then(()=>t):t}async t(i,h){if(await p.Promises.exists(i)&&await this.z(i),await p.Promises.exists(h))try{await p.Promises.rename(h,i,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(i){return this.e.some(h=>this.h.isEqual(i.folderUri,h.folderUri))||(this.e.push(i),this.C()),(0,A.$kc)(this.c,this.D(i))}registerEmptyWindowBackup(i){return this.g.some(h=>!!h.backupFolder&&this.i.isEqual(h.backupFolder,i.backupFolder))||(this.g.push(i),this.C()),(0,A.$kc)(this.c,i.backupFolder)}async u(i){if(!Array.isArray(i))return[];const h=new Set,t=[];for(const o of i){const s=o.workspace;if(!(0,v.$Vi)(s))return[];if(!h.has(s.id)){h.add(s.id);const a=(0,A.$kc)(this.c,s.id);await this.B(a)?s.configPath.scheme!==E.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?t.push(o):await this.z(a):await this.x(a)}}return t}async v(i){if(!Array.isArray(i))return[];const h=[],t=new Set;for(const o of i){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!t.has(a)){t.add(a);const l=(0,A.$kc)(this.c,this.D(o));await this.B(l)?s.scheme!==E.Schemas.file||await p.Promises.exists(s.fsPath)?h.push(o):await this.z(l):await this.x(l)}}return h}async w(i){if(!Array.isArray(i))return[];const h=[],t=new Set;for(const o of i){const s=o.backupFolder;if(typeof s!="string")return[];if(!t.has(s)){t.add(s);const a=(0,A.$kc)(this.c,s);await this.B(a)?h.push(o):await this.x(a)}}return h}async x(i){try{await p.Promises.rm(i,p.RimRafMode.MOVE)}catch(h){this.l.error(`Backup: Could not delete stale backup: ${h.toString()}`)}}y(){let i=(0,b.$ngc)();for(;this.g.some(h=>!!h.backupFolder&&this.i.isEqual(h.backupFolder,i.id));)i=(0,b.$ngc)();return{backupFolder:i.id}}async z(i){const h=this.y(),t=(0,A.$kc)(this.c,h.backupFolder);try{await p.Promises.rename(i,t,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(h),!0}async getDirtyWorkspaces(){const i=[];for(const h of this.d)await this.A(h)&&i.push(h);for(const h of this.e)await this.A(h)&&i.push(h);return i}A(i){let h;return(0,c.$6fc)(i)?h=(0,A.$kc)(this.c,i.backupFolder):(0,d.$iib)(i)?h=(0,A.$kc)(this.c,this.D(i)):h=(0,A.$kc)(this.c,i.workspace.id),this.B(h)}async B(i){try{const h=await p.Promises.readdir(i);for(const t of h)try{if((await p.Promises.readdir((0,A.$kc)(i,t))).length>0)return!0}catch{}}catch{}return!1}C(){const i={workspaces:this.d.map(({workspace:h,remoteAuthority:t})=>{const o={id:h.id,configURIPath:h.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.e.map(({folderUri:h,remoteAuthority:t})=>{const o={folderUri:h.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.g.map(({backupFolder:h,remoteAuthority:t})=>{const o={backupFolder:h};return t&&(o.remoteAuthority=t),o})};this.m.setItem($.a,i)}D(i){const h=i.folderUri;let t;return h.scheme===E.Schemas.file?t=O.$l?h.fsPath:h.fsPath.toLowerCase():t=h.toString().toLowerCase(),(0,n.createHash)("md5").update(t).digest("hex")}};e.$Hgc=k,e.$Hgc=k=$=Se([se(0,u.$2fc),se(1,g.$aj),se(2,f.$bk),se(3,m.$GR)],k)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[19],le([0,1,13,35,8,4,2,3,36,11,6,5,34,52,20]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.LifecycleMainPhase=e.ShutdownReason=e.$vgc=void 0,n=Ge(n),e.$vgc=(0,g.$Gi)("lifecycleMainService");var v;(function(k){k[k.QUIT=1]="QUIT",k[k.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(k){k[k.Starting=1]="Starting",k[k.Ready=2]="Ready",k[k.AfterWindowOpen=3]="AfterWindowOpen",k[k.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends O.$Vc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,i,h){super(),this.F=S,this.G=i,this.H=h,this.c=this.B(new A.$me),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.$me),this.onWillShutdown=this.f.event,this.g=this.B(new A.$me),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.$me),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.default.app.addListener("before-quit",S);const i=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",i),n.default.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.default.app.removeListener("before-quit",S),n.default.app.removeListener("window-all-closed",i),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}L(S){if(this.y)return this.y;const i=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:S,join(t,o){i.trace(`Lifecycle#onWillShutdown - begin '${t}'`),h.push(o.finally(()=>{i.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await E.Promises.settled(h)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const i=this.C.get(this.n);i&&(i.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let i=this.C.get(S);i||(i=new E.$Fh,this.C.set(S,i)),await i.wait()}registerWindow(S){const i=new O.$Uc;this.t++,i.add(S.onWillLoad(t=>this.g.fire({window:S,workspace:t.workspace,reason:t.reason})));const h=(0,c.$qg)(S.win);i.add(A.Event.fromNodeEventEmitter(h,"close")(t=>{const o=S.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),t.preventDefault(),this.unload(S,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(S),S.close()})})),i.add(A.Event.fromNodeEventEmitter(h,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,i.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(S){const i=(0,c.$qg)(S.win),h=new O.$Uc;h.add(A.Event.fromNodeEventEmitter(i,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),h.add(A.Event.fromNodeEventEmitter(i,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),h.dispose()}))}async reload(S,i){await this.unload(S,w.UnloadReason.RELOAD)||S.reload(i)}unload(S,i){const h=this.z.get(S.id);if(h)return h;const t=this.M(S,i).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,t),t}async M(S,i){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const h=this.j?w.UnloadReason.QUIT:i,t=await this.P(S,h);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(t)):(await this.Q(S,h),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,i){return new Promise(h=>{const t=this.s++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;r.$1X.once(o,()=>{h(!1)}),r.$1X.once(s,()=>{h(!0)}),S.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:i})})}Q(S,i){return new Promise(h=>{const o=`vscode:reply${this.s++}`;r.$1X.once(o,()=>h()),S.send("vscode:onWillUnload",{replyChannel:o,reason:i})})}quit(S){return this.R(S).then(i=>{if(!i&&S)try{if(I.$j){const h=(0,p.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return i})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(d.b,!0),this.u=new Promise(i=>{this.w=i,this.S("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const i=process.argv.slice(1);if(S?.addArgs&&i.push(...S.addArgs),S?.removeArgs)for(const o of S.removeArgs){const s=i.indexOf(o);s>=0&&i.splice(s,1)}const h=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:i}))};n.default.app.once("quit",h),await this.quit(!0)&&n.default.app.removeListener("quit",h)}async kill(S){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,E.$Hh)(1e3),(async()=>{for(const i of n.default.BrowserWindow.getAllWindows())if(i&&!i.isDestroyed()){let h;i.webContents&&!i.webContents.isDestroyed()?h=new Promise(t=>i.once("closed",t)):h=Promise.resolve(),i.destroy(),await h}})()]),n.default.app.exit(S)}};e.$wgc=$,e.$wgc=$=d=Se([se(0,u.$bk),se(1,m.$GR),se(2,f.$2fc)],$)}),define(ce[256],le([0,1,3,4,2,6,19]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=void 0,n=Pe(n),e.$6gc=(0,A.$Gi)("keyboardLayoutMainService");let I=class extends E.$Vc{constructor(g){super(),this.a=this.B(new r.$me),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((u,m)=>{x(["native-keymap"],u,m)}).then(Pe);this.c=p(g),n.$u||g.onDidChangeKeyboardLayout(()=>{this.c=p(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$7gc=I,e.$7gc=I=Se([se(0,O.$vgc)],I);function p(c){const g=c.getKeyMap(),u=c.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:u}}}),define(ce[257],le([0,1,217,8,17,15,11,16,38,100,5,49,216,254]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0,e.$js=v;let f=class extends u.$0p{constructor($,k,S,i){super(i),this.m=$,this.n=k,this.r=S,this.s(),this.B($.onDidChangeConfiguration(h=>{h.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,k){const{f:S,g:i}=this;let h;try{h=await(0,c.$Sm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(s)))}const t={...process.env,...h},o=$.agent?$.agent:await(0,m.$hs)($.url||"",t,{proxyUrl:S,strictSSL:i});return $.agent=o,$.strictSSL=i,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,k))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const k=await new Promise((o,s)=>{x(["kerberos"],o,s)}).then(Pe),S=new URL($),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${S.hostname}`:`HTTP@${S.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${S}`,`spn:${i}`),"Negotiate "+await(await k.initializeClient(i)).step("")}catch(k){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",k);return}}async loadCertificates(){return(await new Promise((k,S)=>{x(["@vscode/proxy-agent"],k,S)}).then(Pe)).loadSystemCertificates({log:this.r})}};e.$is=f,e.$is=f=Se([se(0,I.$aj),se(1,p.$Oi),se(2,g.$bk),se(3,g.$ck)],f);async function d(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((S,i)=>{x(["https"],S,i)}).then(Pe):await new Promise((S,i)=>{x(["http"],S,i)}).then(Pe)).request}async function v(b,$){return r.Promises.withAsyncBody(async(k,S)=>{const i=(0,n.parse)(b.url),h=b.getRawRequest?b.getRawRequest(b):await d(b),t={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,O.$lg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(t.auth=b.user+":"+b.password);const o=h(t,s=>{const a=(0,O.$jg)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:a-1},$).then(k,S);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),k({res:s,stream:(0,E.$4e)(l)})}});o.on("error",S),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),S(new A.$5)})})}}),define(ce[258],le([0,1,13,257]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;function E(O){return n.net.request}class A extends r.$is{request(I,p){return super.request({...I||{},getRawRequest:E,isChromiumNetwork:!0},p)}}e.$$hc=A}),define(ce[87],le([0,1,7,4,2,38,14,6,19,5,62,251,42,58,41,12]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=e.$Bgc=void 0,e.$Bgc=(0,I.$Gi)("storageMainService");let v=class extends E.$Vc{constructor(k,S,i,h,t,o){super(),this.c=k,this.f=S,this.g=i,this.h=h,this.j=t,this.m=o,this.a=void 0,this.b=this.B(new r.$me),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)k.join("profileStorage",S.close());for(const[,S]of this.w)k.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.j.exists(k.profile.globalStorageHome)||await this.j.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.t.get(k.profile.id);S&&k.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const k=new u.$ygc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),k}profileStorage(k){if((0,g.$mq)(k))return this.applicationStorage;let S=this.t.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.B(this.u(k)),this.t.set(k.id,S);const i=this.B(S.onDidChangeStorage(h=>this.b.fire({...h,storage:S,profile:k})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.t.delete(k.id),i.dispose()}))}return S}u(k){return this.a===p.ShutdownReason.KILL?new u.$Agc(this.c,this.j):new u.$xgc(k,this.n(),this.c,this.j)}workspaceStorage(k){let S=this.w.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.B(this.y(k)),this.w.set(k.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.w.delete(k.id)}))),S}y(k){return this.a===p.ShutdownReason.KILL?new u.$Agc(this.c,this.j):new u.$zgc(k,this.n(),this.c,this.f,this.j)}isUsed(k){const S=n.URI.file(k);for(const i of[this.applicationStorage,...this.t.values(),...this.w.values()])if(i.path&&this.m.extUri.isEqualOrParent(n.URI.file(i.path),S))return!0;return!1}};e.$Cgc=v,e.$Cgc=v=Se([se(0,c.$bk),se(1,A.$Ni),se(2,w.$fgc),se(3,p.$vgc),se(4,O.$bl),se(5,f.$Ll)],v),e.$Dgc=(0,I.$Gi)("applicationStorageMainService");let b=class extends g.$lq{constructor(k,S){super(),this.s=k,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(k){if(k===g.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(k){if(k===g.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Egc=b,e.$Egc=b=Se([se(0,m.$Nl),se(1,e.$Bgc)],b)}),define(ce[259],le([0,1,93,27,113,104,8,2,3,16,5,28,210,213,101,131,17]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0,n=Pe(n),r=Pe(r);async function b(h,t,o,s,a){let l;for(let P=3;P&&(l?.dispose(),l=await new $(h,t,o,s,a).waitForReady(),!(a&&E.$6g[a]||!E.$6g[l.tunnelLocalPort]));P--);return l}class $ extends I.$Vc{constructor(t,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=n.createServer(),this.c=new O.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=P=>this.r(P),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,o=(0,d.$Qw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,E.$7g)(t,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(t){t.pause();const o=(0,d.$Ow)(this.tunnelRemoteHost)||(0,d.$Qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$4l)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&t.write(l.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),a.end()}),t.on("close",()=>a.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),a instanceof A.$vi?a.socket.destroy():a.end()}),a instanceof A.$vi?this.t(t,a):this.s(t,a),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),a.end()})}s(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(s=>t.write(s.buffer)),t.on("data",s=>o.write(v.$Oe.wrap(s))),t.resume()}t(t,o){const s=o.socket;s.on("end",()=>t.end()),s.on("close",()=>t.end()),s.on("error",()=>{t.destroy()}),s.pipe(t),t.pipe(s)}}e.$7hc=$;let k=class extends d.$Tw{constructor(t,o,s,a,l){super(o,l),this.H=t,this.I=s,this.J=a}isPortPrivileged(t){return(0,d.$Rw)(t,this.t,p.OS,r.release())}F(t,o,s,a,l,P,y,D){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,d.$Kw)(t))return this.G(t,o,s,l,P,y,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const R={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},T=b(R,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,T),T}}};e.$8hc=k,e.$8hc=k=Se([se(0,w.$Xl),se(1,g.$bk),se(2,f.$1l),se(3,u.$uk),se(4,c.$aj)],k);let S=class extends k{constructor(t,o,s,a,l){super(t,o,s,a,l)}};e.$9hc=S,e.$9hc=S=Se([se(0,w.$Xl),se(1,g.$bk),se(2,f.$1l),se(3,u.$uk),se(4,c.$aj)],S);let i=class extends I.$Vc{constructor(t,o,s,a,l){super(),this.b=t,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(t,o,s,a,l,P,y,D,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${P}.`),!this.a.has(t)){const R=new S(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(t,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(o,s,a,l,P,y,D,L)}};e.$0hc=i,e.$0hc=i=Se([se(0,w.$Xl),se(1,g.$bk),se(2,u.$uk),se(3,f.$1l),se(4,c.$aj)],i)}),define(ce[105],le([0,1,8,22,4,16,20,19,5,28,49,50]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0,e.$qhc=m;function m(f,d,v){return`${v.updateUrl}/api/update/${f}/${d}/${v.commit}`}let w=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,v,b,$,k,S){this.f=d,this.g=v,this.h=b,this.i=$,this.j=k,this.k=S,this.b=u.$YY.Uninitialized,this.c=new E.$me,this.onStateChange=this.c.event,d.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(u.$YY.Disabled(u.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(u.$YY.Disabled(u.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(u.$YY.Disabled(u.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.g.getValue("update.mode"),v=this.m(d);if(!v){this.d(u.$YY.Disabled(u.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(u.$YY.Disabled(u.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(u.$YY.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,n.$Hh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(d){}q(){return u.UpdateType.Archive}r(){}};e.$rhc=w,e.$rhc=w=Se([se(0,I.$vgc),se(1,A.$aj),se(2,O.$2fc),se(3,g.$9p),se(4,p.$bk),se(5,c.$uk)],w)}),define(ce[260],le([0,1,13,54,4,46,2,16,20,19,5,28,49,24,50,105]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0,n=Pe(n);let v=class extends d.$rhc{get v(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,k)=>k)}get w(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,k,S,i)=>({version:S,productVersion:S,timestamp:i}))}constructor($,k,S,i,h,t,o){super($,k,i,h,t,o),this.z=S,this.u=new O.$Uc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,A.$uj)(String($)))}),this.j.error("UpdateService error:",$);const k=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$YY.Idle(f.UpdateType.Archive,k))}s($){let k;this.k.darwinUniversalAssetId?k=this.k.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,d.$qhc)(k,$,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(i){this.j.error("Failed to set update feed URL",i);return}return S}t($){this.d(f.$YY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$YY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$YY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$YY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$YY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$shc=v,Se([r.$$h],v.prototype,"v",null),Se([r.$$h],v.prototype,"w",null),Se([r.$$h],v.prototype,"x",null),Se([r.$$h],v.prototype,"y",null),e.$shc=v=Se([se(0,c.$vgc),se(1,I.$aj),se(2,w.$am),se(3,p.$2fc),se(4,m.$9p),se(5,g.$bk),se(6,u.$uk)],v)}),define(ce[261],le([0,1,48,26,8,4,9,20,19,5,24,50]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0,O=Pe(O);let m=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,v,b){if(this.f=d,this.g=b,this.a=u.$YY.Uninitialized,this.b=new A.$me,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(u.$YY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(d=60*60*1e3){return(0,E.$Hh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return u.UpdateType.Snap}l(){}async _applySpecificUpdate(d){}};m=Se([se(0,p.$vgc),se(1,I.$2fc),se(2,c.$bk)],m);let w=class extends m{constructor(d,v,b,$,k,S){super(b,$,k),this.o=d,this.p=v,this.q=S;const i=(0,r.watch)(O.$nc(this.o)),h=A.Event.fromNodeEventEmitter(i,"change",(a,l)=>l),t=A.Event.filter(h,a=>a==="current"),s=A.Event.debounce(t,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),i.close()})}m(){this.d(u.$YY.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(u.$YY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$YY.Idle(u.UpdateType.Snap)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$YY.Idle(u.UpdateType.Snap,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+O.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((b,$)=>(0,r.realpath)(`${O.$nc(this.o)}/current`,(k,S)=>k?$(k):b(S))),v=O.$oc(d);return this.p!==v}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$uhc=w,e.$uhc=w=Se([se(2,p.$vgc),se(3,I.$2fc),se(4,c.$bk),se(5,g.$am)],w)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[29],le([0,1,13,141,9,3,16,20,6,28,76,51,52]),function(x,e,n,r,E,A,O,I,p,c,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$cgc=void 0,e.$dgc=f,e.$egc=d,n=Ge(n),e.$cgc=(0,p.$Gi)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,k,S){const i=b.get(g.$agc),h=b.get(c.$uk),t=b.get(O.$aj),o=b.get(I.$2fc),s=t.getValue("window"),a={backgroundColor:i.getBackgroundColor(),minWidth:u.$_D.WIDTH,minHeight:u.$_D.HEIGHT,title:h.nameLong,show:$.mode!==m.WindowMode.Maximized&&$.mode!==m.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...S,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$lE)($.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(A.$l?a.icon=(0,E.$kc)(o.appRoot,"resources/linux/code.png"):A.$j&&!o.isBuilt&&(a.icon=(0,E.$kc)(o.appRoot,"resources/win32/code_150x150.png")),A.$k&&(a.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(a.acceptFirstMouse=!1)),k?.disableFullscreen?a.fullscreen=!1:A.$k&&!(0,u.$kE)(t)&&(a.fullscreenable=!1),A.$k&&s?.nativeTabs===!0&&(a.tabbingIdentifier=h.nameShort),!(0,u.$gE)(t,k?.forceNativeTitlebar?u.TitlebarStyle.NATIVE:void 0)&&(a.titleBarStyle="hidden",A.$k||(a.frame=!1),(0,u.$jE)(t))){const y=i.getWindowSplash()?.colorInfo.titleBarBackground??i.getBackgroundColor(),D=r.$ru.fromHex(y).isDarker()?"#FFFFFF":"#000000";a.titleBarOverlay={height:29,color:y,symbolColor:D}}return a}function d(b){let $,k=Number.MIN_VALUE;for(const S of b)S.lastFocusTime>k&&(k=S.lastFocusTime,$=S);return $}var v;(function(b){function $(S,i,h=n.default.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${h.length} display(s)`,i),typeof i.x!="number"||typeof i.y!="number"||typeof i.width!="number"||typeof i.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(i.width<=0||i.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(h.length===1){const s=k(h[0]);if(S.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!i||typeof i.x!="number"||typeof i.y!="number"||!s||(i.x<s.x&&(i.x=s.x),i.y<s.y&&(i.y=s.y))};a(),i.width>s.width&&(i.width=s.width),i.height>s.height&&(i.height=s.height),i.x>s.x+s.width-128&&(i.x=s.x+s.width-i.width),i.y>s.y+s.height-128&&(i.y=s.y+s.height-i.height),a()}return i}if(i.display&&i.mode===m.WindowMode.Fullscreen){const s=h.find(a=>a.id===i.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,m.$4fc)(m.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let t,o;try{t=n.default.screen.getDisplayMatching({x:i.x,y:i.y,width:i.width,height:i.height}),o=k(t),S.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){S.error("window#validateWindowState: error finding display for window state",s)}if(t&&o&&i.x+i.width>o.x&&i.y+i.height>o.y&&i.x<o.x+o.width&&i.y<o.y+o.height)return i;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function k(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(v||(e.WindowStateValidator=v={}))}),define(ce[262],le([0,1,93,169,120,29]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class O extends r.$1o{constructor(p){super(),this.f=p}call(p,c,g){return c==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(p,c,g)}async g(p,c){const g=(0,E.$Em)(p,E.$Dm);g.debugRenderer=c;const u=g.extensionDevelopmentPath;if(!u)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(u,{context:A.OpenContext.API,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!c)return{success:!0};const w=m.win;if(!w)return{success:!0};const f=w.webContents.debugger;let d=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{d++===0&&f.attach();let $=!1;const k=h=>{$||b.write(JSON.stringify(h)+"\0")},S=(h,t,o,s)=>k({method:t,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",S),b.end(),$=!0}),f.addListener("message",S);let i=Buffer.alloc(0);b.on("data",h=>{i=Buffer.concat([i,h]);for(let t=i.indexOf(0);t!==-1;t=i.indexOf(0)){let o;try{const s=i.slice(0,t).toString("utf8");i=i.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>k({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>k({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",h=>{console.error("error on cdp pipe:",h)}),b.on("close",()=>{$=!0,--d===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$Igc=O}),define(ce[263],le([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(x,e,n,r,E,A,O,I,p,c,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=e.ID=void 0,e.ID="launchMainService",e.$9gc=(0,c.$Gi)(e.ID);let w=class{constructor(d,v,b,$){this.a=d,this.b=v,this.c=b,this.d=$}async start(d,v){this.a.trace("Received data from other instance: ",d,v),E.$k&&n.app.focus({steal:!0});const b=this.e(d);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,r.$Ob)(await this.b.openEmptyWindow({context:m.OpenContext.DESKTOP}));k&&($=k.ready())}$.then(()=>{for(const{uri:k,originalUrl:S}of b)this.c.open(k,{originalUrl:S})})}else return this.f(d,v)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,r.$Hb)(d._urls.map(v=>{try{return{uri:A.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(d,v){const b=(0,p.$Lm)(v)?m.OpenContext.CLI:m.OpenContext.DESKTOP;let $=[];const k=d.wait&&d.waitMarkerFilePath?A.URI.file(d.waitMarkerFilePath):void 0,S=d.remote||void 0,i={context:b,cli:d,userEnv:d["preserve-env"]||b===m.OpenContext.CLI?v:void 0,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,i);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let h=!1;if(d["new-window"]||i.forceProfile||i.forceTempProfile)h=!0;else if(d["reuse-window"])h=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":h=!0;break;case"off":h=!1;break;default:h=!E.$k}if(h)$=await this.b.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const t=this.b.getLastActiveWindow();t?(this.b.openExistingWindow(t,i),$=[t]):$=await this.b.open({...i,forceEmpty:!0})}}else $=await this.b.open({...i,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(k&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,O.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$0gc=w,e.$0gc=w=Se([se(0,g.$bk),se(1,m.$cgc),se(2,u.$PY),se(3,I.$aj)],w)}),define(ce[135],le([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,m.$Gi)("proxyAuthService");let b=class extends O.$Vc{constructor(k,S,i,h,t,o){super(),this.h=k,this.m=S,this.n=i,this.r=h,this.s=t,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const k=E.Event.fromNodeEventEmitter(n.app,"login",(S,i,h,t,o)=>({event:S,authInfo:{...t,attempt:h.firstAuthAttempt?1:2},callback:o}));this.B(k(this.w,this))}async lookupAuthorization(k){return this.w({authInfo:k})}async w({event:k,authInfo:S,callback:i}){if(!S.isProxy)return;k?.preventDefault();const h=String((0,A.$uj)({scheme:S.scheme,host:S.host,port:S.port}));let t,o=this.b.get(h);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(S,h),this.b.set(h,o);try{t=await o}finally{this.b.delete(h)}}return i?.(t?.username,t?.password),t}async y(k,S){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const i=await this.z(k,S);if(i)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),i;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(k,S){if(this.h.trace("auth#doResolveProxyCredentials - enter",k),this.t.extensionTestsLocationURI){const l=this.s.getValue("integration-test.http.proxyAuth");if(l){const P=l.indexOf(":");return P!==-1?{username:l.substring(0,P),password:l.substring(P+1)}:{username:l,password:""}}return}const i=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(i?.indexOf("@")!==-1){const l=I.URI.parse(i),P=l.authority.indexOf("@");if(P!==-1){if(k.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const y=l.authority.substring(0,P),D=y.indexOf(":");return D!==-1?{username:y.substring(0,D),password:y.substring(D+1)}:{username:y,password:""}}}const h=k.attempt===1&&this.g.get(S);if(h){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:l,password:P}=h;return{username:l,password:P}}let t,o;try{const l=this.r.get(this.a+S,f.StorageScope.APPLICATION);if(l){const P=JSON.parse(await this.n.decrypt(l));t=P.username,o=P.password}}catch(l){this.h.error(l)}if(k.attempt===1&&typeof t=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(S,{username:t,password:o}),{username:t,password:o};const s=this.c,a=this.c=(async()=>{await s;const l=await this.C(k,S,t,o);return this.c===a&&(this.c=void 0),l})();return a}async C(k,S,i,h){if(this.f.has(S)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.g.get(S),s={authInfo:k,username:o?.username??i,password:o?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,p.$3g)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,s);const a=await new Promise(l=>{const P=async(y,D,L)=>{if(D===s.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",P),L){const R={username:L.username,password:L.password};try{if(L.remember){const T=await this.n.encrypt(JSON.stringify(R));this.r.store(this.a+S,T,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+S,f.StorageScope.APPLICATION)}catch(T){this.h.error(T)}l({username:R.username,password:R.password})}else this.f.add(S),l(void 0)};t.win?.webContents.on("ipc-message",P)});return this.g.set(S,a),a}};e.$Ggc=b,e.$Ggc=b=Se([se(0,w.$bk),se(1,v.$cgc),se(2,g.$JY),se(3,d.$Dgc),se(4,c.$aj),se(5,u.$2fc)],b)}),define(ce[264],le([0,1,2,19,52,58,30,8,29]),function(x,e,n,r,E,A,O,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;let c=class extends n.$Vc{constructor(u,m,w){super(),this.a=m,this.b=w,this.B(u.onWillLoadWindow(f=>{f.reason===E.LoadReason.LOAD&&this.c(f.window)})),this.B(u.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Sh(()=>this.g(),30*1e3)).schedule()}async c(u){const m=this.f(u),w=this.a.getProfileForWorkspace(m);w?.isTransient&&(this.a.unsetWorkspace(m,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(u){return u.openedWorkspace??(0,O.$Ui)(u.backupPath,u.isExtensionDevelopmentHost)}g(){const u=this.a.getAssociatedEmptyWindows();if(u.length===0)return;const m=this.b.getWindows().map(w=>this.f(w));for(const w of u)m.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$Mhc=c,e.$Mhc=c=Se([se(0,r.$vgc),se(1,A.$fgc),se(2,p.$cgc)],c)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[63],le([0,1,13,2,4,5,284,8,12,29,81,24,19,79,37,3,106,11]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0,g=Ge(g);function k(h){return typeof h.responseWindowId=="number"}let S=class extends r.$Vc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,s){super(),this.w=t,this.y=o,this.z=s,this.c=String(++$.a),this.f=this.B(new E.$me),this.onStdout=this.f.event,this.g=this.B(new E.$me),this.onStderr=this.g.event,this.h=this.B(new E.$me),this.onMessage=this.h.event,this.j=this.B(new E.$me),this.onSpawn=this.j.event,this.m=this.B(new E.$me),this.onExit=this.m.event,this.n=this.B(new E.$me),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,o){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case g.default.Error:this.w.error(s);break;case g.default.Warning:this.w.warn(s);break;case g.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const o=this.F(t);return o&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",g.default.Info),o}F(t){if(!this.D())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,s=p.$1g.asFileUri("bootstrap-fork.js").fsPath,a=this.t.args??[],l=this.t.execArgv??[],P=this.t.allowLoadingUnsignedLibraries,y=this.t.forceAllocationsToV8Sandbox,D=this.t.respondToAuthRequestsFromMainProcess,L="pipe",R=this.G(t);return this.C("creating new...",g.default.Info),this.r=n.utilityProcess.fork(s,a,(0,b.$xg)({serviceName:o,env:R,execArgv:l,allowLoadingUnsignedLibraries:P,forceAllocationsToV8Sandbox:y,respondToAuthRequestsFromMainProcess:D,stdio:L})),this.H(this.r,this.t,o),!0}G(t){const o=t.env?{...t.env}:{...(0,f.$fo)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,d.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$nm)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}H(t,o,s){if(t.stdout){const a=new O.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stdout,"data")(l=>this.f.fire(typeof l=="string"?l:a.write(l))))}if(t.stderr){const a=new O.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stderr,"data")(l=>this.g.fire(typeof l=="string"?l:a.write(l))))}this.B(E.Event.fromNodeEventEmitter(t,"message")(a=>this.h.fire(a))),this.B(E.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:k(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.C("successfully created",g.default.Info),this.j.fire(t.pid)})),this.B(E.Event.fromNodeEventEmitter(t,"exit")(a=>{const l=this.I(a)?0:a;this.C(`received exit event with code ${l}`,g.default.Info),this.m.fire({pid:this.s,code:l,signal:"unknown"}),this.J()})),this.B(E.Event.fromNodeEventEmitter(n.app,"child-process-gone",(a,l)=>({event:a,details:l}))(({details:a})=>{a.type==="Utility"&&a.name===s&&!this.I(a.exitCode)&&(this.C(`crashed with code ${a.exitCode} and reason '${a.reason}'`,g.default.Error),this.y.publicLog2("utilityprocesscrash",{type:o.type,reason:a.reason,code:a.exitCode}),this.n.fire({pid:this.s,code:a.exitCode,reason:a.reason}),this.J())}))}once(t,o){const s=this.B(this.h.event(a=>{a===t&&(s.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",g.default.Info),this.r.kill()?(this.C("successfully killed the process",g.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",g.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",g.default.Info),await Promise.race([E.Event.toPromise(this.onExit),(0,I.$Hh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$Jgc=S,e.$Jgc=S=$=Se([se(0,A.$bk),se(1,u.$am),se(2,m.$vgc)],S);let i=class extends S{constructor(t,o,s,a){super(t,s,a),this.L=o}start(t){const o=this.L.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.F(t))return!1;this.M(o.win,t);const a=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[a]),!0}M(t,o){o.windowLifecycleBound&&(this.B(E.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(E.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Kgc=i,e.$Kgc=i=Se([se(0,A.$bk),se(1,c.$cgc),se(2,u.$am),se(3,m.$vgc)],i)}),define(ce[265],le([0,1,8,15,4,2,19,5,24,63,29]),function(x,e,n,r,E,A,O,I,p,c,g){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;let m=class extends A.$Vc{static{u=this}static{this.a=0}constructor(f,d,v,b){super(),this.f=f,this.g=d,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const d=this.b.get(f);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$6)();const f=String(++u.a),d=new c.$Kgc(this.f,this.h,this.j,this.g);this.b.set(f,d);const v=d.onExit(({pid:b,code:$,signal:k})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${k}.`),setTimeout(()=>{d.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,d){if(this.c)throw(0,r.$6)();const v=this.m(f);return v.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await E.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$6)();const d=this.b.get(f);return d?d.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$6)();const d=this.b.get(f);d&&d.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(f));return n.Promises.settled(d).then(()=>{})}};e.$Rgc=m,e.$Rgc=m=u=Se([se(0,I.$bk),se(1,O.$vgc),se(2,g.$cgc),se(3,p.$am)],m)}),define(ce[266],le([0,1,35,8,2,20,19,5,42,40,71,63,57,95,11,218,4]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let b=class extends E.$Vc{constructor(k,S,i,h,t,o,s,a,l){super(),this.g=k,this.h=S,this.j=i,this.m=h,this.n=t,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Fh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$me),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$1X.on(d.$ihc.request,(k,S)=>this.y(k,S,d.$ihc.response)),n.$1X.on(d.$jhc.request,(k,S)=>this.y(k,S,d.$jhc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(k,S,i){this.s.trace(`[SharedProcess] onWindowConnection for: ${i}`),this.a.isOpen()||this.a.open(),await this.whenReady();const h=await this.connect(i);if(k.sender.isDestroyed())return h.close();k.sender.postMessage(i,S,[h])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(d.$hhc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const k=new r.$4h;this.b?.once(d.$hhc.initDone,()=>k.complete()),await k.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const k=new r.$4h;this.b?.once(d.$hhc.ipcReady,()=>k.complete()),await k.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new u.$Jgc(this.s,m.$Ap,this.r)),this.c=this.b.onMessage(i=>{typeof i.warning=="string"?this.s.warn(i.warning):typeof i.error=="string"&&this.s.error(i.error)});const k=(0,w.$_m)(this.m.args,this.m.isBuilt);let S;k.port&&(S=["--nolazy"],k.break?S.push(`--inspect-brk=${k.port}`):S.push(`--inspect=${k.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(k){return await this.F,(0,f.$qg)(this.b).connect(k)}};e.$khc=b,e.$khc=b=Se([se(3,A.$2fc),se(4,p.$Nl),se(5,O.$vgc),se(6,I.$bk),se(7,g.$qgc),se(8,c.$uo)],b)}),define(ce[267],le([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,12]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let v=class extends u.$Vc{constructor($,k,S,i,h){super(),this.f=$,this.g=k,this.h=S,this.j=i,this.m=h,this.a=void 0,this.b=new m.$me,this.onRequestConnection=this.b.event,this.c=new m.$me,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),g.$1X.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,u.$Tc)(()=>{g.$1X.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$Jgc(this.m,O.$Ap,this.j);const $=(0,r.$$m)(this.h.args,this.h.isBuilt),k=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:k,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),i=new c.$9X(S,"ptyHost"),h=new u.$Uc;return h.add(i),h.add((0,u.$Tc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:i,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$fo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);k&&typeof k=="number"&&($.VSCODE_LATENCY=String(k));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&($.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),$}r($,k){this.b.fire();const S=this.a.connect();if($.sender.isDestroyed()){S.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",k,[S])}};e.$Yhc=v,e.$Yhc=v=Se([se(1,f.$aj),se(2,n.$2fc),se(3,E.$vgc),se(4,A.$bk)],v)}),define(ce[268],le([0,1,2,6,5,29,63,24,46,4,8,19]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0,e.$Whc=(0,r.$Gi)("utilityProcessWorker");let m=class extends n.$Vc{constructor(d,v,b,$){super(),this.b=d,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(d){const v=`window: ${d.reply.windowId}, moduleId: ${d.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(d);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(d));const $=new w(this.b,this.c,this.f,this.g,d);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const k=new g.$4h;return c.Event.once($.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(b),k.complete({reason:S})}),k.p}h(d){return(0,p.$uj)({moduleId:d.process.moduleId,windowId:d.reply.windowId})}async disposeWorker(d){const v=this.h(d),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${d.reply.windowId}, moduleId: ${d.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$Xhc=m,e.$Xhc=m=Se([se(0,E.$bk),se(1,A.$cgc),se(2,I.$am),se(3,u.$vgc)],m);let w=class extends n.$Vc{constructor(d,v,b,$,k){super(),this.c=d,this.f=v,this.g=b,this.h=$,this.j=k,this.a=this.B(new c.$me),this.onDidTerminate=this.a.event,this.b=this.B(new O.$Kgc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(d=>this.a.fire({code:d.code,signal:d.signal}))),this.B(this.b.onCrash(d=>this.a.fire({code:d.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Se([se(0,E.$bk),se(1,A.$cgc),se(2,I.$am),se(3,u.$vgc)],w)}),define(ce[269],le([0,1,13,4,2,243,29]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let I=class extends E.$Vc{constructor(c){super(),this.b=c,this.a=this.B(new r.$me),this.onFoundInFrame=this.a.event,this.B(new A.$Bhc)}async setIgnoreMenuShortcuts(c,g){let u;if(typeof c.windowId=="number"){const{windowId:m}=c,w=this.b.getWindowById(m);if(!w?.win)throw new Error(`Invalid windowId: ${m}`);u=w.win.webContents}else{const{webContentsId:m}=c;if(u=n.webContents.fromId(m),!u)throw new Error(`Invalid webContentsId: ${m}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(g)}async findInFrame(c,g,u,m){const f=this.c(c,g);if(typeof f.findInFrame=="function"){f.findInFrame(u,{findNext:m.findNext,forward:m.forward});const d=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",d))};f.on("found-in-frame",d)}}async stopFindInFrame(c,g,u){const w=this.c(c,g);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}c(c,g){const u=this.b.getWindowById(c.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${c}`);const m=u.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===g);if(!m)throw new Error(`Unknown frame: ${g}`);return m}};e.$Chc=I,e.$Chc=I=Se([se(0,O.$cgc)],I)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[270],le([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0,e.$Ehc=v,e.$Fhc=$,n=Ge(n);let d=class extends r.$Vc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(i,h,t,o,s){super(),this.g=i,this.h=h,this.j=t,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(i=>this.u(i))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(i=>{i.newCount-i.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(i=>this.u(i)))}s(){this.f=!0,this.t()}t(){const i=new Set,h={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!h.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(h.lastActiveWindow=this.w(s),h.lastActiveWindow.uiState.mode===m.WindowMode.Fullscreen&&i.add(h.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);t&&(h.lastPluginDevelopmentHostWindow=this.w(t),h.lastPluginDevelopmentHostWindow.uiState.mode===m.WindowMode.Fullscreen&&(i.has(h.lastPluginDevelopmentHostWindow.uiState.display)?E.$k&&!t.win?.isSimpleFullScreen()&&(h.lastPluginDevelopmentHostWindow.uiState.mode=m.WindowMode.Normal):i.add(h.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(h.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===m.WindowMode.Fullscreen&&(i.has(a.uiState.display)?E.$k&&a.windowId!==h.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=m.WindowMode.Normal):i.add(a.uiState.display)),a}));const o=$(h);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(i){if(this.j.quitRequested)return;const h=this.w(i);i.isExtensionDevelopmentHost&&!i.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=h:!i.isExtensionDevelopmentHost&&i.openedWorkspace&&this.b.openedWindows.forEach(t=>{const o=(0,w.$Vi)(i.openedWorkspace)&&t.workspace?.id===i.openedWorkspace.id,s=(0,w.$Qi)(i.openedWorkspace)&&t.folderUri&&A.$$g.isEqual(t.folderUri,i.openedWorkspace.uri);(o||s)&&(t.uiState=h.uiState)}),this.g.getWindowCount()===1&&(this.c=h)}w(i){return{windowId:i.id,workspace:(0,w.$Vi)(i.openedWorkspace)?i.openedWorkspace:void 0,folderUri:(0,w.$Qi)(i.openedWorkspace)?i.openedWorkspace.uri:void 0,backupPath:i.backupPath,remoteAuthority:i.remoteAuthority,uiState:i.serializeWindowState()}}getNewWindowState(i){const h=this.z(i),t=this.n.getValue("window");if(h.mode===m.WindowMode.Fullscreen){let o;h.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||t?.restoreFullscreen),o||(h.mode=m.WindowMode.Normal)}return h}z(i){const h=this.g.getLastActiveWindow();if(!i.extensionTestsPath){if(i.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=i.workspace;if((0,w.$Vi)(P)){const D=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===P.id).map(L=>L.uiState);if(D.length)return D[0]}if((0,w.$Qi)(P)){const D=this.state.openedWindows.filter(L=>L.folderUri&&A.$$g.isEqual(L.folderUri,P.uri)).map(L=>L.uiState);if(D.length)return D[0]}else if(i.backupPath){const D=this.state.openedWindows.filter(L=>L.backupPath===i.backupPath).map(L=>L.uiState);if(D.length)return D[0]}const y=this.c||this.state.lastActiveWindow;if(!h&&y)return y.uiState}let t;const o=n.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(E.$k){const P=n.default.screen.getCursorScreenPoint();t=n.default.screen.getDisplayNearestPoint(P)}!t&&h&&(t=n.default.screen.getDisplayMatching(h.getBounds())),t||(t=n.default.screen.getPrimaryDisplay()||o[0])}let s=(0,m.$4fc)();s.x=Math.round(t.bounds.x+t.bounds.width/2-s.width/2),s.y=Math.round(t.bounds.y+t.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=m.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=m.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&h){const P=h.serializeWindowState();P.mode===m.WindowMode.Fullscreen?s.mode=m.WindowMode.Fullscreen:s={...P,zoomLevel:void 0},l=s.mode!==m.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(i){if(this.g.getWindows().length===0)return i;i.x=typeof i.x=="number"?i.x:0,i.y=typeof i.y=="number"?i.y:0;const h=this.g.getWindows().map(t=>t.getBounds());for(;h.some(t=>t.x===i.x||t.y===i.y);)i.x+=30,i.y+=30;return i}};e.$Dhc=d,e.$Dhc=d=f=Se([se(0,u.$cgc),se(1,g.$GR),se(2,p.$vgc),se(3,c.$bk),se(4,I.$aj)],d);function v(S){const i={openedWindows:[]},h=S||{openedWindows:[]};return h.lastActiveWindow&&(i.lastActiveWindow=b(h.lastActiveWindow)),h.lastPluginDevelopmentHostWindow&&(i.lastPluginDevelopmentHostWindow=b(h.lastPluginDevelopmentHostWindow)),Array.isArray(h.openedWindows)&&(i.openedWindows=h.openedWindows.map(t=>b(t))),i}function b(S){const i={uiState:S.uiState};return S.backupPath&&(i.backupPath=S.backupPath),S.remoteAuthority&&(i.remoteAuthority=S.remoteAuthority),S.folder&&(i.folderUri=O.URI.parse(S.folder)),S.workspaceIdentifier&&(i.workspace={id:S.workspaceIdentifier.id,configPath:O.URI.parse(S.workspaceIdentifier.configURIPath)}),i}function $(S){return{lastActiveWindow:S.lastActiveWindow&&k(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&k(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(i=>k(i))}}function k(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[59],le([0,1,26,13,4,43,2,12,9,18,23,10,69,53,20,6,5,58,134,30,102,103]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0,n=Pe(n),r=Ge(r),e.$ogc=(0,d.$Gi)("workspacesManagementMainService");let h=class extends O.$Vc{constructor(o,s,a,l,P){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=P,this.a=this.B(new E.$me),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new E.$me),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await g.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$hh)(this.c,s,k.$6i));for(const s of o){const a=(0,i.$lgc)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,k.$7i)(o,this.g)||(0,k.$_i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,i.$lgc)(o);return{id:l.id,configPath:l.configPath,folders:(0,S.$qib)(a.folders,l.configPath,c.$$g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,A.$Zn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,S.$oib)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),P=a.configPath.fsPath;return await n.promises.mkdir((0,p.$nc)(P),{recursive:!0}),await g.Promises.writeFile(P,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$hh)(this.c,a),P=(0,c.$hh)(l,k.$6i),y=[];for(const D of o)y.push((0,S.$pib)(D.uri,!0,D.name,l,c.$$g));return{workspace:(0,i.$lgc)(P),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,i.$lgc)(o)}isUntitledWorkspace(o){return(0,k.$7i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$8g)(o.configPath);try{await g.Promises.rm((0,p.$nc)(s));const a=(0,p.$kc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await g.Promises.exists(a)&&await g.Promises.writeFile((0,p.$kc)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const P=await this.C(o,(0,i.$lgc)(a));if(P)return this.b.fire({window:o,workspace:P.workspace}),P}async z(o,s,a){return a?(0,k.$Vi)(o.openedWorkspace)&&c.$$g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$igc)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,u.localize)(2487,null)],message:(0,u.localize)(2488,null,(0,c.$eh)(a)),detail:(0,u.localize)(2489,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,k.$Vi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$pgc=h,e.$pgc=h=Se([se(0,f.$2fc),se(1,v.$bk),se(2,b.$fgc),se(3,m.$9fc),se(4,w.$0fc)],h)}),define(ce[136],le([0,1,13,35,22,6,29,30,59,11,5,63]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Mgc=(0,A.$Gi)(e.ID);let m=class{constructor(f,d,v){this.a=f,this.b=d,this.c=v}async getRemoteDiagnostics(f){const d=this.a.getWindows();return(await Promise.all(d.map(async b=>{const $=b.remoteAuthority;if(!$)return;const k=`vscode:getDiagnosticInfoResponse${b.id}`,S={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(i=>{b.sendWhenReady("vscode:getDiagnosticInfo",E.CancellationToken.None,{replyChannel:k,args:S}),r.$1X.once(k,(h,t)=>{t||i({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),i(t)}),setTimeout(()=>{i({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const d=[];for(const{pid:v,name:b}of u.$Jgc.getAll())d.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:d,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const d=await this.f(f),v=(0,c.$qg)(f.win);return this.e(v,d,f.remoteAuthority)}e(f,d=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:v}}async f(f){const d=[],v=f.openedWorkspace;if((0,I.$Qi)(v))d.push(v.uri);else if((0,I.$Vi)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(k=>{d.push(k.uri)})}return d}};e.$Ngc=m,e.$Ngc=m=Se([se(0,O.$cgc),se(1,p.$ogc),se(2,g.$bk)],m)}),define(ce[64],le([0,1,26,48,13,27,156,54,4,2,12,9,3,7,112,92,23,113,10,53,20,6,19,5,28,76,29,30,59,17,214,204,84,15,16,135,49]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R,T,N,V,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=void 0,n=Pe(n),e.$2gc=(0,i.$Gi)("nativeHostMainService");let Y=class extends c.$Vc{constructor(q,Q,U,Z,W,j,C,X,oe,G,ue,re){super(),this.a=q,this.b=Q,this.c=U,this.f=Z,this.g=W,this.h=j,this.j=C,this.m=X,this.n=oe,this.r=G,this.s=ue,this.t=re,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:M,y:F})=>({windowId:J.id,x:M,y:F})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:J,x:M,y:F})=>({windowId:J.id,x:M,y:F}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,J=>J.id),p.Event.map(this.b.onDidMaximizeWindow,J=>J.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,J=>J.id),p.Event.map(this.b.onDidUnmaximizeWindow,J=>J.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(J,M)=>M.id),J=>!!this.a.getWindowById(J)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(J,M)=>M.id),J=>!!this.a.getWindowById(J))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(J,M)=>this.b.getWindowByWebContents(M.webContents)),J=>!!J),J=>J.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(J,M)=>this.b.getWindowByWebContents(M.webContents)),J=>!!J),J=>J.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(E.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new p.$me),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(E.screen,"display-metrics-changed",(J,M,F)=>F),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),p.Event.fromNodeEventEmitter(E.screen,"display-added"),p.Event.fromNodeEventEmitter(E.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(q,Q){const U=this.a.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace??(0,l.$Ui)(W.backupPath,W.isExtensionDevelopmentHost),title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()})),Z=[];return Q.includeAuxiliaryWindows&&Z.push(...this.b.getWindows().map(W=>({id:W.id,parentId:W.parentId,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename()}))),[...U,...Z]}async getWindowCount(q){return this.a.getWindowCount()}async getActiveWindowId(q){const Q=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(Q)return Q.id}async getActiveWindowPosition(){const q=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(q)return q.getBounds()}openWindow(q,Q,U){return Array.isArray(Q)?this.w(q,Q,U):this.z(q,Q)}async w(q,Q,U=Object.create(null)){Q.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:q,urisToOpen:Q,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async z(q,Q){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:q},Q)}async isFullScreen(q,Q){return this.H(Q?.targetWindowId,q)?.isFullScreen??!1}async toggleFullScreen(q,Q){this.H(Q?.targetWindowId,q)?.toggleFullScreen()}async handleTitleDoubleClick(q,Q){this.H(Q?.targetWindowId,q)?.handleTitleDoubleClick()}async getCursorScreenPoint(q){const Q=E.screen.getCursorScreenPoint(),U=E.screen.getDisplayNearestPoint(Q);return{point:Q,display:U.bounds}}async isMaximized(q,Q){return this.H(Q?.targetWindowId,q)?.win?.isMaximized()??!1}async maximizeWindow(q,Q){this.H(Q?.targetWindowId,q)?.win?.maximize()}async unmaximizeWindow(q,Q){this.H(Q?.targetWindowId,q)?.win?.unmaximize()}async minimizeWindow(q,Q){this.H(Q?.targetWindowId,q)?.win?.minimize()}async moveWindowTop(q,Q){this.H(Q?.targetWindowId,q)?.win?.moveTop()}async positionWindow(q,Q,U){const Z=this.H(U?.targetWindowId,q);if(Z?.win){if(Z.win.isFullScreen()){const W=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(Z.win,"leave-full-screen")));Z.win.setFullScreen(!1),await W}Z.win.setBounds(Q)}}async updateWindowControls(q,Q){this.H(Q?.targetWindowId,q)?.updateWindowControls(Q)}async focusWindow(q,Q){this.H(Q?.targetWindowId,q)?.focus({force:Q?.force??!1})}async setMinimumSize(q,Q,U){const Z=this.I(q);if(Z?.win){const[W,j]=Z.win.getSize(),[C,X]=Z.win.getMinimumSize(),[oe,G]=[Q??C,U??X],[ue,re]=[Math.max(W,oe),Math.max(j,G)];(C!==oe||X!==G)&&Z.win.setMinimumSize(oe,G),(W!==ue||j!==re)&&Z.win.setSize(ue,re)}}async saveWindowSplash(q,Q){this.m.saveWindowSplash(q,Q)}async installShellCommand(q){const{source:Q,target:U}=await this.C();try{const{symbolicLink:Z}=await v.SymlinkSupport.stat(Q);if(Z&&!Z.dangling){const W=await(0,f.$qr)(Q);if(U===W)return}await n.promises.unlink(Q)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await n.promises.symlink(U,Q)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:W}=await this.showMessageBox(q,{type:"info",message:(0,$.localize)(1995,null,this.j.nameShort),buttons:[(0,$.localize)(1996,null),(0,$.localize)(1997,null)]});if(W===1)throw new T.$5;try{const j=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${Q}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(j)}catch{throw new Error((0,$.localize)(1998,null,Q))}}}async uninstallShellCommand(q){const{source:Q}=await this.C();try{await n.promises.unlink(Q)}catch(U){switch(U.code){case"EACCES":{const{response:Z}=await this.showMessageBox(q,{type:"info",message:(0,$.localize)(1999,null,this.j.nameShort),buttons:[(0,$.localize)(2e3,null),(0,$.localize)(2001,null)]});if(Z===1)throw new T.$5;try{const W=`osascript -e "do shell script \\"rm '${Q}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(W)}catch{throw new Error((0,$.localize)(2002,null,Q))}break}case"ENOENT":break;default:throw U}}}async C(){const q=(0,u.$lc)(this.g.appRoot,"bin","code"),Q=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(q))throw new Error((0,$.localize)(2003,null,q));return{source:Q,target:q}}async showMessageBox(q,Q){const U=this.H(Q?.targetWindowId,q);return this.c.showMessageBox(Q,U?.win??void 0)}async showSaveDialog(q,Q){const U=this.H(Q?.targetWindowId,q);return this.c.showSaveDialog(Q,U?.win??void 0)}async showOpenDialog(q,Q){const U=this.H(Q?.targetWindowId,q);return this.c.showOpenDialog(Q,U?.win??void 0)}async pickFileFolderAndOpen(q,Q){const U=await this.c.pickFileFolder(Q);U&&await this.D(await Promise.all(U.map(async Z=>await v.SymlinkSupport.existsDirectory(Z)?{folderUri:w.URI.file(Z)}:{fileUri:w.URI.file(Z)})),Q,q)}async pickFolderAndOpen(q,Q){const U=await this.c.pickFolder(Q);U&&await this.D(U.map(Z=>({folderUri:w.URI.file(Z)})),Q,q)}async pickFileAndOpen(q,Q){const U=await this.c.pickFile(Q);U&&await this.D(U.map(Z=>({fileUri:w.URI.file(Z)})),Q,q)}async pickWorkspaceAndOpen(q,Q){const U=await this.c.pickWorkspace(Q);U&&await this.D(U.map(Z=>({workspaceUri:w.URI.file(Z)})),Q,q)}async D(q,Q,U){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:U,cli:this.g.args,urisToOpen:q,forceNewWindow:Q.forceNewWindow})}async showItemInFolder(q,Q){E.shell.showItemInFolder(Q)}async setRepresentedFilename(q,Q,U){this.H(U?.targetWindowId,q)?.setRepresentedFilename(Q)}async setDocumentEdited(q,Q,U){this.H(U?.targetWindowId,q)?.setDocumentEdited(Q)}async openExternal(q,Q,U){this.g.unsetSnapExportedVariables();try{(0,g.$Qg)(Q,g.Schemas.http,g.Schemas.https)?this.F(Q,U):E.shell.openExternal(Q)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(q,Q){const U=Q??this.r.getValue("workbench.externalBrowser");if(!U)return E.shell.openExternal(q);if((U.includes(u.$hc.sep)||U.includes(u.$gc.sep))&&!await v.Promises.exists(U))return this.h.error(`Configured external browser path does not exist: ${U}`),E.shell.openExternal(q);try{const{default:Z}=await new Promise((j,C)=>{x(["open"],j,C)}).then(Pe);(await Z(q,{app:{name:Object.hasOwn(Z.apps,U)?Z.apps[U]:U}})).stderr?.on("data",j=>{this.h.error(`Error openening external URL '${q}' using browser '${U}': ${j.toString()}`)})}catch(Z){return this.h.error(`Unable to open external URL '${q}' using browser '${U}' due to ${Z}.`),E.shell.openExternal(q)}}moveItemToTrash(q,Q){return E.shell.trashItem(Q)}async isAdmin(){let q;return m.$j?q=(await new Promise((Q,U)=>{x(["native-is-elevated"],Q,U)}).then(Pe)).default():q=process.getuid?.()===0,q}async writeElevated(q,Q,U,Z){const W=await new Promise((j,C)=>{x(["@vscode/sudo-prompt"],j,C)}).then(Pe);return new Promise((j,C)=>{const X=[`"${this.G}"`];Z?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${Q.fsPath}"`,`"${U.fsPath}"`);const oe={name:this.j.nameLong.replace("-",""),icns:m.$k&&this.g.isBuilt?(0,u.$kc)((0,u.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};W.exec(X.join(" "),oe,(G,ue,re)=>{ue&&this.h.trace(`[sudo-prompt] received stdout: ${ue}`),re&&this.h.trace(`[sudo-prompt] received stderr: ${re}`),G?C(G):j(void 0)})})}async isRunningUnderARM64Translation(){return m.$l||m.$j?!1:E.app.runningUnderARM64Translation}get G(){return m.$j?this.g.isBuilt?(0,u.$kc)((0,u.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,u.$kc)(this.g.appRoot,"scripts","code-cli.bat"):m.$l?this.g.isBuilt?(0,u.$kc)((0,u.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,u.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,u.$kc)(this.g.appRoot,"bin","code"):(0,u.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,A.totalmem)(),freemem:(0,A.freemem)(),loadavg:(0,A.loadavg)()}}async getOSProperties(){return{arch:(0,A.arch)(),platform:(0,A.platform)(),release:(0,A.release)(),type:(0,A.type)(),cpus:(0,A.cpus)()}}async getOSVirtualMachineHint(){return d.$Tn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return m.$j&&(0,D.$Ygc)()}async getProcessId(q){return this.H(void 0,q)?.win?.webContents.getOSProcessId()}async killProcess(q,Q,U){process.kill(Q,U)}async readClipboardText(q,Q){return E.clipboard.readText(Q)}async writeClipboardText(q,Q,U){return E.clipboard.writeText(Q,U)}async readClipboardFindText(q){return E.clipboard.readFindText()}async writeClipboardFindText(q,Q){return E.clipboard.writeFindText(Q)}async writeClipboardBuffer(q,Q,U,Z){return E.clipboard.writeBuffer(Q,Buffer.from(U.buffer),Z)}async readClipboardBuffer(q,Q){return y.$Oe.wrap(E.clipboard.readBuffer(Q))}async hasClipboard(q,Q,U){return E.clipboard.has(Q,U)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){E.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){E.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){E.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){E.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){E.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(q,Q){this.I(q)?.updateTouchBar(Q)}async notifyReady(q){this.I(q)?.setReady()}async relaunch(q,Q){return this.f.relaunch(Q)}async reload(q,Q){const U=this.I(q);if(U){if((0,l.$Vi)(U.openedWorkspace)){const Z=U.openedWorkspace.configPath;if(Z.scheme===g.Schemas.file&&(await this.n.resolveLocalWorkspace(Z))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,Q?.disableExtensions!==void 0?{_:[],"disable-extensions":Q.disableExtensions}:void 0)}}async closeWindow(q,Q){return this.H(Q?.targetWindowId,q)?.win?.close()}async quit(q){const Q=this.a.getLastActiveWindow();Q?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&Q.win?Q.win.close():this.f.quit()}async exit(q,Q){await this.f.kill(Q)}async resolveProxy(q,Q){if(this.g.extensionTestsLocationURI){const W=this.r.getValue("integration-test.http.proxy");if(W)return W}return this.I(q)?.win?.webContents?.session?.resolveProxy(Q)}async lookupAuthorization(q,Q){return this.t.lookupAuthorization(Q)}async lookupKerberosAuthorization(q,Q){return this.s.lookupKerberosAuthorization(Q)}async loadCertificates(q){return this.s.loadCertificates()}findFreePort(q,Q,U,Z,W=1){return(0,b.$5g)(Q,U,Z,W)}async openDevTools(q,Q){this.H(Q?.targetWindowId,q)?.win?.webContents.openDevTools(Q?.mode?{mode:Q.mode,activate:Q.activate}:void 0)}async toggleDevTools(q,Q){this.H(Q?.targetWindowId,q)?.win?.webContents.toggleDevTools()}async profileRenderer(q,Q,U){const Z=this.I(q);if(!Z||!Z.win)throw new Error;return await new L.$Zgc(Z.win,Q,this.h).inspect(U)}async windowsGetStringRegKey(q,Q,U,Z){if(!m.$j)return;const W=await new Promise((j,C)=>{x(["@vscode/windows-registry"],j,C)}).then(Pe);try{return W.GetStringRegKey(Q,U,Z)}catch{return}}H(q,Q){return this.I(q)??this.J(q)??this.I(Q)}I(q){if(typeof q=="number")return this.a.getWindowById(q)}J(q){if(typeof q!="number")return;const Q=E.webContents.fromId(q);if(Q)return this.b.getWindowByWebContents(Q)}};e.$3gc=Y,Se([I.$$h],Y.prototype,"G",null),e.$3gc=Y=Se([se(0,a.$cgc),se(1,R.$1gc),se(2,k.$0fc),se(3,h.$vgc),se(4,S.$2fc),se(5,t.$bk),se(6,o.$uk),se(7,s.$agc),se(8,P.$ogc),se(9,N.$aj),se(10,H.$9p),se(11,V.$Fgc)],Y)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[271],le([0,1,13,27,8,22,2,12,3,35,10,53,20,5,64,72,73,51,29]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0,d=Ge(d);let S=class{static{k=this}static{this.a="#1E1E1E"}constructor(h,t,o,s,a,l,P){this.d=h,this.e=t,this.f=o,this.g=s,this.h=a,this.i=l,this.j=P,this.b=null,this.c=null}async openReporter(h){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const t=new O.$Uc,o=t.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:h.styles.backgroundColor,title:(0,g.localize)(1900,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:h,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:d.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$1g.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,t.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,t.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(h){this.f.error(h)}}async $showConfirmCloseDialog(){if(this.b){const{response:h}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(1901,null),buttons:[(0,g.localize)(1902,null),(0,g.localize)(1903,null)]},this.b);h===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:h}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(1904,null),buttons:[(0,g.localize)(1905,null),(0,g.localize)(1906,null)]},this.b);return h===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const h=this.j.getWindowById(this.c.id);if(!h)throw new Error("Window not found");return h}async $sendReporterMenu(h,t){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new A.$xe;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:h,extensionName:t}),await(0,E.$xh)(new Promise(P=>c.$1X.once(`vscode:triggerReporterMenuResponse:${h}`,(y,D)=>P(D))),5e3,()=>{this.f.error(`Error: Extension ${h} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(h){h.isMinimized()&&h.restore(),h.focus()}l(h,t,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:o.title,backgroundColor:o.backgroundColor||k.a,webPreferences:{preload:I.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$lE)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(h,t,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&h&&(s=n.screen.getDisplayMatching(h.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,P={width:t,height:o,x:l.x+l.width/2-t/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(P.x<l.x&&(P.x=l.x),P.y<l.y&&(P.y=l.y),P.x>l.x+l.width&&(P.x=l.x),P.y>l.y+l.height&&(P.y=l.y),P.width>l.width&&(P.width=l.width),P.height>l.height&&(P.height=l.height)),P}};e.$4gc=S,e.$4gc=S=k=Se([se(1,m.$2fc),se(2,w.$bk),se(3,u.$0fc),se(4,f.$2gc),se(5,v.$_fc),se(6,$.$cgc)],S)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[272],le([0,1,13,32,2,12,3,115,35,10,96,136,53,20,5,64,72,28,73,34,63,51]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0,v=Ge(v);const t="issue.processExplorerWindowState";let o=class{static{h=this}static{this.a="#1E1E1E"}constructor(l,P,y,D,L,R,T,N,V,H){this.d=l,this.f=P,this.g=y,this.h=D,this.i=L,this.j=R,this.k=T,this.l=N,this.m=V,this.n=H,this.b=null,this.c=null,this.o()}o(){p.$1X.on("vscode:listProcesses",async l=>{const P=[];try{P.push({name:(0,c.localize)(1907,null),rootProcess:await(0,I.$1s)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(D=>{(0,g.$Vm)(D)?P.push({name:D.hostName,rootProcess:D}):D.processes&&P.push({name:D.hostName,rootProcess:D.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",P)}),p.$1X.on("vscode:workbenchCommand",(l,P)=>{const{id:y,from:D,args:L}=P;let R;switch(D){case"processExplorer":R=this.c;break;default:throw new Error(`Unexpected command source: ${D}`)}R?.webContents.send("vscode:runAction",{id:y,from:D,args:L})}),p.$1X.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$1X.on("vscode:pidToNameRequest",async l=>{const P=await this.i.getMainDiagnostics(),y=[];for(const D of P.windows)y.push([D.pid,`window [${D.id}] (${D.title})`]);for(const{pid:D,name:L}of S.$Jgc.getAll())y.push([D,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const P=new E.$Uc,y=P.add(this.l.createIPCObjectUrl()),D=this.n.getItem(t,void 0),L=s(D)?D:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(1908,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(A.$1g.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,P.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,P.dispose())});const R=()=>{if(!this.b)return;const T=this.b.getSize(),N=this.b.getPosition();if(!T||!N)return;const V={width:T[0],height:T[1],x:N[0],y:N[1]};this.n.setItem(t,V)};this.b.on("moved",R),this.b.on("resized",R)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,P,y){let D;const L=n.screen.getAllDisplays();if(L.length===1)D=L[0];else{if(O.$k){const N=n.screen.getCursorScreenPoint();D=n.screen.getDisplayNearestPoint(N)}!D&&l&&(D=n.screen.getDisplayMatching(l.getBounds())),D||(D=n.screen.getPrimaryDisplay()||L[0])}const R=D.bounds,T={width:P,height:y,x:R.x+R.width/2-P/2,y:R.y+R.height/2-y/2};return R.width>0&&R.height>0&&(T.x<R.x&&(T.x=R.x),T.y<R.y&&(T.y=R.y),T.x>R.x+R.width&&(T.x=R.x),T.y>R.y+R.height&&(T.y=R.y),T.width>R.width&&(T.width=R.width),T.height>R.height&&(T.height=R.height)),T}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Og)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(1909,null),detail:(0,c.localize)(1910,null,l),buttons:[(0,c.localize)(1911,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,P]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,P)}async $getSystemInfo(){const[l,P]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,P)}async $getPerformanceInfo(){try{const[l,P]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,P)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,P,y,D){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||h.a,webPreferences:{preload:A.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$lE)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,P,...y){l.sender.isDestroyed()||l.sender.send(P,...y)}async closeProcessExplorer(){this.b?.close()}};e.$5gc=o,e.$5gc=o=h=Se([se(1,w.$2fc),se(2,f.$bk),se(3,g.$Um),se(4,u.$Mgc),se(5,m.$0fc),se(6,d.$2gc),se(7,$.$_fc),se(8,b.$uk),se(9,k.$GR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ce[273],le([0,1,22,16,20,19,5,64,28,49,24,50,105]),function(x,e,n,r,E,A,O,I,p,c,g,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;let w=class extends m.$rhc{constructor(d,v,b,$,k,S,i,h){super(d,v,$,k,S,h),this.e=b,this.u=i}s(d){return(0,m.$qhc)(`linux-${process.arch}`,d,this.k)}t(d){this.a&&(this.d(u.$YY.CheckingForUpdates(d)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$cq).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(u.$YY.Idle(u.UpdateType.Archive))):this.d(u.$YY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=d?v.message||v:void 0;this.d(u.$YY.Idle(u.UpdateType.Archive,b))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(u.$YY.Idle(u.UpdateType.Archive))}};e.$thc=w,e.$thc=w=Se([se(0,A.$vgc),se(1,r.$aj),se(2,g.$am),se(3,E.$2fc),se(4,c.$9p),se(5,O.$bk),se(6,I.$2gc),se(7,p.$uk)],w)}),define(ce[274],le([0,1,48,26,27,8,22,54,46,9,7,154,23,16,20,14,19,5,64,28,49,24,50,105]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0,r=Pe(r),c=Pe(c),m=Pe(m);async function o(P,y=1e3){for(;!P();)await(0,A.$Hh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?h.UpdateType.Setup:h.UpdateType.Archive),s}let l=class extends t.$rhc{get cachePath(){const y=c.$kc((0,E.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,D,L,R,T,N,V,H,Y){super(y,D,R,T,N,Y),this.u=L,this.v=V,this.w=H,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==h.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$YY.Disabled(h.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let D=`win32-${process.arch}`;return a()===h.UpdateType.Archive?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,t.$qhc)(D,y,this.k)}t(y){this.a&&(this.d(h.$YY.CheckingForUpdates(y)),this.i.request({url:this.a},O.CancellationToken.None).then(S.$cq).then(D=>{const L=a();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(h.$YY.Idle(L)),Promise.resolve(null)):L===h.UpdateType.Archive?(this.d(h.$YY.AvailableForDownload(D)),Promise.resolve(null)):(this.d(h.$YY.Downloading),this.C(D.version).then(()=>this.B(D.version).then(R=>m.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const N=`${R}.tmp`;return this.i.request({url:D.url},O.CancellationToken.None).then(V=>this.v.writeFile(g.URI.file(N),V.stream)).then(D.sha256hash?()=>(0,u.$TX)(N,D.sha256hash):()=>{}).then(()=>m.Promises.rename(N,R,!1)).then(()=>R)})).then(R=>{this.e={packagePath:R},this.d(h.$YY.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(h.$YY.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$uj)(String(D)))}),this.j.error(D);const L=y?D.message||D:void 0;this.d(h.$YY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(h.$YY.Idle(a()))}async B(y){const D=await this.cachePath;return c.$kc(D,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const D=y?N=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(N):()=>!0,L=await this.cachePath,T=(await m.Promises.readdir(L)).filter(D).map(async N=>{try{await r.promises.unlink(c.$kc(L,N))}catch{}});await Promise.all(T)}async p(){if(this.state.type!==h.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(h.$YY.Updating(y));const D=await this.cachePath;this.e.updateFilePath=c.$kc(D,`CodeSetup-${this.k.quality}-${y.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$YY.Idle(a()))});const R=`${this.k.win32MutexName}-ready`,T=await new Promise((N,V)=>{x(["@vscode/windows-mutex"],N,V)}).then(Pe);o(()=>T.isActive(R)).then(()=>this.d(h.$YY.Ready(y)))}r(){this.state.type!==h.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==h.StateType.Idle)return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(h.$YY.Downloading),this.e={packagePath:y},this.d(h.$YY.Downloaded(L)),D?this.k.target==="user"&&this.p():this.d(h.$YY.Ready(L))}};e.$vhc=l,Se([I.$$h],l.prototype,"cachePath",null),e.$vhc=l=Se([se(0,v.$vgc),se(1,w.$aj),se(2,i.$am),se(3,f.$2fc),se(4,S.$9p),se(5,b.$bk),se(6,d.$bl),se(7,$.$2gc),se(8,k.$uk)],l)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[137],le([0,1,13,8,22,55,4,2,12,70,3,7,10,27,69,16,53,20,68,14,19,5,28,73,250,87,24,110,76,51,29,30,59,52,40,34,58,71,21,6]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R,T,N,V,H,Y,de,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0,n=Ge(n);var Q;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(Q||(Q={}));class U extends I.$Vc{get lastFocusTime(){return this.j}get win(){return this.m}n(j,C){this.m=j,this.B(O.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const X=!(0,y.$gE)(this.r,C?.titleBarStyle==="hidden"?y.TitlebarStyle.CUSTOM:void 0);if(g.$k&&X&&j.setSheetOffset((0,g.$K)((0,w.release)())?28:22),X&&(g.$j&&(0,y.$jE)(this.r)||g.$k)){const oe=this.s.getItem(U.D);oe?this.updateWindowControls({height:oe}):this.updateWindowControls({height:y.$iE})}g.$j&&X&&j.hookWindowMessage(278,()=>{const[G,ue]=j.getPosition(),re=n.default.screen.getCursorScreenPoint(),J=re.x-G,M=re.y-ue;return!(J>30&&M>=0&&M<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:J,y:M})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),g.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,C,X,oe){super(),this.r=j,this.s=C,this.t=X,this.u=oe,this.a=this.B(new O.$me),this.onDidClose=this.a.event,this.b=this.B(new O.$me),this.onDidMaximize=this.b.event,this.c=this.B(new O.$me),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$me),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$me),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$jE)(this.r),this.G=void 0,this.H=void 0}w(j,C=n.default.screen.getAllDisplays().length>0){const X=this.r.getValue("window"),oe=g.$k&&X?.nativeTabs===!0;(g.$k||g.$j)&&C&&(!oe||n.default.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===T.WindowMode.Maximized||j.mode===T.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===T.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){g.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return g.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){g.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return g.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){g.$k&&j?.force&&n.default.app.focus({steal:!0});const C=this.win;C&&(C.isMinimized()&&C.restore(),C.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(g.$k)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const C=this.win;if(C){if(j.height&&this.s.setItem(Z.D,j.height),g.$j&&this.F)C.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(g.$k&&j.height!==void 0){const X=(j.height-15)/2;X?C.setWindowButtonPosition({x:X,y:X}):C.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,C){(0,y.$kE)(this.r)?this.J(j,C):this.M(j)}get isFullScreen(){if(g.$k&&typeof this.G=="boolean")return this.G;const j=this.win,C=j?.isFullScreen(),X=j?.isSimpleFullScreen();return!!(C||X)}J(j,C){const X=this.win;X?.isSimpleFullScreen()&&X?.setSimpleFullScreen(!1),this.L(j,C)}L(j,C){if(g.$k){this.G=j;const oe=this.H=new r.$4h;(async()=>{const G=await Promise.race([oe.p,(0,r.$Hh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!G&&j&&C&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const C=this.win;C?.isFullScreen()&&this.L(!1,!1),C?.setSimpleFullScreen(j),C?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$sgc=U;let Z=class extends U{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(C=>C.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Ui)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,C,X,oe,G,ue,re,J,M,F,_,z,ie,K,B,te,he,me,we,Ie,Ce){super(F,Ie,oe,C),this.fb=X,this.gb=G,this.hb=ue,this.ib=re,this.jb=J,this.kb=M,this.lb=_,this.mb=z,this.nb=ie,this.ob=K,this.pb=B,this.qb=te,this.rb=he,this.sb=me,this.tb=we,this.N=this.B(new O.$me),this.onWillLoad=this.N.event,this.O=this.B(new O.$me),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$me),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=Q.NONE;{const[De,ve]=this.Eb(j.state);this.U=De,this.u.trace("window#ctor: using window state",De);const $e=Ce.invokeFunction(D.$dgc,this.U,void 0,{preload:p.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.default.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m,$e),this.w(this.U,ve),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=Q.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===Q.READY}get whenClosedOrLoaded(){return new Promise(j=>{function C(){X.dispose(),oe.dispose(),j()}const X=this.onDidClose(()=>C()),oe=this.onWillLoad(()=>C())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(T.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(C,X)=>X)(C=>this.yb(T.WindowError.PROCESS_GONE,{...C}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(C,X,oe)=>({exitCode:X,reason:oe}))(({exitCode:C,reason:X})=>this.yb(T.WindowError.LOAD,{reason:X,exitCode:C}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(C=>C.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",E.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",E.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(C=>this.Bb(C))),this.B(this.mb.onDidDeleteUntitledWorkspace(C=>this.Ab(C)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(C,X)=>{const oe=await this.xb();X({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,o.$qq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,C){switch(j){case T.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break;case T.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case T.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:C?.reason,code:C?.exitCode}),j){case T.WindowError.UNRESPONSIVE:case T.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===T.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,m.localize)(2450,null),(0,m.localize)(2451,null),(0,m.localize)(2452,null)],message:(0,m.localize)(2453,null),detail:(0,m.localize)(2454,null),checkboxLabel:this.S?.workspace?(0,m.localize)(2455,null):void 0},this.m);if(X!==2){const G=X===0;await this.zb(G,oe)}}else if(j===T.WindowError.PROCESS_GONE){let X;C?X=(0,m.localize)(2457,null,C.reason,C.exitCode??"<unknown>"):X=(0,m.localize)(2456,null);const{response:oe,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,m.localize)(2458,null):(0,m.localize)(2459,null),(0,m.localize)(2460,null)],message:X,detail:this.S?.workspace?(0,m.localize)(2461,null):(0,m.localize)(2462,null),checkboxLabel:this.S?.workspace?(0,m.localize)(2463,null):void 0},this.m),ue=oe===0;await this.zb(ue,G)}break}}async zb(j,C){const X=this.S?.workspace;if(C&&X)try{const oe=this.kb.workspaceStorage(X);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(j&&this.S){let oe,G;(0,L.$Qi)(X)?oe={folderUri:X.uri}:(0,L.$Vi)(X)?oe={workspaceUri:X.configPath}:G=!0,(0,de.$Ob)(await this.tb.open({context:D.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const C=this.Gb();C!==this.W&&(this.W=C,this.Hb(C))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let C=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(C?.indexOf("@")!==-1){const oe=u.URI.parse(C),G=oe.authority.indexOf("@");G!==-1&&(C=oe.with({authority:oe.authority.substring(G+1)}).toString())}C?.endsWith("/")&&(C=C.substr(0,C.length-1));const X=(this.r.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((C||"").indexOf("@")===-1&&(C!==this.Z||X!==this.$)){this.Z=C,this.$=X;const oe=C||"",G=X?`${X},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""}),n.default.app.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){g.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,C=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!C.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),C.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,C),this.ub===Q.NONE?this.S=j:this.db=j,this.ub=Q.NAVIGATING,this.m.loadURL(p.$1g.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Sh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:C.isReload?T.LoadReason.RELOAD:X?T.LoadReason.LOAD:T.LoadReason.INITIAL})}Cb(j,C){const X=(this.S??this.db)?.userEnv;if(X){const oe=(0,$.$Lm)(X)&&!(0,$.$Lm)(j.userEnv),G=this.isExtensionDevelopmentHost;(oe||G)&&(j.userEnv={...X,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),C.disableExtensions!==void 0&&(j["disable-extensions"]=C.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const C=Object.assign({},this.S);C.workspace=await this.Db(C),delete C.filesToOpenOrCreate,delete C.filesToDiff,delete C.filesToMerge,delete C.filesToWait,this.isExtensionDevelopmentHost&&j&&(C.verbose=j.verbose,C.debugId=j.debugId,C.extensionEnvironment=j.extensionEnvironment,C["inspect-extensions"]=j["inspect-extensions"],C["inspect-brk-extensions"]=j["inspect-brk-extensions"],C["extensions-dir"]=j["extensions-dir"]),C.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),C.isInitialStartup=!1,C.policiesData=this.gb.serialize(),C.continueOn=this.t.continueOn,C.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},C.logLevel=this.fb.getLogLevel(),C.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(C,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Vi)(j.workspace)){const C=j.workspace.configPath;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}else if((0,L.$Qi)(j.workspace)){const C=j.workspace.uri;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,T.$4fc)();if(this.isFullScreen){let X;try{X=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,T.$4fc)();return{mode:T.WindowMode.Fullscreen,display:X?X.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let C;if(!g.$k&&this.m.isMaximized()?C=T.WindowMode.Maximized:C=T.WindowMode.Normal,C===T.WindowMode.Maximized?j.mode=T.WindowMode.Maximized:j.mode=T.WindowMode.Normal,C===T.WindowMode.Normal||C===T.WindowMode.Maximized){let X;C===T.WindowMode.Normal?X=this.getBounds():X=this.m.getNormalBounds(),j.x=X.x,j.y=X.y,j.width=X.width,j.height=X.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let C=!1;if(j){this.ab=j.zoomLevel;try{const X=n.default.screen.getAllDisplays();C=X.length>1,j=D.WindowStateValidator.validateWindowState(this.u,j,X)}catch(X){this.u.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,T.$4fc)(),C]}getBounds(){const[j,C]=this.m.getPosition(),[X,oe]=this.m.getSize();return{x:j,y:C,width:X,height:oe}}I(j,C){super.I(j,C),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",E.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$eE)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,C=!0){g.$k||(j==="toggle"&&C&&this.send("vscode:showInfoMessage",(0,m.localize)(2464,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const C=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!C),this.m.autoHideMenuBar=C;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,C,...X){this.isReady?this.send(j,...X):this.ready().then(()=>{C.isCancellationRequested||this.send(j,...X)})}send(j,...C){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...C)}catch(X){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,A.$rj)(X)}`)}}}updateTouchBar(j){g.$k&&this.Y.forEach((C,X)=>{const oe=j[X];C.segments=this.Mb(oe)})}Kb(){if(g.$k){for(let j=0;j<10;j++){const C=this.Lb();this.Y.push(C)}this.m.setTouchBar(new n.default.TouchBar({items:this.Y}))}}Lb(j=[]){const C=this.Mb(j),X=new n.default.TouchBar.TouchBarSegmentedControl({segments:C,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",E.CancellationToken.None,{id:X.segments[oe].id,from:"touchbar"})}});return X}Mb(j=[]){return j.map(X=>{let oe;X.icon&&!l.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===p.Schemas.file&&(oe=n.default.nativeImage.createFromPath(u.URI.revive(X.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let G;return typeof X.title=="string"?G=X.title:G=X.title.value,{id:X.id,label:oe?void 0:G,icon:oe}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$tgc=Z,e.$tgc=Z=Se([se(1,i.$bk),se(2,Y.$qgc),se(3,b.$2fc),se(4,N.$uo),se(5,H.$fgc),se(6,k.$bl),se(7,s.$Dgc),se(8,s.$Bgc),se(9,d.$aj),se(10,P.$agc),se(11,R.$ogc),se(12,f.$9fc),se(13,a.$am),se(14,v.$0fc),se(15,S.$vgc),se(16,h.$uk),se(17,t.$_fc),se(18,D.$cgc),se(19,V.$GR),se(20,q.$Fi)],Z)}),define(ce[275],le([0,1,13,3,16,20,19,5,34,51,52,137]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let m=class extends u.$sgc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,d,v,b,$,k){super(b,$,d,v),this.O=f,this.P=k,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(f),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?g.WindowMode.Maximized:g.WindowMode.Normal})))}Q(f){if(this.m)return;const d=n.BrowserWindow.fromWebContents(this.O);d&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(d,f),d.setMenu(null),(r.$j||r.$l)&&(0,c.$gE)(this.r,f?.titleBarStyle==="hidden"?c.TitlebarStyle.CUSTOM:void 0)&&d.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$ugc=m,e.$ugc=m=Se([se(1,A.$2fc),se(2,I.$bk),se(3,E.$aj),se(4,p.$GR),se(5,O.$vgc)],m)}),define(ce[276],le([0,1,13,4,2,12,35,275,6,5,52,29]),function(x,e,n,r,E,A,O,I,p,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let m=class extends E.$Vc{constructor(f,d){super(),this.h=f,this.j=d,this.a=this.B(new r.$me),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$me),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$me),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,d)=>{const v=this.getWindowByWebContents(d.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new E.$Uc;b.add(r.Event.fromNodeEventEmitter(d.webContents,"did-create-window",($,k)=>({browserWindow:$,details:k}))(({browserWindow:$,details:k})=>{const S=this.getWindowByWebContents($.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(k.options))})),b.add(r.Event.fromNodeEventEmitter(d,"closed")(()=>b.dispose()))}}),O.$1X.handle("vscode:registerAuxiliaryWindow",async(f,d)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=d),f.sender.id})}createWindow(f){const{state:d,overrides:v}=this.n(f);return this.h.invokeFunction(u.$dgc,d,v,{preload:A.$1g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const d={},v={},b=f.features.split(",");for(const k of b){const[S,i]=k.split("=");switch(S){case"width":d.width=parseInt(i,10);break;case"height":d.height=parseInt(i,10);break;case"left":d.x=parseInt(i,10);break;case"top":d.y=parseInt(i,10);break;case"window-maximized":d.mode=g.WindowMode.Maximized;break;case"window-fullscreen":d.mode=g.WindowMode.Fullscreen;break;case"window-disable-fullscreen":v.disableFullscreen=!0;break;case"window-native-titlebar":v.forceNativeTitlebar=!0;break}}const $=u.WindowStateValidator.validateWindowState(this.j,d)??(0,g.$5fc)();return this.j.trace("[aux window] using window state",$),{state:$,overrides:v}}registerWindow(f){const d=new E.$Uc,v=this.h.createInstance(I.$ugc,f);this.g.set(v.id,v),d.add((0,E.$Tc)(()=>this.g.delete(v.id))),d.add(v.onDidMaximize(()=>this.a.fire(v))),d.add(v.onDidUnmaximize(()=>this.b.fire(v))),d.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),d.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),d.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>d.dispose())}getWindowByWebContents(f){const d=this.g.get(f.id);return d?.matches(f)?d:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,u.$egc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$3hc=m,e.$3hc=m=Se([se(0,p.$Fi),se(1,c.$bk)],m)}),define(ce[88],le([0,1,13,21,8,4,47,2,12,3,18,7,23,10,6,19,5,62,87,102,30,59,31,53]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0,e.$chc=(0,f.$Gi)("workspacesHistoryMainService");let s=class extends I.$Vc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,P,y,D,L){super(),this.f=l,this.g=P,this.h=y,this.j=D,this.m=L,this.c=this.B(new A.$me),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new E.$Eh(800)),this.n()}n(){this.h.when(d.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let P=[],y=[];for(const L of l)if((0,k.$lib)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(P,L.workspace)&&P.push(L);else if((0,k.$mib)(L))this.y(P,L.folderUri)||P.push(L);else{const R=this.z(y,L.fileUri),T=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,g.$eh)(L.fileUri))>=0;!R&&!T&&(y.push(L),c.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const D=await this.r({workspaces:P,files:y});P=D.workspaces,y=D.files,P.length>o.a&&(P.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:P,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const P=R=>{const T=this.u(R);for(const N of l)if(g.$$g.isEqual(N,T))return!1;return!0},y=await this.getRecentlyOpened(),D=y.workspaces.filter(P),L=y.files.filter(P);(D.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:D}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:P}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(2477,null),(0,w.localize)(2478,null)],message:(0,w.localize)(2479,null),detail:(0,w.localize)(2480,null),cancelId:1});if(P!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const P=new h.$Bc(L=>g.$$g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)P.set(this.u(L),L);const y=new h.$Bc(L=>g.$$g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const D=await this.s();for(const L of D.workspaces){const R=P.get(this.u(L));R?R.label=R.label??L.label:P.set(this.u(L),L)}for(const L of D.files){const R=y.get(this.u(L));R?R.label=R.label??L.label:y.set(this.u(L),L)}return{workspaces:[...P.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const P=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof P=="string")try{l=JSON.parse(P)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,k.$sib)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,k.$tib)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,k.$mib)(l)?l.folderUri:(0,k.$nib)(l)?l.fileUri:l.workspace.configPath}w(l,P){return!!l.find(y=>(0,k.$lib)(y)&&y.workspace.id===P.id)}y(l,P){return!!l.find(y=>(0,k.$mib)(y)&&g.$$g.isEqual(y.folderUri,P))}z(l,P){return!!l.find(y=>g.$$g.isEqual(y.fileUri,P))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(2481,null),description:(0,w.localize)(2482,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const L of n.app.getJumpListSettings().removedItems){const R=L.args;if(R){const T=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);T&&P.push(u.URI.parse(T[2]))}}await this.removeRecentlyOpened(P);let y=!1;const D=(0,r.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const R=(0,k.$lib)(L)?L.workspace:L.folderUri,{title:T,description:N}=this.L(R,L.label);let V;return u.URI.isUri(R)?V=`--folder-uri "${R.toString()}"`:(y=!0,V=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:T.substr(0,255),description:N.substr(0,255),program:process.execPath,args:V,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&l.push({type:"custom",name:y?(0,w.localize)(2483,null):(0,w.localize)(2484,null),items:D})}l.push({type:"recent"});try{const P=n.app.setJumpList(l);P&&P!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.f.warn("updateWindowsJumpList#setJumpList",P)}}L(l,P){if(P)return{title:(0,O.$ax)(P).name,description:P};if(u.URI.isUri(l))return{title:(0,g.$eh)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(2485,null),description:""};let y=(0,g.$eh)(l.configPath);return y.endsWith(S.$3i)&&(y=y.substr(0,y.length-S.$3i.length-1)),{title:(0,w.localize)(2486,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,O.$5w)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),P=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const R=this.u(l.workspaces[L]);if(R.scheme===p.Schemas.file){const T=(0,g.$8g)(R);await m.Promises.exists(T)&&(P.push(T),y++)}}const D=[];for(let L=0;L<l.files.length&&y<o.D;L++){const R=this.u(l.files[L]);if(R.scheme===p.Schemas.file){const T=(0,g.$8g)(R);if(o.G.includes((0,g.$eh)(R))||P.includes(T))continue;await m.Promises.exists(T)&&(D.push(T),y++)}}D.reverse().forEach(L=>n.app.addRecentDocument(L)),P.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$dhc=s,e.$dhc=s=o=Se([se(0,v.$bk),se(1,i.$ogc),se(2,d.$vgc),se(3,$.$Dgc),se(4,t.$0fc)],s)}),define(ce[277],le([0,1,13,8,22,47,3,7,10,84,16,20,19,5,200,64,28,34,24,50,51,29,88,2]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0,p=Pe(p);const s="menu";let a=class extends t.$Vc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,D,L,R,T,N,V,H,Y,de,q,Q){super(),this.t=y,this.u=D,this.w=L,this.y=R,this.z=T,this.C=N,this.D=V,this.F=H,this.G=Y,this.H=de,this.I=q,this.J=Q,this.s=Object.create(null),this.h=new r.$Sh(()=>this.R(),0),this.j=new r.$Sh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$k||(0,S.$gE)(D))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(N,V,H)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:V?.id})},this.s["workbench.action.newWindow"]=(N,V,H)=>this.w.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:V?.id}),this.s["workbench.action.files.openFileFolder"]=(N,V,H)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(N,V,H)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(N,V,H)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const D=this.I.requestFeatureUrl;D&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(D,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const R=this.I.licenseUrl;R&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$x){const N=R.indexOf("?")>0?"&":"?";this.ob(`${R}${N}lang=${O.$x}`,"openLicenseUrl")}else this.ob(R,"openLicenseUrl")});const T=this.I.privacyStatementUrl;T&&R&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(T,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!O.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,D){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){O.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!O.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(O.$k?new n.Menu:null);return}const D=new n.Menu;let L;if(O.$k){const T=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:T}),this.Y(T),D.append(L)}if(O.$k&&!this.c){this.c=!0;const T=new n.Menu;T.append(new n.MenuItem({label:this.qb(p.localize(1959,null)),click:()=>this.w.openEmptyWindow({context:i.OpenContext.DOCK})})),n.app.dock.setMenu(T)}if(this.$("File")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1960,null)),submenu:T});this.bb(T,"File"),D.append(N)}if(this.$("Edit")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1961,null)),submenu:T});this.bb(T,"Edit"),D.append(N)}if(this.$("Selection")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1962,null)),submenu:T});this.bb(T,"Selection"),D.append(N)}if(this.$("View")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1963,null)),submenu:T});this.bb(T,"View"),D.append(N)}if(this.$("Go")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1964,null)),submenu:T});this.bb(T,"Go"),D.append(N)}if(this.$("Run")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1965,null)),submenu:T});this.bb(T,"Run"),D.append(N)}if(this.$("Terminal")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1966,null)),submenu:T});this.bb(T,"Terminal"),D.append(N)}let R;if(this.$("Window")){const T=new n.Menu;R=new n.MenuItem({label:this.qb(p.localize(1967,null)),submenu:T,role:"window"}),this.hb(T)}if(R&&D.append(R),this.$("Help")){const T=new n.Menu,N=new n.MenuItem({label:this.qb(p.localize(1968,null)),submenu:T,role:"help"});this.bb(T,"Help"),D.append(N)}D.items&&D.items.length>0?this.X(D):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const D of this.J.getWindows())D.win?.setMenu(null)}Y(y){const D=this.jb(p.localize(1969,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let R;if(this.$("Preferences")){const Q=new n.Menu;this.bb(Q,"Preferences"),R=new n.MenuItem({label:this.qb(p.localize(1970,null)),submenu:Q})}const T=new n.Menu,N=new n.MenuItem({label:p.localize(1971,null),role:"services",submenu:T}),V=new n.MenuItem({label:p.localize(1972,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),H=new n.MenuItem({label:p.localize(1973,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new n.MenuItem({label:p.localize(1974,null),role:"unhide"}),de=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(1975,null,this.I.nameLong),click:async(Q,U,Z)=>{const W=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||W?.win?.isMinimized())&&await this.Z(Z)&&this.H.quit(void 0)}})),q=[D];q.push(...L),R&&q.push(l(),R),q.push(l(),N,l(),V,H,Y,l(),de),q.forEach(Q=>y.append(Q))}async Z(y){if(this.w.getWindowCount()===0)return!0;const D=this.u.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(1976,null),p.localize(1977,null)],message:p.localize(1978,null)});return L===0}return!0}$(y){if(!O.$k&&!(0,S.$gE)(this.u))return!1;switch(y){case"File":case"Help":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,D){D.forEach(L=>{if((0,f.$_gc)(L))y.append(l());else if((0,f.$$gc)(L)){const R=new n.Menu,T=new n.MenuItem({label:this.qb(L.label),submenu:R});this.ab(R,L.submenu.items),y.append(T)}else(0,f.$ahc)(L)?y.append(this.db(L)):(0,f.$bhc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),O.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,D){this.n&&this.n[D]&&this.ab(y,this.n[D].items)}cb(y){const D=this.ib();D.length&&(D.forEach(L=>y.append(L)),y.append(l()))}db(y){const D=I.URI.revive(y.uri),L=y.id,R=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.nb(L,{label:y.label,click:async(T,N,V)=>{const H=this.eb(V);(await this.w.open({context:i.OpenContext.MENU,cli:this.y.args,urisToOpen:[R],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([D])}},!1))}eb(y){return!!(y&&(!O.$k&&(y.ctrlKey||y.shiftKey)||O.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,D,L){const R={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(D,R))}hb(y){const D=new n.MenuItem({label:p.localize(1979,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(1980,null),role:"zoom",enabled:this.w.getWindowCount()>0}),R=new n.MenuItem({label:p.localize(1981,null),role:"front",enabled:this.w.getWindowCount()>0}),T=this.jb(p.localize(1982,null),"workbench.action.switchWindow"),N=[];this.P&&(N.push(l()),N.push(this.jb(p.localize(1983,null),"workbench.action.newWindowTab")),N.push(this.gb(p.localize(1984,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),N.push(this.gb(p.localize(1985,null),"workbench.action.showNextWindowTab","selectNextTab")),N.push(this.gb(p.localize(1986,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),N.push(this.gb(p.localize(1987,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,l(),T,...N,l(),R].forEach(V=>y.append(V))}ib(){switch(this.t.state.type){case k.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(1988,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case k.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(1989,null),enabled:!1})];case k.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(1990,null)),click:()=>{this.t.downloadUpdate()}})];case k.StateType.Downloading:return[new n.MenuItem({label:p.localize(1991,null),enabled:!1})];case k.StateType.Downloaded:return O.$k?[]:[new n.MenuItem({label:this.qb(p.localize(1992,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case k.StateType.Updating:return[new n.MenuItem({label:p.localize(1993,null),enabled:!1})];case k.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(1994,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,D,L,R){const T=this.qb(y),N=typeof D=="function"?D:(q,Q,U)=>{const Z=q?q.userSettingsLabel:null;let W=D;Array.isArray(D)&&(W=this.eb(U)?D[1]:D[0]),Z&&U.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:Z}):this.lb({type:"commandId",commandId:W})},V=typeof L=="boolean"?L:this.w.getWindowCount()>0,H=typeof R=="boolean"?R:!1,Y={label:T,click:N,enabled:V};H&&(Y.type="checkbox",Y.checked=H);let de;return typeof D=="string"?de=D:Array.isArray(D)&&(de=D[0]),O.$k&&(de==="editor.action.clipboardCutAction"?Y.role="cut":de==="editor.action.clipboardCopyAction"?Y.role="copy":de==="editor.action.clipboardPasteAction"&&(Y.role="paste"),de==="undo"?Y.click=this.kb(N,{inDevTools:q=>q.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?Y.click=this.kb(N,{inDevTools:q=>q.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(Y.click=this.kb(N,{inDevTools:q=>q.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(de,Y))}kb(y,D){return(L,R,T)=>{const N=n.BrowserWindow.getFocusedWindow();if(!N)return D.inNoWindow();if(N.webContents.isDevToolsFocused()&&N.webContents.devToolsWebContents)return D.inDevTools(N.webContents.devToolsWebContents);y(L,R||N,T)}}lb(y){let D=n.BrowserWindow.getFocusedWindow();if(D){const R=this.J.getWindowByWebContents(D.webContents);R&&(D=this.w.getWindowById(R.parentId)?.win??null)}if(!D){const R=this.w.getLastActiveWindow();R?.win?.isMinimized()&&(D=R.win)}const L=D?this.w.getWindowById(D.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),O.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const R={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",E.CancellationToken.None,R)}else{const R={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,R)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,D){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const R=D.label.indexOf("[");R>=0?D.label=`${D.label.substr(0,R)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}nb(y,D,L=!D.accelerator){L&&(D=this.mb(y,D));const R=D.click;return D.click=(T,N,V)=>{this.pb(y),R?.(T,N,V)},D}ob(y,D){this.H.openExternal(void 0,y),this.pb(D)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,A.$0w)(y,!this.O)}};e.$ehc=a,e.$ehc=a=o=Se([se(0,k.$ZY),se(1,g.$aj),se(2,i.$cgc),se(3,u.$2fc),se(4,$.$am),se(5,h.$chc),se(6,b.$GR),se(7,m.$vgc),se(8,w.$bk),se(9,d.$2gc),se(10,v.$uk),se(11,c.$1gc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(ce[278],le([0,1,6,19,5,277,2]),function(x,e,n,r,E,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0,e.$fhc=(0,n.$Gi)("menubarMainService");let I=class extends O.$Vc{constructor(c,g,u){super(),this.b=c,this.c=g,this.f=u,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(A.$ehc))}async updateMenubar(c,g){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(g,c)}};e.$ghc=I,e.$ghc=I=Se([se(0,n.$Fi),se(1,r.$vgc),se(2,E.$bk)],I)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[279],le([0,1,26,13,106,27,21,22,39,4,32,47,2,12,9,70,3,36,18,11,7,10,69,16,53,20,14,6,19,5,72,73,74,34,51,137,29,134,270,30,103,88,59,52,76,40,58,71,84]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R,T,N,V,H,Y,de,q,Q,U,Z,W,j,C,X,oe,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0,n=Pe(n),D=Ge(D);function ue(M){return(0,q.$Vi)(M?.workspace)}function re(M){return(0,q.$Qi)(M?.workspace)}let J=class extends m.$Vc{constructor(F,_,z,ie,K,B,te,he,me,we,Ie,Ce,De,ve,$e,ee,ae,fe,be,Ae,Ne){super(),this.s=F,this.t=_,this.u=z,this.w=ie,this.z=K,this.C=B,this.D=te,this.F=he,this.G=me,this.H=we,this.I=Ie,this.J=Ce,this.L=De,this.M=ve,this.N=$e,this.O=ee,this.P=ae,this.Q=fe,this.R=be,this.S=Ae,this.U=Ne,this.a=this.B(new c.$me),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$me),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$me),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$me),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$me),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$me),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$me),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$me),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$Dhc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(F=>this.b.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const _=new m.$Uc;if(_.add(c.Event.any(F.onDidClose,F.onDidDestroy)(()=>_.dispose())),F.config.extensionDevelopmentPath)for(const z of F.config.extensionDevelopmentPath)_.add(this.R.addValidFileRoot(z));F.config.extensionTestsPath&&_.add(this.R.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,_){const z=this.G.args,ie=_?.remoteAuthority||void 0,K=!0,B=_?.forceReuseWindow,te=!B;return this.open({...F,cli:z,forceEmpty:K,forceNewWindow:te,forceReuseWindow:B,remoteAuthority:ie,forceTempProfile:_?.forceTempProfile,forceProfile:_?.forceProfile})}openExistingWindow(F,_){F.focus(),this.X(_,[F])}async open(F){this.z.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const _=[],z=[],ie=[],K=[],B=[];let te,he=0;const me=await this.db(F);this.z.trace("windowsManager#open pathsToOpen",me);for(const ve of me)re(ve)?F.addMode?_.push(ve):z.push(ve):ue(ve)?ie.push(ve):ve.fileUri?(te||(te={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ve.remoteAuthority}),te.filesToOpenOrCreate.push(ve)):ve.backupPath?B.push({backupFolder:(0,f.$oc)(ve.backupPath),remoteAuthority:ve.remoteAuthority}):he++;F.diffMode&&te&&te.filesToOpenOrCreate.length>=2&&(te.filesToDiff=te.filesToOpenOrCreate.slice(0,2),te.filesToOpenOrCreate=[]),F.mergeMode&&te&&te.filesToOpenOrCreate.length===4&&(te.filesToMerge=te.filesToOpenOrCreate.slice(0,4),te.filesToOpenOrCreate=[],te.filesToDiff=[]),te&&F.waitMarkerFileURI&&(te.filesToWait={paths:(0,O.$Hb)([...te.filesToDiff,te.filesToMerge[3],...te.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(K.push(...this.N.getUntitledWorkspaces()),ie.push(...K),B.push(...this.J.getEmptyWindowBackups())):B.length=0;const{windows:we,filesOpenedInWindow:Ie}=await this.Y(F,ie,z,B,he,te,_);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${ie.length}, foldersToOpen: ${z.length}, emptyToRestore: ${B.length}, emptyToOpen: ${he})`),we.length>1)if(Ie)Ie.focus();else{const ve=this.r.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let $e=!0,ee=!0;if(ve){const ae=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ae.length&&(ae[0].focus(),$e=!1,ee=!1)}if($e)for(let ae=we.length-1;ae>=0;ae--){const fe=we[ae];if(!(fe.openedWorkspace&&K.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&B.some(be=>fe.backupPath&&be.backupFolder===(0,f.$oc)(fe.backupPath)))){fe.focus(),ee=!1;break}}ee&&we[we.length-1].focus()}const Ce=te&&te.filesToDiff.length>0,De=te&&te.filesToMerge.length>0;if(!we.some(ve=>ve.isExtensionDevelopmentHost)&&!Ce&&!De&&!F.noRecentEntry){const ve=[];for(const $e of me)ue($e)&&!$e.transient?ve.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):re($e)?ve.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&ve.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(ve)}return this.X(F,we),we}X(F,_){const z=F.waitMarkerFileURI;F.context===H.OpenContext.CLI&&z&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(F,_,z,ie,K,B,te){const he=[];let me;function we(ae,fe){he.push(ae),fe&&(me=ae,B=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:Ce}=this.pb(F);if(!F.initialStartup&&te.length>0){const ae=te[0].remoteAuthority,fe=this.vb(ae);fe&&we(this.ab(fe,te.map(be=>be.workspace.uri)))}const De=z.length+_.length+ie.length;if(B&&De===0){const ae=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],fe=this.getWindows().filter(Ae=>B&&(0,$.$mh)(Ae.remoteAuthority,B.remoteAuthority));let be;ae?.fileUri&&!Ce&&((F.context===H.OpenContext.DESKTOP||F.context===H.OpenContext.CLI||F.context===H.OpenContext.DOCK)&&(be=await(0,Y.$hgc)(fe,ae.fileUri,async Ae=>Ae.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Ae.configPath):void 0)),be||(be=this.wb(fe))),be?(0,q.$Vi)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,q.$Qi)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(F,be,B),!0):we(await this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const ve=(0,O.$Mb)(_,ae=>ae.workspace.id);if(ve.length>0){const ae=(0,O.$Hb)(ve.map(fe=>(0,Y.$igc)(this.getWindows(),fe.workspace.configPath)));if(ae.length>0){const fe=ae[0],be=(0,$.$mh)(B?.remoteAuthority,fe.remoteAuthority)?B:void 0;we(this.Z(F,fe,be),!!be),Ie=!0}for(const fe of ve){if(ae.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Ae=(0,$.$mh)(B?.remoteAuthority,be)?B:void 0;we(await this.cb(F,fe,Ie,Ae),!!Ae),Ie=!0}}const $e=(0,O.$Mb)(z,ae=>$.$$g.getComparisonKey(ae.workspace.uri));if($e.length>0){const ae=(0,O.$Hb)($e.map(fe=>(0,Y.$igc)(this.getWindows(),fe.workspace.uri)));if(ae.length>0){const fe=ae[0],be=(0,$.$mh)(B?.remoteAuthority,fe.remoteAuthority)?B:void 0;we(this.Z(F,fe,be),!!be),Ie=!0}for(const fe of $e){if(ae.some(Ne=>(0,q.$Qi)(Ne.openedWorkspace)&&$.$$g.isEqual(Ne.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Ae=(0,$.$mh)(B?.remoteAuthority,be)?B:void 0;we(await this.cb(F,fe,Ie,Ae),!!Ae),Ie=!0}}const ee=(0,O.$Mb)(ie,ae=>ae.backupFolder);if(ee.length>0)for(const ae of ee){const fe=ae.remoteAuthority,be=(0,$.$mh)(B?.remoteAuthority,fe)?B:void 0;we(await this.bb(F,!0,fe,be,ae),!!be),Ie=!0}if(he.length===0||B){B&&!K&&K++;const ae=B?B.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<K;fe++)we(await this.bb(F,Ie,ae,B),!!B),Ie=!0}return{windows:(0,O.$Mb)(he),filesOpenedInWindow:me}}Z(F,_,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(_);const ie={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",I.CancellationToken.None,ie),_}$(F){let _=F;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==F.id){const ie=this.U.getWindowByWebContents(z.webContents);ie&&ie.parentId===F.id&&(_=ie)}_.focus()}ab(F,_){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),F.focus();const z={foldersToAdd:_};return F.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),F}bb(F,_,z,ie,K){this.z.trace("windowsManager#doOpenEmpty",{restore:!!K,remoteAuthority:z,filesToOpen:ie,forceNewWindow:_});let B;return!_&&typeof F.contextWindowId=="number"&&(B=this.getWindowById(F.contextWindowId)),this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z,forceNewWindow:_,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:B,emptyWindowBackupInfo:K,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}cb(F,_,z,ie,K){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:ie}),!z&&!K&&typeof F.contextWindowId=="number"&&(K=this.getWindowById(F.contextWindowId)),this.qb({workspace:_.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:ie,windowToUse:K,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async db(F){let _,z=!1,ie=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(_=await this.eb(F),z=!0):F.forceEmpty?_=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(_=await this.fb(F.cli),_.length===0&&_.push(Object.create(null)),z=!0):(_=await this.hb(),_.length===0&&_.push(Object.create(null)),ie=!0),!F.addMode&&z){const K=_.filter(B=>re(B));if(K.length>1){const B=K[0].remoteAuthority;if(K.every(te=>(0,$.$mh)(te.remoteAuthority,B))){const te=await this.N.createUntitledWorkspace(K.map(he=>({uri:he.workspace.uri})));_.push({workspace:te,remoteAuthority:B}),_=_.filter(he=>!re(he))}}}if(F.initialStartup&&!ie&&this.L.getValue("window")?.restoreWindows==="preserve"){const K=await this.hb();_.unshift(...K.filter(B=>ue(B)||re(B)||B.backupPath))}return _}async eb(F){const _={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},z=await Promise.all((0,O.$Hb)(F.urisToOpen||[]).map(async ie=>{const K=await this.jb(ie,_);if(K)return K.label=ie.label,K;const B=this.lb(ie);this.P.showMessageBox({type:"info",buttons:[(0,i.localize)(2465,null)],message:B.scheme===w.Schemas.file?(0,i.localize)(2466,null):(0,i.localize)(2467,null),detail:B.scheme===w.Schemas.file?(0,i.localize)(2468,null,(0,u.$4w)(B,{os:v.OS,tildify:this.G})):(0,i.localize)(2469,null,B.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Hb)(z)}async fb(F){const _=[],z={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},ie=F["folder-uri"];if(ie){const te=await Promise.all(ie.map(he=>{const me=this.gb(he);if(me)return this.jb({folderUri:me},z)}));_.push(...(0,O.$Hb)(te))}const K=F["file-uri"];if(K){const te=await Promise.all(K.map(he=>{const me=this.gb(he);if(me)return this.jb((0,q.$_i)(he)?{workspaceUri:me}:{fileUri:me},z)}));_.push(...(0,O.$Hb)(te))}const B=await Promise.all(F._.map(te=>z.remoteAuthority?this.ob(te,z):this.mb(te,z)));return _.push(...(0,O.$Hb)(B)),_}gb(F){try{const _=S.URI.parse(F);if(!_.scheme){this.z.error(`Invalid URI input string, scheme missing: ${F}`);return}return _.path?_:_.with({path:"/"})}catch(_){this.z.error(`Invalid URI input string: ${F}, ${_.message}`)}}async hb(){const F=this.ib();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];F!=="one"&&_.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&_.push(this.r.state.lastActiveWindow);const z=await Promise.all(_.map(async ie=>{if(ie.workspace){const K=await this.jb({workspaceUri:ie.workspace.configPath},{remoteAuthority:ie.remoteAuthority,rejectTransientWorkspaces:!0});if(ue(K))return K}else if(ie.folderUri){const K=await this.jb({folderUri:ie.folderUri},{remoteAuthority:ie.remoteAuthority});if(re(K))return K}else if(F!=="folders"&&ie.backupPath)return{backupPath:ie.backupPath,remoteAuthority:ie.remoteAuthority}}));return(0,O.$Hb)(z)}}}ib(){let F;return this.I.wasRestarted?F="all":(F=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async jb(F,_=Object.create(null)){const z=this.lb(F);return z.scheme===w.Schemas.file?((0,N.$dE)(F)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,_)):this.kb(F,_)}kb(F,_){let z=this.lb(F);const ie=(0,R.$in)(z)||_.remoteAuthority;if(z=(0,$.$oh)((0,$.$ih)(z)),(0,N.$dE)(F)){if(_.gotoLineMode){const{path:K,line:B,column:te}=(0,g.$Ng)(z.path);return{fileUri:z.with({path:K}),options:{selection:B?{startLineNumber:B,startColumn:te||1}:void 0},remoteAuthority:ie}}return{fileUri:z,remoteAuthority:ie}}else if((0,N.$bE)(F))return{workspace:(0,Q.$lgc)(z),remoteAuthority:ie};return{workspace:(0,Q.$mgc)(z),remoteAuthority:ie}}lb(F){return(0,N.$bE)(F)?F.workspaceUri:(0,N.$cE)(F)?F.folderUri:F.fileUri}async mb(F,_,z){let ie,K;_.gotoLineMode&&({path:F,line:ie,column:K}=(0,g.$Ng)(F)),F=(0,g.$Hg)((0,f.$ic)(F),(0,b.cwd)());try{const B=await n.promises.stat(F);if(B.isFile()){if(!_.forceOpenWorkspaceAsFile){const te=await this.N.resolveLocalWorkspace(S.URI.file(F));if(te)return te.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:te.id,configPath:te.configPath},type:a.FileType.File,exists:!0,remoteAuthority:te.remoteAuthority,transient:te.transient}}return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0,options:{selection:ie?{startLineNumber:ie,startColumn:K||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,Q.$mgc)(S.URI.file(F),B),type:a.FileType.Directory,exists:!0};if(!v.$j&&F==="/dev/null")return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(F,_);const te=S.URI.file(F);if(this.M.removeRecentlyOpened([te]),_.ignoreFileNotFound)return{fileUri:te,type:a.FileType.File,exists:!1}}}async nb(F,_){const z=S.URI.file(F),{response:ie,checkboxChecked:K}=await this.P.showMessageBox({type:"warning",buttons:[(0,i.localize)(2470,null),(0,i.localize)(2471,null),(0,i.localize)(2472,null)],message:(0,i.localize)(2473,null,z.authority),detail:(0,i.localize)(2474,null,(0,u.$4w)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,i.localize)(2475,null,z.authority),cancelId:1});if(ie===0){if((0,E.addUNCHostToAllowlist)(z.authority),K){const B={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.mb(F,_,!0)}if(ie===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(F,_)}ob(F,_){const z=F.charCodeAt(0),ie=_.remoteAuthority;let K,B;_.gotoLineMode&&({path:F,line:K,column:B}=(0,g.$Ng)(F)),z!==p.CharCode.Slash&&((0,g.$Gg)(z)&&F.charCodeAt(F.charCodeAt(1))===p.CharCode.Colon&&(F=(0,g.$zg)(F)),F=`/${F}`);const te=S.URI.from({scheme:w.Schemas.vscodeRemote,authority:ie,path:F});if(F.charCodeAt(F.length-1)!==p.CharCode.Slash){if((0,q.$_i)(F))return _.forceOpenWorkspaceAsFile?{fileUri:te,options:{selection:K?{startLineNumber:K,startColumn:B||1}:void 0},remoteAuthority:_.remoteAuthority}:{workspace:(0,Q.$lgc)(te),remoteAuthority:ie};if(_.gotoLineMode||f.$hc.basename(F).indexOf(".")!==-1)return{fileUri:te,options:{selection:K?{startLineNumber:K,startColumn:B||1}:void 0},remoteAuthority:ie}}return{workspace:(0,Q.$mgc)(te),remoteAuthority:ie}}pb(F){const _=this.L.getValue("window"),z=_?.openFoldersInNewWindow||"default",ie=_?.openFilesInNewWindow||"off";let K=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(z==="on"||z==="off")&&(K=z==="on");let B=!1;return F.forceNewWindow||F.forceReuseWindow?B=!!F.forceNewWindow&&!F.forceReuseWindow:(v.$k?F.context===H.OpenContext.DOCK&&(B=!0):F.context!==H.OpenContext.DIALOG&&F.context!==H.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!F.cli.extensionDevelopmentPath&&(ie==="on"||ie==="off")&&(B=ie==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(F,_){const z=(0,Y.$jgc)(this.getWindows(),F);if(z)return this.I.reload(z,_.cli),z.focus(),[z];let ie=_.cli["folder-uri"]||[],K=_.cli["file-uri"]||[],B=_.cli._;if(!B.length&&!ie.length&&!K.length&&!_.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(S.URI.isUri(we)?we.scheme===w.Schemas.file?B=[we.fsPath]:ie=[we.toString()]:we.configPath.scheme===w.Schemas.file?B=[(0,$.$8g)(we.configPath)]:K=[we.configPath.toString()])}let te=_.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=S.URI.parse(me),Ie=(0,R.$in)(we);Ie&&(te?(0,$.$mh)(Ie,te)||this.z.error("more than one extension development path authority"):te=Ie)}B=B.filter(me=>{const we=S.URI.file(me);return(0,Y.$igc)(this.getWindows(),we)?!1:(0,$.$mh)((0,R.$in)(we),te)}),ie=ie.filter(me=>{const we=this.gb(me);return we&&(0,Y.$igc)(this.getWindows(),we)?!1:we?(0,$.$mh)((0,R.$in)(we),te):!1}),K=K.filter(me=>{const we=this.gb(me);return we&&(0,Y.$igc)(this.getWindows(),we)?!1:we?(0,$.$mh)((0,R.$in)(we),te):!1}),_.cli._=B,_.cli["folder-uri"]=ie,_.cli["file-uri"]=K;const he={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:!B.length&&!ie.length&&!K.length,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:te,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile};return this.open(he)}async qb(F){const _=this.L.getValue("window"),z=this.getLastActiveWindow(),K=(_?.newWindowProfile?this.H.profiles.find(he=>he.name===_.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let B;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(B=F.windowToUse||z,B&&B.focus());const te={...this.G.args,...F.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,f.$kc)(this.G.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:K},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.w,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:D.default,isInitialStartup:F.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:_?.autoDetectHighContrast??!0,autoDetectColorScheme:_?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(B){const he=B.config;!te.extensionDevelopmentPath&&he?.extensionDevelopmentPath&&(te.extensionDevelopmentPath=he.extensionDevelopmentPath,te.extensionDevelopmentKind=he.extensionDevelopmentKind,te["enable-proposed-api"]=he["enable-proposed-api"],te.verbose=he.verbose,te["inspect-extensions"]=he["inspect-extensions"],te["inspect-brk-extensions"]=he["inspect-brk-extensions"],te.debugId=he.debugId,te.extensionEnvironment=he.extensionEnvironment,te["extensions-dir"]=he["extensions-dir"],te["disable-extensions"]=he["disable-extensions"]),te.loggers={global:te.loggers.global,window:he?.loggers.window??te.loggers.window}}else{const he=this.r.getNewWindowState(te);(0,d.mark)("code/willCreateCodeWindow");const me=B=this.O.createInstance(V.$tgc,{state:he,extensionDevelopmentPath:te.extensionDevelopmentPath,isExtensionTestHost:!!te.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new m.$Uc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Ce,y:De})=>this.m.fire({window:me,x:Ce,y:De})));const Ie=(0,k.$qg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return te.windowId=B.id,B.isReady?this.I.unload(B,W.UnloadReason.LOAD).then(async he=>{he||await this.rb(B,te,F,K)}):await this.rb(B,te,F,K),B}async rb(F,_,z,ie){if(_.extensionDevelopmentPath||((0,q.$Vi)(_.workspace)?_.backupPath=this.J.registerWorkspaceBackup({workspace:_.workspace,remoteAuthority:_.remoteAuthority}):(0,q.$Qi)(_.workspace)?_.backupPath=this.J.registerFolderBackup({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority}):_.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,Q.$ngc)().id,remoteAuthority:_.remoteAuthority})),this.H.isEnabled()){const K=_.workspace??(0,q.$Ui)(_.backupPath,!1),B=this.sb(z,K,ie),te=B instanceof Promise?await B:B;_.profiles.profile=te,_.extensionDevelopmentPath||await this.H.setProfileForWorkspace(K,te)}F.load(_)}sb(F,_,z){return F.forceProfile?this.H.profiles.find(ie=>ie.name===F.forceProfile)??this.H.createNamedProfile(F.forceProfile):F.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(_)??z}tb(F,_){this.n.delete(F.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),_.dispose()}ub(F){this.n.delete(F.id),this.c.fire(F)}getFocusedWindow(){const F=r.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(F){return this.wb(this.getWindows().filter(_=>(0,$.$mh)(_.remoteAuthority,F)))}wb(F){return(0,H.$egc)(F)}sendToFocused(F,..._){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,I.CancellationToken.None,..._)}sendToOpeningWindow(F,..._){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(F,I.CancellationToken.None,..._)}))}sendToAll(F,_,z){for(const ie of this.getWindows())z&&z.indexOf(ie.id)>=0||ie.sendWhenReady(F,I.CancellationToken.None,_)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(F){return this.n.get(F)}getWindowByWebContents(F){const _=r.BrowserWindow.fromWebContents(F);if(!_)return;const z=this.getWindowById(_.id);return z?.matches(F)?z:void 0}};e.$Ghc=J,e.$Ghc=J=Se([se(4,y.$bk),se(5,oe.$qgc),se(6,T.$GR),se(7,C.$uo),se(8,s.$2fc),se(9,X.$fgc),se(10,P.$vgc),se(11,h.$9fc),se(12,t.$aj),se(13,U.$chc),se(14,Z.$ogc),se(15,l.$Fi),se(16,o.$0fc),se(17,a.$bl),se(18,L.$_fc),se(19,j.$agc),se(20,G.$1gc)],J)}),define(ce[280],le([0,1,69,29,88,59]),function(x,e,n,r,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;let O=class{constructor(p,c,g,u){this.a=p,this.b=c,this.c=g,this.d=u,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,c){const g=this.b.getWindowById(p);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),c)}createUntitledWorkspace(p,c,g){return this.a.createUntitledWorkspace(c,g)}deleteUntitledWorkspace(p,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(p,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(p,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Ihc=O,e.$Ihc=O=Se([se(0,A.$ogc),se(1,r.$cgc),se(2,E.$chc),se(3,n.$9fc)],O)}),define(ce[281],le([0,1,13,106,35,27,17,55,15,4,285,47,2,12,9,3,11,7,33,160,44,161,118,135,10,69,255,16,262,96,136,53,97,189,20,68,100,177,265,179,180,181,14,193,99,83,6,98,188,271,272,256,263,19,5,278,64,28,74,266,101,34,245,87,128,24,222,223,57,50,235,260,273,261,274,132,237,238,239,242,269,51,29,279,244,30,102,88,280,59,40,202,58,215,49,86,133,247,264,252,8,225,246,197,71,268,241,21,75,267,233,208,65,84,276,78]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R,T,N,V,H,Y,de,q,Q,U,Z,W,j,C,X,oe,G,ue,re,J,M,F,_,z,ie,K,B,te,he,me,we,Ie,Ce,De,ve,$e,ee,ae,fe,be,Ae,Ne,Me,Re,Be,Ke,Ze,qe,Xe,Je,Qe,We,ne,ge,pe,ye,je,Ue,_e,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Mt,Et,dt,Nt,Ft,wt,Ct,St,Wt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;let yt=class extends m.$Vc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Oe,Te,Le,Ee,ke,He,Ve,Ye,Fe,xe,ze,et){super(),this.g=Oe,this.h=Te,this.j=Le,this.m=Ee,this.n=ke,this.s=He,this.t=Ve,this.u=Ye,this.w=Fe,this.y=xe,this.z=ze,this.C=et,this.D(),this.F()}D(){const Oe=Fe=>Fe?.startsWith(`${w.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,xe,ze,et)=>Oe(et.requestingUrl)?ze(Te.has(xe)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,xe,ze,et)=>Oe(et.requestingUrl)?Te.has(xe):!1);const Le=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),Ee=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},ke=Fe=>Fe.resourceType==="xhr"||Ee(Fe.frame),He=Fe=>{const xe=Fe.frame;if(!xe||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(xe.processId===et.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const ze=xe.frame;if(!ze||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const ze=b.URI.parse(Fe.url);return ze.scheme===w.Schemas.vscodeWebview&&!Ve(ze,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!He(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):ze.path.endsWith(".svg")&&!Le.has(ze.scheme)?xe({cancel:!ke(Fe)}):xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const ze=Fe.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return xe({cancel:!ke(Fe)})}return xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],xe({cancel:!1,responseHeaders:ze})}return xe({cancel:!1})});const Ye=n.session.defaultSession;typeof Ye.setCodeCachePath=="function"&&this.s.codeCachePath&&Ye.setCodeCachePath((0,f.$kc)(this.s.codeCachePath,"chrome")),d.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,p.$Y)(Le)||(0,p.$Z)(Le)}),process.on("unhandledRejection",Le=>(0,p.$Z)(Le)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$2X)(),n.app.on("accessibility-support-changed",(Le,Ee)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),n.app.on("activate",async(Le,Ee)=>{this.m.trace("app#activate"),Ee||await this.b?.openEmptyWindow({context:Qe.OpenContext.DOCK})}),n.app.on("web-contents-created",(Le,Ee)=>{Ee?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Zg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Ee)),Ee.on("will-navigate",ke=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Ee.setWindowOpenHandler(ke=>ke.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(ke)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${ke.url}}`),this.f?.openExternal(void 0,ke.url),{action:"deny"}))});let Oe=[],Te;n.app.on("open-file",(Le,Ee)=>{Ee=(0,kt.$om)(Ee),this.m.trace("app#open-file: ",Ee),Le.preventDefault(),Oe.push((0,ge.$_i)(Ee)?{workspaceUri:b.URI.file(Ee)}:{fileUri:b.URI.file(Ee)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Qe.OpenContext.DOCK,cli:this.s.args,urisToOpen:Oe,gotoLineMode:!1,preferNewWindow:!0}),Oe=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Qe.OpenContext.DESKTOP})}),E.$1X.handle("vscode:fetchShellEnv",Le=>{const Ee=this.b?.getWindowByWebContents(Le.sender);let ke,He;return Ee?.config?(ke=Ee.config,He={...process.env,...Ee.config.userEnv}):(ke=this.s.args,He=process.env),this.W(ke,He,!1)}),E.$1X.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),E.$1X.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),E.$1X.on("vscode:reloadWindow",Le=>Le.sender.reload()),E.$1X.handle("vscode:notifyZoomLevel",async(Le,Ee)=>{const ke=this.b?.getWindowByWebContents(Le.sender);ke&&ke.notifyZoomLevel(Ee)})}G(Oe){if(Oe){const Te={message:`[uncaught exception in main]: ${Oe.message}`,stack:Oe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Oe}`),Oe.stack&&this.m.error(Oe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Oe=this.z.win32AppUserModelId;d.$j&&Oe&&n.app.setAppUserModelId(Oe);try{d.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new i.$8X;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,Ee,ke]=await Promise.all([(0,$t.$Rhc)(this.w,this.m),(0,$t.$Shc)(this.w,this.m),(0,$t.$Thc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.O(Le,Ee,ke),Ye=await this.P(Le,Ee,ke,He);Ye.invokeFunction(ze=>ze.get(t.$Fgc)),this.B(Ye.createInstance(gt.$Mhc)),Ye.invokeFunction(ze=>this.Q(ze,Te,Ve));const Fe=await Ye.invokeFunction(ze=>this.H(ze,Te));this.I(Te),this.t.phase=F.LifecycleMainPhase.Ready,await Ye.invokeFunction(ze=>this.R(ze,Fe)),this.t.phase=F.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Sh(()=>{this.B((0,mt.$Wh)(()=>this.t.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Oe,Te){const Le=this.b=Oe.get(Qe.$cgc),Ee=Oe.get(Re.$PY),ke=this.f=Oe.get(ie.$2gc),He=Oe.get(L.$0fc),Ve=this;Ee.registerHandler({async handleURL(it,ot){return Ve.N(Le,He,Ee,it,ot)}});const Ye=this.B(new ne.$Hhc({onDidOpenMainWindow:ke.onDidOpenMainWindow,onDidFocusMainWindow:ke.onDidFocusMainWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Fe=new S.$oi(it=>Ye.getActiveClientId().then(ot=>it===ot)),xe=new Be.$yhc(Fe,this.m),ze=Te.getChannel("urlHandler",xe);Ee.registerHandler(new Be.$xhc(ze));const et=await this.J(Le,He);return this.B(new Ze.$zhc(et?.urls,Ee,Le,this.s,this.z,this.m)),et}I(Oe){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Ct.$U(()=>Oe.getChannel(wt.$1hc,new wt.$2hc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(Ee,ke)=>{const He=b.URI.parse(Ee.url);if(!He.authority.startsWith("window:"))return ke(Te());Le.value.call(wt.$Zhc,[He]).then(Ve=>ke({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),ke({statusCode:500,data:String(Ve)})})})}async J(Oe,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Le.length+Ee.length===0)return;const ke=[...Le,...Ee].map(Ye=>{try{return{uri:b.URI.parse(Ye),originalUrl:Ye}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ye);return}}),He=[],Ve=[];for(const Ye of ke){if(!Ye)continue;const Fe=this.M(Ye.uri);if(Fe)if(await this.L(Fe,Oe,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ye.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ye.uri.toString(!0),Fe),He.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ye.uri.toString(!0)),Ve.push(Ye)}return{urls:Ve,openables:He}}async L(Oe,Te,Le){let Ee,ke;if((0,Je.$bE)(Oe)?(Ee=Oe.workspaceUri,ke=(0,o.localize)(141,null,Ee.scheme===w.Schemas.file?(0,u.$4w)(Ee,{os:d.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(0,Je.$cE)(Oe)?(Ee=Oe.folderUri,ke=(0,o.localize)(142,null,Ee.scheme===w.Schemas.file?(0,u.$4w)(Ee,{os:d.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(Ee=Oe.fileUri,ke=(0,o.localize)(143,null,Ee.scheme===w.Schemas.file?(0,u.$4w)(Ee,{os:d.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)),Ee.scheme!==w.Schemas.file&&Ee.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[Ee.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ye}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(144,null),(0,o.localize)(145,null)],message:ke,detail:(0,o.localize)(146,null),checkboxLabel:Ee.scheme===w.Schemas.file?(0,o.localize)(147,null):(0,o.localize)(148,null),cancelId:1});if(Ve!==0)return!0;if(Ye){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:Ee.scheme===w.Schemas.file?"local":"remote"};Te.sendToFocused(Fe.channel,Fe.args),Te.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}M(Oe){if(Oe.path){if(Oe.authority===w.Schemas.file){const Te=b.URI.file(Oe.fsPath);return(0,ge.$_i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Oe.authority===w.Schemas.vscodeRemote){const Te=Oe.path.indexOf(f.$hc.sep,1);if(Te!==-1){const Le=Oe.path.substring(1,Te),Ee=Oe.path.substring(Te);let ke=Oe.query;const He=new URLSearchParams(Oe.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),ke=He.toString());const Ve=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:Le,path:Ee,query:ke,fragment:Oe.fragment});return(0,ge.$_i)(Ee)?{workspaceUri:Ve}:/:[\d]+$/.test(Ee)?{fileUri:Ve}:{folderUri:Ve}}}}}async N(Oe,Te,Le,Ee,ke){this.m.trace("app#handleProtocolUrl():",Ee.toString(!0),ke),Ee.scheme===this.z.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:b.URI.parse(Ee.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(Ee.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),Ve.delete("windowId"),Ee=Ee.with({query:Ve.toString()}),He=!0):d.$k&&Oe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),He=!0);const Ye=Ve.get("continueOn");Ye!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),Ve.delete("continueOn"),Ee=Ee.with({query:Ve.toString()}),this.s.continueOn=Ye??void 0);const Fe=this.M(Ee);return Fe?await this.L(Fe,Oe,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,Ee.toString(!0)),(0,Et.$Ob)(await Oe.open({context:Qe.OpenContext.API,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0)),await(0,Et.$Ob)(await Oe.open({context:Qe.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,B.$in)(Ee)}))?.ready(),Le.open(Ee,ke)):(this.m.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),ke),!1)}O(Oe,Te,Le){const Ee=this.B(this.j.createInstance(te.$khc,Oe,Te,Le));this.B(Ee.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const ke=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await Ee.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new h.$9X(Ve,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),ke))(),sharedProcessClient:ke}}async P(Oe,Te,Le,Ee){const ke=new oe.$Ei;switch(process.platform){case"win32":ke.set(ae.$ZY,new C.$Di(Me.$vhc));break;case"linux":d.$m?ke.set(ae.$ZY,new C.$Di(Ne.$uhc,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(ae.$ZY,new C.$Di(Ae.$thc));break;case"darwin":ke.set(ae.$ZY,new C.$Di(be.$shc));break}ke.set(Qe.$cgc,new C.$Di(We.$Ghc,[Oe,Te,Le,this.h],!1)),ke.set(St.$1gc,new C.$Di(Wt.$3hc,void 0,!1));const He=new L.$$fc(this.m,this.z);ke.set(L.$0fc,He),ke.set(M.$9gc,new C.$Di(M.$0gc,void 0,!1)),ke.set(D.$Mgc,new C.$Di(D.$Ngc,void 0,!1)),ke.set(y.$Um,S.ProxyChannel.toService((0,S.$mi)(Ee.then(ze=>ze.getChannel("diagnostics"))))),ke.set(G.$wac,new C.$Di(ue.$4gc,[this.h])),ke.set(G.$xac,new C.$Di(re.$5gc,[this.h])),ke.set(R.$JY,new C.$Di(T.$Ogc)),ke.set(J.$6gc,new C.$Di(J.$7gc)),ke.set(ie.$2gc,new C.$Di(ie.$3gc,void 0,!1)),ke.set(qe.$Ahc,new C.$Di(Xe.$Chc)),ke.set(z.$fhc,new C.$Di(z.$ghc)),ke.set(Y.$Pgc,new C.$Di(de.$Rgc)),ke.set(Ie.$Bgc,new C.$Di(Ie.$Cgc)),ke.set(Ie.$Dgc,new C.$Di(Ie.$Egc));const Ve=new Nt.$Yhc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ye=new Ft.$Ts(Ve,this.u,this.m,this.n);ke.set(dt.$us,Ye),d.$j?ke.set(q.$Sgc,new C.$Di(Q.$Tgc)):d.$k?ke.set(q.$Sgc,new C.$Di(Q.$Ugc)):d.$l&&ke.set(q.$Sgc,new C.$Di(Q.$Vgc));const Fe=new a.$Hgc(this.s,this.u,this.m,this.w);ke.set(s.$9fc,Fe);const xe=new Ue.$pgc(this.s,this.m,this.C,Fe,He);if(ke.set(Ue.$ogc,xe),ke.set(pe.$kib,new C.$Di(je.$Ihc,void 0,!1)),ke.set(ye.$chc,new C.$Di(ye.$dhc,void 0,!1)),ke.set(Re.$PY,new C.$Di(Ke.$RY,void 0,!1)),(0,ee.$Fp)(this.z,this.s)){const ze=(0,ee.$Kp)(this.z,this.u),et=(0,S.$mi)(Ee.then(vt=>vt.getChannel("telemetryAppender"))),it=new ve.$nhc(et),ot=(0,Ce.$wp)((0,A.release)(),(0,A.hostname)(),process.arch,this.z.commit,this.z.version,Oe,Te,Le,ze),nt=(0,ee.$Lp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};ke.set(De.$am,new C.$Di($e.$ks,[ht],!1))}else ke.set(De.$am,ee.$Ap);return ke.set(ut.$Mq,new C.$Di(Tt.$NR,void 0,!0)),ke.set(ct.$Qq,new C.$Di(ft.$Lhc,void 0,!0)),ke.set(pt.$Whc,new C.$Di(pt.$Xhc,void 0,!0)),ke.set(t.$Fgc,new C.$Di(t.$Ggc)),await mt.Promises.settled([Fe.initialize(),xe.initialize()]),this.j.createChild(ke)}Q(Oe,Te,Le){const Ee=this.B(new m.$Uc),ke=S.ProxyChannel.fromService(Oe.get(M.$9gc),Ee,{disableMarshalling:!0});this.g.registerChannel("launch",ke);const He=S.ProxyChannel.fromService(Oe.get(D.$Mgc),Ee,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=Ee.add(new lt.$Jhc(Oe.get(_e.$uo)));Te.registerChannel("policy",Ve),Le.then(st=>st.registerChannel("policy",Ve));const Ye=this.y.getProvider(w.Schemas.file);(0,v.$pg)(Ye instanceof j.$wr);const Fe=Ee.add(new W.$Wgc(Ye,this.m,this.s));Te.registerChannel(U.$wR,Fe),Le.then(st=>st.registerChannel(U.$wR,Fe));const xe=S.ProxyChannel.fromService(Oe.get(rt.$fgc),Ee);Te.registerChannel("userDataProfiles",xe),Le.then(st=>st.registerChannel("userDataProfiles",xe));const ze=new at.$fs(Oe.get(tt.$9p));Le.then(st=>st.registerChannel("request",ze));const et=new fe.$ohc(Oe.get(ae.$ZY));Te.registerChannel("update",et);const it=S.ProxyChannel.fromService(Oe.get(G.$wac),Ee);Te.registerChannel("issue",it);const ot=S.ProxyChannel.fromService(Oe.get(G.$xac),Ee);Te.registerChannel("process",ot);const nt=S.ProxyChannel.fromService(Oe.get(R.$JY),Ee);Te.registerChannel("encryption",nt);const ht=S.ProxyChannel.fromService(Oe.get(he.$1l),Ee);Te.registerChannel("sign",ht);const vt=S.ProxyChannel.fromService(Oe.get(J.$6gc),Ee);Te.registerChannel("keyboardLayout",vt),this.f=Oe.get(ie.$2gc);const Pt=S.ProxyChannel.fromService(this.f,Ee);Te.registerChannel("nativeHost",Pt),Le.then(st=>st.registerChannel("nativeHost",Pt));const Bt=S.ProxyChannel.fromService(Oe.get(pe.$kib),Ee);Te.registerChannel("workspaces",Bt);const Ut=S.ProxyChannel.fromService(Oe.get(z.$fhc),Ee);Te.registerChannel("menubar",Ut);const zt=S.ProxyChannel.fromService(Oe.get(Re.$PY),Ee);Te.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Oe.get(qe.$Ahc),Ee);Te.registerChannel("webview",qt);const It=Ee.add(new we.$lhc(this.m,Oe.get(Ie.$Bgc)));Te.registerChannel("storage",It),Le.then(st=>st.registerChannel("storage",It));const Ht=Ee.add(new Ot.$Nhc(Oe.get(Ie.$Bgc),Oe.get(rt.$fgc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",Ht));const xt=S.ProxyChannel.fromService(Oe.get(dt.$us),Ee);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Vt=S.ProxyChannel.fromService(Oe.get(q.$Sgc),Ee);Te.registerChannel("externalTerminal",Vt);const Dt=new Lt.$Uhc(Oe.get(jt.$qgc));Te.registerChannel("logger",Dt),Le.then(st=>st.registerChannel("logger",Dt));const Gt=new P.$Igc(Oe.get(Qe.$cgc));Te.registerChannel("extensionhostdebugservice",Gt);const Kt=S.ProxyChannel.fromService(Oe.get(Y.$Pgc),Ee);Te.registerChannel(Y.$Qgc,Kt);const Yt=S.ProxyChannel.fromService(Oe.get(pt.$Whc),Ee);Te.registerChannel(Mt.$Vhc,Yt)}async R(Oe,Te){const Le=this.b=Oe.get(Qe.$cgc);this.c=Oe.get(St.$1gc);const Ee=(0,V.$Lm)(process.env)?Qe.OpenContext.CLI:Qe.OpenContext.DESKTOP,ke=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:Ee,cli:ke,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=ke._.length,Ye=!!ke["folder-uri"],Fe=!!ke["file-uri"],xe=ke["skip-add-to-recently-opened"]===!0,ze=ke.wait&&ke.waitMarkerFilePath?b.URI.file(ke.waitMarkerFilePath):void 0,et=ke.remote||void 0,it=ke.profile,ot=ke["profile-temp"];if(!Ve&&!Ye&&!Fe){if(ke["new-window"]||it||ot)return Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(He.length)return Le.open({context:Qe.OpenContext.DOCK,cli:ke,urisToOpen:He.map(nt=>(nt=(0,kt.$om)(nt),(0,ge.$_i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0})}return Le.open({context:Ee,cli:ke,forceNewWindow:ke["new-window"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:xe,waitMarkerFileURI:ze,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Oe,Te)=>{Te({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),this.W(this.s.args,process.env,!0),this.X(),d.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Oe=this.z.win32MutexName;if(d.$j&&Oe)try{const Te=await new Promise((Ee,ke)=>{x(["@vscode/windows-mutex"],Ee,ke)}).then(Pe),Le=new Te.Mutex(Oe);c.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(Oe,Te,Le){try{return await(0,H.$Sm)(this.u,this.m,Oe,Te)}catch(Ee){const ke=(0,I.$rj)(Ee);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",ke):this.m.error(ke)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,g.parse)(Te),ke=(0,ee.$Hp)(this.u)>=De.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$3g)()}"`,"}"],Ve=Te.substring(0,Te.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Oe.fromString(Ve))}else{const He=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);He!==Te&&await this.y.writeFile(this.s.argvResource,O.$Oe.fromString(He))}}catch(Oe){this.m.error(Oe),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$4hc=yt,e.$4hc=yt=bt=Se([se(2,X.$Fi),se(3,_.$bk),se(4,_.$ck),se(5,N.$2fc),se(6,F.$vgc),se(7,l.$aj),se(8,me.$GR),se(9,Z.$bl),se(10,K.$uk),se(11,rt.$fgc)],yt)});var Ge=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[286],le([0,1,13,26,7,21,8,55,15,32,4,47,12,9,70,3,36,25,23,44,104,281,10,16,207,221,20,68,172,14,191,99,83,187,98,19,194,5,72,28,73,248,131,259,49,258,101,220,34,57,76,58,40,203,201,2,41,236,71,196,123,127,240,106,234]),function(x,e,n,r,E,A,O,I,p,c,g,u,m,w,f,d,v,b,$,k,S,i,h,t,o,s,a,l,P,y,D,L,R,T,N,V,H,Y,de,q,Q,U,Z,W,j,C,X,oe,G,ue,re,J,M,F,_,z,ie,K,B,te,he,me,we,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=Ge(de);class Ce{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Re=>console.error(Re));const[$e,ee,ae,fe,be,Ae,Ne,Me]=this.b();try{try{await this.d(ae,Me,fe,be,Ne)}catch(Re){throw this.g(ae,Ne,Re),Re}await $e.invokeFunction(async Re=>{const Be=Re.get(Y.$bk),Ke=Re.get(V.$vgc),Ze=Re.get(y.$bl),qe=Re.get(Y.$ck),Xe=await this.f(Be,ae,Ke,$e,Ne,!0);return $.Promises.writeFile(ae.mainLockfile,String(process.pid)).catch(Je=>{Be.warn(`app#startup(): Error writing main lockfile: ${Je.stack}`)}),Ae.logger=qe.createLogger("main",{name:(0,h.localize)(149,null)}),g.Event.once(Ke.onWillShutdown)(Je=>{Ze.dispose(),fe.dispose(),Je.join("instanceLockfile",r.promises.unlink(ae.mainLockfile).catch(()=>{}))}),$e.createInstance(i.$4hc,Xe,ee).startup()})}catch(Re){$e.invokeFunction(this.j,Re)}}b(){const $e=new N.$Ei,ee=new z.$Uc;process.once("exit",()=>ee.dispose());const ae={_serviceBrand:void 0,...de.default};$e.set(q.$uk,ae);const fe=new a.$3fc(this.k(),ae),be=this.c(fe);$e.set(a.$2fc,fe);const Ae=new B.$rgc((0,Y.$pk)(fe),fe.logsHome);$e.set(B.$qgc,Ae);const Ne=new H.$Bdc(Ae.getLogLevel()),Me=ee.add(new te.$OR(Ne,[new Y.$ik(Ae.getLogLevel())]));$e.set(Y.$bk,Me);const Re=new D.$6q(Me);$e.set(y.$bl,Re);const Be=new L.$wr(Me);Re.registerProvider(m.Schemas.file,Be);const Ke=new K.$Xs(Re);$e.set(ie.$Ll,Ke);const Ze=new me.$JR(me.SaveStrategy.DELAYED,fe,Me,Re);$e.set(G.$FR,Ze),$e.set(G.$GR,Ze);const qe=new J.$ggc(Ze,Ke,fe,Re,Me);$e.set(J.$fgc,qe),Re.registerProvider(m.Schemas.vscodeUserData,new we.$cic(m.Schemas.file,Be,m.Schemas.vscodeUserData,qe,Ke,Me));const Xe=d.$j&&ae.win32RegValueName?ee.add(new F.$aic(Me,ae.win32RegValueName)):fe.policyFile?ee.add(new _.$bic(fe.policyFile,Re,Me)):new M.$wo;$e.set(M.$uo,Xe);const Je=new o.$Yo(qe.defaultProfile.settingsResource,Re,Xe,Me);return $e.set(t.$aj,Je),$e.set(V.$vgc,new R.$Di(V.$wgc,void 0,!1)),$e.set(j.$9p,new R.$Di(C.$$hc,void 0,!0)),$e.set(re.$agc,new R.$Di(re.$bgc)),$e.set(X.$1l,new R.$Di(oe.$_hc,void 0,!1)),$e.set(Z.$Iw,new R.$Di(W.$9hc)),$e.set(Q.$_fc,new U.$6hc(fe,qe,Me)),[new T.$zr($e,!0),be,fe,Je,Ze,Ne,ae,qe]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const fe=process.env[ae];typeof fe=="string"&&(ee[ae]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,ae,fe,be){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:m.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:m.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?r.promises.mkdir(Ae,{recursive:!0}):void 0)),fe.init(),ae.initialize()]),ee.init()}e($e){if(d.$j){const ee=(0,Ie.getUNCHost)($e);ee&&(0,Ie.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,ae,fe,be,Ae){let Ne;try{(0,f.mark)("code/willStartMainServer"),Ne=await(0,S.$Bi)(ee.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),g.Event.once(ae.onWillShutdown)(()=>Ne.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(ee,be,Me),Me;let Re;try{Re=await(0,S.$Ci)(ee.mainIPCHandle,"main")}catch(qe){if(!Ae||d.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,h.localize)(150,null,be.nameShort),(0,h.localize)(151,null),be),qe;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Xe){throw $e.warn("Could not delete obsolete instance handle",Xe),Xe}return this.f($e,ee,ae,fe,be,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Re.dispose(),new Error(qe)}let Be;!ee.args.wait&&!ee.args.status&&(Be=setTimeout(()=>{this.h((0,h.localize)(152,null,be.nameShort),(0,h.localize)(153,null),be)},1e4));const Ke=k.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),Ze=k.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const qe=new s.$5s(ue.$Ap,be),Xe=await Ze.getMainDiagnostics(),Je=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await qe.getDiagnostics(Xe,Je);throw console.log(Qe),new p.$ab});throw d.$j&&await this.i(Ke,$e),$e.trace("Sending env to running instance..."),await Ke.start(ee.args,process.env),Re.dispose(),Be&&clearTimeout(Be),new p.$ab("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,h.localize)(154,null,be.nameShort)),new p.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}g($e,ee,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const fe=(0,A.$Hb)([$e.userDataPath,$e.extensionsPath,S.$xi]).map(be=>(0,u.$4w)(E.URI.file(be),{os:d.OS,tildify:$e}));this.h((0,h.localize)(155,null),(0,h.localize)(156,null,(0,I.$rj)(ae),fe.join(`
`)),ee)}}h($e,ee,ae){n.dialog.showMessageBoxSync((0,he.$fx)({type:"warning",buttons:[(0,h.localize)(157,null)],message:$e,detail:ee},ae).options)}async i($e,ee){if(d.$j){const ae=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(Pe)).allowSetForegroundWindow(ae)}catch(fe){ee.error(fe)}}}j($e,ee){const ae=$e.get(Y.$bk),fe=$e.get(V.$vgc);let be=0;ee&&(ee.isExpected?ee.message&&ae.trace(ee.message):(be=1,ee.stack?ae.error(ee.stack):ae.error(`Startup error: ${ee.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Im)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,P.$5hc)($e.verbose);ee&&((0,l.$Km)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const ae=(0,v.cwd)(),fe=$e.map(Ne=>{let Me=String(Ne),Re;ee&&(Re=(0,c.$Ng)(Me),Me=Re.path),Me&&(Me=this.n(ae,Me));const Be=(0,c.$Hg)(Me,ae),Ke=(0,w.$oc)(Be);return Ke&&!(0,c.$Dg)(Ke)?null:ee&&Re?(Re.path=Be,this.o(Re)):Be}),be=d.$j||d.$k,Ae=(0,A.$Mb)(fe,Ne=>Ne&&be?Ne.toLowerCase():Ne||"");return(0,A.$Hb)(Ae)}n($e,ee){return d.$j&&(ee=(0,b.$of)(ee,'"')),ee=(0,b.$mf)((0,b.$mf)(ee," "),"	"),d.$j&&(ee=(0,w.$lc)($e,ee),ee=(0,b.$of)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d4c4e690b9f1e70291da9a46c5c8ac5ebfbda81a/core/vs/code/electron-main/main.js.map
