/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","vs/amdX","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/request/common/request","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],de=function(ce){for(var e=[],R=0,a=ce.length;R<a;R++)e[R]=ue[ce[R]];return e};define(ue[129],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.LoaderEventType=e.$S=e.$R=void 0,e.$R=!1,e.$S=!0;var R;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class a{static get(){const A=new Map,T=new Map,k=new Map,O=new Map;function y(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function I(l,g){const E=l.get(g.detail);E&&(E>=0||l.set(g.detail,E+g.timestamp))}let p=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(p=ce.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of p)switch(l.type){case R.BeginLoadingScript:y(A,l);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:I(A,l);break;case R.BeginInvokeFactory:y(T,l);break;case R.EndInvokeFactory:I(T,l);break;case R.NodeBeginNativeRequire:y(k,l);break;case R.NodeEndNativeRequire:I(k,l);break;case R.NodeBeginEvaluatingScript:y(O,l);break;case R.NodeEndEvaluatingScript:I(O,l);break}let f=0;k.forEach(l=>f+=l);function d(l){const g=[];return l.forEach((E,m)=>g.push([m,E])),g}return{amdLoad:d(A),amdInvoke:d(T),nodeRequire:d(k),nodeEval:d(O),nodeRequireTotal:f}}static toMarkdownTable(A,T){let k="";const O=[];return A.forEach((y,I)=>{O[I]=y.length}),T.forEach(y=>{y.forEach((I,p)=>{typeof I>"u"&&(I=y[p]="-");const f=I.toString().length;O[p]=Math.max(f,O[p])})}),A.forEach((y,I)=>{k+=`| ${y+" ".repeat(O[I]-y.toString().length)} `}),k+=`|
`,A.forEach((y,I)=>{k+=`| ${"-".repeat(O[I])} `}),k+=`|
`,T.forEach(y=>{y.forEach((I,p)=>{typeof I<"u"&&(k+=`| ${I+" ".repeat(O[p]-I.toString().length)} `)}),k+=`|
`}),k}}e.$T=a}),define(ue[130],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=R,e.$gb=a,e.$hb=N,e.$ib=A,e.$jb=T,e.$kb=k,e.$lb=O,e.$nb=I,e.$ob=p,e.$pb=f,e.$qb=d,e.$rb=l;function R(g,E){const m=a(g,E);if(m!==-1)return g[m]}function a(g,E,m=g.length-1){for(let w=m;w>=0;w--){const P=g[w];if(E(P))return w}return-1}function N(g,E){const m=A(g,E);return m===-1?void 0:g[m]}function A(g,E,m=0,w=g.length){let P=m,$=w;for(;P<$;){const c=Math.floor((P+$)/2);E(g[c])?P=c+1:$=c}return P-1}function T(g,E){const m=k(g,E);return m===g.length?void 0:g[m]}function k(g,E,m=0,w=g.length){let P=m,$=w;for(;P<$;){const c=Math.floor((P+$)/2);E(g[c])?$=c:P=c+1}return P}function O(g,E,m=0,w=g.length){const P=k(g,E,m,w);return P===g.length?-1:P}class y{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(y.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const m=A(this.e,E,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=y;function I(g,E){if(g.length===0)return;let m=g[0];for(let w=1;w<g.length;w++){const P=g[w];E(P,m)>0&&(m=P)}return m}function p(g,E){if(g.length===0)return;let m=g[0];for(let w=1;w<g.length;w++){const P=g[w];E(P,m)>=0&&(m=P)}return m}function f(g,E){return I(g,(m,w)=>-E(m,w))}function d(g,E){if(g.length===0)return-1;let m=0;for(let w=1;w<g.length;w++){const P=g[w];E(P,g[m])>0&&(m=w)}return m}function l(g,E){for(const m of g){const w=E(m);if(w!==void 0)return w}}}),define(ue[39],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(ue[131],de([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=a,e.$d=N,e.$e=A,e.$f=T;function a(O,y){const I=Object.create(null);for(const p of O){const f=y(p);let d=I[f];d||(d=I[f]=[]),d.push(p)}return I}function N(O,y){const I=[],p=[];for(const f of O)y.has(f)||I.push(f);for(const f of y)O.has(f)||p.push(f);return{removed:I,added:p}}function A(O,y){const I=[],p=[];for(const[f,d]of O)y.has(f)||I.push(d);for(const[f,d]of y)O.has(f)||p.push(d);return{removed:I,added:p}}function T(O,y){const I=new Set;for(const p of y)O.has(p)&&I.add(p);return I}class k{static{R=Symbol.toStringTag}constructor(y,I){this.b=I,this.a=new Map,this[R]="SetWithKey";for(const p of y)this.add(p)}get size(){return this.a.size}add(y){const I=this.b(y);return this.a.set(I,y),this}delete(y){return this.a.delete(this.b(y))}has(y){return this.a.has(this.b(y))}*entries(){for(const y of this.a.values())yield[y,y]}keys(){return this.values()}*values(){for(const y of this.a.values())yield y}clear(){this.a.clear()}forEach(y,I){this.a.forEach(p=>y.call(I,p,p,this))}[Symbol.iterator](){return this.values()}}e.$g=k}),define(ue[88],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=a,e.$_h=N,e.$ai=A;function R(T){return(k,O,y)=>{let I=null,p=null;if(typeof y.value=="function"?(I="value",p=y.value):typeof y.get=="function"&&(I="get",p=y.get),!p)throw new Error("not supported");y[I]=T(p,O)}}function a(T,k,O){let y=null,I=null;if(typeof O.value=="function"?(y="value",I=O.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof O.get=="function"&&(y="get",I=O.get),!I)throw new Error("not supported");const p=`$memoize$${k}`;O[y]=function(...f){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[p]}}function N(T,k,O){return R((y,I)=>{const p=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...d){this[f]||(this[f]=O?O():void 0),clearTimeout(this[p]),k&&(this[f]=k(this[f],...d),d=[this[f]]),this[p]=setTimeout(()=>{y.apply(this,d),this[f]=O?O():void 0},T)}})}function A(T,k,O){return R((y,I)=>{const p=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,d=`$throttle$lastRun$${I}`,l=`$throttle$pending$${I}`;return function(...g){if(this[f]||(this[f]=O?O():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),k&&(this[f]=k(this[f],...g)),this[l])return;const E=this[d]+T;E<=Date.now()?(this[d]=Date.now(),y.apply(this,[this[f]]),this[f]=O?O():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),y.apply(this,[this[f]]),this[f]=O?O():void 0},E-Date.now()))}})}}),define(ue[8],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$W=e.$V=void 0,e.setUnexpectedErrorHandler=a,e.$Y=N,e.$Z=A,e.$1=T,e.$2=k,e.$3=O,e.$4=I,e.$6=f,e.$7=d,e.$8=l,e.$0=E;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=R,e.$W=new R;function a(h){e.$W.setUnexpectedErrorHandler(h)}function N(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(h){I(h)||e.$W.onUnexpectedError(h)}function T(h){I(h)||e.$W.onUnexpectedExternalError(h)}function k(h){if(h instanceof Error){const{name:i,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:$.isErrorNoTelemetry(h)}}return h}function O(h){let i;return h.noTelemetry?i=new $:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const y="Canceled";function I(h){return h instanceof p?!0:h instanceof Error&&h.name===y&&h.message===y}class p extends Error{constructor(){super(y),this.name=this.message}}e.$5=p;function f(){const h=new Error(y);return h.name=h.message,h}function d(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=g;function E(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=m;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=P;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const n=new $;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=$;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(ue[17],de([0,1,8,130]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=N,e.$tb=A,e.$ub=T,e.$vb=k,e.$wb=O,e.$xb=y,e.$yb=I,e.$zb=p,e.$Ab=f,e.$Bb=d,e.$Cb=l,e.$Db=g,e.$Eb=E,e.top=m,e.$Gb=w,e.$Hb=$,e.$Ib=c,e.$Jb=h,e.$Kb=i,e.$Lb=n,e.$Mb=t,e.$Nb=s,e.$Ob=r,e.$Pb=o,e.$Qb=u,e.$Rb=b,e.$Sb=L,e.$Tb=S,e.$Ub=v,e.$Vb=C,e.$Wb=U,e.$Xb=F,e.$Yb=j,e.$Zb=H,e.$1b=W,e.$2b=x,e.$3b=G,e.$4b=te,e.$5b=B,e.$6b=ne,e.$7b=le,e.$0b=K,e.$bc=oe;function N(Y,Z=0){return Y[Y.length-(1+Z)]}function A(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}function T(Y,Z,M=(z,ie)=>z===ie){if(Y===Z)return!0;if(!Y||!Z||Y.length!==Z.length)return!1;for(let z=0,ie=Y.length;z<ie;z++)if(!M(Y[z],Z[z]))return!1;return!0}function k(Y,Z){const M=Y.length-1;Z<M&&(Y[Z]=Y[M]),Y.pop()}function O(Y,Z,M){return y(Y.length,z=>M(Y[z],Z))}function y(Y,Z){let M=0,z=Y-1;for(;M<=z;){const ie=(M+z)/2|0,ae=Z(ie);if(ae<0)M=ie+1;else if(ae>0)z=ie-1;else return ie}return-(M+1)}function I(Y,Z,M){if(Y=Y|0,Y>=Z.length)throw new TypeError("invalid index");const z=Z[Math.floor(Z.length*Math.random())],ie=[],ae=[],he=[];for(const pe of Z){const be=M(pe,z);be<0?ie.push(pe):be>0?ae.push(pe):he.push(pe)}return Y<ie.length?I(Y,ie,M):Y<ie.length+he.length?he[0]:I(Y-(ie.length+he.length),ae,M)}function p(Y,Z){const M=[];let z;for(const ie of Y.slice(0).sort(Z))!z||Z(z[0],ie)!==0?(z=[ie],M.push(z)):z.push(ie);return M}function*f(Y,Z){let M,z;for(const ie of Y)z!==void 0&&Z(z,ie)?M.push(ie):(M&&(yield M),M=[ie]),z=ie;M&&(yield M)}function d(Y,Z){for(let M=0;M<=Y.length;M++)Z(M===0?void 0:Y[M-1],M===Y.length?void 0:Y[M])}function l(Y,Z){for(let M=0;M<Y.length;M++)Z(M===0?void 0:Y[M-1],Y[M],M+1===Y.length?void 0:Y[M+1])}function g(Y,Z,M){const z=[];function ie(pe,be,Pe){if(be===0&&Pe.length===0)return;const ve=z[z.length-1];ve&&ve.start+ve.deleteCount===pe?(ve.deleteCount+=be,ve.toInsert.push(...Pe)):z.push({start:pe,deleteCount:be,toInsert:Pe})}let ae=0,he=0;for(;;){if(ae===Y.length){ie(ae,0,Z.slice(he));break}if(he===Z.length){ie(ae,Y.length-ae,[]);break}const pe=Y[ae],be=Z[he],Pe=M(pe,be);Pe===0?(ae+=1,he+=1):Pe<0?(ie(ae,1,[]),ae+=1):Pe>0&&(ie(ae,0,[be]),he+=1)}return z}function E(Y,Z,M){const z=g(Y,Z,M),ie=[],ae=[];for(const he of z)ie.push(...Y.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:ie,added:ae}}function m(Y,Z,M){if(M===0)return[];const z=Y.slice(0,M).sort(Z);return P(Y,Z,z,M,Y.length),z}function w(Y,Z,M,z,ie){return M===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const pe=Y.length,be=Y.slice(0,M).sort(Z);for(let Pe=M,ve=Math.min(M+z,pe);Pe<pe;Pe=ve,ve=Math.min(ve+z,pe)){if(Pe>M&&await new Promise(we=>setTimeout(we)),ie&&ie.isCancellationRequested)throw new R.$5;P(Y,Z,be,Pe,ve)}return be})().then(ae,he)})}function P(Y,Z,M,z,ie){for(const ae=M.length;z<ie;z++){const he=Y[z];if(Z(he,M[ae-1])<0){M.pop();const pe=(0,a.$kb)(M,be=>Z(he,be)<0);M.splice(pe,0,he)}}}function $(Y){return Y.filter(Z=>!!Z)}function c(Y){let Z=0;for(let M=0;M<Y.length;M++)Y[M]&&(Y[Z]=Y[M],Z+=1);Y.length=Z}function h(Y,Z,M){Y.splice(M,0,Y.splice(Z,1)[0])}function i(Y){return!Array.isArray(Y)||Y.length===0}function n(Y){return Array.isArray(Y)&&Y.length>0}function t(Y,Z=M=>M){const M=new Set;return Y.filter(z=>{const ie=Z(z);return M.has(ie)?!1:(M.add(ie),!0)})}function s(Y){const Z=new Set;return M=>{const z=Y(M);return Z.has(z)?!1:(Z.add(z),!0)}}function r(Y,Z){return Y.length>0?Y[0]:Z}function o(Y,Z){return Y.length>0?Y[Y.length-1]:Z}function u(Y,Z,M=(z,ie)=>z===ie){let z=0;for(let ie=0,ae=Math.min(Y.length,Z.length);ie<ae&&M(Y[ie],Z[ie]);ie++)z++;return z}function b(Y,Z){let M=typeof Z=="number"?Y:0;typeof Z=="number"?M=Y:(M=0,Z=Y);const z=[];if(M<=Z)for(let ie=M;ie<Z;ie++)z.push(ie);else for(let ie=M;ie>Z;ie--)z.push(ie);return z}function L(Y,Z,M){return Y.reduce((z,ie)=>(z[Z(ie)]=M?M(ie):ie,z),Object.create(null))}function S(Y,Z){return Y.push(Z),()=>v(Y,Z)}function v(Y,Z){const M=Y.indexOf(Z);if(M>-1)return Y.splice(M,1),Z}function C(Y,Z,M){const z=Y.slice(0,Z),ie=Y.slice(Z);return z.concat(M,ie)}function U(Y,Z){let M;if(typeof Z=="number"){let z=Z;M=()=>{const ie=Math.sin(z++)*179426549;return ie-Math.floor(ie)}}else M=Math.random;for(let z=Y.length-1;z>0;z-=1){const ie=Math.floor(M()*(z+1)),ae=Y[z];Y[z]=Y[ie],Y[ie]=ae}}function F(Y,Z){const M=Y.indexOf(Z);M>-1&&(Y.splice(M,1),Y.unshift(Z))}function j(Y,Z){const M=Y.indexOf(Z);M>-1&&(Y.splice(M,1),Y.push(Z))}function H(Y,Z){for(const M of Z)Y.push(M)}function W(Y,Z){return Array.isArray(Y)?Y.map(Z):Z(Y)}function x(Y){return Array.isArray(Y)?Y:[Y]}function G(Y){return Y[Math.floor(Math.random()*Y.length)]}function te(Y,Z,M){const z=V(Y,Z),ie=Y.length,ae=M.length;Y.length=ie+ae;for(let he=ie-1;he>=z;he--)Y[he+ae]=Y[he];for(let he=0;he<ae;he++)Y[he+z]=M[he]}function B(Y,Z,M,z){const ie=V(Y,Z);let ae=Y.splice(ie,M);return ae===void 0&&(ae=[]),te(Y,ie,z),ae}function V(Y,Z){return Z<0?Math.max(Z+Y.length,0):Math.min(Z,Y.length)}var _;(function(Y){function Z(ae){return ae<0}Y.isLessThan=Z;function M(ae){return ae<=0}Y.isLessThanOrEqual=M;function z(ae){return ae>0}Y.isGreaterThan=z;function ie(ae){return ae===0}Y.isNeitherLessOrGreaterThan=ie,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(Y,Z){return(M,z)=>Z(Y(M),Y(z))}function le(...Y){return(Z,M)=>{for(const z of Y){const ie=z(Z,M);if(!_.isNeitherLessOrGreaterThan(ie))return ie}return _.neitherLessOrGreaterThan}}const ee=(Y,Z)=>Y-Z;e.$8b=ee;const X=(Y,Z)=>(0,e.$8b)(Y?1:0,Z?1:0);e.$9b=X;function K(Y){return(Z,M)=>-Y(Z,M)}class q{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let M=this.c;for(;M<this.g.length&&Z(this.g[M]);)M++;const z=M===this.c?null:this.g.slice(this.c,M);return this.c=M,z}takeFromEndWhile(Z){let M=this.d;for(;M>=0&&Z(this.g[M]);)M--;const z=M===this.d?null:this.g.slice(M+1,this.d+1);return this.d=M,z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const M=this.g.slice(this.c,this.c+Z);return this.c+=Z,M}}e.$$b=q;class D{static{this.empty=new D(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(M=>(Z(M),!0))}toArray(){const Z=[];return this.iterate(M=>(Z.push(M),!0)),Z}filter(Z){return new D(M=>this.iterate(z=>Z(z)?M(z):!0))}map(Z){return new D(M=>this.iterate(z=>M(Z(z))))}some(Z){let M=!1;return this.iterate(z=>(M=Z(z),!M)),M}findFirst(Z){let M;return this.iterate(z=>Z(z)?(M=z,!1):!0),M}findLast(Z){let M;return this.iterate(z=>(Z(z)&&(M=z),!0)),M}findLastMaxBy(Z){let M,z=!0;return this.iterate(ie=>((z||_.isGreaterThan(Z(ie,M)))&&(z=!1,M=ie),!0)),M}}e.$_b=D;class J{constructor(Z){this.c=Z}static createSortPermutation(Z,M){const z=Array.from(Z.keys()).sort((ie,ae)=>M(Z[ie],Z[ae]));return new J(z)}apply(Z){return Z.map((M,z)=>Z[this.c[z]])}inverse(){const Z=this.c.slice();for(let M=0;M<this.c.length;M++)Z[this.c[M]]=M;return new J(Z)}}e.$ac=J;async function oe(Y,Z){return(await Promise.all(Y.map(async(z,ie)=>({element:z,ok:await Z(z,ie)})))).find(z=>z.ok)?.element}}),define(ue[132],de([0,1,8]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$fd=N,e.$gd=A,e.$hd=T,e.$id=k,e.$jd=O;function a(y,I){if(!y)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function N(y,I="Unreachable"){throw new Error(I)}function A(y,I="unexpected state"){if(!y)throw new R.$cb(`Assertion Failed: ${I}`)}function T(y){y||(0,R.$Z)(new R.$cb("Soft Assertion Failed"))}function k(y){if(!y()){debugger;y(),(0,R.$Z)(new R.$cb("Assertion Failed"))}}function O(y,I){let p=0;for(;p<y.length-1;){const f=y[p],d=y[p+1];if(!I(f,d))return!1;p++}return!0}}),define(ue[89],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=R;function R(a,N){const A=this;let T=!1,k;return function(){if(T)return k;if(T=!0,N)try{k=a.apply(A,arguments)}finally{N()}else k=a.apply(A,arguments);return k}}}),define(ue[63],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(a){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=N;const A=Object.freeze([]);function T(){return A}a.empty=T;function*k(i){yield i}a.single=k;function O(i){return N(i)?i:k(i)}a.wrap=O;function y(i){return i||A}a.from=y;function*I(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=I;function p(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=p;function f(i){return i[Symbol.iterator]().next().value}a.first=f;function d(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=d;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*g(i,n){for(const t of i)n(t)&&(yield t)}a.filter=g;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=E;function*m(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=m;function*w(...i){for(const n of i)yield*n}a.concat=w;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=P;function*$(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=$;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function h(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=h})(R||(e.Iterable=R={}))}),define(ue[36],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=T,e.$Yn=p,e.$Zn=f,e.$1n=d,e.$2n=l,e.$3n=g,e.$4n=E,e.$5n=m,e.$6n=w,e.$7n=P,e.$8n=$;var R;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var N;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var A;(function(c){c.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(c,h=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=R.None;function u(F){let j=0,H=0;for(;j<F;){const W=c.charCodeAt(i);if(W>=I._0&&W<=I._9)H=H*16+W-I._0;else if(W>=I.A&&W<=I.F)H=H*16+W-I.A+10;else if(W>=I.a&&W<=I.f)H=H*16+W-I.a+10;else break;i++,j++}return j<F&&(H=-1),H}function b(F){i=F,t="",s=0,r=a.Unknown,o=R.None}function L(){const F=i;if(c.charCodeAt(i)===I._0)i++;else for(i++;i<c.length&&y(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===I.dot)if(i++,i<c.length&&y(c.charCodeAt(i)))for(i++;i<c.length&&y(c.charCodeAt(i));)i++;else return o=R.UnexpectedEndOfNumber,c.substring(F,i);let j=i;if(i<c.length&&(c.charCodeAt(i)===I.E||c.charCodeAt(i)===I.e))if(i++,(i<c.length&&c.charCodeAt(i)===I.plus||c.charCodeAt(i)===I.minus)&&i++,i<c.length&&y(c.charCodeAt(i))){for(i++;i<c.length&&y(c.charCodeAt(i));)i++;j=i}else o=R.UnexpectedEndOfNumber;return c.substring(F,j)}function S(){let F="",j=i;for(;;){if(i>=n){F+=c.substring(j,i),o=R.UnexpectedEndOfString;break}const H=c.charCodeAt(i);if(H===I.doubleQuote){F+=c.substring(j,i),i++;break}if(H===I.backslash){if(F+=c.substring(j,i),i++,i>=n){o=R.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const x=u(4);x>=0?F+=String.fromCharCode(x):o=R.InvalidUnicode;break}default:o=R.InvalidEscapeCharacter}j=i;continue}if(H>=0&&H<=31)if(O(H)){F+=c.substring(j,i),o=R.UnexpectedEndOfString;break}else o=R.InvalidCharacter;i++}return F}function v(){if(t="",o=R.None,s=i,i>=n)return s=n,r=a.EOF;let F=c.charCodeAt(i);if(k(F)){do i++,t+=String.fromCharCode(F),F=c.charCodeAt(i);while(k(F));return r=a.Trivia}if(O(F))return i++,t+=String.fromCharCode(F),F===I.carriageReturn&&c.charCodeAt(i)===I.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(F){case I.openBrace:return i++,r=a.OpenBraceToken;case I.closeBrace:return i++,r=a.CloseBraceToken;case I.openBracket:return i++,r=a.OpenBracketToken;case I.closeBracket:return i++,r=a.CloseBracketToken;case I.colon:return i++,r=a.ColonToken;case I.comma:return i++,r=a.CommaToken;case I.doubleQuote:return i++,t=S(),r=a.StringLiteral;case I.slash:{const j=i-1;if(c.charCodeAt(i+1)===I.slash){for(i+=2;i<n&&!O(c.charCodeAt(i));)i++;return t=c.substring(j,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===I.asterisk){i+=2;const H=n-1;let W=!1;for(;i<H;){if(c.charCodeAt(i)===I.asterisk&&c.charCodeAt(i+1)===I.slash){i+=2,W=!0;break}i++}return W||(i++,o=R.UnexpectedEndOfComment),t=c.substring(j,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(F),i++,r=a.Unknown}case I.minus:if(t+=String.fromCharCode(F),i++,i===n||!y(c.charCodeAt(i)))return r=a.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return t+=L(),r=a.NumericLiteral;default:for(;i<n&&C(F);)i++,F=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(F),i++,r=a.Unknown}}function C(F){if(k(F)||O(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function U(){let F;do F=v();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:b,getPosition:()=>i,scan:h?U:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function k(c){return c===I.space||c===I.tab||c===I.verticalTab||c===I.formFeed||c===I.nonBreakingSpace||c===I.ogham||c>=I.enQuad&&c<=I.zeroWidthSpace||c===I.narrowNoBreakSpace||c===I.mathematicalSpace||c===I.ideographicSpace||c===I.byteOrderMark}function O(c){return c===I.lineFeed||c===I.carriageReturn||c===I.lineSeparator||c===I.paragraphSeparator}function y(c){return c>=I._0&&c<=I._9}var I;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(I||(I={}));function p(c,h){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(u,b,L,S){s.value=u,s.offset=b,s.length=L,s.type=S,s.colonOffset=void 0,t=s}try{P(c,{onObjectBegin:(u,b)=>{if(h<=u)throw n;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,b,L)=>{if(h<b||(o(u,b,L,"property"),i[i.length-1]=u,h<=b+L))throw n},onObjectEnd:(u,b)=>{if(h<=u)throw n;t=void 0,i.pop()},onArrayBegin:(u,b)=>{if(h<=u)throw n;t=void 0,i.push(0)},onArrayEnd:(u,b)=>{if(h<=u)throw n;t=void 0,i.pop()},onLiteralValue:(u,b,L)=>{if(h<b||(o(u,b,L,$(u)),h<=b+L))throw n},onSeparator:(u,b,L)=>{if(h<=b)throw n;if(u===":"&&t&&t.type==="property")t.colonOffset=b,r=!1,t=void 0;else if(u===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let b=0;for(let L=0;b<u.length&&L<i.length;L++)if(u[b]===i[L]||u[b]==="*")b++;else if(u[b]!=="**")return!1;return b===u.length}}}function f(c,h=[],i=A.DEFAULT){let n=null,t=[];const s=[];function r(u){Array.isArray(t)?t.push(u):n!==null&&(t[n]=u)}return P(c,{onObjectBegin:()=>{const u={};r(u),s.push(t),t=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const u=[];r(u),s.push(t),t=u,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(u,b,L)=>{h.push({error:u,offset:b,length:L})}},i),t[0]}function d(c,h=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function s(u){return n.children.push(u),u}P(c,{onObjectBegin:u=>{n=s({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,b,L)=>{n=s({type:"property",offset:b,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:b,length:L,parent:n})},onObjectEnd:(u,b)=>{n.length=u+b-n.offset,n=n.parent,t(u+b)},onArrayBegin:(u,b)=>{n=s({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,b)=>{n.length=u+b-n.offset,n=n.parent,t(u+b)},onLiteralValue:(u,b,L)=>{s({type:$(u),offset:b,length:L,parent:n,value:u}),t(b+L)},onSeparator:(u,b,L)=>{n.type==="property"&&(u===":"?n.colonOffset=b:u===","&&t(b))},onError:(u,b,L)=>{h.push({error:u,offset:b,length:L})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,h){if(!c)return;let i=c;for(const n of h)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function g(c){if(!c.parent||!c.parent.children)return[];const h=g(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;h.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&h.push(i)}return h}function E(c){switch(c.type){case"array":return c.children.map(E);case"object":{const h=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(h[i.children[0].value]=E(n))}return h}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function m(c,h,i=!1){return h>=c.offset&&h<c.offset+c.length||i&&h===c.offset+c.length}function w(c,h,i=!1){if(m(c,h,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=h;t++){const s=w(n[t],h,i);if(s)return s}return c}}function P(c,h,i=A.DEFAULT){const n=T(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),o=s(h.onObjectProperty),u=t(h.onObjectEnd),b=t(h.onArrayBegin),L=t(h.onArrayEnd),S=s(h.onLiteralValue),v=s(h.onSeparator),C=t(h.onComment),U=s(h.onError),F=i&&i.disallowComments,j=i&&i.allowTrailingComma;function H(){for(;;){const ne=n.scan();switch(n.getTokenError()){case R.InvalidUnicode:W(N.InvalidUnicode);break;case R.InvalidEscapeCharacter:W(N.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:W(N.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:F||W(N.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:W(N.UnexpectedEndOfString);break;case R.InvalidCharacter:W(N.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?W(N.InvalidCommentToken):C();break;case a.Unknown:W(N.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function W(ne,le=[],ee=[]){if(U(ne),le.length+ee.length>0){let X=n.getToken();for(;X!==a.EOF;){if(le.indexOf(X)!==-1){H();break}else if(ee.indexOf(X)!==-1)break;X=H()}}}function x(ne){const le=n.getTokenValue();return ne?S(le):o(le),H(),!0}function G(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(W(N.InvalidNumberFormat),ne=0)}catch{W(N.InvalidNumberFormat)}S(ne);break}case a.NullKeyword:S(null);break;case a.TrueKeyword:S(!0);break;case a.FalseKeyword:S(!1);break;default:return!1}return H(),!0}function te(){return n.getToken()!==a.StringLiteral?(W(N.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(x(!1),n.getToken()===a.ColonToken?(v(":"),H(),_()||W(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):W(N.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function B(){r(),H();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||W(N.ValueExpected,[],[]),v(","),H(),n.getToken()===a.CloseBraceToken&&j)break}else ne&&W(N.CommaExpected,[],[]);te()||W(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return u(),n.getToken()!==a.CloseBraceToken?W(N.CloseBraceExpected,[a.CloseBraceToken],[]):H(),!0}function V(){b(),H();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||W(N.ValueExpected,[],[]),v(","),H(),n.getToken()===a.CloseBracketToken&&j)break}else ne&&W(N.CommaExpected,[],[]);_()||W(N.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return L(),n.getToken()!==a.CloseBracketToken?W(N.CloseBracketExpected,[a.CloseBracketToken],[]):H(),!0}function _(){switch(n.getToken()){case a.OpenBracketToken:return V();case a.OpenBraceToken:return B();case a.StringLiteral:return x(!0);default:return G()}}return H(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(W(N.ValueExpected,[],[]),!1):_()?(n.getToken()!==a.EOF&&W(N.EndOfFileExpected,[],[]),!0):(W(N.ValueExpected,[],[]),!1)}function $(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(ue[45],de([0,1,36]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=a,e.$0n=N,e.$$n=k,e.$_n=O;function a(y,I,p){let f,d,l,g,E;if(I){for(g=I.offset,E=g+I.length,l=g;l>0&&!O(y,l-1);)l--;let o=E;for(;o<y.length&&!O(y,o);)o++;d=y.substring(l,o),f=T(d,p)}else d=y,f=0,l=0,g=0,E=y.length;const m=k(p,y);let w=!1,P=0,$;p.insertSpaces?$=A(" ",p.tabSize||4):$="	";const c=(0,R.$Xn)(d,!1);let h=!1;function i(){return m+A($,f+P)}function n(){let o=c.scan();for(w=!1;o===R.SyntaxKind.Trivia||o===R.SyntaxKind.LineBreakTrivia;)w=w||o===R.SyntaxKind.LineBreakTrivia,o=c.scan();return h=o===R.SyntaxKind.Unknown||c.getTokenError()!==R.ScanError.None,o}const t=[];function s(o,u,b){!h&&u<E&&b>g&&y.substring(u,b)!==o&&t.push({offset:u,length:b-u,content:o})}let r=n();if(r!==R.SyntaxKind.EOF){const o=c.getTokenOffset()+l,u=A($,f);s(u,l,o)}for(;r!==R.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,u=n(),b="";for(;!w&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia);){const S=c.getTokenOffset()+l;s(" ",o,S),o=c.getTokenOffset()+c.getTokenLength()+l,b=u===R.SyntaxKind.LineCommentTrivia?i():"",u=n()}if(u===R.SyntaxKind.CloseBraceToken)r!==R.SyntaxKind.OpenBraceToken&&(P--,b=i());else if(u===R.SyntaxKind.CloseBracketToken)r!==R.SyntaxKind.OpenBracketToken&&(P--,b=i());else{switch(r){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:P++,b=i();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:b=i();break;case R.SyntaxKind.BlockCommentTrivia:w?b=i():b=" ";break;case R.SyntaxKind.ColonToken:b=" ";break;case R.SyntaxKind.StringLiteral:if(u===R.SyntaxKind.ColonToken){b="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia?b=" ":u!==R.SyntaxKind.CommaToken&&u!==R.SyntaxKind.EOF&&(h=!0);break;case R.SyntaxKind.Unknown:h=!0;break}w&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia)&&(b=i())}const L=c.getTokenOffset()+l;s(b,o,L),r=u}return t}function N(y,I){const p=JSON.stringify(y,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?p.replace(/\r\n|\r|\n/g,I.eol):p}function A(y,I){let p="";for(let f=0;f<I;f++)p+=y;return p}function T(y,I){let p=0,f=0;const d=I.tabSize||4;for(;p<y.length;){const l=y.charAt(p);if(l===" ")f++;else if(l==="	")f+=d;else break;p++}return Math.floor(f/d)}function k(y,I){for(let p=0;p<I.length;p++){const f=I.charAt(p);if(f==="\r")return p+1<I.length&&I.charAt(p+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return y&&y.eol||`
`}function O(y,I){return`\r
`.indexOf(y.charAt(I))!==-1}}),define(ue[64],de([0,1,36,45]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=N,e.$bo=A,e.$co=T,e.$do=k,e.$eo=O;function N(y,I,p){return A(y,I,void 0,p)}function A(y,I,p,f,d){const l=I.slice(),g=[],E=(0,R.$1n)(y,g);let m,w;for(;l.length>0&&(w=l.pop(),m=(0,R.$2n)(E,l),m===void 0&&p!==void 0);)typeof w=="string"?p={[w]:p}:p=[p];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const P=(0,R.$2n)(m,[w]);if(P!==void 0)if(p===void 0){if(!P.parent)throw new Error("Malformed AST");const $=m.children.indexOf(P.parent);let c,h=P.parent.offset+P.parent.length;if($>0){const i=m.children[$-1];c=i.offset+i.length}else c=m.offset+1,m.children.length>1&&(h=m.children[1].offset);return T(y,{offset:c,length:h-c,content:""},f)}else return T(y,{offset:P.offset,length:P.length,content:JSON.stringify(p)},f);else{if(p===void 0)return[];const $=`${JSON.stringify(w)}: ${JSON.stringify(p)}`,c=d?d(m.children.map(i=>i.children[0].value)):m.children.length;let h;if(c>0){const i=m.children[c-1];h={offset:i.offset+i.length,length:0,content:","+$}}else m.children.length===0?h={offset:m.offset+1,length:0,content:$}:h={offset:m.offset+1,length:0,content:$+","};return T(y,h,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(p!==void 0){const P=`${JSON.stringify(p)}`;let $;if(m.children.length===0||w===0)$={offset:m.offset+1,length:0,content:m.children.length===0?P:P+","};else{const c=w===-1||w>m.children.length?m.children.length:w,h=m.children[c-1];$={offset:h.offset+h.length,length:0,content:","+P}}return T(y,$,f)}else{const P=w,$=m.children[P];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===P){const h=m.children[P-1],i=h.offset+h.length,n=m.offset+m.length;c={offset:i,length:n-2-i,content:""}}else c={offset:$.offset,length:m.children[P+1].offset-$.offset,content:""};return T(y,c,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else return p===void 0?[]:T(y,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(p)},f)}function T(y,I,p){let f=k(y,I),d=I.offset,l=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;d>0&&!(0,a.$_n)(f,d-1);)d--;for(;l<f.length&&!(0,a.$_n)(f,l);)l++}const g=(0,a.$9n)(f,{offset:d,length:l-d},p);for(let m=g.length-1;m>=0;m--){const w=g[m];f=k(f,w),d=Math.min(d,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const E=y.length-(f.length-l)-d;return[{offset:d,length:E,content:f.substring(d,l)}]}function k(y,I){return y.substring(0,I.offset)+I.content+y.substring(I.offset+I.length)}function O(y,I){const p=I.slice(0).sort((d,l)=>{const g=d.offset-l.offset;return g===0?d.length-l.length:g});let f=y.length;for(let d=p.length-1;d>=0;d--){const l=p[d];if(l.offset+l.length<=f)y=k(y,l);else throw new Error("Overlapping edit");f=l.offset}return y}}),define(ue[133],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=R;function R(A){let T=!1;const k=new Map,O=new Map;if(N(A,g=>{if(A===g)return!0;const E=JSON.stringify(g);if(E.length<30)return!0;const m=k.get(E);if(!m){const w={schemas:[g]};return k.set(E,w),O.set(g,w),!0}return m.schemas.push(g),O.set(g,m),T=!0,!1}),k.clear(),!T)return JSON.stringify(A);let I="$defs";for(;A.hasOwnProperty(I);)I+="_";const p=[];function f(g){return JSON.stringify(g,(E,m)=>{if(m!==g){const w=O.get(m);if(w&&w.schemas.length>1)return w.id||(w.id=`_${p.length}`,p.push(w.schemas[0])),{$ref:`#/${I}/${w.id}`}}return m})}const d=f(A),l=[];for(let g=0;g<p.length;g++)l.push(`"_${g}":${f(p[g])}`);return l.length?`${d.substring(0,d.length-1)},"${I}":{${l.join(",")}}}`:d}function a(A){return typeof A=="object"&&A!==null}function N(A,T){if(!A||typeof A!="object")return;const k=(...d)=>{for(const l of d)a(l)&&p.push(l)},O=(...d)=>{for(const l of d)if(a(l))for(const g in l){const E=l[g];a(E)&&p.push(E)}},y=(...d)=>{for(const l of d)if(Array.isArray(l))for(const g of l)a(g)&&p.push(g)},I=d=>{if(Array.isArray(d))for(const l of d)a(l)&&p.push(l);else a(d)&&p.push(d)},p=[A];let f=p.pop();for(;f;)T(f)&&(k(f.additionalItems,f.additionalProperties,f.not,f.contains,f.propertyNames,f.if,f.then,f.else,f.unevaluatedItems,f.unevaluatedProperties),O(f.definitions,f.$defs,f.properties,f.patternProperties,f.dependencies,f.dependentSchemas),y(f.anyOf,f.allOf,f.oneOf,f.prefixItems),I(f.items)),f=p.pop()}}),define(ue[53],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class R{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=R}),define(ue[90],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(A){this.element=A,this.next=R.Undefined,this.prev=R.Undefined}}class a{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let A=this.a;for(;A!==R.Undefined;){const T=A.next;A.prev=R.Undefined,A.next=R.Undefined,A=T}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const k=new R(A);if(this.a===R.Undefined)this.a=k,this.b=k;else if(T){const y=this.b;this.b=k,k.prev=y,y.next=k}else{const y=this.a;this.a=k,k.next=y,y.prev=k}this.c+=1;let O=!1;return()=>{O||(O=!0,this.e(k))}}shift(){if(this.a!==R.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==R.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==R.Undefined&&A.next!==R.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===R.Undefined&&A.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):A.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):A.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==R.Undefined;)yield A.element,A=A.next}}e.$6c=a}),define(ue[31],de([0,1]),function(ce,e){"use strict";var R,a,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=T,e.$Ac=k,e.$Jc=$;function A(c,h,i){let n=c.get(h);return n===void 0&&(n=i,c.set(h,n)),n}function T(c){const h=[];return c.forEach((i,n)=>{h.push(`${n} => ${i}`)}),`Map(${c.size}) {${h.join(", ")}}`}function k(c){const h=[];return c.forEach(i=>{h.push(i)}),`Set(${c.size}) {${h.join(", ")}}`}class O{constructor(h,i){this.uri=h,this.value=i}}function y(c){return Array.isArray(c)}class I{static{this.c=h=>h.toString()}constructor(h,i){if(this[R]="ResourceMap",h instanceof I)this.d=new Map(h.d),this.e=i??I.c;else if(y(h)){this.d=new Map,this.e=i??I.c;for(const[n,t]of h)this.set(n,t)}else this.d=new Map,this.e=h??I.c}set(h,i){return this.d.set(this.e(h),new O(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[n,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Bc=I;class p{constructor(h,i){this[a]="ResourceSet",!h||typeof h=="function"?this.c=new I(h):(this.c=new I(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((n,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=p;var f;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class d{constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=f.None){const n=this.c.get(h);if(n)return i!==f.None&&this.m(n,i),n.value}set(h,i,n=f.None){let t=this.c.get(h);if(t)t.value=i,n!==f.None&&this.m(t,n);else{switch(t={key:h,value:i,next:void 0,previous:void 0},n){case f.None:this.k(t);break;case f.AsOld:this.j(t);break;case f.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const n=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,n=h.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==f.AsOld&&i!==f.AsNew)){if(i===f.AsOld){if(h===this.d)return;const n=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===f.AsNew){if(h===this.e)return;const n=h.next,t=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,n)=>{h.push([n,i])}),h}fromJSON(h){this.clear();for(const[i,n]of h)this.set(i,n)}}e.$Dc=d;class l extends d{constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=f.AsNew){return super.get(h,i)}peek(h){return super.get(h,f.None)}set(h,i){return super.set(h,i,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Ec=g;class E extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Fc=E;class m{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Gc=m;class w{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,n]of h)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((n,t)=>{h.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=w;class P{constructor(){this.c=new Map}add(h,i){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(i)}delete(h,i){const n=this.c.get(h);n&&(n.delete(i),n.size===0&&this.c.delete(h))}forEach(h,i){const n=this.c.get(h);n&&n.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Ic=P;function $(c,h){if(c===h)return!0;if(c.size!==h.size)return!1;for(const[i,n]of c)if(!h.has(i)||h.get(i)!==n)return!1;for(const[i]of h)if(!c.has(i))return!1;return!0}}),define(ue[2],de([0,1,17,131,31,89,63]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=I,e.$Mc=p,e.$Nc=f,e.$Oc=g,e.$Pc=E,e.$Qc=m,e.$Rc=w,e.$Sc=P,e.$Tc=$,e.$4c=b;const k=!1;let O=null;class y{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:y.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const U=this.c(v);U.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const U=C.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,C){let U;if(C)U=C;else{const x=new Map,G=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,x).isSingleton);if(G.length===0)return;const te=new Set(G.map(B=>B.value));if(U=G.filter(B=>!(B.parent&&te.has(B.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(x){function G(B,V){for(;B.length>0&&V.some(_=>typeof _=="string"?_===B[0]:B[0].match(_));)B.shift()}const te=x.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return G(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const j=new N.$Ic;for(const x of U){const G=F(x);for(let te=0;te<=G.length;te++)j.add(G.slice(0,te).join(`
`),x)}U.sort((0,R.$6b)(x=>x.idx,R.$8b));let H="",W=0;for(const x of U.slice(0,v)){W++;const G=F(x),te=[];for(let B=0;B<G.length;B++){let V=G[B];V=`(shared with ${j.get(G.slice(0,B+1).join(`
`)).size}/${U.length} leaks) at ${V}`;const ne=j.get(G.slice(0,B).join(`
`)),le=(0,a.$c)([...ne].map(ee=>F(ee)[B]),ee=>ee);delete le[G[B]];for(const[ee,X]of Object.entries(le))te.unshift(`    - stacktraces of ${X.length} other leaks continue with ${ee}`);te.unshift(V)}H+=`


==================== Leaking disposable ${W}/${U.length}: ${x.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>v&&(H+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:H}}}e.$Kc=y;function I(S){O=S}if(k){const S="__is_disposable_tracked__";I(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function p(S){return O?.trackDisposable(S),S}function f(S){O?.markAsDisposed(S)}function d(S,v){O?.setParent(S,v)}function l(S,v){if(O)for(const C of S)O.setParent(C,v)}function g(S){return O?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function m(S){if(T.Iterable.is(S)){const v=[];for(const C of S)if(C)try{C.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function w(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=$(()=>m(S));return l(S,v),v}function $(S){const v=p({dispose:(0,A.$db)(()=>{f(v),S()})});return v}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return d(v,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),d(v,null))}}e.$Uc=c;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,p(this),d(this.q,this)}dispose(){f(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=h;class i{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&d(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&d(v,null),v}}e.$Wc=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,f(this))},this}}e.$Zc=s;class r{constructor(){this.a=new Map}acquire(v,...C){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...C)},this.a.set(v,U));const{object:F}=U,j=(0,A.$db)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:j}}}e.$1c=r;class o{constructor(v){this.a=v}async acquire(v,...C){const U=this.a.acquire(v,...C);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$2c=o;class u{constructor(v){this.object=v}dispose(){}}e.$3c=u;function b(S){const v=new c;try{S(v)}finally{v.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const C=this.a.get(v);return this.a.delete(v),C}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=L}),define(ue[65],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(ue[91],de([0,1,31]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0,e.$om=N,e.$pm=T;const a=new R.$Ec(1e4);function N(y){return O(y,"NFC",a)}const A=new R.$Ec(1e4);function T(y){return O(y,"NFD",A)}const k=/[^\u0000-\u0080]/;function O(y,I,p){if(!y)return y;const f=p.get(y);if(f)return f;let d;return k.test(y)?d=y.normalize(I):d=y,p.set(y,d),d}e.$qm=function(){const y=/[\u0300-\u036f]/g;return function(I){return T(I).replace(y,"")}}()}),function(){function ce(N){const A=[];typeof N=="number"&&A.push("code/timeOrigin",N);function T(O){A.push(O,Date.now())}function k(){const O=[];for(let y=0;y<A.length;y+=2)O.push({name:A[y],startTime:A[y+1]});return O}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(N+T.startTime)});return A}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function R(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=R(a))}(),define(ue[5],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=o,e.$K=u,e.$h="en";let R=!1,a=!1,N=!1,A=!1,T=!1,k=!1,O=!1,y=!1,I=!1,p=!1,f,d=e.$h,l=e.$h,g,E;const m=globalThis;let w;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?w=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",$=P&&w?.type==="renderer";if(typeof w=="object"){R=w.platform==="win32",a=w.platform==="darwin",N=w.platform==="linux",A=N&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,O=P,I=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$h,d=e.$h;const b=w.env.VSCODE_NLS_CONFIG;if(b)try{const L=JSON.parse(b);f=L.userLocale,l=L.osLocale,d=L.resolvedLanguage||e.$h,g=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!$?(E=navigator.userAgent,R=E.indexOf("Windows")>=0,a=E.indexOf("Macintosh")>=0,y=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=E.indexOf("Linux")>=0,p=E?.indexOf("Mobi")>=0,k=!0,d=globalThis._VSCODE_NLS_LANGUAGE||e.$h,f=navigator.language.toLowerCase(),l=f):console.error("Unable to resolve platform.");var c;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(c||(e.Platform=c={}));function h(b){switch(b){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let i=c.Web;a?i=c.Mac:R?i=c.Windows:N&&(i=c.Linux),e.$j=R,e.$k=a,e.$l=N,e.$m=A,e.$n=T,e.$o=O,e.$p=k,e.$q=k&&typeof m.importScripts=="function",e.$r=e.$q?m.origin:void 0,e.$s=y,e.$t=p,e.$u=I,e.$v=i,e.$w=E,e.$x=d;var n;(function(b){function L(){return e.$x}b.value=L;function S(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}b.isDefaultVariant=S;function v(){return e.$x==="en"}b.isDefault=v})(n||(e.Language=n={})),e.$y=f,e.$z=l,e.$A=g,e.$B=typeof m.postMessage=="function"&&!m.importScripts,e.$C=(()=>{if(e.$B){const b=[];m.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let v=0,C=b.length;v<C;v++){const U=b[v];if(U.id===S.data.vscodeScheduleAsyncWork){b.splice(v,1),U.callback();return}}});let L=0;return S=>{const v=++L;b.push({id:v,callback:S}),m.postMessage({vscodeScheduleAsyncWork:v},"*")}}return b=>setTimeout(b)})();var t;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=a||y?t.Macintosh:R?t.Windows:t.Linux;let s=!0,r=!1;function o(){if(!r){r=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,s=new Uint16Array(b.buffer)[0]===513}return s}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function u(b){return parseFloat(b)>=20}}),define(ue[37],de([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const A=N.process;a={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return R.$j?"win32":R.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$ec=a.platform,e.$fc=a.arch}),define(ue[134],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zX=T;var a;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(a||(a={}));const N="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function T(){const k=R.env[N];if(k){const y=k.split(":").map(I=>I.trim()).filter(I=>I.length>0);for(const I of y)switch(I){case"Unity":{const p=R.env.DESKTOP_SESSION;return p&&p.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const p=R.env[A];return p==="5"?a.KDE5:p==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const O=R.env.DESKTOP_SESSION;if(O)switch(O){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return A in R.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?a.GNOME:"KDE_FULL_SESSION"in R.env?A in R.env?a.KDE4:a.KDE3:a.UNKNOWN}});var kt=this&&this.__createBinding||(Object.create?function(ce,e,R,a){a===void 0&&(a=R);var N=Object.getOwnPropertyDescriptor(e,R);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(ce,a,N)}:function(ce,e,R,a){a===void 0&&(a=R),ce[a]=e[R]}),At=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Oe=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var R in ce)R!=="default"&&Object.prototype.hasOwnProperty.call(ce,R)&&kt(e,ce,R);return At(e,ce),e};define(ue[13],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,R=Oe(R);const a=65,N=97,A=90,T=122,k=46,O=47,y=92,I=58,p=63;class f extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${o} ${r} of type ${t}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,n){if(i===null||typeof i!="object")throw new f(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new f(n,"string",i)}const g=R.$ec==="win32";function E(i){return i===O||i===y}function m(i){return i===O}function w(i){return i>=a&&i<=A||i>=N&&i<=T}function P(i,n,t,s){let r="",o=0,u=-1,b=0,L=0;for(let S=0;S<=i.length;++S){if(S<i.length)L=i.charCodeAt(S);else{if(s(L))break;L=O}if(s(L)){if(!(u===S-1||b===1))if(b===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",o=0):(r=r.slice(0,v),o=r.length-1-r.lastIndexOf(t)),u=S,b=0;continue}else if(r.length!==0){r="",o=0,u=S,b=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(u+1,S)}`:r=i.slice(u+1,S),o=S-u-1;u=S,b=0}else L===k&&b!==-1?++b:b=-1}return r}function $(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){d(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${$(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$gc={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=R.cwd():(o=R.env[`=${n}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===y)&&(o=`${n}\\`));const u=o.length;let b=0,L="",S=!1;const v=o.charCodeAt(0);if(u===1)E(v)&&(b=1,S=!0);else if(E(v))if(S=!0,E(o.charCodeAt(1))){let C=2,U=C;for(;C<u&&!E(o.charCodeAt(C));)C++;if(C<u&&C!==U){const F=o.slice(U,C);for(U=C;C<u&&E(o.charCodeAt(C));)C++;if(C<u&&C!==U){for(U=C;C<u&&!E(o.charCodeAt(C));)C++;(C===u||C!==U)&&(L=`\\\\${F}\\${o.slice(U,C)}`,b=C)}}}else b=1;else w(v)&&o.charCodeAt(1)===I&&(L=o.slice(0,2),b=2,u>2&&E(o.charCodeAt(2))&&(S=!0,b=3));if(L.length>0)if(n.length>0){if(L.toLowerCase()!==n.toLowerCase())continue}else n=L;if(s){if(n.length>0)break}else if(t=`${o.slice(b)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return m(o)?"\\":i;if(E(o))if(r=!0,E(i.charCodeAt(1))){let b=2,L=b;for(;b<n&&!E(i.charCodeAt(b));)b++;if(b<n&&b!==L){const S=i.slice(L,b);for(L=b;b<n&&E(i.charCodeAt(b));)b++;if(b<n&&b!==L){for(L=b;b<n&&!E(i.charCodeAt(b));)b++;if(b===n)return`\\\\${S}\\${i.slice(L)}\\`;b!==L&&(s=`\\\\${S}\\${i.slice(L,b)}`,t=b)}}}else t=1;else w(o)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let u=t<n?P(i.slice(t),!r,"\\",E):"";return u.length===0&&!r&&(u="."),u.length>0&&E(i.charCodeAt(n-1))&&(u+="\\"),s===void 0?r?`\\${u}`:u:r?`${s}\\${u}`:`${s}${u}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&w(t)&&i.charCodeAt(1)===I&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const u=i[o];l(u,"path"),u.length>0&&(n===void 0?n=t=u:n+=`\\${u}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const o=t.length;o>1&&E(t.charCodeAt(1))&&(++r,o>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$gc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$gc.resolve(i),s=e.$gc.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===y;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===y;)o--;const u=o-r;let b=0;for(;b<n.length&&n.charCodeAt(b)===y;)b++;let L=n.length;for(;L-1>b&&n.charCodeAt(L-1)===y;)L--;const S=L-b,v=u<S?u:S;let C=-1,U=0;for(;U<v;U++){const j=i.charCodeAt(r+U);if(j!==n.charCodeAt(b+U))break;j===y&&(C=U)}if(U!==v){if(C===-1)return s}else{if(S>v){if(n.charCodeAt(b+U)===y)return s.slice(b+U+1);if(U===2)return s.slice(b+U)}u>v&&(i.charCodeAt(r+U)===y?C=U:U===2&&(C=3)),C===-1&&(C=0)}let F="";for(U=r+C+1;U<=o;++U)(U===o||i.charCodeAt(U)===y)&&(F+=F.length===0?"..":"\\..");return b+=C,F.length>0?`${F}${s.slice(b,L)}`:(s.charCodeAt(b)===y&&++b,s.slice(b,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$gc.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===y){if(n.charCodeAt(1)===y){const t=n.charCodeAt(2);if(t!==p&&t!==k)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===I&&n.charCodeAt(2)===y)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let b=2,L=b;for(;b<n&&!E(i.charCodeAt(b));)b++;if(b<n&&b!==L){for(L=b;b<n&&E(i.charCodeAt(b));)b++;if(b<n&&b!==L){for(L=b;b<n&&!E(i.charCodeAt(b));)b++;if(b===n)return i;b!==L&&(t=s=b+1)}}}}else w(r)&&i.charCodeAt(1)===I&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let o=-1,u=!0;for(let b=n-1;b>=s;--b)if(E(i.charCodeAt(b))){if(!u){o=b;break}}else u=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,b=-1;for(o=i.length-1;o>=t;--o){const L=i.charCodeAt(o);if(E(L)){if(!r){t=o+1;break}}else b===-1&&(r=!1,b=o+1),u>=0&&(L===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=b))}return t===s?s=b:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(E(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,u=0;i.length>=2&&i.charCodeAt(1)===I&&w(i.charCodeAt(0))&&(n=s=2);for(let b=i.length-1;b>=n;--b){const L=i.charCodeAt(b);if(E(L)){if(!o){s=b+1;break}continue}r===-1&&(o=!1,r=b+1),L===k?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let C=2,U=C;for(;C<t&&!E(i.charCodeAt(C));)C++;if(C<t&&C!==U){for(U=C;C<t&&E(i.charCodeAt(C));)C++;if(C<t&&C!==U){for(U=C;C<t&&!E(i.charCodeAt(C));)C++;C===t?s=C:C!==U&&(s=C+1)}}}}else if(w(r)&&i.charCodeAt(1)===I){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,u=s,b=-1,L=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!L){u=S+1;break}continue}b===-1&&(L=!1,b=S+1),r===k?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return b!==-1&&(o===-1||v===0||v===1&&o===b-1&&o===u+1?n.base=n.name=i.slice(u,b):(n.name=i.slice(u,o),n.base=i.slice(u,b),n.ext=i.slice(o,b))),u>0&&u!==s?n.dir=i.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(g){const i=/\\/g;return()=>{const n=R.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>R.cwd()})();e.$hc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:h();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===O)}return n=P(n,!t,"/",m),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O,t=i.charCodeAt(i.length-1)===O;return i=P(i,!n,"/",m),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===O},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$hc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$hc.resolve(i),n=e.$hc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,u=n.length-o,b=r<u?r:u;let L=-1,S=0;for(;S<b;S++){const C=i.charCodeAt(t+S);if(C!==n.charCodeAt(o+S))break;C===O&&(L=S)}if(S===b)if(u>b){if(n.charCodeAt(o+S)===O)return n.slice(o+S+1);if(S===0)return n.slice(o+S)}else r>b&&(i.charCodeAt(t+S)===O?L=S:S===0&&(L=0));let v="";for(S=t+L+1;S<=s;++S)(S===s||i.charCodeAt(S)===O)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(o+L)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===O){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,b=-1;for(o=i.length-1;o>=0;--o){const L=i.charCodeAt(o);if(L===O){if(!r){t=o+1;break}}else b===-1&&(r=!1,b=o+1),u>=0&&(L===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=b))}return t===s?s=b:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===O){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let u=i.length-1;u>=0;--u){const b=i.charCodeAt(u);if(b===O){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),b===k?n===-1?n=u:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===O;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,u=-1,b=!0,L=i.length-1,S=0;for(;L>=s;--L){const v=i.charCodeAt(L);if(v===O){if(!b){o=L+1;break}continue}u===-1&&(b=!1,u=L+1),v===k?r===-1?r=L:S!==1&&(S=1):r!==-1&&(S=-1)}if(u!==-1){const v=o===0&&t?1:o;r===-1||S===0||S===1&&r===u-1&&r===o+1?n.base=n.name=i.slice(v,u):(n.name=i.slice(v,r),n.base=i.slice(v,u),n.ext=i.slice(r,u))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=g?e.$gc.normalize:e.$hc.normalize,e.$jc=g?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=g?e.$gc.join:e.$hc.join,e.$lc=g?e.$gc.resolve:e.$hc.resolve,e.$mc=g?e.$gc.relative:e.$hc.relative,e.$nc=g?e.$gc.dirname:e.$hc.dirname,e.$oc=g?e.$gc.basename:e.$hc.basename,e.$pc=g?e.$gc.extname:e.$hc.extname,e.$qc=g?e.$gc.format:e.$hc.format,e.$rc=g?e.$gc.parse:e.$hc.parse,e.$sc=g?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=g?e.$gc.sep:e.$hc.sep,e.$uc=g?e.$gc.delimiter:e.$hc.delimiter}),define(ue[135],de([0,1,13]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0,e.$ct=A,e.$dt=T,e.$et=k,e.$ft=y,e.$bt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const p=(0,R.$pc)(I),f=a[p.toLowerCase()];return f!==void 0?f:T(I)}function T(I){const p=(0,R.$pc)(I);return N[p.toLowerCase()]}function k(I){for(const p in N)if(N[p]===I)return p}const O=/^(.+)\/(.+?)(;.+)?$/;function y(I,p){const f=O.exec(I);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:p?void 0:I}}),define(ue[92],de([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=A,e.$nm=T;var a;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(a||(e.Source=a={}));var N;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function A(k,...O){const y=O.reduce((f,d)=>(f[d]=!0,f),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(f=>!y[f]).forEach(f=>{for(let d=0;d<I.length;d++)if(f.search(I[d])!==-1){delete k[f];break}})}function T(k){k&&(delete k.DEBUG,R.$l&&delete k.LD_PRELOAD)}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var a in R)(typeof exports=="object"?exports:ce)[a]=R[a]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function R(a){if(e[a])return e[a].exports;var N=e[a]={i:a,l:!1,exports:{}};return ce[a].call(N.exports,N,N.exports,R),N.l=!0,N.exports}return R.m=ce,R.c=e,R.d=function(a,N,A){R.o(a,N)||Object.defineProperty(a,N,{enumerable:!0,get:A})},R.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},R.t=function(a,N){if(1&N&&(a=R(a)),8&N||4&N&&typeof a=="object"&&a&&a.__esModule)return a;var A=Object.create(null);if(R.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:a}),2&N&&typeof a!="string")for(var T in a)R.d(A,T,function(k){return a[k]}.bind(null,T));return A},R.n=function(a){var N=a&&a.__esModule?function(){return a.default}:function(){return a};return R.d(N,"a",N),N},R.o=function(a,N){return Object.prototype.hasOwnProperty.call(a,N)},R.p="",R(R.s=0)}([function(ce,e,R){(function(a){var N;e=ce.exports=X,N=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],O=e.src=[],y=0,I=y++;O[I]="0|[1-9]\\d*";var p=y++;O[p]="[0-9]+";var f=y++;O[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=y++;O[d]="("+O[I]+")\\.("+O[I]+")\\.("+O[I]+")";var l=y++;O[l]="("+O[p]+")\\.("+O[p]+")\\.("+O[p]+")";var g=y++;O[g]="(?:"+O[I]+"|"+O[f]+")";var E=y++;O[E]="(?:"+O[p]+"|"+O[f]+")";var m=y++;O[m]="(?:-("+O[g]+"(?:\\."+O[g]+")*))";var w=y++;O[w]="(?:-?("+O[E]+"(?:\\."+O[E]+")*))";var P=y++;O[P]="[0-9A-Za-z-]+";var $=y++;O[$]="(?:\\+("+O[P]+"(?:\\."+O[P]+")*))";var c=y++,h="v?"+O[d]+O[m]+"?"+O[$]+"?";O[c]="^"+h+"$";var i="[v=\\s]*"+O[l]+O[w]+"?"+O[$]+"?",n=y++;O[n]="^"+i+"$";var t=y++;O[t]="((?:<|>)?=?)";var s=y++;O[s]=O[p]+"|x|X|\\*";var r=y++;O[r]=O[I]+"|x|X|\\*";var o=y++;O[o]="[v=\\s]*("+O[r]+")(?:\\.("+O[r]+")(?:\\.("+O[r]+")(?:"+O[m]+")?"+O[$]+"?)?)?";var u=y++;O[u]="[v=\\s]*("+O[s]+")(?:\\.("+O[s]+")(?:\\.("+O[s]+")(?:"+O[w]+")?"+O[$]+"?)?)?";var b=y++;O[b]="^"+O[t]+"\\s*"+O[o]+"$";var L=y++;O[L]="^"+O[t]+"\\s*"+O[u]+"$";var S=y++;O[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=y++;O[v]="(?:~>?)";var C=y++;O[C]="(\\s*)"+O[v]+"\\s+",k[C]=new RegExp(O[C],"g");var U=y++;O[U]="^"+O[v]+O[o]+"$";var F=y++;O[F]="^"+O[v]+O[u]+"$";var j=y++;O[j]="(?:\\^)";var H=y++;O[H]="(\\s*)"+O[j]+"\\s+",k[H]=new RegExp(O[H],"g");var W=y++;O[W]="^"+O[j]+O[o]+"$";var x=y++;O[x]="^"+O[j]+O[u]+"$";var G=y++;O[G]="^"+O[t]+"\\s*("+i+")$|^$";var te=y++;O[te]="^"+O[t]+"\\s*("+h+")$|^$";var B=y++;O[B]="(\\s*)"+O[t]+"\\s*("+i+"|"+O[o]+")",k[B]=new RegExp(O[B],"g");var V=y++;O[V]="^\\s*("+O[o]+")\\s+-\\s+("+O[o]+")\\s*$";var _=y++;O[_]="^\\s*("+O[u]+")\\s+-\\s+("+O[u]+")\\s*$";var ne=y++;O[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)N(le,O[le]),k[le]||(k[le]=new RegExp(O[le]));function ee(se,fe){if(se instanceof X)return se;if(typeof se!="string"||se.length>A||!(fe?k[n]:k[c]).test(se))return null;try{return new X(se,fe)}catch{return null}}function X(se,fe){if(se instanceof X){if(se.loose===fe)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(se,fe);N("SemVer",se,fe),this.loose=fe;var me=se.trim().match(fe?k[n]:k[c]);if(!me)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var ke=+Ie;if(ke>=0&&ke<T)return ke}return Ie}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(se,fe){var me=ee(se,fe);return me?me.version:null},e.clean=function(se,fe){var me=ee(se.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(se){return N("SemVer.compare",this.version,this.loose,se),se instanceof X||(se=new X(se,this.loose)),this.compareMain(se)||this.comparePre(se)},X.prototype.compareMain=function(se){return se instanceof X||(se=new X(se,this.loose)),q(this.major,se.major)||q(this.minor,se.minor)||q(this.patch,se.patch)},X.prototype.comparePre=function(se){if(se instanceof X||(se=new X(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Ie=se.prerelease[fe];if(N("prerelease compare",fe,me,Ie),me===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(me===void 0)return-1;if(me!==Ie)return q(me,Ie)}while(++fe)},X.prototype.inc=function(se,fe){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,fe,me,Ie){typeof me=="string"&&(Ie=me,me=void 0);try{return new X(se,me).inc(fe,Ie).version}catch{return null}},e.diff=function(se,fe){if(Y(se,fe))return null;var me=ee(se),Ie=ee(fe);if(me.prerelease.length||Ie.prerelease.length){for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Ie[ke])return"pre"+ke;return"prerelease"}for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Ie[ke])return ke},e.compareIdentifiers=q;var K=/^[0-9]+$/;function q(se,fe){var me=K.test(se),Ie=K.test(fe);return me&&Ie&&(se=+se,fe=+fe),me&&!Ie?-1:Ie&&!me?1:se<fe?-1:se>fe?1:0}function D(se,fe,me){return new X(se,me).compare(new X(fe,me))}function J(se,fe,me){return D(se,fe,me)>0}function oe(se,fe,me){return D(se,fe,me)<0}function Y(se,fe,me){return D(se,fe,me)===0}function Z(se,fe,me){return D(se,fe,me)!==0}function M(se,fe,me){return D(se,fe,me)>=0}function z(se,fe,me){return D(se,fe,me)<=0}function ie(se,fe,me,Ie){var ke;switch(fe){case"===":typeof se=="object"&&(se=se.version),typeof me=="object"&&(me=me.version),ke=se===me;break;case"!==":typeof se=="object"&&(se=se.version),typeof me=="object"&&(me=me.version),ke=se!==me;break;case"":case"=":case"==":ke=Y(se,me,Ie);break;case"!=":ke=Z(se,me,Ie);break;case">":ke=J(se,me,Ie);break;case">=":ke=M(se,me,Ie);break;case"<":ke=oe(se,me,Ie);break;case"<=":ke=z(se,me,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return ke}function ae(se,fe){if(se instanceof ae){if(se.loose===fe)return se;se=se.value}if(!(this instanceof ae))return new ae(se,fe);N("comparator",se,fe),this.loose=fe,this.parse(se),this.semver===he?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(se,fe){return q(fe,se)},e.major=function(se,fe){return new X(se,fe).major},e.minor=function(se,fe){return new X(se,fe).minor},e.patch=function(se,fe){return new X(se,fe).patch},e.compare=D,e.compareLoose=function(se,fe){return D(se,fe,!0)},e.rcompare=function(se,fe,me){return D(fe,se,me)},e.sort=function(se,fe){return se.sort(function(me,Ie){return e.compare(me,Ie,fe)})},e.rsort=function(se,fe){return se.sort(function(me,Ie){return e.rcompare(me,Ie,fe)})},e.gt=J,e.lt=oe,e.eq=Y,e.neq=Z,e.gte=M,e.lte=z,e.cmp=ie,e.Comparator=ae;var he={};function pe(se,fe){if(se instanceof pe)return se.loose===fe?se:new pe(se.raw,fe);if(se instanceof ae)return new pe(se.value,fe);if(!(this instanceof pe))return new pe(se,fe);if(this.loose=fe,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function be(se){return!se||se.toLowerCase()==="x"||se==="*"}function Pe(se,fe,me,Ie,ke,De,Te,Ne,Ue,Be,We,je,qe){return((fe=be(me)?"":be(Ie)?">="+me+".0.0":be(ke)?">="+me+"."+Ie+".0":">="+fe)+" "+(Ne=be(Ue)?"":be(Be)?"<"+(+Ue+1)+".0.0":be(We)?"<"+Ue+"."+(+Be+1)+".0":je?"<="+Ue+"."+Be+"."+We+"-"+je:"<="+Ne)).trim()}function ve(se,fe){for(var me=0;me<se.length;me++)if(!se[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<se.length;me++)if(N(se[me].semver),se[me].semver!==he&&se[me].semver.prerelease.length>0){var Ie=se[me].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function we(se,fe,me){try{fe=new pe(fe,me)}catch{return!1}return fe.test(se)}function Ee(se,fe,me,Ie){var ke,De,Te,Ne,Ue;switch(se=new X(se,Ie),fe=new pe(fe,Ie),me){case">":ke=J,De=z,Te=oe,Ne=">",Ue=">=";break;case"<":ke=oe,De=M,Te=J,Ne="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(se,fe,Ie))return!1;for(var Be=0;Be<fe.set.length;++Be){var We=fe.set[Be],je=null,qe=null;if(We.forEach(function(ze){ze.semver===he&&(ze=new ae(">=0.0.0")),je=je||ze,qe=qe||ze,ke(ze.semver,je.semver,Ie)?je=ze:Te(ze.semver,qe.semver,Ie)&&(qe=ze)}),je.operator===Ne||je.operator===Ue||(!qe.operator||qe.operator===Ne)&&De(se,qe.semver)||qe.operator===Ue&&Te(se,qe.semver))return!1}return!0}ae.prototype.parse=function(se){var fe=this.loose?k[G]:k[te],me=se.match(fe);if(!me)throw new TypeError("Invalid comparator: "+se);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new X(me[2],this.loose):this.semver=he},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(se){return N("Comparator.test",se,this.loose),this.semver===he||(typeof se=="string"&&(se=new X(se,this.loose)),ie(se,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(se,fe){if(!(se instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(se.value,fe),we(this.value,me,fe);if(se.operator==="")return me=new pe(this.value,fe),we(se.semver,me,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),De=this.semver.version===se.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),Ne=ie(this.semver,"<",se.semver,fe)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Ue=ie(this.semver,">",se.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ie||ke||De&&Te||Ne||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(se){var fe=this.loose;se=se.trim(),N("range",se,fe);var me=fe?k[_]:k[V];se=se.replace(me,Pe),N("hyphen replace",se),se=se.replace(k[B],"$1$2$3"),N("comparator trim",se,k[B]),se=(se=(se=se.replace(k[C],"$1~")).replace(k[H],"$1^")).split(/\s+/).join(" ");var Ie=fe?k[G]:k[te],ke=se.split(" ").map(function(De){return function(Te,Ne){return N("comp",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(We){return function(je,qe){N("caret",je,qe);var ze=qe?k[x]:k[W];return je.replace(ze,function(Ve,Le,re,ge,$e){var ye;return N("caret",je,Ve,Le,re,ge,$e),be(Le)?ye="":be(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ye=Le==="0"?">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+".0 <"+(+Le+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+ge+$e+" <"+Le+"."+re+"."+(+ge+1):">="+Le+"."+re+"."+ge+$e+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+ge+$e+" <"+(+Le+1)+".0.0"):(N("no pr"),ye=Le==="0"?re==="0"?">="+Le+"."+re+"."+ge+" <"+Le+"."+re+"."+(+ge+1):">="+Le+"."+re+"."+ge+" <"+Le+"."+(+re+1)+".0":">="+Le+"."+re+"."+ge+" <"+(+Le+1)+".0.0"),N("caret return",ye),ye})}(We,Be)}).join(" ")}(Te,Ne),N("caret",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(We){return function(je,qe){var ze=qe?k[F]:k[U];return je.replace(ze,function(Ve,Le,re,ge,$e){var ye;return N("tilde",je,Ve,Le,re,ge,$e),be(Le)?ye="":be(re)?ye=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ye=">="+Le+"."+re+".0 <"+Le+"."+(+re+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Le+"."+re+"."+ge+$e+" <"+Le+"."+(+re+1)+".0"):ye=">="+Le+"."+re+"."+ge+" <"+Le+"."+(+re+1)+".0",N("tilde return",ye),ye})}(We,Be)}).join(" ")}(Te,Ne),N("tildes",Te),Te=function(Ue,Be){return N("replaceXRanges",Ue,Be),Ue.split(/\s+/).map(function(We){return function(je,qe){je=je.trim();var ze=qe?k[L]:k[b];return je.replace(ze,function(Ve,Le,re,ge,$e,ye){N("xRange",je,Ve,Le,re,ge,$e,ye);var Ae=be(re),Ce=Ae||be(ge),Me=Ce||be($e);return Le==="="&&Me&&(Le=""),Ae?Ve=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Me?(Ce&&(ge=0),Me&&($e=0),Le===">"?(Le=">=",Ce?(re=+re+1,ge=0,$e=0):Me&&(ge=+ge+1,$e=0)):Le==="<="&&(Le="<",Ce?re=+re+1:ge=+ge+1),Ve=Le+re+"."+ge+"."+$e):Ce?Ve=">="+re+".0.0 <"+(+re+1)+".0.0":Me&&(Ve=">="+re+"."+ge+".0 <"+re+"."+(+ge+1)+".0"),N("xRange return",Ve),Ve})}(We,Be)}).join(" ")}(Te,Ne),N("xrange",Te),Te=function(Ue,Be){return N("replaceStars",Ue,Be),Ue.trim().replace(k[ne],"")}(Te,Ne),N("stars",Te),Te}(De,fe)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(De){return!!De.match(Ie)})),ke=ke.map(function(De){return new ae(De,fe)})},pe.prototype.intersects=function(se,fe){if(!(se instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ie){return se.set.some(function(ke){return ke.every(function(De){return Ie.intersects(De,fe)})})})})},e.toComparators=function(se,fe){return new pe(se,fe).set.map(function(me){return me.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new X(se,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ve(this.set[fe],se))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(se,fe,me){var Ie=null,ke=null;try{var De=new pe(fe,me)}catch{return null}return se.forEach(function(Te){De.test(Te)&&(Ie&&ke.compare(Te)!==-1||(ke=new X(Ie=Te,me)))}),Ie},e.minSatisfying=function(se,fe,me){var Ie=null,ke=null;try{var De=new pe(fe,me)}catch{return null}return se.forEach(function(Te){De.test(Te)&&(Ie&&ke.compare(Te)!==1||(ke=new X(Ie=Te,me)))}),Ie},e.validRange=function(se,fe){try{return new pe(se,fe).range||"*"}catch{return null}},e.ltr=function(se,fe,me){return Ee(se,fe,"<",me)},e.gtr=function(se,fe,me){return Ee(se,fe,">",me)},e.outside=Ee,e.prerelease=function(se,fe){var me=ee(se,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(se,fe,me){return se=new pe(se,me),fe=new pe(fe,me),se.intersects(fe)},e.coerce=function(se){if(se instanceof X)return se;if(typeof se!="string")return null;var fe=se.match(k[S]);return fe==null?null:ee((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,R(1))},function(ce,e){var R,a,N=ce.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(E){if(R===setTimeout)return setTimeout(E,0);if((R===A||!R)&&setTimeout)return R=setTimeout,setTimeout(E,0);try{return R(E,0)}catch{try{return R.call(null,E,0)}catch{return R.call(this,E,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:A}catch{R=A}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var O,y=[],I=!1,p=-1;function f(){I&&O&&(I=!1,O.length?y=O.concat(y):p=-1,y.length&&d())}function d(){if(!I){var E=k(f);I=!0;for(var m=y.length;m;){for(O=y,y=[];++p<m;)O&&O[p].run();p=-1,m=y.length}O=null,I=!1,function(w){if(a===clearTimeout)return clearTimeout(w);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(w);try{a(w)}catch{try{return a.call(null,w)}catch{return a.call(this,w)}}}(E)}}function l(E,m){this.fun=E,this.array=m}function g(){}N.nextTick=function(E){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];y.push(new l(E,m)),y.length!==1||I||k(d)},l.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=g,N.addListener=g,N.once=g,N.off=g,N.removeListener=g,N.removeAllListeners=g,N.emit=g,N.prependListener=g,N.prependOnceListener=g,N.listeners=function(E){return[]},N.binding=function(E){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(E){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(ue[136],de([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class a{constructor(k,O,y){this.level=k,this.key=O,this.value=y,this.forward=[]}}const N=void 0;class A{constructor(k,O=2**16){this.comparator=k,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(O)|0),this.e=new a(this.c,N,N)}get size(){return this.f}clear(){this.e=new a(this.c,N,N),this.f=0}has(k){return!!A.g(this,k,this.comparator)}get(k){return A.g(this,k,this.comparator)?.value}set(k,O){return A.h(this,k,O,this.comparator)&&(this.f+=1),this}delete(k){const O=A.k(this,k,this.comparator);return O&&(this.f-=1),O}forEach(k,O){let y=this.e.forward[0];for(;y;)k.call(O,y.value,y.key,this),y=y.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",O=this.e.forward[0];for(;O;)k+=`node(${O.key}, ${O.value}, lvl:${O.level})`,O=O.forward[0];return k}static g(k,O,y){let I=k.e;for(let p=k.d-1;p>=0;p--)for(;I.forward[p]&&y(I.forward[p].key,O)<0;)I=I.forward[p];if(I=I.forward[0],I&&y(I.key,O)===0)return I}static h(k,O,y,I){const p=[];let f=k.e;for(let d=k.d-1;d>=0;d--){for(;f.forward[d]&&I(f.forward[d].key,O)<0;)f=f.forward[d];p[d]=f}if(f=f.forward[0],f&&I(f.key,O)===0)return f.value=y,!1;{const d=A.j(k);if(d>k.d){for(let l=k.d;l<d;l++)p[l]=k.e;k.d=d}f=new a(d,O,y);for(let l=0;l<d;l++)f.forward[l]=p[l].forward[l],p[l].forward[l]=f;return!0}}static j(k,O=.5){let y=1;for(;Math.random()<O&&y<k.c;)y+=1;return y}static k(k,O,y){const I=[];let p=k.e;for(let f=k.d-1;f>=0;f--){for(;p.forward[f]&&y(p.forward[f].key,O)<0;)p=p.forward[f];I[f]=p}if(p=p.forward[0],!p||y(p.key,O)!==0)return!1;for(let f=0;f<k.d&&I[f].forward[f]===p;f++)I[f].forward[f]=p.forward[f];for(;k.d>0&&k.e.forward[k.d-1]===N;)k.d-=1;return!0}}e.$Ws=A}),define(ue[54],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(A){return new a(A)}constructor(A){this.c=R&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=a}),define(ue[3],de([0,1,8,89,2,90,54]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=d;const k=!1,O=!1,y=!1;var I;(function(F){F.None=()=>N.$Vc.None;function j(ve){if(y){const{onDidAddListener:we}=ve,Ee=g.create();let se=0;ve.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),we?.()}}}function H(ve,we){return ee(ve,()=>{},0,void 0,!0,void 0,we)}F.defer=H;function W(ve){return(we,Ee=null,se)=>{let fe=!1,me;return me=ve(Ie=>{if(!fe)return me?me.dispose():fe=!0,we.call(Ee,Ie)},null,se),fe&&me.dispose(),me}}F.once=W;function x(ve,we,Ee){return ne((se,fe=null,me)=>ve(Ie=>se.call(fe,we(Ie)),null,me),Ee)}F.map=x;function G(ve,we,Ee){return ne((se,fe=null,me)=>ve(Ie=>{we(Ie),se.call(fe,Ie)},null,me),Ee)}F.forEach=G;function te(ve,we,Ee){return ne((se,fe=null,me)=>ve(Ie=>we(Ie)&&se.call(fe,Ie),null,me),Ee)}F.filter=te;function B(ve){return ve}F.signal=B;function V(...ve){return(we,Ee=null,se)=>{const fe=(0,N.$Sc)(...ve.map(me=>me(Ie=>we.call(Ee,Ie))));return le(fe,se)}}F.any=V;function _(ve,we,Ee,se){let fe=Ee;return x(ve,me=>(fe=we(fe,me),fe),se)}F.reduce=_;function ne(ve,we){let Ee;const se={onWillAddFirstListener(){Ee=ve(fe.fire,fe)},onDidRemoveLastListener(){Ee?.dispose()}};we||j(se);const fe=new i(se);return we?.add(fe),fe.event}function le(ve,we){return we instanceof Array?we.push(ve):we&&we.add(ve),ve}function ee(ve,we,Ee=100,se=!1,fe=!1,me,Ie){let ke,De,Te,Ne=0,Ue;const Be={leakWarningThreshold:me,onWillAddFirstListener(){ke=ve(je=>{Ne++,De=we(De,je),se&&!Te&&(We.fire(De),De=void 0),Ue=()=>{const qe=De;De=void 0,Te=void 0,(!se||Ne>1)&&We.fire(qe),Ne=0},typeof Ee=="number"?(clearTimeout(Te),Te=setTimeout(Ue,Ee)):Te===void 0&&(Te=0,queueMicrotask(Ue))})},onWillRemoveListener(){fe&&Ne>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,ke.dispose()}};Ie||j(Be);const We=new i(Be);return Ie?.add(We),We.event}F.debounce=ee;function X(ve,we=0,Ee){return F.debounce(ve,(se,fe)=>se?(se.push(fe),se):[fe],we,void 0,!0,void 0,Ee)}F.accumulate=X;function K(ve,we=(se,fe)=>se===fe,Ee){let se=!0,fe;return te(ve,me=>{const Ie=se||!we(me,fe);return se=!1,fe=me,Ie},Ee)}F.latch=K;function q(ve,we,Ee){return[F.filter(ve,we,Ee),F.filter(ve,se=>!we(se),Ee)]}F.split=q;function D(ve,we=!1,Ee=[],se){let fe=Ee.slice(),me=ve(De=>{fe?fe.push(De):ke.fire(De)});se&&se.add(me);const Ie=()=>{fe?.forEach(De=>ke.fire(De)),fe=null},ke=new i({onWillAddFirstListener(){me||(me=ve(De=>ke.fire(De)),se&&se.add(me))},onDidAddFirstListener(){fe&&(we?setTimeout(Ie):Ie())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return se&&se.add(ke),ke.event}F.buffer=D;function J(ve,we){return(se,fe,me)=>{const Ie=we(new Y);return ve(function(ke){const De=Ie.evaluate(ke);De!==oe&&se.call(fe,De)},void 0,me)}}F.chain=J;const oe=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Ee=>(we(Ee),Ee)),this}filter(we){return this.f.push(Ee=>we(Ee)?Ee:oe),this}reduce(we,Ee){let se=Ee;return this.f.push(fe=>(se=we(se,fe),se)),this}latch(we=(Ee,se)=>Ee===se){let Ee=!0,se;return this.f.push(fe=>{const me=Ee||!we(fe,se);return Ee=!1,se=fe,me?fe:oe}),this}evaluate(we){for(const Ee of this.f)if(we=Ee(we),we===oe)break;return we}}function Z(ve,we,Ee=se=>se){const se=(...ke)=>Ie.fire(Ee(...ke)),fe=()=>ve.on(we,se),me=()=>ve.removeListener(we,se),Ie=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return Ie.event}F.fromNodeEventEmitter=Z;function M(ve,we,Ee=se=>se){const se=(...ke)=>Ie.fire(Ee(...ke)),fe=()=>ve.addEventListener(we,se),me=()=>ve.removeEventListener(we,se),Ie=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:me});return Ie.event}F.fromDOMEventEmitter=M;function z(ve){return new Promise(we=>W(ve)(we))}F.toPromise=z;function ie(ve){const we=new i;return ve.then(Ee=>{we.fire(Ee)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}F.fromPromise=ie;function ae(ve,we){return ve(Ee=>we.fire(Ee))}F.forward=ae;function he(ve,we,Ee){return we(Ee),ve(se=>we(se))}F.runAndSubscribe=he;class pe{constructor(we,Ee){this._observable=we,this.f=0,this.g=!1;const se={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Ee||j(se),this.emitter=new i(se),Ee&&Ee.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Ee){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function be(ve,we){return new pe(ve,we).emitter.event}F.fromObservable=be;function Pe(ve){return(we,Ee,se)=>{let fe=0,me=!1;const Ie={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ve.reportChanges(),me&&(me=!1,we.call(Ee)))},handlePossibleChange(){},handleChange(){me=!0}};ve.addObserver(Ie),ve.reportChanges();const ke={dispose(){ve.removeObserver(Ie)}};return se instanceof N.$Uc?se.add(ke):Array.isArray(se)&&se.push(ke),ke}}F.fromObservableLight=Pe})(I||(e.Event=I={}));class p{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${p.f++}`,p.all.add(this)}start(j){this.g=new T.$ge,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$ie=p;let f=-1;function d(F){const j=f;return f=F,{dispose(){f=j}}}class l{static{this.f=1}constructor(j,H,W=(l.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=H,this.name=W,this.h=0}dispose(){this.g?.clear()}check(j,H){const W=this.threshold;if(W<=0||H<W)return;this.g||(this.g=new Map);const x=this.g.get(j.value)||0;if(this.g.set(j.value,x+1),this.h-=1,this.h<=0){this.h=W*.5;const[G,te]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${te}):`;console.warn(B),console.warn(G);const V=new E(B,G);this.j(V)}return()=>{const G=this.g.get(j.value)||0;this.g.set(j.value,G-1)}}getMostFrequentStack(){if(!this.g)return;let j,H=0;for(const[W,x]of this.g)(!j||H<x)&&(j=[W,x],H=x);return j}}class g{static create(){const j=new Error;return new g(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(j,H){super(j),this.name="ListenerLeakError",this.stack=H}}e.$ke=E;class m extends Error{constructor(j,H){super(j),this.name="ListenerRefusalError",this.stack=H}}e.$le=m;let w=0;class P{constructor(j){this.value=j,this.id=w++}}const $=2,c=(F,j)=>{if(F instanceof P)j(F);else for(let H=0;H<F.length;H++){const W=F[H];W&&j(W)}};let h;if(k){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),h=new FinalizationRegistry(j=>{typeof j=="string"&&F.push(j)})}class i{constructor(j){this.z=0,this.f=j,this.g=f>0||this.f?.leakWarningThreshold?new l(j?.onListenerError??R.$Z,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(O){const j=this.u;queueMicrotask(()=>{c(j,H=>H.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,H,W)=>{if(this.g&&this.z>this.g.threshold**2){const V=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(V);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new m(`${V}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||R.$Z)(ne),N.$Vc.None}if(this.m)return N.$Vc.None;H&&(j=j.bind(H));const x=new P(j);let G,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=g.create(),G=this.g.check(x.stack,this.z+1)),O&&(x.stack=te??g.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,N.$Tc)(()=>{h?.unregister(B),G?.(),this.A(x)});if(W instanceof N.$Uc?W.add(B):Array.isArray(W)&&W.push(B),h){const V=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(V);h.register(B,_?.[2]??V,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const H=this.u,W=H.indexOf(j);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,H[W]=void 0;const x=this.w.current===this;if(this.z*$<=H.length){let G=0;for(let te=0;te<H.length;te++)H[te]?H[G++]=H[te]:x&&(this.w.end--,G<this.w.i&&this.w.i--);H.length=G}}B(j,H){if(!j)return;const W=this.f?.onListenerError||R.$Z;if(!W){j.value(H);return}try{j.value(H)}catch(x){W(x)}}C(j){const H=j.current.u;for(;j.i<j.end;)this.B(H[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,j);else{const H=this.w;H.enqueue(this,j,this.u.length),this.C(H)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=i;const n=()=>new t;e.$ne=n;class t{constructor(){this.i=-1,this.end=0}enqueue(j,H,W){this.i=0,this.end=W,this.current=j,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(j,H,W){if(this.u)for(this.h||(this.h=new A.$6c),c(this.u,x=>this.h.push([x.value,j]));this.h.size>0&&!H.isCancellationRequested;){const[x,G]=this.h.shift(),te=[],B={...G,token:H,waitUntil:V=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");W&&(V=W(V,x)),te.push(V)}};try{x(B)}catch(V){(0,R.$Z)(V);continue}Object.freeze(te),await Promise.allSettled(te).then(V=>{for(const _ of V)_.status==="rejected"&&(0,R.$Z)(_.reason)})}}}e.$oe=s;class r extends i{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new A.$6c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$pe=r;class o extends r{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$qe=o;class u extends i{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(H=>super.fire(H)),this.h=[]}))}}e.$re=u;class b{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const H={event:j,listener:null};this.h.push(H),this.g&&this.m(H);const W=()=>{this.g&&this.o(H);const x=this.h.indexOf(H);this.h.splice(x,1)};return(0,N.$Tc)((0,a.$db)(W))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(H=>this.f.fire(H))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$se=b;class L{constructor(j,H,W,x){this.f=new N.$Uc;const G=this.f.add(new b),te=this.f.add(new N.$5c);function B(V){te.set(V,G.add(x(V)))}for(const V of j)B(V);this.f.add(H(V=>{B(V)})),this.f.add(W(V=>{te.deleteAndDispose(V)})),this.event=G.event}dispose(){this.f.dispose()}}e.$te=L;class S{constructor(){this.f=[]}wrapEvent(j,H,W){return(x,G,te)=>j(B=>{const V=this.f[this.f.length-1];if(!H){V?V.buffers.push(()=>x.call(G,B)):x.call(G,B);return}const _=V;if(!_){x.call(G,H(W,B));return}_.items??=[],_.items.push(B),_.buffers.length===0&&V.buffers.push(()=>{_.reducedResult??=W?_.items.reduce(H,W):_.items.reduce(H),x.call(G,_.reducedResult)})},void 0,te)}bufferEvents(j){const H={buffers:new Array};this.f.push(H);const W=j();return this.f.pop(),H.buffers.forEach(x=>x()),W}}e.$ue=S;class v{constructor(){this.f=!1,this.g=I.None,this.h=N.$Vc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class C{static const(j){return new U(j)}constructor(j){this.g=j,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$we=C;class U{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(ue[25],de([0,1,3]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=k;const a=Object.freeze(function(O,y){const I=setTimeout(O.bind(y),0);return{dispose(){clearTimeout(I)}}});var N;(function(O){function y(I){return I===O.None||I===O.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}O.isCancellationToken=y,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(N||(e.CancellationToken=N={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new R.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=N.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=N.None}}e.$xe=T;function k(O){const y=new T;return O.add({dispose(){y.cancel()}}),y.token}}),define(ue[137],de([0,1,25]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=N;class a{constructor(O){this.b=O,this.a=null}get(){if(this.a)return this.a;const O=new R.$xe,y=this.b(O.token);return this.a={promise:y,dispose:()=>{this.a=null,O.cancel(),O.dispose()}},this.a}}e.$0e=a;function N(k){return k}class A{constructor(O,y){this.a=void 0,this.b=void 0,typeof O=="function"?(this.c=O,this.d=N):(this.c=y,this.d=O.getCacheKey)}get(O){const y=this.d(O);return this.b!==y&&(this.b=y,this.a=this.c(O)),this.a}}e.$_e=A;class T{get cachedValues(){return this.a}constructor(O,y){this.a=new Map,this.b=new Map,typeof O=="function"?(this.c=O,this.d=N):(this.c=y,this.d=O.getCacheKey)}get(O){const y=this.d(O);if(this.b.has(y))return this.b.get(y);const I=this.c(O);return this.a.set(O,I),this.b.set(y,I),I}}e.$af=T}),define(ue[50],de([0,1,8,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=N,e.$Ae=A,e.$Be=T,e.$Ce=k,e.$De=y,e.$Ee=I,e.$Fe=p,e.$Ge=f,e.$He=d,e.$Ie=l,e.$Je=g,e.$Ke=E,e.$Le=m,e.$Me=w,e.$Ne=P;function N($){const c=$;return c?typeof c.read=="function":!1}function A($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}function T($){const c=$;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function k($,c){return new O($,c)}class O{constructor(c,h){this.e=c,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(h=>h(c))}h(c){this.c.error.length===0?(0,R.$Z)(c):this.c.error.slice(0).forEach(h=>h(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,h){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(c,h){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(h);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y($,c){const h=[];let i;for(;(i=$.read())!==null;)h.push(i);return c(h)}function I($,c,h){const i=[];let n;for(;(n=$.read())!==null&&i.length<h;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return $.read()}}}function p($,c){return new Promise((h,i)=>{const n=[];f($,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}function f($,c,h){$.on("error",i=>{h?.isCancellationRequested||c.onError(i)}),$.on("end",()=>{h?.isCancellationRequested||c.onEnd()}),$.on("data",i=>{h?.isCancellationRequested||c.onData(i)})}function d($,c){return new Promise((h,i)=>{const n=new a.$Uc,t=[],s=u=>{if(t.push(u),t.length>c)return n.dispose(),$.pause(),h({stream:$,buffer:t,ended:!1})},r=u=>(n.dispose(),i(u)),o=()=>(n.dispose(),h({stream:$,buffer:t,ended:!0}));n.add((0,a.$Tc)(()=>$.removeListener("error",r))),$.on("error",r),n.add((0,a.$Tc)(()=>$.removeListener("end",o))),$.on("end",o),n.add((0,a.$Tc)(()=>$.removeListener("data",s))),$.on("data",s)})}function l($,c){const h=k(c);return h.end($),h}function g(){const $=k(()=>{throw new Error("not supported")});return $.end(),$}function E($){let c=!1;return{read:()=>c?null:(c=!0,$)}}function m($,c,h){const i=k(h);return f($,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function w($,c,h){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?h([$,n]):$)}}}function P($,c,h){let i=!1;const n=k(h);return f(c,{onData:t=>i?n.write(t):(i=!0,n.write(h([$,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write($)),n.end()}}),n}}),define(ue[14],de([0,1,53,50]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=y,e.$Qe=I,e.$Re=p,e.$Se=f,e.$Te=d,e.$Ue=l,e.$Ve=g,e.$We=E,e.$Xe=m,e.$Ye=w,e.$Ze=P,e.$1e=$,e.$2e=c,e.$3e=h,e.$4e=i,e.$5e=n,e.$6e=t,e.$7e=s,e.$8e=r,e.$9e=b,a=Oe(a);const N=typeof Buffer<"u",A=new R.$U(()=>new Uint8Array(256));let T,k;class O{static alloc(S){return N?new O(Buffer.allocUnsafe(S)):new O(new Uint8Array(S))}static wrap(S){return N&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new O(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&N?new O(Buffer.from(S)):(T||(T=new TextEncoder),new O(T.encode(S)))}static fromByteArray(S){const v=O.alloc(S.length);for(let C=0,U=S.length;C<U;C++)v.buffer[C]=S[C];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let F=0,j=S.length;F<j;F++)v+=S[F].byteLength}const C=O.alloc(v);let U=0;for(let F=0,j=S.length;F<j;F++){const H=S[F];C.set(H,U),U+=H.byteLength}return C}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=O.alloc(this.byteLength);return S.set(this),S}toString(){return N?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(S,v){return new O(this.buffer.subarray(S,v))}set(S,v){if(S instanceof O)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return f(this.buffer,S)}writeUInt32BE(S,v){d(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){g(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){m(this.buffer,S,v)}indexOf(S,v=0){return y(this.buffer,S instanceof O?S.buffer:S,v)}}e.$Oe=O;function y(L,S,v=0){const C=S.byteLength,U=L.byteLength;if(C===0)return 0;if(C===1)return L.indexOf(S[0]);if(C>U-v)return-1;const F=A.value;F.fill(S.length);for(let x=0;x<S.length;x++)F[S[x]]=S.length-x-1;let j=v+S.length-1,H=j,W=-1;for(;j<U;)if(L[j]===S[H]){if(H===0){W=j;break}j--,H--}else j+=Math.max(S.length-H,F[L[j]]),H=S.length-1;return W}function I(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0}function p(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255}function f(L,S){return L[S]*2**24+L[S+1]*2**16+L[S+2]*2**8+L[S+3]}function d(L,S,v){L[v+3]=S,S=S>>>8,L[v+2]=S,S=S>>>8,L[v+1]=S,S=S>>>8,L[v]=S}function l(L,S){return L[S+0]<<0>>>0|L[S+1]<<8>>>0|L[S+2]<<16>>>0|L[S+3]<<24>>>0}function g(L,S,v){L[v+0]=S&255,S=S>>>8,L[v+1]=S&255,S=S>>>8,L[v+2]=S&255,S=S>>>8,L[v+3]=S&255}function E(L,S){return L[S]}function m(L,S,v){L[v]=S}function w(L){return a.$De(L,S=>O.concat(S))}function P(L){return a.$Ke(L)}function $(L){return a.$Fe(L,S=>O.concat(S))}async function c(L){return L.ended?O.concat(L.buffer):O.concat([...L.buffer,await $(L.stream)])}function h(L){return a.$Ie(L,S=>O.concat(S))}function i(L){return a.$Le(L,{data:S=>typeof S=="string"?O.fromString(S):O.wrap(S)},S=>O.concat(S))}function n(L){return a.$Ce(S=>O.concat(S),L)}function t(L,S){return a.$Me(L,S,v=>O.concat(v))}function s(L,S){return a.$Ne(L,S,v=>O.concat(v))}function r(L){let S=0,v=0,C=0;const U=new Uint8Array(Math.floor(L.length/4*3)),F=H=>{switch(v){case 3:U[C++]=S|H,v=0;break;case 2:U[C++]=S|H>>>2,S=H<<6,v=3;break;case 1:U[C++]=S|H>>>4,S=H<<4,v=2;break;default:S=H<<2,v=1}};for(let H=0;H<L.length;H++){const W=L.charCodeAt(H);if(W>=65&&W<=90)F(W-65);else if(W>=97&&W<=122)F(W-97+26);else if(W>=48&&W<=57)F(W-48+52);else if(W===43||W===45)F(62);else if(W===47||W===95)F(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${L[H]}`)}}const j=C;for(;v>0;)F(0);return O.wrap(U).slice(0,j)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:L},S=!0,v=!1){const C=v?u:o;let U="";const F=L.byteLength%3;let j=0;for(;j<L.byteLength-F;j+=3){const H=L[j+0],W=L[j+1],x=L[j+2];U+=C[H>>>2],U+=C[(H<<4|W>>>4)&63],U+=C[(W<<2|x>>>6)&63],U+=C[x&63]}if(F===1){const H=L[j+0];U+=C[H>>>2],U+=C[H<<4&63],S&&(U+="==")}else if(F===2){const H=L[j+0],W=L[j+1];U+=C[H>>>2],U+=C[(H<<4|W>>>4)&63],U+=C[W<<2&63],S&&(U+="=")}return U}}),define(ue[138],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ue[12],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=R,e.$gg=a,e.$hg=N,e.$ig=A,e.$jg=T,e.$kg=k,e.$lg=O,e.$mg=y,e.$ng=I,e.$og=p,e.$pg=f,e.$qg=d,e.$rg=l,e.$sg=E,e.$tg=m,e.$ug=w,e.$vg=P,e.$wg=$,e.$xg=c;function R(h){return typeof h=="string"}function a(h){return Array.isArray(h)&&h.every(i=>R(i))}function N(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function A(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}function T(h){return typeof h=="number"&&!isNaN(h)}function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}function O(h){return h===!0||h===!1}function y(h){return typeof h>"u"}function I(h){return!p(h)}function p(h){return y(h)||h===null}function f(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function d(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function l(...h){const i=[];for(let n=0;n<h.length;n++){const t=h[n];if(p(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const g=Object.prototype.hasOwnProperty;function E(h){if(!N(h))return!1;for(const i in h)if(g.call(h,i))return!1;return!0}function m(h){return typeof h=="function"}function w(...h){return h.length>0&&h.every(m)}function P(h,i){const n=Math.min(h.length,i.length);for(let t=0;t<n;t++)$(h[t],i[t])}function $(h,i){if(R(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(m(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(h){return h}}),define(ue[29],de([0,1,12]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=a,e.$go=N,e.$ho=T,e.$io=O,e.$jo=y,e.$ko=I,e.$lo=p,e.$mo=f,e.$no=d,e.$oo=l,e.$po=g,e.$qo=E,e.$ro=m;function a(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([$,c])=>{P[$]=c&&typeof c=="object"?a(c):c}),P}function N(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const $=P.shift();Object.freeze($);for(const c in $)if(A.call($,c)){const h=$[c];typeof h=="object"&&!Object.isFrozen(h)&&!(0,R.$ig)(h)&&P.push(h)}}return w}const A=Object.prototype.hasOwnProperty;function T(w,P){return k(w,P,new Set)}function k(w,P,$){if((0,R.$og)(w))return w;const c=P(w);if(typeof c<"u")return c;if(Array.isArray(w)){const h=[];for(const i of w)h.push(k(i,P,$));return h}if((0,R.$hg)(w)){if($.has(w))throw new Error("Cannot clone recursive data-structure");$.add(w);const h={};for(const i in w)A.call(w,i)&&(h[i]=k(w[i],P,$));return $.delete(w),h}return w}function O(w,P,$=!0){return(0,R.$hg)(w)?((0,R.$hg)(P)&&Object.keys(P).forEach(c=>{c in w?$&&((0,R.$hg)(w[c])&&(0,R.$hg)(P[c])?O(w[c],P[c],$):w[c]=P[c]):w[c]=P[c]}),w):P}function y(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let $,c;if(Array.isArray(w)){if(w.length!==P.length)return!1;for($=0;$<w.length;$++)if(!y(w[$],P[$]))return!1}else{const h=[];for(c in w)h.push(c);h.sort();const i=[];for(c in P)i.push(c);if(i.sort(),!y(h,i))return!1;for($=0;$<h.length;$++)if(!y(w[h[$]],P[h[$]]))return!1}return!0}function I(w){const P=new Set;return JSON.stringify(w,($,c)=>{if((0,R.$hg)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function p(w,P){const $=Object.create(null);return!w||!P||Object.keys(P).forEach(h=>{const i=w[h],n=P[h];y(i,n)||($[h]=n)}),$}function f(w,P){const $=P.toLowerCase(),c=Object.keys(w).find(h=>h.toLowerCase()===$);return c?w[c]:w[P]}function d(w,P){const $=Object.create(null);for(const[c,h]of Object.entries(w))P(c,h)&&($[c]=h);return $}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function g(w){const P=[];for(const $ of l(w))typeof w[$]=="function"&&P.push($);return P}function E(w,P){const $=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},c={};for(const h of w)c[h]=$(h);return c}function m(w,P){const $={};for(const[c,h]of Object.entries(w))$[c]=P(h,c);return $}}),define(ue[139],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=a,e.$cf=N;var R;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function a(A){return A<0?0:A>R.MAX_UINT_8?R.MAX_UINT_8:A|0}function N(A){return A<0?0:A>R.MAX_UINT_32?R.MAX_UINT_32:A|0}}),define(ue[26],de([0,1,137,39,53,139]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=O,e.$ff=I,e.$gf=p,e.$hf=f,e.$if=d,e.$jf=l,e.$kf=g,e.$lf=E,e.$mf=m,e.$nf=w,e.$of=P,e.$pf=$,e.$qf=c,e.$rf=h,e.$sf=i,e.$tf=n,e.$uf=t,e.$vf=s,e.$wf=r,e.$xf=o,e.$yf=u,e.$zf=b,e.$Af=L,e.$Bf=S,e.$Cf=v,e.$Df=C,e.$Ef=U,e.$Ff=F,e.$Gf=j,e.$Hf=H,e.$If=W,e.$Jf=x,e.$Kf=G,e.$Lf=te,e.$Mf=B,e.$Nf=V,e.$Qf=ee,e.$Rf=X,e.$Sf=K,e.$Tf=q,e.$Uf=oe,e.$Vf=Z,e.$Xf=M,e.$Yf=z,e.$Zf=ie,e.$1f=ae,e.$2f=pe,e.$3f=be,e.$4f=ve,e.$6f=we,e.$7f=Ee,e.$8f=se,e.$9f=fe,e.$0f=me,e.$$f=Ie,e.$_f=ke,e.$ag=De,e.$bg=We;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}const k=/{(\d+)}/g;function O(re,...ge){return ge.length===0?re:re.replace(k,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=ge.length?$e:ge[Ae]})}const y=/{([^}]+)}/g;function I(re,ge){return Object.keys(ge).length===0?re:re.replace(y,($e,ye)=>ge[ye]??$e)}function p(re){return re.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function f(re){return re.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function d(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(re,ge){let $e=0,ye=re.indexOf(ge);for(;ye!==-1;)$e++,ye=re.indexOf(ge,ye+ge.length);return $e}function g(re,ge,$e="\u2026"){return re.length<=ge?re:`${re.substr(0,ge)}${$e}`}function E(re,ge,$e="\u2026"){if(re.length<=ge)return re;const ye=Math.ceil(ge/2)-$e.length/2,Ae=Math.floor(ge/2)-$e.length/2;return`${re.substr(0,ye)}${$e}${re.substr(re.length-Ae)}`}function m(re,ge=" "){const $e=w(re,ge);return P($e,ge)}function w(re,ge){if(!re||!ge)return re;const $e=ge.length;if($e===0||re.length===0)return re;let ye=0;for(;re.indexOf(ge,ye)===ye;)ye=ye+$e;return re.substring(ye)}function P(re,ge){if(!re||!ge)return re;const $e=ge.length,ye=re.length;if($e===0||ye===0)return re;let Ae=ye,Ce=-1;for(;Ce=re.lastIndexOf(ge,Ae-1),!(Ce===-1||Ce+$e!==Ae);){if(Ce===0)return"";Ae=Ce}return re.substring(0,Ae)}function $(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(re){return re.replace(/\*/g,"")}function h(re,ge,$e={}){if(!re)throw new Error("Cannot create regex from empty string");ge||(re=d(re)),$e.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(re,ye)}function i(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function n(re){return re.split(/\r\n|\r|\n/)}function t(re){const ge=[],$e=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)ge.push($e[2*ye]+($e[2*ye+1]??""));return ge}function s(re){for(let ge=0,$e=re.length;ge<$e;ge++){const ye=re.charCodeAt(ge);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return ge}return-1}function r(re,ge=0,$e=re.length){for(let ye=ge;ye<$e;ye++){const Ae=re.charCodeAt(ye);if(Ae!==a.CharCode.Space&&Ae!==a.CharCode.Tab)return re.substring(ge,ye)}return re.substring(ge,$e)}function o(re,ge=re.length-1){for(let $e=ge;$e>=0;$e--){const ye=re.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function u(re,ge,$e){const ye=[];let Ae=0;for(const Ce of re.matchAll(ge)){if(ye.push(re.slice(Ae,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ae=Ce.index+Ce[0].length,ye.push($e(Ce[0],...Ce.slice(1),Ce.index,re,Ce.groups))}return ye.push(re.slice(Ae)),Promise.all(ye).then(Ce=>Ce.join(""))}function b(re,ge){return re<ge?-1:re>ge?1:0}function L(re,ge,$e=0,ye=re.length,Ae=0,Ce=ge.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){const Je=re.charCodeAt($e),Qe=ge.charCodeAt(Ae);if(Je<Qe)return-1;if(Je>Qe)return 1}const Me=ye-$e,xe=Ce-Ae;return Me<xe?-1:Me>xe?1:0}function S(re,ge){return v(re,ge,0,re.length,0,ge.length)}function v(re,ge,$e=0,ye=re.length,Ae=0,Ce=ge.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){let Je=re.charCodeAt($e),Qe=ge.charCodeAt(Ae);if(Je===Qe)continue;if(Je>=128||Qe>=128)return L(re.toLowerCase(),ge.toLowerCase(),$e,ye,Ae,Ce);U(Je)&&(Je-=32),U(Qe)&&(Qe-=32);const Ge=Je-Qe;if(Ge!==0)return Ge}const Me=ye-$e,xe=Ce-Ae;return Me<xe?-1:Me>xe?1:0}function C(re){return re>=a.CharCode.Digit0&&re<=a.CharCode.Digit9}function U(re){return re>=a.CharCode.a&&re<=a.CharCode.z}function F(re){return re>=a.CharCode.A&&re<=a.CharCode.Z}function j(re,ge){return re.length===ge.length&&v(re,ge)===0}function H(re,ge){const $e=ge.length;return ge.length>re.length?!1:v(re,ge,0,$e)===0}function W(re,ge){const $e=Math.min(re.length,ge.length);let ye;for(ye=0;ye<$e;ye++)if(re.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return $e}function x(re,ge){const $e=Math.min(re.length,ge.length);let ye;const Ae=re.length-1,Ce=ge.length-1;for(ye=0;ye<$e;ye++)if(re.charCodeAt(Ae-ye)!==ge.charCodeAt(Ce-ye))return ye;return $e}function G(re){return 55296<=re&&re<=56319}function te(re){return 56320<=re&&re<=57343}function B(re,ge){return(re-55296<<10)+(ge-56320)+65536}function V(re,ge,$e){const ye=re.charCodeAt($e);if(G(ye)&&$e+1<ge){const Ae=re.charCodeAt($e+1);if(te(Ae))return B(ye,Ae)}return ye}function _(re,ge){const $e=re.charCodeAt(ge-1);if(te($e)&&ge>1){const ye=re.charCodeAt(ge-2);if(G(ye))return B(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(ge,$e=0){this.c=ge,this.d=ge.length,this.e=$e}setOffset(ge){this.e=ge}prevCodePoint(){const ge=_(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=V(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Of=ne;class le{get offset(){return this.c.offset}constructor(ge,$e=0){this.c=new ne(ge,$e)}nextGraphemeLength(){const ge=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=ge.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ce=$e.offset,Me=ge.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,Me)){$e.setOffset(Ce);break}Ae=Me}return $e.offset-ye}prevGraphemeLength(){const ge=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=ge.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ce=$e.offset,Me=ge.getGraphemeBreakType($e.prevCodePoint());if(Te(Me,Ae)){$e.setOffset(Ce);break}Ae=Me}return ye-$e.offset}eol(){return this.c.eol()}}e.$Pf=le;function ee(re,ge){return new le(re,ge).nextGraphemeLength()}function X(re,ge){return new le(re,ge).prevGraphemeLength()}function K(re,ge){ge>0&&te(re.charCodeAt(ge))&&ge--;const $e=ge+ee(re,ge);return[$e-X(re,$e),$e]}function q(re){const ge=new le(re);let $e=0;for(;!ge.eol();)$e++,ge.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(re){return D||(D=J()),D.test(re)}const Y=/^[\t\n\r\x20-\x7E]*$/;function Z(re){return Y.test(re)}e.$Wf=/[\u2028\u2029]/;function M(re){return e.$Wf.test(re)}function z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function ie(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function ae(re,ge,$e=""){const ye=re.trimStart();if(ye.length<ge)return ye;const Ae=/\b/g;let Ce=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<ge);)Ce=Ae.lastIndex,Ae.lastIndex+=1;return Ce===0?ye:$e+ye.substring(Ce).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(re){let ge=0;for(const $e of re.matchAll(he))ge!==$e.index&&(yield{isCode:!1,str:re.substring(ge,$e.index)}),yield{isCode:!0,str:$e[0]},ge=$e.index+$e[0].length;ge!==re.length&&(yield{isCode:!1,str:re.substring(ge)})}function be(re){return re&&(re=re.replace(he,"")),re}const Pe=/\\\[.*?\\\]/g;function ve(re){return be(re).replace(Pe,"")}e.$5f=String.fromCharCode(a.CharCode.UTF8_BOM);function we(re){return!!(re&&re.length>0&&re.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Ee(re){return we(re)?re.substr(1):re}function se(re,ge){if(!re||!ge||re.length<ge.length)return!1;const $e=ge.length,ye=re.toLowerCase();let Ae=0,Ce=-1;for(;Ae<$e;){const Me=ye.indexOf(ge[Ae],Ce+1);if(Me<0)return!1;Ce=Me,Ae++}return!0}function fe(re,ge=!1){return re?(ge&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function me(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Ie(re,ge=1){if(ge===0)return"";let $e=-1;do $e=re.indexOf(`
`,$e+1),ge--;while(ge>0&&$e>=0);return $e===-1?re:(re[$e-1]==="\r"&&$e--,re.substr(0,$e))}function ke(re){const ge=a.CharCode.Z-a.CharCode.A+1;return re=re%(2*ge),re<ge?String.fromCharCode(a.CharCode.a+re):String.fromCharCode(a.CharCode.A+re-ge)}function De(re){return Ue.getInstance().getGraphemeBreakType(re)}function Te(re,ge){return re===Ne.Other?ge!==Ne.Extend&&ge!==Ne.SpacingMark:re===Ne.CR&&ge===Ne.LF?!1:re===Ne.Control||re===Ne.CR||re===Ne.LF||ge===Ne.Control||ge===Ne.CR||ge===Ne.LF?!0:!(re===Ne.L&&(ge===Ne.L||ge===Ne.V||ge===Ne.LV||ge===Ne.LVT)||(re===Ne.LV||re===Ne.V)&&(ge===Ne.V||ge===Ne.T)||(re===Ne.LVT||re===Ne.T)&&ge===Ne.T||ge===Ne.Extend||ge===Ne.ZWJ||ge===Ne.SpacingMark||re===Ne.Prepend||re===Ne.ZWJ&&ge===Ne.Extended_Pictographic||re===Ne.Regional_Indicator&&ge===Ne.Regional_Indicator)}var Ne;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Be()}getGraphemeBreakType(ge){if(ge<32)return ge===a.CharCode.LineFeed?Ne.LF:ge===a.CharCode.CarriageReturn?Ne.CR:Ne.Control;if(ge<127)return Ne.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(ge<$e[3*Ae])Ae=2*Ae;else if(ge>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Ne.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(re,ge){if(re===0)return 0;const $e=je(re,ge);if($e!==void 0)return $e;const ye=new ne(ge,re);return ye.prevCodePoint(),ye.offset}function je(re,ge){const $e=new ne(ge,re);let ye=$e.prevCodePoint();for(;qe(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ie(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function qe(re){return 127995<=re&&re<=127999}var ze;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$cg="\xA0";class Ve{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$_e({getCacheKey:JSON.stringify},ge=>{function $e(Ge){const _e=new Map;for(let Ze=0;Ze<Ge.length;Ze+=2)_e.set(Ge[Ze],Ge[Ze+1]);return _e}function ye(Ge,_e){const Ze=new Map(Ge);for(const[nt,at]of _e)Ze.set(nt,at);return Ze}function Ae(Ge,_e){if(!Ge)return _e;const Ze=new Map;for(const[nt,at]of Ge)_e.has(nt)&&Ze.set(nt,at);return Ze}const Ce=this.c.value;let Me=ge.filter(Ge=>!Ge.startsWith("_")&&Ge in Ce);Me.length===0&&(Me=["_default"]);let xe;for(const Ge of Me){const _e=$e(Ce[Ge]);xe=Ae(xe,_e)}const Je=$e(Ce._common),Qe=ye(Je,xe);return new Ve(Qe)})}static getInstance(ge){return Ve.d.get(Array.from(ge))}static{this.e=new N.$U(()=>Object.keys(Ve.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ye=ge.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=Ve;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(ge){return Le.e().has(ge)}static containsInvisibleCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ye=ge.codePointAt($e);if(typeof ye=="number"&&Le.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Le.e()}}e.$eg=Le}),define(ue[41],de([0,1,39,13,5,26,12]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=k,e.$zg=O,e.$Ag=y,e.$Bg=I,e.$Cg=p,e.$Dg=g,e.$Eg=E,e.$Fg=m,e.$Gg=w,e.$Hg=P,e.$Ig=$,e.$Jg=c,e.$Kg=h,e.$Lg=i,e.$Mg=n,e.$Ng=t,e.$Og=o;function k(u){return u===R.CharCode.Slash||u===R.CharCode.Backslash}function O(u){return u.replace(/[\\/]/g,a.$hc.sep)}function y(u){return u.indexOf("/")===-1&&(u=O(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function I(u,b=a.$hc.sep){if(!u)return"";const L=u.length,S=u.charCodeAt(0);if(k(S)){if(k(u.charCodeAt(1))&&!k(u.charCodeAt(2))){let C=3;const U=C;for(;C<L&&!k(u.charCodeAt(C));C++);if(U!==C&&!k(u.charCodeAt(C+1))){for(C+=1;C<L;C++)if(k(u.charCodeAt(C)))return u.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if(w(S)&&u.charCodeAt(1)===R.CharCode.Colon)return k(u.charCodeAt(2))?u.slice(0,2)+b:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<L;v++)if(k(u.charCodeAt(v)))return u.slice(0,v+1)}return""}function p(u){if(!N.$j||!u||u.length<5)return!1;let b=u.charCodeAt(0);if(b!==R.CharCode.Backslash||(b=u.charCodeAt(1),b!==R.CharCode.Backslash))return!1;let L=2;const S=L;for(;L<u.length&&(b=u.charCodeAt(L),b!==R.CharCode.Backslash);L++);return!(S===L||(b=u.charCodeAt(L+1),isNaN(b)||b===R.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,d=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(u,b=N.$j){const L=b?f:d;return!(!u||u.length===0||/^\s+$/.test(u)||(L.lastIndex=0,L.test(u))||b&&l.test(u)||u==="."||u===".."||b&&u[u.length-1]==="."||b&&u.length!==u.trim().length||u.length>255)}function E(u,b,L){const S=u===b;return!L||S?S:!u||!b?!1:(0,A.$Gf)(u,b)}function m(u,b,L,S=a.sep){if(u===b)return!0;if(!u||!b||b.length>u.length)return!1;if(L){if(!(0,A.$Hf)(u,b))return!1;if(b.length===u.length)return!0;let C=b.length;return b.charAt(b.length-1)===S&&C--,u.charAt(C)===S}return b.charAt(b.length-1)!==S&&(b+=S),u.indexOf(b)===0}function w(u){return u>=R.CharCode.A&&u<=R.CharCode.Z||u>=R.CharCode.a&&u<=R.CharCode.z}function P(u,b){return N.$j&&u.endsWith(":")&&(u+=a.sep),(0,a.$jc)(u)||(u=(0,a.$kc)(b,u)),u=(0,a.$ic)(u),$(u)}function $(u){return N.$j?(u=(0,A.$of)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,A.$of)(u,a.sep),u||(u=a.sep)),u}function c(u){const b=(0,a.$ic)(u);return N.$j?u.length>3?!1:h(b)&&(u.length===2||b.charCodeAt(2)===R.CharCode.Backslash):b===a.$hc.sep}function h(u,b=N.$j){return b?w(u.charCodeAt(0))&&u.charCodeAt(1)===R.CharCode.Colon:!1}function i(u,b=N.$j){return h(u,b)?u[0]:void 0}function n(u,b,L){return b.length>u.length?-1:u===b?0:(L&&(u=u.toLowerCase(),b=b.toLowerCase()),u.indexOf(b))}function t(u){const b=u.split(":");let L,S,v;for(const C of b){const U=Number(C);(0,T.$jg)(U)?S===void 0?S=U:v===void 0&&(v=U):L=L?[L,C].join(":"):C}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,b,L=8){let S="";for(let C=0;C<L;C++){let U;C===0&&N.$j&&!b&&(L===3||L===4)?U=r:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let v;return b?v=`${b}-${S}`:v=S,u?(0,a.$kc)(u,v):v}}),define(ue[55],de([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=a,e.$vj=N,e.$wj=A,e.$xj=k,e.$zj=g,R=Oe(R);function a(m){return N(m,0)}function N(m,w){switch(typeof m){case"object":return m===null?A(349,w):Array.isArray(m)?O(m,w):y(m,w);case"string":return k(m,w);case"boolean":return T(m,w);case"number":return A(m,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(m,w){return(w<<5)-w+m|0}function T(m,w){return A(m?433:863,w)}function k(m,w){w=A(149417,w);for(let P=0,$=m.length;P<$;P++)w=A(m.charCodeAt(P),w);return w}function O(m,w){return w=A(104579,w),m.reduce((P,$)=>N($,P),w)}function y(m,w){return w=A(181387,w),Object.keys(m).sort().reduce((P,$)=>(P=k($,P),N(m[$],P)),w)}class I{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=N(w,this.g),this.g}}e.$yj=I;var p;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function f(m,w,P=32){const $=P-w,c=~((1<<$)-1);return(m<<w|(c&m)>>>$)>>>0}function d(m,w=0,P=m.byteLength,$=0){for(let c=0;c<P;c++)m[w+c]=$}function l(m,w,P="0"){for(;m.length<w;)m=P+m;return m}function g(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((m>>>0).toString(16),w/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(p.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const $=this.p;let c=this.r,h=this.u,i,n;for(h!==0?(i=h,n=-1,h=0):(i=w.charCodeAt(0),n=0);;){let t=i;if(R.$Kf(i))if(n+1<P){const s=w.charCodeAt(n+1);R.$Lf(s)?(n++,t=R.$Mf(i,s)):t=p.UNICODE_REPLACEMENT}else{h=i;break}else R.$Lf(i)&&(t=p.UNICODE_REPLACEMENT);if(c=this.w($,c,t),n++,n<P)i=w.charCodeAt(n);else break}this.r=c,this.u=h}w(w,P,$){return $<128?w[P++]=$:$<2048?(w[P++]=192|($&1984)>>>6,w[P++]=128|($&63)>>>0):$<65536?(w[P++]=224|($&61440)>>>12,w[P++]=128|($&4032)>>>6,w[P++]=128|($&63)>>>0):(w[P++]=240|($&1835008)>>>18,w[P++]=128|($&258048)>>>12,w[P++]=128|($&4032)>>>6,w[P++]=128|($&63)>>>0),P>=p.BLOCK_SIZE&&(this.y(),P-=p.BLOCK_SIZE,this.t+=p.BLOCK_SIZE,w[0]=w[p.BLOCK_SIZE+0],w[1]=w[p.BLOCK_SIZE+1],w[2]=w[p.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,p.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=E.g,P=this.q;for(let o=0;o<64;o+=4)w.setUint32(o,P.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)w.setUint32(o,f(w.getUint32(o-12,!1)^w.getUint32(o-32,!1)^w.getUint32(o-56,!1)^w.getUint32(o-64,!1),1),!1);let $=this.h,c=this.l,h=this.m,i=this.n,n=this.o,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&h|~c&i,s=1518500249):o<40?(t=c^h^i,s=1859775393):o<60?(t=c&h|c&i|h&i,s=2400959708):(t=c^h^i,s=3395469782),r=f($,5)+t+n+s+w.getUint32(o*4,!1)&4294967295,n=i,i=h,h=f(c,30),c=$,$=r;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$Aj=E}),define(ue[93],de([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=Oe(R);var a;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(a||(a={})),function(N){const A="error",T="warning",k="warn",O="info",y="ignore";function I(f){return f?R.$Gf(A,f)?N.Error:R.$Gf(T,f)||R.$Gf(k,f)?N.Warning:R.$Gf(O,f)?N.Info:N.Ignore:N.Ignore}N.fromValue=I;function p(f){switch(f){case N.Error:return A;case N.Warning:return T;case N.Info:return O;default:return y}}N.toString=p}(a||(a={})),e.default=a}),define(ue[51],de([0,1,17,39,26]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return g-E}value(){return this.b[this.c]}}e.$Ii=A;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Af)(l,this.b,0,l.length,this.c,this.d):(0,N.$Cf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=T;class k{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const E=this.b.charCodeAt(g);if(!(E===a.CharCode.Slash||this.f&&E===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===a.CharCode.Slash||this.f&&g===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Af)(l,this.b,0,l.length,this.d,this.e):(0,N.$Cf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=k;var O;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(O||(O={}));class y{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(O.Scheme),this.c.authority&&this.d.push(O.Authority),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(O.Path)),this.g(l)||(this.c.query&&this.d.push(O.Query),this.c.fragment&&this.d.push(O.Fragment)),this.e=0,this}next(){return this.d[this.e]===O.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===O.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===O.Scheme)return(0,N.$Bf)(l,this.c.scheme);if(this.d[this.e]===O.Authority)return(0,N.$Bf)(l,this.c.authority);if(this.d[this.e]===O.Path)return this.b.cmp(l);if(this.d[this.e]===O.Query)return(0,N.$zf)(l,this.c.query);if(this.d[this.e]===O.Fragment)return(0,N.$zf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===O.Scheme)return this.c.scheme;if(this.d[this.e]===O.Authority)return this.c.authority;if(this.d[this.e]===O.Path)return this.b.value();if(this.d[this.e]===O.Query)return this.c.query;if(this.d[this.e]===O.Fragment)return this.c.fragment;throw new Error}}e.$Li=y;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(p||(p={}));class f{static forUris(l=()=>!1,g=()=>!1){return new f(new y(l,g))}static forPaths(l=!1){return new f(new k(void 0,!l))}static forStrings(){return new f(new A)}static forConfigKeys(){return new f(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const E=g.slice(0);(0,R.$Wb)(E);for(const m of E)this.set(m,l)}else{const E=l.slice(0);(0,R.$Wb)(E);for(const m of E)this.set(m[0],m[1])}}set(l,g){const E=this.b.reset(l);let m;this.c||(this.c=new I,this.c.segment=E.value());const w=[];for(m=this.c;;){const $=E.cmp(m.segment);if($>0)m.left||(m.left=new I,m.left.segment=E.value()),w.push([p.Left,m]),m=m.left;else if($<0)m.right||(m.right=new I,m.right.segment=E.value()),w.push([p.Right,m]),m=m.right;else if(E.hasNext())E.next(),m.mid||(m.mid=new I,m.mid.segment=E.value()),w.push([p.Mid,m]),m=m.mid;else break}const P=m.value;m.value=g,m.key=l;for(let $=w.length-1;$>=0;$--){const c=w[$][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=w[$][0],n=w[$+1][0];if(i===p.Right&&n===p.Right)w[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Left)w[$][1]=c.rotateRight();else if(i===p.Right&&n===p.Left)c.right=w[$+1][1]=w[$+1][1].rotateRight(),w[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Right)c.left=w[$+1][1]=w[$+1][1].rotateLeft(),w[$][1]=c.rotateRight();else throw new Error;if($>0)switch(w[$-1][0]){case p.Left:w[$-1][1].left=w[$][1];break;case p.Right:w[$-1][1].right=w[$][1];break;case p.Mid:w[$-1][1].mid=w[$][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let E=this.c;for(;E;){const m=g.cmp(E.segment);if(m>0)E=E.left;else if(m<0)E=E.right;else if(g.hasNext())g.next(),E=E.mid;else break}return E}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const E=this.b.reset(l),m=[];let w=this.c;for(;w;){const P=E.cmp(w.segment);if(P>0)m.push([p.Left,w]),w=w.left;else if(P<0)m.push([p.Right,w]),w=w.right;else if(E.hasNext())E.next(),m.push([p.Mid,w]),w=w.mid;else break}if(w){if(g?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:$,value:c,segment:h}=P;this.e(P.key,!1),w.key=$,w.value=c,w.segment=h}}else{const P=w.left??w.right;if(m.length>0){const[$,c]=m[m.length-1];switch($){case p.Left:c.left=P;break;case p.Mid:c.mid=P;break;case p.Right:c.right=P;break}}else this.c=P}for(let P=m.length-1;P>=0;P--){const $=m[P][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),m[P][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),m[P][1]=$.rotateRight()),P>0)switch(m[P-1][0]){case p.Left:m[P-1][1].left=m[P][1];break;case p.Right:m[P-1][1].right=m[P][1];break;case p.Mid:m[P-1][1].mid=m[P][1];break}else this.c=m[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let E=this.c,m;for(;E;){const w=g.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(g.hasNext())g.next(),m=E.value||m,E=E.mid;else break}return E&&E.value||m}findSuperstr(l){return this.g(l,!1)}g(l,g){const E=this.b.reset(l);let m=this.c;for(;m;){const w=E.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(E.hasNext())E.next(),m=m.mid;else return m.mid?this.h(m.mid):g?m.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,E]of this)l(E,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const E=g.balanceFactor();return E<-1||E>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Mi=f}),define(ue[9],de([0,1,39,65,13,5]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=E,e.$xc=h,N=Oe(N);const T=/^\w[\w\d+.-]*$/,k=/^\//,O=/^\/\//;function y(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(r,o){return!r&&!o?"file":r}function p(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==d&&(o=d+o):o=d;break}return o}const f="",d="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,b,L,S,v=!1){typeof o=="object"?(this.scheme=o.scheme||f,this.authority=o.authority||f,this.path=o.path||f,this.query=o.query||f,this.fragment=o.fragment||f):(this.scheme=I(o,v),this.authority=u||f,this.path=p(this.scheme,b||f),this.query=L||f,this.fragment=S||f,y(this,v))}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:b,path:L,query:S,fragment:v}=o;return u===void 0?u=this.scheme:u===null&&(u=f),b===void 0?b=this.authority:b===null&&(b=f),L===void 0?L=this.path:L===null&&(L=f),S===void 0?S=this.query:S===null&&(S=f),v===void 0?v=this.fragment:v===null&&(v=f),u===this.scheme&&b===this.authority&&L===this.path&&S===this.query&&v===this.fragment?this:new w(u,b,L,S,v)}static parse(o,u=!1){const b=l.exec(o);return b?new w(b[2]||f,s(b[4]||f),s(b[5]||f),s(b[7]||f),s(b[9]||f),u):new w(f,f,f,f,f)}static file(o){let u=f;if(A.$j&&(o=o.replace(/\\/g,d)),o[0]===d&&o[1]===d){const b=o.indexOf(d,2);b===-1?(u=o.substring(2),o=d):(u=o.substring(2,b),o=o.substring(b)||d)}return new w("file",u,o,f,f)}static from(o,u){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return A.$j&&o.scheme==="file"?b=g.file(N.$gc.join(h(o,!0),...u)).path:b=N.$hc.join(o.path,...u),o.with({path:b})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new w(o);return u._formatted=o.external??null,u._fsPath=o._sep===m?o.fsPath??null:null,u}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const m=A.$j?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=m),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function $(r,o,u){let b,L=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=R.CharCode.a&&v<=R.CharCode.z||v>=R.CharCode.A&&v<=R.CharCode.Z||v>=R.CharCode.Digit0&&v<=R.CharCode.Digit9||v===R.CharCode.Dash||v===R.CharCode.Period||v===R.CharCode.Underline||v===R.CharCode.Tilde||o&&v===R.CharCode.Slash||u&&v===R.CharCode.OpenSquareBracket||u&&v===R.CharCode.CloseSquareBracket||u&&v===R.CharCode.Colon)L!==-1&&(b+=encodeURIComponent(r.substring(L,S)),L=-1),b!==void 0&&(b+=r.charAt(S));else{b===void 0&&(b=r.substr(0,S));const C=P[v];C!==void 0?(L!==-1&&(b+=encodeURIComponent(r.substring(L,S)),L=-1),b+=C):L===-1&&(L=S)}}return L!==-1&&(b+=encodeURIComponent(r.substring(L))),b!==void 0?b:r}function c(r){let o;for(let u=0;u<r.length;u++){const b=r.charCodeAt(u);b===R.CharCode.Hash||b===R.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,u)),o+=P[b]):o!==void 0&&(o+=r[u])}return o!==void 0?o:r}function h(r,o){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===R.CharCode.Slash&&(r.path.charCodeAt(1)>=R.CharCode.A&&r.path.charCodeAt(1)<=R.CharCode.Z||r.path.charCodeAt(1)>=R.CharCode.a&&r.path.charCodeAt(1)<=R.CharCode.z)&&r.path.charCodeAt(2)===R.CharCode.Colon?o?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,A.$j&&(u=u.replace(/\//g,"\\")),u}function i(r,o){const u=o?c:$;let b="",{scheme:L,authority:S,path:v,query:C,fragment:U}=r;if(L&&(b+=L,b+=":"),(S||L==="file")&&(b+=d,b+=d),S){let F=S.indexOf("@");if(F!==-1){const j=S.substr(0,F);S=S.substr(F+1),F=j.lastIndexOf(":"),F===-1?b+=u(j,!1,!1):(b+=u(j.substr(0,F),!1,!1),b+=":",b+=u(j.substr(F+1),!1,!0)),b+="@"}S=S.toLowerCase(),F=S.lastIndexOf(":"),F===-1?b+=u(S,!1,!0):(b+=u(S.substr(0,F),!1,!0),b+=S.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===R.CharCode.Slash&&v.charCodeAt(2)===R.CharCode.Colon){const F=v.charCodeAt(1);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===R.CharCode.Colon){const F=v.charCodeAt(0);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}b+=u(v,!0,!1)}return C&&(b+="?",b+=u(C,!1,!1)),U&&(b+="#",b+=o?U:$(U,!1,!1)),b}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(ue[140],de([0,1,9]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=a,e.$hr=N,e.$ir=A,e.log=k;function a(y){const I=y;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function N(y){const I=[];let p;try{const f=JSON.parse(y.arguments),d=f[f.length-1];d&&d.__$stack&&(f.pop(),p=d.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",y.arguments)}return{args:I,stack:p}}function A(y){if(typeof y!="string")return A(N(y).stack);const I=y;if(I){const p=T(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(f&&f.length===4)return{uri:R.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function T(y){if(!y)return y;const I=y.indexOf(`
`);return I===-1?y:y.substring(0,I)}function k(y,I){const{args:p,stack:f}=N(y),d=typeof p[0]=="string"&&p.length===1;let l=T(f);l&&(l=`(${l.trim()})`);let g=[];if(typeof p[0]=="string"?l&&d?g=[`%c[${I}] %c${p[0]} %c${l}`,O("blue"),O(""),O("grey")]:g=[`%c[${I}] %c${p[0]}`,O("blue"),O(""),...p.slice(1)]:g=[`%c[${I}]%`,O("blue"),...p],l&&!d&&g.push(l),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}function O(y){return`color: ${y}`}}),define(ue[66],de([0,1,14,9,65]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=A,e.$ci=T,e.$di=O;function A(y){return JSON.stringify(y,k)}function T(y){let I=JSON.parse(y);return I=O(I),I}function k(y,I){return I instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function O(y,I=0){if(!y||I>200)return y;if(typeof y=="object"){switch(y.$mid){case N.MarshalledId.Uri:return a.URI.revive(y);case N.MarshalledId.Regexp:return new RegExp(y.source,y.flags);case N.MarshalledId.Date:return new Date(y.source)}if(y instanceof R.$Oe||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let p=0;p<y.length;++p)y[p]=O(y[p],I+1);else for(const p in y)Object.hasOwnProperty.call(y,p)&&(y[p]=O(y[p],I+1))}return y}}),define(ue[22],de([0,1,8,5,26,9,13]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=O,e.$Qg=y,e.$Ug=p,R=Oe(R),a=Oe(a),T=Oe(T);var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(k||(e.Schemas=k={}));function O(l,g){return A.URI.isUri(l)?(0,N.$Gf)(l.scheme,g):(0,N.$Hf)(l,g+":")}function y(l,...g){return g.some(E=>O(l,E))}e.$Rg="vscode-tkn",e.$Sg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,E){this.f=p(g,E)}getServerRootPath(){return this.f}get g(){return T.$hc.join(this.f,k.vscodeRemoteResource)}set(g,E,m){this.a[g]=E,this.b[g]=m}setConnectionToken(g,E){this.c[g]=E}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(c){return R.$Z(c),g}const E=g.authority;let m=this.a[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const w=this.b[E],P=this.c[E];let $=`path=${encodeURIComponent(g.path)}`;return typeof P=="string"&&($+=`&${e.$Sg}=${encodeURIComponent(P)}`),A.URI.from({scheme:a.$p?this.d:k.vscodeRemoteResource,authority:`${m}:${w}`,path:this.g,query:$})}}e.$Tg=new I;function p(l,g){return T.$hc.join(g??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class f{static{this.a=e.$Zg}asBrowserUri(g){const E=this.b(g,ce);return this.uriToBrowserUri(E)}uriToBrowserUri(g){return g.scheme===k.vscodeRemote?e.$Tg.rewrite(g):g.scheme===k.file&&(a.$n||a.$r===`${k.vscodeFileResource}://${f.a}`)?g.with({scheme:k.vscodeFileResource,authority:g.authority||f.a,query:null,fragment:null}):g}asFileUri(g){const E=this.b(g,ce);return this.uriToFileUri(E)}uriToFileUri(g){return g.scheme===k.vscodeFileResource?g.with({scheme:k.file,authority:g.authority!==f.a?g.authority:null,query:null,fragment:null}):g}b(g,E){return A.URI.isUri(g)?g:A.URI.parse(E.toUrl(g))}}e.$1g=new f;var d;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const E="vscode-coi";function m(P){let $;typeof P=="string"?$=new URL(P).searchParams:P instanceof URL?$=P.searchParams:A.URI.isUri(P)&&($=new URL(P.toString(!0)).searchParams);const c=$?.get(E);if(c)return g.get(c)}l.getHeadersFromQuery=m;function w(P,$,c){if(!globalThis.crossOriginIsolated)return;const h=$&&c?"3":c?"2":"1";P instanceof URLSearchParams?P.set(E,h):P[E]=h}l.addSearchParam=w})(d||(e.COI=d={}))}),define(ue[67],de([0,1,129,22,5,12,9]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=p,e.$vq=f,N=Oe(N);class k{constructor(l,g,E){this.id=l,this.dependencies=g,this.callback=E}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,g,E)=>{typeof l!="string"&&(E=g,g=l,l=null),(typeof g!="object"||!Array.isArray(g))&&(E=g,g=null),this.c.push(new k(l,g,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const g=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!g)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(g.dependencies)&&g.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${g.dependencies.join(", ")}`);return typeof g.callback=="function"?g.callback([]):g.callback}h(l){return new Promise((g,E)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const w=()=>{m.removeEventListener("load",P),m.removeEventListener("error",$)},P=c=>{w(),g(this.c.pop())},$=c=>{w(),E(c)};m.addEventListener("load",P),m.addEventListener("error",$),this.f&&(l=this.f.createScriptURL(l)),m.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(m)})}async i(l){return this.f&&(l=this.f.createScriptURL(l)),R.$R?await new Promise((g,E)=>{ce([l],g,E)}).then(Oe):importScripts(l),this.c.pop()}async j(l){try{const g=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,w=T.URI.parse(l).fsPath,P=g.readFileSync(w).toString(),$=m.wrap(P.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(g){throw g}}}const y=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function p(d,l,g){if(R.$R){g===void 0&&(g=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[d]&&(d=I[d]);const E=l?`${d}/${l}`:d;if(y.has(E))return y.get(E);let m;if(/^\w[\w\d+.-]*:\/\//.test(E))m=E;else{const c=`${R.$S&&g&&!N.$p?a.$Xg:a.$Wg}/${E}`;m=a.$1g.asBrowserUri(c).toString(!0)}const w=O.INSTANCE.load(m);return y.set(E,w),w}else return await new Promise((E,m)=>{ce([d],E,m)}).then(Oe)}function f(d,l){(0,A.$pg)(R.$R);const E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,m=R.$S&&E&&!N.$p,w=`${d}/${l}`,$=`${m?a.$Xg:a.$Wg}/${w}`;return a.$1g.asBrowserUri($).toString(!0)}}),define(ue[20],de([0,1,39,41,22,13,5,26,9]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=y,e.$qh=p,e.$rh=d,a=Oe(a),A=Oe(A);function y(l){return(0,O.$xc)(l,!0)}class I{constructor(g){this.a=g}compare(g,E,m=!1){return g===E?0:(0,k.$zf)(this.getComparisonKey(g,m),this.getComparisonKey(E,m))}isEqual(g,E,m=!1){return g===E?!0:!g||!E?!1:this.getComparisonKey(g,m)===this.getComparisonKey(E,m)}getComparisonKey(g,E=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,E,m=!1){if(g.scheme===E.scheme){if(g.scheme===N.Schemas.file)return a.$Fg(y(g),y(E),this.a(g))&&g.query===E.query&&(m||g.fragment===E.fragment);if((0,e.$mh)(g.authority,E.authority))return a.$Fg(g.path,E.path,this.a(g),"/")&&g.query===E.query&&(m||g.fragment===E.fragment)}return!1}joinPath(g,...E){return O.URI.joinPath(g,...E)}basenameOrAuthority(g){return(0,e.$eh)(g)||g.authority}basename(g){return A.$hc.basename(g.path)}extname(g){return A.$hc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let E;return g.scheme===N.Schemas.file?E=O.URI.file(A.$nc(y(g))).path:(E=A.$hc.dirname(g.path),g.authority&&E.length&&E.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),E="/")),g.with({path:E})}normalizePath(g){if(!g.path.length)return g;let E;return g.scheme===N.Schemas.file?E=O.URI.file(A.$ic(y(g))).path:E=A.$hc.normalize(g.path),g.with({path:E})}relativePath(g,E){if(g.scheme!==E.scheme||!(0,e.$mh)(g.authority,E.authority))return;if(g.scheme===N.Schemas.file){const P=A.$mc(y(g),y(E));return T.$j?a.$zg(P):P}let m=g.path||"/";const w=E.path||"/";if(this.a(g)){let P=0;for(const $=Math.min(m.length,w.length);P<$&&!(m.charCodeAt(P)!==w.charCodeAt(P)&&m.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);m=w.substr(0,P)+m.substr(P)}return A.$hc.relative(m,w)}resolvePath(g,E){if(g.scheme===N.Schemas.file){const m=O.URI.file(A.$lc(y(g),E));return g.with({authority:m.authority,path:m.path})}return E=a.$Ag(E),g.with({path:A.$hc.resolve(g.path,E)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,E){return g===E||g!==void 0&&E!==void 0&&(0,k.$Gf)(g,E)}hasTrailingPathSeparator(g,E=A.sep){if(g.scheme===N.Schemas.file){const m=y(g);return m.length>a.$Bg(m).length&&m[m.length-1]===E}else{const m=g.path;return m.length>1&&m.charCodeAt(m.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,E=A.sep){return(0,e.$nh)(g,E)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,E=A.sep){let m=!1;if(g.scheme===N.Schemas.file){const w=y(g);m=w!==void 0&&w.length===a.$Bg(w).length&&w[w.length-1]===E}else{E="/";const w=g.path;m=w.length===1&&w.charCodeAt(w.length-1)===R.CharCode.Slash}return!m&&!(0,e.$nh)(g,E)?g.with({path:g.path+"/"}):g}}e.$9g=I,e.$0g=new I(()=>!1),e.$$g=new I(l=>l.scheme===N.Schemas.file?!T.$l:!0),e.$_g=new I(l=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function p(l,g){const E=[];for(let m=0;m<l.length;m++){const w=g(l[m]);l.some((P,$)=>$===m?!1:(0,e.$bh)(w,g(P)))||E.push(l[m])}return E}var f;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(E){const m=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach($=>{const[c,h]=$.split(":");c&&h&&m.set(c,h)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&m.set(l.META_DATA_MIME,P),m}l.parseMetaData=g})(f||(e.DataUri=f={}));function d(l,g,E){if(g){let m=l.path;return m&&m[0]!==A.$hc.sep&&(m=A.$hc.sep+m),l.with({scheme:E,authority:g,path:m})}return l.with({scheme:E})}}),define(ue[6],de([0,1,25,8,3,2,20,5,138,53]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=I,e.$th=p,e.$uh=f,e.$vh=d,e.$wh=l,e.$xh=g,e.$yh=E,e.$zh=m,e.$Hh=r,e.$Ih=o,e.$Jh=u,e.$Kh=b,e.$Lh=L,e.$1h=V,e.$9h=Y;function I(M){return!!M&&typeof M.then=="function"}function p(M){const z=new R.$xe,ie=M(z.token),ae=new Promise((he,pe)=>{const be=z.token.onCancellationRequested(()=>{be.dispose(),pe(new a.$5)});Promise.resolve(ie).then(Pe=>{be.dispose(),z.dispose(),he(Pe)},Pe=>{be.dispose(),z.dispose(),pe(Pe)})});return new class{cancel(){z.cancel(),z.dispose()}then(he,pe){return ae.then(he,pe)}catch(he){return this.then(void 0,he)}finally(he){return ae.finally(he)}}}function f(M,z,ie){return new Promise((ae,he)=>{const pe=z.onCancellationRequested(()=>{pe.dispose(),ae(ie)});M.then(ae,he).finally(()=>pe.dispose())})}function d(M,z){return new Promise((ie,ae)=>{const he=z.onCancellationRequested(()=>{he.dispose(),ae(new a.$5)});M.then(ie,ae).finally(()=>he.dispose())})}async function l(M){let z=-1;const ie=M.map((ae,he)=>ae.then(pe=>(z=he,pe)));try{return await Promise.race(ie)}finally{M.forEach((ae,he)=>{he!==z&&ae.cancel()})}}function g(M,z,ie){let ae;const he=setTimeout(()=>{ae?.(void 0),ie?.()},z);return Promise.race([M.finally(()=>clearTimeout(he)),new Promise(pe=>ae=pe)])}function E(M){return new Promise((z,ie)=>{const ae=M();I(ae)?ae.then(z,ie):z(ae)})}function m(){let M,z;return{promise:new Promise((ae,he)=>{M=ae,z=he}),resolve:M,reject:z}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(ie,ie).then(ae)})}return new Promise((ie,ae)=>{this.b.then(ie,ae)})}return this.a=z(),new Promise((ie,ae)=>{this.a.then(he=>{this.a=null,ie(he)},he=>{this.a=null,ae(he)})})}dispose(){this.f=!0}}e.$Ah=w;class P{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$Bh=P;class ${constructor(){this.a=new Map}queue(z,ie){const he=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(z)===he&&this.a.delete(z)});return this.a.set(z,he),he}}e.$Ch=$;const c=(M,z)=>{let ie=!0;const ae=setTimeout(()=>{ie=!1,z()},M);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ae),ie=!1}}},h=M=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,M())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class i{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ie=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((he,pe)=>{this.d=he,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=ie===O.$he?h(ae):c(ie,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class n{constructor(z){this.a=new i(z),this.b=new w}trigger(z,ie){return this.a.trigger(()=>this.b.queue(z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=n;class t{constructor(){this.a=!1,this.b=new Promise((z,ie)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=t;class s extends t{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$Gh=s;function r(M,z){return z?new Promise((ie,ae)=>{const he=setTimeout(()=>{pe.dispose(),ie()},M),pe=z.onCancellationRequested(()=>{clearTimeout(he),pe.dispose(),ae(new a.$5)})}):p(ie=>r(M,ie))}function o(M,z=0,ie){const ae=setTimeout(()=>{M(),ie&&he.dispose()},z),he=(0,A.$Tc)(()=>{clearTimeout(ae),ie?.deleteAndLeak(he)});return ie?.add(he),he}function u(M){const z=[];let ie=0;const ae=M.length;function he(){return ie<ae?M[ie++]():null}function pe(be){be!=null&&z.push(be);const Pe=he();return Pe?Pe.then(pe):Promise.resolve(z)}return Promise.resolve(null).then(pe)}function b(M,z=ae=>!!ae,ie=null){let ae=0;const he=M.length,pe=()=>{if(ae>=he)return Promise.resolve(ie);const be=M[ae++];return Promise.resolve(be()).then(ve=>z(ve)?Promise.resolve(ve):pe())};return pe()}function L(M,z=ae=>!!ae,ie=null){if(M.length===0)return Promise.resolve(ie);let ae=M.length;const he=()=>{ae=-1;for(const pe of M)pe.cancel?.()};return new Promise((pe,be)=>{for(const Pe of M)Pe.then(ve=>{--ae>=0&&z(ve)?(he(),pe(ve)):ae===0&&pe(ie)}).catch(ve=>{--ae>=0&&(he(),be(ve))})})}class S{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new N.$me}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ae)=>{this.g.push({factory:z,c:ie,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ie=z.factory();ie.then(z.c,z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=S;class v extends S{constructor(){super(1)}}e.$Nh=v;class C{constructor(){this.a=new _,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$Oh=C;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new ee;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ie=T.$0g){const ae=ie.getComparisonKey(z);return this.a.get(ae)?.size??0}queueFor(z,ie,ae=T.$0g){const he=ae.getComparisonKey(z);let pe=this.a.get(he);if(!pe){pe=new v;const be=this.f++,Pe=N.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$5c),this.d.set(be,Pe),this.a.set(he,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=U;class F{constructor(z,ie){this.b=!1,this.a=-1,typeof z=="function"&&typeof ie=="number"&&this.setIfNotSet(z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ie){if(this.b)throw new a.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ie)}setIfNotSet(z,ie){if(this.b)throw new a.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ie))}}e.$Qh=F;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ie,ae=globalThis){if(this.f)throw new a.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const he=ae.setInterval(()=>{z()},ie);this.d=(0,A.$Tc)(()=>{ae.clearInterval(he),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=j;class H{constructor(z,ie){this.b=-1,this.a=z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=H;class W{constructor(z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=W;class x extends H{constructor(z,ie){super(z,ie),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Uh=x;class G extends A.$Vc{constructor(z,ie){super(),this.g=z,this.h=ie,this.a=[],this.b=this.B(new A.$Wc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(M,z)=>{(0,k.$C)(()=>{if(ie)return;const ae=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Xh=(M,z,ie)=>{const ae=M.requestIdleCallback(z,typeof ie=="number"?{timeout:ie}:void 0);let he=!1;return{dispose(){he||(he=!0,M.cancelIdleCallback(ae))}}},e.$Wh=M=>(0,e.$Xh)(globalThis,M)}();class te{constructor(z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$Xh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=te;class B extends te{constructor(z){super(globalThis,z)}}e.$Zh=B;async function V(M,z,ie){let ae;for(let he=0;he<ie;he++)try{return await M()}catch(pe){ae=pe,await r(z)}throw ae}class _{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ie,ae){return this.a={taskId:z,cancel:()=>ae?.(),promise:ie},ie.then(()=>this.d(z),()=>this.d(z)),ie}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ie,resolve:ae,reject:he}=m();this.b={run:z,promise:ie,promiseResolve:ae,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=_;class ne{constructor(z,ie=()=>Date.now()){this.d=z,this.f=ie,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$3h=ne;var le;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((z,ie)=>{this.a=z,this.b=ie})}complete(z){return new Promise(ie=>{this.a(z),this.d={outcome:le.Resolved,value:z},ie()})}error(z){return new Promise(ie=>{this.b(z),this.d={outcome:le.Rejected,value:z},ie()})}cancel(){return this.error(new a.$5)}}e.$4h=ee;var X;(function(M){async function z(ae){let he;const pe=await Promise.all(ae.map(be=>be.then(Pe=>Pe,Pe=>{he||(he=Pe)})));if(typeof he<"u")throw he;return pe}M.settled=z;function ie(ae){return new Promise(async(he,pe)=>{try{await ae(he,pe)}catch(be){pe(be)}})}M.withAsyncBody=ie})(X||(e.Promises=X={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new a.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=K;class q{constructor(z){this.b=z,this.a=new y.$U(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=q;var D;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(z){return new J(ie=>{ie.emitMany(z)})}static fromPromise(z){return new J(async ie=>{ie.emitMany(await z)})}static fromPromises(z){return new J(async ie=>{await Promise.all(z.map(async ae=>ie.emitOne(await ae)))})}static merge(z){return new J(async ie=>{await Promise.all(z.map(async ae=>{for await(const he of ae)ie.emitOne(he)}))})}static{this.EMPTY=J.fromArray([])}constructor(z,ie){this.a=D.Initial,this.b=[],this.d=null,this.f=ie,this.g=new N.$me,queueMicrotask(async()=>{const ae={emitOne:he=>this.h(he),emitMany:he=>this.j(he),reject:he=>this.l(he)};try{await Promise.resolve(z(ae)),this.k()}catch(he){this.l(he)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(z,ie){return new J(async ae=>{for await(const he of z)ae.emitOne(ie(he))})}map(z){return J.map(this,z)}static filter(z,ie){return new J(async ae=>{for await(const he of z)ie(he)&&ae.emitOne(he)})}filter(z){return J.filter(this,z)}static coalesce(z){return J.filter(z,ie=>!!ie)}coalesce(){return J.coalesce(this)}static async toPromise(z){const ie=[];for await(const ae of z)ie.push(ae);return ie}toPromise(){return J.toPromise(this)}h(z){this.a===D.Initial&&(this.b.push(z),this.g.fire())}j(z){this.a===D.Initial&&(this.b=this.b.concat(z),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(z){this.a===D.Initial&&(this.a=D.DoneError,this.d=z,this.g.fire())}}e.$7h=J;class oe extends J{constructor(z,ie){super(ie),this.m=z}cancel(){this.m.cancel()}}e.$8h=oe;function Y(M){const z=new R.$xe,ie=M(z.token);return new oe(z,async ae=>{const he=z.token.onCancellationRequested(()=>{he.dispose(),z.dispose(),ae.reject(new a.$5)});try{for await(const pe of ie){if(z.token.isCancellationRequested)return;ae.emitOne(pe)}he.dispose(),z.dispose()}catch(pe){he.dispose(),z.dispose(),ae.reject(pe)}})}class Z{constructor(z){this.a=new ee,this.b=new J(he=>{if(ie){he.reject(ie);return}return ae&&he.emitMany(ae),this.d=pe=>he.reject(pe),this.f=pe=>he.emitOne(pe),this.a.p},z);let ie,ae;this.f=he=>{ae||(ae=[]),ae.push(he)},this.d=he=>{ie||(ie=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$0h=Z}),define(ue[94],de([0,1,17,6,39,41,31,13,5,26]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=void 0,e.$wk=I,e.$zk=g,e.$Ak=C,e.$Bk=U,e.$Ck=F,e.$Dk=j,e.$Ek=H,e.$Fk=te;function I(){return Object.create(null)}e.$xk="**",e.$yk="/";const p="[/\\\\]",f="[^/\\\\]",d=/\//g;function l(B,V){switch(B){case 0:return"";case 1:return`${f}*?`;default:return`(?:${p}|${f}+${p}${V?`|${p}${f}+`:""})*?`}}function g(B,V){if(!B)return[];const _=[];let ne=!1,le=!1,ee="";for(const X of B){switch(X){case V:if(!ne&&!le){_.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=X}return ee&&_.push(ee),_}function E(B){if(!B)return"";let V="";const _=g(B,e.$yk);if(_.every(ne=>ne===e.$xk))V=".*";else{let ne=!1;_.forEach((le,ee)=>{if(le===e.$xk){if(ne)return;V+=l(2,ee===_.length-1)}else{let X=!1,K="",q=!1,D="";for(const J of le){if(J!=="}"&&X){K+=J;continue}if(q&&(J!=="]"||!D)){let oe;J==="-"?oe=J:(J==="^"||J==="!")&&!D?oe="^":J===e.$yk?oe="":oe=(0,y.$if)(J),D+=oe;continue}switch(J){case"{":X=!0;continue;case"[":q=!0;continue;case"}":{const Y=`(?:${g(K,",").map(Z=>E(Z)).join("|")})`;V+=Y,X=!1,K="";break}case"]":{V+="["+D+"]",q=!1,D="";break}case"?":V+=f;continue;case"*":V+=l(1);continue;default:V+=(0,y.$if)(J)}}ee<_.length-1&&(_[ee+1]!==e.$xk||ee+2<_.length)&&(V+=p)}ne=le===e.$xk})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Ec(1e4),n=function(){return!1},t=function(){return null};function s(B,V){if(!B)return t;let _;typeof B!="string"?_=B.pattern:_=B,_=_.trim();const ne=`${_}_${!!V.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,B);let ee;return m.test(_)?le=u(_.substr(4),_):(ee=w.exec(o(_,V)))?le=b(ee[1],_):(V.trimForExclusions?$:P).test(_)?le=L(_,V):(ee=c.exec(o(_,V)))?le=S(ee[1].substr(1),_,!0):(ee=h.exec(o(_,V)))?le=S(ee[1],_,!1):le=v(_),i.set(ne,le),r(le,B)}function r(B,V){if(typeof V=="string")return B;const _=function(ne,le){return(0,A.$Fg)(ne,V.base,!O.$l)?B((0,y.$nf)(ne.substr(V.base.length),k.sep),le):null};return _.allBasenames=B.allBasenames,_.allPaths=B.allPaths,_.basenames=B.basenames,_.patterns=B.patterns,_}function o(B,V){return V.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function u(B,V){return function(_,ne){return typeof _=="string"&&_.endsWith(B)?V:null}}function b(B,V){const _=`/${B}`,ne=`\\${B}`,le=function(X,K){return typeof X!="string"?null:K?K===B?V:null:X===B||X.endsWith(_)||X.endsWith(ne)?V:null},ee=[B];return le.basenames=ee,le.patterns=[V],le.allBasenames=ee,le}function L(B,V){const _=G(B.slice(1,-1).split(",").map(K=>s(K,V)).filter(K=>K!==t),B),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const le=function(K,q){for(let D=0,J=_.length;D<J;D++)if(_[D](K,q))return B;return null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function S(B,V,_){const ne=k.sep===k.$hc.sep,le=ne?B:B.replace(d,k.sep),ee=k.sep+le,X=k.$hc.sep+B;let K;return _?K=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(ee)||!ne&&(q===B||q.endsWith(X)))?V:null}:K=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===B)?V:null},K.allPaths=[(_?"*/":"./")+B],K}function v(B){try{const V=new RegExp(`^${E(B)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?B:null}}catch{return t}}function C(B,V,_){return!B||typeof V!="string"?!1:U(B)(V,void 0,_)}function U(B,V={}){if(!B)return n;if(typeof B=="string"||F(B)){const _=s(B,V);if(_===t)return n;const ne=function(le,ee){return!!_(le,ee)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return W(B,V)}function F(B){const V=B;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function j(B){return B.allBasenames||[]}function H(B){return B.allPaths||[]}function W(B,V){const _=G(Object.getOwnPropertyNames(B).map(K=>x(K,B[K],V)).filter(K=>K!==t)),ne=_.length;if(!ne)return t;if(!_.some(K=>!!K.requiresSiblings)){if(ne===1)return _[0];const K=function(J,oe){let Y;for(let Z=0,M=_.length;Z<M;Z++){const z=_[Z](J,oe);if(typeof z=="string")return z;(0,a.$sh)(z)&&(Y||(Y=[]),Y.push(z))}return Y?(async()=>{for(const Z of Y){const M=await Z;if(typeof M=="string")return M}return null})():null},q=_.find(J=>!!J.allBasenames);q&&(K.allBasenames=q.allBasenames);const D=_.reduce((J,oe)=>oe.allPaths?J.concat(oe.allPaths):J,[]);return D.length&&(K.allPaths=D),K}const le=function(K,q,D){let J,oe;for(let Y=0,Z=_.length;Y<Z;Y++){const M=_[Y];M.requiresSiblings&&D&&(q||(q=(0,k.$oc)(K)),J||(J=q.substr(0,q.length-(0,k.$pc)(K).length)));const z=M(K,q,J,D);if(typeof z=="string")return z;(0,a.$sh)(z)&&(oe||(oe=[]),oe.push(z))}return oe?(async()=>{for(const Y of oe){const Z=await Y;if(typeof Z=="string")return Z}return null})():null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function x(B,V,_){if(V===!1)return t;const ne=s(B,_);if(ne===t)return t;if(typeof V=="boolean")return ne;if(V){const le=V.when;if(typeof le=="string"){const ee=(X,K,q,D)=>{if(!D||!ne(X,K))return null;const J=le.replace("$(basename)",()=>q),oe=D(J);return(0,a.$sh)(oe)?oe.then(Y=>Y?B:null):oe?B:null};return ee.requiresSiblings=!0,ee}}return ne}function G(B,V){const _=B.filter(K=>!!K.basenames);if(_.length<2)return B;const ne=_.reduce((K,q)=>{const D=q.basenames;return D?K.concat(D):K},[]);let le;if(V){le=[];for(let K=0,q=ne.length;K<q;K++)le.push(V)}else le=_.reduce((K,q)=>{const D=q.patterns;return D?K.concat(D):K},[]);const ee=function(K,q){if(typeof K!="string")return null;if(!q){let J;for(J=K.length;J>0;J--){const oe=K.charCodeAt(J-1);if(oe===N.CharCode.Slash||oe===N.CharCode.Backslash)break}q=K.substr(J)}const D=ne.indexOf(q);return D!==-1?le[D]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const X=B.filter(K=>!K.basenames);return X.push(ee),X}function te(B,V){return(0,R.$ub)(B,V,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(ue[95],de([0,1,14,65,9]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=O,e.$Qn=I,e.$Rn=p;function A(f){return f.toJSON()}class T{constructor(d){this.a=d}transformIncoming(d){const l=this.a.transformIncoming(d);return l===d?d:A(N.URI.from(l))}transformOutgoing(d){const l=this.a.transformOutgoing(d);return l===d?d:A(N.URI.from(l))}transformOutgoingURI(d){const l=this.a.transformOutgoing(d);return l===d?d:N.URI.from(l)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$Nn=T,e.$On=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function k(f,d,l){if(!f||l>200)return null;if(typeof f=="object"){if(f instanceof N.URI)return d.transformOutgoing(f);for(const g in f)if(Object.hasOwnProperty.call(f,g)){const E=k(f[g],d,l+1);E!==null&&(f[g]=E)}}return null}function O(f,d){const l=k(f,d,0);return l===null?f:l}function y(f,d,l,g){if(!f||g>200)return null;if(typeof f=="object"){if(f.$mid===a.MarshalledId.Uri)return l?N.URI.revive(d.transformIncoming(f)):d.transformIncoming(f);if(f instanceof R.$Oe)return null;for(const E in f)if(Object.hasOwnProperty.call(f,E)){const m=y(f[E],d,l,g+1);m!==null&&(f[E]=m)}}return null}function I(f,d){const l=y(f,d,!1,0);return l===null?f:l}function p(f,d){const l=y(f,d,!0,0);return l===null?f:l}}),define(ue[32],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=a;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(N){return R.test(N)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(k){for(let O=0;O<k.length;O++)k[O]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){N(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let O=0,y="";return y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y}}()}),define(ue[141],de([0,1,38]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=A;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const k=T.replace(/\-/g,":").toLowerCase();return!a.has(k)}function A(){const T=(0,R.networkInterfaces)();for(const k in T){const O=T[k];if(O){for(const{mac:y}of O)if(N(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ue[142],de([0,1,38,51,32,141,5]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0,e.$Un=O,e.$Vn=p,e.$Wn=f,N=Oe(N),e.$Tn=new class{c(d){return this.a||(this.a=a.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,l=0;const g=(0,R.networkInterfaces)();for(const E in g){const m=g[E];if(m)for(const{mac:w,internal:P}of m)P||(l+=1,this.c(w.toUpperCase())&&(d+=1))}this.b=l>0?d/l:0}return this.b}};let k;async function O(d){return k||(k=(async()=>await y(d)||N.$3g())()),k}async function y(d){try{const l=await new Promise((E,m)=>{ce(["crypto"],E,m)}).then(Oe),g=(0,A.$Sn)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){d(l);return}}const I="Software\\Microsoft\\SQMClient";async function p(d){if(T.$j){const l=await new Promise((g,E)=>{ce(["@vscode/windows-registry"],g,E)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(g){return d(g),""}}return""}async function f(d){try{return await(await new Promise((E,m)=>{ce(["@vscode/deviceid"],E,m)}).then(Oe)).getDeviceId()}catch(l){return d(l),""}}}),define(ue[143],de([0,1,241,14]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UX=void 0;class N extends R.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const k=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(T,k,O){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let y=0;for(;y<this.a.length;){const I=typeof this.b=="number"?this.a.indexOf(this.b,y):(0,a.$Pe)(this.a,this.b,y);if(I===-1)break;this.push(this.a.slice(y,I+this.c)),y=I+this.c}this.a=y===this.a.length?void 0:this.a.slice(y),O()}_flush(T){this.a&&this.push(this.a),T()}}e.$UX=N}),define(ue[144],de([0,1,33,13,37]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VX=y,e.$WX=I;const A="XDG_SESSION_TYPE",T="WAYLAND_DISPLAY",k="XDG_RUNTIME_DIR";var O;(function(p){p.Wayland="wayland",p.XWayland="xwayland",p.X11="x11",p.Unknown="unknown"})(O||(O={}));async function y(p){const f=N.env[A];if(f)return f===O.Wayland||f===O.X11?f:O.Unknown;if(N.env[T]){const l=N.env[k];if(l){const g=(0,a.$kc)(l,"wayland-0");try{return await R.promises.access(g,R.constants.R_OK),O.Wayland}catch(E){return p(E),O.Unknown}}else return O.Unknown}else return O.X11}function I(p,f){if(f)switch(f){case"auto":return p;case"x11":return p===O.Wayland?O.XWayland:O.X11;case"wayland":return O.Wayland;default:return O.Unknown}else return p===O.Wayland?O.XWayland:O.X11}}),define(ue[145],de([0,1,33,242,5]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=A,N=Oe(N);async function A(T){if(N.$k||N.$j)return;let k;for(const O of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{k=await R.promises.open(O,R.constants.R_OK);break}catch{}if(!k){T("Unable to retrieve release information from known identifier paths.");return}try{const O=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const I of(0,a.createInterface)({input:k.createReadStream(),crlfDelay:1/0})){if(!I.includes("="))continue;const p=I.split("=")[0].toUpperCase().trim();if(O.has(p)){const f=I.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?y.id=f:p==="ID_LIKE"?y.id_like=f:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(y.version_id=f)}}return y}catch(O){T(O)}}}),define(ue[30],de([0,1,33,38,243,6,41,91,13,5,20,9]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,R=Oe(R);var f;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function d(W,x=f.UNLINK,G){if((0,T.$Jg)(W))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?g(W):l(W,G)}async function l(W,x=(0,T.$Og)((0,a.tmpdir)())){try{try{await R.promises.rename(W,x)}catch(G){return G.code==="ENOENT"?void 0:g(W)}g(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(W){return R.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function E(W){if((0,T.$Jg)(W))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function m(W,x){return $(await(x?w(W):R.promises.readdir(W)))}async function w(W){try{return await R.promises.readdir(W,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const x=[],G=await m(W);for(const te of G){let B=!1,V=!1,_=!1;try{const ne=await R.promises.lstat((0,O.$kc)(W,te));B=ne.isFile(),V=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:te,isFile:()=>B,isDirectory:()=>V,isSymbolicLink:()=>_})}return x}function P(W){return $(R.readdirSync(W))}function $(W){return W.map(x=>typeof x=="string"?y.$k?(0,k.$om)(x):x:(x.name=y.$k?(0,k.$om)(x.name):x.name,x))}async function c(W){const x=await m(W),G=[];for(const te of x)await i.existsDirectory((0,O.$kc)(W,te))&&G.push(te);return G}function h(W,x=1e3){return new Promise(G=>{let te=!1;const B=setInterval(()=>{te||(te=!0,R.access(W,V=>{te=!1,V&&(clearInterval(B),G(void 0))}))},x)})}var i;(function(W){async function x(B){let V;try{if(V=await R.promises.lstat(B),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await R.promises.stat(B),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(y.$j&&_.code==="EACCES")try{return{stat:await R.promises.stat(await R.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ne}throw _}}W.stat=x;async function G(B){try{const{stat:V,symbolicLink:_}=await W.stat(B);return V.isFile()&&_?.dangling!==!0}catch{}return!1}W.existsFile=G;async function te(B){try{const{stat:V,symbolicLink:_}=await W.stat(B);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}W.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new A.$Ph;function t(W,x,G){return n.queueFor(p.URI.file(W),()=>{const te=b(G);return new Promise((B,V)=>o(W,x,te,_=>_?V(_):B()))},I.$$g)}let s=!0;function r(W){s=W}function o(W,x,G,te){if(!s)return R.writeFile(W,x,{mode:G.mode,flag:G.flag},te);R.open(W,G.flag,G.mode,(B,V)=>{if(B)return te(B);R.writeFile(V,x,_=>{if(_)return R.close(V,()=>te(_));R.fdatasync(V,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),R.close(V,le=>te(le))))})})}function u(W,x,G){const te=b(G);if(!s)return R.writeFileSync(W,x,{mode:te.mode,flag:te.flag});const B=R.openSync(W,te.flag,te.mode);try{R.writeFileSync(B,x);try{R.fdatasyncSync(B)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{R.closeSync(B)}}function b(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function L(W,x,G=6e4){if(W!==x)try{y.$j&&typeof G=="number"?await S(W,x,Date.now(),G):await R.promises.rename(W,x)}catch(te){if(W.toLowerCase()!==x.toLowerCase()&&te.code==="EXDEV"||W.endsWith("."))await v(W,x,{preserveSymlinks:!1}),await d(W,f.MOVE);else throw te}}async function S(W,x,G,te,B=0){try{return await R.promises.rename(W,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-G>=te)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${V}`),V;if(B===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw V}return await(0,A.$Hh)(Math.min(100,B*10)),S(W,x,G,te,B+1)}}async function v(W,x,G){return U(W,x,{root:{source:W,target:x},options:G,handledSourcePaths:new Set})}const C=511;async function U(W,x,G){if(G.handledSourcePaths.has(W))return;G.handledSourcePaths.add(W);const{stat:te,symbolicLink:B}=await i.stat(W);if(B){if(G.options.preserveSymlinks)try{return await H(W,x,G)}catch{}if(B.dangling)return}return te.isDirectory()?F(W,x,te.mode&C,G):j(W,x,te.mode&C)}async function F(W,x,G,te){await R.promises.mkdir(x,{recursive:!0,mode:G});const B=await m(W);for(const V of B)await U((0,O.$kc)(W,V),(0,O.$kc)(x,V),te)}async function j(W,x,G){await R.promises.copyFile(W,x),await R.promises.chmod(x,G)}async function H(W,x,G){let te=await R.promises.readlink(W);(0,T.$Fg)(te,G.root.source,!y.$l)&&(te=(0,O.$kc)(G.root.target,te.substr(G.root.source.length+1))),await R.promises.symlink(te,x)}e.Promises=new class{get read(){return(W,x,G,te,B)=>new Promise((V,_)=>{R.read(W,x,G,te,B,(ne,le,ee)=>ne?_(ne):V({bytesRead:le,buffer:ee}))})}get write(){return(W,x,G,te,B)=>new Promise((V,_)=>{R.write(W,x,G,te,B,(ne,le,ee)=>ne?_(ne):V({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,N.promisify)(R.fdatasync)}get open(){return(0,N.promisify)(R.open)}get close(){return(0,N.promisify)(R.close)}get realpath(){return(0,N.promisify)(R.realpath)}async exists(W){try{return await R.promises.access(W),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return d}get rename(){return L}get copy(){return v}}}),define(ue[146],de([0,1,33,13,5,26,30]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=k,e.$pr=O,e.$qr=y,e.$rr=I,R=Oe(R);function k(f){if(N.$l)return f;const d=(0,a.$nc)(f);if(f===d)return f;const l=((0,a.$oc)(f)||f).toLowerCase();try{const E=(0,T.readdirSync)(d).filter(m=>m.toLowerCase()===l);if(E.length===1){const m=k(d);if(m)return(0,a.$kc)(m,E[0])}else if(E.length>1){const m=E.indexOf(l);if(m>=0){const w=k(d);if(w)return(0,a.$kc)(w,E[m])}}}catch{}return null}async function O(f,d){if(N.$l)return f;const l=(0,a.$nc)(f);if(f===l)return f;const g=((0,a.$oc)(f)||f).toLowerCase();try{if(d?.isCancellationRequested)return null;const m=(await T.Promises.readdir(l)).filter(w=>w.toLowerCase()===g);if(m.length===1){const w=await O(l,d);if(w)return(0,a.$kc)(w,m[0])}else if(m.length>1){const w=m.indexOf(g);if(w>=0){const P=await O(l,d);if(P)return(0,a.$kc)(P,m[w])}}}catch{}return null}async function y(f){try{return await T.Promises.realpath(f)}catch{const l=p(f);return await R.promises.access(l,R.constants.R_OK),l}}function I(f){try{return R.realpathSync(f)}catch{const l=p(f);return R.accessSync(l,R.constants.R_OK),l}}function p(f){return(0,A.$of)((0,a.$ic)(f),a.sep)}}),define(ue[147],de([0,1,68]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=a,e.$7g=A,R=Oe(R);function a(k,O,y,I=1){let p=!1;return new Promise(f=>{const d=setTimeout(()=>{if(!p)return p=!0,f(0)},y);N(k,O,I,l=>{if(!p)return p=!0,clearTimeout(d),f(l)})})}function N(k,O,y,I){if(O===0)return I(0);const p=new R.Socket;p.once("connect",()=>(T(p),N(k+y,O-1,y,I))),p.once("data",()=>{}),p.once("error",f=>(T(p),f.code!=="ECONNREFUSED"?N(k+y,O-1,y,I):I(k))),p.connect(k,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,O,y,I="127.0.0.1"){let p=!1,f,d=1;const l=R.createServer({pauseOnConnect:!0});function g(E,m){p||(p=!0,l.removeAllListeners(),l.close(),f&&clearTimeout(f),m(E))}return new Promise(E=>{f=setTimeout(()=>{g(0,E)},y),l.on("listening",()=>{g(k,E)}),l.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&d<O?(k++,d++,l.listen(k,I)):g(0,E)}),l.on("close",()=>{g(0,E)}),l.listen(k,I)})}function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(O){console.error(O)}}}),define(ue[148],de([0,1,33,13,5,37,92,12,30]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$zm=y,e.$Am=I,a=Oe(a),N=Oe(N),A=Oe(A),k=Oe(k),O=Oe(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function y(f=A.env){return f.comspec||"cmd.exe"}function I(f){let d=[],l=!1;const g=function(E){if(l){d.push(E);return}(!f.send(E,w=>{if(w&&console.error(w),l=!1,d.length>0){const P=d.slice(0);d=[],P.forEach($=>g($))}})||N.$j)&&(l=!0)};return{send:g}}var p;(function(f){async function d(l,g,E){if(a.$jc(l))return l;if(g===void 0&&(g=A.cwd()),a.$nc(l)!=="."||(E===void 0&&k.$fg(A.env.PATH)&&(E=A.env.PATH.split(a.$uc)),E===void 0||E.length===0))return a.$kc(g,l);async function w(P){if(await O.Promises.exists(P)){let $;try{$=await R.promises.stat(P)}catch(c){c.message.startsWith("EACCES")&&($=await R.promises.lstat(P))}return $?!$.isDirectory():!1}return!1}for(const P of E){let $;if(a.$jc(P)?$=a.$kc(P,l):$=a.$kc(g,P,l),await w($))return $;let c=$+".com";if(await w(c)||(c=$+".exe",await w(c)))return c}return a.$kc(g,l)}f.findExecutable=d})(p||(e.win32=p={}))}),define(ue[149],de([0,1,69,22]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=N;function N(T){return new Promise((k,O)=>{let y;const I=new Map;function p(d,l,g,E,m){const w=I.get(l);if(d===T||w){const P={name:f(g),cmd:g,pid:d,ppid:l,load:E,mem:m};I.set(d,P),d===T&&(y=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort(($,c)=>$.pid-c.pid)))}}function f(d){const l=/--utility-sub-type=network/i,g=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,m=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(g.exec(d))return"electron-crash-reporter";if(E.exec(d))return"winpty-agent";if(m.exec(d))return"conpty-agent";let P=w.exec(d);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(d)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const $=/[a-zA-Z-]+\.js/g;let c="";do P=$.exec(d),P&&(c+=P+" ");while(P);return c&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${c})`:d}if(process.platform==="win32"){const d=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,g)=>{ce(["@vscode/windows-process-tree"],l,g)}).then(Oe).then(l=>{l.getProcessList(T,g=>{if(!g){O(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(g,E=>{const m=new Map;E.forEach(w=>{const P=d(w.commandLine||"");m.set(w.pid,{name:f(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),y=m.get(T),y?(m.forEach(w=>{const P=m.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((P,$)=>P.pid-$.pid))}),k(y)):O(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let d=function(){let l=[y];const g=[];for(;l.length;){const m=l.shift();m&&(g.push(m.pid),m.children&&(l=l.concat(m.children)))}let E=JSON.stringify(a.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+g.join(" "),(0,R.exec)(E,{},(m,w,P)=>{if(m||P)O(m||new Error(P.toString()));else{const $=w.toString().split(`
`);for(let c=0;c<g.length;c++){const h=I.get(g[c]);h.load=parseFloat($[c])}if(!y){O(new Error(`Root process ${T} not found`));return}k(y)}})};(0,R.exec)("which ps",{},(l,g,E)=>{if(l||E)if(process.platform!=="linux")O(l||new Error(E.toString()));else{const m=JSON.stringify(a.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(m,{},(w,P,$)=>{w||$?O(w||new Error($.toString())):(A(P,p),d())})}else{const m=g.toString().trim();(0,R.exec)(`${m} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,$,c)=>{P||c&&!c.includes("screen size is bogus")?O(P||new Error(c.toString())):(A($,p),process.platform==="linux"?d():y?k(y):O(new Error(`Root process ${T} not found`)))})}})}})}function A(T,k){const O=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=T.toString().split(`
`);for(const I of y){const p=O.exec(I.trim());p&&p.length===6&&k(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var Se=this&&this.__decorate||function(ce,e,R,a){var N=arguments.length,A=N<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,R):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ce,e,R,a);else for(var k=ce.length-1;k>=0;k--)(T=ce[k])&&(A=(N<3?T(A):N>3?T(e,R,A):T(e,R))||A);return N>3&&A&&Object.defineProperty(e,R,A),A};define(ue[42],de([0,1,17,6,14,25,88,8,3,2,66,26,12]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=r,e.$hi=o,e.$mi=C,e.$ni=U,p=Oe(p);var d;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(d||(d={}));function l(B){switch(B){case d.Promise:return"req";case d.PromiseCancel:return"cancel";case d.EventListen:return"subscribe";case d.EventDispose:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g||(g={}));function E(B){switch(B){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var m;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(m||(m={}));function w(B){let V=0;for(let _=0;;_+=7){const ne=B.read(1);if(V|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return V}}const P=n(0);function $(B,V){if(V===0){B.write(P);return}let _=0;for(let le=V;le!==0;le=le>>>7)_++;const ne=N.$Oe.alloc(_);for(let le=0;V!==0;le++)ne.buffer[le]=V&127,V=V>>>7,V>0&&(ne.buffer[le]|=128);B.write(ne)}class c{constructor(V){this.b=V,this.a=0}read(V){const _=this.b.slice(this.a,this.a+V);return this.a+=_.byteLength,_}}e.$ei=c;class h{constructor(){this.a=[]}get buffer(){return N.$Oe.concat(this.a)}write(V){this.a.push(V)}}e.$fi=h;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function n(B){const V=N.$Oe.alloc(1);return V.writeUInt8(B,0),V}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(B,V){if(typeof V>"u")B.write(t.Undefined);else if(typeof V=="string"){const _=N.$Oe.fromString(V);B.write(t.String),$(B,_.byteLength),B.write(_)}else if(s&&Buffer.isBuffer(V)){const _=N.$Oe.wrap(V);B.write(t.Buffer),$(B,_.byteLength),B.write(_)}else if(V instanceof N.$Oe)B.write(t.VSBuffer),$(B,V.byteLength),B.write(V);else if(Array.isArray(V)){B.write(t.Array),$(B,V.length);for(const _ of V)r(B,_)}else if(typeof V=="number"&&(V|0)===V)B.write(t.Uint),$(B,V);else{const _=N.$Oe.fromString(JSON.stringify(V));B.write(t.Object),$(B,_.byteLength),B.write(_)}}function o(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read(w(B)).toString();case i.Buffer:return B.read(w(B)).buffer;case i.VSBuffer:return B.read(w(B));case i.Array:{const _=w(B),ne=[];for(let le=0;le<_;le++)ne.push(o(B));return ne}case i.Object:return JSON.parse(B.read(w(B)).toString());case i.Int:return w(B)}}class u{constructor(V,_,ne=null,le=1e3){this.h=V,this.j=_,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:g.Initialize})}registerChannel(V,_){this.b.set(V,_),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case g.Initialize:{const _=this.o([V.type]);this.k?.logOutgoing(_,0,b.OtherSide,E(V.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const _=this.o([V.type,V.id],V.data);this.k?.logOutgoing(_,V.id,b.OtherSide,E(V.type),V.data);return}}}o(V,_=void 0){const ne=new h;return r(ne,V),r(ne,_),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const _=new c(V),ne=o(_),le=o(_),ee=ne[0];switch(ee){case d.Promise:return this.k?.logIncoming(V.byteLength,ne[1],b.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.s({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case d.EventListen:return this.k?.logIncoming(V.byteLength,ne[1],b.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.t({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case d.PromiseCancel:return this.k?.logIncoming(V.byteLength,ne[1],b.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]});case d.EventDispose:return this.k?.logIncoming(V.byteLength,ne[1],b.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]})}}s(V){const _=this.b.get(V.channelName);if(!_){this.v(V);return}const ne=new A.$xe;let le;try{le=_.call(this.j,V.name,V.arg,ne.token)}catch(K){le=Promise.reject(K)}const ee=V.id;le.then(K=>{this.m({id:ee,data:K,type:g.PromiseSuccess})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:ee,data:K,type:g.PromiseErrorObj})}).finally(()=>{X.dispose(),this.d.delete(V.id)});const X=(0,y.$Tc)(()=>ne.cancel());this.d.set(V.id,X)}t(V){const _=this.b.get(V.channelName);if(!_){this.v(V);return}const ne=V.id,ee=_.listen(this.j,V.name,V.arg)(X=>this.m({id:ne,data:X,type:g.EventFire}));this.d.set(V.id,ee)}u(V){const _=this.d.get(V.id);_&&(_.dispose(),this.d.delete(V.id))}v(V){let _=this.g.get(V.channelName);_||(_=[],this.g.set(V.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===d.Promise&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);_.push({request:V,timeoutTimer:ne})}w(V){const _=this.g.get(V);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case d.Promise:this.s(ne.request);break;case d.EventListen:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Qc)(this.d.values()),this.d.clear()}}e.$ii=u;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class L{constructor(V,_=null){this.l=V,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new O.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(V){const _=this;return{call(ne,le,ee){return _.a?Promise.reject(new k.$5):_.m(V,ne,le,ee)},listen(ne,le){return _.a?O.Event.None:_.o(V,ne,le)}}}m(V,_,ne,le=A.CancellationToken.None){const ee=this.g++,X=d.Promise,K={id:ee,type:X,channelName:V,name:_,arg:ne};if(le.isCancellationRequested)return Promise.reject(new k.$5);let q;return new Promise((J,oe)=>{if(le.isCancellationRequested)return oe(new k.$5);const Y=()=>{const ie=ae=>{switch(ae.type){case g.PromiseSuccess:this.f.delete(ee),J(ae.data);break;case g.PromiseError:{this.f.delete(ee);const he=new Error(ae.data.message);he.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,he.name=ae.data.name,oe(he);break}case g.PromiseErrorObj:this.f.delete(ee),oe(ae.data);break}};this.f.set(ee,ie),this.p(K)};let Z=null;this.b===m.Idle?Y():(Z=(0,a.$th)(ie=>this.u()),Z.then(()=>{Z=null,Y()}));const M=()=>{Z?(Z.cancel(),Z=null):this.p({id:ee,type:d.PromiseCancel}),oe(new k.$5)},z=le.onCancellationRequested(M);q=(0,y.$Sc)((0,y.$Tc)(M),z),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(V,_,ne){const le=this.g++,ee=d.EventListen,X={id:le,type:ee,channelName:V,name:_,arg:ne};let K=null;const q=new O.$me({onWillAddFirstListener:()=>{K=(0,a.$th)(J=>this.u()),K.then(()=>{K=null,this.d.add(q),this.p(X)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(q),this.p({id:le,type:d.EventDispose}))}}),D=J=>q.fire(J.data);return this.f.set(le,D),q.event}p(V){switch(V.type){case d.Promise:case d.EventListen:{const _=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(_,V.id,b.LocalSide,`${l(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case d.PromiseCancel:case d.EventDispose:{const _=this.q([V.type,V.id]);this.j?.logOutgoing(_,V.id,b.LocalSide,l(V.type));return}}}q(V,_=void 0){const ne=new h;return r(ne,V),r(ne,_),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const _=new c(V),ne=o(_),le=o(_),ee=ne[0];switch(ee){case g.Initialize:return this.j?.logIncoming(V.byteLength,0,b.LocalSide,E(ee)),this.t({type:ne[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(V.byteLength,ne[1],b.LocalSide,E(ee),le),this.t({type:ne[0],id:ne[1],data:le})}}t(V){if(V.type===g.Initialize){this.b=m.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return O.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Qc)(this.d.values()),this.d.clear()}}e.$ji=L,Se([T.$$h],L.prototype,"onDidInitializePromise",null);class S{get connections(){const V=[];return this.f.forEach(_=>V.push(_)),V}constructor(V,_,ne){this.a=new Map,this.f=new Set,this.g=new O.$me,this.onDidAddConnection=this.g.event,this.h=new O.$me,this.onDidRemoveConnection=this.h.event,this.j=new y.$Uc,this.j.add(V(({protocol:le,onDidClientDisconnect:ee})=>{const X=O.Event.once(le.onMessage);this.j.add(X(K=>{const q=new c(K),D=o(q),J=new u(le,D,_,ne),oe=new L(le,_);this.a.forEach((Z,M)=>J.registerChannel(M,Z));const Y={channelServer:J,channelClient:oe,ctx:D};this.f.add(Y),this.g.fire(Y),this.j.add(ee(()=>{J.dispose(),oe.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(V,_){const ne=this;return{call(le,ee,X){let K;if((0,f.$tg)(_)){const D=(0,R.$3b)(ne.connections.filter(_));K=D?Promise.resolve(D):O.Event.toPromise(O.Event.filter(ne.onDidAddConnection,_))}else K=_.routeCall(ne,le,ee);const q=K.then(D=>D.channelClient.getChannel(V));return C(q).call(le,ee,X)},listen(le,ee){if((0,f.$tg)(_))return ne.k(V,_,le,ee);const X=_.routeEvent(ne,le,ee).then(K=>K.channelClient.getChannel(V));return C(X).listen(le,ee)}}}k(V,_,ne,le){const ee=this;let X;const K=new O.$me({onWillAddFirstListener:()=>{X=new y.$Uc;const q=new O.$se,D=new Map,J=Y=>{const M=Y.channelClient.getChannel(V).listen(ne,le),z=q.add(M);D.set(Y,z)},oe=Y=>{const Z=D.get(Y);Z&&(Z.dispose(),D.delete(Y))};ee.connections.filter(_).forEach(J),O.Event.filter(ee.onDidAddConnection,_)(J,void 0,X),ee.onDidRemoveConnection(oe,void 0,X),q.event(K.fire,K,X),X.add(q)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return K.event}registerChannel(V,_){this.a.set(V,_);for(const ne of this.f)ne.channelServer.registerChannel(V,_)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=S;class v{constructor(V,_,ne=null){const le=new h;r(le,_),V.send(le.buffer),this.a=new L(V,ne),this.d=new u(V,_,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,_){this.d.registerChannel(V,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=v;function C(B){return{call(V,_,ne){return B.then(le=>le.call(V,_,ne))},listen(V,_){const ne=new O.$ve;return B.then(le=>ne.input=le.listen(V,_)),ne.event}}}function U(B){let V=!1;return{call(_,ne,le){return V?B.call(_,ne,le):(0,a.$Hh)(0).then(()=>V=!0).then(()=>B.call(_,ne,le))},listen(_,ne){if(V)return B.listen(_,ne);const le=new O.$ve;return(0,a.$Hh)(0).then(()=>V=!0).then(()=>le.input=B.listen(_,ne)),le.event}}}class F{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const _ of V.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await O.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$oi=F;var j;(function(B){function V(ee,X,K){const q=ee,D=K&&K.disableMarshalling,J=new Map;for(const oe in q)ne(oe)&&J.set(oe,O.Event.buffer(q[oe],!0,void 0,X));return new class{listen(oe,Y,Z){const M=J.get(Y);if(M)return M;const z=q[Y];if(typeof z=="function"){if(le(Y))return z.call(q,Z);if(ne(Y))return J.set(Y,O.Event.buffer(q[Y],!0,void 0,X)),J.get(Y)}throw new k.$bb(`Event not found: ${Y}`)}call(oe,Y,Z){const M=q[Y];if(typeof M=="function"){if(!D&&Array.isArray(Z))for(let ie=0;ie<Z.length;ie++)Z[ie]=(0,I.$di)(Z[ie]);let z=M.apply(q,Z);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new k.$bb(`Method not found: ${Y}`)}}}B.fromService=V;function _(ee,X){const K=X&&X.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return X?.properties?.has(D)?X.properties.get(D):le(D)?function(J){return ee.listen(D,J)}:ne(D)?ee.listen(D):async function(...J){let oe;X&&!(0,f.$og)(X.context)?oe=[X.context,...J]:oe=J;const Y=await ee.call(D,oe);return K?Y:(0,I.$di)(Y)};throw new k.$bb(`Property not found: ${String(D)}`)}})}B.toService=_;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&p.$Ff(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&p.$Ff(ee.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const V=B.toString();if(V!=="[object Object]")return V}return B}function x(B){return Array.isArray(B)?B.map(W):W(B)}function G(B,V,_,ne,le,ee,X){X=x(X);const K=H[le],q=K[ne%K.length];let D=[`%c[${B}]%c[${String(V).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ee)?(D=D.concat(X),D.push(")")):D.push(X),console.log.apply(console,D)}class te{constructor(V,_){this.d=V,this.f=_,this.a=0,this.b=0}logOutgoing(V,_,ne,le,ee){this.b+=V,G(this.d,this.b,V,_,ne,le,ee)}logIncoming(V,_,ne,le,ee){this.a+=V,G(this.f,this.a,V,_,ne,le,ee)}}e.$pi=te}),define(ue[70],de([0,1,14,3,2,42]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(b,L){if(!s.has(b)){const S=String(++r);s.set(b,S)}return s.get(b)}function u(b,L,S,v){if(!t.enableDiagnostics)return;const C=o(b,L);if(v instanceof R.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=R.$Oe.alloc(v.byteLength);U.set(v),t.records.push({timestamp:Date.now(),id:C,label:L,type:S,buff:U})}else t.records.push({timestamp:Date.now(),id:C,label:L,type:S,data:v})}t.traceSocketEvent=u})(k||(e.SocketDiagnostics=k={}));var O;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(O||(e.SocketCloseEventType=O={}));let y=null;function I(){return y||(y=R.$Oe.alloc(0)),y}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return I();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const L=this.a[0];return r&&(this.a.shift(),this.b-=s),L}if(this.a[0].byteLength>s){const L=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),L}const o=R.$Oe.alloc(s);let u=0,b=0;for(;s>0;){const L=this.a[b];if(L.byteLength>s){const S=L.slice(0,s);o.set(S,u),u+=s,r&&(this.a[b]=L.slice(s),this.b-=s),s-=s}else o.set(L,u),u+=L.byteLength,r?(this.a.shift(),this.b-=L.byteLength):b++,s-=L.byteLength}return o}}e.$qi=p;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(f||(f={}));function d(t){switch(t){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class g{constructor(s,r,o,u){this.type=s,this.id=r,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends N.$Vc{constructor(s){super(),this.f=this.B(new a.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:f.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,u=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=f.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,r),this.f.fire(new g(o,u,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Oe.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const o=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,o}h(){const s=R.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class w extends N.$Vc{constructor(s){super(),this.f=new a.$me,this.onMessage=this.f.event,this.g=new a.$me,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new m(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===f.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new g(f.Regular,0,0,s))}}e.$ri=w;class P extends A.$li{static fromSocket(s,r){return new P(new w(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$si=P;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$ti=$;class c{constructor(s){this.data=s,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,o=this.a;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new c(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let o=0;for(let u=0;u<i.a;u++)s-this.c[u]<=r&&o++;return 1-o/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new $,this.onControlMessage=this.v.event,this.w=new $,this.onMessage=this.w.event,this.x=new $,this.onDidDispose=this.x.event,this.y=new $,this.onSocketClose=this.y.event,this.z=new $,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new N.$Uc,this.p=s.socket,this.q=this.s.add(new m(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new g(f.Disconnect,0,0,I());this.q.write(s),this.q.flush()}}sendPause(){const s=new g(f.Pause,0,0,I());this.q.write(s)}sendResume(){const s=new g(f.Resume,0,0,I());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new N.$Uc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new m(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(o=>this.A(o))),this.s.add(this.p.onClose(o=>this.y.fire(o))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new g(f.Ack,0,this.j,I());this.q.write(s);const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case f.None:break;case f.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new g(f.ReplayRequest,0,0,I())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case f.Control:{this.v.fire(s.data);break}case f.Ack:break;case f.Disconnect:{this.x.fire();break}case f.ReplayRequest:{const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C();break}case f.Pause:{this.q.pause();break}case f.Resume:{this.q.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const o=new g(f.Regular,r,this.j,s);this.c.push(o),this.a||(this.q.write(o),this.C())}sendControl(s){const r=new g(f.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const b=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},b)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new g(f.Ack,0,this.j,I());this.q.write(s)}E(){this.j=this.h;const s=new g(f.KeepAlive,0,this.j,I());this.q.write(s)}}e.$ui=n}),define(ue[96],de([0,1,69,6,14,25,140,8,3,2,29,148,92,42]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0,k=Oe(k);class l extends d.$ii{constructor(m){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:O.Event.fromNodeEventEmitter(process,"message",w=>N.$Oe.wrap(Buffer.from(w,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$kr=l;class g{constructor(m,w){this.i=m,this.j=w,this.c=new Set,this.g=new Map,this.h=new O.$me,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new a.$Dh(P),this.d=null,this.f=null}getChannel(m){const w=this;return{call(P,$,c){return w.k(m,P,$,c)},listen(P,$){return w.l(m,P,$)}}}k(m,w,P,$=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const c=this.n(m),h=(0,a.$th)(t=>c.call(w,P,t)),i=$.onCancellationRequested(()=>h.cancel()),n=(0,y.$Tc)(()=>h.cancel());return this.c.add(n),h.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(m,w,P){if(!this.b)return O.Event.None;this.b.cancel();let $;const c=new O.$me({onWillAddFirstListener:()=>{$=this.n(m).listen(w,P)(c.fire,c),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,I.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,f.$nm)(w.env),this.d=(0,R.fork)(this.i,m,w);const P=new O.$me,c=O.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.$gr)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(N.$Oe.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,p.$Am)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new d.$ji(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.c.forEach(u=>(0,y.$Qc)(u)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(m){let w=this.g.get(m);return w||(w=this.m.getChannel(m),this.g.set(m,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$lr=g}),define(ue[150],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0,e.$0o=a;const R="Offline";function a(A){return A instanceof N?!0:A instanceof Error&&A.name===R&&A.message===R}class N extends Error{constructor(){super(R),this.name=this.message}}e.$$o=N}),define(ue[151],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aY=R;function R(a){return!!a.parentPort}}),define(ue[152],de([0,1,151,14,42,3,12,17]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bY=void 0,e.$cY=I;class O{constructor(f){this.a=f,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",d=>d.data?a.$Oe.wrap(d.data):a.$Oe.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}class y extends N.$ki{static b(f){(0,T.$pg)((0,R.$aY)(process),"Electron Utility Process");const d=new A.$me;return process.parentPort.on("message",l=>{if(f?.handledClientConnection(l))return;const g=(0,k.$Ob)(l.ports);g&&d.fire(g)}),A.Event.map(d.event,l=>({protocol:new O(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor(f){super(y.b(f))}}e.$bY=y;function I(p,f,d){const l=g=>{g.data===f&&(p.removeListener("message",l),d())};p.on("message",l)}}),define(ue[71],de([0,1,6,3,2,66,12]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=O;var k;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function O(f){const d=f;return d?.changed instanceof Map||d?.deleted instanceof Set}var y;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(y||(e.StorageState=y={}));class I extends N.$Vc{static{this.a=100}constructor(d,l=Object.create(null)){super(),this.r=d,this.s=l,this.b=this.B(new a.$pe),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new R.$Eh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((l,g)=>this.w(g,l)),d.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(d,l){if(this.c===y.Closed)return;let g=!1;(0,T.$og)(l)?g=this.f.delete(d):this.f.get(d)!==l&&(this.f.set(d,l),g=!0),g&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,l){const g=this.f.get(d);return(0,T.$og)(g)?l:g}getBoolean(d,l){const g=this.get(d);return(0,T.$og)(g)?l:g==="true"}getNumber(d,l){const g=this.get(d);return(0,T.$og)(g)?l:parseInt(g,10)}getObject(d,l){const g=this.get(d);return(0,T.$og)(g)?l:(0,A.$ci)(g)}async set(d,l,g=!1){if(this.c===y.Closed)return;if((0,T.$og)(l))return this.delete(d,g);const E=(0,T.$hg)(l)||Array.isArray(l)?(0,A.$bi)(l):String(l);if(this.f.get(d)!==E)return this.f.set(d,E),this.j.set(d,E),this.h.delete(d),this.b.fire({key:d,external:g}),this.D()}async delete(d,l=!1){if(!(this.c===y.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:l}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(!(this.c===y.Closed||this.m))return this.D(d)}async D(d){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$fq=I;class p{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((l,g)=>this.a.set(g,l)),d.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$gq=p}),define(ue[11],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=N,e.localize2=T;const R=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function a(k,O){let y;return O.length===0?y=k:y=k.replace(/\{(\d+)\}/g,(I,p)=>{const f=p[0],d=O[f];let l=I;return typeof d=="string"?l=d:(typeof d=="number"||typeof d=="boolean"||d===void 0||d===null)&&(l=String(d)),l}),R&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function N(k,O,...y){return a(typeof k=="number"?A(k,O):O,y)}function A(k,O){const y=globalThis._VSCODE_NLS_MESSAGES?.[k];if(typeof y!="string"){if(typeof O=="string")return O;throw new Error(`!!! NLS MISSING: ${k} !!!`)}return y}function T(k,O,...y){let I;typeof k=="number"?I=A(k,O):I=O;const p=a(I,y);return{value:p,original:O===I?p:a(O,y)}}}),define(ue[72],de([0,1,11]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=y,e.$4m=I,e.$5m=p;const a=60,N=a*60,A=N*24,T=A*7,k=A*30,O=A*365;function y(f,d,l,g){typeof f!="number"&&(f=f.getTime());const E=Math.round((new Date().getTime()-f)/1e3);if(E<-30)return(0,R.localize)(40,null,y(new Date().getTime()+E*1e3,!1));if(!g&&E<30)return(0,R.localize)(41,null);let m;return E<a?(m=E,d?m===1?l?(0,R.localize)(42,null,m):(0,R.localize)(43,null,m):l?(0,R.localize)(44,null,m):(0,R.localize)(45,null,m):m===1?l?(0,R.localize)(46,null,m):(0,R.localize)(47,null,m):l?(0,R.localize)(48,null,m):(0,R.localize)(49,null,m)):E<N?(m=Math.floor(E/a),d?m===1?l?(0,R.localize)(50,null,m):(0,R.localize)(51,null,m):l?(0,R.localize)(52,null,m):(0,R.localize)(53,null,m):m===1?l?(0,R.localize)(54,null,m):(0,R.localize)(55,null,m):l?(0,R.localize)(56,null,m):(0,R.localize)(57,null,m)):E<A?(m=Math.floor(E/N),d?m===1?l?(0,R.localize)(58,null,m):(0,R.localize)(59,null,m):l?(0,R.localize)(60,null,m):(0,R.localize)(61,null,m):m===1?l?(0,R.localize)(62,null,m):(0,R.localize)(63,null,m):l?(0,R.localize)(64,null,m):(0,R.localize)(65,null,m)):E<T?(m=Math.floor(E/A),d?m===1?(0,R.localize)(66,null,m):(0,R.localize)(67,null,m):m===1?(0,R.localize)(68,null,m):(0,R.localize)(69,null,m)):E<k?(m=Math.floor(E/T),d?m===1?l?(0,R.localize)(70,null,m):(0,R.localize)(71,null,m):l?(0,R.localize)(72,null,m):(0,R.localize)(73,null,m):m===1?l?(0,R.localize)(74,null,m):(0,R.localize)(75,null,m):l?(0,R.localize)(76,null,m):(0,R.localize)(77,null,m)):E<O?(m=Math.floor(E/k),d?m===1?l?(0,R.localize)(78,null,m):(0,R.localize)(79,null,m):l?(0,R.localize)(80,null,m):(0,R.localize)(81,null,m):m===1?l?(0,R.localize)(82,null,m):(0,R.localize)(83,null,m):l?(0,R.localize)(84,null,m):(0,R.localize)(85,null,m)):(m=Math.floor(E/O),d?m===1?l?(0,R.localize)(86,null,m):(0,R.localize)(87,null,m):l?(0,R.localize)(88,null,m):(0,R.localize)(89,null,m):m===1?l?(0,R.localize)(90,null,m):(0,R.localize)(91,null,m):l?(0,R.localize)(92,null,m):(0,R.localize)(93,null,m))}function I(f,d){const l=Math.abs(f/1e3);return l<1?d?(0,R.localize)(94,null,f):(0,R.localize)(95,null,f):l<a?d?(0,R.localize)(96,null,Math.round(f)/1e3):(0,R.localize)(97,null,Math.round(f)/1e3):l<N?d?(0,R.localize)(98,null,Math.round(f/(1e3*a))):(0,R.localize)(99,null,Math.round(f/(1e3*a))):l<A?d?(0,R.localize)(100,null,Math.round(f/(1e3*N))):(0,R.localize)(101,null,Math.round(f/(1e3*N))):(0,R.localize)(102,null,Math.round(f/(1e3*A)))}function p(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ue[43],de([0,1,17,12,11]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=O,e.$sj=y,e.$tj=I,R=Oe(R),a=Oe(a),N=Oe(N);function A(p,f){return f&&(p.stack||p.stacktrace)?N.localize(103,null,k(p),T(p.stack)||T(p.stacktrace)):k(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function k(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?N.localize(104,null,p.message):p.message||N.localize(105,null)}function O(p=null,f=!1){if(!p)return N.localize(106,null);if(Array.isArray(p)){const d=R.$Hb(p),l=O(d[0],f);return d.length>1?N.localize(107,null,l,d.length):l}if(a.$fg(p))return p;if(p.detail){const d=p.detail;if(d.error)return A(d.error,f);if(d.exception)return A(d.exception,f)}return p.stack?A(p,f):p.message?p.message:N.localize(108,null)}function y(p){const f=p;return f instanceof Error&&Array.isArray(f.actions)}function I(p,f){let d;return typeof p=="string"?d=new Error(p):d=p,d.actions=f,d}}),define(ue[153],de([0,1,11,36]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=N;function N(A){switch(A){case a.ParseErrorCode.InvalidSymbol:return(0,R.localize)(109,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(110,null);case a.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(111,null);case a.ParseErrorCode.ValueExpected:return(0,R.localize)(112,null);case a.ParseErrorCode.ColonExpected:return(0,R.localize)(113,null);case a.ParseErrorCode.CommaExpected:return(0,R.localize)(114,null);case a.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(115,null);case a.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(116,null);case a.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(117,null);default:return""}}}),define(ue[73],de([0,1,33,6,13,12,30,11]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0,e.zip=E,e.$Gq=m,e.$Hq=P,N=Oe(N),k=Oe(k),e.$Dq="end of central directory record signature not found";const O=new RegExp(e.$Dq);class y extends Error{constructor(c,h){let i=h.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=h}}e.$Eq=y;function I($){const c=$.externalFileAttributes>>16||33188;return[448,56,7].map(h=>c&h).reduce((h,i)=>h+i,c&61440)}function p($){if($ instanceof y)return $;let c;return O.test($.message)&&(c="CorruptZip"),new y(c,$)}function f($,c,h,i,n,t){const s=N.$nc(c),r=N.$kc(i,s);if(!r.startsWith(i))return Promise.reject(new Error(k.localize(138,null,c)));const o=N.$kc(i,c);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(R.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,L)=>{if(!t.isCancellationRequested)try{u=(0,R.createWriteStream)(o,{mode:h}),u.once("close",()=>b()),u.once("error",L),$.once("error",L),$.pipe(u)}catch(S){L(S)}}))}function d($,c,h,i){let n=(0,a.$th)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),$.close()});return new Promise((r,o)=>{const u=new a.$Bh,b=L=>{L.isCancellationRequested||(t++,$.readEntry())};$.once("error",o),$.once("close",()=>n.then(()=>{i.isCancellationRequested||$.entryCount===t?r():o(new y("Incomplete",new Error(k.localize(139,null,t,$.entryCount))))},o)),$.readEntry(),$.on("entry",L=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(L.fileName)){b(i);return}const S=L.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(S)){const U=N.$kc(c,S);n=(0,a.$th)(F=>R.promises.mkdir(U,{recursive:!0}).then(()=>b(F)).then(void 0,o));return}const v=g($,L),C=I(L);n=(0,a.$th)(U=>u.queue(()=>v.then(F=>f(F,S,C,c,h,U).then(()=>b(U)))).then(null,o))})}).finally(()=>s.dispose())}async function l($,c=!1){const{open:h}=await new Promise((i,n)=>{ce(["yauzl"],i,n)}).then(Oe);return new Promise((i,n)=>{h($,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(p(t)):i((0,A.$qg)(s))})})}function g($,c){return new Promise((h,i)=>{$.openReadStream(c,(n,t)=>{n?i(p(n)):h((0,A.$qg)(t))})})}async function E($,c){const{ZipFile:h}=await new Promise((i,n)=>{ce(["yazl"],i,n)}).then(Oe);return new Promise((i,n)=>{const t=new h;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,R.createWriteStream)($);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i($))})}function m($,c,h={},i){const n=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l($,!0);return h.overwrite&&(t=t.then(s=>T.Promises.rm(c).then(()=>s))),t.then(s=>d(s,c,{sourcePathRegex:n},i))}function w($,c){return l($).then(h=>new Promise((i,n)=>{h.on("entry",t=>{t.fileName===c&&g(h,t).then(s=>i(s),s=>n(s))}),h.once("close",()=>n(new Error(k.localize(140,null,c))))}))}function P($,c){return w($,c).then(h=>new Promise((i,n)=>{const t=[];h.once("error",n),h.on("data",s=>t.push(s)),h.on("end",()=>i(Buffer.concat(t)))}))}}),define(ue[154],de([0,1,39,8,11]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...I){switch(I.length){case 1:return(0,N.localize)(1684,null,I[0]);case 2:return(0,N.localize)(1685,null,I[0],I[1]);case 3:return(0,N.localize)(1686,null,I[0],I[1],I[2]);default:return}}const k=(0,N.localize)(1687,null),O=(0,N.localize)(1688,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return p.isTripleEq?"===":"==";case A.NotEq:return p.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return p.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return p.lexeme;case A.QuotedStr:return p.lexeme;case A.Error:return p.lexeme;case A.EOF:return"EOF";default:throw(0,a.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case R.CharCode.OpenParen:this.k(A.LParen);break;case R.CharCode.CloseParen:this.k(A.RParen);break;case R.CharCode.ExclamationMark:if(this.h(R.CharCode.Equals)){const f=this.h(R.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:f})}else this.k(A.Neg);break;case R.CharCode.SingleQuote:this.o();break;case R.CharCode.Slash:this.q();break;case R.CharCode.Equals:if(this.h(R.CharCode.Equals)){const f=this.h(R.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:f})}else this.h(R.CharCode.Tilde)?this.k(A.RegexOp):this.l(T("==","=~"));break;case R.CharCode.LessThan:this.k(this.h(R.CharCode.Equals)?A.LtEq:A.Lt);break;case R.CharCode.GreaterThan:this.k(this.h(R.CharCode.Equals)?A.GtEq:A.Gt);break;case R.CharCode.Ampersand:this.h(R.CharCode.Ampersand)?this.k(A.And):this.l(T("&&"));break;case R.CharCode.Pipe:this.h(R.CharCode.Pipe)?this.k(A.Or):this.l(T("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?R.CharCode.Null:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const f=this.d,d=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:d};this.g.push({offset:f,lexeme:d,additionalInfo:p}),this.f.push(l)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const f=this.c.substring(this.d,this.e),d=y.b.get(f);d?this.k(d):this.f.push({type:A.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==R.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,f=!1,d=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(O);return}const g=this.c.charCodeAt(p);if(f)f=!1;else if(g===R.CharCode.Slash&&!d){p++;break}else g===R.CharCode.OpenSquareBracket?d=!0:g===R.CharCode.Backslash?f=!0:g===R.CharCode.CloseSquareBracket&&(d=!1);p++}for(;p<this.c.length&&y.a.has(this.c.charCodeAt(p));)p++;this.e=p;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=y}),define(ue[155],de([0,1,72,88,22,13,37,20,9]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$8m=I,e.$9m=p,e.$6m=/^([^.]+\..+)[:=](.+)$/;class y{get appRoot(){return(0,A.$nc)(N.$1g.asFileUri("").fsPath)}get userHome(){return O.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return O.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.b.tmpDir)}get cacheHome(){return O.URI.file(this.userDataPath)}get stateResource(){return(0,k.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,R.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",d)}return O.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$hh)(O.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=T.env.VSCODE_PORTABLE;return d?O.URI.file((0,A.$kc)(d,"argv.json")):(0,k.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$lc)(d):(0,A.$ic)((0,A.$kc)(N.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?O.URI.file((0,A.$lc)(d)):O.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$lc)(d);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const g=T.env.VSCODE_PORTABLE;return g?(0,A.$kc)(g,"extensions"):(0,k.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(l=>/^[^:/?#]+?:\/\//.test(l)?O.URI.parse(l):O.URI.file((0,A.$ic)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?O.URI.parse(d):O.URI.file((0,A.$ic)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$6m.test(d))}get extensionLogLevel(){const d=[];for(const l of this.args.log||[]){const g=e.$6m.exec(l);g&&g[1]&&g[2]&&d.push([g[1],g[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.$hh)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=T.env.VSCODE_PORTABLE;return d?O.URI.file((0,A.$kc)(d,"policy.json")):(0,k.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,l,g){this.a=d,this.b=l,this.c=g,this.editSessionId=this.args.editSessionId}}e.$7m=y,Se([a.$$h],y.prototype,"appRoot",null),Se([a.$$h],y.prototype,"userHome",null),Se([a.$$h],y.prototype,"userDataPath",null),Se([a.$$h],y.prototype,"appSettingsHome",null),Se([a.$$h],y.prototype,"tmpDir",null),Se([a.$$h],y.prototype,"cacheHome",null),Se([a.$$h],y.prototype,"stateResource",null),Se([a.$$h],y.prototype,"userRoamingDataHome",null),Se([a.$$h],y.prototype,"userDataSyncHome",null),Se([a.$$h],y.prototype,"sync",null),Se([a.$$h],y.prototype,"machineSettingsResource",null),Se([a.$$h],y.prototype,"workspaceStorageHome",null),Se([a.$$h],y.prototype,"localHistoryHome",null),Se([a.$$h],y.prototype,"keyboardLayoutResource",null),Se([a.$$h],y.prototype,"argvResource",null),Se([a.$$h],y.prototype,"isExtensionDevelopment",null),Se([a.$$h],y.prototype,"untitledWorkspacesHome",null),Se([a.$$h],y.prototype,"builtinExtensionsPath",null),Se([a.$$h],y.prototype,"extensionsPath",null),Se([a.$$h],y.prototype,"extensionDevelopmentLocationURI",null),Se([a.$$h],y.prototype,"extensionDevelopmentKind",null),Se([a.$$h],y.prototype,"extensionTestsLocationURI",null),Se([a.$$h],y.prototype,"debugExtensionHost",null),Se([a.$$h],y.prototype,"logLevel",null),Se([a.$$h],y.prototype,"extensionLogLevel",null),Se([a.$$h],y.prototype,"serviceMachineIdResource",null),Se([a.$$h],y.prototype,"disableTelemetry",null),Se([a.$$h],y.prototype,"disableWorkspaceTrust",null),Se([a.$$h],y.prototype,"useInMemorySecretStorage",null),Se([a.$$h],y.prototype,"policyFile",null);function I(f,d){return p(f["inspect-extensions"],f["inspect-brk-extensions"],5870,d,f.debugId,f.extensionEnvironment)}function p(f,d,l,g,E,m){const P=Number(d||f)||(g?null:l),$=P?!!d:!1;let c;if(m)try{c=JSON.parse(m)}catch{}return{port:P,break:$,debugId:E,env:c}}}),function(){function ce(e,R,a){function N(T,k){const O=A(T,k),y=[O];return e.isAbsolute(O)||y.unshift(a),e.resolve(...y)}function A(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const O=process.env.VSCODE_PORTABLE;if(O)return e.join(O,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,k);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(p,"AppData","Roaming")}break;case"darwin":y=e.join(R.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,k)}return{getUserDataPath:N}}if(typeof define=="function")define(ue[156],de([244,38,37]),function(e,R,a){return ce(e,R,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ce(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[157],de([0,1,38,155,156]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$$m=T,e.$_m=k;class A extends a.$7m{constructor(y,I){super(y,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,N.getUserDataPath)(y,I.nameShort)},I)}}e.$0m=A;function T(O,y){return(0,a.$9m)(O["inspect-ptyhost"],O["inspect-brk-ptyhost"],5877,y,O.extensionEnvironment)}function k(O,y){return(0,a.$9m)(O["inspect-sharedprocess"],O["inspect-brk-sharedprocess"],5879,y,O.extensionEnvironment)}}),define(ue[158],de([0,1,12,11]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=N;function N(T,k,O,y){try{A(T,k,O,y)}catch(I){T.error(I?.message??I)}return k}function A(T,k,O,y){const I=(p,f,d)=>{const l=p[f];if((0,R.$fg)(l)){const g=l,E=g.length;if(E>1&&g[0]==="%"&&g[E-1]==="%"){const m=g.substr(1,E-2);let w=O[m];w===void 0&&y&&(w=y[m]);const P=typeof w=="string"?w:w?.message,$=y?.[m],c=typeof $=="string"?$:$?.message;if(!P){c||T.warn(`[${k.name}]: ${(0,a.localize)(1805,null,m)}`);return}if(d&&(f==="title"||f==="category")&&c&&c!==P){const h={value:P,original:c};p[f]=h}else p[f]=P}}else if((0,R.$hg)(l))for(const g in l)l.hasOwnProperty(g)&&(g==="commands"?I(l,g,!0):I(l,g,d));else if(Array.isArray(l))for(let g=0;g<l.length;g++)I(l,g,d)};for(const p in k)k.hasOwnProperty(p)&&I(k,p)}}),define(ue[159],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=void 0;class R{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Zic=R;class a{constructor(A){this.a=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.$1ic=a}),define(ue[160],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:3},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(ue[74],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class R{constructor(N,A=[],T=!1){this.ctor=N,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.$Di=R}),define(ue[161],de([0,1,74]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Us=A,e.$Vs=T;const a=[];var N;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function A(k,O,y){O instanceof R.$Di||(O=new R.$Di(O,[],!!y)),a.push([k,O])}function T(){return a}}),define(ue[162],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;class R{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$xr=R;class a{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const k=this.lookupOrInsertNode(A),O=this.lookupOrInsertNode(T);k.outgoing.set(O.key,O),O.incoming.set(k.key,k)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let k=this.a.get(T);return k||(k=new R(T,A),this.a.set(T,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,k]of this.a)A.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const k=new Set([A]),O=this.c(T,k);if(O)return O}}c(A,T){for(const[k,O]of A.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const y=this.c(O,T);if(y)return y;T.delete(k)}}}e.$yr=a}),define(ue[4],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=N,e.$Hi=A;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(O){return O[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(R||(e._util=R={})),e.$Fi=N("instantiationService");function a(T,k,O){k[R.DI_TARGET]===k?k[R.DI_DEPENDENCIES].push({id:T,index:O}):(k[R.DI_DEPENDENCIES]=[{id:T,index:O}],k[R.DI_TARGET]=k)}function N(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const k=function(O,y,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(k,O,I)};return k.toString=()=>T,R.serviceIds.set(T,k),k}function A(T){return T}}),define(ue[163],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0,e.$zic=(0,R.$Gi)("checksumService")}),define(ue[21],de([0,1,12,9,4]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=A,e.$cj=T,e.$dj=O,e.$ej=y,e.$fj=I,e.$gj=p,e.$hj=f,e.$ij=l,e.$jj=g,e.$kj=E,R=Oe(R),e.$aj=(0,N.$Gi)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof a.URI)}function T(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof a.URI)}var k;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function O(m){switch(m){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function y(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}function I(m,w){const P=Object.create(null);for(const $ in m)p(P,$,m[$],w);return P}function p(m,w,P,$){const c=w.split("."),h=c.pop();let i=m;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){$(`Ignoring ${w} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:$(`Ignoring ${w} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{$(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(i)}`)}function f(m,w){const P=w.split(".");d(m,P)}function d(m,w){const P=w.shift();if(w.length===0){delete m[P];return}if(Object.keys(m).indexOf(P)!==-1){const $=m[P];typeof $=="object"&&!Array.isArray($)&&(d($,w),Object.keys($).length===0&&delete m[P])}}function l(m,w,P){function $(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=w.split("."),h=$(m,c);return typeof h>"u"?P:h}function g(m,w,P){Object.keys(w).forEach($=>{$!=="__proto__"&&($ in m?R.$hg(m[$])&&R.$hg(w[$])?g(m[$],w[$],P):P&&(m[$]=w[$]):m[$]=w[$])})}function E(m){return m.replace(/[\[\]]/g,"")}}),define(ue[97],de([0,1,39,5,26,154,4,11,8]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=I,e.$Fj=n,e.$Gj=t,e.$Zj=ee;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",a.$k),y.set("isLinux",a.$l),y.set("isWindows",a.$j),y.set("isWeb",a.$p),y.set("isMacNative",a.$k&&!a.$p),y.set("isEdge",a.$I),y.set("isFirefox",a.$G),y.set("isChrome",a.$F),y.set("isSafari",a.$H);function I(q,D){if(y.get(q)!==void 0)throw(0,O.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(q,D)}const p=Object.prototype.hasOwnProperty;var f;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const d={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(1664,null),g=(0,k.localize)(1665,null),E=(0,k.localize)(1666,null),m=(0,k.localize)(1667,null),w=(0,k.localize)(1668,null),P=(0,k.localize)(1669,null),$=(0,k.localize)(1670,null),c=(0,k.localize)(1671,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=d){this.k=D,this.d=new A.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const oe=this.D(),Y=oe.type===A.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:oe.offset,lexeme:A.$Bj.getLexeme(oe),additionalInfo:Y}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),o.INSTANCE;case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,m),J?.negate()}case A.TokenType.Str:return this.z(),C.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,m),J}case A.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==A.TokenType.RegexStr)throw this.B("REGEX",Y);const Z=Y.lexeme,M=Z.lastIndexOf("/"),z=M===Z.length-1?void 0:this.w(Z.substring(M+1));let ie;try{ie=new RegExp(Z.substring(1,M),z)}catch{throw this.B("REGEX",Y)}return x.create(J,ie)}switch(Y.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const Z=[Y.lexeme];this.z();let M=this.D(),z=0;for(let be=0;be<Y.lexeme.length;be++)Y.lexeme.charCodeAt(be)===R.CharCode.OpenParen?z++:Y.lexeme.charCodeAt(be)===R.CharCode.CloseParen&&z--;for(;!this.E()&&M.type!==A.TokenType.And&&M.type!==A.TokenType.Or;){switch(M.type){case A.TokenType.LParen:z++;break;case A.TokenType.RParen:z--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let be=0;be<M.lexeme.length;be++)M.lexeme.charCodeAt(be)===R.CharCode.OpenParen?z++:Y.lexeme.charCodeAt(be)===R.CharCode.CloseParen&&z--}if(z<0)break;Z.push(A.$Bj.getLexeme(M)),this.z(),M=this.D()}const ie=Z.join(""),ae=ie.lastIndexOf("/"),he=ae===ie.length-1?void 0:this.w(ie.substring(ae+1));let pe;try{pe=new RegExp(ie.substring(1,ae),he)}catch{throw this.B("REGEX",Y)}return i.regex(J,pe)}case A.TokenType.QuotedStr:{const Z=Y.lexeme;this.z();let M=null;if(!(0,N.$df)(Z)){const z=Z.indexOf("/"),ie=Z.lastIndexOf("/");if(z!==ie&&z>=0){const ae=Z.slice(z+1,ie),he=Z[ie+1]==="i"?"i":"";try{M=new RegExp(ae,he)}catch{throw this.B("REGEX",Y)}}}if(M===null)throw this.B("REGEX",Y);return x.create(J,M)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,E);const Y=this.u();return i.notIn(J,Y)}switch(this.D().type){case A.TokenType.Eq:{this.z();const Y=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(J,Y);switch(Y){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,Y)}}case A.TokenType.NotEq:{this.z();const Y=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(J,Y);switch(Y){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,Y)}}case A.TokenType.Lt:return this.z(),H.create(J,this.u());case A.TokenType.LtEq:return this.z(),W.create(J,this.u());case A.TokenType.Gt:return this.z(),F.create(J,this.u());case A.TokenType.GtEq:return this.z(),j.create(J,this.u());case A.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case A.TokenType.EOF:throw this.h.push({message:$,offset:D.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,oe){const Y=(0,k.localize)(1672,null,D,A.$Bj.getLexeme(J)),Z=J.offset,M=A.$Bj.getLexeme(J);return this.h.push({message:Y,offset:Z,lexeme:M,additionalInfo:oe}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Dj=h;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(D){return u.create(D)}static equals(D,J){return b.create(D,J)}static notEquals(D,J){return v.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return L.create(D,J)}static notIn(D,J){return S.create(D,J)}static not(D){return C.create(D)}static and(...D){return B.create(D,null,!0)}static or(...D){return V.create(D,null,!0)}static greater(D,J){return F.create(D,J)}static greaterEquals(D,J){return j.create(D,J)}static smaller(D,J){return H.create(D,J)}static smallerEquals(D,J){return W.create(D,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Ej=i;function n(q){const D=new h({regexParsingWithErrorRecovery:!1});return q.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,k.localize)(1673,null,oe.additionalInfo):(0,k.localize)(1674,null),offset:oe.offset,length:oe.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(q,D){const J=q?q.substituteConstants():void 0,oe=D?D.substituteConstants():void 0;return!J&&!oe?!0:!J||!oe?!1:J.equals(oe)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=f.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Hj=r;class o{static{this.INSTANCE=new o}constructor(){this.type=f.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Ij=o;class u{static create(D,J=null){const oe=y.get(D);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new u(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=f.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=y.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Jj=u;class b{static create(D,J,oe=null){if(typeof J=="boolean")return J?u.create(D,oe):C.create(D,oe);const Y=y.get(D);return typeof Y=="boolean"?J===(Y?"true":"false")?o.INSTANCE:r.INSTANCE:new b(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?o.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Kj=b;class L{static create(D,J){return new L(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),oe=D.getValue(this.d);return Array.isArray(J)?J.includes(oe):typeof oe=="string"&&typeof J=="object"&&J!==null?p.call(J,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Lj=L;class S{static create(D,J){return new S(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.NotIn,this.c=L.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=S;class v{static create(D,J,oe=null){if(typeof J=="boolean")return J?C.create(D,oe):u.create(D,oe);const Y=y.get(D);return typeof Y=="boolean"?J===(Y?"true":"false")?r.INSTANCE:o.INSTANCE:new v(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Nj=v;class C{static create(D,J=null){const oe=y.get(D);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new C(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=f.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=y.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Oj=C;function U(q,D){if(typeof q=="string"){const J=parseFloat(q);isNaN(J)||(q=J)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class F{static create(D,J,oe=null){return U(J,Y=>new F(D,Y,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=F;class j{static create(D,J,oe=null){return U(J,Y=>new j(D,Y,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Qj=j;class H{static create(D,J,oe=null){return U(J,Y=>new H(D,Y,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Rj=H;class W{static create(D,J,oe=null){return U(J,Y=>new W(D,Y,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=f.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Sj=W;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return J<oe?-1:J>oe?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return this.d===D.d&&J===oe}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Tj=x;class G{static create(D){return new G(D)}constructor(D){this.c=D,this.type=f.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new G(this.c.map(D))}negate(){return this.c}}e.$Uj=G;function te(q){let D=null;for(let J=0,oe=q.length;J<oe;J++){const Y=q[J].substituteConstants();if(q[J]!==Y&&D===null){D=[];for(let Z=0;Z<J;Z++)D[Z]=q[Z]}D!==null&&(D[J]=Y)}return D===null?q:D}class B{static create(D,J,oe){return B.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=f.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Y=s(this.expr[J],D.expr[J]);if(Y!==0)return Y}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:B.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,oe){const Y=[];let Z=!1;for(const M of D)if(M){if(M.type===f.True){Z=!0;continue}if(M.type===f.False)return r.INSTANCE;if(M.type===f.And){Y.push(...M.expr);continue}Y.push(M)}if(Y.length===0&&Z)return o.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(s);for(let M=1;M<Y.length;M++)Y[M-1].equals(Y[M])&&(Y.splice(M,1),M--);if(Y.length===1)return Y[0];for(;Y.length>1;){const M=Y[Y.length-1];if(M.type!==f.Or)break;Y.pop();const z=Y.pop(),ie=Y.length===0,ae=V.create(M.expr.map(he=>B.create([he,z],null,oe)),null,ie);ae&&(Y.push(ae),Y.sort(s))}if(Y.length===1)return Y[0];if(oe){for(let M=0;M<Y.length;M++)for(let z=M+1;z<Y.length;z++)if(Y[M].negate().equals(Y[z]))return r.INSTANCE;if(Y.length===1)return Y[0]}return new B(Y,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new B(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=V.create(D,this,!0)}return this.c}}e.$Vj=B;class V{static create(D,J,oe){return V.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=f.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Y=s(this.expr[J],D.expr[J]);if(Y!==0)return Y}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,oe){let Y=[],Z=!1;if(D){for(let M=0,z=D.length;M<z;M++){const ie=D[M];if(ie){if(ie.type===f.False){Z=!0;continue}if(ie.type===f.True)return o.INSTANCE;if(ie.type===f.Or){Y=Y.concat(ie.expr);continue}Y.push(ie)}}if(Y.length===0&&Z)return r.INSTANCE;Y.sort(s)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let M=1;M<Y.length;M++)Y[M-1].equals(Y[M])&&(Y.splice(M,1),M--);if(Y.length===1)return Y[0];if(oe){for(let M=0;M<Y.length;M++)for(let z=M+1;z<Y.length;z++)if(Y[M].negate().equals(Y[z]))return o.INSTANCE;if(Y.length===1)return Y[0]}return new V(Y,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new V(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),oe=D.shift(),Y=[];for(const Z of K(J))for(const M of K(oe))Y.push(B.create([Z,M],null,!1));D.unshift(V.create(Y,null,!1))}this.c=V.create(D,this,!0)}return this.c}}e.$Wj=V;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,J,oe){super(D,null),this.f=J,typeof oe=="object"?_.d.push({...oe,key:D}):oe!==!0&&_.d.push({key:D,description:oe,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return b.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Xj=_,e.$Yj=(0,T.$Gi)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,J,oe){return q<J?-1:q>J?1:D<oe?-1:D>oe?1:0}function ee(q,D){if(q.type===f.False||D.type===f.True)return!0;if(q.type===f.Or)return D.type===f.Or?X(q.expr,D.expr):!1;if(D.type===f.Or){for(const J of D.expr)if(ee(q,J))return!0;return!1}if(q.type===f.And){if(D.type===f.And)return X(D.expr,q.expr);for(const J of q.expr)if(ee(J,D))return!0;return!1}return q.equals(D)}function X(q,D){let J=0,oe=0;for(;J<q.length&&oe<D.length;){const Y=q[J].cmp(D[oe]);if(Y<0)return!1;Y===0&&J++,oe++}return J===q.length}function K(q){return q.type===f.Or?q.expr:[q]}}),define(ue[98],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Um=e.ID=void 0,e.$Vm=a,e.ID="diagnosticsService",e.$Um=(0,R.$Gi)(e.ID);function a(A){return!!A.hostName&&!!A.errorMessage}class N{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Wm=N}),define(ue[99],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0,e.$3o=(0,R.$Gi)("downloadService")}),define(ue[15],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,R.$Gi)("environmentService"),e.$Oi=(0,R.$Hi)(e.$Ni)}),define(ue[75],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$O7b=N;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function N(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$P7b=(0,R.$Gi)("IExtensionRecommendationNotificationService")}),define(ue[7],de([0,1,51,13,26,12,9,11,4,5,22,53]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Gl=e.FileKind=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.FileOperationResult=e.$yl=e.$xl=e.$wl=e.$ul=e.FileChangeType=e.$tl=e.FileOperation=e.$nl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$bl=void 0,e.$cl=f,e.$dl=E,e.$el=w,e.$fl=P,e.$gl=$,e.$hl=c,e.$il=h,e.$jl=i,e.$kl=n,e.$ll=t,e.$ml=s,e.$ol=u,e.$pl=b,e.$ql=L,e.$rl=S,e.$sl=v,e.$vl=H,e.$Hl=V,e.$Il=_,e.$Kl=le,e.$bl=(0,O.$Gi)("fileService");function f(ee){return ee.create===!0}var d;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var g;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function E(ee){const X=ee;return!!X&&typeof X.onDidChange=="function"}var m;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function w(ee){return!!(ee.capabilities&m.FileReadWrite)}function P(ee){return!!(ee.capabilities&m.FileFolderCopy)}function $(ee){return!!(ee.capabilities&m.FileClone)}function c(ee){return!!(ee.capabilities&m.FileOpenReadWriteClose)}function h(ee){return!!(ee.capabilities&m.FileReadStream)}function i(ee){return w(ee)?!!(ee.capabilities&m.FileAtomicRead):!1}function n(ee){return w(ee)?!!(ee.capabilities&m.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&m.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&m.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(X,K){const q=new o(X.toString(),K);return L(q,K),q}constructor(X,K){super(X),this.code=K}}e.$nl=o;function u(ee,X){return o.create(ee,X)}function b(ee){return ee||u((0,k.localize)(1856,null),r.Unknown)}function L(ee,X){return ee.name=X?`${X} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const X=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(ee){if(ee instanceof W)return ee.fileOperationResult;switch(S(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var C;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class U{constructor(X,K,q){this.resource=X,this.operation=K,this.target=q}isOperation(X){return this.operation===X}}e.$tl=U;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor(X,K){this.c=K,this.b=void 0,this.d=new p.$U(()=>{const q=R.$Mi.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new p.$U(()=>{const q=R.$Mi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new p.$U(()=>{const q=R.$Mi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of X){switch(q.type){case F.ADDED:this.rawAdded.push(q.resource);break;case F.UPDATED:this.rawUpdated.push(q.resource);break;case F.DELETED:this.rawDeleted.push(q.resource);break}this.b!==j.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(X,...K){return this.h(X,{includeChildren:!1},...K)}affects(X,...K){return this.h(X,{includeChildren:!0},...K)}h(X,K,...q){if(!X)return!1;const D=q.length>0;return!!((!D||q.includes(F.ADDED))&&(this.d.value.get(X)||K.includeChildren&&this.d.value.findSuperstr(X))||(!D||q.includes(F.UPDATED))&&(this.f.value.get(X)||K.includeChildren&&this.f.value.findSuperstr(X))||(!D||q.includes(F.DELETED))&&(this.g.value.findSubstr(X)||K.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$ul=j;function H(ee,X,K){return!ee||!X||ee===X||X.length>ee.length?!1:(X.charAt(X.length-1)!==a.sep&&(X+=a.sep),K?(0,N.$Hf)(ee,X):ee.indexOf(X)===0)}class W extends Error{constructor(X,K,q){super(X),this.fileOperationResult=K,this.options=q}}e.$wl=W;class x extends W{constructor(X,K,q,D){super(X,K,D),this.fileOperationResult=K,this.size=q}}e.$xl=x;class G extends W{constructor(X,K,q){super(X,te.FILE_NOT_MODIFIED_SINCE,q),this.stat=K}}e.$yl=G;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bl="files.associations",e.$Cl="files.exclude",e.$Dl="files.readonlyInclude",e.$El="files.readonlyExclude",e.$Fl="files.readonlyFromPermissions";var B;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Gl="";function V(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function _(ee,X){if(!X.hasProvider(T.URI.from({scheme:ee.scheme})))return new Promise(K=>{const q=X.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(q.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(X){return(0,A.$jg)(X)||(X=0),X<ne.KB?(0,k.localize)(1857,null,X.toFixed(0)):X<ne.MB?(0,k.localize)(1858,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,k.localize)(1859,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,k.localize)(1860,null,(X/ne.GB).toFixed(2)):(0,k.localize)(1861,null,(X/ne.TB).toFixed(2))}}e.$Jl=ne;function le(ee){const X=typeof ee=="string"||ee?.scheme===I.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===I.Schemas.file?1024*ne.MB:X?10*ne.MB:y.$p?50*ne.MB:1024*ne.MB}});var Q=this&&this.__param||function(ce,e){return function(R,a){e(R,a,ce)}};define(ue[164],de([0,1,76,50,7]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;let A=class{constructor(k){this.a=k}async checksum(k){const O=(await this.a.readFileStream(k)).value;return new Promise((y,I)=>{const p=(0,R.createHash)("sha256");(0,a.$Ge)(O,{onData:f=>p.update(f.buffer),onError:f=>I(f),onEnd:()=>y(p.digest("base64").replace(/=+$/,""))})})}};e.$Aic=A,e.$Aic=A=Se([Q(0,N.$bl)],A)}),define(ue[100],de([0,1,14,8,11,7]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=T;async function T(I,p,f,d,l,g){let E;try{await k(I,p,f,d,l,g)}catch(m){E=m}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&f.error(E),f.end()}}async function k(I,p,f,d,l,g){O(g);const E=await I.open(p,{create:!1});try{O(g);let m=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,$=R.$Oe.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,h=0;do w=await I.read(E,c,$.buffer,h,$.byteLength-h),c+=w,h+=w,m+=w,typeof P=="number"&&(P-=w),h===$.byteLength&&(await f.write(d($)),$=R.$Oe.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(w>0&&(typeof P!="number"||P>0)&&O(g)&&y(m,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),f.write(d($.slice(0,i)))}}catch(m){throw(0,A.$pl)(m)}finally{await I.close(E)}}function O(I){if(I.isCancellationRequested)throw(0,a.$6)();return!0}function y(I,p){if(typeof p?.limits?.size=="number"&&I>p.limits.size)throw(0,A.$ol)((0,N.localize)(1889,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ue[46],de([0,1,94,2,13,5,9,7]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=void 0,e.$7q=O,e.$8q=y,e.$_q=d,e.$ar=l,e.$br=g,e.$cr=E,e.$dr=w,e.$er=P;function O($){return typeof $.correlationId=="number"}function y($){return $.recursive===!0}class I extends a.$Vc{static{this.a=5}constructor(c,h,i,n){super(),this.h=c,this.j=h,this.m=i,this.n=n,this.c=this.B(new a.$Wc),this.f=void 0,this.g=0}s(){const c=new a.$Uc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(c,h){this.u(c,h)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${c}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${c}`):this.y(c)}u(c,h){return!(!this.n.restartOnError||h||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}w(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}y(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}z(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$9q=I;class p extends I{constructor(c,h,i){super(c,h,i,{type:"node.js",restartOnError:!1})}}e.$0q=p;class f extends I{constructor(c,h,i){super(c,h,i,{type:"universal",restartOnError:!0})}}e.$$q=f;function d($){return $.map(c=>({type:c.type,resource:T.URI.revive(c.resource),cId:c.cId}))}function l($){const c=new m;for(const h of $)c.processEvent(h);return c.coalesce()}function g($,c){return typeof c=="string"&&!c.startsWith(R.$xk)&&!(0,N.$jc)(c)?{base:$,pattern:c}:c}function E($,c){const h=[];for(const i of c)h.push((0,R.$Bk)(g($,i)));return h}class m{constructor(){this.a=new Set,this.b=new Map}c(c){return A.$l?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let i=!1;if(h){const n=h.type,t=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===k.FileChangeType.DELETED||c.type===k.FileChangeType.ADDED)?i=!0:n===k.FileChangeType.ADDED&&t===k.FileChangeType.DELETED?(this.b.delete(this.c(c)),this.a.delete(h)):n===k.FileChangeType.DELETED&&t===k.FileChangeType.ADDED?h.type=k.FileChangeType.UPDATED:n===k.FileChangeType.ADDED&&t===k.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(i=>i.type!==k.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>h.some(n=>(0,k.$vl)(i.resource.fsPath,n,!A.$l))?!1:(h.push(i.resource.fsPath),!0)).concat(c)}}function w($,c){if(typeof c=="number")switch($.type){case k.FileChangeType.ADDED:return(c&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(c&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(c&k.FileChangeFilter.UPDATED)===0}return!1}function P($){if(typeof $=="number"){const c=[];return $&k.FileChangeFilter.ADDED&&c.push("Added"),$&k.FileChangeFilter.DELETED&&c.push("Deleted"),$&k.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(ue[165],de([0,1,14,43,8,3,2,50,32,7,46]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=e.$wR=void 0,e.$wR="localFilesystem";class p extends T.$Vc{constructor(d,l){super(),this.a=d,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$me),this.onDidWatchError=this.g.event,this.h=(0,O.$3g)(),this.j()}get capabilities(){return this.c||(this.c=y.FileSystemProviderCapabilities.FileReadWrite|y.FileSystemProviderCapabilities.FileOpenReadWriteClose|y.FileSystemProviderCapabilities.FileReadStream|y.FileSystemProviderCapabilities.FileFolderCopy|y.FileSystemProviderCapabilities.FileWriteUnlock|y.FileSystemProviderCapabilities.FileAtomicRead|y.FileSystemProviderCapabilities.FileAtomicWrite|y.FileSystemProviderCapabilities.FileAtomicDelete|y.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=y.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=y.FileSystemProviderCapabilities.Trash)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,l){const{buffer:g}=await this.a.call("readFile",[d,l]);return g}readFileStream(d,l,g){const E=(0,k.$Ce)(w=>R.$Oe.concat(w.map(P=>R.$Oe.wrap(P))).buffer),m=new T.$Uc;return m.add(this.a.listen("readFileStream",[d,l])(w=>{if(w instanceof R.$Oe)E.write(w.buffer);else{if(w==="end")E.end();else{let P;if(w instanceof Error)P=w;else{const $=w;P=(0,y.$ol)($.message??(0,a.$rj)($),$.code??y.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}m.dispose()}})),m.add(g.onCancellationRequested(()=>{E.error((0,N.$6)()),E.end(),m.dispose()})),E}writeFile(d,l,g){return this.a.call("writeFile",[d,R.$Oe.wrap(l),g])}open(d,l){return this.a.call("open",[d,l])}close(d){return this.a.call("close",[d])}async read(d,l,g,E,m){const[w,P]=await this.a.call("read",[d,l,m]);return g.set(w.buffer.slice(0,P),E),P}write(d,l,g,E,m){return this.a.call("write",[d,l,R.$Oe.wrap(g),E,m])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,l){return this.a.call("delete",[d,l])}rename(d,l,g){return this.a.call("rename",[d,l,g])}copy(d,l,g){return this.a.call("copy",[d,l,g])}cloneFile(d,l){return this.a.call("cloneFile",[d,l])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const l=d;this.f.fire((0,I.$_q)(l))}else{const l=d;this.g.fire(l)}}))}watch(d,l){const g=(0,O.$3g)();return this.a.call("watch",[this.h,g,d,l]),(0,T.$Tc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$xR=p}),define(ue[166],de([0,1,33,2,46,3,7,9,6]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class y extends a.$Vc{constructor(){super(),this.a=this.B(new A.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$5c),this.m=new Set,this.n=this.B(new O.$Eh(this.y())),this.r=5007,this.s=new O.$4h,this.R=!1,this.B(this.f(p=>this.t(p)))}t(p){this.u(p)&&this.z(p)}u(p){return(0,N.$7q)(p)}async watch(p){this.s.isSettled||this.s.complete(),this.s=new O.$4h;try{this.h.clear(),this.g.clear();for(const f of p)this.u(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.w(!1)}finally{this.s.complete()}}w(p){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))]),p?this.y():0)}y(){return 800}isSuspended(p){return typeof p.correlationId!="number"?!1:this.m.has(p.correlationId)?"polling":this.j.has(p.correlationId)}async z(p){if(this.j.has(p.correlationId))return;const f=new a.$Uc;this.j.set(p.correlationId,f),await this.s.p,!f.isDisposed&&(this.D(p,f),this.w(!0))}C(p){this.j.deleteAndDispose(p.correlationId),this.m.delete(p.correlationId),this.w(!1)}D(p,f){this.F(p,f)?(this.P(`reusing an existing recursive watcher to monitor ${p.path}`),this.m.delete(p.correlationId)):(this.G(p,f),this.m.add(p.correlationId))}F(p,f){const d=this.O?.subscribe(p.path,(l,g)=>{f.isDisposed||(l?this.D(p,f):g?.type===T.FileChangeType.ADDED&&this.H(p))});return d?(f.add(d),!0):!1}G(p,f){let d=!1;const l=(g,E)=>{if(f.isDisposed)return;const m=this.I(g),w=this.I(E),P=d;d=m,!m&&(w||P)&&this.H(p)};this.P(`starting fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,R.watchFile)(p.path,{persistent:!1,interval:this.r},l)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${p.path} (correlationId: ${p.correlationId})`)}f.add((0,a.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,R.unwatchFile)(p.path,l)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${p.path} (correlationId: ${p.correlationId})`)}}))}H(p){this.P(`detected ${p.path} exists again, resuming watcher (correlationId: ${p.correlationId})`);const f={resource:k.URI.file(p.path),type:T.FileChangeType.ADDED,cId:p.correlationId};this.a.fire([f]),this.J(f,p),this.C(p)}I(p){return p.ctimeMs===0&&p.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(p,f){if(this.R){const d=` >> normalized ${p.type===T.FileChangeType.ADDED?"[ADDED]":p.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`;this.L(d,f)}}L(p,f){this.R&&this.P(`${p}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}M(p){return`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, filter: ${(0,N.$er)(p.filter)}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`}async setVerboseLogging(p){this.R=p}}e.$nr=y}),define(ue[167],de([0,1,33,6,25,41,2,91,13,5,20,9,146,30,7,46]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0,e.$tr=m;class E extends T.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,$,c,h,i,n){super(),this.s=P,this.t=$,this.u=c,this.w=h,this.y=i,this.z=n,this.c=this.B(new a.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new a.$Uh(t=>this.M(t),E.b)),this.g=(0,g.$cr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$cr)(this.s.path,this.s.includes):void 0,this.j=(0,g.$7q)(this.s)?this.s.filter:void 0,this.m=new N.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const $=await R.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,$.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let $=P.path;try{$=await d.Promises.realpath(P.path),P.path===$&&($=await(0,f.$pr)(P.path,this.m.token)??P.path),P.path!==$&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${$})`)}catch{}return $}async G(P,$){const c=new T.$Uc;return this.H(P,$,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,$,c)),c}H(P,$,c){if($)return!1;const h=p.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.G(P,$);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(P,$,c){if(y.$k&&(0,A.$Fg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new N.$xe(this.m.token);c.add((0,T.$Tc)(()=>h.dispose(!0)));const i=new T.$Uc;c.add(i);try{const n=p.URI.file(this.s.path),t=(0,O.$oc)(P),s=(0,R.watch)(P);i.add((0,T.$Tc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if($)try{for(const u of await d.Promises.readdir(P))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const o=new Map;i.add((0,T.$Tc)(()=>{for(const[,u]of o)u.dispose();o.clear()})),s.on("error",(u,b)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${u}, ${b})`),this.D())}),s.on("change",(u,b)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${b}`);let L="";if(b&&(L=b.toString(),y.$k&&(L=(0,k.$om)(L))),!(!L||u!=="change"&&u!=="rename"))if($)if(u==="rename"){o.get(L)?.dispose();const S=setTimeout(async()=>{if(o.delete(L),L===t&&!await d.Promises.exists(P)){this.J(n);return}if(h.token.isCancellationRequested)return;const v=await this.N((0,O.$kc)(P,L));if(h.token.isCancellationRequested)return;let C;v?r.has(L)?C=l.FileChangeType.UPDATED:(C=l.FileChangeType.ADDED,r.add(L)):(r.delete(L),C=l.FileChangeType.DELETED),this.L({resource:(0,I.$hh)(n,L),type:C,cId:this.s.correlationId})},E.a);o.set(L,(0,T.$Tc)(()=>clearTimeout(S)))}else{let S;r.has(L)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(L)),this.L({resource:(0,I.$hh)(n,L),type:S,cId:this.s.correlationId})}else if(u==="rename"||L!==t){const S=setTimeout(async()=>{const v=await d.Promises.exists(P);h.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,T.$Tc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,$=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!$&&this.g.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const $=(0,g.$ar)(P),c=[];for(const i of $){if((0,g.$dr)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(y.$l)return d.Promises.exists(P);try{const $=(0,O.$oc)(P);return(await d.Promises.readdir((0,O.$nc)(P))).some(h=>h===$)}catch($){return this.Q($),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$sr=E;async function m(w,P,$,c,h=512){const i=await d.Promises.open(w,"r"),n=Buffer.allocUnsafe(h),t=new N.$xe(c);let s,r=!1;const o={path:w,excludes:[],recursive:!1},u=new E(o,void 0,b=>{(async()=>{for(const{type:L}of b)if(L===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await d.Promises.read(i,n,0,h,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,$(),new Promise((b,L)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await d.Promises.close(i)}catch(S){s=new Error(S)}s?L(s):b()})})}}),define(ue[168],de([0,1,3,94,166,5,167,41]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class O extends N.$nr{constructor(I){super(),this.O=I,this.onDidError=R.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const p=[],f=new Set(Array.from(this.watchers));for(const d of I){const l=this.W(d);l&&(0,a.$Fk)(l.request.excludes,d.excludes)&&(0,a.$Fk)(l.request.includes,d.includes)?f.delete(l):p.push(d)}p.length&&this.P(`Request to start watching: ${p.map(d=>this.M(d)).join(",")}`),f.size&&this.P(`Request to stop watching: ${Array.from(f).map(d=>this.M(d.request)).join(",")}`);for(const d of f)this.Y(d);for(const d of p)this.X(d)}W(I){for(const p of this.watchers)if(typeof I.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===I.correlationId)return p}else if((0,k.$Eg)(p.request.path,I.path,!A.$l))return p}X(I){const p=new T.$sr(I,this.O,d=>this.a.fire(d),()=>this.c.fire(I),d=>this.b.fire(d),this.R),f={request:I,instance:p};this.watchers.add(f)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const p=new Map;for(const f of I){const d=A.$l?f.path:f.path.toLowerCase();let l=p.get(f.correlationId);l||(l=new Map,p.set(f.correlationId,l)),l.has(d)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(f)}`),l.set(d,f)}return Array.from(p.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const p of this.watchers)p.instance.setVerboseLogging(I)}P(I,p){this.R&&this.b.fire({type:"trace",message:this.bb(I,p)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,p){return p?`[File Watcher (node.js)] ${I} (${this.M(p.request)})`:`[File Watcher (node.js)] ${I}`}}e.$ur=O}),define(ue[169],de([0,1,46,168]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class N extends R.$0q{constructor(T,k,O){super(T,k,O),this.s()}r(T){return T.add(new a.$ur(void 0))}}e.$vr=N}),define(ue[170],de([0,1,22,42,96,46]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class T extends A.$$q{constructor(O,y,I){super(O,y,I),this.s()}r(O){const y=O.add(new N.$lr(R.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return O.add(y.onDidProcessExit(({code:I,signal:p})=>this.t(`terminated by itself with code ${I}, signal: ${p} (ETERM)`))),a.ProxyChannel.toService((0,a.$ni)(y.getChannel("watcher")))}}e.$mr=T}),define(ue[77],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class R{constructor(...N){this.a=new Map;for(const[A,T]of N)this.set(A,T)}set(N,A){const T=this.a.get(N);return this.a.set(N,A),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Ei=R}),define(ue[171],de([0,1,6,8,2,74,162,4,77,90]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;const I=!1;class p extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class f{constructor(E=new O.$Ei,m=!1,w,P=I){this.i=E,this.j=m,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Fi,this),this._globalGraph=P?w?._globalGraph??new T.$yr($=>$):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Qc)(this.h),this.h.clear();for(const E of this.g)(0,N.$Pc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,m){this.m();const w=this,P=new class extends f{dispose(){w.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),m?.add(P),P}invokeFunction(E,...m){this.m();const w=l.traceInvocation(this.l,E);let P=!1;try{return E({get:c=>{if(P)throw(0,a.$8)("service accessor is only valid during the invocation of its target method");const h=this.s(c,w);if(!h)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...m)}finally{P=!0,w.stop()}}createInstance(E,...m){this.m();let w,P;return E instanceof A.$Di?(w=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(m),w)):(w=l.traceCreation(this.l,E),P=this.o(E,m,w)),w.stop(),P}o(E,m=[],w){const P=k._util.getServiceDependencies(E).sort((h,i)=>h.index-i.index),$=[];for(const h of P){const i=this.s(h.id,w);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${h.id}.`,!1),$.push(i)}const c=P.length>0?P[0].index:m.length;if(m.length!==c){console.trace(`[createInstance] First service dependency of ${E.name} at position ${c+1} conflicts with ${m.length} static arguments`);const h=c-m.length;h>0?m=m.concat(new Array(h)):m=m.slice(0,c)}return Reflect.construct(E,m.concat($))}q(E,m){if(this.i.get(E)instanceof A.$Di)this.i.set(E,m);else if(this.k)this.k.q(E,m);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const m=this.i.get(E);return!m&&this.k?this.k.r(E):m}s(E,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const w=this.r(E);return w instanceof A.$Di?this.u(E,w,m.branch(E,!0)):(m.branch(E,!1),w)}u(E,m,w){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,m,w)}finally{this.t.delete(E)}}v(E,m,w){const P=new T.$yr(i=>i.id.toString());let $=0;const c=[{id:E,desc:m,_trace:w}],h=new Set;for(;c.length;){const i=c.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),$++>1e3)throw new p(P);for(const n of k._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof A.$Di){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),c.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new p(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof A.$Di){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,m,w=[],P,$){if(this.i.get(E)instanceof A.$Di)return this.x(E,m,w,P,$,this.g);if(this.k)return this.k.w(E,m,w,P,$);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}x(E,m,w=[],P,$,c){if(P){const h=new f(void 0,this.j,this,this.l);h.c=String(E);const i=new Map,n=new R.$Zh(()=>{const t=h.o(m,w,$);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const u of r)u.disposable=o.apply(t,u.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=i.get(s);return u||(u=new y.$6c,i.set(s,u)),(L,S,v)=>{if(n.isInitialized)return n.value[s](L,S,v);{const C={listener:[L,S,v],disposable:void 0},U=u.push(C);return(0,N.$Tc)(()=>{U(),C.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return m.prototype}})}else{const h=this.o(m,w,$);return c.add(h),h}}y(E,m){if(m&&console.warn(E),this.j)throw new Error(E)}}e.$zr=f;var d;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(d||(d={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(d.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,m){return E?new l(d.Invocation,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,m){return E?new l(d.Creation,m.name):l.c}static{this.f=0}constructor(E,m){this.type=E,this.name=m,this.g=Date.now(),this.h=[]}branch(E,m){const w=new l(d.Branch,E.toString());return this.h.push([E,m,w]),w}stop(){const E=Date.now()-this.g;l.f+=E;let m=!1;function w($,c){const h=[],i=new Array($+1).join("	");for(const[n,t,s]of c.h)if(t&&s){m=!0,h.push(`${i}CREATES -> ${n}`);const r=w($+1,s);r&&h.push(r)}else h.push(`${i}uses -> ${n}`);return h.join(`
`)}const P=[`${this.type===d.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||m)&&l.all.add(P.join(`
`))}}e.$Ar=l}),define(ue[56],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0,e.$dic=(0,R.$Gi)("mainProcessService");class a{constructor(A,T){this.a=A,this.b=T}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,T){this.a.registerChannel(A,T)}}e.$eic=a}),define(ue[10],de([0,1,11,43,3,55,2,31,5,20,12,9,97,4]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=g,e.log=m,e.$pk=o,e.$qk=u,e.$rk=b,e.$sk=L,R=Oe(R),e.$bk=(0,d.$Gi)("logService"),e.$ck=(0,d.$Gi)("loggerService");function l(){return new Date().toISOString()}function g(S){return(0,I.$jg)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$ek=E.Info;function m(S,v,C){switch(v){case E.Trace:S.trace(C);break;case E.Debug:S.debug(C);break;case E.Info:S.info(C);break;case E.Warning:S.warn(C);break;case E.Error:S.error(C);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function w(S,v=!1){let C="";for(let U=0;U<S.length;U++){let F=S[U];if(F instanceof Error&&(F=(0,a.$rj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}C+=(U>0?" ":"")+F}return C}class P extends T.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new N.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$gk=P;class $ extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(E.Trace)&&this.g(E.Trace,w([v,...C],!0))}debug(v,...C){this.f(E.Debug)&&this.g(E.Debug,w([v,...C]))}info(v,...C){this.f(E.Info)&&this.g(E.Info,w([v,...C]))}warn(v,...C){this.f(E.Warning)&&this.g(E.Warning,w([v,...C]))}error(v,...C){if(this.f(E.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(E.Error,w(U))}else this.g(E.Error,w([v,...C]))}flush(){}}e.$hk=$;class c extends P{constructor(v=e.$ek){super(),this.setLevel(v),this.g=!O.$j}trace(v,...C){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}debug(v,...C){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}info(v,...C){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...C):console.log(`[main ${l()}]`,v,...C))}warn(v,...C){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...C):console.warn(`[main ${l()}]`,v,...C))}error(v,...C){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...C):console.error(`[main ${l()}]`,v,...C))}flush(){}}e.$ik=c;class h extends P{constructor(v=e.$ek,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}flush(){}}e.$jk=h;class i extends P{constructor(v,C=e.$ek){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...C])}debug(v,...C){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...C])}info(v,...C){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...C])}warn(v,...C){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...C])}error(v,...C){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,a.$rj)(v,this.f(E.Trace))}flush(){}}e.$kk=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const U of this.g)U.trace(v,...C)}debug(v,...C){for(const U of this.g)U.debug(v,...C)}info(v,...C){for(const U of this.g)U.info(v,...C)}warn(v,...C){for(const U of this.g)U.warn(v,...C)}error(v,...C){for(const U of this.g)U.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$lk=n;class t extends T.$Vc{constructor(v,C,U){if(super(),this.h=v,this.j=C,this.b=new k.$Bc,this.c=this.B(new N.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$me),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,I.$fg)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const U=this.n(v),F=(0,I.$fg)(v)?v:C?.id??(0,A.$uj)(U.toString()).toString(16);let j=this.b.get(U)?.logger;const H=C?.logLevel==="always"?E.Trace:C?.logLevel;j||(j=this.s(U,H??this.getLogLevel(U)??this.h,{...C,id:F}));const W={logger:j,info:{resource:U,id:F,logLevel:H,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(W.info),this.b.set(U,W),j}n(v){return(0,I.$fg)(v)?(0,y.$hh)(this.j,`${v}.log`):v}setLogLevel(v,C){if(p.URI.isUri(v)){const U=v,F=C,j=this.b.get(U);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const U=this.m(v);U&&C!==!U.info.hidden&&(U.info.hidden=!C,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=t;class s{constructor(){this.onDidChangeLogLevel=new N.$me().event}setLevel(v){}getLevel(){return E.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$nk=s;class r extends s{}e.$ok=r;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=L(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ek}function u(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function b(S){switch(S){case E.Trace:return{original:"Trace",value:R.localize(1950,null)};case E.Debug:return{original:"Debug",value:R.localize(1951,null)};case E.Info:return{original:"Info",value:R.localize(1952,null)};case E.Warning:return{original:"Warning",value:R.localize(1953,null)};case E.Error:return{original:"Error",value:R.localize(1954,null)};case E.Off:return{original:"Off",value:R.localize(1955,null)}}}function L(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$tk=new f.$Xj("logLevel",u(E.Info))}),define(ue[172],de([0,1,6,8,2,22,13,20,30,15,10]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;let p=class extends N.$Vc{constructor(d,l){super(),this.a=d,this.b=l,this.B(new R.$Sh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const d=(0,k.$eh)(this.a.logsHome),l=(0,k.$gh)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,m=(await O.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==d),w=m.slice(0,Math.max(0,m.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>O.Promises.rm((0,T.$kc)(l,P)))))}catch(d){(0,a.$Z)(d)}}};e.$xic=p,e.$xic=p=Se([Q(0,y.$Ni),Q(1,I.$bk)],p)}),define(ue[173],de([0,1,17,6,8,3,41,2,13,46,10]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class p extends k.$Vc{constructor(d,l){super(),this.a=d,this.b=l,this.c=this.B(new A.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Eh(0)),this.w=[],this.y=this.B(new a.$Eh(0))}watch(d,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(d,l):this.z(d,l)}n(d,l){const g={path:this.J(d),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Tb)(this.j,g);return this.r(),(0,k.$Tc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,N.$Z)(d))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,y.$_q)(l)),l=>this.G(l),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const l of this.j)(0,y.$8q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const l of this.j)(0,y.$8q)(l)&&d.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,l){const g={path:this.J(d),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Tb)(this.w,g);return this.C(),(0,k.$Tc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,N.$Z)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,y.$_q)(d)),d=>this.G(d),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.H(d)}H(d){this.a[d.type](d.message)}I(d){return(0,O.$ic)(d.fsPath)}J(d){const l=this.I(d);return(0,T.$Ig)(l)}}e.$fr=p}),define(ue[174],de([0,1,17,6,14,25,3,55,63,2,51,22,101,20,50,11,7,100,10,8]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let c=class extends y.$Vc{static{$=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$me),this.Y=this.B(new T.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Ph)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${i}`);const t=new y.$Uc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$ul(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,y.$Tc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,y.$Qc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return O.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,d.$lh)(i))throw new E.$wl((0,g.localize)(1862,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$bb;throw t.message=(0,g.localize)(1863,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$hl)(n)||(0,E.$el)(n)||(0,E.$il)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$hl)(n)||(0,E.$el)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$rl)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$wl((0,g.localize)(1864,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$pl)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,b=await t.stat(i);let L;return this.t(t,i,b,void 0,!!u,(S,v)=>(L||(L=I.$Mi.forUris(()=>!s),L.set(i,!0),r&&L.fill(!0,r)),L.get(S.resource)||L.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?v===1:!1))}async t(i,n,t,s,r,o){const{providerExtUri:u}=this.R(i),b={resource:n,name:u.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Hl)({mtime:t.mtime,size:t.size}),children:void 0};if(b.isDirectory&&o(b,s)){try{const L=await i.readdir(n),S=await a.Promises.settled(L.map(async([v,C])=>{try{const U=u.joinPath(n,v),F=r?await i.stat(U):{type:C};return await this.t(i,U,F,L.length,r,o)}catch(U){return this.b.trace(U),null}}));b.children=(0,R.$Hb)(S)}catch(L){this.b.trace(L),b.children=[]}return b}return b}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$wl((0,g.localize)(1865,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=N.$Oe.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$tl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let o=t;if((0,E.$kl)(s)&&!o?.atomic){const u=s.enforceAtomicWriteFile?.(i);u&&(o={...t,atomic:u})}try{await this.w(s,i,o)||await this.U(s,r.dirname(i));let b;if((0,E.$el)(s)&&!(n instanceof N.$Oe))if((0,l.$Ae)(n)){const L=await(0,l.$He)(n,3);L.ended?b=N.$Oe.concat(L.buffer):b=L}else b=(0,l.$Ee)(n,L=>N.$Oe.concat(L),3);else b=n;!(0,E.$hl)(s)||(0,E.$el)(s)&&b instanceof N.$Oe||(0,E.$el)(s)&&(0,E.$kl)(s)&&o?.atomic?await this.hb(s,i,o,b):await this.db(s,i,o,b instanceof N.$Oe?(0,N.$Ze)(b):b),this.r.fire(new E.$tl(i,E.FileOperation.WRITE))}catch(u){throw new E.$wl((0,g.localize)(1866,null,this.sb(i),(0,E.$pl)(u).toString()),(0,E.$sl)(u),o)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(1867,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(1868,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(1869,null,this.sb(n)));if(s)throw new Error((0,g.localize)(1870,null,this.sb(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&E.FileType.Directory)throw new E.$wl((0,g.localize)(1871,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Gl&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,E.$Hl)({mtime:t.mtime,size:o.size}))throw new E.$wl((0,g.localize)(1872,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,o)=>{this.cb.queueFor(n,async()=>{try{const u=await this.C(i,n,t,s);r(u)}catch(u){o(u)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,N.$1e)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new A.$xe(s);let o=t;(0,E.$jl)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const u=this.J(n,o).then(L=>L,L=>{throw r.dispose(!0),L});let b;try{return typeof o?.etag=="string"&&o.etag!==E.$Gl&&await u,o?.atomic&&(0,E.$jl)(i)||!((0,E.$hl)(i)||(0,E.$il)(i))||(0,E.$el)(i)&&o?.preferUnbuffered?b=this.I(i,n,o):(0,E.$il)(i)?b=this.G(i,n,r.token,o):b=this.H(i,n,r.token,o),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await u,value:b}}catch(L){throw b&&await(0,l.$Fe)(b),this.F(L,n,o)}}F(i,n,t){const s=(0,g.localize)(1873,null,this.sb(n),(0,E.$pl)(i).toString());return i instanceof E.$yl?new E.$yl(s,i.stat,t):i instanceof E.$xl?new E.$xl(s,i.fileOperationResult,i.size,i.options):new E.$wl(s,(0,E.$sl)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Le)(r,{data:o=>o instanceof N.$Oe?o:N.$Oe.wrap(o),error:o=>this.F(o,n,s)},o=>N.$Oe.concat(o))}H(i,n,t,s=Object.create(null)){const r=(0,N.$5e)();return(0,m.$5q)(i,n,r,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.F(o,n,s)},t),r}I(i,n,t){const s=(0,l.$Ce)(r=>N.$Oe.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$jl)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(N.$Oe.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$wl((0,g.localize)(1874,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Gl&&n.etag===t.etag)throw new E.$yl((0,g.localize)(1875,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$xl((0,g.localize)(1876,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),o=this.qb(await this.n(n),n);await this.Q(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"move",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$tl(i,o==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,u)),u}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"copy",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$tl(i,o==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,u)),u}async N(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:b}=await this.Q(i,n,t,s,r,o);if(u&&!b&&o&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$fl)(i))await i.copy(n,s,{overwrite:o});else{const L=await this.resolve(n);L.isDirectory?await this.P(i,L,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.N(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$hl)(i)&&(0,E.$hl)(t))return this.jb(i,n,t,s);if((0,E.$hl)(i)&&(0,E.$el)(t))return this.pb(i,n,t,s);if((0,E.$el)(i)&&(0,E.$hl)(t))return this.nb(i,n,t,s);if((0,E.$el)(i)&&(0,E.$el)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,o):this.O(i,r.resource,t,o)}))}async Q(i,n,t,s,r,o){let u=!1;if(i===t){const{providerExtUri:L,isPathCaseSensitive:S}=this.R(i);if(S||(u=L.isEqual(n,s)),u&&r==="copy")throw new Error((0,g.localize)(1877,null,this.sb(n),this.sb(s)));if(!u&&L.isEqualOrParent(s,n))throw new Error((0,g.localize)(1878,null,this.sb(n),this.sb(s)))}const b=await this.exists(s);if(b&&!u){if(!o)throw new E.$wl((0,g.localize)(1879,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(n,s))throw new Error((0,g.localize)(1880,null,this.sb(n),this.sb(s)))}}return{exists:b,isSameResourceWithDifferentPathCase:u}}R(i){const n=this.S(i);return{providerExtUri:n?d.$0g:d.$_g,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$tl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,g.localize)(1881,null,this.sb(n)));break}catch(r){if((0,E.$rl)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,E.$rl)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(1882,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(1883,null,this.sb(i)));if(s&&r)throw new Error((0,g.localize)(1884,null,this.sb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.rb(i,o);else throw new E.$wl((0,g.localize)(1885,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const b=await this.resolve(i);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,g.localize)(1886,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$ll)(t)&&!s?.atomic){const b=t.enforceAtomicDelete?.(i);b&&(s={...n,atomic:b})}const r=!!s?.useTrash,o=!!s?.recursive,u=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:u}),this.r.fire(new E.$tl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$gl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$fl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:$.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new y.$Uc;let s=!1,r=()=>{s=!0};t.add((0,y.$Tc)(()=>r())),(async()=>{try{const u=await this.bb(i,n);s?(0,y.$Qc)(u):r=()=>(0,y.$Qc)(u)}catch(u){this.b.error(u)}})();const o=n.correlationId;if(typeof o=="number"){const u=t.add(new T.$me);return t.add(this.X.event(L=>{L.correlates(o)&&u.fire(L)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,k.$uj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,y.$Tc)(()=>{r&&(r.count--,r.count===0&&((0,y.$Qc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,y.$Qc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$Ae)(s)||(0,l.$Be)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(o){throw(0,E.$pl)(o)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$Be)(t)){if(t.buffer.length>0){const o=N.$Oe.concat(t.buffer);await this.gb(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,u)=>{(0,l.$Ge)(r,{onData:async b=>{r.pause();try{await this.gb(i,n,b,b.byteLength,s,0)}catch(L){return u(L)}s+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>u(b),onEnd:()=>o()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,o){let u=0;for(;u<s;){const b=await i.write(n,r+u,t.buffer,o+u,s-u);u+=b}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof N.$Oe?r=s:(0,l.$Ae)(s)?r=await(0,N.$1e)(s):(0,l.$Be)(s)?r=await(0,N.$2e)(s):r=(0,N.$Ye)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const u=N.$Oe.alloc(this.a);let b=0,L=0,S=0;do S=await i.read(r,b,u.buffer,L,u.byteLength-L),await this.gb(t,o,u,S,b,L),b+=S,L+=S,L===u.byteLength&&(L=0);while(S>0)}catch(u){throw(0,E.$pl)(u)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.gb(t,r,N.$Oe.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.$pl)(o)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,N.$1e)(this.H(i,n,A.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$wl((0,g.localize)(1887,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$wl((0,g.localize)(1888,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}};e.$6q=c,e.$6q=c=$=Se([Q(0,w.$bk)],c)}),define(ue[175],de([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,100,173,170,169]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class $ extends m.$fr{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=T.Event.None,this.P=new N.$Bc(n=>p.$$g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:n}=await d.SymlinkSupport.stat(this.I(h));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await d.Promises.readdir(this.I(h),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,p.$hh)(h,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(h,i){let n;return i?.dangling?n=g.FileType.Unknown:h.isFile()?n=g.FileType.File:h.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.$Fh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,O.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),n=await this.Q(h));const t=this.I(h);return await R.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(h){$.L&&this.a.trace(h)}readFileStream(h,i,n){const t=(0,f.$Ce)(s=>A.$Oe.concat(s.map(r=>A.$Oe.wrap(r))).buffer);return(0,E.$5q)(this,h,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(h,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(h)?this.U(h,(0,p.$hh)((0,p.$gh)(h),`${(0,p.$eh)(h)}${n.atomic.postfix}`),i,n):this.W(h,i,n)}async S(h){try{const i=this.I(h),{symbolicLink:n}=await d.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(h,i,n,t){const s=new O.$Uc;try{s.add(await this.Q(h)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(h,i,n,t){let s;try{const r=this.I(h);if(!n.create||!n.overwrite){if(await d.Promises.exists(r)){if(!n.overwrite)throw(0,g.$ol)((0,l.localize)(1892,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$ol)((0,l.localize)(1893,null),g.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(h,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(h){$.$=h}async open(h,i,n){const t=this.I(h);let s;(0,g.$cl)(i)&&!n&&(s=await this.Q(h));let r;try{if((0,g.$cl)(i)&&i.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await R.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let o;if((0,g.$cl)(i)){if(I.$j)try{await R.promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}o||(o="w")}else o="r";r=await d.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,g.$cl)(i)?await this.ib(h,o):this.hb(o)}if(this.X.set(r,0),(0,g.$cl)(i)&&this.Z.set(r,h),s){const o=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&$.$)try{await d.Promises.fdatasync(h)}catch(n){$.configureFlushOnWrite(!1),this.a.error(n)}return await d.Promises.close(h)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await d.Promises.read(h,n,t,s,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,o)}return o}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,n){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(h,t+n):this.X.delete(h)))}async write(h,i,n,t,s){return(0,a.$1h)(()=>this.cb(h,i,n,t,s),100,3)}async cb(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await d.Promises.write(h,n,t,s,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,o)}return o}async mkdir(h){try{await R.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const n=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,y.$kc)((0,y.$nc)(n),`${(0,y.$oc)(n)}${i.atomic.postfix}`)),await d.Promises.rm(n,d.RimRafMode.MOVE,t)}else try{await R.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await d.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await R.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"move",n.overwrite),await d.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1894,null,(0,y.$oc)(t),(0,y.$oc)((0,y.$nc)(s)),r.toString()))),this.hb(r)}}async copy(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"copy",n.overwrite),await d.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1895,null,(0,y.$oc)(t),(0,y.$oc)((0,y.$nc)(s)),r.toString()))),this.hb(r)}}async db(h,i,n,t){const s=this.I(h),r=this.I(i);let o=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,k.$Eg)(s,r,!0)),o){if(n==="copy")throw(0,g.$ol)((0,l.localize)(1896,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const b=await this.N(h);if(!b)throw(0,g.$ol)((0,l.localize)(1897,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!t)throw(0,g.$ol)((0,l.localize)(1898,null),g.FileSystemProviderErrorCode.FileExists);b.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,n){const t=this.I(h),s=this.I(i),r=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.$Eg)(t,s,!r))return;const o=new O.$Uc;try{o.add(await this.Q(h)),o.add(await this.Q(i)),n&&await R.promises.mkdir((0,y.$nc)(s),{recursive:!0}),await R.promises.copyFile(t,s)}catch(u){if(u.code==="ENOENT"&&!n)return this.eb(h,i,!0);throw this.hb(u)}finally{o.dispose()}}t(h,i,n){return new w.$mr(t=>h(t),t=>i(t),n)}F(h,i,n){return new P.$vr(t=>h(t),t=>i(t),n)}hb(h){if(h instanceof g.$nl)return h;let i=h,n;switch(h.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$ol)(i,n)}async ib(h,i){let n=this.hb(i);if(h&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.I(h));t.mode&128||(n=(0,g.$ol)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$wr=$}),define(ue[102],de([0,1,3,2,4,10]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=e.$Wic=void 0,e.$Wic=(0,N.$Gi)("sharedProcessLifecycleService");let T=class extends a.$Vc{constructor(O){super(),this.b=O,this.a=this.B(new R.$me),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Xic=T,e.$Xic=T=Se([Q(0,A.$bk)],T)}),define(ue[176],de([0,1,9,3,10,2]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=void 0;class T extends N.$mk{constructor(p,f,d,l,g){super(f,d,l),this.r=p,this.t=g,this.B(g.listen("onDidChangeLogLevel",p)(E=>{(0,N.$dk)(E)?super.setLogLevel(E):super.setLogLevel(R.URI.revive(E[0]),E[1])})),this.B(g.listen("onDidChangeVisibility",p)(([E,m])=>super.setVisibility(R.URI.revive(E),m))),this.B(g.listen("onDidChangeLoggers",p)(({added:E,removed:m})=>{for(const w of E)super.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of m)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new N.$kk({log:(p,f)=>{this.t.call("consoleLog",[p,f])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,f){super.setLogLevel(p,f),this.t.call("setLogLevel",[p,f])}setVisibility(p,f){super.setVisibility(p,f),this.t.call("setVisibility",[this.n(p),f])}s(p,f,d){return new k(this.t,p,f,d,this.r)}static setLogLevel(p,f,d){return p.call("setLogLevel",[f,d])}}e.$ws=T;class k extends N.$hk{constructor(p,f,d,l,g){super(l?.logLevel==="always"),this.r=p,this.s=f,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[f,l,g]).then(()=>{this.u(this.n),this.m=!0})}g(p,f){const d=[[p,f]];this.m?this.u(d):this.n.push(...d)}u(p){this.r.call("log",[this.s,p])}}class O{constructor(p,f){this.a=p,this.b=f}listen(p,f){const d=this.b(p);switch(f){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(g=>this.c(g,d)),removed:[...l.removed].map(g=>this.c(g,d))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[d.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,N.$dk)(l)?l:[d.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${f}`)}async call(p,f,d){const l=this.b(p);switch(f){case"setLogLevel":return(0,N.$dk)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(R.URI.revive(l.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,l)))}throw new Error(`Call not found: ${f}`)}c(p,f){return{...p,resource:f.transformOutgoingURI(p.resource)}}}e.$xs=O;class y extends A.$Vc{constructor(p,f){super(),f.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(d=>f.call("setLogLevel",[d]))),f.call("getRegisteredLoggers").then(d=>{for(const l of d)p.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this.B(f.listen("onDidChangeVisibility")(([d,l])=>p.setVisibility(R.URI.revive(d),l))),this.B(f.listen("onDidChangeLoggers")(({added:d,removed:l})=>{for(const g of d)p.registerLogger({...g,resource:R.URI.revive(g.resource)});for(const g of l)p.deregisterLogger(g.resource)}))}}e.$ys=y}),define(ue[177],de([0,1,2,10]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class N extends R.$Vc{constructor(T,k=[]){super(),this.a=new a.$lk([T,...k]),this.B(T.onDidChangeLogLevel(O=>this.setLevel(O)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.$OR=N}),define(ue[57],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0,e.$Xgc=(0,R.$Gi)("nativeHostService")}),define(ue[178],de([0,1,42,56]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;let N=class{constructor(T,k){return this.windowId=T,R.ProxyChannel.toService(k.getChannel("nativeHost"),{context:T,properties:(()=>{const O=new Map;return O.set("windowId",T),O})()})}};e.$gic=N,e.$gic=N=Se([Q(1,a.$dic)],N)}),define(ue[58],de([0,1,3,63,2,4]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,A.$Gi)("policy");class T extends N.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const I=Object.keys(this.f).length;return this.f={...y,...this.f},I!==Object.keys(this.f).length&&await this.j(y),a.Iterable.reduce(this.g.entries(),(p,[f,d])=>({...p,[f]:d}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(y,[I,p])=>({...y,[I]:{definition:p,value:this.g.get(I)}}),{})}}e.$vo=T;class k{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$wo=k}),define(ue[179],de([0,1,3,2,58]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0;class A{constructor(O){this.b=O,this.a=new a.$Uc}listen(O,y){switch(y){case"onDidChange":return R.Event.map(this.b.onDidChange,I=>I.reduce((p,f)=>({...p,[f]:this.b.getPolicyValue(f)??null}),{}),this.a)}throw new Error(`Event not found: ${y}`)}call(O,y,I){switch(y){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${y}`)}dispose(){this.a.dispose()}}e.$Jhc=A;class T extends N.$vo{constructor(O,y){super(),this.a=y;for(const I in O){const{definition:p,value:f}=O[I];this.f[I]=p,f!==void 0&&this.g.set(I,f)}this.a.listen("onDidChange")(I=>{for(const p in I){const f=I[p];f===null?this.g.delete(p):this.g.set(p,f)}this.h.fire(Object.keys(I))})}async j(O){const y=await this.a.call("updatePolicyDefinitions",O);for(const I in y)this.g.set(I,y[I])}}e.$Khc=T}),define(ue[103],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const A=N.context.configuration();if(A)a=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:A.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(ue[23],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,R.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"}),define(ue[180],de([0,1,33,6,8,2,13,30,10,23]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0,R=Oe(R);let I=class extends A.$Vc{constructor(f,d,l){super(),this.b=d,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,f&&this.B(new a.$Sh(()=>{this.f(f)},3e4)).schedule()}async f(f){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),l=(0,T.$nc)(f),g=(0,T.$oc)(f),E=await k.Promises.readdir(l);await Promise.all(E.map(async m=>{if(m===g)return;const w=(0,T.$kc)(l,m),P=await R.promises.stat(w);if(P.isDirectory()&&d-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${m}.`),k.Promises.rm(w)}))}catch(d){(0,N.$Z)(d)}}};e.$uic=I,e.$uic=I=Se([Q(1,y.$uk),Q(2,O.$bk)],I)}),define(ue[181],de([0,1,33,6,8,2,13,30,15,10,23]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0,R=Oe(R);let p=class extends A.$Vc{constructor(d,l,g){super(),this.b=d,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new a.$Sh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),l=JSON.parse(await R.promises.readFile((0,T.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const $=l[P];d[`${$.hash}.${P}`]=!0}const g=(0,T.$kc)(this.b.userDataPath,"clp");if(!await k.Promises.exists(g))return;const m=await k.Promises.readdir(g);for(const P of m){if(d[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await k.Promises.rm((0,T.$kc)(g,P))}const w=Date.now();for(const P of Object.keys(d)){const $=(0,T.$kc)(g,P),c=await k.Promises.readdir($);for(const h of c){if(h==="tcf.json")continue;const i=(0,T.$kc)($,h),n=await R.promises.stat(i);n.isDirectory()&&w-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.$kc)(P,h)}`),await k.Promises.rm(i))}}}catch(d){(0,N.$Z)(d)}}};e.$vic=p,e.$vic=p=Se([Q(0,O.$Oi),Q(1,y.$bk),Q(2,I.$uk)],p)}),define(ue[182],de([0,1,13,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$3G=void 0,e.$3G=(0,a.$Gi)("IV8InspectProfilingService");var N;(function(A){function T(O){return!!(O.samples&&O.timeDeltas)}A.isValidProfile=T;function k(O,y="noAbsolutePaths"){for(const I of O.nodes)I.callFrame&&I.callFrame.url&&((0,R.$jc)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,R.$kc)(y,(0,R.$oc)(I.callFrame.url)));return O}A.rewriteAbsolutePaths=k})(N||(e.Utils=N={}))}),define(ue[183],de([0,1,32]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class a{constructor(){this.a=new Map}async startProfiling(A){const k=await(await new Promise((y,I)=>{ce(["v8-inspect-profiler"],y,I)}).then(Oe)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),O=(0,R.$3g)();return this.a.set(O,k),O}async stopProfiling(A){const T=this.a.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const k=await T.stop();return this.a.delete(A),k.profile}}e.$Mic=a}),define(ue[44],de([0,1,132,12]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,R=Oe(R),a=Oe(a);class N{constructor(){this.a=new Map}add(T,k){R.ok(a.$fg(T)),R.ok(a.$hg(k)),R.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$so=new N}),define(ue[104],de([0,1,3,133,44]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,N=Oe(N),e.$to={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class T{constructor(){this.b=new R.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,I){this.a[A(y)]=I,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(y){const I=this.a[y];return I?(0,a.$9j)(I):void 0}hasSchemaContent(y){return!!this.a[y]}}const k=new T;N.$so.add(e.$to.JSONContribution,k)}),define(ue[47],de([0,1,17,3,12,11,21,104,44]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=g,e.$Jo=E,e.$Ko=m,e.$Lo=P,e.$Mo=$,e.$No=c,e.$Oo=h,N=Oe(N),A=Oe(A);var y;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$xo={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const p=O.$so.as(k.$to.JSONContribution);class f{constructor(){this.a=[],this.i=new Set,this.j=new a.$me,this.onDidSchemaChange=this.j.event,this.k=new a.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},p.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),p.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),p.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),p.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const u in r){t.add(u);const b=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),L=r[u];if(b.configurationDefaultOverrides.push({value:L,source:o}),e.$Ho.test(u)){const S=this.o(u,L,o,b.configurationDefaultOverrideValue);if(!S)continue;b.configurationDefaultOverrideValue=S,this.n(u,S,o),s.push(...g(u))}else{const S=this.p(u,L,o,b.configurationDefaultOverrideValue);if(!S)continue;b.configurationDefaultOverrideValue=S;const v=this.e[u];v&&(this.A(u,v),this.w(u,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const u=this.b.get(o);if(!u)continue;const b=u.configurationDefaultOverrides.findIndex(L=>r?L.source?.id===r.id:L.value===s[o]);if(b!==-1){if(u.configurationDefaultOverrides.splice(b,1),u.configurationDefaultOverrides.length===0&&this.b.delete(o),e.$Ho.test(o)){let L;for(const S of u.configurationDefaultOverrides)L=this.o(o,S.value,S.source,L);L&&!N.$sg(L.value)?(u.configurationDefaultOverrideValue=L,this.n(o,L,r)):(this.b.delete(o),delete this.e[o],delete this.c.properties[o])}else{let L;for(const v of u.configurationDefaultOverrides)L=this.p(o,v.value,v.source,L);u.configurationDefaultOverrideValue=L;const S=this.e[o];S&&(this.A(o,S),this.w(o,S))}t.add(o)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:A.localize(1654,null,(0,T.$kj)(n)),$ref:e.$Eo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const o=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const b of Object.keys(t)){const L=t[b];if(N.$hg(L)&&(N.$mg(o[b])||N.$hg(o[b]))){if(o[b]={...o[b]??{},...L},s)for(const v in L)u.set(`${b}.${v}`,s)}else o[b]=L,s?u.set(b,s):u.delete(b)}return{value:o,source:u}}p(n,t,s,r){const o=this.e[n],u=r?.value??o?.defaultDefaultValue;let b=s;if(N.$hg(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(N.$mg(u)||N.$hg(u)))){if(b=r?.source??new Map,!(b instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&b.set(`${n}.${S}`,s);t={...N.$hg(u)?u:{},...t}}return{value:t,source:b}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const u=this.e[o];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[o],this.x(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.d.indexOf(r);o!==-1&&this.d.splice(o,1)}}u(n,t=!0,s,r,o=I.WINDOW,u){o=N.$og(n.scope)?o:n.scope;const b=n.properties;if(b)for(const S in b){const v=b[S];if(t&&P(S,v)){delete b[S];continue}if(v.source=s,v.defaultDefaultValue=b[S].default,this.A(S,v),e.$Ho.test(S)?v.scope=void 0:(v.scope=N.$og(v.scope)?o:v.scope,v.restricted=N.$og(v.restricted)?!!r?.includes(S):v.restricted),b[S].hasOwnProperty("included")&&!b[S].included){this.g[S]=b[S],delete b[S];continue}else this.e[S]=b[S],b[S].policy?.name&&this.f.set(b[S].policy.name,S);!b[S].deprecationMessage&&b[S].markdownDeprecationMessage&&(b[S].deprecationMessage=b[S].markdownDeprecationMessage),u.add(S)}const L=n.allOf;if(L)for(const S of L)this.u(S,t,s,r,o,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const u in r)this.w(u,r[u]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$yo.properties[n]=t,t.scope){case I.APPLICATION:e.$zo.properties[n]=t;break;case I.MACHINE:e.$Ao.properties[n]=t;break;case I.MACHINE_OVERRIDABLE:e.$Bo.properties[n]=t;break;case I.WINDOW:e.$Co.properties[n]=t;break;case I.RESOURCE:e.$Do.properties[n]=t;break;case I.LANGUAGE_OVERRIDABLE:e.$Do.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$yo.properties[n],t.scope){case I.APPLICATION:delete e.$zo.properties[n];break;case I.MACHINE:delete e.$Ao.properties[n];break;case I.MACHINE_OVERRIDABLE:delete e.$Bo.properties[n];break;case I.WINDOW:delete e.$Co.properties[n];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:A.localize(1655,null),errorMessage:A.localize(1656,null),$ref:e.$Eo};this.A(t,s),e.$yo.properties[t]=s,e.$zo.properties[t]=s,e.$Ao.properties[t]=s,e.$Bo.properties[t]=s,e.$Co.properties[t]=s,e.$Do.properties[t]=s}}z(){const n={type:"object",description:A.localize(1657,null),errorMessage:A.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=n,e.$zo.patternProperties[e.$Go]=n,e.$Ao.patternProperties[e.$Go]=n,e.$Bo.patternProperties[e.$Go]=n,e.$Co.patternProperties[e.$Go]=n,e.$Do.patternProperties[e.$Go]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),N.$mg(r)&&(r=t.defaultDefaultValue,o=void 0),N.$mg(r)&&(r=m(t.type)),t.default=r,t.defaultValueSource=o}}const d="\\[([^\\]]+)\\]",l=new RegExp(d,"g");e.$Go=`^(${d})+$`,e.$Ho=new RegExp(e.$Go);function g(i){const n=[];if(e.$Ho.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,R.$Mb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function m(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new f;O.$so.add(e.$xo.Configuration,w);function P(i,n){return i.trim()?e.$Ho.test(i)?A.localize(1660,null,i):w.getConfigurationProperties()[i]!==void 0?A.localize(1661,null,i):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(1662,null,i,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(1659,null)}function $(){const i=[],n=w.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(N.$hg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function h(i){switch(i){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ue[78],de([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=$,R=Oe(R),N=Oe(N),k=Oe(k),O=Oe(O);function l(n){return Object.isFrozen(n)?n:k.$go(n)}class g{static createEmptyModel(t){return new g({},[],[],void 0,t)}constructor(t,s,r,o,u){this.b=t,this.c=s,this.d=r,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof g)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.$ij)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:b,keys:L}of r.rawConfiguration.overrides){const S=new g(u,L,[],void 0,r.f).getValue(t);S!==void 0&&o.push({identifiers:b,value:S})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,I.$ij)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return R.$Mb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return R.$Mb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=k.$fo(this.contents),r=k.$fo(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const b of t)if(u.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const L of b.overrides){const[S]=r.filter(v=>R.$ub(v.identifiers,L.identifiers));S?(this.i(S.contents,L.contents),S.keys.push(...L.keys),S.keys=R.$Mb(S.keys)):r.push(k.$fo(L))}for(const L of b.keys)o.indexOf(L)===-1&&o.push(L)}return new g(s,o,r,u.every(b=>b instanceof g)?void 0:u,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of R.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[o];const b=s[o];b&&(typeof u=="object"&&typeof b=="object"?(u=k.$fo(u),this.i(u,b)):u=b),r[o]=u}return new g(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&O.$hg(t[r])&&O.$hg(s[r])){this.i(t[r],s[r]);continue}t[r]=k.$fo(s[r])}}j(t){let s=null,r=null;const o=u=>{u&&(r?this.i(r,u):r=k.$fo(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?s=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,I.$hj)(this.contents,t),p.$Ho.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.$ub(r.identifiers,(0,p.$Io)(t))),1))}k(t,s,r){if((0,I.$gj)(this.contents,t,s,o=>this.f.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),p.$Ho.test(t)){const o=(0,p.$Io)(t),u={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,I.$fj)(this.contents[t],L=>this.f.error(L))},b=this.overrides.findIndex(L=>R.$ub(L.identifiers,o));b!==-1?this.overrides[b]=u:this.overrides.push(u)}}}e.$Po=g;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!O.$og(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:o,overrides:u,restricted:b,hasExcludedProperties:L}=this.i(t,s);this.b=new g(r,o,u,L?[t]:void 0,this.g),this.c=b||[]}h(t){let s={},r=null,o=[];const u=[],b=[];function L(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}const S={onObjectBegin:()=>{const v={};L(v),u.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];L(v),u.push(o),o=v,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:L,onError:(v,C,U)=>{b.push({error:v,offset:C,length:U})}};if(t)try{N.$7n(t,S),s=o[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=d.$so.as(p.$xo.Configuration).getConfigurationProperties(),o=this.j(t,r,!0,s);t=o.raw;const u=(0,I.$fj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),b=Object.keys(t),L=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:u,keys:b,overrides:L,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,s,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const b={},L=[];for(const S in t)if(p.$Ho.test(S)&&r){const v=this.j(t[S],s,!1,o);b[S]=v.raw,u=u||v.hasExcludedProperties,L.push(...v.restricted)}else{const v=s[S],C=v?typeof v.scope<"u"?v.scope:p.ConfigurationScope.WINDOW:void 0;v?.restricted&&L.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&!(o.skipRestricted&&v?.restricted))?b[S]=t[S]:u=!0}return{raw:b,restricted:L,hasExcludedProperties:u}}l(t,s){const r=[];for(const o of Object.keys(t))if(p.$Ho.test(o)){const u={};for(const b in t[o])u[b]=t[o][b];r.push({identifiers:(0,p.$Io)(o),keys:Object.keys(u),contents:(0,I.$fj)(u,s)})}return r}}e.$Qo=E;class m extends A.$Vc{constructor(t,s,r,o,u){super(),this.c=t,this.f=s,this.g=o,this.h=u,this.b=this.B(new a.$me),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(f.FileOperation.CREATE)||b.isOperation(f.FileOperation.COPY)||b.isOperation(f.FileOperation.DELETE)||b.isOperation(f.FileOperation.WRITE))&&r.isEqual(b.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=m;class w{constructor(t,s,r,o,u,b,L,S,v,C,U,F,j){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=o,this.d=u,this.f=b,this.g=L,this.h=S,this.i=v,this.j=C,this.k=U,this.l=F,this.m=j}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,o,u,b,L,S,v,C){this.j=t,this.l=s,this.m=r,this.n=o,this.p=u,this.q=b,this.r=L,this.s=S,this.t=v,this.u=C,this.h=null,this.i=new T.$Bc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this.t.get(r.resource),o||(o=g.createEmptyModel(this.u),this.t.set(r.resource,o))):o=this.s,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const o=this.w(t,s,r),u=this.A(s.resource,r),b=s.resource?this.t.get(s.resource)||this.s:this.s,L=new Set;for(const S of o.overrides)for(const v of S.identifiers)o.getOverrideValue(t,v)!==void 0&&L.add(v);return new w(t,s,o.getValue(t),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,b)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:u,removed:b}=h(this.j,t);s=[...o,...u,...b]}for(const o of s)for(const u of(0,p.$Io)(o)){const b=this.j.getKeysForOverrideIdentifier(u),L=t.getKeysForOverrideIdentifier(u),S=[...L.filter(v=>b.indexOf(v)===-1),...b.filter(v=>L.indexOf(v)===-1),...b.filter(v=>!k.$jo(this.j.override(u).getValue(v),t.override(u).getValue(v)))];r.push([u,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=h(this.l,t),u=[...s,...r,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.applicationConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateApplicationConfiguration(t),{keys:b,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.localUserConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.remoteUserConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.workspaceConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:u,removed:b,overrides:L}=h(r,s),S=[...o,...u,...b];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:L}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:u,overrides:b}=h(s,void 0);return{keys:[...r,...o,...u],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let o=this.x(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},s){let r=this.y();if(s&&t){const o=s.getFolder(t);o&&(r=this.z(o.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),o=this.r.get(t);o?(s=r.merge(o),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:u}=this.r.get(s);return t.push([s,{contents:r,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),o=this.E(t.policy,s),u=this.E(t.application,s),b=this.E(t.user,s),L=this.E(t.workspace,s),S=t.folders.reduce((v,C)=>(v.set(y.URI.revive(C[0]),this.E(C[1],s)),v),new T.$Bc);return new P(r,o,u,b,g.createEmptyModel(s),L,S,g.createEmptyModel(s),new T.$Bc,s)}static E(t,s){return new g(t.contents,t.keys,t.overrides,void 0,s)}}e.$So=P;function $(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,b])=>{const L=(0,T.$yc)(s,u,new Set);b.forEach(S=>L.add(S))});const r=[];return s.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,u){this.change=t,this.f=s,this.g=r,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of t.keys)this.affectedKeys.add(b);for(const[,b]of t.overrides)for(const L of b)this.affectedKeys.add(L);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const u=o+r.length;if(u>=this.d.length)return!1;const b=this.d.charCodeAt(u);if(b!==this.b&&b!==this.c)return!1;if(s){const L=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!k.$jo(L,S)}return!0}}e.$Uo=c;function h(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),u=[],b=n?.getAllOverrideIdentifiers()||[],L=t?.getAllOverrideIdentifiers()||[];if(t){const S=L.filter(v=>!b.includes(v));for(const v of S)u.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=b.filter(v=>!L.includes(v));for(const v of S)u.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of b)if(L.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:o,overrides:u}}function i(n,t){const s=n?t?n.keys.filter(u=>t.keys.indexOf(u)===-1):[...n.keys]:[],r=t?n?t.keys.filter(u=>n.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(n&&t){for(const u of t.keys)if(n.keys.indexOf(u)!==-1){const b=(0,I.$ij)(t.contents,u),L=(0,I.$ij)(n.contents,u);k.$jo(b,L)||o.push(u)}}return{added:s,removed:r,updated:o}}}),define(ue[184],de([0,1,17,3,2,29,12,78,47,10,58,44]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=void 0;class f extends N.$Vc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new a.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Po.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$so.as(O.$xo.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:m})=>this.f(Array.from(E),m))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,m){this.j(E,p.$so.as(O.$xo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=k.$Po.createEmptyModel(this.c);const E=p.$so.as(O.$xo.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,m){const w=this.g();for(const P of E){const $=w[P],c=m[P];$!==void 0?this.b.setValue(P,$):c?this.b.setValue(P,c.default):this.b.removeValue(P)}}}e.$Vo=f;class d{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=k.$Po.createEmptyModel(new y.$ok)}async initialize(){return this.configurationModel}}e.$Wo=d;let l=class extends N.$Vc{get configurationModel(){return this.b}constructor(E,m,w){super(),this.c=E,this.f=m,this.g=w,this.a=this.B(new a.$me),this.onDidChangeConfiguration=this.a.event,this.b=k.$Po.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const m={},w=[],P=p.$so.as(O.$xo.Configuration).getConfigurationProperties();for(const $ of E){const c=P[$];if(!c){w.push($);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}w.push($),m[c.policy.name]={type:c.type}}}return(0,T.$sg)(m)||await this.f.updatePolicyDefinitions(m),w}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const m=p.$so.as(O.$xo.Configuration).getPolicyConfigurations(),w=(0,R.$Hb)(E.map(P=>m.get(P)));this.m(w,!0)}m(E,m){this.g.trace("PolicyConfiguration#update",E);const w=p.$so.as(O.$xo.Configuration).getConfigurationProperties(),P=[],$=this.b.isEmpty();for(const c of E){const h=w[c]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);($?i!==void 0:!(0,A.$jo)(this.b.getValue(c),i))&&P.push([c,i])}else this.b.getValue(c)!==void 0&&P.push([c,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const c=this.b;this.b=k.$Po.createEmptyModel(this.g);for(const h of c.keys)this.b.setValue(h,c.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);m&&this.a.fire(this.b)}}};e.$Xo=l,e.$Xo=l=Se([Q(1,I.$uo),Q(2,y.$bk)],l)}),define(ue[185],de([0,1,17,6,14,3,36,64,2,31,29,5,20,21,78,47,184,7,58]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;class P extends O.$Vc{constructor(h,i,n,t){super(),this.m=h,this.n=t,this.h=this.B(new A.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Vo(t)),this.c=n instanceof w.$wo?new E.$Wo:this.B(new E.$Xo(this.b,n,t)),this.f=this.B(new l.$Ro(this.m,{},f.$$g,i,t)),this.a=new l.$So(this.b.configurationModel,this.c.configurationModel,l.$Po.createEmptyModel(t),l.$Po.createEmptyModel(t),l.$Po.createEmptyModel(t),l.$Po.createEmptyModel(t),new y.$Bc,l.$Po.createEmptyModel(t),new y.$Bc,t),this.j=new $(h,i,this),this.g=this.B(new a.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$So(h,i,l.$Po.createEmptyModel(this.n),n,l.$Po.createEmptyModel(this.n),l.$Po.createEmptyModel(this.n),new y.$Bc,l.$Po.createEmptyModel(this.n),new y.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const n=typeof h=="string"?h:void 0,t=(0,d.$bj)(h)?h:(0,d.$bj)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(h,i,n,t,s){const r=(0,d.$cj)(n)?n:(0,d.$bj)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==d.ConfigurationTarget.USER_LOCAL&&o!==d.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,R.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,I.$jo)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const L=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,R.$ub)([...v.identifiers].sort(),L));S&&(r.overrideIdentifiers=S.identifiers)}const b=r?.overrideIdentifiers?.length?[(0,g.$Jo)(r.overrideIdentifiers),h]:[h];await this.j.write(b,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(n,i,d.ConfigurationTarget.USER)}s(h,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,n,d.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(h);this.u(n,i,d.ConfigurationTarget.DEFAULT)}u(h,i,n){const t=new l.$Uo(h,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$Yo=P;class ${constructor(h,i,n){this.b=h,this.c=i,this.d=n,this.a=new a.$Nh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,T.$Zn)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,h,i);n=(0,k.$eo)(n,s),await this.c.writeFile(this.b,N.$Oe.fromString(n))}f(h,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,k.$bo)(h,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let h=p.OS===p.OperatingSystem.Linux||p.OS===p.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ue[186],de([0,1,14,3,2,70]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mxb=e.$Kxb=e.$Jxb=void 0,e.$Lxb=k;const T=(y,I,p)=>{const f=new Uint8Array(16);for(let g=0;g<16;g++)f[g]=Math.round(Math.random()*256);const d=(0,R.$9e)(R.$Oe.wrap(f));return[`GET ws://localhost${y}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`].join(`\r
`)+`\r
\r
`};e.$Jxb=T,e.$Kxb=R.$Oe.fromString(`\r
\r
`);async function k(y,I,p,f,d){y.write(R.$Oe.fromString((0,e.$Jxb)(I,p,f)));const l=new N.$Uc;try{return await new Promise((g,E)=>{let m;l.add(y.onData(w=>{m?m=R.$Oe.concat([m,w],m.byteLength+w.byteLength):m=w;const P=m.indexOf(e.$Kxb);if(P===-1)return;g(y),y.pauseData();const $=m.slice(P+e.$Kxb.byteLength);$.byteLength&&d.onData.fire($)})),l.add(y.onClose(w=>E(w??new Error("socket closed")))),l.add(y.onEnd(()=>E(new Error("socket ended"))))})}catch(g){throw y.dispose(),g}finally{l.dispose()}}class O extends N.$Vc{constructor(I,p){super(),this.g=I,this.a=this.B(new a.$pe),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new a.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event(f=>this.a.fire(f))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,p){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Mxb=O}),define(ue[105],de([0,1,8,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.RemoteAuthorityResolverErrorCode=e.$Ul=e.$Tl=e.RemoteConnectionType=e.$Sl=void 0,e.$Wl=y,e.$Sl=(0,a.$Gi)("remoteAuthorityResolverService");var N;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class A{constructor(p){this.id=p,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Tl=A;class T{constructor(p,f){this.host=p,this.port=f,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ul=T;var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class O extends R.$bb{static isNotAvailable(p){return p instanceof O&&p._code===k.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof O&&p._code===k.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof O&&p._code===k.NoResolverFound}static isInvalidAuthority(p){return p instanceof O&&p._code===k.InvalidAuthority}static isHandled(p){return p instanceof O&&p.isHandled}constructor(p,f=k.Unknown,d){super(p),this._message=p,this._code=f,this._detail=d,this.isHandled=f===k.NotAvailable&&d===!0,Object.setPrototypeOf(this,O.prototype)}}e.$Vl=O;function y(I){const p=I.indexOf("+");return p===-1?I:I.substring(0,p)}}),define(ue[187],de([0,1,6,14,25,8,3,2,22,101,54,32,70,105]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$2l=u,e.$3l=b,e.$4l=S,y=Oe(y);const l=30*1e3;var g;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function E(K){switch(K){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function m(K){const q=new N.$xe;return setTimeout(()=>q.cancel(),K),q.token}function w(K,q){if(K.isCancellationRequested||q.isCancellationRequested)return N.CancellationToken.Cancelled;const D=new N.$xe;return K.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new k.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$zh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function $(K,q){const D=new P(q);return D.registerDisposable(K.onControlMessage(J=>{const oe=JSON.parse(J.toString()),Y=V(oe);Y?D.reject(Y):D.resolve(oe)})),D.promise}function c(K,q,D,J,oe,Y,Z,M){const z=new P(M),ie=I.$ge.create(!1);return K.info(`Creating a socket (${Z})...`),y.mark(`code/willCreateSocket/${Y}`),q.connect(D,J,oe,Z).then(ae=>{z.didTimeout?(y.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${Z}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(y.mark(`code/didCreateSocketOK/${Y}`),K.info(`Creating a socket (${Z}) was successful after ${ie.elapsed()} ms.`),z.resolve(ae))},ae=>{y.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${Z}) returned an error after ${ie.elapsed()} ms.`),K.error(ae),z.reject(ae)}),z.promise}function h(K,q){const D=new P(q);return K.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(K,q,D,J){const oe=ee(K,q);K.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,O.$Tg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${K.reconnectionToken}`,J)}catch(ae){throw K.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ae),ae}K.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let Z,M;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=K.reconnectionProtocol,M=!1):(Z=new f.$ui({socket:Y}),M=!0),K.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const z=await h(K.signService.createNewMessage((0,p.$3g)()),J),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};Z.sendControl(a.$Oe.fromString(JSON.stringify(ie)));try{const ae=await $(Z,w(J,m(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await h(K.signService.validate(z,ae.signedData),J)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const pe=await h(K.signService.sign(ae.data),J),be={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:q};return D&&(be.args=D),K.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(a.$Oe.fromString(JSON.stringify(be))),{protocol:Z,ownsProtocol:M}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(K.logService.error(`${oe} the handshake timed out. Error:`),K.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${oe} received error control message when negotiating connection. Error:`),K.logService.error(ae)),M&&B(Z),ae}}async function n(K,q,D,J){const oe=Date.now(),Y=ee(K,q),{protocol:Z,ownsProtocol:M}=await i(K,q,D,J),z=new P(J);return z.registerDisposable(Z.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),he=V(ae);he?(K.logService.error(`${Y} received error control message when negotiating connection. Error:`),K.logService.error(he),M&&B(Z),z.reject(he)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${X(oe)}!`),z.resolve({protocol:Z,firstMessage:ae}))})),z.promise}async function t(K,q){const{protocol:D}=await n(K,g.Management,void 0,q);return{protocol:D}}async function s(K,q,D){const{protocol:J,firstMessage:oe}=await n(K,g.ExtensionHost,q,D),Y=oe&&oe.debugPort;return{protocol:J,debugPort:Y}}async function r(K,q,D){const J=Date.now(),oe=ee(K,g.Tunnel),{protocol:Y}=await i(K,g.Tunnel,q,D);return K.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${X(J)}!`),Y}async function o(K,q,D){const{connectTo:J,connectionToken:oe}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:J,connectionToken:oe,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function u(K,q,D){return L(K,async J=>{const{protocol:oe}=await t(J,N.CancellationToken.None);return new G(K,q,D,J.reconnectionToken,oe)})}async function b(K,q){return L(K,async D=>{const{protocol:J,debugPort:oe}=await s(D,q,N.CancellationToken.None);return new te(K,q,D.reconnectionToken,J,oe)})}async function L(K,q){for(let J=1;;J++)try{const oe=(0,p.$3g)(),Y=await o(K,oe,null);return await q(Y)}catch(oe){if(J<5)K.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(oe);else throw K.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(oe),x.triggerPermanentFailure(0,0,d.$Vl.isHandled(oe)),oe}}async function S(K,q,D){const J=await o(K,(0,p.$3g)(),null);return await r(J,{host:q,port:D},N.CancellationToken.None)}function v(K){return(0,R.$th)(q=>new Promise((D,J)=>{const oe=setTimeout(D,K*1e3);q.onCancellationRequested(()=>{clearTimeout(oe),D()})}))}var C;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class U{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=C.ConnectionLost}}e.$5l=U;class F{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=oe,this.type=C.ReconnectionWait}skipWait(){this.c.cancel()}}e.$6l=F;class j{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=C.ReconnectionRunning}}e.$7l=j;class H{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=C.ConnectionGain}}e.$8l=H;class W{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=oe,this.type=C.ReconnectionPermanentFailure}}e.$9l=W;class x extends k.$Vc{static triggerPermanentFailure(q,D,J){this._permanentFailure=!0,this.f=q,this.g=D,this.h=J,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(q,D,J,oe,Y){super(),this.t=q,this.u=D,this.reconnectionToken=J,this.protocol=oe,this.w=Y,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new H(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(Z=>{const M=le(this.t,this.reconnectionToken,!0);Z?Z.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${M} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${M} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${M} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(Z=>{const M=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,k.$Tc)(()=>{const Z=x.j.indexOf(this);Z>=0&&x.j.splice(Z,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const oe=J<D.length?D[J]:D[D.length-1];try{if(oe>0){const Z=v(oe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,Z)),this.u.logService.info(`${q} waiting for ${oe} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${q} resolving connection...`);const Y=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${Y.connectTo}...`),await this.G(Y,m(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(d.$Vl.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,A.$4)(Y)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof d.$Vl){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,d.$Vl.isHandled(Y));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(q,D,J){this.w?x.triggerPermanentFailure(q,D,J):this.D(q,D,J)}D(q,D,J){this.m.fire(new W(this.reconnectionToken,q,D,J)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0l=x;class G extends x{constructor(q,D,J,oe,Y){super(g.Management,q,oe,Y,!0),this.client=this.B(new f.$si(Y,{remoteAuthority:D,clientId:J},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$$l=G;class te extends x{constructor(q,D,J,oe,Y){super(g.ExtensionHost,q,J,oe,!1),this.H=D,this.debugPort=Y}async G(q,D){await s(q,this.H,D)}}e.$_l=te;function B(K){try{K.acceptDisconnect();const q=K.getSocket();K.dispose(),q.dispose()}catch(q){(0,A.$Z)(q)}}function V(K){if(K&&K.type==="error"){const q=new Error(`Connection error: ${K.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(K,q){for(;K.length<q;)K+=" ";return K}function ne(K,q){return`[remote-connection][${_(E(K),13)}][${q.substr(0,5)}\u2026]`}function le(K,q,D){return`${ne(K,q)}[${D?"reconnect":"initial"}]`}function ee(K,q){return`${le(q,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function X(K){return`${Date.now()-K} ms`}}),define(ue[106],de([0,1,22]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=a,e.$jn=N,e.$kn=A,e.$ln=T;function a(O){return O.scheme===R.Schemas.vscodeRemote?O.authority:void 0}function N(O){if(!O)return;const y=O.indexOf("+");return y<0?O:O.substr(0,y)}function A(O){const{host:y,port:I}=k(O);if(typeof I>"u")throw new Error(`Invalid remote authority: ${O}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:I}}function T(O,y){let{host:I,port:p}=k(O);return typeof p>"u"&&(p=y),{host:I,port:p}}function k(O){const y=O.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const I=O.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=O.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:O,port:void 0}}}),define(ue[34],de([0,1,26,4,106]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=A,e.$vn=p,e.$wn=f,e.$xn=d,e.$yn=l,e.$zn=g,e.$An=E,R=Oe(R),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function A(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class O{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const $=typeof w=="string"?w:w.value,c=typeof P=="string"?P:P.value;return R.$Gf($,c)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$sn=O;class y{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(O.toKey(w))}delete(w){return this.c.delete(O.toKey(w))}has(w){return this.c.has(O.toKey(w))}}e.$tn=y;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(O.toKey(w))}get(w){return this.c.get(O.toKey(w))}has(w){return this.c.has(O.toKey(w))}set(w,P){this.c.set(O.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=I;function p(m){return f(m)}function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}function l(m,w){if(w){const P=`onResolveRemoteAuthority:${(0,N.$jn)(w)}`;return!!m.activationEvents?.includes(P)}return!1}function g(m){return m.map(w=>{const[P,$]=w.split("@");return{proposalName:P,version:$?parseInt($):void 0}})}function E(m){return m.map(w=>w.split("@")[0])}e.$Bn=(0,a.$Gi)("IBuiltinExtensionsScannerService")}),define(ue[27],de([0,1,5,11,34,4]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=k,e.$hp=O,e.$ip=y,e.$jp=I,e.$kp=p,e.$lp=f,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var T;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function k(c){switch(c){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function O(c){switch(c){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function y(c,h){switch(c){case R.Platform.Windows:return h==="x64"?N.TargetPlatform.WIN32_X64:h==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Linux:return h==="x64"?N.TargetPlatform.LINUX_X64:h==="arm64"?N.TargetPlatform.LINUX_ARM64:h==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?N.TargetPlatform.ALPINE_X64:h==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Mac:return h==="x64"?N.TargetPlatform.DARWIN_X64:h==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Web:return N.TargetPlatform.WEB}}function I(c,h){return h===N.TargetPlatform.WEB&&!c.includes(N.TargetPlatform.WEB)}function p(c,h,i){return I(h,i)?!1:c===N.TargetPlatform.UNDEFINED||c===N.TargetPlatform.UNIVERSAL?!0:c===N.TargetPlatform.UNKNOWN?!1:c===i}function f(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$mp=(0,A.$Gi)("extensionGalleryService");var m;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting",c.Offline="Offline"})(m||(e.ExtensionGalleryErrorCode=m={}));class w extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$np=w;var P;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class $ extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$op=$,e.$pp=(0,A.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,A.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,A.$Gi)("IExtensionTipsService"),e.$up=(0,a.localize2)(1771,"Extensions"),e.$vp=(0,a.localize2)(1772,"Preferences")}),define(ue[188],de([0,1,3,2,29,9,95,27]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=e.$Aq=void 0;function O(E,m){return E?A.URI.revive(m?m.transformIncoming(E):E):void 0}function y(E,m){return m?m.transformOutgoingURI(E):E}function I(E,m){m=m||T.$On;const w=E.manifest;return{...(0,T.$Rn)({...E,manifest:void 0},m),manifest:w}}function p(E,m){return E?.profileLocation?(0,T.$Rn)(E,m??T.$On):E}function f(E,m){return m?(0,N.$ho)(E,w=>w instanceof A.URI?m.transformOutgoingURI(w):void 0):E}class d{constructor(m,w){this.a=m,this.b=w,this.onInstallExtension=R.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(m.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(m.onDidUpdateExtensionMetadata,!0)}listen(m,w){const P=this.b(m);switch(w){case"onInstallExtension":return R.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?y($.profileLocation,P):$.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,$=>$.map(c=>({...c,local:c.local?f(c.local,P):c.local,profileLocation:c.profileLocation?y(c.profileLocation,P):c.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?y($.profileLocation,P):$.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?y($.profileLocation,P):$.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,$=>({local:f($.local,P),profileLocation:y($.profileLocation,P)}))}throw new Error("Invalid listen")}async call(m,w,P){const $=this.b(m);switch(w){case"zip":{const c=I(P[0],$),h=await this.a.zip(c);return y(h,$)}case"install":return this.a.install(O(P[0],$),p(P[1],$));case"installFromLocation":return this.a.installFromLocation(O(P[0],$),O(P[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],O(P[1],$),O(P[2],$));case"getManifest":return this.a.getManifest(O(P[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],p(P[1],$));case"installGalleryExtensions":{const c=P[0];return this.a.installGalleryExtensions(c.map(({extension:h,options:i})=>({extension:h,options:p(i,$)??{}})))}case"uninstall":return this.a.uninstall(I(P[0],$),p(P[1],$));case"uninstallExtensions":{const c=P[0];return this.a.uninstallExtensions(c.map(({extension:h,options:i})=>({extension:I(h,$),options:p(i,$)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(I(P[0],$));case"getInstalled":return(await this.a.getInstalled(P[0],O(P[1],$),P[2])).map(h=>f(h,$));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(I(P[0],$),O(P[1],$));return f(c,$)}case"copyExtensions":return this.a.copyExtensions(O(P[0],$),O(P[1],$));case"updateMetadata":{const c=await this.a.updateMetadata(I(P[0],$),P[1],O(P[2],$));return f(c,$)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Aq=d;class l extends a.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(m){super(),this.m=m,this.c=this.B(new R.$me),this.f=this.B(new R.$me),this.g=this.B(new R.$me),this.h=this.B(new R.$me),this.j=this.B(new R.$me),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?A.URI.revive(w.source):w.source,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:A.URI.revive(w.profileLocation),local:I(w.local,null)})))}n(m,w){m.fire(w)}r(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(m){const w=await this.getTargetPlatform();return m.allTargetPlatforms.some(P=>(0,k.$kp)(P,m.allTargetPlatforms,w))}zip(m){return Promise.resolve(this.m.call("zip",[m]).then(w=>A.URI.revive(w)))}install(m,w){return Promise.resolve(this.m.call("install",[m,w])).then(P=>I(P,null))}installFromLocation(m,w){return Promise.resolve(this.m.call("installFromLocation",[m,w])).then(P=>I(P,null))}async installExtensionsFromProfile(m,w,P){return(await this.m.call("installExtensionsFromProfile",[m,w,P])).map(c=>I(c,null))}getManifest(m){return Promise.resolve(this.m.call("getManifest",[m]))}installFromGallery(m,w){return Promise.resolve(this.m.call("installFromGallery",[m,w])).then(P=>I(P,null))}async installGalleryExtensions(m){return(await this.m.call("installGalleryExtensions",[m])).map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(m,w){if(m.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[m,w]))}uninstallExtensions(m){if(m.some(w=>w.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[m]))}reinstallFromGallery(m){return Promise.resolve(this.m.call("reinstallFromGallery",[m])).then(w=>I(w,null))}getInstalled(m=null,w,P){return Promise.resolve(this.m.call("getInstalled",[m,w,P])).then($=>$.map(c=>I(c,null)))}updateMetadata(m,w,P){return Promise.resolve(this.m.call("updateMetadata",[m,w,P])).then($=>I($,null))}resetPinnedStateForAllUserExtensions(m){return this.m.call("resetPinnedStateForAllUserExtensions",[m])}toggleAppliationScope(m,w){return this.m.call("toggleAppliationScope",[m,w]).then(P=>I(P,null))}copyExtensions(m,w){return this.m.call("copyExtensions",[m,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(m,w,P){const $=await this.m.call("download",[m,w,P]);return A.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Bq=l;class g{constructor(m){this.a=m}listen(m,w){throw new Error("Invalid listen")}call(m,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Cq=g}),define(ue[189],de([0,1,2,34,7]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class A extends R.$Vc{constructor(k,O,y,I,p){super(),this.a=k,this.b=O,this.c=y,this.f=p,this.B(I.onDidInstallExtensions(f=>this.g(f))),this.B(I.onDidUninstallExtension(f=>this.h(f)))}g(k){for(const O of k)O.local&&this.invalidate(O.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const O of this.a.profiles)this.c.extUri.isEqual(O.extensionsResource,k)&&await this.j(O);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,a.$mn))}catch(O){(0,N.$sl)(O)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(O)}}}e.$Zq=A});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[59],de([0,1,20,93,11,60,34,160]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=I,e.$2p=p,e.$3p=f,e.$4p=d,e.$5p=l,e.$6p=g,e.$7p=E,e.$8p=m,a=it(a),N=Oe(N),A=Oe(A);const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function I($){return $=$.trim(),$==="*"||O.test($)}function p($){if(!I($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=$.match(O);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function f($){if(!$)return null;const c=$.majorBase,h=$.majorMustEqual,i=$.minorBase;let n=$.minorMustEqual;const t=$.patchBase;let s=$.patchMustEqual;$.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if($.preRelease){const o=y.exec($.preRelease);if(o){const[,u,b,L]=o;r=Date.UTC(Number(u),Number(b)-1,Number(L))}}return{majorBase:c,majorMustEqual:h,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:$.hasGreaterEquals,notBefore:r}}function d($,c,h){let i;typeof $=="string"?i=f(p($)):i=$;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof h=="string"?t=f(p(h)):t=h,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let u=t.majorBase,b=t.minorBase,L=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,C=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>b?!0:r<b||n&&n<S?!1:o>=L:(s===1&&u===0&&(!v||!C||!U)&&(u=1,b=0,L=0,v=!0,C=!1,U=!1),s<u?!1:s>u?!v:r<b?!1:r>b?!C:o<L?!1:o>L?!U:!(n&&n<S))}function l($,c,h,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,N.localize(1823,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,N.localize(1824,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,N.localize(1825,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,N.localize(1826,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,N.localize(1827,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([a.default.Error,N.localize(1828,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([a.default.Error,N.localize(1829,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,N.localize(1830,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,N.localize(1831,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,N.localize(1832,null,"main")]),s;{const u=(0,R.$hh)(h,i.main);(0,R.$bh)(u,h)||s.push([a.default.Warning,N.localize(1833,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,N.localize(1834,null,"browser")]),s;{const u=(0,R.$hh)(h,i.browser);(0,R.$bh)(u,h)||s.push([a.default.Warning,N.localize(1835,null,u.path,h.path)])}}if(!A.valid(i.version))return s.push([a.default.Error,N.localize(1836,null)]),s;const r=[];if(!g($,c,i,n,r))for(const u of r)s.push([a.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!m([...i.enabledApiProposals],u))for(const b of u)s.push([a.default.Error,b])}return s}function g($,c,h,i,n){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:w($,c,h.engines.vscode,n)}function E($,c,h){return $==="*"||w(c,h,$)}function m($,c){if($.length===0)return!0;const h=Array.isArray(c)?c:void 0,i=(h?void 0:c)??k.allApiProposals,n=[],t=(0,T.$zn)($);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(N.localize(1837,null,s))}return h?.push(...n),n.length===0}function w($,c,h,i=[]){const n=f(p(h));if(!n)return i.push(N.localize(1838,null,h)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(N.localize(1839,null,h)),!1}else if(!n.majorMustEqual)return i.push(N.localize(1840,null,h)),!1;return d($,c,n)?!0:(i.push(N.localize(1841,null,$,h)),!1)}function P($){if(!Array.isArray($))return!1;for(let c=0,h=$.length;c<h;c++)if(typeof $[c]!="string")return!1;return!0}}),define(ue[79],de([0,1,25,2,5,11,27,4]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.$cs=void 0,e.$bs=O;function O(I){return I.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$cs=(0,k.$Gi)("languagePackService");let y=class extends a.$Vc{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new R.$xe;setTimeout(()=>p.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const l=f.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(E=>E.startsWith("lp-"))).map(g=>{const E=g.properties.localizedLanguages?.[0],m=O(g);return{...this.f(m,E,g),extensionId:g.identifier.id,galleryExtension:g}});return l.push(this.f("en","English")),l}f(p,f,d){const l=f??p;let g;if(l!==p&&(g=`(${p})`),p.toLowerCase()===N.$x.toLowerCase()&&(g??="",g+=(0,A.localize)(1919,null)),d?.installCount){g??="";const E=d.installCount;let m;E>1e6?m=`${Math.floor(E/1e5)/10}M`:E>1e3?m=`${Math.floor(E/1e3)}K`:m=String(E),g+=` $(cloud-download) ${m}`}return{id:p,label:l,description:g}}};e.$ds=y,e.$ds=y=Se([Q(0,T.$mp)],y)}),define(ue[190],de([0,1,2,79]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let N=class extends R.$Vc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$wic=N,e.$wic=N=Se([Q(0,a.$cs)],N)}),define(ue[107],de([0,1,2,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl=(0,a.$Gi)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,k){return this.a[T]??=[],this.a[T].push(k),(0,R.$Tc)(()=>{const O=this.a[T]?.indexOf(k);typeof O=="number"&&O>=0&&this.a[T]?.splice(O,1)})}b(T){return(this.a[T.type]||[]).find(O=>O.supports(T))}connect(T,k,O,y){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,k,O,y)}}e.$Yl=N}),define(ue[191],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=void 0,e.$Jic=(0,R.$Gi)("sharedProcessTunnelService"),e.$Kic="sharedProcessTunnel"}),define(ue[108],de([0,1,4,11]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=e.$Sic=e.$Ric=e.$Qic=e.TunnelStates=e.$Pic=e.$Oic=void 0,e.$Oic=(0,R.$Gi)("IRemoteTunnelService"),e.$Pic={active:!1};var N;(function(A){A.disconnected=T=>({type:"disconnected",onTokenFailed:T}),A.connected=(T,k)=>({type:"connected",info:T,serviceInstallFailed:k}),A.connecting=T=>({type:"connecting",progress:T}),A.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$Qic="remote.tunnels.access",e.$Ric=e.$Qic+".hostNameOverride",e.$Sic=e.$Qic+".preventSleep",e.$Tic="remoteTunnelService",e.$Uic=(0,a.localize)(2035,null)}),define(ue[61],de([0,1,14,8,2,11,47,4,10,44]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=f,e.$_p=d,e.$aq=l,e.$bq=g,e.$cq=E,e.$dq=m,e.$9p=(0,k.$Gi)("requestService");class I{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?c[h]="*****":c[h]=this.b[h];this.a=c}return this.a}}class p extends N.$Vc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,A.localize)(2041,null),when:O.$tk.isEqualTo((0,O.$qk)(O.LogLevel.Trace)).serialize()})}async c(c,h,i){const n=`${c} #${++this.b}: ${h.url}`;this.a.trace(`${n} - begin`,h.type,new I(h.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,h.type,(0,a.$0)(t)),t}}}e.$0p=p;function f($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function d($){return $.res.statusCode===204}async function l($){return d($)?null:(await(0,R.$1e)($.stream)).toString()}async function g($){if(!f($))throw new Error("Server returned "+$.res.statusCode);return l($)}async function E($){if(!f($))throw new Error("Server returned "+$.res.statusCode);if(d($))return null;const h=(await(0,R.$1e)($.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function m($){P($)}let w;function P($){const c=y.$so.as(T.$xo.Configuration),h=w;w={id:"http",order:15,title:(0,A.localize)(2042,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2048,null),(0,A.localize)(2049,null),(0,A.localize)(2050,null),(0,A.localize)(2051,null)],default:"override",description:(0,A.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2054,null),restricted:!0}}},c.updateConfigurations({add:[w],remove:h?[h]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(ue[192],de([0,1,25,22,7,61]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;let T=class{constructor(O,y){this.a=O,this.b=y}async download(O,y,I=R.CancellationToken.None){if(O.scheme===a.Schemas.file||O.scheme===a.Schemas.vscodeRemote){await this.b.copy(O,y);return}const p={type:"GET",url:O.toString(!0)},f=await this.a.request(p,I);if(f.res.statusCode===200)await this.b.writeFile(y,f.stream);else{const d=await(0,A.$bq)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${d}`)}}};e.$4R=T,e.$4R=T=Se([Q(0,A.$9p),Q(1,N.$bl)],T)}),define(ue[193],de([0,1,14,25]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=void 0;class N{constructor(k){this.a=k}listen(k,O){throw new Error("Invalid listen")}call(k,O,y,I=a.CancellationToken.None){switch(O){case"request":return this.a.request(y[0],I).then(async({res:p,stream:f})=>{const d=await(0,R.$1e)(f);return[{statusCode:p.statusCode,headers:p.headers},d]});case"resolveProxy":return this.a.resolveProxy(y[0]);case"lookupAuthorization":return this.a.lookupAuthorization(y[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(y[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$fs=N;class A{constructor(k){this.a=k}async request(k,O){const[y,I]=await this.a.call("request",[k],O);return{res:y,stream:(0,R.$3e)(I)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async lookupAuthorization(k){return this.a.call("lookupAuthorization",[k])}async lookupKerberosAuthorization(k){return this.a.call("lookupKerberosAuthorization",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$gs=A}),define(ue[194],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=e.$hhc=void 0,e.$hhc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$ihc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$jhc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ue[195],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const A=await this.c();if(A){const T=String(R.a++);return this.b.set(T,A),{id:T,data:A.createNewMessage(N)}}}catch(A){console.error(A)}return{id:"",data:N}}async validate(N,A){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(A)==="ok"}catch(k){return console.error(k),!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch(A){console.error(A)}return N}}e.$4cc=R}),define(ue[109],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl="signService",e.$1l=(0,R.$Gi)(e.$Zl)}),define(ue[196],de([0,1,67,195]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class N extends a.$4cc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(k=>new k.signer().sign(T))}h(){return(0,R.$uq)("vsda","index.js")}}e.$_hc=N}),define(ue[80],de([0,1,3,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jNb=e.$iNb=e.$hNb=e.$gNb=void 0;class N extends a.$Vc{constructor(p,f,d){super(),this.a=p,this.b=f,this.c=d}async getItems(){const p={profile:this.b,workspace:this.c},f=await this.a.call("getItems",p);return new Map(f)}updateItems(p){const f={profile:this.b,workspace:this.c};return p.insert&&(f.insert=Array.from(p.insert.entries())),p.delete&&(f.delete=Array.from(p.delete.values())),this.a.call("updateItems",f)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class A extends N{constructor(p,f){super(p,f,void 0),this.f=this.B(new R.$me),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class T extends A{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$gNb=T;class k extends A{constructor(p,f){super(p,f)}async close(){this.dispose()}}e.$hNb=k;class O extends N{constructor(p,f){super(p,void 0,f),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$iNb=O;class y{constructor(p){this.a=p}isUsed(p){const f={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",f)}}e.$jNb=y}),define(ue[110],de([0,1,5,37,32]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=T,e.$xp=k;function A(O){if(R.$v===R.Platform.Linux&&/^penguin(\.|$)/i.test(O))return"chromebook"}function T(O,y,I,p,f,d,l,g,E,m){const w=Object.create(null);w["common.machineId"]=d,w["common.sqmId"]=l,w["common.devDeviceId"]=g,w.sessionID=(0,N.$3g)()+Date.now(),w.commitHash=p,w.version=f,w["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,R.$i)(R.$v),w["common.nodePlatform"]=a.$ec,w["common.nodeArch"]=I,w["common.product"]=m||"desktop",E&&(w["common.msftInternal"]=E);let P=0;const $=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),R.$m&&(w["common.snap"]="true");const c=A(y);return c&&(w["common.platformDetail"]=c),w}function k(O){const y=a.env.USERDNSDOMAIN;if(!y)return!1;const I=y.toLowerCase();return O.some(p=>I===p)}}),define(ue[18],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,R.$Gi)("telemetryService"),e.$bm=(0,R.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var a;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var N;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(ue[197],de([0,1,33,38,6,36,22,13,5,54,9,142,30,149,98,7,23,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$2s=P,e.$3s=c,e.$4s=h,R=Oe(R),a=Oe(a);const w=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=w.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,b=new Map,L=2e4;function S(C,U,F,j){const H=U.substring(C.length+1);return N.Promises.withAsyncBody(async W=>{let x;j.readdirCount++;try{x=await f.Promises.readdir(U,{withFileTypes:!0})}catch{W();return}if(j.count>=L){j.count+=x.length,j.maxReached=!0,W();return}let G=x.length;if(G===0){W();return}let te=x;j.count+x.length>L&&(j.maxReached=!0,G=L-j.count,te=x.slice(0,G)),j.count+=x.length;for(const B of te)if(B.isDirectory()){if(F.includes(B.name)||await S(C,(0,k.$kc)(U,B.name),F,j),--G===0){W();return}}else{const V=B.name.lastIndexOf(".");if(V>=0){const _=B.name.substring(V+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of o)_.relativePathPattern?.test(H)!==!1&&_.filePattern.test(B.name)&&b.set(_.tag,(b.get(_.tag)??0)+1);if(--G===0){W();return}}})}const v=N.Promises.withAsyncBody(async C=>{const U={count:0,maxReached:!1,readdirCount:0},F=new y.$ge(!0);await S(n,n,t,U);const j=await h(n);C({configFiles:$(b),fileTypes:$(u),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:j,totalScanTime:F.elapsed(),totalReaddirCount:U.readdirCount})});return w.set(s,v),v}function $(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/g.$Jl.GB).toFixed(2)}GB (${(a.freemem()/g.$Jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(p.$Tn.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function h(n){try{const t=new Map,s=(0,k.$kc)(n,".vscode","launch.json"),r=await R.promises.readFile(s),o=[],u=(0,A.$Zn)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$8n)(u)==="object"&&u.configurations)for(const b of u.configurations){const L=b.type;L&&(t.has(L)?t.set(L,t.get(L)+1):t.set(L,1))}return $(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/g.$Jl.GB).toFixed(2)}GB (${(a.freemem()/g.$Jl.GB).toFixed(2)}GB free)`),O.$j||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(p.$Tn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,d.$1s)(t.mainPID),this.k(t)]).then(async r=>{let[o,u]=r,b=this.m(t,o);return s.forEach(L=>{if((0,l.$Vm)(L))b+=`
${L.errorMessage}`,u+=`
${L.errorMessage}`;else if(b+=`

Remote: ${L.hostName}`,L.processes&&(b+=`
${this.m(t,L.processes)}`),L.workspaceMetadata){u+=`
|  Remote: ${L.hostName}`;for(const S of Object.keys(L.workspaceMetadata)){const v=L.workspaceMetadata[S];let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),u+=`|    Folder (${S}): ${C}`,u+=this.h(v)}}}),{processInfo:b,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:u,cpus:b}=c(),L={os:u,memory:r,cpus:b,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return O.$j||(L.load=`${a.loadavg().map(S=>Math.round(S)).join(", ")}`),O.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(t,s){const r=[];return(0,d.$1s)(t.mainPID).then(async o=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(u=>{if((0,l.$Vm)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const b of Object.keys(u.workspaceMetadata)){const L=u.workspaceMetadata[b];let S=`${L.fileCount} files`;L.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${b}): ${S}`),r.push(this.h(L))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let o=0;const u=(v,C)=>{const U=` ${v}(${C})`;o+U.length>60?(s.push(b),b="|                 ",o=b.length):o+=U.length,b+=U};let b="|      File types:";const L=10,S=t.fileTypes.length>L?L:t.fileTypes.length;for(let v=0;v<S;v++){const C=t.fileTypes[v];u(C.name,C.count)}if(s.push(b),t.configFiles.length>=0&&(b="|      Conf files:",o=0,t.configFiles.forEach(v=>{u(v.name,v.count)}),s.push(b)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(C=>{const U=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;v+=U}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const b=I.URI.revive(u);if(b.scheme===T.Schemas.file){const L=b.fsPath;r.push(P(L,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,k.$oc)(L)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${L} (${S.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:b})=>r.set(u,b));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,o,s,0),o.join(`
`)}n(t,s,r,o,u){const b=u===0;let L;b?L=o.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?L=s.get(o.pid):L=`${"  ".repeat(u)} ${o.name}`;const S=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/g.$Jl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(o.children)&&o.children.forEach(v=>this.n(t,s,r,v,u+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=I.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const u=o.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(L=>s.add(L.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=I.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const u=await P(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),u.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),u.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$5s=i,e.$5s=i=Se([Q(0,m.$am),Q(1,E.$uk)],i)}),define(ue[111],de([0,1,67,8,4,10,18]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.ExtensionSignatureVerificationCode=e.$wq=void 0,e.$wq=(0,N.$Gi)("IExtensionSignatureVerificationService");var k;(function(I){I.Success="Success",I.RequiredArgumentMissing="RequiredArgumentMissing",I.InvalidArgument="InvalidArgument",I.PackageIsUnreadable="PackageIsUnreadable",I.UnhandledException="UnhandledException",I.SignatureManifestIsMissing="SignatureManifestIsMissing",I.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",I.SignatureIsMissing="SignatureIsMissing",I.SignatureIsUnreadable="SignatureIsUnreadable",I.CertificateIsUnreadable="CertificateIsUnreadable",I.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",I.FileAlreadyExists="FileAlreadyExists",I.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",I.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",I.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",I.SignatureIsInvalid="SignatureIsInvalid",I.SignatureManifestIsInvalid="SignatureManifestIsInvalid",I.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",I.EntryIsMissing="EntryIsMissing",I.EntryIsTampered="EntryIsTampered",I.Untrusted="Untrusted",I.CertificateRevoked="CertificateRevoked",I.SignatureIsNotValid="SignatureIsNotValid",I.UnknownError="UnknownError",I.PackageIsInvalidZip="PackageIsInvalidZip",I.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(e.ExtensionSignatureVerificationCode=k={}));class O extends Error{constructor(p){super(p),this.code=p}}e.$xq=O;let y=class{constructor(p,f){this.b=p,this.c=f}d(){return this.a||(this.a=(0,R.$uq)("@vscode/vsce-sign","src/main.js")),this.a}async verify(p,f,d,l){let g;const E=p.identifier.id;try{g=await this.d()}catch($){return this.b.error("Could not load vsce-sign module",(0,a.$0)($)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const m=new Date().getTime();let w;try{this.b.trace(`Verifying extension signature for ${E}...`),w=await g.verify(f,d,this.b.getLevel()===A.LogLevel.Trace)}catch($){w={code:k.UnknownError,didExecute:!1,output:(0,a.$0)($)}}const P=new Date().getTime()-m;if(this.b.info(`Extension signature verification result for ${E}: ${w.code}. Executed: ${w.didExecute}. Duration: ${P}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${w.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,extensionVersion:p.version,code:w.code,internalCode:w.internalCode,duration:P,didExecute:w.didExecute,clientTargetPlatform:l}),w.code===k.Success)return!0;throw new O(w.code)}};e.$yq=y,e.$yq=y=Se([Q(0,A.$bk),Q(1,T.$am)],y)}),define(ue[112],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=void 0;class R{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:k,data:O}){return this.b.forEach(y=>y.log(k,O)),Promise.resolve(null)}}e.$mhc=R;class a{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$nhc=a}),define(ue[48],de([0,1,29,12,106,110,18]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=I,e.$Gp=p,e.$Hp=f,e.$Ip=d,e.$Jp=g,e.$Kp=m,e.$Lp=w,e.$Mp=c;class k{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$yp=k;class O{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=O,e.$Ap=new O;class y{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$Bp=y,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function I(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function p(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function f(h){const i=h.getValue(T.$jm),n=h.getValue(T.$km);if(h.getValue(T.$lm)===!1||n===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function d(h){const i={},n={},t={};E(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(h){if(!h)return"none";const i=(0,N.$jn)(h);return l.has(i)?i:"other"}function E(h,i,n=0,t){if(h)for(const s of Object.getOwnPropertyNames(h)){const r=h[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,R.$ko)(r):r instanceof Date?i[o]=r.toISOString():(0,a.$hg)(r)?n<2?E(r,i,n+1,o+"."):i[o]=(0,R.$ko)(r):i[o]=r}}function m(h,i){const n=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$xp)(n)||t}function w(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let n=h;const t=[];for(const u of i)for(;;){const b=u.exec(h);if(!b)break;t.push([b.index,u.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const u=r.exec(h);if(!u)break;const b=t.some(([L,S])=>u.index<S&&L<r.lastIndex);!s.test(u[0])&&!b&&(n+=h.substring(o,u.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<h.length&&(n+=h.substr(o)),n}function $(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(h))return`<REDACTED: ${n.label}>`;return h}function c(h,i){return(0,R.$ho)(h,n=>{if(n instanceof k||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=$(t),t}})}}),define(ue[35],de([0,1,26,27,34,5,9,8,37,48]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=I,e.$Pp=l,e.$Qp=g,e.$Rp=E,e.$Sp=m,e.$Tp=w,e.$Up=P,e.$Vp=$,e.$Xp=c,e.$Yp=i;function I(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,R.$Bf)(n.id,t.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new f(t.identifier,s,r)}static parse(t){const s=p.exec(t);return s&&s[1]&&s[2]?new f({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=N.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof f?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Op=f;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=d.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function g(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function m(n,t){return E(g(n??N.$on,t))}function w(n,t){const s=[],r=o=>{for(const u of s)if(u.some(b=>I(t(b),t(o))))return u;return null};for(const o of n){const u=r(o);u?u.push(o):s.push([o])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function $(n){return{id:new y.$yp(n.identifier.id),name:new y.$yp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Wp=new N.$sn("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(u=>!I(u.identifier,{id:o}))){const u=n.filter(b=>I(b.identifier,{id:o}));u.length===1&&(s.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function h(n,t){if(!A.$l)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,k.$0)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await h(n,t),r=(0,a.$ip)(s?"alpine":A.$v,O.$fc);return t.debug("ComputeTargetPlatform:",r),r}}),define(ue[198],de([0,1,25,27,35,34]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=T;async function T(k,O,y,I,p){try{const f=await k.getExtensionsControlManifest();if(!f.deprecated)return;const d=await k.getInstalled(A.ExtensionType.User);for(const[l,g]of Object.entries(f.deprecated)){if(!g?.extension)continue;const{id:E,autoMigrate:m,preRelease:w}=g.extension;if(!m)continue;const P=d.find(c=>(0,N.$Np)(c.identifier,{id:l}));if(!P)continue;const $=(await O.getExtensions([{id:E,preRelease:w}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!$){p.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{p.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const c=!I.getDisabledExtensions().some(i=>(0,N.$Np)(i,P.identifier));await k.uninstall(P),p.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=d.find(i=>(0,N.$Np)(i.identifier,{id:E}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery($,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:a.InstallOperation.Migrate}),p.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await I.disableExtension(h.identifier),p.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),m.storage&&(y.addToMigrationList((0,N.$Qp)(P.manifest.publisher,P.manifest.name),(0,N.$Qp)(h.manifest.publisher,h.manifest.name)),p.info("Added pre-release extension to the storage migration list"))),p.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(c){p.error(c)}}}catch(f){p.error(f)}}}),define(ue[199],de([0,1,8,3,2,31,35,34,7]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class y extends N.$Vc{constructor(p,f,d,l,g,E,m){super(),this.f=p,this.g=f,this.h=d,this.j=l,this.m=g,this.n=E,this.r=m,this.a=this.B(new a.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$5c),this.s().then(null,w=>m.error("Error while initializing Extensions Watcher",(0,R.$0)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(p=>this.u(p.added))),this.B(this.j.onAddExtensions(p=>this.w(p))),this.B(this.j.onDidAddExtensions(p=>this.y(p))),this.B(this.j.onRemoveExtensions(p=>this.z(p))),this.B(this.j.onDidRemoveExtensions(p=>this.C(p))),this.B(this.n.onDidFilesChange(p=>this.D(p)))}async u(p){try{p.length&&await Promise.all(p.map(f=>(this.c.set(f.id,(0,N.$Sc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(p){for(const f of p.extensions)this.I(this.L(f.identifier,f.version),p.profileLocation)}async y(p){for(const f of p.extensions){const d=this.L(f.identifier,f.version);p.error?this.J(d,p.profileLocation):this.I(d,p.profileLocation)}}async z(p){for(const f of p.extensions)this.J(this.L(f.identifier,f.version),p.profileLocation)}async C(p){const f=[],d=[];for(const l of p.extensions){const g=this.L(l.identifier,l.version);p.error?this.I(g,p.profileLocation):(this.J(g,p.profileLocation),this.b.has(g)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),d.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?f.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(d),f.length&&await this.H(f)}catch(l){this.r.error(l)}}D(p){for(const f of this.h.profiles)p.contains(f.extensionsResource,O.FileChangeType.UPDATED,O.FileChangeType.ADDED)&&this.F(f.extensionsResource)}async F(p){const f=[],d=[],l=await this.j.scanProfileExtensions(p),g=new Set,E=new Set;for(const[m,w]of this.b)w.has(p)&&E.add(m);for(const m of l){const w=this.L(m.identifier,m.version);g.add(w),E.has(w)||(f.push(m.identifier),this.I(w,p))}for(const m of E)if(!g.has(m)){const w=this.M(m);w&&(d.push(w.identifier),this.J(m,p))}(f.length||d.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:p}:void 0,removed:d.length?{extensions:d,profileLocation:p}:void 0})}async G(p){const f=await this.j.scanProfileExtensions(p);for(const d of f)this.I(this.L(d.identifier,d.version),p)}async H(p){p||(p=(await this.f.scanAllUserInstalledExtensions()).filter(d=>!this.b.has(this.L(d.identifier,d.manifest.version)))),p.length&&await this.f.markAsUninstalled(...p)}I(p,f){let d=this.b.get(p);d||this.b.set(p,d=new A.$Cc(l=>this.m.extUri.getComparisonKey(l))),d.add(f)}J(p,f){const d=this.b.get(p);d&&d.delete(f),d?.size||this.b.delete(p)}L(p,f){return`${k.$sn.toKey(p.id)}@${f}`}M(p){const[f,d]=(0,T.$Pp)(p);return d?{identifier:{id:f},version:d}:void 0}}e.$1q=y}),define(ue[200],de([0,1,33,76,17,6,2,22,13,30,15,27,35,10,79,9]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,R=Oe(R);let E=class extends l.$ds{constructor($,c,h,i){super(h),this.h=$,this.j=i,this.g=this.B(new m(c,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri($,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const n=i.translations[$];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),c=Object.keys($).map(h=>{const i=$[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((h,i)=>h.label.localeCompare(i.label)),c}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const c=await this.g.getLanguagePacks();Object.keys(c).some(h=>c[h]&&c[h].extensions.some(i=>(0,f.$Np)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(c);return!(0,N.$ub)(Object.keys($),Object.keys(h))}};e.$es=E,e.$es=E=Se([Q(0,p.$pp),Q(1,I.$Oi),Q(2,p.$mp),Q(3,d.$bk)],E);let m=class extends T.$Vc{constructor($,c){super(),this.j=c,this.c={},this.f=(0,O.$kc)($.userDataPath,"languagepacks.json"),this.g=new A.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(c=>{Object.keys(c).forEach(h=>delete c[h]),this.m(c,...$)}).then(()=>this.c)}m($,...c){for(const h of c)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n($,h);Object.keys($).forEach(h=>this.r($[h]))}n($,c){const h=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===k.Schemas.file&&w(n)){let t=$[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},$[n.languageId]=t);const s=t.extensions.filter(r=>(0,f.$Np)(r.extensionIdentifier,h))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:h,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,O.$kc)(c.location.fsPath,r.path)}}r($){if($){const c=(0,a.createHash)("md5");for(const h of $.extensions)c.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);$.hash=c.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let c=null;return R.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(c=$(h),h)).then(h=>{for(const n of Object.keys(h))h[n]||delete h[n];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),y.Promises.writeFile(this.f,i)}).then(()=>c,h=>this.j.error(h))})}};m=Se([Q(0,I.$Oi),Q(1,d.$bk)],m);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const $ of P.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(ue[201],de([0,1,67,8,29,48]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function O(I,p,f){const d=await(0,R.$uq)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,R.$uq)("@microsoft/1ds-post-js","dist/ms.post.js"),g=new d.AppInsightsCore,E=new l.PostChannel,m={instrumentationKey:I,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(f){m.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};m.extensionConfig[E.identifier]=w}return g.initialize(m,[]),g.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',p&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),g}class y{constructor(p,f,d,l,g){this.e=p,this.f=f,this.g=d,this.h=g,this.c=T,this.d=k,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=O(this.a,this.e,this.h)),this.b.then(f=>{p(f)},f=>{(0,a.$Z)(f),console.error(f)})}}log(p,f){if(!this.a)return;f=(0,N.$io)(f,this.g),f=(0,A.$Ip)(f);const d=this.f+"/"+p;try{this.i(l=>{l.pluginVersionString=f?.properties.version??"Unknown",l.track({name:d,baseData:{name:d,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.$BR=y}),define(ue[113],de([0,1,2,11,15,10,23,48]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;let O=class extends R.$Vc{constructor(I,p,f,d,l=""){super(),this.b=l;const g=p.getLogger(k.$Cp);if(g)this.a=this.B(g);else{const m=(0,k.$Gp)(d,f)?" (Not Sent)":"",w=()=>(0,k.$Fp)(d,f)&&I.getLevel()===A.LogLevel.Trace;this.a=this.B(p.createLogger(k.$Cp,{name:(0,a.localize)(2058,null,m),hidden:!w()})),this.B(I.onDidChangeLogLevel(()=>p.setVisibility(k.$Cp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,p){this.a.trace(`${this.b}telemetry/${I}`,(0,k.$Ip)(p))}};e.$Aec=O,e.$Aec=O=Se([Q(0,A.$bk),Q(1,A.$ck),Q(2,N.$Ni),Q(3,T.$uk)],O)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[114],de([0,1,2,29,5,26,11,21,47,103,23,44,18,48]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0,y=it(y);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,w,P){this.k=w,this.l=P,this.d={},this.i=new R.$Uc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,A.$if)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$if)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(f.$jm)||$.affectsConfiguration(f.$lm)||$.affectsConfiguration(f.$km))&&this.m()}))}setExperimentProperty(m,w){this.d[m]=w}m(){let m=(0,d.$Hp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?f.TelemetryLevel.USAGE:w.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;m=Math.min(m,P)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,w,P){this.g<w||(P=(0,a.$io)(P,this.d),P=(0,d.$Mp)(P,this.j),P=(0,a.$io)(P,this.c),this.b.forEach($=>$.log(m,P)))}publicLog(m,w){this.n(m,f.TelemetryLevel.USAGE,w)}publicLog2(m,w){this.publicLog(m,w)}publicLogError(m,w){this.h&&this.n(m,f.TelemetryLevel.ERROR,w)}publicLogError2(m,w){this.publicLogError(m,w)}};e.$ks=l,e.$ks=l=Se([Q(1,k.$aj),Q(2,I.$uk)],l);function g(){const E=(0,T.localize)(2059,null,y.default.nameLong),m=y.default.privacyStatementUrl?(0,T.localize)(2061,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,T.localize)(2060,null,"https://aka.ms/vscode-telemetry"),w=N.$p?"":(0,T.localize)(2062,null),P=(0,T.localize)(2063,null),$=(0,T.localize)(2064,null),c=(0,T.localize)(2065,null),h=(0,T.localize)(2066,null),i=`
|       | ${P} | ${$} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(2067,null);return`
${E} ${m} ${w}

&nbsp;

${h}
${i}

&nbsp;

${n}
`}p.$so.as(O.$xo.Configuration).registerConfiguration({id:f.$im,order:1,type:"object",title:(0,T.localize)(2068,null),properties:{[f.$jm]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(2069,null),(0,T.localize)(2070,null),(0,T.localize)(2071,null),(0,T.localize)(2072,null)],markdownDescription:g(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),p.$so.as(O.$xo.Configuration).registerConfiguration({id:f.$im,order:110,type:"object",title:(0,T.localize)(2073,null),properties:{[f.$lm]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,T.localize)(2075,null,y.default.nameLong,y.default.privacyStatementUrl):(0,T.localize)(2074,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(2076,null,`\`#${f.$jm}#\``),scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[202],de([0,1,14,25,245,201]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=void 0,N=Oe(N);async function T(I,p){const f=await p.request(I,a.CancellationToken.None),d=(await(0,R.$1e)(f.stream)).toString(),l=f.res.statusCode??200;return{headers:f.res.headers,statusCode:l,responseData:d}}async function k(I){const p={method:I.type,headers:I.headers};return new Promise((d,l)=>{const g=N.request(I.url??"",p,E=>{E.on("data",function(m){d({headers:E.headers,statusCode:E.statusCode??200,responseData:m.toString()})}),E.on("error",function(m){l(m)})});g.write(I.data,E=>{E&&l(E)}),g.end()})}async function O(I,p,f){const d=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),l={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:d};try{const g=I?await T(l,I):await k(l);f(g.statusCode,g.headers,g.responseData)}catch{f(0,{})}}class y extends A.$BR{constructor(p,f,d,l,g){const E={sendPOST:(m,w)=>{O(p,m,w)}};super(f,d,l,g,E)}}e.$CR=y}),define(ue[203],de([0,1,22,96,21,15,10,23,18,112,113,114]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;let f=class{constructor(l,g,E,m,w,P){this.b=l,this.c=g,this.d=E,this.e=m,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.c.machineId,g["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(g),l.aiKey],w=new a.$lr(R.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new y.$nhc(w),new I.$Aec(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new p.$ks({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,g,E){this.h(l).publicLog(g,E)}publicLogError(l,g,E){this.h(l).publicLogError(g,E)}};e.$Bic=f,e.$Bic=f=Se([Q(0,N.$aj),Q(1,O.$am),Q(2,T.$bk),Q(3,T.$ck),Q(4,A.$Ni),Q(5,k.$uk)],f)}),define(ue[81],de([0,1,3,2,5,9,21,4,10]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Pw=e.$Nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Jw=e.$Iw=void 0,e.$Kw=p,e.$Lw=d,e.$Mw=l,e.$Ow=g,e.$Qw=E,e.$Rw=m,e.$Iw=(0,k.$Gi)("tunnelService"),e.$Jw=(0,k.$Gi)("sharedTunnelsService");var y;(function($){$.Http="http",$.Https="https"})(y||(e.TunnelProtocol=y={}));var I;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(I||(e.TunnelPrivacyId=I={}));function p($){return!!$.forwardPort}var f;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function d($){if($.scheme!=="http"&&$.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(c)return{address:c[1],port:+c[2]}}function l($){if($.scheme!=="http"&&$.scheme!=="https"||!$.query)return;const c=$.query.split("&");for(const h of c){const i=h.split("=")[1];if(/^https?:/.exec(i)){const n=d(A.URI.parse(i));if(n)return n}}}e.$Nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g($){return e.$Nw.indexOf($)>=0}e.$Pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E($){return e.$Pw.indexOf($)>=0}function m($,c,h,i){if(h===N.OperatingSystem.Windows)return!1;if(h===N.OperatingSystem.Macintosh&&E(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return $<1024}class w{constructor(c,h,i){this.remoteAddress=c,this.localAddress=h,this.b=i,this.a=new R.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sw=w;let P=class extends a.$Vc{constructor(c,h){super(),this.r=c,this.s=h,this.a=new R.$me,this.onTunnelOpened=this.a.event,this.b=new R.$me,this.onTunnelClosed=this.b.event,this.c=new R.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const c=this.s.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.g=c,c?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.h=c.elevation,this.m=c.privacyOptions,this.j=c.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const c=[],h=Array.from(this.f.values());for(const i of h){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this.f.values()){for(const{value:h}of c.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this.f.clear()}setEnvironmentTunnel(c,h,i,n,t){this.z(c,h,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:h,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,h){(E(c)||g(c))&&(c=e.$Nw[0]);const i=this.D(c,h);if(i)return++i.refcount,i.value}openTunnel(c,h,i,n,t,s=!1,r,o){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??c;if(!u)return;if(h||(h="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.F(u,h,i,n,t,s,r,o);return b?b.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(L);return(L.tunnelRemoteHost!==h||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&L.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}w(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this.f.get(c.tunnelRemoteHost);if(h){const i=h.get(c.tunnelRemotePort);i&&(i.refcount--,await this.y(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async y(c,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(c)&&this.f.get(c).delete(h),n}}async closeTunnel(c,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const i=this.f.get(c);if(i&&i.has(h)){const n=i.get(h);n.refcount=0,await this.y(c,h,n)}}z(c,h,i){this.f.has(c)||this.f.set(c,new Map),this.f.get(c).set(h,{refcount:1,value:i})}async C(c,h){const i=this.f.get(c);if(i){const n=i.get(h),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(c)}}D(c,h){const i=[c];g(c)?(i.push(...e.$Nw),i.push(...e.$Pw)):E(c)&&i.push(...e.$Pw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(h);if(s)return s}}canTunnel(c){return!!d(c)}G(c,h,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${n}.`);const o=i;this.n.add(o);const u=n===void 0?i:n,b={elevationRequired:t?this.isPortPrivileged(u):!1},L={remoteAddress:{host:h,port:i},localAddressPort:n,privacy:s,public:s?s!==I.Private:void 0,protocol:r},S=c.forwardPort(L,b);return S?(this.z(h,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(o)})):this.n.delete(o),S}};e.$Tw=P,e.$Tw=P=Se([Q(0,O.$bk),Q(1,T.$aj)],P)}),define(ue[204],de([0,1,10,81,2,8,6]),function(ce,e,R,a,N,A,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class O extends N.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$4h),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let y=class extends N.$Vc{static{k=this}static{this.a=0}constructor(p,f){super(),this.f=p,this.g=f,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel(p,f,d,l,g,E,m){const w=new O,P=await Promise.resolve(this.f.openTunnel(p,w,d,l,g,E,m));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(f))throw this.c.delete(f),w.dispose(),await P.dispose(),(0,A.$6)();return w.setTunnel(P),this.b.set(f,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${f}: ${P.localAddress} (local) to ${d}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(p,f){const d=this.b.get(p);d&&d.setAddress(f)}async destroyTunnel(p){const f=this.b.get(p);if(f){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await f.dispose();return}this.c.add(p)}};e.$Lic=y,e.$Lic=y=k=Se([Q(0,a.$Jw),Q(1,R.$bk)],y)}),define(ue[28],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,R.$Gi)("IUriIdentityService")}),define(ue[205],de([0,1,28,161,7,20,136,3,2]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class y{static{this._clock=0}constructor(f){this.uri=f,this.time=y._clock++}touch(){return this.time=y._clock++,this}}let I=class{constructor(f){this.g=f,this.c=new O.$Uc,this.f=2**16;const d=new Map,l=g=>{let E=d.get(g.scheme);return E===void 0&&(E=f.hasProvider(g)&&!this.g.hasCapability(g,N.FileSystemProviderCapabilities.PathCaseSensitive),d.set(g.scheme,E)),E};this.c.add(k.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(g=>{d.delete(g.scheme)})),this.extUri=new A.$9g(l),this.d=new T.$Ws((g,E)=>this.extUri.compare(g,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,A.$ih)(f));const d=this.d.get(f);return d?d.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new y(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort((l,g)=>l[1].time<g[1].time?1:l[1].time>g[1].time?-1:0);y._clock=0,this.d.clear();const d=this.f*.5;for(let l=0;l<d;l++)this.d.set(f[l][0],f[l][1].touch())}};e.$Xs=I,e.$Xs=I=Se([Q(0,N.$bl)],I),(0,a.$Us)(R.$Ll,I,a.InstantiationType.Delayed)}),define(ue[206],de([0,1,3,2,7,51,31]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class k extends a.$Vc{constructor(y,I,p,f,d,l){super(),this.f=y,this.g=I,this.h=p,this.j=f,this.m=d,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$me),this.onDidChangeFile=this.a.event,this.b=A.$Mi.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Cc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(f.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const y of this.j.profiles)this.c.add(y.settingsResource),this.c.add(y.keybindingsResource),this.c.add(y.tasksResource),this.c.add(y.extensionsResource)}open(y,I){return this.g.open(this.t(y),I)}close(y){return this.g.close(y)}read(y,I,p,f,d){return this.g.read(y,I,p,f,d)}write(y,I,p,f,d){return this.g.write(y,I,p,f,d)}watch(y,I){this.b.set(y,y);const p=this.g.watch(this.t(y),I);return(0,a.$Tc)(()=>{this.b.delete(y),p.dispose()})}stat(y){return this.g.stat(this.t(y))}mkdir(y){return this.g.mkdir(this.t(y))}rename(y,I,p){return this.g.rename(this.t(y),this.t(I),p)}readFile(y,I){return this.g.readFile(this.t(y),I)}readFileStream(y,I,p){return this.g.readFileStream(this.t(y),I,p)}readdir(y){return this.g.readdir(this.t(y))}enforceAtomicReadFile(y){return this.c.has(y)}writeFile(y,I,p){return this.g.writeFile(this.t(y),I,p)}enforceAtomicWriteFile(y){return this.c.has(y)?{postfix:".vsctmp"}:!1}delete(y,I){return this.g.delete(this.t(y),I)}copy(y,I,p){if((0,N.$fl)(this.g))return this.g.copy(this.t(y),this.t(I),p);throw new Error("copy not supported")}cloneFile(y,I){if((0,N.$gl)(this.g))return this.g.cloneFile(this.t(y),this.t(I));throw new Error("clone not supported")}s(y){const I=[];for(const p of y){if(p.resource.scheme!==this.f)continue;const f=this.u(p.resource);this.b.findSubstr(f)&&I.push({resource:f,type:p.type,cId:p.cId})}I.length&&(this.n.debug("User data changed"),this.a.fire(I))}t(y){return y.with({scheme:this.f})}u(y){return y.with({scheme:this.h})}}e.$cic=k}),define(ue[82],de([0,1,64]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$YMb=N,e.$ZMb=A;function a(T,k,O,y){const I=(0,R.$bo)(T,k,O,y)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}function N(T,k,O){let y=O;for(;y>=0;){if(T.charAt(y)===k.charAt(k.length-1)&&k.length===1)return y+1;if(y--,k.length===2&&y>=0&&T.charAt(y)===k.charAt(0))return y+2}return 0}function A(T,k,O){let y=O;for(;y>=0;)if(T.charAt(y)===k.charAt(k.length-1)&&k.length===1||(y++,k.length===2&&y>=0&&T.charAt(y)===k.charAt(1)))return y;return T.length-1}}),define(ue[207],de([0,1,29,60,12]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=A,a=Oe(a);function A(d,l,g,E,m,w){const P=[],$=[],c=[];if(!l){const j=d.filter(({identifier:H})=>m.every(W=>W.toLowerCase()!==H.id.toLowerCase()));return{local:{added:P,removed:$,updated:c},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}d=d.map(p),l=l.map(p),g=g?g.map(p):null;const h=new Map,i=j=>{j.uuid&&h.set(j.id.toLowerCase(),j.uuid)};d.forEach(({identifier:j})=>i(j)),l.forEach(({identifier:j})=>i(j)),g?.forEach(({identifier:j})=>i(j)),E?.forEach(({identifier:j})=>i(j)),w?.forEach(j=>i(j));const n=j=>{const H=j.identifier.uuid||h.get(j.identifier.id.toLowerCase());return H?`uuid:${H}`:`id:${j.identifier.id.toLowerCase()}`},t=(j,H)=>(j.set(n(H),H),j),s=d.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((j,H)=>t(j,(0,R.$fo)(H)),new Map),u=g?g.reduce(t,new Map):null,b=E.reduce(t,new Map),L=m.reduce((j,H)=>{const W=h.get(H.toLowerCase());return j.add(W?`uuid:${W}`:`id:${H.toLowerCase()}`)},new Set),S=w?w.reduce((j,{id:H,uuid:W})=>(W=W??h.get(H.toLowerCase()),j.add(W?`uuid:${W}`:`id:${H.toLowerCase()}`)),new Set):null,v=T(s,r,L,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const j=T(u,s,L,!1),H=T(u,r,L,!0),W=(x,G,te,B)=>{let V,_,ne;return G.installed?(V=B.pinned,ne=B.preRelease,V&&(_=B.version)):(V=te.pinned,ne=te.preRelease,V&&(_=te.version)),V===void 0&&(V=G.pinned,V&&(_=G.version)),ne===void 0&&(ne=G.preRelease),{...B,installed:G.installed||te.installed,pinned:V,preRelease:ne,version:_??(te.version&&(!G.installed||a.gt(te.version,G.version))?te.version:G.version),state:O(G,te,u?.get(x))}};for(const x of H.removed.values()){const G=s.get(x);if(!G)continue;const te=(0,N.$qg)(u?.get(x)),B=S&&!S.has(x)&&te.installed;G.installed&&B?$.push(G.identifier):o.set(x,G)}for(const x of H.added.values()){const G=(0,N.$qg)(r.get(x)),te=s.get(x);if(te){if(v.updated.has(x)){const B=W(x,te,G,G);k(te,G,!1,!1)||c.push(f(B,x)),o.set(x,B)}}else G.installed&&P.push(f(G,x))}for(const x of H.updated.values()){const G=(0,N.$qg)(r.get(x)),te=(0,N.$qg)(u?.get(x)),B=s.get(x);if(B)if(S&&!S.has(x)&&te.installed&&B.installed&&!G.installed)$.push(B.identifier);else{const _=W(x,B,G,G);c.push(f(_,x)),o.set(x,_)}else G.installed&&P.push(f(G,x))}for(const x of j.added.values())H.added.has(x)||o.set(x,(0,N.$qg)(s.get(x)));for(const x of j.updated.values()){if(H.removed.has(x)||H.updated.has(x))continue;const G=(0,N.$qg)(s.get(x)),te=(0,N.$qg)(r.get(x));o.set(x,W(x,G,te,G))}for(const x of j.removed.values())H.updated.has(x)||H.removed.has(x)||b.has(x)||(0,N.$qg)(r.get(x)).installed&&S&&(S.has(x)||!(0,N.$qg)(u?.get(x)).installed||o.delete(x))}const C=[],U=T(r,o,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&o.forEach((j,H)=>C.push(f(j,H))),{local:{added:P,removed:$,updated:c},remote:F?{added:[...U.added].map(j=>o.get(j)),updated:[...U.updated].map(j=>o.get(j)),removed:[...U.removed].map(j=>r.get(j)),all:C}:null}}function T(d,l,g,E){const m=d?[...d.keys()].filter(h=>!g.has(h)):[],w=[...l.keys()].filter(h=>!g.has(h)),P=w.filter(h=>!m.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),$=m.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),c=new Set;for(const h of m){if($.has(h))continue;const i=d.get(h),n=l.get(h);(!n||!k(i,n,E,!0))&&c.add(h)}return{added:P,removed:$,updated:c}}function k(d,l,g,E){return!(d.disabled!==l.disabled||!!d.isApplicationScoped!=!!l.isApplicationScoped||E&&d.installed!==l.installed||d.installed&&l.installed&&(d.preRelease!==l.preRelease||d.pinned!==l.pinned||l.pinned&&d.version!==l.version)||!I(d.state,l.state)||g&&d.version!==l.version)}function O(d,l,g){const E=d.state,m=l.state,w=g?.state;if(!l.version||E&&a.gt(d.version,l.version))return E;if(m&&a.gt(l.version,d.version)||!E)return m;if(!m)return E;const P=(0,R.$fo)(E),$=w?y(w,m):{added:Object.keys(m).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},c=w?y(w,E):{added:Object.keys(E).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...$.added.values(),...$.updated.values()])P[h]=m[h];for(const h of $.removed.values())c.updated.has(h)||delete P[h];return P}function y(d,l){const g=Object.keys(d),E=Object.keys(l),m=E.filter($=>!g.includes($)).reduce(($,c)=>($.add(c),$),new Set),w=g.filter($=>!E.includes($)).reduce(($,c)=>($.add(c),$),new Set),P=new Set;for(const $ of g){if(w.has($))continue;const c=d[$],h=l[$];(0,R.$jo)(c,h)||P.add($)}return{added:m,removed:w,updated:P}}function I(d={},l={}){const{added:g,removed:E,updated:m}=y(d,l);return g.size===0&&E.size===0&&m.size===0}function p(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function f(d,l){const g={...d,identifier:{id:d.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled||delete g.disabled,d.installed||delete g.installed,d.state||delete g.state,d.isApplicationScoped||delete g.isApplicationScoped,g}}),define(ue[115],de([0,1,17,21,4]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jPb=e.$iPb=void 0,e.$iPb=(0,N.$Gi)("IIgnoredExtensionsManagementService");let A=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,O){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==k&&I!==`-${k}`),O&&y.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,O){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==k&&I!==`-${k}`),O&&y.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(k){const O=k.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),y=this.b().map(f=>f.toLowerCase()),I=[],p=[];if(Array.isArray(y))for(const f of y)f.startsWith("-")?p.push(f.substring(1)):I.push(f);return(0,R.$Mb)([...O,...I].filter(f=>!p.includes(f)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(O=>O.toLowerCase())}};e.$jPb=A,e.$jPb=A=Se([Q(0,a.$aj)],A)}),define(ue[208],de([0,1,17,36,29,97,82]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=O,N=Oe(N),T=Oe(T);function k($){return(0,a.$Zn)($)||[]}async function O($,c,h,i,n){const t=k($),s=k(c),r=h?k(h):null,o=[...t,...s,...r||[]].map(W=>W.key),u=await n.resolveUserBindings(o),b=I(t,s,r,u);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:$,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};const L=f(t),S=f(s),v=r?f(r):null,C=l(L,S,u),U=v?l(v,L,u):{added:[...L.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},F=v?l(v,S,u):{added:[...S.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},j=y(C,U,F);let H=$;for(const W of j.removed.values())j.conflicts.has(W)||(H=w(H,W,i));for(const W of j.added.values()){if(j.conflicts.has(W))continue;const x=S.get(W);if(x.some(G=>G.command!==`-${W}`&&b.conflicts.has(u[G.key]))){j.conflicts.add(W);continue}H=m(H,x,i)}for(const W of j.updated.values()){if(j.conflicts.has(W))continue;const x=S.get(W);if(x.some(G=>G.command!==`-${W}`&&b.conflicts.has(u[G.key]))){j.conflicts.add(W);continue}H=P(H,W,x,i)}return{mergeContent:H,hasChanges:!0,hasConflicts:j.conflicts.size>0}}function y($,c,h){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())h.updated.has(r)&&s.add(r);for(const r of h.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||h.added.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.added.values())s.has(r)||(c.added.has(r)?$.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||h.updated.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.updated.values())s.has(r)||(c.updated.has(r)?$.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function I($,c,h,i){const n=new Set,t=p($,i),s=p(c,i),r=h?p(h,i):null,o=d(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=r?d(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const b=r?d(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:L,removed:S,updated:v,conflicts:C}=y(o,u,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:S,updated:v,conflicts:C}}function p($,c){const h=new Map;for(const i of $){const n=c[i.key];let t=h.get(n);t||(t=[],h.set(n,t)),t.push(i)}return h}function f($){const c=new Map;for(const h of $){const i=h.command[0]==="-"?h.command.substring(1):h.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(h)}return c}function d($,c){const h=[...$.keys()],i=[...c.keys()],n=i.filter(r=>!h.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of h){if(t.has(r))continue;const o=$.get(r).map(b=>({...b,key:r})),u=c.get(r).map(b=>({...b,key:r}));(0,R.$ub)(o,u,(b,L)=>E(b,L))||s.add(r)}return{added:n,removed:t,updated:s}}function l($,c,h){const i=[...$.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const u=$.get(o).map(L=>({...L,key:h[L.key]})),b=c.get(o).map(L=>({...L,key:h[L.key]}));g(u,b)||r.add(o)}return{added:t,removed:s,updated:r}}function g($,c){return!(!(0,R.$ub)($.filter(({command:h})=>h[0]!=="-"),c.filter(({command:h})=>h[0]!=="-"),(h,i)=>E(h,i))||!(0,R.$ub)($.filter(({command:h})=>h[0]==="-"),c.filter(({command:h})=>h[0]==="-"),(h,i)=>E(h,i)))}function E($,c){if($.command!==c.command||$.key!==c.key)return!1;const h=A.$Ej.deserialize($.when),i=A.$Ej.deserialize(c.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!N.$jo($.args,c.args))}function m($,c,h){for(const i of c)$=T.edit($,[-1],i,h);return $}function w($,c,h){const i=k($);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&($=T.edit($,[n],void 0,h));return $}function P($,c,h,i){const n=k($),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&($=T.edit($,[s],void 0,i));for(let s=h.length-1;s>=0;s--)$=T.edit($,[t],h[s],i);return $}}),define(ue[209],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=R,e.$sdc=N;function R(A,T,k){const O={},y={},I=new Set;if(!T)return{local:{added:O,updated:y,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const p=a(A,T);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:O,updated:y,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=a(k,A),d=a(k,T),l={},g={},E=new Set,m=new Set;for(const w of f.removed.values())d.updated.has(w)?O[w]=T[w]:E.add(w);for(const w of d.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):I.add(w));for(const w of f.updated.values())m.has(w)||(d.updated.has(w)?p.updated.has(w)&&m.add(w):g[w]=A[w]);for(const w of d.updated.values())m.has(w)||(f.updated.has(w)?p.updated.has(w)&&m.add(w):A[w]!==void 0&&(y[w]=T[w]));for(const w of f.added.values())m.has(w)||(d.added.has(w)?p.updated.has(w)&&m.add(w):l[w]=A[w]);for(const w of d.added.values())m.has(w)||(f.added.has(w)?p.updated.has(w)&&m.add(w):O[w]=T[w]);return{local:{added:O,removed:[...I.values()],updated:y},remote:{added:l,removed:[...E.values()],updated:g},conflicts:[...m.values()]}}function a(A,T){const k=A?Object.keys(A):[],O=T?Object.keys(T):[],y=O.filter(f=>!k.includes(f)).reduce((f,d)=>(f.add(d),f),new Set),I=k.filter(f=>!O.includes(f)).reduce((f,d)=>(f.add(d),f),new Set),p=new Set;for(const f of k){if(I.has(f))continue;const d=A[f],l=T[f];d!==l&&p.add(f)}return{added:y,removed:I,updated:p}}function N(A,T){const{added:k,removed:O,updated:y}=a(A,T);return k.size===0&&O.size===0&&y.size===0}}),define(ue[210],de([0,1,29]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=a;function a(A,T,k,O){const y={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!T){const f=A.filter(({id:d})=>!O.includes(d));return f.length?I.added=f:I=null,{local:y,remote:I}}const p=N(A,T,O);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const f=N(k,A,O),d=N(k,T,O);for(const l of d.removed){const g=A.find(E=>E.id===l);g&&y.removed.push(g)}for(const l of d.added){const g=T.find(E=>E.id===l);f.added.includes(l)?p.updated.includes(l)&&y.updated.push(g):y.added.push(g)}for(const l of d.updated)y.updated.push(T.find(g=>g.id===l));for(const l of f.added)d.added.includes(l)||I.added.push(A.find(g=>g.id===l));for(const l of f.updated)d.removed.includes(l)||d.updated.includes(l)||I.updated.push(A.find(g=>g.id===l));for(const l of f.removed){const g=T.find(E=>E.id===l);g&&I.removed.push(g)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:y,remote:I}}function N(A,T,k){A=A?A.filter(({id:d})=>!k.includes(d)):[],T=T.filter(({id:d})=>!k.includes(d));const O=A.map(({id:d})=>d),y=T.map(({id:d})=>d),I=y.filter(d=>!O.includes(d)),p=O.filter(d=>!y.includes(d)),f=[];for(const{id:d,name:l,shortName:g,icon:E,useDefaultFlags:m}of A){if(p.includes(d))continue;const w=T.find(P=>P.id===d);(!w||w.name!==l||w.shortName!==g||w.icon!==E||!(0,R.$jo)(w.useDefaultFlags,m))&&f.push(d)}return{added:I,removed:p,updated:f}}}),define(ue[24],de([0,1,17,12,11,47,27,4,104,44]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eob=e.$dob=e.$cob=e.$bob=e.$aob=e.$_nb=e.$$nb=e.$0nb=e.$9nb=e.$7nb=e.MergeState=e.Change=e.SyncStatus=e.$6nb=e.$5nb=e.$4nb=e.UserDataSyncErrorCode=e.$2nb=e.$1nb=e.$Znb=e.$Ynb=e.$Xnb=e.$Unb=e.SyncResource=e.$Rnb=e.$Qnb=void 0,e.$Nnb=I,e.$Onb=p,e.$Pnb=f,e.$Snb=l,e.$Tnb=g,e.$Vnb=m,e.$Wnb=w,e.$3nb=P,e.$8nb=r;function I(){const o=y.$so.as(A.$xo.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}function p(o=!1){const u=y.$so.as(A.$xo.Configuration).getConfigurationProperties(),b=d(u,o),L=I();return(0,R.$Mb)([...b,...L])}function f(o){if(!o.contributes?.configuration)return[];const u=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!u.length)return[];const b=(0,A.$No)(u);return d(b,!1)}function d(o,u){const b=new Set;for(const L in o){if(u&&o[L].source)continue;const S=(0,a.$fg)(o[L].scope)?(0,A.$Oo)(o[L].scope):o[L].scope;(o[L].ignoreSync||S===A.ConfigurationScope.MACHINE||S===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&b.add(L)}return[...b.values()]}e.$Qnb="settingsSync",e.$Rnb="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",u=y.$so.as(A.$xo.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(2442,null),type:"object",properties:{[e.$Rnb]:{type:"boolean",description:(0,N.localize)(2443,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2444,null),items:[{type:"string",pattern:T.$_o,errorMessage:(0,N.localize)(2445,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(2446,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const b=y.$so.as(O.$to.JSONContribution),L=()=>{const S=I(),v=p(),C=Object.keys(A.$yo.properties).filter(j=>!v.includes(j)),U=v.filter(j=>!S.includes(j)),F={items:{type:"string",enum:[...C,...U.map(j=>`-${j}`)]}};b.registerSchema(o,F)};return u.onDidUpdateConfiguration(()=>L())}function g(o){return o&&(0,a.$hg)(o)&&(0,a.$fg)(o.id)&&Array.isArray(o.scopes)}var E;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$Unb=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function m(o,...u){return o?[o,...u]:u}function w(o,u,b,L){return L.joinPath(b.userDataSyncHome,...m(o,u,`lastSync${u}.json`))}e.$Xnb=(0,k.$Gi)("IUserDataSyncStoreManagementService"),e.$Ynb=(0,k.$Gi)("IUserDataSyncStoreService"),e.$Znb=(0,k.$Gi)("IUserDataSyncLocalStoreService"),e.$1nb="x-operation-id",e.$2nb="X-Execution-Id";function P(o){const u={};return u[e.$2nb]=o,u}var $;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})($||(e.UserDataSyncErrorCode=$={}));class c extends Error{constructor(u,b,L,S){super(u),this.code=b,this.resource=L,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$4nb=c;class h extends c{constructor(u,b,L,S,v){super(u,L,void 0,v),this.url=b,this.serverCode=S}}e.$5nb=h;class i extends c{constructor(u,b){super(u,b)}}e.$6nb=i,function(o){function u(b){if(b instanceof o)return b;const L=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(b.name);if(L&&L[1]){const S=L[2]==="unknown"?void 0:L[2],v=L[3]==="unknown"?void 0:L[3];return new o(b.message,L[1],S,v)}return new o(b.message,$.Unknown)}o.toUserDataSyncError=u}(c||(e.$4nb=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.$7nb="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.$9nb=(0,k.$Gi)("IUserDataSyncEnablementService"),e.$0nb=(0,k.$Gi)("IUserDataSyncService"),e.$$nb=(0,k.$Gi)("IUserDataSyncResourceProviderService"),e.$_nb=(0,k.$Gi)("IUserDataAutoSyncService"),e.$aob=(0,k.$Gi)("IUserDataSyncUtilService"),e.$bob=(0,k.$Gi)("IUserDataSyncLogService"),e.$cob="userDataSync",e.$dob="vscode-userdata-sync",e.$eob="preview"}),define(ue[211],de([0,1,29,24]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uOb=N,R=Oe(R);function N(T,k,O,y,I){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const p=A(T,k);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const f=O?A(O,k):{added:Object.keys(k).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},d=O?A(O,T):{added:Object.keys(T).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},g=R.$fo(k),E=!O;for(const w of d.added.values())w!==a.$7nb&&E&&f.added.has(w)||(g[w]=T[w]);for(const w of d.updated.values())g[w]=T[w];for(const w of d.removed.values())y.unregistered.includes(w)||delete g[w];for(const w of f.added.values()){const P=k[w];if(y.machine.includes(w)){I.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(O&&d.added.has(w))continue;const $=T[w];$&&$.value===P.value||w===a.$7nb&&E&&d.added.has(w)||($?l.updated[w]=P:l.added[w]=P)}for(const w of f.updated.values()){const P=k[w];if(y.machine.includes(w)){I.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(w)||d.removed.has(w))continue;const $=T[w];$&&$.value===P.value||(l.updated[w]=P)}for(const w of f.removed.values()){if(y.machine.includes(w)){I.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}d.updated.has(w)||d.removed.has(w)||l.removed.push(w)}const m=A(k,g);return{local:l,remote:{added:[...m.added],updated:[...m.updated],removed:[...m.removed],all:m.added.size===0&&m.removed.size===0&&m.updated.size===0?null:g}}}function A(T,k){const O=Object.keys(T),y=Object.keys(k),I=y.filter(d=>!O.includes(d)).reduce((d,l)=>(d.add(l),d),new Set),p=O.filter(d=>!y.includes(d)).reduce((d,l)=>(d.add(l),d),new Set),f=new Set;for(const d of O){if(p.has(d))continue;const l=T[d],g=k[d];R.$jo(l,g)||f.add(d)}return{added:I,removed:p,updated:f}}}),define(ue[212],de([0,1,17,36,64,45,29,82,24]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Mb=y,e.$2Mb=f,e.$3Mb=d,e.$4Mb=l,e.$5Mb=E,e.$6Mb=w,T=Oe(T),k=Oe(k);function y(o,u,b){let L=[];b?L=p(b):L=I(u);const S=[],v=[...(0,O.$Nnb)()];if(Array.isArray(L))for(const C of L)C.startsWith("-")?v.push(C.substring(1)):S.push(C);return(0,R.$Mb)([...o,...S].filter(C=>!v.includes(C)))}function I(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function p(o){const u=(0,a.$Zn)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(o,u){const b=(0,a.$Zn)(o)||{};let L="{}";for(const S of Object.keys(b)){const v=(0,N.$bo)(L,[S],b[S],u);L=(0,N.$eo)(L,v)}return L}function d(o,u,b,L){if(b.length){const S=r(u),v=(0,a.$Zn)(u)||{},C=(0,a.$Zn)(o);if(!C)return o;const U=[];for(const F of b){const j=v[F],H=C[F];j===void 0?o=k.edit(o,[F],void 0,L):H!==void 0?o=k.edit(o,[F],j,L):U.push(h(F,S))}U.sort((F,j)=>F.startOffset-j.startOffset),U.forEach(F=>o=w(F.setting.key,u,o,L))}return o}function l(o,u,b,L,S,v){const C=d(o,u,L,v),U=b!==C,F=b!==u;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:C,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:d(u,o,L,v),remoteContent:null,hasConflicts:!1};if(b===null&&E(o)){const D=g(o,u,L)?null:d(u,o,L,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let j=o,H=u;const W=(0,a.$Zn)(o),x=(0,a.$Zn)(u),G=b?(0,a.$Zn)(b):null,te=L.reduce((D,J)=>(D.add(J),D),new Set),B=m(W,x,te),V=m(G,W,te),_=m(G,x,te),ne=new Map,le=new Set,ee=D=>{le.add(D);const J=S.filter(({key:oe})=>oe===D)[0];J?(j=k.edit(j,[D],J.value,v),H=k.edit(H,[D],J.value,v)):ne.set(D,{key:D,localValue:W[D],remoteValue:x[D]})};for(const D of V.removed.values())_.updated.has(D)?ee(D):H=k.edit(H,[D],void 0,v);for(const D of _.removed.values())le.has(D)||(V.updated.has(D)?ee(D):j=k.edit(j,[D],void 0,v));for(const D of V.updated.values())le.has(D)||(_.updated.has(D)?B.updated.has(D)&&ee(D):H=k.edit(H,[D],W[D],v));for(const D of _.updated.values())le.has(D)||(V.updated.has(D)?B.updated.has(D)&&ee(D):j=k.edit(j,[D],x[D],v));for(const D of V.added.values())le.has(D)||(_.added.has(D)?B.updated.has(D)&&ee(D):H=w(D,j,H,v));for(const D of _.added.values())le.has(D)||(V.added.has(D)?B.updated.has(D)&&ee(D):j=w(D,H,j,v));const X=ne.size>0||!g(j,H,L),K=X||!g(j,o,[]),q=X||!g(H,u,[]);return{localContent:K?j:null,remoteContent:q?H:null,conflictsSettings:[...ne.values()],hasConflicts:X}}function g(o,u,b){if(o===u)return!0;const L=(0,a.$Zn)(o),S=(0,a.$Zn)(u),v=b.reduce((F,j)=>(F.add(j),F),new Set),C=r(o).filter(F=>!(F.setting&&v.has(F.setting.key))),U=r(u).filter(F=>!(F.setting&&v.has(F.setting.key)));if(C.length!==U.length)return!1;for(let F=0;F<C.length;F++){const j=C[F],H=U[F];if(j.setting&&H.setting){if(j.setting.key!==H.setting.key||!T.$jo(L[j.setting.key],S[j.setting.key]))return!1}else if(!j.setting&&!H.setting){if(j.value!==H.value)return!1}else return!1}return!0}function E(o){return o?r(o).length===0:!0}function m(o,u,b){const L=o?Object.keys(o).filter(F=>!b.has(F)):[],S=Object.keys(u).filter(F=>!b.has(F)),v=S.filter(F=>!L.includes(F)).reduce((F,j)=>(F.add(j),F),new Set),C=L.filter(F=>!S.includes(F)).reduce((F,j)=>(F.add(j),F),new Set),U=new Set;if(o)for(const F of L){if(C.has(F))continue;const j=o[F],H=u[F];T.$jo(j,H)||U.add(F)}return{added:v,removed:C,updated:U}}function w(o,u,b,L){const S=(0,a.$Zn)(u),v=r(u),C=r(b),U=P(o,v,C);return $(b,o,S[o],U,C,L)}function P(o,u,b){const L=u.findIndex(v=>v.setting?.key===o),S=u[L-1];if(S){if(S.setting){const C=h(S.setting.key,b);if(C)return{index:b.indexOf(C),insertAfter:!0}}else{const C=i(L,u);if(C){const U=h(C.setting.key,b);if(U){const F=n(b.indexOf(U),b),j=t(u,C,u[L]);if(F){const H=t(b,U,F),W=s(j,H);return W?{index:b.indexOf(W),insertAfter:!0}:{index:b.indexOf(F),insertAfter:!1}}else{const H=t(b,U,b[b.length-1]),W=s(j,H);return W?{index:b.indexOf(W),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const v=u[L+1];if(v)if(v.setting){const C=h(v.setting.key,b);if(C)return{index:b.indexOf(C),insertAfter:!1}}else{const C=n(L,u);if(C){const U=h(C.setting.key,b);if(U){const F=i(b.indexOf(U),b),j=t(u,u[L],C);if(F){const H=t(b,F,U),W=s(j.reverse(),H.reverse());return W?{index:b.indexOf(W),insertAfter:!1}:{index:b.indexOf(F),insertAfter:!0}}else{const H=t(b,b[0],U),W=s(j.reverse(),H.reverse());return W?{index:b.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function $(o,u,b,L,S,v){let C;return L.index===-1?C=(0,N.$bo)(o,[u],b,v):C=c(o,u,b,L,S,v).map(U=>(0,N.$co)(o,U,v)[0]),(0,N.$eo)(o,C)}function c(o,u,b,L,S,v){const C=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,U=(0,A.$$n)(v,o),F=S[L.index];if(L.insertAfter){const j=[];if(F.setting)j.push({offset:F.endOffset,length:0,content:","+C});else{const H=n(L.index,S),W=i(L.index,S),x=W?.setting?.commaOffset;W&&x===void 0&&j.push({offset:W.endOffset,length:0,content:","});const G=x!==void 0&&x>F.endOffset;j.push({offset:G?x+1:F.endOffset,length:0,content:H?U+C+",":U+C})}return j}else{if(F.setting)return[{offset:F.startOffset,length:0,content:C+","}];const j=(S[L.index-1]&&!S[L.index-1].setting?U:"")+C+(n(L.index,S)?",":"")+U;return[{offset:F.startOffset,length:0,content:j}]}}function h(o,u){return u.filter(b=>b.setting?.key===o)[0]}function i(o,u){for(let b=o-1;b>=0;b--)if(u[b].setting)return u[b]}function n(o,u){for(let b=o+1;b<u.length;b++)if(u[b].setting)return u[b]}function t(o,u,b){const L=o.indexOf(u),S=o.indexOf(b);return o.filter((v,C)=>L<C&&C<S)}function s(o,u){if(o.length&&u.length){let b=0;for(;b<u.length&&b<o.length;b++)if(o[b].value!==u[b].value)return u[b-1];return u[b-1]}}function r(o){const u=[];let b=-1,L,S;const v={onObjectBegin:C=>{b++},onObjectProperty:(C,U,F)=>{b===0&&(L=U,S=C)},onObjectEnd:(C,U)=>{b--,b===0&&u.push({startOffset:L,endOffset:C+U,value:o.substring(L,C+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(C,U)=>{b++},onArrayEnd:(C,U)=>{b--,b===0&&u.push({startOffset:L,endOffset:C+U,value:o.substring(L,C+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(C,U,F)=>{b===0&&u.push({startOffset:L,endOffset:U+F,value:o.substring(L,U+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(C,U,F)=>{if(b===0&&C===","){let j=u.length-1;for(;j>=0&&!u[j].setting;j--);const H=u[j];H&&u.splice(j,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:U}})}},onComment:(C,U)=>{b===0&&u.push({startOffset:C,endOffset:C+U,value:o.substring(C,C+U)})}};return(0,a.$7n)(o,v),u}}),define(ue[83],de([0,1,3,2,4,24]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LMb=e.$KMb=void 0,e.$KMb=(0,N.$Gi)("IUserDataSyncAccountService");let T=class extends a.$Vc{get account(){return this.a}constructor(O,y){super(),this.g=O,this.h=y,this.b=this.B(new R.$me),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$me),this.onTokenFailed=this.c.event,this.f=!1,this.B(O.onTokenFailed(I=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,I),this.updateAccount(void 0),I===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(O.onTokenSucceed(()=>this.f=!1))}async updateAccount(O){(O&&this.a?O.token!==this.a.token||O.authenticationProviderId!==this.a.authenticationProviderId:O!==this.a)&&(this.a=O,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(O))}};e.$LMb=T,e.$LMb=T=Se([Q(0,A.$Ynb),Q(1,A.$bob)],T)}),define(ue[213],de([0,1,20,11,15,10,24]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kPb=void 0;let k=class extends A.$gk{constructor(y,I){super(),this.g=this.B(y.createLogger((0,R.$hh)(I.logsHome,`${T.$cob}.log`),{id:T.$cob,name:(0,a.localize)(2447,null)}))}trace(y,...I){this.g.trace(y,...I)}debug(y,...I){this.g.debug(y,...I)}info(y,...I){this.g.info(y,...I)}warn(y,...I){this.g.warn(y,...I)}error(y,...I){this.g.error(y,...I)}flush(){this.g.flush()}};e.$kPb=k,e.$kPb=k=Se([Q(0,A.$ck),Q(1,N.$Ni)],k)}),define(ue[214],de([0,1,6,3,2]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class A extends N.$Vc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:O,getActiveWindowId:y}){super(),this.a=this.B(new N.$Uc),a.Event.latch(a.Event.any(k,O))(this.f,this,this.a),this.b=(0,R.$th)(()=>y()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Hhc=A}),define(ue[116],de([0,1,11,13,51,20,9,4,22]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=y,e.$Ri=I,e.$Ui=p,e.$Vi=f,e.$Wi=d,e.$Xi=g,e.$Yi=E,e.$2i=P,e.$7i=$,e.$8i=c,e.$0i=h,e.$$i=i,e.$_i=n,e.$Pi=(0,k.$Gi)("contextService");function y(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}function I(t){return typeof t?.id=="string"&&!y(t)&&!f(t)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function p(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.$oc)(t)}:s?e.$Si:e.$Ti;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function f(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}function d(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function g(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class m{constructor(s,r,o,u,b){this.h=s,this.j=o,this.k=u,this.l=b,this.c=N.$Mi.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=N.$Mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=m;class w{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$hh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=w;function P(t){return new w({uri:t,index:0,name:(0,A.$dh)(t)},{uri:t.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,R.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function $(t,s){return A.$$g.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===O.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$9i}function i(t,s){return!$(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.$pc)(t):(0,A.$fh)(t))===e.$4i}}),define(ue[19],de([0,1,55,3,2,20,9,11,15,7,4,10,116,31,28,6,32,26,12]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=$,e.$Ol=c,e.$Pl=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function $(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.$Nl=(0,I.$Gi)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,s,r,o,u,b){return{id:t,name:s,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:b&&u?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$hh)(r,"globalStorage"),settingsResource:b&&u?.useDefaultFlags?.settings?b.settingsResource:(0,A.$hh)(r,"settings.json"),keybindingsResource:b&&u?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$hh)(r,"keybindings.json"),tasksResource:b&&u?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$hh)(r,"tasks.json"),snippetsHome:b&&u?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$hh)(r,"snippets"),extensionsResource:b&&u?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$hh)(r,"extensions.json"),cacheHome:(0,A.$hh)(o,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends N.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,o,u){super(),this.t=s,this.u=r,this.w=o,this.y=u,this.f=!0,this.h=this.B(new a.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new d.$Bc,workspaces:new d.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,w.$fg)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(h((0,A.$eh)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},s))}}catch(b){this.y.error(b)}const o=new d.$Bc,u=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[L,S]of Object.entries(b.workspaces)){const v=T.URI.parse(L),C=r.find(U=>U.id===S);C&&o.set(v,C)}if(b.emptyWindows)for(const[L,S]of Object.entries(b.emptyWindows)){const v=r.find(C=>C.id===S);v&&u.set(L,v)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:o,emptyWindows:u}}return this.z}D(){const s=h("__default__profile__",(0,k.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,m.$if)(r)}\\s(\\d+)`);let u=0;for(const L of this.profiles){const S=o.exec(L.name),v=S?parseInt(S[1]):0;u=v>u?v:u}const b=`${r} ${u+1}`;return this.createProfile((0,R.$uj)((0,E.$3g)()).toString(16),b,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,R.$uj)((0,E.$3g)()).toString(16),s,r,o)}async createProfile(s,r,o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(s,r,o);return u&&await this.setProfileForWorkspace(u,b),b}async F(s,r,o){if(!(0,w.$fg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const L=h(s,r,(0,A.$hh)(this.profilesHome,s),this.g,o,this.defaultProfile);await this.u.createFolder(L.location);const S=[];return this.j.fire({profile:L,join(v){S.push(v)}}),await g.Promises.settled(S),this.I([L],[],[]),L}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(u=>u.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=h(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this.m.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,y.$sl)(u)!==y.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,o)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),o=T.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return o||((0,f.$Qi)(s)?this.s.folders.get(s.uri):(0,f.$Vi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,f.$Qi)(s)?s.uri:(0,f.$Vi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,o){const u=[...this.profiles,...s],b=[],L=this.s.profiles;this.s.profiles=[];for(let S of u){if(S.isDefault||r.some(C=>S.id===C.id))continue;S=o.find(C=>S.id===C.id)??S;const v=L.find(C=>S.id===C.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[C,U]of this.s.emptyWindows.entries())if(S.id===U.id){this.L({id:C},S);break}for(const[C,U]of this.s.workspaces.entries())if(S.id===U.id){this.L({id:"",configPath:C},S);break}for(const[C,U]of this.s.folders.entries())if(S.id===U.id){this.L({id:"",uri:C},S);break}}b.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(b),this.z=void 0,this.J(s,r,o)}J(s,r,o){this.h.fire({added:s,removed:r,updated:o,all:this.profiles})}L(s,r,o){if(o=r?.isTransient?!0:o,o)(0,f.$Qi)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,f.$Vi)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const u=this.G(s);T.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const s={};for(const[o,u]of this.C.workspaces.entries())s[o.toString()]=u.id;const r={};for(const[o,u]of this.C.emptyWindows.entries())r[o.toString()]=u.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},o=this.D();if(s.workspaces)for(const[b,L]of Object.entries(s.workspaces)){const S=T.URI.parse(L);r[b]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}const u={};if(s.emptyWindows)for(const[b,L]of Object.entries(s.emptyWindows)){const S=T.URI.parse(L);u[b]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ql=i,e.$Ql=i=Se([Q(0,O.$Ni),Q(1,y.$bl),Q(2,l.$Ll),Q(3,p.$bk)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Rl=n}),define(ue[215],de([0,1,6,2,19]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;let A=class extends a.$Vc{constructor(k){super(),this.B(new R.$Sh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$Nic=A,e.$Nic=A=Se([Q(0,N.$Nl)],A)}),define(ue[84],de([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Iq=void 0,e.$Jq=i,f=Oe(f);let h=class extends k.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,o,u,b,L,S){super(),this.z=r,this.C=o,this.D=u,this.F=b,this.G=L,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$me),this.s=this.B(new T.$me),this.t=this.B(new T.$me),this.u=this.B(new T.$me),this.w=this.B(new T.$me),this.y=[],this.B((0,k.$Tc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(u=>(0,d.$kp)(u,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const b=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:L})=>(0,l.$Np)(L,r.identifier));if(b?.local)return b?.local;throw b?.error?b.error:new d.$op(`Unknown error while installing extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new d.$op(f.localize(1758,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(r.map(async({extension:b,options:L})=>{try{const S=await this.N(b,!!L?.installGivenVersion,!!L?.installPreReleaseVersion,L.productVersion??{version:this.G.version,date:this.G.date});u.push({...S,options:L})}catch(S){o.push({identifier:b.identifier,operation:d.InstallOperation.Install,source:b,error:S,profileLocation:L.profileLocation??this.W()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(r,o){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,g.$vn)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let u=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.Z(r,this.H.defaultProfile.extensionsResource,o));for(const b of this.H.profiles){const L=(await this.getInstalled(g.ExtensionType.User,b.extensionsResource)).find(S=>(0,l.$Np)(S.identifier,r.identifier));L?this.w.fire({local:L,profileLocation:b.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:b.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:d.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(g.ExtensionType.User,o.extensionsResource);await this.L(u.map(async b=>{b.pinned!==r&&await this.updateMetadata(b,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$0)(o)),o}}async I(r){const o=new Map,u=new Map,b=[],L=(v,C)=>`${l.$Op.create(v).toString()}-${C.toString()}`,S=(v,C,U,F)=>{const j=this.X(v,C,U),H=`${(0,l.$Sp)(v.publisher,v.name)}-${U.profileLocation.toString()}`;u.set(H,{task:j,root:F}),this.n.fire({identifier:j.identifier,source:C,profileLocation:U.profileLocation}),this.F.info("Installing extension:",j.identifier.id,U),p.URI.isUri(C)||this.j.set(L(C,U.profileLocation),{task:j,waitingTasks:[]})};try{for(const{manifest:v,extension:C,options:U}of r){const F=U.isApplicationScoped||U.isBuiltin||(0,g.$vn)(v),j={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!p.URI.isUri(C),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.W(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},H=p.URI.isUri(C)?void 0:this.j.get(L(C,j.profileLocation));H?(this.F.info("Extension is already requested to install",H.task.identifier.id,j.profileLocation.toString()),b.push(H.task.waitUntilTaskIsFinished())):S(v,C,j,void 0)}return await Promise.all([...u.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const C=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),U=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),F={...v.options,context:{...v.options.context,[d.$ep]:!0}};for(const{gallery:j,manifest:H}of(0,R.$Mb)(C,({gallery:W})=>W.identifier.id)){if(u.has(`${j.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const W=this.j.get(L(j,F.profileLocation));if(W){if(this.J(v,W.task)){const x=W.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),W.waitingTasks.push(v),b.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,G=>G.some(te=>(0,l.$Np)(te.identifier,x)))).then(G=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),!G.find(B=>(0,l.$Np)(B.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else U.some(({identifier:x})=>(0,l.$Np)(x,j.identifier))||S(H,j,F,v)}}catch(C){if(p.URI.isUri(v.source))(0,R.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,C.message),(0,R.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,C.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),C}})),await this.L([...u.entries()].map(async([v,{task:C}])=>{const U=new Date().getTime();let F;try{F=await C.run(),await this.L(this.y.map(j=>j.postInstall(F,C.source,C.options,N.CancellationToken.None)),d.ExtensionManagementErrorCode.PostInstall)}catch(j){const H=i(j);throw p.URI.isUri(C.source)||n(this.C,C.operation===d.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Vp)(C.source),error:H,source:C.options.context?.[d.$dp]}),o.set(v,{error:H,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:C.options.isApplicationScoped}),this.F.error("Error while installing the extension",C.identifier.id,(0,A.$0)(H),C.options.profileLocation.toString()),H}if(!p.URI.isUri(C.source)){const j=C.operation===d.InstallOperation.Update,H=j?void 0:(new Date().getTime()-C.source.lastUpdated)/1e3;if(n(this.C,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Vp)(C.source),verificationStatus:C.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:H,source:C.options.context?.[d.$dp]}),y.$p&&C.operation!==d.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,d.StatisticType.Install)}catch{}}o.set(v,{local:F,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:F.isApplicationScoped})})),b.length&&await this.L(b),[...o.values()]}catch(v){const C=(j,H,W)=>{const x=[];j.manifest.extensionDependencies?.length&&x.push(...j.manifest.extensionDependencies),j.manifest.extensionPack?.length&&x.push(...j.manifest.extensionPack);for(const G of x){if(W.includes(G.toLowerCase()))continue;W.push(G.toLowerCase());const te=o.get(`${G.toLowerCase()}-${H.toString()}`);te?.local&&(W=C(te.local,H,W))}return W},U=j=>({identifier:j.identifier,operation:d.InstallOperation.Install,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,error:v}),F=[];for(const[j,{task:H,root:W}]of u){const x=o.get(j);x?x.local&&W&&!o.get(`${W.identifier.id.toLowerCase()}-${H.options.profileLocation.toString()}`)?.local&&(F.push(this.Y(x.local,{versionOnly:!0,profileLocation:H.options.profileLocation})),o.set(j,U(H))):(H.cancel(),o.set(j,U(H)))}for(const[j,{task:H}]of u){const W=o.get(j);if(!W?.local||H.options.donotIncludePackAndDependencies)continue;C(W.local,H.options.profileLocation,[W.local.identifier.id.toLowerCase()]).slice(1).some(G=>u.has(`${G.toLowerCase()}-${H.options.profileLocation.toString()}`)&&!o.get(`${G.toLowerCase()}-${H.options.profileLocation.toString()}`)?.local)&&(F.push(this.Y(W.local,{versionOnly:!0,profileLocation:H.options.profileLocation})),o.set(j,U(H)))}throw F.length&&await Promise.allSettled(F.map(async j=>{try{await j.run(),this.F.info("Rollback: Uninstalled extension",j.extension.identifier.id)}catch(H){this.F.warn("Rollback: Error while uninstalling extension",j.extension.identifier.id,(0,A.$0)(H))}})),v}finally{for(const{task:v}of u.values())v.source&&!p.URI.isUri(v.source)&&this.j.delete(L(v.source,v.options.profileLocation));if(o.size){const v=[...o.values()];for(const C of v)C.local&&this.F.info("Extension installed successfully:",C.identifier.id,C.profileLocation.toString());this.s.fire(v)}}}J(r,o){for(const[,{task:u,waitingTasks:b}]of this.j.entries())if(u===r&&(b.includes(o)||b.some(L=>this.J(L,o)))||u===o&&b[0]&&!this.J(r,b[0]))return!1;return!0}async L(r,o){const u=[],b=[],L=await Promise.allSettled(r);for(const v of L)v.status==="fulfilled"?u.push(v.value):b.push(i(v.reason,o));if(!b.length)return u;if(b.length===1)throw b[0];let S=new d.$op("",d.ExtensionManagementErrorCode.Unknown);for(const v of b)S=new d.$op(S.message?`${S.message}, ${v.message}`:v.message,v.code!==d.ExtensionManagementErrorCode.Unknown&&v.code!==d.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,o,u,b,L,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,L,S),C=[],U=[],F=async(j,H)=>{C.push(j);const W=H.extensionDependencies||[],x=[...W];if(H.extensionPack){const G=u?v.find(te=>(0,l.$Np)(te.identifier,j)):void 0;for(const te of H.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(B=>(0,l.$Np)({id:B},{id:te}))||x.every(B=>!(0,l.$Np)({id:B},{id:te}))&&x.push(te)}if(x.length){const G=x.filter(te=>C.every(B=>!(0,l.$Np)(B,{id:te})));if(G.length){const te=await this.z.getExtensions(G.map(B=>({id:B,preRelease:b})),N.CancellationToken.None);for(const B of te){if(C.find(ne=>(0,l.$Np)(ne,B.identifier)))continue;const V=W.some(ne=>(0,l.$Np)({id:ne},B.identifier));let _;try{_=await this.N(B,!1,b,S)}catch(ne){if(V)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$0)(ne));continue}U.push({gallery:_.extension,manifest:_.manifest}),await F(_.extension.identifier,_.manifest)}}}};return await F(r,o),U}async N(r,o,u,b){let L;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,l.$Np)(r.identifier,U)))throw new d.$op(f.localize(1759,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:b},N.CancellationToken.None))[0],!L)throw new d.$op(f.localize(1760,null,r.identifier.id,v.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const U=await this.getTargetPlatform();throw new d.$op(f.localize(1761,null,r.identifier.id,this.G.nameLong,(0,d.$gp)(U)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.O(r,o,u,b),!L){const U=[];throw(0,E.$8p)(r.properties.enabledApiProposals??[],U)?!u&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],N.CancellationToken.None))[0]?new d.$op(f.localize(1763,null,r.displayName??r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$op(f.localize(1764,null,r.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible):new d.$op(f.localize(1762,null,r.displayName??r.identifier.id,U[0]),d.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",L.identifier.id);const C=await this.z.getManifest(L,N.CancellationToken.None);if(C===null)throw new d.$op(`Missing manifest for extension ${L.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(C.version!==L.version)throw new d.$op(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:C}}async O(r,o,u,b){const L=await this.getTargetPlatform();let S=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:u}],{targetPlatform:L,compatible:!0,productVersion:b},N.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,u,L,b)&&(S=r),S||(o?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:L,compatible:!0,productVersion:b},N.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,u,L,b)),S}async uninstallExtensions(r){const o=(U,F)=>`${U.identifier.id.toLowerCase()}${F.versionOnly?`-${U.manifest.version}`:""}@${F.profileLocation.toString()}`,u=(U,F)=>{const j=this.Y(U,F);return this.m.set(o(j.extension,F),j),this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),this.t.fire({identifier:U.identifier,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped}),j},b=(U,F,j)=>{j?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString(),j.message):this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Up)(U),error:j}),this.u.fire({identifier:U.identifier,error:j?.code,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped})},L=[],S=[],v=[],C=new O.$Bc;for(const{extension:U,options:F}of r){const j={...F,profileLocation:U.isApplicationScoped?this.H.defaultProfile.extensionsResource:F?.profileLocation??this.W()},H=this.m.get(o(U,j));H?(this.F.info("Extensions is already requested to uninstall",U.identifier.id),v.push(H.waitUntilTaskIsFinished())):L.push(u(U,j))}try{for(const U of L.slice(0)){let F=C.get(U.options.profileLocation);if(F||C.set(U.options.profileLocation,F=await this.getInstalled(g.ExtensionType.User,U.options.profileLocation)),U.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${U.extension.identifier.id}@${U.extension.manifest.version}`);else{const j=this.R(U.extension,F);for(const H of j)this.m.has(o(H,U.options))?this.F.info("Extensions is already requested to uninstall",H.identifier.id):L.push(u(H,U.options))}U.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${U.extension.identifier.id}@${U.extension.manifest.version}`):this.P(L.map(j=>j.extension),F,U.extension)}await this.L(L.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,U.options,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,d.StatisticType.Uninstall)}catch{}}catch(F){const j=i(F);throw b(U.extension,U.options,j),j}finally{S.push(U)}})),v.length&&await this.L(v);for(const U of L)b(U.extension,U.options)}catch(U){const F=i(U);for(const j of L){try{j.cancel()}catch{}S.includes(j)||b(j.extension,j.options,F)}throw F}finally{for(const U of L)this.m.delete(o(U.extension,U.options))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}P(r,o,u){for(const b of r){const L=this.S(b,o);if(L.length){const S=L.filter(v=>!r.some(C=>(0,l.$Np)(C.identifier,v.identifier)));if(S.length)throw new Error(this.Q(b,S,u))}}}Q(r,o,u){return u===r?o.length===1?f.localize(1765,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?f.localize(1766,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):f.localize(1767,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?f.localize(1768,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?f.localize(1769,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):f.localize(1770,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}R(r,o,u=[]){if(u.indexOf(r)!==-1)return[];u.push(r);const b=r.manifest.extensionPack?r.manifest.extensionPack:[];if(b.length){const L=o.filter(v=>!v.isBuiltin&&b.some(C=>(0,l.$Np)({id:C},v.identifier))),S=[];for(const v of L)S.push(...this.R(v,o,u));return[...L,...S]}return[]}S(r,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(b=>(0,l.$Np)({id:b},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Iq=h,e.$Iq=h=Se([Q(0,d.$mp),Q(1,P.$am),Q(2,$.$Ll),Q(3,m.$bk),Q(4,w.$uk),Q(5,c.$Nl)],h);function i(s,r){if(s instanceof d.$op)return s;let o;return s instanceof d.$np?o=new d.$op(s.message,s.code===d.ExtensionGalleryErrorCode.DownloadFailedWriting?d.ExtensionManagementErrorCode.DownloadFailedWriting:d.ExtensionManagementErrorCode.Gallery):o=new d.$op(s.message,(0,A.$4)(s)?d.ExtensionManagementErrorCode.Cancelled:r??d.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:u,duration:b,error:L,source:S,durationSinceUpdate:v}){let C,U;(0,I.$ng)(u)&&(u===!0?u="Verified":(u===!1||(C=d.ExtensionManagementErrorCode.Signature,U=u),u="Unverified")),L&&(C=L.code,L.code===d.ExtensionManagementErrorCode.Signature&&(U=L.message)),s.publicLog(r,{...o,verificationStatus:u,success:!L,duration:b,errorcode:C,errorcodeDetail:U,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new a.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$th)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$th)(r=>new Promise((o,u)=>{const b=r.onCancellationRequested(()=>{b.dispose(),u(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$Kq=t}),define(ue[52],de([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Lq=P,e.$Mq=(0,p.$Gi)("IExtensionsProfileScannerService");let $=class extends N.$Vc{constructor(n,t,s,r,o,u){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=o,this.t=u,this.b=this.B(new A.$me),this.onAddExtensions=this.b.event,this.c=this.B(new A.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$me),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Bc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.u(t,u=>{const b=[];if(s)b.push(...u);else for(const L of u)n.some(([S])=>(0,y.$Np)(S.identifier,L.identifier)&&S.manifest.version!==L.version)?r.push(L):b.push(L);for(const[L,S]of n){const v=b.findIndex(U=>(0,y.$Np)(U.identifier,L.identifier)&&U.version===L.manifest.version),C={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:S};v===-1?(o.push(C),b.push(C)):b.splice(v,1,C)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),b}),o.length&&this.c.fire({extensions:o,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),o}catch(u){throw o.length&&this.c.fire({extensions:o,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const o=[];for(const u of r){const b=n.find(([L])=>(0,y.$Np)(L.identifier,u.identifier)&&L.manifest.version===u.version);b&&(u.metadata={...u.metadata,...b[1]},s.push(u)),o.push(u)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const o=[];for(const u of r)(0,y.$Np)(u.identifier,n.identifier)?s.push(u):o.push(u);return s.length&&this.f.fire({extensions:s,profileLocation:t}),o}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],o;try{const u=await this.m.readFile(n);o=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,I.$sl)(u)!==I.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&s?.bailOutWhenFileNotFound)throw new P((0,E.$0)(u),w.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.w(n);let u=!1;for(const b of o){c(b)||this.w(n);let L;if((0,g.$fg)(b.relativeLocation)&&b.relativeLocation)L=this.z(b.relativeLocation);else if((0,g.$fg)(b.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${b.location}`);continue}else{L=k.URI.revive(b.location);const S=this.y(L);S&&(u=!0,b.relativeLocation=S)}(0,g.$mg)(b.metadata?.hasPreReleaseVersion)&&b.metadata?.preRelease&&(u=!0,b.metadata.hasPreReleaseVersion=!0),r.push({identifier:b.identifier,location:L,version:b.version,metadata:b.metadata})}u&&await this.m.writeFile(n,a.$Oe.fromString(JSON.stringify(o)))}if(t){r=t(r);const u=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(n,a.$Oe.fromString(JSON.stringify(u)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(o){if((0,I.$sl)(o)===I.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(u=>c(u))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Oe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.$sl)(o)===I.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,I.$sl)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}try{await this.m.del(t)}catch(o){(0,I.$sl)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new R.$Nh,this.h.set(n,t)),t}};e.$Nq=$,e.$Nq=$=Se([Q(1,I.$bl),Q(2,d.$Nl),Q(3,l.$Ll),Q(4,m.$am),Q(5,f.$bk)],$);function c(i){return(0,g.$hg)(i)&&(0,O.$lp)(i.identifier)&&(h(i.location)||(0,g.$fg)(i.location)&&i.location)&&((0,g.$mg)(i.relativeLocation)||(0,g.$fg)(i.relativeLocation))&&i.version&&(0,g.$fg)(i.version)}function h(i){return i?(0,g.$fg)(i.path)&&(0,g.$fg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[85],de([0,1,17,6,29,14,8,36,153,2,22,13,5,20,60,93,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,158]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i,n,t,s,r,o,u,b,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Sq=e.$Rq=e.$Qq=e.Translations=void 0,e.$Tq=H,N=Oe(N),p=Oe(p),f=Oe(f),l=Oe(l),g=it(g);var v;(function(x){function G(te,B){if(te===B)return!0;const V=Object.keys(te),_=new Set;for(const ne of Object.keys(B))_.add(ne);if(V.length!==_.size)return!1;for(const ne of V){if(te[ne]!==B[ne])return!1;_.delete(ne)}return _.size===0}x.equals=G})(v||(e.Translations=v={})),e.$Qq=(0,n.$Gi)("IExtensionsScannerService");let C=class extends y.$Vc{constructor(G,te,B,V,_,ne,le,ee,X,K,q,D){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=te,this.r=B,this.s=V,this.t=_,this.u=ne,this.w=le,this.y=ee,this.z=X,this.C=K,this.D=q,this.F=D,this.g=this.B(new r.$me),this.onDidChangeCache=this.g.event,this.h=(0,d.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(j,this.s,this.h)),this.m=this.B(this.F.createInstance(j,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(c.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(c.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,$.$Yp)(this.w,this.y)),this.G}async scanAllExtensions(G,te,B){const[V,_]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(te)]),ne=B?await this.scanExtensionsUnderDevelopment(G,[...V,..._]):[];return this.L(V,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const te=[];te.push(this.M(!!G.useCache,G.language)),te.push(this.N(G.language,!!G.checkControlFile));const[B,V]=await Promise.all(te);return this.J([...B,...V],c.ExtensionType.System,G,!1)}async scanUserExtensions(G){const te=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const B=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(te,!!G.profileLocation,c.ExtensionType.User,!G.includeUninstalled,G.language,!0,B,G.productVersion??this.R()),_=G.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(V)}catch(le){if(le instanceof u.$Lq&&le.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(V);else throw le}return ne=await this.J(ne,c.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(G,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===I.Schemas.file).map(async V=>{const _=await this.P(V,!1,c.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(le=>(le.type=te.find(ee=>(0,$.$Np)(ee.identifier,le.identifier))?.type??le.type,this.n.validate(le,_)))}))).flat();return this.J(B,"development",G,!0)}return[]}async scanExistingExtension(G,te,B){const V=await this.P(G,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanExtension(V);return!_||!B.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(G,te,B){const V=await this.P(G,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(V);return this.J(_,te,B,!0)}async scanMultipleExtensions(G,te,B){const V=[];return await Promise.all(G.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,te,B);V.push(...ne)})),this.J(V,te,B,!0)}async scanMetadata(G){const te=(0,d.$hh)(G,"package.json"),B=(await this.w.readFile(te)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(G,te){const B=(0,d.$hh)(G,"package.json"),V=(await this.w.readFile(B)).value.toString(),_=JSON.parse(V);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,_.__metadata={..._.__metadata,...te},await this.w.writeFile((0,d.$hh)(G,"package.json"),A.$Oe.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof u.$Lq&&G.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Oe.fromString(JSON.stringify([])))}catch(te){(0,i.$sl)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$0)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,te,B,V){return B.includeAllVersions||(G=this.L(te===c.ExtensionType.System?G:void 0,te===c.ExtensionType.User?G:void 0,te==="development"?G:void 0,await this.getTargetPlatform(),V)),B.includeInvalid||(G=G.filter(_=>_.isValid)),G.sort((_,ne)=>{const le=p.$oc(_.location.fsPath),ee=p.$oc(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}L(G,te,B,V,_){const ne=(ee,X,K)=>{if(ee.isValid&&!X.isValid)return!1;if(ee.isValid===X.isValid){if(_&&l.gt(ee.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,X.manifest.version)){if(ee.type===c.ExtensionType.System)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===V)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`),!0},le=new c.$un;return G?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const X=le.get(ee.identifier.id);if(!X&&G&&ee.type===c.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),B?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async M(G,te){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.R()),_=await(G&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",_.length),_}async N(G,te){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const V=te?await this.O():{},_=[],ne=m.URI.file(p.$ic(p.$kc(I.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of B){const X=V[ee.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":_.push((0,d.$hh)(ne,ee.name));break;default:_.push(m.URI.file(X));break}}const le=await Promise.all(_.map(async ee=>this.n.scanExtension(await this.P(ee,!1,c.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,R.$Hb)(le)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,te,B,V,_,ne,le,ee){const X=await this.f(_??f.$x),K=await this.Q(G),q=te&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new U(G,K,q,D,te,le,B,V,ne,ee.version,ee.date,this.C.commit,!this.z.isBuilt,_,X)}async Q(G){try{const te=await this.w.stat(G);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Rq=C,e.$Rq=C=Se([Q(4,b.$Nl),Q(5,u.$Mq),Q(6,i.$bl),Q(7,t.$bk),Q(8,P.$Ni),Q(9,s.$uk),Q(10,L.$Ll),Q(11,n.$Fi)],C);class U{constructor(G,te,B,V,_,ne,le,ee,X,K,q,D,J,oe,Y){this.location=G,this.mtime=te,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=V,this.profile=_,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=X,this.productVersion=K,this.productDate=q,this.productCommit=D,this.devMode=J,this.language=oe,this.translations=Y}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,te){return(0,d.$ah)(G.location,te.location)&&G.mtime===te.mtime&&(0,d.$ah)(G.applicationExtensionslocation,te.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&G.profile===te.profile&&N.$jo(G.profileScanOptions,te.profileScanOptions)&&G.type===te.type&&G.excludeObsolete===te.excludeObsolete&&G.validate===te.validate&&G.productVersion===te.productVersion&&G.productDate===te.productDate&&G.productCommit===te.productCommit&&G.devMode===te.devMode&&G.language===te.language&&v.equals(G.translations,te.translations)}}e.$Sq=U;let F=class extends y.$Vc{constructor(G,te,B,V,_,ne,le){super(),this.g=G,this.h=te,this.j=B,this.m=V,this.n=ne,this.r=le,this.f=_.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(G){const te=G.profile?await this.t(G):await this.s(G);let B={};if(G.excludeObsolete&&G.type===c.ExtensionType.User)try{const V=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(V)}catch{}return(0,E.$sg)(B)?te:te.filter(V=>!B[$.$Op.create(V).toString()])}async s(G){const te=await this.m.resolve(G.location);if(!te.children?.length)return[];const B=await Promise.all(te.children.map(async V=>{if(!V.isDirectory||G.type===c.ExtensionType.User&&(0,d.$eh)(V.resource).indexOf(".")===0)return null;const _=new U(V.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_)}));return(0,R.$Hb)(B).sort((V,_)=>V.location.path<_.location.path?-1:1)}async t(G){let te=await this.u(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.j.extUri.isEqual(G.location,G.applicationExtensionslocation)){te=te.filter(V=>!V.metadata?.isApplicationScoped);const B=await this.u(G.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,G);te.push(...B)}return te}async u(G,te,B){const V=await this.h.scanProfileExtensions(G,B.profileScanOptions);if(!V.length)return[];const _=await Promise.all(V.map(async ne=>{if(te(ne)){const le=new U(ne.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,R.$Hb)(_)}async scanOneOrMultipleExtensions(G){try{if(await this.m.exists((0,d.$hh)(G.location,"package.json"))){const te=await this.scanExtension(G);return te?[te]:[]}else return await this.scanExtensions(G)}catch(te){return this.r.error(`Error scanning extensions at ${G.location.path}:`,(0,T.$0)(te)),[]}}async scanExtension(G,te){try{let B=await this.w(G.location);if(B){B.publisher||(B.publisher=c.$on),te=te??B.__metadata,delete B.__metadata;const V=(0,$.$Sp)(B.publisher,B.name),_=te?.id?{id:V,uuid:te.id}:{id:V},ne=te?.isSystem?c.ExtensionType.System:G.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;B=await this.y(G.location,B,U.createNlsConfiguration(G));let ee={type:ne,identifier:_,manifest:B,location:G.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return G.validate&&(ee=this.validate(ee,G)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(V.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,c.$An)([...B.enabledApiProposals])),ee}}catch(B){G.type!==c.ExtensionType.System&&this.r.error(B)}return null}validate(G,te){let B=!0;const V=this.n.isBuilt&&this.f.includes(G.identifier.id.toLowerCase()),_=(0,h.$5p)(te.productVersion,te.productDate,te.location,G.manifest,G.isBuiltin,V);for(const[ne,le]of _)ne===g.default.Error&&(B=!1,this.r.error(this.F(te.location,le)));return G.isValid=B,G.validations=_,G}async w(G){const te=(0,d.$hh)(G,"package.json");let B;try{B=(await this.m.readFile(te)).value.toString()}catch(_){return(0,i.$sl)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(G,(0,w.localize)(1806,null,te.path,_.message))),null}let V;try{V=JSON.parse(B)}catch{const ne=[];(0,k.$Zn)(B,ne);for(const le of ne)this.r.error(this.F(G,(0,w.localize)(1807,null,te.path,le.offset,le.length,(0,O.$Oq)(le.error))));return null}return(0,k.$8n)(V)!=="object"?(this.r.error(this.F(G,(0,w.localize)(1808,null,te.path))),null):V}async y(G,te,B){const V=await this.z(G,te,B);if(V)try{const _=[],ne=await this.C(V.default,_);if(_.length>0)return _.forEach(ee=>{this.r.error(this.F(G,(0,w.localize)(1809,null,V.default?.path,(0,O.$Oq)(ee.error))))}),te;if((0,k.$8n)(V)!=="object")return this.r.error(this.F(G,(0,w.localize)(1810,null,V.default?.path))),te;const le=V.values||Object.create(null);return(0,S.$Pq)(this.r,te,le,ne)}catch{}return te}async z(G,te,B){const V=(0,d.$hh)(G,"package.nls.json"),_=(X,K)=>{K.forEach(q=>{this.r.error(this.F(G,(0,w.localize)(1811,null,X?.path,(0,O.$Oq)(q.error))))})},ne=X=>{this.r.error(this.F(G,(0,w.localize)(1812,null,X?.path)))},le=`${te.publisher}.${te.name}`,ee=B.translations[le];if(ee)try{const X=m.URI.file(ee),K=(await this.m.readFile(X)).value.toString(),q=[],D=(0,k.$Zn)(K,q);return q.length>0?(_(X,q),{values:void 0,default:V}):(0,k.$8n)(D)!=="object"?(ne(X),{values:void 0,default:V}):{values:D.contents?D.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.m.exists(V))return;let K;try{K=await this.D(G,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const q=(await this.m.readFile(K.localized)).value.toString(),D=[],J=(0,k.$Zn)(q,D);return D.length>0?(_(K.localized,D),{values:void 0,default:K.original}):(0,k.$8n)(J)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:J,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(G,te){if(G)try{const B=(await this.m.readFile(G)).value.toString();return(0,k.$Zn)(B,te)}catch{}}D(G,te){return new Promise((B,V)=>{const _=ne=>{const le=(0,d.$hh)(G,`package.nls.${ne}.json`);this.m.exists(le).then(ee=>{ee&&B({localized:le,original:(0,d.$hh)(G,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?B({localized:(0,d.$hh)(G,"package.nls.json"),original:null}):(ne=ne.substring(0,X),_(ne))})};if(te.devMode||te.pseudo||!te.language)return B({localized:(0,d.$hh)(G,"package.nls.json"),original:null});_(te.language)})}F(G,te){return`[${G.path}]: ${te}`}};F=Se([Q(1,u.$Mq),Q(2,L.$Ll),Q(3,i.$bl),Q(4,s.$uk),Q(5,P.$Ni),Q(6,t.$bk)],F);let j=class extends F{constructor(G,te,B,V,_,ne,le,ee,X){super(te,V,_,ne,le,ee,X),this.J=G,this.L=B,this.H=this.B(new a.$Eh(3e3)),this.I=this.B(new r.$me),this.onDidChangeCache=this.I.event}async scanExtensions(G){const te=this.P(G),B=await this.M(te);if(this.G=G,B&&B.input&&U.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",G.type===c.ExtensionType.System?"system":"user",G.location.toString()),this.H.trigger(()=>this.O()),B.result.map(_=>(_.location=m.URI.revive(_.location),_));const V=await super.scanExtensions(G);return await this.N(te,{input:G,result:V}),V}async M(G){try{const te=await this.m.readFile(G),B=JSON.parse(te.value.toString());return{result:B.result,input:(0,o.$di)(B.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",G.path,(0,T.$0)(te))}return null}async N(G,te){try{await this.m.writeFile(G,A.$Oe.fromString(JSON.stringify(te)))}catch(B){this.r.debug("Error while writing the extension cache file:",G.path,(0,T.$0)(B))}}async O(){if(!this.G)return;const G=this.P(this.G),te=await this.M(G);if(!te)return;const B=te.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!N.$jo(V,B))try{this.r.info("Invalidating Cache",B,V),await this.m.del(G),this.I.fire()}catch(_){this.r.error(_)}}P(G){const te=this.Q(G);return this.j.extUri.joinPath(te.cacheHome,G.type===c.ExtensionType.System?c.$nn:c.$mn)}Q(G){return G.type===c.ExtensionType.System?this.L.defaultProfile:G.profile?this.j.extUri.isEqual(G.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(G.location,te.extensionsResource))??this.J:this.L.defaultProfile}};j=Se([Q(2,b.$Nl),Q(3,u.$Mq),Q(4,L.$Ll),Q(5,i.$bl),Q(6,s.$uk),Q(7,P.$Ni),Q(8,t.$bk)],j);function H(x,G){const te=(0,$.$Qp)(x.manifest.publisher,x.manifest.name);return{id:te,identifier:new c.$sn(te),isBuiltin:x.type===c.ExtensionType.System,isUserBuiltin:x.type===c.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class W extends C{constructor(G,te,B,V,_,ne,le,ee,X,K,q,D){super(G,te,(0,d.$hh)(B,".vscode-oss-dev","extensions","control.json"),V,_,ne,le,ee,X,K,q,D),this.S=(async()=>{if(f.$A)try{const J=await this.w.readFile(m.URI.file(f.$A));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Uq=W}),define(ue[216],de([0,1,69,6,43,3,2,22,13,30,10,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let f=class extends T.$Vc{constructor(l,g){super(),this.b=l,this.f=g,this.a=new a.$Mh(5)}async postUninstall(l){const g=this.g(l,"uninstall");g&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(g.script,"uninstall",g.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await y.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,g){const E=`vscode:${g}`;if(l.location.scheme===k.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const m=l.manifest.scripts[E].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,O.$kc)(l.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}h(l,g,E,m,w){return new Promise((P,$)=>{const c=this.j(l,g,E,w);let h;const i=n=>{h&&(clearTimeout(h),h=null),n?$(n):P(void 0)};c.on("error",n=>{i((0,N.$rj)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${g} process exited with code ${n}`:void 0)}),m&&(h=setTimeout(()=>{h=null,c.kill(),$("timed out")},5e3))})}j(l,g,E,m){const w={silent:!0,execArgv:void 0},P=(0,R.fork)(l,[`--type=extension-post-${g}`,...E],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const $=A.Event.fromNodeEventEmitter(P.stdout,"data"),c=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B($(n=>this.f.info(m.identifier.id,m.manifest.version,`post-${g}`,n))),this.B(c(n=>this.f.error(m.identifier.id,m.manifest.version,`post-${g}`,n)));const h=A.Event.any(A.Event.map($,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(h,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,O.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Yq=f,e.$Yq=f=Se([Q(0,p.$Nl),Q(1,I.$bk)],f)}),define(ue[117],de([0,1,73,11,84,27]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=T,e.$Wq=k;function T(O){let y=A.ExtensionManagementErrorCode.Extract;return O instanceof R.$Eq&&(O.type==="CorruptZip"?y=A.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(y=A.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$Jq)(O,y)}async function k(O){let y;try{y=await(0,R.$Hq)(O,"extension/package.json")}catch(I){throw T(I)}try{return JSON.parse(y.toString("utf8"))}catch{throw new A.$op((0,a.localize)(1822,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(ue[217],de([0,1,6,8,2,22,20,60,12,32,30,73,21,15,84,27,35,117,111,7,10,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0,k=Oe(k);let i=class extends N.$Vc{static{h=this}static{this.c=".sigzip"}constructor(t,s,r,o,u,b,L){super(),this.h=s,this.j=r,this.m=o,this.n=u,this.r=b,this.t=L,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,o){await this.g;const u=await this.w(t,s);let b=!1;if(r&&this.u(t)){let L;try{L=await this.y(t)}catch(S){try{await this.delete(u)}catch(v){this.t.error(v)}throw S}try{b=await this.n.verify(t,u.fsPath,L.fsPath,o)}catch(S){if(b=S.code,b===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||b===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(v){this.t.error(v)}throw new g.$op(p.$Dq,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(S){this.t.error(S)}}}return{location:u,verificationStatus:b}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,O.$lg)(s)?s:!0}async w(t,s){try{const r=(0,T.$hh)(this.extensionsDownloadDir,this.G(t)),o=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,s));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(b){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$0)(b))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,l.$Jq)(r,g.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,T.$hh)(this.extensionsDownloadDir,`.${(0,y.$3g)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(o){try{await this.h.del(s)}catch(u){this.t.warn(`Error while deleting: ${s.path}`,(0,a.$0)(u))}throw o}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Jq)(s,g.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==A.Schemas.file){await r(s);return}const o=(0,T.$hh)(this.extensionsDownloadDir,`.${(0,y.$3g)()}`);try{await r(o)}catch(u){try{await this.h.del(o)}catch{}throw u}try{await I.Promises.rename(o.fsPath,s.fsPath,2*60*1e3)}catch(u){try{await this.h.del(o)}catch{}let b=!1;try{b=await this.h.exists(s)}catch{}if(b)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,a.$0)(u)}. Deleted the file from downloaded location`,o.path),u}}async C(t,s,r,o){let u=1;for(;;)try{return await r(),u}catch(b){if(u++>o)throw b;this.t.warn(`Failed downloading ${s}. ${(0,a.$0)(b)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,p.$Hq)(t,s)}catch(r){throw(0,m.$Vq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],o=[];for(const L of t.children)if(L.name.endsWith(h.c))o.push(L.resource);else{const S=E.$Op.parse(L.name);S&&r.push([S,L])}const u=(0,E.$Tp)(r,([L])=>L),b=[];for(const L of u)L.sort((S,v)=>k.rcompare(S[0].version,v[0].version)),s.push(...L.slice(1).map(S=>S[1].resource)),b.push(L[0][1]);b.sort((L,S)=>L.mtime-S.mtime),s.push(...b.slice(0,Math.max(0,b.length-this.f)).map(L=>L.resource)),s.push(...o),await R.Promises.settled(s.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Op.create(t).toString().toLowerCase():(0,y.$3g)()}};e.$Xq=i,e.$Xq=i=h=Se([Q(0,d.$Oi),Q(1,P.$bl),Q(2,g.$mp),Q(3,f.$aj),Q(4,w.$wq),Q(5,c.$am),Q(6,$.$bk)],i)}),define(ue[118],de([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,73,11,99,15,84,27,35,52,85,217,216,117,189,199,34,59,7,4,10,23,18,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i,n,t,s,r,o,u,b,L,S,v,C,U,F,j,H,W,x,G,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0,R=Oe(R),d=Oe(d),g=Oe(g),P=Oe(P),c=Oe(c),e.$2q=(0,j.$Hi)(t.$pp);const B=".vsctmp";let V=class extends n.$Iq{constructor(X,K,q,D,J,oe,Y,Z,M,z,ie,ae){super(X,K,ie,q,z,ae),this.db=J,this.eb=oe,this.fb=Y,this.gb=Z,this.hb=M,this.cb=new Map,this.sb=new p.$Cc;const he=this.B(Z.createInstance(b.$Yq));this.$=this.B(Z.createInstance(_,be=>he.postUninstall(be))),this.ab=this.B(new S.$Zq(ae,M,ie,this,this.F)),this.bb=this.B(Z.createInstance(u.$Xq));const pe=this.B(new v.$1q(this,this.db,ae,oe,ie,M,q));this.B(pe.onDidChangeExtensionsByAnotherSource(be=>this.rb(be))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Yp)(this.hb,this.F)),this.ib}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.qb(X),q=await(0,$.zip)((0,l.$hh)(this.bb.extensionsDownloadDir,(0,w.$3g)()).fsPath,K);return m.URI.file(q)}async getManifest(X){const{location:K,cleanup:q}=await this.kb(X),D=d.$lc(K.fsPath);try{return await(0,L.$Wq)(D)}finally{await q()}}getInstalled(X,K=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(X??null,K,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.$.scanUserExtensionAtLocation(X)}async install(X,K={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:q,cleanup:D}=await this.kb(X);try{const J=await(0,L.$Wq)(d.$lc(q.fsPath)),oe=(0,s.$Sp)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,U.$7p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(1813,null,oe,this.G.version));const Z=(await this.I([{manifest:J,extension:q,options:K}])).find(({identifier:M})=>(0,s.$Np)(M,{id:oe}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,n.$Jq)(new Error(`Unknown error while installing extension ${oe}`))}finally{await D()}}async installFromLocation(X,K){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const q=await this.$.scanUserExtensionAtLocation(X);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.vb([[q,{source:"resource"}]],K),this.F.info("Successfully installed extension",q.identifier.id,K.toString()),q}async installExtensionsFromProfile(X,K,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),q.toString());const D=(await this.getInstalled(C.ExtensionType.User,K)).filter(J=>X.some(oe=>(0,s.$Np)(oe,J.identifier)));if(D.length){const J=await Promise.all(D.map(oe=>this.$.scanMetadata(oe,K)));await this.vb(D.map((oe,Y)=>[oe,J[Y]]),q),this.F.info("Successfully installed extensions",D.map(oe=>oe.identifier.id),q.toString())}return D}async updateMetadata(X,K,q){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),X=await this.$.updateMetadata(X,K,q),this.ab.invalidate(q),this.w.fire({local:X,profileLocation:q}),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1814,null));const K=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},A.CancellationToken.None);if(!q)throw new Error(c.localize(1815,null));await this.$.setUninstalled(X);try{await this.$.removeUninstalledExtension(X)}catch(D){throw new Error(c.localize(1816,null,(0,T.$rj)(D)))}return this.installFromGallery(q)}Z(X,K,q,D){return this.$.copyExtension(X,K,q,D)}copyExtensions(X,K){return this.$.copyExtensions(X,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...X){return this.$.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(X){this.F.error(X)}}async download(X,K,q){const{location:D}=await this.bb.download(X,K,!q);return D}async kb(X){if(X.scheme===f.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const K=(0,l.$hh)(this.bb.extensionsDownloadDir,(0,w.$3g)());return await this.fb.download(X,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(X,K,q){const D=K instanceof m.URI?new s.$Op({id:(0,s.$Sp)(X.publisher,X.name)},X.version):s.$Op.create(K);return this.gb.createInstance(ne,D,X,K,q,(J,oe)=>{if(K instanceof m.URI)return this.pb(D,K,q,oe);let Y=this.cb.get(D.toString());return Y||(this.cb.set(D.toString(),Y=this.ob(D,K,J,q,oe)),Y.finally(()=>this.cb.delete(D.toString()))),Y},this.$)}Y(X,K){return new le(X,K,this.eb)}async ob(X,K,q,D,J){const{verificationStatus:oe,location:Y}=await this.bb.download(K,q,!D.donotVerifySignature,D.context?.[t.$fp]);try{if(J.isCancellationRequested)throw new k.$5;const Z=await(0,L.$Wq)(Y.fsPath);if(!new s.$Op(K.identifier,K.version).equals(new s.$Op({id:(0,s.$Sp)(Z.publisher,Z.name)},Z.version)))throw new t.$op(c.localize(1817,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(X,Y.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$lg)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:oe}}catch(Z){try{await this.bb.delete(Y)}catch(M){this.F.warn("Error while deleting the downloaded file",Y.toString(),(0,k.$0)(M))}throw(0,n.$Jq)(Z)}}async pb(X,K,q,D){return{local:await this.$.extractUserExtension(X,d.$lc(K.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(X){const K=async D=>{let J=await P.Promises.readdir(D);J=J.map(Z=>d.$kc(D,Z));const oe=await Promise.all(J.map(Z=>R.promises.stat(Z)));let Y=Promise.resolve([]);return oe.forEach((Z,M)=>{const z=J[M];Z.isFile()&&(Y=Y.then(ie=>[...ie,z])),Z.isDirectory()&&(Y=Y.then(ie=>K(z).then(ae=>[...ie,...ae])))}),Y};return(await K(X.location.fsPath)).map(D=>({path:`extension/${d.$mc(X.location.fsPath,D)}`,localPath:D}))}async rb({added:X,removed:K}){if(K){const q=X&&this.D.extUri.isEqual(K.profileLocation,X.profileLocation)?K.extensions.filter(D=>X.extensions.every(J=>!(0,s.$Np)(J,D))):K.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(X){const D=(await this.getInstalled(C.ExtensionType.User,X.profileLocation)).filter(J=>X.extensions.some(oe=>(0,s.$Np)(oe,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,X.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:X.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const X=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(X){if(!X.affects(this.db.userExtensionsLocation,F.FileChangeType.ADDED))return;const K=[];for(const q of X.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),K.push(D))}K.length&&(await this.vb(K.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(q=>q.identifier.id)))}async vb(X,K){const q=X.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(X,K),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(X){const K=await this.$.getUninstalledExtensions();for(const q of X){const D=s.$Op.create(q);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$3q=V,e.$3q=V=Se([Q(0,t.$mp),Q(1,x.$am),Q(2,H.$bk),Q(3,i.$Oi),Q(4,o.$Qq),Q(5,r.$Mq),Q(6,h.$3o),Q(7,j.$Fi),Q(8,F.$bl),Q(9,W.$uk),Q(10,G.$Ll),Q(11,te.$Nl)],V);let _=class extends I.$Vc{constructor(X,K,q,D,J,oe,Y){super(),this.n=X,this.s=K,this.t=q,this.u=D,this.w=J,this.y=oe,this.z=Y,this.h=this.B(new O.$me),this.onExtract=this.h.event,this.j=new p.$Bc,this.m=new p.$Bc,this.c=(0,l.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new a.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(X,K,q){try{const D={includeInvalid:!0,profileLocation:K,productVersion:q};let J=[];if(X===null||X===C.ExtensionType.System){let oe=this.j.get(K);oe||(oe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,oe)),J.push(...await oe)}else if(X===C.ExtensionType.User){let oe=this.m.get(K);oe||(oe=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,oe)),J.push(...await oe)}return J=X!==null?J.filter(oe=>oe.type===X):J,await Promise.all(J.map(oe=>this.H(oe)))}catch(D){throw(0,n.$Jq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(X){try{const K=await this.t.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return await Promise.all(K.map(q=>this.H(q)))}catch(K){throw(0,n.$Jq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(X){try{const K=await this.t.scanExistingExtension(X,C.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(X,K,q,D,J){const oe=X.toString(),Y=m.URI.file(d.$kc(this.t.userExtensionsLocation.fsPath,`.${(0,w.$3g)()}`)),Z=m.URI.file(d.$kc(this.t.userExtensionsLocation.fsPath,oe));if(await this.s.exists(Z)){if(!D)try{return await this.scanLocalExtension(Z,C.ExtensionType.User)}catch(M){this.z.warn(`Error while scanning the existing extension at ${Z.path}. Deleting the existing extension and extracting it.`,(0,k.$0)(M))}try{await this.D(X.id,Z,"removeExisting")}catch{throw new t.$op(c.localize(1818,null,Z.fsPath,X.id),t.ExtensionManagementErrorCode.Delete)}}try{if(J.isCancellationRequested)throw new k.$5;try{this.z.trace(`Started extracting the extension from ${K} to ${Z.fsPath}`),await(0,$.$Gq)(K,Y.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Z}:`,X.id)}catch(M){throw(0,L.$Vq)(M)}try{await this.t.updateMetadata(Y,q)}catch(M){throw this.y.publicLog2("extension:extract",{extensionId:X.id,code:`${(0,F.$sl)(M)}`}),(0,n.$Jq)(M,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new k.$5;try{this.z.trace(`Started renaming the extension from ${Y.fsPath} to ${Z.fsPath}`),await this.G(Y.fsPath,Z.fsPath),this.z.info("Renamed to",Z.fsPath)}catch(M){if(M.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);try{await this.s.del(Y,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,k.$0)(M)}. Deleted from extracted location`,Y),M}this.h.fire(Z)}catch(M){try{await this.s.del(Y,{recursive:!0})}catch{}throw M}return this.scanLocalExtension(Z,C.ExtensionType.User)}async scanMetadata(X,K){return K?(await this.C(X,K))?.metadata:this.t.scanMetadata(X.location)}async C(X,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Np)(D.identifier,X.identifier))}async updateMetadata(X,K,q){try{q?await this.u.updateMetadata([[X,K]],q):await this.t.updateMetadata(X.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:X.identifier.id,code:`${(0,F.$sl)(D)}`,isProfile:!!q}),(0,n.$Jq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(X.location,X.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(X){throw(0,n.$Jq)(X,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...X){const K=X.map(q=>s.$Op.create(q));await this.F(q=>K.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(X){try{await this.F(K=>delete K[X.toString()])}catch(K){throw(0,n.$Jq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(X,K){if(this.w.extUri.isEqualOrParent(X.location,this.t.userExtensionsLocation))return this.D(X.identifier.id,X.location,K)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.F(K=>delete K[s.$Op.create(X).toString()])}async copyExtension(X,K,q,D){const J=await this.C(X,K),oe=await this.C(X,q);if(D={...J?.metadata,...D},oe)if(this.w.extUri.isEqual(oe.location,X.location))await this.u.updateMetadata([[X,{...oe.metadata,...D}]],q);else{const Y=await this.scanLocalExtension(oe.location,X.type,q);await this.u.removeExtensionFromProfile(Y,q),await this.u.addExtensionsToProfile([[X,{...oe.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[X,D]],q);return this.scanLocalExtension(X.location,X.type,q)}async copyExtensions(X,K,q){const D=await this.scanExtensions(C.ExtensionType.User,X,q),J=await Promise.all(D.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,X)]));await this.u.addExtensionsToProfile(J,K)}async D(X,K,q){this.z.trace(`Deleting ${q} extension from disk`,X,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,y.$uj)((0,w.$3g)()).toString(16)}${B}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,X,K.fsPath)}F(X){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,F.$sl)(D)!==F.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(K)try{q=JSON.parse(K)}catch{}return X&&(X(q),Object.keys(q).length?await this.s.writeFile(this.c,N.$Oe.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(X,K){try{await P.Promises.rename(X,K,2*60*1e3)}catch(q){throw(0,n.$Jq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,K,q){try{if(q){const J=(await this.t.scanUserExtensions({profileLocation:q})).find(oe=>this.w.extUri.isEqual(oe.location,X));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(X,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$op(c.localize(1819,null,X.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Jq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(X){const K=await this.s.resolve(X.location);let q,D;return K.children&&(q=K.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=K.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async I(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const J of K)X[s.$Op.create(J).toString()]||q.add(J.identifier.id.toLowerCase());try{const J=(0,s.$Tp)(K,oe=>oe.identifier);await a.Promises.settled(J.map(async oe=>{const Y=oe.sort((Z,M)=>g.rcompare(Z.manifest.version,M.manifest.version))[0];q.has(Y.identifier.id.toLowerCase())||await this.n(await this.H(Y))}))}catch(J){this.z.error(J)}const D=K.filter(J=>J.metadata&&X[s.$Op.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,F.$sl)(K)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(X?.children)try{await Promise.allSettled(X.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(q){(0,F.$sl)(q)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$4q=_,e.$4q=_=Se([Q(1,F.$bl),Q(2,o.$Qq),Q(3,r.$Mq),Q(4,G.$Ll),Q(5,x.$am),Q(6,H.$bk)],_);let ne=class extends n.$Kq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(X,K,q,D,J,oe,Y,Z,M,z,ie,ae){super(),this.l=X,this.manifest=K,this.source=q,this.options=D,this.m=J,this.n=oe,this.o=Y,this.p=Z,this.q=M,this.s=z,this.t=ie,this.u=ae,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(X){const q=(await this.n.scanExtensions(C.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Y=>(0,s.$Np)(Y.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof m.URI?"vsix":"gallery"};let J;if(this.source instanceof m.URI){if(q&&this.l.equals(new s.$Op(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(c.localize(1820,null,this.manifest.displayName||this.manifest.name))}const Y=await this.w(this.l);if(Y)try{await this.n.removeExtension(Y,"existing")}catch{throw new Error(c.localize(1821,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==C.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);J=await this.w(this.l)}if(X.isCancellationRequested)throw(0,n.$Jq)(new k.$5);if(!J){const Y=await this.m(this.operation,X);J=Y.local,this.k=Y.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(Y){throw(0,n.$Jq)(Y,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(X.isCancellationRequested)throw(0,n.$Jq)(new k.$5);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(Y){throw(0,n.$Jq)(Y,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.n.scanLocalExtension(J.location,C.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.$op("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof m.URI&&this.x(J,X),oe}async w(X){return(await this.n.getUninstalledExtensions())[X.toString()]?(this.u.trace("Removing the extension from uninstalled list:",X.id),await this.n.setInstalled(X),this.u.info("Removed the extension from uninstalled list:",X.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Op.create(D).equals(X))):void 0}async x(X,K){try{let[q]=await this.p.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(q||([q]=await this.p.getExtensions([{id:X.identifier.id}],K)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(X,D,this.options.profileLocation)}}catch{}}};ne=Se([Q(6,G.$Ll),Q(7,t.$mp),Q(8,te.$Nl),Q(9,o.$Qq),Q(10,r.$Mq),Q(11,H.$bk)],ne);class le extends n.$Kq{constructor(X,K,q){super(),this.extension=X,this.options=K,this.j=q}async h(X){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ue[218],de([0,1,10,19,28,18,52,7,15,9]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NR=void 0;let I=class extends T.$Nq{constructor(f,d,l,g,E,m){super(y.URI.file(f.extensionsPath),d,l,g,E,m)}};e.$NR=I,e.$NR=I=Se([Q(0,O.$Oi),Q(1,k.$bl),Q(2,a.$Nl),Q(3,N.$Ll),Q(4,A.$am),Q(5,R.$bk)],I)}),define(ue[219],de([0,1,9,15,52,85,7,4,10,23,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let f=class extends A.$Uq{constructor(l,g,E,m,w,P,$,c){super(R.URI.file(w.builtinExtensionsPath),R.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,g,E,m,w,P,$,c)}};e.$Lhc=f,e.$Lhc=f=Se([Q(0,p.$Nl),Q(1,N.$Mq),Q(2,T.$bl),Q(3,O.$bk),Q(4,a.$Oi),Q(5,y.$uk),Q(6,I.$Ll),Q(7,k.$Fi)],f)}),define(ue[16],de([0,1,6,3,2,101,12,71,4,19]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=d,e.$mq=g,e.$oq=m,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,O.$Gi)("storageService");var I;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var p;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var f;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function d(w){const P=w.get(e.$iq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends N.$Vc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new a.$pe),this.c=this.B(new a.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$me),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,$,c){return a.Event.filter(this.b.event,h=>h.scope===P&&($===void 0||h.key===$),c)}n(){this.j.value=(0,R.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,$){const{key:c,external:h}=$;if(c===e.$iq){switch(P){case p.APPLICATION:this.H=void 0;break;case p.PROFILE:this.F=void 0;break;case p.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:c,target:this.J(P)[c],external:h})}w(P){this.f.fire({reason:P})}get(P,$,c){return this.P($)?.get(P,c)}getBoolean(P,$,c){return this.P($)?.getBoolean(P,c)}getNumber(P,$,c){return this.P($)?.getNumber(P,c)}getObject(P,$,c){return this.P($)?.getObject(P,c)}storeAll(P,$){this.y(()=>{for(const c of P)this.store(c.key,c.value,c.scope,c.target,$)})}store(P,$,c,h,i=!1){if((0,T.$og)($)){this.remove(P,c,i);return}this.y(()=>{this.z(P,c,h),this.P(c)?.set(P,$,i)})}remove(P,$,c=!1){this.y(()=>{this.z(P,$,void 0),this.P($)?.delete(P,c)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,$){const c=[],h=this.J(P);for(const i of Object.keys(h))h[i]===$&&c.push(i);return c}z(P,$,c,h=!1){const i=this.J($);typeof c=="number"?i[P]!==c&&(i[P]=c,this.P($)?.set(e.$iq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P($)?.set(e.$iq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(p.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(p.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(p.APPLICATION)),this.H}J(P){switch(P){case p.APPLICATION:return this.I;case p.PROFILE:return this.G;default:return this.D}}L(P){const $=this.P(P);return $?d($):Object.create(null)}isNew(P){return this.getBoolean(e.$hq,P)===!0}async flush(P=I.NONE){this.f.fire({reason:P});const $=this.P(p.APPLICATION),c=this.P(p.PROFILE),h=this.P(p.WORKSPACE);switch(P){case I.NONE:await R.Promises.settled([$?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([$?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(p.APPLICATION)?.items??new Map,$=this.P(p.PROFILE)?.items??new Map,c=this.P(p.WORKSPACE)?.items??new Map;return m(P,$,c,this.Q(p.APPLICATION)??"",this.Q(p.PROFILE)??"",this.Q(p.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,$){return this.w(I.NONE),(0,y.$Ml)(P)?this.R(P,$):this.S(P,$)}M(P,$){return!(P.id===$.id||g($)&&g(P))}N(P,$,c){this.y(()=>{const h=new Set;for(const[i,n]of P)h.add(i),$.get(i)!==n&&this.u(c,{key:i,external:!0});for(const[i]of $.items)h.has(i)||this.u(c,{key:i,external:!0})})}}e.$lq=l;function g(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new k.$fq(new k.$gq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$fq(new k.$gq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$fq(new k.$gq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(p.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(p.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(p.APPLICATION,P)))}P(P){switch(P){case p.APPLICATION:return this.U;case p.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case p.APPLICATION:return"inMemory (application)";case p.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$nq=E;async function m(w,P,$,c,h,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;w.forEach((v,C)=>{t.set(C,v),s.set(C,n(v))});const r=new Map,o=new Map;P.forEach((v,C)=>{r.set(C,v),o.set(C,n(v))});const u=new Map,b=new Map;$.forEach((v,C)=>{u.set(C,v),b.set(C,n(v))}),console.group(c!==h?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const L=[];if(t.forEach((v,C)=>{L.push({key:C,value:v})}),console.table(L),console.groupEnd(),console.log(s),c!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const v=[];r.forEach((C,U)=>{v.push({key:U,value:C})}),console.table(v),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const S=[];u.forEach((v,C)=>{S.push({key:C,value:v})}),console.table(S),console.groupEnd(),console.log(b)}}),define(ue[119],de([0,1,3,2,12,27,35,16]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JMb=e.$IMb=void 0;let O=class extends a.$Vc{constructor(p,f){super(),this.a=new R.$me,this.onDidChangeEnablement=this.a.event,this.b=this.B(new y(p)),this.B(this.b.onDidChange(d=>this.a.fire({extensions:d,source:"storage"}))),this.B(f.onDidInstallExtensions(d=>d.forEach(({local:l,operation:g})=>{l&&g===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(p,f){return this.f(p)?(this.a.fire({extensions:[p],source:f}),!0):!1}async disableExtension(p,f){return this.c(p)?(this.a.fire({extensions:[p],source:f}),!0):!1}getDisabledExtensions(){return this.h(A.$qp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const f=this.getDisabledExtensions();return f.every(d=>!(0,T.$Np)(d,p))?(f.push(p),this.g(f),!0):!1}f(p){const f=this.getDisabledExtensions();for(let d=0;d<f.length;d++){const l=f[d];if((0,T.$Np)(l,p))return f.splice(d,1),this.g(f),!0}return!1}g(p){this.j(A.$qp,p)}h(p){return this.b.get(p,k.StorageScope.PROFILE)}j(p,f){this.b.set(p,f,k.StorageScope.PROFILE)}};e.$IMb=O,e.$IMb=O=Se([Q(0,k.$jq),Q(1,A.$pp)],O);class y extends a.$Vc{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new R.$me),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new a.$Uc))(f=>this.f(f)))}get(p,f){let d;return f===k.StorageScope.PROFILE?((0,N.$og)(this.a[p])&&(this.a[p]=this.g(p,f)),d=this.a[p]):d=this.g(p,f),JSON.parse(d)}set(p,f,d){const l=JSON.stringify(f.map(({id:E,uuid:m})=>({id:E,uuid:m})));this.g(p,d)!==l&&(d===k.StorageScope.PROFILE&&(f.length?this.a[p]=l:delete this.a[p]),this.h(p,f.length?l:void 0,d))}f(p){if(!(0,N.$og)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const d=this.get(p.key,p.scope);delete this.a[p.key];const l=this.get(p.key,p.scope),g=d.filter(m=>!l.some(w=>(0,T.$Np)(m,w))),E=l.filter(m=>!d.some(w=>(0,T.$Np)(w,m)));(g.length||E.length)&&this.b.fire([...g,...E])}}g(p,f){return this.c.get(p,f,"[]")}h(p,f,d){f?this.c.store(p,f,d,k.StorageTarget.MACHINE):this.c.remove(p,d)}}e.$JMb=y}),define(ue[86],de([0,1,4,3,2,16,35,23,17,10,12]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=void 0,e.$uw=(0,R.$Gi)("IExtensionStorageService");const f=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let d=class extends N.$Vc{static{p=this}static{this.a=512*1024}static b(g){return`extensionKeys/${(0,T.$Rp)(g.id)}@${g.version}`}static c(g){const E=f.exec(g);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(g,E){const m=await g.getInstalled(),w=[];for(const[P,$]of p.f(E)){const c=m.find(h=>(0,T.$Np)(h.identifier,{id:P}))?.manifest.version;for(const h of $)c!==h&&w.push(p.b({id:P,version:h}))}for(const P of w)E.remove(P,A.StorageScope.PROFILE)}static f(g){const E=new Map,m=g.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const w of m){const P=p.c(w);if(P){let $=E.get(P.id.toLowerCase());$||E.set(P.id.toLowerCase(),$=[]),$.push(P.version)}}return E}constructor(g,E,m){super(),this.j=g,this.m=E,this.n=m,this.g=this.B(new a.$me),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(g),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new N.$Uc))(w=>this.r(w)))}r(g){if(this.h.has(g.key.toLowerCase())){this.g.fire();return}const E=p.c(g.key);if(E){if(this.j.get(g.key,A.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let m=this.h.get(E.id.toLowerCase());m||this.h.set(E.id.toLowerCase(),m=[]),m.push(E.version),this.g.fire()}return}}s(g){if((0,I.$fg)(g))return g;const E=g.manifest?g.manifest.publisher:g.publisher,m=g.manifest?g.manifest.name:g.name;return(0,T.$Qp)(E,m)}getExtensionState(g,E){const m=this.s(g),w=this.getExtensionStateRaw(g,E);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${E}): ${P}`)}}getExtensionStateRaw(g,E){const m=this.s(g),w=this.j.get(m,E?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return w&&w?.length>p.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${m}, global: ${E}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(g,E,m){const w=this.s(g);E===void 0?this.j.remove(w,m?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(E),m?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(g,E){this.j.store(p.b(g),JSON.stringify(E),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(g){const E=this.m.extensionSyncedKeys?.[g.id.toLowerCase()],m=this.j.get(p.b(g),A.StorageScope.PROFILE),w=m?JSON.parse(m):void 0;return w&&E?(0,O.$Mb)([...w,...E]):w||E}addToMigrationList(g,E){if(g!==E){const m=this.t.filter(w=>!w.includes(g)&&!w.includes(E));m.push([g,E]),this.t=m}}getSourceExtensionToMigrate(g){const E=this.t.find(([,m])=>g===m);return E?E[0]:void 0}get t(){const g=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(g);if(Array.isArray(E))return E}catch{}return[]}set t(g){g.length?this.j.store("extensionStorage.migrationList",JSON.stringify(g),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$vw=d,e.$vw=d=p=Se([Q(0,A.$jq),Q(1,k.$uk),Q(2,y.$bk)],d)}),define(ue[220],de([0,1,2,27,86,198,118,10,16]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;let y=class extends R.$Vc{constructor(p,f,d,l,g,E){super(),p.cleanUp(),(0,A.$87b)(p,f,d,l,E),N.$vw.removeOutdatedExtensionVersions(p,g)}};e.$Vic=y,e.$Vic=y=Se([Q(0,T.$2q),Q(1,a.$mp),Q(2,N.$uw),Q(3,a.$sp),Q(4,O.$jq),Q(5,k.$bk)],y)}),define(ue[221],de([0,1,17,2,20,9,7,23,6,3,13,5,37,35,75,34,16]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0;let m=class extends a.$Vc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const s=(await this.b.readFile((0,N.$hh)(h,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.$afc=m,e.$afc=m=Se([Q(0,T.$bl),Q(1,k.$uk)],m);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class $ extends m{constructor(h,i,n,t,s,r,o,u){super(o,u),this.r=h,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([b,L])=>{const S=[],v=[],C=[];Object.entries(L.recommendations).forEach(([U,F])=>{F.important?L.important?S.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):C.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),S.length&&this.g.set(b,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:S}),v.length&&this.h.set(b,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:v}),C.length&&this.j.set(b,{exeFriendlyName:L.friendlyName,windowsPath:L.windowsPath,recommendations:C})}),(0,O.$Ih)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(h,n),this.n=this.D(i,n)}D(h,i){const n=new Map;h.forEach(u=>n.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const u of t){const b=n.get(u);b&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:b.exeName})}for(const u of s){const b=n.get(u);b&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:b.exeName})}const r=this.L(),o=new Map;for(const u of s){const b=n.get(u);if(b&&(!r[b.exeName]||!r[b.exeName].includes(b.extensionId))){let L=o.get(b.exeName);L||(L=[],o.set(b.exeName,L)),L.push(b)}}return o}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new a.$Wc);t.value=(0,O.$Ih)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,n=7*24*60*60*1e3;if(i<n){const r=this.B(new a.$Wc);r.value=(0,O.$Ih)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const o=this.B(new a.$Wc);o.value=(0,O.$Ih)(()=>{o.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(o(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this.B(new a.$Wc);o.value=(0,O.$Ih)(()=>{o.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(g.ExtensionType.User),n=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,d.$Np)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,E.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,E.StorageScope.APPLICATION,"{}"))}M(h,i){const n=this.L();n[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(h,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(h){const i=[],n=new Map;for(const t of h.keys()){const s=h.get(t);if(!s||!(0,R.$Lb)(s.recommendations))continue;const r=[];p.$j?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>f.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>f.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>f.env.ProgramFiles).replace("%APPDATA%",()=>f.env.APPDATA).replace("%WINDIR%",()=>f.env.WINDIR)):(r.push((0,I.$kc)("/usr/local/bin",t)),r.push((0,I.$kc)("/usr/bin",t)),r.push((0,I.$kc)(this.r.fsPath,t)));for(const o of r){let u=n.get(o);if(u===void 0&&(u=await this.b.exists(A.URI.file(o)),n.set(o,u)),u)for(const{extensionId:b,extensionName:L,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:b,extensionName:L,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$bfc=$}),define(ue[222],de([0,1,27,7,23,15,75,57,16,18,221]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;let p=class extends I.$bfc{constructor(d,l,g,E,m,w,P,$){super(d.userHome,m,l,g,E,w,P,$)}};e.$3ic=p,e.$3ic=p=Se([Q(0,A.$Oi),Q(1,y.$am),Q(2,R.$pp),Q(3,O.$jq),Q(4,k.$Xgc),Q(5,T.$P7b),Q(6,a.$bl),Q(7,N.$uk)],p)}),define(ue[49],de([0,1,14,32,16]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=A;async function A(T,k,O){let y=O&&O.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(y)return y;try{const p=(await k.readFile(T.serviceMachineIdResource)).value.toString();y=(0,a.$2g)(p)?p:null}catch{y=null}if(!y){y=(0,a.$3g)();try{await k.writeFile(T.serviceMachineIdResource,R.$Oe.fromString(y))}catch{}}return O?.store("storage.serviceMachineId",y,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),y}}),define(ue[223],de([0,1,49,18,48]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=A;async function A(T,k,O,y,I,p,f){const d={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${k.nameShort})`};if((0,N.$Fp)(k,O)&&(0,N.$Hp)(y)===a.TelemetryLevel.USAGE){const l=await(0,R.$pq)(O,I,p);d["X-Market-User-Id"]=l,d["VSCode-SessionId"]=f.machineId||l}return d}}),define(ue[224],de([0,1,17,25,8,5,37,12,9,150,21,15,27,35,34,59,7,10,23,61,223,16,18,54]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0,e.$rq=K;const n=A.$p?l.TargetPlatform.WEB:(0,f.$ip)(A.$v,T.$fc),t="X-Market-Search-Activity-Id";var s;(function(Z){Z[Z.None=0]="None",Z[Z.IncludeVersions=1]="IncludeVersions",Z[Z.IncludeFiles=2]="IncludeFiles",Z[Z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",Z[Z.IncludeSharedAccounts=8]="IncludeSharedAccounts",Z[Z.IncludeVersionProperties=16]="IncludeVersionProperties",Z[Z.ExcludeNonValidated=32]="ExcludeNonValidated",Z[Z.IncludeInstallationTargets=64]="IncludeInstallationTargets",Z[Z.IncludeAssetUri=128]="IncludeAssetUri",Z[Z.IncludeStatistics=256]="IncludeStatistics",Z[Z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",Z[Z.Unpublished=4096]="Unpublished",Z[Z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(...Z){return String(Z.reduce((M,z)=>M|z,0))}var o;(function(Z){Z[Z.Tag=1]="Tag",Z[Z.ExtensionId=4]="ExtensionId",Z[Z.Category=5]="Category",Z[Z.ExtensionName=7]="ExtensionName",Z[Z.Target=8]="Target",Z[Z.Featured=9]="Featured",Z[Z.SearchText=10]="SearchText",Z[Z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},S={pageNumber:1,pageSize:10,sortBy:f.SortBy.NoneOrRelevance,sortOrder:f.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(M=S){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,z=this.d.pageSize){return new v({...this.d,pageNumber:M,pageSize:z})}withFilter(M,...z){const ie=[...this.d.criteria,...z.length?z.map(ae=>({filterType:M,value:ae})):[{filterType:M}]];return new v({...this.d,criteria:ie})}withSortBy(M){return new v({...this.d,sortBy:M})}withSortOrder(M){return new v({...this.d,sortOrder:M})}withFlags(...M){return new v({...this.d,flags:M.reduce((z,ie)=>z|ie,0)})}withAssetTypes(...M){return new v({...this.d,assetTypes:M})}withSource(M){return new v({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:he,flags:pe,assetTypes:be}=this.d;return{filters:[{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:he}],assetTypes:be,flags:pe}}get searchText(){const M=this.d.criteria.filter(z=>z.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(Z,M){const z=(Z||[]).filter(ie=>ie.statisticName===M)[0];return z?z.value:0}function U(Z){const M="Microsoft.VisualStudio.Code.Translation.";return Z.files.filter(ie=>ie.assetType.indexOf(M)===0).reduce((ie,ae)=>{const he=H(Z,ae.assetType);return he&&ie.push([ae.assetType.substring(M.length),he]),ie},[])}function F(Z){if(Z.properties){const M=Z.properties.filter(ae=>ae.key===u.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=M.filter(ae=>z.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return H(Z,u.Repository)}function j(Z){return{uri:`${Z.fallbackAssetUri}/${u.VSIX}?redirect=true${Z.targetPlatform?`&targetPlatform=${Z.targetPlatform}`:""}`,fallbackUri:`${Z.fallbackAssetUri}/${u.VSIX}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`}}function H(Z,M){return Z.files.filter(ie=>ie.assetType===M)[0]?{uri:`${Z.assetUri}/${M}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`,fallbackUri:`${Z.fallbackAssetUri}/${M}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`}:null}function W(Z,M){const z=Z.properties?Z.properties.filter(ae=>ae.key===M):[],ie=z.length>0&&z[0].value;return ie?ie.split(",").map(ae=>(0,d.$Rp)(ae)):[]}function x(Z){const M=Z.properties?Z.properties.filter(z=>z.key===b.Engine):[];return M.length>0&&M[0].value||""}function G(Z){const M=Z.properties?Z.properties.filter(z=>z.key===b.PreRelease):[];return M.length>0&&M[0].value==="true"}function te(Z){const M=Z.properties?Z.properties.filter(z=>z.key===b.ExecutesCode):[];return M.length>0?M[0].value==="true":void 0}function B(Z){const M=Z.properties?Z.properties.filter(ie=>ie.key===b.EnabledApiProposals):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function V(Z){const M=Z.properties?Z.properties.filter(ie=>ie.key===b.LocalizedLanguages):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function _(Z){return Z.properties?.find(M=>M.key===b.SponsorLink)?.value}function ne(Z){return Z.properties?.find(M=>M.key===b.SupportLink)?.value}function le(Z){return Z.indexOf("preview")!==-1}function ee(Z){return Z.targetPlatform?(0,f.$hp)(Z.targetPlatform):l.TargetPlatform.UNDEFINED}function X(Z){const M=(0,R.$Mb)(Z.versions.map(ee)),z=!!Z.tags?.includes(f.$bp),ie=M.indexOf(l.TargetPlatform.WEB);return z?ie===-1&&M.push(l.TargetPlatform.WEB):ie!==-1&&M.splice(ie,1),M}function K(Z,M){for(let z=0;z<Z.length;z++){const ie=Z[z];if(ie.version===Z[z-1]?.version){let ae=z;if(ee(ie)===M)for(;ae>0&&Z[ae-1].version===ie.version;)ae--;ae!==z&&(Z.splice(z,1),Z.splice(ae,0,ie))}}return Z}function q(Z,M,z){Z.telemetryData={index:M,querySource:z,queryActivityId:Z.queryContext?.[t]}}function D(Z,M,z,ie){const ae=Z.versions[0],he={manifest:H(M,u.Manifest),readme:H(M,u.Details),changelog:H(M,u.Changelog),license:H(M,u.License),repository:F(M),download:j(M),icon:H(M,u.Icon),signature:H(M,u.Signature),coreTranslations:U(M)};return{type:"gallery",identifier:{id:(0,d.$Sp)(Z.publisher.publisherName,Z.extensionName),uuid:Z.extensionId},name:Z.extensionName,version:M.version,displayName:Z.displayName,publisherId:Z.publisher.publisherId,publisher:Z.publisher.publisherName,publisherDisplayName:Z.publisher.displayName,publisherDomain:Z.publisher.domain?{link:Z.publisher.domain,verified:!!Z.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(ae),description:Z.shortDescription??"",installCount:C(Z.statistics,"install"),rating:C(Z.statistics,"averagerating"),ratingCount:C(Z.statistics,"ratingcount"),categories:Z.categories||[],tags:Z.tags||[],releaseDate:Date.parse(Z.releaseDate),lastUpdated:Date.parse(Z.lastUpdated),allTargetPlatforms:z,assets:he,properties:{dependencies:W(M,b.Dependency),extensionPack:W(M,b.ExtensionPack),engine:x(M),enabledApiProposals:B(M),localizedLanguages:V(M),targetPlatform:ee(M),isPreReleaseVersion:G(M),executesCode:te(M)},hasPreReleaseVersion:G(ae),hasReleaseVersion:!0,preview:le(Z.flags),isSigned:!!he.signature,queryContext:ie,supportLink:ne(ae)}}let J=class{constructor(M,z,ie,ae,he,pe,be,Pe){this.l=z,this.n=ie,this.o=ae,this.q=he,this.u=pe,this.w=be,this.x=Pe;const ve=be.extensionsGallery,we=ve?.servicePPEUrl&&Pe.getValue("_extensionsGallery.enablePPE");this.d=we?ve.servicePPEUrl:ve?.serviceUrl,this.g=we?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.k=be.extensionsEnabledWithApiProposalVersion?.map(Ee=>Ee.toLowerCase())??[],this.j=(0,$.$qq)(be.version,be,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,z,ie){const ae=a.CancellationToken.isCancellationToken(z)?{}:z,he=a.CancellationToken.isCancellationToken(z)?z:ie,pe=[],be=[],Pe=[],ve=[];let we=!0;for(const fe of M){fe.uuid?be.push(fe.uuid):pe.push(fe.id);const me=!!(fe.version||fe.preRelease);Pe.push({id:fe.id,uuid:fe.uuid,includePreRelease:me}),fe.version&&ve.push({id:fe.id,uuid:fe.uuid,version:fe.version}),we=we&&!!fe.hasPreRelease&&!me}if(!be.length&&!pe.length)return[];let Ee=new v().withPage(1,M.length);be.length&&(Ee=Ee.withFilter(o.ExtensionId,...be)),pe.length&&(Ee=Ee.withFilter(o.ExtensionName,...pe)),(ae.queryAllVersions||we)&&(Ee=Ee.withFlags(Ee.flags,s.IncludeVersions)),ae.source&&(Ee=Ee.withSource(ae.source));const{extensions:se}=await this.B(Ee,{targetPlatform:ae.targetPlatform??n,includePreRelease:Pe,versions:ve,compatible:!!ae.compatible,productVersion:ae.productVersion??{version:this.w.version,date:this.w.date}},he);return ae.source&&se.forEach((fe,me)=>q(fe,me,ae.source)),se}async getCompatibleExtension(M,z,ie,ae={version:this.w.version,date:this.w.date}){if((0,f.$jp)(M.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(M,z,ie))return M;const he=new v().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:pe}=await this.B(he,{targetPlatform:ie,compatible:!0,includePreRelease:z,productVersion:ae},a.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(M,z,ie,ae={version:this.w.version,date:this.w.date}){if(!(0,f.$kp)(M.properties.targetPlatform,M.allTargetPlatforms,ie)||!z&&M.properties.isPreReleaseVersion)return!1;let he=M.properties.engine;if(!he){const pe=await this.getManifest(M,a.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");he=pe.engines.vscode}return!(!(0,g.$7p)(he,ae.version,ae.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,z){return!z||!this.k.includes(M.id.toLowerCase())?!0:(0,g.$8p)(z)}async A(M,z,ie,ae,he,pe,be={version:this.w.version,date:this.w.date}){if(!(0,f.$kp)(ee(z),he,pe)||ie!=="any"&&G(z)!==(ie==="prerelease"))return!1;if(ae)try{const Pe=await this.G(M,z);if(!(0,g.$7p)(Pe,be.version,be.date))return!1}catch(Pe){return this.n.error(`Error while getting the engine for the version ${z.version}.`,(0,N.$0)(Pe)),!1}return!0}async query(M,z){let ie=M.text||"";const ae=M.pageSize??50;let he=new v().withPage(1,ae);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,Ee,se)=>(he=he.withFilter(o.Category,se||Ee),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,Ee,se)=>(he=he.withFilter(o.Tag,se||Ee),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),he=he.withFilter(o.SearchText,ie)),he=he.withSortBy(f.SortBy.NoneOrRelevance)):M.ids?he=he.withFilter(o.ExtensionId,...M.ids):M.names?he=he.withFilter(o.ExtensionName,...M.names):he=he.withSortBy(f.SortBy.InstallCount),typeof M.sortBy=="number"&&(he=he.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(he=he.withSortOrder(M.sortOrder)),M.source&&(he=he.withSource(M.source));const pe=async(we,Ee)=>{const{extensions:se,total:fe}=await this.B(we,{targetPlatform:n,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},Ee);return se.forEach((me,Ie)=>q(me,(we.pageNumber-1)*we.pageSize+Ie,M.source)),{extensions:se,total:fe}},{extensions:be,total:Pe}=await pe(he,z),ve=async(we,Ee)=>{if(Ee.isCancellationRequested)throw new N.$5;const{extensions:se}=await pe(he.withPage(we+1),Ee);return se};return{firstPage:be,total:Pe,pageSize:he.pageSize,getPage:ve}}async B(M,z,ie){const ae=M.flags;M.flags&s.IncludeLatestVersionOnly&&M.flags&s.IncludeVersions&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:he,total:pe,context:be}=await this.D(M,ie);if(!(M.flags&s.IncludeLatestVersionOnly)){const Ee=[];for(const se of he){const fe=await this.C(se,z,be);fe&&Ee.push(fe)}return{extensions:Ee,total:pe}}const ve=[],we=new Map;for(let Ee=0;Ee<he.length;Ee++){const se=he[Ee],fe={id:(0,d.$Sp)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},me=(0,k.$lg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(ke=>(0,d.$Np)(ke,fe))?.includePreRelease;if(z.compatible&&(0,f.$jp)(X(se),z.targetPlatform))continue;const Ie=await this.C(se,z,be);!Ie||Ie.properties.isPreReleaseVersion&&(!me||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==z.targetPlatform&&Ie.hasPreReleaseVersion?we.set(se.extensionId,Ee):ve.push([Ee,Ie])}if(we.size){const Ee=new i.$ge,se=new v().withFlags(ae&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,we.size).withFilter(o.ExtensionId,...we.keys()),{extensions:fe}=await this.B(se,z,ie);this.q.publicLog2("galleryService:additionalQuery",{duration:Ee.elapsed(),count:we.size});for(const me of fe){const Ie=we.get(me.identifier.uuid);ve.push([Ie,me])}}return{extensions:ve.sort((Ee,se)=>Ee[0]-se[0]).map(([,Ee])=>Ee),total:pe}}async C(M,z,ie){const ae={id:(0,d.$Sp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},he=z.versions?.find(ve=>(0,d.$Np)(ve,ae))?.version,pe=(0,k.$lg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(ve=>(0,d.$Np)(ve,ae))?.includePreRelease,be=X(M),Pe=K(M.versions,z.targetPlatform);if(z.compatible&&(0,f.$jp)(be,z.targetPlatform))return null;for(let ve=0;ve<Pe.length;ve++){const we=Pe[ve];if(!(he&&we.version!==he)){if(await this.A(ae.id,we,pe?"any":"release",z.compatible,be,z.targetPlatform,z.productVersion))return z.compatible&&!this.z(ae,B(we))?null:D(M,we,be,ie);if(he&&we.version===he)return null}}return he||z.compatible?null:D(M,M.versions[0],be)}async D(M,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(s.Unpublished));const ie=await this.j,ae=JSON.stringify(M.raw),he={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},pe=new i.$ge;let be,Pe,ve=0;try{if(be=await this.l.request({type:"POST",url:this.g&&M.criteria.some(Ee=>Ee.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ae,headers:he},z),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:ve};const we=await(0,P.$cq)(be);if(we){const Ee=we.results[0],se=Ee.extensions,fe=Ee.resultMetadata&&Ee.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return ve=fe&&fe.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:ve,context:be.res.headers.activityid?{[t]:be.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ve}}catch(we){if((0,N.$4)(we))throw Pe=f.ExtensionGalleryErrorCode.Cancelled,we;{const Ee=(0,N.$0)(we);throw Pe=(0,y.$0o)(we)?f.ExtensionGalleryErrorCode.Offline:Ee.startsWith("XHR timeout")?f.ExtensionGalleryErrorCode.Timeout:f.ExtensionGalleryErrorCode.Failed,new f.$np(Ee,Pe)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ae.length),duration:pe.elapsed(),success:!!be&&(0,P.$$p)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Pe,count:String(ve)})}}async reportStatistic(M,z,ie,ae){if(!this.isEnabled())return;const he=A.$p?this.y(`/itemName/${M}.${z}/version/${ie}/statType/${ae===f.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${z}/${ie}/stats?statType=${ae}`),pe=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Pe={...await this.j,Accept:pe};try{await this.l.request({type:"POST",url:he,headers:Pe},a.CancellationToken.None)}catch{}}async download(M,z,ie){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const ae=(0,d.$Vp)(M),he=new Date().getTime(),pe=ie===f.InstallOperation.Install?"install":ie===f.InstallOperation.Update?"update":"",be=pe?{uri:`${M.assets.download.uri}${O.URI.parse(M.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${M.assets.download.fallbackUri}${O.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:M.assets.download,Pe=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,ve=await this.F(M.identifier.id,be,u.VSIX,Pe?{headers:Pe}:void 0);try{await this.u.writeFile(z,ve.stream)}catch(we){try{await this.u.del(z)}catch(Ee){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,N.$0)(Ee))}throw new f.$np((0,N.$0)(we),f.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ae,duration:new Date().getTime()-he})}async downloadSignatureArchive(M,z){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ie=await this.F(M.identifier.id,M.assets.signature,u.Signature);try{await this.u.writeFile(z,ie.stream)}catch(ae){try{await this.u.del(z)}catch(he){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,N.$0)(he))}throw new f.$np((0,N.$0)(ae),f.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,z){if(M.assets.readme){const ie=await this.F(M.identifier.id,M.assets.readme,u.Details,{},z);return await(0,P.$bq)(ie)||""}return""}async getManifest(M,z){if(M.assets.manifest){const ie=await this.F(M.identifier.id,M.assets.manifest,u.Manifest,{},z),ae=await(0,P.$bq)(ie);return ae?JSON.parse(ae):null}return null}async E(M,z,ie){const ae=H(z,u.Manifest);if(!ae)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},pe=await this.F(M,ae,u.Manifest,{headers:he});return await(0,P.$cq)(pe)}async getCoreTranslation(M,z){const ie=M.assets.coreTranslations.filter(ae=>ae[0]===z.toUpperCase())[0];if(ie){const ae=await this.F(M.identifier.id,ie[1],ie[0]),he=await(0,P.$bq)(ae);return he?JSON.parse(he):null}return null}async getChangelog(M,z){if(M.assets.changelog){const ie=await this.F(M.identifier.id,M.assets.changelog,u.Changelog,{},z);return await(0,P.$bq)(ie)||""}return""}async getAllCompatibleVersions(M,z,ie){let ae=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.uuid?ae=ae.withFilter(o.ExtensionId,M.uuid):ae=ae.withFilter(o.ExtensionName,M.id);const{galleryExtensions:he}=await this.D(ae,a.CancellationToken.None);if(!he.length)return[];const pe=X(he[0]);if((0,f.$jp)(pe,ie))return[];const be=[];await Promise.all(he[0].versions.map(async we=>{try{await this.A(M.id,we,z?"any":"release",!0,pe,ie)&&this.z(M,B(we))&&be.push(we)}catch{}}));const Pe=[],ve=new Set;for(const we of K(be,ie))ve.has(we.version)||(ve.add(we.version),Pe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:G(we)}));return Pe}async F(M,z,ie,ae={},he=a.CancellationToken.None){const pe=await this.j,be={type:"GET"},Pe={...pe,...ae.headers||{}};ae={...ae,...be,headers:Pe};const ve=z.uri,we=z.fallbackUri,Ee={...ae,url:ve};try{const se=await this.l.request(Ee,he);if(se.res.statusCode===200)return se;const fe=await(0,P.$bq)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${fe}`)}catch(se){if((0,N.$4)(se))throw se;const fe=(0,N.$0)(se);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ie,message:fe});const me={...ae,url:we};return this.l.request(me,he)}}async G(M,z){let ie=x(z);if(!ie){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:z.version});const ae=await this.E(M,z,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,P.$cq)(M),ie=[],ae={},he=[],pe=[];if(z){for(const be of z.malicious)ie.push({id:be});if(z.migrateToPreRelease)for(const[be,Pe]of Object.entries(z.migrateToPreRelease))(!Pe.engine||(0,g.$7p)(Pe.engine,this.w.version,this.w.date))&&(ae[be.toLowerCase()]={disallowInstall:!0,extension:{id:Pe.id,displayName:Pe.displayName,autoMigrate:{storage:!!Pe.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[be,Pe]of Object.entries(z.deprecated))Pe&&(ae[be.toLowerCase()]=(0,k.$lg)(Pe)?{}:Pe);if(z.search)for(const be of z.search)he.push(be);if(Array.isArray(z.extensionsEnabledWithPreRelease))for(const be of z.extensionsEnabledWithPreRelease)pe.push(be.toLowerCase())}return{malicious:ie,deprecated:ae,search:he,extensionsEnabledWithPreRelease:pe}}};J=Se([Q(1,P.$9p),Q(2,m.$bk),Q(3,p.$Ni),Q(4,h.$am),Q(5,E.$bl),Q(6,w.$uk),Q(7,I.$aj)],J);let oe=class extends J{constructor(M,z,ie,ae,he,pe,be,Pe){super(M,z,ie,ae,he,pe,be,Pe)}};e.$sq=oe,e.$sq=oe=Se([Q(0,c.$jq),Q(1,P.$9p),Q(2,m.$bk),Q(3,p.$Ni),Q(4,h.$am),Q(5,E.$bl),Q(6,w.$uk),Q(7,I.$aj)],oe);let Y=class extends J{constructor(M,z,ie,ae,he,pe,be){super(void 0,M,z,ie,ae,he,pe,be)}};e.$tq=Y,e.$tq=Y=Se([Q(0,P.$9p),Q(1,m.$bk),Q(2,p.$Ni),Q(3,h.$am),Q(4,E.$bl),Q(5,w.$uk),Q(6,I.$aj)],Y)}),define(ue[225],de([0,1,108,3,18,15,2,10,13,69,23,5,6,102,21,11,38,16,12,143,20]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;const c=[R.$Ric,R.$Sic],h="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends T.$Vc{constructor(o,u,b,L,S,v,C){super(),this.y=o,this.z=u,this.C=b,this.D=v,this.F=C,this.f=new a.$me,this.onDidTokenFailed=this.f.event,this.g=new a.$me,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$me,this.onDidChangeMode=this.h.event,this.n=R.$Pic,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(L.createLogger((0,$.$hh)(b.logsHome,`${R.$Tic}.log`),{id:R.$Tic,name:R.$Uic})),this.t=new f.$Dh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,k.$qk)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{c.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){s(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let o;p.$k?o=this.C.appRoot:o=(0,O.$nc)((0,O.$nc)(this.C.appRoot)),this.u=(0,O.$kc)(o,"bin",`${this.z.tunnelApplicationName}${p.$j?".exe":""}`)}return this.u}async startTunnel(o){if(s(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const o=this.n.asService;this.H(R.$Pic);try{o&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(o){this.j.error(o)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",u=!1;const b=(F,j)=>{j?this.j.error(F):o+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,g.localize)(2036,null)))},L=this.O("status",["status"],b);this.r=L;try{if(await L,this.r!==L)return;let F;try{F=JSON.parse(o.trim().split(`
`).find(j=>j.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(R.TunnelStates.disconnected());return}if(u=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(R.TunnelStates.disconnected());return}finally{this.r===L&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(R.TunnelStates.connecting((0,g.localize)(2037,null,S.accountLabel,S.providerId)));const j=(W,x)=>{W=W.replaceAll(F,"*".repeat(4)),b(W,x)},H=this.O("login",["user","login","--provider",S.providerId,"--log",(0,k.$qk)(this.j.getLevel())],j,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=H;try{if(await H,this.r!==H)return}catch(W){this.j.error(W),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(R.TunnelStates.connecting((0,g.localize)(2038,null,v))):this.G(R.TunnelStates.connecting((0,g.localize)(2039,null)));const C=["--accept-server-license-terms","--log",(0,k.$qk)(this.j.getLevel())];v?C.push("--name",v):C.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!u&&(U=await this.M(C)===!1),this.N(S,C,U)}async M(o){let u;try{u=await this.O("serviceInstall",["service","install",...o])}catch(b){this.j.error(b),u=1}if(u!==0){const b=(0,g.localize)(2040,null);return this.j.warn(b),this.G(R.TunnelStates.connecting(b)),!1}return!0}async N(o,u,b){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let L=!1;const S=this.O("tunnel",u,(v,C)=>{C?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(L=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:L};this.G(R.TunnelStates.connected(F,b))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(o),this.G(R.TunnelStates.disconnected(o)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Pic,this.G(R.TunnelStates.disconnected()))})}O(o,u,b=this.I,L){return(0,f.$th)(S=>new Promise((v,C)=>{S.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this.j.info(`${o} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${o} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),U=(0,y.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,O.$kc)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...L}});else{b(`Running tunnel CLI
`,!1);const j=this.J();b(`${o} Spawning: ${j} tunnel ${u.join(" ")}
`,!1),U=(0,y.spawn)(j,["tunnel",...u],{cwd:(0,E.homedir)(),stdio:F,env:{...process.env,...L}})}U.stdout.pipe(new P.$UX(`
`)).on("data",j=>{if(U){const H=j.toString();b(H,!1)}}),U.stderr.pipe(new P.$UX(`
`)).on("data",j=>{if(U){const H=j.toString();b(H,!0)}}),U.on("exit",j=>{U&&(b(`${o} exit(${U.pid}): + ${j} `,!1),U=void 0,v(j||0))}),U.on("error",j=>{U&&(b(`${o} error(${U.pid}): + ${j} `,!0),U=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Sic)}Q(){let o=this.D.getValue(R.$Ric)||(0,E.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(h,m.StorageScope.APPLICATION),u=this.F.getBoolean(i,m.StorageScope.APPLICATION,!1);if(o){const b=JSON.parse(o);if(b&&(0,w.$fg)(b.accountLabel)&&(0,w.$fg)(b.sessionId)&&(0,w.$fg)(b.providerId))return{active:!0,session:b,asService:u};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(o){this.j.error("Problems restoring session from storage",o)}return R.$Pic}S(o){if(o.active){const u={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(h,JSON.stringify(u),m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),this.F.store(i,o.asService,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE)}else this.F.remove(h,m.StorageScope.APPLICATION),this.F.remove(i,m.StorageScope.APPLICATION)}};e.$Yic=n,e.$Yic=n=Se([Q(0,N.$am),Q(1,I.$uk),Q(2,A.$Oi),Q(3,k.$ck),Q(4,d.$Wic),Q(5,l.$aj),Q(6,m.$jq)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(ue[226],de([0,1,6,2,22,20,71,16,80,19]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class I extends k.$lq{constructor(f,d,l,g){super(),this.bb=f,this.cb=d,this.db=l,this.eb=g,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Uc),this.ab=this.hb(this.bb)}fb(){const f=this.B(new O.$gNb(this.db.getChannel("storage"))),d=this.B(new T.$fq(f));return this.B(d.onDidChangeStorage(l=>this.u(k.StorageScope.APPLICATION,l))),d}gb(f){this.X.clear(),this.W=f;let d;if((0,k.$mq)(f))d=this.U;else{const l=this.X.add(new O.$hNb(this.db.getChannel("storage"),f));d=this.X.add(new T.$fq(l))}return this.X.add(d.onDidChangeStorage(l=>this.u(k.StorageScope.PROFILE,l))),d}hb(f){this.$.clear(),this.Z=f?.id;let d;if(f){const l=this.$.add(new O.$iNb(this.db.getChannel("storage"),f));d=this.$.add(new T.$fq(l)),this.$.add(d.onDidChangeStorage(g=>this.u(k.StorageScope.WORKSPACE,g)))}return d}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(f){switch(f){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(f){switch(f){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$hh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(f){if(!this.M(this.W,f))return;const d=this.Y,l=d.items;d!==this.U&&await d.close(),this.Y=this.gb(f),await this.Y.init(),this.N(l,this.Y,k.StorageScope.PROFILE)}async S(f,d){const l=this.ab,g=l?.items??new Map;await l?.close(),this.ab=this.hb(f),await this.ab.init(),this.N(g,this.ab,k.StorageScope.WORKSPACE)}hasScope(f){return(0,y.$Ml)(f)?this.W.id===f.id:this.Z===f.id}}e.$4ic=I}),define(ue[227],de([0,1,3,2,19,95]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0;class T{constructor(y,I){this.a=y,this.b=I}listen(y,I){const p=this.b(y);switch(I){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,f=>({all:f.all.map(d=>(0,A.$Pn)({...d},p)),added:f.added.map(d=>(0,A.$Pn)({...d},p)),removed:f.removed.map(d=>(0,A.$Pn)({...d},p)),updated:f.updated.map(d=>(0,A.$Pn)({...d},p))}))}throw new Error(`Invalid listen ${I}`)}async call(y,I,p){const f=this.b(y);switch(I){case"createProfile":{const d=await this.a.createProfile(p[0],p[1],p[2]);return(0,A.$Pn)({...d},f)}case"updateProfile":{let d=(0,N.$Ol)((0,A.$Qn)(p[0],f),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,p[1]),(0,A.$Pn)({...d},f)}case"removeProfile":{const d=(0,N.$Ol)((0,A.$Qn)(p[0],f),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${I}`)}}e.$UR=T;class k extends a.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(y,I,p){super(),this.profilesHome=I,this.f=p,this.a=[],this.b=this.B(new R.$me),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=y.map(f=>(0,N.$Ol)(f,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(f=>{const d=f.added.map(E=>(0,N.$Ol)(E,this.profilesHome.scheme)),l=f.removed.map(E=>(0,N.$Ol)(E,this.profilesHome.scheme)),g=f.updated.map(E=>(0,N.$Ol)(E,this.profilesHome.scheme));this.a=f.all.map(E=>(0,N.$Ol)(E,this.profilesHome.scheme)),this.b.fire({added:d,removed:l,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(y){this.c=y}isEnabled(){return this.c}async createNamedProfile(y,I,p){const f=await this.f.call("createNamedProfile",[y,I,p]);return(0,N.$Ol)(f,this.profilesHome.scheme)}async createProfile(y,I,p,f){const d=await this.f.call("createProfile",[y,I,p,f]);return(0,N.$Ol)(d,this.profilesHome.scheme)}async createTransientProfile(y){const I=await this.f.call("createTransientProfile",[y]);return(0,N.$Ol)(I,this.profilesHome.scheme)}async setProfileForWorkspace(y,I){await this.f.call("setProfileForWorkspace",[y,I])}removeProfile(y){return this.f.call("removeProfile",[y])}async updateProfile(y,I){const p=await this.f.call("updateProfile",[y,I]);return(0,N.$Ol)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$VR=k}),define(ue[62],de([0,1,2,71,4,16,3,80,19]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mNb=e.$lNb=e.$kNb=void 0,e.$kNb=(0,N.$Gi)("IUserDataProfileStorageService");let y=class extends R.$Vc{constructor(d,l){super(),this.b=l,d&&(this.a=this.B(new R.$5c))}async readStorageData(d){return this.withProfileScopedStorageService(d,async l=>this.c(l))}async updateStorageData(d,l,g){return this.withProfileScopedStorageService(d,async E=>this.f(E,l,g))}async withProfileScopedStorageService(d,l){if(this.b.hasScope(d))return l(this.b);let g=this.a?.get(d.id);if(!g){g=new p(this.g(d)),this.a?.set(d.id,g);try{await g.initialize()}catch(E){throw this.a?.has(d.id)?this.a.deleteAndDispose(d.id):g.dispose(),E}}try{const E=await l(g);return await g.flush(),E}finally{this.a?.has(d.id)||g.dispose()}}c(d){const l=new Map,g=E=>{for(const m of d.keys(A.StorageScope.PROFILE,E))l.set(m,{value:d.get(m,A.StorageScope.PROFILE),target:E})};return g(A.StorageTarget.USER),g(A.StorageTarget.MACHINE),l}f(d,l,g){d.storeAll(Array.from(l.entries()).map(([E,m])=>({key:E,value:m,scope:A.StorageScope.PROFILE,target:g})),!0)}};e.$lNb=y,e.$lNb=y=Se([Q(1,A.$jq)],y);class I extends y{constructor(d,l,g,E,m){super(d,E),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new R.$Wc);this.h=this.B(new T.$me({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")($=>{m.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(c=>(0,O.$Ol)(c,g.profilesHome.scheme)),valueChanges:$.valueChanges.map(c=>({...c,profile:(0,O.$Ol)(c.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(d){const l=this.j.getChannel("storage");return(0,A.$mq)(d)?new k.$gNb(l):new k.$hNb(l,d)}}e.$mNb=I;class p extends A.$lq{constructor(d){super({flushInterval:100}),this.U=d}async O(){const d=await this.U,l=new a.$fq(d);return this.B(l.onDidChangeStorage(g=>{this.u(A.StorageScope.PROFILE,g)})),this.B((0,R.$Tc)(()=>{l.close(),l.dispose(),(0,R.$Pc)(d)&&d.dispose()})),this.s=l,this.s.init()}P(d){return d===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ue[228],de([0,1,16,10,19,56,62]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;let k=class extends T.$mNb{constructor(y,I,p,f){super(!0,y,I,p,f)}};e.$Iic=k,e.$Iic=k=Se([Q(0,A.$dic),Q(1,N.$Nl),Q(2,R.$jq),Q(3,a.$bk)],k)}),define(ue[40],de([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tOb=e.$sOb=e.$rOb=e.$qOb=void 0,e.$nOb=h,e.$oOb=i,e.$pOb=n;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function n(u,b){return`${(0,y.$0f)(u)}${b.isDefault?"":` (${b.name})`}`}let t=class extends O.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,L,S,v,C,U,F,j,H,W,x,G){super(),this.syncResource=b,this.collection=L,this.G=S,this.H=v,this.I=C,this.J=U,this.L=F,this.M=j,this.N=H,this.O=W,this.P=x,this.c=null,this.m=$.SyncStatus.Idle,this.n=this.B(new T.$me),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$me),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Eh(50)),this.w=this.B(new T.$me),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(b.syncResource,b.profile),this.h=G.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,$.$Vnb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,$.$eob),this.y=(0,$.$Wnb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,v,this.h),this.j=(0,E.$pq)(v,S,C)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===$.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const L=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(L)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,L={}){await this.U(b,!0,this.ob(),L)}async preview(b,L,S={}){return this.U(b,!1,L,S)}async apply(b,L={}){try{this.F={...L};const S=await this.ab(b);return this.S(S),this.c}finally{this.F={}}}async U(b,L,S,v){try{if(this.F={...v},this.status===$.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===$.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);let C=$.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(b,U);return C=await this.Y(F,U,L,S),C===$.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):C===$.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(C)}}finally{this.F={}}}async replace(b){const L=this.kb(b);if(!L)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),C=await this.W(v),U=await this.qb({ref:v.ref,syncData:L},S,C,this.ob(),A.CancellationToken.None),F=[];for(const j of U){const H=await this.sb(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:W}=await this.sb(j,j.previewResource,j.remoteContent,A.CancellationToken.None);F.push([j,{...H,remoteChange:W!==$.Change.None?W:$.Change.Modified}])}await this.tb(v,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S($.SyncStatus.Idle)}return!0}async W(b){const L=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===L}async X(b,L){if(L){const S=b?b[this.resource]:void 0;if(L.ref===S||S===void 0&&L.syncData===null)return L}return this.getRemoteUserData(L)}async Y(b,L,S,v){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new $.$4nb((0,p.localize)(2430,null,this.resource,this.pb,b.syncData.version),$.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(b,L,S,v)}catch(C){if(C instanceof $.$4nb)switch(C.code){case $.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,L,S,v);case $.UserDataSyncErrorCode.Conflict:case $.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),L=await this.getLastSyncUserData(),this.Y(b,L,S,v)}throw C}}async Z(b,L,S,v){try{const C=await this.W(b),U=!C&&L===null&&this.gb()!==void 0,F=S&&!U;this.c||(this.c=(0,a.$th)(H=>this.eb(b,L,C,F,v,H)));let j=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const H of j.resourcePreviews)j=await this.accept(H.remoteResource)||j}return this.cb(j.resourcePreviews),j.resourcePreviews.some(({mergeState:H})=>H===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:S?await this.ab(!1):$.SyncStatus.Syncing}catch(C){throw this.c=null,C}}async merge(b){return await this.$(b,async L=>{const S=await this.rb(L,A.CancellationToken.None);await this.G.writeFile(L.previewResource,N.$Oe.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(L,L.previewResource,void 0,A.CancellationToken.None):void 0;return L.acceptResult=v,L.mergeState=S.hasConflicts?$.MergeState.Conflict:v?$.MergeState.Accepted:$.MergeState.Preview,L.localChange=v?v.localChange:S.localChange,L.remoteChange=v?v.remoteChange:S.remoteChange,L}),this.c}async accept(b,L){return await this.$(b,async S=>{const v=await this.sb(S,b,L,A.CancellationToken.None);return S.acceptResult=v,S.mergeState=$.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(b){return await this.$(b,async L=>{const S=await this.rb(L,A.CancellationToken.None);return await this.G.writeFile(L.previewResource,N.$Oe.fromString(S.content||"")),L.acceptResult=void 0,L.mergeState=$.MergeState.Preview,L.localChange=S.localChange,L.remoteChange=S.remoteChange,L}),this.c}async $(b,L){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:C,remoteResource:U,previewResource:F})=>this.h.isEqual(C,b)||this.h.isEqual(U,b)||this.h.isEqual(F,b));v!==-1&&(this.c=(0,a.$th)(async C=>{const U=[...S.resourcePreviews];return U[v]=await L(U[v]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:C})=>C===$.MergeState.Conflict)?this.S($.SyncStatus.HasConflicts):this.S($.SyncStatus.Syncing))}async ab(b){if(!this.c)return $.SyncStatus.Idle;const L=await this.c;return L.resourcePreviews.some(({mergeState:S})=>S===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:L.resourcePreviews.some(({mergeState:S})=>S!==$.MergeState.Accepted)?$.SyncStatus.Syncing:(await this.tb(L.remoteUserData,L.lastSyncUserData,L.resourcePreviews.map(S=>[S,S.acceptResult]),b),this.c=null,await this.bb(),$.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const L=b.filter(({mergeState:S})=>S===$.MergeState.Conflict);(0,R.$ub)(this.s,L,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=L,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const L=this.c?await this.c:null;if(L)for(const S of L.resourcePreviews){if(this.h.isEqual(S.acceptedResource,b))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,b))return S.remoteContent;if(this.h.isEqual(S.localResource,b))return S.localContent;if(this.h.isEqual(S.baseResource,b))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,m.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(b){(0,l.$sl)(b)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(b)}}async eb(b,L,S,v,C,U){const F=await this.qb(b,L,S,C,U),j=[];for(const H of F){const W=H.previewResource.with({scheme:$.$dob,authority:"accepted"});if(H.localChange===$.Change.None&&H.remoteChange===$.Change.None)j.push({...H,acceptedResource:W,acceptResult:{content:null,localChange:$.Change.None,remoteChange:$.Change.None},mergeState:$.MergeState.Accepted});else{const x=v?await this.rb(H,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(H.previewResource,N.$Oe.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.sb(H,H.previewResource,void 0,U):void 0;j.push({...H,acceptResult:G,mergeState:x?.hasConflicts?$.MergeState.Conflict:G?$.MergeState.Accepted:$.MergeState.Preview,localChange:G?G.localChange:x?x.localChange:H.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:H.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:L,resourcePreviews:j,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const L=JSON.parse(b),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!L.version&&!!S&&L.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${L.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,C=1;for(;v===void 0&&C++<6;)try{const U=await this.hb();U&&(U.ref===L.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$wl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof $.$4nb)throw U;this.O.error(U,C)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,L.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:L.ref,syncData:v})}catch(U){if(U instanceof $.$4nb&&U.code===$.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...L,syncData:v}}async fb(b,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:b.ref,version:S,...L};this.I.store(this.z,JSON.stringify(v),m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),await this.ib(b)}gb(){return this.I.get(this.z,m.StorageScope.APPLICATION)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const L=b?JSON.parse(b):void 0;if(h(L))return L}catch(L){this.O.error(L)}}async ib(b){await this.G.writeFile(this.y,N.$Oe.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),L=JSON.parse(b.value.toString());await this.G.del(this.y),L.ref&&L.content!==void 0?(this.I.store(this.z,JSON.stringify({...L,content:void 0}),m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),await this.ib({ref:L.ref,syncData:L.content===null?null:JSON.parse(L.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,L)}catch(b){b instanceof l.$wl&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,m.StorageScope.APPLICATION)}async getRemoteUserData(b){const{ref:L,content:S}=await this.lb(b);let v=null;return S!==null&&(v=this.kb(S)),{ref:L,syncData:v}}kb(b){try{const L=JSON.parse(b);if(i(L))return L}catch(L){this.O.error(L)}throw new $.$4nb((0,p.localize)(2431,null),$.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(b){const L=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,L,this.collection,this.F)}async mb(b,L){const S=await this.j,v={version:this.pb,machineId:S,content:b};try{return L=await this.J.writeResource(this.resource,JSON.stringify(v),L,this.collection,this.F),{ref:L,syncData:v}}catch(C){throw C instanceof $.$4nb&&C.code===$.UserDataSyncErrorCode.TooLarge&&(C=new $.$4nb(C.message,C.code,this.resource)),C}}async nb(b){const L={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(L),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==$.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S($.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue($.$Qnb)}};e.$qOb=t,e.$qOb=t=Se([Q(2,l.$bl),Q(3,d.$Ni),Q(4,m.$jq),Q(5,$.$Ynb),Q(6,$.$Znb),Q(7,$.$9nb),Q(8,w.$am),Q(9,$.$bob),Q(10,f.$aj),Q(11,P.$Ll)],t);let s=class extends t{constructor(b,L,S,v,C,U,F,j,H,W,x,G,te){super(L,S,v,C,U,F,j,H,W,x,G,te),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(B=>this.yb(B)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,L,S){try{L?await this.G.writeFile(this.r,N.$Oe.fromString(b),S?void 0:L):await this.G.createFile(this.r,N.$Oe.fromString(b),{overwrite:S})}catch(v){throw v instanceof l.$wl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$wl&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new $.$4nb(v.message,$.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof l.$wl&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$rOb=s,e.$rOb=s=Se([Q(3,l.$bl),Q(4,d.$Ni),Q(5,m.$jq),Q(6,$.$Ynb),Q(7,$.$Znb),Q(8,$.$9nb),Q(9,w.$am),Q(10,$.$bob),Q(11,f.$aj),Q(12,P.$Ll)],s);let r=class extends s{constructor(b,L,S,v,C,U,F,j,H,W,x,G,te,B){super(b,L,S,v,C,U,F,j,H,W,x,te,B),this.zb=G,this.Bb=void 0}Ab(b,L){const S=[],v=(0,k.$Zn)(b,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,I.$mg)(v)&&L!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$sOb=r,e.$sOb=r=Se([Q(3,l.$bl),Q(4,d.$Ni),Q(5,m.$jq),Q(6,$.$Ynb),Q(7,$.$Znb),Q(8,$.$9nb),Q(9,w.$am),Q(10,$.$bob),Q(11,$.$aob),Q(12,f.$aj),Q(13,P.$Ll)],r);let o=class{constructor(b,L,S,v,C,U,F){this.resource=b,this.g=L,this.h=S,this.j=v,this.k=C,this.l=U,this.d=F.extUri,this.f=(0,$.$Wnb)(void 0,this.resource,S,this.d)}async initialize({ref:b,content:L}){if(!L){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(L);if(S)try{await this.o({ref:b,syncData:S})}catch(v){this.j.error(v)}}m(b){try{const L=JSON.parse(b);if(i(L))return L}catch(L){this.j.error(L)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,L={}){if(L.ref||L.version)throw new Error("Cannot have core properties as additional");const S={ref:b.ref,version:void 0,...L};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Oe.fromString(JSON.stringify(b)))}};e.$tOb=o,e.$tOb=o=Se([Q(1,c.$Nl),Q(2,d.$Ni),Q(3,g.$bk),Q(4,l.$bl),Q(5,m.$jq),Q(6,P.$Ll)],o)}),define(ue[120],de([0,1,6,25,8,3,45,2,26,21,15,119,27,35,86,34,7,4,77,10,16,18,28,19,40,207,115,24,62]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=e.$hdc=void 0,e.$fdc=b,e.$gdc=L;async function u(U,F){const j=JSON.parse(U.content);if(U.version===1||U.version===2){const H=(await F.getInstalled(g.ExtensionType.System)).filter(W=>W.isBuiltin);for(const W of j)U.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),U.version===2&&H.every(x=>!(0,d.$Np)(x.identifier,W.identifier))&&(W.installed=!0)}return j}function b(U){return JSON.parse(U.content)}function L(U,F){return U.sort((j,H)=>!j.identifier.uuid&&H.identifier.uuid?-1:j.identifier.uuid&&!H.identifier.uuid?1:(0,O.$zf)(j.identifier.id,H.identifier.id)),F?(0,T.$0n)(U,{}):JSON.stringify(U)}let S=class extends n.$qOb{constructor(F,j,H,W,x,G,te,B,V,_,ne,le,ee,X,K,q,D){super({syncResource:r.SyncResource.Extensions,profile:F},j,W,H,x,G,te,le,ee,_,ne,K),this.Cb=B,this.Db=V,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$dob,authority:"base"}),this.yb=this.wb.with({scheme:r.$dob,authority:"local"}),this.zb=this.wb.with({scheme:r.$dob,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$dob,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:oe})=>!!oe)),A.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),A.Event.filter(q.onDidChange,J=>J.valueChanges.some(({profile:oe,changes:Y})=>this.syncResource.profile.id===oe.id&&Y.some(Z=>Z.key===f.$qp))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,j){const H=F.syncData?await u(F.syncData,this.Cb):null,W=j?.skippedExtensions??[],x=j?.builtinExtensions??null,G=j?.syncData?await u(j.syncData,this.Cb):null,{localExtensions:te,ignoredExtensions:B}=await this.Bb.getLocalExtensions(this.syncResource.profile);H?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:_}=(0,t.$edc)(te,H,G,W,B,x),ne={local:V,remote:_,content:this.Hb(te,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},le=this.Ob(te,!1);return[{skippedExtensions:W,builtinExtensions:x,baseResource:this.xb,baseContent:G?this.Ob(G,!1):le,localResource:this.yb,localContent:le,localExtensions:te,remoteResource:this.zb,remoteExtensions:H,remoteContent:H?this.Ob(H,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(F){const j=F.syncData?await u(F.syncData,this.Cb):null,{localExtensions:H,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$edc)(H,j,j,F.skippedExtensions||[],W,F.builtinExtensions||[]);return x!==null}Hb(F,j,H,W){const x=[...j,...H],G=new Set,te=B=>{G.add(B.id.toLowerCase()),B.uuid&&G.add(B.uuid)};x.forEach(({identifier:B})=>te(B)),W.forEach(te);for(const B of F)G.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&G.has(B.identifier.uuid)||x.push(B);return this.Ob(x,!1)}async rb(F,j){return{...F.previewResult,hasConflicts:!1}}async sb(F,j,H,W){if(this.h.isEqual(j,this.yb))return this.Kb(F);if(this.h.isEqual(j,this.zb))return this.Lb(F);if(this.h.isEqual(j,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Kb(F){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.Db.getIgnoredExtensions(j),W=(0,t.$edc)(F.localExtensions,null,null,F.skippedExtensions,H,F.builtinExtensions),{local:x,remote:G}=W;return{content:F.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:G!==null?r.Change.Modified:r.Change.None}}async Lb(F){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),H=this.Db.getIgnoredExtensions(j),W=F.remoteContent?JSON.parse(F.remoteContent):null;if(W!==null){const x=(0,t.$edc)(F.localExtensions,W,F.localExtensions,[],H,F.builtinExtensions),{local:G,remote:te}=x;return{content:F.remoteContent,local:G,remote:te,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(F,j,H,W){let{skippedExtensions:x,builtinExtensions:G,localExtensions:te}=H[0][0];const{local:B,remote:V,localChange:_,remoteChange:ne}=H[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(te)),x=await this.Bb.updateLocalExtensions(B.added,B.removed,B.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(V.all);F=await this.mb(le,W?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ee=>ee.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ee=>ee.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ee=>ee.identifier.id))}.`:""}`)}j?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(te,G),await this.fb(F,{skippedExtensions:x,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(le=>le.identifier.id))}.`:""}`))}Nb(F,j){const H=new Set,W=[];for(const x of F)H.add(x.identifier.id.toLowerCase()),x.installed||W.push(x.identifier);if(j)for(const x of j)H.has(x.id.toLowerCase())||W.push(x);return W}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const j=await this.db(F);return j&&this.Ob(JSON.parse(j),!0)}return null}Ob(F,j){return L(F,j)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.$hdc=S,e.$hdc=S=Se([Q(2,I.$Ni),Q(3,E.$bl),Q(4,$.$jq),Q(5,r.$Ynb),Q(6,r.$Znb),Q(7,f.$pp),Q(8,s.$iPb),Q(9,r.$bob),Q(10,y.$aj),Q(11,r.$9nb),Q(12,c.$am),Q(13,l.$uw),Q(14,h.$Ll),Q(15,o.$kNb),Q(16,m.$Fi)],S);let v=class{constructor(F,j,H,W,x,G){this.a=F,this.b=j,this.c=H,this.d=W,this.f=x,this.g=G}async getLocalExtensions(F){const j=await this.a.getInstalled(void 0,F.extensionsResource),H=this.d.getIgnoredExtensions(j);return{localExtensions:await this.j(F,async(x,G)=>{const te=x.getDisabledExtensions();return j.map(B=>{const{identifier:V,isBuiltin:_,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:X}=B,K={identifier:V,preRelease:le,version:ne.version,pinned:!!ee};X&&!(0,g.$vn)(ne)&&(K.isApplicationScoped=X),te.some(q=>(0,d.$Np)(q,V))&&(K.disabled=!0),_||(K.installed=!0);try{const q=G.getKeysForSync({id:V.id,version:ne.version});if(q){const D=G.getExtensionState(B,!0)||{};K.state=Object.keys(D).reduce((J,oe)=>(q.includes(oe)&&(J[oe]=D[oe]),J),{})}}catch(q){this.g.info(`${(0,n.$pOb)(r.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,N.$0)(q))}return K})}),ignoredExtensions:H}}async updateLocalExtensions(F,j,H,W,x){const G=(0,n.$pOb)(r.SyncResource.Extensions,x),te=[],B=new Map,V=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((F.length||H.length)&&await this.j(x,async(X,K)=>{await R.Promises.settled([...F,...H].map(async q=>{const D=ne.find(Y=>(0,d.$Np)(Y.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,K),X.getDisabledExtensions().some(Z=>(0,d.$Np)(Z,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${G}: Disabling extension...`,q.identifier.id),await X.disableExtension(q.identifier),this.g.info(`${G}: Disabled extension`,q.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,q.identifier.id),await X.enableExtension(q.identifier),this.g.info(`${G}: Enabled extension`,q.identifier.id))),V.push(q.identifier);return}const J=q.pinned?q.version:void 0,oe=(await this.c.getExtensions([{...q.identifier,version:J,preRelease:J?void 0:q.preRelease}],a.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:oe)&&this.h(q.state,D||oe,D?.manifest.version,K),oe)try{X.getDisabledExtensions().some(Z=>(0,d.$Np)(Z,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${G}: Disabling extension...`,q.identifier.id,oe.version),await X.disableExtension(oe.identifier),this.g.info(`${G}: Disabled extension`,q.identifier.id,oe.version)):(this.g.trace(`${G}: Enabling extension...`,q.identifier.id,oe.version),await X.enableExtension(oe.identifier),this.g.info(`${G}: Enabled extension`,q.identifier.id,oe.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[f.$cp]:!0,[f.$dp]:f.ExtensionInstallSource.SETTINGS_SYNC}}}),B.set(oe.identifier.id.toLowerCase(),q)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),_.push(q)))}catch(Y){_.push(q),this.g.error(Y),this.g.info(`${G}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else _.push(q),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),j.length){const X=ne.filter(({identifier:K,isBuiltin:q})=>!q&&j.some(D=>(0,d.$Np)(K,D)));await R.Promises.settled(X.map(async K=>{this.g.trace(`${G}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,K.identifier.id),V.push(K.identifier)}))}const le=await this.a.installGalleryExtensions(te);for(const{identifier:X,local:K,error:q,source:D}of le){const J=D;if(K)this.g.info(`${G}: Installed extension.`,X.id,J.version),V.push(X);else{const oe=B.get(X.id.toLowerCase());oe&&(_.push(oe),this.g.info(`${G}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),q instanceof f.$op&&[f.ExtensionManagementErrorCode.Incompatible,f.ExtensionManagementErrorCode.IncompatibleApi,f.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):q&&this.g.error(q)}}const ee=[];for(const X of W)V.some(K=>(0,d.$Np)(K,X.identifier))||ee.push(X);for(const X of _)ee.some(K=>(0,d.$Np)(K.identifier,X.identifier))||ee.push(X);return ee}h(F,j,H,W){const x=W.getExtensionState(j,!0)||{},G=H?W.getKeysForSync({id:j.identifier.id,version:H}):void 0;G?G.forEach(te=>{x[te]=F[te]}):Object.keys(F).forEach(te=>x[te]=F[te]),W.setExtensionState(j,x,!0)}async j(F,j){return this.b.withProfileScopedStorageService(F,async H=>{const W=new k.$Uc,x=W.add(this.f.createChild(new w.$Ei([$.$jq,H]))),G=W.add(x.createInstance(p.$IMb)),te=W.add(x.createInstance(l.$vw));try{return await j(G,te)}finally{W.dispose()}})}};e.$idc=v,e.$idc=v=Se([Q(0,f.$pp),Q(1,o.$kNb),Q(2,f.$mp),Q(3,s.$iPb),Q(4,m.$Fi),Q(5,r.$bob)],v);let C=class extends n.$tOb{constructor(F,j,H,W,x,G,te,B){super(r.SyncResource.Extensions,W,x,G,H,te,B),this.p=F,this.q=j}async t(F){return F.syncData?await u(F.syncData,this.p):null}u(F,j){const H=[],W=[],x=[];for(const G of F){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const te=j.find(B=>(0,d.$Np)(B.identifier,G.identifier));te?(H.push(te),G.disabled&&x.push(G.identifier)):G.installed&&(W.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:H,newExtensions:W,disabledExtensions:x,remoteExtensions:F}}};e.$jdc=C,e.$jdc=C=Se([Q(0,f.$pp),Q(1,s.$iPb),Q(2,E.$bl),Q(3,i.$Nl),Q(4,I.$Ni),Q(5,P.$bk),Q(6,$.$jq),Q(7,h.$Ll)],C)}),define(ue[121],de([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,82,211,24,19,62,4]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zOb=e.$yOb=e.$xOb=e.$wOb=void 0,e.$vOb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const C=S.storage?Object.keys(S.storage).sort():[],U={};return C.forEach(F=>U[F]=S.storage[F]),S.storage=U,v?(0,T.$0n)(S,{}):JSON.stringify(S)}const r=1;let o=class extends m.$qOb{constructor(v,C,U,F,j,H,W,x,G,te,B,V,_,ne){super({syncResource:$.SyncResource.GlobalState,profile:v},C,F,x,V,j,H,G,te,W,B,_),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:$.$dob,authority:"base"}),this.xb=this.vb.with({scheme:$.$dob,authority:"local"}),this.yb=this.vb.with({scheme:$.$dob,authority:"remote"}),this.zb=this.vb.with({scheme:$.$dob,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(F.onDidFilesChange,le=>le.contains(this.H.argvResource)),N.Event.filter(U.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:X})=>this.syncResource.profile.id===ee.id&&X.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,C,U){const F=v.syncData?JSON.parse(v.syncData.content):null;C=C===null&&U?v:C;const j=C&&C.syncData?JSON.parse(C.syncData.content):null,H=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Jb(j),{local:x,remote:G}=(0,P.$uOb)(H.storage,F?F.storage:null,j?j.storage:null,W,this.O),te={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:G.all!==null?$.Change.Modified:$.Change.None},B=s(H,!1);return[{baseResource:this.wb,baseContent:j?s(j,!1):B,localResource:this.xb,localContent:B,localUserData:H,remoteResource:this.yb,remoteContent:F?s(F,!1):null,previewResource:this.vb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.zb,storageKeys:W}]}async ub(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(C===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(C),{remote:j}=(0,P.$uOb)(U.storage,C.storage,C.storage,F,this.O);return j.all!==null}async rb(v,C){return{...v.previewResult,hasConflicts:!1}}async sb(v,C,U,F){if(this.h.isEqual(C,this.xb))return this.Gb(v);if(this.h.isEqual(C,this.yb))return this.Hb(v);if(this.h.isEqual(C,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:$.Change.None,remoteChange:$.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const C=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,P.$uOb)(v.localUserData.storage,C.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:F!==null?$.Change.Modified:$.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:$.Change.None,remoteChange:$.Change.None}}async tb(v,C,U,F){const{localUserData:j}=U[0][0],{local:H,remote:W,localChange:x,remoteChange:G}=U[0][1];if(x===$.Change.None&&G===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==$.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(j)),await this.Ab.writeLocalGlobalState(H,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==$.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const te=JSON.stringify({storage:W.all});v=await this.mb(te,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}C?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const C=await this.db(v);return C&&s(JSON.parse(C),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const C=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[W,x]of C)x.target===l.StorageTarget.USER?U.push(W):x.target===l.StorageTarget.MACHINE&&F.push(W);const j=[...U,...F],H=v?.storage?Object.keys(v.storage).filter(W=>!W.startsWith(n)&&!j.includes(W)&&C.get(W)!==void 0):[];if(!k.$p){const W=[...$.$Unb.map(x=>(0,$.$8nb)(x)),$.$7nb];H.push(...W),F.push(...W)}return{user:U,machine:F,unregistered:H}}};e.$wOb=o,e.$wOb=o=Se([Q(2,h.$kNb),Q(3,p.$bl),Q(4,$.$Ynb),Q(5,$.$Znb),Q(6,$.$bob),Q(7,I.$Ni),Q(8,$.$9nb),Q(9,g.$am),Q(10,y.$aj),Q(11,l.$jq),Q(12,E.$Ll),Q(13,i.$Fi)],o);let u=class{constructor(v,C,U,F){this.a=v,this.b=C,this.c=U,this.d=F}async getLocalGlobalState(v){const C={};if(v.isDefault){const F=await this.f(),j=(0,A.$Zn)(F);for(const H of t)j[H]!==void 0&&(C[`${n}${H}`]={version:1,value:j[H]})}const U=await this.c.readStorageData(v);for(const[F,j]of U)j.value&&j.target===l.StorageTarget.USER&&(C[F]={version:1,value:j.value});return{storage:C}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$0)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:C,updated:U},F){const j=(0,m.$pOb)($.SyncResource.GlobalState,F),H={},W=new Map,x=await this.c.readStorageData(F),G=(te,B)=>{for(const V of te){if(V.startsWith(n)){H[V.substring(n.length)]=B?B[V].value:void 0;continue}if(B){const _=B[V];_.value!==x.get(V)?.value&&W.set(V,_.value)}else x.get(V)!==void 0&&W.set(V,void 0)}};if(G(Object.keys(v),v),G(Object.keys(U),U),G(C),Object.keys(H).length){this.d.trace(`${j}: Updating locale...`);const te=await this.f();let B=te;for(const V of Object.keys(H))B=(0,w.edit)(B,[V],H[V],{});te!==B&&(this.d.trace(`${j}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Oe.fromString(B)),this.d.info(`${j}: Updated locale.`)),this.d.info(`${j}: Updated locale`)}W.size&&(this.d.trace(`${j}: Updating global state...`),await this.c.updateStorageData(F,W,l.StorageTarget.USER),this.d.info(`${j}: Updated global state`,[...W.keys()]))}};e.$xOb=u,e.$xOb=u=Se([Q(0,p.$bl),Q(1,I.$Ni),Q(2,h.$kNb),Q(3,$.$bob)],u);let b=class extends m.$tOb{constructor(v,C,U,F,j,H){super($.SyncResource.GlobalState,U,F,j,C,v,H)}async o(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(!C){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const j of Object.keys(C.storage))j.startsWith(n)?U[j.substring(n.length)]=C.storage[j].value:this.l.get(j,l.StorageScope.PROFILE)===void 0&&(F[j]=C.storage[j].value);if(Object.keys(U).length){let j="{}";try{j=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const H of Object.keys(U))j=(0,w.edit)(j,[H],U[H],{});await this.k.writeFile(this.h.argvResource,R.$Oe.fromString(j))}if(Object.keys(F).length){const j=[];for(const H of Object.keys(F))j.push({key:H,value:F[H],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(j,!0)}}};e.$yOb=b,e.$yOb=b=Se([Q(0,l.$jq),Q(1,p.$bl),Q(2,c.$Nl),Q(3,I.$Ni),Q(4,$.$bob),Q(5,E.$Ll)],b);let L=class{constructor(v,C,U,F,j){this.a=v,this.b=C,this.c=U,this.d=F,this.f=j}getSyncStoreType(v){return this.h(v)?.storage[$.$7nb]?.value}async sync(v){const C=(0,$.$3nb)((0,O.$3g)());try{return await this.g(v,C)}catch(U){if(U instanceof $.$4nb)switch(U.code){case $.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,C)}throw U}}async g(v,C){const U=await this.a.readResource($.SyncResource.GlobalState,null,void 0,C),F=this.h(U)||{storage:{}};F.storage[$.$7nb]={value:v,version:r};const j=await(0,d.$pq)(this.c,this.d,this.b),H={version:r,machineId:j,content:s(F,!1)};await this.a.writeResource($.SyncResource.GlobalState,JSON.stringify(H),U.ref,void 0,C)}h({content:v}){if(!v)return null;const C=JSON.parse(v);if((0,m.$oOb)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};e.$zOb=L,e.$zOb=L=Se([Q(1,l.$jq),Q(2,I.$Ni),Q(3,p.$bl),Q(4,f.$bk)],L)}),define(ue[122],de([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,208,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$ldc=P;function P(h,i,n){try{const t=JSON.parse(h);if(!i)return(0,k.$mg)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,k.$mg)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,k.$mg)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,k.$mg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let $=class extends E.$sOb{constructor(i,n,t,s,r,o,u,b,L,S,v,C,U){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},n,b,L,S,t,s,u,C,r,v,o,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$dob,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$dob,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$dob,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$dob,authority:"accepted"}),this.B(N.Event.filter(o.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const o=n?this.Ob(n):null,u=await this.vb(),b=await this.Cb();let L=null,S=!1,v=!1,C=!1;if(r){let j=u?u.value.toString():"[]";if(j=j||"[]",this.Ab(j,!0))throw new w.$4nb((0,O.localize)(2432,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==j||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const H=await(0,m.$kdc)(j,r,o,b,this.zb);H.hasChanges&&(L=H.mergeContent,C=H.hasConflicts,S=C||H.mergeContent!==j,v=C||H.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=u.value.toString(),v=!0);const U={content:C?o:L,localChange:S?u?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:v?w.Change.Modified:w.Change.None,hasConflicts:C},F=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),o=await(0,m.$kdc)(s||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:u,remoteChange:b}=t[0][1];if(u===w.Change.None&&b===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new w.$4nb((0,O.localize)(2433,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),b!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const L=this.Pb(o||"[]",i.syncData?.content);i=await this.mb(L,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,A.$Zn)(i.value.toString());if((0,R.$Lb)(n))return!0}}catch(i){if(i.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$Rnb)}};e.$mdc=$,e.$mdc=$=Se([Q(2,w.$Ynb),Q(3,w.$Znb),Q(4,w.$bob),Q(5,y.$aj),Q(6,w.$9nb),Q(7,p.$bl),Q(8,I.$Ni),Q(9,f.$jq),Q(10,w.$aob),Q(11,d.$am),Q(12,l.$Ll)],$);let c=class extends E.$tOb{constructor(i,n,t,s,r,o){super(w.SyncResource.Keybindings,n,t,s,i,r,o)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Oe.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Zn)(i.value.toString());return!(0,R.$Lb)(n)}catch(i){return i.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$ndc=c,e.$ndc=c=Se([Q(0,p.$bl),Q(1,g.$Nl),Q(2,I.$Ni),Q(3,w.$bob),Q(4,f.$jq),Q(5,l.$Ll)],c)}),define(ue[123],de([0,1,17,14,3,11,21,78,15,27,34,7,16,18,28,19,40,212,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=void 0,e.$odc=$;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function $(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let c=class extends E.$sOb{constructor(n,t,s,r,o,u,b,L,S,v,C,U,F,j){super(n.settingsResource,{syncResource:w.SyncResource.Settings,profile:n},t,s,r,o,u,b,C,U,L,S,v,j),this.Eb=n,this.Fb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$dob,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$dob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$dob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$dob,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),o=new k.$Qo(w.$Qnb,this.O);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(w.$Qnb)||{}}async qb(n,t,s){const r=await this.vb(),o=await this.Cb(),u=this.Mb(n);t=t===null&&s?n:t;const b=t?this.Mb(t):null,L=await this.Sb();let S=null,v=!1,C=!1,U=!1;if(u){let W=r?r.value.toString().trim():"{}";W=W||"{}",this.Vb(W),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,m.$4Mb)(W,u.settings,b?b.settings:null,L,[],o);S=x.localContent||x.remoteContent,v=x.localContent!==null,C=x.remoteContent!==null,U=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),C=!0);const F=r?r.value.toString():null,j=b?.settings??null,H={content:U?j:S,localChange:v?w.Change.Modified:w.Change.None,remoteChange:C?w.Change.Modified:w.Change.None,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:j,localResource:this.localResource,localContent:F,localChange:H.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:H.remoteChange,previewResource:this.previewResource,previewResult:H,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",o=await this.Sb(),u=await this.Cb();return(0,m.$4Mb)(r||"{}",t.settings,t.settings,o,[],u).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,m.$3Mb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const o=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,m.$3Mb)(n.fileContent.value.toString(),"{}",u,o):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,m.$3Mb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,m.$3Mb)(s,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:o}=s[0][0];let{content:u,localChange:b,remoteChange:L}=s[0][1];if(b===w.Change.None&&L===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),b!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),o&&await this.nb(JSON.stringify(this.Ob(o.value.toString()))),await this.wb(u,o,r),await this.P.reloadConfiguration(T.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),L!==w.Change.None){const S=await this.Cb(),v=this.Mb(n),C=await this.Sb(u);u=(0,m.$3Mb)(u,v?v.settings:"{}",C,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(u)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,m.$5Mb)(n.value.toString())}catch(n){if(n.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,m.$3Mb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return $(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(N.Event.any(N.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),N.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,m.$1Mb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(I.ExtensionType.System);return(0,R.$Mb)(n.map(t=>(0,w.$Pnb)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(I.ExtensionType.User,this.Eb.extensionsResource);return(0,R.$Mb)(n.map(t=>(0,w.$Pnb)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new w.$4nb((0,A.localize)(2434,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$pdc=c,e.$pdc=c=Se([Q(2,p.$bl),Q(3,O.$Ni),Q(4,f.$jq),Q(5,w.$Ynb),Q(6,w.$Znb),Q(7,w.$bob),Q(8,w.$aob),Q(9,T.$aj),Q(10,w.$9nb),Q(11,d.$am),Q(12,y.$pp),Q(13,l.$Ll)],c);let h=class extends E.$tOb{constructor(n,t,s,r,o,u){super(w.SyncResource.Settings,t,s,r,n,o,u)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,a.$Oe.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,m.$5Mb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return $(n)}catch(t){this.j.error(t)}return null}};e.$qdc=h,e.$qdc=h=Se([Q(0,p.$bl),Q(1,g.$Nl),Q(2,O.$Ni),Q(3,w.$bob),Q(4,f.$jq),Q(5,l.$Ll)],h)}),define(ue[124],de([0,1,14,3,29,21,15,7,16,18,28,19,40,209,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0,e.$tdc=g;function g(w){return JSON.parse(w.content)}let E=class extends f.$qOb{constructor(P,$,c,h,i,n,t,s,r,o,u,b){super({syncResource:l.SyncResource.Snippets,profile:P},$,h,c,i,n,t,o,u,s,r,b),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(c.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,L=>L.affects(this.vb))(()=>this.Q()))}async qb(P,$,c){const h=await this.Hb(),i=this.Gb(h),n=P.syncData?this.Fb(P.syncData):null;$=$===null&&c?P:$;const t=$&&$.syncData?this.Fb($.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.$rdc)(i,n,t);return this.Bb(s,h,n||{},t||{})}async ub(P){const $=P.syncData?this.Fb(P.syncData):null;if($===null)return!0;const c=await this.Hb(),h=this.Gb(c),i=(0,d.$rdc)(h,$,$);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,$){return P.previewResult}async sb(P,$,c,h){if(this.h.isEqualOrParent($,this.g.with({scheme:l.$dob,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent($,this.g.with({scheme:l.$dob,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent($,this.g))return c===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:c,localChange:c===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${$.toString()}`)}async tb(P,$,c,h){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,h)),$?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,$,c,h){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of P.conflicts){const t={content:h[n]??null,hasConflicts:!0,localChange:$[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}for(const n of Object.keys($))if(!i.has(n)){const t={content:$[n]?$[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$dob,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$dob,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$dob,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$dob,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$dob,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const $={};for(const c of P)c.fileContent&&($[this.h.basename(c.localResource)]=c.fileContent);await this.nb(JSON.stringify(this.Gb($)))}async Db(P,$){for(const{fileContent:c,acceptResult:h,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Oe.fromString(h.content),{overwrite:$}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Oe.fromString(h.content),$?void 0:c),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,$,c){const h=$.syncData?this.Fb($.syncData):{},i=(0,N.$fo)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const o=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,d.$sdc)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),$=await this.mb(JSON.stringify(i),c?null:$.ref),this.O.info(`${this.D}: Updated remote snippets`)),$}Fb(P){return g(P)}Gb(P){const $={};for(const c of Object.keys(P))$[c]=P[c].value.toString();return $}async Hb(){const P={};let $;try{$=await this.G.resolve(this.vb)}catch(c){if(c instanceof k.$wl&&c.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return P;throw c}for(const c of $.children||[]){const h=c.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[n]=t}}return P}};e.$udc=E,e.$udc=E=Se([Q(2,T.$Ni),Q(3,k.$bl),Q(4,O.$jq),Q(5,l.$Ynb),Q(6,l.$Znb),Q(7,l.$bob),Q(8,A.$aj),Q(9,l.$9nb),Q(10,y.$am),Q(11,I.$Ll)],E);let m=class extends f.$tOb{constructor(P,$,c,h,i,n){super(l.SyncResource.Snippets,$,c,h,P,i,n)}async o(P){const $=P.syncData?JSON.parse(P.syncData.content):null;if(!$){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys($)){const i=$[h];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(n,R.$Oe.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$vdc=m,e.$vdc=m=Se([Q(0,k.$bl),Q(1,p.$Nl),Q(2,T.$Ni),Q(3,l.$bob),Q(4,O.$jq),Q(5,I.$Ll)],m)}),define(ue[125],de([0,1,14,21,15,7,16,18,28,19,40,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0,e.$wdc=f;function f(E,m){try{return JSON.parse(E).tasks??null}catch(w){return m.error(w),null}}let d=class extends I.$rOb{constructor(m,w,P,$,c,h,i,n,t,s,r,o){super(m.tasksResource,{syncResource:p.SyncResource.Tasks,profile:m},w,n,t,s,P,$,i,r,c,h,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:p.$dob,authority:"base"}),this.Cb=this.Ab.with({scheme:p.$dob,authority:"local"}),this.Db=this.Ab.with({scheme:p.$dob,authority:"remote"}),this.Eb=this.Ab.with({scheme:p.$dob,authority:"accepted"})}async qb(m,w,P,$){const c=m.syncData?f(m.syncData.content,this.O):null;w=w===null&&P?m:w;const h=w?.syncData?f(w.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(m.syncData){const b=i?i.value.toString():null;if(!h||h!==b||h!==c){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const L=g(b,c,h);n=L.content,r=L.hasConflicts,t=L.hasLocalChanged,s=L.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?h:n,localChange:t?i?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:s?p.Change.Modified:p.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:o.localChange,remoteResource:this.Db,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(m){const w=m?.syncData?f(m.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),$=P?P.value.toString():null,c=g($,w,w);return c.hasLocalChanged||c.hasRemoteChanged}async rb(m,w){return m.previewResult}async sb(m,w,P,$){if(this.h.isEqual(w,this.Cb))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:m.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:P,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(m,w,P,$){const{fileContent:c}=P[0][0],{content:h,localChange:i,remoteChange:n}=P[0][1];if(i===p.Change.None&&n===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==p.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),c&&await this.nb(JSON.stringify(this.Kb(c.value.toString()))),h?await this.wb(h,c,$):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==p.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));m=await this.mb(t,$?null:m.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(m){return this.h.isEqual(this.Db,m)||this.h.isEqual(this.Bb,m)||this.h.isEqual(this.Cb,m)||this.h.isEqual(this.Eb,m)?this.db(m):null}Kb(m){return m?{tasks:m}:{}}};e.$xdc=d,e.$xdc=d=Se([Q(2,p.$Ynb),Q(3,p.$Znb),Q(4,p.$bob),Q(5,a.$aj),Q(6,p.$9nb),Q(7,A.$bl),Q(8,N.$Ni),Q(9,T.$jq),Q(10,k.$am),Q(11,O.$Ll)],d);let l=class extends I.$tOb{constructor(m,w,P,$,c,h){super(p.SyncResource.Tasks,w,P,$,m,c,h),this.c=this.g.defaultProfile.tasksResource}async o(m){const w=m.syncData?f(m.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Oe.fromString(w)),await this.n(m)}async p(){return this.k.exists(this.c)}};e.$ydc=l,e.$ydc=l=Se([Q(0,A.$bl),Q(1,y.$Nl),Q(2,N.$Ni),Q(3,p.$bob),Q(4,T.$jq),Q(5,O.$Ll)],l);function g(E,m,w){if(E===null&&m===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==E,$=w!==m;return!P&&!$?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!$?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:$&&!P?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ue[126],de([0,1,45,21,15,7,16,18,28,19,40,210,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0,e.$gfc=l,e.$hfc=g;let d=class extends I.$qOb{constructor(m,w,P,$,c,h,i,n,t,s,r,o,u){super({syncResource:f.SyncResource.Profiles,profile:m},w,$,c,h,i,n,r,o,t,s,u),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:f.$dob,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$dob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$dob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$dob,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const m=await this.getLastSyncUserData();return m?.syncData?g(m.syncData):null}async getRemoteSyncedProfiles(m){const w=await this.getLastSyncUserData(),P=await this.X(m,w);return P?.syncData?g(P.syncData):null}async qb(m,w,P){if(!this.vb.isEnabled())throw new f.$4nb("Cannot sync profiles because they are disabled",f.UserDataSyncErrorCode.LocalError);const $=m.syncData?g(m.syncData):null,c=w?.syncData?g(w.syncData):null,h=this.Db(),{local:i,remote:n}=(0,p.$efc)(h,$,c,[]),t={local:i,remote:n,content:c?this.Eb(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:n!==null?f.Change.Modified:f.Change.None},s=l(h,!1);return[{baseResource:this.baseResource,baseContent:c?this.Eb(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:$?this.Eb($):null,remoteProfiles:$,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(m){const w=m?.syncData?g(m.syncData):null,P=this.Db(),{remote:$}=(0,p.$efc)(P,w,w,[]);return!!$?.added.length||!!$?.removed.length||!!$?.updated.length}async rb(m,w){return{...m.previewResult,hasConflicts:!1}}async sb(m,w,P,$){if(this.h.isEqual(w,this.localResource))return this.Ab(m);if(this.h.isEqual(w,this.remoteResource))return this.Bb(m);if(this.h.isEqual(w,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(m){const w=this.Db(),P=(0,p.$efc)(w,null,null,[]),{local:$,remote:c}=P;return{content:m.localContent,local:$,remote:c,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:c!==null?f.Change.Modified:f.Change.None}}async Bb(m){const w=m.remoteContent?JSON.parse(m.remoteContent):null,P=[],$=[];for(const c of this.Db()){const h=w?.find(i=>i.id===c.id);h&&(P.push({id:c.id,name:c.name,collection:h.collection}),$.push(c))}if(w!==null){const c=(0,p.$efc)($,w,P,[]),{local:h,remote:i}=c;return{content:m.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:i!==null?f.Change.Modified:f.Change.None}}else return{content:m.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:f.Change.None,remoteChange:f.Change.None}}async tb(m,w,P,$){const{local:c,remote:h,localChange:i,remoteChange:n}=P[0][1];i===f.Change.None&&n===f.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new f.$4nb("Too many profiles to sync. Please remove some profiles and try again.",f.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==f.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(c.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.vb.profiles.find(o=>o.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==f.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const o of h?.added||[]){const u=await this.J.createCollection(this.F);s.push(u),t.push({id:o.id,name:o.name,collection:u,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of h?.removed||[])t.splice(t.findIndex(({id:u})=>o.id===u),1);for(const o of h?.updated||[]){const u=t.find(({id:b})=>o.id===b);u&&t.splice(t.indexOf(u),1,{...u,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{m=await this.updateRemoteProfiles(t,$?null:m.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(o=>o.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(o=>o.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of s)await this.J.deleteCollection(u,this.F)}throw o}for(const o of h?.removed||[])await this.J.deleteCollection(o.collection,this.F)}w?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(m,w){return this.mb(this.Eb(m),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(m){if(this.h.isEqual(this.remoteResource,m)||this.h.isEqual(this.baseResource,m)||this.h.isEqual(this.localResource,m)||this.h.isEqual(this.acceptedResource,m)){const w=await this.db(m);return w&&(0,R.$0n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(m=>!m.isDefault&&!m.isTransient)}Eb(m){return JSON.stringify([...m].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$ffc=d,e.$ffc=d=Se([Q(2,y.$Nl),Q(3,A.$bl),Q(4,N.$Ni),Q(5,T.$jq),Q(6,f.$Ynb),Q(7,f.$Znb),Q(8,f.$bob),Q(9,a.$aj),Q(10,f.$9nb),Q(11,k.$am),Q(12,O.$Ll)],d);function l(E,m){const w=[...E].sort((P,$)=>P.name.localeCompare($.name)).map(P=>({id:P.id,name:P.name}));return m?(0,R.$0n)(w,{}):JSON.stringify(w)}function g(E){return JSON.parse(E.content)}}),define(ue[229],de([0,1,3,2,5,15,16,18,24]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;const y="sync.enable";let I=class extends a.$Vc{constructor(f,d,l,g){super(),this.c=f,this.f=d,this.g=l,this.h=g,this.a=new R.$me,this.onDidChangeEnablement=this.a.event,this.b=new R.$me,this.onDidChangeResourceEnablement=this.b.event,this.B(f.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Uc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(y,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.f.publicLog2(y,{enabled:f}),this.c.store(y,f,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(f){return this.c.getBoolean((0,O.$8nb)(f),T.StorageScope.APPLICATION,!0)}setResourceEnablement(f,d){if(this.isResourceEnabled(f)!==d){const l=(0,O.$8nb)(f);this.j(l,d)}}getResourceSyncStateVersion(f){}j(f,d){this.c.store(f,d,T.StorageScope.APPLICATION,N.$p?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(f){if(y===f.key){this.a.fire(this.isEnabled());return}const d=O.$Unb.filter(l=>(0,O.$8nb)(l)===f.key)[0];if(d){this.b.fire([d,this.isResourceEnabled(d)]);return}}};e.$5ec=I,e.$5ec=I=Se([Q(0,T.$jq),Q(1,k.$am),Q(2,A.$Ni),Q(3,O.$Xnb)],I)}),define(ue[230],de([0,1,6,14,72,2,20,21,15,7,19,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let f=class extends A.$Vc{constructor(l,g,E,m,w){super(),this.a=l,this.b=g,this.c=E,this.f=m,this.g=w,this.h()}async h(){for(const g of this.g.profiles)for(const E of p.$Unb)try{await this.m(this.j(E,g.isDefault?void 0:g.id))}catch(m){this.f.error(m)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(g){(0,y.$sl)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g);return}if(l.children){for(const g of l.children)if(g.isDirectory&&!p.$Unb.includes(g.name)&&!this.g.profiles.some(E=>E.id===g.name))try{this.f.info("Deleting non existing profile from backup",g.resource.path),await this.b.del(g.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,g,E){const m=this.j(l,g,E);try{const w=await this.b.resolve(m);if(w.children)return w.children.filter($=>$.isFile&&!$.name.startsWith("lastSync")).sort().reverse().map($=>({ref:$.name,created:this.n($)}))}catch(w){if((0,y.$sl)(w)!==y.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,g,E,m){const w=this.j(l,E,m),P=(0,T.$hh)(w,g);try{return(await this.b.readFile(P)).value.toString()}catch($){return this.f.error($),null}}async writeResource(l,g,E,m,w){const P=this.j(l,m,w),$=(0,T.$hh)(P,`${(0,N.$5m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile($,a.$Oe.fromString(g))}catch(c){this.f.error(c)}}j(l,g,E=this.a.userDataSyncHome){return(0,T.$hh)(E,...g?[g,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const g=await this.b.resolve(l);if(g.children){const E=g.children.filter($=>$.isFile&&/^\d{8}T\d{6}(\.json)?$/.test($.name)).sort(),m=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=E.filter($=>Date.now()-this.n($)>m);const P=E.length-w.length;P<10&&(w=w.slice(10-P)),await R.Promises.settled(w.map(async $=>{this.f.info("Deleting from backup",$.resource.path),await this.b.del($.resource)}))}}catch(g){this.f.error(g)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$dfc=f,e.$dfc=f=Se([Q(0,O.$Ni),Q(1,y.$bl),Q(2,k.$aj),Q(3,p.$bob),Q(4,I.$Nl)],f)}),define(ue[87],de([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnb=e.$Knb=void 0,e.$Lnb=c,e.$Knb=(0,y.$Gi)("IUserDataSyncMachinesService");const g="sync.currentMachineName",E="Safari",m="Chrome",w="Edge",P="Firefox",$="Android";function c(n){switch(n){case E:case m:case w:case P:case $:case(0,N.$i)(N.Platform.Web):return!0}return!1}function h(){return N.$H?E:N.$F?m:N.$I?w:N.$G?P:N.$J?$:(0,N.$i)(N.$p?N.Platform.Web:N.$v)}let i=class extends a.$Vc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,o,u,b){super(),this.h=r,this.j=o,this.m=u,this.n=b,this.c=this.B(new R.$me),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$pq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),o=r.machines.filter(({id:u})=>u!==s);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(t,s,r){const o=await this.s(r),u=o.machines.find(({id:b})=>b===t);if(u){u.name=s,await this.t(o);const b=await this.f;t===b&&this.h.store(g,s,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,o]of t){const u=s.machines.find(b=>b.id===r);u&&(u.disabled=o?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(g,f.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$if)(r)}\\s#(\\d+)`);let u=0;for(const b of t){const L=o.exec(b.name),S=L?parseInt(L[1]):0;u=S>u?S:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,T.localize)(2448,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$Mnb=i,e.$Mnb=i=l=Se([Q(0,k.$Ni),Q(1,O.$bl),Q(2,f.$jq),Q(3,d.$Ynb),Q(4,d.$bob),Q(5,I.$uk)],i)}),define(ue[231],de([0,1,6,72,43,8,3,2,5,20,9,11,23,16,18,24,83,87]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",$="sync.storeUrl",c="sync.productQuality";let h=class extends k.$Vc{get n(){const t=this.H.get($,d.StorageScope.APPLICATION);return t?I.URI.parse(t):void 0}set n(t){t?this.H.store($,t.toString(),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE):this.H.remove($,d.StorageScope.APPLICATION)}get s(){return this.H.get(c,d.StorageScope.APPLICATION)}set s(t){t?this.H.store(c,t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE):this.H.remove(c,d.StorageScope.APPLICATION)}constructor(t,s,r,o,u,b,L,S,v,C){super(),this.u=s,this.w=r,this.y=o,this.z=u,this.C=b,this.D=L,this.F=S,this.G=v,this.H=C,this.a=this.B(new k.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$me),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$Eh(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,y.$ah)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(L.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$5m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,d.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),s)this.M(!1);else throw o}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=g.$4nb.toUserDataSyncError(t);s instanceof g.$6nb&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===g.UserDataSyncErrorCode.UpgradeRequired||s.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===g.UserDataSyncErrorCode.ServiceChanged||s.code===g.UserDataSyncErrorCode.DefaultServiceChanged?O.$p&&s.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(w,!0,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),await(0,R.$Hh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,d.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,d.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$jfc=h,e.$jfc=h=Se([Q(0,f.$uk),Q(1,g.$Xnb),Q(2,g.$Ynb),Q(3,g.$9nb),Q(4,g.$0nb),Q(5,g.$bob),Q(6,E.$KMb),Q(7,l.$am),Q(8,m.$Knb),Q(9,d.$jq)],h);class i extends k.$Vc{static{this.a="Interval"}constructor(t,s,r,o,u,b,L,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=o,this.u=u,this.w=b,this.y=L,this.z=S,this.C=v,this.b=this.B(new k.$Wc),this.c=this.B(new T.$me),this.onDidStartSync=this.c.event,this.f=this.B(new T.$me),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,R.$Ih)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,R.$th)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,A.$4)(u))return}return this.H(t,s,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,y.$ah)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,y.$ah)(s.defaultUrl,t.defaultUrl)||!(0,y.$ah)(s.insidersUrl,t.insidersUrl)||!(0,y.$ah)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let o;try{await this.I(s,r)}catch(u){if(this.y.error(u),o=u,g.$4nb.toUserDataSyncError(u).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),o=void 0}catch(b){this.y.error(b),o=b}}this.f.fire(o)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new g.$6nb((0,p.localize)(2435,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$6nb((0,p.localize)(2436,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$6nb((0,p.localize)(2437,null),g.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,d.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new g.$6nb((0,p.localize)(2438,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$6nb((0,p.localize)(2439,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$6nb((0,p.localize)(2440,null),g.UserDataSyncErrorCode.SessionExpired);const o=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const u=o.find(L=>L.isCurrent);if(u?.disabled)throw new g.$6nb((0,p.localize)(2441,null),g.UserDataSyncErrorCode.TurnedOff);const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(L){throw new g.$6nb((0,N.$rj)(L),L instanceof g.$4nb?L.code:g.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),!s.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(ue[232],de([0,1,9,11,15,7,49,16,28,24,19,40,124,123,122,21,125,120,121,4,126,45,26]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,o,u,b,L,S,v,C,U){this.e=s,this.f=r,this.g=o,this.h=b,this.i=L,this.j=S,this.k=v,this.l=C,this.n=U,this.d=u.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(y.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,y.SyncResource.Profiles);return(0,$.$hfc)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(y.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.f.resolveResourceContent(y.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const u=this.L(o,y.SyncResource.Profiles);return(0,$.$hfc)(u)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:u,ref:b})=>({created:u,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.f.getAllResourceRefs(s,r?.collection,o)).map(({created:b,ref:L})=>({created:b,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:L,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),o=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const o=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case y.SyncResource.Settings:return this.s(s,o);case y.SyncResource.Keybindings:return this.u(s,o);case y.SyncResource.Tasks:return this.w(s,o);case y.SyncResource.Snippets:return this.y(s,o);case y.SyncResource.GlobalState:return this.D(s,o);case y.SyncResource.Extensions:return this.A(s,o);case y.SyncResource.Profiles:return this.G(s,o);case y.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,T.$pq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,o,u,b){if(s){const{content:L}=await this.M(r,u,o);return L}return this.f.resolveResourceContent(r,u,o,b)}q(s,r,o){const u=this.L(r,s);switch(s){case y.SyncResource.Settings:return this.t(u,o);case y.SyncResource.Keybindings:return this.v(u,o);case y.SyncResource.Tasks:return this.x(u,o);case y.SyncResource.Snippets:return this.z(u,o);case y.SyncResource.GlobalState:return this.E(u,o);case y.SyncResource.Extensions:return this.B(u,o);case y.SyncResource.Profiles:return this.H(u,o);case y.SyncResource.WorkspaceState:return null}}async r(s,r){const o=this.k.profiles.find(u=>u.id===r);if(!o)return null;switch(s){case y.SyncResource.GlobalState:return this.F(o);case y.SyncResource.Extensions:return this.C(o);case y.SyncResource.Profiles:return this.I(o);case y.SyncResource.Settings:return null;case y.SyncResource.Keybindings:return null;case y.SyncResource.Tasks:return null;case y.SyncResource.Snippets:return null;case y.SyncResource.WorkspaceState:return null}}s(s,r){const o=this.d.joinPath(s,"settings.json"),u=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}t(s,r){switch(r){case"settings.json":return(0,d.$odc)(s.content).settings}return null}u(s,r){const o=this.d.joinPath(s,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$ldc)(s.content,!!this.l.getValue(y.$Rnb),this.g)}return null}w(s,r){const o=this.d.joinPath(s,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}x(s,r){switch(r){case"tasks.json":return(0,E.$wdc)(s.content,this.g)}return null}async y(s,r){const o=await this.resolveContent(s);if(o){const u=this.L(o,y.SyncResource.Snippets);if(u){const b=(0,f.$tdc)(u),L=[];for(const S of Object.keys(b)){const v=this.d.joinPath(s,S),C=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);L.push({resource:v,comparableResource:C})}return L}}return[]}z(s,r){return(0,f.$tdc)(s)[r]||null}A(s,r){const o=this.d.joinPath(s,"extensions.json"),u=r?this.J({remote:!1,syncResource:y.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}B(s,r){switch(r){case"extensions.json":return(0,m.$gdc)((0,m.$fdc)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(m.$idc).getLocalExtensions(s);return(0,m.$gdc)(r,!0)}D(s,r){const o=this.d.joinPath(s,"globalState.json"),u=r?this.J({remote:!1,syncResource:y.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}E(s,r){switch(r){case"globalState.json":return(0,w.$vOb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(w.$xOb).getLocalGlobalState(s);return(0,w.$vOb)(r,!0)}G(s,r){const o=this.d.joinPath(s,"profiles.json"),u=this.J({remote:!1,syncResource:y.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:u}]}H(s,r){switch(r){case"profiles.json":return(0,c.$0n)(JSON.parse(s.content),{})}return null}async I(s){return(0,$.$gfc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,h.$mf)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.d.joinPath(R.URI.from({scheme:y.$dob,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}K(s){if(s.scheme!==y.$dob)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const o=s.authority===i.b;let u,b;const L=[];let S,v,C,U,F;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?u=j.substring(7):j.startsWith("authority:")?b=j.substring(10):j.startsWith("syncResource:")?S=j.substring(13):j.startsWith("profile:")?v=j.substring(8):j.startsWith("collection:")?C=j.substring(11):j.startsWith("ref:")?U=j.substring(4):S?F=j:L.push(j)}return{remote:o,syncResource:S,profile:v,collection:C,ref:U,node:F,location:u&&b!==void 0?this.d.joinPath(R.URI.from({scheme:u,authority:b,query:s.query,fragment:s.fragment,path:"/"}),...L):void 0}}L(s,r){try{const o=JSON.parse(s);if((0,p.$oOb)(o))return o}catch(o){this.g.error(o)}throw new y.$4nb((0,a.localize)(2449,null),y.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,o){const u=await this.e.resolveResourceContent(s,r,o);return{ref:r,content:u}}};e.$Zfc=n,e.$Zfc=n=i=Se([Q(0,y.$Ynb),Q(1,y.$Znb),Q(2,y.$bob),Q(3,O.$Ll),Q(4,N.$Ni),Q(5,k.$jq),Q(6,A.$bl),Q(7,I.$Nl),Q(8,g.$aj),Q(9,P.$Fi)],n)}),define(ue[233],de([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,120,121,122,123,124,125,126,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;const s="sync.lastSyncTime";let r=class extends k.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,C,U,F,j,H,W,x,G,te){super(),this.C=S,this.D=v,this.F=C,this.G=U,this.H=F,this.I=j,this.J=H,this.L=W,this.M=x,this.N=G,this.O=te,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$me),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$me),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$me),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$me),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$me),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$me),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$me),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=C.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,g.StorageScope.APPLICATION,void 0),this.B((0,k.$Tc)(()=>this.cb())),this.B(new a.$Sh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const C=new Date().getTime(),U=(0,I.$3g)();try{const W=(0,t.$3nb)(U);v&&(W["Cache-Control"]="no-cache"),S=await this.D.manifest(S,W)}catch(W){const x=t.$4nb.toUserDataSyncError(W);throw b(x,U,this.F,this.I),x}const F=!1,j=this;let H;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");H=(0,a.$th)(W=>j.P(S,!1,U,W)),await H.finally(()=>H=void 0),j.H.info(`Sync done. Took ${new Date().getTime()-C}ms`),j.ab()},stop(){return H?.cancel(),j.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$4nb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,I.$3g)(),C=(0,t.$3nb)(v);let U;try{U=await this.D.manifest(null,C)}catch(H){const W=t.$4nb.toUserDataSyncError(H);throw b(W,v,this.F,this.I),W}await this.resetLocal();const F=this,j=new N.$xe;return{id:v,async merge(){return F.P(U,!0,v,j.token)},async apply(){try{try{await F.R(U,v,j.token)}catch(H){if(t.$4nb.toUserDataSyncError(H).code===t.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,j.token);else throw H}}catch(H){throw F.H.error(H),H}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.ab()},async stop(){j.cancel(),await F.U(),await F.resetLocal()}}}async P(S,v,C,U){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,v,C,U));const j=F.enabled.find(H=>H.resource===t.SyncResource.Profiles);if(j){const H=await j.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(H,S,v,C,U)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,C,U,F){for(const j of S){if(F.isCancellationRequested)return;const H=this.M.profiles.find(x=>x.id===j.id);if(!H){this.H.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",j.name);const W=this.getOrCreateActiveProfileSynchronizer(H,j);this.n.push(...await this.S(W,v,C,U,F))}for(const[j,H]of this.z.entries())this.M.profiles.some(W=>W.id===H[0].profile.id)||(await H[0].resetLocal(),H[1].dispose(),this.z.delete(j))}async R(S,v,C){const U=this.bb();for(const x of U){if(C.isCancellationRequested)return;await x.apply(v,C)}const F=U.find(x=>x.profile.isDefault);if(!F)return;const j=F.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!j)return;const W=(await j.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>U.every(G=>G.profile.id!==x.id));W.length&&await this.Q(W,S,!1,v,C)}async S(S,v,C,U,F){return(await S.sync(v,C,U,F)).map(([H,W])=>({profile:S.profile,syncResource:H,error:W}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const C of this.bb())for(const U of C.enabled){const F=await U.resolveContent(S);if(F)return F}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const C=await this.resolveContent(S.uri);C&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(C),!0})}async accept(S,v,C,U){this.db(),await this.X(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(v,C),U&&await F.apply((0,y.$lg)(U)?!1:U.force,(0,t.$3nb)((0,I.$3g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,g.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),v=[];for(const U of S){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const C=new k.$Uc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=C.add(this.G.createInstance(o,this.M.defaultProfile,void 0)));const F=U.enabled.find(W=>W.resource===t.SyncResource.Profiles);if(!F)return;const H=(await F.getLastSyncedProfiles())?.map(W=>W.collection)??[];for(const[W,x]of v)H.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(W,g.StorageScope.APPLICATION))}finally{C.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(j=>j.collection),C=await this.D.getAllCollections(),U=C.filter(j=>!v.includes(j));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(j=>this.D.deleteCollection(j))),this.H.info("Deleted redundant collections on server"));const F=S.filter(j=>C.includes(j.collection));if(F.length!==S.length){const j=this.G.createInstance(n.$ffc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const C=(await this.C.readFile(S)).value.toString(),U=JSON.parse(C);if(U.resources)for(const F in U.resources)for(const j of U.resources[F])await this.O.writeResource(F,j.content,new Date(j.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const j in U.collections[F].resources)for(const H of U.collections[F].resources?.[j]??[])await this.O.writeResource(j,H.content,new Date(H.created*1e3),F,v)}async X(S,v){const C=new k.$Uc;try{const U=this.z.get(S.id);if(U){const x=await this.Y(U[0],v,C);return(0,y.$mg)(x)?null:x}if(S.isDefault){const x=C.add(this.G.createInstance(o,S,void 0)),G=await this.Y(x,v,C);return(0,y.$mg)(G)?null:G}if(this.M.isEnabled())return null;const F=C.add(this.G.createInstance(n.$ffc,S,void 0)),j=await this.D.manifest(null),W=(await F.getRemoteSyncedProfiles(j?.latest??null)||[]).find(x=>x.id===S.id);if(W){const x=C.add(this.G.createInstance(o,S,W.collection)),G=await this.Y(x,v,C);return(0,y.$mg)(G)?null:G}return null}finally{C.dispose()}}async Y(S,v,C){const U=[...S.enabled,...S.disabled.reduce((F,j)=>(j!==t.SyncResource.WorkspaceState&&F.push(C.add(S.createSynchronizer(j))),F),[])];for(const F of U){const j=await v(F);if(!(0,y.$mg)(j))return j}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,R.$ub)(this.j,S,(v,C)=>v.profile.id===C.profile.id&&v.syncResource===C.syncResource&&(0,R.$ub)(v.conflicts,C.conflicts,(U,F)=>(0,O.$ah)(U.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let C=this.z.get(S.id);if(C&&C[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),C[1].dispose(),C=void 0,this.z.delete(S.id)),!C){const U=new k.$Uc,F=U.add(this.G.createInstance(o,S,v?.collection));U.add(F.onDidChangeStatus(j=>this.Z(j))),U.add(F.onDidChangeConflicts(j=>this.$())),U.add(F.onDidChangeLocal(j=>this.h.fire(j))),this.z.set(S.id,C=[F,U])}return C[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$ifc=r,e.$ifc=r=Se([Q(0,d.$bl),Q(1,t.$Ynb),Q(2,t.$Xnb),Q(3,l.$Fi),Q(4,t.$bob),Q(5,E.$am),Q(6,g.$jq),Q(7,t.$9nb),Q(8,m.$Nl),Q(9,t.$$nb),Q(10,t.$Znb)],r);let o=class extends k.$Vc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$Unb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,C,U,F,j,H,W,x,G){super(),this.profile=S,this.collection=v,this.r=C,this.t=U,this.u=F,this.w=j,this.y=H,this.z=W,this.C=x,this.D=G,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$me),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$me),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$me),this.onDidChangeConflicts=this.n.event,this.B(C.onDidChangeResourceEnablement(([te,B])=>this.F(te,B))),this.B((0,k.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,te])=>te.dispose())));for(const te of t.$Unb)C.isResourceEnabled(te)&&this.G(te)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new k.$Uc,C=v.add(this.createSynchronizer(S));v.add(C.onDidChangeStatus(()=>this.L())),v.add(C.onDidChangeConflicts(()=>this.M())),v.add(C.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([C,U,v])}H(S){const v=this.f.findIndex(([C])=>C.resource===S);if(v!==-1){const[[C,,U]]=this.f.splice(v,1);U.dispose(),this.L(),C.stop().then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(c.$pdc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance($.$mdc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$udc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$xdc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$wOb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$hdc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$ffc,this.profile,this.collection)}}async sync(S,v,C,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const j=[],H=(0,t.$3nb)(C),W=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(W):{};for(const G of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(v){const te=await G.preview(W,x,H);if(te)for(const B of te.resourcePreviews)(B.localChange!==t.Change.None||B.remoteChange!==t.Change.None)&&B.mergeState===t.MergeState.Preview&&await G.merge(B.previewResource)}else await G.sync(W,H)}catch(te){const B=t.$4nb.toUserDataSyncError(te);if(b(B,C,this.w,this.y),u(te))throw B;this.z.error(te),this.z.error(`${G.resource}: ${(0,A.$rj)(te)}`),j.push([G.resource,B])}}return j}finally{this.L()}}async apply(S,v){const C=(0,t.$3nb)(S);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,C)}catch(F){const j=t.$4nb.toUserDataSyncError(F);if(b(j,S,this.w,this.y),u(F))throw j;this.z.error(F),this.z.error(`${U.resource}: ${(0,A.$rj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,A.$rj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$Qnb),C=this.enabled.find(U=>U instanceof c.$pdc);if(C){const U=await C.getRemoteUserDataSyncConfiguration(S);return{...v,...U}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,R.$ub)(this.m,S,(v,C)=>v.syncResource===C.syncResource&&(0,R.$ub)(v.conflicts,C.conflicts,(U,F)=>(0,O.$ah)(U.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=Se([Q(2,t.$9nb),Q(3,l.$Fi),Q(4,f.$mp),Q(5,t.$Xnb),Q(6,E.$am),Q(7,t.$bob),Q(8,m.$Nl),Q(9,p.$aj)],o);function u(L){if(L instanceof t.$4nb)switch(L.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function b(L,S,v,C){C.publicLog2("sync/error",{code:L.code,serverCode:L instanceof t.$5nb?String(L.serverCode):void 0,url:L instanceof t.$5nb?L.url:void 0,resource:L.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(ue[234],de([0,1,3,2,9,19,24]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=e.$Gic=void 0;function k(f,d){return{...f,profile:(0,A.$Ol)(f.profile,d.profilesHome.scheme)}}function O(f){return{created:f.created,uri:N.URI.revive(f.uri)}}class y{constructor(d,l,g){this.c=d,this.d=l,this.f=g,this.a=new Map,this.b=new R.$me}listen(d,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(d,l,g){try{return await this.g(d,l,g)}catch(E){throw this.f.error(E),E}}async g(d,l,g){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(g[0]));case"accept":return this.c.accept(k(g[0],this.d),N.URI.revive(g[1]),g[2],g[3]);case"replace":return this.c.replace(O(g[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(g[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(g[0]),N.URI.revive(g[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),m=g[0],w=this.h(m);switch(g=g.slice(1),E){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h(d){const l=this.a.get(this.j(d));if(!l)throw new Error(`Manual sync taks not found: ${d}`);return l}async i(){const d=await this.c.createManualSyncTask();return this.a.set(this.j(d.id),d),d.id}j(d){return`manualSyncTask-${d}`}}e.$Gic=y;let I=class extends a.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(d,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new R.$me),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$me),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$me),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$me),this.onSyncErrors=this.m.event,this.a={call(g,E,m){return d.call(g,E,m).then(null,w=>{throw T.$4nb.toUserDataSyncError(w)})},listen(g,E){return d.listen(g,E)}},this.a.call("_getInitialData").then(([g,E,m])=>{this.s(g),this.t(E),m&&this.u(m),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.t(g))),this.B(this.a.listen("onSyncErrors")(g=>this.m.fire(g.map(E=>({...E,error:T.$4nb.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.a.call("createManualSyncTask"),l=this;return new p(d,{async call(E,m,w){return l.a.call(`manualSync/${E}`,[d,...Array.isArray(m)?m:[m]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(d,l,g,E){return this.a.call("accept",[d,l,g,E])}resolveContent(d){return this.a.call("resolveContent",[d])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(d){return this.a.call("replace",[d])}saveRemoteActivityData(d){return this.a.call("getRemoteActivityData",[d])}extractActivityData(d,l){return this.a.call("extractActivityData",[d,l])}async s(d){this.b=d,this.c.fire(d)}async t(d){this.f=d.map(l=>({syncResource:l.syncResource,profile:(0,A.$Ol)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(g=>({...g,baseResource:N.URI.revive(g.baseResource),localResource:N.URI.revive(g.localResource),remoteResource:N.URI.revive(g.remoteResource),previewResource:N.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}u(d){this.h!==d&&(this.h=d,this.j.fire(d))}};e.$Hic=I,e.$Hic=I=Se([Q(1,A.$Nl)],I);class p extends a.$Vc{constructor(d,l){super(),this.id=d,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ue[127],de([0,1,6,25,8,3,2,135,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mOb=e.$lOb=e.$kOb=e.$jOb=e.$iOb=void 0;const c="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends T.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get($.$7nb,P.StorageScope.APPLICATION)}set c(C){this.h.store($.$7nb,C,P.StorageScope.APPLICATION,O.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(C,U,F){super(),this.f=C,this.g=U,this.h=F,this.a=this.B(new A.$me),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const j=this.B(new T.$Uc);this.B(A.Event.filter(F.onDidChangeValue(P.StorageScope.APPLICATION,$.$7nb,j),()=>this.c!==this.userDataSyncStore?.type,j)(()=>this.j()))}j(){this.b=this.m(this.f[c]),this.a.fire()}m(C){if(C&&(C=O.$p&&C.web?{...C,...C.web}:C,(0,I.$fg)(C.url)&&(0,I.$hg)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(U=>Array.isArray(C.authenticationProviders[U].scopes)))){const U=C,F=!!U.canSwitch,j=U.url===U.insidersUrl?"insiders":"stable",H=(F?this.c:void 0)||j,W=H==="insiders"?U.insidersUrl:H==="stable"?U.stableUrl:U.url;return{url:p.URI.parse(W),type:H,defaultType:j,defaultUrl:p.URI.parse(U.url),stableUrl:p.URI.parse(U.stableUrl),insidersUrl:p.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:U.authenticationProviders[G].scopes}),x),[])}}}};e.$iOb=o,e.$iOb=o=Se([Q(0,E.$uk),Q(1,d.$aj),Q(2,P.$jq)],o);let u=class extends o{constructor(C,U,F){super(C,U,F);const j=this.h.get(h,P.StorageScope.APPLICATION);j&&(this.n=JSON.parse(j));const H=this.f[c];H?this.h.store(h,JSON.stringify(H),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(C){C!==this.c&&(this.c=C,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$jOb=u,e.$jOb=u=Se([Q(0,E.$uk),Q(1,d.$aj),Q(2,P.$jq)],u);let b=class extends T.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(C,U,F,j,H,W,x){super(),this.n=F,this.r=j,this.s=x,this.g=this.B(new A.$me),this.onTokenFailed=this.g.event,this.h=this.B(new A.$me),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$me),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(C),this.c=(0,w.$pq)(H,W,x).then(G=>{const te={"X-Client-Name":`${U.applicationName}${O.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(te["X-Client-Commit"]=U.commit),te}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,T.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(C,U){this.b={token:C,type:U}}t(C){this.a=C?(0,y.$hh)(C,"v1"):void 0}u(){const C=this.s.getNumber(i,P.StorageScope.APPLICATION);C&&Date.now()<C&&this.y(new Date(C))}y(C){this.j?.getTime()!==C?.getTime()&&(this.j=C,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,R.$th)(U=>(0,R.$Hh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$hh)(this.a,"collection").toString();C={...C},C["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:C},[],a.CancellationToken.None);return(await(0,m.$cq)(F))?.map(({id:j})=>j)||[]}async createCollection(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$hh)(this.a,"collection").toString();C={...C},C["Content-Type"]=k.$bt.text;const F=await this.D(U,{type:"POST",headers:C},[],a.CancellationToken.None),j=await(0,m.$bq)(F);if(!j)throw new $.$5nb("Server did not return the collection id",U,$.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[$.$1nb]);return j}async deleteCollection(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=C?(0,y.$hh)(this.a,"collection",C).toString():(0,y.$hh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(C,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,C),j={},H=await this.D(F.toString(),{type:"GET",headers:j},[],a.CancellationToken.None);return(await(0,m.$cq)(H)||[]).map(({url:x,created:G})=>({ref:(0,y.$jh)(F,F.with({path:x})),created:G*1e3}))}async resolveResourceContent(C,U,F,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const H=(0,y.$hh)(this.z(this.a,F,C),U).toString();j={...j},j["Cache-Control"]="no-cache";const W=await this.D(H,{type:"GET",headers:j},[],a.CancellationToken.None);return await(0,m.$bq)(W)}async deleteResource(C,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=U!==null?(0,y.$hh)(this.z(this.a,F,C),U).toString():this.z(this.a,F,C).toString(),H={};await this.D(j,{type:"DELETE",headers:H},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,y.$hh)(this.a,"resource").toString(),U={"Content-Type":k.$bt.text};await this.D(C,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(C,U,F,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const H=(0,y.$hh)(this.z(this.a,F,C),"latest").toString();j={...j},j["Cache-Control"]="no-cache",U&&(j["If-None-Match"]=U.ref);const W=await this.D(H,{type:"GET",headers:j},[304],a.CancellationToken.None);let x=null;if(W.res.statusCode===304&&(x=U),x===null){const G=W.res.headers.etag;if(!G)throw new $.$5nb("Server did not return the ref",H,$.UserDataSyncErrorCode.NoRef,W.res.statusCode,W.res.headers[$.$1nb]);const te=await(0,m.$bq)(W);if(!te&&W.res.statusCode===304)throw new $.$5nb("Empty response",H,$.UserDataSyncErrorCode.EmptyResponse,W.res.statusCode,W.res.headers[$.$1nb]);x={ref:G,content:te}}return x}async writeResource(C,U,F,j,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.z(this.a,j,C).toString();H={...H},H["Content-Type"]=k.$bt.text,F&&(H["If-Match"]=F);const x=await this.D(W,{type:"POST",data:U,headers:H},[],a.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new $.$5nb("Server did not return the ref",W,$.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[$.$1nb]);return G}async manifest(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,y.$hh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",C&&(U["If-None-Match"]=C.ref);const j=await this.D(F,{type:"GET",headers:U},[304],a.CancellationToken.None);let H=null;if(j.res.statusCode===304&&(H=C),!H){const x=j.res.headers.etag;if(!x)throw new $.$5nb("Server did not return the ref",F,$.UserDataSyncErrorCode.NoRef,j.res.statusCode,j.res.headers[$.$1nb]);const G=await(0,m.$bq)(j);if(!G&&j.res.statusCode===304)throw new $.$5nb("Empty response",F,$.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[$.$1nb]);G&&(H={...JSON.parse(G),ref:x})}const W=this.s.get(n,P.StorageScope.APPLICATION);return W&&H&&W!==H.session&&this.C(),H===null&&W&&this.C(),H&&this.s.store(n,H.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),H}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,y.$hh)(this.a,"download").toString(),U={},F=await this.D(C,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,m.$$p)(F))throw new $.$5nb("Server returned "+F.res.statusCode,C,$.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[$.$1nb]);if((0,m.$_p)(F))throw new $.$5nb("Empty response",C,$.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[$.$1nb]);return F.stream}z(C,U,F){return U?(0,y.$hh)(C,"collection",U,"resource",F):(0,y.$hh)(C,"resource",F)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(C,U,F,j){if(!this.b)throw new $.$5nb("No Auth Token Available",C,$.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new $.$5nb(`${U.type} request '${C}' failed because of too many requests (429).`,C,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const H=await this.c;U.headers={...U.headers||{},...H,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:C,type:U.type,headers:{...U.headers,authorization:void 0}});let W;try{W=await this.f.request(C,U,j)}catch(V){if(!(V instanceof $.$5nb)){let _=$.UserDataSyncErrorCode.RequestFailed;const ne=(0,N.$0)(V).toLowerCase();ne.includes("xhr timeout")?_=$.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=$.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=$.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=$.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$4)(V)&&(_=$.UserDataSyncErrorCode.RequestCanceled),V=new $.$5nb(`Connection refused for the request '${C}'.`,C,_,void 0,void 0)}throw this.r.info("Request failed",C),V}const x=W.res.headers[$.$1nb],G={url:C,status:W.res.statusCode,"execution-id":U.headers[$.$2nb],"operation-id":x},te=(0,m.$$p)(W)||W.res.statusCode&&F.includes(W.res.statusCode);let B="";if(te?this.r.trace("Request succeeded",G):(B=await(0,m.$aq)(W)||"",this.r.info("Request failed",G,B)),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire($.UserDataSyncErrorCode.Unauthorized),new $.$5nb(`${U.type} request '${C}' failed because of Unauthorized (401).`,C,$.UserDataSyncErrorCode.Unauthorized,W.res.statusCode,x);if(W.res.statusCode===403)throw this.g.fire($.UserDataSyncErrorCode.Forbidden),new $.$5nb(`${U.type} request '${C}' failed because the access is forbidden (403).`,C,$.UserDataSyncErrorCode.Forbidden,W.res.statusCode,x)}if(this.h.fire(),W.res.statusCode===404)throw new $.$5nb(`${U.type} request '${C}' failed because the requested resource is not found (404).`,C,$.UserDataSyncErrorCode.NotFound,W.res.statusCode,x);if(W.res.statusCode===405)throw new $.$5nb(`${U.type} request '${C}' failed because the requested endpoint is not found (405). ${B}`,C,$.UserDataSyncErrorCode.MethodNotFound,W.res.statusCode,x);if(W.res.statusCode===409)throw new $.$5nb(`${U.type} request '${C}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,C,$.UserDataSyncErrorCode.Conflict,W.res.statusCode,x);if(W.res.statusCode===410)throw new $.$5nb(`${U.type} request '${C}' failed because the requested resource is not longer available (410).`,C,$.UserDataSyncErrorCode.Gone,W.res.statusCode,x);if(W.res.statusCode===412)throw new $.$5nb(`${U.type} request '${C}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,C,$.UserDataSyncErrorCode.PreconditionFailed,W.res.statusCode,x);if(W.res.statusCode===413)throw new $.$5nb(`${U.type} request '${C}' failed because of too large payload (413).`,C,$.UserDataSyncErrorCode.TooLarge,W.res.statusCode,x);if(W.res.statusCode===426)throw new $.$5nb(`${U.type} request '${C}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,C,$.UserDataSyncErrorCode.UpgradeRequired,W.res.statusCode,x);if(W.res.statusCode===429){const V=W.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new $.$5nb(`${U.type} request '${C}' failed because of too many requests (429).`,C,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W.res.statusCode,x)):new $.$5nb(`${U.type} request '${C}' failed because of too many requests (429).`,C,$.UserDataSyncErrorCode.TooManyRequests,W.res.statusCode,x)}if(!te)throw new $.$5nb("Server returned "+W.res.statusCode,C,$.UserDataSyncErrorCode.Unknown,W.res.statusCode,x);return W}F(C){let U=this.s.get(t,P.StorageScope.APPLICATION);U===void 0&&(U=(0,f.$3g)(),this.s.store(t,U,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),C["X-Machine-Session-Id"]=U;const F=this.s.get(n,P.StorageScope.APPLICATION);F!==void 0&&(C["X-User-Session-Id"]=F)}};e.$kOb=b,e.$kOb=b=Se([Q(1,E.$uk),Q(2,m.$9p),Q(3,$.$bob),Q(4,l.$Ni),Q(5,g.$bl),Q(6,P.$jq)],b);let L=class extends b{constructor(C,U,F,j,H,W,x){super(C.userDataSyncStore?.url,U,F,j,H,W,x),this.B(C.onDidChangeUserDataSyncStore(()=>this.t(C.userDataSyncStore?.url)))}};e.$lOb=L,e.$lOb=L=Se([Q(0,$.$Xnb),Q(1,E.$uk),Q(2,m.$9p),Q(3,$.$bob),Q(4,l.$Ni),Q(5,g.$bl),Q(6,P.$jq)],L);class S{constructor(C,U,F,j){this.c=C,this.d=U,this.f=F,this.g=j,this.a=[],this.b=void 0}request(C,U,F){if(this.h()&&this.i(),U.url=C,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new $.$5nb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,C,$.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(C),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$mOb=S}),define(ue[235],de([0,1,3,2,9,21,23,16,127]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=e.$Eic=e.$Dic=e.$Cic=void 0;class y{constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(l,g,E){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$Cic=y;class I extends a.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new R.$me),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(g=>{this.a=g,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$Dic=I;class p{constructor(l){this.a=l}listen(l,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(l,g,E){switch(g){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Eic=p;let f=class extends O.$iOb{constructor(l,g,E,m){super(g,E,m),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:N.URI.revive(l.url),type:l.type,defaultUrl:N.URI.revive(l.defaultUrl),insidersUrl:N.URI.revive(l.insidersUrl),stableUrl:N.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Fic=f,e.$Fic=f=Se([Q(1,T.$uk),Q(2,A.$aj),Q(3,k.$jq)],f)}),define(ue[236],de([0,1,3,57,23,16,18,231,24,83,87]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let p=class extends k.$jfc{constructor(d,l,g,E,m,w,P,$,c,h,i){super(d,l,g,E,m,P,$,c,h,i),this.B(R.Event.debounce(R.Event.any(R.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$2ic=p,e.$2ic=p=Se([Q(0,N.$uk),Q(1,O.$Xnb),Q(2,O.$Ynb),Q(3,O.$9nb),Q(4,O.$0nb),Q(5,a.$Xgc),Q(6,O.$bob),Q(7,y.$KMb),Q(8,T.$am),Q(9,I.$Knb),Q(10,A.$jq)],p)}),define(ue[237],de([0,1,76,22,5,20]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0,e.$lgc=T,e.$mgc=k,e.$ngc=O,e.$kgc=128/4;function T(y){function I(){let p=y.scheme===a.Schemas.file?(0,A.$8g)(y):y.toString();return N.$l||(p=p.toLowerCase()),(0,R.createHash)("md5").update(p).digest("hex")}return{id:I(),configPath:y}}function k(y,I){function p(){if(y.scheme!==a.Schemas.file)return(0,R.createHash)("md5").update(y.toString()).digest("hex");if(!I)return;let d;return N.$l?d=I.ino:N.$k?d=I.birthtime.getTime():N.$j&&(typeof I.birthtimeMs=="number"?d=Math.floor(I.birthtimeMs):d=I.birthtime.getTime()),(0,R.createHash)("md5").update(y.fsPath).update(d?String(d):"").digest("hex")}const f=p();if(typeof f=="string")return{id:f,uri:y}}function O(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ue[238],de([0,1,6,8,2,13,30,15,10,80,116,237,57,56,22]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;let g=class extends N.$Vc{constructor(m,w,P,$){super(),this.a=m,this.b=w,this.c=P,this.f=$,this.B(new R.$Sh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const m=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await T.Promises.readdir(m),P=new y.$jNb(this.f.getChannel("storage"));await Promise.all(w.map(async $=>{const c=(0,A.$kc)(m,$);$.length===p.$kgc||$===I.$Si.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===$)||await P.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${$} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(m){(0,a.$Z)(m)}}};e.$yic=g,e.$yic=g=Se([Q(0,k.$Oi),Q(1,O.$bk),Q(2,f.$Xgc),Q(3,d.$dic)],g)}),define(ue[128],de([0,1,76,68,38,246,14,8,3,2,13,5,32,42,70]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=t,e.$zi=s,e.$Bi=u,e.$Ci=b;const g=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.$Z)(U)}},this.socket.on("error",this.a);let C;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,C&&clearTimeout(C)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,C=setTimeout(()=>S.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=C=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,C),S(T.$Oe.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=C=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,k.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,k.$Z)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$vi=E;var m;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class P extends y.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,C,U){super(),this.f=this.B(new O.$me),this.g=this.B(new O.$me),this.h=!1,this.j={state:w.PeekHeader,readLen:m.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new $(this,v,C,U,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,k.$Z)(F),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new l.$qi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+m.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=m.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let U=m.MinHeaderByteSize;S.byteLength<126?U+=0:S.byteLength<2**16?U+=2:U+=8;const F=T.$Oe.alloc(U),j=v?64:0,H=C&15;if(F.writeUInt8(128|j|H,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let W=1;F.writeUInt8(S.byteLength>>>8&255,++W),F.writeUInt8(S.byteLength>>>0&255,++W)}else{F.writeUInt8(127,1);let W=1;F.writeUInt8(0,++W),F.writeUInt8(0,++W),F.writeUInt8(0,++W),F.writeUInt8(0,++W),F.writeUInt8(S.byteLength>>>24&255,++W),F.writeUInt8(S.byteLength>>>16&255,++W),F.writeUInt8(S.byteLength>>>8&255,++W),F.writeUInt8(S.byteLength>>>0&255,++W)}this.socket.write(T.$Oe.concat([F,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),U=(C&128)>>>7,F=(C&64)>>>6,j=C&15,H=v.readUInt8(1),W=(H&128)>>>7,x=H&127;this.j.state=w.ReadHeader,this.j.readLen=m.MinHeaderByteSize+(W?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),U=(C&128)>>>7;let F=C&127,j=1;F===126?F=v.readUInt8(++j)*2**8+v.readUInt8(++j):F===127&&(F=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let H=0;U&&(H=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=w.ReadBody,this.j.readLen=F,this.j.mask=H,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=w.PeekHeader,this.j.readLen=m.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=P;class $ extends y.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(S,v,C,U,F,j){super(),this.n=S,this.r=F,this.s=j,this.a=this.B(new O.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new O.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new O.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new c(this.n,U,C,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(H=>this.a.fire(H))),this.B(this.f.onError(H=>this.a.fire(H)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,S);this.s(C,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((C,U)=>{S.write(v),S.flush(F=>C(F))})}acceptFrame(S,v,C){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,C){return new Promise((U,F)=>{S.write(v),C&&S.write(T.$Oe.fromByteArray([0,0,255,255])),S.flush(j=>U(j))})}}class c extends y.$Vc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(S,v,C,U){super(),this.h=S,this.j=v,this.a=this.B(new O.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(T.$Oe.wrap(F))}),C&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,S(v)})}}class h extends y.$Vc{constructor(S,v){super(),this.g=S,this.a=this.B(new O.$me),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,C),this.f.push(T.$Oe.wrap(C))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(L,S){if(S===0)return;const v=L.byteLength>>>2;for(let W=0;W<v;W++){const x=L.readUInt32BE(W*4);L.writeUInt32BE(x^S,W*4)}const C=v*4,U=L.byteLength-C,F=S>>>24&255,j=S>>>16&255,H=S>>>8&255;U>=1&&L.writeUInt8(L.readUInt8(C)^F,C),U>=2&&L.writeUInt8(L.readUInt8(C+1)^j,C+1),U>=3&&L.writeUInt8(L.readUInt8(C+2)^H,C+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const n={[p.Platform.Linux]:107,[p.Platform.Mac]:103};function t(){const L=(0,f.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const S=process.platform!=="darwin"&&e.$xi?e.$xi:(0,N.tmpdir)(),v=(0,I.$kc)(S,`vscode-ipc-${L}.sock`);return r(v),v}function s(L,S,v){const U=(0,R.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${S}-sock`;const F=v.substr(0,4),j=S.substr(0,6);let H;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?H=(0,I.$kc)(e.$xi,`vscode-${U}-${F}-${j}.sock`):H=(0,I.$kc)(L,`${F}-${j}.sock`),r(H),H}function r(L){const S=n[p.$v];typeof S=="number"&&L.length>=S&&console.warn(`WARNING: IPC handle "${L}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends d.$ki{static b(S){const v=O.Event.fromNodeEventEmitter(S,"connection");return O.Event.map(v,C=>({protocol:new l.$ri(new E(C,"ipc-server-connection")),onDidClientDisconnect:O.Event.once(O.Event.fromNodeEventEmitter(C,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=o;function u(L){return new Promise((S,v)=>{const C=(0,a.createServer)();C.on("error",v),C.listen(L,()=>{C.removeListener("error",v),S(new o(C))})})}function b(L,S){return new Promise((v,C)=>{const U=(0,a.createConnection)(L,()=>{U.removeListener("error",C),v(l.$si.fromSocket(new E(U,`ipc-client${S}`),S))});U.once("error",C)})}}),define(ue[239],de([0,1,68,128,186]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0,R=Oe(R),e.$5ic=new class{supports(A){return!0}connect({host:A,port:T},k,O,y){return new Promise((I,p)=>{const f=R.createConnection({host:A,port:T},()=>{f.removeListener("error",p),f.write((0,N.$Jxb)(k,O,y));const d=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",d),I(new a.$vi(f,y)))};f.on("data",d)});f.setNoDelay(!0),f.once("error",p)})}}}),define(ue[240],de([0,1,68,38,147,128,6,2,5,21,10,23,187,107,109,81,14]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0,R=Oe(R),a=Oe(a);async function m(h,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new w(h,i,n,t,s).waitForReady(),!(s&&N.$6g[s]||!N.$6g[r.tunnelLocalPort]));o--);return r}class w extends k.$Vc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=R.createServer(),this.c=new T.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,g.$Qw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,N.$7g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,g.$Ow)(this.tunnelRemoteHost)||(0,g.$Qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,f.$4l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof A.$vi?s.socket.destroy():s.end()}),s instanceof A.$vi?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Oe.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$7hc=w;let P=class extends g.$Tw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,g.$Rw)(i,this.t,O.OS,a.release())}F(i,n,t,s,r,o,u,b){const L=this.D(n,t);if(L)return++L.refcount,L.value;if((0,g.$Kw)(i))return this.G(i,n,t,r,o,u,b);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=m(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$8hc=P,e.$8hc=P=Se([Q(0,d.$Xl),Q(1,I.$bk),Q(2,l.$1l),Q(3,p.$uk),Q(4,y.$aj)],P);let $=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$9hc=$,e.$9hc=$=Se([Q(0,d.$Xl),Q(1,I.$bk),Q(2,l.$1l),Q(3,p.$uk),Q(4,y.$aj)],$);let c=class extends k.$Vc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,o,u,b,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this.a.has(i)){const S=new $(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,o,u,b,L)}};e.$0hc=c,e.$0hc=c=Se([Q(0,d.$Xl),Q(1,I.$bk),Q(2,p.$uk),Q(3,l.$1l),Q(4,y.$aj)],c)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(ue[247],de([0,1,38,43,8,2,22,9,17,3,42,152,180,181,190,172,238,163,164,21,185,98,197,99,192,15,119,224,27,111,188,118,75,7,174,175,74,4,171,77,79,200,10,176,103,23,61,16,110,18,112,113,114,48,203,86,115,24,83,230,235,213,87,229,233,234,127,62,228,214,109,196,81,240,191,204,28,205,5,206,165,183,182,85,219,19,52,179,58,227,202,215,108,232,220,11,177,102,225,218,193,159,57,178,236,222,56,226,107,105,239,157,194,145,134,144]),function(ce,e,R,a,N,A,T,k,O,y,I,p,f,d,l,g,E,m,w,P,$,c,h,i,n,t,s,r,o,u,b,L,S,v,C,U,F,j,H,W,x,G,te,B,V,_,ne,le,ee,X,K,q,D,J,oe,Y,Z,M,z,ie,ae,he,pe,be,Pe,ve,we,Ee,se,fe,me,Ie,ke,De,Te,Ne,Ue,Be,We,je,qe,ze,Ve,Le,re,ge,$e,ye,Ae,Ce,Me,xe,Je,Qe,Ge,_e,Ze,nt,at,Nt,Lt,Ct,Tt,Dt,Ut,Ft,yt,jt,vt,Mt,qt,Bt,ht,zt,Vt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,V=it(V);class Wt extends A.$Vc{constructor(Re){super(),this.f=Re,this.a=this.B(new p.$bY(this)),this.b=void 0,this.c=this.B(new y.$me),this.g()}g(){let Re=!1;const Fe=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,p.$cY)(process.parentPort,ht.$hhc.exit,Fe)}async init(){const Re=await this.h();(0,M.$Snb)(),Re.invokeFunction(Fe=>{const Ke=Fe.get(te.$bk),He=Fe.get(X.$am),et=Fe.get(ge.$Nl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke),this.n(He,et),this.B(et.onDidChangeProfiles(()=>this.n(He,et))),this.r(He,Ke)}),this.B((0,A.$Sc)(Re.createInstance(f.$uic,this.f.codeCachePath),Re.createInstance(d.$vic),Re.createInstance(E.$yic),Re.createInstance(g.$xic),Re.createInstance(l.$wic),Re.createInstance(Ge.$Vic),Re.createInstance(xe.$Nic)))}async h(){const Re=new W.$Ei,Fe={_serviceBrand:void 0,...V.default};Re.set(_.$uk,Fe);const Ke=new I.$oi(Ye=>Ye==="main"),He=new yt.$eic(this.a,Ke);Re.set(yt.$dic,He);const et=this.f.policiesData?new ye.$Khc(this.f.policiesData,He.getChannel("policy")):new Ae.$wo;Re.set(Ae.$uo,et);const Xe=new Bt.$0m(this.f.args,Fe);Re.set(t.$Oi,Xe);const ot=new B.$ws(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ye=>({...Ye,resource:k.URI.revive(Ye.resource)})),He.getChannel("logger"));Re.set(te.$ck,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(168,null)})),$t=this.B(new te.$jk(ft.getLevel())),tt=this.B(new Ze.$OR(ft,[$t]));Re.set(te.$bk,tt),this.b=this.B(new nt.$Xic(tt)),Re.set(nt.$Wic,this.b);const st=this.B(new C.$6q(tt));Re.set(v.$bl,st);const pt=this.B(new U.$wr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new Be.$Xs(st);Re.set(Ue.$Ll,dt);const rt=this.B(new Ce.$VR(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Re.set(ge.$Nl,rt);const wt=this.B(new je.$cic(T.Schemas.file,this.B(new qe.$xR(He.getChannel(qe.$wR),{pathCaseSensitive:We.$l})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new $.$Yo(rt.defaultProfile.settingsResource,st,et,tt));Re.set(P.$aj,ct);const bt=new jt.$4ic(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},He,Xe);Re.set(le.$jq,bt),this.B((0,A.$Tc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Lt.$gs(He.getChannel("request"));Re.set(ne.$9p,It),Re.set(m.$zic,new F.$Di(w.$Aic,void 0,!1)),Re.set(Ve.$3G,new F.$Di(ze.$Mic,void 0,!1));const Rt=new Dt.$gic(-1,He);Re.set(Tt.$Xgc,Rt),Re.set(i.$3o,new F.$Di(n.$4R,void 0,!0));const Ht=this.B(new fe.$Hhc(Rt)),Kt=new I.$oi(Ye=>Ht.getActiveClientId().then(mt=>Ye===mt));Re.set(S.$P7b,new Ct.$Zic(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Kp)(Fe,ct);if((0,J.$Fp)(Fe,Xe)){const Ye=new q.$Aec(tt,ot,Xe,Fe);if(lt.push(Ye),!(0,J.$Gp)(Fe,Xe)&&Fe.aiConfig?.ariaKey){const mt=new Me.$CR(It,Pt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,A.$Tc)(()=>mt.flush())),lt.push(mt)}gt=new D.$ks({appenders:lt,commonProperties:(0,ee.$wp)((0,R.release)(),(0,R.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Lp)(Xe)},ct,Fe)}else{gt=J.$Ap;const Ye=J.$Ep;lt.push(Ye)}this.a.registerChannel("telemetryAppender",new K.$mhc(lt)),Re.set(X.$am,gt);const Jt=new oe.$Bic(ct,gt,tt,ot,Xe,Fe);Re.set(X.$bm,Jt),Re.set($e.$Mq,new F.$Di(Nt.$NR,void 0,!0)),Re.set(Le.$Qq,new F.$Di(re.$Lhc,void 0,!0)),Re.set(u.$wq,new F.$Di(u.$yq,void 0,!0)),Re.set(L.$2q,new F.$Di(L.$3q,void 0,!0)),Re.set(o.$mp,new F.$Di(r.$sq,void 0,!0)),Re.set(o.$tp,new F.$Di(Ft.$3ic,void 0,!1)),Re.set(x.$cs,new F.$Di(G.$es,void 0,!1)),Re.set(c.$Um,new F.$Di(h.$5s,void 0,!1)),Re.set(z.$KMb,new F.$Di(z.$LMb,void 0,!0)),Re.set(M.$bob,new F.$Di(he.$kPb,void 0,!0)),Re.set(M.$aob,I.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),Re.set(o.$sp,new F.$Di(s.$IMb,void 0,!1)),Re.set(Z.$iPb,new F.$Di(Z.$jPb,void 0,!0)),Re.set(Y.$uw,new F.$Di(Y.$vw)),Re.set(M.$Xnb,new F.$Di(we.$jOb,void 0,!0)),Re.set(M.$Ynb,new F.$Di(we.$lOb,void 0,!0)),Re.set(pe.$Knb,new F.$Di(pe.$Mnb,void 0,!0)),Re.set(M.$Znb,new F.$Di(ie.$dfc,void 0,!1)),Re.set(M.$9nb,new F.$Di(be.$5ec,void 0,!0)),Re.set(M.$0nb,new F.$Di(Pe.$ifc,void 0,!1)),Re.set(Ee.$kNb,new F.$Di(se.$Iic,void 0,!0)),Re.set(M.$$nb,new F.$Di(Qe.$Zfc,void 0,!0)),Re.set(me.$1l,new F.$Di(Ie.$_hc,void 0,!1));const Ot=new vt.$Yl;return Re.set(vt.$Xl,Ot),Ot.register(Mt.RemoteConnectionType.WebSocket,qt.$5ic),Re.set(ke.$Jw,new F.$Di(De.$0hc)),Re.set(Te.$Jic,new F.$Di(Ne.$Lic)),Re.set(Je.$Oic,new F.$Di(at.$Yic)),new H.$zr(Re)}j(Re){const Fe=new b.$Aq(Re.get(o.$pp),()=>null);this.a.registerChannel("extensions",Fe);const Ke=I.ProxyChannel.fromService(Re.get(x.$cs),this.q);this.a.registerChannel("languagePacks",Ke);const He=I.ProxyChannel.fromService(Re.get(c.$Um),this.q);this.a.registerChannel("diagnostics",He);const et=new b.$Cq(Re.get(o.$tp));this.a.registerChannel("extensionTipsService",et);const Xe=I.ProxyChannel.fromService(Re.get(m.$zic),this.q);this.a.registerChannel("checksum",Xe);const ot=I.ProxyChannel.fromService(Re.get(Ve.$3G),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=I.ProxyChannel.fromService(Re.get(pe.$Knb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=I.ProxyChannel.fromService(Re.get(X.$bm),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ae.$Cic(Re.get(z.$KMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ae.$Eic(Re.get(M.$Xnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new ve.$Gic(Re.get(M.$0nb),Re.get(ge.$Nl),Re.get(te.$bk));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(j.$Fi).createInstance(Ut.$2ic));this.a.registerChannel("userDataAutoSync",I.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",I.ProxyChannel.fromService(Re.get(M.$$nb),this.q));const rt=I.ProxyChannel.fromService(Re.get(Te.$Jic),this.q);this.a.registerChannel(Te.$Kic,rt);const wt=I.ProxyChannel.fromService(Re.get(Je.$Oic),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",Fe=>(0,N.$Z)(Fe)),process.on("unhandledRejection",Fe=>(0,N.$Z)(Fe)),(0,N.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,a.$rj)(Fe,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,Fe){Re.publicLog2("profilesInfo",{count:Fe.profiles.length})}async r(Re,Fe){if(We.$l){const[Ke,He]=await Promise.all([(0,zt.$4g)(Fe.error.bind(Fe)),(0,Et.$VX)(Fe.error.bind(Fe))]),et=(0,Vt.$zX)(),Xe=(0,Et.$WX)(He,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:He,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$jhc.response)return!1;const Fe=(0,O.$Ob)(Re.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function St(ut){try{const Re=new Wt(ut);process.parentPort.postMessage(ht.$hhc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$hhc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Gt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Gt),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d4c4e690b9f1e70291da9a46c5c8ac5ebfbda81a/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
