/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/amdX","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function($e){for(var e=[],r=0,h=$e.length;r<h;r++)e[r]=ke[$e[r]];return e};define(ke[131],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.LoaderEventType=e.$S=e.$R=void 0,e.$R=!1,e.$S=!0;var r;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,T=new Map,O=new Map,b=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function k(w,a){const m=w.get(a.detail);m&&(m>=0||w.set(a.detail,m+a.timestamp))}let y=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(y=$e.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of y)switch(w.type){case r.BeginLoadingScript:c(R,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:k(R,w);break;case r.BeginInvokeFactory:c(T,w);break;case r.EndInvokeFactory:k(T,w);break;case r.NodeBeginNativeRequire:c(O,w);break;case r.NodeEndNativeRequire:k(O,w);break;case r.NodeBeginEvaluatingScript:c(b,w);break;case r.NodeEndEvaluatingScript:k(b,w);break}let u=0;O.forEach(w=>u+=w);function P(w){const a=[];return w.forEach((m,p)=>a.push([p,m])),a}return{amdLoad:P(R),amdInvoke:P(T),nodeRequire:P(O),nodeEval:P(b),nodeRequireTotal:u}}static toMarkdownTable(R,T){let O="";const b=[];return R.forEach((c,k)=>{b[k]=c.length}),T.forEach(c=>{c.forEach((k,y)=>{typeof k>"u"&&(k=c[y]="-");const u=k.toString().length;b[y]=Math.max(u,b[y])})}),R.forEach((c,k)=>{O+=`| ${c+" ".repeat(b[k]-c.toString().length)} `}),O+=`|
`,R.forEach((c,k)=>{O+=`| ${"-".repeat(b[k])} `}),O+=`|
`,T.forEach(c=>{c.forEach((k,y)=>{typeof k<"u"&&(O+=`| ${k+" ".repeat(b[y]-k.toString().length)} `)}),O+=`|
`}),O}}e.$T=h}),define(ke[132],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=r,e.$gb=h,e.$hb=C,e.$ib=R,e.$jb=T,e.$kb=O,e.$lb=b,e.$nb=k,e.$ob=y,e.$pb=u,e.$qb=P,e.$rb=w;function r(a,m){const p=h(a,m);if(p!==-1)return a[p]}function h(a,m,p=a.length-1){for(let f=p;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function C(a,m){const p=R(a,m);return p===-1?void 0:a[p]}function R(a,m,p=0,f=a.length){let i=p,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function T(a,m){const p=O(a,m);return p===a.length?void 0:a[p]}function O(a,m,p=0,f=a.length){let i=p,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function b(a,m,p=0,f=a.length){const i=O(a,m,p,f);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const p=R(this.e,m,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}e.$mb=c;function k(a,m){if(a.length===0)return;let p=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,p)>0&&(p=i)}return p}function y(a,m){if(a.length===0)return;let p=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,p)>=0&&(p=i)}return p}function u(a,m){return k(a,(p,f)=>-m(p,f))}function P(a,m){if(a.length===0)return-1;let p=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[p])>0&&(p=f)}return p}function w(a,m){for(const p of a){const f=m(p);if(f!==void 0)return f}}}),define(ke[26],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ke[78],Ie([1,0]),function($e,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=C,e.$e=R,e.$f=T;function h(b,c){const k=Object.create(null);for(const y of b){const u=c(y);let P=k[u];P||(P=k[u]=[]),P.push(y)}return k}function C(b,c){const k=[],y=[];for(const u of b)c.has(u)||k.push(u);for(const u of c)b.has(u)||y.push(u);return{removed:k,added:y}}function R(b,c){const k=[],y=[];for(const[u,P]of b)c.has(u)||k.push(P);for(const[u,P]of c)b.has(u)||y.push(P);return{removed:k,added:y}}function T(b,c){const k=new Set;for(const y of c)b.has(y)&&k.add(y);return k}class O{static{r=Symbol.toStringTag}constructor(c,k){this.b=k,this.a=new Map,this[r]="SetWithKey";for(const y of c)this.add(y)}get size(){return this.a.size}add(c){const k=this.b(c);return this.a.set(k,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,k){this.a.forEach(y=>c.call(k,y,y,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(ke[59],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=h,e.$_h=C,e.$ai=R;function r(T){return(O,b,c)=>{let k=null,y=null;if(typeof c.value=="function"?(k="value",y=c.value):typeof c.get=="function"&&(k="get",y=c.get),!y)throw new Error("not supported");c[k]=T(y,b)}}function h(T,O,b){let c=null,k=null;if(typeof b.value=="function"?(c="value",k=b.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(c="get",k=b.get),!k)throw new Error("not supported");const y=`$memoize$${O}`;b[c]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,u)}),this[y]}}function C(T,O,b){return r((c,k)=>{const y=`$debounce$${k}`,u=`$debounce$result$${k}`;return function(...P){this[u]||(this[u]=b?b():void 0),clearTimeout(this[y]),O&&(this[u]=O(this[u],...P),P=[this[u]]),this[y]=setTimeout(()=>{c.apply(this,P),this[u]=b?b():void 0},T)}})}function R(T,O,b){return r((c,k)=>{const y=`$throttle$timer$${k}`,u=`$throttle$result$${k}`,P=`$throttle$lastRun$${k}`,w=`$throttle$pending$${k}`;return function(...a){if(this[u]||(this[u]=b?b():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...a)),this[w])return;const m=this[P]+T;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0):(this[w]=!0,this[y]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0},m-Date.now()))}})}}),define(ke[13],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$W=e.$V=void 0,e.setUnexpectedErrorHandler=h,e.$Y=C,e.$Z=R,e.$1=T,e.$2=O,e.$3=b,e.$4=k,e.$6=u,e.$7=P,e.$8=w,e.$0=m;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$V=r,e.$W=new r;function h(o){e.$W.setUnexpectedErrorHandler(o)}function C(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(o){k(o)||e.$W.onUnexpectedError(o)}function T(o){k(o)||e.$W.onUnexpectedExternalError(o)}function O(o){if(o instanceof Error){const{name:n,message:d}=o,l=o.stacktrace||o.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function b(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const c="Canceled";function k(o){return o instanceof y?!0:o instanceof Error&&o.name===c&&o.message===c}class y extends Error{constructor(){super(c),this.name=this.message}}e.$5=y;function u(){const o=new Error(c);return o.name=o.message,o}function P(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function w(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=p;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const d=new s;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$cb=t}),define(ke[18],Ie([1,0,13,132]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=C,e.$tb=R,e.$ub=T,e.$vb=O,e.$wb=b,e.$xb=c,e.$yb=k,e.$zb=y,e.$Ab=u,e.$Bb=P,e.$Cb=w,e.$Db=a,e.$Eb=m,e.top=p,e.$Gb=f,e.$Hb=s,e.$Ib=t,e.$Jb=o,e.$Kb=n,e.$Lb=d,e.$Mb=l,e.$Nb=g,e.$Ob=E,e.$Pb=D,e.$Qb=S,e.$Rb=I,e.$Sb=A,e.$Tb=$,e.$Ub=v,e.$Vb=M,e.$Wb=N,e.$Xb=L,e.$Yb=F,e.$Zb=B,e.$1b=j,e.$2b=U,e.$3b=z,e.$4b=ee,e.$5b=V,e.$6b=_,e.$7b=ce,e.$0b=ge,e.$bc=ve;function C(ie,ae=0){return ie[ie.length-(1+ae)]}function R(ie){if(ie.length===0)throw new Error("Invalid tail call");return[ie.slice(0,ie.length-1),ie[ie.length-1]]}function T(ie,ae,se=(X,re)=>X===re){if(ie===ae)return!0;if(!ie||!ae||ie.length!==ae.length)return!1;for(let X=0,re=ie.length;X<re;X++)if(!se(ie[X],ae[X]))return!1;return!0}function O(ie,ae){const se=ie.length-1;ae<se&&(ie[ae]=ie[se]),ie.pop()}function b(ie,ae,se){return c(ie.length,X=>se(ie[X],ae))}function c(ie,ae){let se=0,X=ie-1;for(;se<=X;){const re=(se+X)/2|0,pe=ae(re);if(pe<0)se=re+1;else if(pe>0)X=re-1;else return re}return-(se+1)}function k(ie,ae,se){if(ie=ie|0,ie>=ae.length)throw new TypeError("invalid index");const X=ae[Math.floor(ae.length*Math.random())],re=[],pe=[],we=[];for(const Me of ae){const ze=se(Me,X);ze<0?re.push(Me):ze>0?pe.push(Me):we.push(Me)}return ie<re.length?k(ie,re,se):ie<re.length+we.length?we[0]:k(ie-(re.length+we.length),pe,se)}function y(ie,ae){const se=[];let X;for(const re of ie.slice(0).sort(ae))!X||ae(X[0],re)!==0?(X=[re],se.push(X)):X.push(re);return se}function*u(ie,ae){let se,X;for(const re of ie)X!==void 0&&ae(X,re)?se.push(re):(se&&(yield se),se=[re]),X=re;se&&(yield se)}function P(ie,ae){for(let se=0;se<=ie.length;se++)ae(se===0?void 0:ie[se-1],se===ie.length?void 0:ie[se])}function w(ie,ae){for(let se=0;se<ie.length;se++)ae(se===0?void 0:ie[se-1],ie[se],se+1===ie.length?void 0:ie[se+1])}function a(ie,ae,se){const X=[];function re(Me,ze,Ae){if(ze===0&&Ae.length===0)return;const De=X[X.length-1];De&&De.start+De.deleteCount===Me?(De.deleteCount+=ze,De.toInsert.push(...Ae)):X.push({start:Me,deleteCount:ze,toInsert:Ae})}let pe=0,we=0;for(;;){if(pe===ie.length){re(pe,0,ae.slice(we));break}if(we===ae.length){re(pe,ie.length-pe,[]);break}const Me=ie[pe],ze=ae[we],Ae=se(Me,ze);Ae===0?(pe+=1,we+=1):Ae<0?(re(pe,1,[]),pe+=1):Ae>0&&(re(pe,0,[ze]),we+=1)}return X}function m(ie,ae,se){const X=a(ie,ae,se),re=[],pe=[];for(const we of X)re.push(...ie.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:re,added:pe}}function p(ie,ae,se){if(se===0)return[];const X=ie.slice(0,se).sort(ae);return i(ie,ae,X,se,ie.length),X}function f(ie,ae,se,X,re){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Me=ie.length,ze=ie.slice(0,se).sort(ae);for(let Ae=se,De=Math.min(se+X,Me);Ae<Me;Ae=De,De=Math.min(De+X,Me)){if(Ae>se&&await new Promise(Ce=>setTimeout(Ce)),re&&re.isCancellationRequested)throw new r.$5;i(ie,ae,ze,Ae,De)}return ze})().then(pe,we)})}function i(ie,ae,se,X,re){for(const pe=se.length;X<re;X++){const we=ie[X];if(ae(we,se[pe-1])<0){se.pop();const Me=(0,h.$kb)(se,ze=>ae(we,ze)<0);se.splice(Me,0,we)}}}function s(ie){return ie.filter(ae=>!!ae)}function t(ie){let ae=0;for(let se=0;se<ie.length;se++)ie[se]&&(ie[ae]=ie[se],ae+=1);ie.length=ae}function o(ie,ae,se){ie.splice(se,0,ie.splice(ae,1)[0])}function n(ie){return!Array.isArray(ie)||ie.length===0}function d(ie){return Array.isArray(ie)&&ie.length>0}function l(ie,ae=se=>se){const se=new Set;return ie.filter(X=>{const re=ae(X);return se.has(re)?!1:(se.add(re),!0)})}function g(ie){const ae=new Set;return se=>{const X=ie(se);return ae.has(X)?!1:(ae.add(X),!0)}}function E(ie,ae){return ie.length>0?ie[0]:ae}function D(ie,ae){return ie.length>0?ie[ie.length-1]:ae}function S(ie,ae,se=(X,re)=>X===re){let X=0;for(let re=0,pe=Math.min(ie.length,ae.length);re<pe&&se(ie[re],ae[re]);re++)X++;return X}function I(ie,ae){let se=typeof ae=="number"?ie:0;typeof ae=="number"?se=ie:(se=0,ae=ie);const X=[];if(se<=ae)for(let re=se;re<ae;re++)X.push(re);else for(let re=se;re>ae;re--)X.push(re);return X}function A(ie,ae,se){return ie.reduce((X,re)=>(X[ae(re)]=se?se(re):re,X),Object.create(null))}function $(ie,ae){return ie.push(ae),()=>v(ie,ae)}function v(ie,ae){const se=ie.indexOf(ae);if(se>-1)return ie.splice(se,1),ae}function M(ie,ae,se){const X=ie.slice(0,ae),re=ie.slice(ae);return X.concat(se,re)}function N(ie,ae){let se;if(typeof ae=="number"){let X=ae;se=()=>{const re=Math.sin(X++)*179426549;return re-Math.floor(re)}}else se=Math.random;for(let X=ie.length-1;X>0;X-=1){const re=Math.floor(se()*(X+1)),pe=ie[X];ie[X]=ie[re],ie[re]=pe}}function L(ie,ae){const se=ie.indexOf(ae);se>-1&&(ie.splice(se,1),ie.unshift(ae))}function F(ie,ae){const se=ie.indexOf(ae);se>-1&&(ie.splice(se,1),ie.push(ae))}function B(ie,ae){for(const se of ae)ie.push(se)}function j(ie,ae){return Array.isArray(ie)?ie.map(ae):ae(ie)}function U(ie){return Array.isArray(ie)?ie:[ie]}function z(ie){return ie[Math.floor(Math.random()*ie.length)]}function ee(ie,ae,se){const X=W(ie,ae),re=ie.length,pe=se.length;ie.length=re+pe;for(let we=re-1;we>=X;we--)ie[we+pe]=ie[we];for(let we=0;we<pe;we++)ie[we+X]=se[we]}function V(ie,ae,se,X){const re=W(ie,ae);let pe=ie.splice(re,se);return pe===void 0&&(pe=[]),ee(ie,re,X),pe}function W(ie,ae){return ae<0?Math.max(ae+ie.length,0):Math.min(ae,ie.length)}var J;(function(ie){function ae(pe){return pe<0}ie.isLessThan=ae;function se(pe){return pe<=0}ie.isLessThanOrEqual=se;function X(pe){return pe>0}ie.isGreaterThan=X;function re(pe){return pe===0}ie.isNeitherLessOrGreaterThan=re,ie.greaterThan=1,ie.lessThan=-1,ie.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function _(ie,ae){return(se,X)=>ae(ie(se),ie(X))}function ce(...ie){return(ae,se)=>{for(const X of ie){const re=X(ae,se);if(!J.isNeitherLessOrGreaterThan(re))return re}return J.neitherLessOrGreaterThan}}const ne=(ie,ae)=>ie-ae;e.$8b=ne;const ye=(ie,ae)=>(0,e.$8b)(ie?1:0,ae?1:0);e.$9b=ye;function ge(ie){return(ae,se)=>-ie(ae,se)}class Y{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let se=this.c;for(;se<this.g.length&&ae(this.g[se]);)se++;const X=se===this.c?null:this.g.slice(this.c,se);return this.c=se,X}takeFromEndWhile(ae){let se=this.d;for(;se>=0&&ae(this.g[se]);)se--;const X=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const se=this.g.slice(this.c,this.c+ae);return this.c+=ae,se}}e.$$b=Y;class q{static{this.empty=new q(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(se=>(ae(se),!0))}toArray(){const ae=[];return this.iterate(se=>(ae.push(se),!0)),ae}filter(ae){return new q(se=>this.iterate(X=>ae(X)?se(X):!0))}map(ae){return new q(se=>this.iterate(X=>se(ae(X))))}some(ae){let se=!1;return this.iterate(X=>(se=ae(X),!se)),se}findFirst(ae){let se;return this.iterate(X=>ae(X)?(se=X,!1):!0),se}findLast(ae){let se;return this.iterate(X=>(ae(X)&&(se=X),!0)),se}findLastMaxBy(ae){let se,X=!0;return this.iterate(re=>((X||J.isGreaterThan(ae(re,se)))&&(X=!1,se=re),!0)),se}}e.$_b=q;class oe{constructor(ae){this.c=ae}static createSortPermutation(ae,se){const X=Array.from(ae.keys()).sort((re,pe)=>se(ae[re],ae[pe]));return new oe(X)}apply(ae){return ae.map((se,X)=>ae[this.c[X]])}inverse(){const ae=this.c.slice();for(let se=0;se<this.c.length;se++)ae[this.c[se]]=se;return new oe(ae)}}e.$ac=oe;async function ve(ie,ae){return(await Promise.all(ie.map(async(X,re)=>({element:X,ok:await ae(X,re)})))).find(X=>X.ok)?.element}}),define(ke[65],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$fd=C,e.$gd=R,e.$hd=T,e.$id=O,e.$jd=b;function h(c,k){if(!c)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}function C(c,k="Unreachable"){throw new Error(k)}function R(c,k="unexpected state"){if(!c)throw new r.$cb(`Assertion Failed: ${k}`)}function T(c){c||(0,r.$Z)(new r.$cb("Soft Assertion Failed"))}function O(c){if(!c()){debugger;c(),(0,r.$Z)(new r.$cb("Assertion Failed"))}}function b(c,k){let y=0;for(;y<c.length-1;){const u=c[y],P=c[y+1];if(!k(u,P))return!1;y++}return!0}});var Qn=this&&this.__createBinding||(Object.create?function($e,e,r,h){h===void 0&&(h=r);var C=Object.getOwnPropertyDescriptor(e,r);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty($e,h,C)}:function($e,e,r,h){h===void 0&&(h=r),$e[h]=e[r]}),Kn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),We=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var r in $e)r!=="default"&&Object.prototype.hasOwnProperty.call($e,r)&&Qn(e,$e,r);return Kn(e,$e),e};define(ke[177],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=C,e.$9c=R,e.$0c=T,e.$$c=O,e.$_c=b,e.$ad=c,r=We(r);const h=(P,w)=>P===w;e.$7c=h;function C(P=e.$7c){return(w,a)=>r.$ub(w,a,P)}function R(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function T(){return(P,w)=>P.equals(w)}function O(P,w,a){if(a!==void 0){const m=P;return m==null||w===void 0||w===null?w===m:a(m,w)}else{const m=P;return(p,f)=>p==null||f===void 0||f===null?f===p:m(p,f)}}function b(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let a=0;a<P.length;a++)if(!b(P[a],w[a]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=P,m=w,p=Object.keys(a),f=Object.keys(m),i=new Set(f);if(p.length!==f.length)return!1;for(const s of p)if(!i.has(s)||!b(a[s],m[s]))return!1;return!0}return!1}function c(P){return JSON.stringify(u(P))}let k=0;const y=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,a=Object.create(null);for(const m of Object.keys(w).sort())a[m]=u(w[m]);return a}else{let w=y.get(P);return w===void 0&&(w=k++,y.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(ke[79],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=r;function r(h,C){const R=this;let T=!1,O;return function(){if(T)return O;if(T=!0,C)try{O=h.apply(R,arguments)}finally{C()}else O=h.apply(R,arguments);return O}}}),define(ke[133],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=e.$tQ=void 0;class r{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$tQ=r,e.$uQ=new r("id#")}),define(ke[39],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=C;const R=Object.freeze([]);function T(){return R}h.empty=T;function*O(n){yield n}h.single=O;function b(n){return C(n)?n:O(n)}h.wrap=b;function c(n){return n||R}h.from=c;function*k(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=k;function y(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=y;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function P(n,d){let l=0;for(const g of n)if(d(g,l++))return!0;return!1}h.some=P;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*m(n,d){let l=0;for(const g of n)yield d(g,l++)}h.map=m;function*p(n,d){let l=0;for(const g of n)yield*d(g,l++)}h.flatMap=p;function*f(...n){for(const d of n)yield*d}h.concat=f;function i(n,d,l){let g=l;for(const E of n)g=d(g,E);return g}h.reduce=i;function*s(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=s;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const g=n[Symbol.iterator]();for(let E=0;E<d;E++){const D=g.next();if(D.done)return[l,h.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function o(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=o})(r||(e.Iterable=r={}))}),define(ke[178],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=T,e.$Yn=y,e.$Zn=u,e.$1n=P,e.$2n=w,e.$3n=a,e.$4n=m,e.$5n=p,e.$6n=f,e.$7n=i,e.$8n=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,o=!1){let n=0;const d=t.length;let l="",g=0,E=h.Unknown,D=r.None;function S(L){let F=0,B=0;for(;F<L;){const j=t.charCodeAt(n);if(j>=k._0&&j<=k._9)B=B*16+j-k._0;else if(j>=k.A&&j<=k.F)B=B*16+j-k.A+10;else if(j>=k.a&&j<=k.f)B=B*16+j-k.a+10;else break;n++,F++}return F<L&&(B=-1),B}function I(L){n=L,l="",g=0,E=h.Unknown,D=r.None}function A(){const L=n;if(t.charCodeAt(n)===k._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===k.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return D=r.UnexpectedEndOfNumber,t.substring(L,n);let F=n;if(n<t.length&&(t.charCodeAt(n)===k.E||t.charCodeAt(n)===k.e))if(n++,(n<t.length&&t.charCodeAt(n)===k.plus||t.charCodeAt(n)===k.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;F=n}else D=r.UnexpectedEndOfNumber;return t.substring(L,F)}function $(){let L="",F=n;for(;;){if(n>=d){L+=t.substring(F,n),D=r.UnexpectedEndOfString;break}const B=t.charCodeAt(n);if(B===k.doubleQuote){L+=t.substring(F,n),n++;break}if(B===k.backslash){if(L+=t.substring(F,n),n++,n>=d){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case k.doubleQuote:L+='"';break;case k.backslash:L+="\\";break;case k.slash:L+="/";break;case k.b:L+="\b";break;case k.f:L+="\f";break;case k.n:L+=`
`;break;case k.r:L+="\r";break;case k.t:L+="	";break;case k.u:{const U=S(4);U>=0?L+=String.fromCharCode(U):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}F=n;continue}if(B>=0&&B<=31)if(b(B)){L+=t.substring(F,n),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;n++}return L}function v(){if(l="",D=r.None,g=n,n>=d)return g=d,E=h.EOF;let L=t.charCodeAt(n);if(O(L)){do n++,l+=String.fromCharCode(L),L=t.charCodeAt(n);while(O(L));return E=h.Trivia}if(b(L))return n++,l+=String.fromCharCode(L),L===k.carriageReturn&&t.charCodeAt(n)===k.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(L){case k.openBrace:return n++,E=h.OpenBraceToken;case k.closeBrace:return n++,E=h.CloseBraceToken;case k.openBracket:return n++,E=h.OpenBracketToken;case k.closeBracket:return n++,E=h.CloseBracketToken;case k.colon:return n++,E=h.ColonToken;case k.comma:return n++,E=h.CommaToken;case k.doubleQuote:return n++,l=$(),E=h.StringLiteral;case k.slash:{const F=n-1;if(t.charCodeAt(n+1)===k.slash){for(n+=2;n<d&&!b(t.charCodeAt(n));)n++;return l=t.substring(F,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===k.asterisk){n+=2;const B=d-1;let j=!1;for(;n<B;){if(t.charCodeAt(n)===k.asterisk&&t.charCodeAt(n+1)===k.slash){n+=2,j=!0;break}n++}return j||(n++,D=r.UnexpectedEndOfComment),l=t.substring(F,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(L),n++,E=h.Unknown}case k.minus:if(l+=String.fromCharCode(L),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case k._0:case k._1:case k._2:case k._3:case k._4:case k._5:case k._6:case k._7:case k._8:case k._9:return l+=A(),E=h.NumericLiteral;default:for(;n<d&&M(L);)n++,L=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(L),n++,E=h.Unknown}}function M(L){if(O(L)||b(L))return!1;switch(L){case k.closeBrace:case k.closeBracket:case k.openBrace:case k.openBracket:case k.doubleQuote:case k.colon:case k.comma:case k.slash:return!1}return!0}function N(){let L;do L=v();while(L>=h.LineCommentTrivia&&L<=h.Trivia);return L}return{setPosition:I,getPosition:()=>n,scan:o?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>D}}function O(t){return t===k.space||t===k.tab||t===k.verticalTab||t===k.formFeed||t===k.nonBreakingSpace||t===k.ogham||t>=k.enQuad&&t<=k.zeroWidthSpace||t===k.narrowNoBreakSpace||t===k.mathematicalSpace||t===k.ideographicSpace||t===k.byteOrderMark}function b(t){return t===k.lineFeed||t===k.carriageReturn||t===k.lineSeparator||t===k.paragraphSeparator}function c(t){return t>=k._0&&t<=k._9}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function y(t,o){const n=[],d=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(S,I,A,$){g.value=S,g.offset=I,g.length=A,g.type=$,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(S,I)=>{if(o<=S)throw d;l=void 0,E=o>S,n.push("")},onObjectProperty:(S,I,A)=>{if(o<I||(D(S,I,A,"property"),n[n.length-1]=S,o<=I+A))throw d},onObjectEnd:(S,I)=>{if(o<=S)throw d;l=void 0,n.pop()},onArrayBegin:(S,I)=>{if(o<=S)throw d;l=void 0,n.push(0)},onArrayEnd:(S,I)=>{if(o<=S)throw d;l=void 0,n.pop()},onLiteralValue:(S,I,A)=>{if(o<I||(D(S,I,A,s(S)),o<=I+A))throw d},onSeparator:(S,I,A)=>{if(o<=I)throw d;if(S===":"&&l&&l.type==="property")l.colonOffset=I,E=!1,l=void 0;else if(S===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(S){if(S!==d)throw S}return{path:n,previousNode:l,isAtPropertyKey:E,matches:S=>{let I=0;for(let A=0;I<S.length&&A<n.length;A++)if(S[I]===n[A]||S[I]==="*")I++;else if(S[I]!=="**")return!1;return I===S.length}}}function u(t,o=[],n=R.DEFAULT){let d=null,l=[];const g=[];function E(S){Array.isArray(l)?l.push(S):d!==null&&(l[d]=S)}return i(t,{onObjectBegin:()=>{const S={};E(S),g.push(l),l=S,d=null},onObjectProperty:S=>{d=S},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const S=[];E(S),g.push(l),l=S,d=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(S,I,A)=>{o.push({error:S,offset:I,length:A})}},n),l[0]}function P(t,o=[],n=R.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){d.type==="property"&&(d.length=S-d.offset,d=d.parent)}function g(S){return d.children.push(S),S}i(t,{onObjectBegin:S=>{d=g({type:"object",offset:S,length:-1,parent:d,children:[]})},onObjectProperty:(S,I,A)=>{d=g({type:"property",offset:I,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:S,offset:I,length:A,parent:d})},onObjectEnd:(S,I)=>{d.length=S+I-d.offset,d=d.parent,l(S+I)},onArrayBegin:(S,I)=>{d=g({type:"array",offset:S,length:-1,parent:d,children:[]})},onArrayEnd:(S,I)=>{d.length=S+I-d.offset,d=d.parent,l(S+I)},onLiteralValue:(S,I,A)=>{g({type:s(S),offset:I,length:A,parent:d,value:S}),l(I+A)},onSeparator:(S,I,A)=>{d.type==="property"&&(S===":"?d.colonOffset=I:S===","&&l(I))},onError:(S,I,A)=>{o.push({error:S,offset:I,length:A})}},n);const D=d.children[0];return D&&delete D.parent,D}function w(t,o){if(!t)return;let n=t;for(const d of o)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===d){n=g.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(o[n.children[0].value]=m(d))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if(p(t,o,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=o;l++){const g=f(d[l],o,n);if(g)return g}return t}}function i(t,o,n=R.DEFAULT){const d=T(t,!1);function l(_){return _?()=>_(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(_){return _?ce=>_(ce,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(o.onObjectBegin),D=g(o.onObjectProperty),S=l(o.onObjectEnd),I=l(o.onArrayBegin),A=l(o.onArrayEnd),$=g(o.onLiteralValue),v=g(o.onSeparator),M=l(o.onComment),N=g(o.onError),L=n&&n.disallowComments,F=n&&n.allowTrailingComma;function B(){for(;;){const _=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:j(C.InvalidUnicode);break;case r.InvalidEscapeCharacter:j(C.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:j(C.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:L||j(C.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:j(C.UnexpectedEndOfString);break;case r.InvalidCharacter:j(C.InvalidCharacter);break}switch(_){case h.LineCommentTrivia:case h.BlockCommentTrivia:L?j(C.InvalidCommentToken):M();break;case h.Unknown:j(C.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return _}}}function j(_,ce=[],ne=[]){if(N(_),ce.length+ne.length>0){let ye=d.getToken();for(;ye!==h.EOF;){if(ce.indexOf(ye)!==-1){B();break}else if(ne.indexOf(ye)!==-1)break;ye=B()}}}function U(_){const ce=d.getTokenValue();return _?$(ce):D(ce),B(),!0}function z(){switch(d.getToken()){case h.NumericLiteral:{let _=0;try{_=JSON.parse(d.getTokenValue()),typeof _!="number"&&(j(C.InvalidNumberFormat),_=0)}catch{j(C.InvalidNumberFormat)}$(_);break}case h.NullKeyword:$(null);break;case h.TrueKeyword:$(!0);break;case h.FalseKeyword:$(!1);break;default:return!1}return B(),!0}function ee(){return d.getToken()!==h.StringLiteral?(j(C.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(U(!1),d.getToken()===h.ColonToken?(v(":"),B(),J()||j(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):j(C.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function V(){E(),B();let _=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(C.ValueExpected,[],[]),v(","),B(),d.getToken()===h.CloseBraceToken&&F)break}else _&&j(C.CommaExpected,[],[]);ee()||j(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),_=!0}return S(),d.getToken()!==h.CloseBraceToken?j(C.CloseBraceExpected,[h.CloseBraceToken],[]):B(),!0}function W(){I(),B();let _=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(C.ValueExpected,[],[]),v(","),B(),d.getToken()===h.CloseBracketToken&&F)break}else _&&j(C.CommaExpected,[],[]);J()||j(C.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),_=!0}return A(),d.getToken()!==h.CloseBracketToken?j(C.CloseBracketExpected,[h.CloseBracketToken],[]):B(),!0}function J(){switch(d.getToken()){case h.OpenBracketToken:return W();case h.OpenBraceToken:return V();case h.StringLiteral:return U(!0);default:return z()}}return B(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(j(C.ValueExpected,[],[]),!1):J()?(d.getToken()!==h.EOF&&j(C.EndOfFileExpected,[],[]),!0):(j(C.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[179],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=r;function r(R){let T=!1;const O=new Map,b=new Map;if(C(R,a=>{if(R===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const p=O.get(m);if(!p){const f={schemas:[a]};return O.set(m,f),b.set(a,f),!0}return p.schemas.push(a),b.set(a,p),T=!0,!1}),O.clear(),!T)return JSON.stringify(R);let k="$defs";for(;R.hasOwnProperty(k);)k+="_";const y=[];function u(a){return JSON.stringify(a,(m,p)=>{if(p!==a){const f=b.get(p);if(f&&f.schemas.length>1)return f.id||(f.id=`_${y.length}`,y.push(f.schemas[0])),{$ref:`#/${k}/${f.id}`}}return p})}const P=u(R),w=[];for(let a=0;a<y.length;a++)w.push(`"_${a}":${u(y[a])}`);return w.length?`${P.substring(0,P.length-1)},"${k}":{${w.join(",")}}}`:P}function h(R){return typeof R=="object"&&R!==null}function C(R,T){if(!R||typeof R!="object")return;const O=(...P)=>{for(const w of P)h(w)&&y.push(w)},b=(...P)=>{for(const w of P)if(h(w))for(const a in w){const m=w[a];h(m)&&y.push(m)}},c=(...P)=>{for(const w of P)if(Array.isArray(w))for(const a of w)h(a)&&y.push(a)},k=P=>{if(Array.isArray(P))for(const w of P)h(w)&&y.push(w);else h(P)&&y.push(P)},y=[R];let u=y.pop();for(;u;)T(u)&&(O(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),b(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),c(u.anyOf,u.allOf,u.oneOf,u.prefixItems),k(u.items)),u=y.pop()}}),define(ke[50],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class r{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=r}),define(ke[80],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const T=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=T}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const O=new r(R);if(this.a===r.Undefined)this.a=O,this.b=O;else if(T){const c=this.b;this.b=O,O.prev=c,c.next=O}else{const c=this.a;this.a=O,O.next=c,c.prev=O}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(O))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$6c=h}),define(ke[28],Ie([1,0]),function($e,e){"use strict";var r,h,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=T,e.$Ac=O,e.$Jc=s;function R(t,o,n){let d=t.get(o);return d===void 0&&(d=n,t.set(o,d)),d}function T(t){const o=[];return t.forEach((n,d)=>{o.push(`${d} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function O(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class b{constructor(o,n){this.uri=o,this.value=n}}function c(t){return Array.isArray(t)}class k{static{this.c=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof k)this.d=new Map(o.d),this.e=n??k.c;else if(c(o)){this.d=new Map,this.e=n??k.c;for(const[d,l]of o)this.set(d,l)}else this.d=new Map,this.e=o??k.c}set(o,n){return this.d.set(this.e(o),new b(o,n)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[d,l]of this.d)o(l.value,l.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Bc=k;class y{constructor(o,n){this[h]="ResourceSet",!o||typeof o=="function"?this.c=new k(o):(this.c=new k(n),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,n){this.c.forEach((d,l)=>o.call(n,l,l,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,n=u.None){const d=this.c.get(o);if(d)return n!==u.None&&this.m(d,n),d.value}set(o,n,d=u.None){let l=this.c.get(o);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:o,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(o,l),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this.c.get(o);if(n)return this.c.delete(o),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,n){const d=this.g;let l=this.d;for(;l;){if(n?o.bind(n)(l.value,l.key,this):o(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}values(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}entries(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const n=o.next,d=o.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}o.next=void 0,o.previous=void 0,this.g++}m(o,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this.d)return;const d=o.next,l=o.previous;o===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(n===u.AsNew){if(o===this.e)return;const d=o.next,l=o.previous;o===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((n,d)=>{o.push([d,n])}),o}fromJSON(o){this.clear();for(const[n,d]of o)this.set(n,d)}}e.$Dc=P;class w extends P{constructor(o,n=1){super(),this.n=o,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(o,n=1){super(o,n)}q(o){this.h(o)}set(o,n){return super.set(o,n),this.p(),this}}e.$Ec=a;class m extends w{constructor(o,n=1){super(o,n)}q(o){this.i(o)}set(o,n){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,n),this}}e.$Fc=m;class p{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let n=this.c.get(o)||0;return n===0?!1:(n--,n===0?this.c.delete(o):this.c.set(o,n),!0)}has(o){return this.c.has(o)}}e.$Gc=p;class f{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[n,d]of o)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(o,n){this.c.set(o,n),this.d.set(n,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const n=this.c.get(o);return n===void 0?!1:(this.c.delete(o),this.d.delete(n),!0)}forEach(o,n){this.c.forEach((d,l)=>{o.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=f;class i{constructor(){this.c=new Map}add(o,n){let d=this.c.get(o);d||(d=new Set,this.c.set(o,d)),d.add(n)}delete(o,n){const d=this.c.get(o);d&&(d.delete(n),d.size===0&&this.c.delete(o))}forEach(o,n){const d=this.c.get(o);d&&d.forEach(n)}get(o){const n=this.c.get(o);return n||new Set}}e.$Ic=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,d]of t)if(!o.has(n)||o.get(n)!==d)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(ke[3],Ie([1,0,18,78,28,79,39]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=k,e.$Mc=y,e.$Nc=u,e.$Oc=a,e.$Pc=m,e.$Qc=p,e.$Rc=f,e.$Sc=i,e.$Tc=s,e.$4c=I;const O=!1;let b=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let M=this.b.get(v);return M||(M={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,M)),M}trackDisposable(v){const M=this.c(v);M.source||(M.source=new Error().stack)}setParent(v,M){const N=this.c(v);N.parent=M}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,M){const N=M.get(v);if(N)return N;const L=v.parent?this.f(this.c(v.parent),M):v;return M.set(v,L),L}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,M){let N;if(M)N=M;else{const U=new Map,z=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,U).isSingleton);if(z.length===0)return;const ee=new Set(z.map(V=>V.value));if(N=z.filter(V=>!(V.parent&&ee.has(V.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function L(U){function z(V,W){for(;V.length>0&&W.some(J=>typeof J=="string"?J===V[0]:V[0].match(J));)V.shift()}const ee=U.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return z(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const F=new C.$Ic;for(const U of N){const z=L(U);for(let ee=0;ee<=z.length;ee++)F.add(z.slice(0,ee).join(`
`),U)}N.sort((0,r.$6b)(U=>U.idx,r.$8b));let B="",j=0;for(const U of N.slice(0,v)){j++;const z=L(U),ee=[];for(let V=0;V<z.length;V++){let W=z[V];W=`(shared with ${F.get(z.slice(0,V+1).join(`
`)).size}/${N.length} leaks) at ${W}`;const _=F.get(z.slice(0,V).join(`
`)),ce=(0,h.$c)([..._].map(ne=>L(ne)[V]),ne=>ne);delete ce[z[V]];for(const[ne,ye]of Object.entries(ce))ee.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${ne}`);ee.unshift(W)}B+=`


==================== Leaking disposable ${j}/${N.length}: ${U.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return N.length>v&&(B+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:B}}}e.$Kc=c;function k($){b=$}if(O){const $="__is_disposable_tracked__";k(new class{trackDisposable(v){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[$]||console.log(M)},3e3)}setParent(v,M){if(v&&v!==o.None)try{v[$]=!0}catch{}}markAsDisposed(v){if(v&&v!==o.None)try{v[$]=!0}catch{}}markAsSingleton(v){}})}function y($){return b?.trackDisposable($),$}function u($){b?.markAsDisposed($)}function P($,v){b?.setParent($,v)}function w($,v){if(b)for(const M of $)b.setParent(M,v)}function a($){return b?.markAsSingleton($),$}function m($){return typeof $=="object"&&$!==null&&typeof $.dispose=="function"&&$.dispose.length===0}function p($){if(T.Iterable.is($)){const v=[];for(const M of $)if(M)try{M.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}function f($){for(const v of $)m(v)&&v.dispose();return[]}function i(...$){const v=s(()=>p($));return w($,v),v}function s($){const v=y({dispose:(0,R.$db)(()=>{u(v),$()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Uc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,y(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=o;class n{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Wc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(v){let M=v;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,u(this))},this}}e.$Zc=g;class E{constructor(){this.a=new Map}acquire(v,...M){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...M)},this.a.set(v,N));const{object:L}=N,F=(0,R.$db)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:L,dispose:F}}}e.$1c=E;class D{constructor(v){this.a=v}async acquire(v,...M){const N=this.a.acquire(v,...M);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(L){throw N.dispose(),L}}}e.$2c=D;class S{constructor(v){this.object=v}dispose(){}}e.$3c=S;function I($){const v=new t;try{$(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,M,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,M)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const M=this.a.get(v);return this.a.delete(v),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=A}),function($e,e){typeof define=="function"&&define.amd?define(ke[180],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ie,ae){for(var se=0;se<ae.length;se++){var X=ae[se];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ie,X.key,X)}}function r(ie,ae,se){return ae&&e(ie.prototype,ae),se&&e(ie,se),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function h(ie,ae){if(ie){if(typeof ie=="string")return C(ie,ae);var se=Object.prototype.toString.call(ie).slice(8,-1);if(se==="Object"&&ie.constructor&&(se=ie.constructor.name),se==="Map"||se==="Set")return Array.from(ie);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return C(ie,ae)}}function C(ie,ae){(ae==null||ae>ie.length)&&(ae=ie.length);for(var se=0,X=new Array(ae);se<ae;se++)X[se]=ie[se];return X}function R(ie,ae){var se=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(se)return(se=se.call(ie)).next.bind(se);if(Array.isArray(ie)||(se=h(ie))||ae&&ie&&typeof ie.length=="number"){se&&(ie=se);var X=0;return function(){return X>=ie.length?{done:!0}:{done:!1,value:ie[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=T();function O(ie){$e.defaults=ie}var b=/[&<>"']/,c=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ae){return u[ae]};function w(ie,ae){if(ae){if(b.test(ie))return ie.replace(c,P)}else if(k.test(ie))return ie.replace(y,P);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ie){return ie.replace(a,function(ae,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var p=/(^|[^\[])\^/g;function f(ie,ae){ie=typeof ie=="string"?ie:ie.source,ae=ae||"";var se={replace:function(re,pe){return pe=pe.source||pe,pe=pe.replace(p,"$1"),ie=ie.replace(re,pe),se},getRegex:function(){return new RegExp(ie,ae)}};return se}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ie,ae,se){if(ie){var X;try{X=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ae&&!s.test(se)&&(se=g(ae,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var o={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(ie,ae){o[" "+ie]||(n.test(ie)?o[" "+ie]=ie+"/":o[" "+ie]=I(ie,"/",!0)),ie=o[" "+ie];var se=ie.indexOf(":")===-1;return ae.substring(0,2)==="//"?se?ae:ie.replace(d,"$1")+ae:ae.charAt(0)==="/"?se?ae:ie.replace(l,"$1")+ae:ie+ae}var E={exec:function(){}};function D(ie){for(var ae=1,se,X;ae<arguments.length;ae++){se=arguments[ae];for(X in se)Object.prototype.hasOwnProperty.call(se,X)&&(ie[X]=se[X])}return ie}function S(ie,ae){var se=ie.replace(/\|/g,function(pe,we,Me){for(var ze=!1,Ae=we;--Ae>=0&&Me[Ae]==="\\";)ze=!ze;return ze?"|":" |"}),X=se.split(/ \|/),re=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>ae)X.splice(ae);else for(;X.length<ae;)X.push("");for(;re<X.length;re++)X[re]=X[re].trim().replace(/\\\|/g,"|");return X}function I(ie,ae,se){var X=ie.length;if(X===0)return"";for(var re=0;re<X;){var pe=ie.charAt(X-re-1);if(pe===ae&&!se)re++;else if(pe!==ae&&se)re++;else break}return ie.slice(0,X-re)}function A(ie,ae){if(ie.indexOf(ae[1])===-1)return-1;for(var se=ie.length,X=0,re=0;re<se;re++)if(ie[re]==="\\")re++;else if(ie[re]===ae[0])X++;else if(ie[re]===ae[1]&&(X--,X<0))return re;return-1}function $(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(ie,ae){if(ae<1)return"";for(var se="";ae>1;)ae&1&&(se+=ie),ae>>=1,ie+=ie;return se+ie}function M(ie,ae,se,X){var re=ae.href,pe=ae.title?w(ae.title):null,we=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){X.state.inLink=!0;var Me={type:"link",raw:se,href:re,title:pe,text:we,tokens:X.inlineTokens(we)};return X.state.inLink=!1,Me}return{type:"image",raw:se,href:re,title:pe,text:w(we)}}function N(ie,ae){var se=ie.match(/^(\s+)(?:```)/);if(se===null)return ae;var X=se[1];return ae.split(`
`).map(function(re){var pe=re.match(/^\s+/);if(pe===null)return re;var we=pe[0];return we.length>=X.length?re.slice(X.length):re}).join(`
`)}var L=function(){function ie(se){this.options=se||$e.defaults}var ae=ie.prototype;return ae.space=function(X){var re=this.rules.block.newline.exec(X);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},ae.code=function(X){var re=this.rules.block.code.exec(X);if(re){var pe=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:I(pe,`
`)}}},ae.fences=function(X){var re=this.rules.block.fences.exec(X);if(re){var pe=re[0],we=N(pe,re[3]||"");return{type:"code",raw:pe,lang:re[2]?re[2].trim():re[2],text:we}}},ae.heading=function(X){var re=this.rules.block.heading.exec(X);if(re){var pe=re[2].trim();if(/#$/.test(pe)){var we=I(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ae.hr=function(X){var re=this.rules.block.hr.exec(X);if(re)return{type:"hr",raw:re[0]}},ae.blockquote=function(X){var re=this.rules.block.blockquote.exec(X);if(re){var pe=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ae.list=function(X){var re=this.rules.block.list.exec(X);if(re){var pe,we,Me,ze,Ae,De,Ce,H,G,Z,x,de,Ee=re[1].trim(),Te=Ee.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Te?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Te?Ee:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(de=!1,!(!(re=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=re[0],X=X.substring(pe.length),H=re[2].split(`
`,1)[0],G=X.split(`
`,1)[0],this.options.pedantic?(ze=2,x=H.trimLeft()):(ze=re[2].search(/[^ ]/),ze=ze>4?1:ze,x=H.slice(ze),ze+=re[1].length),De=!1,!H&&/^ *$/.test(G)&&(pe+=G+`
`,X=X.substring(G.length+1),de=!0),!de)for(var et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(Z=X.split(`
`,1)[0],H=Z,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(H)||rt.test(H)||et.test(H)||nt.test(X)));){if(H.search(/[^ ]/)>=ze||!H.trim())x+=`
`+H.slice(ze);else if(!De)x+=`
`+H;else break;!De&&!H.trim()&&(De=!0),pe+=Z+`
`,X=X.substring(Z.length+1)}He.loose||(Ce?He.loose=!0:/\n *\n *$/.test(pe)&&(Ce=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(x),we&&(Me=we[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!we,checked:Me,loose:!1,text:x}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(Ae=0;Ae<at;Ae++){this.lexer.state.top=!1,He.items[Ae].tokens=this.lexer.blockTokens(He.items[Ae].text,[]);var gt=He.items[Ae].tokens.filter(function(ct){return ct.type==="space"}),dt=gt.every(function(ct){for(var Pe=ct.raw.split(""),Be=0,Qe=R(Pe),Ne;!(Ne=Qe()).done;){var je=Ne.value;if(je===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&gt.length&&dt&&(He.loose=!0,He.items[Ae].loose=!0)}return He}},ae.html=function(X){var re=this.rules.block.html.exec(X);if(re){var pe={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},ae.def=function(X){var re=this.rules.block.def.exec(X);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var pe=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:re[0],href:re[2],title:re[3]}}},ae.table=function(X){var re=this.rules.block.table.exec(X);if(re){var pe={type:"table",header:S(re[1]).map(function(Ce){return{text:Ce}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=re[0];var we=pe.align.length,Me,ze,Ae,De;for(Me=0;Me<we;Me++)/^ *-+: *$/.test(pe.align[Me])?pe.align[Me]="right":/^ *:-+: *$/.test(pe.align[Me])?pe.align[Me]="center":/^ *:-+ *$/.test(pe.align[Me])?pe.align[Me]="left":pe.align[Me]=null;for(we=pe.rows.length,Me=0;Me<we;Me++)pe.rows[Me]=S(pe.rows[Me],pe.header.length).map(function(Ce){return{text:Ce}});for(we=pe.header.length,ze=0;ze<we;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for(we=pe.rows.length,ze=0;ze<we;ze++)for(De=pe.rows[ze],Ae=0;Ae<De.length;Ae++)De[Ae].tokens=this.lexer.inline(De[Ae].text);return pe}}},ae.lheading=function(X){var re=this.rules.block.lheading.exec(X);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},ae.paragraph=function(X){var re=this.rules.block.paragraph.exec(X);if(re){var pe=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:pe,tokens:this.lexer.inline(pe)}}},ae.text=function(X){var re=this.rules.block.text.exec(X);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},ae.escape=function(X){var re=this.rules.inline.escape.exec(X);if(re)return{type:"escape",raw:re[0],text:w(re[1])}},ae.tag=function(X){var re=this.rules.inline.tag.exec(X);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]):re[0]}},ae.link=function(X){var re=this.rules.inline.link.exec(X);if(re){var pe=re[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=I(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Me=A(re[2],"()");if(Me>-1){var ze=re[0].indexOf("!")===0?5:4,Ae=ze+re[1].length+Me;re[2]=re[2].substring(0,Me),re[0]=re[0].substring(0,Ae).trim(),re[3]=""}}var De=re[2],Ce="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);H&&(De=H[1],Ce=H[3])}else Ce=re[3]?re[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(pe)?De=De.slice(1):De=De.slice(1,-1)),M(re,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},ae.reflink=function(X,re){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=re[we.toLowerCase()],!we||!we.href){var Me=pe[0].charAt(0);return{type:"text",raw:Me,text:Me}}return M(pe,we,pe[0],this.lexer)}},ae.emStrong=function(X,re,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(X);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=we[1]||we[2]||"";if(!Me||Me&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=we[0].length-1,Ae,De,Ce=ze,H=0,G=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(G.lastIndex=0,re=re.slice(-1*X.length+ze);(we=G.exec(re))!=null;)if(Ae=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ae){if(De=Ae.length,we[3]||we[4]){Ce+=De;continue}else if((we[5]||we[6])&&ze%3&&!((ze+De)%3)){H+=De;continue}if(Ce-=De,!(Ce>0)){if(De=Math.min(De,De+Ce+H),Math.min(ze,De)%2){var Z=X.slice(1,ze+we.index+De);return{type:"em",raw:X.slice(0,ze+we.index+De+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var x=X.slice(2,ze+we.index+De-1);return{type:"strong",raw:X.slice(0,ze+we.index+De+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ae.codespan=function(X){var re=this.rules.inline.code.exec(X);if(re){var pe=re[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Me=/^ /.test(pe)&&/ $/.test(pe);return we&&Me&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:re[0],text:pe}}},ae.br=function(X){var re=this.rules.inline.br.exec(X);if(re)return{type:"br",raw:re[0]}},ae.del=function(X){var re=this.rules.inline.del.exec(X);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},ae.autolink=function(X,re){var pe=this.rules.inline.autolink.exec(X);if(pe){var we,Me;return pe[2]==="@"?(we=w(this.options.mangle?re(pe[1]):pe[1]),Me="mailto:"+we):(we=w(pe[1]),Me=we),{type:"link",raw:pe[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},ae.url=function(X,re){var pe;if(pe=this.rules.inline.url.exec(X)){var we,Me;if(pe[2]==="@")we=w(this.options.mangle?re(pe[0]):pe[0]),Me="mailto:"+we;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);we=w(pe[0]),pe[1]==="www."?Me="http://"+we:Me=we}return{type:"link",raw:pe[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},ae.inlineText=function(X,re){var pe=this.rules.inline.text.exec(X);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:we=w(this.options.smartypants?re(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},ie}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=f(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=f(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=f(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=f(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=f(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=f(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=D({},F),F.gfm=D({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=f(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=f(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=D({},F.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=f(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=f(F._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=f(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=f(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=f(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=f(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=f(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=f(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=f(B.reflink).replace("label",B._label).replace("ref",F._label).getRegex(),B.nolink=f(B.nolink).replace("ref",F._label).getRegex(),B.reflinkSearch=f(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=D({},B),B.pedantic=D({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=D({},B.normal,{escape:f(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=f(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=D({},B.gfm,{br:f(B.br).replace("{2,}","*").getRegex(),text:f(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ie){var ae="",se,X,re=ie.length;for(se=0;se<re;se++)X=ie.charCodeAt(se),Math.random()>.5&&(X="x"+X.toString(16)),ae+="&#"+X+";";return ae}var z=function(){function ie(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||$e.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:F.normal,inline:B.normal};this.options.pedantic?(X.block=F.pedantic,X.inline=B.pedantic):this.options.gfm&&(X.block=F.gfm,this.options.breaks?X.inline=B.breaks:X.inline=B.gfm),this.tokenizer.rules=X}ie.lex=function(X,re){var pe=new ie(re);return pe.lex(X)},ie.lexInline=function(X,re){var pe=new ie(re);return pe.inlineTokens(X)};var ae=ie.prototype;return ae.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},ae.blockTokens=function(X,re){var pe=this;re===void 0&&(re=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Ce,H,G){return H+"    ".repeat(G.length)});for(var we,Me,ze,Ae;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(we=Ce.call({lexer:pe},X,re))?(X=X.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.space(X)){X=X.substring(we.raw.length),we.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(we);continue}if(we=this.tokenizer.code(X)){X=X.substring(we.raw.length),Me=re[re.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):re.push(we);continue}if(we=this.tokenizer.fences(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.heading(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.hr(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.blockquote(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.list(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.html(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.def(X)){X=X.substring(we.raw.length),Me=re[re.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.lheading(X)){X=X.substring(we.raw.length),re.push(we);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,H=X.slice(1),G=void 0;pe.options.extensions.startBlock.forEach(function(Z){G=Z.call({lexer:this},H),typeof G=="number"&&G>=0&&(Ce=Math.min(Ce,G))}),Ce<1/0&&Ce>=0&&(ze=X.substring(0,Ce+1))}(),this.state.top&&(we=this.tokenizer.paragraph(ze))){Me=re[re.length-1],Ae&&Me.type==="paragraph"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):re.push(we),Ae=ze.length!==X.length,X=X.substring(we.raw.length);continue}if(we=this.tokenizer.text(X)){X=X.substring(we.raw.length),Me=re[re.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):re.push(we);continue}if(X){var De="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,re},ae.inline=function(X,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:X,tokens:re}),re},ae.inlineTokens=function(X,re){var pe=this;re===void 0&&(re=[]);var we,Me,ze,Ae=X,De,Ce,H;if(this.tokens.links){var G=Object.keys(this.tokens.links);if(G.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)G.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,De.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ce||(H=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(we=x.call({lexer:pe},X,re))?(X=X.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.escape(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.tag(X)){X=X.substring(we.raw.length),Me=re[re.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):re.push(we);continue}if(we=this.tokenizer.link(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(we.raw.length),Me=re[re.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):re.push(we);continue}if(we=this.tokenizer.emStrong(X,Ae,H)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.codespan(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.br(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.del(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.autolink(X,U)){X=X.substring(we.raw.length),re.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(X,U))){X=X.substring(we.raw.length),re.push(we);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,de=X.slice(1),Ee=void 0;pe.options.extensions.startInline.forEach(function(Te){Ee=Te.call({lexer:this},de),typeof Ee=="number"&&Ee>=0&&(x=Math.min(x,Ee))}),x<1/0&&x>=0&&(ze=X.substring(0,x+1))}(),we=this.tokenizer.inlineText(ze,j)){X=X.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(H=we.raw.slice(-1)),Ce=!0,Me=re[re.length-1],Me&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):re.push(we);continue}if(X){var Z="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return re},r(ie,null,[{key:"rules",get:function(){return{block:F,inline:B}}}]),ie}(),ee=function(){function ie(se){this.options=se||$e.defaults}var ae=ie.prototype;return ae.code=function(X,re,pe){var we=(re||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(X,we);Me!=null&&Me!==X&&(pe=!0,X=Me)}return X=X.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(pe?X:w(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:w(X,!0))+`</code></pre>
`},ae.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ae.html=function(X){return X},ae.heading=function(X,re,pe,we){if(this.options.headerIds){var Me=this.options.headerPrefix+we.slug(pe);return"<h"+re+' id="'+Me+'">'+X+"</h"+re+`>
`}return"<h"+re+">"+X+"</h"+re+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(X,re,pe){var we=re?"ol":"ul",Me=re&&pe!==1?' start="'+pe+'"':"";return"<"+we+Me+`>
`+X+"</"+we+`>
`},ae.listitem=function(X){return"<li>"+X+`</li>
`},ae.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(X){return"<p>"+X+`</p>
`},ae.table=function(X,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+re+`</table>
`},ae.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ae.tablecell=function(X,re){var pe=re.header?"th":"td",we=re.align?"<"+pe+' align="'+re.align+'">':"<"+pe+">";return we+X+("</"+pe+`>
`)},ae.strong=function(X){return"<strong>"+X+"</strong>"},ae.em=function(X){return"<em>"+X+"</em>"},ae.codespan=function(X){return"<code>"+X+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(X){return"<del>"+X+"</del>"},ae.link=function(X,re,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<a href="'+w(X)+'"';return re&&(we+=' title="'+re+'"'),we+=">"+pe+"</a>",we},ae.image=function(X,re,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<img src="'+X+'" alt="'+pe+'"';return re&&(we+=' title="'+re+'"'),we+=this.options.xhtml?"/>":">",we},ae.text=function(X){return X},ie}(),V=function(){function ie(){}var ae=ie.prototype;return ae.strong=function(X){return X},ae.em=function(X){return X},ae.codespan=function(X){return X},ae.del=function(X){return X},ae.html=function(X){return X},ae.text=function(X){return X},ae.link=function(X,re,pe){return""+pe},ae.image=function(X,re,pe){return""+pe},ae.br=function(){return""},ie}(),W=function(){function ie(){this.seen={}}var ae=ie.prototype;return ae.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(X,re){var pe=X,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[X];do we++,pe=X+"-"+we;while(this.seen.hasOwnProperty(pe))}return re||(this.seen[X]=we,this.seen[pe]=0),pe},ae.slug=function(X,re){re===void 0&&(re={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,re.dryrun)},ie}(),J=function(){function ie(se){this.options=se||$e.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new W}ie.parse=function(X,re){var pe=new ie(re);return pe.parse(X)},ie.parseInline=function(X,re){var pe=new ie(re);return pe.parseInline(X)};var ae=ie.prototype;return ae.parse=function(X,re){re===void 0&&(re=!0);var pe="",we,Me,ze,Ae,De,Ce,H,G,Z,x,de,Ee,Te,He,Ke,et,nt,st,rt,at=X.length;for(we=0;we<at;we++){if(x=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(rt=this.options.extensions.renderers[x.type].call({parser:this},x),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=rt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,m(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(G="",H="",Ae=x.header.length,Me=0;Me<Ae;Me++)H+=this.renderer.tablecell(this.parseInline(x.header[Me].tokens),{header:!0,align:x.align[Me]});for(G+=this.renderer.tablerow(H),Z="",Ae=x.rows.length,Me=0;Me<Ae;Me++){for(Ce=x.rows[Me],H="",De=Ce.length,ze=0;ze<De;ze++)H+=this.renderer.tablecell(this.parseInline(Ce[ze].tokens),{header:!1,align:x.align[ze]});Z+=this.renderer.tablerow(H)}pe+=this.renderer.table(G,Z);continue}case"blockquote":{Z=this.parse(x.tokens),pe+=this.renderer.blockquote(Z);continue}case"list":{for(de=x.ordered,Ee=x.start,Te=x.loose,Ae=x.items.length,Z="",Me=0;Me<Ae;Me++)Ke=x.items[Me],et=Ke.checked,nt=Ke.task,He="",Ke.task&&(st=this.renderer.checkbox(et),Te?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=st+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=st+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(Ke.tokens,Te),Z+=this.renderer.listitem(He,nt,et);pe+=this.renderer.list(Z,de,Ee);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Z=x.tokens?this.parseInline(x.tokens):x.text;we+1<at&&X[we+1].type==="text";)x=X[++we],Z+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=re?this.renderer.paragraph(Z):Z;continue}default:{var gt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return pe},ae.parseInline=function(X,re){re=re||this.renderer;var pe="",we,Me,ze,Ae=X.length;for(we=0;we<Ae;we++){if(Me=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ze=this.options.extensions.renderers[Me.type].call({parser:this},Me),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){pe+=ze||"";continue}switch(Me.type){case"escape":{pe+=re.text(Me.text);break}case"html":{pe+=re.html(Me.text);break}case"link":{pe+=re.link(Me.href,Me.title,this.parseInline(Me.tokens,re));break}case"image":{pe+=re.image(Me.href,Me.title,Me.text);break}case"strong":{pe+=re.strong(this.parseInline(Me.tokens,re));break}case"em":{pe+=re.em(this.parseInline(Me.tokens,re));break}case"codespan":{pe+=re.codespan(Me.text);break}case"br":{pe+=re.br();break}case"del":{pe+=re.del(this.parseInline(Me.tokens,re));break}case"text":{pe+=re.text(Me.text);break}default:{var De='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return pe},ie}();function _(ie,ae,se){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ae=="function"&&(se=ae,ae=null),ae=D({},_.defaults,ae||{}),$(ae),se){var X=ae.highlight,re;try{re=z.lex(ie,ae)}catch(Ae){return se(Ae)}var pe=function(De){var Ce;if(!De)try{ae.walkTokens&&_.walkTokens(re,ae.walkTokens),Ce=J.parse(re,ae)}catch(H){De=H}return ae.highlight=X,De?se(De):se(null,Ce)};if(!X||X.length<3||(delete ae.highlight,!re.length))return pe();var we=0;_.walkTokens(re,function(Ae){Ae.type==="code"&&(we++,setTimeout(function(){X(Ae.text,Ae.lang,function(De,Ce){if(De)return pe(De);Ce!=null&&Ce!==Ae.text&&(Ae.text=Ce,Ae.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Me(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Ae.message+"",!0)+"</pre>";throw Ae}try{var ze=z.lex(ie,ae);if(ae.walkTokens){if(ae.async)return Promise.all(_.walkTokens(ze,ae.walkTokens)).then(function(){return J.parse(ze,ae)}).catch(Me);_.walkTokens(ze,ae.walkTokens)}return J.parse(ze,ae)}catch(Ae){Me(Ae)}}_.options=_.setOptions=function(ie){return D(_.defaults,ie),O(_.defaults),_},_.getDefaults=T,_.defaults=$e.defaults,_.use=function(){for(var ie=arguments.length,ae=new Array(ie),se=0;se<ie;se++)ae[se]=arguments[se];var X=D.apply(void 0,[{}].concat(ae)),re=_.defaults.extensions||{renderers:{},childTokens:{}},pe;ae.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ae=re.renderers?re.renderers[ze.name]:null;Ae?re.renderers[ze.name]=function(){for(var De=arguments.length,Ce=new Array(De),H=0;H<De;H++)Ce[H]=arguments[H];var G=ze.renderer.apply(this,Ce);return G===!1&&(G=Ae.apply(this,Ce)),G}:re.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[ze.level]?re[ze.level].unshift(ze.tokenizer):re[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?re.startBlock?re.startBlock.push(ze.start):re.startBlock=[ze.start]:ze.level==="inline"&&(re.startInline?re.startInline.push(ze.start):re.startInline=[ze.start]))}ze.childTokens&&(re.childTokens[ze.name]=ze.childTokens)})),we.renderer&&function(){var ze=_.defaults.renderer||new ee,Ae=function(H){var G=ze[H];ze[H]=function(){for(var Z=arguments.length,x=new Array(Z),de=0;de<Z;de++)x[de]=arguments[de];var Ee=we.renderer[H].apply(ze,x);return Ee===!1&&(Ee=G.apply(ze,x)),Ee}};for(var De in we.renderer)Ae(De);X.renderer=ze}(),we.tokenizer&&function(){var ze=_.defaults.tokenizer||new L,Ae=function(H){var G=ze[H];ze[H]=function(){for(var Z=arguments.length,x=new Array(Z),de=0;de<Z;de++)x[de]=arguments[de];var Ee=we.tokenizer[H].apply(ze,x);return Ee===!1&&(Ee=G.apply(ze,x)),Ee}};for(var De in we.tokenizer)Ae(De);X.tokenizer=ze}(),we.walkTokens){var Me=_.defaults.walkTokens;X.walkTokens=function(ze){var Ae=[];return Ae.push(we.walkTokens.call(this,ze)),Me&&(Ae=Ae.concat(Me.call(this,ze))),Ae}}pe&&(X.extensions=re),_.setOptions(X)})},_.walkTokens=function(ie,ae){for(var se=[],X=function(){var Me=pe.value;switch(se=se.concat(ae.call(_,Me)),Me.type){case"table":{for(var ze=R(Me.header),Ae;!(Ae=ze()).done;){var De=Ae.value;se=se.concat(_.walkTokens(De.tokens,ae))}for(var Ce=R(Me.rows),H;!(H=Ce()).done;)for(var G=H.value,Z=R(G),x;!(x=Z()).done;){var de=x.value;se=se.concat(_.walkTokens(de.tokens,ae))}break}case"list":{se=se.concat(_.walkTokens(Me.items,ae));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Me.type]?_.defaults.extensions.childTokens[Me.type].forEach(function(Ee){se=se.concat(_.walkTokens(Me[Ee],ae))}):Me.tokens&&(se=se.concat(_.walkTokens(Me.tokens,ae)))}},re=R(ie),pe;!(pe=re()).done;)X();return se},_.parseInline=function(ie,ae){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ae=D({},_.defaults,ae||{}),$(ae);try{var se=z.lexInline(ie,ae);return ae.walkTokens&&_.walkTokens(se,ae.walkTokens),J.parseInline(se,ae)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(X.message+"",!0)+"</pre>";throw X}},_.Parser=J,_.parser=J.parse,_.Renderer=ee,_.TextRenderer=V,_.Lexer=z,_.lexer=z.lex,_.Tokenizer=L,_.Slugger=W,_.parse=_;var ce=_.options,ne=_.setOptions,ye=_.use,ge=_.walkTokens,Y=_.parseInline,q=_,oe=J.parse,ve=z.lex;$e.Lexer=z,$e.Parser=J,$e.Renderer=ee,$e.Slugger=W,$e.TextRenderer=V,$e.Tokenizer=L,$e.getDefaults=T,$e.lexer=ve,$e.marked=_,$e.options=ce,$e.parse=q,$e.parseInline=Y,$e.parser=oe,$e.setOptions=ne,$e.use=ye,$e.walkTokens=ge,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[40],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ke[181],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=r;function r(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const C=new Uint32Array(10);function R(a){if(h=0,T(a,y,b.InitialConsonant),h>0||(T(a,u,b.Vowel),h>0)||(T(a,P,b.FinalConsonant),h>0)||(T(a,w,b.CompatibilityJamo),h))return C.subarray(0,h);if(a>=44032&&a<=55203){const m=a-44032,p=m%588,f=Math.floor(m/588),i=Math.floor(p/28),s=p%28-1;if(f<y.length?T(f,y,0):b.InitialConsonant+f-b.CompatibilityJamo<w.length&&T(b.InitialConsonant+f,w,b.CompatibilityJamo),i<u.length?T(i,u,0):b.Vowel+i-b.CompatibilityJamo<w.length&&T(b.Vowel+i-b.CompatibilityJamo,w,b.CompatibilityJamo),s>=0&&(s<P.length?T(s,P,0):b.FinalConsonant+s-b.CompatibilityJamo<w.length&&T(b.FinalConsonant+s-b.CompatibilityJamo,w,b.CompatibilityJamo)),h>0)return C.subarray(0,h)}}function T(a,m,p){a>=p&&a<p+m.length&&O(m[a-p])}function O(a){a!==c.NUL&&(C[h++]=a&255,a>>8&&(C[h++]=a>>8&255),a>>16&&(C[h++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var k;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(k||(k={}));const y=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,k.hk,k.ho,k.hl,c.y,c.n,k.nj,k.np,k.nl,c.b,c.m,k.ml,c.l]),P=new Uint16Array([c.r,c.R,k.rt,c.s,k.sw,k.sg,c.e,c.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,c.a,c.q,k.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,k.rt,c.s,k.sw,k.sg,c.e,c.E,c.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,c.a,c.q,c.Q,k.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,k.hk,k.ho,k.hl,c.y,c.n,k.nj,k.np,k.nl,c.b,c.m,k.ml,c.l])}),define(ke[81],Ie([1,0,28]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0,e.$om=C,e.$pm=T;const h=new r.$Ec(1e4);function C(c){return b(c,"NFC",h)}const R=new r.$Ec(1e4);function T(c){return b(c,"NFD",R)}const O=/[^\u0000-\u0080]/;function b(c,k,y){if(!c)return c;const u=y.get(c);if(u)return u;let P;return O.test(c)?P=c.normalize(k):P=c,y.set(c,P),P}e.$qm=function(){const c=/[\u0300-\u036f]/g;return function(k){return T(k).replace(c,"")}}()}),define(ke[134],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0,e.$Mm=r,e.rot=h,e.$Rm=O;function r(b,c,k){return Math.min(Math.max(b,c),k)}function h(b,c){return(c+b%c)%c}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Om=C;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pm=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const k=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Qm=T;function O(b,c,k,y,u,P,w,a){const m=w-k,p=a-y,f=u-k,i=P-y,s=b-k,t=c-y,o=m*m+p*p,n=m*f+p*i,d=m*s+p*t,l=f*f+i*i,g=f*s+i*t,E=1/(o*l-n*n),D=(l*d-n*g)*E,S=(o*g-n*d)*E;return D>=0&&S>=0&&D+S<1}}),define(ke[182],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=u;class r{constructor(w,a,m){this.owner=w,this.debugNameSource=a,this.referenceFn=m}getDebugName(w){return R(w,this)}}e.$bd=r;const h=new Map,C=new WeakMap;function R(P,w){const a=C.get(P);if(a)return a;const m=T(P,w);if(m){let p=h.get(m)??0;p++,h.set(m,p);const f=p===1?m:`${m}#${p}`;return C.set(P,f),f}}function T(P,w){const a=C.get(P);if(a)return a;const m=w.owner?k(w.owner)+".":"";let p;const f=w.debugNameSource;if(f!==void 0)if(typeof f=="function"){if(p=f(),p!==void 0)return m+p}else return m+f;const i=w.referenceFn;if(i!==void 0&&(p=u(i),p!==void 0))return m+p;if(w.owner!==void 0){const s=O(w.owner,P);if(s!==void 0)return m+s}}function O(P,w){for(const a in P)if(P[a]===w)return a}const b=new Map,c=new WeakMap;function k(P){const w=c.get(P);if(w)return w;const a=y(P);let m=b.get(a)??0;m++,b.set(a,m);const p=m===1?a:`${a}#${m}`;return c.set(P,p),p}function y(P){const w=P.constructor;return w?w.name:"Object"}function u(P){const w=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(ke[183],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=h,e.$Md=C;let r;function h(a){r=a}function C(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(m){return T([O(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[O(" "),c(k(m.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),c(k(m.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),c(k(m.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(m,p){console.log(...this.b([b("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c(p)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map(p=>p.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const p=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),p.apply(m,[f,i]))}handleDerivedRecomputed(m,p){const f=this.d.get(m);console.log(...this.b([b("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c(p),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,p){console.log(...this.b([b("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c(p),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const p=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),p.apply(m,[f,i]))}handleAutorunTriggered(m){const p=this.d.get(m);console.log(...this.b([b("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),p.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let p=m.getDebugName();p===void 0&&(p=""),console.log(...this.b([b("transaction"),c(p,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=R;function T(a){const m=new Array,p=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&p.push(...t.data)):"data"in t&&p.push(...t.data)}i(a);const s=[f,...m];return s.push(...p),s}function O(a){return c(a,{color:"black"})}function b(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,m={color:"black"}){function p(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:p(f)}}function k(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?y(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function y(a,m){let p="[ ",f=!0;for(const i of a){if(f||(p+=", "),p.length-5>m){p+="...";break}f=!1,p+=`${k(i,m-p.length)}`}return p+=" ]",p}function u(a,m){let p="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||(p+=", "),p.length-5>m){p+="...";break}f=!1,p+=`${i}: ${k(s,m-p.length)}`}return p+=" }",p}function P(a,m){let p="";for(let f=1;f<=m;f++)p+=a;return p}function w(a,m){for(;a.length<m;)a+=" ";return a}}),define(ke[184],Ie([1,0,177,182,183]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=T,e.$Xd=b,e.$Yd=k,e.$2d=P,e.$3d=a,e.$4d=m,e.$5d=p,e.$7d=i,e.$9d=t;let R;function T(n){R=n}let O;function b(n){O=n}let c;function k(n){c=n}class y{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const g=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:g,debugName:()=>{const D=(0,h.$dd)(E);if(D!==void 0)return D;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(I)return`${this.debugName}.${I[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,l){return d.add(R(this,l)),this}keepObserved(d){return d.add(O(this)),this}get a(){return this.get()}}e.$Zd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function P(n,d){const l=new f(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new f(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function m(n,d){const l=new f(n,d);try{await n(l)}finally{l.finish()}}function p(n,d,l){n?d(n):P(d,l)}class f{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,C.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$dd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:g,observable:E}=d[l];g.endUpdate(E)}this.a=null,(0,C.$Md)()?.handleEndTransaction()}}e.$6d=f;function i(n,d){let l;return typeof n=="string"?l=new h.$bd(void 0,n,void 0):l=new h.$bd(n,void 0,void 0),new s(l,d,r.$7c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,g){super(),this.e=d,this.g=g,this.d=l}get(){return this.d}set(d,l,g){if(g===void 0&&this.g(this.d,d))return;let E;l||(l=E=new f(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,C.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:g,didChange:!0,hadValue:!0});for(const S of this.b)l.updateObserver(S,this),S.handleChange(this,g)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$8d=s;function t(n,d){let l;return typeof n=="string"?l=new h.$bd(void 0,n,void 0):l=new h.$bd(n,void 0,void 0),new o(l,d,r.$7c)}class o extends s{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$0d=o}),function(){function $e(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function T(b){R.push(b,Date.now())}function O(){const b=[];for(let c=0;c<R.length;c+=2)b.push({name:R[c],startTime:R[c+1]});return b}return{mark:T,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(C+T.startTime)});return R}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function r(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ke[10],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=D,e.$K=S,e.$h="en";let r=!1,h=!1,C=!1,R=!1,T=!1,O=!1,b=!1,c=!1,k=!1,y=!1,u,P=e.$h,w=e.$h,a,m;const p=globalThis;let f;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?f=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",h=f.platform==="darwin",C=f.platform==="linux",R=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,b=i,k=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,P=e.$h;const I=f.env.VSCODE_NLS_CONFIG;if(I)try{const A=JSON.parse(I);u=A.userLocale,w=A.osLocale,P=A.resolvedLanguage||e.$h,a=A.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,h=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,O=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(I){switch(I){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:C&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=C,e.$m=R,e.$n=T,e.$o=b,e.$p=O,e.$q=O&&typeof p.importScripts=="function",e.$r=e.$q?p.origin:void 0,e.$s=c,e.$t=y,e.$u=k,e.$v=n,e.$w=m,e.$x=P;var d;(function(I){function A(){return e.$x}I.value=A;function $(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}I.isDefaultVariant=$;function v(){return e.$x==="en"}I.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof p.postMessage=="function"&&!p.importScripts,e.$C=(()=>{if(e.$B){const I=[];p.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let v=0,M=I.length;v<M;v++){const N=I[v];if(N.id===$.data.vscodeScheduleAsyncWork){I.splice(v,1),N.callback();return}}});let A=0;return $=>{const v=++A;I.push({id:v,callback:$}),p.postMessage({vscodeScheduleAsyncWork:v},"*")}}return I=>setTimeout(I)})();var l;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let g=!0,E=!1;function D(){if(!E){E=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,g=new Uint16Array(I.buffer)[0]===513}return g}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function S(I){return parseFloat(I)>=20}}),define(ke[185],Ie([1,0,39]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0;const h=Symbol("unset");class C{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(b,c,k){this.d(b,y=>y._value=c,k)}mutate(b,c){this.d(b,k=>k._value=c(k._value===h?void 0:k._value))}mutatePath(b,c){this.d(b,()=>{},k=>c(k))}delete(b){const c=this.c(b);if(!c)return;let k=c.length-1;const y=c[k].node._value;if(y!==h){for(this.b--,c[k].node._value=h;k>0;k--){const{node:u,part:P}=c[k];if(u.children?.size||u._value!==h)break;c[k-1].node.children.delete(P)}return y}}*deleteRecursive(b){const c=this.c(b);if(!c)return;const k=c[c.length-1].node;for(let y=c.length-1;y>0;y--){const u=c[y-1];if(u.node.children.delete(c[y].part),u.node.children.size>0||u.node._value!==h)break}for(const y of R(k))y._value!==h&&(this.b--,yield y._value)}find(b){let c=this.a;for(const k of b){const y=c.children?.get(k);if(!y)return;c=y}return c._value===h?void 0:c._value}hasKeyOrParent(b){let c=this.a;for(const k of b){const y=c.children?.get(k);if(!y)return!1;if(y._value!==h)return!0;c=y}return!1}hasKeyOrChildren(b){let c=this.a;for(const k of b){const y=c.children?.get(k);if(!y)return!1;c=y}return!0}hasKey(b){let c=this.a;for(const k of b){const y=c.children?.get(k);if(!y)return!1;c=y}return c._value!==h}c(b){const c=[{part:"",node:this.a}];let k=0;for(const y of b){const u=c[k].node.children?.get(y);if(!u)return;c.push({part:y,node:u}),k++}return c}d(b,c,k){let y=this.a;for(const w of b){if(y.children)if(y.children.has(w))y=y.children.get(w);else{const a=new T;y.children.set(w,a),y=a}else{const a=new T;y.children=new Map([[w,a]]),y=a}k?.(y)}const u=y._value===h?0:1;c(y);const P=y._value===h?0:1;this.b+=P-u}*values(){for(const{_value:b}of R(this.a))b!==h&&(yield b)}}e.$0I=C;function*R(O){const b=[O];for(;b.length>0;){const c=b.pop();if(yield c,c.children)for(const k of c.children.values())b.push(k)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(b){this._value=b===void 0?h:b}}}),define(ke[55],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const R=C.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ec=h.platform,e.$fc=h.arch}),define(ke[16],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,r=We(r);const h=65,C=97,R=90,T=122,O=46,b=47,c=92,k=58,y=63;class u extends Error{constructor(d,l,g){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const D=d.indexOf(".")!==-1?"property":"argument";let S=`The "${d}" ${D} ${E} of type ${l}`;S+=`. Received type ${typeof g}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$ec==="win32";function m(n){return n===b||n===c}function p(n){return n===b}function f(n){return n>=h&&n<=R||n>=C&&n<=T}function i(n,d,l,g){let E="",D=0,S=-1,I=0,A=0;for(let $=0;$<=n.length;++$){if($<n.length)A=n.charCodeAt($);else{if(g(A))break;A=b}if(g(A)){if(!(S===$-1||I===1))if(I===2){if(E.length<2||D!==2||E.charCodeAt(E.length-1)!==O||E.charCodeAt(E.length-2)!==O){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",D=0):(E=E.slice(0,v),D=E.length-1-E.lastIndexOf(l)),S=$,I=0;continue}else if(E.length!==0){E="",D=0,S=$,I=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",D=2)}else E.length>0?E+=`${l}${n.slice(S+1,$)}`:E=n.slice(S+1,$),D=$-S-1;S=$,I=0}else A===O&&I!==-1?++I:I=-1}return E}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){P(d,"pathObject");const l=d.dir||d.root,g=d.base||`${d.name||""}${s(d.ext)}`;return l?l===d.root?`${l}${g}`:`${l}${n}${g}`:g}e.$gc={resolve(...n){let d="",l="",g=!1;for(let E=n.length-1;E>=-1;E--){let D;if(E>=0){if(D=n[E],w(D,`paths[${E}]`),D.length===0)continue}else d.length===0?D=r.cwd():(D=r.env[`=${d}`]||r.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==d.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${d}\\`));const S=D.length;let I=0,A="",$=!1;const v=D.charCodeAt(0);if(S===1)m(v)&&(I=1,$=!0);else if(m(v))if($=!0,m(D.charCodeAt(1))){let M=2,N=M;for(;M<S&&!m(D.charCodeAt(M));)M++;if(M<S&&M!==N){const L=D.slice(N,M);for(N=M;M<S&&m(D.charCodeAt(M));)M++;if(M<S&&M!==N){for(N=M;M<S&&!m(D.charCodeAt(M));)M++;(M===S||M!==N)&&(A=`\\\\${L}\\${D.slice(N,M)}`,I=M)}}}else I=1;else f(v)&&D.charCodeAt(1)===k&&(A=D.slice(0,2),I=2,S>2&&m(D.charCodeAt(2))&&($=!0,I=3));if(A.length>0)if(d.length>0){if(A.toLowerCase()!==d.toLowerCase())continue}else d=A;if(g){if(d.length>0)break}else if(l=`${D.slice(I)}\\${l}`,g=$,$&&d.length>0)break}return l=i(l,!g,"\\",m),g?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,g,E=!1;const D=n.charCodeAt(0);if(d===1)return p(D)?"\\":n;if(m(D))if(E=!0,m(n.charCodeAt(1))){let I=2,A=I;for(;I<d&&!m(n.charCodeAt(I));)I++;if(I<d&&I!==A){const $=n.slice(A,I);for(A=I;I<d&&m(n.charCodeAt(I));)I++;if(I<d&&I!==A){for(A=I;I<d&&!m(n.charCodeAt(I));)I++;if(I===d)return`\\\\${$}\\${n.slice(A)}\\`;I!==A&&(g=`\\\\${$}\\${n.slice(A,I)}`,l=I)}}}else l=1;else f(D)&&n.charCodeAt(1)===k&&(g=n.slice(0,2),l=2,d>2&&m(n.charCodeAt(2))&&(E=!0,l=3));let S=l<d?i(n.slice(l),!E,"\\",m):"";return S.length===0&&!E&&(S="."),S.length>0&&m(n.charCodeAt(d-1))&&(S+="\\"),g===void 0?E?`\\${S}`:S:E?`${g}\\${S}`:`${g}${S}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return m(l)||d>2&&f(l)&&n.charCodeAt(1)===k&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let D=0;D<n.length;++D){const S=n[D];w(S,"path"),S.length>0&&(d===void 0?d=l=S:d+=`\\${S}`)}if(d===void 0)return".";let g=!0,E=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++E;const D=l.length;D>1&&m(l.charCodeAt(1))&&(++E,D>2&&(m(l.charCodeAt(2))?++E:g=!1))}if(g){for(;E<d.length&&m(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$gc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$gc.resolve(n),g=e.$gc.resolve(d);if(l===g||(n=l.toLowerCase(),d=g.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let D=n.length;for(;D-1>E&&n.charCodeAt(D-1)===c;)D--;const S=D-E;let I=0;for(;I<d.length&&d.charCodeAt(I)===c;)I++;let A=d.length;for(;A-1>I&&d.charCodeAt(A-1)===c;)A--;const $=A-I,v=S<$?S:$;let M=-1,N=0;for(;N<v;N++){const F=n.charCodeAt(E+N);if(F!==d.charCodeAt(I+N))break;F===c&&(M=N)}if(N!==v){if(M===-1)return g}else{if($>v){if(d.charCodeAt(I+N)===c)return g.slice(I+N+1);if(N===2)return g.slice(I+N)}S>v&&(n.charCodeAt(E+N)===c?M=N:N===2&&(M=3)),M===-1&&(M=0)}let L="";for(N=E+M+1;N<=D;++N)(N===D||n.charCodeAt(N)===c)&&(L+=L.length===0?"..":"\\..");return I+=M,L.length>0?`${L}${g.slice(I,A)}`:(g.charCodeAt(I)===c&&++I,g.slice(I,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$gc.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==y&&l!==O)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(f(d.charCodeAt(0))&&d.charCodeAt(1)===k&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,g=0;const E=n.charCodeAt(0);if(d===1)return m(E)?n:".";if(m(E)){if(l=g=1,m(n.charCodeAt(1))){let I=2,A=I;for(;I<d&&!m(n.charCodeAt(I));)I++;if(I<d&&I!==A){for(A=I;I<d&&m(n.charCodeAt(I));)I++;if(I<d&&I!==A){for(A=I;I<d&&!m(n.charCodeAt(I));)I++;if(I===d)return n;I!==A&&(l=g=I+1)}}}}else f(E)&&n.charCodeAt(1)===k&&(l=d>2&&m(n.charCodeAt(2))?3:2,g=l);let D=-1,S=!0;for(let I=d-1;I>=g;--I)if(m(n.charCodeAt(I))){if(!S){D=I;break}}else S=!1;if(D===-1){if(l===-1)return".";D=l}return n.slice(0,D)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,g=-1,E=!0,D;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===k&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let S=d.length-1,I=-1;for(D=n.length-1;D>=l;--D){const A=n.charCodeAt(D);if(m(A)){if(!E){l=D+1;break}}else I===-1&&(E=!1,I=D+1),S>=0&&(A===d.charCodeAt(S)?--S===-1&&(g=D):(S=-1,g=I))}return l===g?g=I:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=l;--D)if(m(n.charCodeAt(D))){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=0,l=-1,g=0,E=-1,D=!0,S=0;n.length>=2&&n.charCodeAt(1)===k&&f(n.charCodeAt(0))&&(d=g=2);for(let I=n.length-1;I>=d;--I){const A=n.charCodeAt(I);if(m(A)){if(!D){g=I+1;break}continue}E===-1&&(D=!1,E=I+1),A===O?l===-1?l=I:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||E===-1||S===0||S===1&&l===E-1&&l===g+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let g=0,E=n.charCodeAt(0);if(l===1)return m(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if(m(E)){if(g=1,m(n.charCodeAt(1))){let M=2,N=M;for(;M<l&&!m(n.charCodeAt(M));)M++;if(M<l&&M!==N){for(N=M;M<l&&m(n.charCodeAt(M));)M++;if(M<l&&M!==N){for(N=M;M<l&&!m(n.charCodeAt(M));)M++;M===l?g=M:M!==N&&(g=M+1)}}}}else if(f(E)&&n.charCodeAt(1)===k){if(l<=2)return d.root=d.dir=n,d;if(g=2,m(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;g=3}}g>0&&(d.root=n.slice(0,g));let D=-1,S=g,I=-1,A=!0,$=n.length-1,v=0;for(;$>=g;--$){if(E=n.charCodeAt($),m(E)){if(!A){S=$+1;break}continue}I===-1&&(A=!1,I=$+1),E===O?D===-1?D=$:v!==1&&(v=1):D!==-1&&(v=-1)}return I!==-1&&(D===-1||v===0||v===1&&D===I-1&&D===S+1?d.base=d.name=n.slice(S,I):(d.name=n.slice(S,D),d.base=n.slice(S,I),d.ext=n.slice(D,I))),S>0&&S!==g?d.dir=n.slice(0,S-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$hc={resolve(...n){let d="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const E=g>=0?n[g]:o();w(E,`paths[${g}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===b)}return d=i(d,!l,"/",p),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b,l=n.charCodeAt(n.length-1)===b;return n=i(n,!d,"/",p),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const g=n[l];w(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.$hc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$hc.resolve(n),d=e.$hc.resolve(d),n===d))return"";const l=1,g=n.length,E=g-l,D=1,S=d.length-D,I=E<S?E:S;let A=-1,$=0;for(;$<I;$++){const M=n.charCodeAt(l+$);if(M!==d.charCodeAt(D+$))break;M===b&&(A=$)}if($===I)if(S>I){if(d.charCodeAt(D+$)===b)return d.slice(D+$+1);if($===0)return d.slice(D+$)}else E>I&&(n.charCodeAt(l+$)===b?A=$:$===0&&(A=0));let v="";for($=l+A+1;$<=g;++$)($===g||n.charCodeAt($)===b)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(D+A)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b;let l=-1,g=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===b){if(!g){l=E;break}}else g=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,g=-1,E=!0,D;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let S=d.length-1,I=-1;for(D=n.length-1;D>=0;--D){const A=n.charCodeAt(D);if(A===b){if(!E){l=D+1;break}}else I===-1&&(E=!1,I=D+1),S>=0&&(A===d.charCodeAt(S)?--S===-1&&(g=D):(S=-1,g=I))}return l===g?g=I:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=0;--D)if(n.charCodeAt(D)===b){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=-1,l=0,g=-1,E=!0,D=0;for(let S=n.length-1;S>=0;--S){const I=n.charCodeAt(S);if(I===b){if(!E){l=S+1;break}continue}g===-1&&(E=!1,g=S+1),I===O?d===-1?d=S:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||g===-1||D===0||D===1&&d===g-1&&d===l+1?"":n.slice(d,g)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===b;let g;l?(d.root="/",g=1):g=0;let E=-1,D=0,S=-1,I=!0,A=n.length-1,$=0;for(;A>=g;--A){const v=n.charCodeAt(A);if(v===b){if(!I){D=A+1;break}continue}S===-1&&(I=!1,S=A+1),v===O?E===-1?E=A:$!==1&&($=1):E!==-1&&($=-1)}if(S!==-1){const v=D===0&&l?1:D;E===-1||$===0||$===1&&E===S-1&&E===D+1?d.base=d.name=n.slice(v,S):(d.name=n.slice(v,E),d.base=n.slice(v,S),d.ext=n.slice(E,S))}return D>0?d.dir=n.slice(0,D-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[135],Ie([1,0,50,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=O,e.$Er=b,e.$Fr=c,e.$Gr=k,e.$Hr=y,e.$Ir=u,e.$Jr=P,e.$Kr=w,e.$Lr=a,e.$Mr=m,e.$Nr=g,e.$Or=E,e.$Pr=D;const C=new r.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new r.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new r.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(S,I,A=!1){const $=S||"",v=I||"",M=C.value.collator.compare($,v);return C.value.collatorIsNumeric&&M===0&&$!==v?$<v?-1:1:M}function b(S,I){const A=R.value.collator;return S=S||"",I=I||"",s(A,S,I)}function c(S,I){const A=R.value.collator;return S=S||"",I=I||"",d(S,I)||s(A,S,I)}function k(S,I){const A=R.value.collator;return S=S||"",I=I||"",n(S,I)||s(A,S,I)}function y(S,I){return S=S||"",I=I||"",S===I?0:S<I?-1:1}function u(S,I){const[A,$]=f(S),[v,M]=f(I);let N=C.value.collator.compare($,M);if(N===0){if(C.value.collatorIsNumeric&&$!==M)return $<M?-1:1;if(N=C.value.collator.compare(A,v),C.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(S,I){S=S||"",I=I||"";const A=i(S),$=i(I),v=R.value.collator,M=T.value.collator;return s(M,A,$)||s(v,S,I)}function w(S,I){S=S||"",I=I||"";const A=i(S),$=i(I),v=R.value.collator,M=T.value.collator;return s(M,A,$)||d(S,I)||s(v,S,I)}function a(S,I){S=S||"",I=I||"";const A=i(S),$=i(I),v=R.value.collator,M=T.value.collator;return s(M,A,$)||n(S,I)||s(v,S,I)}function m(S,I){S=S||"",I=I||"";const A=i(S).toLowerCase(),$=i(I).toLowerCase();return A!==$?A<$?-1:1:S!==I?S<I?-1:1:0}const p=/^(.*?)(\.([^.]*))?$/;function f(S,I=!1){const A=S?p.exec(S):[];let $=[A&&A[1]||"",A&&A[3]||""];return I&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function i(S){const I=S?p.exec(S):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function s(S,I,A){const $=S.compare(I,A);return $!==0?$:I.length!==A.length?I.length<A.length?-1:1:0}function t(S){const I=S.charAt(0);return I.toLocaleUpperCase()!==I}function o(S){const I=S.charAt(0);return I.toLocaleLowerCase()!==I}function n(S,I){return t(S)&&o(I)?-1:o(S)&&t(I)?1:0}function d(S,I){return o(S)&&t(I)?-1:t(S)&&o(I)?1:0}function l(S,I,A=!1){return A||(S=S&&S.toLowerCase(),I=I&&I.toLowerCase()),S===I?0:S<I?-1:1}function g(S,I,A=!1){const $=S.split(h.sep),v=I.split(h.sep),M=$.length-1,N=v.length-1;let L,F;for(let B=0;;B++){if(L=M===B,F=N===B,L&&F)return O($[B],v[B],A);if(L)return-1;if(F)return 1;const j=l($[B],v[B],A);if(j!==0)return j}}function E(S,I,A){const $=S.toLowerCase(),v=I.toLowerCase(),M=D(S,I,A);if(M)return M;const N=$.endsWith(A),L=v.endsWith(A);if(N!==L)return N?-1:1;const F=O($,v);return F!==0?F:$.localeCompare(v)}function D(S,I,A){const $=S.toLowerCase(),v=I.toLowerCase(),M=$.startsWith(A),N=v.startsWith(A);if(M!==N)return M?-1:1;if(M&&N){if($.length<v.length)return-1;if($.length>v.length)return 1}return 0}}),define(ke[103],Ie([1,0,16]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0,e.$ct=R,e.$dt=T,e.$et=O,e.$ft=c,e.$bt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(k){const y=(0,r.$pc)(k),u=h[y.toLowerCase()];return u!==void 0?u:T(k)}function T(k){const y=(0,r.$pc)(k);return C[y.toLowerCase()]}function O(k){for(const y in C)if(C[y]===k)return y}const b=/^(.+)\/(.+?)(;.+)?$/;function c(k,y){const u=b.exec(k);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:k}}),define(ke[104],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=T;var h;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(h||(e.Source=h={}));var C;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function R(O,...b){const c=b.reduce((u,P)=>(u[P]=!0,u),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(u=>!c[u]).forEach(u=>{for(let P=0;P<k.length;P++)if(u.search(k[P])!==-1){delete O[u];break}})}function T(O){O&&(delete O.DEBUG,r.$l&&delete O.LD_PRELOAD)}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:$e)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function r(h){if(e[h])return e[h].exports;var C=e[h]={i:h,l:!1,exports:{}};return $e[h].call(C.exports,C,C.exports,r),C.l=!0,C.exports}return r.m=$e,r.c=e,r.d=function(h,C,R){r.o(h,C)||Object.defineProperty(h,C,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,C){if(1&C&&(h=r(h)),8&C||4&C&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&C&&typeof h!="string")for(var T in h)r.d(R,T,function(O){return h[O]}.bind(null,T));return R},r.n=function(h){var C=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(C,"a",C),C},r.o=function(h,C){return Object.prototype.hasOwnProperty.call(h,C)},r.p="",r(r.s=0)}([function($e,e,r){(function(h){var C;e=$e.exports=ye,C=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],b=e.src=[],c=0,k=c++;b[k]="0|[1-9]\\d*";var y=c++;b[y]="[0-9]+";var u=c++;b[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;b[P]="("+b[k]+")\\.("+b[k]+")\\.("+b[k]+")";var w=c++;b[w]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var a=c++;b[a]="(?:"+b[k]+"|"+b[u]+")";var m=c++;b[m]="(?:"+b[y]+"|"+b[u]+")";var p=c++;b[p]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var f=c++;b[f]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var i=c++;b[i]="[0-9A-Za-z-]+";var s=c++;b[s]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var t=c++,o="v?"+b[P]+b[p]+"?"+b[s]+"?";b[t]="^"+o+"$";var n="[v=\\s]*"+b[w]+b[f]+"?"+b[s]+"?",d=c++;b[d]="^"+n+"$";var l=c++;b[l]="((?:<|>)?=?)";var g=c++;b[g]=b[y]+"|x|X|\\*";var E=c++;b[E]=b[k]+"|x|X|\\*";var D=c++;b[D]="[v=\\s]*("+b[E]+")(?:\\.("+b[E]+")(?:\\.("+b[E]+")(?:"+b[p]+")?"+b[s]+"?)?)?";var S=c++;b[S]="[v=\\s]*("+b[g]+")(?:\\.("+b[g]+")(?:\\.("+b[g]+")(?:"+b[f]+")?"+b[s]+"?)?)?";var I=c++;b[I]="^"+b[l]+"\\s*"+b[D]+"$";var A=c++;b[A]="^"+b[l]+"\\s*"+b[S]+"$";var $=c++;b[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;b[v]="(?:~>?)";var M=c++;b[M]="(\\s*)"+b[v]+"\\s+",O[M]=new RegExp(b[M],"g");var N=c++;b[N]="^"+b[v]+b[D]+"$";var L=c++;b[L]="^"+b[v]+b[S]+"$";var F=c++;b[F]="(?:\\^)";var B=c++;b[B]="(\\s*)"+b[F]+"\\s+",O[B]=new RegExp(b[B],"g");var j=c++;b[j]="^"+b[F]+b[D]+"$";var U=c++;b[U]="^"+b[F]+b[S]+"$";var z=c++;b[z]="^"+b[l]+"\\s*("+n+")$|^$";var ee=c++;b[ee]="^"+b[l]+"\\s*("+o+")$|^$";var V=c++;b[V]="(\\s*)"+b[l]+"\\s*("+n+"|"+b[D]+")",O[V]=new RegExp(b[V],"g");var W=c++;b[W]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var J=c++;b[J]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var _=c++;b[_]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,b[ce]),O[ce]||(O[ce]=new RegExp(b[ce]));function ne(G,Z){if(G instanceof ye)return G;if(typeof G!="string"||G.length>R||!(Z?O[d]:O[t]).test(G))return null;try{return new ye(G,Z)}catch{return null}}function ye(G,Z){if(G instanceof ye){if(G.loose===Z)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(G,Z);C("SemVer",G,Z),this.loose=Z;var x=G.trim().match(Z?O[d]:O[t]);if(!x)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var Ee=+de;if(Ee>=0&&Ee<T)return Ee}return de}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(G,Z){var x=ne(G,Z);return x?x.version:null},e.clean=function(G,Z){var x=ne(G.trim().replace(/^[=v]+/,""),Z);return x?x.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(G){return C("SemVer.compare",this.version,this.loose,G),G instanceof ye||(G=new ye(G,this.loose)),this.compareMain(G)||this.comparePre(G)},ye.prototype.compareMain=function(G){return G instanceof ye||(G=new ye(G,this.loose)),Y(this.major,G.major)||Y(this.minor,G.minor)||Y(this.patch,G.patch)},ye.prototype.comparePre=function(G){if(G instanceof ye||(G=new ye(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var Z=0;do{var x=this.prerelease[Z],de=G.prerelease[Z];if(C("prerelease compare",Z,x,de),x===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(x===void 0)return-1;if(x!==de)return Y(x,de)}while(++Z)},ye.prototype.inc=function(G,Z){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,Z,x,de){typeof x=="string"&&(de=x,x=void 0);try{return new ye(G,x).inc(Z,de).version}catch{return null}},e.diff=function(G,Z){if(ie(G,Z))return null;var x=ne(G),de=ne(Z);if(x.prerelease.length||de.prerelease.length){for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return Ee},e.compareIdentifiers=Y;var ge=/^[0-9]+$/;function Y(G,Z){var x=ge.test(G),de=ge.test(Z);return x&&de&&(G=+G,Z=+Z),x&&!de?-1:de&&!x?1:G<Z?-1:G>Z?1:0}function q(G,Z,x){return new ye(G,x).compare(new ye(Z,x))}function oe(G,Z,x){return q(G,Z,x)>0}function ve(G,Z,x){return q(G,Z,x)<0}function ie(G,Z,x){return q(G,Z,x)===0}function ae(G,Z,x){return q(G,Z,x)!==0}function se(G,Z,x){return q(G,Z,x)>=0}function X(G,Z,x){return q(G,Z,x)<=0}function re(G,Z,x,de){var Ee;switch(Z){case"===":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G===x;break;case"!==":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G!==x;break;case"":case"=":case"==":Ee=ie(G,x,de);break;case"!=":Ee=ae(G,x,de);break;case">":Ee=oe(G,x,de);break;case">=":Ee=se(G,x,de);break;case"<":Ee=ve(G,x,de);break;case"<=":Ee=X(G,x,de);break;default:throw new TypeError("Invalid operator: "+Z)}return Ee}function pe(G,Z){if(G instanceof pe){if(G.loose===Z)return G;G=G.value}if(!(this instanceof pe))return new pe(G,Z);C("comparator",G,Z),this.loose=Z,this.parse(G),this.semver===we?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(G,Z){return Y(Z,G)},e.major=function(G,Z){return new ye(G,Z).major},e.minor=function(G,Z){return new ye(G,Z).minor},e.patch=function(G,Z){return new ye(G,Z).patch},e.compare=q,e.compareLoose=function(G,Z){return q(G,Z,!0)},e.rcompare=function(G,Z,x){return q(Z,G,x)},e.sort=function(G,Z){return G.sort(function(x,de){return e.compare(x,de,Z)})},e.rsort=function(G,Z){return G.sort(function(x,de){return e.rcompare(x,de,Z)})},e.gt=oe,e.lt=ve,e.eq=ie,e.neq=ae,e.gte=se,e.lte=X,e.cmp=re,e.Comparator=pe;var we={};function Me(G,Z){if(G instanceof Me)return G.loose===Z?G:new Me(G.raw,Z);if(G instanceof pe)return new Me(G.value,Z);if(!(this instanceof Me))return new Me(G,Z);if(this.loose=Z,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function ze(G){return!G||G.toLowerCase()==="x"||G==="*"}function Ae(G,Z,x,de,Ee,Te,He,Ke,et,nt,st,rt,at){return((Z=ze(x)?"":ze(de)?">="+x+".0.0":ze(Ee)?">="+x+"."+de+".0":">="+Z)+" "+(Ke=ze(et)?"":ze(nt)?"<"+(+et+1)+".0.0":ze(st)?"<"+et+"."+(+nt+1)+".0":rt?"<="+et+"."+nt+"."+st+"-"+rt:"<="+Ke)).trim()}function De(G,Z){for(var x=0;x<G.length;x++)if(!G[x].test(Z))return!1;if(Z.prerelease.length){for(x=0;x<G.length;x++)if(C(G[x].semver),G[x].semver!==we&&G[x].semver.prerelease.length>0){var de=G[x].semver;if(de.major===Z.major&&de.minor===Z.minor&&de.patch===Z.patch)return!0}return!1}return!0}function Ce(G,Z,x){try{Z=new Me(Z,x)}catch{return!1}return Z.test(G)}function H(G,Z,x,de){var Ee,Te,He,Ke,et;switch(G=new ye(G,de),Z=new Me(Z,de),x){case">":Ee=oe,Te=X,He=ve,Ke=">",et=">=";break;case"<":Ee=ve,Te=se,He=oe,Ke="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(G,Z,de))return!1;for(var nt=0;nt<Z.set.length;++nt){var st=Z.set[nt],rt=null,at=null;if(st.forEach(function(gt){gt.semver===we&&(gt=new pe(">=0.0.0")),rt=rt||gt,at=at||gt,Ee(gt.semver,rt.semver,de)?rt=gt:He(gt.semver,at.semver,de)&&(at=gt)}),rt.operator===Ke||rt.operator===et||(!at.operator||at.operator===Ke)&&Te(G,at.semver)||at.operator===et&&He(G,at.semver))return!1}return!0}pe.prototype.parse=function(G){var Z=this.loose?O[z]:O[ee],x=G.match(Z);if(!x)throw new TypeError("Invalid comparator: "+G);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ye(x[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(G){return C("Comparator.test",G,this.loose),this.semver===we||(typeof G=="string"&&(G=new ye(G,this.loose)),re(G,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(G,Z){if(!(G instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Me(G.value,Z),Ce(this.value,x,Z);if(G.operator==="")return x=new Me(this.value,Z),Ce(G.semver,x,Z);var de=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Te=this.semver.version===G.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Ke=re(this.semver,"<",G.semver,Z)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),et=re(this.semver,">",G.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return de||Ee||Te&&He||Ke||et},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(G){var Z=this.loose;G=G.trim(),C("range",G,Z);var x=Z?O[J]:O[W];G=G.replace(x,Ae),C("hyphen replace",G),G=G.replace(O[V],"$1$2$3"),C("comparator trim",G,O[V]),G=(G=(G=G.replace(O[M],"$1~")).replace(O[B],"$1^")).split(/\s+/).join(" ");var de=Z?O[z]:O[ee],Ee=G.split(" ").map(function(Te){return function(He,Ke){return C("comp",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){C("caret",rt,at);var gt=at?O[U]:O[j];return rt.replace(gt,function(dt,ct,Pe,Be,Qe){var Ne;return C("caret",rt,dt,ct,Pe,Be,Qe),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=ct==="0"?">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+".0 <"+(+ct+1)+".0.0":Qe?(C("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+Qe+" <"+(+ct+1)+".0.0"):(C("no pr"),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+" <"+(+ct+1)+".0.0"),C("caret return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),C("caret",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){var gt=at?O[L]:O[N];return rt.replace(gt,function(dt,ct,Pe,Be,Qe){var Ne;return C("tilde",rt,dt,ct,Pe,Be,Qe),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":Qe?(C("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ne=">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+(+Pe+1)+".0"):Ne=">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0",C("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),C("tildes",He),He=function(et,nt){return C("replaceXRanges",et,nt),et.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var gt=at?O[A]:O[I];return rt.replace(gt,function(dt,ct,Pe,Be,Qe,Ne){C("xRange",rt,dt,ct,Pe,Be,Qe,Ne);var je=ze(Pe),ue=je||ze(Be),he=ue||ze(Qe);return ct==="="&&he&&(ct=""),je?dt=ct===">"||ct==="<"?"<0.0.0":"*":ct&&he?(ue&&(Be=0),he&&(Qe=0),ct===">"?(ct=">=",ue?(Pe=+Pe+1,Be=0,Qe=0):he&&(Be=+Be+1,Qe=0)):ct==="<="&&(ct="<",ue?Pe=+Pe+1:Be=+Be+1),dt=ct+Pe+"."+Be+"."+Qe):ue?dt=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":he&&(dt=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),C("xRange return",dt),dt})}(st,nt)}).join(" ")}(He,Ke),C("xrange",He),He=function(et,nt){return C("replaceStars",et,nt),et.trim().replace(O[_],"")}(He,Ke),C("stars",He),He}(Te,Z)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Te){return!!Te.match(de)})),Ee=Ee.map(function(Te){return new pe(Te,Z)})},Me.prototype.intersects=function(G,Z){if(!(G instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(de){return G.set.some(function(Ee){return Ee.every(function(Te){return de.intersects(Te,Z)})})})})},e.toComparators=function(G,Z){return new Me(G,Z).set.map(function(x){return x.map(function(de){return de.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new ye(G,this.loose));for(var Z=0;Z<this.set.length;Z++)if(De(this.set[Z],G))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(G,Z,x){var de=null,Ee=null;try{var Te=new Me(Z,x)}catch{return null}return G.forEach(function(He){Te.test(He)&&(de&&Ee.compare(He)!==-1||(Ee=new ye(de=He,x)))}),de},e.minSatisfying=function(G,Z,x){var de=null,Ee=null;try{var Te=new Me(Z,x)}catch{return null}return G.forEach(function(He){Te.test(He)&&(de&&Ee.compare(He)!==1||(Ee=new ye(de=He,x)))}),de},e.validRange=function(G,Z){try{return new Me(G,Z).range||"*"}catch{return null}},e.ltr=function(G,Z,x){return H(G,Z,"<",x)},e.gtr=function(G,Z,x){return H(G,Z,">",x)},e.outside=H,e.prerelease=function(G,Z){var x=ne(G,Z);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(G,Z,x){return G=new Me(G,x),Z=new Me(Z,x),G.intersects(Z)},e.coerce=function(G){if(G instanceof ye)return G;if(typeof G!="string")return null;var Z=G.match(O[$]);return Z==null?null:ne((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,r(1))},function($e,e){var r,h,C=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function O(m){if(r===setTimeout)return setTimeout(m,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var b,c=[],k=!1,y=-1;function u(){k&&b&&(k=!1,b.length?c=b.concat(c):y=-1,c.length&&P())}function P(){if(!k){var m=O(u);k=!0;for(var p=c.length;p;){for(b=c,c=[];++y<p;)b&&b[y].run();y=-1,p=c.length}b=null,k=!1,function(f){if(h===clearTimeout)return clearTimeout(f);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(f);try{h(f)}catch{try{return h.call(null,f)}catch{return h.call(this,f)}}}(m)}}function w(m,p){this.fun=m,this.array=p}function a(){}C.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)p[f-1]=arguments[f];c.push(new w(m,p)),c.length!==1||k||O(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(m){return[]},C.binding=function(m){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(m){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ke[42],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=h}),define(ke[4],Ie([1,0,13,79,3,80,42]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=P;const O=!1,b=!1,c=!1;var k;(function(L){L.None=()=>C.$Vc.None;function F(De){if(c){const{onDidAddListener:Ce}=De,H=a.create();let G=0;De.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),Ce?.()}}}function B(De,Ce){return ne(De,()=>{},0,void 0,!0,void 0,Ce)}L.defer=B;function j(De){return(Ce,H=null,G)=>{let Z=!1,x;return x=De(de=>{if(!Z)return x?x.dispose():Z=!0,Ce.call(H,de)},null,G),Z&&x.dispose(),x}}L.once=j;function U(De,Ce,H){return _((G,Z=null,x)=>De(de=>G.call(Z,Ce(de)),null,x),H)}L.map=U;function z(De,Ce,H){return _((G,Z=null,x)=>De(de=>{Ce(de),G.call(Z,de)},null,x),H)}L.forEach=z;function ee(De,Ce,H){return _((G,Z=null,x)=>De(de=>Ce(de)&&G.call(Z,de),null,x),H)}L.filter=ee;function V(De){return De}L.signal=V;function W(...De){return(Ce,H=null,G)=>{const Z=(0,C.$Sc)(...De.map(x=>x(de=>Ce.call(H,de))));return ce(Z,G)}}L.any=W;function J(De,Ce,H,G){let Z=H;return U(De,x=>(Z=Ce(Z,x),Z),G)}L.reduce=J;function _(De,Ce){let H;const G={onWillAddFirstListener(){H=De(Z.fire,Z)},onDidRemoveLastListener(){H?.dispose()}};Ce||F(G);const Z=new n(G);return Ce?.add(Z),Z.event}function ce(De,Ce){return Ce instanceof Array?Ce.push(De):Ce&&Ce.add(De),De}function ne(De,Ce,H=100,G=!1,Z=!1,x,de){let Ee,Te,He,Ke=0,et;const nt={leakWarningThreshold:x,onWillAddFirstListener(){Ee=De(rt=>{Ke++,Te=Ce(Te,rt),G&&!He&&(st.fire(Te),Te=void 0),et=()=>{const at=Te;Te=void 0,He=void 0,(!G||Ke>1)&&st.fire(at),Ke=0},typeof H=="number"?(clearTimeout(He),He=setTimeout(et,H)):He===void 0&&(He=0,queueMicrotask(et))})},onWillRemoveListener(){Z&&Ke>0&&et?.()},onDidRemoveLastListener(){et=void 0,Ee.dispose()}};de||F(nt);const st=new n(nt);return de?.add(st),st.event}L.debounce=ne;function ye(De,Ce=0,H){return L.debounce(De,(G,Z)=>G?(G.push(Z),G):[Z],Ce,void 0,!0,void 0,H)}L.accumulate=ye;function ge(De,Ce=(G,Z)=>G===Z,H){let G=!0,Z;return ee(De,x=>{const de=G||!Ce(x,Z);return G=!1,Z=x,de},H)}L.latch=ge;function Y(De,Ce,H){return[L.filter(De,Ce,H),L.filter(De,G=>!Ce(G),H)]}L.split=Y;function q(De,Ce=!1,H=[],G){let Z=H.slice(),x=De(Te=>{Z?Z.push(Te):Ee.fire(Te)});G&&G.add(x);const de=()=>{Z?.forEach(Te=>Ee.fire(Te)),Z=null},Ee=new n({onWillAddFirstListener(){x||(x=De(Te=>Ee.fire(Te)),G&&G.add(x))},onDidAddFirstListener(){Z&&(Ce?setTimeout(de):de())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return G&&G.add(Ee),Ee.event}L.buffer=q;function oe(De,Ce){return(G,Z,x)=>{const de=Ce(new ie);return De(function(Ee){const Te=de.evaluate(Ee);Te!==ve&&G.call(Z,Te)},void 0,x)}}L.chain=oe;const ve=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(H=>(Ce(H),H)),this}filter(Ce){return this.f.push(H=>Ce(H)?H:ve),this}reduce(Ce,H){let G=H;return this.f.push(Z=>(G=Ce(G,Z),G)),this}latch(Ce=(H,G)=>H===G){let H=!0,G;return this.f.push(Z=>{const x=H||!Ce(Z,G);return H=!1,G=Z,x?Z:ve}),this}evaluate(Ce){for(const H of this.f)if(Ce=H(Ce),Ce===ve)break;return Ce}}function ae(De,Ce,H=G=>G){const G=(...Ee)=>de.fire(H(...Ee)),Z=()=>De.on(Ce,G),x=()=>De.removeListener(Ce,G),de=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return de.event}L.fromNodeEventEmitter=ae;function se(De,Ce,H=G=>G){const G=(...Ee)=>de.fire(H(...Ee)),Z=()=>De.addEventListener(Ce,G),x=()=>De.removeEventListener(Ce,G),de=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return de.event}L.fromDOMEventEmitter=se;function X(De){return new Promise(Ce=>j(De)(Ce))}L.toPromise=X;function re(De){const Ce=new n;return De.then(H=>{Ce.fire(H)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}L.fromPromise=re;function pe(De,Ce){return De(H=>Ce.fire(H))}L.forward=pe;function we(De,Ce,H){return Ce(H),De(G=>Ce(G))}L.runAndSubscribe=we;class Me{constructor(Ce,H){this._observable=Ce,this.f=0,this.g=!1;const G={onWillAddFirstListener:()=>{Ce.addObserver(this)},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};H||F(G),this.emitter=new n(G),H&&H.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,H){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ze(De,Ce){return new Me(De,Ce).emitter.event}L.fromObservable=ze;function Ae(De){return(Ce,H,G)=>{let Z=0,x=!1;const de={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(De.reportChanges(),x&&(x=!1,Ce.call(H)))},handlePossibleChange(){},handleChange(){x=!0}};De.addObserver(de),De.reportChanges();const Ee={dispose(){De.removeObserver(de)}};return G instanceof C.$Uc?G.add(Ee):Array.isArray(G)&&G.push(Ee),Ee}}L.fromObservableLight=Ae})(k||(e.Event=k={}));class y{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${y.f++}`,y.all.add(this)}start(F){this.g=new T.$ge,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ie=y;let u=-1;function P(L){const F=u;return u=L,{dispose(){u=F}}}class w{static{this.f=1}constructor(F,B,j=(w.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=B,this.name=j,this.h=0}dispose(){this.g?.clear()}check(F,B){const j=this.threshold;if(j<=0||B<j)return;this.g||(this.g=new Map);const U=this.g.get(F.value)||0;if(this.g.set(F.value,U+1),this.h-=1,this.h<=0){this.h=j*.5;const[z,ee]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${ee}):`;console.warn(V),console.warn(z);const W=new m(V,z);this.j(W)}return()=>{const z=this.g.get(F.value)||0;this.g.set(F.value,z-1)}}getMostFrequentStack(){if(!this.g)return;let F,B=0;for(const[j,U]of this.g)(!F||B<U)&&(F=[j,U],B=U);return F}}class a{static create(){const F=new Error;return new a(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(F,B){super(F),this.name="ListenerLeakError",this.stack=B}}e.$ke=m;class p extends Error{constructor(F,B){super(F),this.name="ListenerRefusalError",this.stack=B}}e.$le=p;let f=0;class i{constructor(F){this.value=F,this.id=f++}}const s=2,t=(L,F)=>{if(L instanceof i)F(L);else for(let B=0;B<L.length;B++){const j=L[B];j&&F(j)}};let o;if(O){const L=[];setInterval(()=>{L.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(L.join(`
`)),L.length=0)},3e3),o=new FinalizationRegistry(F=>{typeof F=="string"&&L.push(F)})}class n{constructor(F){this.z=0,this.f=F,this.g=u>0||this.f?.leakWarningThreshold?new w(F?.onListenerError??r.$Z,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const F=this.u;queueMicrotask(()=>{t(F,B=>B.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,B,j)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const J=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],_=new p(`${W}. HINT: Stack shows most frequent listener (${J[1]}-times)`,J[0]);return(this.f?.onListenerError||r.$Z)(_),C.$Vc.None}if(this.m)return C.$Vc.None;B&&(F=F.bind(B));const U=new i(F);let z,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(U.stack=a.create(),z=this.g.check(U.stack,this.z+1)),b&&(U.stack=ee??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,U]):this.u.push(U):(this.f?.onWillAddFirstListener?.(this),this.u=U,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,C.$Tc)(()=>{o?.unregister(V),z?.(),this.A(U)});if(j instanceof C.$Uc?j.add(V):Array.isArray(j)&&j.push(V),o){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),J=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);o.register(V,J?.[2]??W,V)}return V},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const B=this.u,j=B.indexOf(F);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,B[j]=void 0;const U=this.w.current===this;if(this.z*s<=B.length){let z=0;for(let ee=0;ee<B.length;ee++)B[ee]?B[z++]=B[ee]:U&&(this.w.end--,z<this.w.i&&this.w.i--);B.length=z}}B(F,B){if(!F)return;const j=this.f?.onListenerError||r.$Z;if(!j){F.value(B);return}try{F.value(B)}catch(U){j(U)}}C(F){const B=F.current.u;for(;F.i<F.end;)this.B(B[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,F);else{const B=this.w;B.enqueue(this,F,this.u.length),this.C(B)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=n;const d=()=>new l;e.$ne=d;class l{constructor(){this.i=-1,this.end=0}enqueue(F,B,j){this.i=0,this.end=j,this.current=F,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(F,B,j){if(this.u)for(this.h||(this.h=new R.$6c),t(this.u,U=>this.h.push([U.value,F]));this.h.size>0&&!B.isCancellationRequested;){const[U,z]=this.h.shift(),ee=[],V={...z,token:B,waitUntil:W=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");j&&(W=j(W,U)),ee.push(W)}};try{U(V)}catch(W){(0,r.$Z)(W);continue}Object.freeze(ee),await Promise.allSettled(ee).then(W=>{for(const J of W)J.status==="rejected"&&(0,r.$Z)(J.reason)})}}}e.$oe=g;class E extends n{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$6c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$pe=E;class D extends E{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$qe=D;class S extends n{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}e.$re=S;class I{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const B={event:F,listener:null};this.h.push(B),this.g&&this.m(B);const j=()=>{this.g&&this.o(B);const U=this.h.indexOf(B);this.h.splice(U,1)};return(0,C.$Tc)((0,h.$db)(j))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(B=>this.f.fire(B))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$se=I;class A{constructor(F,B,j,U){this.f=new C.$Uc;const z=this.f.add(new I),ee=this.f.add(new C.$5c);function V(W){ee.set(W,z.add(U(W)))}for(const W of F)V(W);this.f.add(B(W=>{V(W)})),this.f.add(j(W=>{ee.deleteAndDispose(W)})),this.event=z.event}dispose(){this.f.dispose()}}e.$te=A;class ${constructor(){this.f=[]}wrapEvent(F,B,j){return(U,z,ee)=>F(V=>{const W=this.f[this.f.length-1];if(!B){W?W.buffers.push(()=>U.call(z,V)):U.call(z,V);return}const J=W;if(!J){U.call(z,B(j,V));return}J.items??=[],J.items.push(V),J.buffers.length===0&&W.buffers.push(()=>{J.reducedResult??=j?J.items.reduce(B,j):J.items.reduce(B),U.call(z,J.reducedResult)})},void 0,ee)}bufferEvents(F){const B={buffers:new Array};this.f.push(B);const j=F();return this.f.pop(),B.buffers.forEach(U=>U()),j}}e.$ue=$;class v{constructor(){this.f=!1,this.g=k.None,this.h=C.$Vc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class M{static const(F){return new N(F)}constructor(F){this.g=F,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$we=M;class N{constructor(F){this.value=F,this.onDidChange=k.None}}}),define(ke[20],Ie([1,0,4]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=O;const h=Object.freeze(function(b,c){const k=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(k)}}});var C;(function(b){function c(k){return k===b.None||k===b.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(C||(e.CancellationToken=C={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=C.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=C.None}}e.$xe=T;function O(b){const c=new T;return b.add({dispose(){c.cancel()}}),c.token}}),define(ke[186],Ie([1,0,20]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=C;class h{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new r.$xe,c=this.b(b.token);return this.a={promise:c,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$0e=h;function C(O){return O}class R{constructor(b,c){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);return this.b!==c&&(this.b=c,this.a=this.c(b)),this.a}}e.$_e=R;class T{get cachedValues(){return this.a}constructor(b,c){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);if(this.b.has(c))return this.b.get(c);const k=this.c(b);return this.a.set(b,k),this.b.set(c,k),k}}e.$af=T}),define(ke[187],Ie([1,0,4,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.$ht=e.$gt=e.ScrollbarVisibility=void 0;var C;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class R{constructor(w,a,m,p,f,i,s){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,m=m|0,p=p|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=p,this.rawScrollTop=s,a<0&&(a=0),p+a>m&&(p=m-a),p<0&&(p=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=p,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new R(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new R(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const m=this.width!==w.width,p=this.scrollWidth!==w.scrollWidth,f=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,s=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:p,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.$gt=R;class T extends h.$Vc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$me),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new R(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const m=this.g.withScrollDimensions(w,a);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let p;a?p=new k(this.h.from,m,this.h.startTime,this.h.duration):p=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=p}else{const m=this.g.withScrollPosition(w);this.h=k.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,a)))}}e.$ht=T;class O{constructor(w,a,m){this.scrollLeft=w,this.scrollTop=a,this.isDone=m}}e.$it=O;function b(P,w){const a=w-P;return function(m){return P+a*u(m)}}function c(P,w,a){return function(m){return m<a?P(m/a):w((m-a)/(1-a))}}class k{constructor(w,a,m,p){this.from=w,this.to=a,this.duration=p,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,m){if(Math.abs(w-a)>2.5*m){let f,i;return w<a?(f=w+.75*m,i=a-.75*m):(f=w-.75*m,i=a+.75*m),c(b(w,f),b(i,a),.33)}return b(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const m=this.c(a),p=this.d(a);return new O(m,p,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,m){return k.start(w,a,m)}static start(w,a,m){m=m+10;const p=Date.now()-10;return new k(w,a,p,m)}}e.$jt=k;function y(P){return Math.pow(P,3)}function u(P){return 1-y(1-P)}}),define(ke[105],Ie([1,0,13,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=C,e.$Ae=R,e.$Be=T,e.$Ce=O,e.$De=c,e.$Ee=k,e.$Fe=y,e.$Ge=u,e.$He=P,e.$Ie=w,e.$Je=a,e.$Ke=m,e.$Le=p,e.$Me=f,e.$Ne=i;function C(s){const t=s;return t?typeof t.read=="function":!1}function R(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function T(s){const t=s;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(s,t){return new b(s,t)}class b{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,r.$Z)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(o);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function k(s,t,o){const n=[];let d;for(;(d=s.read())!==null&&n.length<o;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function y(s,t){return new Promise((o,n)=>{const d=[];u(s,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):o(void 0)},onEnd:()=>{o(t?t(d):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function P(s,t){return new Promise((o,n)=>{const d=new h.$Uc,l=[],g=S=>{if(l.push(S),l.length>t)return d.dispose(),s.pause(),o({stream:s,buffer:l,ended:!1})},E=S=>(d.dispose(),n(S)),D=()=>(d.dispose(),o({stream:s,buffer:l,ended:!0}));d.add((0,h.$Tc)(()=>s.removeListener("error",E))),s.on("error",E),d.add((0,h.$Tc)(()=>s.removeListener("end",D))),s.on("end",D),d.add((0,h.$Tc)(()=>s.removeListener("data",g))),s.on("data",g)})}function w(s,t){const o=O(t);return o.end(s),o}function a(){const s=O(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function p(s,t,o){const n=O(o);return u(s,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?o([s,d]):s)}}}function i(s,t,o){let n=!1;const d=O(o);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(o([s,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(s)),d.end()}}),d}}),define(ke[21],Ie([1,0,50,105]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=k,e.$Re=y,e.$Se=u,e.$Te=P,e.$Ue=w,e.$Ve=a,e.$We=m,e.$Xe=p,e.$Ye=f,e.$Ze=i,e.$1e=s,e.$2e=t,e.$3e=o,e.$4e=n,e.$5e=d,e.$6e=l,e.$7e=g,e.$8e=E,e.$9e=I,h=We(h);const C=typeof Buffer<"u",R=new r.$U(()=>new Uint8Array(256));let T,O;class b{static alloc($){return C?new b(Buffer.allocUnsafe($)):new b(new Uint8Array($))}static wrap($){return C&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new b($)}static fromString($,v){return!(v?.dontUseNodeBuffer||!1)&&C?new b(Buffer.from($)):(T||(T=new TextEncoder),new b(T.encode($)))}static fromByteArray($){const v=b.alloc($.length);for(let M=0,N=$.length;M<N;M++)v.buffer[M]=$[M];return v}static concat($,v){if(typeof v>"u"){v=0;for(let L=0,F=$.length;L<F;L++)v+=$[L].byteLength}const M=b.alloc(v);let N=0;for(let L=0,F=$.length;L<F;L++){const B=$[L];M.set(B,N),N+=B.byteLength}return M}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=b.alloc(this.byteLength);return $.set(this),$}toString(){return C?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice($,v){return new b(this.buffer.subarray($,v))}set($,v){if($ instanceof b)this.buffer.set($.buffer,v);else if($ instanceof Uint8Array)this.buffer.set($,v);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),v);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return u(this.buffer,$)}writeUInt32BE($,v){P(this.buffer,$,v)}readUInt32LE($){return w(this.buffer,$)}writeUInt32LE($,v){a(this.buffer,$,v)}readUInt8($){return m(this.buffer,$)}writeUInt8($,v){p(this.buffer,$,v)}indexOf($,v=0){return c(this.buffer,$ instanceof b?$.buffer:$,v)}}e.$Oe=b;function c(A,$,v=0){const M=$.byteLength,N=A.byteLength;if(M===0)return 0;if(M===1)return A.indexOf($[0]);if(M>N-v)return-1;const L=R.value;L.fill($.length);for(let U=0;U<$.length;U++)L[$[U]]=$.length-U-1;let F=v+$.length-1,B=F,j=-1;for(;F<N;)if(A[F]===$[B]){if(B===0){j=F;break}F--,B--}else F+=Math.max($.length-B,L[A[F]]),B=$.length-1;return j}function k(A,$){return A[$+0]<<0>>>0|A[$+1]<<8>>>0}function y(A,$,v){A[v+0]=$&255,$=$>>>8,A[v+1]=$&255}function u(A,$){return A[$]*2**24+A[$+1]*2**16+A[$+2]*2**8+A[$+3]}function P(A,$,v){A[v+3]=$,$=$>>>8,A[v+2]=$,$=$>>>8,A[v+1]=$,$=$>>>8,A[v]=$}function w(A,$){return A[$+0]<<0>>>0|A[$+1]<<8>>>0|A[$+2]<<16>>>0|A[$+3]<<24>>>0}function a(A,$,v){A[v+0]=$&255,$=$>>>8,A[v+1]=$&255,$=$>>>8,A[v+2]=$&255,$=$>>>8,A[v+3]=$&255}function m(A,$){return A[$]}function p(A,$,v){A[v]=$}function f(A){return h.$De(A,$=>b.concat($))}function i(A){return h.$Ke(A)}function s(A){return h.$Fe(A,$=>b.concat($))}async function t(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await s(A.stream)])}function o(A){return h.$Ie(A,$=>b.concat($))}function n(A){return h.$Le(A,{data:$=>typeof $=="string"?b.fromString($):b.wrap($)},$=>b.concat($))}function d(A){return h.$Ce($=>b.concat($),A)}function l(A,$){return h.$Me(A,$,v=>b.concat(v))}function g(A,$){return h.$Ne(A,$,v=>b.concat(v))}function E(A){let $=0,v=0,M=0;const N=new Uint8Array(Math.floor(A.length/4*3)),L=B=>{switch(v){case 3:N[M++]=$|B,v=0;break;case 2:N[M++]=$|B>>>2,$=B<<6,v=3;break;case 1:N[M++]=$|B>>>4,$=B<<4,v=2;break;default:$=B<<2,v=1}};for(let B=0;B<A.length;B++){const j=A.charCodeAt(B);if(j>=65&&j<=90)L(j-65);else if(j>=97&&j<=122)L(j-97+26);else if(j>=48&&j<=57)L(j-48+52);else if(j===43||j===45)L(62);else if(j===47||j===95)L(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${A[B]}`)}}const F=M;for(;v>0;)L(0);return b.wrap(N).slice(0,F)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:A},$=!0,v=!1){const M=v?S:D;let N="";const L=A.byteLength%3;let F=0;for(;F<A.byteLength-L;F+=3){const B=A[F+0],j=A[F+1],U=A[F+2];N+=M[B>>>2],N+=M[(B<<4|j>>>4)&63],N+=M[(j<<2|U>>>6)&63],N+=M[U&63]}if(L===1){const B=A[F+0];N+=M[B>>>2],N+=M[B<<4&63],$&&(N+="==")}else if(L===2){const B=A[F+0],j=A[F+1];N+=M[B>>>2],N+=M[(B<<4|j>>>4)&63],N+=M[j<<2&63],$&&(N+="=")}return N}}),define(ke[188],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ke[17],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=r,e.$gg=h,e.$hg=C,e.$ig=R,e.$jg=T,e.$kg=O,e.$lg=b,e.$mg=c,e.$ng=k,e.$og=y,e.$pg=u,e.$qg=P,e.$rg=w,e.$sg=m,e.$tg=p,e.$ug=f,e.$vg=i,e.$wg=s,e.$xg=t;function r(o){return typeof o=="string"}function h(o){return Array.isArray(o)&&o.every(n=>r(n))}function C(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function T(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function b(o){return o===!0||o===!1}function c(o){return typeof o>"u"}function k(o){return!y(o)}function y(o){return c(o)||o===null}function u(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function P(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const n=[];for(let d=0;d<o.length;d++){const l=o[d];if(y(l))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);n.push(l)}return n}const a=Object.prototype.hasOwnProperty;function m(o){if(!C(o))return!1;for(const n in o)if(a.call(o,n))return!1;return!0}function p(o){return typeof o=="function"}function f(...o){return o.length>0&&o.every(p)}function i(o,n){const d=Math.min(o.length,n.length);for(let l=0;l<d;l++)s(o[l],n[l])}function s(o,n){if(r(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(o instanceof n)return}catch{}if(!y(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(o){return o}}),define(ke[106],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=C,e.$2j=R;const h=Object.create(null);function C(T,O){if((0,r.$fg)(O)){const b=h[O];if(b===void 0)throw new Error(`${T} references an unknown codicon: ${O}`);O=b}return h[T]=O,{id:T}}function R(){return h}}),define(ke[189],Ie([1,0,106]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,r.$1j)("add",6e4),plus:(0,r.$1j)("plus",6e4),gistNew:(0,r.$1j)("gist-new",6e4),repoCreate:(0,r.$1j)("repo-create",6e4),lightbulb:(0,r.$1j)("lightbulb",60001),lightBulb:(0,r.$1j)("light-bulb",60001),repo:(0,r.$1j)("repo",60002),repoDelete:(0,r.$1j)("repo-delete",60002),gistFork:(0,r.$1j)("gist-fork",60003),repoForked:(0,r.$1j)("repo-forked",60003),gitPullRequest:(0,r.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,r.$1j)("record-keys",60005),keyboard:(0,r.$1j)("keyboard",60005),tag:(0,r.$1j)("tag",60006),gitPullRequestLabel:(0,r.$1j)("git-pull-request-label",60006),tagAdd:(0,r.$1j)("tag-add",60006),tagRemove:(0,r.$1j)("tag-remove",60006),person:(0,r.$1j)("person",60007),personFollow:(0,r.$1j)("person-follow",60007),personOutline:(0,r.$1j)("person-outline",60007),personFilled:(0,r.$1j)("person-filled",60007),gitBranch:(0,r.$1j)("git-branch",60008),gitBranchCreate:(0,r.$1j)("git-branch-create",60008),gitBranchDelete:(0,r.$1j)("git-branch-delete",60008),sourceControl:(0,r.$1j)("source-control",60008),mirror:(0,r.$1j)("mirror",60009),mirrorPublic:(0,r.$1j)("mirror-public",60009),star:(0,r.$1j)("star",60010),starAdd:(0,r.$1j)("star-add",60010),starDelete:(0,r.$1j)("star-delete",60010),starEmpty:(0,r.$1j)("star-empty",60010),comment:(0,r.$1j)("comment",60011),commentAdd:(0,r.$1j)("comment-add",60011),alert:(0,r.$1j)("alert",60012),warning:(0,r.$1j)("warning",60012),search:(0,r.$1j)("search",60013),searchSave:(0,r.$1j)("search-save",60013),logOut:(0,r.$1j)("log-out",60014),signOut:(0,r.$1j)("sign-out",60014),logIn:(0,r.$1j)("log-in",60015),signIn:(0,r.$1j)("sign-in",60015),eye:(0,r.$1j)("eye",60016),eyeUnwatch:(0,r.$1j)("eye-unwatch",60016),eyeWatch:(0,r.$1j)("eye-watch",60016),circleFilled:(0,r.$1j)("circle-filled",60017),primitiveDot:(0,r.$1j)("primitive-dot",60017),closeDirty:(0,r.$1j)("close-dirty",60017),debugBreakpoint:(0,r.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,r.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,r.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,r.$1j)("primitive-square",60018),edit:(0,r.$1j)("edit",60019),pencil:(0,r.$1j)("pencil",60019),info:(0,r.$1j)("info",60020),issueOpened:(0,r.$1j)("issue-opened",60020),gistPrivate:(0,r.$1j)("gist-private",60021),gitForkPrivate:(0,r.$1j)("git-fork-private",60021),lock:(0,r.$1j)("lock",60021),mirrorPrivate:(0,r.$1j)("mirror-private",60021),close:(0,r.$1j)("close",60022),removeClose:(0,r.$1j)("remove-close",60022),x:(0,r.$1j)("x",60022),repoSync:(0,r.$1j)("repo-sync",60023),sync:(0,r.$1j)("sync",60023),clone:(0,r.$1j)("clone",60024),desktopDownload:(0,r.$1j)("desktop-download",60024),beaker:(0,r.$1j)("beaker",60025),microscope:(0,r.$1j)("microscope",60025),vm:(0,r.$1j)("vm",60026),deviceDesktop:(0,r.$1j)("device-desktop",60026),file:(0,r.$1j)("file",60027),fileText:(0,r.$1j)("file-text",60027),more:(0,r.$1j)("more",60028),ellipsis:(0,r.$1j)("ellipsis",60028),kebabHorizontal:(0,r.$1j)("kebab-horizontal",60028),mailReply:(0,r.$1j)("mail-reply",60029),reply:(0,r.$1j)("reply",60029),organization:(0,r.$1j)("organization",60030),organizationFilled:(0,r.$1j)("organization-filled",60030),organizationOutline:(0,r.$1j)("organization-outline",60030),newFile:(0,r.$1j)("new-file",60031),fileAdd:(0,r.$1j)("file-add",60031),newFolder:(0,r.$1j)("new-folder",60032),fileDirectoryCreate:(0,r.$1j)("file-directory-create",60032),trash:(0,r.$1j)("trash",60033),trashcan:(0,r.$1j)("trashcan",60033),history:(0,r.$1j)("history",60034),clock:(0,r.$1j)("clock",60034),folder:(0,r.$1j)("folder",60035),fileDirectory:(0,r.$1j)("file-directory",60035),symbolFolder:(0,r.$1j)("symbol-folder",60035),logoGithub:(0,r.$1j)("logo-github",60036),markGithub:(0,r.$1j)("mark-github",60036),github:(0,r.$1j)("github",60036),terminal:(0,r.$1j)("terminal",60037),console:(0,r.$1j)("console",60037),repl:(0,r.$1j)("repl",60037),zap:(0,r.$1j)("zap",60038),symbolEvent:(0,r.$1j)("symbol-event",60038),error:(0,r.$1j)("error",60039),stop:(0,r.$1j)("stop",60039),variable:(0,r.$1j)("variable",60040),symbolVariable:(0,r.$1j)("symbol-variable",60040),array:(0,r.$1j)("array",60042),symbolArray:(0,r.$1j)("symbol-array",60042),symbolModule:(0,r.$1j)("symbol-module",60043),symbolPackage:(0,r.$1j)("symbol-package",60043),symbolNamespace:(0,r.$1j)("symbol-namespace",60043),symbolObject:(0,r.$1j)("symbol-object",60043),symbolMethod:(0,r.$1j)("symbol-method",60044),symbolFunction:(0,r.$1j)("symbol-function",60044),symbolConstructor:(0,r.$1j)("symbol-constructor",60044),symbolBoolean:(0,r.$1j)("symbol-boolean",60047),symbolNull:(0,r.$1j)("symbol-null",60047),symbolNumeric:(0,r.$1j)("symbol-numeric",60048),symbolNumber:(0,r.$1j)("symbol-number",60048),symbolStructure:(0,r.$1j)("symbol-structure",60049),symbolStruct:(0,r.$1j)("symbol-struct",60049),symbolParameter:(0,r.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,r.$1j)("symbol-type-parameter",60050),symbolKey:(0,r.$1j)("symbol-key",60051),symbolText:(0,r.$1j)("symbol-text",60051),symbolReference:(0,r.$1j)("symbol-reference",60052),goToFile:(0,r.$1j)("go-to-file",60052),symbolEnum:(0,r.$1j)("symbol-enum",60053),symbolValue:(0,r.$1j)("symbol-value",60053),symbolRuler:(0,r.$1j)("symbol-ruler",60054),symbolUnit:(0,r.$1j)("symbol-unit",60054),activateBreakpoints:(0,r.$1j)("activate-breakpoints",60055),archive:(0,r.$1j)("archive",60056),arrowBoth:(0,r.$1j)("arrow-both",60057),arrowDown:(0,r.$1j)("arrow-down",60058),arrowLeft:(0,r.$1j)("arrow-left",60059),arrowRight:(0,r.$1j)("arrow-right",60060),arrowSmallDown:(0,r.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,r.$1j)("arrow-small-left",60062),arrowSmallRight:(0,r.$1j)("arrow-small-right",60063),arrowSmallUp:(0,r.$1j)("arrow-small-up",60064),arrowUp:(0,r.$1j)("arrow-up",60065),bell:(0,r.$1j)("bell",60066),bold:(0,r.$1j)("bold",60067),book:(0,r.$1j)("book",60068),bookmark:(0,r.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$1j)("briefcase",60076),broadcast:(0,r.$1j)("broadcast",60077),browser:(0,r.$1j)("browser",60078),bug:(0,r.$1j)("bug",60079),calendar:(0,r.$1j)("calendar",60080),caseSensitive:(0,r.$1j)("case-sensitive",60081),check:(0,r.$1j)("check",60082),checklist:(0,r.$1j)("checklist",60083),chevronDown:(0,r.$1j)("chevron-down",60084),chevronLeft:(0,r.$1j)("chevron-left",60085),chevronRight:(0,r.$1j)("chevron-right",60086),chevronUp:(0,r.$1j)("chevron-up",60087),chromeClose:(0,r.$1j)("chrome-close",60088),chromeMaximize:(0,r.$1j)("chrome-maximize",60089),chromeMinimize:(0,r.$1j)("chrome-minimize",60090),chromeRestore:(0,r.$1j)("chrome-restore",60091),circleOutline:(0,r.$1j)("circle-outline",60092),circle:(0,r.$1j)("circle",60092),debugBreakpointUnverified:(0,r.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$1j)("circle-slash",60093),circuitBoard:(0,r.$1j)("circuit-board",60094),clearAll:(0,r.$1j)("clear-all",60095),clippy:(0,r.$1j)("clippy",60096),closeAll:(0,r.$1j)("close-all",60097),cloudDownload:(0,r.$1j)("cloud-download",60098),cloudUpload:(0,r.$1j)("cloud-upload",60099),code:(0,r.$1j)("code",60100),collapseAll:(0,r.$1j)("collapse-all",60101),colorMode:(0,r.$1j)("color-mode",60102),commentDiscussion:(0,r.$1j)("comment-discussion",60103),creditCard:(0,r.$1j)("credit-card",60105),dash:(0,r.$1j)("dash",60108),dashboard:(0,r.$1j)("dashboard",60109),database:(0,r.$1j)("database",60110),debugContinue:(0,r.$1j)("debug-continue",60111),debugDisconnect:(0,r.$1j)("debug-disconnect",60112),debugPause:(0,r.$1j)("debug-pause",60113),debugRestart:(0,r.$1j)("debug-restart",60114),debugStart:(0,r.$1j)("debug-start",60115),debugStepInto:(0,r.$1j)("debug-step-into",60116),debugStepOut:(0,r.$1j)("debug-step-out",60117),debugStepOver:(0,r.$1j)("debug-step-over",60118),debugStop:(0,r.$1j)("debug-stop",60119),debug:(0,r.$1j)("debug",60120),deviceCameraVideo:(0,r.$1j)("device-camera-video",60121),deviceCamera:(0,r.$1j)("device-camera",60122),deviceMobile:(0,r.$1j)("device-mobile",60123),diffAdded:(0,r.$1j)("diff-added",60124),diffIgnored:(0,r.$1j)("diff-ignored",60125),diffModified:(0,r.$1j)("diff-modified",60126),diffRemoved:(0,r.$1j)("diff-removed",60127),diffRenamed:(0,r.$1j)("diff-renamed",60128),diff:(0,r.$1j)("diff",60129),diffSidebyside:(0,r.$1j)("diff-sidebyside",60129),discard:(0,r.$1j)("discard",60130),editorLayout:(0,r.$1j)("editor-layout",60131),emptyWindow:(0,r.$1j)("empty-window",60132),exclude:(0,r.$1j)("exclude",60133),extensions:(0,r.$1j)("extensions",60134),eyeClosed:(0,r.$1j)("eye-closed",60135),fileBinary:(0,r.$1j)("file-binary",60136),fileCode:(0,r.$1j)("file-code",60137),fileMedia:(0,r.$1j)("file-media",60138),filePdf:(0,r.$1j)("file-pdf",60139),fileSubmodule:(0,r.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,r.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$1j)("file-symlink-file",60142),fileZip:(0,r.$1j)("file-zip",60143),files:(0,r.$1j)("files",60144),filter:(0,r.$1j)("filter",60145),flame:(0,r.$1j)("flame",60146),foldDown:(0,r.$1j)("fold-down",60147),foldUp:(0,r.$1j)("fold-up",60148),fold:(0,r.$1j)("fold",60149),folderActive:(0,r.$1j)("folder-active",60150),folderOpened:(0,r.$1j)("folder-opened",60151),gear:(0,r.$1j)("gear",60152),gift:(0,r.$1j)("gift",60153),gistSecret:(0,r.$1j)("gist-secret",60154),gist:(0,r.$1j)("gist",60155),gitCommit:(0,r.$1j)("git-commit",60156),gitCompare:(0,r.$1j)("git-compare",60157),compareChanges:(0,r.$1j)("compare-changes",60157),gitMerge:(0,r.$1j)("git-merge",60158),githubAction:(0,r.$1j)("github-action",60159),githubAlt:(0,r.$1j)("github-alt",60160),globe:(0,r.$1j)("globe",60161),grabber:(0,r.$1j)("grabber",60162),graph:(0,r.$1j)("graph",60163),gripper:(0,r.$1j)("gripper",60164),heart:(0,r.$1j)("heart",60165),home:(0,r.$1j)("home",60166),horizontalRule:(0,r.$1j)("horizontal-rule",60167),hubot:(0,r.$1j)("hubot",60168),inbox:(0,r.$1j)("inbox",60169),issueReopened:(0,r.$1j)("issue-reopened",60171),issues:(0,r.$1j)("issues",60172),italic:(0,r.$1j)("italic",60173),jersey:(0,r.$1j)("jersey",60174),json:(0,r.$1j)("json",60175),kebabVertical:(0,r.$1j)("kebab-vertical",60176),key:(0,r.$1j)("key",60177),law:(0,r.$1j)("law",60178),lightbulbAutofix:(0,r.$1j)("lightbulb-autofix",60179),linkExternal:(0,r.$1j)("link-external",60180),link:(0,r.$1j)("link",60181),listOrdered:(0,r.$1j)("list-ordered",60182),listUnordered:(0,r.$1j)("list-unordered",60183),liveShare:(0,r.$1j)("live-share",60184),loading:(0,r.$1j)("loading",60185),location:(0,r.$1j)("location",60186),mailRead:(0,r.$1j)("mail-read",60187),mail:(0,r.$1j)("mail",60188),markdown:(0,r.$1j)("markdown",60189),megaphone:(0,r.$1j)("megaphone",60190),mention:(0,r.$1j)("mention",60191),milestone:(0,r.$1j)("milestone",60192),gitPullRequestMilestone:(0,r.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,r.$1j)("mortar-board",60193),move:(0,r.$1j)("move",60194),multipleWindows:(0,r.$1j)("multiple-windows",60195),mute:(0,r.$1j)("mute",60196),noNewline:(0,r.$1j)("no-newline",60197),note:(0,r.$1j)("note",60198),octoface:(0,r.$1j)("octoface",60199),openPreview:(0,r.$1j)("open-preview",60200),package:(0,r.$1j)("package",60201),paintcan:(0,r.$1j)("paintcan",60202),pin:(0,r.$1j)("pin",60203),play:(0,r.$1j)("play",60204),run:(0,r.$1j)("run",60204),plug:(0,r.$1j)("plug",60205),preserveCase:(0,r.$1j)("preserve-case",60206),preview:(0,r.$1j)("preview",60207),project:(0,r.$1j)("project",60208),pulse:(0,r.$1j)("pulse",60209),question:(0,r.$1j)("question",60210),quote:(0,r.$1j)("quote",60211),radioTower:(0,r.$1j)("radio-tower",60212),reactions:(0,r.$1j)("reactions",60213),references:(0,r.$1j)("references",60214),refresh:(0,r.$1j)("refresh",60215),regex:(0,r.$1j)("regex",60216),remoteExplorer:(0,r.$1j)("remote-explorer",60217),remote:(0,r.$1j)("remote",60218),remove:(0,r.$1j)("remove",60219),replaceAll:(0,r.$1j)("replace-all",60220),replace:(0,r.$1j)("replace",60221),repoClone:(0,r.$1j)("repo-clone",60222),repoForcePush:(0,r.$1j)("repo-force-push",60223),repoPull:(0,r.$1j)("repo-pull",60224),repoPush:(0,r.$1j)("repo-push",60225),report:(0,r.$1j)("report",60226),requestChanges:(0,r.$1j)("request-changes",60227),rocket:(0,r.$1j)("rocket",60228),rootFolderOpened:(0,r.$1j)("root-folder-opened",60229),rootFolder:(0,r.$1j)("root-folder",60230),rss:(0,r.$1j)("rss",60231),ruby:(0,r.$1j)("ruby",60232),saveAll:(0,r.$1j)("save-all",60233),saveAs:(0,r.$1j)("save-as",60234),save:(0,r.$1j)("save",60235),screenFull:(0,r.$1j)("screen-full",60236),screenNormal:(0,r.$1j)("screen-normal",60237),searchStop:(0,r.$1j)("search-stop",60238),server:(0,r.$1j)("server",60240),settingsGear:(0,r.$1j)("settings-gear",60241),settings:(0,r.$1j)("settings",60242),shield:(0,r.$1j)("shield",60243),smiley:(0,r.$1j)("smiley",60244),sortPrecedence:(0,r.$1j)("sort-precedence",60245),splitHorizontal:(0,r.$1j)("split-horizontal",60246),splitVertical:(0,r.$1j)("split-vertical",60247),squirrel:(0,r.$1j)("squirrel",60248),starFull:(0,r.$1j)("star-full",60249),starHalf:(0,r.$1j)("star-half",60250),symbolClass:(0,r.$1j)("symbol-class",60251),symbolColor:(0,r.$1j)("symbol-color",60252),symbolConstant:(0,r.$1j)("symbol-constant",60253),symbolEnumMember:(0,r.$1j)("symbol-enum-member",60254),symbolField:(0,r.$1j)("symbol-field",60255),symbolFile:(0,r.$1j)("symbol-file",60256),symbolInterface:(0,r.$1j)("symbol-interface",60257),symbolKeyword:(0,r.$1j)("symbol-keyword",60258),symbolMisc:(0,r.$1j)("symbol-misc",60259),symbolOperator:(0,r.$1j)("symbol-operator",60260),symbolProperty:(0,r.$1j)("symbol-property",60261),wrench:(0,r.$1j)("wrench",60261),wrenchSubaction:(0,r.$1j)("wrench-subaction",60261),symbolSnippet:(0,r.$1j)("symbol-snippet",60262),tasklist:(0,r.$1j)("tasklist",60263),telescope:(0,r.$1j)("telescope",60264),textSize:(0,r.$1j)("text-size",60265),threeBars:(0,r.$1j)("three-bars",60266),thumbsdown:(0,r.$1j)("thumbsdown",60267),thumbsup:(0,r.$1j)("thumbsup",60268),tools:(0,r.$1j)("tools",60269),triangleDown:(0,r.$1j)("triangle-down",60270),triangleLeft:(0,r.$1j)("triangle-left",60271),triangleRight:(0,r.$1j)("triangle-right",60272),triangleUp:(0,r.$1j)("triangle-up",60273),twitter:(0,r.$1j)("twitter",60274),unfold:(0,r.$1j)("unfold",60275),unlock:(0,r.$1j)("unlock",60276),unmute:(0,r.$1j)("unmute",60277),unverified:(0,r.$1j)("unverified",60278),verified:(0,r.$1j)("verified",60279),versions:(0,r.$1j)("versions",60280),vmActive:(0,r.$1j)("vm-active",60281),vmOutline:(0,r.$1j)("vm-outline",60282),vmRunning:(0,r.$1j)("vm-running",60283),watch:(0,r.$1j)("watch",60284),whitespace:(0,r.$1j)("whitespace",60285),wholeWord:(0,r.$1j)("whole-word",60286),window:(0,r.$1j)("window",60287),wordWrap:(0,r.$1j)("word-wrap",60288),zoomIn:(0,r.$1j)("zoom-in",60289),zoomOut:(0,r.$1j)("zoom-out",60290),listFilter:(0,r.$1j)("list-filter",60291),listFlat:(0,r.$1j)("list-flat",60292),listSelection:(0,r.$1j)("list-selection",60293),selection:(0,r.$1j)("selection",60293),listTree:(0,r.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$1j)("circle-small-filled",60298),debugStackframeDot:(0,r.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,r.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,r.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$1j)("symbol-string",60301),debugReverseContinue:(0,r.$1j)("debug-reverse-continue",60302),debugStepBack:(0,r.$1j)("debug-step-back",60303),debugRestartFrame:(0,r.$1j)("debug-restart-frame",60304),debugAlt:(0,r.$1j)("debug-alt",60305),callIncoming:(0,r.$1j)("call-incoming",60306),callOutgoing:(0,r.$1j)("call-outgoing",60307),menu:(0,r.$1j)("menu",60308),expandAll:(0,r.$1j)("expand-all",60309),feedback:(0,r.$1j)("feedback",60310),gitPullRequestReviewer:(0,r.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,r.$1j)("ungroup-by-ref-type",60312),account:(0,r.$1j)("account",60313),gitPullRequestAssignee:(0,r.$1j)("git-pull-request-assignee",60313),bellDot:(0,r.$1j)("bell-dot",60314),debugConsole:(0,r.$1j)("debug-console",60315),library:(0,r.$1j)("library",60316),output:(0,r.$1j)("output",60317),runAll:(0,r.$1j)("run-all",60318),syncIgnored:(0,r.$1j)("sync-ignored",60319),pinned:(0,r.$1j)("pinned",60320),githubInverted:(0,r.$1j)("github-inverted",60321),serverProcess:(0,r.$1j)("server-process",60322),serverEnvironment:(0,r.$1j)("server-environment",60323),pass:(0,r.$1j)("pass",60324),issueClosed:(0,r.$1j)("issue-closed",60324),stopCircle:(0,r.$1j)("stop-circle",60325),playCircle:(0,r.$1j)("play-circle",60326),record:(0,r.$1j)("record",60327),debugAltSmall:(0,r.$1j)("debug-alt-small",60328),vmConnect:(0,r.$1j)("vm-connect",60329),cloud:(0,r.$1j)("cloud",60330),merge:(0,r.$1j)("merge",60331),export:(0,r.$1j)("export",60332),graphLeft:(0,r.$1j)("graph-left",60333),magnet:(0,r.$1j)("magnet",60334),notebook:(0,r.$1j)("notebook",60335),redo:(0,r.$1j)("redo",60336),checkAll:(0,r.$1j)("check-all",60337),pinnedDirty:(0,r.$1j)("pinned-dirty",60338),passFilled:(0,r.$1j)("pass-filled",60339),circleLargeFilled:(0,r.$1j)("circle-large-filled",60340),circleLarge:(0,r.$1j)("circle-large",60341),circleLargeOutline:(0,r.$1j)("circle-large-outline",60341),combine:(0,r.$1j)("combine",60342),gather:(0,r.$1j)("gather",60342),table:(0,r.$1j)("table",60343),variableGroup:(0,r.$1j)("variable-group",60344),typeHierarchy:(0,r.$1j)("type-hierarchy",60345),typeHierarchySub:(0,r.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$1j)("git-pull-request-create",60348),runAbove:(0,r.$1j)("run-above",60349),runBelow:(0,r.$1j)("run-below",60350),notebookTemplate:(0,r.$1j)("notebook-template",60351),debugRerun:(0,r.$1j)("debug-rerun",60352),workspaceTrusted:(0,r.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,r.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,r.$1j)("workspace-unknown",60355),terminalCmd:(0,r.$1j)("terminal-cmd",60356),terminalDebian:(0,r.$1j)("terminal-debian",60357),terminalLinux:(0,r.$1j)("terminal-linux",60358),terminalPowershell:(0,r.$1j)("terminal-powershell",60359),terminalTmux:(0,r.$1j)("terminal-tmux",60360),terminalUbuntu:(0,r.$1j)("terminal-ubuntu",60361),terminalBash:(0,r.$1j)("terminal-bash",60362),arrowSwap:(0,r.$1j)("arrow-swap",60363),copy:(0,r.$1j)("copy",60364),personAdd:(0,r.$1j)("person-add",60365),filterFilled:(0,r.$1j)("filter-filled",60366),wand:(0,r.$1j)("wand",60367),debugLineByLine:(0,r.$1j)("debug-line-by-line",60368),inspect:(0,r.$1j)("inspect",60369),layers:(0,r.$1j)("layers",60370),layersDot:(0,r.$1j)("layers-dot",60371),layersActive:(0,r.$1j)("layers-active",60372),compass:(0,r.$1j)("compass",60373),compassDot:(0,r.$1j)("compass-dot",60374),compassActive:(0,r.$1j)("compass-active",60375),azure:(0,r.$1j)("azure",60376),issueDraft:(0,r.$1j)("issue-draft",60377),gitPullRequestClosed:(0,r.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$1j)("git-pull-request-draft",60379),debugAll:(0,r.$1j)("debug-all",60380),debugCoverage:(0,r.$1j)("debug-coverage",60381),runErrors:(0,r.$1j)("run-errors",60382),folderLibrary:(0,r.$1j)("folder-library",60383),debugContinueSmall:(0,r.$1j)("debug-continue-small",60384),beakerStop:(0,r.$1j)("beaker-stop",60385),graphLine:(0,r.$1j)("graph-line",60386),graphScatter:(0,r.$1j)("graph-scatter",60387),pieChart:(0,r.$1j)("pie-chart",60388),bracket:(0,r.$1j)("bracket",60175),bracketDot:(0,r.$1j)("bracket-dot",60389),bracketError:(0,r.$1j)("bracket-error",60390),lockSmall:(0,r.$1j)("lock-small",60391),azureDevops:(0,r.$1j)("azure-devops",60392),verifiedFilled:(0,r.$1j)("verified-filled",60393),newline:(0,r.$1j)("newline",60394),layout:(0,r.$1j)("layout",60395),layoutActivitybarLeft:(0,r.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,r.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,r.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,r.$1j)("layout-panel-right",60401),layoutPanel:(0,r.$1j)("layout-panel",60402),layoutSidebarLeft:(0,r.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$1j)("layout-statusbar",60405),layoutMenubar:(0,r.$1j)("layout-menubar",60406),layoutCentered:(0,r.$1j)("layout-centered",60407),target:(0,r.$1j)("target",60408),indent:(0,r.$1j)("indent",60409),recordSmall:(0,r.$1j)("record-small",60410),errorSmall:(0,r.$1j)("error-small",60411),terminalDecorationError:(0,r.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,r.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,r.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$1j)("layout-sidebar-left-off",60418),blank:(0,r.$1j)("blank",60419),heartFilled:(0,r.$1j)("heart-filled",60420),map:(0,r.$1j)("map",60421),mapHorizontal:(0,r.$1j)("map-horizontal",60421),foldHorizontal:(0,r.$1j)("fold-horizontal",60421),mapFilled:(0,r.$1j)("map-filled",60422),mapHorizontalFilled:(0,r.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$1j)("fold-horizontal-filled",60422),circleSmall:(0,r.$1j)("circle-small",60423),bellSlash:(0,r.$1j)("bell-slash",60424),bellSlashDot:(0,r.$1j)("bell-slash-dot",60425),commentUnresolved:(0,r.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$1j)("search-fuzzy",60429),commentDraft:(0,r.$1j)("comment-draft",60430),send:(0,r.$1j)("send",60431),sparkle:(0,r.$1j)("sparkle",60432),insert:(0,r.$1j)("insert",60433),mic:(0,r.$1j)("mic",60434),thumbsdownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$1j)("thumbsup-filled",60436),coffee:(0,r.$1j)("coffee",60437),snake:(0,r.$1j)("snake",60438),game:(0,r.$1j)("game",60439),vr:(0,r.$1j)("vr",60440),chip:(0,r.$1j)("chip",60441),piano:(0,r.$1j)("piano",60442),music:(0,r.$1j)("music",60443),micFilled:(0,r.$1j)("mic-filled",60444),repoFetch:(0,r.$1j)("repo-fetch",60445),copilot:(0,r.$1j)("copilot",60446),lightbulbSparkle:(0,r.$1j)("lightbulb-sparkle",60447),robot:(0,r.$1j)("robot",60448),sparkleFilled:(0,r.$1j)("sparkle-filled",60449),diffSingle:(0,r.$1j)("diff-single",60450),diffMultiple:(0,r.$1j)("diff-multiple",60451),surroundWith:(0,r.$1j)("surround-with",60452),share:(0,r.$1j)("share",60453),gitStash:(0,r.$1j)("git-stash",60454),gitStashApply:(0,r.$1j)("git-stash-apply",60455),gitStashPop:(0,r.$1j)("git-stash-pop",60456),vscode:(0,r.$1j)("vscode",60457),vscodeInsiders:(0,r.$1j)("vscode-insiders",60458),codeOss:(0,r.$1j)("code-oss",60459),runCoverage:(0,r.$1j)("run-coverage",60460),runAllCoverage:(0,r.$1j)("run-all-coverage",60461),coverage:(0,r.$1j)("coverage",60462),githubProject:(0,r.$1j)("github-project",60463),mapVertical:(0,r.$1j)("map-vertical",60464),foldVertical:(0,r.$1j)("fold-vertical",60464),mapVerticalFilled:(0,r.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$1j)("fold-vertical-filled",60465),goToSearch:(0,r.$1j)("go-to-search",60466),percentage:(0,r.$1j)("percentage",60467),sortPercentage:(0,r.$1j)("sort-percentage",60467),attach:(0,r.$1j)("attach",60468)}}),define(ke[82],Ie([1,0,106,189]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=C;function C(){return Object.values(e.$6j)}e.$5j={dialogError:(0,r.$1j)("dialog-error","error"),dialogWarning:(0,r.$1j)("dialog-warning","warning"),dialogInfo:(0,r.$1j)("dialog-info","info"),dialogClose:(0,r.$1j)("dialog-close","close"),treeItemExpanded:(0,r.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$1j)("tree-filter-clear","close"),treeItemLoading:(0,r.$1j)("tree-item-loading","loading"),menuSelection:(0,r.$1j)("menu-selection","check"),menuSubmenu:(0,r.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,r.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,r.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$1j)("toolbar-more","more"),quickInputBack:(0,r.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,r.$1j)("drop-down-button",60084),symbolCustomColor:(0,r.$1j)("symbol-customcolor",60252),exportIcon:(0,r.$1j)("export",60332),workspaceUnspecified:(0,r.$1j)("workspace-unspecified",60355),newLine:(0,r.$1j)("newline",60394),thumbsDownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$1j)("thumbsup-filled",60436),gitFetch:(0,r.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$1j)("debug-breakpoint-pending",60377)},e.$6j={...h.$3j,...e.$5j}}),define(ke[24],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=h,e.$go=C,e.$ho=T,e.$io=b,e.$jo=c,e.$ko=k,e.$lo=y,e.$mo=u,e.$no=P,e.$oo=w,e.$po=a,e.$qo=m,e.$ro=p;function h(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?h(t):t}),i}function C(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(R.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.$ig)(o)&&i.push(o)}}return f}const R=Object.prototype.hasOwnProperty;function T(f,i){return O(f,i,new Set)}function O(f,i,s){if((0,r.$og)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(O(n,i,s));return o}if((0,r.$hg)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)R.call(f,n)&&(o[n]=O(f[n],i,s));return s.delete(f),o}return f}function b(f,i,s=!0){return(0,r.$hg)(f)?((0,r.$hg)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.$hg)(f[t])&&(0,r.$hg)(i[t])?b(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function c(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!c(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(o,n))return!1;for(s=0;s<o.length;s++)if(!c(f[o[s]],i[o[s]]))return!1}return!0}function k(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.$hg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function y(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],d=i[o];c(n,d)||(s[o]=d)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function P(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function w(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of w(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function p(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(ke[51],Ie([1,0,82]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=C;var h;(function(T){function O(b){return b&&typeof b=="object"&&typeof b.id=="string"}T.isThemeColor=O})(h||(e.ThemeColor=h={}));function C(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(f){const i=O.exec(f.id);if(!i)return b(r.$6j.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}T.asClassNameArray=b;function c(f){return b(f).join(" ")}T.asClassName=c;function k(f){return"."+b(f).join(".")}T.asCSSSelector=k;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||h.isThemeColor(f.color))}T.isThemeIcon=y;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function P(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}T.fromString=P;function w(f){return{id:f}}T.fromId=w;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}T.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}T.getModifier=m;function p(f,i){return f.id===i.id&&f.color?.id===i.color?.id}T.isEqual=p})(R||(e.ThemeIcon=R={}))}),define(ke[83],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=h,e.$cf=C;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function C(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ke[12],Ie([1,0,186,26,50,83]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=b,e.$ff=k,e.$gf=y,e.$hf=u,e.$if=P,e.$jf=w,e.$kf=a,e.$lf=m,e.$mf=p,e.$nf=f,e.$of=i,e.$pf=s,e.$qf=t,e.$rf=o,e.$sf=n,e.$tf=d,e.$uf=l,e.$vf=g,e.$wf=E,e.$xf=D,e.$yf=S,e.$zf=I,e.$Af=A,e.$Bf=$,e.$Cf=v,e.$Df=M,e.$Ef=N,e.$Ff=L,e.$Gf=F,e.$Hf=B,e.$If=j,e.$Jf=U,e.$Kf=z,e.$Lf=ee,e.$Mf=V,e.$Nf=W,e.$Qf=ne,e.$Rf=ye,e.$Sf=ge,e.$Tf=Y,e.$Uf=ve,e.$Vf=ae,e.$Xf=se,e.$Yf=X,e.$Zf=re,e.$1f=pe,e.$2f=Me,e.$3f=ze,e.$4f=De,e.$6f=Ce,e.$7f=H,e.$8f=G,e.$9f=Z,e.$0f=x,e.$$f=de,e.$_f=Ee,e.$ag=Te,e.$bg=st;function T(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const O=/{(\d+)}/g;function b(Pe,...Be){return Be.length===0?Pe:Pe.replace(O,function(Qe,Ne){const je=parseInt(Ne,10);return isNaN(je)||je<0||je>=Be.length?Qe:Be[je]})}const c=/{([^}]+)}/g;function k(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(c,(Qe,Ne)=>Be[Ne]??Qe)}function y(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Pe,Be){let Qe=0,Ne=Pe.indexOf(Be);for(;Ne!==-1;)Qe++,Ne=Pe.indexOf(Be,Ne+Be.length);return Qe}function a(Pe,Be,Qe="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Qe}`}function m(Pe,Be,Qe="\u2026"){if(Pe.length<=Be)return Pe;const Ne=Math.ceil(Be/2)-Qe.length/2,je=Math.floor(Be/2)-Qe.length/2;return`${Pe.substr(0,Ne)}${Qe}${Pe.substr(Pe.length-je)}`}function p(Pe,Be=" "){const Qe=f(Pe,Be);return i(Qe,Be)}function f(Pe,Be){if(!Pe||!Be)return Pe;const Qe=Be.length;if(Qe===0||Pe.length===0)return Pe;let Ne=0;for(;Pe.indexOf(Be,Ne)===Ne;)Ne=Ne+Qe;return Pe.substring(Ne)}function i(Pe,Be){if(!Pe||!Be)return Pe;const Qe=Be.length,Ne=Pe.length;if(Qe===0||Ne===0)return Pe;let je=Ne,ue=-1;for(;ue=Pe.lastIndexOf(Be,je-1),!(ue===-1||ue+Qe!==je);){if(ue===0)return"";je=ue}return Pe.substring(0,je)}function s(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function o(Pe,Be,Qe={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=P(Pe)),Qe.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ne="";return Qe.global&&(Ne+="g"),Qe.matchCase||(Ne+="i"),Qe.multiline&&(Ne+="m"),Qe.unicode&&(Ne+="u"),new RegExp(Pe,Ne)}function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const Be=[],Qe=Pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Qe.length/2);Ne++)Be.push(Qe[2*Ne]+(Qe[2*Ne+1]??""));return Be}function g(Pe){for(let Be=0,Qe=Pe.length;Be<Qe;Be++){const Ne=Pe.charCodeAt(Be);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Be}return-1}function E(Pe,Be=0,Qe=Pe.length){for(let Ne=Be;Ne<Qe;Ne++){const je=Pe.charCodeAt(Ne);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(Be,Ne)}return Pe.substring(Be,Qe)}function D(Pe,Be=Pe.length-1){for(let Qe=Be;Qe>=0;Qe--){const Ne=Pe.charCodeAt(Qe);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Qe}return-1}function S(Pe,Be,Qe){const Ne=[];let je=0;for(const ue of Pe.matchAll(Be)){if(Ne.push(Pe.slice(je,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");je=ue.index+ue[0].length,Ne.push(Qe(ue[0],...ue.slice(1),ue.index,Pe,ue.groups))}return Ne.push(Pe.slice(je)),Promise.all(Ne).then(ue=>ue.join(""))}function I(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function A(Pe,Be,Qe=0,Ne=Pe.length,je=0,ue=Be.length){for(;Qe<Ne&&je<ue;Qe++,je++){const Xe=Pe.charCodeAt(Qe),tt=Be.charCodeAt(je);if(Xe<tt)return-1;if(Xe>tt)return 1}const he=Ne-Qe,le=ue-je;return he<le?-1:he>le?1:0}function $(Pe,Be){return v(Pe,Be,0,Pe.length,0,Be.length)}function v(Pe,Be,Qe=0,Ne=Pe.length,je=0,ue=Be.length){for(;Qe<Ne&&je<ue;Qe++,je++){let Xe=Pe.charCodeAt(Qe),tt=Be.charCodeAt(je);if(Xe===tt)continue;if(Xe>=128||tt>=128)return A(Pe.toLowerCase(),Be.toLowerCase(),Qe,Ne,je,ue);N(Xe)&&(Xe-=32),N(tt)&&(tt-=32);const ut=Xe-tt;if(ut!==0)return ut}const he=Ne-Qe,le=ue-je;return he<le?-1:he>le?1:0}function M(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function L(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function F(Pe,Be){return Pe.length===Be.length&&v(Pe,Be)===0}function B(Pe,Be){const Qe=Be.length;return Be.length>Pe.length?!1:v(Pe,Be,0,Qe)===0}function j(Pe,Be){const Qe=Math.min(Pe.length,Be.length);let Ne;for(Ne=0;Ne<Qe;Ne++)if(Pe.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Qe}function U(Pe,Be){const Qe=Math.min(Pe.length,Be.length);let Ne;const je=Pe.length-1,ue=Be.length-1;for(Ne=0;Ne<Qe;Ne++)if(Pe.charCodeAt(je-Ne)!==Be.charCodeAt(ue-Ne))return Ne;return Qe}function z(Pe){return 55296<=Pe&&Pe<=56319}function ee(Pe){return 56320<=Pe&&Pe<=57343}function V(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function W(Pe,Be,Qe){const Ne=Pe.charCodeAt(Qe);if(z(Ne)&&Qe+1<Be){const je=Pe.charCodeAt(Qe+1);if(ee(je))return V(Ne,je)}return Ne}function J(Pe,Be){const Qe=Pe.charCodeAt(Be-1);if(ee(Qe)&&Be>1){const Ne=Pe.charCodeAt(Be-2);if(z(Ne))return V(Ne,Qe)}return Qe}class _{get offset(){return this.e}constructor(Be,Qe=0){this.c=Be,this.d=Be.length,this.e=Qe}setOffset(Be){this.e=Be}prevCodePoint(){const Be=J(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=W(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Of=_;class ce{get offset(){return this.c.offset}constructor(Be,Qe=0){this.c=new _(Be,Qe)}nextGraphemeLength(){const Be=et.getInstance(),Qe=this.c,Ne=Qe.offset;let je=Be.getGraphemeBreakType(Qe.nextCodePoint());for(;!Qe.eol();){const ue=Qe.offset,he=Be.getGraphemeBreakType(Qe.nextCodePoint());if(He(je,he)){Qe.setOffset(ue);break}je=he}return Qe.offset-Ne}prevGraphemeLength(){const Be=et.getInstance(),Qe=this.c,Ne=Qe.offset;let je=Be.getGraphemeBreakType(Qe.prevCodePoint());for(;Qe.offset>0;){const ue=Qe.offset,he=Be.getGraphemeBreakType(Qe.prevCodePoint());if(He(he,je)){Qe.setOffset(ue);break}je=he}return Ne-Qe.offset}eol(){return this.c.eol()}}e.$Pf=ce;function ne(Pe,Be){return new ce(Pe,Be).nextGraphemeLength()}function ye(Pe,Be){return new ce(Pe,Be).prevGraphemeLength()}function ge(Pe,Be){Be>0&&ee(Pe.charCodeAt(Be))&&Be--;const Qe=Be+ne(Pe,Be);return[Qe-ye(Pe,Qe),Qe]}function Y(Pe){const Be=new ce(Pe);let Qe=0;for(;!Be.eol();)Qe++,Be.nextGraphemeLength();return Qe}let q;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Pe){return q||(q=oe()),q.test(Pe)}const ie=/^[\t\n\r\x20-\x7E]*$/;function ae(Pe){return ie.test(Pe)}e.$Wf=/[\u2028\u2029]/;function se(Pe){return e.$Wf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function re(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,Be,Qe=""){const Ne=Pe.trimStart();if(Ne.length<Be)return Ne;const je=/\b/g;let ue=0;for(;je.test(Ne)&&!(Ne.length-je.lastIndex<Be);)ue=je.lastIndex,je.lastIndex+=1;return ue===0?Ne:Qe+Ne.substring(ue).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Me(Pe){let Be=0;for(const Qe of Pe.matchAll(we))Be!==Qe.index&&(yield{isCode:!1,str:Pe.substring(Be,Qe.index)}),yield{isCode:!0,str:Qe[0]},Be=Qe.index+Qe[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function ze(Pe){return Pe&&(Pe=Pe.replace(we,"")),Pe}const Ae=/\\\[.*?\\\]/g;function De(Pe){return ze(Pe).replace(Ae,"")}e.$5f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ce(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function H(Pe){return Ce(Pe)?Pe.substr(1):Pe}function G(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Qe=Be.length,Ne=Pe.toLowerCase();let je=0,ue=-1;for(;je<Qe;){const he=Ne.indexOf(Be[je],ue+1);if(he<0)return!1;ue=he,je++}return!0}function Z(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function de(Pe,Be=1){if(Be===0)return"";let Qe=-1;do Qe=Pe.indexOf(`
`,Qe+1),Be--;while(Be>0&&Qe>=0);return Qe===-1?Pe:(Pe[Qe-1]==="\r"&&Qe--,Pe.substr(0,Qe))}function Ee(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Te(Pe){return et.getInstance().getGraphemeBreakType(Pe)}function He(Pe,Be){return Pe===Ke.Other?Be!==Ke.Extend&&Be!==Ke.SpacingMark:Pe===Ke.CR&&Be===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||Be===Ke.Control||Be===Ke.CR||Be===Ke.LF?!0:!(Pe===Ke.L&&(Be===Ke.L||Be===Ke.V||Be===Ke.LV||Be===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(Be===Ke.V||Be===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&Be===Ke.T||Be===Ke.Extend||Be===Ke.ZWJ||Be===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&Be===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&Be===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class et{static{this.c=null}static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=nt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Ke.LF:Be===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Be<127)return Ke.Other;const Qe=this.d,Ne=Qe.length/3;let je=1;for(;je<=Ne;)if(Be<Qe[3*je])je=2*je;else if(Be>Qe[3*je+1])je=2*je+1;else return Qe[3*je+2];return Ke.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Pe,Be){if(Pe===0)return 0;const Qe=rt(Pe,Be);if(Qe!==void 0)return Qe;const Ne=new _(Be,Pe);return Ne.prevCodePoint(),Ne.offset}function rt(Pe,Be){const Qe=new _(Be,Pe);let Ne=Qe.prevCodePoint();for(;at(Ne)||Ne===gt.emojiVariantSelector||Ne===gt.enclosingKeyCap;){if(Qe.offset===0)return;Ne=Qe.prevCodePoint()}if(!re(Ne))return;let je=Qe.offset;return je>0&&Qe.prevCodePoint()===gt.zwj&&(je=Qe.offset),je}function at(Pe){return 127995<=Pe&&Pe<=127999}var gt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.$cg="\xA0";class dt{static{this.c=new C.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$_e({getCacheKey:JSON.stringify},Be=>{function Qe(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Ne(ut,mt){const Dt=new Map(ut);for(const[Ft,Ht]of mt)Dt.set(Ft,Ht);return Dt}function je(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Ft,Ht]of ut)mt.has(Ft)&&Dt.set(Ft,Ht);return Dt}const ue=this.c.value;let he=Be.filter(ut=>!ut.startsWith("_")&&ut in ue);he.length===0&&(he=["_default"]);let le;for(const ut of he){const mt=Qe(ue[ut]);le=je(le,mt)}const Xe=Qe(ue._common),tt=Ne(Xe,le);return new dt(tt)})}static getInstance(Be){return dt.d.get(Array.from(Be))}static{this.e=new C.$U(()=>Object.keys(dt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return dt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Qe=0;Qe<Be.length;Qe++){const Ne=Be.codePointAt(Qe);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=dt;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Be){return ct.e().has(Be)}static containsInvisibleCharacter(Be){for(let Qe=0;Qe<Be.length;Qe++){const Ne=Be.codePointAt(Qe);if(typeof Ne=="number"&&ct.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return ct.e()}}e.$eg=ct}),define(ke[31],Ie([1,0,26,16,10,12,17]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=O,e.$zg=b,e.$Ag=c,e.$Bg=k,e.$Cg=y,e.$Dg=a,e.$Eg=m,e.$Fg=p,e.$Gg=f,e.$Hg=i,e.$Ig=s,e.$Jg=t,e.$Kg=o,e.$Lg=n,e.$Mg=d,e.$Ng=l,e.$Og=D;function O(S){return S===r.CharCode.Slash||S===r.CharCode.Backslash}function b(S){return S.replace(/[\\/]/g,h.$hc.sep)}function c(S){return S.indexOf("/")===-1&&(S=b(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function k(S,I=h.$hc.sep){if(!S)return"";const A=S.length,$=S.charCodeAt(0);if(O($)){if(O(S.charCodeAt(1))&&!O(S.charCodeAt(2))){let M=3;const N=M;for(;M<A&&!O(S.charCodeAt(M));M++);if(N!==M&&!O(S.charCodeAt(M+1))){for(M+=1;M<A;M++)if(O(S.charCodeAt(M)))return S.slice(0,M+1).replace(/[\\/]/g,I)}}return I}else if(f($)&&S.charCodeAt(1)===r.CharCode.Colon)return O(S.charCodeAt(2))?S.slice(0,2)+I:S.slice(0,2);let v=S.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(O(S.charCodeAt(v)))return S.slice(0,v+1)}return""}function y(S){if(!C.$j||!S||S.length<5)return!1;let I=S.charCodeAt(0);if(I!==r.CharCode.Backslash||(I=S.charCodeAt(1),I!==r.CharCode.Backslash))return!1;let A=2;const $=A;for(;A<S.length&&(I=S.charCodeAt(A),I!==r.CharCode.Backslash);A++);return!($===A||(I=S.charCodeAt(A+1),isNaN(I)||I===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(S,I=C.$j){const A=I?u:P;return!(!S||S.length===0||/^\s+$/.test(S)||(A.lastIndex=0,A.test(S))||I&&w.test(S)||S==="."||S===".."||I&&S[S.length-1]==="."||I&&S.length!==S.trim().length||S.length>255)}function m(S,I,A){const $=S===I;return!A||$?$:!S||!I?!1:(0,R.$Gf)(S,I)}function p(S,I,A,$=h.sep){if(S===I)return!0;if(!S||!I||I.length>S.length)return!1;if(A){if(!(0,R.$Hf)(S,I))return!1;if(I.length===S.length)return!0;let M=I.length;return I.charAt(I.length-1)===$&&M--,S.charAt(M)===$}return I.charAt(I.length-1)!==$&&(I+=$),S.indexOf(I)===0}function f(S){return S>=r.CharCode.A&&S<=r.CharCode.Z||S>=r.CharCode.a&&S<=r.CharCode.z}function i(S,I){return C.$j&&S.endsWith(":")&&(S+=h.sep),(0,h.$jc)(S)||(S=(0,h.$kc)(I,S)),S=(0,h.$ic)(S),s(S)}function s(S){return C.$j?(S=(0,R.$of)(S,h.sep),S.endsWith(":")&&(S+=h.sep)):(S=(0,R.$of)(S,h.sep),S||(S=h.sep)),S}function t(S){const I=(0,h.$ic)(S);return C.$j?S.length>3?!1:o(I)&&(S.length===2||I.charCodeAt(2)===r.CharCode.Backslash):I===h.$hc.sep}function o(S,I=C.$j){return I?f(S.charCodeAt(0))&&S.charCodeAt(1)===r.CharCode.Colon:!1}function n(S,I=C.$j){return o(S,I)?S[0]:void 0}function d(S,I,A){return I.length>S.length?-1:S===I?0:(A&&(S=S.toLowerCase(),I=I.toLowerCase()),S.indexOf(I))}function l(S){const I=S.split(":");let A,$,v;for(const M of I){const N=Number(M);(0,T.$jg)(N)?$===void 0?$=N:v===void 0&&(v=N):A=A?[A,M].join(":"):M}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:$!==void 0?$:void 0,column:v!==void 0?v:$!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(S,I,A=8){let $="";for(let M=0;M<A;M++){let N;M===0&&C.$j&&!I&&(A===3||A===4)?N=E:N=g,$+=N.charAt(Math.floor(Math.random()*N.length))}let v;return I?v=`${I}-${$}`:v=$,S?(0,h.$kc)(S,v):v}}),define(ke[136],Ie([1,0,26,28,181,12]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.FuzzyScore=e.$Jk=e.$Ik=void 0,e.or=T,e.$Kk=b,e.$Lk=c,e.$Mk=u,e.$Nk=D,e.$Ok=S,e.$Pk=N,e.$Qk=L,e.$Rk=F,e.$Sk=B,e.$Tk=oe,e.$Vk=se,e.$Wk=pe,e.$Xk=we,R=We(R);function T(...Ae){return function(De,Ce){for(let H=0,G=Ae.length;H<G;H++){const Z=Ae[H](De,Ce);if(Z)return Z}return null}}e.$Ik=O.bind(void 0,!1),e.$Jk=O.bind(void 0,!0);function O(Ae,De,Ce){if(!Ce||Ce.length<De.length)return null;let H;return Ae?H=R.$Hf(Ce,De):H=Ce.indexOf(De)===0,H?De.length>0?[{start:0,end:De.length}]:[]:null}function b(Ae,De){const Ce=De.toLowerCase().indexOf(Ae.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+Ae.length}]}function c(Ae,De){return k(Ae.toLowerCase(),De.toLowerCase(),0,0)}function k(Ae,De,Ce,H){if(Ce===Ae.length)return[];if(H===De.length)return null;if(Ae[Ce]===De[H]){let G=null;return(G=k(Ae,De,Ce+1,H+1))?t({start:H,end:H+1},G):null}return k(Ae,De,Ce,H+1)}function y(Ae){return r.CharCode.a<=Ae&&Ae<=r.CharCode.z}function u(Ae){return r.CharCode.A<=Ae&&Ae<=r.CharCode.Z}function P(Ae){return r.CharCode.Digit0<=Ae&&Ae<=r.CharCode.Digit9}function w(Ae){return Ae===r.CharCode.Space||Ae===r.CharCode.Tab||Ae===r.CharCode.LineFeed||Ae===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ae=>a.add(Ae.charCodeAt(0)));function m(Ae){return w(Ae)||a.has(Ae)}function p(Ae,De){return Ae===De||m(Ae)&&m(De)}const f=new Map;function i(Ae){if(f.has(Ae))return f.get(Ae);let De;const Ce=(0,C.$Gk)(Ae);return Ce&&(De=Ce),f.set(Ae,De),De}function s(Ae){return y(Ae)||u(Ae)||P(Ae)}function t(Ae,De){return De.length===0?De=[Ae]:Ae.end===De[0].start?De[0].start=Ae.start:De.unshift(Ae),De}function o(Ae,De){for(let Ce=De;Ce<Ae.length;Ce++){const H=Ae.charCodeAt(Ce);if(u(H)||P(H)||Ce>0&&!s(Ae.charCodeAt(Ce-1)))return Ce}return Ae.length}function n(Ae,De,Ce,H){if(Ce===Ae.length)return[];if(H===De.length)return null;if(Ae[Ce]!==De[H].toLowerCase())return null;{let G=null,Z=H+1;for(G=n(Ae,De,Ce+1,H+1);!G&&(Z=o(De,Z))<De.length;)G=n(Ae,De,Ce+1,Z),Z++;return G===null?null:t({start:H,end:H+1},G)}}function d(Ae){let De=0,Ce=0,H=0,G=0,Z=0;for(let He=0;He<Ae.length;He++)Z=Ae.charCodeAt(He),u(Z)&&De++,y(Z)&&Ce++,s(Z)&&H++,P(Z)&&G++;const x=De/Ae.length,de=Ce/Ae.length,Ee=H/Ae.length,Te=G/Ae.length;return{upperPercent:x,lowerPercent:de,alphaPercent:Ee,numericPercent:Te}}function l(Ae){const{upperPercent:De,lowerPercent:Ce}=Ae;return Ce===0&&De>.6}function g(Ae){const{upperPercent:De,lowerPercent:Ce,alphaPercent:H,numericPercent:G}=Ae;return Ce>.2&&De<.8&&H>.6&&G<.2}function E(Ae){let De=0,Ce=0,H=0,G=0;for(let Z=0;Z<Ae.length;Z++)H=Ae.charCodeAt(Z),u(H)&&De++,y(H)&&Ce++,w(H)&&G++;return(De===0||Ce===0)&&G===0?Ae.length<=30:De<=5}function D(Ae,De){if(!De||(De=De.trim(),De.length===0)||!E(Ae))return null;De.length>60&&(De=De.substring(0,60));const Ce=d(De);if(!g(Ce)){if(!l(Ce))return null;De=De.toLowerCase()}let H=null,G=0;for(Ae=Ae.toLowerCase();G<De.length&&(H=n(Ae,De,0,G))===null;)G=o(De,G+1);return H}function S(Ae,De,Ce=!1){if(!De||De.length===0)return null;let H=null,G=0;for(Ae=Ae.toLowerCase(),De=De.toLowerCase();G<De.length&&(H=I(Ae,De,0,G,Ce),H===null);)G=A(De,G+1);return H}function I(Ae,De,Ce,H,G){let Z=0;if(Ce===Ae.length)return[];if(H===De.length)return null;if(!p(Ae.charCodeAt(Ce),De.charCodeAt(H))){const Ee=i(Ae.charCodeAt(Ce));if(!Ee)return null;for(let Te=0;Te<Ee.length;Te++)if(!p(Ee[Te],De.charCodeAt(H+Te)))return null;Z+=Ee.length-1}let x=null,de=H+Z+1;if(x=I(Ae,De,Ce+1,de,G),!G)for(;!x&&(de=A(De,de))<De.length;)x=I(Ae,De,Ce+1,de,G),de++;if(!x)return null;if(Ae.charCodeAt(Ce)!==De.charCodeAt(H)){const Ee=i(Ae.charCodeAt(Ce));if(!Ee)return x;for(let Te=0;Te<Ee.length;Te++)if(Ee[Te]!==De.charCodeAt(H+Te))return x}return t({start:H,end:H+Z+1},x)}function A(Ae,De){for(let Ce=De;Ce<Ae.length;Ce++)if(m(Ae.charCodeAt(Ce))||Ce>0&&m(Ae.charCodeAt(Ce-1)))return Ce;return Ae.length}const $=T(e.$Jk,D,b),v=T(e.$Jk,D,c),M=new h.$Ec(1e4);function N(Ae,De,Ce=!1){if(typeof Ae!="string"||typeof De!="string")return null;let H=M.get(Ae);H||(H=new RegExp(R.$pf(Ae),"i"),M.set(Ae,H));const G=H.exec(De);return G?[{start:G.index,end:G.index+G[0].length}]:Ce?v(Ae,De):$(Ae,De)}function L(Ae,De){const Ce=se(Ae,Ae.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?B(Ce):null}function F(Ae,De,Ce,H,G,Z){const x=Math.min(13,Ae.length);for(;Ce<x;Ce++){const de=se(Ae,De,Ce,H,G,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,Z]}function B(Ae){if(typeof Ae>"u")return[];const De=[],Ce=Ae[1];for(let H=Ae.length-1;H>1;H--){const G=Ae[H]+Ce,Z=De[De.length-1];Z&&Z.end===G?Z.end=G+1:De.push({start:G,end:G+1})}return De}const j=128;function U(){const Ae=[],De=[];for(let Ce=0;Ce<=j;Ce++)De[Ce]=0;for(let Ce=0;Ce<=j;Ce++)Ae.push(De.slice(0));return Ae}function z(Ae){const De=[];for(let Ce=0;Ce<=Ae;Ce++)De[Ce]=0;return De}const ee=z(2*j),V=z(2*j),W=U(),J=U(),_=U(),ce=!1;function ne(Ae,De,Ce,H,G){function Z(de,Ee,Te=" "){for(;de.length<Ee;)de=Te+de;return de}let x=` |   |${H.split("").map(de=>Z(de,3)).join("|")}
`;for(let de=0;de<=Ce;de++)de===0?x+=" |":x+=`${De[de-1]}|`,x+=Ae[de].slice(0,G+1).map(Ee=>Z(Ee.toString(),3)).join("|")+`
`;return x}function ye(Ae,De,Ce,H){Ae=Ae.substr(De),Ce=Ce.substr(H),console.log(ne(J,Ae,Ae.length,Ce,Ce.length)),console.log(ne(_,Ae,Ae.length,Ce,Ce.length)),console.log(ne(W,Ae,Ae.length,Ce,Ce.length))}function ge(Ae,De){if(De<0||De>=Ae.length)return!1;const Ce=Ae.codePointAt(De);switch(Ce){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Zf(Ce)}}function Y(Ae,De){if(De<0||De>=Ae.length)return!1;switch(Ae.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function q(Ae,De,Ce){return De[Ae]!==Ce[Ae]}function oe(Ae,De,Ce,H,G,Z,x=!1){for(;De<Ce&&G<Z;)Ae[De]===H[G]&&(x&&(ee[De]=G),De+=1),G+=1;return De===Ce}var ve;(function(Ae){Ae[Ae.Diag=1]="Diag",Ae[Ae.Left=2]="Left",Ae[Ae.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ie;(function(Ae){Ae.Default=[-100,0];function De(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}Ae.isDefault=De})(ie||(e.FuzzyScore=ie={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ce){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ce}}e.$Uk=ae;function se(Ae,De,Ce,H,G,Z,x=ae.default){const de=Ae.length>j?j:Ae.length,Ee=H.length>j?j:H.length;if(Ce>=de||Z>=Ee||de-Ce>Ee-Z||!oe(De,Ce,de,G,Z,Ee,!0))return;X(de,Ee,Ce,Z,De,G);let Te=1,He=1,Ke=Ce,et=Z;const nt=[!1];for(Te=1,Ke=Ce;Ke<de;Te++,Ke++){const dt=ee[Ke],ct=V[Ke],Pe=Ke+1<de?V[Ke+1]:Ee;for(He=dt-Z+1,et=dt;et<Pe;He++,et++){let Be=Number.MIN_SAFE_INTEGER,Qe=!1;et<=ct&&(Be=re(Ae,De,Ke,Ce,H,G,et,Ee,Z,W[Te-1][He-1]===0,nt));let Ne=0;Be!==Number.MAX_SAFE_INTEGER&&(Qe=!0,Ne=Be+J[Te-1][He-1]);const je=et>dt,ue=je?J[Te][He-1]+(W[Te][He-1]>0?-5:0):0,he=et>dt+1&&W[Te][He-1]>0,le=he?J[Te][He-2]+(W[Te][He-2]>0?-5:0):0;if(he&&(!je||le>=ue)&&(!Qe||le>=Ne))J[Te][He]=le,_[Te][He]=ve.LeftLeft,W[Te][He]=0;else if(je&&(!Qe||ue>=Ne))J[Te][He]=ue,_[Te][He]=ve.Left,W[Te][He]=0;else if(Qe)J[Te][He]=Ne,_[Te][He]=ve.Diag,W[Te][He]=W[Te-1][He-1]+1;else throw new Error("not possible")}}if(ce&&ye(Ae,Ce,H,Z),!nt[0]&&!x.firstMatchCanBeWeak)return;Te--,He--;const st=[J[Te][He],Z];let rt=0,at=0;for(;Te>=1;){let dt=He;do{const ct=_[Te][dt];if(ct===ve.LeftLeft)dt=dt-2;else if(ct===ve.Left)dt=dt-1;else break}while(dt>=1);rt>1&&De[Ce+Te-1]===G[Z+He-1]&&!q(dt+Z-1,H,G)&&rt+1>W[Te][dt]&&(dt=He),dt===He?rt++:rt=1,at||(at=dt),Te--,He=dt-1,st.push(He)}Ee-Z===de&&x.boostFullMatch&&(st[0]+=2);const gt=at-de;return st[0]-=gt,st}function X(Ae,De,Ce,H,G,Z){let x=Ae-1,de=De-1;for(;x>=Ce&&de>=H;)G[x]===Z[de]&&(V[x]=de,x--),de--}function re(Ae,De,Ce,H,G,Z,x,de,Ee,Te,He){if(De[Ce]!==Z[x])return Number.MIN_SAFE_INTEGER;let Ke=1,et=!1;return x===Ce-H?Ke=Ae[Ce]===G[x]?7:5:q(x,G,Z)&&(x===0||!q(x-1,G,Z))?(Ke=Ae[Ce]===G[x]?7:5,et=!0):ge(Z,x)&&(x===0||!ge(Z,x-1))?Ke=5:(ge(Z,x-1)||Y(Z,x-1))&&(Ke=5,et=!0),Ke>1&&Ce===H&&(He[0]=!0),et||(et=q(x,G,Z)||ge(Z,x-1)||Y(Z,x-1)),Ce===H?x>Ee&&(Ke-=et?3:5):Te?Ke+=et?2:0:Ke+=et?0:1,x+1===de&&(Ke-=et?3:5),Ke}function pe(Ae,De,Ce,H,G,Z,x){return Me(Ae,De,Ce,H,G,Z,!0,x)}function we(Ae,De,Ce,H,G,Z,x){return Me(Ae,De,Ce,H,G,Z,!1,x)}function Me(Ae,De,Ce,H,G,Z,x,de){let Ee=se(Ae,De,Ce,H,G,Z,de);if(Ee&&!x)return Ee;if(Ae.length>=3){const Te=Math.min(7,Ae.length-1);for(let He=Ce+1;He<Te;He++){const Ke=ze(Ae,He);if(Ke){const et=se(Ke,Ke.toLowerCase(),Ce,H,G,Z,de);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function ze(Ae,De){if(De+1>=Ae.length)return;const Ce=Ae[De],H=Ae[De+1];if(Ce!==H)return Ae.slice(0,De)+H+Ce+Ae.slice(De+2)}}),define(ke[60],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=h,e.$vj=C,e.$wj=R,e.$xj=O,e.$zj=a,r=We(r);function h(p){return C(p,0)}function C(p,f){switch(typeof p){case"object":return p===null?R(349,f):Array.isArray(p)?b(p,f):c(p,f);case"string":return O(p,f);case"boolean":return T(p,f);case"number":return R(p,f);case"undefined":return R(937,f);default:return R(617,f)}}function R(p,f){return(f<<5)-f+p|0}function T(p,f){return R(p?433:863,f)}function O(p,f){f=R(149417,f);for(let i=0,s=p.length;i<s;i++)f=R(p.charCodeAt(i),f);return f}function b(p,f){return f=R(104579,f),p.reduce((i,s)=>C(s,i),f)}function c(p,f){return f=R(181387,f),Object.keys(p).sort().reduce((i,s)=>(i=O(s,i),C(p[s],i)),f)}class k{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=C(f,this.g),this.g}}e.$yj=k;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function u(p,f,i=32){const s=i-f,t=~((1<<s)-1);return(p<<f|(t&p)>>>s)>>>0}function P(p,f=0,i=p.byteLength,s=0){for(let t=0;t<i;t++)p[f+t]=s}function w(p,f,i="0"){for(;p.length<f;)p=i+p;return p}function a(p,f=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((p>>>0).toString(16),f/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const i=f.length;if(i===0)return;const s=this.p;let t=this.r,o=this.u,n,d;for(o!==0?(n=o,d=-1,o=0):(n=f.charCodeAt(0),d=0);;){let l=n;if(r.$Kf(n))if(d+1<i){const g=f.charCodeAt(d+1);r.$Lf(g)?(d++,l=r.$Mf(n,g)):l=y.UNICODE_REPLACEMENT}else{o=n;break}else r.$Lf(n)&&(l=y.UNICODE_REPLACEMENT);if(t=this.w(s,t,l),d++,d<i)n=f.charCodeAt(d);else break}this.r=t,this.u=o}w(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=y.BLOCK_SIZE&&(this.y(),i-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,f[0]=f[y.BLOCK_SIZE+0],f[1]=f[y.BLOCK_SIZE+1],f[2]=f[y.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=m.g,i=this.q;for(let D=0;D<64;D+=4)f.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)f.setUint32(D,u(f.getUint32(D-12,!1)^f.getUint32(D-32,!1)^f.getUint32(D-56,!1)^f.getUint32(D-64,!1),1),!1);let s=this.h,t=this.l,o=this.m,n=this.n,d=this.o,l,g,E;for(let D=0;D<80;D++)D<20?(l=t&o|~t&n,g=1518500249):D<40?(l=t^o^n,g=1859775393):D<60?(l=t&o|t&n|o&n,g=2400959708):(l=t^o^n,g=3395469782),E=u(s,5)+l+d+g+f.getUint32(D*4,!1)&4294967295,d=n,n=o,o=u(t,30),t=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$Aj=m}),define(ke[137],Ie([1,0,26,135,136,60,16,10,12]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=y,e.$Rr=p,e.$Sr=l,e.$Tr=$,e.$Ur=B,e.$Vr=U;const c=0,k=[c,[]];function y(z,ee,V,W){if(!z||!ee)return k;const J=z.length,_=ee.length;if(J<_)return k;const ce=z.toLowerCase();return u(ee,V,_,z,ce,J,W)}function u(z,ee,V,W,J,_,ce){const ne=[],ye=[];for(let oe=0;oe<V;oe++){const ve=oe*_,ie=ve-_,ae=oe>0,se=z[oe],X=ee[oe];for(let re=0;re<_;re++){const pe=re>0,we=ve+re,Me=we-1,ze=ie+re-1,Ae=pe?ne[Me]:0,De=ae&&pe?ne[ze]:0,Ce=ae&&pe?ye[ze]:0;let H;!De&&ae?H=0:H=P(se,X,W,J,re,Ce),H&&De+H>=Ae&&(ce||ae||J.startsWith(ee,re))?(ye[we]=Ce+1,ne[we]=De+H):(ye[we]=c,ne[we]=Ae)}}const ge=[];let Y=V-1,q=_-1;for(;Y>=0&&q>=0;){const oe=Y*_+q;ye[oe]===c||(ge.push(q),Y--),q--}return[ne[V*_-1],ge.reverse()]}function P(z,ee,V,W,J,_){let ce=0;if(!w(ee,W[J]))return ce;if(ce+=1,_>0&&(ce+=_*5),z===V[J]&&(ce+=1),J===0)ce+=8;else{const ne=a(V.charCodeAt(J-1));ne?ce+=ne:(0,C.$Mk)(V.charCodeAt(J))&&_===0&&(ce+=2)}return ce}function w(z,ee){return z===ee?!0:z==="/"||z==="\\"?ee==="/"||ee==="\\":!1}function a(z){switch(z){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function p(z,ee,V=0,W=0){const J=ee;return J.values&&J.values.length>1?f(z,J.values,V,W):i(z,ee,V,W)}function f(z,ee,V,W){let J=0;const _=[];for(const ce of ee){const[ne,ye]=i(z,ce,V,W);if(typeof ne!="number")return m;J+=ne,_.push(...ye)}return[J,I(_)]}function i(z,ee,V,W){const J=(0,C.$Vk)(ee.original,ee.originalLowercase,V,z,z.toLowerCase(),W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,C.$Sk)(J)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function d(z,ee,V,W){const J=W.values?W.values:[W];return(0,R.$uj)({[W.normalized]:{values:J.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:z,description:ee,allowNonContiguousMatches:V}})}function l(z,ee,V,W,J){if(!z||!ee.normalized)return s;const _=W.getItemLabel(z);if(!_)return s;const ce=W.getItemDescription(z),ne=d(_,ce,V,ee),ye=J[ne];if(ye)return ye;const ge=g(_,ce,W.getItemPath(z),ee,V);return J[ne]=ge,ge}function g(z,ee,V,W,J){const _=!V||!W.containsPathSeparator;return V&&(O.$l?W.pathNormalized===V:(0,b.$Gf)(W.pathNormalized,V))?{score:t,labelMatch:[{start:0,end:z.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:W.values&&W.values.length>1?E(z,ee,V,W.values,_,J):D(z,ee,V,W,_,J)}function E(z,ee,V,W,J,_){let ce=0;const ne=[],ye=[];for(const ge of W){const{score:Y,labelMatch:q,descriptionMatch:oe}=D(z,ee,V,ge,J,_);if(Y===c)return s;ce+=Y,q&&ne.push(...q),oe&&ye.push(...oe)}return{score:ce,labelMatch:I(ne),descriptionMatch:I(ye)}}function D(z,ee,V,W,J,_){if(J||!ee){const[ce,ne]=y(z,W.normalized,W.normalizedLowercase,_&&!W.expectContiguousMatch);if(ce){const ye=(0,C.$Jk)(W.normalized,z);let ge;if(ye){ge=o;const Y=Math.round(W.normalized.length/z.length*100);ge+=Y}else ge=n;return{score:ge+ce,labelMatch:ye||S(ne)}}}if(ee){let ce=ee;V&&(ce=`${ee}${T.sep}`);const ne=ce.length,ye=`${ce}${z}`,[ge,Y]=y(ye,W.normalized,W.normalizedLowercase,_&&!W.expectContiguousMatch);if(ge){const q=S(Y),oe=[],ve=[];return q.forEach(ie=>{ie.start<ne&&ie.end>ne?(oe.push({start:0,end:ie.end-ne}),ve.push({start:ie.start,end:ne})):ie.start>=ne?oe.push({start:ie.start-ne,end:ie.end-ne}):ve.push(ie)}),{score:ge,labelMatch:oe,descriptionMatch:ve}}}return s}function S(z){const ee=[];if(!z)return ee;let V;for(const W of z)V&&V.end===W?V.end+=1:(V={start:W,end:W+1},ee.push(V));return ee}function I(z){const ee=z.sort((J,_)=>J.start-_.start),V=[];let W;for(const J of ee)!W||!A(W,J)?(W=J,V.push(J)):(W.start=Math.min(W.start,J.start),W.end=Math.max(W.end,J.end));return V}function A(z,ee){return!(z.end<ee.start||ee.end<z.start)}function $(z,ee,V,W,J,_){const ce=l(z,V,W,J,_),ne=l(ee,V,W,J,_),ye=ce.score,ge=ne.score;if((ye===t||ge===t)&&ye!==ge)return ye===t?-1:1;if(ye>n||ge>n){if(ye!==ge)return ye>ge?-1:1;if(ye<o&&ge<o){const se=M(ce.labelMatch,ne.labelMatch);if(se!==0)return se}const ie=J.getItemLabel(z)||"",ae=J.getItemLabel(ee)||"";if(ie.length!==ae.length)return ie.length-ae.length}if(ye!==ge)return ye>ge?-1:1;const Y=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,q=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(Y&&!q)return-1;if(q&&!Y)return 1;const oe=v(z,ce,J),ve=v(ee,ne,J);return oe&&ve&&oe!==ve?ve>oe?-1:1:N(z,ee,V,J)}function v(z,ee,V){let W=-1,J=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?W=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(W=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(J=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const _=V.getItemDescription(z);_&&(J+=_.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(J=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return J-W}function M(z,ee){if(!z&&!ee||(!z||!z.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!z||!z.length)return 1;const V=z[0].start,J=z[z.length-1].end-V,_=ee[0].start,ne=ee[ee.length-1].end-_;return J===ne?0:ne<J?1:-1}function N(z,ee,V,W){const J=W.getItemLabel(z)||"",_=W.getItemLabel(ee)||"",ce=W.getItemDescription(z),ne=W.getItemDescription(ee),ye=J.length+(ce?ce.length:0),ge=_.length+(ne?ne.length:0);if(ye!==ge)return ye-ge;const Y=W.getItemPath(z),q=W.getItemPath(ee);return Y&&q&&Y.length!==q.length?Y.length-q.length:J!==_?(0,h.$Or)(J,_,V.normalized):ce&&ne&&ce!==ne?(0,h.$Or)(ce,ne,V.normalized):Y&&q&&Y!==q?(0,h.$Or)(Y,q,V.normalized):0}function L(z){return z.startsWith('"')&&z.endsWith('"')}const F=" ";function B(z){typeof z!="string"&&(z="");const ee=z.toLowerCase(),{pathNormalized:V,normalized:W,normalizedLowercase:J}=j(z),_=V.indexOf(T.sep)>=0,ce=L(z);let ne;const ye=z.split(F);if(ye.length>1)for(const ge of ye){const Y=L(ge),{pathNormalized:q,normalized:oe,normalizedLowercase:ve}=j(ge);oe&&(ne||(ne=[]),ne.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:q,normalized:oe,normalizedLowercase:ve,expectContiguousMatch:Y}))}return{original:z,originalLowercase:ee,pathNormalized:V,normalized:W,normalizedLowercase:J,values:ne,containsPathSeparator:_,expectContiguousMatch:ce}}function j(z){let ee;O.$j?ee=z.replace(/\//g,T.sep):ee=z.replace(/\\/g,T.sep);const V=(0,b.$qf)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:V,normalizedLowercase:V.toLowerCase()}}function U(z){return Array.isArray(z)?B(z.map(ee=>ee.original).join(F)):B(z.original)}}),define(ke[138],Ie([1,0,136,12,51]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=b,e.$Zk=k,e.$1k=u,e.$2k=P,e.$3k=a,e.$4k=m;const R="$(",T=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${T.source}`,"g");function b(p){return p.replace(O,(f,i)=>i?f:`\\${f}`)}const c=new RegExp(`\\\\${T.source}`,"g");function k(p){return p.replace(c,f=>`\\${f}`)}const y=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(p){return p.indexOf(R)===-1?p:p.replace(y,(f,i,s,t)=>s?f:i||t||"")}function P(p){return p?p.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(p){w.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=w.lastIndex,o=w.exec(p),n=p.substring(t,o?.index);if(n.length>0){f+=n;for(let d=0;d<n.length;d++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m(p,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.$Pk)(p,s,i);const o=(0,h.$nf)(s," "),n=s.length-o.length,d=(0,r.$Pk)(p,o,i);if(d)for(const l of d){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return d}}),define(ke[43],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(h||(h={})),function(C){const R="error",T="warning",O="warn",b="info",c="ignore";function k(u){return u?r.$Gf(R,u)?C.Error:r.$Gf(T,u)||r.$Gf(O,u)?C.Warning:r.$Gf(b,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=k;function y(u){switch(u){case C.Error:return R;case C.Warning:return T;case C.Info:return b;default:return c}}C.toString=y}(h||(h={})),e.default=h}),define(ke[84],Ie([1,0,18,26,12]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$Ii=R;class T{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$Af)(w,this.b,0,w.length,this.c,this.d):(0,C.$Cf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=T;class O{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$Af)(w,this.b,0,w.length,this.d,this.e):(0,C.$Cf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=O;var b;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new O(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(b.Path)),this.g(w)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===b.Scheme)return(0,C.$Bf)(w,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,C.$Bf)(w,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(w);if(this.d[this.e]===b.Query)return(0,C.$zf)(w,this.c.query);if(this.d[this.e]===b.Fragment)return(0,C.$zf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Li=c;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(y||(y={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new O(void 0,!w))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new T)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const m=a.slice(0);(0,r.$Wb)(m);for(const p of m)this.set(p,w)}else{const m=w.slice(0);(0,r.$Wb)(m);for(const p of m)this.set(p[0],p[1])}}set(w,a){const m=this.b.reset(w);let p;this.c||(this.c=new k,this.c.segment=m.value());const f=[];for(p=this.c;;){const s=m.cmp(p.segment);if(s>0)p.left||(p.left=new k,p.left.segment=m.value()),f.push([y.Left,p]),p=p.left;else if(s<0)p.right||(p.right=new k,p.right.segment=m.value()),f.push([y.Right,p]),p=p.right;else if(m.hasNext())m.next(),p.mid||(p.mid=new k,p.mid.segment=m.value()),f.push([y.Mid,p]),p=p.mid;else break}const i=p.value;p.value=a,p.key=w;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],d=f[s+1][0];if(n===y.Right&&d===y.Right)f[s][1]=t.rotateLeft();else if(n===y.Left&&d===y.Left)f[s][1]=t.rotateRight();else if(n===y.Right&&d===y.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===y.Left&&d===y.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case y.Left:f[s-1][1].left=f[s][1];break;case y.Right:f[s-1][1].right=f[s][1];break;case y.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let m=this.c;for(;m;){const p=a.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const m=this.b.reset(w),p=[];let f=this.c;for(;f;){const i=m.cmp(f.segment);if(i>0)p.push([y.Left,f]),f=f.left;else if(i<0)p.push([y.Right,f]),f=f.right;else if(m.hasNext())m.next(),p.push([y.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this.f(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this.e(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if(p.length>0){const[s,t]=p[p.length-1];switch(s){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=p.length-1;i>=0;i--){const s=p[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),p[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),p[i][1]=s.rotateRight()),i>0)switch(p[i-1][0]){case y.Left:p[i-1][1].left=p[i][1];break;case y.Right:p[i-1][1].right=p[i][1];break;case y.Mid:p[i-1][1].mid=p[i][1];break}else this.c=p[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let m=this.c,p;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),p=m.value||p,m=m.mid;else break}return m&&m.value||p}findSuperstr(w){return this.g(w,!1)}g(w,a){const m=this.b.reset(w);let p=this.c;for(;p;){const f=m.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else return p.mid?this.h(p.mid):a?p.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,m]of this)w(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Mi=u}),define(ke[2],Ie([1,0,26,40,16,10]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=o,C=We(C);const T=/^\w[\w\d+.-]*$/,O=/^\//,b=/^\/\//;function c(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!T.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!O.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(E,D){return!E&&!D?"file":E}function y(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const u="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,S,I,A,$,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=k(D,v),this.authority=S||u,this.path=y(this.scheme,I||u),this.query=A||u,this.fragment=$||u,c(this,v))}get fsPath(){return o(this,!1)}with(D){if(!D)return this;let{scheme:S,authority:I,path:A,query:$,fragment:v}=D;return S===void 0?S=this.scheme:S===null&&(S=u),I===void 0?I=this.authority:I===null&&(I=u),A===void 0?A=this.path:A===null&&(A=u),$===void 0?$=this.query:$===null&&($=u),v===void 0?v=this.fragment:v===null&&(v=u),S===this.scheme&&I===this.authority&&A===this.path&&$===this.query&&v===this.fragment?this:new f(S,I,A,$,v)}static parse(D,S=!1){const I=w.exec(D);return I?new f(I[2]||u,g(I[4]||u),g(I[5]||u),g(I[7]||u),g(I[9]||u),S):new f(u,u,u,u,u)}static file(D){let S=u;if(R.$j&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const I=D.indexOf(P,2);I===-1?(S=D.substring(2),D=P):(S=D.substring(2,I),D=D.substring(I)||P)}return new f("file",S,D,u,u)}static from(D,S){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,S)}static joinPath(D,...S){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return R.$j&&D.scheme==="file"?I=a.file(C.$gc.join(o(D,!0),...S)).path:I=C.$hc.join(D.path,...S),D.with({path:I})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const S=new f(D);return S._formatted=D.external??null,S._fsPath=D._sep===p?D.fsPath??null:null,S}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const p=R.$j?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=p),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,D,S){let I,A=-1;for(let $=0;$<E.length;$++){const v=E.charCodeAt($);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||S&&v===r.CharCode.OpenSquareBracket||S&&v===r.CharCode.CloseSquareBracket||S&&v===r.CharCode.Colon)A!==-1&&(I+=encodeURIComponent(E.substring(A,$)),A=-1),I!==void 0&&(I+=E.charAt($));else{I===void 0&&(I=E.substr(0,$));const M=i[v];M!==void 0?(A!==-1&&(I+=encodeURIComponent(E.substring(A,$)),A=-1),I+=M):A===-1&&(A=$)}}return A!==-1&&(I+=encodeURIComponent(E.substring(A))),I!==void 0?I:E}function t(E){let D;for(let S=0;S<E.length;S++){const I=E.charCodeAt(S);I===r.CharCode.Hash||I===r.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,S)),D+=i[I]):D!==void 0&&(D+=E[S])}return D!==void 0?D:E}function o(E,D){let S;return E.authority&&E.path.length>1&&E.scheme==="file"?S=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?D?S=E.path.substr(1):S=E.path[1].toLowerCase()+E.path.substr(2):S=E.path,R.$j&&(S=S.replace(/\//g,"\\")),S}function n(E,D){const S=D?t:s;let I="",{scheme:A,authority:$,path:v,query:M,fragment:N}=E;if(A&&(I+=A,I+=":"),($||A==="file")&&(I+=P,I+=P),$){let L=$.indexOf("@");if(L!==-1){const F=$.substr(0,L);$=$.substr(L+1),L=F.lastIndexOf(":"),L===-1?I+=S(F,!1,!1):(I+=S(F.substr(0,L),!1,!1),I+=":",I+=S(F.substr(L+1),!1,!0)),I+="@"}$=$.toLowerCase(),L=$.lastIndexOf(":"),L===-1?I+=S($,!1,!0):(I+=S($.substr(0,L),!1,!0),I+=$.substr(L))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const L=v.charCodeAt(1);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`/${String.fromCharCode(L+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const L=v.charCodeAt(0);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`${String.fromCharCode(L+32)}:${v.substr(2)}`)}I+=S(v,!0,!1)}return M&&(I+="?",I+=S(M,!1,!1)),N&&(I+="#",I+=D?N:s(N,!1,!1)),I}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(E){return E.match(l)?E.replace(l,D=>d(D)):E}}),define(ke[190],Ie([1,0,2]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=h,e.$hr=C,e.$ir=R,e.log=O;function h(c){const k=c;return k&&typeof k.type=="string"&&typeof k.severity=="string"}function C(c){const k=[];let y;try{const u=JSON.parse(c.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),y=P.__$stack),k.push(...u)}catch{k.push("Unable to log remote console arguments",c.arguments)}return{args:k,stack:y}}function R(c){if(typeof c!="string")return R(C(c).stack);const k=c;if(k){const y=T(k),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(c){if(!c)return c;const k=c.indexOf(`
`);return k===-1?c:c.substring(0,k)}function O(c,k){const{args:y,stack:u}=C(c),P=typeof y[0]=="string"&&y.length===1;let w=T(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof y[0]=="string"?w&&P?a=[`%c[${k}] %c${y[0]} %c${w}`,b("blue"),b(""),b("grey")]:a=[`%c[${k}] %c${y[0]}`,b("blue"),b(""),...y.slice(1)]:a=[`%c[${k}]%`,b("blue"),...y],w&&!P&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function b(c){return`color: ${c}`}}),define(ke[44],Ie([1,0,21,2,40]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=R,e.$ci=T,e.$di=b;function R(c){return JSON.stringify(c,O)}function T(c){let k=JSON.parse(c);return k=b(k),k}function O(c,k){return k instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function b(c,k=0){if(!c||k>200)return c;if(typeof c=="object"){switch(c.$mid){case C.MarshalledId.Uri:return h.URI.revive(c);case C.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case C.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=b(c[y],k+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=b(c[y],k+1))}return c}}),define(ke[14],Ie([1,0,13,10,12,2,16]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=b,e.$Qg=c,e.$Ug=y,r=We(r),h=We(h),T=We(T);var O;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(O||(e.Schemas=O={}));function b(w,a){return R.URI.isUri(w)?(0,C.$Gf)(w.scheme,a):(0,C.$Hf)(w,a+":")}function c(w,...a){return a.some(m=>b(w,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=y(a,m)}getServerRootPath(){return this.f}get g(){return T.$hc.join(this.f,O.vscodeRemoteResource)}set(a,m,p){this.a[a]=m,this.b[a]=p}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Z(t),a}const m=a.authority;let p=this.a[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.$Sg}=${encodeURIComponent(i)}`),R.URI.from({scheme:h.$p?this.d:O.vscodeRemoteResource,authority:`${p}:${f}`,path:this.g,query:s})}}e.$Tg=new k;function y(w,a){return T.$hc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class u{static{this.a=e.$Zg}asBrowserUri(a){const m=this.b(a,$e);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===O.vscodeRemote?e.$Tg.rewrite(a):a.scheme===O.file&&(h.$n||h.$r===`${O.vscodeFileResource}://${u.a}`)?a.with({scheme:O.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,$e);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===O.vscodeFileResource?a.with({scheme:O.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$1g=new u;var P;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function p(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}w.getHeadersFromQuery=p;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}w.addSearchParam=f})(P||(e.COI=P={}))}),define(ke[139],Ie([1,0,131,14,10,17,2]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=y,e.$vq=u,C=We(C);class O{constructor(w,a,m){this.id=w,this.dependencies=a,this.callback=m}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,a,m)=>{typeof w!="string"&&(m=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this.c.push(new O(w,a,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const a=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!a)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(w){return new Promise((a,m)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const f=()=>{p.removeEventListener("load",i),p.removeEventListener("error",s)},i=t=>{f(),a(this.c.pop())},s=t=>{f(),m(t)};p.addEventListener("load",i),p.addEventListener("error",s),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(p)})}async i(w){return this.f&&(w=this.f.createScriptURL(w)),r.$R?await new Promise((a,m)=>{$e([w],a,m)}).then(We):importScripts(w),this.c.pop()}async j(w){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,f=T.URI.parse(w).fsPath,i=a.readFileSync(f).toString(),s=p.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function y(P,w,a){if(r.$R){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[P]&&(P=k[P]);const m=w?`${P}/${w}`:P;if(c.has(m))return c.get(m);let p;if(/^\w[\w\d+.-]*:\/\//.test(m))p=m;else{const t=`${r.$S&&a&&!C.$p?h.$Xg:h.$Wg}/${m}`;p=h.$1g.asBrowserUri(t).toString(!0)}const f=b.INSTANCE.load(p);return c.set(m,f),f}else return await new Promise((m,p)=>{$e([P],m,p)}).then(We)}function u(P,w){(0,R.$pg)(r.$R);const m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,p=r.$S&&m&&!C.$p,f=`${P}/${w}`,s=`${p?h.$Xg:h.$Wg}/${f}`;return h.$1g.asBrowserUri(s).toString(!0)}}),define(ke[22],Ie([1,0,26,31,14,16,10,12,2]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=c,e.$qh=y,e.$rh=P,h=We(h),R=We(R);function c(w){return(0,b.$xc)(w,!0)}class k{constructor(a){this.a=a}compare(a,m,p=!1){return a===m?0:(0,O.$zf)(this.getComparisonKey(a,p),this.getComparisonKey(m,p))}isEqual(a,m,p=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,p)===this.getComparisonKey(m,p)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,p=!1){if(a.scheme===m.scheme){if(a.scheme===C.Schemas.file)return h.$Fg(c(a),c(m),this.a(a))&&a.query===m.query&&(p||a.fragment===m.fragment);if((0,e.$mh)(a.authority,m.authority))return h.$Fg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&(p||a.fragment===m.fragment)}return!1}joinPath(a,...m){return b.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$eh)(a)||a.authority}basename(a){return R.$hc.basename(a.path)}extname(a){return R.$hc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$nc(c(a))).path:(m=R.$hc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$ic(c(a))).path:m=R.$hc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$mh)(a.authority,m.authority))return;if(a.scheme===C.Schemas.file){const i=R.$mc(c(a),c(m));return T.$j?h.$zg(i):i}let p=a.path||"/";const f=m.path||"/";if(this.a(a)){let i=0;for(const s=Math.min(p.length,f.length);i<s&&!(p.charCodeAt(i)!==f.charCodeAt(i)&&p.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);p=f.substr(0,i)+p.substr(i)}return R.$hc.relative(p,f)}resolvePath(a,m){if(a.scheme===C.Schemas.file){const p=b.URI.file(R.$lc(c(a),m));return a.with({authority:p.authority,path:p.path})}return m=h.$Ag(m),a.with({path:R.$hc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,O.$Gf)(a,m)}hasTrailingPathSeparator(a,m=R.sep){if(a.scheme===C.Schemas.file){const p=c(a);return p.length>h.$Bg(p).length&&p[p.length-1]===m}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=R.sep){return(0,e.$nh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=R.sep){let p=!1;if(a.scheme===C.Schemas.file){const f=c(a);p=f!==void 0&&f.length===h.$Bg(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;p=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!p&&!(0,e.$nh)(a,m)?a.with({path:a.path+"/"}):a}}e.$9g=k,e.$0g=new k(()=>!1),e.$$g=new k(w=>w.scheme===C.Schemas.file?!T.$l:!0),e.$_g=new k(w=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function y(w,a){const m=[];for(let p=0;p<w.length;p++){const f=a(w[p]);w.some((i,s)=>s===p?!1:(0,e.$bh)(f,a(i)))||m.push(w[p])}return m}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(m){const p=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&p.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&p.set(w.META_DATA_MIME,i),p}w.parseMetaData=a})(u||(e.DataUri=u={}));function P(w,a,m){if(a){let p=w.path;return p&&p[0]!==R.$hc.sep&&(p=R.$hc.sep+p),w.with({scheme:m,authority:a,path:p})}return w.with({scheme:m})}}),define(ke[7],Ie([1,0,20,13,4,3,22,10,188,50]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=k,e.$th=y,e.$uh=u,e.$vh=P,e.$wh=w,e.$xh=a,e.$yh=m,e.$zh=p,e.$Hh=E,e.$Ih=D,e.$Jh=S,e.$Kh=I,e.$Lh=A,e.$1h=W,e.$9h=ie;function k(se){return!!se&&typeof se.then=="function"}function y(se){const X=new r.$xe,re=se(X.token),pe=new Promise((we,Me)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Me(new h.$5)});Promise.resolve(re).then(Ae=>{ze.dispose(),X.dispose(),we(Ae)},Ae=>{ze.dispose(),X.dispose(),Me(Ae)})});return new class{cancel(){X.cancel(),X.dispose()}then(we,Me){return pe.then(we,Me)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function u(se,X,re){return new Promise((pe,we)=>{const Me=X.onCancellationRequested(()=>{Me.dispose(),pe(re)});se.then(pe,we).finally(()=>Me.dispose())})}function P(se,X){return new Promise((re,pe)=>{const we=X.onCancellationRequested(()=>{we.dispose(),pe(new h.$5)});se.then(re,pe).finally(()=>we.dispose())})}async function w(se){let X=-1;const re=se.map((pe,we)=>pe.then(Me=>(X=we,Me)));try{return await Promise.race(re)}finally{se.forEach((pe,we)=>{we!==X&&pe.cancel()})}}function a(se,X,re){let pe;const we=setTimeout(()=>{pe?.(void 0),re?.()},X);return Promise.race([se.finally(()=>clearTimeout(we)),new Promise(Me=>pe=Me)])}function m(se){return new Promise((X,re)=>{const pe=se();k(pe)?pe.then(X,re):X(pe)})}function p(){let se,X;return{promise:new Promise((pe,we)=>{se=pe,X=we}),resolve:se,reject:X}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const re=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(re,re).then(pe)})}return new Promise((re,pe)=>{this.b.then(re,pe)})}return this.a=X(),new Promise((re,pe)=>{this.a.then(we=>{this.a=null,re(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$Ah=f;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Bh=i;class s{constructor(){this.a=new Map}queue(X,re){const we=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(X)===we&&this.a.delete(X)});return this.a.set(X,we),we}}e.$Ch=s;const t=(se,X)=>{let re=!0;const pe=setTimeout(()=>{re=!1,X()},se);return{isTriggered:()=>re,dispose:()=>{clearTimeout(pe),re=!1}}},o=se=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,se())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class n{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,re=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((we,Me)=>{this.d=we,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=re===b.$he?o(pe):t(re,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=n;class d{constructor(X){this.a=new n(X),this.b=new f}trigger(X,re){return this.a.trigger(()=>this.b.queue(X),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=d;class l{constructor(){this.a=!1,this.b=new Promise((X,re)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=l;class g extends l{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Gh=g;function E(se,X){return X?new Promise((re,pe)=>{const we=setTimeout(()=>{Me.dispose(),re()},se),Me=X.onCancellationRequested(()=>{clearTimeout(we),Me.dispose(),pe(new h.$5)})}):y(re=>E(se,re))}function D(se,X=0,re){const pe=setTimeout(()=>{se(),re&&we.dispose()},X),we=(0,R.$Tc)(()=>{clearTimeout(pe),re?.deleteAndLeak(we)});return re?.add(we),we}function S(se){const X=[];let re=0;const pe=se.length;function we(){return re<pe?se[re++]():null}function Me(ze){ze!=null&&X.push(ze);const Ae=we();return Ae?Ae.then(Me):Promise.resolve(X)}return Promise.resolve(null).then(Me)}function I(se,X=pe=>!!pe,re=null){let pe=0;const we=se.length,Me=()=>{if(pe>=we)return Promise.resolve(re);const ze=se[pe++];return Promise.resolve(ze()).then(De=>X(De)?Promise.resolve(De):Me())};return Me()}function A(se,X=pe=>!!pe,re=null){if(se.length===0)return Promise.resolve(re);let pe=se.length;const we=()=>{pe=-1;for(const Me of se)Me.cancel?.()};return new Promise((Me,ze)=>{for(const Ae of se)Ae.then(De=>{--pe>=0&&X(De)?(we(),Me(De)):pe===0&&Me(re)}).catch(De=>{--pe>=0&&(we(),ze(De))})})}class ${constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new C.$me}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,pe)=>{this.g.push({factory:X,c:re,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const re=X.factory();re.then(X.c,X.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=$;class v extends ${constructor(){super(1)}}e.$Nh=v;class M{constructor(){this.a=new J,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Oh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,re=T.$0g){const pe=re.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,re,pe=T.$0g){const we=pe.getComparisonKey(X);let Me=this.a.get(we);if(!Me){Me=new v;const ze=this.f++,Ae=C.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(ze,Ae),this.a.set(we,Me)}return Me.queue(re)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=N;class L{constructor(X,re){this.b=!1,this.a=-1,typeof X=="function"&&typeof re=="number"&&this.setIfNotSet(X,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,re){if(this.b)throw new h.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},re)}setIfNotSet(X,re){if(this.b)throw new h.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},re))}}e.$Qh=L;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,re,pe=globalThis){if(this.f)throw new h.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{X()},re);this.d=(0,R.$Tc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=F;class B{constructor(X,re){this.b=-1,this.a=X,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=B;class j{constructor(X,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=X,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=j;class U extends B{constructor(X,re){super(X,re),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Uh=U;class z extends R.$Vc{constructor(X,re){super(),this.g=X,this.h=re,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of X)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(se,X)=>{(0,O.$C)(()=>{if(re)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Xh=(se,X,re)=>{const pe=se.requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let we=!1;return{dispose(){we||(we=!0,se.cancelIdleCallback(pe))}}},e.$Wh=se=>(0,e.$Xh)(globalThis,se)}();class ee{constructor(X,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Xh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ee;class V extends ee{constructor(X){super(globalThis,X)}}e.$Zh=V;async function W(se,X,re){let pe;for(let we=0;we<re;we++)try{return await se()}catch(Me){pe=Me,await E(X)}throw pe}class J{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,re,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:re},re.then(()=>this.d(X),()=>this.d(X)),re}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:re,resolve:pe,reject:we}=p();this.b={run:X,promise:re,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=J;class _{constructor(X,re=()=>Date.now()){this.d=X,this.f=re,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$3h=_;var ce;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(ce||(ce={}));class ne{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,re)=>{this.a=X,this.b=re})}complete(X){return new Promise(re=>{this.a(X),this.d={outcome:ce.Resolved,value:X},re()})}error(X){return new Promise(re=>{this.b(X),this.d={outcome:ce.Rejected,value:X},re()})}cancel(){return this.error(new h.$5)}}e.$4h=ne;var ye;(function(se){async function X(pe){let we;const Me=await Promise.all(pe.map(ze=>ze.then(Ae=>Ae,Ae=>{we||(we=Ae)})));if(typeof we<"u")throw we;return Me}se.settled=X;function re(pe){return new Promise(async(we,Me)=>{try{await pe(we,Me)}catch(ze){Me(ze)}})}se.withAsyncBody=re})(ye||(e.Promises=ye={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new h.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=ge;class Y{constructor(X){this.b=X,this.a=new c.$U(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=Y;var q;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(q||(q={}));class oe{static fromArray(X){return new oe(re=>{re.emitMany(X)})}static fromPromise(X){return new oe(async re=>{re.emitMany(await X)})}static fromPromises(X){return new oe(async re=>{await Promise.all(X.map(async pe=>re.emitOne(await pe)))})}static merge(X){return new oe(async re=>{await Promise.all(X.map(async pe=>{for await(const we of pe)re.emitOne(we)}))})}static{this.EMPTY=oe.fromArray([])}constructor(X,re){this.a=q.Initial,this.b=[],this.d=null,this.f=re,this.g=new C.$me,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(X(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,re){return new oe(async pe=>{for await(const we of X)pe.emitOne(re(we))})}map(X){return oe.map(this,X)}static filter(X,re){return new oe(async pe=>{for await(const we of X)re(we)&&pe.emitOne(we)})}filter(X){return oe.filter(this,X)}static coalesce(X){return oe.filter(X,re=>!!re)}coalesce(){return oe.coalesce(this)}static async toPromise(X){const re=[];for await(const pe of X)re.push(pe);return re}toPromise(){return oe.toPromise(this)}h(X){this.a===q.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===q.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(X){this.a===q.Initial&&(this.a=q.DoneError,this.d=X,this.g.fire())}}e.$7h=oe;class ve extends oe{constructor(X,re){super(re),this.m=X}cancel(){this.m.cancel()}}e.$8h=ve;function ie(se){const X=new r.$xe,re=se(X.token);return new ve(X,async pe=>{const we=X.token.onCancellationRequested(()=>{we.dispose(),X.dispose(),pe.reject(new h.$5)});try{for await(const Me of re){if(X.token.isCancellationRequested)return;pe.emitOne(Me)}we.dispose(),X.dispose()}catch(Me){we.dispose(),X.dispose(),pe.reject(Me)}})}class ae{constructor(X){this.a=new ne,this.b=new oe(we=>{if(re){we.reject(re);return}return pe&&we.emitMany(pe),this.d=Me=>we.reject(Me),this.f=Me=>we.emitOne(Me),this.a.p},X);let re,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{re||(re=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$0h=ae}),define(ke[38],Ie([1,0,18,7,26,31,28,16,10,12]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=void 0,e.$wk=k,e.$zk=a,e.$Ak=M,e.$Bk=N,e.$Ck=L,e.$Dk=F,e.$Ek=B,e.$Fk=ee;function k(){return Object.create(null)}e.$xk="**",e.$yk="/";const y="[/\\\\]",u="[^/\\\\]",P=/\//g;function w(V,W){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${W?`|${y}${u}+`:""})*?`}}function a(V,W){if(!V)return[];const J=[];let _=!1,ce=!1,ne="";for(const ye of V){switch(ye){case W:if(!_&&!ce){J.push(ne),ne="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=ye}return ne&&J.push(ne),J}function m(V){if(!V)return"";let W="";const J=a(V,e.$yk);if(J.every(_=>_===e.$xk))W=".*";else{let _=!1;J.forEach((ce,ne)=>{if(ce===e.$xk){if(_)return;W+=w(2,ne===J.length-1)}else{let ye=!1,ge="",Y=!1,q="";for(const oe of ce){if(oe!=="}"&&ye){ge+=oe;continue}if(Y&&(oe!=="]"||!q)){let ve;oe==="-"?ve=oe:(oe==="^"||oe==="!")&&!q?ve="^":oe===e.$yk?ve="":ve=(0,c.$if)(oe),q+=ve;continue}switch(oe){case"{":ye=!0;continue;case"[":Y=!0;continue;case"}":{const ie=`(?:${a(ge,",").map(ae=>m(ae)).join("|")})`;W+=ie,ye=!1,ge="";break}case"]":{W+="["+q+"]",Y=!1,q="";break}case"?":W+=u;continue;case"*":W+=w(1);continue;default:W+=(0,c.$if)(oe)}}ne<J.length-1&&(J[ne+1]!==e.$xk||ne+2<J.length)&&(W+=y)}_=ce===e.$xk})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Ec(1e4),d=function(){return!1},l=function(){return null};function g(V,W){if(!V)return l;let J;typeof V!="string"?J=V.pattern:J=V,J=J.trim();const _=`${J}_${!!W.trimForExclusions}`;let ce=n.get(_);if(ce)return E(ce,V);let ne;return p.test(J)?ce=S(J.substr(4),J):(ne=f.exec(D(J,W)))?ce=I(ne[1],J):(W.trimForExclusions?s:i).test(J)?ce=A(J,W):(ne=t.exec(D(J,W)))?ce=$(ne[1].substr(1),J,!0):(ne=o.exec(D(J,W)))?ce=$(ne[1],J,!1):ce=v(J),n.set(_,ce),E(ce,V)}function E(V,W){if(typeof W=="string")return V;const J=function(_,ce){return(0,R.$Fg)(_,W.base,!b.$l)?V((0,c.$nf)(_.substr(W.base.length),O.sep),ce):null};return J.allBasenames=V.allBasenames,J.allPaths=V.allPaths,J.basenames=V.basenames,J.patterns=V.patterns,J}function D(V,W){return W.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function S(V,W){return function(J,_){return typeof J=="string"&&J.endsWith(V)?W:null}}function I(V,W){const J=`/${V}`,_=`\\${V}`,ce=function(ye,ge){return typeof ye!="string"?null:ge?ge===V?W:null:ye===V||ye.endsWith(J)||ye.endsWith(_)?W:null},ne=[V];return ce.basenames=ne,ce.patterns=[W],ce.allBasenames=ne,ce}function A(V,W){const J=z(V.slice(1,-1).split(",").map(ge=>g(ge,W)).filter(ge=>ge!==l),V),_=J.length;if(!_)return l;if(_===1)return J[0];const ce=function(ge,Y){for(let q=0,oe=J.length;q<oe;q++)if(J[q](ge,Y))return V;return null},ne=J.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=J.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function $(V,W,J){const _=O.sep===O.$hc.sep,ce=_?V:V.replace(P,O.sep),ne=O.sep+ce,ye=O.$hc.sep+V;let ge;return J?ge=function(Y,q){return typeof Y=="string"&&(Y===ce||Y.endsWith(ne)||!_&&(Y===V||Y.endsWith(ye)))?W:null}:ge=function(Y,q){return typeof Y=="string"&&(Y===ce||!_&&Y===V)?W:null},ge.allPaths=[(J?"*/":"./")+V],ge}function v(V){try{const W=new RegExp(`^${m(V)}$`);return function(J){return W.lastIndex=0,typeof J=="string"&&W.test(J)?V:null}}catch{return l}}function M(V,W,J){return!V||typeof W!="string"?!1:N(V)(W,void 0,J)}function N(V,W={}){if(!V)return d;if(typeof V=="string"||L(V)){const J=g(V,W);if(J===l)return d;const _=function(ce,ne){return!!J(ce,ne)};return J.allBasenames&&(_.allBasenames=J.allBasenames),J.allPaths&&(_.allPaths=J.allPaths),_}return j(V,W)}function L(V){const W=V;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(V){return V.allBasenames||[]}function B(V){return V.allPaths||[]}function j(V,W){const J=z(Object.getOwnPropertyNames(V).map(ge=>U(ge,V[ge],W)).filter(ge=>ge!==l)),_=J.length;if(!_)return l;if(!J.some(ge=>!!ge.requiresSiblings)){if(_===1)return J[0];const ge=function(oe,ve){let ie;for(let ae=0,se=J.length;ae<se;ae++){const X=J[ae](oe,ve);if(typeof X=="string")return X;(0,h.$sh)(X)&&(ie||(ie=[]),ie.push(X))}return ie?(async()=>{for(const ae of ie){const se=await ae;if(typeof se=="string")return se}return null})():null},Y=J.find(oe=>!!oe.allBasenames);Y&&(ge.allBasenames=Y.allBasenames);const q=J.reduce((oe,ve)=>ve.allPaths?oe.concat(ve.allPaths):oe,[]);return q.length&&(ge.allPaths=q),ge}const ce=function(ge,Y,q){let oe,ve;for(let ie=0,ae=J.length;ie<ae;ie++){const se=J[ie];se.requiresSiblings&&q&&(Y||(Y=(0,O.$oc)(ge)),oe||(oe=Y.substr(0,Y.length-(0,O.$pc)(ge).length)));const X=se(ge,Y,oe,q);if(typeof X=="string")return X;(0,h.$sh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ie of ve){const ae=await ie;if(typeof ae=="string")return ae}return null})():null},ne=J.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=J.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function U(V,W,J){if(W===!1)return l;const _=g(V,J);if(_===l)return l;if(typeof W=="boolean")return _;if(W){const ce=W.when;if(typeof ce=="string"){const ne=(ye,ge,Y,q)=>{if(!q||!_(ye,ge))return null;const oe=ce.replace("$(basename)",()=>Y),ve=q(oe);return(0,h.$sh)(ve)?ve.then(ie=>ie?V:null):ve?V:null};return ne.requiresSiblings=!0,ne}}return _}function z(V,W){const J=V.filter(ge=>!!ge.basenames);if(J.length<2)return V;const _=J.reduce((ge,Y)=>{const q=Y.basenames;return q?ge.concat(q):ge},[]);let ce;if(W){ce=[];for(let ge=0,Y=_.length;ge<Y;ge++)ce.push(W)}else ce=J.reduce((ge,Y)=>{const q=Y.patterns;return q?ge.concat(q):ge},[]);const ne=function(ge,Y){if(typeof ge!="string")return null;if(!Y){let oe;for(oe=ge.length;oe>0;oe--){const ve=ge.charCodeAt(oe-1);if(ve===C.CharCode.Slash||ve===C.CharCode.Backslash)break}Y=ge.substr(oe)}const q=_.indexOf(Y);return q!==-1?ce[q]:null};ne.basenames=_,ne.patterns=ce,ne.allBasenames=_;const ye=V.filter(ge=>!ge.basenames);return ye.push(ne),ye}function ee(V,W){return(0,r.$ub)(V,W,(J,_)=>typeof J=="string"&&typeof _=="string"?J===_:typeof J!="string"&&typeof _!="string"?J.base===_.base&&J.pattern===_.pattern:!1)}}),define(ke[85],Ie([1,0,13,138,22,12,2]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.MarkdownStringTextNewlineStyle=void 0,e.$6k=c,e.$7k=k,e.$8k=y,e.$9k=u,e.$0k=P,e.$$k=w,e.$_k=a,e.$al=m;var O;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class b{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=O.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Yk)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${P(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,i){const s=new RegExp((0,R.$if)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$5k=b;function c(p){return k(p)?!p.value:Array.isArray(p)?p.every(c):!0}function k(p){return p instanceof b?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||typeof p.isTrusted=="object"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}function y(p,f){return p===f?!0:!p||!f?!1:p.value===f.value&&p.isTrusted===f.isTrusted&&p.supportThemeIcons===f.supportThemeIcons&&p.supportHtml===f.supportHtml&&(p.baseUri===f.baseUri||!!p.baseUri&&!!f.baseUri&&(0,C.$ah)(T.URI.from(p.baseUri),T.URI.from(f.baseUri)))}function u(p){return p.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(p,f){const i=p.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,p,`${"`".repeat(s)}`].join(`
`)}function w(p){return p.replace(/"/g,"&quot;")}function a(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(p){const f=[],i=p.split("|").map(t=>t.trim());p=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",d=o?o[1]:"",l=isFinite(parseInt(d)),g=isFinite(parseInt(n));l&&f.push(`width="${d}"`),g&&f.push(`height="${n}"`)}return{href:p,dimensions:f}}}),define(ke[107],Ie([1,0,18,31,16,10,22,12]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4w=b,e.$5w=k,e.$6w=u,e.$7w=P,e.$8w=p,e.$9w=i,e.$0w=s,e.$$w=t,e.$_w=o,e.$ax=n;function b(l,g){const{os:E,tildify:D,relative:S}=g;if(S){const $=c(l,S,E);if(typeof $=="string")return $}let I=l.fsPath;if(E===R.OperatingSystem.Windows&&!R.$j?I=I.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$j&&(I=I.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&D?.userHome){const $=D.userHome.fsPath;let v;l.scheme!==D.userHome.scheme&&l.path[0]===C.$hc.sep&&l.path[1]!==C.$hc.sep?v=D.userHome.with({path:l.path}).fsPath:v=I,I=u(v,$,E)}return(E===R.OperatingSystem.Windows?C.$gc:C.$hc).normalize(k(I,E===R.OperatingSystem.Windows))}function c(l,g,E){const D=E===R.OperatingSystem.Windows?C.$gc:C.$hc,S=E===R.OperatingSystem.Linux?T.$0g:T.$_g,I=g.getWorkspace(),A=(0,r.$Ob)(I.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===C.$hc.sep&&l.path[1]!==C.$hc.sep&&(l=A.uri.with({path:l.path}));const $=g.getWorkspaceFolder(l);if(!$)return;let v;if(S.isEqual($.uri,l)?v="":v=S.relativePath($.uri,l)??"",v&&(v=D.normalize(v)),I.folders.length>1&&!g.noPrefix){const M=$.name?$.name:S.basenameOrAuthority($.uri);v=v?`${M} \u2022 ${v}`:M}return v}function k(l,g=R.$j){return(0,h.$Kg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let y=Object.create(null);function u(l,g,E=R.OS){if(E===R.OperatingSystem.Windows||!l||!g)return l;let D=y.original===g?y.normalized:void 0;D||(D=g,R.$j&&(D=(0,h.$zg)(D)),D=`${(0,O.$of)(D,C.$hc.sep)}${C.$hc.sep}`,y={original:g,normalized:D});let S=l;return R.$j&&(S=(0,h.$zg)(S)),(E===R.OperatingSystem.Linux?S.startsWith(D):(0,O.$Hf)(S,D))?`~/${S.substr(D.length)}`:l}function P(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const w="\u2026",a="\\\\",m="~";function p(l,g=C.sep){const E=new Array(l.length);let D=!1;for(let S=0;S<l.length;S++){const I=l[S];if(I===""){E[S]=`.${g}`;continue}if(!I){E[S]=I;continue}D=!0;let A="",$=I;$.indexOf(a)===0?(A=$.substr(0,$.indexOf(a)+a.length),$=$.substr($.indexOf(a)+a.length)):$.indexOf(g)===0?(A=$.substr(0,$.indexOf(g)+g.length),$=$.substr($.indexOf(g)+g.length)):$.indexOf(m)===0&&(A=$.substr(0,$.indexOf(m)+m.length),$=$.substr($.indexOf(m)+m.length));const v=$.split(g);for(let M=1;D&&M<=v.length;M++)for(let N=v.length-M;D&&N>=0;N--){D=!1;let L=v.slice(N,N+M).join(g);for(let F=0;!D&&F<l.length;F++)if(F!==S&&l[F]&&l[F].indexOf(L)>-1){const B=N+M===v.length,j=N>0&&l[F].indexOf(g)>-1?g+L:L,U=l[F].endsWith(j);D=!B||U}if(!D){let F="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,M++,L=v[0]+g+L),N>0&&(F=v[0]+g),F=A+F),N>0&&(F=F+w+g),F=F+L,N+M<v.length&&(F=F+g+w),E[S]=F}}D&&(E[S]=I)}return E}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(l,g=Object.create(null)){const E=[];let D=!1,S="";for(const I of l)if(I==="$"||D&&I==="{")S&&E.push({value:S,type:f.TEXT}),S="",D=!0;else if(I==="}"&&D){const A=g[S];if(typeof A=="string")A.length&&E.push({value:A,type:f.VARIABLE});else if(A){const $=E[E.length-1];(!$||$.type!==f.SEPARATOR)&&E.push({value:A.label,type:f.SEPARATOR})}S="",D=!1}else S+=I;return S&&!D&&E.push({value:S,type:f.TEXT}),E.filter((I,A)=>{if(I.type===f.SEPARATOR){const $=E[A-1],v=E[A+1];return[$,v].every(M=>M&&(M.type===f.VARIABLE||M.type===f.TEXT)&&M.value.length>0)}return!0}).map(I=>I.value).join("")}function s(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,""):R.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function o(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const E=d(l.substring(0,g)),D=l.substring(g);return{name:E.name+D,parentPath:E.parentPath}}}return d(l)}function d(l){const g=l.indexOf("/")!==-1?C.$hc:C.$gc,E=g.basename(l),D=g.dirname(l);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(ke[140],Ie([1,0,21,40,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=b,e.$Qn=k,e.$Rn=y;function R(u){return u.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:R(C.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:R(C.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:C.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Nn=T,e.$On=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,P,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=O(u[a],P,w+1);m!==null&&(u[a]=m)}}return null}function b(u,P){const w=O(u,P,0);return w===null?u:w}function c(u,P,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?C.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Oe)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const p=c(u[m],P,w,a+1);p!==null&&(u[m]=p)}}return null}function k(u,P){const w=c(u,P,!1,0);return w===null?u:w}function y(u,P){const w=c(u,P,!0,0);return w===null?u:w}}),define(ke[32],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(C){return r.test(C)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(O){for(let b=0;b<O.length;b++)O[b]=Math.floor(Math.random()*256);return O};const R=new Uint8Array(16),T=[];for(let O=0;O<256;O++)T.push(O.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,c="";return c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c}}()}),define(ke[191],Ie([1,0,18,39,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.$uu=void 0,e.$su=R,e.$tu=T,e.$vu=c;function R(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function T(y,u,P){const w={id:(0,C.$3g)(),name:y,uri:u,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class O{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&P.push("files"),k(b(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const w=this.a.get(u);w?w.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const w of P)yield[u,w]}b(u){return b(u)}}e.$uu=O;function b(y){return y.toLowerCase()}function c(y,u){return k(b(y),u.map(b))}function k(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const P=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,a,m]=P;return m==="*"?u.some(p=>p.startsWith(a+"/")):!1}e.$wu=Object.freeze({create:y=>(0,r.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$wu.split(y).filter(u=>!u.startsWith("#"))})}),define(ke[33],Ie([1,0,45,66,360,7,31,81,16,10,22,2]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=E,e.writeFileSync=S,r=We(r);var u;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(j,U=u.UNLINK,z){if((0,T.$Jg)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===u.UNLINK?a(j):w(j,z)}async function w(j,U=(0,T.$Og)((0,h.tmpdir)())){try{try{await r.promises.rename(j,U)}catch(z){return z.code==="ENOENT"?void 0:a(j)}a(U).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function a(j){return r.promises.rm(j,{recursive:!0,force:!0,maxRetries:3})}function m(j){if((0,T.$Jg)(j))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function p(j,U){return s(await(U?f(j):r.promises.readdir(j)))}async function f(j){try{return await r.promises.readdir(j,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const U=[],z=await p(j);for(const ee of z){let V=!1,W=!1,J=!1;try{const _=await r.promises.lstat((0,b.$kc)(j,ee));V=_.isFile(),W=_.isDirectory(),J=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}U.push({name:ee,isFile:()=>V,isDirectory:()=>W,isSymbolicLink:()=>J})}return U}function i(j){return s(r.readdirSync(j))}function s(j){return j.map(U=>typeof U=="string"?c.$k?(0,O.$om)(U):U:(U.name=c.$k?(0,O.$om)(U.name):U.name,U))}async function t(j){const U=await p(j),z=[];for(const ee of U)await n.existsDirectory((0,b.$kc)(j,ee))&&z.push(ee);return z}function o(j,U=1e3){return new Promise(z=>{let ee=!1;const V=setInterval(()=>{ee||(ee=!0,r.access(j,W=>{ee=!1,W&&(clearInterval(V),z(void 0))}))},U)})}var n;(function(j){async function U(V){let W;try{if(W=await r.promises.lstat(V),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await r.promises.stat(V),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(c.$j&&J.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw _}throw J}}j.stat=U;async function z(V){try{const{stat:W,symbolicLink:J}=await j.stat(V);return W.isFile()&&J?.dangling!==!0}catch{}return!1}j.existsFile=z;async function ee(V){try{const{stat:W,symbolicLink:J}=await j.stat(V);return W.isDirectory()&&J?.dangling!==!0}catch{}return!1}j.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const d=new R.$Ph;function l(j,U,z){return d.queueFor(y.URI.file(j),()=>{const ee=I(z);return new Promise((V,W)=>D(j,U,ee,J=>J?W(J):V()))},k.$$g)}let g=!0;function E(j){g=j}function D(j,U,z,ee){if(!g)return r.writeFile(j,U,{mode:z.mode,flag:z.flag},ee);r.open(j,z.flag,z.mode,(V,W)=>{if(V)return ee(V);r.writeFile(W,U,J=>{if(J)return r.close(W,()=>ee(J));r.fdatasync(W,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),E(!1)),r.close(W,ce=>ee(ce))))})})}function S(j,U,z){const ee=I(z);if(!g)return r.writeFileSync(j,U,{mode:ee.mode,flag:ee.flag});const V=r.openSync(j,ee.flag,ee.mode);try{r.writeFileSync(V,U);try{r.fdatasyncSync(V)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),E(!1)}}finally{r.closeSync(V)}}function I(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function A(j,U,z=6e4){if(j!==U)try{c.$j&&typeof z=="number"?await $(j,U,Date.now(),z):await r.promises.rename(j,U)}catch(ee){if(j.toLowerCase()!==U.toLowerCase()&&ee.code==="EXDEV"||j.endsWith("."))await v(j,U,{preserveSymlinks:!1}),await P(j,u.MOVE);else throw ee}}async function $(j,U,z,ee,V=0){try{return await r.promises.rename(j,U)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-z>=ee)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${W}`),W;if(V===0){let J=!1;try{const{stat:_}=await n.stat(U);_.isFile()||(J=!0)}catch{}if(J)throw W}return await(0,R.$Hh)(Math.min(100,V*10)),$(j,U,z,ee,V+1)}}async function v(j,U,z){return N(j,U,{root:{source:j,target:U},options:z,handledSourcePaths:new Set})}const M=511;async function N(j,U,z){if(z.handledSourcePaths.has(j))return;z.handledSourcePaths.add(j);const{stat:ee,symbolicLink:V}=await n.stat(j);if(V){if(z.options.preserveSymlinks)try{return await B(j,U,z)}catch{}if(V.dangling)return}return ee.isDirectory()?L(j,U,ee.mode&M,z):F(j,U,ee.mode&M)}async function L(j,U,z,ee){await r.promises.mkdir(U,{recursive:!0,mode:z});const V=await p(j);for(const W of V)await N((0,b.$kc)(j,W),(0,b.$kc)(U,W),ee)}async function F(j,U,z){await r.promises.copyFile(j,U),await r.promises.chmod(U,z)}async function B(j,U,z){let ee=await r.promises.readlink(j);(0,T.$Fg)(ee,z.root.source,!c.$l)&&(ee=(0,b.$kc)(z.root.target,ee.substr(z.root.source.length+1))),await r.promises.symlink(ee,U)}e.Promises=new class{get read(){return(j,U,z,ee,V)=>new Promise((W,J)=>{r.read(j,U,z,ee,V,(_,ce,ne)=>_?J(_):W({bytesRead:ce,buffer:ne}))})}get write(){return(j,U,z,ee,V)=>new Promise((W,J)=>{r.write(j,U,z,ee,V,(_,ce,ne)=>_?J(_):W({bytesWritten:ce,buffer:ne}))})}get fdatasync(){return(0,C.promisify)(r.fdatasync)}get open(){return(0,C.promisify)(r.open)}get close(){return(0,C.promisify)(r.close)}get realpath(){return(0,C.promisify)(r.realpath)}async exists(j){try{return await r.promises.access(j),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(ke[108],Ie([1,0,45,16,10,12,33]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=O,e.$pr=b,e.$qr=c,e.$rr=k,r=We(r);function O(u){if(C.$l)return u;const P=(0,h.$nc)(u);if(u===P)return u;const w=((0,h.$oc)(u)||u).toLowerCase();try{const m=(0,T.readdirSync)(P).filter(p=>p.toLowerCase()===w);if(m.length===1){const p=O(P);if(p)return(0,h.$kc)(p,m[0])}else if(m.length>1){const p=m.indexOf(w);if(p>=0){const f=O(P);if(f)return(0,h.$kc)(f,m[p])}}}catch{}return null}async function b(u,P){if(C.$l)return u;const w=(0,h.$nc)(u);if(u===w)return u;const a=((0,h.$oc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const p=(await T.Promises.readdir(w)).filter(f=>f.toLowerCase()===a);if(p.length===1){const f=await b(w,P);if(f)return(0,h.$kc)(f,p[0])}else if(p.length>1){const f=p.indexOf(a);if(f>=0){const i=await b(w,P);if(i)return(0,h.$kc)(i,p[f])}}}catch{}return null}async function c(u){try{return await T.Promises.realpath(u)}catch{const w=y(u);return await r.promises.access(w,r.constants.R_OK),w}}function k(u){try{return r.realpathSync(u)}catch{const w=y(u);return r.accessSync(w,r.constants.R_OK),w}}function y(u){return(0,R.$of)((0,h.$ic)(u),h.sep)}}),define(ke[192],Ie([1,0,67]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=h,e.$7g=R,r=We(r);function h(O,b,c,k=1){let y=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!y)return y=!0,u(0)},c);C(O,b,k,w=>{if(!y)return y=!0,clearTimeout(P),u(w)})})}function C(O,b,c,k){if(b===0)return k(0);const y=new r.Socket;y.once("connect",()=>(T(y),C(O+c,b-1,c,k))),y.once("data",()=>{}),y.once("error",u=>(T(y),u.code!=="ECONNREFUSED"?C(O+c,b-1,c,k):k(O))),y.connect(O,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(O,b,c,k="127.0.0.1"){let y=!1,u,P=1;const w=r.createServer({pauseOnConnect:!0});function a(m,p){y||(y=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),p(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},c),w.on("listening",()=>{a(O,m)}),w.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&P<b?(O++,P++,w.listen(O,k)):a(0,m)}),w.on("close",()=>{a(0,m)}),w.listen(O,k)})}function T(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(b){console.error(b)}}}),define(ke[109],Ie([1,0,45,16,10,55,104,17,33]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$zm=c,e.$Am=k,h=We(h),C=We(C),R=We(R),O=We(O),b=We(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(u=R.env){return u.comspec||"cmd.exe"}function k(u){let P=[],w=!1;const a=function(m){if(w){P.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),w=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(s=>a(s))}})||C.$j)&&(w=!0)};return{send:a}}var y;(function(u){async function P(w,a,m){if(h.$jc(w))return w;if(a===void 0&&(a=R.cwd()),h.$nc(w)!=="."||(m===void 0&&O.$fg(R.env.PATH)&&(m=R.env.PATH.split(h.$uc)),m===void 0||m.length===0))return h.$kc(a,w);async function f(i){if(await b.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(h.$jc(i)?s=h.$kc(i,w):s=h.$kc(a,i,w),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return h.$kc(a,w)}u.findExecutable=P})(y||(e.win32=y={}))});var Ze=this&&this.__decorate||function($e,e,r,h){var C=arguments.length,R=C<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,r,h);else for(var O=$e.length-1;O>=0;O--)(T=$e[O])&&(R=(C<3?T(R):C>3?T(e,r,R):T(e,r))||R);return C>3&&R&&Object.defineProperty(e,r,R),R};define(ke[86],Ie([1,0,18,7,21,20,59,13,4,3,44,12,17]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=E,e.$hi=D,e.$mi=M,e.$ni=N,y=We(y);var P;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(P||(P={}));function w(V){switch(V){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(a||(a={}));function m(V){switch(V){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var p;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(p||(p={}));function f(V){let W=0;for(let J=0;;J+=7){const _=V.read(1);if(W|=(_.buffer[0]&127)<<J,!(_.buffer[0]&128))return W}}const i=d(0);function s(V,W){if(W===0){V.write(i);return}let J=0;for(let ce=W;ce!==0;ce=ce>>>7)J++;const _=C.$Oe.alloc(J);for(let ce=0;W!==0;ce++)_.buffer[ce]=W&127,W=W>>>7,W>0&&(_.buffer[ce]|=128);V.write(_)}class t{constructor(W){this.b=W,this.a=0}read(W){const J=this.b.slice(this.a,this.a+W);return this.a+=J.byteLength,J}}e.$ei=t;class o{constructor(){this.a=[]}get buffer(){return C.$Oe.concat(this.a)}write(W){this.a.push(W)}}e.$fi=o;var n;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(n||(n={}));function d(V){const W=C.$Oe.alloc(1);return W.writeUInt8(V,0),W}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},g=typeof Buffer<"u";function E(V,W){if(typeof W>"u")V.write(l.Undefined);else if(typeof W=="string"){const J=C.$Oe.fromString(W);V.write(l.String),s(V,J.byteLength),V.write(J)}else if(g&&Buffer.isBuffer(W)){const J=C.$Oe.wrap(W);V.write(l.Buffer),s(V,J.byteLength),V.write(J)}else if(W instanceof C.$Oe)V.write(l.VSBuffer),s(V,W.byteLength),V.write(W);else if(Array.isArray(W)){V.write(l.Array),s(V,W.length);for(const J of W)E(V,J)}else if(typeof W=="number"&&(W|0)===W)V.write(l.Uint),s(V,W);else{const J=C.$Oe.fromString(JSON.stringify(W));V.write(l.Object),s(V,J.byteLength),V.write(J)}}function D(V){switch(V.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return V.read(f(V)).toString();case n.Buffer:return V.read(f(V)).buffer;case n.VSBuffer:return V.read(f(V));case n.Array:{const J=f(V),_=[];for(let ce=0;ce<J;ce++)_.push(D(V));return _}case n.Object:return JSON.parse(V.read(f(V)).toString());case n.Int:return f(V)}}class S{constructor(W,J,_=null,ce=1e3){this.h=W,this.j=J,this.k=_,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:a.Initialize})}registerChannel(W,J){this.b.set(W,J),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case a.Initialize:{const J=this.o([W.type]);this.k?.logOutgoing(J,0,I.OtherSide,m(W.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const J=this.o([W.type,W.id],W.data);this.k?.logOutgoing(J,W.id,I.OtherSide,m(W.type),W.data);return}}}o(W,J=void 0){const _=new o;return E(_,W),E(_,J),this.p(_.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const J=new t(W),_=D(J),ce=D(J),ne=_[0];switch(ne){case P.Promise:return this.k?.logIncoming(W.byteLength,_[1],I.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.s({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case P.EventListen:return this.k?.logIncoming(W.byteLength,_[1],I.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.t({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case P.PromiseCancel:return this.k?.logIncoming(W.byteLength,_[1],I.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]});case P.EventDispose:return this.k?.logIncoming(W.byteLength,_[1],I.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]})}}s(W){const J=this.b.get(W.channelName);if(!J){this.v(W);return}const _=new R.$xe;let ce;try{ce=J.call(this.j,W.name,W.arg,_.token)}catch(ge){ce=Promise.reject(ge)}const ne=W.id;ce.then(ge=>{this.m({id:ne,data:ge,type:a.PromiseSuccess})},ge=>{ge instanceof Error?this.m({id:ne,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:ne,data:ge,type:a.PromiseErrorObj})}).finally(()=>{ye.dispose(),this.d.delete(W.id)});const ye=(0,c.$Tc)(()=>_.cancel());this.d.set(W.id,ye)}t(W){const J=this.b.get(W.channelName);if(!J){this.v(W);return}const _=W.id,ne=J.listen(this.j,W.name,W.arg)(ye=>this.m({id:_,data:ye,type:a.EventFire}));this.d.set(W.id,ne)}u(W){const J=this.d.get(W.id);J&&(J.dispose(),this.d.delete(W.id))}v(W){let J=this.g.get(W.channelName);J||(J=[],this.g.set(W.channelName,J));const _=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===P.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);J.push({request:W,timeoutTimer:_})}w(W){const J=this.g.get(W);if(J){for(const _ of J)switch(clearTimeout(_.timeoutTimer),_.request.type){case P.Promise:this.s(_.request);break;case P.EventListen:this.t(_.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ii=S;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class A{constructor(W,J=null){this.l=W,this.a=!1,this.b=p.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=J}getChannel(W){const J=this;return{call(_,ce,ne){return J.a?Promise.reject(new O.$5):J.m(W,_,ce,ne)},listen(_,ce){return J.a?b.Event.None:J.o(W,_,ce)}}}m(W,J,_,ce=R.CancellationToken.None){const ne=this.g++,ye=P.Promise,ge={id:ne,type:ye,channelName:W,name:J,arg:_};if(ce.isCancellationRequested)return Promise.reject(new O.$5);let Y;return new Promise((oe,ve)=>{if(ce.isCancellationRequested)return ve(new O.$5);const ie=()=>{const re=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(ne),oe(pe.data);break;case a.PromiseError:{this.f.delete(ne);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ve(we);break}case a.PromiseErrorObj:this.f.delete(ne),ve(pe.data);break}};this.f.set(ne,re),this.p(ge)};let ae=null;this.b===p.Idle?ie():(ae=(0,h.$th)(re=>this.u()),ae.then(()=>{ae=null,ie()}));const se=()=>{ae?(ae.cancel(),ae=null):this.p({id:ne,type:P.PromiseCancel}),ve(new O.$5)},X=ce.onCancellationRequested(se);Y=(0,c.$Sc)((0,c.$Tc)(se),X),this.d.add(Y)}).finally(()=>{Y.dispose(),this.d.delete(Y)})}o(W,J,_){const ce=this.g++,ne=P.EventListen,ye={id:ce,type:ne,channelName:W,name:J,arg:_};let ge=null;const Y=new b.$me({onWillAddFirstListener:()=>{ge=(0,h.$th)(oe=>this.u()),ge.then(()=>{ge=null,this.d.add(Y),this.p(ye)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(Y),this.p({id:ce,type:P.EventDispose}))}}),q=oe=>Y.fire(oe.data);return this.f.set(ce,q),Y.event}p(W){switch(W.type){case P.Promise:case P.EventListen:{const J=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(J,W.id,I.LocalSide,`${w(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case P.PromiseCancel:case P.EventDispose:{const J=this.q([W.type,W.id]);this.j?.logOutgoing(J,W.id,I.LocalSide,w(W.type));return}}}q(W,J=void 0){const _=new o;return E(_,W),E(_,J),this.r(_.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const J=new t(W),_=D(J),ce=D(J),ne=_[0];switch(ne){case a.Initialize:return this.j?.logIncoming(W.byteLength,0,I.LocalSide,m(ne)),this.t({type:_[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,_[1],I.LocalSide,m(ne),ce),this.t({type:_[0],id:_[1],data:ce})}}t(W){if(W.type===a.Initialize){this.b=p.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ji=A,Ze([T.$$h],A.prototype,"onDidInitializePromise",null);class ${get connections(){const W=[];return this.f.forEach(J=>W.push(J)),W}constructor(W,J,_){this.a=new Map,this.f=new Set,this.g=new b.$me,this.onDidAddConnection=this.g.event,this.h=new b.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Uc,this.j.add(W(({protocol:ce,onDidClientDisconnect:ne})=>{const ye=b.Event.once(ce.onMessage);this.j.add(ye(ge=>{const Y=new t(ge),q=D(Y),oe=new S(ce,q,J,_),ve=new A(ce,J);this.a.forEach((ae,se)=>oe.registerChannel(se,ae));const ie={channelServer:oe,channelClient:ve,ctx:q};this.f.add(ie),this.g.fire(ie),this.j.add(ne(()=>{oe.dispose(),ve.dispose(),this.f.delete(ie),this.h.fire(ie)}))}))}))}getChannel(W,J){const _=this;return{call(ce,ne,ye){let ge;if((0,u.$tg)(J)){const q=(0,r.$3b)(_.connections.filter(J));ge=q?Promise.resolve(q):b.Event.toPromise(b.Event.filter(_.onDidAddConnection,J))}else ge=J.routeCall(_,ce,ne);const Y=ge.then(q=>q.channelClient.getChannel(W));return M(Y).call(ce,ne,ye)},listen(ce,ne){if((0,u.$tg)(J))return _.k(W,J,ce,ne);const ye=J.routeEvent(_,ce,ne).then(ge=>ge.channelClient.getChannel(W));return M(ye).listen(ce,ne)}}}k(W,J,_,ce){const ne=this;let ye;const ge=new b.$me({onWillAddFirstListener:()=>{ye=new c.$Uc;const Y=new b.$se,q=new Map,oe=ie=>{const se=ie.channelClient.getChannel(W).listen(_,ce),X=Y.add(se);q.set(ie,X)},ve=ie=>{const ae=q.get(ie);ae&&(ae.dispose(),q.delete(ie))};ne.connections.filter(J).forEach(oe),b.Event.filter(ne.onDidAddConnection,J)(oe,void 0,ye),ne.onDidRemoveConnection(ve,void 0,ye),Y.event(ge.fire,ge,ye),ye.add(Y)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return ge.event}registerChannel(W,J){this.a.set(W,J);for(const _ of this.f)_.channelServer.registerChannel(W,J)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=$;class v{constructor(W,J,_=null){const ce=new o;E(ce,J),W.send(ce.buffer),this.a=new A(W,_),this.d=new S(W,J,_)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,J){this.d.registerChannel(W,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=v;function M(V){return{call(W,J,_){return V.then(ce=>ce.call(W,J,_))},listen(W,J){const _=new b.$ve;return V.then(ce=>_.input=ce.listen(W,J)),_.event}}}function N(V){let W=!1;return{call(J,_,ce){return W?V.call(J,_,ce):(0,h.$Hh)(0).then(()=>W=!0).then(()=>V.call(J,_,ce))},listen(J,_){if(W)return V.listen(J,_);const ce=new b.$ve;return(0,h.$Hh)(0).then(()=>W=!0).then(()=>ce.input=V.listen(J,_)),ce.event}}}class L{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const J of W.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await b.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$oi=L;var F;(function(V){function W(ne,ye,ge){const Y=ne,q=ge&&ge.disableMarshalling,oe=new Map;for(const ve in Y)_(ve)&&oe.set(ve,b.Event.buffer(Y[ve],!0,void 0,ye));return new class{listen(ve,ie,ae){const se=oe.get(ie);if(se)return se;const X=Y[ie];if(typeof X=="function"){if(ce(ie))return X.call(Y,ae);if(_(ie))return oe.set(ie,b.Event.buffer(Y[ie],!0,void 0,ye)),oe.get(ie)}throw new O.$bb(`Event not found: ${ie}`)}call(ve,ie,ae){const se=Y[ie];if(typeof se=="function"){if(!q&&Array.isArray(ae))for(let re=0;re<ae.length;re++)ae[re]=(0,k.$di)(ae[re]);let X=se.apply(Y,ae);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new O.$bb(`Method not found: ${ie}`)}}}V.fromService=W;function J(ne,ye){const ge=ye&&ye.disableMarshalling;return new Proxy({},{get(Y,q){if(typeof q=="string")return ye?.properties?.has(q)?ye.properties.get(q):ce(q)?function(oe){return ne.listen(q,oe)}:_(q)?ne.listen(q):async function(...oe){let ve;ye&&!(0,u.$og)(ye.context)?ve=[ye.context,...oe]:ve=oe;const ie=await ne.call(q,ve);return ge?ie:(0,k.$di)(ie)};throw new O.$bb(`Property not found: ${String(q)}`)}})}V.toService=J;function _(ne){return ne[0]==="o"&&ne[1]==="n"&&y.$Ff(ne.charCodeAt(2))}function ce(ne){return/^onDynamic/.test(ne)&&y.$Ff(ne.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const W=V.toString();if(W!=="[object Object]")return W}return V}function U(V){return Array.isArray(V)?V.map(j):j(V)}function z(V,W,J,_,ce,ne,ye){ye=U(ye);const ge=B[ce],Y=ge[_%ge.length];let q=[`%c[${V}]%c[${String(W).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(ne)?(q=q.concat(ye),q.push(")")):q.push(ye),console.log.apply(console,q)}class ee{constructor(W,J){this.d=W,this.f=J,this.a=0,this.b=0}logOutgoing(W,J,_,ce,ne){this.b+=W,z(this.d,this.b,W,J,_,ce,ne)}logIncoming(W,J,_,ce,ne){this.a+=W,z(this.f,this.a,W,J,_,ce,ne)}}e.$pi=ee}),define(ke[68],Ie([1,0,21,4,3,86]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var O;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let E=0;function D(I,A){if(!g.has(I)){const $=String(++E);g.set(I,$)}return g.get(I)}function S(I,A,$,v){if(!l.enableDiagnostics)return;const M=D(I,A);if(v instanceof r.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Oe.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:M,label:A,type:$,buff:N})}else l.records.push({timestamp:Date.now(),id:M,label:A,type:$,data:v})}l.traceSocketEvent=S})(O||(e.SocketDiagnostics=O={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let c=null;function k(){return c||(c=r.$Oe.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,E){if(g===0)return k();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const A=this.a[0];return E&&(this.a.shift(),this.b-=g),A}if(this.a[0].byteLength>g){const A=this.a[0].slice(0,g);return E&&(this.a[0]=this.a[0].slice(g),this.b-=g),A}const D=r.$Oe.alloc(g);let S=0,I=0;for(;g>0;){const A=this.a[I];if(A.byteLength>g){const $=A.slice(0,g);D.set($,S),S+=g,E&&(this.a[I]=A.slice(g),this.b-=g),g-=g}else D.set(A,S),S+=A.byteLength,E?(this.a.shift(),this.b-=A.byteLength):I++,g-=A.byteLength}return D}}e.$qi=y;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(g,E,D,S){this.type=g,this.id=E,this.ack=D,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends C.$Vc{constructor(g){super(),this.f=this.B(new h.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new y,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,S=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,E),this.f.fire(new a(D,S,I,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Oe.alloc(w.HeaderLength);E.writeUInt8(g.type,0),E.writeUInt32BE(g.id,1),E.writeUInt32BE(g.ack,5),E.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:P(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,g.data),this.j(E,g.data)}g(g,E){const D=this.f===0;return this.d.push(g,E),this.f+=g.byteLength+E.byteLength,D}h(){const g=r.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,E){this.g(g,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class f extends C.$Vc{constructor(g){super(),this.f=new h.$me,this.onMessage=this.f.event,this.g=new h.$me,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new p(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new a(u.Regular,0,0,g))}}e.$ri=f;class i extends R.$li{static fromSocket(g,E){return new i(new f(g),E)}get onDidDispose(){return this.b.onDidDispose}constructor(g,E,D=null){super(g,E,D),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$si=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$ti=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,E=this.a;for(;E;)E=E.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let E=0,D=this.a;for(;D;)g[E++]=D.data,D=D.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const E=new t(g);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let E=0;E<n.a;E++)this.c[E]=g-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),E=(1+n.a)*1e3;let D=0;for(let S=0;S<n.a;S++)g-this.c[S]<=E&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new s,this.onControlMessage=this.v.event,this.w=new s,this.onMessage=this.w.event,this.x=new s,this.onDidDispose=this.x.event,this.y=new s,this.onSocketClose=this.y.event,this.z=new s,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new o,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Uc,this.p=g.socket,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new a(u.Disconnect,0,0,k());this.q.write(g),this.q.flush()}}sendPause(){const g=new a(u.Pause,0,0,k());this.q.write(g)}sendResume(){const g=new a(u.Resume,0,0,k());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,E){this.a=!0,this.s.dispose(),this.s=new C.$Uc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(D=>this.A(D))),this.s.add(this.p.onClose(D=>this.y.fire(D))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new a(u.Ack,0,this.j,k());this.q.write(g);const E=this.c.toArray();for(let D=0,S=E.length;D<S;D++)this.q.write(E[D]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const E=this.c.peek();if(E&&E.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,k())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case u.Control:{this.v.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let D=0,S=E.length;D<S;D++)this.q.write(E[D]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const E=++this.d;this.j=this.h;const D=new a(u.Regular,E,this.j,g);this.c.push(D),this.a||(this.q.write(D),this.C())}sendControl(g){const E=new a(u.Control,0,0,g);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),E=Date.now()-g.writtenTime,D=Date.now()-this.r.lastReadTime,S=Date.now()-this.o;if(E>=w.TimeoutTime&&D>=w.TimeoutTime&&S>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:D});return}const I=Math.max(w.TimeoutTime-E,w.TimeoutTime-D,w.TimeoutTime-S,500);this.g=setTimeout(()=>{this.g=null,this.C()},I)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new a(u.Ack,0,this.j,k());this.q.write(g)}E(){this.j=this.h;const g=new a(u.KeepAlive,0,this.j,k());this.q.write(g)}}e.$ui=d}),define(ke[193],Ie([1,0,56,7,21,20,190,13,4,3,24,109,104,86]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0,O=We(O);class w extends P.$ii{constructor(p){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",f=>C.$Oe.wrap(Buffer.from(f,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.$kr=w;class a{constructor(p,f){this.i=p,this.j=f,this.c=new Set,this.g=new Map,this.h=new b.$me,this.onDidProcessExit=this.h.event;const i=f&&f.timeout?f.timeout:6e4;this.b=new h.$Dh(i),this.d=null,this.f=null}getChannel(p){const f=this;return{call(i,s,t){return f.k(p,i,s,t)},listen(i,s){return f.l(p,i,s)}}}k(p,f,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(O.$6());this.b.cancel();const t=this.n(p),o=(0,h.$th)(l=>t.call(f,i,l)),n=s.onCancellationRequested(()=>o.cancel()),d=(0,c.$Tc)(()=>o.cancel());return this.c.add(d),o.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l(p,f,i){if(!this.b)return b.Event.None;this.b.cancel();let s;const t=new b.$me({onWillAddFirstListener:()=>{s=this.n(p).listen(f,i)(t.fire,t),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const p=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,k.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$nm)(f.env),this.d=(0,r.fork)(this.i,p,f);const i=new b.$me,t=b.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,T.$gr)(E)){(0,T.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(C.$Oe.wrap(Buffer.from(E,"base64")))}),o=this.j.useQueue?(0,y.$Am)(this.d):this.d,n=E=>this.d&&this.d.connected&&o.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new P.$ji(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,D)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(S=>(0,c.$Qc)(S)),this.c.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:D})})}return this.f}n(p){let f=this.g.get(p);return f||(f=this.m.getChannel(p),this.g.set(p,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$lr=a}),define(ke[194],Ie([1,0,7,4,3,44,17]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=b;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function b(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class k extends C.$Vc{static{this.a=100}constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new h.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Eh(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,a)=>this.w(a,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let a=!1;(0,T.$og)(w)?a=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const a=this.f.get(P);return(0,T.$og)(a)?w:a}getBoolean(P,w){const a=this.get(P);return(0,T.$og)(a)?w:a==="true"}getNumber(P,w){const a=this.get(P);return(0,T.$og)(a)?w:parseInt(a,10)}getObject(P,w){const a=this.get(P);return(0,T.$og)(a)?w:(0,R.$ci)(a)}async set(P,w,a=!1){if(this.c===c.Closed)return;if((0,T.$og)(w))return this.delete(P,a);const m=(0,T.$hg)(w)||Array.isArray(w)?(0,R.$bi)(w):String(w);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$fq=k;class y{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,a)=>this.a.set(a,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$gq=y}),define(ke[141],Ie([1,0,83]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=void 0;class h{constructor(O){const b=(0,r.$bf)(O);this.c=b,this.a=h.d(b),this.b=new Map}static d(O){const b=new Uint8Array(256);return b.fill(O),b}set(O,b){const c=(0,r.$bf)(b);O>=0&&O<256?this.a[O]=c:this.b.set(O,c)}get(O){return O>=0&&O<256?this.a[O]:this.b.get(O)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ku=h;var C;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(C||(C={}));class R{constructor(){this.a=new h(C.False)}add(O){this.a.set(O,C.True)}has(O){return this.a.get(O)===C.True}clear(){return this.a.clear()}}e.$lu=R}),define(ke[195],Ie([1,0,26]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Cu=C;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function C(R){let T=0,O=0,b=0,c=h.Unknown;for(let k=0,y=R.length;k<y;k++){const u=R.charCodeAt(k);u===r.CharCode.CarriageReturn?(T===0&&(O=k),T++,k+1<y&&R.charCodeAt(k+1)===r.CharCode.LineFeed?(c|=h.CRLF,k++):c|=h.Invalid,b=k+1):u===r.CharCode.LineFeed&&(c|=h.LF,T===0&&(O=k),T++,b=k+1)}return T===0&&(O=R.length),[T,O,R.length-b,c]}}),define(ke[57],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=void 0;class r{constructor(C,R){this.lineNumber=C,this.column=R}with(C=this.lineNumber,R=this.column){return C===this.lineNumber&&R===this.column?this:new r(C,R)}delta(C=0,R=0){return this.with(this.lineNumber+C,this.column+R)}equals(C){return r.equals(this,C)}static equals(C,R){return!C&&!R?!0:!!C&&!!R&&C.lineNumber===R.lineNumber&&C.column===R.column}isBefore(C){return r.isBefore(this,C)}static isBefore(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<R.column}isBeforeOrEqual(C){return r.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<=R.column}static compare(C,R){const T=C.lineNumber|0,O=R.lineNumber|0;if(T===O){const b=C.column|0,c=R.column|0;return b-c}return T-O}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new r(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Qt=r}),define(ke[30],Ie([1,0,57]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=void 0;class h{constructor(R,T,O,b){R>O||R===O&&T>b?(this.startLineNumber=O,this.startColumn=b,this.endLineNumber=R,this.endColumn=T):(this.startLineNumber=R,this.startColumn=T,this.endLineNumber=O,this.endColumn=b)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<R.startColumn||T.lineNumber===R.endLineNumber&&T.column>R.endColumn)}static strictContainsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<=R.startColumn||T.lineNumber===R.endLineNumber&&T.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<=R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,T){let O,b,c,k;return T.startLineNumber<R.startLineNumber?(O=T.startLineNumber,b=T.startColumn):T.startLineNumber===R.startLineNumber?(O=T.startLineNumber,b=Math.min(T.startColumn,R.startColumn)):(O=R.startLineNumber,b=R.startColumn),T.endLineNumber>R.endLineNumber?(c=T.endLineNumber,k=T.endColumn):T.endLineNumber===R.endLineNumber?(c=T.endLineNumber,k=Math.max(T.endColumn,R.endColumn)):(c=R.endLineNumber,k=R.endColumn),new h(O,b,c,k)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,T){let O=R.startLineNumber,b=R.startColumn,c=R.endLineNumber,k=R.endColumn;const y=T.startLineNumber,u=T.startColumn,P=T.endLineNumber,w=T.endColumn;return O<y?(O=y,b=u):O===y&&(b=Math.max(b,u)),c>P?(c=P,k=w):c===P&&(k=Math.min(k,w)),O>c||O===c&&b>k?null:new h(O,b,c,k)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,T){return!R&&!T?!0:!!R&&!!T&&R.startLineNumber===T.startLineNumber&&R.startColumn===T.startColumn&&R.endLineNumber===T.endLineNumber&&R.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Qt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Qt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,T){return new h(this.startLineNumber,this.startColumn,R,T)}setStartPosition(R,T){return new h(R,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,T=R){return new h(R.lineNumber,R.column,T.lineNumber,T.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn)}static areIntersecting(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,T){if(R&&T){const c=R.startLineNumber|0,k=T.startLineNumber|0;if(c===k){const y=R.startColumn|0,u=T.startColumn|0;if(y===u){const P=R.endLineNumber|0,w=T.endLineNumber|0;if(P===w){const a=R.endColumn|0,m=T.endColumn|0;return a-m}return P-w}return y-u}return c-k}return(R?1:0)-(T?1:0)}static compareRangesUsingEnds(R,T){return R.endLineNumber===T.endLineNumber?R.endColumn===T.endColumn?R.startLineNumber===T.startLineNumber?R.startColumn-T.startColumn:R.startLineNumber-T.startLineNumber:R.endColumn-T.endColumn:R.endLineNumber-T.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Rt=h}),define(ke[196],Ie([1,0,30]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=void 0;class h{static insert(R,T){return{range:new r.$Rt(R.lineNumber,R.column,R.lineNumber,R.column),text:T,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,T){return{range:R,text:T}}static replaceMove(R,T){return{range:R,text:T,forceMoveMarkers:!0}}}e.$St=h}),define(ke[197],Ie([1,0,57,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.SelectionDirection=void 0;var C;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(C||(e.SelectionDirection=C={}));class R extends h.$Rt{constructor(O,b,c,k){super(O,b,c,k),this.selectionStartLineNumber=O,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=k}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(O){return R.selectionsEqual(this,O)}static selectionsEqual(O,b){return O.selectionStartLineNumber===b.selectionStartLineNumber&&O.selectionStartColumn===b.selectionStartColumn&&O.positionLineNumber===b.positionLineNumber&&O.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?C.LTR:C.RTL}setEndPosition(O,b){return this.getDirection()===C.LTR?new R(this.startLineNumber,this.startColumn,O,b):new R(O,b,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Qt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Qt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(O,b){return this.getDirection()===C.LTR?new R(O,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,O,b)}static fromPositions(O,b=O){return new R(O.lineNumber,O.column,b.lineNumber,b.column)}static fromRange(O,b){return b===C.LTR?new R(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):new R(O.endLineNumber,O.endColumn,O.startLineNumber,O.startColumn)}static liftSelection(O){return new R(O.selectionStartLineNumber,O.selectionStartColumn,O.positionLineNumber,O.positionColumn)}static selectionsArrEqual(O,b){if(O&&!b||!O&&b)return!1;if(!O&&!b)return!0;if(O.length!==b.length)return!1;for(let c=0,k=O.length;c<k;c++)if(!this.selectionsEqual(O[c],b[c]))return!1;return!0}static isISelection(O){return O&&typeof O.selectionStartLineNumber=="number"&&typeof O.selectionStartColumn=="number"&&typeof O.positionLineNumber=="number"&&typeof O.positionColumn=="number"}static createWithDirection(O,b,c,k,y){return y===C.LTR?new R(O,b,c,k):new R(c,k,O,b)}}e.$Tt=R}),define(ke[198],Ie([1,0,12,10,21]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=void 0,e.$fu=k,e.$gu=y,r=We(r),h=We(h),C=We(C);let R;function T(){return R||(R=new TextDecoder("UTF-16LE")),R}let O;function b(){return O||(O=new TextDecoder("UTF-16BE")),O}let c;function k(){return c||(c=h.$E()?T():b()),c}function y(w,a,m){const p=new Uint16Array(w.buffer,a,m);return m>0&&(p[0]===65279||p[0]===65534)?u(w,a,m):T().decode(p)}function u(w,a,m){const p=[];let f=0;for(let i=0;i<m;i++){const s=C.$Qe(w,a);a+=2,p[f++]=String.fromCharCode(s)}return p.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return k().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||r.$Kf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let p=0;p<m;p++)this.b[this.d++]=a.charCodeAt(p)}}e.$hu=P}),define(ke[199],Ie([1,0,21,198]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=void 0,e.$ju=T,r=We(r);function C(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,k,y,u){this.oldPosition=c,this.oldText=k,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,k,y){const u=k.length;r.$Te(c,u,y),y+=4;for(let P=0;P<u;P++)r.$Re(c,k.charCodeAt(P),y),y+=2;return y}static d(c,k){const y=r.$Se(c,k);return k+=4,(0,h.$gu)(c,k,y)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,k){return r.$Te(c,this.oldPosition,k),k+=4,r.$Te(c,this.newPosition,k),k+=4,k=R.c(c,this.oldText,k),k=R.c(c,this.newText,k),k}static read(c,k,y){const u=r.$Se(c,k);k+=4;const P=r.$Se(c,k);k+=4;const w=R.d(c,k);k+=R.a(w);const a=R.d(c,k);return k+=R.a(a),y.push(new R(u,w,P,a)),k}}e.$iu=R;function T(b,c){return b===null||b.length===0?c:new O(b,c).compress()}class O{constructor(c,k){this.a=c,this.c=k,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,k=0,y=this.n(c),u=this.l(k);for(;c<this.f||k<this.h;){if(y===null){this.k(u),u=this.l(++k);continue}if(u===null){this.m(y),y=this.n(++c);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++k);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++c);continue}if(u.oldPosition<y.newPosition){const[p,f]=O.r(u,y.newPosition-u.oldPosition);this.k(p),u=f;continue}if(y.newPosition<u.oldPosition){const[p,f]=O.q(y,u.oldPosition-y.newPosition);this.m(p),y=f;continue}let a,m;if(u.oldEnd===y.newEnd)a=y,m=u,y=this.n(++c),u=this.l(++k);else if(u.oldEnd<y.newEnd){const[p,f]=O.q(y,u.oldLength);a=p,m=u,y=f,u=this.l(++k)}else{const[p,f]=O.r(u,y.newLength);a=y,m=p,y=this.n(++c),u=f}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const P=O.s(this.d);return O.t(P)}k(c){this.d[this.e++]=O.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=O.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,k){return new R(k.oldPosition-c,k.oldText,k.newPosition,k.newText)}static p(c,k){return new R(k.oldPosition,k.oldText,k.newPosition+c,k.newText)}static q(c,k){const y=c.newText.substr(0,k),u=c.newText.substr(k);return[new R(c.oldPosition,c.oldText,c.newPosition,y),new R(c.oldEnd,"",c.newPosition+k,u)]}static r(c,k){const y=c.oldText.substr(0,k),u=c.oldText.substr(k);return[new R(c.oldPosition,y,c.newPosition,c.newText),new R(c.oldPosition+k,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const k=[];let y=0,u=c[0];for(let P=1;P<c.length;P++){const w=c[P];u.oldEnd===w.oldPosition?u=new R(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(k[y++]=u,u=w)}return k[y++]=u,k}static t(c){if(c.length===0)return c;const k=[];let y=0;for(let u=0;u<c.length;u++){const P=c[u];P.oldText!==P.newText&&(k[y++]=P)}return k}}}),define(ke[200],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0,e.$ot={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[201],Ie([1,0,26,28,141]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.WordCharacterClass=void 0,e.$nu=b;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class T extends C.$ku{constructor(k,y){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=y,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=k.length;u<P;u++)this.set(k.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(k,y){let u=null;for(const P of this.h(k)){if(P.index>y)break;u=P}return u}findNextIntlWordAtOrAfterOffset(k,y){for(const u of this.h(k))if(!(u.index<y))return u;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const y=[];for(const u of k)this.k(u)&&y.push(u);return y}k(k){return!!k.isWordLike}}e.$mu=T;const O=new h.$Ec(10);function b(c,k){const y=`${c}/${k.join(",")}`;let u=O.get(y);return u||(u=new T(c,k),O.set(y,u)),u}}),define(ke[142],Ie([1,0,39,3,80]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=void 0,e.$rt=T,e.$st=b,e.$tt=c,e.$pt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(y=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$pt)y.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$qt=R();function T(y){let u=e.$qt;if(y&&y instanceof RegExp)if(y.global)u=y;else{let P="g";y.ignoreCase&&(P+="i"),y.multiline&&(P+="m"),y.unicode&&(P+="u"),u=new RegExp(y.source,P)}return u.lastIndex=0,u}const O=new C.$6c;O.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(y){const u=O.unshift(y);return(0,h.$Tc)(u)}function c(y,u,P,w,a){if(u=T(u),a||(a=r.Iterable.first(O)),P.length>a.maxLen){let s=y-a.maxLen/2;return s<0?s=0:w+=s,P=P.substring(s,y+a.maxLen/2),c(y,u,P,w,a)}const m=Date.now(),p=y-1-w;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=p-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=k(u,P,p,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function k(y,u,P,w){let a;for(;a=y.exec(u);){const m=a.index||0;if(m<=P&&y.lastIndex>=P)return a;if(w>0&&m>w)return null}return null}}),define(ke[110],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var C;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(C||(e.ColorId=C={}));var R;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var T;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class O{static getLanguageId(c){return(c&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(c){return(c&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(c){return(c&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(c){return(c&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let y="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(y+=" mtki"),u&h.Bold&&(y+=" mtkb"),u&h.Underline&&(y+=" mtku"),u&h.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(c,k){const y=this.getForeground(c),u=this.getFontStyle(c);let P=`color: ${k[y]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const k=this.getForeground(c),y=this.getFontStyle(c);return{foreground:k,italic:!!(y&h.Italic),bold:!!(y&h.Bold),underline:!!(y&h.Underline),strikethrough:!!(y&h.Strikethrough)}}}e.$yu=O}),define(ke[202],Ie([1,0,38,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=C,e.$Au=R;function C(T,O,b,c,k,y){if(Array.isArray(T)){let u=0;for(const P of T){const w=C(P,O,b,c,k,y);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof T=="string")return c?T==="*"?5:T===b?10:0:0;if(T){const{language:u,pattern:P,scheme:w,hasAccessToAllModels:a,notebookType:m}=T;if(!c&&!a)return 0;m&&k&&(O=k);let p=0;if(w)if(w===O.scheme)p=10;else if(w==="*")p=5;else return 0;if(u)if(u===b)p=10;else if(u==="*")p=Math.max(p,5);else return 0;if(m)if(m===y)p=10;else if(m==="*"&&y!==void 0)p=Math.max(p,5);else return 0;if(P){let f;if(typeof P=="string"?f=P:f={...P,base:(0,h.$ic)(P.base)},f===O.fsPath||(0,r.$Ak)(f,O.fsPath))p=10;else return 0}return p}else return 0}}function R(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(R):!!T.notebookType}}),define(ke[203],Ie([1,0,26,110]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.IndentAction=void 0;var C;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let k=0,y=c.notIn.length;k<y;k++)switch(c.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,k){if(c.getTokenCount()===0)return!0;const y=c.findTokenIndexAtOffset(k-2),u=c.getStandardTokenType(y);return this.isOK(u)}g(c,k){for(let y=c;y<=k;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$1u=R;class T{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of c)O(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),O(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),O(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),O(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&O(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$2u=T;function O(b,c,k){b.has(c)?b.get(c).push(k):b.set(c,[k])}}),define(ke[204],Ie([1,0,26,141]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4=e.$J4=e.State=void 0,e.$L4=P;var C;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(C||(e.State=C={}));class R{constructor(a,m,p){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=p;this.a=f,this.rows=a,this.cols=m}get(a,m){return this.a[a*this.cols+m]}set(a,m,p){this.a[a*this.cols+m]=p}}class T{constructor(a){let m=0,p=C.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>p&&(p=t),n>p&&(p=n)}m++,p++;const f=new R(p,m,C.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this.a=f,this.b=m}nextState(a,m){return m<0||m>=this.b?C.Invalid:this.a.get(a,m)}}e.$J4=T;let O=null;function b(){return O===null&&(O=new T([[C.Start,r.CharCode.h,C.H],[C.Start,r.CharCode.H,C.H],[C.Start,r.CharCode.f,C.F],[C.Start,r.CharCode.F,C.F],[C.H,r.CharCode.t,C.HT],[C.H,r.CharCode.T,C.HT],[C.HT,r.CharCode.t,C.HTT],[C.HT,r.CharCode.T,C.HTT],[C.HTT,r.CharCode.p,C.HTTP],[C.HTT,r.CharCode.P,C.HTTP],[C.HTTP,r.CharCode.s,C.BeforeColon],[C.HTTP,r.CharCode.S,C.BeforeColon],[C.HTTP,r.CharCode.Colon,C.AfterColon],[C.F,r.CharCode.i,C.FI],[C.F,r.CharCode.I,C.FI],[C.FI,r.CharCode.l,C.FIL],[C.FI,r.CharCode.L,C.FIL],[C.FIL,r.CharCode.e,C.BeforeColon],[C.FIL,r.CharCode.E,C.BeforeColon],[C.BeforeColon,r.CharCode.Colon,C.AfterColon],[C.AfterColon,r.CharCode.Slash,C.AlmostThere],[C.AlmostThere,r.CharCode.Slash,C.End]])),O}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let k=null;function y(){if(k===null){k=new h.$ku(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)k.set(w.charCodeAt(m),c.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)k.set(a.charCodeAt(m),c.CannotEndIn)}return k}class u{static a(a,m,p,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==c.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:p,startColumn:f+1,endLineNumber:p,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=b()){const p=y(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,d=0,l=0,g=C.Start,E=!1,D=!1,S=!1,I=!1;for(;n<o;){let A=!1;const $=t.charCodeAt(n);if(g===C.Accept){let v;switch($){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:S=!0,D=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:S=!1,v=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:I=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=I?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===$?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=S?c.None:c.ForceTermination;break;default:v=p.get($)}v===c.ForceTermination&&(f.push(u.a(p,t,i,d,n)),A=!0)}else if(g===C.End){let v;$===r.CharCode.OpenSquareBracket?(D=!0,v=c.None):v=p.get($),v===c.ForceTermination?A=!0:g=C.Accept}else g=m.nextState(g,$),g===C.Invalid&&(A=!0);A&&(g=C.Start,E=!1,D=!1,I=!1,d=n+1,l=$),n++}g===C.Accept&&f.push(u.a(p,t,i,d,o))}return f}}e.$K4=u;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(ke[58],Ie([1,0,24]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$kw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$iw=e.$hw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$jw=w,e.$nw=s;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(C||(e.GlyphMarginLane=C={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var T;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var O;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(O||(e.InjectedTextCursorStops=O={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var k;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.$jo)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$hw=y;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.$iw=u;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class p{constructor(o,n,d,l,g,E){this.identifier=o,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=E}}e.$kw=p;class f{constructor(o,n,d){this.regex=o,this.wordSeparators=n,this.simpleSearch=d}}e.$lw=f;class i{constructor(o,n,d){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$mw=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ke[205],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=e.NodeColor=e.$eD=void 0,e.$gD=C,e.$hD=R,e.$iD=c,e.$jD=k,e.$kD=y,e.$lD=u,e.$mD=P,e.$nD=w;class r{constructor(m,p){this.piece=m,this.color=p,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$fD)return C(this.right);let m=this;for(;m.parent!==e.$fD&&m.parent.left!==m;)m=m.parent;return m.parent===e.$fD?e.$fD:m.parent}prev(){if(this.left!==e.$fD)return R(this.left);let m=this;for(;m.parent!==e.$fD&&m.parent.right!==m;)m=m.parent;return m.parent===e.$fD?e.$fD:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$eD=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$fD=new r(null,h.Black),e.$fD.parent=e.$fD,e.$fD.left=e.$fD,e.$fD.right=e.$fD,e.$fD.color=h.Black;function C(a){for(;a.left!==e.$fD;)a=a.left;return a}function R(a){for(;a.right!==e.$fD;)a=a.right;return a}function T(a){return a===e.$fD?0:a.size_left+a.piece.length+T(a.right)}function O(a){return a===e.$fD?0:a.lf_left+a.piece.lineFeedCnt+O(a.right)}function b(){e.$fD.parent=e.$fD}function c(a,m){const p=m.right;p.size_left+=m.size_left+(m.piece?m.piece.length:0),p.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=p.left,p.left!==e.$fD&&(p.left.parent=m),p.parent=m.parent,m.parent===e.$fD?a.root=p:m.parent.left===m?m.parent.left=p:m.parent.right=p,p.left=m,m.parent=p}function k(a,m){const p=m.left;m.left=p.right,p.right!==e.$fD&&(p.right.parent=m),p.parent=m.parent,m.size_left-=p.size_left+(p.piece?p.piece.length:0),m.lf_left-=p.lf_left+(p.piece?p.piece.lineFeedCnt:0),m.parent===e.$fD?a.root=p:m===m.parent.right?m.parent.right=p:m.parent.left=p,p.right=m,m.parent=p}function y(a,m){let p,f;if(m.left===e.$fD?(f=m,p=f.right):m.right===e.$fD?(f=m,p=f.left):(f=C(m.right),p=f.right),f===a.root){a.root=p,p.color=h.Black,m.detach(),b(),a.root.parent=e.$fD;return}const i=f.color===h.Red;if(f===f.parent.left?f.parent.left=p:f.parent.right=p,f===m?(p.parent=f.parent,w(a,p)):(f.parent===m?p.parent=f:p.parent=f.parent,w(a,p),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.$fD&&(f.left.parent=f),f.right!==e.$fD&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,w(a,f)),m.detach(),p.parent.left===p){const t=T(p),o=O(p);if(t!==p.parent.size_left||o!==p.parent.lf_left){const n=t-p.parent.size_left,d=o-p.parent.lf_left;p.parent.size_left=t,p.parent.lf_left=o,P(a,p.parent,n,d)}}if(w(a,p.parent),i){b();return}let s;for(;p!==a.root&&p.color===h.Black;)p===p.parent.left?(s=p.parent.right,s.color===h.Red&&(s.color=h.Black,p.parent.color=h.Red,c(a,p.parent),s=p.parent.right),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,p=p.parent):(s.right.color===h.Black&&(s.left.color=h.Black,s.color=h.Red,k(a,s),s=p.parent.right),s.color=p.parent.color,p.parent.color=h.Black,s.right.color=h.Black,c(a,p.parent),p=a.root)):(s=p.parent.left,s.color===h.Red&&(s.color=h.Black,p.parent.color=h.Red,k(a,p.parent),s=p.parent.left),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,p=p.parent):(s.left.color===h.Black&&(s.right.color=h.Black,s.color=h.Red,c(a,s),s=p.parent.left),s.color=p.parent.color,p.parent.color=h.Black,s.left.color=h.Black,k(a,p.parent),p=a.root));p.color=h.Black,b()}function u(a,m){for(w(a,m);m!==a.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const p=m.parent.parent.right;p.color===h.Red?(m.parent.color=h.Black,p.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,k(a,m.parent.parent))}else{const p=m.parent.parent.left;p.color===h.Red?(m.parent.color=h.Black,p.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,k(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(a,m.parent.parent))}a.root.color=h.Black}function P(a,m,p,f){for(;m!==a.root&&m!==e.$fD;)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=f),m=m.parent}function w(a,m){let p=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,p=T(m.left)-m.size_left,f=O(m.left)-m.lf_left,m.size_left+=p,m.lf_left+=f;m!==a.root&&(p!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=p,m.parent.lf_left+=f),m=m.parent}}}),define(ke[206],Ie([1,0,18,83]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sw=e.$rw=e.$qw=void 0;class C{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,c){b=(0,h.$cf)(b);const k=this.a,y=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(k.length+u),this.a.set(k.subarray(0,b),0),this.a.set(k.subarray(b),b+u),this.a.set(c,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}setValue(b,c){return b=(0,h.$cf)(b),c=(0,h.$cf)(c),this.a[b]===c?!1:(this.a[b]=c,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,c){b=(0,h.$cf)(b),c=(0,h.$cf)(c);const k=this.a,y=this.b;if(b>=k.length)return!1;const u=k.length-b;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(k.length-c),this.a.set(k.subarray(0,b),0),this.a.set(k.subarray(b+c),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,h.$cf)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),b>=this.a.length&&(b=this.a.length-1);for(let k=c;k<=b;k++)this.b[k]=this.b[k-1]+this.a[k];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let c=0,k=this.a.length-1,y=0,u=0,P=0;for(;c<=k;)if(y=c+(k-c)/2|0,u=this.b[y],P=u-this.a[y],b<P)k=y-1;else if(b>=u)c=y+1;else break;return new T(y,b-P)}}e.$qw=C;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const c=this.e[b],k=c>0?this.d[c-1]:0;return new T(c,b-k)}removeValues(b,c){this.a.splice(b,c),this.f(b)}insertValues(b,c){this.a=(0,r.$Vb)(this.a,b,c),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,c=this.a.length;b<c;b++){const k=this.a[b],y=b>0?this.d[b-1]:0;this.d[b]=y+k;for(let u=0;u<k;u++)this.e[y+u]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,c){this.a[b]!==c&&(this.a[b]=c,this.f(b))}}e.$rw=R;class T{constructor(b,c){this.index=b,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=c}}e.$sw=T}),define(ke[207],Ie([1,0,12,57,206]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=void 0;class R{constructor(O,b,c,k){this.d=O,this.f=b,this.g=c,this.h=k,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(O){O.eol&&O.eol!==this.g&&(this.g=O.eol,this.j=null);const b=O.changes;for(const c of b)this.o(c.range),this.p(new h.$Qt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=O.versionId,this.k=null}l(){if(!this.j){const O=this.g.length,b=this.f.length,c=new Uint32Array(b);for(let k=0;k<b;k++)c[k]=this.f[k].length+O;this.j=new C.$qw(c)}}n(O,b){this.f[O]=b,this.j&&this.j.setValue(O,this.f[O].length+this.g.length)}o(O){if(O.startLineNumber===O.endLineNumber){if(O.startColumn===O.endColumn)return;this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.startLineNumber-1].substring(O.endColumn-1));return}this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.endLineNumber-1].substring(O.endColumn-1)),this.f.splice(O.startLineNumber,O.endLineNumber-O.startLineNumber),this.j&&this.j.removeValues(O.startLineNumber,O.endLineNumber-O.startLineNumber)}p(O,b){if(b.length===0)return;const c=(0,r.$tf)(b);if(c.length===1){this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+c[0]+this.f[O.lineNumber-1].substring(O.column-1));return}c[c.length-1]+=this.f[O.lineNumber-1].substring(O.column-1),this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+c[0]);const k=new Uint32Array(c.length-1);for(let y=1;y<c.length;y++)this.f.splice(O.lineNumber+y-1,0,c[y]),k[y-1]=c[y].length+this.g.length;this.j&&this.j.insertValues(O.lineNumber,k)}}e.$tw=R}),define(ke[111],Ie([1,0,26,12,201,57,30,58]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$rD=e.$oD=void 0,e.$pD=k,e.$qD=y,e.$sD=m,h=We(h);const b=999;class c{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.$rf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new O.$lw(s,this.wordSeparators?(0,C.$nu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$oD=c;function k(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function y(f,i,s){if(!s)return new O.$iw(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new O.$iw(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class P{static findMatches(i,s,t,o,n){const d=s.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new p(d.wordSeparators,d.regex),o,n):this.c(i,t,d,o,n):[]}static a(i,s,t,o,n,d){let l,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),l=s+n+g):l=s+n;let E;if(o){const A=o.findLineFeedCountBeforeOffset(n+d.length)-g;E=l+d.length+A}else E=l+d.length;const D=i.getPositionAt(l),S=i.getPositionAt(E);return new T.$Rt(D.lineNumber,D.column,S.lineNumber,S.column)}static b(i,s,t,o,n){const d=i.getOffsetAt(s.getStartPosition()),l=i.getValueInRange(s,O.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(l):null,E=[];let D=0,S;for(t.reset(0);S=t.next(l);)if(E[D++]=y(this.a(i,d,l,g,S.index,S[0]),S,o),D>=n)return E;return E}static c(i,s,t,o,n){const d=[];let l=0;if(s.startLineNumber===s.endLineNumber){const E=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return l=this.d(t,E,s.startLineNumber,s.startColumn-1,l,d,o,n),d}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);l=this.d(t,g,s.startLineNumber,s.startColumn-1,l,d,o,n);for(let E=s.startLineNumber+1;E<s.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,o,n);if(l<n){const E=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);l=this.d(t,E,s.endLineNumber,0,l,d,o,n)}return d}static d(i,s,t,o,n,d,l,g){const E=i.wordSeparators;if(!l&&i.simpleSearch){const I=i.simpleSearch,A=I.length,$=s.length;let v=-A;for(;(v=s.indexOf(I,v+A))!==-1;)if((!E||m(E,s,$,v,A))&&(d[n++]=new O.$iw(new T.$Rt(t,v+1+o,t,v+1+A+o),null),n>=g))return n;return n}const D=new p(i.wordSeparators,i.regex);let S;D.reset(0);do if(S=D.next(s),S&&(d[n++]=y(new T.$Rt(t,S.index+1+o,t,S.index+1+S[0].length+o),S,l),n>=g))return n;while(S);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new p(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,o):this.f(i,t,d,o)}static e(i,s,t,o){const n=new R.$Qt(s.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new T.$Rt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),O.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const D=t.next(g);return D?y(this.a(i,d,g,E,D.index,D[0]),D,o):s.lineNumber!==1||s.column!==1?this.e(i,new R.$Qt(1,1),t,o):null}static f(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d),g=this.g(t,l,d,s.column,o);if(g)return g;for(let E=1;E<=n;E++){const D=(d+E-1)%n,S=i.getLineContent(D+1),I=this.g(t,S,D+1,1,o);if(I)return I}return null}static g(i,s,t,o,n){i.reset(o-1);const d=i.next(s);return d?y(new T.$Rt(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new p(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,o):this.j(i,t,d,o)}static h(i,s,t,o){const n=this.b(i,new T.$Rt(1,1,s.lineNumber,s.column),t,o,10*b);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return s.lineNumber!==d||s.column!==i.getLineMaxColumn(d)?this.h(i,new R.$Qt(d,i.getLineMaxColumn(d)),t,o):null}static j(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d).substring(0,s.column-1),g=this.k(t,l,d,o);if(g)return g;for(let E=1;E<=n;E++){const D=(n+d-E-1)%n,S=i.getLineContent(D+1),I=this.k(t,S,D+1,o);if(I)return I}return null}static k(i,s,t,o){let n=null,d;for(i.reset(0);d=i.next(s);)n=y(new T.$Rt(t,d.index+1,t,d.index+1+d[0].length),d,o);return n}}e.$rD=P;function w(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t+o-1);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return w(f,i,s,t,o)&&a(f,i,s,t,o)}class p{constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let t;do{if(this.b+this.c===s||(t=this.a.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this.b&&n===this.c){if(n===0){h.$Nf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.$tD=p}),define(ke[143],Ie([1,0,26,57,30,58,205,111]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yD=e.$xD=e.$wD=void 0,e.$uD=y,e.$vD=u;const b=65535;function c(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class k{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function y(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const d=f.charCodeAt(o);d===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:d===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?c(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,d=!0;for(let g=0,E=i.length;g<E;g++){const D=i.charCodeAt(g);D===r.CharCode.CarriageReturn?g+1<E&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):D===r.CharCode.LineFeed?(o++,f[s++]=g+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const l=new k(c(f),t,o,n,d);return f.length=0,l}class P{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.$wD=P;class w{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$xD=w;class a{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==T.$fD&&i.iterate(i.root,t=>(t!==T.$fD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const t=this.b;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this.b=o}}}class p{constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=T.$fD,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=t;let o=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=y(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),o=this.S(o,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=b,t=s-Math.floor(s/3),o=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,g=>{const E=this.R(g),D=E.length;if(d<=t||d+D<o)return n+=E,d+=D,!0;const S=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(S,y(S))),n=E,d=D,!0}),d>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new w(g,y(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===T.$fD)return!0;const n=this.R(o),d=n.length,l=i.G(s),g=i.G(s+d),E=i.getValueInRange2(l,g);return s+=d,n===E})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==T.$fD;)if(o.left!==T.$fD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.B(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==T.$fD;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.A(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=o-d;return new h.$Qt(t+1,l+1)}return new h.$Qt(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===T.$fD){const n=this.getOffsetAt(t+1,1),d=o-i-n;return new h.$Qt(t+1,d+1)}else s=s.right;return new h.$Qt(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(E+i.remainder,E+s.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==T.$fD;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===s.node){d+=l.substring(g,g+s.remainder);break}else d+=l.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===T.$fD)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const g=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,D=d.start.line,S=d.end.line;let I=E[D]+d.start.column;if(o&&(g.charCodeAt(I)===r.CharCode.LineFeed&&(I++,l--),i[s++]=t,t="",o=!1,l===0))return!0;if(D===S)return!this.f&&g.charCodeAt(I+l-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(I,l-1)):t+=g.substr(I,l),!0;t+=this.f?g.substring(I,Math.max(I,E[D+1]-this.e)):g.substring(I,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let A=D+1;A<S;A++)t=this.f?g.substring(E[A],E[A+1]-this.e):g.substring(E[A],E[A+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this.f&&g.charCodeAt(E[S]+d.end.column-1)===r.CharCode.CarriageReturn?(o=!0,d.end.column===0?s--:t=g.substr(E[S],d.end.column-1)):t=g.substr(E[S],d.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.H(i,s+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}getNearestChunk(i){const s=this.G(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===T.$fD)return"";const o=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this.a[s.node.piece.bufferIndex],o=this.u(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,d=o+s.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,s,t,o,n,d,l,g,E,D,S){const I=this.a[i.piece.bufferIndex],A=this.u(i.piece.bufferIndex,i.piece.start),$=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let M;const N={line:0,column:0};let L,F;s._wordSeparators?(L=I.buffer.substring($,v),F=B=>B+$,s.reset(0)):(L=I.buffer,F=B=>B,s.reset($));do if(M=s.next(L),M){if(F(M.index)>=v)return D;this.s(i,F(M.index)-A,N);const B=this.t(i.piece.bufferIndex,n,N),j=N.line===n.line?N.column-n.column+o:N.column+1,U=j+M[0].length;if(S[D++]=(0,O.$qD)(new C.$Rt(t+B,j,t+B,U),M,g),F(M.index)+M[0].length>=v||D>=E)return D}while(M);return D}findMatchesLineByLine(i,s,t,o){const n=[];let d=0;const l=new O.$tD(s.wordSeparators,s.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(g.node,g.remainder);const S=this.s(E.node,E.remainder);if(g.node===E.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,D,S,s,t,o,d,n),n;let I=i.startLineNumber,A=g.node;for(;A!==E.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,L=this.u(A.piece.bufferIndex,A.piece.start),F=N[D.line+v],B=I===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(A,l,I,B,D,this.s(A,F-L),s,t,o,d,n),d>=o)return n;I+=v}const M=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const N=this.getLineContent(I).substring(M,i.endColumn-1);return d=this.n(s,l,N,i.endLineNumber,M,d,n,t,o),n}if(d=this.n(s,l,this.getLineContent(I).substr(M),I,M,d,n,t,o),d>=o)return n;I++,g=this.H(I,1),A=g.node,D=this.s(g.node,g.remainder)}if(I===i.endLineNumber){const v=I===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(I).substring(v,i.endColumn-1);return d=this.n(s,l,M,i.endLineNumber,v,d,n,t,o),n}const $=I===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,I,$,D,S,s,t,o,d,n),n}n(i,s,t,o,n,d,l,g,E){const D=i.wordSeparators;if(!g&&i.simpleSearch){const I=i.simpleSearch,A=I.length,$=t.length;let v=-A;for(;(v=t.indexOf(I,v+A))!==-1;)if((!D||(0,O.$sD)(D,t,$,v,A))&&(l[d++]=new R.$iw(new C.$Rt(o,v+1+n,o,v+1+A+n),null),d>=E))return d;return d}let S;s.reset(0);do if(S=s.next(t),S&&(l[d++]=(0,O.$qD)(new C.$Rt(o,S.index+1+n,o,S.index+1+S[0].length+n),S,g),d>=E))return d;while(S);return d}insert(i,s,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$fD){const{node:o,remainder:n,nodeStartOffset:d}=this.G(i),l=o.piece,g=l.bufferIndex,E=this.s(o,n);if(o.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&s.length<b){this.F(o,s),this.y();return}if(d===i)this.o(s,o),this.h.validate(i);else if(d+o.piece.length>i){const D=[];let S=new P(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(g,l.end)-this.u(g,E));if(this.K()&&this.M(s)&&this.I(o,n)===10){const v={line:S.start.line+1,column:0};S=new P(S.bufferIndex,v,S.end,this.t(S.bufferIndex,v,S.end),S.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,n-1)===13){const v=this.s(o,n-1);this.C(o,v),s="\r"+s,o.piece.length===0&&D.push(o)}else this.C(o,E);else this.C(o,E);const I=this.w(s);S.length>0&&this.S(o,S);let A=o;for(let $=0;$<I.length;$++)A=this.S(A,I[$]);this.v(D)}else this.q(s,o)}else{const o=this.w(s);let n=this.T(null,o[0]);for(let d=1;d<o.length;d++)n=this.S(n,o[d])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===T.$fD)return;const t=this.G(i),o=this.G(i+s),n=t.node,d=o.node;if(n===d){const I=this.s(n,t.remainder),A=this.s(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const $=n.next();(0,T.$kD)(this,n),this.N($),this.y();return}this.D(n,A),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+s){this.C(n,I),this.O(n),this.y();return}this.E(n,I,A),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,o.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const D=n.next();for(let I=D;I!==T.$fD&&I!==d;I=I.next())l.push(I);const S=n.piece.length===0?n.prev():n;this.v(l),this.O(S),this.y()}o(i,s){const t=[];if(this.K()&&this.M(i)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},g=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=g,i+=`
`,(0,T.$mD)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.w(i);let n=this.T(s,o[o.length-1]);for(let d=o.length-2;d>=0;d--)n=this.T(n,o[d]);this.N(n),this.v(t)}q(i,s){this.Q(i,s)&&(i+=`
`);const t=this.w(i),o=this.S(s,t[0]);let n=o;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(o)}s(i,s,t){const o=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,g=d[o.start.line]+o.start.column+s;let E=o.start.line,D=o.end.line,S=0,I=0,A=0;for(;E<=D&&(S=E+(D-E)/2|0,A=d[S],S!==D);)if(I=d[S+1],g<A)D=S-1;else if(g>=I)E=S+1;else break;return t?(t.line=S,t.column=g-A,null):{line:S,column:g-A}}t(i,s,t){if(t.column===0)return t.line-s.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],d=o[t.line]+t.column;if(n>d+1)return t.line-s.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-s.line+1:t.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,T.$kD)(this,i[s])}w(i){if(i.length>b){const D=[];for(;i.length>b;){const I=i.charCodeAt(b-1);let A;I===r.CharCode.CarriageReturn||I>=55296&&I<=56319?(A=i.substring(0,b-1),i=i.substring(b-1)):(A=i.substring(0,b),i=i.substring(b));const $=y(A);D.push(new P(this.a.length,{line:0,column:0},{line:$.length-1,column:A.length-$[$.length-1]},$.length-1,A.length)),this.a.push(new w(A,$))}const S=y(i);return D.push(new P(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new w(i,S)),D}let s=this.a[0].buffer.length;const t=y(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let D=0;D<t.length;D++)t[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<t.length;D++)t[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],g={line:d,column:l},E=new P(0,o,g,this.t(0,o,g),n-s);return this.g=g,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=l.substring(g+d,g+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+d,g+E-s)}}else{let d=0;const l=i;for(;t!==T.$fD;)if(t.left!==T.$fD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),D.substring(S+g,S+E-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);o=E.substring(D+g,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$fD;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return o+=d.substring(g,g+l-s),o}else{const l=this.u(t.piece.bufferIndex,t.piece.start);o+=d.substr(l,t.piece.length)}t=t.next()}return o}y(){let i=this.root,s=1,t=0;for(;i!==T.$fD;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=t,this.h.validate(this.c)}A(i,s){const t=i.piece,o=this.s(i,s),n=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===s){const d=this.t(i.piece.bufferIndex,t.start,o);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:o.column}}B(i,s){if(s<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}C(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=s,l=this.u(t.bufferIndex,d),g=this.t(t.bufferIndex,t.start,d),E=g-o,D=l-n,S=t.length+D;i.piece=new P(t.bufferIndex,t.start,d,g,S),(0,T.$mD)(this,i,D,E)}D(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=s,l=this.t(t.bufferIndex,d,t.end),g=this.u(t.bufferIndex,d),E=l-o,D=n-g,S=t.length+D;i.piece=new P(t.bufferIndex,d,t.end,l,S),(0,T.$mD)(this,i,D,E)}E(i,s,t){const o=i.piece,n=o.start,d=o.end,l=o.length,g=o.lineFeedCnt,E=s,D=this.t(o.bufferIndex,o.start,E),S=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,n);i.piece=new P(o.bufferIndex,o.start,E,D,S),(0,T.$mD)(this,i,S-l,D-g);const I=new P(o.bufferIndex,t,d,this.t(o.bufferIndex,t,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,t)),A=this.S(i,I);this.N(A)}F(i,s){this.Q(s,i)&&(s+=`
`);const t=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const n=y(s,!1);for(let A=0;A<n.length;A++)n[A]+=o;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:l},E=i.piece.length+s.length,D=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,g),I=S-D;i.piece=new P(i.piece.bufferIndex,i.piece.start,g,S,E),this.g=g,(0,T.$mD)(this,i,s.length,I)}G(i){let s=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==T.$fD;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let t=this.root,o=0;for(;t!==T.$fD;)if(t.left!==T.$fD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,d),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$fD;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:d}}else if(t.piece.length>=s-1){const n=this.J(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$fD||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this.a[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$fD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,d),(0,T.$mD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},E=s.piece.length-1,D=this.t(s.piece.bufferIndex,g,s.piece.end);s.piece=new P(s.piece.bufferIndex,g,s.piece.end,D,E),(0,T.$mD)(this,s,-1,-1),s.piece.length===0&&t.push(s);const S=this.w(`\r
`);this.S(i,S[0]);for(let I=0;I<t.length;I++)(0,T.$kD)(this,t[I])}Q(i,s){if(this.K()&&this.M(i)){const t=s.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,T.$kD)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},d=o.length-1,l=this.t(o.bufferIndex,n,o.end);t.piece=new P(o.bufferIndex,n,o.end,l,d),(0,T.$mD)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===T.$fD)return s(T.$fD);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}R(i){if(i===T.$fD)return"";const s=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,o)}S(i,s){const t=new T.$eD(s,T.NodeColor.Red);if(t.left=T.$fD,t.right=T.$fD,t.parent=T.$fD,t.size_left=0,t.lf_left=0,this.root===T.$fD)this.root=t,t.color=T.NodeColor.Black;else if(i.right===T.$fD)i.right=t,t.parent=i;else{const n=(0,T.$gD)(i.right);n.left=t,t.parent=n}return(0,T.$lD)(this,t),t}T(i,s){const t=new T.$eD(s,T.NodeColor.Red);if(t.left=T.$fD,t.right=T.$fD,t.parent=T.$fD,t.size_left=0,t.lf_left=0,this.root===T.$fD)this.root=t,t.color=T.NodeColor.Black;else if(i.left===T.$fD)i.left=t,t.parent=i;else{const o=(0,T.$hD)(i.left);o.right=t,t.parent=o}return(0,T.$lD)(this,t),t}U(i){let s="";return this.iterate(i,t=>(s+=this.R(t),!0)),s}}e.$yD=p}),define(ke[208],Ie([1,0,4,12,30,58,143,195,199,3]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zD=void 0,h=We(h);class k extends c.$Vc{constructor(u,P,w,a,m,p,f){super(),this.m=this.B(new r.$me),this.onDidChangeContent=this.m.event,this.f=P,this.j=!p,this.g=a,this.h=m,this.c=new T.$yD(u,w,f)}equals(u){return!(u instanceof k)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const w=u+P,a=this.getPositionAt(u),m=this.getPositionAt(w);return new C.$Rt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const p=this.n(P),f=this.getEOL();if(p.length!==f.length){const i=p.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-w+m}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,m=u.endLineNumber;for(let p=a;p<=m;p++){const f=this.getLineContent(p),i=p===a?u.startColumn-1:0,s=p===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)h.$Kf(f.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*(m-a),w}return this.getValueLengthInRange(u,P)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$vf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$xf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,w){let a=this.g,m=this.h,p=this.j,f=!0,i=[];for(let g=0;g<u.length;g++){const E=u[g];f&&E._isTracked&&(f=!1);const D=E.range;if(E.text){let v=!0;p||(v=!h.$Vf(E.text),p=v),!a&&v&&(a=h.$Uf(E.text)),!m&&v&&(m=h.$Xf(E.text))}let S="",I=0,A=0,$=0;if(E.text){let v;[I,A,$,v]=(0,O.$Cu)(E.text);const M=this.getEOL(),N=M===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;v===O.StringEOL.Unknown||v===N?S=E.text:S=E.text.replace(/\r\n|\r|\n/g,M)}i[g]={sortIndex:g,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:S,eolCount:I,firstLineLength:A,lastLineLength:$,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(k.u);let s=!1;for(let g=0,E=i.length-1;g<E;g++){const D=i[g].range.getEndPosition(),S=i[g+1].range.getStartPosition();if(S.isBeforeOrEqual(D)){if(S.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this.s(i));const t=w||P?k._getInverseEditRanges(i):[],o=[];if(P)for(let g=0;g<i.length;g++){const E=i[g],D=t[g];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let S=D.startLineNumber;S<=D.endLineNumber;S++){let I="";S===D.startLineNumber&&(I=this.getLineContent(E.range.startLineNumber),h.$vf(I)!==-1)||o.push({lineNumber:S,oldContent:I})}}let n=null;if(w){let g=0;n=[];for(let E=0;E<i.length;E++){const D=i[E],S=t[E],I=this.getValueInRange(D.range),A=D.rangeOffset+g;g+=D.text.length-I.length,n[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:S,text:I,textChange:new b.$iu(D.rangeOffset,I,A,D.text)}}s||n.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=a,this.h=m,this.j=p;const d=this.t(i);let l=null;if(P&&o.length>0){o.sort((g,E)=>E.lineNumber-g.lineNumber),l=[];for(let g=0,E=o.length;g<E;g++){const D=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===D)continue;const S=o[g].oldContent,I=this.getLineContent(D);I.length===0||I===S||h.$vf(I)!==-1||l.push(D)}}return this.m.fire(),new R.$mw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const w=u[0].range,a=u[u.length-1].range,m=new C.$Rt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let p=w.startLineNumber,f=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const g=u[d],E=g.range;P=P||g.forceMoveMarkers,i.push(this.getValueInRange(new C.$Rt(p,f,E.startLineNumber,E.startColumn))),g.text.length>0&&i.push(g.text),p=E.endLineNumber,f=E.endColumn}const s=i.join(""),[t,o,n]=(0,O.$Cu)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(k.w);const P=[];for(let w=0;w<u.length;w++){const a=u[w],m=a.range.startLineNumber,p=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&p===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new C.$Rt(m,p,f,i);P.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,w,a){return this.c.findMatchesLineByLine(u,P,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const w=u.startLineNumber,a=u.startColumn,[m,p,f]=(0,O.$Cu)(P);let i;if(P.length>0){const s=m+1;s===1?i=new C.$Rt(w,a,w,a+p):i=new C.$Rt(w,a,w+s-1,f+1)}else i=new C.$Rt(w,a,w,a);return i}static _getInverseEditRanges(u){const P=[];let w=0,a=0,m=null;for(let p=0,f=u.length;p<f;p++){const i=u[p];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=w,t=a+(i.range.startColumn-m.range.endColumn)):(s=w+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new C.$Rt(s,t,s,t+i.firstLineLength):o=new C.$Rt(s,t,s+n-1,i.lastLineLength+1)}else o=new C.$Rt(s,t,s,t);w=o.endLineNumber,a=o.endColumn,P.push(o),m=i}return P}static u(u,P){const w=C.$Rt.compareRangesUsingEnds(u.range,P.range);return w===0?u.sortIndex-P.sortIndex:w}static w(u,P){const w=C.$Rt.compareRangesUsingEnds(u.range,P.range);return w===0?P.sortIndex-u.sortIndex:-w}}e.$zD=k}),define(ke[209],Ie([1,0,26,12,58,143,208]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=void 0,h=We(h);class O{constructor(k,y,u,P,w,a,m,p,f){this.a=k,this.b=y,this.c=u,this.d=P,this.e=w,this.f=a,this.g=m,this.h=p,this.j=f}k(k){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?k===C.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(k){const y=this.k(k),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const m=u[w].buffer.replace(/\r\n|\r|\n/g,y),p=(0,R.$uD)(m);u[w]=new R.$xD(m,p)}const P=new T.$zD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(k){return this.a[0].buffer.substr(0,k).split(/\r\n|\r|\n/)[0]}}class b{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(k){if(k.length===0)return;this.a.length===0&&h.$6f(k)&&(this.b=h.$5f,k=k.substr(1));const y=k.charCodeAt(k.length-1);y===r.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(k.substr(0,k.length-1),!1),this.c=!0,this.d=y):(this.m(k,!1),this.c=!1,this.d=y)}m(k,y){!y&&k.length===0||(this.c?this.n(String.fromCharCode(this.d)+k):this.n(k))}n(k){const y=(0,R.$vD)(this.e,k);this.a.push(new R.$xD(k,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Uf(k)),this.k||(this.k=h.$Xf(k)))}finish(k=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,k)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const k=this.a[this.a.length-1];k.buffer+=String.fromCharCode(this.d);const y=(0,R.$uD)(k.buffer);k.lineStarts=y,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$AD=b}),define(ke[144],Ie([1,0,21,10]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3db=b,e.$4db=k,h=We(h);var C;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(C||(C={}));function R(y){for(let u=0,P=y.length;u<P;u+=4){const w=y[u+0],a=y[u+1],m=y[u+2],p=y[u+3];y[u+0]=p,y[u+1]=m,y[u+2]=a,y[u+3]=w}}function T(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return h.$E()||R(u),r.$Oe.wrap(u)}function O(y){const u=y.buffer;if(h.$E()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function b(y){const u=new Uint32Array(c(y));let P=0;if(u[P++]=y.id,y.type==="full")u[P++]=C.Full,u[P++]=y.data.length,u.set(y.data,P),P+=y.data.length;else{u[P++]=C.Delta,u[P++]=y.deltas.length;for(const w of y.deltas)u[P++]=w.start,u[P++]=w.deleteCount,w.data?(u[P++]=w.data.length,u.set(w.data,P),P+=w.data.length):u[P++]=0}return T(u)}function c(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const P of y.deltas)P.data&&(u+=P.data.length)}return u}function k(y){const u=O(y);let P=0;const w=u[P++];if(u[P++]===C.Full){const f=u[P++],i=u.subarray(P,P+f);return P+=f,{id:w,type:"full",data:i}}const m=u[P++],p=[];for(let f=0;f<m;f++){const i=u[P++],s=u[P++],t=u[P++];let o;t>0&&(o=u.subarray(P,P+t),P+=t),p[f]={start:i,deleteCount:s,data:o}}return{id:w,type:"delta",deltas:p}}}),define(ke[210],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_=e.$T_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const T=this.a.get(R);return this.a.delete(R),T}}addDragOperationTransfer(R,T){this.a.set(R,T)}}e.$T_=r;class h{constructor(R){this.identifier=R}}e.$U_=h}),define(ke[211],Ie([1,0,4,3,110]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$me,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this.a.set(b,c),this.handleChange([b]),(0,h.$Tc)(()=>{this.a.get(b)===c&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,c){this.b.get(b)?.dispose();const k=new T(this,b,c);return this.b.set(b,k),(0,h.$Tc)(()=>{const y=this.b.get(b);!y||y!==k||(this.b.delete(b),y.dispose())})}async getOrCreate(b){const c=this.get(b);if(c)return c;const k=this.b.get(b);return!k||k.isResolved?null:(await k.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const k=this.b.get(b);return!!(!k||k.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>C.ColorId.DefaultBackground?this.d[C.ColorId.DefaultBackground]:null}}e.$Bu=R;class T extends h.$Vc{get isResolved(){return this.c}constructor(b,c,k){super(),this.f=b,this.g=c,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[8],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=T;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(O,b){let c;return b.length===0?c=O:c=O.replace(/\{(\d+)\}/g,(k,y)=>{const u=y[0],P=b[u];let w=k;return typeof P=="string"?w=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(w=String(P)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function C(O,b,...c){return h(typeof O=="number"?R(O,b):b,c)}function R(O,b){const c=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof c!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return c}function T(O,b,...c){let k;typeof O=="number"?k=R(O,b):k=b;const y=h(k,c);return{value:y,original:b===k?y:h(b,c)}}}),define(ke[212],Ie([1,0,4,3,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=k,C=We(C);class R extends h.$Vc{constructor(u,P="",w="",a=!0,m){super(),this.j=this.B(new r.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=w,this.z=a,this.D=m}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$lj=R;class T extends h.$Vc{constructor(){super(...arguments),this.f=this.B(new r.$me),this.onWillRun=this.f.event,this.m=this.B(new r.$me),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,P)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,P){await u.run(P)}}e.$mj=T;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const w of u)w.length&&(P.length?P=[...P,new O,...w]:P=w);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=O;class b{get actions(){return this.a}constructor(u,P,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=w}async run(){}}e.$oj=b;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,C.localize(39,null),void 0,!1)}}e.$pj=c;function k(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(ke[213],Ie([1,0,8]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=c,e.$4m=k,e.$5m=y;const h=60,C=h*60,R=C*24,T=R*7,O=R*30,b=R*365;function c(u,P,w,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(40,null,c(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(41,null);let p;return m<h?(p=m,P?p===1?w?(0,r.localize)(42,null,p):(0,r.localize)(43,null,p):w?(0,r.localize)(44,null,p):(0,r.localize)(45,null,p):p===1?w?(0,r.localize)(46,null,p):(0,r.localize)(47,null,p):w?(0,r.localize)(48,null,p):(0,r.localize)(49,null,p)):m<C?(p=Math.floor(m/h),P?p===1?w?(0,r.localize)(50,null,p):(0,r.localize)(51,null,p):w?(0,r.localize)(52,null,p):(0,r.localize)(53,null,p):p===1?w?(0,r.localize)(54,null,p):(0,r.localize)(55,null,p):w?(0,r.localize)(56,null,p):(0,r.localize)(57,null,p)):m<R?(p=Math.floor(m/C),P?p===1?w?(0,r.localize)(58,null,p):(0,r.localize)(59,null,p):w?(0,r.localize)(60,null,p):(0,r.localize)(61,null,p):p===1?w?(0,r.localize)(62,null,p):(0,r.localize)(63,null,p):w?(0,r.localize)(64,null,p):(0,r.localize)(65,null,p)):m<T?(p=Math.floor(m/R),P?p===1?(0,r.localize)(66,null,p):(0,r.localize)(67,null,p):p===1?(0,r.localize)(68,null,p):(0,r.localize)(69,null,p)):m<O?(p=Math.floor(m/T),P?p===1?w?(0,r.localize)(70,null,p):(0,r.localize)(71,null,p):w?(0,r.localize)(72,null,p):(0,r.localize)(73,null,p):p===1?w?(0,r.localize)(74,null,p):(0,r.localize)(75,null,p):w?(0,r.localize)(76,null,p):(0,r.localize)(77,null,p)):m<b?(p=Math.floor(m/O),P?p===1?w?(0,r.localize)(78,null,p):(0,r.localize)(79,null,p):w?(0,r.localize)(80,null,p):(0,r.localize)(81,null,p):p===1?w?(0,r.localize)(82,null,p):(0,r.localize)(83,null,p):w?(0,r.localize)(84,null,p):(0,r.localize)(85,null,p)):(p=Math.floor(m/b),P?p===1?w?(0,r.localize)(86,null,p):(0,r.localize)(87,null,p):w?(0,r.localize)(88,null,p):(0,r.localize)(89,null,p):p===1?w?(0,r.localize)(90,null,p):(0,r.localize)(91,null,p):w?(0,r.localize)(92,null,p):(0,r.localize)(93,null,p))}function k(u,P){const w=Math.abs(u/1e3);return w<1?P?(0,r.localize)(94,null,u):(0,r.localize)(95,null,u):w<h?P?(0,r.localize)(96,null,Math.round(u)/1e3):(0,r.localize)(97,null,Math.round(u)/1e3):w<C?P?(0,r.localize)(98,null,Math.round(u/(1e3*h))):(0,r.localize)(99,null,Math.round(u/(1e3*h))):w<R?P?(0,r.localize)(100,null,Math.round(u/(1e3*C))):(0,r.localize)(101,null,Math.round(u/(1e3*C))):(0,r.localize)(102,null,Math.round(u/(1e3*R)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[52],Ie([1,0,18,17,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=b,e.$sj=c,e.$tj=k,r=We(r),h=We(h),C=We(C);function R(y,u){return u&&(y.stack||y.stacktrace)?C.localize(103,null,O(y),T(y.stack)||T(y.stacktrace)):O(y)}function T(y){return Array.isArray(y)?y.join(`
`):y}function O(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(104,null,y.message):y.message||C.localize(105,null)}function b(y=null,u=!1){if(!y)return C.localize(106,null);if(Array.isArray(y)){const P=r.$Hb(y),w=b(P[0],u);return P.length>1?C.localize(107,null,w,P.length):w}if(h.$fg(y))return y;if(y.detail){const P=y.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return y.stack?R(y,u):y.message?y.message:C.localize(108,null)}function c(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function k(y,u){let P;return typeof y=="string"?P=new Error(y):P=y,P.actions=u,P}}),define(ke[87],Ie([1,0,82,2,196,30,211,8]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Vu=e.$Uu=e.$Tu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Su=e.$Ru=e.SymbolKinds=e.SymbolTag=e.$Pu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Nu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Mu=e.$Lu=e.$Ku=void 0,e.$Ou=d,e.$Qu=g;class b{constructor(W,J,_){this.offset=W,this.type=J,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ku=b;class c{constructor(W,J){this.tokens=W,this.endState=J,this._tokenizationResultBrand=void 0}}e.$Lu=c;class k{constructor(W,J){this.tokens=W,this.endState=J,this._encodedTokenizationResultBrand=void 0}}e.$Mu=k;var y;(function(V){V[V.Increase=0]="Increase",V[V.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var u;(function(V){V[V.Method=0]="Method",V[V.Function=1]="Function",V[V.Constructor=2]="Constructor",V[V.Field=3]="Field",V[V.Variable=4]="Variable",V[V.Class=5]="Class",V[V.Struct=6]="Struct",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Event=10]="Event",V[V.Operator=11]="Operator",V[V.Unit=12]="Unit",V[V.Value=13]="Value",V[V.Constant=14]="Constant",V[V.Enum=15]="Enum",V[V.EnumMember=16]="EnumMember",V[V.Keyword=17]="Keyword",V[V.Text=18]="Text",V[V.Color=19]="Color",V[V.File=20]="File",V[V.Reference=21]="Reference",V[V.Customcolor=22]="Customcolor",V[V.Folder=23]="Folder",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue",V[V.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(V){const W=new Map;W.set(u.Method,r.$6j.symbolMethod),W.set(u.Function,r.$6j.symbolFunction),W.set(u.Constructor,r.$6j.symbolConstructor),W.set(u.Field,r.$6j.symbolField),W.set(u.Variable,r.$6j.symbolVariable),W.set(u.Class,r.$6j.symbolClass),W.set(u.Struct,r.$6j.symbolStruct),W.set(u.Interface,r.$6j.symbolInterface),W.set(u.Module,r.$6j.symbolModule),W.set(u.Property,r.$6j.symbolProperty),W.set(u.Event,r.$6j.symbolEvent),W.set(u.Operator,r.$6j.symbolOperator),W.set(u.Unit,r.$6j.symbolUnit),W.set(u.Value,r.$6j.symbolValue),W.set(u.Enum,r.$6j.symbolEnum),W.set(u.Constant,r.$6j.symbolConstant),W.set(u.Enum,r.$6j.symbolEnum),W.set(u.EnumMember,r.$6j.symbolEnumMember),W.set(u.Keyword,r.$6j.symbolKeyword),W.set(u.Snippet,r.$6j.symbolSnippet),W.set(u.Text,r.$6j.symbolText),W.set(u.Color,r.$6j.symbolColor),W.set(u.File,r.$6j.symbolFile),W.set(u.Reference,r.$6j.symbolReference),W.set(u.Customcolor,r.$6j.symbolCustomColor),W.set(u.Folder,r.$6j.symbolFolder),W.set(u.TypeParameter,r.$6j.symbolTypeParameter),W.set(u.User,r.$6j.account),W.set(u.Issue,r.$6j.issues);function J(ne){let ye=W.get(ne);return ye||(console.info("No codicon found for CompletionItemKind "+ne),ye=r.$6j.symbolProperty),ye}V.toIcon=J;const _=new Map;_.set("method",u.Method),_.set("function",u.Function),_.set("constructor",u.Constructor),_.set("field",u.Field),_.set("variable",u.Variable),_.set("class",u.Class),_.set("struct",u.Struct),_.set("interface",u.Interface),_.set("module",u.Module),_.set("property",u.Property),_.set("event",u.Event),_.set("operator",u.Operator),_.set("unit",u.Unit),_.set("value",u.Value),_.set("constant",u.Constant),_.set("enum",u.Enum),_.set("enum-member",u.EnumMember),_.set("enumMember",u.EnumMember),_.set("keyword",u.Keyword),_.set("snippet",u.Snippet),_.set("text",u.Text),_.set("color",u.Color),_.set("file",u.File),_.set("reference",u.Reference),_.set("customcolor",u.Customcolor),_.set("folder",u.Folder),_.set("type-parameter",u.TypeParameter),_.set("typeParameter",u.TypeParameter),_.set("account",u.User),_.set("issue",u.Issue);function ce(ne,ye){let ge=_.get(ne);return typeof ge>"u"&&!ye&&(ge=u.Property),ge}V.fromString=ce})(P||(e.CompletionItemKinds=P={}));var w;(function(V){V[V.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(V){V[V.None=0]="None",V[V.KeepWhitespace=1]="KeepWhitespace",V[V.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(V){V[V.Word=0]="Word",V[V.Line=1]="Line",V[V.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var p;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var f;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor(W,J,_,ce){this.range=W,this.text=J,this.completionKind=_,this.isSnippetText=ce}equals(W){return R.$Rt.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}e.$Nu=i;var s;(function(V){V[V.Invoke=1]="Invoke",V[V.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(V){return V&&h.URI.isUri(V.uri)&&R.$Rt.isIRange(V.range)&&(R.$Rt.isIRange(V.originSelectionRange)||R.$Rt.isIRange(V.targetSelectionRange))}var l;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Pu={[l.Array]:(0,O.localize)(783,null),[l.Boolean]:(0,O.localize)(784,null),[l.Class]:(0,O.localize)(785,null),[l.Constant]:(0,O.localize)(786,null),[l.Constructor]:(0,O.localize)(787,null),[l.Enum]:(0,O.localize)(788,null),[l.EnumMember]:(0,O.localize)(789,null),[l.Event]:(0,O.localize)(790,null),[l.Field]:(0,O.localize)(791,null),[l.File]:(0,O.localize)(792,null),[l.Function]:(0,O.localize)(793,null),[l.Interface]:(0,O.localize)(794,null),[l.Key]:(0,O.localize)(795,null),[l.Method]:(0,O.localize)(796,null),[l.Module]:(0,O.localize)(797,null),[l.Namespace]:(0,O.localize)(798,null),[l.Null]:(0,O.localize)(799,null),[l.Number]:(0,O.localize)(800,null),[l.Object]:(0,O.localize)(801,null),[l.Operator]:(0,O.localize)(802,null),[l.Package]:(0,O.localize)(803,null),[l.Property]:(0,O.localize)(804,null),[l.String]:(0,O.localize)(805,null),[l.Struct]:(0,O.localize)(806,null),[l.TypeParameter]:(0,O.localize)(807,null),[l.Variable]:(0,O.localize)(808,null)};function g(V,W){return(0,O.localize)(809,null,V,e.$Pu[W])}var E;(function(V){V[V.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var D;(function(V){const W=new Map;W.set(l.File,r.$6j.symbolFile),W.set(l.Module,r.$6j.symbolModule),W.set(l.Namespace,r.$6j.symbolNamespace),W.set(l.Package,r.$6j.symbolPackage),W.set(l.Class,r.$6j.symbolClass),W.set(l.Method,r.$6j.symbolMethod),W.set(l.Property,r.$6j.symbolProperty),W.set(l.Field,r.$6j.symbolField),W.set(l.Constructor,r.$6j.symbolConstructor),W.set(l.Enum,r.$6j.symbolEnum),W.set(l.Interface,r.$6j.symbolInterface),W.set(l.Function,r.$6j.symbolFunction),W.set(l.Variable,r.$6j.symbolVariable),W.set(l.Constant,r.$6j.symbolConstant),W.set(l.String,r.$6j.symbolString),W.set(l.Number,r.$6j.symbolNumber),W.set(l.Boolean,r.$6j.symbolBoolean),W.set(l.Array,r.$6j.symbolArray),W.set(l.Object,r.$6j.symbolObject),W.set(l.Key,r.$6j.symbolKey),W.set(l.Null,r.$6j.symbolNull),W.set(l.EnumMember,r.$6j.symbolEnumMember),W.set(l.Struct,r.$6j.symbolStruct),W.set(l.Event,r.$6j.symbolEvent),W.set(l.Operator,r.$6j.symbolOperator),W.set(l.TypeParameter,r.$6j.symbolTypeParameter);function J(_){let ce=W.get(_);return ce||(console.info("No codicon found for SymbolKind "+_),ce=r.$6j.symbolProperty),ce}V.toIcon=J})(D||(e.SymbolKinds=D={}));class S{static asEditOperation(W){return C.$St.replace(R.$Rt.lift(W.range),W.text)}}e.$Ru=S;class I{static{this.Comment=new I("comment")}static{this.Imports=new I("imports")}static{this.Region=new I("region")}static fromValue(W){switch(W){case"comment":return I.Comment;case"imports":return I.Imports;case"region":return I.Region}return new I(W)}constructor(W){this.value=W}}e.$Su=I;var A;(function(V){V[V.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var $;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})($||(e.NewSymbolNameTriggerKind=$={}));var v;(function(V){function W(J){return!J||typeof J!="object"?!1:typeof J.id=="string"&&typeof J.title=="string"}V.is=W})(v||(e.Command=v={}));var M;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(M||(e.CommentThreadCollapsibleState=M={}));var N;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var L;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(L||(e.CommentThreadApplicability=L={}));var F;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var B;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(B||(e.CommentState=B={}));var j;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(W){this.b=W,this.a=null}dispose(){this.a&&this.a.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Tu=U,e.$Uu=new T.$Bu,e.$Vu=new T.$Bu;var z;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var ee;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(ke[214],Ie([1,0,26,13,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var R;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...k){switch(k.length){case 1:return(0,C.localize)(1684,null,k[0]);case 2:return(0,C.localize)(1685,null,k[0],k[1]);case 3:return(0,C.localize)(1686,null,k[0],k[1],k[2]);default:return}}const O=(0,C.localize)(1687,null),b=(0,C.localize)(1688,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return y.isTripleEq?"===":"==";case R.NotEq:return y.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return y.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return y.lexeme;case R.QuotedStr:return y.lexeme;case R.Error:return y.lexeme;case R.EOF:return"EOF";default:throw(0,h.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,P=this.c.substring(this.d,this.e),w={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:y}),this.f.push(w)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),P=c.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,P=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(b);return}const a=this.c.charCodeAt(y);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){y++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);y++}for(;y<this.c.length&&c.a.has(this.c.charCodeAt(y));)y++;this.e=y;const w=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=c}),define(ke[145],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:3},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ke[112],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(C,R=[],T=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$Di=r}),define(ke[88],Ie([1,0,112]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Us=R,e.$Vs=T;const h=[];var C;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function R(O,b,c){b instanceof r.$Di||(b=new r.$Di(b,[],!!c)),h.push([O,b])}function T(){return h}}),define(ke[215],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;class r{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$xr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const O=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(T);O.outgoing.set(b.key,b),b.incoming.set(O.key,O)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const O of this.a.values())O.outgoing.delete(T),O.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let O=this.a.get(T);return O||(O=new r(T,R),this.a.set(T,O)),O}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,O]of this.a)R.push(`${T}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const O=new Set([R]),b=this.c(T,O);if(b)return b}}c(R,T){for(const[O,b]of R.outgoing){if(T.has(O))return[...T,O].join(" -> ");T.add(O);const c=this.c(b,T);if(c)return c;T.delete(O)}}}e.$yr=h}),define(ke[5],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=C,e.$Hi=R;var r;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function O(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=O})(r||(e._util=r={})),e.$Fi=C("instantiationService");function h(T,O,b){O[r.DI_TARGET]===O?O[r.DI_DEPENDENCIES].push({id:T,index:b}):(O[r.DI_DEPENDENCIES]=[{id:T,index:b}],O[r.DI_TARGET]=O)}function C(T){if(r.serviceIds.has(T))return r.serviceIds.get(T);const O=function(b,c,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(O,b,k)};return O.toString=()=>T,r.serviceIds.set(T,O),O}function R(T){return T}}),define(ke[46],Ie([1,0,17,2,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=R,e.$cj=T,e.$dj=b,e.$ej=c,e.$fj=k,e.$gj=y,e.$hj=u,e.$ij=w,e.$jj=a,e.$kj=m,r=We(r),e.$aj=(0,C.$Gi)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof h.URI)}function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof h.URI)}var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function b(p){switch(p){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function c(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function k(p,f){const i=Object.create(null);for(const s in p)y(i,s,p[s],f);return i}function y(p,f,i,s){const t=f.split("."),o=t.pop();let n=p;for(let d=0;d<t.length;d++){const l=t[d];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u(p,f){const i=f.split(".");P(p,i)}function P(p,f){const i=f.shift();if(f.length===0){delete p[i];return}if(Object.keys(p).indexOf(i)!==-1){const s=p[i];typeof s=="object"&&!Array.isArray(s)&&(P(s,f),Object.keys(s).length===0&&delete p[i])}}function w(p,f,i){function s(n,d){let l=n;for(const g of d){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=f.split("."),o=s(p,t);return typeof o>"u"?i:o}function a(p,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in p?r.$hg(p[s])&&r.$hg(f[s])?a(p[s],f[s],i):i&&(p[s]=f[s]):p[s]=f[s])})}function m(p){return p.replace(/[\[\]]/g,"")}}),define(ke[35],Ie([1,0,26,10,12,214,5,8,13]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=k,e.$Fj=d,e.$Gj=l,e.$Zj=ne;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function k(Y,q){if(c.get(Y)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,q)}const y=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},w=(0,O.localize)(1664,null),a=(0,O.localize)(1665,null),m=(0,O.localize)(1666,null),p=(0,O.localize)(1667,null),f=(0,O.localize)(1668,null),i=(0,O.localize)(1669,null),s=(0,O.localize)(1670,null),t=(0,O.localize)(1671,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=P){this.k=q,this.d=new R.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const oe=this.l();if(!this.E()){const ve=this.D(),ie=ve.type===R.TokenType.Str?i:void 0;throw this.h.push({message:f,offset:ve.offset,lexeme:R.$Bj.getLexeme(ve),additionalInfo:ie}),o.c}return oe}catch(oe){if(oe!==o.c)throw oe;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(R.TokenType.Or);){const oe=this.o();q.push(oe)}return q.length===1?q[0]:n.or(...q)}o(){const q=[this.s()];for(;this.y(R.TokenType.And);){const oe=this.s();q.push(oe)}return q.length===1?q[0]:n.and(...q)}s(){if(this.y(R.TokenType.Neg)){const q=this.D();switch(q.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,p),oe?.negate()}case R.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case R.TokenType.True:return this.z(),n.true();case R.TokenType.False:return this.z(),n.false();case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,p),oe}case R.TokenType.Str:{const oe=q.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==R.TokenType.RegexStr)throw this.B("REGEX",ie);const ae=ie.lexeme,se=ae.lastIndexOf("/"),X=se===ae.length-1?void 0:this.w(ae.substring(se+1));let re;try{re=new RegExp(ae.substring(1,se),X)}catch{throw this.B("REGEX",ie)}return U.create(oe,re)}switch(ie.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ae=[ie.lexeme];this.z();let se=this.D(),X=0;for(let ze=0;ze<ie.lexeme.length;ze++)ie.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?X++:ie.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&X--;for(;!this.E()&&se.type!==R.TokenType.And&&se.type!==R.TokenType.Or;){switch(se.type){case R.TokenType.LParen:X++;break;case R.TokenType.RParen:X--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ze=0;ze<se.lexeme.length;ze++)se.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?X++:ie.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&X--}if(X<0)break;ae.push(R.$Bj.getLexeme(se)),this.z(),se=this.D()}const re=ae.join(""),pe=re.lastIndexOf("/"),we=pe===re.length-1?void 0:this.w(re.substring(pe+1));let Me;try{Me=new RegExp(re.substring(1,pe),we)}catch{throw this.B("REGEX",ie)}return n.regex(oe,Me)}case R.TokenType.QuotedStr:{const ae=ie.lexeme;this.z();let se=null;if(!(0,C.$df)(ae)){const X=ae.indexOf("/"),re=ae.lastIndexOf("/");if(X!==re&&X>=0){const pe=ae.slice(X+1,re),we=ae[re+1]==="i"?"i":"";try{se=new RegExp(pe,we)}catch{throw this.B("REGEX",ie)}}}if(se===null)throw this.B("REGEX",ie);return U.create(oe,se)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,m);const ie=this.u();return n.notIn(oe,ie)}switch(this.D().type){case R.TokenType.Eq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.equals(oe,ie);switch(ie){case"true":return n.has(oe);case"false":return n.not(oe);default:return n.equals(oe,ie)}}case R.TokenType.NotEq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.notEquals(oe,ie);switch(ie){case"true":return n.not(oe);case"false":return n.has(oe);default:return n.notEquals(oe,ie)}}case R.TokenType.Lt:return this.z(),B.create(oe,this.u());case R.TokenType.LtEq:return this.z(),j.create(oe,this.u());case R.TokenType.Gt:return this.z(),L.create(oe,this.u());case R.TokenType.GtEq:return this.z(),F.create(oe,this.u());case R.TokenType.In:return this.z(),n.in(oe,this.u());default:return n.has(oe)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:q.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),q.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,oe){if(this.C(q))return this.z();throw this.B(oe,this.D())}B(q,oe,ve){const ie=(0,O.localize)(1672,null,q,R.$Bj.getLexeme(oe)),ae=oe.offset,se=R.$Bj.getLexeme(oe);return this.h.push({message:ie,offset:ae,lexeme:se,additionalInfo:ve}),o.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Dj=o;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(q){return S.create(q)}static equals(q,oe){return I.create(q,oe)}static notEquals(q,oe){return v.create(q,oe)}static regex(q,oe){return U.create(q,oe)}static in(q,oe){return A.create(q,oe)}static notIn(q,oe){return $.create(q,oe)}static not(q){return M.create(q)}static and(...q){return V.create(q,null,!0)}static or(...q){return W.create(q,null,!0)}static greater(q,oe){return L.create(q,oe)}static greaterEquals(q,oe){return F.create(q,oe)}static smaller(q,oe){return B.create(q,oe)}static smallerEquals(q,oe){return j.create(q,oe)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Ej=n;function d(Y){const q=new o({regexParsingWithErrorRecovery:!1});return Y.map(oe=>(q.parse(oe),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,O.localize)(1673,null,ve.additionalInfo):(0,O.localize)(1674,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function l(Y,q){const oe=Y?Y.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!oe&&!ve?!0:!oe||!ve?!1:oe.equals(ve)}function g(Y,q){return Y.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Hj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Ij=D;class S{static create(q,oe=null){const ve=c.get(q);return typeof ve=="boolean"?ve?D.INSTANCE:E.INSTANCE:new S(q,oe)}constructor(q,oe){this.key=q,this.c=oe,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:_(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=c.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Jj=S;class I{static create(q,oe,ve=null){if(typeof oe=="boolean")return oe?S.create(q,ve):M.create(q,ve);const ie=c.get(q);return typeof ie=="boolean"?oe===(ie?"true":"false")?D.INSTANCE:E.INSTANCE:new I(q,oe,ve)}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const oe=q?"true":"false";return this.d===oe?D.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Kj=I;class A{static create(q,oe){return new A(q,oe)}constructor(q,oe){this.d=q,this.f=oe,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const oe=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(oe)?oe.includes(ve):typeof ve=="string"&&typeof oe=="object"&&oe!==null?y.call(oe,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Lj=A;class ${static create(q,oe){return new $(q,oe)}constructor(q,oe){this.d=q,this.f=oe,this.type=u.NotIn,this.c=A.create(q,oe)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=$;class v{static create(q,oe,ve=null){if(typeof oe=="boolean")return oe?M.create(q,ve):S.create(q,ve);const ie=c.get(q);return typeof ie=="boolean"?oe===(ie?"true":"false")?E.INSTANCE:D.INSTANCE:new v(q,oe,ve)}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const oe=q?"true":"false";return this.d===oe?E.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Nj=v;class M{static create(q,oe=null){const ve=c.get(q);return typeof ve=="boolean"?ve?E.INSTANCE:D.INSTANCE:new M(q,oe)}constructor(q,oe){this.c=q,this.d=oe,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:_(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=c.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Oj=M;function N(Y,q){if(typeof Y=="string"){const oe=parseFloat(Y);isNaN(oe)||(Y=oe)}return typeof Y=="string"||typeof Y=="number"?q(Y):E.INSTANCE}class L{static create(q,oe,ve=null){return N(oe,ie=>new L(q,ie,ve))}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Pj=L;class F{static create(q,oe,ve=null){return N(oe,ie=>new F(q,ie,ve))}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Qj=F;class B{static create(q,oe,ve=null){return N(oe,ie=>new B(q,ie,ve))}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Rj=B;class j{static create(q,oe,ve=null){return N(oe,ie=>new j(q,ie,ve))}constructor(q,oe,ve){this.c=q,this.d=oe,this.f=ve,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Sj=j;class U{static create(q,oe){return new U(q,oe)}constructor(q,oe){this.d=q,this.f=oe,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const oe=this.f?this.f.source:"",ve=q.f?q.f.source:"";return oe<ve?-1:oe>ve?1:0}equals(q){if(q.type===this.type){const oe=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&oe===ve}return!1}substituteConstants(){return this}evaluate(q){const oe=q.getValue(this.d);return this.f?this.f.test(oe):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$Tj=U;class z{static create(q){return new z(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new z(this.c.map(q))}negate(){return this.c}}e.$Uj=z;function ee(Y){let q=null;for(let oe=0,ve=Y.length;oe<ve;oe++){const ie=Y[oe].substituteConstants();if(Y[oe]!==ie&&q===null){q=[];for(let ae=0;ae<oe;ae++)q[ae]=Y[ae]}q!==null&&(q[oe]=ie)}return q===null?Y:q}class V{static create(q,oe,ve){return V.d(q,oe,ve)}constructor(q,oe){this.expr=q,this.c=oe,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const ie=g(this.expr[oe],q.expr[oe]);if(ie!==0)return ie}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(q.expr[oe]))return!1;return!0}return!1}substituteConstants(){const q=ee(this.expr);return q===this.expr?this:V.create(q,this.c,!1)}evaluate(q){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].evaluate(q))return!1;return!0}static d(q,oe,ve){const ie=[];let ae=!1;for(const se of q)if(se){if(se.type===u.True){ae=!0;continue}if(se.type===u.False)return E.INSTANCE;if(se.type===u.And){ie.push(...se.expr);continue}ie.push(se)}if(ie.length===0&&ae)return D.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(g);for(let se=1;se<ie.length;se++)ie[se-1].equals(ie[se])&&(ie.splice(se,1),se--);if(ie.length===1)return ie[0];for(;ie.length>1;){const se=ie[ie.length-1];if(se.type!==u.Or)break;ie.pop();const X=ie.pop(),re=ie.length===0,pe=W.create(se.expr.map(we=>V.create([we,X],null,ve)),null,re);pe&&(ie.push(pe),ie.sort(g))}if(ie.length===1)return ie[0];if(ve){for(let se=0;se<ie.length;se++)for(let X=se+1;X<ie.length;X++)if(ie[se].negate().equals(ie[X]))return E.INSTANCE;if(ie.length===1)return ie[0]}return new V(ie,oe)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const oe of this.expr)q.push(...oe.keys());return q}map(q){return new V(this.expr.map(oe=>oe.map(q)),null)}negate(){if(!this.c){const q=[];for(const oe of this.expr)q.push(oe.negate());this.c=W.create(q,this,!0)}return this.c}}e.$Vj=V;class W{static create(q,oe,ve){return W.d(q,oe,ve)}constructor(q,oe){this.expr=q,this.c=oe,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const ie=g(this.expr[oe],q.expr[oe]);if(ie!==0)return ie}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(q.expr[oe]))return!1;return!0}return!1}substituteConstants(){const q=ee(this.expr);return q===this.expr?this:W.create(q,this.c,!1)}evaluate(q){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(this.expr[oe].evaluate(q))return!0;return!1}static d(q,oe,ve){let ie=[],ae=!1;if(q){for(let se=0,X=q.length;se<X;se++){const re=q[se];if(re){if(re.type===u.False){ae=!0;continue}if(re.type===u.True)return D.INSTANCE;if(re.type===u.Or){ie=ie.concat(re.expr);continue}ie.push(re)}}if(ie.length===0&&ae)return E.INSTANCE;ie.sort(g)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let se=1;se<ie.length;se++)ie[se-1].equals(ie[se])&&(ie.splice(se,1),se--);if(ie.length===1)return ie[0];if(ve){for(let se=0;se<ie.length;se++)for(let X=se+1;X<ie.length;X++)if(ie[se].negate().equals(ie[X]))return D.INSTANCE;if(ie.length===1)return ie[0]}return new W(ie,oe)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const oe of this.expr)q.push(...oe.keys());return q}map(q){return new W(this.expr.map(oe=>oe.map(q)),null)}negate(){if(!this.c){const q=[];for(const oe of this.expr)q.push(oe.negate());for(;q.length>1;){const oe=q.shift(),ve=q.shift(),ie=[];for(const ae of ge(oe))for(const se of ge(ve))ie.push(V.create([ae,se],null,!1));q.unshift(W.create(ie,null,!1))}this.c=W.create(q,this,!0)}return this.c}}e.$Wj=W;class J extends S{static{this.d=[]}static all(){return J.d.values()}constructor(q,oe,ve){super(q,null),this.f=oe,typeof ve=="object"?J.d.push({...ve,key:q}):ve!==!0&&J.d.push({key:q,description:ve,type:oe!=null?typeof oe:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return v.create(this.key,q)}}e.$Xj=J,e.$Yj=(0,T.$Gi)("contextKeyService");function _(Y,q){return Y<q?-1:Y>q?1:0}function ce(Y,q,oe,ve){return Y<oe?-1:Y>oe?1:q<ve?-1:q>ve?1:0}function ne(Y,q){if(Y.type===u.False||q.type===u.True)return!0;if(Y.type===u.Or)return q.type===u.Or?ye(Y.expr,q.expr):!1;if(q.type===u.Or){for(const oe of q.expr)if(ne(Y,oe))return!0;return!1}if(Y.type===u.And){if(q.type===u.And)return ye(q.expr,Y.expr);for(const oe of Y.expr)if(ne(oe,q))return!0;return!1}return Y.equals(q)}function ye(Y,q){let oe=0,ve=0;for(;oe<Y.length&&ve<q.length;){const ie=Y[oe].cmp(q[ve]);if(ie<0)return!1;ie===0&&oe++,ve++}return oe===Y.length}function ge(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(ke[216],Ie([1,0,35,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$vt=e.AccessibilitySupport=e.$ut=void 0,e.$wt=R,e.$ut=(0,h.$Gi)("accessibilityService");var C;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$vt=new r.$Xj("accessibilityModeEnabled",!1);function R(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$xt="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[113],Ie([1,0,18,24,10,187,83,200,142,8,216]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=We(r),h=We(h),C=We(C),c=We(c);var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(he){this.c=he}hasChanged(he){return this.c[he]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(he,le,Xe,tt){this.id=he,this.name=le,this.defaultValue=Xe,this.schema=tt}applyUpdate(he,le){return m(he,le)}compute(he,le,Xe){return Xe}}class a{constructor(he,le){this.newValue=he,this.didChange=le}}e.ApplyUpdateResult=a;function m(ue,he){if(typeof ue!="object"||typeof he!="object"||!ue||!he)return new a(he,ue!==he);if(Array.isArray(ue)||Array.isArray(he)){const Xe=Array.isArray(ue)&&Array.isArray(he)&&r.$ub(ue,he);return new a(he,!Xe)}let le=!1;for(const Xe in he)if(he.hasOwnProperty(Xe)){const tt=m(ue[Xe],he[Xe]);tt.didChange&&(ue[Xe]=tt.newValue,le=!0)}return new a(ue,le)}class p{constructor(he){this.schema=void 0,this.id=he,this.name="_never_",this.defaultValue=void 0}applyUpdate(he,le){return m(he,le)}validate(he){return this.defaultValue}}class f{constructor(he,le,Xe,tt){this.id=he,this.name=le,this.defaultValue=Xe,this.schema=tt}applyUpdate(he,le){return m(he,le)}validate(he){return typeof he>"u"?this.defaultValue:he}compute(he,le,Xe){return Xe}}function i(ue,he){return typeof ue>"u"?he:ue==="false"?!1:!!ue}class s extends f{constructor(he,le,Xe,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Xe),super(he,le,Xe,tt)}validate(he){return i(he,this.defaultValue)}}function t(ue,he,le,Xe){if(typeof ue>"u")return he;let tt=parseInt(ue,10);return isNaN(tt)?he:(tt=Math.max(le,tt),tt=Math.min(Xe,tt),tt|0)}class o extends f{static clampedInt(he,le,Xe,tt){return t(he,le,Xe,tt)}constructor(he,le,Xe,tt,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Xe,mt.minimum=tt,mt.maximum=ut),super(he,le,Xe,mt),this.minimum=tt,this.maximum=ut}validate(he){return o.clampedInt(he,this.defaultValue,this.minimum,this.maximum)}}function n(ue,he,le,Xe){if(typeof ue>"u")return he;const tt=d.float(ue,he);return d.clamp(tt,le,Xe)}class d extends f{static clamp(he,le,Xe){return he<le?le:he>Xe?Xe:he}static float(he,le){if(typeof he=="number")return he;if(typeof he>"u")return le;const Xe=parseFloat(he);return isNaN(Xe)?le:Xe}constructor(he,le,Xe,tt,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(he,le,Xe,ut),this.validationFn=tt}validate(he){return this.validationFn(d.float(he,this.defaultValue))}}class l extends f{static string(he,le){return typeof he!="string"?le:he}constructor(he,le,Xe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Xe),super(he,le,Xe,tt)}validate(he){return l.string(he,this.defaultValue)}}function g(ue,he,le,Xe){return typeof ue!="string"?he:Xe&&ue in Xe?Xe[ue]:le.indexOf(ue)===-1?he:ue}class E extends f{constructor(he,le,Xe,tt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=tt,ut.default=Xe),super(he,le,Xe,ut),this.c=tt}validate(he){return g(he,this.defaultValue,this.c)}}class D extends w{constructor(he,le,Xe,tt,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=tt),super(he,le,Xe,Dt),this.c=ut,this.d=mt}validate(he){return typeof he!="string"?this.defaultValue:this.c.indexOf(he)===-1?this.defaultValue:this.d(he)}}function S(ue){switch(ue){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class I extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",k.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(297,null),c.localize(298,null),c.localize(299,null)],default:"auto",tags:["accessibility"],description:c.localize(300,null)})}validate(he){switch(he){case"auto":return k.AccessibilitySupport.Unknown;case"off":return k.AccessibilitySupport.Disabled;case"on":return k.AccessibilitySupport.Enabled}return this.defaultValue}compute(he,le,Xe){return Xe===k.AccessibilitySupport.Unknown?he.accessibilitySupport:Xe}}class A extends w{constructor(){const he={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",he,{"editor.comments.insertSpace":{type:"boolean",default:he.insertSpace,description:c.localize(301,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:he.ignoreEmptyLines,description:c.localize(302,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertSpace:i(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var $;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})($||(e.TextEditorCursorBlinkingStyle=$={}));function v(ue){switch(ue){case"blink":return $.Blink;case"smooth":return $.Smooth;case"phase":return $.Phase;case"expand":return $.Expand;case"solid":return $.Solid}}var M;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(ue){switch(ue){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(ue){switch(ue){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class F extends p{constructor(){super(je.editorClassName)}compute(he,le,Xe){const tt=["monaco-editor"];return le.get(je.extraEditorClassName)&&tt.push(le.get(je.extraEditorClassName)),he.extraEditorClassName&&tt.push(he.extraEditorClassName),le.get(je.mouseStyle)==="default"?tt.push("mouse-default"):le.get(je.mouseStyle)==="copy"&&tt.push("mouse-copy"),le.get(je.showUnused)&&tt.push("showUnused"),le.get(je.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class B extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(303,null)})}compute(he,le,Xe){return Xe&&he.emptySelectionClipboard}}class j extends w{constructor(){const he={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",he,{"editor.find.cursorMoveOnType":{type:"boolean",default:he.cursorMoveOnType,description:c.localize(304,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:he.seedSearchStringFromSelection,enumDescriptions:[c.localize(305,null),c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:he.autoFindInSelection,enumDescriptions:[c.localize(309,null),c.localize(310,null),c.localize(311,null)],description:c.localize(312,null)},"editor.find.globalFindClipboard":{type:"boolean",default:he.globalFindClipboard,description:c.localize(313,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:he.addExtraSpaceOnTop,description:c.localize(314,null)},"editor.find.loop":{type:"boolean",default:he.loop,description:c.localize(315,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{cursorMoveOnType:i(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof he.seedSearchStringFromSelection=="boolean"?he.seedSearchStringFromSelection?"always":"never":g(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof he.autoFindInSelection=="boolean"?he.autoFindInSelection?"always":"never":g(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(le.loop,this.defaultValue.loop)}}}class U extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:c.localize(316,null)},{type:"string",description:c.localize(317,null)}],description:c.localize(318,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"||he.length===0?U.OFF:he==="true"?U.ON:he:he?U.ON:U.OFF}}e.EditorFontLigatures=U;class z extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:c.localize(319,null)},{type:"string",description:c.localize(320,null)}],description:c.localize(321,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?z.OFF:he==="true"?z.TRANSLATE:he:he?z.TRANSLATE:z.OFF}compute(he,le,Xe){return he.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class ee extends p{constructor(){super(je.fontInfo)}compute(he,le,Xe){return he.fontInfo}}class V extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(322,null)})}validate(he){const le=d.float(he,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(le,6,100)}compute(he,le,Xe){return he.fontInfo.fontSize}}class W extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:c.localize(323,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(324,null)})}validate(he){return he==="normal"||he==="bold"?he:String(o.clampedInt(he,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class J extends w{constructor(){const he={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:he.multiple,enumDescriptions:[c.localize(325,null),c.localize(326,null),c.localize(327,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",he,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(328,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(329,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(330,null),...le},"editor.gotoLocation.multipleDeclarations":{description:c.localize(331,null),...le},"editor.gotoLocation.multipleImplementations":{description:c.localize(332,null),...le},"editor.gotoLocation.multipleReferences":{description:c.localize(333,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:he.alternativeDefinitionCommand,enum:Xe,description:c.localize(334,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:he.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(335,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:he.alternativeDeclarationCommand,enum:Xe,description:c.localize(336,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:he.alternativeImplementationCommand,enum:Xe,description:c.localize(337,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:he.alternativeReferenceCommand,enum:Xe,description:c.localize(338,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{multiple:g(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??g(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??g(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??g(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??g(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??g(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:le.multipleTests??g(le.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:l.string(le.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class _ extends w{constructor(){const he={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",he,{"editor.hover.enabled":{type:"boolean",default:he.enabled,description:c.localize(339,null)},"editor.hover.delay":{type:"number",default:he.delay,minimum:0,maximum:1e4,description:c.localize(340,null)},"editor.hover.sticky":{type:"boolean",default:he.sticky,description:c.localize(341,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:he.hidingDelay,description:c.localize(342,null)},"editor.hover.above":{type:"boolean",default:he.above,description:c.localize(343,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),delay:o.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:i(le.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(le.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(le.above,this.defaultValue.above)}}}var ce;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class ne extends p{constructor(){super(je.layoutInfo)}compute(he,le,Xe){return ne.computeLayout(le,{memory:he.memory,outerWidth:he.outerWidth,outerHeight:he.outerHeight,isDominatedByLongLines:he.isDominatedByLongLines,lineHeight:he.fontInfo.lineHeight,viewLineCount:he.viewLineCount,lineNumbersDigitCount:he.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:he.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:he.fontInfo.maxDigitWidth,pixelRatio:he.pixelRatio,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(he){const le=he.height/he.lineHeight,Xe=Math.floor(he.paddingTop/he.lineHeight);let tt=Math.floor(he.paddingBottom/he.lineHeight);he.scrollBeyondLastLine&&(tt=Math.max(tt,le-1));const ut=(Xe+he.viewLineCount+tt)/(he.pixelRatio*he.height),mt=Math.floor(he.viewLineCount/ut);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:tt,desiredRatio:ut,minimapLineCount:mt}}static c(he,le){const Xe=he.outerWidth,tt=he.outerHeight,ut=he.pixelRatio;if(!he.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const mt=le.stableMinimapLayoutInput,Dt=mt&&he.outerHeight===mt.outerHeight&&he.lineHeight===mt.lineHeight&&he.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&he.pixelRatio===mt.pixelRatio&&he.scrollBeyondLastLine===mt.scrollBeyondLastLine&&he.paddingTop===mt.paddingTop&&he.paddingBottom===mt.paddingBottom&&he.minimap.enabled===mt.minimap.enabled&&he.minimap.side===mt.minimap.side&&he.minimap.size===mt.minimap.size&&he.minimap.showSlider===mt.minimap.showSlider&&he.minimap.renderCharacters===mt.minimap.renderCharacters&&he.minimap.maxColumn===mt.minimap.maxColumn&&he.minimap.scale===mt.minimap.scale&&he.verticalScrollbarWidth===mt.verticalScrollbarWidth&&he.isViewportWrapping===mt.isViewportWrapping,Ft=he.lineHeight,Ht=he.typicalHalfwidthCharacterWidth,ti=he.scrollBeyondLastLine,oi=he.minimap.renderCharacters;let Ot=ut>=2?Math.round(he.minimap.scale*2):he.minimap.scale;const it=he.minimap.maxColumn,Ct=he.minimap.size,hi=he.minimap.side,bt=he.verticalScrollbarWidth,St=he.viewLineCount,ii=he.remainingWidth,ni=he.isViewportWrapping,qt=oi?2:3;let pt=Math.floor(ut*tt);const Bt=pt/ut;let ri=!1,ai=!1,xe=qt*Ot,ci=Ot/ut,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Wt,desiredRatio:Kt,minimapLineCount:Zt}=ne.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:ti,paddingTop:he.paddingTop,paddingBottom:he.paddingBottom,height:tt,lineHeight:Ft,pixelRatio:ut});if(St/Zt>1)ri=!0,ai=!0,Ot=1,xe=1,ci=Ot/ut;else{let wt=!1,It=Ot+1;if(Ct==="fit"){const Qt=Math.ceil((li+St+Wt)*xe);ni&&Dt&&ii<=le.stableFitRemainingWidth?(wt=!0,It=le.stableFitMaxMinimapScale):wt=Qt>pt}if(Ct==="fill"||wt){ri=!0;const Qt=Ot;xe=Math.min(Ft*ut,Math.max(1,Math.floor(1/Kt))),ni&&Dt&&ii<=le.stableFitRemainingWidth&&(It=le.stableFitMaxMinimapScale),Ot=Math.min(It,Math.max(1,Math.floor(xe/qt))),Ot>Qt&&(di=Math.min(2,Ot/Qt)),ci=Ot/ut/di,pt=Math.ceil(Math.max(Jt,li+St+Wt)*xe),ni?(le.stableMinimapLayoutInput=he,le.stableFitRemainingWidth=ii,le.stableFitMaxMinimapScale=Ot):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const fi=Math.floor(it*ci),vt=Math.min(fi,Math.max(0,Math.floor((ii-bt-2)*ci/(Ht+ci)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(ut*vt);const Nt=jt/ut;jt=Math.floor(jt*di);const Gt=oi?ce.Text:ce.Blocks,si=hi==="left"?0:Xe-vt-bt;return{renderMinimap:Gt,minimapLeft:si,minimapWidth:vt,minimapHeightIsEditorHeight:ri,minimapIsSampling:ai,minimapScale:Ot,minimapLineHeight:xe,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Bt}}static computeLayout(he,le){const Xe=le.outerWidth|0,tt=le.outerHeight|0,ut=le.lineHeight|0,mt=le.lineNumbersDigitCount|0,Dt=le.typicalHalfwidthCharacterWidth,Ft=le.maxDigitWidth,Ht=le.pixelRatio,ti=le.viewLineCount,oi=he.get(je.wordWrapOverride2),Ot=oi==="inherit"?he.get(je.wordWrapOverride1):oi,it=Ot==="inherit"?he.get(je.wordWrap):Ot,Ct=he.get(je.wordWrapColumn),hi=le.isDominatedByLongLines,bt=he.get(je.glyphMargin),St=he.get(je.lineNumbers).renderType!==ze.Off,ii=he.get(je.lineNumbersMinChars),ni=he.get(je.scrollBeyondLastLine),qt=he.get(je.padding),pt=he.get(je.minimap),Bt=he.get(je.scrollbar),ri=Bt.verticalScrollbarSize,ai=Bt.verticalHasArrows,xe=Bt.arrowSize,ci=Bt.horizontalScrollbarSize,di=he.get(je.folding),fi=he.get(je.showFoldingControls)!=="never";let vt=he.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let jt=0;if(St){const mi=Math.max(mt,ii);jt=Math.round(mi*Ft)}let Nt=0;bt&&(Nt=ut*le.glyphMarginDecorationLaneCount);let Gt=0,si=Gt+Nt,Jt=si+jt,li=Jt+vt;const Wt=Xe-Nt-jt-vt;let Kt=!1,Zt=!1,Mt=-1;Ot==="inherit"&&hi?(Kt=!0,Zt=!0):it==="on"||it==="bounded"?Zt=!0:it==="wordWrapColumn"&&(Mt=Ct);const wt=ne.c({outerWidth:Xe,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ht,scrollBeyondLastLine:ni,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:pt,verticalScrollbarWidth:ri,viewLineCount:ti,remainingWidth:Wt,isViewportWrapping:Zt},le.memory||new P);wt.renderMinimap!==ce.None&&wt.minimapLeft===0&&(Gt+=wt.minimapWidth,si+=wt.minimapWidth,Jt+=wt.minimapWidth,li+=wt.minimapWidth);const It=Wt-wt.minimapWidth,Qt=Math.max(1,Math.floor((It-ri-2)/Dt)),Pt=ai?xe:0;return Zt&&(Mt=Math.max(1,Qt),it==="bounded"&&(Mt=Math.min(Mt,Ct))),{width:Xe,height:tt,glyphMarginLeft:Gt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount,lineNumbersLeft:si,lineNumbersWidth:jt,decorationsLeft:Jt,decorationsWidth:vt,contentLeft:li,contentWidth:It,minimap:wt,viewportColumn:Qt,isWordWrapMinified:Kt,isViewportWrapping:Zt,wrappingColumn:Mt,verticalScrollbarWidth:ri,horizontalScrollbarHeight:ci,overviewRuler:{top:Pt,width:ri,height:tt-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=ne;class ye extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(344,null),c.localize(345,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(346,null)}})}validate(he){return g(he,"simple",["simple","advanced"])}compute(he,le,Xe){return le.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?"advanced":Xe}}var ge;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class Y extends w{constructor(){const he={enabled:ge.On};super(je.lightbulb,"lightbulb",he,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:he.enabled,enumDescriptions:[c.localize(347,null),c.localize(348,null),c.localize(349,null)],description:c.localize(350,null)}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{enabled:g(he.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class q extends w{constructor(){const he={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",he,{"editor.stickyScroll.enabled":{type:"boolean",default:he.enabled,description:c.localize(351,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:he.maxLineCount,minimum:1,maximum:20,description:c.localize(352,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:he.defaultModel,description:c.localize(353,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:he.scrollWithEditor,description:c.localize(354,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(le.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(le.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class oe extends w{constructor(){const he={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",he,{"editor.inlayHints.enabled":{type:"string",default:he.enabled,description:c.localize(355,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(356,null),c.localize(357,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(358,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(359,null)]},"editor.inlayHints.fontSize":{type:"number",default:he.fontSize,markdownDescription:c.localize(360,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:he.fontFamily,markdownDescription:c.localize(361,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:he.padding,description:c.localize(362,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:g(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),padding:i(le.padding,this.defaultValue.padding)}}}class ve extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(he){return typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)?-parseFloat(he.substring(0,he.length-2)):o.clampedInt(he,this.defaultValue,0,1e3)}compute(he,le,Xe){return Xe<0?o.clampedInt(-Xe*he.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class ie extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,he=>d.clamp(he,0,150),{markdownDescription:c.localize(363,null)})}compute(he,le,Xe){return he.fontInfo.lineHeight}}class ae extends w{constructor(){const he={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",he,{"editor.minimap.enabled":{type:"boolean",default:he.enabled,description:c.localize(364,null)},"editor.minimap.autohide":{type:"boolean",default:he.autohide,description:c.localize(365,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(366,null),c.localize(367,null),c.localize(368,null)],default:he.size,description:c.localize(369,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:he.side,description:c.localize(370,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:he.showSlider,description:c.localize(371,null)},"editor.minimap.scale":{type:"number",default:he.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(372,null)},"editor.minimap.renderCharacters":{type:"boolean",default:he.renderCharacters,description:c.localize(373,null)},"editor.minimap.maxColumn":{type:"number",default:he.maxColumn,description:c.localize(374,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:he.showRegionSectionHeaders,description:c.localize(375,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:he.showMarkSectionHeaders,description:c.localize(376,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:he.sectionHeaderFontSize,description:c.localize(377,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:he.sectionHeaderLetterSpacing,description:c.localize(378,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),autohide:i(le.autohide,this.defaultValue.autohide),size:g(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(le.side,this.defaultValue.side,["right","left"]),showSlider:g(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(le.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(le.scale,1,1,3),maxColumn:o.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(le.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(le.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(le.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(le.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function se(ue){return ue==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class X extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(379,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(380,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{top:o.clampedInt(le.top,0,0,1e3),bottom:o.clampedInt(le.bottom,0,0,1e3)}}}class re extends w{constructor(){const he={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",he,{"editor.parameterHints.enabled":{type:"boolean",default:he.enabled,description:c.localize(381,null)},"editor.parameterHints.cycle":{type:"boolean",default:he.cycle,description:c.localize(382,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),cycle:i(le.cycle,this.defaultValue.cycle)}}}class pe extends p{constructor(){super(je.pixelRatio)}compute(he,le,Xe){return he.pixelRatio}}class we extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he:this.defaultValue}}class Me extends w{constructor(){const he={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(383,null),c.localize(384,null),c.localize(385,null)]}];super(je.quickSuggestions,"quickSuggestions",he,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:he.strings,description:c.localize(386,null)},comments:{anyOf:le,default:he.comments,description:c.localize(387,null)},other:{anyOf:le,default:he.other,description:c.localize(388,null)}},default:he,markdownDescription:c.localize(389,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=he}validate(he){if(typeof he=="boolean"){const Ht=he?"on":"off";return{comments:Ht,strings:Ht,other:Ht}}if(!he||typeof he!="object")return this.defaultValue;const{other:le,comments:Xe,strings:tt}=he,ut=["on","inline","off"];let mt,Dt,Ft;return typeof le=="boolean"?mt=le?"on":"off":mt=g(le,this.defaultValue.other,ut),typeof Xe=="boolean"?Dt=Xe?"on":"off":Dt=g(Xe,this.defaultValue.comments,ut),typeof tt=="boolean"?Ft=tt?"on":"off":Ft=g(tt,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Ft}}}var ze;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Ae extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(390,null),c.localize(391,null),c.localize(392,null),c.localize(393,null)],default:"on",description:c.localize(394,null)})}validate(he){let le=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof he<"u"&&(typeof he=="function"?(le=ze.Custom,Xe=he):he==="interval"?le=ze.Interval:he==="relative"?le=ze.Relative:he==="on"?le=ze.On:le=ze.Off),{renderType:le,renderFn:Xe}}}function De(ue){const he=ue.get(je.renderValidationDecorations);return he==="editable"?ue.get(je.readOnly):he!=="on"}class Ce extends w{constructor(){const he=[],le={type:"number",description:c.localize(395,null)};super(je.rulers,"rulers",he,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:c.localize(396,null),format:"color-hex"}}}]},default:he,description:c.localize(397,null)})}validate(he){if(Array.isArray(he)){const le=[];for(const Xe of he)if(typeof Xe=="number")le.push({column:o.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const tt=Xe;le.push({column:o.clampedInt(tt.column,0,0,1e4),color:tt.color})}return le.sort((Xe,tt)=>Xe.column-tt.column),le}return this.defaultValue}}class H extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(he){return!he||typeof he!="object"?this.defaultValue:he}}function G(ue,he){if(typeof ue!="string")return he;switch(ue){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class Z extends w{constructor(){const he={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",he,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(398,null),c.localize(399,null),c.localize(400,null)],default:"auto",description:c.localize(401,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(402,null),c.localize(403,null),c.localize(404,null)],default:"auto",description:c.localize(405,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:he.verticalScrollbarSize,description:c.localize(406,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:he.horizontalScrollbarSize,description:c.localize(407,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:he.scrollByPage,description:c.localize(408,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:he.ignoreHorizontalScrollbarInContentHeight,description:c.localize(409,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he,Xe=o.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=o.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(le.vertical,this.defaultValue.vertical),horizontal:G(le.horizontal,this.defaultValue.horizontal),useShadows:i(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:o.clampedInt(le.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:o.clampedInt(le.verticalSliderSize,tt,0,1e3),scrollByPage:i(le.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(le.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends w{constructor(){const he={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",he,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.nonBasicASCII,description:c.localize(410,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:he.invisibleCharacters,description:c.localize(411,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:he.ambiguousCharacters,description:c.localize(412,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeComments,description:c.localize(413,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeStrings,description:c.localize(414,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:he.allowedCharacters,description:c.localize(415,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:he.allowedLocales,description:c.localize(416,null)}})}applyUpdate(he,le){let Xe=!1;le.allowedCharacters&&he&&(h.$jo(he.allowedCharacters,le.allowedCharacters)||(he={...he,allowedCharacters:le.allowedCharacters},Xe=!0)),le.allowedLocales&&he&&(h.$jo(he.allowedLocales,le.allowedLocales)||(he={...he,allowedLocales:le.allowedLocales},Xe=!0));const tt=super.applyUpdate(he,le);return Xe?new a(tt.newValue,!0):tt}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{nonBasicASCII:Ke(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(he.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(he.allowedLocales,this.defaultValue.allowedLocales)}}c(he,le){if(typeof he!="object"||!he)return le;const Xe={};for(const[tt,ut]of Object.entries(he))ut===!0&&(Xe[tt]=!0);return Xe}}class de extends w{constructor(){const he={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",he,{"editor.inlineSuggest.enabled":{type:"boolean",default:he.enabled,description:c.localize(417,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(418,null),c.localize(419,null),c.localize(420,null)],description:c.localize(421,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:he.suppressSuggestions,description:c.localize(422,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(423,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),mode:g(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(le.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily)}}}class Ee extends w{constructor(){const he={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",he,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:he.enabled,description:c.localize(424,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(425,null),c.localize(426,null),c.localize(427,null)],description:c.localize(428,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(429,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Te extends w{constructor(){const he={enabled:O.$ot.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$ot.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",he,{"editor.bracketPairColorization.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(430,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:he.independentColorPoolPerBracketType,description:c.localize(431,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends w{constructor(){const he={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",he,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(432,null),c.localize(433,null),c.localize(434,null)],default:he.bracketPairs,description:c.localize(435,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(436,null),c.localize(437,null),c.localize(438,null)],default:he.bracketPairsHorizontal,description:c.localize(439,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:he.highlightActiveBracketPair,description:c.localize(440,null)},"editor.guides.indentation":{type:"boolean",default:he.indentation,description:c.localize(441,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(442,null),c.localize(443,null),c.localize(444,null)],default:he.highlightActiveIndentation,description:c.localize(445,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{bracketPairs:Ke(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ue,he,le){const Xe=le.indexOf(ue);return Xe===-1?he:le[Xe]}class et extends w{constructor(){const he={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",he,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(446,null),c.localize(447,null)],default:he.insertMode,description:c.localize(448,null)},"editor.suggest.filterGraceful":{type:"boolean",default:he.filterGraceful,description:c.localize(449,null)},"editor.suggest.localityBonus":{type:"boolean",default:he.localityBonus,description:c.localize(450,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:he.shareSuggestSelections,markdownDescription:c.localize(451,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(452,null),c.localize(453,null),c.localize(454,null),c.localize(455,null)],default:he.selectionMode,markdownDescription:c.localize(456,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:he.snippetsPreventQuickSuggestions,description:c.localize(457,null)},"editor.suggest.showIcons":{type:"boolean",default:he.showIcons,description:c.localize(458,null)},"editor.suggest.showStatusBar":{type:"boolean",default:he.showStatusBar,description:c.localize(459,null)},"editor.suggest.preview":{type:"boolean",default:he.preview,description:c.localize(460,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:he.showInlineDetails,description:c.localize(461,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(462,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(463,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(464,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(465,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(466,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(467,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(468,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(469,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(470,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(471,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(472,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(473,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(474,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(475,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(476,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(477,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(478,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(479,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(480,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(481,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(482,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(483,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(484,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(485,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(486,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(487,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(488,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(489,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(490,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(491,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(492,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(493,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertMode:g(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(le.showIcons,this.defaultValue.showIcons),showStatusBar:i(le.showStatusBar,this.defaultValue.showStatusBar),preview:i(le.preview,this.defaultValue.preview),previewMode:g(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(le.showMethods,this.defaultValue.showMethods),showFunctions:i(le.showFunctions,this.defaultValue.showFunctions),showConstructors:i(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(le.showFields,this.defaultValue.showFields),showVariables:i(le.showVariables,this.defaultValue.showVariables),showClasses:i(le.showClasses,this.defaultValue.showClasses),showStructs:i(le.showStructs,this.defaultValue.showStructs),showInterfaces:i(le.showInterfaces,this.defaultValue.showInterfaces),showModules:i(le.showModules,this.defaultValue.showModules),showProperties:i(le.showProperties,this.defaultValue.showProperties),showEvents:i(le.showEvents,this.defaultValue.showEvents),showOperators:i(le.showOperators,this.defaultValue.showOperators),showUnits:i(le.showUnits,this.defaultValue.showUnits),showValues:i(le.showValues,this.defaultValue.showValues),showConstants:i(le.showConstants,this.defaultValue.showConstants),showEnums:i(le.showEnums,this.defaultValue.showEnums),showEnumMembers:i(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(le.showKeywords,this.defaultValue.showKeywords),showWords:i(le.showWords,this.defaultValue.showWords),showColors:i(le.showColors,this.defaultValue.showColors),showFiles:i(le.showFiles,this.defaultValue.showFiles),showReferences:i(le.showReferences,this.defaultValue.showReferences),showFolders:i(le.showFolders,this.defaultValue.showFolders),showTypeParameters:i(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(le.showSnippets,this.defaultValue.showSnippets),showUsers:i(le.showUsers,this.defaultValue.showUsers),showIssues:i(le.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(494,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(495,null),default:!0,type:"boolean"}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(he.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(he.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends w{constructor(){const he=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",he,{anyOf:[{description:c.localize(496,null),type:"string"},{description:c.localize(497,null),type:"array",items:{type:"string"}}]})}validate(he){if(typeof he=="string"&&(he=[he]),Array.isArray(he)){const le=[];for(const Xe of he)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&le.push(Xe)}catch{}return le}return this.defaultValue}}var rt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(498,null),c.localize(499,null),c.localize(500,null),c.localize(501,null)],description:c.localize(502,null),default:"same"}})}validate(he){switch(he){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(he,le,Xe){return le.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?rt.None:Xe}}class gt extends p{constructor(){super(je.wrappingInfo)}compute(he,le,Xe){const tt=le.get(je.layoutInfo);return{isDominatedByLongLines:he.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class dt extends w{constructor(){const he={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",he,{"editor.dropIntoEditor.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(503,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(504,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(505,null),c.localize(506,null)],default:"afterDrop"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showDropSelector:g(le.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const he={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",he,{"editor.pasteAs.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(507,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(508,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(509,null),c.localize(510,null)],default:"afterPaste"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showPasteSelector:g(le.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?Be:C.$l?Qe:Pe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var je;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.placeholder=88]="placeholder",ue[ue.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=90]="quickSuggestions",ue[ue.quickSuggestionsDelay=91]="quickSuggestionsDelay",ue[ue.readOnly=92]="readOnly",ue[ue.readOnlyMessage=93]="readOnlyMessage",ue[ue.renameOnType=94]="renameOnType",ue[ue.renderControlCharacters=95]="renderControlCharacters",ue[ue.renderFinalNewline=96]="renderFinalNewline",ue[ue.renderLineHighlight=97]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=99]="renderValidationDecorations",ue[ue.renderWhitespace=100]="renderWhitespace",ue[ue.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ue[ue.roundedSelection=102]="roundedSelection",ue[ue.rulers=103]="rulers",ue[ue.scrollbar=104]="scrollbar",ue[ue.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=106]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=107]="scrollPredominantAxis",ue[ue.selectionClipboard=108]="selectionClipboard",ue[ue.selectionHighlight=109]="selectionHighlight",ue[ue.selectOnLineNumbers=110]="selectOnLineNumbers",ue[ue.showFoldingControls=111]="showFoldingControls",ue[ue.showUnused=112]="showUnused",ue[ue.snippetSuggestions=113]="snippetSuggestions",ue[ue.smartSelect=114]="smartSelect",ue[ue.smoothScrolling=115]="smoothScrolling",ue[ue.stickyScroll=116]="stickyScroll",ue[ue.stickyTabStops=117]="stickyTabStops",ue[ue.stopRenderingLineAfter=118]="stopRenderingLineAfter",ue[ue.suggest=119]="suggest",ue[ue.suggestFontSize=120]="suggestFontSize",ue[ue.suggestLineHeight=121]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ue[ue.suggestSelection=123]="suggestSelection",ue[ue.tabCompletion=124]="tabCompletion",ue[ue.tabIndex=125]="tabIndex",ue[ue.unicodeHighlighting=126]="unicodeHighlighting",ue[ue.unusualLineTerminators=127]="unusualLineTerminators",ue[ue.useShadowDOM=128]="useShadowDOM",ue[ue.useTabStops=129]="useTabStops",ue[ue.wordBreak=130]="wordBreak",ue[ue.wordSegmenterLocales=131]="wordSegmenterLocales",ue[ue.wordSeparators=132]="wordSeparators",ue[ue.wordWrap=133]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=136]="wordWrapColumn",ue[ue.wordWrapOverride1=137]="wordWrapOverride1",ue[ue.wordWrapOverride2=138]="wordWrapOverride2",ue[ue.wrappingIndent=139]="wrappingIndent",ue[ue.wrappingStrategy=140]="wrappingStrategy",ue[ue.showDeprecated=141]="showDeprecated",ue[ue.inlayHints=142]="inlayHints",ue[ue.editorClassName=143]="editorClassName",ue[ue.pixelRatio=144]="pixelRatio",ue[ue.tabFocusMode=145]="tabFocusMode",ue[ue.layoutInfo=146]="layoutInfo",ue[ue.wrappingInfo=147]="wrappingInfo",ue[ue.defaultColorDecorators=148]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(511,null)})),acceptSuggestionOnEnter:Ne(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(512,null),""],markdownDescription:c.localize(513,null)})),accessibilitySupport:Ne(new I),accessibilityPageSize:Ne(new o(je.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(514,null),tags:["accessibility"]})),ariaLabel:Ne(new l(je.ariaLabel,"ariaLabel",c.localize(515,null))),ariaRequired:Ne(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(516,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(517,null),c.localize(518,null),""],description:c.localize(519,null)})),autoClosingComments:Ne(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(520,null),c.localize(521,null),""],description:c.localize(522,null)})),autoClosingDelete:Ne(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(523,null),""],description:c.localize(524,null)})),autoClosingOvertype:Ne(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(525,null),""],description:c.localize(526,null)})),autoClosingQuotes:Ne(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(527,null),c.localize(528,null),""],description:c.localize(529,null)})),autoIndent:Ne(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[c.localize(530,null),c.localize(531,null),c.localize(532,null),c.localize(533,null),c.localize(534,null)],description:c.localize(535,null)})),automaticLayout:Ne(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(536,null),c.localize(537,null),c.localize(538,null),""],description:c.localize(539,null)})),bracketPairColorization:Ne(new Te),bracketPairGuides:Ne(new He),stickyTabStops:Ne(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(540,null)})),codeLens:Ne(new s(je.codeLens,"codeLens",!0,{description:c.localize(541,null)})),codeLensFontFamily:Ne(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(542,null)})),codeLensFontSize:Ne(new o(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(543,null)})),colorDecorators:Ne(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(544,null)})),colorDecoratorActivatedOn:Ne(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(545,null),c.localize(546,null),c.localize(547,null)],description:c.localize(548,null)})),colorDecoratorsLimit:Ne(new o(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(549,null)})),columnSelection:Ne(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(550,null)})),comments:Ne(new A),contextmenu:Ne(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(551,null)})),cursorBlinking:Ne(new D(je.cursorBlinking,"cursorBlinking",$.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(552,null)})),cursorSmoothCaretAnimation:Ne(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(553,null),c.localize(554,null),c.localize(555,null)],description:c.localize(556,null)})),cursorStyle:Ne(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:c.localize(557,null)})),cursorSurroundingLines:Ne(new o(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(558,null)})),cursorSurroundingLinesStyle:Ne(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(559,null),c.localize(560,null)],markdownDescription:c.localize(561,null)})),cursorWidth:Ne(new o(je.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(562,null)})),disableLayerHinting:Ne(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(563,null)})),emptySelectionClipboard:Ne(new B),dropIntoEditor:Ne(new dt),stickyScroll:Ne(new q),experimentalWhitespaceRendering:Ne(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(564,null),c.localize(565,null),c.localize(566,null)],description:c.localize(567,null)})),extraEditorClassName:Ne(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:c.localize(568,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(je.folding,"folding",!0,{description:c.localize(569,null)})),foldingStrategy:Ne(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(570,null),c.localize(571,null)],description:c.localize(572,null)})),foldingHighlight:Ne(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(573,null)})),foldingImportsByDefault:Ne(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(574,null)})),foldingMaximumRegions:Ne(new o(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(575,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(576,null)})),fontFamily:Ne(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(577,null)})),fontInfo:Ne(new ee),fontLigatures2:Ne(new U),fontSize:Ne(new V),fontWeight:Ne(new W),fontVariations:Ne(new z),formatOnPaste:Ne(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(578,null)})),formatOnType:Ne(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(579,null)})),glyphMargin:Ne(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(580,null)})),gotoLocation:Ne(new J),hideCursorInOverviewRuler:Ne(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(581,null)})),hover:Ne(new _),inDiffEditor:Ne(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>d.clamp(ue,-5,20),{description:c.localize(582,null)})),lightbulb:Ne(new Y),lineDecorationsWidth:Ne(new ve),lineHeight:Ne(new ie),lineNumbers:Ne(new Ae),lineNumbersMinChars:Ne(new o(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(583,null)})),links:Ne(new s(je.links,"links",!0,{description:c.localize(584,null)})),matchBrackets:Ne(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(585,null)})),minimap:Ne(new ae),mouseStyle:Ne(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:c.localize(586,null)})),mouseWheelZoom:Ne(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?c.localize(587,null):c.localize(588,null)})),multiCursorMergeOverlapping:Ne(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(589,null)})),multiCursorModifier:Ne(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[c.localize(590,null),c.localize(591,null)],markdownDescription:c.localize(592,null)})),multiCursorPaste:Ne(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(593,null),c.localize(594,null)],markdownDescription:c.localize(595,null)})),multiCursorLimit:Ne(new o(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(596,null)})),occurrencesHighlight:Ne(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(597,null),c.localize(598,null),c.localize(599,null)],markdownDescription:c.localize(600,null)})),overviewRulerBorder:Ne(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(601,null)})),overviewRulerLanes:Ne(new o(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new X),pasteAs:Ne(new ct),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(602,null),c.localize(603,null)],description:c.localize(604,null)})),placeholder:Ne(new we),definitionLinkOpensInPeek:Ne(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(605,null)})),quickSuggestions:Ne(new Me),quickSuggestionsDelay:Ne(new o(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(606,null)})),readOnly:Ne(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new H),renameOnType:Ne(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(607,null),markdownDeprecationMessage:c.localize(608,null)})),renderControlCharacters:Ne(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(609,null),restricted:!0})),renderFinalNewline:Ne(new E(je.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(610,null)})),renderLineHighlight:Ne(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(611,null)],description:c.localize(612,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(613,null)})),renderValidationDecorations:Ne(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(614,null),c.localize(615,null),c.localize(616,null),""],description:c.localize(617,null)})),revealHorizontalRightPadding:Ne(new o(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(618,null)})),rulers:Ne(new Ce),scrollbar:Ne(new Z),scrollBeyondLastColumn:Ne(new o(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(619,null)})),scrollBeyondLastLine:Ne(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(620,null)})),scrollPredominantAxis:Ne(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(621,null)})),selectionClipboard:Ne(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(622,null),included:C.$l})),selectionHighlight:Ne(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(623,null)})),selectOnLineNumbers:Ne(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(624,null),c.localize(625,null),c.localize(626,null)],description:c.localize(627,null)})),showUnused:Ne(new s(je.showUnused,"showUnused",!0,{description:c.localize(628,null)})),showDeprecated:Ne(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(629,null)})),inlayHints:Ne(new oe),snippetSuggestions:Ne(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(630,null),c.localize(631,null),c.localize(632,null),c.localize(633,null)],description:c.localize(634,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(635,null)})),stopRenderingLineAfter:Ne(new o(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new et),inlineSuggest:Ne(new de),inlineEdit:Ne(new Ee),inlineCompletionsAccessibilityVerbose:Ne(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(636,null)})),suggestFontSize:Ne(new o(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(637,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(638,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(639,null)})),suggestSelection:Ne(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(640,null),c.localize(641,null),c.localize(642,null)],description:c.localize(643,null)})),tabCompletion:Ne(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(644,null),c.localize(645,null),c.localize(646,null)],description:c.localize(647,null)})),tabIndex:Ne(new o(je.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new x),unusualLineTerminators:Ne(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(648,null),c.localize(649,null),c.localize(650,null)],description:c.localize(651,null)})),useShadowDOM:Ne(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(652,null)})),wordBreak:Ne(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(653,null),c.localize(654,null)],description:c.localize(655,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new l(je.wordSeparators,"wordSeparators",b.$pt,{description:c.localize(656,null)})),wordWrap:Ne(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(657,null),c.localize(658,null),c.localize(659,null),c.localize(660,null)],description:c.localize(661,null)})),wordWrapBreakAfterCharacters:Ne(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(je.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(662,null)})),wordWrapOverride1:Ne(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new F),defaultColorDecorators:Ne(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(663,null)})),pixelRatio:Ne(new pe),tabFocusMode:Ne(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(664,null)})),layoutInfo:Ne(new ne),wrappingInfo:Ne(new gt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new ye)}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[217],Ie([1,0,22,43,8,5,107,10,24]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$dx=e.$cx=e.$bx=void 0,e.$ex=P,e.$fx=w,h=Ut(h),e.$bx=(0,R.$Gi)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class k{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,p){const f=[];switch(p){case c.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(1689,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(1690,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,C.localize)(1691,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,C.localize)(1692,null))),f.length===0&&f.push((0,C.localize)(1693,null));break}case c.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(1694,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(1695,null));break}}return f}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,p,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[p]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.$cx=k,e.$dx=(0,R.$Gi)("fileDialogService");var y;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const u=10;function P(a){const m=[];return m.push(...a.slice(0,u).map(p=>typeof p=="string"?p:(0,r.$eh)(p))),a.length>u&&(a.length-u===1?m.push((0,C.localize)(1696,null)):m.push((0,C.localize)(1697,null,a.length-u))),m.push(""),m.join(`
`)}function w(a,m){const p=(0,b.$fo)(a);let f=(p.buttons??[]).map(o=>(0,T.$$w)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=p.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(O.$l||O.$k){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}O.$l&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(O.$j&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return p.buttons=f,p.defaultId=s,p.cancelId=t,p.noLink=!0,p.title=p.title||m.nameLong,{options:p,buttonIndeces:i}}}),define(ke[146],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,r.$Gi)("environmentService"),e.$Oi=(0,r.$Hi)(e.$Ni)}),define(ke[218],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0,e.$30b=(0,r.$Gi)("externalTerminal"),e.$40b="Terminal.app"}),define(ke[219],Ie([1,0,56,59,14,16,10,104,33,109,8,218]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=void 0,r=We(r),R=We(R),T=We(T),b=We(b),c=We(c),k=We(k);const u=k.localize(1842,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,c.$zm(),o)}spawnTerminal(t,o,n,d){const l=o.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=R.$oc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push(l),E.push(l),g==="wt"&&E.push("-d ."),new Promise((D,S)=>{const I=p(process),A=t.spawn(n,E,{cwd:d,env:I,detached:!0});A.on("error",S),A.on("exit",()=>D())})}async runInTerminal(t,o,n,d,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((D,S)=>{const I=`"${o} - ${u}"`,A=`"${n.join('" "')}" & pause`,$=Object.assign({},p(process),d);Object.keys($).filter(F=>$[F]===null).forEach(F=>delete $[F]);const v={cwd:o,env:$,windowsVerbatimArguments:!0};let M,N;R.$oc(g,".exe")==="wt"?(M=g,N=["-d",".",w.b,"/c",A]):E?(M=E,N=["-d",".",g,"/c",A]):(M=w.b,N=["/c","start",I,"/wait",g,"/c",`"${A}"`]),r.spawn(M,N,v).on("error",F=>{S(f(F))}),D(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$Tgc=w,Ze([h.$$h],w,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.osxExec||y.$40b;return new Promise((E,D)=>{if(g===y.$40b||g==="iTerm.app"){const S=g===y.$40b?"TerminalHelper":"iTermHelper",A=[C.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",t||u,"-w",o];for(const M of n)A.push("-a"),A.push(M);if(d){const M=Object.assign({},p(process),d);for(const N in M){const L=M[N];L===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${L}`))}}let $="";const v=r.spawn(a.b,A);v.on("error",M=>{D(f(M))}),v.stderr.on("data",M=>{$+=M.toString()}),v.on("exit",M=>{if(M===0)E(void 0);else if($){const N=$.split(`
`,1);D(new Error(N[0]))}else D(new Error(k.localize(1843,null,S,M)))})}else D(new Error(k.localize(1844,null,g)))})}spawnTerminal(t,o,n){const d=o.osxExec||y.$40b;return new Promise((l,g)=>{const E=["-a",d];n&&E.push(n);const D=p(process),S=t.spawn("/usr/bin/open",E,{cwd:n,env:D});S.on("error",g),S.on("exit",()=>l())})}}e.$Ugc=a;class m extends P{static{this.b=k.localize(1845,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,D)=>{const S=[];g.then(I=>{I.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const A=`${i(n)}; echo; read -p "${m.b}" -n1;`;S.push(`''${A}''`);const $=Object.assign({},p(process),d);Object.keys($).filter(L=>$[L]===null).forEach(L=>delete $[L]);const v={cwd:o,env:$};let M="";const N=r.spawn(I,S,v);N.on("error",L=>{D(f(L))}),N.stderr.on("data",L=>{M+=L.toString()}),N.on("exit",L=>{if(L===0)E(void 0);else if(M){const F=M.split(`
`,1);D(new Error(F[0]))}else D(new Error(k.localize(1846,null,I,L)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!T.$l)m.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");m.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m.d}spawnTerminal(t,o,n){const d=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{d.then(E=>{const D=p(process),S=t.spawn(E,[],{cwd:n,env:D});S.on("error",g),S.on("exit",()=>l())})})}}e.$Vgc=m;function p(s){const t={...s.env};return(0,O.$mm)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(k.localize(1847,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(ke[27],Ie([1,0,84,16,12,17,2,8,5,10,14,50]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Gl=e.FileKind=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.FileOperationResult=e.$yl=e.$xl=e.$wl=e.$ul=e.FileChangeType=e.$tl=e.FileOperation=e.$nl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$bl=void 0,e.$cl=u,e.$dl=m,e.$el=f,e.$fl=i,e.$gl=s,e.$hl=t,e.$il=o,e.$jl=n,e.$kl=d,e.$ll=l,e.$ml=g,e.$ol=S,e.$pl=I,e.$ql=A,e.$rl=$,e.$sl=v,e.$vl=B,e.$Hl=W,e.$Il=J,e.$Kl=ce,e.$bl=(0,b.$Gi)("fileService");function u(ne){return ne.create===!0}var P;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(ne){const ye=ne;return!!ye&&typeof ye.onDidChange=="function"}var p;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function f(ne){return!!(ne.capabilities&p.FileReadWrite)}function i(ne){return!!(ne.capabilities&p.FileFolderCopy)}function s(ne){return!!(ne.capabilities&p.FileClone)}function t(ne){return!!(ne.capabilities&p.FileOpenReadWriteClose)}function o(ne){return!!(ne.capabilities&p.FileReadStream)}function n(ne){return f(ne)?!!(ne.capabilities&p.FileAtomicRead):!1}function d(ne){return f(ne)?!!(ne.capabilities&p.FileAtomicWrite):!1}function l(ne){return!!(ne.capabilities&p.FileAtomicDelete)}function g(ne){return!!(ne.capabilities&p.Readonly)}var E;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ye,ge){const Y=new D(ye.toString(),ge);return A(Y,ge),Y}constructor(ye,ge){super(ye),this.code=ge}}e.$nl=D;function S(ne,ye){return D.create(ne,ye)}function I(ne){return ne||S((0,O.localize)(1856,null),E.Unknown)}function A(ne,ye){return ne.name=ye?`${ye} (FileSystemError)`:"FileSystemError",ne}function $(ne){if(!ne)return E.Unknown;if(ne instanceof D)return ne.code;const ye=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!ye)return E.Unknown;switch(ye[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(ne){if(ne instanceof j)return ne.fileOperationResult;switch($(ne)){case E.FileNotFound:return ee.FILE_NOT_FOUND;case E.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case E.NoPermissions:return ee.FILE_PERMISSION_DENIED;case E.FileExists:return ee.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var M;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(ye,ge,Y){this.resource=ye,this.operation=ge,this.target=Y}isOperation(ye){return this.operation===ye}}e.$tl=N;var L;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class F{static{this.a=null}constructor(ye,ge){this.c=ge,this.b=void 0,this.d=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ye){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==F.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ye,...ge){return this.h(ye,{includeChildren:!1},...ge)}affects(ye,...ge){return this.h(ye,{includeChildren:!0},...ge)}h(ye,ge,...Y){if(!ye)return!1;const q=Y.length>0;return!!((!q||Y.includes(L.ADDED))&&(this.d.value.get(ye)||ge.includeChildren&&this.d.value.findSuperstr(ye))||(!q||Y.includes(L.UPDATED))&&(this.f.value.get(ye)||ge.includeChildren&&this.f.value.findSuperstr(ye))||(!q||Y.includes(L.DELETED))&&(this.g.value.findSubstr(ye)||ge.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$ul=F;function B(ne,ye,ge){return!ne||!ye||ne===ye||ye.length>ne.length?!1:(ye.charAt(ye.length-1)!==h.sep&&(ye+=h.sep),ge?(0,C.$Hf)(ne,ye):ne.indexOf(ye)===0)}class j extends Error{constructor(ye,ge,Y){super(ye),this.fileOperationResult=ge,this.options=Y}}e.$wl=j;class U extends j{constructor(ye,ge,Y,q){super(ye,ge,q),this.fileOperationResult=ge,this.size=Y}}e.$xl=U;class z extends j{constructor(ye,ge,Y){super(ye,ee.FILE_NOT_MODIFIED_SINCE,Y),this.stat=ge}}e.$yl=z;var ee;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bl="files.associations",e.$Cl="files.exclude",e.$Dl="files.readonlyInclude",e.$El="files.readonlyExclude",e.$Fl="files.readonlyFromPermissions";var V;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Gl="";function W(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function J(ne,ye){if(!ye.hasProvider(T.URI.from({scheme:ne.scheme})))return new Promise(ge=>{const Y=ye.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===ne.scheme&&q.added&&(Y.dispose(),ge())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(ye){return(0,R.$jg)(ye)||(ye=0),ye<_.KB?(0,O.localize)(1857,null,ye.toFixed(0)):ye<_.MB?(0,O.localize)(1858,null,(ye/_.KB).toFixed(2)):ye<_.GB?(0,O.localize)(1859,null,(ye/_.MB).toFixed(2)):ye<_.TB?(0,O.localize)(1860,null,(ye/_.GB).toFixed(2)):(0,O.localize)(1861,null,(ye/_.TB).toFixed(2))}}e.$Jl=_;function ce(ne){const ye=typeof ne=="string"||ne?.scheme===k.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===k.Schemas.file?1024*_.MB:ye?10*_.MB:c.$p?50*_.MB:1024*_.MB}}),define(ke[220],Ie([1,0,21,13,8,27]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=T;async function T(k,y,u,P,w,a){let m;try{await O(k,y,u,P,w,a)}catch(p){m=p}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function O(k,y,u,P,w,a){b(a);const m=await k.open(y,{create:!1});try{b(a);let p=0,f=0,i=w&&typeof w.length=="number"?w.length:void 0,s=r.$Oe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,o=0;do f=await k.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,p+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(P(s)),s=r.$Oe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&b(a)&&c(p,w));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(P(s.slice(0,n)))}}catch(p){throw(0,R.$pl)(p)}finally{await k.close(m)}}function b(k){if(k.isCancellationRequested)throw(0,h.$6)();return!0}function c(k,y){if(typeof y?.limits?.size=="number"&&k>y.limits.size)throw(0,R.$ol)((0,C.localize)(1889,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[69],Ie([1,0,38,3,16,10,2,27]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=void 0,e.$7q=b,e.$8q=c,e.$_q=P,e.$ar=w,e.$br=a,e.$cr=m,e.$dr=f,e.$er=i;function b(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class k extends h.$Vc{static{this.a=5}constructor(t,o,n,d){super(),this.h=t,this.j=o,this.m=n,this.n=d,this.c=this.B(new h.$Wc),this.f=void 0,this.g=0}s(){const t=new h.$Uc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<k.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$9q=k;class y extends k{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.$0q=y;class u extends k{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.$$q=u;function P(s){return s.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function w(s){const t=new p;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.$xk)&&!(0,C.$jc)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.$Bk)(a(s,n)));return o}class p{constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let n=!1;if(o){const d=o.type,l=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===O.FileChangeType.DELETED||t.type===O.FileChangeType.ADDED)?n=!0:d===O.FileChangeType.ADDED&&l===O.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):d===O.FileChangeType.DELETED&&l===O.FileChangeType.ADDED?o.type=O.FileChangeType.UPDATED:d===O.FileChangeType.ADDED&&l===O.FileChangeType.UPDATED||(o.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(n=>n.type!==O.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>o.some(d=>(0,O.$vl)(n.resource.fsPath,d,!R.$l))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case O.FileChangeType.ADDED:return(t&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(t&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(t&O.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&O.FileChangeFilter.ADDED&&t.push("Added"),s&O.FileChangeFilter.DELETED&&t.push("Deleted"),s&O.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ke[221],Ie([1,0,45,3,69,4,27,2,7]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class c extends h.$Vc{constructor(){super(),this.a=this.B(new R.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$5c),this.m=new Set,this.n=this.B(new b.$Eh(this.y())),this.r=5007,this.s=new b.$4h,this.R=!1,this.B(this.f(y=>this.t(y)))}t(y){this.u(y)&&this.z(y)}u(y){return(0,C.$7q)(y)}async watch(y){this.s.isSettled||this.s.complete(),this.s=new b.$4h;try{this.h.clear(),this.g.clear();for(const u of y)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(y){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),y?this.y():0)}y(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async z(y){if(this.j.has(y.correlationId))return;const u=new h.$Uc;this.j.set(y.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(y,u),this.w(!0))}C(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.w(!1)}D(y,u){this.F(y,u)?(this.P(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.G(y,u),this.m.add(y.correlationId))}F(y,u){const P=this.O?.subscribe(y.path,(w,a)=>{u.isDisposed||(w?this.D(y,u):a?.type===T.FileChangeType.ADDED&&this.H(y))});return P?(u.add(P),!0):!1}G(y,u){let P=!1;const w=(a,m)=>{if(u.isDisposed)return;const p=this.I(a),f=this.I(m),i=P;P=p,!p&&(f||i)&&this.H(y)};this.P(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.watchFile)(y.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}u.add((0,h.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.unwatchFile)(y.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}H(y){this.P(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const u={resource:O.URI.file(y.path),type:T.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([u]),this.J(u,y),this.C(y)}I(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(y,u){if(this.R){const P=` >> normalized ${y.type===T.FileChangeType.ADDED?"[ADDED]":y.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.L(P,u)}}L(y,u){this.R&&this.P(`${y}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,C.$er)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.R=y}}e.$nr=c}),define(ke[222],Ie([1,0,45,7,20,31,3,81,16,10,22,2,108,33,27,69]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0,e.$tr=p;class m extends T.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,s,t,o,n,d){super(),this.s=i,this.t=s,this.u=t,this.w=o,this.y=n,this.z=d,this.c=this.B(new h.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Uh(l=>this.M(l),m.b)),this.g=(0,a.$cr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$cr)(this.s.path,this.s.includes):void 0,this.j=(0,a.$7q)(this.s)?this.s.filter:void 0,this.m=new C.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let s=i.path;try{s=await P.Promises.realpath(i.path),i.path===s&&(s=await(0,u.$pr)(i.path,this.m.token)??i.path),i.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async G(i,s){const t=new T.$Uc;return this.H(i,s,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,s,t)),t}H(i,s,t){if(s)return!1;const o=y.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const g=await this.G(i,s);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,s,t){if(c.$k&&(0,R.$Fg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new C.$xe(this.m.token);t.add((0,T.$Tc)(()=>o.dispose(!0)));const n=new T.$Uc;t.add(n);try{const d=y.URI.file(this.s.path),l=(0,b.$oc)(i),g=(0,r.watch)(i);n.add((0,T.$Tc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(s)try{for(const S of await P.Promises.readdir(i))E.add(S)}catch(S){this.O(S)}if(o.token.isCancellationRequested)return;const D=new Map;n.add((0,T.$Tc)(()=>{for(const[,S]of D)S.dispose();D.clear()})),g.on("error",(S,I)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${S}, ${I})`),this.D())}),g.on("change",(S,I)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${S}"] ${I}`);let A="";if(I&&(A=I.toString(),c.$k&&(A=(0,O.$om)(A))),!(!A||S!=="change"&&S!=="rename"))if(s)if(S==="rename"){D.get(A)?.dispose();const $=setTimeout(async()=>{if(D.delete(A),A===l&&!await P.Promises.exists(i)){this.J(d);return}if(o.token.isCancellationRequested)return;const v=await this.N((0,b.$kc)(i,A));if(o.token.isCancellationRequested)return;let M;v?E.has(A)?M=w.FileChangeType.UPDATED:(M=w.FileChangeType.ADDED,E.add(A)):(E.delete(A),M=w.FileChangeType.DELETED),this.L({resource:(0,k.$hh)(d,A),type:M,cId:this.s.correlationId})},m.a);D.set(A,(0,T.$Tc)(()=>clearTimeout($)))}else{let $;E.has(A)?$=w.FileChangeType.UPDATED:($=w.FileChangeType.ADDED,E.add(A)),this.L({resource:(0,k.$hh)(d,A),type:$,cId:this.s.correlationId})}else if(S==="rename"||A!==l){const $=setTimeout(async()=>{const v=await P.Promises.exists(i);o.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},m.a);n.clear(),n.add((0,T.$Tc)(()=>clearTimeout($)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const s=(0,a.$ar)(i),t=[];for(const n of s){if((0,a.$dr)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const s=(0,b.$oc)(i);return(await P.Promises.readdir((0,b.$nc)(i))).some(o=>o===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$sr=m;async function p(f,i,s,t,o=512){const n=await P.Promises.open(f,"r"),d=Buffer.allocUnsafe(o),l=new C.$xe(t);let g,E=!1;const D={path:f,excludes:[],recursive:!1},S=new m(D,void 0,I=>{(async()=>{for(const{type:A}of I)if(A===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:$}=await P.Promises.read(n,d,0,o,null);if(!$||l.token.isCancellationRequested)break;i(d.slice(0,$))}}catch($){g=new Error($),l.dispose(!0)}finally{E=!1}}})()});return await S.ready,s(),new Promise((I,A)=>{l.token.onCancellationRequested(async()=>{S.dispose();try{await P.Promises.close(n)}catch($){g=new Error($)}g?A(g):I()})})}}),define(ke[223],Ie([1,0,4,38,221,10,222,31]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class b extends C.$nr{constructor(k){super(),this.O=k,this.onDidError=r.Event.None,this.watchers=new Set}async N(k){k=this.Z(k);const y=[],u=new Set(Array.from(this.watchers));for(const P of k){const w=this.W(P);w&&(0,h.$Fk)(w.request.excludes,P.excludes)&&(0,h.$Fk)(w.request.includes,P.includes)?u.delete(w):y.push(P)}y.length&&this.P(`Request to start watching: ${y.map(P=>this.M(P)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(P=>this.M(P.request)).join(",")}`);for(const P of u)this.Y(P);for(const P of y)this.X(P)}W(k){for(const y of this.watchers)if(typeof k.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===k.correlationId)return y}else if((0,O.$Eg)(y.request.path,k.path,!R.$l))return y}X(k){const y=new T.$sr(k,this.O,P=>this.a.fire(P),()=>this.c.fire(k),P=>this.b.fire(P),this.R),u={request:k,instance:y};this.watchers.add(u)}async stop(){await super.stop();for(const k of this.watchers)this.Y(k)}Y(k){this.P("stopping file watcher",k),this.watchers.delete(k),k.instance.dispose()}Z(k){const y=new Map;for(const u of k){const P=R.$l?u.path:u.path.toLowerCase();let w=y.get(u.correlationId);w||(w=new Map,y.set(u.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(P,u)}return Array.from(y.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(k){super.setVerboseLogging(k);for(const y of this.watchers)y.instance.setVerboseLogging(k)}P(k,y){this.R&&this.b.fire({type:"trace",message:this.bb(k,y)})}Q(k){this.b.fire({type:"warn",message:this.bb(k)})}bb(k,y){return y?`[File Watcher (node.js)] ${k} (${this.M(y.request)})`:`[File Watcher (node.js)] ${k}`}}e.$ur=b}),define(ke[224],Ie([1,0,69,223]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class C extends r.$0q{constructor(T,O,b){super(T,O,b),this.s()}r(T){return T.add(new h.$ur(void 0))}}e.$vr=C}),define(ke[225],Ie([1,0,14,86,193,69]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class T extends R.$$q{constructor(b,c,k){super(b,c,k),this.s()}r(b){const c=b.add(new C.$lr(r.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(c.onDidProcessExit(({code:k,signal:y})=>this.t(`terminated by itself with code ${k}, signal: ${y} (ETERM)`))),h.ProxyChannel.toService((0,h.$ni)(c.getChannel("watcher")))}}e.$mr=T}),define(ke[114],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class r{constructor(...C){this.a=new Map;for(const[R,T]of C)this.set(R,T)}set(C,R){const T=this.a.get(C);return this.a.set(C,R),T}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ei=r}),define(ke[226],Ie([1,0,7,13,3,112,215,5,114,80]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;const k=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new b.$Ei,p=!1,f,i=k){this.i=m,this.j=p,this.k=f,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Fi,this),this._globalGraph=i?f?._globalGraph??new T.$yr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Qc)(this.h),this.h.clear();for(const m of this.g)(0,C.$Pc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,p){this.m();const f=this,i=new class extends u{dispose(){f.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),p?.add(i),i}invokeFunction(m,...p){this.m();const f=w.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$8)("service accessor is only valid during the invocation of its target method");const o=this.s(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...p)}finally{i=!0,f.stop()}}createInstance(m,...p){this.m();let f,i;return m instanceof R.$Di?(f=w.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat(p),f)):(f=w.traceCreation(this.l,m),i=this.o(m,p,f)),f.stop(),i}o(m,p=[],f){const i=O._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this.s(o.id,f);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${p.length} static arguments`);const o=t-p.length;o>0?p=p.concat(new Array(o)):p=p.slice(0,t)}return Reflect.construct(m,p.concat(s))}q(m,p){if(this.i.get(m)instanceof R.$Di)this.i.set(m,p);else if(this.k)this.k.q(m,p);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const p=this.i.get(m);return!p&&this.k?this.k.r(m):p}s(m,p){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const f=this.r(m);return f instanceof R.$Di?this.u(m,f,p.branch(m,!0)):(p.branch(m,!1),f)}u(m,p,f){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,p,f)}finally{this.t.delete(m)}}v(m,p,f){const i=new T.$yr(n=>n.id.toString());let s=0;const t=[{id:m,desc:p,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new y(i);for(const d of O._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof R.$Di){const g={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof R.$Di){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(m)}w(m,p,f=[],i,s){if(this.i.get(m)instanceof R.$Di)return this.x(m,p,f,i,s,this.g);if(this.k)return this.k.w(m,p,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}x(m,p,f=[],i,s,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(m);const n=new Map,d=new r.$Zh(()=>{const l=o.o(p,f,s);for(const[g,E]of n){const D=l[g];if(typeof D=="function")for(const S of E)S.disposable=D.apply(l,S.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let S=n.get(g);return S||(S=new c.$6c,n.set(g,S)),(A,$,v)=>{if(d.isInitialized)return d.value[g](A,$,v);{const M={listener:[A,$,v],disposable:void 0},N=S.push(M);return(0,C.$Tc)(()=>{N(),M.disposable?.dispose()})}}}if(g in l)return l[g];const E=d.value;let D=E[g];return typeof D!="function"||(D=D.bind(E),l[g]=D),D},set(l,g,E){return d.value[g]=E,!0},getPrototypeOf(l){return p.prototype}})}else{const o=this.o(p,f,s);return t.add(o),o}}y(m,p){if(p&&console.warn(m),this.j)throw new Error(m)}}e.$zr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,p){return m?new w(P.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,p){return m?new w(P.Creation,p.name):w.c}static{this.f=0}constructor(m,p){this.type=m,this.name=p,this.g=Date.now(),this.h=[]}branch(m,p){const f=new w(P.Branch,m.toString());return this.h.push([m,p,f]),f}stop(){const m=Date.now()-this.g;w.f+=m;let p=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[d,l,g]of t.h)if(l&&g){p=!0,o.push(`${n}CREATES -> ${d}`);const E=f(s+1,g);E&&o.push(E)}else o.push(`${n}uses -> ${d}`);return o.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||p)&&w.all.add(i.join(`
`))}}e.$Ar=w}),define(ke[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=a,e.log=p,e.$pk=D,e.$qk=S,e.$rk=I,e.$sk=A,r=We(r),e.$bk=(0,P.$Gi)("logService"),e.$ck=(0,P.$Gi)("loggerService");function w(){return new Date().toISOString()}function a($){return(0,k.$jg)($)}var m;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ek=m.Info;function p($,v,M){switch(v){case m.Trace:$.trace(M);break;case m.Debug:$.debug(M);break;case m.Info:$.info(M);break;case m.Warning:$.warn(M);break;case m.Error:$.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f($,v=!1){let M="";for(let N=0;N<$.length;N++){let L=$[N];if(L instanceof Error&&(L=(0,h.$rj)(L,v)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class i extends T.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new C.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$gk=i;class s extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...M){this.f(m.Trace)&&this.g(m.Trace,f([v,...M],!0))}debug(v,...M){this.f(m.Debug)&&this.g(m.Debug,f([v,...M]))}info(v,...M){this.f(m.Info)&&this.g(m.Info,f([v,...M]))}warn(v,...M){this.f(m.Warning)&&this.g(m.Warning,f([v,...M]))}error(v,...M){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,f(N))}else this.g(m.Error,f([v,...M]))}flush(){}}e.$hk=s;class t extends i{constructor(v=e.$ek){super(),this.setLevel(v),this.g=!b.$j}trace(v,...M){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...M):console.log(`[main ${w()}]`,v,...M))}debug(v,...M){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...M):console.log(`[main ${w()}]`,v,...M))}info(v,...M){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...M):console.log(`[main ${w()}]`,v,...M))}warn(v,...M){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...M):console.warn(`[main ${w()}]`,v,...M))}error(v,...M){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...M):console.error(`[main ${w()}]`,v,...M))}flush(){}}e.$ik=t;class o extends i{constructor(v=e.$ek,M=!0){super(),this.g=M,this.setLevel(v)}trace(v,...M){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...M):console.log(v,...M))}debug(v,...M){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...M):console.log(v,...M))}info(v,...M){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...M):console.log(v,...M))}warn(v,...M){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...M):console.log(v,...M))}error(v,...M){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...M):console.error(v,...M))}flush(){}}e.$jk=o;class n extends i{constructor(v,M=e.$ek){super(),this.g=v,this.setLevel(M)}trace(v,...M){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...M])}debug(v,...M){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...M])}info(v,...M){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...M])}warn(v,...M){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...M])}error(v,...M){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...M])}h(v){return typeof v=="string"?v:(0,h.$rj)(v,this.f(m.Trace))}flush(){}}e.$kk=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const M of this.g)M.setLevel(v);super.setLevel(v)}trace(v,...M){for(const N of this.g)N.trace(v,...M)}debug(v,...M){for(const N of this.g)N.debug(v,...M)}info(v,...M){for(const N of this.g)N.info(v,...M)}warn(v,...M){for(const N of this.g)N.warn(v,...M)}error(v,...M){for(const N of this.g)N.error(v,...M)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$lk=d;class l extends T.$Vc{constructor(v,M,N){if(super(),this.h=v,this.j=M,this.b=new O.$Bc,this.c=this.B(new C.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$me),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(v){return(0,k.$fg)(v)?[...this.b.values()].find(M=>M.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,M){const N=this.n(v),L=(0,k.$fg)(v)?v:M?.id??(0,R.$uj)(N.toString()).toString(16);let F=this.b.get(N)?.logger;const B=M?.logLevel==="always"?m.Trace:M?.logLevel;F||(F=this.s(N,B??this.getLogLevel(N)??this.h,{...M,id:L}));const j={logger:F,info:{resource:N,id:L,logLevel:B,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(j.info),this.b.set(N,j),F}n(v){return(0,k.$fg)(v)?(0,c.$hh)(this.j,`${v}.log`):v}setLogLevel(v,M){if(y.URI.isUri(v)){const N=v,L=M,F=this.b.get(N);F&&L!==F.info.logLevel&&(F.info.logLevel=L===this.h?void 0:L,F.logger?.setLevel(L),this.b.set(F.info.resource,F),this.f.fire([N,L]))}else{this.h=v;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,M){const N=this.m(v);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(v){let M;return v&&(M=this.b.get(v)?.info.logLevel),M??this.h}registerLogger(v){const M=this.b.get(v.resource);M?M.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const M=this.b.get(v);M&&(M.logger&&M.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=l;class g{constructor(){this.onDidChangeLogLevel=new C.$me().event}setLevel(v){}getLevel(){return m.Info}trace(v,...M){}debug(v,...M){}info(v,...M){}warn(v,...M){}error(v,...M){}critical(v,...M){}dispose(){}flush(){}}e.$nk=g;class E extends g{}e.$ok=E;function D($){if($.verbose)return m.Trace;if(typeof $.logLevel=="string"){const v=A($.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ek}function S($){switch($){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I($){switch($){case m.Trace:return{original:"Trace",value:r.localize(1950,null)};case m.Debug:return{original:"Debug",value:r.localize(1951,null)};case m.Info:return{original:"Info",value:r.localize(1952,null)};case m.Warning:return{original:"Warning",value:r.localize(1953,null)};case m.Error:return{original:"Error",value:r.localize(1954,null)};case m.Off:return{original:"Off",value:r.localize(1955,null)}}}function A($){switch($){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$tk=new u.$Xj("logLevel",S(m.Info))}),define(ke[227],Ie([1,0,18,7,13,4,31,3,16,69,11]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class y extends O.$Vc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new R.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Eh(0)),this.w=[],this.y=this.B(new h.$Eh(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Tb)(this.j,a);return this.r(),(0,O.$Tc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,C.$Z)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$_q)(w)),w=>this.G(w),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$8q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$8q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Tb)(this.w,a);return this.C(),(0,O.$Tc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,C.$Z)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$_q)(P)),P=>this.G(P),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,b.$ic)(P.fsPath)}J(P){const w=this.I(P);return(0,T.$Ig)(w)}}e.$fr=y}),define(ke[228],Ie([1,0,45,7,28,21,4,31,3,16,10,22,105,33,8,27,220,227,225,224]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class s extends p.$fr{static{this.L=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=T.Event.None,this.P=new C.$Bc(d=>y.$$g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,k.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:n,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(o));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await P.Promises.readdir(this.I(o),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,y.$hh)(o,l.name))).type:g=this.O(l),d.push([l.name,g])}catch(g){this.a.trace(g)}})),d}catch(n){throw this.hb(n)}}O(o,n){let d;return n?.dangling?d=a.FileType.Unknown:o.isFile()?d=a.FileType.File:o.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(o){const n=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Fh;return this.P.set(o,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(o)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(o,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),d=await this.Q(o));const l=this.I(o);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(o){s.L&&this.a.trace(o)}readFileStream(o,n,d){const l=(0,u.$Ce)(g=>R.$Oe.concat(g.map(E=>R.$Oe.wrap(E))).buffer);return(0,m.$5q)(this,o,l,g=>g.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(o,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(o)?this.U(o,(0,y.$hh)((0,y.$gh)(o),`${(0,y.$eh)(o)}${d.atomic.postfix}`),n,d):this.W(o,n,d)}async S(o){try{const n=this.I(o),{symbolicLink:d}=await P.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(o,n,d,l){const g=new b.$Uc;try{g.add(await this.Q(o)),g.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,o,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async W(o,n,d,l){let g;try{const E=this.I(o);if(!d.create||!d.overwrite){if(await P.Promises.exists(E)){if(!d.overwrite)throw(0,a.$ol)((0,w.localize)(1892,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$ol)((0,w.localize)(1893,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:d.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(E){throw await this.ib(o,E)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(o){s.$=o}async open(o,n,d){const l=this.I(o);let g;(0,a.$cl)(n)&&!d&&(g=await this.Q(o));let E;try{if((0,a.$cl)(n)&&n.unlock)try{const{stat:S}=await P.SymlinkSupport.stat(l);S.mode&128||await r.promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let D;if((0,a.$cl)(n)){if(k.$j)try{await r.promises.truncate(l,0),D="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}D||(D="w")}else D="r";E=await P.Promises.open(l,D)}catch(D){throw g?.dispose(),(0,a.$cl)(n)?await this.ib(o,D):this.hb(D)}if(this.X.set(E,0),(0,a.$cl)(n)&&this.Z.set(E,o),g){const D=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),D.dispose())}return E}async close(o){const n=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&s.$)try{await P.Promises.fdatasync(o)}catch(d){s.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(o)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(o)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.read(o,d,l,g,E)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(o,E,D)}return D}ab(o,n){return n===this.X.get(o)?null:n}bb(o,n,d){const l=this.X.get(o);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(o,l+d):this.X.delete(o)))}async write(o,n,d,l,g){return(0,h.$1h)(()=>this.cb(o,n,d,l,g),100,3)}async cb(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.write(o,d,l,g,E)).bytesWritten}catch(S){throw await this.ib(this.Z.get(o),S)}finally{this.bb(o,E,D)}return D}async mkdir(o){try{await r.promises.mkdir(this.I(o))}catch(n){throw this.hb(n)}}async delete(o,n){try{const d=this.I(o);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$kc)((0,c.$nc)(d),`${(0,c.$oc)(d)}${n.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:D}=await P.SymlinkSupport.stat(d);g=E.isDirectory()&&!D}catch{}if(g)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"move",d.overwrite),await P.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(1894,null,(0,c.$oc)(l),(0,c.$oc)((0,c.$nc)(g)),E.toString()))),this.hb(E)}}async copy(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"copy",d.overwrite),await P.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(1895,null,(0,c.$oc)(l),(0,c.$oc)((0,c.$nc)(g)),E.toString()))),this.hb(E)}}async db(o,n,d,l){const g=this.I(o),E=this.I(n);let D=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,O.$Eg)(g,E,!0)),D){if(d==="copy")throw(0,a.$ol)((0,w.localize)(1896,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const I=await this.N(o);if(!I)throw(0,a.$ol)((0,w.localize)(1897,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(n);if(A){if(!l)throw(0,a.$ol)((0,w.localize)(1898,null),a.FileSystemProviderErrorCode.FileExists);I.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.eb(o,n,!1)}async eb(o,n,d){const l=this.I(o),g=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Eg)(l,g,!E))return;const D=new b.$Uc;try{D.add(await this.Q(o)),D.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$nc)(g),{recursive:!0}),await r.promises.copyFile(l,g)}catch(S){if(S.code==="ENOENT"&&!d)return this.eb(o,n,!0);throw this.hb(S)}finally{D.dispose()}}t(o,n,d){return new f.$mr(l=>o(l),l=>n(l),d)}F(o,n,d){return new i.$vr(l=>o(l),l=>n(l),d)}hb(o){if(o instanceof a.$nl)return o;let n=o,d;switch(o.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$ol)(n,d)}async ib(o,n){let d=this.hb(n);if(o&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(o));l.mode&128||(d=(0,a.$ol)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$wr=s}),define(ke[229],Ie([1,0,3,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class C extends r.$Vc{constructor(T,O=[]){super(),this.a=new h.$lk([T,...O]),this.B(T.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...O){this.a.trace(T,...O)}debug(T,...O){this.a.debug(T,...O)}info(T,...O){this.a.info(T,...O)}warn(T,...O){this.a.warn(T,...O)}error(T,...O){this.a.error(T,...O)}flush(){this.a.flush()}}e.$OR=C}),define(ke[230],Ie([1,0,27,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function R(c,k,y,u,P){try{const w=await new Promise((m,p)=>{$e(["@vscode/spdlog"],m,p)}).then(We);w.setFlushOn(C.Trace);const a=await w.createAsyncRotatingLogger(c,k,y,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function T(c,k,y){switch(k){case h.LogLevel.Trace:c.trace(y);break;case h.LogLevel.Debug:c.debug(y);break;case h.LogLevel.Info:c.info(y);break;case h.LogLevel.Warning:c.warn(y);break;case h.LogLevel.Error:c.error(y);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function O(c,k){switch(k){case h.LogLevel.Trace:c.setLevel(C.Trace);break;case h.LogLevel.Debug:c.setLevel(C.Debug);break;case h.LogLevel.Info:c.setLevel(C.Info);break;case h.LogLevel.Warning:c.setLevel(C.Warning);break;case h.LogLevel.Error:c.setLevel(C.Error);break;case h.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${k}`)}}class b extends h.$hk{constructor(k,y,u,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(k,y,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&O(this.r,a)}))}async s(k,y,u,P){const w=u?6:1,a=30/w*r.$Jl.MB,m=await R(k,y,a,w,P);if(m){this.r=m,O(this.r,this.getLevel());for(const{level:p,message:f}of this.m)T(this.r,p,f);this.m=[]}}g(k,y){this.r?T(this.r,k,y):this.getLevel()<=k&&this.m.push({level:k,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DR=b});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[147],Ie([1,0,43,8,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Ut(r);var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(b){function c(w,a){return a-w}b.compare=c;const k=Object.create(null);k[b.Error]=(0,h.localize)(1956,null),k[b.Warning]=(0,h.localize)(1957,null),k[b.Info]=(0,h.localize)(1958,null);function y(w){return k[w]||""}b.toString=y;function u(w){switch(w){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=u;function P(w){switch(w){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=P}(T||(e.MarkerSeverity=T={}));var O;(function(b){const c="";function k(u){return y(u,!0)}b.makeKey=k;function y(u,P){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(T.toString(u.severity)):w.push(c),u.message&&P?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}b.makeKeyOptionalMessage=y})(O||(e.IMarkerData=O={})),e.$Ju=(0,C.$Gi)("markerService")});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[231],Ie([1,0,4,43,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$xw=e.Severity=void 0,e.$yw=O,h=Ut(h),e.Severity=h.default,e.$xw=(0,C.$Gi)("notificationService");var R;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function O(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var b;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class c{constructor(){this.progress=new k,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$zw=c;class k{infinite(){}done(){}total(u){}worked(u){}}e.$Aw=k}),define(ke[232],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const R=C.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ke[115],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,r.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(r,h){e(r,h,$e)}};define(ke[89],Ie([1,0,7,20,3,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.ProgressLocation=e.$Bw=void 0,e.$Bw=(0,R.$Gi)("progressService");var T;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$Cw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Dw=O;class b{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$Ew=b;let c=class extends C.$Vc{constructor(u,P){super(),this.a=new r.$4h,P.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Fw=c,e.$Fw=c=Ze([Ve(1,e.$Bw)],c);class k extends C.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Uc)}start(u){this.stop();const P=++this.a,w=new h.$xe;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Tc)(()=>w.cancel())),this.b.add((0,C.$Tc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Gw=k,e.$Hw=(0,R.$Gi)("editorProgressService")}),define(ke[36],Ie([1,0,65,17]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,r=We(r),h=We(h);class C{constructor(){this.a=new Map}add(T,O){r.ok(h.$fg(T)),r.ok(h.$hg(O)),r.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,O)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$so=new C}),define(ke[116],Ie([1,0,4,179,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,C=We(C),e.$to={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this.b=new r.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,k){this.a[R(c)]=k,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const k=this.a[c];return k?(0,h.$9j)(k):void 0}hasSchemaContent(c){return!!this.a[c]}}const O=new T;C.$so.add(e.$to.JSONContribution,O)}),define(ke[70],Ie([1,0,18,4,17,8,46,116,36]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=a,e.$Jo=m,e.$Ko=p,e.$Lo=i,e.$Mo=s,e.$No=t,e.$Oo=o,C=We(C),R=We(R);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$xo={Configuration:"base.contributions.configuration"};var k;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const y=b.$so.as(O.$to.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new h.$me,this.onDidSchemaChange=this.j.event,this.k=new h.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const g=new Set;this.r(d,l,g),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(d){const l=new Set;this.s(d,l),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const g=new Set;this.s(l,g),this.r(d,!1,g),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const g=[];for(const{overrides:E,source:D}of d)for(const S in E){l.add(S);const I=this.b.get(S)??this.b.set(S,{configurationDefaultOverrides:[]}).get(S),A=E[S];if(I.configurationDefaultOverrides.push({value:A,source:D}),e.$Ho.test(S)){const $=this.o(S,A,D,I.configurationDefaultOverrideValue);if(!$)continue;I.configurationDefaultOverrideValue=$,this.n(S,$,D),g.push(...a(S))}else{const $=this.p(S,A,D,I.configurationDefaultOverrideValue);if(!$)continue;I.configurationDefaultOverrideValue=$;const v=this.e[S];v&&(this.A(S,v),this.w(S,v))}}this.q(g)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const g of d){const E=this.a.indexOf(g);E!==-1&&this.a.splice(E,1)}for(const{overrides:g,source:E}of d)for(const D in g){const S=this.b.get(D);if(!S)continue;const I=S.configurationDefaultOverrides.findIndex(A=>E?A.source?.id===E.id:A.value===g[D]);if(I!==-1){if(S.configurationDefaultOverrides.splice(I,1),S.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Ho.test(D)){let A;for(const $ of S.configurationDefaultOverrides)A=this.o(D,$.value,$.source,A);A&&!C.$sg(A.value)?(S.configurationDefaultOverrideValue=A,this.n(D,A,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let A;for(const v of S.configurationDefaultOverrides)A=this.p(D,v.value,v.source,A);S.configurationDefaultOverrideValue=A;const $=this.e[D];$&&(this.A(D,$),this.w(D,$))}l.add(D)}}this.y()}n(d,l,g){const E={type:"object",default:l.value,description:R.localize(1654,null,(0,T.$kj)(d)),$ref:e.$Eo,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[d]=E,this.c.properties[d]=E}o(d,l,g,E){const D=E?.value||{},S=E?.source??new Map;if(!(S instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const I of Object.keys(l)){const A=l[I];if(C.$hg(A)&&(C.$mg(D[I])||C.$hg(D[I]))){if(D[I]={...D[I]??{},...A},g)for(const v in A)S.set(`${I}.${v}`,g)}else D[I]=A,g?S.set(I,g):S.delete(I)}return{value:D,source:S}}p(d,l,g,E){const D=this.e[d],S=E?.value??D?.defaultDefaultValue;let I=g;if(C.$hg(l)&&(D!==void 0&&D.type==="object"||D===void 0&&(C.$mg(S)||C.$hg(S)))){if(I=E?.source??new Map,!(I instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const $ in l)g&&I.set(`${d}.${$}`,g);l={...C.$hg(S)?S:{},...l}}return{value:l,source:I}}deltaConfiguration(d){let l=!1;const g=new Set;d.removedDefaults&&(this.m(d.removedDefaults,g),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,g),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,g),d.addedConfigurations&&this.r(d.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,g){d.forEach(E=>{this.u(E,l,E.extensionInfo,E.restrictedProperties,void 0,g),this.d.push(E),this.v(E)})}s(d,l){const g=E=>{if(E.properties)for(const D in E.properties){l.add(D);const S=this.e[D];S?.policy?.name&&this.f.delete(S.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>g(D))};for(const E of d){g(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(d,l=!0,g,E,D=k.WINDOW,S){D=C.$og(d.scope)?D:d.scope;const I=d.properties;if(I)for(const $ in I){const v=I[$];if(l&&i($,v)){delete I[$];continue}if(v.source=g,v.defaultDefaultValue=I[$].default,this.A($,v),e.$Ho.test($)?v.scope=void 0:(v.scope=C.$og(v.scope)?D:v.scope,v.restricted=C.$og(v.restricted)?!!E?.includes($):v.restricted),I[$].hasOwnProperty("included")&&!I[$].included){this.g[$]=I[$],delete I[$];continue}else this.e[$]=I[$],I[$].policy?.name&&this.f.set(I[$].policy.name,$);!I[$].deprecationMessage&&I[$].markdownDeprecationMessage&&(I[$].deprecationMessage=I[$].markdownDeprecationMessage),S.add($)}const A=d.allOf;if(A)for(const $ of A)this.u($,l,g,E,D,S)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&d.set(l,g.configurationDefaultOverrideValue);return d}v(d){const l=g=>{const E=g.properties;if(E)for(const S in E)this.w(S,E[S]);g.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$yo.properties[d]=l,l.scope){case k.APPLICATION:e.$zo.properties[d]=l;break;case k.MACHINE:e.$Ao.properties[d]=l;break;case k.MACHINE_OVERRIDABLE:e.$Bo.properties[d]=l;break;case k.WINDOW:e.$Co.properties[d]=l;break;case k.RESOURCE:e.$Do.properties[d]=l;break;case k.LANGUAGE_OVERRIDABLE:e.$Do.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$yo.properties[d],l.scope){case k.APPLICATION:delete e.$zo.properties[d];break;case k.MACHINE:delete e.$Ao.properties[d];break;case k.MACHINE_OVERRIDABLE:delete e.$Bo.properties[d];break;case k.WINDOW:delete e.$Co.properties[d];break;case k.RESOURCE:case k.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,g={type:"object",description:R.localize(1655,null),errorMessage:R.localize(1656,null),$ref:e.$Eo};this.A(l,g),e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g,e.$Co.properties[l]=g,e.$Do.properties[l]=g}}z(){const d={type:"object",description:R.localize(1657,null),errorMessage:R.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=d,e.$zo.patternProperties[e.$Go]=d,e.$Ao.patternProperties[e.$Go]=d,e.$Bo.patternProperties[e.$Go]=d,e.$Co.patternProperties[e.$Go]=d,e.$Do.patternProperties[e.$Go]=d,this.j.fire()}A(d,l){const g=this.b.get(d)?.configurationDefaultOverrideValue;let E,D;g&&(!l.disallowConfigurationDefault||!g.source)&&(E=g.value,D=g.source),C.$mg(E)&&(E=l.defaultDefaultValue,D=void 0),C.$mg(E)&&(E=p(l.type)),l.default=E,l.defaultValueSource=D}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Go=`^(${P})+$`,e.$Ho=new RegExp(e.$Go);function a(n){const d=[];if(e.$Ho.test(n)){let l=w.exec(n);for(;l?.length;){const g=l[1].trim();g&&d.push(g),l=w.exec(n)}}return(0,r.$Mb)(d)}function m(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function p(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;b.$so.add(e.$xo.Configuration,f);function i(n,d){return n.trim()?e.$Ho.test(n)?R.localize(1660,null,n):f.getConfigurationProperties()[n]!==void 0?R.localize(1661,null,n):d.policy?.name&&f.getPolicyConfigurations().get(d.policy?.name)!==void 0?R.localize(1662,null,n,d.policy?.name,f.getPolicyConfigurations().get(d.policy?.name)):null:R.localize(1659,null)}function s(){const n=[],d=f.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",k.RESOURCE]),n.push(["task",k.RESOURCE]),n}function t(n){const d={};for(const l of n){const g=l.properties;if(C.$hg(g))for(const E in g)d[E]=g[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function o(n){switch(n){case"application":return k.APPLICATION;case"machine":return k.MACHINE;case"resource":return k.RESOURCE;case"machine-overridable":return k.MACHINE_OVERRIDABLE;case"language-overridable":return k.LANGUAGE_OVERRIDABLE;default:return k.WINDOW}}}),define(ke[233],Ie([1,0,18,4,178,3,28,24,17,2,46,70,27,36]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=s,r=We(r),C=We(C),O=We(O),b=We(b);function w(d){return Object.isFrozen(d)?d:O.$go(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,g,E,D,S){this.b=l,this.c=g,this.d=E,this.raw=D,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof a)return g;const E=new m("",this.f);return E.parseRaw(g),E.configurationModel});this.g=l.reduce((g,E)=>E===g?E:g.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,k.$ij)(this.contents,l):this.contents}inspect(l,g){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return g?w(E.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return w(g?E.rawConfiguration.override(g).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:S,identifiers:I,keys:A}of E.rawConfiguration.overrides){const $=new a(S,A,[],void 0,E.f).getValue(l);$!==void 0&&D.push({identifiers:I,value:$})}return D.length?w(D):void 0}}}getOverrideValue(l,g){const E=this.j(g);return E?l?(0,k.$ij)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const E of this.overrides)E.identifiers.includes(l)&&g.push(...E.keys);return r.$Mb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return r.$Mb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=O.$fo(this.contents),E=O.$fo(this.overrides),D=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of l)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.i(g,I.contents);for(const A of I.overrides){const[$]=E.filter(v=>r.$ub(v.identifiers,A.identifiers));$?(this.i($.contents,A.contents),$.keys.push(...A.keys),$.keys=r.$Mb($.keys)):E.push(O.$fo(A))}for(const A of I.keys)D.indexOf(A)===-1&&D.push(A)}return new a(g,D,E,S.every(I=>I instanceof a)?void 0:S,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const E={};for(const D of r.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let S=this.contents[D];const I=g[D];I&&(typeof S=="object"&&typeof I=="object"?(S=O.$fo(S),this.i(S,I)):S=I),E[D]=S}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const E of Object.keys(g)){if(E in l&&b.$hg(l[E])&&b.$hg(g[E])){this.i(l[E],g[E]);continue}l[E]=O.$fo(g[E])}}j(l){let g=null,E=null;const D=S=>{S&&(E?this.i(E,S):E=O.$fo(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===l?g=S.contents:S.identifiers.includes(l)&&D(S.contents);return D(g),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,k.$hj)(this.contents,l),y.$Ho.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$ub(E.identifiers,(0,y.$Io)(l))),1))}k(l,g,E){if((0,k.$gj)(this.contents,l,g,D=>this.f.error(D)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),y.$Ho.test(l)){const D=(0,y.$Io)(l),S={identifiers:D,keys:Object.keys(this.contents[l]),contents:(0,k.$fj)(this.contents[l],A=>this.f.error(A))},I=this.overrides.findIndex(A=>r.$ub(A.identifiers,D));I!==-1?this.overrides[I]=S:this.overrides.push(S)}}}e.$Po=a;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!b.$og(l)){const E=this.h(l);this.parseRaw(E,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:E,keys:D,overrides:S,restricted:I,hasExcludedProperties:A}=this.i(l,g);this.b=new a(E,D,S,A?[l]:void 0,this.g),this.c=I||[]}h(l){let g={},E=null,D=[];const S=[],I=[];function A(v){Array.isArray(D)?D.push(v):E!==null&&(D[E]=v)}const $={onObjectBegin:()=>{const v={};A(v),S.push(D),D=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{D=S.pop()},onArrayBegin:()=>{const v=[];A(v),S.push(D),D=v,E=null},onArrayEnd:()=>{D=S.pop()},onLiteralValue:A,onError:(v,M,N)=>{I.push({error:v,offset:M,length:N})}};if(l)try{C.$7n(l,$),g=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return g}i(l,g){const E=P.$so.as(y.$xo.Configuration).getConfigurationProperties(),D=this.j(l,E,!0,g);l=D.raw;const S=(0,k.$fj)(l,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`)),I=Object.keys(l),A=this.l(l,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:S,keys:I,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,g,E,D){let S=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:S};const I={},A=[];for(const $ in l)if(y.$Ho.test($)&&E){const v=this.j(l[$],g,!1,D);I[$]=v.raw,S=S||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=g[$],M=v?typeof v.scope<"u"?v.scope:y.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push($),!D.exclude?.includes($)&&(D.include?.includes($)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&v?.restricted))?I[$]=l[$]:S=!0}return{raw:I,restricted:A,hasExcludedProperties:S}}l(l,g){const E=[];for(const D of Object.keys(l))if(y.$Ho.test(D)){const S={};for(const I in l[D])S[I]=l[D][I];E.push({identifiers:(0,y.$Io)(D),keys:Object.keys(S),contents:(0,k.$fj)(S,g)})}return E}}e.$Qo=m;class p extends R.$Vc{constructor(l,g,E,D,S){super(),this.c=l,this.f=g,this.g=D,this.h=S,this.b=this.B(new h.$me),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),S),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(u.FileOperation.CREATE)||I.isOperation(u.FileOperation.COPY)||I.isOperation(u.FileOperation.DELETE)||I.isOperation(u.FileOperation.WRITE))&&E.isEqual(I.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=p;class f{constructor(l,g,E,D,S,I,A,$,v,M,N,L,F){this.a=l,this.b=g,this.c=E,this.overrideIdentifiers=D,this.d=S,this.f=I,this.g=A,this.h=$,this.i=v,this.j=M,this.k=N,this.l=L,this.m=F}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,E,D,S,I,A,$,v,M){this.j=l,this.l=g,this.m=E,this.n=D,this.p=S,this.q=I,this.r=A,this.s=$,this.t=v,this.u=M,this.h=null,this.i=new T.$Bc,this.v=null}getValue(l,g,E){return this.w(l,g,E).getValue(l)}updateValue(l,g,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=a.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,g===void 0?D.removeValue(l):D.setValue(l,g),E.resource||(this.h=null)}inspect(l,g,E){const D=this.w(l,g,E),S=this.A(g.resource,E),I=g.resource?this.t.get(g.resource)||this.s:this.s,A=new Set;for(const $ of D.overrides)for(const v of $.identifiers)D.getOverrideValue(l,v)!==void 0&&A.add(v);return new f(l,g,D.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,S||void 0,I)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const E=[];if(!g){const{added:D,updated:S,removed:I}=o(this.j,l);g=[...D,...S,...I]}for(const D of g)for(const S of(0,y.$Io)(D)){const I=this.j.getKeysForOverrideIdentifier(S),A=l.getKeysForOverrideIdentifier(S),$=[...A.filter(v=>I.indexOf(v)===-1),...I.filter(v=>A.indexOf(v)===-1),...I.filter(v=>!O.$jo(this.j.override(S).getValue(v),l.override(S).getValue(v)))];E.push([S,$])}return this.updateDefaultConfiguration(l),{keys:g,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:E,removed:D}=o(this.l,l),S=[...g,...E,...D];return S.length&&this.updatePolicyConfiguration(l),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:E,removed:D,overrides:S}=o(this.applicationConfiguration,l),I=[...g,...E,...D];return I.length&&this.updateApplicationConfiguration(l),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:S}=o(this.localUserConfiguration,l),I=[...g,...E,...D];return I.length&&this.updateLocalUserConfiguration(l),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:S}=o(this.remoteUserConfiguration,l),I=[...g,...E,...D];return I.length&&this.updateRemoteUserConfiguration(l),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:E,removed:D,overrides:S}=o(this.workspaceConfiguration,l),I=[...g,...E,...D];return I.length&&this.updateWorkspaceConfiguration(l),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(l,g){const E=this.folderConfigurations.get(l),{added:D,updated:S,removed:I,overrides:A}=o(E,g),$=[...D,...S,...I];return($.length||!E)&&this.updateFolderConfiguration(l,g),{keys:$,overrides:A}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:D,removed:S,overrides:I}=o(g,void 0);return{keys:[...E,...D,...S],overrides:I}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,E){let D=this.x(g,E);return g.overrideIdentifier&&(D=D.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},g){let E=this.y();if(g&&l){const D=g.getFolder(l);D&&(E=this.z(D.uri)||E);const S=this.t.get(l);S&&(E=E.merge(S))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const E=this.y(),D=this.r.get(l);D?(g=E.merge(D),this.i.set(l,g)):g=E}return g}A(l,g){if(g&&l){const E=g.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:E,overrides:D,keys:S}=this.r.get(g);return l.push([g,{contents:E,overrides:D,keys:S}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(D=>g.add(D))),[...g.values()]}static parse(l,g){const E=this.E(l.defaults,g),D=this.E(l.policy,g),S=this.E(l.application,g),I=this.E(l.user,g),A=this.E(l.workspace,g),$=l.folders.reduce((v,M)=>(v.set(c.URI.revive(M[0]),this.E(M[1],g)),v),new T.$Bc);return new i(E,D,S,I,a.createEmptyModel(g),A,$,a.createEmptyModel(g),new T.$Bc,g)}static E(l,g){return new a(l.contents,l.keys,l.overrides,void 0,g)}}e.$So=i;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,g=new Map;for(const D of d)D.keys.forEach(S=>l.add(S)),D.overrides.forEach(([S,I])=>{const A=(0,T.$yc)(g,S,new Set);I.forEach($=>A.add($))});const E=[];return g.forEach((D,S)=>E.push([S,[...D.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,g,E,D,S){this.change=l,this.f=g,this.g=E,this.h=D,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const I of l.keys)this.affectedKeys.add(I);for(const[,I]of l.overrides)for(const A of I)this.affectedKeys.add(A);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const E=this.a+l,D=this.d.indexOf(E);if(D<0)return!1;const S=D+E.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(g){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,$=this.g.getValue(l,g,this.h);return!O.$jo(A,$)}return!0}}e.$Uo=t;function o(d,l){const{added:g,removed:E,updated:D}=n(l?.rawConfiguration,d?.rawConfiguration),S=[],I=d?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const $=A.filter(v=>!I.includes(v));for(const v of $)S.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const $=I.filter(v=>!A.includes(v));for(const v of $)S.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const $ of I)if(A.includes($)){const v=n({contents:d.getOverrideValue(void 0,$)||{},keys:d.getKeysForOverrideIdentifier($)},{contents:l.getOverrideValue(void 0,$)||{},keys:l.getKeysForOverrideIdentifier($)});S.push([$,[...v.added,...v.removed,...v.updated]])}}return{added:g,removed:E,updated:D,overrides:S}}function n(d,l){const g=d?l?d.keys.filter(S=>l.keys.indexOf(S)===-1):[...d.keys]:[],E=l?d?l.keys.filter(S=>d.keys.indexOf(S)===-1):[...l.keys]:[],D=[];if(d&&l){for(const S of l.keys)if(d.keys.indexOf(S)!==-1){const I=(0,k.$ij)(l.contents,S),A=(0,k.$ij)(d.contents,S);O.$jo(I,A)||D.push(S)}}return{added:g,removed:E,updated:D}}}),define(ke[234],Ie([1,0,21,4,3,68]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mxb=e.$Kxb=e.$Jxb=void 0,e.$Lxb=O;const T=(c,k,y)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$9e)(r.$Oe.wrap(u));return[`GET ws://localhost${c}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$Jxb=T,e.$Kxb=r.$Oe.fromString(`\r
\r
`);async function O(c,k,y,u,P){c.write(r.$Oe.fromString((0,e.$Jxb)(k,y,u)));const w=new C.$Uc;try{return await new Promise((a,m)=>{let p;w.add(c.onData(f=>{p?p=r.$Oe.concat([p,f],p.byteLength+f.byteLength):p=f;const i=p.indexOf(e.$Kxb);if(i===-1)return;a(c),c.pauseData();const s=p.slice(i+e.$Kxb.byteLength);s.byteLength&&P.onData.fire(s)})),w.add(c.onClose(f=>m(f??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class b extends C.$Vc{constructor(k,y){super(),this.g=k,this.a=this.B(new h.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(u=>this.a.fire(u))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(k,y){R.SocketDiagnostics.traceSocketEvent(this,this.g,k,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Mxb=b}),define(ke[71],Ie([1,0,13,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.RemoteAuthorityResolverErrorCode=e.$Ul=e.$Tl=e.RemoteConnectionType=e.$Sl=void 0,e.$Wl=c,e.$Sl=(0,h.$Gi)("remoteAuthorityResolverService");var C;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class R{constructor(y){this.id=y,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Tl=R;class T{constructor(y,u){this.host=y,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ul=T;var O;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class b extends r.$bb{static isNotAvailable(y){return y instanceof b&&y._code===O.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===O.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===O.NoResolverFound}static isInvalidAuthority(y){return y instanceof b&&y._code===O.InvalidAuthority}static isHandled(y){return y instanceof b&&y.isHandled}constructor(y,u=O.Unknown,P){super(y),this._message=y,this._code=u,this._detail=P,this.isHandled=u===O.NotAvailable&&P===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Vl=b;function c(k){const y=k.indexOf("+");return y===-1?k:k.substring(0,y)}}),define(ke[235],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$2l=S,e.$3l=I,e.$4l=$,c=We(c);const w=30*1e3;var a;(function(ge){ge[ge.Management=1]="Management",ge[ge.ExtensionHost=2]="ExtensionHost",ge[ge.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ge){switch(ge){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function p(ge){const Y=new C.$xe;return setTimeout(()=>Y.cancel(),ge),Y.token}function f(ge,Y){if(ge.isCancellationRequested||Y.isCancellationRequested)return C.CancellationToken.Cancelled;const q=new C.$xe;return ge.onCancellationRequested(()=>q.cancel()),Y.onCancellationRequested(()=>q.cancel()),q.token}class i{get didTimeout(){return this.c==="timedout"}constructor(Y){this.c="pending",this.d=new O.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$zh)(),Y.isCancellationRequested?this.h():this.d.add(Y.onCancellationRequested(()=>this.h()))}registerDisposable(Y){this.c==="pending"?this.d.add(Y):Y.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Y))}reject(Y){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Y))}}function s(ge,Y){const q=new i(Y);return q.registerDisposable(ge.onControlMessage(oe=>{const ve=JSON.parse(oe.toString()),ie=W(ve);ie?q.reject(ie):q.resolve(ve)})),q.promise}function t(ge,Y,q,oe,ve,ie,ae,se){const X=new i(se),re=k.$ge.create(!1);return ge.info(`Creating a socket (${ae})...`),c.mark(`code/willCreateSocket/${ie}`),Y.connect(q,oe,ve,ae).then(pe=>{X.didTimeout?(c.mark(`code/didCreateSocketError/${ie}`),ge.info(`Creating a socket (${ae}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${ie}`),ge.info(`Creating a socket (${ae}) was successful after ${re.elapsed()} ms.`),X.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${ie}`),ge.info(`Creating a socket (${ae}) returned an error after ${re.elapsed()} ms.`),ge.error(pe),X.reject(pe)}),X.promise}function o(ge,Y){const q=new i(Y);return ge.then(oe=>{q.didTimeout||q.resolve(oe)},oe=>{q.didTimeout||q.reject(oe)}),q.promise}async function n(ge,Y,q,oe){const ve=ne(ge,Y);ge.logService.trace(`${ve} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await t(ge.logService,ge.remoteSocketFactoryService,ge.connectTo,b.$Tg.getServerRootPath(),`reconnectionToken=${ge.reconnectionToken}&reconnection=${ge.reconnectionProtocol?"true":"false"}`,m(Y),`renderer-${m(Y)}-${ge.reconnectionToken}`,oe)}catch(pe){throw ge.logService.error(`${ve} socketFactory.connect() failed or timed out. Error:`),ge.logService.error(pe),pe}ge.logService.trace(`${ve} 2/6. socketFactory.connect() was successful.`);let ae,se;ge.reconnectionProtocol?(ge.reconnectionProtocol.beginAcceptReconnection(ie,null),ae=ge.reconnectionProtocol,se=!1):(ae=new u.$ui({socket:ie}),se=!0),ge.logService.trace(`${ve} 3/6. sending AuthRequest control message.`);const X=await o(ge.signService.createNewMessage((0,y.$3g)()),oe),re={type:"auth",auth:ge.connectionToken||"00000000000000000000",data:X.data};ae.sendControl(h.$Oe.fromString(JSON.stringify(re)));try{const pe=await s(ae,f(oe,p(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(ge.logService.trace(`${ve} 4/6. received SignRequest control message.`),!await o(ge.signService.validate(X,pe.signedData),oe)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Me=await o(ge.signService.sign(pe.data),oe),ze={type:"connectionType",commit:ge.commit,signedData:Me,desiredConnectionType:Y};return q&&(ze.args=q),ge.logService.trace(`${ve} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(h.$Oe.fromString(JSON.stringify(ze))),{protocol:ae,ownsProtocol:se}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(ge.logService.error(`${ve} the handshake timed out. Error:`),ge.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(ge.logService.error(`${ve} received error control message when negotiating connection. Error:`),ge.logService.error(pe)),se&&V(ae),pe}}async function d(ge,Y,q,oe){const ve=Date.now(),ie=ne(ge,Y),{protocol:ae,ownsProtocol:se}=await n(ge,Y,q,oe),X=new i(oe);return X.registerDisposable(ae.onControlMessage(re=>{const pe=JSON.parse(re.toString()),we=W(pe);we?(ge.logService.error(`${ie} received error control message when negotiating connection. Error:`),ge.logService.error(we),se&&V(ae),X.reject(we)):(ge.reconnectionProtocol?.endAcceptReconnection(),ge.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ye(ve)}!`),X.resolve({protocol:ae,firstMessage:pe}))})),X.promise}async function l(ge,Y){const{protocol:q}=await d(ge,a.Management,void 0,Y);return{protocol:q}}async function g(ge,Y,q){const{protocol:oe,firstMessage:ve}=await d(ge,a.ExtensionHost,Y,q),ie=ve&&ve.debugPort;return{protocol:oe,debugPort:ie}}async function E(ge,Y,q){const oe=Date.now(),ve=ne(ge,a.Tunnel),{protocol:ie}=await n(ge,a.Tunnel,Y,q);return ge.logService.trace(`${ve} 6/6. handshake finished, connection is up and running after ${ye(oe)}!`),ie}async function D(ge,Y,q){const{connectTo:oe,connectionToken:ve}=await ge.addressProvider.getAddress();return{commit:ge.commit,quality:ge.quality,connectTo:oe,connectionToken:ve,reconnectionToken:Y,reconnectionProtocol:q,remoteSocketFactoryService:ge.remoteSocketFactoryService,signService:ge.signService,logService:ge.logService}}async function S(ge,Y,q){return A(ge,async oe=>{const{protocol:ve}=await l(oe,C.CancellationToken.None);return new z(ge,Y,q,oe.reconnectionToken,ve)})}async function I(ge,Y){return A(ge,async q=>{const{protocol:oe,debugPort:ve}=await g(q,Y,C.CancellationToken.None);return new ee(ge,Y,q.reconnectionToken,oe,ve)})}async function A(ge,Y){for(let oe=1;;oe++)try{const ve=(0,y.$3g)(),ie=await D(ge,ve,null);return await Y(ie)}catch(ve){if(oe<5)ge.logService.error(`[remote-connection][attempt ${oe}] An error occurred in initial connection! Will retry... Error:`),ge.logService.error(ve);else throw ge.logService.error(`[remote-connection][attempt ${oe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ge.logService.error(ve),U.triggerPermanentFailure(0,0,P.$Vl.isHandled(ve)),ve}}async function $(ge,Y,q){const oe=await D(ge,(0,y.$3g)(),null);return await E(oe,{host:Y,port:q},C.CancellationToken.None)}function v(ge){return(0,r.$th)(Y=>new Promise((q,oe)=>{const ve=setTimeout(q,ge*1e3);Y.onCancellationRequested(()=>{clearTimeout(ve),q()})}))}var M;(function(ge){ge[ge.ConnectionLost=0]="ConnectionLost",ge[ge.ReconnectionWait=1]="ReconnectionWait",ge[ge.ReconnectionRunning=2]="ReconnectionRunning",ge[ge.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ge[ge.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class N{constructor(Y,q){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.type=M.ConnectionLost}}e.$5l=N;class L{constructor(Y,q,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.durationSeconds=oe,this.c=ve,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$6l=L;class F{constructor(Y,q,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=oe,this.type=M.ReconnectionRunning}}e.$7l=F;class B{constructor(Y,q,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=oe,this.type=M.ConnectionGain}}e.$8l=B;class j{constructor(Y,q,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=oe,this.handled=ve,this.type=M.ReconnectionPermanentFailure}}e.$9l=j;class U extends O.$Vc{static triggerPermanentFailure(Y,q,oe){this._permanentFailure=!0,this.f=Y,this.g=q,this.h=oe,this.j.forEach(ve=>ve.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Y=>Y.y())}static debugPauseSocketWriting(){this.j.forEach(Y=>Y.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(Y,q,oe,ve,ie){super(),this.t=Y,this.u=q,this.reconnectionToken=oe,this.protocol=ve,this.w=ie,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new B(this.reconnectionToken,0,0)),this.B(ve.onSocketClose(ae=>{const se=ce(this.t,this.reconnectionToken,!0);ae?ae.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${se} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(ve.onSocketTimeout(ae=>{const se=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,O.$Tc)(()=>{const ae=U.j.indexOf(this);ae>=0&&U.j.splice(ae,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Y=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let oe=-1;do{oe++;const ve=oe<q.length?q[oe]:q[q.length-1];try{if(ve>0){const ae=v(ve);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve,ae)),this.u.logService.info(`${Y} waiting for ${ve} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1)),this.u.logService.info(`${Y} resolving connection...`);const ie=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Y} connecting to ${ie.connectTo}...`),await this.G(ie,p(w)),this.u.logService.info(`${Y} reconnected!`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(oe>360){this.u.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(P.$Vl.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,R.$4)(ie)){this.u.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof P.$Vl){this.u.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,P.$Vl.isHandled(ie));break}this.u.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}}while(!this.n&&!this.s)}C(Y,q,oe){this.w?U.triggerPermanentFailure(Y,q,oe):this.D(Y,q,oe)}D(Y,q,oe){this.m.fire(new j(this.reconnectionToken,Y,q,oe)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0l=U;class z extends U{constructor(Y,q,oe,ve,ie){super(a.Management,Y,ve,ie,!0),this.client=this.B(new u.$si(ie,{remoteAuthority:q,clientId:oe},Y.ipcLogger))}async G(Y,q){await l(Y,q)}}e.$$l=z;class ee extends U{constructor(Y,q,oe,ve,ie){super(a.ExtensionHost,Y,oe,ve,!1),this.H=q,this.debugPort=ie}async G(Y,q){await g(Y,this.H,q)}}e.$_l=ee;function V(ge){try{ge.acceptDisconnect();const Y=ge.getSocket();ge.dispose(),Y.dispose()}catch(Y){(0,R.$Z)(Y)}}function W(ge){if(ge&&ge.type==="error"){const Y=new Error(`Connection error: ${ge.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function J(ge,Y){for(;ge.length<Y;)ge+=" ";return ge}function _(ge,Y){return`[remote-connection][${J(m(ge),13)}][${Y.substr(0,5)}\u2026]`}function ce(ge,Y,q){return`${_(ge,Y)}[${q?"reconnect":"initial"}]`}function ne(ge,Y){return`${ce(Y,ge.reconnectionToken,!!ge.reconnectionProtocol)}[${ge.connectTo}]`}function ye(ge){return`${Date.now()-ge} ms`}}),define(ke[90],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=h,e.$jn=C,e.$kn=R,e.$ln=T;function h(b){return b.scheme===r.Schemas.vscodeRemote?b.authority:void 0}function C(b){if(!b)return;const c=b.indexOf("+");return c<0?b:b.substr(0,c)}function R(b){const{host:c,port:k}=O(b);if(typeof k>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:k}}function T(b,c){let{host:k,port:y}=O(b);return typeof y>"u"&&(y=c),{host:k,port:y}}function O(b){const c=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(ke[23],Ie([1,0,12,5,90]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=R,e.$vn=y,e.$wn=u,e.$xn=P,e.$yn=w,e.$zn=a,e.$An=m,r=We(r),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function R(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(T||(e.ExtensionType=T={}));var O;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class b{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.$Gf(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$sn=b;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const i of f)this.add(i)}add(f){this.c.add(b.toKey(f))}delete(f){return this.c.delete(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}}e.$tn=c;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(b.toKey(f))}get(f){return this.c.get(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}set(f,i){this.c.set(b.toKey(f),i)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=k;function y(p){return u(p)}function u(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function P(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function w(p,f){if(f){const i=`onResolveRemoteAuthority:${(0,C.$jn)(f)}`;return!!p.activationEvents?.includes(i)}return!1}function a(p){return p.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m(p){return p.map(f=>f.split("@")[0])}e.$Bn=(0,h.$Gi)("IBuiltinExtensionsScannerService")}),define(ke[148],Ie([1,0,10,8,23,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=O,e.$hp=b,e.$ip=c,e.$jp=k,e.$kp=y,e.$lp=u,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function O(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function b(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function c(t,o){switch(t){case r.Platform.Windows:return o==="x64"?C.TargetPlatform.WIN32_X64:o==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?C.TargetPlatform.LINUX_X64:o==="arm64"?C.TargetPlatform.LINUX_ARM64:o==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?C.TargetPlatform.ALPINE_X64:o==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?C.TargetPlatform.DARWIN_X64:o==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Web:return C.TargetPlatform.WEB}}function k(t,o){return o===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function y(t,o,n){return k(o,n)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$mp=(0,R.$Gi)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(p||(e.ExtensionGalleryErrorCode=p={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$np=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$op=s,e.$pp=(0,R.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,R.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,R.$Gi)("IExtensionTipsService"),e.$up=(0,h.localize2)(1771,"Extensions"),e.$vp=(0,h.localize2)(1772,"Preferences")}),define(ke[149],Ie([1,0,13,23]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(T,O){this.a.set(T,O)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const O=Object.create(null);for(const b of T){const c=this.readActivationEvents(b);c.length>0&&(O[h.$sn.toKey(b.identifier)]=c)}return O}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const O=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let b=0;b<O.length;b++)O[b]==="onUri"&&(O[b]=`onUri:${h.$sn.toKey(T.identifier)}`);if(!T.contributes)return O;for(const b in T.contributes){const c=this.a.get(b);if(!c)continue;const k=T.contributes[b],y=Array.isArray(k)?k:[k];try{c(y,O)}catch(u){(0,r.$Z)(u)}}return O}}e.$1G=C,e.$2G=new C});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[236],Ie([1,0,22,43,8,361,23,145]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=k,e.$2p=y,e.$3p=u,e.$4p=P,e.$5p=w,e.$6p=a,e.$7p=m,e.$8p=p,h=Ut(h),C=We(C),R=We(R);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function k(s){return s=s.trim(),s==="*"||b.test(s)}function y(s){if(!k(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let d=s.minorMustEqual;const l=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(d=!1),g=!1);let E=0;if(s.preRelease){const D=c.exec(s.preRelease);if(D){const[,S,I,A]=D;E=Date.UTC(Number(S),Number(I)-1,Number(A))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:E}}function P(s,t,o){let n;typeof s=="string"?n=u(y(s)):n=s;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof o=="string"?l=u(y(o)):l=o,!n||!l)return!1;const g=n.majorBase,E=n.minorBase,D=n.patchBase;let S=l.majorBase,I=l.minorBase,A=l.patchBase;const $=l.notBefore;let v=l.majorMustEqual,M=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?g>S?!0:g<S?!1:E>I?!0:E<I||d&&d<$?!1:D>=A:(g===1&&S===0&&(!v||!M||!N)&&(S=1,I=0,A=0,v=!0,M=!1,N=!1),g<S?!1:g>S?!v:E<I?!1:E>I?!M:D<A?!1:D>A?!N:!(d&&d<$))}function w(s,t,o,n,d,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,C.localize(1823,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,C.localize(1824,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,C.localize(1825,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,C.localize(1826,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,C.localize(1827,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,C.localize(1828,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,C.localize(1829,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,C.localize(1830,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,C.localize(1831,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,C.localize(1832,null,"main")]),g;{const S=(0,r.$hh)(o,n.main);(0,r.$bh)(S,o)||g.push([h.default.Warning,C.localize(1833,null,S.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,C.localize(1834,null,"browser")]),g;{const S=(0,r.$hh)(o,n.browser);(0,r.$bh)(S,o)||g.push([h.default.Warning,C.localize(1835,null,S.path,o.path)])}}if(!R.valid(n.version))return g.push([h.default.Error,C.localize(1836,null)]),g;const E=[];if(!a(s,t,n,d,E))for(const S of E)g.push([h.default.Error,S]);if(l&&n.enabledApiProposals?.length){const S=[];if(!p([...n.enabledApiProposals],S))for(const I of S)g.push([h.default.Error,I])}return g}function a(s,t,o,n,d){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,d)}function m(s,t,o){return s==="*"||f(t,o,s)}function p(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??O.allApiProposals,d=[],l=(0,T.$zn)(s);for(const{proposalName:g,version:E}of l){const D=n[g];D&&E&&D.version!==E&&d.push(C.localize(1837,null,g))}return o?.push(...d),d.length===0}function f(s,t,o,n=[]){const d=u(y(o));if(!d)return n.push(C.localize(1838,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(C.localize(1839,null,o)),!1}else if(!d.majorMustEqual)return n.push(C.localize(1840,null,o)),!1;return P(s,t,d)?!0:(n.push(C.localize(1841,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(ke[237],Ie([1,0,3,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl=(0,h.$Gi)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(T,O){return this.a[T]??=[],this.a[T].push(O),(0,r.$Tc)(()=>{const b=this.a[T]?.indexOf(O);typeof b=="number"&&b>=0&&this.a[T]?.splice(b,1)})}b(T){return(this.a[T.type]||[]).find(b=>b.supports(T))}connect(T,O,b,c){const k=this.b(T);if(!k)throw new Error(`No socket factory found for ${T}`);return k.connect(T,O,b,c)}}e.$Yl=C}),define(ke[238],Ie([1,0,21,13,3,8,70,5,11,36]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=u,e.$_p=P,e.$aq=w,e.$bq=a,e.$cq=m,e.$dq=p,e.$9p=(0,O.$Gi)("requestService");class k{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class y extends C.$Vc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(2041,null),when:b.$tk.isEqualTo((0,b.$qk)(b.LogLevel.Trace)).serialize()})}async c(t,o,n){const d=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${d} - begin`,o.type,new k(o.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,o.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,o.type,(0,h.$0)(l)),l}}}e.$0p=y;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function P(s){return s.res.statusCode===204}async function w(s){return P(s)?null:(await(0,r.$1e)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return w(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(P(s))return null;const o=(await(0,r.$1e)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function p(s){i(s)}let f;function i(s){const t=c.$so.as(T.$xo.Configuration),o=f;f={id:"http",order:15,title:(0,R.localize)(2042,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(2048,null),(0,R.localize)(2049,null),(0,R.localize)(2050,null),(0,R.localize)(2051,null)],default:"override",description:(0,R.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(2054,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(T.ConfigurationScope.APPLICATION)}),define(ke[239],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const R=await this.c();if(R){const T=String(r.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(C)}}}catch(R){console.error(R)}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const T=this.b.get(C.id);if(!T)return!1;this.b.delete(C.id);try{return T.validate(R)==="ok"}catch(O){return console.error(O),!1}finally{T.dispose?.()}}async sign(C){try{return await this.d(C)}catch(R){console.error(R)}return C}}e.$4cc=r}),define(ke[117],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl="signService",e.$1l=(0,r.$Gi)(e.$Zl)}),define(ke[150],Ie([1,0,139,239]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class C extends h.$4cc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(O=>new O.signer().sign(T))}h(){return(0,r.$uq)("vsda","index.js")}}e.$_hc=C}),define(ke[240],Ie([1,0,10,55,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=T,e.$xp=O;function R(b){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function T(b,c,k,y,u,P,w,a,m,p){const f=Object.create(null);f["common.machineId"]=P,f["common.sqmId"]=w,f["common.devDeviceId"]=a,f.sessionID=(0,C.$3g)()+Date.now(),f.commitHash=y,f.version=u,f["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.$i)(r.$v),f["common.nodePlatform"]=h.$ec,f["common.nodeArch"]=k,f["common.product"]=p||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(f["common.snap"]="true");const t=R(c);return t&&(f["common.platformDetail"]=t),f}function O(b){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const k=c.toLowerCase();return b.some(y=>k===y)}}),define(ke[151],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,r.$Gi)("telemetryService"),e.$bm=(0,r.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ke[91],Ie([1,0,24,17,90,240,151]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=k,e.$Gp=y,e.$Hp=u,e.$Ip=P,e.$Jp=a,e.$Kp=p,e.$Lp=f,e.$Mp=t;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$yp=O;class b{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=b,e.$Ap=new b;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$Bp=c,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function k(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function y(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(T.$jm),d=o.getValue(T.$km);if(o.getValue(T.$lm)===!1||d===!1)return T.TelemetryLevel.NONE;switch(n??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function P(o){const n={},d={},l={};m(o,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const E=l[g];typeof E=="number"?d[g]=E:typeof E=="boolean"?d[g]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${E.length}`),n[g]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[g]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,C.$jn)(o);return w.has(n)?n:"other"}function m(o,n,d=0,l){if(o)for(const g of Object.getOwnPropertyNames(o)){const E=o[g],D=l?l+g:g;Array.isArray(E)?n[D]=(0,r.$ko)(E):E instanceof Date?n[D]=E.toISOString():(0,h.$hg)(E)?d<2?m(E,n,d+1,D+"."):n[D]=(0,r.$ko)(E):n[D]=E}}function p(o,n){const d=o.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,R.$xp)(d)||l}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const l=[];for(const S of n)for(;;){const I=S.exec(o);if(!I)break;l.push([I.index,S.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const S=E.exec(o);if(!S)break;const I=l.some(([A,$])=>S.index<$&&A<E.lastIndex);!g.test(S[0])&&!I&&(d+=o.substring(D,S.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<o.length&&(d+=o.substr(D)),d}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function t(o,n){return(0,r.$ho)(o,d=>{if(d instanceof O||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=s(l),l}})}}),define(ke[241],Ie([1,0,12,148,23,10,2,13,55,91]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=k,e.$Pp=w,e.$Qp=a,e.$Rp=m,e.$Sp=p,e.$Tp=f,e.$Up=i,e.$Vp=s,e.$Xp=t,e.$Yp=n;function k(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$Bf)(d.id,l.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const g=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,g,E)}static parse(l){const g=y.exec(l);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,E=C.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?k(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Op=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=P.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function p(d,l){return m(a(d??C.$on,l))}function f(d,l){const g=[],E=D=>{for(const S of g)if(S.some(I=>k(l(I),l(D))))return S;return null};for(const D of d){const S=E(D);S?S.push(D):g.push([D])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new c.$yp(d.identifier.id),name:new c.$yp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Wp=new C.$sn("pprice.better-merge");function t(d,l){const g=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&g.every(S=>!k(S.identifier,{id:D}))){const S=d.filter(I=>k(I.identifier,{id:D}));S.length===1&&(g.push(S[0]),E.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(d,l){if(!R.$l)return!1;let g;try{g=(await d.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,O.$0)(D))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const g=await o(d,l),E=(0,h.$ip)(g?"alpine":R.$v,b.$fc);return l.debug("ComputeTargetPlatform:",E),E}}),define(ke[242],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=r,e.$Js=h,e.$Ks=C,e.$Ls=R,e.$Ms=T,e.$Ns=O;function r(b){return[...b.entries()]}function h(b){return b?[...b.entries()]:[]}function C(b){return new Map(b)}function R(b){return new Map(b??[])}function T(b){return Array.from(b.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function O(b){return new Map(b.map(c=>[c[0],{map:C(c[1]),descriptionMap:R(c[2])}]))}}),define(ke[243],Ie([1,0,5,35,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ss=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$rs=void 0,e.$rs=new h.$Xj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var O;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(O||(e.PosixShellType=O={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var k;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(k||(e.TerminalIpcChannels=k={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ss=(0,r.$Gi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var p;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ts={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const n=this.b(o.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}C.$so.add(e.$ts.Backend,new s),e.$us=(0,r.$Gi)("localPtyService"),e.$vs=(0,r.$Gi)("terminalLogService")}),define(ke[244],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5xb=void 0;class r{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,R,T=5){const O=R(b=>{const c=typeof b=="string"?b:b.data;let k=this.a.get(C);if(k){k.data.push(c);return}const y=setTimeout(()=>this.flushBuffer(C),T);k={data:[c],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(C),O.dispose()}},this.a.set(C,k)});return O}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const R=this.a.get(C);R&&(this.a.delete(C),this.b(C,R.data.join("")))}}e.$5xb=r}),define(ke[245],Ie([1,0,7,82,106,51,4,17,2,8,116,36]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mx=e.$Lx=e.$Kx=e.$Jx=e.$Ix=e.$Hx=e.IconFontDefinition=e.IconContribution=e.$Ex=void 0,e.$Fx=m,e.$Gx=p,y=We(y),e.$Ex={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,d){let l=n.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const g=a.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=o})(u||(e.IconContribution=u={}));var P;(function(t){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=o;function n(d){const l=g=>(0,O.$fg)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,O.$fg)(g.format)&&(0,O.$fg)(g.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(g=>({format:g.format,location:b.URI.parse(g.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new T.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(2351,null)},fontCharacter:{type:"string",description:(0,c.localize)(2352,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,n,d,l){const g=this.b[o];if(g){if(d&&!g.description){g.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const S=this.e.enum.indexOf(o);S!==-1&&(this.e.enumDescriptions[S]=d),this.a.fire()}return g}const E={id:o,description:d,defaults:n,deprecationMessage:l};this.b[o]=E;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),d&&(D.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=D,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const n=this.e.enum.indexOf(o);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,n){const d=this.f[o];return d||(this.f[o]=n,this.a.fire(),n)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(g,E)=>g.id.localeCompare(E.id),n=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(E=>!!E.description).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of l.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|`);return d.join(`
`)}}const a=new w;y.$so.add(e.$Ex.IconContribution,a);function m(t,o,n,d){return a.registerIcon(t,o,n,d)}function p(){return a}function f(){const t=(0,C.$2j)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.$Hx="vscode://schemas/icons";const i=y.$so.as(k.$to.JSONContribution);i.registerSchema(e.$Hx,a.getIconSchema());const s=new r.$Sh(()=>i.notifySchemaChanged(e.$Hx),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Ix=m("widget-close",h.$6j.close,(0,c.localize)(2353,null)),e.$Jx=m("goto-previous-location",h.$6j.arrowUp,(0,c.localize)(2354,null)),e.$Kx=m("goto-next-location",h.$6j.arrowDown,(0,c.localize)(2355,null)),e.$Lx=R.ThemeIcon.modify(h.$6j.sync,"spin"),e.$Mx=R.ThemeIcon.modify(h.$6j.loading,"spin")}),define(ke[92],Ie([1,0,4,3,10,2,46,5,11]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Pw=e.$Nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Jw=e.$Iw=void 0,e.$Kw=y,e.$Lw=P,e.$Mw=w,e.$Ow=a,e.$Qw=m,e.$Rw=p,e.$Iw=(0,O.$Gi)("tunnelService"),e.$Jw=(0,O.$Gi)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var k;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(k||(e.TunnelPrivacyId=k={}));function y(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function w(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const d=P(R.URI.parse(n));if(d)return d}}}e.$Nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.$Nw.indexOf(s)>=0}e.$Pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.$Pw.indexOf(s)>=0}function p(s,t,o,n){if(o===C.OperatingSystem.Windows)return!1;if(o===C.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this.b=n,this.a=new r.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sw=f;let i=class extends h.$Vc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new r.$me,this.onTunnelOpened=this.a.event,this.b=new r.$me,this.onTunnelClosed=this.b.event,this.c=new r.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const n of o){const d=Array.from(n.values());for(const l of d){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,n,d,l){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.$Nw[0]);const n=this.D(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,d,l,g=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${l}.`);const S=this.g??t;if(!S)return;if(o||(o="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const I=this.F(S,o,n,d,l,g,E,D);return I?I.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,n),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.w(A);return(A.tunnelRemoteHost!==o||A.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&A.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),I)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,o,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),d}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this.f.get(t);if(n&&n.has(o)){const d=n.get(o);d.refcount=0,await this.y(t,o,d)}}z(t,o,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:n})}async C(t,o){const n=this.f.get(t);if(n){const d=n.get(o),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(o),n.size===0&&this.f.delete(t)}}D(t,o){const n=[t];a(t)?(n.push(...e.$Nw),n.push(...e.$Pw)):m(t)&&n.push(...e.$Pw);const d=n.map(l=>this.f.get(l));for(const l of d){const g=l?.get(o);if(g)return g}}canTunnel(t){return!!P(t)}G(t,o,n,d,l,g,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${d}.`);const D=n;this.n.add(D);const S=d===void 0?n:d,I={elevationRequired:l?this.isPortPrivileged(S):!1},A={remoteAddress:{host:o,port:n},localAddressPort:d,privacy:g,public:g?g!==k.Private:void 0,protocol:E},$=t.forwardPort(A,I);return $?(this.z(o,n,$),$.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),$}};e.$Tw=i,e.$Tw=i=Ze([Ve(0,b.$bk),Ve(1,T.$aj)],i)}),define(ke[152],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,r.$Gi)("IUriIdentityService")}),define(ke[246],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Uw=void 0,e.$Uw=(0,r.$Gi)("editSessionIdentityService");var h;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ke[247],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=h,e.$mN=C,e.$nN=R,e.$oN=T,e.$pN=O;function h(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}function C(b){if(b.folders.length)return b.folders.every(c=>h(c.uri))?b.folders[0].uri:void 0;if(b.configuration&&h(b.configuration))return b.configuration}function R(b){return C(b)?.scheme}function T(b){return C(b)?.authority}function O(b){return C(b)!==void 0}}),define(ke[47],Ie([1,0,8,16,84,22,2,5,14]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=c,e.$Ri=k,e.$Ui=y,e.$Vi=u,e.$Wi=P,e.$Xi=a,e.$Yi=m,e.$2i=i,e.$7i=s,e.$8i=t,e.$0i=o,e.$$i=n,e.$_i=d,e.$Pi=(0,O.$Gi)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.uri)}function k(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function y(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$oc)(l)}:g?e.$Si:e.$Ti;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.configPath)}function P(l){const g=l;if(g?.uri)return{id:g.id,uri:T.URI.revive(g.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:T.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&T.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class p{constructor(g,E,D,S,I){this.h=g,this.j=D,this.k=S,this.l=I,this.c=C.$Mi.forUris(this.l,()=>!0),this.folders=E}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=C.$Mi.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=p;class f{constructor(g,E){this.raw=E,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.$hh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=f;function i(l){return new f({uri:l,index:0,name:(0,R.$dh)(l)},{uri:l.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,r.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function s(l,g){return R.$$g.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return T.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===b.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(l){return l.id===e.$9i}function n(l,g){return!s(l,g)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$pc)(l):(0,R.$fh)(l))===e.$4i}}),define(ke[153],Ie([1,0,60,4,3,22,2,8,146,27,5,11,47,28,152,7,32,12,17]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=s,e.$Ol=t,e.$Pl=o;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&T.URI.isUri(g.location)&&T.URI.isUri(g.globalStorageHome)&&T.URI.isUri(g.settingsResource)&&T.URI.isUri(g.keybindingsResource)&&T.URI.isUri(g.tasksResource)&&T.URI.isUri(g.snippetsHome)&&T.URI.isUri(g.extensionsResource))}e.$Nl=(0,k.$Gi)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:T.URI.revive(l.location).with({scheme:g}),globalStorageHome:T.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:T.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:T.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:T.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:T.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:T.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:T.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function o(l,g,E,D,S,I){return{id:l,name:g,location:E,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:I&&S?.useDefaultFlags?.globalState?I.globalStorageHome:(0,R.$hh)(E,"globalStorage"),settingsResource:I&&S?.useDefaultFlags?.settings?I.settingsResource:(0,R.$hh)(E,"settings.json"),keybindingsResource:I&&S?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,R.$hh)(E,"keybindings.json"),tasksResource:I&&S?.useDefaultFlags?.tasks?I.tasksResource:(0,R.$hh)(E,"tasks.json"),snippetsHome:I&&S?.useDefaultFlags?.snippets?I.snippetsHome:(0,R.$hh)(E,"snippets"),extensionsResource:I&&S?.useDefaultFlags?.extensions?I.extensionsResource:(0,R.$hh)(E,"extensions.json"),cacheHome:(0,R.$hh)(D,l),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let n=class extends C.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,E,D,S){super(),this.t=g,this.u=E,this.w=D,this.y=S,this.f=!0,this.h=this.B(new h.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Bc,workspaces:new P.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),E=[g];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$fg)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}E.push(o((0,R.$eh)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},g))}}catch(I){this.y.error(I)}const D=new P.$Bc,S=new Map;if(E.length)try{const I=this.Q();if(I.workspaces)for(const[A,$]of Object.entries(I.workspaces)){const v=T.URI.parse(A),M=E.find(N=>N.id===$);M&&D.set(v,M)}if(I.emptyWindows)for(const[A,$]of Object.entries(I.emptyWindows)){const v=E.find(M=>M.id===$);v&&S.set(A,v)}}catch(I){this.y.error(I)}this.z={profiles:E,workspaces:D,emptyWindows:S}}return this.z}D(){const g=o("__default__profile__",(0,O.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const E="Temp",D=new RegExp(`${(0,p.$if)(E)}\\s(\\d+)`);let S=0;for(const A of this.profiles){const $=D.exec(A.name),v=$?parseInt($[1]):0;S=v>S?v:S}const I=`${E} ${S+1}`;return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),I,{transient:!0},g)}async createNamedProfile(g,E,D){return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),g,E,D)}async createProfile(g,E,D,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(g,E,D);return S&&await this.setProfileForWorkspace(S,I),I}async F(g,E,D){if(!(0,f.$fg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(E);return S||(S=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===g))throw new Error(`Profile with ${E} name already exists`);const A=o(g,E,(0,R.$hh)(this.profilesHome,g),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const $=[];return this.j.fire({profile:A,join(v){$.push(v)}}),await a.Promises.settled($),this.I([A],[],[]),A}finally{this.r.delete(E)}})(),this.r.set(E,S)),S}async updateProfile(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(S=>S.id===g.id);if(!D)throw new Error(`Profile '${g.name}' does not exist`);return D=o(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(S=>S.id===g.id);if(!E)throw new Error(`Profile '${g.name}' does not exist`);const D=[];this.m.fire({profile:E,join(S){D.push(S)}});try{await Promise.allSettled(D)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(S){(0,c.$sl)(S)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(S=>S.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(g,D)}unsetWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(g.map(E=>this.removeProfile(E)))}getProfileForWorkspace(g){const E=this.G(g),D=T.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,u.$Qi)(g)?this.s.folders.get(g.uri):(0,u.$Vi)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,u.$Qi)(g)?g.uri:(0,u.$Vi)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,g.location)))}I(g,E,D){const S=[...this.profiles,...g],I=[],A=this.s.profiles;this.s.profiles=[];for(let $ of S){if($.isDefault||E.some(M=>$.id===M.id))continue;$=D.find(M=>$.id===M.id)??$;const v=A.find(M=>$.id===M.id);if($.isTransient)this.s.profiles.push($);else{if(v){for(const[M,N]of this.s.emptyWindows.entries())if($.id===N.id){this.L({id:M},$);break}for(const[M,N]of this.s.workspaces.entries())if($.id===N.id){this.L({id:"",configPath:M},$);break}for(const[M,N]of this.s.folders.entries())if($.id===N.id){this.L({id:"",uri:M},$);break}}I.push({location:$.location,name:$.name,shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags})}}this.P(I),this.z=void 0,this.J(g,E,D)}J(g,E,D){this.h.fire({added:g,removed:E,updated:D,all:this.profiles})}L(g,E,D){if(D=E?.isTransient?!0:D,D)(0,u.$Qi)(g)?(this.s.folders.delete(g.uri),E&&this.s.folders.set(g.uri,E)):(0,u.$Vi)(g)?(this.s.workspaces.delete(g.configPath),E&&this.s.workspaces.set(g.configPath,E)):(this.s.emptyWindows.delete(g.id),E&&this.s.emptyWindows.set(g.id,E));else{this.L(g,void 0,!0);const S=this.G(g);T.URI.isUri(S)?(this.C.workspaces.delete(S),E&&this.C.workspaces.set(S,E)):(this.C.emptyWindows.delete(S),E&&this.C.emptyWindows.set(S,E)),this.M()}}M(){const g={};for(const[D,S]of this.C.workspaces.entries())g[D.toString()]=S.id;const E={};for(const[D,S]of this.C.emptyWindows.entries())E[D.toString()]=S.id;this.R({workspaces:g,emptyWindows:E}),this.z=void 0}N(g){const E={},D=this.D();if(g.workspaces)for(const[I,A]of Object.entries(g.workspaces)){const $=T.URI.parse(A);E[I]=this.w.extUri.isEqual($,D.location)?D.id:this.w.extUri.basename($)}const S={};if(g.emptyWindows)for(const[I,A]of Object.entries(g.emptyWindows)){const $=T.URI.parse(A);S[I]=this.w.extUri.isEqual($,D.location)?D.id:this.w.extUri.basename($)}return{workspaces:E,emptyWindows:S}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Ql=n,e.$Ql=n=Ze([Ve(0,b.$Ni),Ve(1,c.$bl),Ve(2,w.$Ll),Ve(3,y.$bk)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Rl=d}),define(ke[154],Ie([1,0,7,4,3,61,17,194,5,153]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=P,e.$mq=a,e.$oq=p,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,b.$Gi)("storageService");var k;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(f){const i=f.get(e.$iq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends C.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$pe),this.c=this.B(new h.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$me),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,t){return h.Event.filter(this.b.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}n(){this.j.value=(0,r.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:t,external:o}=s;if(t===e.$iq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,s,t){return this.P(s)?.get(i,t)}getBoolean(i,s,t){return this.P(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.P(s)?.getNumber(i,t)}getObject(i,s,t){return this.P(s)?.getObject(i,t)}storeAll(i,s){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,T.$og)(s)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,s,n)})}remove(i,s,t=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const t=[],o=this.J(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}z(i,s,t,o=!1){const n=this.J(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(s)?.set(e.$iq,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.P(s)?.set(e.$iq,JSON.stringify(n),o))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?P(s):Object.create(null)}isNew(i){return this.getBoolean(e.$hq,i)===!0}async flush(i=k.NONE){this.f.fire({reason:i});const s=this.P(y.APPLICATION),t=this.P(y.PROFILE),o=this.P(y.WORKSPACE);switch(i){case k.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,s=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return p(i,s,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(k.NONE),(0,c.$Ml)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||a(s)&&a(i))}N(i,s,t){this.y(()=>{const o=new Set;for(const[n,d]of i)o.add(n),s.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.u(t,{key:n,external:!0})})}}e.$lq=w;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$nq=m;async function p(f,i,s,t,o,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,g=new Map;f.forEach((v,M)=>{l.set(M,v),g.set(M,d(v))});const E=new Map,D=new Map;i.forEach((v,M)=>{E.set(M,v),D.set(M,d(v))});const S=new Map,I=new Map;s.forEach((v,M)=>{S.set(M,v),I.set(M,d(v))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,M)=>{A.push({key:M,value:v})}),console.table(A),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const v=[];E.forEach((M,N)=>{v.push({key:N,value:M})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const $=[];S.forEach((v,M)=>{$.push({key:M,value:v})}),console.table($),console.groupEnd(),console.log(I)}}),define(ke[118],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class r{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const R=this.c++;return this.b.set(R,C),this.e(),R}get(C,R){return this.b.has(C)?this.b.get(C)[R]:void 0}delete(C){this.b.delete(C),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hpc=r}),define(ke[62],Ie([1,0,14,22,27,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0;class T{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$9g(b=>{const c=this.b.get(b.scheme);return!(c===void 0||c&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(b,c){c===null?this.b.delete(b.scheme):this.b.set(b.scheme,c)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Mpc=T,e.$Npc=(0,R.$Gi)("IExtHostFileSystemInfo")}),define(ke[29],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0,e.$EQ=(0,r.$Gi)("IExtHostInitDataService")}),define(ke[248],Ie([1,0,8,11,229,29]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0;let T=class extends C.$OR{constructor(b,c,k){const y=k.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",u=k.remote.isRemote?(0,r.localize)(2693,null):b?(0,r.localize)(2694,null):(0,r.localize)(2695,null);super(c.createLogger(y,{name:u}))}};e.$Vrc=T,e.$Vrc=T=Ze([Ve(1,h.$ck),Ve(2,R.$EQ)],T)}),define(ke[249],Ie([1,0,7]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=e.$sqc=void 0;class h{constructor(T,O,b){this.h=new Map,this.a=T,this.b=O,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Sh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const k of c.values())k.complete()}catch(k){for(const y of c.values())y.error(k)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,O){let b=this.f[T];return typeof b>"u"&&(b=O),b}update(T,O){this.f[T]=O;const b=this.h.get(T);if(b!==void 0)return b.p;const c=new r.$4h;return this.h.set(T,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$sqc=h;class C extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,O){super(T.identifier.value,!0,O),this.j=T}}e.$tqc=C}),define(ke[250],Ie([1,0,4,2]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=void 0;class C{constructor(T){this.c=T,this.a=new r.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,O,b,c){const y=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(O.value,b,c);this.b.fire(y)}$acceptDirtyStateChanged(T,O){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(O)}$acceptModelSaved(T){const O=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(O.apiNotebook)}}e.$nrc=C}),define(ke[19],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0,e.$oQ=(0,r.$Gi)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$pQ=h}),define(ke[251],Ie([1,0,23,4,3]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;class R{#e;constructor(O,b){this.disposables=new C.$Uc,this.a=r.$sn.toKey(O.identifier),this.#e=b,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,b){return this.#e.store(this.a,O,b)}delete(O){return this.#e.delete(this.a,O)}}e.$Cqc=R}),define(ke[72],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=e.$3pc=void 0,e.$3pc=(0,r.$Gi)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$4pc=h}),define(ke[252],Ie([1,0,253,362,363,67,2,11,364]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=k,r=We(r),h=We(h),C=We(C),R=We(R);const c=!1;function k(i,s,t,o,n,d){const l=d.environment.useHostProxy,g=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:I=>i.resolveProxy(I),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},d.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>P(s),log:o,getLogLevel:()=>{const I=o.getLevel();switch(I){case O.LogLevel.Trace:return b.LogLevel.Trace;case O.LogLevel.Debug:return b.LogLevel.Debug;case O.LogLevel.Info:return b.LogLevel.Info;case O.LogLevel.Warning:return b.LogLevel.Warning;case O.LogLevel.Error:return b.LogLevel.Error;case O.LogLevel.Off:return b.LogLevel.Off;default:return A(I)}function A($){return o.error("Unknown log level",$),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const I=[];if(d.remote.isRemote&&I.push((0,b.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then($=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",$.length)),I.push(A)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),I.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(I)).flat()},env:process.env},D=(0,b.createProxyResolver)(E),S=y(E,D);return a(t,S)}function y(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,b.createHttpPatch)(i,r,s)),https:t(h,(0,b.createHttpPatch)(i,h,s)),net:t(R,(0,b.createNetPatch)(i,R)),tls:t(C,(0,b.createTlsPatch)(i,C))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function P(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const w=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(l,g,E){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const D=t.findSubstr(T.URI.file(g.filename));let S=w.get(D);if(S||w.set(D,S={}),!S[l]){const I=s[l];S[l]={...I}}return S[l]}})}async function m(i,s,t,o,n,d,l,g,E,D,S){const I=n[E];D&&(n[E]=D),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${E}`,`proxyAuthenticate:${D}`,`proxyAuthenticateCache:${I}`);const A=D||I,$=Array.isArray(A)?A:typeof A=="string"?[A]:[];if(f(t,$,l),$.some(M=>/^(Negotiate|Kerberos)( |$)/i.test(M))&&!S.kerberosRequested){S.kerberosRequested=!0;try{const M=await new Promise((j,U)=>{$e(["kerberos"],j,U)}).then(We),N=new URL(E),L=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${L}`),"Negotiate "+await(await M.initializeClient(L)).step("")}catch(M){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",M)}if(l&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${E}`);const M=await i.lookupKerberosAuthorization(E);if(M)return"Negotiate "+M}}const v=$.find(M=>/^Basic( |$)/i.test(M));if(v)try{const M=d[E];if(M)if(S.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${E}`),delete d[E];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${E}`),S.basicAuthCacheUsed=!0,M;S.basicAuthAttempt=(S.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(v)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${E}`,`realm:${N}`);const L=new URL(E),F={scheme:"basic",host:L.hostname,port:Number(L.port),realm:N||"",isProxy:!0,attempt:S.basicAuthAttempt},B=await i.lookupAuthorization(F);if(B){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${E}`,`realm:${N}`);const j="Basic "+Buffer.from(`${B.username}:${B.password}`).toString("base64");return d[E]=j,j}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${E}`,`realm:${N}`)}catch(M){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",M)}}let p=!1;function f(i,s,t){p||!s.length||(p=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ke[254],Ie([1,0,140]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=C;function h(R){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:R,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function C(R){return new r.$Nn(h(R))}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[155],Ie([1,0,8,17,2,3,5,36,27,14,52,212,43]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$sG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$iG=e.EditorInputCapabilities=e.$hG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=void 0,e.$$F=a,e.$_F=m,e.$aG=p,e.$bG=f,e.$cG=i,e.$dG=s,e.$eG=t,e.$fG=o,e.$gG=n,e.$jG=S,e.$kG=A,e.$lG=$,e.$mG=v,e.$nG=M,e.$oG=N,e.$pG=L,e.$qG=F,e.$rG=V,e.$tG=_,e.$uG=ne,e.$vG=ye,e.$wG=ge,u=Ut(u),e.$6F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$7F={id:"default",displayName:(0,r.localize)(4042,null),providerDisplayName:(0,r.localize)(4043,null)},e.$8F="workbench.editor.sidebysideEditor",e.$9F="workbench.editors.textDiffEditor",e.$0F="workbench.editors.binaryResourceDiffEditor";var P;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function m(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function p(Y,q,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===q&&Y.matches(ve.input))return ve.getViewState()}function f(Y){if(S(Y))return!1;const q=Y;return C.URI.isUri(q?.resource)}function i(Y){if(S(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function s(Y){if(S(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(S(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function o(Y){if(S(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===c.Schemas.untitled||q.forceUntitled===!0:!1}function n(Y){if(S(Y))return!1;const q=Y;return C.URI.isUri(q?.base?.resource)&&C.URI.isUri(q?.input1?.resource)&&C.URI.isUri(q?.input2?.resource)&&C.URI.isUri(q?.result?.resource)}var d;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(q,oe){let ve=this.a.get(q);return ve||(ve={source:q,label:oe},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$hG=new g;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends R.$Vc{}e.$iG=D;function S(Y){return Y instanceof D}function I(Y){const q=Y;return C.URI.isUri(q?.preferredResource)}function A(Y){const q=Y;return S(q?.primary)&&S(q?.secondary)}function $(Y){const q=Y;return S(q?.modified)&&S(q?.original)}function v(Y,q,oe,ve,ie){return ge(ve,[(0,y.$qj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(4044,null),run:()=>{const ae={...oe,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,ae)}}),(0,y.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(4045,null),run:()=>ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(Y){return S(Y?.editor)}function N(Y){const q=Y;return M(Y)&&q?.group!==void 0}function L(Y){const q=Y;return typeof q?.groupId=="number"&&S(q.editor)}function F(Y){return typeof Y?.groupId=="number"}var B;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var j;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var U;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class z{getOriginalUri(q,oe){if(!q)return;if(n(q))return e.$sG.getOriginalUri(q.result,oe);if(oe?.supportSideBySide){const{primary:ie,secondary:ae}=this.a(q);if(ie&&ae){if(oe?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===U.ANY)return this.getOriginalUri(ie,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme});q=oe.supportSideBySide===U.PRIMARY?ie:ae}}if(i(q)||s(q)||t(q)||n(q))return;const ve=I(q)?q.preferredResource:q.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(q){return A(q)||t(q)?{primary:q.primary,secondary:q.secondary}:$(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,oe){if(!q)return;if(n(q))return e.$sG.getCanonicalUri(q.result,oe);if(oe?.supportSideBySide){const{primary:ie,secondary:ae}=this.a(q);if(ie&&ae){if(oe?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===U.ANY)return this.getCanonicalUri(ie,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme});q=oe.supportSideBySide===U.PRIMARY?ie:ae}}if(i(q)||s(q)||t(q)||n(q))return;const ve=q.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(q,oe){if(Array.isArray(oe)){if(oe.some(ve=>q.scheme===ve))return q}else if(oe===q.scheme)return q}}var ee;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function V(Y,q,oe,ve){if(!Y.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return oe===ee.MOUSE||oe===ee.KEYBOARD;case"mouse":return oe===ee.MOUSE;case"keyboard":return oe===ee.KEYBOARD}return!1}e.$sG=new z;var W;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(W||(e.CloseDirection=W={}));class J{constructor(){this.c=new Map,this.d=new Map}start(q){const oe=this.a=q.get(T.$Fi);for(const[ve,ie]of this.c)this.e(ve,ie,oe);this.c.clear()}e(q,oe,ve){const ie=ve.createInstance(oe);this.d.set(q,ie)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,h.$qg)(this.b)}registerEditorSerializer(q,oe){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,oe,this.a):this.c.set(q,oe),(0,R.$Tc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}O.$so.add(e.$6F.EditorFactory,new J);async function _(Y,q,oe){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const ie=C.URI.revive(ve.fileUri);if(!ie){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ie)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let se=ve.exists,X=ve.type;if(typeof se!="boolean"||typeof X!="number")try{X=(await q.stat(ie)).isDirectory?b.FileType.Directory:b.FileType.Unknown,se=!0}catch(pe){oe.error(pe),se=!1}if(!se&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(X===b.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const re={...ve.options,pinned:!0};return se?{resource:ie,options:re}:{resource:ie,options:re,forceUntitled:!0}}))}var ce;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(Y){const q=Y;if(!q)return!1;const oe=q;if(oe.modified)return ne(oe.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ye(Y){return(0,k.$sj)(Y)}function ge(Y,q,oe){const ve=(0,k.$tj)(Y,q);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}}),define(ke[255],Ie([1,0,4,8,5,3,28,36,24,82,245]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$CG=e.ViewContentGroups=e.$AG=e.ViewContainerLocation=e.Extensions=e.$zG=e.$yG=e.$xG=void 0,e.$BG=P,e.$xG="views",e.$yG=(0,h.localize)(4205,null),e.$zG=(0,k.$Fx)("default-view-icon",c.$6j.window,(0,h.localize)(4206,null));var y;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$AG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onDidRegister=this.c.event,this.f=this.B(new r.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const g=this.get(n.id);if(g)return g;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,T.$yc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}O.$so.add(y.ViewContainersRegistry,new w);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const d=o.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(o.order??5)-(n.order??5)}class p extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Ic}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const g=this.s(n,l);g.length&&(this.r(g,d),this.g.fire({views:g,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(g=>g.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,R.$Tc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[g,E]of d)this.n.add(n,E),l.set(g,(0,R.$Tc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort(m)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(4207,null,g.id));l.push(g)}}s(n,d){const l=this.m.get(d);if(!l)return[];const g=[],E=[];for(const D of l)n.includes(D)?g.push(D):E.push(D);return g.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),g}}O.$so.add(y.ViewsRegistry,new p),e.$CG=(0,C.$Gi)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,d){this.c=!1,this.d=!1,(0,b.$io)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const g=await d(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$DG=s;class t extends Error{constructor(n){super((0,h.localize)(4208,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$EG=t}),define(ke[256],Ie([1,0,8,35]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG=new h.$Xj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(4679,null)}),e.$JG=new h.$Xj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,r.localize)(4680,null)}),e.$KG=new h.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(4681,null)}),e.$LG=new h.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(4682,null)}),e.$MG=new h.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(4683,null)}),e.$NG=new h.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4684,null)}),e.$OG=new h.$Xj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(4685,null)}),e.$PG=new h.$Xj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(4686,null)}),e.$QG=new h.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(4687,null)}),e.$RG=new h.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(4688,null)}),e.$SG=new h.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(4689,null)}),e.$TG=new h.$Xj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(4690,null)}),e.$UG=new h.$Xj("inChat",!1,{type:"boolean",description:(0,r.localize)(4691,null)}),e.$VG=new h.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(4692,null)}),e.$WG=new h.$Xj("chatCursorAtTop",!1),e.$XG=new h.$Xj("chatInputHasAgent",!1),e.$YG=new h.$Xj("chatLocation",void 0),e.$ZG=new h.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(4693,null)})}),define(ke[156],Ie([1,0,132,7,20,4,39,3,44,184,12,35,23,5,11,115,238,154,256]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.ChatAgentLocation=void 0,e.$6H=d,e.$7H=l;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function E(D){switch(D){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$1H=(0,P.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=f.$VG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const I=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||I.f.contextMatchesRules(y.$Ej.deserialize(v.when)))}};const $={data:D};return this.b.set(E,$),(0,O.$Tc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const S=this.b.get(E);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return S.data.isDefault&&this.e.set(!0),S.impl=D,this.d.fire(new o(S.data,D)),(0,O.$Tc)(()=>{S.impl=void 0,this.d.fire(void 0),S.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const S={data:E,impl:D};return this.b.set(E.id,S),this.d.fire(new o(E,D)),(0,O.$Tc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,S){return await this.g.get(E)?.(D,S)??[]}updateAgent(E,D){const S=this.b.get(E);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);S.data.metadata={...S.data.metadata,...D},this.d.fire(new o(S.data,S.impl))}getDefaultAgent(E){return(0,r.$fb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=T.Iterable.find(this.b.values(),S=>d(S.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new o(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(S=>S.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,S,I,A){const $=this.b.get(E);if(!$?.impl)throw new Error(`No activated agent with id "${E}"`);return await $.impl.invoke(D,S,I,A)}async getFollowups(E,D,S,I,A){const $=this.b.get(E);if(!$?.impl)throw new Error(`No activated agent with id "${E}"`);return $.impl?.provideFollowups?$.impl.provideFollowups(D,S,I,A):[]}registerChatParticipantDetectionProvider(E,D){return this.i.set(E,D),(0,O.$Tc)(()=>{this.i.delete(E)})}async detectAgentOrCommand(E,D,S,I){const A=T.Iterable.first(this.i.values());if(!A)return;const $=this.getAgents().reduce((L,F)=>{L.push({participant:F.id,description:void 0});for(const B of F.slashCommands)L.push({participant:F.id,command:B.name,description:void 0});return L},[]),v=await A.provideParticipantDetection(E,D,{...S,participants:$},I);if(!v)return;const M=this.getAgent(v.participant);if(!M)return;if(!v.command)return{agent:M};const N=M?.slashCommands.find(L=>L.name===v.command);if(N)return{agent:M,command:N}}};e.$2H=t,e.$2H=t=Ze([Ve(0,y.$Yj)],t);class o{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,S,I){return this.d.invoke(E,D,S,I)}async provideFollowups(E,D,S,I){return this.d.provideFollowups?this.d.provideFollowups(E,D,S,I):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$3H=o,e.$4H=(0,P.$Gi)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,S,I){if(this.g=D,this.h=S,this.i=I,this.e=(0,c.$7d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const A=I.get(i.b,p.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{I.remove(i.b,p.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$cq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const S=D.restrictedChatParticipants;this.e.set(S,void 0),this.i.store(i.b,JSON.stringify(S),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),S=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&S}l(E,D){return this.e.map(I=>I[E.toLowerCase()]).map(I=>I?I.some(A=>(0,k.$Gf)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$5H=n,e.$5H=n=i=Ze([Ve(0,a.$uk),Ve(1,m.$9p),Ve(2,w.$bk),Ve(3,p.$jq)],n);function d(g){return`${g.extensionId.value}.${g.id}`}function l(g){const E="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$sn("")),(0,b.$di)(E)}}),define(ke[257],Ie([1,0,2,30,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=e.$wH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$uH=R,e.$vH=T;function R(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof r.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(h.$Rt.isIRange)}function T(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(R)}var O;(function(k){k[k.Complete=1]="Complete",k[k.Partial=2]="Partial",k[k.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var b;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(b||(e.ChatAgentVoteDirection=b={}));var c;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(c||(e.ChatCopyKind=c={})),e.$wH=(0,C.$Gi)("IChatService"),e.$xH="accessibility.voice.keywordActivation"}),define(ke[157],Ie([1,0,4,7,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eub=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$me,this.o=new r.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,b,c,k){const y={command:O};if(b&&Object.keys(b).length>0&&(y.arguments=b),this.u("request",y),typeof k=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(y.seq);if(P){this.f.delete(y.seq);const w={type:"response",seq:0,request_seq:y.seq,success:!1,command:O,message:(0,C.localize)(5685,null,k,O)};P(w)}},k)}return c&&this.f.set(y.seq,c),y.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,b){return O.type!=="event"||b.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,h.$Hh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const b=O,c=this.f.get(b.request_seq);c&&(this.f.delete(b.request_seq),c(b));break}}}}u(O,b){b.type=O,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((b,c)=>O.set(c,b)),await(0,h.$Hh)(500),O.forEach((b,c)=>{b({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$eub=R}),define(ke[119],Ie([1,0,2,8,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RK=e.MemoryRangeType=e.State=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0,e.$QK=b,e.$SK=k,h=We(h),e.$EJ="workbench.view.debug",e.$FJ="workbench.debug.variablesView",e.$GJ="workbench.debug.watchExpressionsView",e.$HJ="workbench.debug.callStackView",e.$IJ="workbench.debug.loadedScriptsView",e.$JJ="workbench.debug.breakPointsView",e.$KJ="workbench.debug.disassemblyView",e.$LJ="workbench.panel.repl",e.$MJ="workbench.panel.repl.view",e.$NJ=new C.$Xj("debugType",void 0,{type:"string",description:h.localize(5686,null)}),e.$OJ=new C.$Xj("debugConfigurationType",void 0,{type:"string",description:h.localize(5687,null)}),e.$PJ=new C.$Xj("debugState","inactive",{type:"string",description:h.localize(5688,null)}),e.$QJ="debugUx",e.$RJ=new C.$Xj(e.$QJ,"default",{type:"string",description:h.localize(5689,null)}),e.$SJ=new C.$Xj("hasDebugged",!1,{type:"boolean",description:h.localize(5690,null)}),e.$TJ=new C.$Xj("inDebugMode",!1,{type:"boolean",description:h.localize(5691,null)}),e.$UJ=new C.$Xj("inDebugRepl",!1,{type:"boolean",description:h.localize(5692,null)}),e.$VJ=new C.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(5693,null)}),e.$WJ=new C.$Xj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(5694,null)}),e.$XJ=new C.$Xj("breakpointsFocused",!0,{type:"boolean",description:h.localize(5695,null)}),e.$YJ=new C.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(5696,null)}),e.$ZJ=new C.$Xj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(5697,null)}),e.$1J=new C.$Xj("variablesFocused",!0,{type:"boolean",description:h.localize(5698,null)}),e.$2J=new C.$Xj("expressionSelected",!1,{type:"boolean",description:h.localize(5699,null)}),e.$3J=new C.$Xj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(5700,null)}),e.$4J=new C.$Xj("callStackItemType",void 0,{type:"string",description:h.localize(5701,null)}),e.$5J=new C.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(5702,null)}),e.$6J=new C.$Xj("callStackItemStopped",!1,{type:"boolean",description:h.localize(5703,null)}),e.$7J=new C.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(5704,null)}),e.$8J=new C.$Xj("watchItemType",void 0,{type:"string",description:h.localize(5705,null)}),e.$9J=new C.$Xj("canViewMemory",void 0,{type:"boolean",description:h.localize(5706,null)}),e.$0J=new C.$Xj("breakpointItemType",void 0,{type:"string",description:h.localize(5707,null)}),e.$$J=new C.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(5708,null)}),e.$_J=new C.$Xj("breakpointHasModes",!1,{type:"boolean",description:h.localize(5709,null)}),e.$aK=new C.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(5710,null)}),e.$bK=new C.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(5711,null)}),e.$cK=new C.$Xj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(5712,null)}),e.$dK=new C.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(5713,null)}),e.$eK=new C.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(5714,null)}),e.$fK=new C.$Xj("stepBackSupported",!1,{type:"boolean",description:h.localize(5715,null)}),e.$gK=new C.$Xj("restartFrameSupported",!1,{type:"boolean",description:h.localize(5716,null)}),e.$hK=new C.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(5717,null)}),e.$iK=new C.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(5718,null)}),e.$jK=new C.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(5719,null)}),e.$kK=new C.$Xj("breakpointsExist",!1,{type:"boolean",description:h.localize(5720,null)}),e.$lK=new C.$Xj("debuggersAvailable",!1,{type:"boolean",description:h.localize(5721,null)}),e.$mK=new C.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(5722,null)}),e.$nK=new C.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(5723,null)}),e.$oK=new C.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(5724,null)}),e.$pK=new C.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(5725,null)}),e.$qK=new C.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(5726,null)}),e.$rK=new C.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(5727,null)}),e.$sK=new C.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(5728,null)}),e.$tK=new C.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(5729,null)}),e.$uK=new C.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(5730,null)}),e.$vK=new C.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(5731,null)}),e.$wK=new C.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(5732,null)}),e.$xK=new C.$Xj("variableIsReadonly",!1,{type:"boolean",description:h.localize(5733,null)}),e.$yK=new C.$Xj("variableValue",!1,{type:"string",description:h.localize(5734,null)}),e.$zK=new C.$Xj("variableType",!1,{type:"string",description:h.localize(5735,null)}),e.$AK=new C.$Xj("variableInterfaces",!1,{type:"array",description:h.localize(5736,null)}),e.$BK=new C.$Xj("variableName",!1,{type:"string",description:h.localize(5737,null)}),e.$CK=new C.$Xj("variableLanguage",!1,{type:"string",description:h.localize(5738,null)}),e.$DK=new C.$Xj("variableExtensionId",!1,{type:"string",description:h.localize(5739,null)}),e.$EK=new C.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(5740,null)}),e.$FK=new C.$Xj("multiSessionRepl",!1,{type:"boolean",description:h.localize(5741,null)}),e.$GK=new C.$Xj("multiSessionDebug",!1,{type:"boolean",description:h.localize(5742,null)}),e.$HK=new C.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(5743,null)}),e.$IK=new C.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(5744,null)}),e.$JK=new C.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(5745,null)}),e.$KK=new C.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(5746,null)});const T=i=>h.localize(5747,null,i);e.$LK=T,e.$MK="editor.contrib.debug",e.$NK="editor.contrib.breakpoint",e.$OK="debug",e.$PK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(5748,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function b(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$RK="vscode-debug-memory";function k(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$TK=(0,R.$Gi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var p;(function(i){i.deserialize=s=>s,i.serialize=s=>s})(p||(e.IDebugVisualizationTreeItem=p={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(ke[258],Ie([1,0,12,2,16,24,14,30,20,18]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=void 0,e.$_H=y,e.$aI=u,e.$bI=P,e.$cI=w,e.$dI=a,e.$eI=m,e.$fI=p,e.$gI=i,e.$hI=o,e.$iI=n,e.$jI=l,e.$kI=E;const k=/{([^}]+)}/g;function y(S,I,A){return S.replace(k,function($,v){return I&&v.length>0&&v[0]!=="_"?$:A&&A.hasOwnProperty(v)?A[v]:$})}function u(S){const I={};for(const A of Object.keys(S))A.startsWith("!")||(I[A]=S[A]);return I}function P(S){return S.configuration.request==="attach"&&!w(S)&&(!S.parentSession||P(S.parentSession))}function w(S){let I=S.configuration.type;if(I)return I==="vslsShare"&&(I=S.configuration.adapterProxy.configuration.type),(0,r.$Gf)(I,"extensionhost")||(0,r.$Gf)(I,"pwa-extensionhost")?S:S.parentSession?w(S.parentSession):void 0}function a(S){return S.type&&(S.label||S.program||S.runtime)}function m(S,I,A){let $,v=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(S);){const L=N.index+1,F=L+N[0].length;if(L<=I&&F>=A){$=N[0],v=L;break}}if($){const L=/(\w|\p{L})+/gu;let F=null;for(;(F=L.exec($))&&!(F.index+1+v+F[0].length>=A););F&&($=$.substring(0,L.lastIndex))}return $?{start:v,end:v+$.length-1}:{start:0,end:0}}async function p(S,I,A,$){if(S.evaluatableExpressionProvider.has(I)){const v=S.evaluatableExpressionProvider.ordered(I),M=(0,c.$Hb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(I,A,$??b.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=I.getLineContent(A.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const v=I.getLineContent(A.lineNumber),{start:M,end:N}=m(v,A.column,A.column),L=v.substring(M-1,N);return{matchingExpression:L,range:new O.$Rt(A.lineNumber,M,A.lineNumber,M+L.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(f))}function s(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return h.URI.parse(S.path);if((0,C.$jc)(S.path))return h.URI.file(S.path)}return S.path}function t(S){if(typeof S.path=="object"){const I=h.URI.revive(S.path);if(I)return I.scheme===T.Schemas.file?I.fsPath:I.toString()}return S.path}function o(S,I){const A=I?s:t,$=(0,R.$fo)(S);return d($,(v,M)=>{v&&M&&(M.path=A(M))}),$}function n(S,I){const A=I?s:t,$=(0,R.$fo)(S);return d($,(v,M)=>{!v&&M&&(M.path=A(M))}),$}function d(S,I){switch(S.type){case"event":{const A=S;switch(A.event){case"output":I(!1,A.body.source);break;case"loadedSource":I(!1,A.body.source);break;case"breakpoint":I(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=S;switch(A.command){case"setBreakpoints":I(!0,A.arguments.source);break;case"breakpointLocations":I(!0,A.arguments.source);break;case"source":I(!0,A.arguments.source);break;case"gotoTargets":I(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach($=>I(!1,$));break;default:break}break}case"response":{const A=S;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach($=>I(!1,$.source));break;case"loadedSources":A.body.sources.forEach($=>I(!1,$));break;case"scopes":A.body.scopes.forEach($=>I(!1,$.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach($=>I(!1,$.source));break;case"setBreakpoints":A.body.breakpoints.forEach($=>I(!1,$.source));break;case"disassemble":A.body?.instructions.forEach(v=>I(!1,v.location));break;default:break}break}}}function l(S){return S.filter(I=>!I.presentation?.hidden).sort((I,A)=>I.presentation?A.presentation?I.presentation.group?A.presentation.group?I.presentation.group!==A.presentation.group?I.presentation.group.localeCompare(A.presentation.group):g(I.presentation.order,A.presentation.order):-1:A.presentation.group?1:g(I.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function g(S,I){return typeof S!="number"?typeof I!="number"?0:1:typeof I!="number"?-1:S-I}async function E(S,I){const A=S.getValue("debug.saveBeforeStart",{overrideIdentifier:I.activeTextEditorLanguageId});if(A!=="none"&&(await I.saveAll(),A==="allEditorsInActiveGroup")){const $=I.activeEditorPane;$&&$.input.resource?.scheme===T.Schemas.untitled&&await I.save({editor:$.input,groupId:$.group.id})}await S.reloadConfiguration()}const D=(S,I)=>!S||!I?S===I:S.name===I.name&&S.path===I.path&&S.sourceReference===I.sourceReference;e.$lI=D}),define(ke[259],Ie([1,0,56,67,24,16,10,12,33,8,157]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6rc=e.$5rc=e.$4rc=e.$3rc=e.$2rc=void 0,r=We(r),h=We(h),C=We(C),R=We(R),T=We(T),O=We(O),c=We(c);class y extends k.$eub{static{this.b=`\r
\r
`}static{this.i=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(p,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,p.on("data",i=>this.x(i))}sendMessage(p){if(this.p){const f=JSON.stringify(p);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${y.b}${f}`,"utf8")}}x(p){for(this.r=Buffer.concat([this.r,p]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this.n.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.r.indexOf(y.b);if(f!==-1){const s=this.r.toString("utf8",0,f).split(y.i);for(const t of s){const o=t.split(y.l);o[0]==="Content-Length"&&(this.t=Number(o[1]))}this.r=this.r.slice(f+y.b.length);continue}}break}}}e.$2rc=y;class u extends y{startSession(){return new Promise((p,f)=>{let i=!1;this.y=this.z(()=>{this.v(this.y,this.y),p(),i=!0}),this.y.on("close",()=>{i?this.n.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.y.on("error",s=>{i?this.n.fire(s):f(s)})})}async stopSession(){await this.w(),this.y&&(this.y.end(),this.y=void 0)}}e.$3rc=u;class P extends u{constructor(p){super(),this.A=p}z(p){return h.createConnection(this.A.port,this.A.host||"127.0.0.1",p)}}e.$4rc=P;class w extends u{constructor(p){super(),this.A=p}z(p){return h.createConnection(this.A.path,p)}}e.$5rc=w;class a extends y{constructor(p,f){super(),this.z=p,this.A=f}async startSession(){const p=this.z.command,f=this.z.args,i=this.z.options||{};try{if(p)if(R.$jc(p)){if(!await b.Promises.exists(p))throw new Error(c.localize(5822,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(c.localize(5823,null,this.A));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=C.$io(C.$fo(process.env),i.env)),p==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(c.localize(5824,null,f[0]));this.y=n}else throw new Error(c.localize(5825,null));else{let t=p,o=f;const n={env:s};i.cwd&&(n.cwd=i.cwd),T.$j&&(p.endsWith(".bat")||p.endsWith(".cmd"))&&(n.shell=!0,t=`"${p}"`,o=f.map(d=>(d=d.replace(/"/g,'\\"'),`"${d}"`))),this.y=r.spawn(t,o,n)}this.y.on("error",t=>{this.n.fire(t)}),this.y.on("exit",(t,o)=>{this.o.fire(t)}),this.y.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.y.stdout.on("error",t=>{this.n.fire(t)}),this.y.stdin.on("error",t=>{this.n.fire(t)}),this.y.stderr.resume(),this.v(this.y.stdout,this.y.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.y?(await this.w(),T.$j?new Promise((p,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.y.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",p),i.on("error",f)}):(this.y.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B(p,f){if(!p)return;const i=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?i.runtime=R.$kc(f,p.runtime):i.runtime=p.runtime),p.runtimeArgs&&(i.runtimeArgs=p.runtimeArgs),p.program&&(R.$jc(p.program)?i.program=p.program:i.program=R.$kc(f,p.program)),p.args&&(i.args=p.args);const s=p;return s.win&&(i.win=a.B(s.win,f)),s.winx86&&(i.winx86=a.B(s.winx86,f)),s.windows&&(i.windows=a.B(s.windows,f)),s.osx&&(i.osx=a.B(s.osx,f)),s.linux&&(i.linux=a.B(s.linux,f)),i}static platformAdapterExecutable(p,f){let i=Object.create(null);f=f.toLowerCase();for(const l of p)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(E=>typeof E.type=="string"&&O.$Gf(E.type,f)).forEach(E=>{const D=a.B(E,l.extensionLocation.fsPath);i=C.$io(i,D,l.isBuiltin)})}let s;T.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:T.$j?s=i.win||i.windows:T.$k?s=i.osx:T.$l&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.$6rc=a}),define(ke[260],Ie([1,0,56,31,10]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7rc=T,e.$8rc=b,r=We(r),C=We(C);function R(c,k){return new Promise((y,u)=>{let P="";const w=r.spawn(c,k);w.pid&&w.stdout.on("data",a=>{P+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{y(P)})})}async function T(c){if(c)if(C.$j){const k=await new Promise((y,u)=>{$e(["@vscode/windows-process-tree"],y,u)}).then(We);return new Promise(y=>{k.getProcessTree(c,u=>{y(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(k=>{const y=k.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},k=>!0);return Promise.resolve(!0)}var O;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(O||(O={}));function b(c,k,y,u,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=O.powershell:c.indexOf("cmd.exe")>=0?w=O.cmd:c.indexOf("bash")>=0?w=O.bash:C.$j?w=O.cmd:w=O.bash;let a,m=" ";switch(w){case O.powershell:if(a=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),u){const p=(0,h.$Lg)(u);p&&(m+=`${p}:; `),m+=`cd ${a(u)}; `}if(P)for(const p in P){const f=P[p];f===null?m+=`Remove-Item env:${p}; `:m+=`\${env:${p}}='${f}'; `}if(k.length>0){const p=k.shift(),f=y?p:a(p);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of k)m+=i==="<"||i===">"||y?i:a(i),m+=" "}break;case O.cmd:if(a=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>p.includes(f))||p.length===0?`"${p}"`:p),u){const p=(0,h.$Lg)(u);p&&(m+=`${p}: && `),m+=`cd ${a(u)} && `}if(P){m+='cmd /C "';for(const p in P){let f=P[p];f===null?m+=`set "${p}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${p}=${f}" && `)}}for(const p of k)m+=p==="<"||p===">"||y?p:a(p),m+=" ";P&&(m+='"');break;case O.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const p=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),P){m+="/usr/bin/env";for(const f in P){const i=P[f];i===null?m+=` -u ${p(f)}`:m+=` ${p(`${f}=${i}`)}`}m+=" "}for(const f of k)m+=f==="<"||f===">"||y?f:a(f),m+=" ";break}}return m}}),define(ke[261],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.CellExecutionUpdateType=void 0;var h;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$2K=(0,r.$Gi)("INotebookExecutionService")}),define(ke[262],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=e.ProxyKernelState=e.$4K=void 0,e.$4K=100;var h;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$5K=(0,r.$Gi)("INotebookKernelService"),e.$6K=(0,r.$Gi)("INotebookKernelHistoryService")}),define(ke[263],Ie([1,0,3,30,58,209,111]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x1b=void 0;class O extends r.$Vc{constructor(c,k,y){super(),this._source=c,this.b=k,this.c=y,this.a=void 0}f(c){const k=c.getLineCount();return new h.$Rt(1,1,k,this.g(c,k))}g(c,k){if(k<1||k>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const c=new R.$AD;c.acceptChunk(this._source);const k=c.finish(!0),{textBuffer:y,disposable:u}=k.create(C.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const k=new R.$AD;k.acceptChunk(c);const y=k.finish(!0),{textBuffer:u,disposable:P}=y.create(C.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(c){const y=new T.$oD(c,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(c){const y=new T.$oD(c,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$x1b=O}),define(ke[73],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class C{static fromExtHostTestItem(T,O,b=T.parent){if(T._isRoot)return new C([O]);const c=[T.id];for(let k=b;k&&k.id!==O;k=k.parent)c.push(k.id);return c.push(O),new C(c.reverse())}static isRoot(T){return!T.includes(r.Delimiter)}static root(T){const O=T.indexOf(r.Delimiter);return O===-1?T:T.slice(0,O)}static fromString(T){return new C(T.split(r.Delimiter))}static join(T,O){return new C([...T.path,O])}static joinToString(T,O){return T.toString()+r.Delimiter+O}static parentId(T){const O=T.lastIndexOf(r.Delimiter);return O===-1?void 0:T.slice(0,O)}static localId(T){const O=T.lastIndexOf(r.Delimiter);return O===-1?T:T.slice(O+r.Delimiter.length)}static isChild(T,O){return O[T.length]===r.Delimiter&&O.startsWith(T)}static compare(T,O){return T===O?h.IsSame:C.isChild(T,O)?h.IsChild:C.isChild(O,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,O){if(T===0)return 0;let b=0;for(;b<T-1;){for(let c=1;c<T;c++){const k=O(c-1),y=O(c);if(k.path[b]!==y.path[b])return b}b++}return b}constructor(T,O=T.length){if(this.path=T,this.d=O,T.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new C(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new C(this.path,T)}compare(T){if(typeof T=="string")return C.compare(this.toString(),T);for(let O=0;O<T.d&&O<this.d;O++)if(T.path[O]!==this.path[O])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=r.Delimiter,this.c+=this.path[T]}return this.c}}e.$$I=C}),define(ke[74],Ie([1,0,2,57,30,73]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$gJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$_I=e.TestResultState=void 0;var T;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$_I={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var O;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var b;(function(U){U[U.Refresh=2]="Refresh",U[U.CodeRelatedToTest=4]="CodeRelatedToTest",U[U.TestRelatedToCode=8]="TestRelatedToCode"})(b||(e.TestControllerCapability=b={}));var c;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$aJ=[c.Run,c.Debug,c.Coverage,c.HasNonDefaultProfile,c.HasConfigurable,c.SupportsContinuousRun];const k=U=>"runId"in U;e.$bJ=k;var y;(function(U){U.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),U.deserialize=(z,ee)=>({range:C.$Rt.lift(ee.range),uri:z.asCanonicalUri(r.URI.revive(ee.uri))})})(y||(e.IRichLocation=y={}));var u;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(u||(e.TestMessageType=u={}));var P;(function(U){U.serialize=z=>({label:z.label,uri:z.uri?.toJSON(),position:z.position?.toJSON()}),U.deserialize=(z,ee)=>({label:ee.label,uri:ee.uri?z.asCanonicalUri(r.URI.revive(ee.uri)):void 0,position:ee.position?h.$Qt.lift(ee.position):void 0})})(P||(e.ITestMessageStackFrame=P={}));var w;(function(U){U.serialize=z=>({message:z.message,type:u.Error,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&y.serialize(z.location),stackTrace:z.stackTrace?.map(P.serialize)}),U.deserialize=(z,ee)=>({message:ee.message,type:u.Error,expected:ee.expected,actual:ee.actual,contextValue:ee.contextValue,location:ee.location&&y.deserialize(z,ee.location),stackTrace:ee.stackTrace&&ee.stackTrace.map(V=>P.deserialize(z,V))})})(w||(e.ITestErrorMessage=w={}));const a=(U,z)=>`${z?"s":"e"}${U}`;e.$cJ=a;var m;(function(U){U.serialize=z=>({message:z.message,type:u.Output,offset:z.offset,length:z.length,location:z.location&&y.serialize(z.location)}),U.deserialize=(z,ee)=>({message:ee.message,type:u.Output,offset:ee.offset,length:ee.length,location:ee.location&&y.deserialize(z,ee.location)})})(m||(e.ITestOutputMessage=m={}));var p;(function(U){U.serialize=z=>z.type===u.Error?w.serialize(z):m.serialize(z),U.deserialize=(z,ee)=>ee.type===u.Error?w.deserialize(z,ee):m.deserialize(z,ee),U.isDiffable=z=>z.type===u.Error&&z.actual!==void 0&&z.expected!==void 0})(p||(e.ITestMessage=p={}));var f;(function(U){U.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),U.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(p.serialize)}),U.deserialize=(z,ee)=>({state:ee.state,duration:ee.duration,messages:ee.messages.map(V=>p.deserialize(z,V))})})(f||(e.ITestTaskState=f={}));const i="\0",s=(U,z)=>U+i+z;e.$dJ=s;const t=U=>{const z=U.indexOf(i);return{ctrlId:U.slice(0,z),tagId:U.slice(z+1)}};e.$eJ=t;var o;(function(U){U.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),U.deserialize=(z,ee)=>({extId:ee.extId,label:ee.label,tags:ee.tags,busy:ee.busy,children:void 0,uri:ee.uri?z.asCanonicalUri(r.URI.revive(ee.uri)):void 0,range:ee.range?C.$Rt.lift(ee.range):null,description:ee.description,error:ee.error,sortText:ee.sortText})})(o||(e.ITestItem=o={}));var n;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var d;(function(U){U.serialize=z=>({expand:z.expand,item:o.serialize(z.item)}),U.deserialize=(z,ee)=>({controllerId:R.$$I.root(ee.item.extId),expand:ee.expand,item:o.deserialize(z,ee.item)})})(d||(e.InternalTestItem=d={}));var l;(function(U){U.serialize=z=>{let ee;return z.item&&(ee={},z.item.label!==void 0&&(ee.label=z.item.label),z.item.tags!==void 0&&(ee.tags=z.item.tags),z.item.busy!==void 0&&(ee.busy=z.item.busy),z.item.uri!==void 0&&(ee.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(ee.range=z.item.range?.toJSON()),z.item.description!==void 0&&(ee.description=z.item.description),z.item.error!==void 0&&(ee.error=z.item.error),z.item.sortText!==void 0&&(ee.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:ee}},U.deserialize=z=>{let ee;return z.item&&(ee={},z.item.label!==void 0&&(ee.label=z.item.label),z.item.tags!==void 0&&(ee.tags=z.item.tags),z.item.busy!==void 0&&(ee.busy=z.item.busy),z.item.range!==void 0&&(ee.range=z.item.range?C.$Rt.lift(z.item.range):null),z.item.description!==void 0&&(ee.description=z.item.description),z.item.error!==void 0&&(ee.error=z.item.error),z.item.sortText!==void 0&&(ee.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:ee}}})(l||(e.ITestItemUpdate=l={}));const g=(U,z)=>{z.expand!==void 0&&(U.expand=z.expand),z.item!==void 0&&(U.item=U.item?Object.assign(U.item,z.item):z.item)};e.$fJ=g;var E;(function(U){U.serializeWithoutMessages=z=>({...d.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(f.serializeWithoutMessages)}),U.serialize=z=>({...d.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(f.serialize)}),U.deserialize=(z,ee)=>({...d.deserialize(z,ee),ownComputedState:ee.ownComputedState,computedState:ee.computedState,tasks:ee.tasks.map(V=>f.deserialize(z,V)),retired:!0})})(E||(e.TestResultItem=E={}));var D;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(z,ee)=>{z.covered+=ee.covered,z.total+=ee.total}})(D||(e.ICoverageCount=D={}));var S;(function(U){U.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testIds:z.testIds,uri:z.uri.toJSON()}),U.deserialize=(z,ee)=>({id:ee.id,statement:ee.statement,branch:ee.branch,declaration:ee.declaration,testIds:ee.testIds,uri:z.asCanonicalUri(r.URI.revive(ee.uri))}),U.empty=(z,ee)=>({id:z,uri:ee,statement:D.empty()})})(S||(e.IFileCoverage=S={}));function I(U){return{...U,location:U.location?.toJSON()}}function A(U){return U.location=U.location?h.$Qt.isIPosition(U.location)?h.$Qt.lift(U.location):C.$Rt.lift(U.location):void 0,U}e.$gJ=3;var $;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})($||(e.DetailType=$={}));var v;(function(U){U.serialize=z=>z.type===$.Declaration?N.serialize(z):L.serialize(z),U.deserialize=z=>z.type===$.Declaration?N.deserialize(z):L.deserialize(z)})(v||(e.CoverageDetails=v={}));var M;(function(U){U.serialize=I,U.deserialize=A})(M||(e.IBranchCoverage=M={}));var N;(function(U){U.serialize=I,U.deserialize=A})(N||(e.IDeclarationCoverage=N={}));var L;(function(U){U.serialize=z=>({...I(z),branches:z.branches?.map(M.serialize)}),U.deserialize=z=>({...A(z),branches:z.branches?.map(M.deserialize)})})(L||(e.IStatementCoverage=L={}));var F;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var B;(function(U){U.deserialize=(z,ee)=>ee.op===F.Add?{op:ee.op,item:d.deserialize(z,ee.item)}:ee.op===F.Update?{op:ee.op,item:l.deserialize(ee.item)}:ee.op===F.DocumentSynced?{op:ee.op,uri:z.asCanonicalUri(r.URI.revive(ee.uri)),docv:ee.docv}:ee,U.serialize=z=>z.op===F.Add?{op:z.op,item:d.serialize(z.item)}:z.op===F.Update?{op:z.op,item:l.serialize(z.item)}:z})(B||(e.TestsDiffOp=B={}));class j{constructor(z){this.l=z,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(z){const ee=this.x();for(const V of z)switch(V.op){case F.Add:this.p(d.deserialize(this.l,V.item),ee);break;case F.Update:this.q(l.deserialize(V.item),ee);break;case F.Remove:this.v(V.itemId,ee);break;case F.Retire:this.w(V.itemId);break;case F.IncrementPendingExtHosts:this.updatePendingRoots(V.amount);break;case F.AddTag:this.f.set(V.tag.id,V.tag);break;case F.RemoveTag:this.f.delete(V.id);break}ee.complete?.()}p(z,ee){const V=R.$$I.parentId(z.item.extId)?.toString();let W;if(!V)W=this.y(z),this.h.add(W),this.g.set(z.item.extId,W);else if(this.g.has(V)){const J=this.g.get(V);J.children.add(z.item.extId),W=this.y(z,J),this.g.set(z.item.extId,W)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return ee.add?.(W),z.expand===n.BusyExpanding&&this.j++,W}q(z,ee){const V=this.g.get(z.extId);if(V)return z.expand!==void 0&&(V.expand===n.BusyExpanding&&this.j--,z.expand===n.BusyExpanding&&this.j++),(0,e.$fJ)(V,z),ee.update?.(V),V}v(z,ee){const V=this.g.get(z);if(!V)return;const W=R.$$I.parentId(V.item.extId)?.toString();W?this.g.get(W).children.delete(V.item.extId):this.h.delete(V);const J=[[z]];for(;J.length;)for(const _ of J.pop()){const ce=this.g.get(_);ce&&(J.push(ce.children),this.g.delete(_),ee.remove?.(ce,ce!==V),ce.expand===n.BusyExpanding&&this.j--)}}w(z){}updatePendingRoots(z){this.k+=z}x(){return{}}}e.$hJ=j}),define(ke[264],Ie([1,0,138,8,74]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$VGb=e.$UGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var T;(function(y){y.List="list",y.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var O;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const b={[C.TestResultState.Errored]:(0,h.localize)(10787,null),[C.TestResultState.Failed]:(0,h.localize)(10788,null),[C.TestResultState.Passed]:(0,h.localize)(10789,null),[C.TestResultState.Queued]:(0,h.localize)(10790,null),[C.TestResultState.Running]:(0,h.localize)(10791,null),[C.TestResultState.Skipped]:(0,h.localize)(10792,null),[C.TestResultState.Unset]:(0,h.localize)(10793,null)},c=(y,u)=>(0,h.localize)(10794,null,(0,r.$1k)(y),b[u]);e.$UGb=c,e.$VGb={[C.TestRunProfileBitset.Debug]:(0,h.localize)(10795,null),[C.TestRunProfileBitset.Run]:(0,h.localize)(10796,null),[C.TestRunProfileBitset.Coverage]:(0,h.localize)(10797,null)};var k;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(k||(e.TestCommandId=k={}))}),define(ke[120],Ie([1,0,7,4,3,65,74,73]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const c=(f,i)=>f===i,y=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of y)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class P extends C.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new h.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case T.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===T.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case T.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===T.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,T.$fJ)(s.item,i.item);return}if(s.op===T.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,T.$fJ)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===T.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,s-1):o.wait().then(()=>this.L(t,s-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,s-1)):this.L(t,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case b.RemoveChild:this.O(O.$$I.joinToString(i.fullId,s.id));break;case b.Upsert:this.z(s.item,i);break;case b.Bulk:for(const t of s.ops)this.w(i,t);break;case b.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case b.UpdateCanResolveChildren:this.J(i);break;case b.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case b.DocumentSynced:this.y(i.actual.uri);break;default:(0,R.$fd)(s)}}y(i){i&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const t=O.$$I.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.s.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,s),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,s);return}if(n.actual===i){this.H(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,s);const d=this.s.getChildren(n.actual),l=n.actual,g=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=T.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:b.SetProp,update:g})),this.I(i,n,s);for(const[D,S]of d)this.s.getChildren(i).get(S.id)||this.O(O.$$I.joinToString(t,S.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===T.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.D(n);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,T.$dJ)(this.s.controllerId,n.id))}}}),o.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$dJ)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$dJ)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.w(s,n),this.J(s)}I(i,s,t){this.H(i,s,t);for(const[o,n]of this.s.getChildren(i))this.z(n,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:s=T.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===T.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const t=[];for(const[o,n]of this.s.getChildren(i.actual)){const d=this.expand(O.$$I.joinToString(i.fullId,n.id),s);(0,r.$sh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Fh;return n.open(),n}i.expand=T.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new r.$Fh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$sh)(o)?o.catch(t).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.F(n.id);this.tree.delete(o.fullId.toString());for(const[n,d]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$$I.joinToString(o.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$eQ=P;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$fQ=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gQ=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.$hQ=m;const p=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const d of t.values())o.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,d=new Set(t.keys()),l={op:b.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const E=i(g).controllerId;if(E!==f.controllerId)throw new m(g.id,E,f.controllerId);if(n.has(g.id))throw new w(g.id);n.set(g.id,g),d.delete(g.id),l.ops.push({op:b.Upsert,item:g})}for(const g of d.keys())l.ops.push({op:b.RemoveChild,id:g});f.listener?.(l),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:b.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:b.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$iQ=p}),define(ke[158],Ie([1,0,120]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0;const h=new WeakMap,C=(T,O)=>{const b={controllerId:O};return h.set(T,b),b};e.$jQ=C;const R=T=>{const O=h.get(T);if(!O)throw new r.$gQ(T?.id||"<unknown>");return O};e.$kQ=R}),define(ke[121],Ie([1,0,26,14,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ODb=e.$NDb=e.$MDb=void 0,e.$PDb=R,e.$QDb=O,e.$MDb="vscode-cdn.net",e.$NDb=`vscode-resource.${e.$MDb}`,e.$ODb=`'self' https://*.${e.$MDb}`;function R(b,c){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(c&&c.authority&&c.isRemote&&b.scheme===h.Schemas.file&&(b=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:b.path})),C.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${T(b.authority)}.${e.$NDb}`,path:b.path,fragment:b.fragment,query:b.query}))}function T(b){return b.replace(/./g,c=>{const k=c.charCodeAt(0);return k>=r.CharCode.a&&k<=r.CharCode.z||k>=r.CharCode.A&&k<=r.CharCode.Z||k>=r.CharCode.Digit0&&k<=r.CharCode.Digit9?c:"-"+k.toString(16).padStart(4,"0")})}function O(b){return b.replace(/-([0-9a-f]{4})/g,(c,k)=>String.fromCharCode(parseInt(k,16)))}}),define(ke[265],Ie([1,0,4,3,121]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0;class R{constructor(O,b,c){this.d=O,this.e=b,this.f=c,this.a=0,this.b=new h.$Uc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const k=b.getVisibleTextEditors();for(const y of this.c.values())k.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,b,c,k,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){u=i;break}if(!u)throw new Error("not a visible editor");const P=this,w=this.a++,a=new r.$me,m=new r.$me,p=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$PDb)(i,P.f)}get cspSource(){return C.$ODb}set options(i){this.b=i,P.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(w,i)}},f=new class{constructor(){this.editor=O,this.line=b,this.height=c,this.webview=p,this.onDidDispose=m.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,b+1,c,k||{},y.identifier,y.extensionLocation),this.c.set(w,{editor:O,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(O){const b=this.c.get(O);b&&b.inset.dispose()}$onDidReceiveMessage(O,b){this.c.get(O)?.onDidReceiveMessage.fire(b)}}e.$1pc=R}),define(ke[159],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0,e.$QM="__",e.$RM=(0,r.$Gi)("IAuthenticationService"),e.$SM=(0,r.$Gi)("IAuthenticationExtensionsService")}),define(ke[266],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=e.VariableKind=e.$cR=void 0,e.$cR=(0,r.$Gi)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class C extends Error{constructor(T,O){super(O),this.variable=T}}e.$dR=C}),define(ke[267],Ie([1,0,16,55,17,24,10,107,8,266,12]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=void 0,r=We(r),h=We(h),C=We(C),R=We(R);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,w,a,m){this.h=new Map,this.a=P,this.b=w,this.g=a,m&&(this.c=m.then(p=>this.i(p)))}i(P){if(T.$j){const w=Object.create(null);return Object.keys(P).forEach(a=>{w[a.toLowerCase()]=P[a]}),w}return P}resolveWithEnvironment(P,w,a){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(P,w){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,w)}async j(P,w,a,m){const p=R.$fo(w);T.$j&&p.windows?Object.keys(p.windows).forEach(i=>p[i]=p.windows[i]):T.$k&&p.osx?Object.keys(p.osx).forEach(i=>p[i]=p.osx[i]):T.$l&&p.linux&&Object.keys(p.linux).forEach(i=>p[i]=p.linux[i]),delete p.windows,delete p.osx,delete p.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,P?P.uri:void 0,p,a,m)}async resolveAnyAsync(P,w,a){return this.j(P,w,a)}async resolveAnyMap(P,w,a){const m=new Map;return{newConfig:await this.j(P,w,a,m),resolvedVariables:m}}resolveWithInteractionReplace(P,w,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,a,m,p){if(C.$fg(a))return this.m(P,w,a,m,p);if(Array.isArray(a))return Promise.all(a.map(f=>this.l(P,w,f,m,p)));if(C.$hg(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.m(P,w,s,m,p),await this.l(P,w,a[s],m,p)]));for(const[s,t]of i)f[s]=t;return f}return a}m(P,w,a,m,p){return(0,k.$yf)(a,y.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(y.VARIABLE_LHS))return f;let s=await this.o(P,f,i,w,m);return p?.set(i,s),s!==f&&C.$fg(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.m(P,w,s,m,p)),s})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,a,m,p){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const d=this.a.getFilePath();if(d)return(0,O.$5w)(d);throw new c.$dR(n,(0,b.localize)(12038,null,w))},t=n=>{const d=s(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,O.$5w)(l)}throw new c.$dR(n,(0,b.localize)(12039,null,w,r.$oc(d)))},o=n=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new c.$dR(n,(0,b.localize)(12040,null,w,f))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$dR(n,(0,b.localize)(12041,null,w)):new c.$dR(n,(0,b.localize)(12042,null,w))};switch(a){case"env":if(f){if(P.env){const n=P.env[T.$j?f.toLowerCase():f];if(C.$fg(n))return n}return""}throw new c.$dR(c.VariableKind.Env,(0,b.localize)(12043,null,w));case"config":if(f){const n=this.a.getConfigurationValue(m,f);if(C.$og(n))throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12044,null,w,f));if(C.$hg(n))throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12045,null,w,f));return n}throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12046,null,w));case"command":return this.p(c.VariableKind.Command,w,f,p,"command");case"input":return this.p(c.VariableKind.Input,w,f,p,"input");case"extensionInstallFolder":if(f){const n=await this.a.getExtension(f);if(!n)throw new c.$dR(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(12047,null,w,f));return this.n(n.extensionLocation)}throw new c.$dR(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(12048,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,O.$5w)(this.n(o(c.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,O.$5w)(this.n(o(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$5w)(r.$oc(this.n(o(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$dR(c.VariableKind.UserHome,(0,b.localize)(12049,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$dR(c.VariableKind.LineNumber,(0,b.localize)(12050,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$dR(c.VariableKind.SelectedText,(0,b.localize)(12051,null,w))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$oc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.$mc(this.n(o(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$nc(s(c.VariableKind.RelativeFileDirname));if(m||f){const d=r.$mc(this.n(o(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$nc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$pc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$oc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$oc(s(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$pc(n).length)}case"fileDirnameBasename":return r.$oc(r.$nc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.p(c.VariableKind.Unknown,w,n,p,void 0)}catch{return w}}}}p(P,w,a,m,p){if(a&&m){const f=p===void 0?m[a]:m[p+":"+a];if(typeof f=="string")return f;throw new c.$dR(P,(0,b.localize)(12052,null,w))}return w}}e.$sR=y}),define(ke[160],Ie([1,0,5,155]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$xE=void 0,e.$yE=c,e.$zE=u,e.$AE=P,e.$xE=(0,r.$Gi)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var O;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var b;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function c(w){const a=w;return(0,h.$jG)(a?.editor)&&(0,h.$jG)(a?.replacement)}var k;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k||(e.GroupsOrder=k={}));var y;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(ke[268],Ie([1,0,5,160]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=e.$DE=e.$CE=e.$BE=void 0,e.$FE=C,e.$BE=(0,r.$Gi)("editorService"),e.$CE=-1,e.$DE=-2,e.$EE=-3;function C(R){const T=R;return typeof R=="number"||(0,h.$zE)(T)}}),define(ke[161],Ie([1,0,5,146]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$_M=(0,r.$Hi)(h.$Ni)}),define(ke[162],Ie([1,0,23,4,16,3,7]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=e.$4dc=e.$3dc=void 0,C=We(C);class O{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.$3dc=O;class b{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this.j=f,this.c=new h.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$un,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const i=this.j.readActivationEvents(f);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,i){this.e=m(this.e,i),this.e=this.e.concat(f);const s=b.l(this.e);return this.e=m(this.e,s.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,s)}static l(f){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const g=i.getArcs(d);for(let E=0;E<g.length;E++)if(!l.has(g[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$un;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$sn.toKey(d.identifier),r.$sn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const o=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<o.length;d++){const l=o[d];i.hasOnlyGoodArcs(l,t)&&(o.splice(d,1),d--,t.add(l),n=!0)}}while(n);return o.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this.h.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this.f.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this.g)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$4dc=b;class c{constructor(f,i){this.versionId=f,this.extensions=i}}e.$5dc=c;class k{constructor(f){this.d=new P,this.c=new b(f,[])}async acquireLock(f){const i=await this.d.acquire(f);return new y(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this.c.getExtensionDescriptionByIdOrUUID(f,i)}}e.$6dc=k;class y extends R.$Vc{constructor(f,i){super(),this.f=f,this.c=!1,this.B(i)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$7dc=y;class u{constructor(f){this.name=f;const i=(0,T.$zh)();this.promise=i.promise,this.c=i.resolve}resolve(f){this.c(f)}}class P{constructor(){this.c=[],this.d=!1}async acquire(f){const i=new u(f);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};f.resolve((0,R.$Tc)(t))}}var w;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})(w||(w={}));function a(p,f){const i=p.isBuiltin?w.Builtin:p.isUnderDevelopment?w.Dev:w.User,s=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User;if(i!==s)return i-s;const t=C.$hc.basename(p.extensionLocation.path),o=C.$hc.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m(p,f){const i=new r.$tn(f);return p.filter(s=>!i.has(s.identifier))}}),define(ke[269],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.ExtHostConnectionType=void 0,e.$gn=O,e.$hn=b;var r;(function(k){k[k.IPC=1]="IPC",k[k.Socket=2]="Socket",k[k.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=r.IPC}serialize(y){y[h.ENV_KEY]=this.pipeName}}e.$dn=h;class C{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[C.ENV_KEY]="1"}}e.$en=C;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[R.ENV_KEY]="1"}}e.$fn=R;function T(k){delete k[h.ENV_KEY],delete k[C.ENV_KEY],delete k[R.ENV_KEY]}function O(k,y){T(y),k.serialize(y)}function b(k){if(k[h.ENV_KEY])return c(k,new h(k[h.ENV_KEY]));if(k[C.ENV_KEY])return c(k,new C);if(k[R.ENV_KEY])return c(k,new R);throw new Error("No connection information defined in environment!")}function c(k,y){return T(k),y}}),define(ke[93],Ie([1,0,21]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=T,e.$Dn=O;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var C;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(c){const k=r.$Oe.alloc(1);switch(c){case R.Initialized:k.writeUInt8(1,0);break;case R.Ready:k.writeUInt8(2,0);break;case R.Terminate:k.writeUInt8(3,0);break}return k}function O(c,k){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return k===R.Initialized;case 2:return k===R.Ready;case 3:return k===R.Terminate;default:return!1}}var b;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[94],Ie([1,0,5,4,151,11,29,93,90,91,24,2,3,8]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$GQ=e.$FQ=void 0,e.$HQ=m;let w=class extends u.$Vc{constructor(f,i){super(),this.s=f,this.t=i,this.a=this.B(new h.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Dp,name:(0,P.localize)(2700,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,R.$dk)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this.f=f,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$jn)((0,c.$Jp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const i=this.getTelemetryDetails();this.r.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,i){const t=this.r.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.$FQ=w,e.$FQ=w=Ze([Ve(0,T.$EQ),Ve(1,R.$ck)],w);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,d){this.g=s,this.h=t,this.i=o,this.j=n,this.a=new h.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,i){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,c.$Mp)(i,[]),this.c&&(i=(0,k.$io)(i,this.c)),this.b||(i=(0,k.$io)(i,this.j)),"properties"in f?f.properties=i:f=i,f}k(f,i){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(f,i),this.h.trace(f,i))}logUsage(f,i){this.d.isUsageEnabled&&this.k(f,i)}logError(f,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,c.$Mp)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$GQ=a;function m(p){const f=Date.now()-new Date(p).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$IQ=(0,r.$Gi)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,241,149,23,5]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.ActivationKind=e.$lH=e.$kH=e.$hH=e.ExtensionHostStartup=e.$gH=e.$fH=e.$eH=e.$dH=void 0,e.$iH=u,e.$jH=P,e.$mH=p,e.$nH=f,e.$dH=Object.freeze({identifier:new T.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$eH="extensions.webWorker",e.$fH=(0,O.$Gi)("extensionService");class b{constructor(t){this.dependency=t}}e.$gH=b;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class k{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,n){this.c=t,this.d=o.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$2G.createActivationEventsMap(this.d)}}set(t,o,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],g=[],E=[],D=y(this.d),S=y(o),I=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=S.get(N.identifier);if(!L){d.push(N.identifier),D.delete(N.identifier);continue}if(!I(N,L)){d.push(N.identifier),D.delete(N.identifier);continue}}for(const N of o){const L=D.get(N.identifier);if(!L){l.push(N);continue}if(!I(L,N)){d.push(L.identifier),D.delete(L.identifier);continue}}const A=new T.$tn(this.e),$=new T.$tn(n);for(const N of this.e)$.has(N)||g.push(N);for(const N of n)A.has(N)||E.push(N);const v=R.$2G.createActivationEventsMap(l),M={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:g,myToAdd:E};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:d,myToAdd:l}=t,g=new T.$tn(o),E=new T.$tn(d);for(let D=0;D<this.d.length;D++)g.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,t}containsExtension(t){for(const o of this.e)if(T.$sn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const n=R.$2G.readActivationEvents(o);for(const d of n)t.add(d)}return t}}e.$hH=k;function y(s){const t=new T.$un;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function P(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class w{constructor(t,o,n,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=d}}e.$kH=w;class a{constructor(t,o){this.description=t,this.value=o}}e.$lH=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function p(s){return{type:s.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.$Sp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,C.$Qp)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new T.$sn(o),isBuiltin:s.type===T.ExtensionType.System,isUserBuiltin:s.type===T.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$oH=i}),define(ke[270],Ie([1,0,13,3,162,23,25,11,7]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.$mqc=e.$lqc=e.$kqc=void 0,r=We(r);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.$kqc=c;class k{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,i){return f===-1||i===-1?-1:i-f}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$lqc=k;class y{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.$mqc=y;class u extends y{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}e.$nqc=u;class P extends y{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}e.$oqc=P;class w extends y{constructor(f){super(!0,f,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}let a=class{constructor(f,i,s,t){this.g=t,this.a=f,this.b=i,this.c=s,this.d=new R.$un,this.f=Object.create(null)}dispose(){for(const[f,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this.d)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this.d.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this.d.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this.f[f])return;const s=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,i){const s=this.a.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const i=this.a.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this.k(f,null,[],new w(o));return this.c.onExtensionActivationError(f.id,o,new T.$gH(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const n=this.d.get(o);if(n){s.push(n);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:f.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;s.push(this.j({id:d.identifier,reason:f.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),E=this.k(f,i.displayName,[],new w(g));return this.c.onExtensionActivationError(i.identifier,g,new T.$gH(o)),E}return this.k(f,i.displayName,s,null)}k(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this.c,this.g);return this.d.set(f.id,o),o}l(f){return C.$4dc.isHostExtension(f,this.a,this.b)}m(f){const i=this.b.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.$pqc=a,e.$pqc=a=Ze([Ve(3,O.$bk)],a);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,i,s,t,o,n,d){this.c=f,this.d=i,this.f=s,this.g=t,this.h=o,this.j=n,this.k=d,this.a=new b.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const i=this.g[f];if(i.value&&!i.value.activationFailed){this.g.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new w(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this.h=new w(i),this.b&&r.$4(f))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=Ze([Ve(6,O.$bk)],m)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[163],Ie([1,0,8,13,43,148,116,36,23,115,149,145]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=void 0,r=We(r),C=Ut(C);const u=O.$so.as(T.$to.JSONContribution);class P{constructor(t,o,n){this.a=t,this.b=o,this.c=n}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$0G=P;class w{static a(t){const o=new b.$tn;for(let n=0,d=t.length;n<d;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new w(o,[]);if(!o||!o.length)return new w([],t);const n=this.a(t),d=this.a(o),l=o.filter(E=>!n.has(E.description.identifier)),g=t.filter(E=>!d.has(E.description.identifier));return new w(l,g)}constructor(t,o){this.added=t,this.removed=o}}e.$$G=w;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Z)(t)}}}e.$_G=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(12207,null),r.localize(12208,null)]},p="vscode://schemas/vscode-extensions";e.$aH={properties:{engines:{type:"object",description:r.localize(12209,null),properties:{vscode:{type:"string",description:r.localize(12210,null),default:"^1.22.0"}}},publisher:{description:r.localize(12211,null),type:"string"},displayName:{description:r.localize(12212,null),type:"string"},categories:{description:r.localize(12213,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$rn},{type:"string",const:"Languages",deprecationMessage:r.localize(12214,null)}]}},galleryBanner:{type:"object",description:r.localize(12215,null),properties:{color:{description:r.localize(12216,null),type:"string"},theme:{description:r.localize(12217,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(12218,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12219,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(12220,null)},enabledApiProposals:{markdownDescription:r.localize(12221,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(12222,null),type:"string",enum:["none"],enumDescriptions:[r.localize(12223,null)]},activationEvents:{description:r.localize(12224,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(12225,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(12226,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(12227,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(12228,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(12229,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(12230,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(12231,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(12232,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(12233,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(12234,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(12235,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(12236,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(12237,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(12238,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(12239,null)},{label:"onUri",body:"onUri",description:r.localize(12240,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(12241,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(12242,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(12243,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(12244,null)},{label:"onRenderer",description:r.localize(12245,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(12246,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(12247,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(12248,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(12249,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(12250,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(12251,null)},{label:"*",description:r.localize(12252,null),body:"*"}]}},badges:{type:"array",description:r.localize(12253,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(12254,null)},href:{type:"string",description:r.localize(12255,null)},description:{type:"string",description:r.localize(12256,null)}}}},markdown:{type:"string",description:r.localize(12257,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(12258,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(12259,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$_o}},extensionPack:{description:r.localize(12260,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$_o}},extensionKind:{description:r.localize(12261,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(12262,null)},{body:["workspace"],description:r.localize(12263,null)},{body:["ui","workspace"],description:r.localize(12264,null)},{body:["workspace","ui"],description:r.localize(12265,null)},{body:[],description:r.localize(12266,null)}]},capabilities:{description:r.localize(12267,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(12268,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(12269,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(12270,null),r.localize(12271,null),r.localize(12272,null)]},description:{type:"string",markdownDescription:r.localize(12273,null)}}},untrustedWorkspaces:{description:r.localize(12274,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(12275,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(12276,null),r.localize(12277,null),r.localize(12278,null)]},restrictedConfigurations:{description:r.localize(12279,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(12280,null)}}}}},sponsor:{description:r.localize(12281,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(12282,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(12283,null),type:"string"},"vscode:uninstall":{description:r.localize(12284,null),type:"string"}}},icon:{type:"string",description:r.localize(12285,null)},l10n:{type:"string",description:r.localize(12286,null)},pricing:{type:"string",markdownDescription:r.localize(12287,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&k.$2G.register(t.extensionPoint,t.activationEventsGenerator),e.$aH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(p,e.$aH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$bH=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$so.add(i.ExtensionsRegistry,new f),e.$cH=O.$so.as(i.ExtensionsRegistry),u.registerSchema(p,e.$aH),u.registerSchema(c.$vk,{properties:{extensionEnabledApiProposals:{description:r.localize(12288,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(ke[271],Ie([1,0,4,39,3,12,8,23,5,11,25,163]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$pH=(0,b.$Gi)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(4698,null)}}};e.$qH=y.$cH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(4699,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,m)=>{for(const p of a)m.push(`onLanguageModelChat:${p.vendor}`)}});let w=class{constructor(m,p){this.e=m,this.f=p,this.a=new C.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$qH.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,k.$iH)(s.description,"chatProvider")){s.collector.error((0,T.localize)(4700,null));continue}for(const t of h.Iterable.wrap(s.value)){if(this.c.has(t.vendor)){s.collector.error((0,T.localize)(4701,null,t.vendor));continue}if((0,R.$df)(t.vendor)){s.collector.error((0,T.localize)(4702,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,T.localize)(4703,null));continue}this.c.add(t.vendor)}}const i=[];for(const[s,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const p=[];for(const[f,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>O.$sn.equals(s,m.extension)))&&p.push(f);return this.f.trace("[LM] selected language models",m,p),p}registerLanguageModelChat(m,p){if(this.f.trace("[LM] registering language model chat",m,p.metadata),!this.c.has(p.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${p.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,p),this.d.fire({added:[{identifier:m,metadata:p.metadata}]}),(0,C.$Tc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,p.metadata))})}async sendChatRequest(m,p,f,i,s){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,p,i,s)}computeTokenLength(m,p,f){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount(p,f)}};e.$rH=w,e.$rH=w=Ze([Ve(0,k.$fH),Ve(1,c.$bk)],w)}),define(ke[272],Ie([1,0,8,17,24,163,35,4]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=void 0,r=We(r),h=We(h),C=We(C);const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(9826,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(9827,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(9828,null),default:""}}};var c;(function(u){function P(w,a,m){if(!w)return;const p=h.$fg(w.type)?w.type:void 0;if(!p||p.length===0){m.error(r.localize(9829,null));return}const f=[];if(Array.isArray(w.required))for(const i of w.required)h.$fg(i)&&f.push(i);return{extensionId:a.value,taskType:p,required:f,properties:w.properties?C.$fo(w.properties):{},when:w.when?T.$Ej.deserialize(w.when):void 0}}u.from=P})(c||(c={}));const k=R.$cH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const w of u)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(9830,null),type:"array",items:b}});class y{constructor(){this.d=new O.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{k.setHandler((a,m)=>{this.c=void 0;try{for(const p of m.removed){const f=p.value;for(const i of f)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const p of m.added){const f=p.value;for(const i of f){const s=c.from(i,p.description.identifier,p.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$fo(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$YI=new y}),define(ke[273],Ie([1,0,8,17,22,24,35,272,46]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$9I=e.JsonSchemaVersion=e.ExecutionEngine=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$3I=e.ShellQuoting=e.$2I=e.$1I=e.$ZI=void 0,r=We(r),h=We(h),C=We(C),R=We(R),e.$ZI="settings",e.$1I=new T.$Xj("taskRunning",!1,r.localize(9831,null)),e.$2I=r.localize2(9833,"Tasks");var c;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$3I="$customized",function(j){function U(z){if(!z)return j.Strong;switch(z.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(c||(e.ShellQuoting=c={}));var k;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var y;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(y||(e.RevealKind=y={})),function(j){function U(z){switch(z.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(y||(e.RevealKind=y={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function U(z){switch(z.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(u||(e.RevealProblemKind=u={}));var P;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(P||(e.PanelKind=P={})),function(j){function U(z){switch(z.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}(P||(e.PanelKind=P={}));var w;(function(j){j.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(j){function U(ee){switch(ee.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function z(ee){switch(ee){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=z}(a||(e.RuntimeType=a={}));var m;(function(j){function U(z){return h.$fg(z)?z:z.value}j.value=U})(m||(e.CommandString=m={}));var p;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(ee){return ee===j.Clean._id||ee===j.Build._id||ee===j.Rebuild._id||ee===j.Test._id}j.is=U;function z(ee){if(ee!==void 0)return h.$fg(ee)?U(ee)?{_id:ee,isDefault:!1}:void 0:ee}j.from=z})(p||(e.TaskGroup=p={}));var f;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(z){switch(z){case j.User:return b.ConfigurationTarget.USER;case j.WorkspaceFile:return b.ConfigurationTarget.WORKSPACE;default:return b.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var s;(function(j){j.parallel="parallel",j.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(U,z,ee,V,W,J){this._label="",this._id=U,z&&(this._label=z),ee&&(this.type=ee),this.runOptions=V,this.configurationProperties=W,this._source=J}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(h.$fg(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$4I=n;class d extends n{constructor(U,z,ee,V,W,J,_,ce){super(U,ee,void 0,_,ce,z),this.command={},this._source=z,this.hasDefinedMatchers=J,W&&(this.command=W)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case a.Shell:z="shell";break;case a.Process:z="process";break;case a.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof d}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const ee={type:e.$3I,folder:U,id:z};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new d(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$5I=d;class l extends n{constructor(U,z,ee,V,W,J,_){super(U,ee,V,J,_,z),this._source=z,this.configures=W}static is(U){return U instanceof l}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const ee={type:e.$3I,folder:U,id:z};return JSON.stringify(ee)}}e.$6I=l;class g extends n{constructor(U,z,ee,V,W,J,_,ce,ne){super(U,ee,V,ce,ne,z),this.defines=W,this.hasDefinedMatchers=_,this.command=J,this.icon=ne.icon,this.hide=ne.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof g}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new g(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$7I=g;class E extends n{constructor(U,z,ee,V,W,J){super(U,ee,V,W,J,z),this._source=z}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new E(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$8I=E;var D;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(j){j._default=j.Terminal}(D||(e.ExecutionEngine=D={}));var S;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const ee=U.getWorkspaceFolder(),V=z.getWorkspaceFolder();if(ee&&V){let W=this.c.get(ee.uri.toString());W=W===void 0?0:W+1;let J=this.c.get(V.uri.toString());return J=J===void 0?0:J+1,W===J?U._label.localeCompare(z._label):W-J}else return!ee&&V?-1:ee&&!V?1:0}}e.$9I=I;var A;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(A||(e.TaskEventKind=A={}));var $;(function(j){j.SingleRun="singleRun",j.Background="background"})($||(e.TaskRunType=$={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var M;(function(j){function U(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?$.Background:$.SingleRun,group:ce.configurationProperties.group,__task:ce}}function z(ce,ne,ye){return{...U(ce),kind:A.Start,terminalId:ne,resolvedVariables:ye}}j.start=z;function ee(ce,ne,ye){return{...U(ce),kind:A.ProcessStarted,terminalId:ne,processId:ye}}j.processStarted=ee;function V(ce,ne,ye){return{...U(ce),kind:A.ProcessEnded,terminalId:ne,exitCode:ye}}j.processEnded=V;function W(ce,ne,ye){return{...U(ce),kind:A.Terminated,exitReason:ye,terminalId:ne}}j.terminated=W;function J(ce,ne,ye){return{...U(ne),kind:ce,terminalId:ye}}j.general=J;function _(){return{kind:A.Changed}}j.changed=_})(M||(e.TaskEvent=M={}));var N;(function(j){function U(ee){const V=Object.keys(ee).sort();let W="";for(const J of V){let _=ee[J];_ instanceof Object?_=U(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),W+=J+","+_+","}return W}function z(ee){const W={_key:U(ee),type:ee.taskType};return Object.assign(W,ee),W}j.create=z})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var F;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var B;(function(j){function U(z,ee){const V=O.$YI.get(z.type);if(V===void 0){const ce=R.$fo(z);return delete ce._key,N.create(ce)}const W=Object.create(null);W.type=V.taskType;const J=new Set;V.required.forEach(ce=>J.add(ce));const _=V.properties;for(const ce of Object.keys(_)){const ne=z[ce];if(ne!=null)W[ce]=ne;else if(J.has(ce)){const ye=_[ce];if(ye.default!==void 0)W[ce]=R.$fo(ye.default);else switch(ye.type){case"boolean":W[ce]=!1;break;case"number":case"integer":W[ce]=0;break;case"string":W[ce]="";break;default:ee.error(r.localize(9832,null,JSON.stringify(z,void 0,0),ce));return}}}return N.create(W)}j.createTaskIdentifier=U})(B||(e.TaskDefinition=B={}))}),define(ke[274],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,O)=>{this.b=T,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,r.$Z)(T))}then(T,O){return this.j().then(T,O)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$8dc=h;class C extends h{constructor(){super(),this.h=!0,this.i=new r.$5}}e.$9dc=C}),define(ke[53],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$Yw=void 0,e.$Zw=C,e.$1w=R;class r{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.$Yw=r;const h=[];function C(O){const b=new r(O);return h[b.nid]=b,b}function R(O){return h[O].sid}class T{constructor(b){this.value=b}}e.$2w=T}),define(ke[6],Ie([1,0,53]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$NN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var O;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var k;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(k||(e.CandidatePortSource=k={}));class y{static{this.a=0}static mixin(m){return m._id=y.a++,m}}e.$NN=y;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$ON={MainThreadAuthentication:(0,r.$Zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Zw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Zw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Zw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Zw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Zw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Zw)("MainThreadCommands"),MainThreadComments:(0,r.$Zw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Zw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Zw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Zw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Zw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Zw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Zw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Zw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Zw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Zw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Zw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Zw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Zw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Zw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Zw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Zw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Zw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Zw)("MainThreadSCM"),MainThreadSearch:(0,r.$Zw)("MainThreadSearch"),MainThreadShare:(0,r.$Zw)("MainThreadShare"),MainThreadTask:(0,r.$Zw)("MainThreadTask"),MainThreadWindow:(0,r.$Zw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Zw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Zw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Zw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Zw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Zw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Zw)("MainThreadAiEmbeddingVector")},e.$PN={ExtHostCommands:(0,r.$Zw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Zw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Zw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Zw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Zw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Zw)("ExtHostSCM"),ExtHostSearch:(0,r.$Zw)("ExtHostSearch"),ExtHostTask:(0,r.$Zw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Zw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Zw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Zw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Zw)("ExtHostProgress"),ExtHostComments:(0,r.$Zw)("ExtHostComments"),ExtHostSecretState:(0,r.$Zw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Zw)("ExtHostStorage"),ExtHostUrls:(0,r.$Zw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Zw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Zw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Zw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Zw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Zw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Zw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Zw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Zw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Zw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Zw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Zw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Zw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Zw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Zw)("ExtHostLocalization")}}),define(ke[95],Ie([1,0,5,11,6,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=void 0,C=We(C),e.$Jpc=(0,r.$Gi)("IExtHostApiDeprecationService");let T=class{constructor(b,c){this.c=c,this.a=new Set,this.b=b.getProxy(C.$ON.MainThreadTelemetry)}report(b,c,k){const y=this.d(b,c);this.a.has(y)||(this.a.add(y),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${k}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:b}))}d(b,c){return`${b}-${c.identifier.value}`}};e.$Kpc=T,e.$Kpc=T=Ze([Ve(0,R.$oQ),Ve(1,h.$bk)],T),e.$Lpc=Object.freeze(new class{report(O,b,c){}})}),define(ke[275],Ie([1,0,6]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class h{constructor(R){const T=R.getProxy(r.$ON.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(O){return T.$writeText(O)}})}}e.$Ypc=h}),define(ke[276],Ie([1,0,24,6,29,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;let T=class{constructor(k,y){this.a=k.getProxy(h.$ON.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(k,y){const u=this,P=console[k];Object.defineProperty(console,k,{set:()=>{},get:()=>function(){u.e(k,y,P,arguments)}})}e(k,y,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:b(P,this.b)}),this.c&&this.f(k,u,P)}};e.$Urc=T,e.$Urc=T=Ze([Ve(0,R.$oQ),Ve(1,C.$EQ)],T);const O=1e5;function b(c,k){const y=[];if(c.length)for(let u=0;u<c.length;u++){let P=c[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}y.push(P)}if(k){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$ko)(y);return u.length>O?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[277],Ie([1,0,2,6,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0;class R{constructor(O){this.a=O.getProxy(h.$ON.MainThreadDialogs)}showOpenDialog(O,b){return b?.allowUIResources&&(0,C.$jH)(O,"showLocal"),this.a.$showOpenDialog(b).then(c=>c?c.map(k=>r.URI.revive(k)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(b=>b?r.URI.revive(b):void 0)}}e.$1qc=R}),define(ke[278],Ie([1,0,20,4,3,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class T{constructor(b){this.b=new Map,this.c=new h.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=b.getProxy(R.$ON.MainThreadEmbeddings)}registerEmbeddingsProvider(b,c,k){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,c),this.b.set(y,{id:c,provider:k}),(0,C.$Tc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(b,c,k){k??=r.CancellationToken.None;let y=!1;typeof c=="string"&&(c=[c],y=!0);const u=await this.a.$computeEmbeddings(b,c,k);if(u.length!==c.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(b,c,k){const y=this.b.get(b);if(!y)return[];const u=await y.provider.provideEmbeddings(c,k);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(b){this.d=new Set(b),this.c.fire()}}e.$4qc=T}),define(ke[279],Ie([1,0,3,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0;class C{constructor(T){this.b=0,this.a=T.getProxy(h.$ON.MainThreadLabelService)}$registerResourceLabelFormatter(T){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,T),(0,r.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$irc=C}),define(ke[122],Ie([1,0,10,12,2,5,11,6,29,19]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=e.$Dqc=void 0;let k=class{constructor(u,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(O.$ON.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,P){const{message:w,args:a,comment:m}=P;if(this.c)return(0,h.$ff)(w,a??{});let p=w;m&&m.length>0&&(p+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.d.get(u)?.contents[p];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${p}`),(0,h.$ff)(f??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),m=JSON.parse(a);P=u.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:w})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(P)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Dqc=k,e.$Dqc=k=Ze([Ve(0,b.$EQ),Ve(1,c.$oQ),Ve(2,T.$bk)],k),e.$Eqc=(0,R.$Gi)("IExtHostLocalizationService")}),define(ke[164],Ie([1,0,11,6,29,19,2,44]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;let b=class extends r.$mk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,O.$di)(P))),this.r=y.getProxy(h.$ON.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(T.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,P){return new c(this.r,y,u,P)}};e.$Trc=b,e.$Trc=b=Ze([Ve(0,R.$oQ),Ve(1,C.$EQ)],b);class c extends r.$hk{constructor(y,u,P,w){super(w?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const P=[[y,u]];this.m?this.u(P):this.n.push(...P)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(ke[123],Ie([1,0,6,5,3,19,21]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=e.$Fqc=void 0,e.$Fqc=(0,h.$Gi)("IExtHostManagedSockets");let O=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(r.$ON.MainThreadManagedSockets)}setFactory(y,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,P=await this.c.makeConnection(),w=new C.$Uc;return this.d.set(u,new c(u,P,w)),w.add((0,C.$Tc)(()=>this.d.delete(u))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,T.$Oe.wrap(a)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Gqc=O,e.$Gqc=O=Ze([Ve(0,R.$oQ)],O);class b{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class c extends C.$Vc{constructor(y,u,P){super(),this.socketId=y,this.actual=u,this.B(P)}}}),define(ke[280],Ie([1,0,6,11,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;function R(O){return O&&O.title}let T=class{constructor(b,c){this.b=c,this.a=b.getProxy(r.$ON.MainThreadMessageService)}showMessage(b,c,k,y,u){const P={source:{identifier:b.identifier,label:b.displayName||b.name}};let w;typeof y=="string"||R(y)?w=[y,...u]:(P.modal=y?.modal,P.useCustom=y?.useCustom,P.detail=y?.detail,w=u),P.useCustom&&(0,C.$jH)(b,"resolvers");const a=[];let m=!1;for(let p=0;p<w.length;p++){const f=w[p];if(typeof f=="string")a.push({title:f,handle:p,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:p}),s&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,f)}return this.a.$showMessage(c,k,P,a).then(p=>{if(typeof p=="number")return w[p]})}};e.$lrc=T,e.$lrc=T=Ze([Ve(1,h.$bk)],T)}),define(ke[281],Ie([1,0,3,17,2,25,6]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0;class O{constructor(c){this.b=new Map,this.a=c.getProxy(T.$ON.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,k,y){if((0,R.$jH)(c,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,y),this.a.$registerProfileContentHandler(k,y.name,y.description,c.identifier.value),(0,r.$Tc)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(c,k,y,u){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(k,y,u)}async $readProfile(c,k,y){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$fg)(k)?k:C.URI.revive(k),y)}}e.$urc=O}),define(ke[124],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=void 0;class R{constructor(O){this.b=new h.$me,this.onDidChangePassword=this.b.event,this.a=O.getProxy(r.$ON.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,b){return this.a.$getPassword(O,b)}store(O,b,c){return this.a.$setPassword(O,b,c)}delete(O,b){return this.a.$deletePassword(O,b)}}e.$Aqc=R,e.$Bqc=(0,C.$Gi)("IExtHostSecretState")}),define(ke[282],Ie([1,0,20,3,6]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=void 0;class R{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(C.$ON.MainThreadSpeech)}async $createSpeechToTextSession(O,b,c){const k=this.c.get(O);if(!k)return;const y=new h.$Uc,u=new r.$xe;this.d.set(b,u);const P=await k.provideSpeechToTextSession(u.token,c?{language:c}:void 0);P&&(y.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,w)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,b,c){const k=this.c.get(O);if(!k)return;const y=new h.$Uc,u=new r.$xe;this.d.set(b,u);const P=await k.provideTextToSpeechSession(u.token,c?{language:c}:void 0);P&&(this.f.set(b,P),y.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(b,w)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(O,b){this.f.get(O)?.synthesize(b)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,b){const c=this.c.get(O);if(!c)return;const k=new h.$Uc,y=new r.$xe;this.d.set(b,y);const u=await c.provideKeywordRecognitionSession(y.token);u&&(k.add(u.onDidChange(P=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,P)})),k.add(y.token.onCancellationRequested(()=>k.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,b,c){const k=R.a++;return this.c.set(k,c),this.b.$registerProvider(k,b,{extension:O,displayName:O.value}),(0,h.$Tc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}}e.$Brc=R}),define(ke[125],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0;class R{constructor(O,b){this.c=b,this.b=new h.$me,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(r.$ON.MainThreadStorage)}registerExtensionStorageKeysToSync(O,b){this.a.$registerExtensionStorageKeysToSync(O,b)}async initializeExtensionStorage(O,b,c){const k=await this.a.$initializeExtensionStorage(O,b);let y;return k&&(y=this.d(O,b,k)),y||c}setValue(O,b,c){return this.a.$setValue(O,b,c)}$acceptValue(O,b,c){const k=this.d(O,b,c);k&&this.b.fire({shared:O,key:b,value:k})}d(O,b,c){try{return JSON.parse(c)}catch(k){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${O}): ${k}`)}}}e.$qqc=R,e.$rqc=(0,C.$Gi)("IExtHostStorage")}),define(ke[283],Ie([1,0,3,14,2,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$ON.MainThreadUriOpeners)}registerExternalUriOpener(b,c,k,y){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=y.schemes.find(P=>!T.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,k),this.b.$registerUriOpener(c,y.schemes,b,y.label),(0,r.$Tc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(b,c,k){const y=this.c.get(b);if(!y)throw new Error(`Unknown opener with id: ${b}`);const u=C.URI.revive(c);return y.canOpenExternalUri(u,k)}async $openUri(b,c,k){const y=this.c.get(b);if(!y)throw new Error(`Unknown opener id: '${b}'`);return y.openExternalUri(C.URI.revive(c.resolvedUri),{sourceUri:C.URI.revive(c.sourceUri)},k)}}e.$Nrc=T}),define(ke[284],Ie([1,0,6,2,3,13,23]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=void 0;class O{static{this.a=0}constructor(c){this.c=new T.$tn,this.d=new Map,this.b=c.getProxy(r.$ON.MainThreadUrls)}registerUriHandler(c,k){const y=c.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=O.a++;return this.c.add(y),this.d.set(u,k),this.b.$registerUriHandler(u,y,c.displayName||c.name),(0,C.$Tc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,k){const y=this.d.get(c);if(!y)return Promise.resolve(void 0);try{y.handleUri(h.URI.revive(k))}catch(u){(0,R.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$Orc=O}),define(ke[285],Ie([1,0,21,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4tb=R,e.$5tb=O,h=We(h);class C{constructor(){this.buffers=[]}add(c){let k=this.buffers.indexOf(c);return k<0&&(k=this.buffers.length,this.buffers.push(c)),k}}function R(b,c){if(c.serializeBuffersForPostMessage){const k=new C,u=JSON.stringify(b,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(a)};if(ArrayBuffer.isView(a)){const m=T(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:k.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=k.buffers.map(w=>{const a=new Uint8Array(w);return r.$Oe.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify(b),buffers:[]}}function T(b){switch(b.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(b,c){const k=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),y=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:m}=a,p=k[m];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return w}:void 0;return{message:JSON.parse(b,y),arrayBuffers:k}}}),define(ke[96],Ie([1,0,4,3,14,24,2,236,285,121,6]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$bqc=void 0,e.$cqc=u,e.$eqc=a,e.$fqc=m,R=We(R),k=We(k);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,t,o,n,d,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$me,this._onDidDispose=this.#h.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=P(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$PDb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===C.Schemas.https||s.scheme===C.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$ODb}return c.$ODb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$jo(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const t=(0,b.$4tb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const S=T.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),I=(0,c.$PDb)(S,{isRemote:t,authority:o}).toString();return`${d}${I}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const S=T.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),I=(0,c.$PDb)(S,{isRemote:t,authority:o}).toString();return`${d}${I}${D}`})}}e.$bqc=y;function u(i){try{const s=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function P(i){try{const s=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class w extends h.$Vc{constructor(s,t,o,n,d){super(),this.c=t,this.f=o,this.g=n,this.h=d,this.b=new Map,this.a=s.getProxy(k.$ON.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,t,o){const n=this.j(s);if(n){const{message:d}=(0,b.$5tb)(t,o.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(s,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new y(s,this.a,p(t),this.c,this.f,o,this.h);this.b.set(s,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$dqc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function p(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>T.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[165],Ie([1,0,4,14,12,2,5,19,6]),function($e,e,r,h,C,R,T,O,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=e.$Qrc=void 0;let k=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$me,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(b.$ON.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let w;if(typeof u=="string"){w=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,P)}async asExternalUri(u,P){if((0,C.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,P);return R.URI.from(w)}};e.$Qrc=k,e.$Qrc=k=c=Ze([Ve(0,O.$oQ)],k),e.$Rrc=(0,T.$Gi)("IExtHostWindow")}),define(ke[286],Ie([1,0,276,29,19,93]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tsc=void 0;const T=1024*1024;let O=class extends r.$Urc{constructor(c,k){super(c,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,k,y){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),k.apply(console,y),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,k){const y=process[c],u=y.write;let P="";Object.defineProperty(y,"write",{set:()=>{},get:()=>(w,a,m)=>{if(!this.g){P+=w.toString(a);const p=P.length>T?P.length:P.lastIndexOf(`
`);p!==-1&&(console[k](P.slice(0,p)),P=P.slice(p+1))}u.call(y,w,a,m)}})}};e.$tsc=O,e.$tsc=O=Ze([Ve(0,C.$oQ),Ve(1,h.$EQ)],O)}),define(ke[287],Ie([1,0,164,14,230,32]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;class T extends r.$Trc{s(b,c,k){return b.scheme===h.Schemas.file?new C.$DR(k?.name||(0,R.$3g)(),b.fsPath,!k?.donotRotate,!!k?.donotUseFormatters,c):super.s(b,c,k)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Fsc=T}),define(ke[288],Ie([1,0,7,21,20,26,13,4,3,40,140,274,53]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.ResponsiveState=e.RequestInitiator=void 0,e.$0dc=f,e.$$dc=i,T=We(T);function w(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class p{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function f(M,N=null,L=!1){const F=[];return{jsonString:(L?w:JSON.stringify)(M,(j,U)=>{if(typeof U>"u")return m;if(typeof U=="object"){if(U instanceof h.$Oe){const z=F.push(U)-1;return{[a]:z}}if(N)return N(j,U)}return U}),referencedBuffers:F}}function i(M,N,L){return JSON.parse(M,(F,B)=>{if(B){const j=B[a];if(typeof j=="number")return N[j];if(L&&B.$mid===c.MarshalledId.Uri)return L.transformIncoming(B)}return B})}function s(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===c.MarshalledId.Uri?M.transformOutgoing(L):L:null}var o;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class E extends b.$Vc{static{P=l}static{this.a=3*1e3}constructor(N,L=null,F=null){super(),this[P]=!0,this.b=this.B(new O.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=F,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,j=u.$Yw.count;B<j;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(B=>this.L(B)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(T.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,k.$Qn)(N,this.g):N}getProxy(N){const{nid:L,sid:F}=N;return this.s[L]||(this.s[L]=this.J(L,F)),this.s[L]}J(N,L){const F={get:(B,j)=>(typeof j=="string"&&!B[j]&&j.charCodeAt(0)===R.CharCode.DollarSign&&(B[j]=(...U)=>this.U(N,j,U)),j===g?L:B[j])};return new Proxy(Object.create(null),F)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,F=N.length;L<F;L++){const B=N[L];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,F=S.read(N,0),B=F.readUInt8(),j=F.readUInt32();switch(B){case $.RequestJSONArgs:case $.RequestJSONArgsWithCancellation:{let{rpcId:U,method:z,args:ee}=A.deserializeRequestJSONArgs(F);this.g&&(ee=(0,k.$Qn)(ee,this.g)),this.M(L,j,U,z,ee,B===$.RequestJSONArgsWithCancellation);break}case $.RequestMixedArgs:case $.RequestMixedArgsWithCancellation:{let{rpcId:U,method:z,args:ee}=A.deserializeRequestMixedArgs(F);this.g&&(ee=(0,k.$Qn)(ee,this.g)),this.M(L,j,U,z,ee,B===$.RequestMixedArgsWithCancellation);break}case $.Acknowledged:{this.f?.logIncoming(L,j,o.LocalSide,"ack"),this.G(j);break}case $.Cancel:{this.N(L,j);break}case $.ReplyOKEmpty:{this.O(L,j,void 0);break}case $.ReplyOKJSON:{let U=A.deserializeReplyOKJSON(F);this.g&&(U=(0,k.$Qn)(U,this.g)),this.O(L,j,U);break}case $.ReplyOKJSONWithBuffers:{const U=A.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(L,j,U);break}case $.ReplyOKVSBuffer:{const U=A.deserializeReplyOKVSBuffer(F);this.O(L,j,U);break}case $.ReplyErrError:{let U=A.deserializeReplyErrError(F);this.g&&(U=(0,k.$Qn)(U,this.g)),this.P(L,j,U);break}case $.ReplyErrEmpty:{this.P(L,j,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,F,B,j,U){this.f?.logIncoming(N,L,o.OtherSide,`receiveRequest ${(0,u.$1w)(F)}.${B}(`,j);const z=String(L);let ee,V;if(U){const J=new C.$xe;j.push(J.token),ee=this.Q(F,B,j),V=()=>J.cancel()}else ee=this.Q(F,B,j),V=d;this.u[z]=V;const W=A.serializeAcknowledged(L);this.f?.logOutgoing(W.byteLength,L,o.OtherSide,"ack"),this.c.send(W),ee.then(J=>{delete this.u[z];const _=A.serializeReplyOK(L,J,this.h);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"reply:",J),this.c.send(_)},J=>{delete this.u[z];const _=A.serializeReplyErr(L,J);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"replyErr:",J),this.c.send(_)})}N(N,L){this.f?.logIncoming(N,L,o.OtherSide,"receiveCancel");const F=String(L);this.u[F]?.()}O(N,L,F){this.f?.logIncoming(N,L,o.LocalSide,"receiveReply:",F);const B=String(L);if(!this.w.hasOwnProperty(B))return;const j=this.w[B];delete this.w[B],j.resolveOk(F)}P(N,L,F){this.f?.logIncoming(N,L,o.LocalSide,"receiveReplyErr:",F);const B=String(L);if(!this.w.hasOwnProperty(B))return;const j=this.w[B];delete this.w[B];let U;F&&(F.$isError?(U=new Error,U.name=F.name,U.message=F.message,U.stack=F.stack):U=F),j.resolveErr(U)}Q(N,L,F){try{return Promise.resolve(this.S(N,L,F))}catch(B){return Promise.reject(B)}}S(N,L,F){const B=this.m[N];if(!B)throw new Error("Unknown actor "+(0,u.$1w)(N));const j=B[L];if(typeof j!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$1w)(N));return j.apply(B,F)}U(N,L,F){if(this.j)return new y.$9dc;let B=null;if(F.length>0&&C.CancellationToken.isCancellationToken(F[F.length-1])&&(B=F.pop()),B&&B.isCancellationRequested)return Promise.reject(T.$6());const j=A.serializeRequestArguments(F,this.h),U=++this.t,z=String(U),ee=new y.$8dc,V=new b.$Uc;B&&V.add(B.onCancellationRequested(()=>{const J=A.serializeCancel(U);this.f?.logOutgoing(J.byteLength,U,o.LocalSide,"cancel"),this.c.send(A.serializeCancel(U))})),this.w[z]=new D(ee,V),this.F(U);const W=A.serializeRequest(U,N,L,j,!!B);return this.f?.logOutgoing(W.byteLength,U,o.LocalSide,`request: ${(0,u.$1w)(N)}.${L}(`,F),this.c.send(W),ee}}e.$_dc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class S{static alloc(N,L,F){const B=new S(h.$Oe.alloc(F+1+4),0);return B.writeUInt8(N),B.writeUInt32(L),B}static read(N,L){return new S(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+N).toString();return this.b+=N,F}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+N).toString();return this.b+=N,F}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let F=0,B=N.length;F<B;F++){const j=N[F];switch(L+=1,j.type){case v.String:L+=this.sizeLongString(j.value);break;case v.VSBuffer:L+=this.sizeVSBuffer(j.value);break;case v.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)L+=this.sizeVSBuffer(j.buffers[U]);break;case v.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,F=N.length;L<F;L++){const B=N[L];switch(B.type){case v.String:this.writeUInt8(v.String),this.writeLongString(B.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(B.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let j=0;j<B.buffers.length;++j)this.writeBuffer(B.buffers[j]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let F=0;F<N;F++)switch(this.readUInt8()){case v.String:L[F]=this.readLongString();break;case v.VSBuffer:L[F]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const j=this.readUInt32(),U=this.readLongString(),z=[];for(let ee=0;ee<j;++ee)z.push(this.readVSBuffer());L[F]=new u.$2w(i(U,z,null));break}case v.Undefined:L[F]=void 0;break}return L}}var I;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(I||(I={}));class A{static a(N){for(let L=0,F=N.length;L<F;L++)if(N[L]instanceof h.$Oe||N[L]instanceof u.$2w||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const F=[];for(let B=0,j=N.length;B<j;B++){const U=N[B];if(U instanceof h.$Oe)F[B]={type:v.VSBuffer,value:U};else if(typeof U>"u")F[B]={type:v.Undefined};else if(U instanceof u.$2w){const{jsonString:z,referencedBuffers:ee}=f(U.value,L);F[B]={type:v.SerializedObjectWithBuffers,value:h.$Oe.fromString(z),buffers:ee}}else F[B]={type:v.String,value:h.$Oe.fromString(s(U,L))}}return{type:I.Mixed,args:F}}return{type:I.Simple,args:s(N,L)}}static serializeRequest(N,L,F,B,j){switch(B.type){case I.Simple:return this.b(N,L,F,B.args,j);case I.Mixed:return this.c(N,L,F,B.args,j)}}static b(N,L,F,B,j){const U=h.$Oe.fromString(F),z=h.$Oe.fromString(B);let ee=0;ee+=S.sizeUInt8(),ee+=S.sizeShortString(U),ee+=S.sizeLongString(z);const V=S.alloc(j?$.RequestJSONArgsWithCancellation:$.RequestJSONArgs,N,ee);return V.writeUInt8(L),V.writeShortString(U),V.writeLongString(z),V.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),F=N.readShortString(),B=N.readLongString();return{rpcId:L,method:F,args:JSON.parse(B)}}static c(N,L,F,B,j){const U=h.$Oe.fromString(F);let z=0;z+=S.sizeUInt8(),z+=S.sizeShortString(U),z+=S.sizeMixedArray(B);const ee=S.alloc(j?$.RequestMixedArgsWithCancellation:$.RequestMixedArgs,N,z);return ee.writeUInt8(L),ee.writeShortString(U),ee.writeMixedArray(B),ee.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),F=N.readShortString(),B=N.readMixedArray(),j=new Array(B.length);for(let U=0,z=B.length;U<z;U++){const ee=B[U];typeof ee=="string"?j[U]=JSON.parse(ee):j[U]=ee}return{rpcId:L,method:F,args:j}}static serializeAcknowledged(N){return S.alloc($.Acknowledged,N,0).buffer}static serializeCancel(N){return S.alloc($.Cancel,N,0).buffer}static serializeReplyOK(N,L,F){if(typeof L>"u")return this.d(N);if(L instanceof h.$Oe)return this.e(N,L);if(L instanceof u.$2w){const{jsonString:B,referencedBuffers:j}=f(L.value,F,!0);return this.g(N,B,j)}else return this.f(N,w(L,F))}static d(N){return S.alloc($.ReplyOKEmpty,N,0).buffer}static e(N,L){let F=0;F+=S.sizeVSBuffer(L);const B=S.alloc($.ReplyOKVSBuffer,N,F);return B.writeVSBuffer(L),B.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const F=h.$Oe.fromString(L);let B=0;B+=S.sizeLongString(F);const j=S.alloc($.ReplyOKJSON,N,B);return j.writeLongString(F),j.buffer}static g(N,L,F){const B=h.$Oe.fromString(L);let j=0;j+=S.sizeUInt32,j+=S.sizeLongString(B);for(const z of F)j+=S.sizeVSBuffer(z);const U=S.alloc($.ReplyOKJSONWithBuffers,N,j);U.writeUInt32(F.length),U.writeLongString(B);for(const z of F)U.writeBuffer(z);return U.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const F=N.readUInt32(),B=N.readLongString(),j=[];for(let U=0;U<F;++U)j.push(N.readVSBuffer());return new u.$2w(i(B,j,L))}static serializeReplyErr(N,L){const F=L?w(T.$2(L),null):void 0;if(typeof F!="string")return this.h(N);const B=h.$Oe.fromString(F);let j=0;j+=S.sizeLongString(B);const U=S.alloc($.ReplyErrError,N,j);return U.writeLongString(B),U.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return S.alloc($.ReplyErrEmpty,N,0).buffer}}var $;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var v;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[289],Ie([1,0,21,28,14,88,5]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$vL=void 0,e.$wL=k,e.$xL=y,e.$vL=(0,T.$Gi)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${O.join("")}]+`),c=7;function k(P){if(P.scheme!==C.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const a=parseInt(P.fragment.substring(0,w).replace(b,""),c),m=(0,r.$8e)(P.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:m,fragment:null})}}function y(P,w){const a=w.toString(c),p=`${a.length<O.length?O[a.length-1]:"z"}${a}s${(0,r.$9e)(r.$Oe.fromString(P.scheme),!0,!0)}`;return P.with({scheme:C.Schemas.vscodeNotebookCell,fragment:p})}class u{constructor(){this.a=new h.$Bc}getNotebook(w){if(w.scheme===C.Schemas.vscodeNotebookCell){const a=k(w);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$yL=u,(0,R.$Us)(e.$vL,u,R.InstantiationType.Delayed)}),define(ke[126],Ie([1,0,21,38,39,103,14,16,10,35,289]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$PL=e.CellStatusbarAlignment=e.$OL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$LL=e.$KL=e.$IL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HL=e.$GL=e.$FL=e.$EL=e.CellKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=void 0,e.$JL=n,e.$ML=g,e.$NL=E,e.$QL=I,e.$RL=$,h=We(h),e.$zL="workbench.editor.notebook",e.$AL="workbench.editor.notebookTextDiffEditor",e.$BL="workbench.editor.interactive",e.$CL="workbench.editor.repl",e.$DL="replNotebook.input.execute";var y;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$EL=["application/json","application/javascript","text/html","image/svg+xml",R.$bt.latex,R.$bt.markdown,"image/png","image/jpeg",R.$bt.text],e.$FL=[R.$bt.latex,R.$bt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$bt.text],e.$GL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HL="_notAvailable";var u;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var p;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(p||(e.NotebookCellsChangeType=p={}));var f;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(z){z.scheme=T.Schemas.vscodeNotebookCell;function ee(ne,ye){return(0,k.$xL)(ne,ye)}z.generate=ee;function V(ne){return(0,k.$wL)(ne)}z.parse=V;function W(ne,ye){return ne.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ye??""},${ne.scheme!==T.Schemas.file?ne.scheme:""}`})}z.generateCellOutputUri=W;function J(ne){if(ne.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ye=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!ye)return;const ge=ye[1]&&ye[1]!==""?ye[1]:void 0,Y=ye[2];return{outputId:ge,notebook:ne.with({scheme:Y||T.Schemas.file,fragment:null})}}z.parseCellOutputUri=J;function _(ne,ye,ge){return z.generate(ne,ye).with({scheme:ge})}z.generateCellPropertyUri=_;function ce(ne,ye){if(ne.scheme===ye)return z.parse(ne.with({scheme:z.scheme}))}z.parseCellPropertyUri=ce})(s||(e.CellUri=s={}));const t=z=>b.$j?z.replace(/\//g,"\\"):z;class o{constructor(ee=[],V=e.$EL){this.e=V,this.d=[...new Set(ee)].map(W=>({pattern:W,matches:h.$Bk(t(W))}))}sort(ee){const V=new Map(C.Iterable.map(ee,J=>[J,t(J)]));let W=[];for(const{matches:J}of this.d)for(const[_,ce]of V)if(J(ce)){W.push(_),V.delete(_);break}return V.size&&(W=W.concat([...V.keys()].sort((J,_)=>this.e.indexOf(J)-this.e.indexOf(_)))),W}prioritize(ee,V){const W=this.f(ee);if(W===-1){this.d.unshift({pattern:ee,matches:h.$Bk(t(ee))});return}const J=new Set(V.map(ce=>this.f(ce,W)));J.delete(-1);const _=Array.from(J).sort();this.d.splice(W+1,0,..._.map(ce=>this.d[ce]));for(let ce=_.length-1;ce>=0;ce--)this.d.splice(_[ce],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,V=this.d.length){const W=t(ee);for(let J=0;J<V;J++)if(this.d[J].matches(W))return J;return-1}}e.$IL=o;function n(z,ee,V,W=(J,_)=>J===_){const J=[];function _(ye,ge,Y){if(ge===0&&Y.length===0)return;const q=J[J.length-1];q&&q.start+q.deleteCount===ye?(q.deleteCount+=ge,q.toInsert.push(...Y)):J.push({start:ye,deleteCount:ge,toInsert:Y})}let ce=0,ne=0;for(;;){if(ce===z.length){_(ce,0,ee.slice(ne));break}if(ne===ee.length){_(ce,z.length-ce,[]);break}const ye=z[ce],ge=ee[ne];if(W(ye,ge)){ce+=1,ne+=1;continue}V(ge)?(_(ce,1,[]),ce+=1):(_(ce,0,[ge]),ne+=1)}return J}e.$KL=new c.$Xj("notebookEditorCursorAtBoundary","none"),e.$LL=new c.$Xj("notebookEditorCursorAtLineBoundary","none");var d;(function(z){z.default="default",z.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(z){z.Cells="cells",z.Text="text",z.None="none"})(l||(e.NotebookFindScopeType=l={}));function g(z){const ee=z;return!!((typeof ee.include=="string"||h.$Ck(ee.include))&&(typeof ee.exclude=="string"||h.$Ck(ee.exclude)))}function E(z,ee,V){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ee)>=0||z.viewType===ee)return!0;if(z.filenamePattern){const W=g(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,J=g(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(h.$Ak(W,(0,O.$oc)(V.fsPath).toLowerCase()))return!(J&&h.$Ak(J,(0,O.$oc)(V.fsPath).toLowerCase()))}return!1}e.$OL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class S{static{this.d="notebook/"}static create(ee){return`${S.d}${ee}`}static parse(ee){if(ee.startsWith(S.d))return ee.substring(S.d.length)}}e.$PL=S;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}const A=new TextDecoder;function $(z){const ee=[];let V=!1;for(const ce of z)(ee.length===0||V)&&(ee.push(ce),V=!0);let W=N(ee);const J=r.$Oe.concat(ee.map(ce=>r.$Oe.wrap(ce))),_=U(J);return W=W||_.byteLength!==J.byteLength,{data:_,didCompression:W}}e.$SL="\x1B[A";const v=e.$SL.split("").map(z=>z.charCodeAt(0)),M=10;function N(z){let ee=!1;return z.forEach((V,W)=>{if(W===0||V.length<e.$SL.length)return;const J=z[W-1],_=V.subarray(0,e.$SL.length);if(_[0]===v[0]&&_[1]===v[1]&&_[2]===v[2]){const ce=J.lastIndexOf(M);if(ce===-1)return;ee=!0,z[W-1]=J.subarray(0,ce),z[W]=V.subarray(e.$SL.length)}}),ee}function L(z){let ee=z;do z=ee,ee=z.replace(/[^\n]\x08/gm,"");while(ee.length<z.length);return z}function F(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ee=z.match(/^(.*)\r+/m)[1];let V=z.match(/\r+(.*)$/m)[1];V=V+ee.slice(V.length,ee.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return z}const B=8,j=13;function U(z){return!z.buffer.includes(B)&&!z.buffer.includes(j)?z:r.$Oe.fromString(F(L(A.decode(z.buffer))))}}),define(ke[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w){"use strict";var a,m,p,f,i,s,t,o,n,d,l,g,E,D,S,I,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$dQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.LanguageModelChatMessageRole=e.$7P=e.$6P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$CP=e.$BP=e.$AP=e.$zP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.TestRunProfileKind=e.TestResultState=e.$sP=e.$rP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$qP=e.NotebookVariablesRequestKind=e.$pP=e.$oP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$nP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.ColorThemeKind=e.$hP=e.$gP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$fP=e.QuickInputButtonLocation=e.$eP=e.DebugConsoleMode=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$$O=e.$0O=e.FileChangeType=e.$9O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$8O=e.$7O=e.$6O=e.$5O=e.InlineCompletionTriggerKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$RO=e.ConfigurationTarget=e.$QO=e.$PO=e.$OO=e.$NO=e.DocumentPasteTriggerKind=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$GO=e.ViewBadge=e.ProgressLocation=e.$FO=e.$EO=e.TaskScope=e.ShellQuoting=e.$DO=e.$CO=e.$BO=e.TaskPanelKind=e.TaskRevealKind=e.$AO=e.TerminalLocation=e.$zO=e.$yO=e.$xO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$wO=e.$vO=e.$uO=e.$tO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$nO=e.$mO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.LanguageStatusSeverity=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.CodeActionTriggerKind=e.$aO=e.$_N=e.SymbolTag=e.SymbolKind=e.$$N=e.$0N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.DiagnosticSeverity=e.DiagnosticTag=e.$4N=e.$3N=e.FileEditType=e.$2N=e.$1N=e.$ZN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YN=e.$XN=e.$WN=e.$TN=e.$SN=e.$RN=e.$QN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$UN=j,e.$VN=U,e.$sO=mt,e.$SO=ji,e.$yP=An;function $(K){return Object.assign(K,{apply:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(K,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const[Oe,...Ye]=me;return Reflect.construct(K,Ye,Oe.constructor)}}})}var v;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var M;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=a=class{static from(...Q){let me=Q;return new a(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$QN=N,e.$QN=N=a=Ze([$],N);let L=m=class{static Min(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Oe=1;Oe<Q.length;Oe++){const Ye=Q[Oe];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Oe=1;Oe<Q.length;Oe++){const Ye=Q[Oe];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(Q){if(!Q)return!1;if(Q instanceof m)return!0;const{line:me,character:Oe}=Q;return typeof me=="number"&&typeof Oe=="number"}static of(Q){if(Q instanceof m)return Q;if(this.isPosition(Q))return new m(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,me){if(Q<0)throw(0,h.$7)("line must be non-negative");if(me<0)throw(0,h.$7)("character must be non-negative");this.c=Q,this.e=me}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,me=0){if(Q===null||me===null)throw(0,h.$7)();let Oe;return typeof Q>"u"?Oe=0:typeof Q=="number"?Oe=Q:(Oe=typeof Q.lineDelta=="number"?Q.lineDelta:0,me=typeof Q.characterDelta=="number"?Q.characterDelta:0),Oe===0&&me===0?this:new m(this.line+Oe,this.character+me)}with(Q,me=this.character){if(Q===null||me===null)throw(0,h.$7)();let Oe;return typeof Q>"u"?Oe=this.line:typeof Q=="number"?Oe=Q:(Oe=typeof Q.line=="number"?Q.line:this.line,me=typeof Q.character=="number"?Q.character:this.character),Oe===this.line&&me===this.character?this:new m(Oe,me)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$RN=L,e.$RN=L=m=Ze([$],L);let F=p=class{static isRange(Q){return Q instanceof p?!0:Q?L.isPosition(Q.start)&&L.isPosition(Q.end):!1}static of(Q){if(Q instanceof p)return Q;if(this.isRange(Q))return new p(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,me,Oe,Ye){let ot,$t;if(typeof Q=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(ot=new L(Q,me),$t=new L(Oe,Ye)):L.isPosition(Q)&&L.isPosition(me)&&(ot=L.of(Q),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");ot.isBefore($t)?(this.c=ot,this.e=$t):(this.c=$t,this.e=ot)}contains(Q){return p.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):L.isPosition(Q)?!(L.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const me=L.Max(Q.start,this.c),Oe=L.Min(Q.end,this.e);if(!me.isAfter(Oe))return new p(me,Oe)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const me=L.Min(Q.start,this.c),Oe=L.Max(Q.end,this.end);return new p(me,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,me=this.end){if(Q===null||me===null)throw(0,h.$7)();let Oe;return Q?L.isPosition(Q)?Oe=Q:(Oe=Q.start||this.start,me=Q.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&me.isEqual(this.end)?this:new p(Oe,me)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$SN=F,e.$SN=F=p=Ze([$],F);let B=f=class extends F{static isSelection(Q){return Q instanceof f?!0:Q?F.isRange(Q)&&L.isPosition(Q.anchor)&&L.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,me,Oe,Ye){let ot,$t;if(typeof Q=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(ot=new L(Q,me),$t=new L(Oe,Ye)):L.isPosition(Q)&&L.isPosition(me)&&(ot=L.of(Q),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");super(ot,$t),this.f=ot,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$TN=B,e.$TN=B=f=Ze([$],B);function j(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function U(K){let Q=j(K);return K.isEmpty||(K.active.isEqual(K.start)?Q=`|${Q}`:Q=`${Q}|`),Q}const z=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.$7)("connectionToken")};class ee{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me,Oe){if(typeof Q!="string"||Q.length===0)throw(0,h.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$7)("port");typeof Oe<"u"&&z(Oe),this.host=Q,this.port=Math.round(me),this.connectionToken=Oe}}e.$WN=ee;class V{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me){this.makeConnection=Q,this.connectionToken=me,typeof me<"u"&&z(me)}}e.$XN=V;class W extends Error{static NotAvailable(Q,me){return new W(Q,P.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(Q){return new W(Q,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,me=P.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(Q),this._message=Q,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,W.prototype)}}e.$YN=W;var J;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var _;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(_||(e.EnvironmentVariableMutatorType=_={}));let ce=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?F.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,me){return new i(Q,me)}static insert(Q,me){return i.replace(new F(Q,Q),me)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const me=new i(new F(new L(0,0),new L(0,0)),"");return me.newEol=Q,me}get range(){return this.c}set range(Q){if(Q&&!F.isRange(Q))throw(0,h.$7)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,h.$7)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,h.$7)("newEol");this.f=Q}constructor(Q,me){this.c=Q,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZN=ce,e.$ZN=ce=i=Ze([$],ce);let ne=s=class{static isNotebookCellEdit(Q){return Q instanceof s?!0:Q?Ei.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,me){return new s(Q,me)}static insertCells(Q,me){return new s(new Ei(Q,Q),me)}static deleteCells(Q){return new s(Q,[])}static updateCellMetadata(Q,me){const Oe=new s(new Ei(Q,Q),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(Q){const me=new s(new Ei(0,0),[]);return me.newNotebookMetadata=Q,me}constructor(Q,me){this.range=Q,this.newCells=me}};e.$1N=ne,e.$1N=ne=s=Ze([$],ne);class ye{static isSnippetTextEdit(Q){return Q instanceof ye?!0:Q?F.isRange(Q.range)&&q.isSnippetString(Q.snippet):!1}static replace(Q,me){return new ye(Q,me)}static insert(Q,me){return ye.replace(new F(Q,Q),me)}constructor(Q,me){this.range=Q,this.snippet=me}}e.$2N=ye;var ge;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,me,Oe,Ye){this.c.push({_type:ge.File,from:Q,to:me,options:Oe,metadata:Ye})}createFile(Q,me,Oe){this.c.push({_type:ge.File,from:void 0,to:Q,options:me,metadata:Oe})}deleteFile(Q,me,Oe){this.c.push({_type:ge.File,from:Q,to:void 0,options:me,metadata:Oe})}e(Q,me,Oe){this.c.push({_type:ge.Cell,metadata:Oe,uri:Q,edit:{editType:w.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(Q,me,Oe,Ye){const ot=me.start,$t=me.end;(ot!==$t||Oe.length>0)&&this.c.push({_type:ge.CellReplace,uri:Q,index:ot,count:$t-ot,cells:Oe,metadata:Ye})}g(Q,me,Oe,Ye){this.c.push({_type:ge.Cell,metadata:Ye,uri:Q,edit:{editType:w.CellEditType.Metadata,index:me,metadata:Oe}})}replace(Q,me,Oe,Ye){this.c.push({_type:ge.Text,uri:Q,edit:new ce(me,Oe),metadata:Ye})}insert(Q,me,Oe,Ye){this.replace(Q,new F(me,me),Oe,Ye)}delete(Q,me,Oe){this.replace(Q,me,"",Oe)}has(Q){return this.c.some(me=>me._type===ge.Text&&me.uri.toString()===Q.toString())}set(Q,me){if(me)for(const Oe of me){if(!Oe)continue;let Ye,ot;Array.isArray(Oe)?(Ye=Oe[0],ot=Oe[1]):Ye=Oe,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(Q,Ye.range.start,Ye.newCellMetadata,ot):Ye.newNotebookMetadata?this.e(Q,Ye.newNotebookMetadata,ot):this.f(Q,Ye.range,Ye.newCells,ot):ye.isSnippetTextEdit(Ye)?this.c.push({_type:ge.Snippet,uri:Q,range:Ye.range,edit:Ye.snippet,metadata:ot}):this.c.push({_type:ge.Text,uri:Q,edit:Ye,metadata:ot})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Ye=this.c[Oe];switch(Ye._type){case ge.Text:case ge.Snippet:case ge.Cell:case ge.CellReplace:Ye.uri.toString()===Q.toString()&&(this.c[Oe]=void 0);break}}(0,r.$Ib)(this.c)}}get(Q){const me=[];for(const Oe of this.c)Oe._type===ge.Text&&Oe.uri.toString()===Q.toString()&&me.push(Oe.edit);return me}entries(){const Q=new R.$Bc;for(const me of this.c)if(me._type===ge.Text){let Oe=Q.get(me.uri);Oe||(Oe=[me.uri,[]],Q.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3N=Y,e.$3N=Y=Ze([$],Y);let q=t=class{static isSnippetString(Q){return Q instanceof t?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=t.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,me=this.e++){if(typeof Q=="function"){const Oe=new t;Oe.e=this.e,Q(Oe),this.e=Oe.e,Q=Oe.value}else Q=t.c(Q);return this.value+="${",this.value+=me,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,me=this.e++){const Oe=Q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(Q,me){if(typeof me=="function"){const Oe=new t;Oe.e=this.e,me(Oe),this.e=Oe.e,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$4N=q,e.$4N=q=t=Ze([$],q);var oe;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(oe||(e.DiagnosticTag=oe={}));var ve;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let ie=o=class{static isLocation(Q){return Q instanceof o?!0:Q?F.isRange(Q.range)&&c.URI.isUri(Q.uri):!1}constructor(Q,me){if(this.uri=Q,me)if(F.isRange(me))this.range=F.of(me);else if(L.isPosition(me))this.range=new F(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5N=ie,e.$5N=ie=o=Ze([$],ie);let ae=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&F.isRange(Q.location.range)&&c.URI.isUri(Q.location.uri):!1}constructor(Q,me){this.location=Q,this.message=me}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.location.range.isEqual(me.location.range)&&Q.location.uri.toString()===me.location.uri.toString()}};e.$6N=ae,e.$6N=ae=Ze([$],ae);let se=class{constructor(Q,me,Oe=ve.Error){if(!F.isRange(Q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=Q,this.message=me,this.severity=Oe}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.severity===me.severity&&Q.code===me.code&&Q.severity===me.severity&&Q.source===me.source&&Q.range.isEqual(me.range)&&(0,r.$ub)(Q.tags,me.tags)&&(0,r.$ub)(Q.relatedInformation,me.relatedInformation,ae.isEqual)}};e.$7N=se,e.$7N=se=Ze([$],se);let X=class{constructor(Q,me){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=me}};e.$8N=X,e.$8N=X=Ze([$],X);let re=class extends X{constructor(Q,me,Oe,Ye){super(Q,me),this.canIncreaseVerbosity=Oe,this.canDecreaseVerbosity=Ye}};e.$9N=re,e.$9N=re=Ze([$],re);var pe;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var we;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Me=class{constructor(Q,me=we.Text){this.range=Q,this.kind=me}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.$0N=Me,e.$0N=Me=Ze([$],Me);let ze=class{constructor(Q,me){this.uri=Q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$$N=ze,e.$$N=ze=Ze([$],ze);var Ae;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var De;(function(K){K[K.Deprecated=1]="Deprecated"})(De||(e.SymbolTag=De={}));let Ce=n=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,me,Oe,Ye,ot){this.name=Q,this.kind=me,this.containerName=ot,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof ie?this.location=Ye:Oe instanceof F&&(this.location=new ie(Ye,Oe)),n.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$_N=Ce,e.$_N=Ce=n=Ze([$],Ce);let H=d=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(d.validate)}constructor(Q,me,Oe,Ye,ot){this.name=Q,this.detail=me,this.kind=Oe,this.range=Ye,this.selectionRange=ot,this.children=[],d.validate(this)}};e.$aO=H,e.$aO=H=d=Ze([$],H);var G;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let Z=class{constructor(Q,me){this.title=Q,this.kind=me}};e.$bO=Z,e.$bO=Z=Ze([$],Z);let x=class{static{l=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new l(this.value?this.value+l.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+l.c)}};e.$cO=x,e.$cO=x=l=Ze([$],x),x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let de=class{constructor(Q,me){if(this.range=Q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$dO=de,e.$dO=de=Ze([$],de);class Ee{constructor(Q,me,Oe,Ye,ot,$t){this.kind=Q,this.name=me,this.detail=Oe,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$eO=Ee;class Te{constructor(Q,me){this.fromRanges=me,this.from=Q}}e.$fO=Te;class He{constructor(Q,me){this.fromRanges=me,this.to=Q}}e.$gO=He;var Ke;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let et=class{constructor(Q,me){this.range=Q,this.command=me}get isResolved(){return!!this.command}};e.$hO=et,e.$hO=et=Ze([$],et);let nt=g=class{#e;static isMarkdownString(Q){return Q instanceof g?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,me=!1){this.#e=new C.$5k(Q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,me){return this.#e.appendCodeblock(me??"",Q),this}};e.$iO=nt,e.$iO=nt=g=Ze([$],nt);let st=class{constructor(Q,me){this.label=Q,this.documentation=me}};e.$jO=st,e.$jO=st=Ze([$],st);let rt=class{constructor(Q,me){this.label=Q,this.documentation=me,this.parameters=[]}};e.$kO=rt,e.$kO=rt=Ze([$],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$lO=at,e.$lO=at=Ze([$],at);var gt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(gt||(e.SignatureHelpTriggerKind=gt={}));var dt;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(dt||(e.InlayHintKind=dt={}));let ct=class{constructor(Q){this.value=Q}};e.$mO=ct,e.$mO=ct=Ze([$],ct);let Pe=class{constructor(Q,me,Oe){this.position=Q,this.label=me,this.kind=Oe}};e.$nO=Pe,e.$nO=Pe=Ze([$],Pe);var Be;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Qe;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Qe||(e.CompletionItemKind=Qe={}));var Ne;(function(K){K[K.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let je=class{constructor(Q,me){this.label=Q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$oO=je,e.$oO=je=Ze([$],je);let ue=class{constructor(Q=[],me=!1){this.items=Q,this.isIncomplete=me}};e.$pO=ue,e.$pO=ue=Ze([$],ue);let he=class{constructor(Q,me,Oe){this.insertText=Q,this.range=me,this.command=Oe}};e.$qO=he,e.$qO=he=Ze([$],he);let le=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$rO=le,e.$rO=le=Ze([$],le);var Xe;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var tt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ut;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function mt(K,Q){return`${y.$sn.toKey(K)}.${Q}`}var Dt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Ft;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Ft||(e.TextDocumentSaveReason=Ft={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var ti;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(ti||(e.TextEditorSelectionChangeKind=ti={}));var oi;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Ot;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(K){function Q(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=Q}(ti||(e.TextEditorSelectionChangeKind=ti={}));var it;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(K){function Q(me){switch(me){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=Q}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(Q,me){if(me&&!c.URI.isUri(me))throw(0,h.$7)("target");if(!F.isRange(Q)||Q.isEmpty)throw(0,h.$7)("range");this.range=Q,this.target=me}};e.$tO=Ct,e.$tO=Ct=Ze([$],Ct);let hi=class{constructor(Q,me,Oe,Ye){this.red=Q,this.green=me,this.blue=Oe,this.alpha=Ye}};e.$uO=hi,e.$uO=hi=Ze([$],hi);let bt=class{constructor(Q,me){if(me&&!(me instanceof hi))throw(0,h.$7)("color");if(!F.isRange(Q)||Q.isEmpty)throw(0,h.$7)("range");this.range=Q,this.color=me}};e.$vO=bt,e.$vO=bt=Ze([$],bt);let St=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,h.$7)("label");this.label=Q}};e.$wO=St,e.$wO=St=Ze([$],St);var ii;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var ni;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ni||(e.SourceControlInputBoxValidationType=ni={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));var pt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(pt||(e.TerminalShellExecutionCommandLineConfidence=pt={}));class Bt{constructor(Q,me,Oe){if(this.startIndex=Q,this.length=me,this.tooltip=Oe,typeof Q!="number"||Q<0)throw(0,h.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,h.$7)("tooltip")}}e.$xO=Bt;class ri{constructor(Q){this.uri=Q}}e.$yO=ri;class ai{constructor(Q){this.terminalCommand=Q}}e.$zO=ai;var xe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class ci{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,h.$7)("options")}}e.$AO=ci;var di;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(Q){switch(Q){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(Q,me){if(this.label=me,typeof Q!="string"||typeof me!="string")throw(0,h.$7)("name");this.c=Q}get id(){return this.c}};e.$BO=vt,e.$BO=vt=E=Ze([$],vt);function jt(K){let Q="";for(let me=0;me<K.length;me++)Q+=K[me].replace(/,/g,",,")+",";return Q}let Nt=class{constructor(Q,me,Oe){if(typeof Q!="string")throw(0,h.$7)("process");this.e=[],this.c=Q,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Oe):this.f=me)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,h.$7)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const me of this.e)Q.push(me);return jt(Q)}};e.$CO=Nt,e.$CO=Nt=Ze([$],Nt);let Gt=class{constructor(Q,me,Oe){if(this.f=[],Array.isArray(me)){if(!Q)throw(0,h.$7)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$7)("command");this.e=Q,this.f=me,this.g=Oe}else{if(typeof Q!="string")throw(0,h.$7)("commandLine");this.c=Q,this.g=me}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,h.$7)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$7)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)Q.push(typeof me=="string"?me:me.value);return jt(Q)}};e.$DO=Gt,e.$DO=Gt=Ze([$],Gt);var si;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(si||(e.ShellQuoting=si={}));var Jt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Jt||(e.TaskScope=Jt={}));class li{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,k.$3g)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$EO=li;let Wt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,me,Oe,Ye,ot,$t){this.k=!1,this.l=this.definition=Q;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Oe,this.execution=Ye,yt=ot,this.k=!0):me===Jt.Global||me===Jt.Workspace?(this.target=me,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=ot,yt=$t):(this.target=me,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=ot,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,k.$3g)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,h.$7)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,h.$7)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,h.$7)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$FO=Wt,e.$FO=Wt=D=Ze([$],Wt);var Kt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Zt;(function(K){function Q(me){const Oe=me;return(0,b.$jg)(Oe.value)?Oe.tooltip&&!(0,b.$fg)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}K.isViewBadge=Q})(Zt||(e.ViewBadge=Zt={}));let Mt=S=class{static isTreeItem(Q,me){const Oe=Q;if(Oe.checkboxState!==void 0){const Ye=(0,b.$jg)(Oe.checkboxState)?Oe.checkboxState:(0,b.$hg)(Oe.checkboxState)&&(0,b.$jg)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,ot=!(0,b.$jg)(Oe.checkboxState)&&(0,b.$hg)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==It.Checked&&Ye!==It.Unchecked||ot!==void 0&&!(0,b.$fg)(ot))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(Q instanceof S)return!0;if(Oe.label!==void 0&&!(0,b.$fg)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,b.$fg)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,b.$fg)(Oe.iconPath)&&!c.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,b.$fg)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,b.$fg)(Ye.light)&&!c.URI.isUri(Ye.light)&&!(0,b.$fg)(Ye.dark)&&!c.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,b.$fg)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!c.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,b.$fg)(Oe.tooltip)&&!(Oe.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<wt.None&&Oe.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,b.$fg)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(Q,me=wt.None){this.collapsibleState=me,c.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$GO=Mt,e.$GO=Mt=S=Ze([$],Mt);var wt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var It;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$HO=Qt,e.$HO=Qt=Ze([$],Qt);class Pt extends Qt{}e.$IO=Pt;class mi extends Pt{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$JO=mi;class xt{constructor(Q,me,Oe,Ye){this.name=Q,this.uri=me,this._itemId=Oe,this.c=Ye}data(){return this.c()}}e.$KO=xt;let ki=class{#e=new Map;constructor(Q){for(const[me,Oe]of Q??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Oe):this.#e.set(this.#t(me),[Oe])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,me){this.#e.set(this.#t(Q),[me])}forEach(Q,me){for(const[Oe,Ye]of this.#e)for(const ot of Ye)Q.call(me,ot,Oe,this)}*[Symbol.iterator](){for(const[Q,me]of this.#e)for(const Oe of me)yield[Q,Oe]}#t(Q){return Q.toLowerCase()}};e.$LO=ki,e.$LO=ki=Ze([$],ki);let wi=class{constructor(Q,me,Oe){this.insertText=Q,this.title=me,this.kind=Oe}};e.$MO=wi,e.$MO=wi=Ze([$],wi);var Oi;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Oi||(e.DocumentPasteTriggerKind=Oi={}));class Tt{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new Tt((this.value?[this.value,...Q]:Q).join(Tt.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+Tt.c)}}e.$NO=Tt,Tt.Empty=new Tt("");class Ni{constructor(Q,me,Oe){this.title=me,this.insertText=Q,this.kind=Oe}}e.$OO=Ni;let ui=class{constructor(Q,me){this.id=Q,this.color=me}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$PO=ui,e.$PO=ui=Ze([$],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Rt=class{constructor(Q){this.id=Q}};e.$QO=Rt,e.$QO=Rt=Ze([$],Rt);var Ti;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let Ii=class{get base(){return this.c}set base(Q){this.c=Q,this.e=c.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,me){if(typeof Q!="string"&&(!Q||!c.URI.isUri(Q)&&!c.URI.isUri(Q.uri)))throw(0,h.$7)("base");if(typeof me!="string")throw(0,h.$7)("pattern");typeof Q=="string"?this.baseUri=c.URI.file(Q):c.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RO=Ii,e.$RO=Ii=Ze([$],Ii);const Si=new WeakMap;function ji(K,Q){Si.set(K,Q)}let $i=class{constructor(Q,me,Oe,Ye,ot){this.enabled=typeof Q=="boolean"?Q:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye),typeof ot=="string"&&(this.mode=ot)}get id(){return this.c||(this.c=Si.get(this)??(0,k.$3g)()),this.c}};e.$TO=$i,e.$TO=$i=Ze([$],$i);let Vt=class extends $i{constructor(Q,me,Oe,Ye,ot,$t){if(super(me,Oe,Ye,ot,$t),Q===null)throw(0,h.$7)("location");this.location=Q}};e.$UO=Vt,e.$UO=Vt=Ze([$],Vt);let Pi=class extends $i{constructor(Q,me,Oe,Ye,ot,$t){super(me,Oe,Ye,ot,$t),this.functionName=Q}};e.$VO=Pi,e.$VO=Pi=Ze([$],Pi);let Re=class extends $i{constructor(Q,me,Oe,Ye,ot,$t,yt,Yt){if(super(Ye,ot,$t,yt,Yt),!me)throw(0,h.$7)("dataId");this.label=Q,this.dataId=me,this.canPersist=Oe}};e.$WO=Re,e.$WO=Re=Ze([$],Re);let Fe=class{constructor(Q,me,Oe){this.command=Q,this.args=me||[],this.options=Oe}};e.$XO=Fe,e.$XO=Fe=Ze([$],Fe);let Se=class{constructor(Q,me){this.port=Q,this.host=me}};e.$YO=Se,e.$YO=Se=Ze([$],Se);let te=class{constructor(Q){this.path=Q}};e.$ZO=te,e.$ZO=te=Ze([$],te);let Le=class{constructor(Q){this.implementation=Q}};e.$1O=Le,e.$1O=Le=Ze([$],Le);class Ge{constructor(Q,me,Oe){this.session=Q,this.threadId=me,this.frameId=Oe}}e.$2O=Ge;class _e{constructor(Q,me){this.session=Q,this.threadId=me}}e.$3O=_e;let Je=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$4O=Je,e.$4O=Je=Ze([$],Je);var ft;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let At=class{constructor(Q,me){this.range=Q,this.text=me}};e.$5O=At,e.$5O=At=Ze([$],At);let Xt=class{constructor(Q,me,Oe=!0){this.range=Q,this.variableName=me,this.caseSensitiveLookup=Oe}};e.$6O=Xt,e.$6O=Xt=Ze([$],Xt);let _t=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$7O=_t,e.$7O=_t=Ze([$],_t);let zt=class{constructor(Q,me){this.frameId=Q,this.stoppedLocation=me}};e.$8O=zt,e.$8O=zt=Ze([$],zt);var ei;(function(K){K[K.AIGenerated=1]="AIGenerated"})(ei||(e.NewSymbolNameTag=ei={}));var rn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(Q,me){this.newSymbolName=Q,this.tags=me}}e.$9O=Vi;var Bi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Bi||(e.FileChangeType=Bi={}));let Hi=I=class extends Error{static FileExists(Q){return new I(Q,u.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(Q){return new I(Q,u.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(Q){return new I(Q,u.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(Q){return new I(Q,u.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(Q){return new I(Q,u.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(Q){return new I(Q,u.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}constructor(Q,me=u.FileSystemProviderErrorCode.Unknown,Oe){super(c.URI.isUri(Q)?Q.toString(!0):Q),this.code=Oe?.name??"Unknown",(0,u.$ql)(this,me),Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$0O=Hi,e.$0O=Hi=I=Ze([$],Hi);let Gi=class{constructor(Q,me,Oe){this.start=Q,this.end=me,this.kind=Oe}};e.$$O=Gi,e.$$O=Gi=Ze([$],Gi);var Ci;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var sn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Mi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var an;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var zi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(zi||(e.CommentThreadApplicability=zi={}));var Qi;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(Qi||(e.CommentThreadFocus=Qi={}));class yn{constructor(Q,me=[]){this.tokenTypes=Q,this.tokenModifiers=me}}e.$_O=yn;function cn(K){return typeof K>"u"||(0,b.$gg)(K)}class Ki{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let me=0,Oe=Q.tokenTypes.length;me<Oe;me++)this.k.set(Q.tokenTypes[me],me);for(let me=0,Oe=Q.tokenModifiers.length;me<Oe;me++)this.l.set(Q.tokenModifiers[me],me)}}push(Q,me,Oe,Ye,ot){if(typeof Q=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this.q(Q,me,Oe,Ye,ot);if(F.isRange(Q)&&typeof me=="string"&&cn(Oe))return this.o(Q,me,Oe);throw(0,h.$7)()}o(Q,me,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=Q.start.line,ot=Q.start.character,$t=Q.end.character-Q.start.character,yt=this.k.get(me);let Yt=0;if(Oe)for(const bi of Oe){if(!this.l.has(bi))throw new Error("`tokenModifier` is not in the provided legend");const yi=this.l.get(bi);Yt|=1<<yi>>>0}this.q(Ye,ot,$t,yt,Yt)}q(Q,me,Oe,Ye,ot){if(this.f&&(Q<this.c||Q===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let bi=0,yi=0;for(let Di=0;Di<Yt;Di++){let Ri=this.g[5*Di],tn=this.g[5*Di+1];Ri===0?(Ri=bi,tn+=yi):Ri+=bi,this.g[5*Di]=Ri,this.g[5*Di+1]=tn,bi=Ri,yi=tn}}let $t=Q,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Oe,this.g[this.j++]=Ye,this.g[this.j++]=ot,this.c=Q,this.e=me}static r(Q){const me=[],Oe=Q.length/5|0;for(let yt=0;yt<Oe;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const bi=Q[5*yt],yi=Q[5*Yt];if(bi===yi){const Di=Q[5*yt+1],Ri=Q[5*Yt+1];return Di-Ri}return bi-yi});const Ye=new Uint32Array(Q.length);let ot=0,$t=0;for(let yt=0;yt<Oe;yt++){const Yt=5*me[yt],bi=Q[Yt+0],yi=Q[Yt+1],Di=Q[Yt+2],Ri=Q[Yt+3],tn=Q[Yt+4],Gn=bi-ot,Nr=Gn===0?yi-$t:yi,nn=5*yt;Ye[nn+0]=Gn,Ye[nn+1]=Nr,Ye[nn+2]=Di,Ye[nn+3]=Ri,Ye[nn+4]=tn,ot=bi,$t=yi}return Ye}build(Q){return this.f?new Ai(new Uint32Array(this.g),Q):new Ai(Ki.r(this.g),Q)}}e.$aP=Ki;class Ai{constructor(Q,me){this.resultId=me,this.data=Q}}e.$bP=Ai;class Sn{constructor(Q,me,Oe){this.start=Q,this.deleteCount=me,this.data=Oe}}e.$cP=Sn;class Dn{constructor(Q,me){this.resultId=me,this.edits=Q}}e.$dP=Dn;var ln;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Ji{constructor(Q){this.name=Q}}e.$eP=Ji;var Zi;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Zi||(e.QuickInputButtonLocation=Zi={}));let qe=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$fP=qe,e.$fP=qe=Ze([$],qe);var vi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Xi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var lt;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(lt||(e.ExtensionKind=lt={}));class kt{static validate(Q){if(typeof Q.badge=="string"){let me=(0,O.$Qf)(Q.badge,0);if(me<Q.badge.length&&(me+=(0,O.$Qf)(Q.badge,me)),Q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!ui.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,me,Oe){this.badge=Q,this.tooltip=me,this.color=Oe}}e.$gP=kt;let Yi=class{constructor(Q){this.kind=Q}};e.$hP=Yi,e.$hP=Yi=Ze([$],Yi);var un;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class Ei{static isNotebookRange(Q){return Q instanceof Ei?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,me){if(Q<0)throw(0,h.$7)("start must be positive");if(me<0)throw(0,h.$7)("end must be positive");Q<=me?(this.c=Q,this.e=me):(this.c=me,this.e=Q)}with(Q){let me=this.c,Oe=this.e;return Q.start!==void 0&&(me=Q.start),Q.end!==void 0&&(Oe=Q.end),me===this.c&&Oe===this.e?this:new Ei(me,Oe)}}e.$iP=Ei;class Ui{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(me=>Ui.isNotebookCellData(me))}static isNotebookCellData(Q){return!0}constructor(Q,me,Oe,Ye,ot,$t,yt){this.kind=Q,this.value=me,this.languageId=Oe,this.mime=Ye,this.outputs=ot??[],this.metadata=$t,this.executionSummary=yt,Ui.validate(this)}}e.$jP=Ui;class qi{constructor(Q){this.cells=Q}}e.$kP=qi;class pi{static isNotebookCellOutputItem(Q){return Q instanceof pi?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const me={name:Q.name,message:Q.message,stack:Q.stack};return pi.json(me,"application/vnd.code.notebook.error")}static stdout(Q){return pi.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return pi.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,me="application/octet-stream"){return new pi(Q,me)}static#e=new TextEncoder;static text(Q,me=T.$bt.text){const Oe=pi.#e.encode(String(Q));return new pi(Oe,me)}static json(Q,me="text/x-json"){const Oe=JSON.stringify(Q,void 0,"	");return pi.text(Oe,me)}constructor(Q,me){this.data=Q,this.mime=me;const Oe=(0,T.$ft)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$lP=pi;class Wi{static isNotebookCellOutput(Q){return Q instanceof Wi?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,me=!1){const Oe=new Set,Ye=new Set;for(let ot=0;ot<Q.length;ot++){const $t=Q[ot],yt=(0,T.$ft)($t.mime);if(!Oe.has(yt)||(0,w.$QL)(yt)){Oe.add(yt);continue}Ye.add(ot),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ye.size===0?Q:Q.filter((ot,$t)=>!Ye.has($t))}constructor(Q,me,Oe){this.items=Wi.ensureUniqueMimeTypes(Q,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,k.$3g)(),this.metadata=me??Oe)}}e.$mP=Wi;var hn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(Q,me){this.text=Q,this.alignment=me}}e.$nP=kn;var gn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(Q,me=[]){this.uri=Q,this.provides=(0,r.$2b)(me)}}e.$oP=In;class Pn{constructor(Q){this.label=Q}}e.$pP=Pn;var $n;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})($n||(e.NotebookVariablesRequestKind=$n={}));let _i=class{constructor(Q,me){this.label=Q,this.timestamp=me}};e.$qP=_i,e.$qP=_i=Ze([$],_i);var pn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(pn||(e.ExtensionMode=pn={}));var bn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(bn||(e.ExtensionRuntime=bn={}));var fe;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class be{constructor(Q,me){this.ranges=Q,this.wordPattern=me}}e.$rP=be;class Ue{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$sP=Ue;var ht;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ht||(e.TestResultState=ht={}));var Et;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(Et||(e.TestRunProfileKind=Et={}));let Lt=class{constructor(Q=void 0,me=void 0,Oe=void 0,Ye=!1,ot=!0){this.include=Q,this.exclude=me,this.profile=Oe,this.continuous=Ye,this.preserveFocus=ot}};e.$tP=Lt,e.$tP=Lt=Ze([$],Lt);let gi=A=class{static diff(Q,me,Oe){const Ye=new A(Q);return Ye.expectedOutput=me,Ye.actualOutput=Oe,Ye}constructor(Q){this.message=Q}};e.$uP=gi,e.$uP=gi=A=Ze([$],gi);let Fi=class{constructor(Q){this.id=Q}};e.$vP=Fi,e.$vP=Fi=Ze([$],Fi);class en{constructor(Q,me,Oe){this.label=Q,this.uri=me,this.position=Oe}}e.$wP=en;class wn{constructor(Q,me){this.covered=Q,this.total=me,An(this)}}e.$xP=wn;function An(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Cn{static fromDetails(Q,me){const Oe=new wn(0,0),Ye=new wn(0,0),ot=new wn(0,0);for(const yt of me)if("branches"in yt){Oe.total+=1,Oe.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else ot.total+=1,ot.covered+=yt.executed?1:0;const $t=new Cn(Q,Oe,Ye.total>0?Ye:void 0,ot.total>0?ot:void 0);return $t.detailedCoverage=me,$t}constructor(Q,me,Oe,Ye,ot=[]){this.uri=Q,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=Ye,this.fromTests=ot}}e.$zP=Cn;class Jn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Oe=[]){this.executed=Q,this.location=me,this.branches=Oe}}e.$AP=Jn;class Zn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Oe){this.executed=Q,this.location=me,this.label=Oe}}e.$BP=Zn;class Xn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Oe){this.name=Q,this.executed=me,this.location=Oe}}e.$CP=Xn;var Rn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var On;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var Tn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(Q,me,Oe,Ye,ot,$t){this.kind=Q,this.name=me,this.detail=Oe,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$DP=Yn;class xn{constructor(Q){this.uri=Q}}e.$EP=xn;class _n{constructor(Q,me){this.original=Q,this.modified=me}}e.$FP=_n;class er{constructor(Q,me,Oe,Ye){this.base=Q,this.input1=me,this.input2=Oe,this.result=Ye}}e.$GP=er;class tr{constructor(Q,me){this.uri=Q,this.viewType=me}}e.$HP=tr;class ir{constructor(Q){this.viewType=Q}}e.$IP=ir;class nr{constructor(Q,me){this.uri=Q,this.notebookType=me}}e.$JP=nr;class rr{constructor(Q,me,Oe){this.original=Q,this.modified=me,this.notebookType=Oe}}e.$KP=rr;class sr{constructor(){}}e.$LP=sr;class or{constructor(Q,me){this.uri=Q,this.inputBoxUri=me}}e.$MP=or;class ar{constructor(){}}e.$NP=ar;class cr{constructor(Q){this.textDiffs=Q}}e.$OP=cr;var Ln;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var Nn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Mn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Mn||(e.ChatVariableLevel=Mn={}));class lr{constructor(Q,me,Oe){this.id=Q,this.label=me,this.values=Oe}}e.$PP=lr;var Fn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var jn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(jn||(e.ChatResultFeedbackKind=jn={}));class ur{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q}}e.$QP=ur;class hr{constructor(Q,me){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q,this.vulnerabilities=me}}e.$RP=hr;class dr{constructor(Q,me){this.participant=Q,this.command=me}}e.$SP=dr;class fr{constructor(Q,me,Oe,Ye){this.title=Q,this.message=me,this.data=Oe,this.buttons=Ye}}e.$TP=fr;class gr{constructor(Q,me){this.value=Q,this.baseUri=me}}e.$UP=gr;class mr{constructor(Q,me){this.value=Q,this.title=me}}e.$VP=mr;class $r{constructor(Q){this.value=Q}}e.$WP=$r;class pr{constructor(Q,me){this.value=Q,this.task=me}}e.$XP=pr;class br{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q}}e.$YP=br;class wr{constructor(Q){this.value=Q}}e.$ZP=wr;class vr{constructor(Q,me,Oe){this.value=Q,this.iconPath=me,this.options=Oe}}e.$1P=vr;class Er{constructor(Q,me,Oe){this.value=Q,this.license=me,this.snippet=Oe}}e.$2P=Er;class yr{constructor(Q,me){this.uri=Q,this.edits=Array.isArray(me)?me:[me]}}e.$3P=yr;class Sr{constructor(Q,me,Oe,Ye){this.prompt=Q,this.command=me,this.references=Oe,this.participant=Ye}}e.$4P=Sr;class Dr{constructor(Q,me,Oe,Ye){this.response=Q,this.result=me,this.participant=Oe,this.command=Ye}}e.$5P=Dr;var Bn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(Bn||(e.ChatLocation=Bn={}));var zn;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(zn||(e.ChatResponseReferencePartStatusKind=zn={}));class kr{constructor(Q,me,Oe){this.document=Q,this.selection=me,this.wholeRange=Oe}}e.$6P=kr;class Ir{constructor(Q){this.cell=Q}}e.$7P=Ir;var vn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Pr{constructor(Q,me,Oe){this.name=Q,this.content=me,this.isError=Oe??!1}}e.$8P=Pr;class En{static User(Q,me){const Oe=new En(vn.User,typeof Q=="string"?Q:"",me);return Oe.content2=Q,Oe}static Assistant(Q,me){return new En(vn.Assistant,Q,me)}constructor(Q,me,Oe){this.role=Q,this.content=me,this.content2=me,this.name=Oe}}e.$9P=En;class Cr{constructor(Q,me){this.name=Q,this.parameters=me}}e.$0P=Cr;class Ar{constructor(Q){this.value=Q}}e.$$P=Ar;class Rr{constructor(Q){this.content=Q}}e.$_P=Rr;class Or{constructor(Q,me){this.content=Q,this.name=me}}e.$aQ=Or;class Tr{constructor(Q,me){this.content=Q,this.name=me}}e.$bQ=Tr;class Li extends Error{static NotFound(Q){return new Li(Q,Li.NotFound.name)}static NoPermissions(Q){return new Li(Q,Li.NoPermissions.name)}static Blocked(Q){return new Li(Q,Li.Blocked.name)}constructor(Q,me,Oe){super(Q,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.$cQ=Li;var Un;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var qn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(qn||(e.SpeechToTextStatus=qn={}));var Wn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Vn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Lr{constructor(Q,me){this.text=Q,this.range=me}}e.$dQ=Lr;var Hn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(ke[290],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class C{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$ON.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,O,b){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(T);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(O,b)??[]}getRelatedInformation(T,O,b){return this.c.$getAiRelatedInformation(O,b)}registerRelatedInformationProvider(T,O,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiRelatedInformationProvider(c,O),new h.$QN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Ipc=C}),define(ke[127],Ie([1,0,4,6,9,23,159,5,19]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,O.$Gi)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$me,this.onDidChangeSessions=this.c.event,this.d=new k,this.a=u.getProxy(h.$ON.MainThreadAuthentication)}async getSession(u,P,w,a={}){const m=R.$sn.toKey(u.identifier),p=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const f=u.displayName||u.name;return this.a.$getSession(P,w,m,f,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,P){const w=this.b.get(u);return w?w.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:w,options:a??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions(p=>this.a.$sendDidChangeSessions(u,p));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new C.$QN(()=>{m.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,w){const a=this.b.get(u);if(a)return await a.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const w=this.b.get(u);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(T.$QM)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$Upc=c,e.$Upc=c=Ze([Ve(0,b.$oQ)],c);class k{constructor(){this.a=new Map}getOrCreate(u,P){const w=this.a.get(u);if(w)return w;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ke[166],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(h.$ON.MainThreadDecorations)}registerFileDecorationProvider(a,m){const p=u.c++;this.f.set(p,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(p,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(p,null);return}const s=(0,b.$2b)(i);if(s.length<=u.d){this.g.$onDidChange(p,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(d=>({uri:d,rank:(0,c.$jf)(d.path,"/")})),o=(0,b.$zb)(t,(d,l)=>d.rank-l.rank||(0,c.$zf)(d.uri.path,l.uri.path)),n=[];e:for(const d of o){let l;for(const g of d){const E=(0,k.$nc)(g.uri.path);if(l!==E&&(l=E,n.push(g.uri)>=u.d))break e}}this.g.$onDidChange(p,n)});return new C.$QN(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(p),this.f.delete(p)})}async $provideDecorations(a,m,p){if(!this.f.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),p));if(!d)return;try{C.$gP.validate(d),d.badge&&typeof d.badge!="string"&&(0,y.$jH)(s,"codiconDecoration"),f[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(o){this.h.error(o)}})),f}};e.$Yqc=P,e.$Yqc=P=u=Ze([Ve(0,T.$oQ),Ve(1,O.$bk)],P),e.$Zqc=(0,R.$Gi)("IExtHostDecorations")}),define(ke[291],Ie([1,0,13,2,9,6,14,20,12]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;class c{static{this.a=0}constructor(y,u,P){this.d=u,this.e=P,this.b=new Map,this.c=y.getProxy(R.$ON.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const P=c.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,y);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async m=>{if(m.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const p=this.$provideTextDocumentContent(P,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,b.$tf)(f);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,f)}).catch(r.$Z).finally(()=>{a===p&&(a=void 0)});a=p})}return new C.$QN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(y,u){const P=this.b.get(y);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$2qc=c}),define(ke[167],Ie([1,0,65,14,12,207,142,9,18]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,e.$qQ=k;const c=new Map;function k(w,a){a?c.set(w,a):c.delete(w)}function y(w){return c.get(w)}class u extends R.$tw{constructor(a,m,p,f,i,s,t){super(m,p,f,i),this.c=a,this.m=s,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,p){return a.y(m,p)},[Symbol.for("debug.description")](){return`TextDocument(${a.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const p=this.g,f=m.start.line,i=m.end.line,s=[];s.push(this.f[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this.f[t]);return s.push(this.f[i].substring(0,m.end.character)),s.join(p)}t(a){let m;if(a instanceof O.$RN?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),p=this.f[m.index].length;return new O.$RN(m.index,Math.min(m.remainder,p))}w(a){if(!(a instanceof O.$SN))throw new Error("Invalid argument");const m=this.x(a.start),p=this.x(a.end);return m===a.start&&p===a.end?a:new O.$SN(m.line,m.character,p.line,p.character)}x(a){if(!(a instanceof O.$RN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:p}=a,f=!1;if(m<0)m=0,p=0,f=!0;else if(m>=this.f.length)m=this.f.length-1,p=this.f[m].length,f=!0;else{const i=this.f[m].length;p<0?(p=0,f=!0):p>i&&(p=i,f=!0)}return f?new O.$RN(m,p):a}y(a,m){const p=this.x(a);if(!m)m=y(this.m);else if((0,C.$sf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,T.$tt)(p.character+1,(0,T.$rt)(m),this.f[p.line],0);if(f)return new O.$SN(p.line,f.startColumn-1,p.line,f.endColumn-1)}}e.$rQ=u;class P{constructor(a,m,p){this.a=a,this.b=m,this.c=p}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$SN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$SN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sQ=P}),define(ke[292],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class C{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$ON.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,O,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(T);if(!c)throw new Error("Embedding vector provider not found");const k=await c.provideEmbeddingVector(O,b);if(!k)throw new Error("Embedding vector provider returned undefined");return k}registerEmbeddingVectorProvider(T,O,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiEmbeddingVectorProvider(O,c),new h.$QN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$5qc=C}),define(ke[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0,h=We(h);let w=P=class{constructor(m,p){this.b=new Map,this.c=new k.$Ph,this.a=m.getProxy(r.$ON.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f.b.get(i.scheme);return t?(await f.a.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===h.FilePermission.Readonly?1:void 0}}catch(s){P.e(s)}},async readDirectory(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f.a.$readdir(i)}catch(s){return P.e(s)}},async createDirectory(i){try{const s=f.b.get(i.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(s.impl,s.extUri,i)):await f.a.$mkdir(i)}catch(s){return P.e(s)}},async readFile(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f.a.$readFile(i)).buffer}catch(s){return P.e(s)}},async writeFile(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(t.impl,t.extUri,t.extUri.dirname(i)),await f.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(i,R.$Oe.wrap(s))}catch(t){return P.e(t)}},async delete(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return P.e(t)}},async rename(i,s,t){try{return await f.a.$rename(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},async copy(i,s,t){try{return await f.a.$copy(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},isWritableFileSystem(i){const s=p.getCapabilities(i);if(typeof s=="number")return!(s&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,p,f){const i=[];for(;!p.isEqual(f,p.dirname(f));)try{if(!((await m.stat(f)).type&h.FileType.Directory))throw C.$0O.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(h.$rl(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(p.basename(f)),f=p.dirname(f)}for(let s=i.length-1;s>=0;s--){f=p.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(h.$rl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof C.$0O)throw m;if(m instanceof h.$nl)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw C.$0O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$0O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$0O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$0O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$0O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$0O.Unavailable(m.message);default:throw new C.$0O(m.message,m.name)}if(!(m instanceof Error))throw new C.$0O(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw C.$0O.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw C.$0O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$0O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$0O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$0O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$0O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$0O.Unavailable(m.message);default:throw new C.$0O(m.message,m.name)}}addFileSystemProvider(m,p,f){return this.b.set(m,{impl:p,extUri:f?.isCaseSensitive?y.$0g:y.$_g,isReadonly:!!f?.isReadonly}),(0,c.$Tc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??y.$0g}};e.$0pc=w,e.$0pc=w=P=Ze([Ve(0,O.$oQ),Ve(1,b.$Npc)],w),e.$$pc=(0,T.$Gi)("IExtHostConsumerFileSystem")}),define(ke[97],Ie([1,0,5,29,11,75,2]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=e.$_pc=void 0,e.$_pc=(0,r.$Gi)("IExtensionStoragePaths");let O=class{constructor(c,k,y){this.d=k,this.f=y,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return T.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,k=await this.g(c);try{return await this.f.value.stat(k),this.d.trace("[ExtHostStorage] storage dir already exists",k),k}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",k),await this.f.value.createDirectory(k),await this.f.value.writeFile(T.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),k}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(c){if(this.c)return T.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return T.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$aqc=O,e.$aqc=O=Ze([Ve(0,h.$EQ),Ve(1,C.$bk),Ve(2,R.$$pc)],O)}),define(ke[293],Ie([1,0,9,19,4]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0;let R=class{constructor(O){this.a=new r.$hP(r.ColorThemeKind.Dark),this.b=new C.$me}get activeColorTheme(){return this.a}$onColorThemeChange(O){let b;switch(O){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this.a=new r.$hP(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jrc=R,e.$Jrc=R=Ze([Ve(0,h.$oQ)],R)}),define(ke[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sGb=e.$rGb=e.TunnelDtoConverter=void 0,R=We(R),u=We(u);class P extends b.$Sw{}var w;(function(m){function p(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=p;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(w||(e.TunnelDtoConverter=w={})),e.$rGb=(0,T.$Gi)("IExtHostTunnelService");let a=class extends C.$Vc{constructor(p,f,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=p.getProxy(c.$ON.MainThreadTunnelService)}async openTunnel(p,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this.a.$openTunnel(f,p.displayName);if(i){const s=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(p,f){p.portRange===void 0&&p.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:p,provider:f}),this.a.$registerPortsAttributesProvider(p,i),new u.$QN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(p,f,i,s,t){const o=[];for(const d of p){const l=this.r.get(d);if(!l)return[];o.push(...await Promise.all(f.map(async g=>{let E;try{E=await l.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{E=await l.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:E,port:g}})))}const n=o.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(p){}registerTunnelProvider(p,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,t)=>await p.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(p,f){if(p){p.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this.f=p.showCandidatePort,this.a.$setCandidateFilter());const i=p.tunnelFactory??(f?this.w(f):void 0);if(i){this.b=i;let s=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(2703,null),themeIcon:"lock"},{id:"public",label:R.localize(2704,null),themeIcon:"eye"}]);const t=p.tunnelFeatures?{elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Tc)(()=>{this.b=void 0})}w(p){}async $closeTunnel(p,f){if(this.g.has(p.host)){const i=this.g.get(p.host);i.has(p.port)&&(f&&i.get(p.port).disposeListener.dispose(),await i.get(p.port).tunnel.dispose(),i.delete(p.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(p,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(p,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(p.remoteAddress.host)||this.g.set(p.remoteAddress.host,new Map);const t=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:s,disposeListener:t}),w.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(p){const f=await Promise.all(p.map(s=>this.f(s.host,s.port,s.detail??""))),i=p.filter((s,t)=>f[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$sGb=a,e.$sGb=a=Ze([Ve(0,y.$oQ),Ve(1,k.$EQ),Ve(2,O.$bk)],a)}),define(ke[15],Ie([1,0,18,21,191,79,85,28,180,44,103,24,185,22,51,17,2,113,30,110,87,58,147,89,158,155,156,271,119,126,73,74,268,9]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g,E,D,S,I,A,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$lQ=_,e.$mQ=ne,e.$nQ=ye,T=We(T),f=We(f),i=We(i),s=We(s),E=We(E),S=We(S),v=We(v);var M;(function(Re){function Fe(te){const{selectionStartLineNumber:Le,selectionStartColumn:Ge,positionLineNumber:_e,positionColumn:Je}=te,ft=new v.$RN(Le-1,Ge-1),At=new v.$RN(_e-1,Je-1);return new v.$TN(ft,At)}Re.to=Fe;function Se(te){const{anchor:Le,active:Ge}=te;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Re.from=Se})(M||(e.Selection=M={}));var N;(function(Re){function Fe(te){if(!te)return;const{start:Le,end:Ge}=te;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Re.from=Fe;function Se(te){if(!te)return;const{startLineNumber:Le,startColumn:Ge,endLineNumber:_e,endColumn:Je}=te;return new v.$SN(Le-1,Ge-1,_e-1,Je-1)}Re.to=Se})(N||(e.Range=N={}));var L;(function(Re){function Fe(te){return{uri:te.uri,range:N.from(te.range)}}Re.from=Fe;function Se(te){return new v.$5N(m.URI.revive(te.uri),N.to(te.range))}Re.to=Se})(L||(e.Location=L={}));var F;(function(Re){function Fe(Se){switch(Se){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Re.to=Fe})(F||(e.TokenType=F={}));var B;(function(Re){function Fe(te){return new v.$RN(te.lineNumber-1,te.column-1)}Re.to=Fe;function Se(te){return{lineNumber:te.line+1,column:te.character+1}}Re.from=Se})(B||(e.Position=B={}));var j;(function(Re){function Fe(Le,Ge,_e){return(0,r.$Hb)((0,r.$2b)(Le).map(Je=>Se(Je,Ge,_e)))}Re.from=Fe;function Se(Le,Ge,_e){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:_e?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:te(Le.scheme,Ge),pattern:tt.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:_e?.isBuiltin}}function te(Le,Ge){return Ge&&typeof Le=="string"?Ge.transformOutgoingScheme(Le):Le}})(j||(e.DocumentSelector=j={}));var U;(function(Re){function Fe(te){switch(te){case v.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Re.from=Fe;function Se(te){switch(te){case o.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(U||(e.DiagnosticTag=U={}));var z;(function(Re){function Fe(te){let Le;return te.code&&((0,a.$fg)(te.code)||(0,a.$jg)(te.code)?Le=String(te.code):Le={value:String(te.code.value),target:te.code.target}),{...N.from(te.range),message:te.message,source:te.source,code:Le,severity:V.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(ee.from),tags:Array.isArray(te.tags)?(0,r.$Hb)(te.tags.map(U.from)):void 0}}Re.from=Fe;function Se(te){const Le=new v.$7N(N.to(te),te.message,V.to(te.severity));return Le.source=te.source,Le.code=(0,a.$fg)(te.code)?te.code:te.code?.value,Le.relatedInformation=te.relatedInformation&&te.relatedInformation.map(ee.to),Le.tags=te.tags&&(0,r.$Hb)(te.tags.map(U.to)),Le}Re.to=Se})(z||(e.Diagnostic=z={}));var ee;(function(Re){function Fe(te){return{...N.from(te.location.range),message:te.message,resource:te.location.uri}}Re.from=Fe;function Se(te){return new v.$6N(new v.$5N(te.resource,N.to(te)),te.message)}Re.to=Se})(ee||(e.DiagnosticRelatedInformation=ee={}));var V;(function(Re){function Fe(te){switch(te){case v.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Re.from=Fe;function Se(te){switch(te){case o.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Re.to=Se})(V||(e.DiagnosticSeverity=V={}));var W;(function(Re){function Fe(te){return typeof te=="number"&&te>=v.ViewColumn.One?te-1:te===v.ViewColumn.Beside?$.$DE:$.$CE}Re.from=Fe;function Se(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(W||(e.ViewColumn=W={}));function J(Re){return typeof Re.range<"u"}function _(Re){return Re.length===0?!0:!!J(Re[0])}var ce;(function(Re){function Fe(Je){return Je.map(Re.from)}Re.fromMany=Fe;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function te(Je){let ft;if(Se(Je)){const{language:zt,value:ei}=Je;ft={value:"```"+zt+`
`+ei+"\n```\n"}}else v.$iO.isMarkdownString(Je)?ft={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ft={value:Je}:ft={value:""};const At=Object.create(null);ft.uris=At;const Xt=zt=>{try{let ei=m.URI.parse(zt,!0);ei=ei.with({query:Le(ei.query,At)}),At[zt]=ei}catch{}return""},_t=new b.marked.Renderer;return _t.link=Xt,_t.image=zt=>typeof zt=="string"?Xt(T.$al(zt).href):"",(0,b.marked)(ft.value,{renderer:_t}),ft}Re.from=te;function Le(Je,ft){if(!Je)return Je;let At;try{At=(0,c.$ci)(Je)}catch{}if(!At)return Je;let Xt=!1;return At=(0,y.$ho)(At,_t=>{if(m.URI.isUri(_t)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[zt]=_t,Xt=!0,zt}else return}),Xt?JSON.stringify(At):Je}function Ge(Je){const ft=new v.$iO(Je.value,Je.supportThemeIcons);return ft.isTrusted=Je.isTrusted,ft.supportHtml=Je.supportHtml,ft.baseUri=Je.baseUri?m.URI.from(Je.baseUri):void 0,ft}Re.to=Ge;function _e(Je){if(Je)return typeof Je=="string"?Je:Re.from(Je)}Re.fromStrict=_e})(ce||(e.MarkdownString=ce={}));function ne(Re){return _(Re)?Re.map(Fe=>({range:N.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?ce.fromMany(Fe.hoverMessage):Fe.hoverMessage?ce.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:N.from(Fe)}))}function ye(Re){return typeof Re>"u"?Re:typeof Re=="string"?m.URI.file(Re):Re}var ge;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?ye(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Fe})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var Y;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Re.from=Fe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(Re){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Re.from=Fe})(q||(e.DecorationRangeBehavior=q={}));var oe;(function(Re){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?q.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Y.from(Se.light):void 0,dark:Se.dark?Y.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Re.from=Fe})(oe||(e.DecorationRenderOptions=oe={}));var ve;(function(Re){function Fe(te){return{text:te.newText,eol:te.newEol&&je.from(te.newEol),range:N.from(te.range)}}Re.from=Fe;function Se(te){const Le=new v.$ZN(N.to(te.range),te.text);return Le.newEol=typeof te.eol>"u"?void 0:je.to(te.eol),Le}Re.to=Se})(ve||(e.TextEdit=ve={}));var ie;(function(Re){function Fe(te,Le){const Ge={edits:[]};if(te instanceof v.$3N){const _e=new O.$Cc;for(const Je of te._allEntries())Je._type===v.FileEditType.File&&m.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of te._allEntries())if(Je._type===v.FileEditType.File){let ft;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ft={type:"base64",value:(0,h.$9e)(h.$Oe.wrap(Je.options.contents))}:ft={type:"dataTransferItem",id:Je.options.contents._itemId}),Ge.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ft},metadata:Je.metadata})}else Je._type===v.FileEditType.Text?Ge.edits.push({resource:Je.uri,textEdit:ve.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Le?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Snippet?Ge.edits.push({resource:Je.uri,textEdit:{range:N.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Le?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Cell?Ge.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Je.uri)}):Je._type===v.FileEditType.CellReplace&&Ge.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:S.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(Ot.from)}})}return Ge}Re.from=Fe;function Se(te){const Le=new v.$3N,Ge=new O.$Bc;for(const _e of te.edits)if(_e.textEdit){const Je=_e,ft=m.URI.revive(Je.resource),At=N.to(Je.textEdit.range),Xt=Je.textEdit.text,_t=Je.textEdit.insertAsSnippet;let zt;_t?zt=v.$2N.replace(At,new v.$4N(Xt)):zt=v.$ZN.replace(At,Xt);const ei=Ge.get(ft);ei?ei.push(zt):Ge.set(ft,[zt])}else Le.renameFile(m.URI.revive(_e.oldResource),m.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of Ge)Le.set(_e,Je);return Le}Re.to=Se})(ie||(e.WorkspaceEdit=ie={}));var ae;(function(Re){const Fe=Object.create(null);Fe[v.SymbolKind.File]=s.SymbolKind.File,Fe[v.SymbolKind.Module]=s.SymbolKind.Module,Fe[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Fe[v.SymbolKind.Package]=s.SymbolKind.Package,Fe[v.SymbolKind.Class]=s.SymbolKind.Class,Fe[v.SymbolKind.Method]=s.SymbolKind.Method,Fe[v.SymbolKind.Property]=s.SymbolKind.Property,Fe[v.SymbolKind.Field]=s.SymbolKind.Field,Fe[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Fe[v.SymbolKind.Enum]=s.SymbolKind.Enum,Fe[v.SymbolKind.Interface]=s.SymbolKind.Interface,Fe[v.SymbolKind.Function]=s.SymbolKind.Function,Fe[v.SymbolKind.Variable]=s.SymbolKind.Variable,Fe[v.SymbolKind.Constant]=s.SymbolKind.Constant,Fe[v.SymbolKind.String]=s.SymbolKind.String,Fe[v.SymbolKind.Number]=s.SymbolKind.Number,Fe[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Fe[v.SymbolKind.Array]=s.SymbolKind.Array,Fe[v.SymbolKind.Object]=s.SymbolKind.Object,Fe[v.SymbolKind.Key]=s.SymbolKind.Key,Fe[v.SymbolKind.Null]=s.SymbolKind.Null,Fe[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Fe[v.SymbolKind.Struct]=s.SymbolKind.Struct,Fe[v.SymbolKind.Event]=s.SymbolKind.Event,Fe[v.SymbolKind.Operator]=s.SymbolKind.Operator,Fe[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function Se(Le){return typeof Fe[Le]=="number"?Fe[Le]:s.SymbolKind.Property}Re.from=Se;function te(Le){for(const Ge in Fe)if(Fe[Ge]===Le)return Number(Ge);return v.SymbolKind.Property}Re.to=te})(ae||(e.SymbolKind=ae={}));var se;(function(Re){function Fe(te){switch(te){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Re.from=Fe;function Se(te){switch(te){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Re.to=Se})(se||(e.SymbolTag=se={}));var X;(function(Re){function Fe(te){return{name:te.name,kind:ae.from(te.kind),tags:te.tags&&te.tags.map(se.from),containerName:te.containerName,location:ze.from(te.location)}}Re.from=Fe;function Se(te){const Le=new v.$_N(te.name,ae.to(te.kind),te.containerName,ze.to(te.location));return Le.tags=te.tags&&te.tags.map(se.to),Le}Re.to=Se})(X||(e.WorkspaceSymbol=X={}));var re;(function(Re){function Fe(te){const Le={name:te.name||"!!MISSING: name!!",detail:te.detail,range:N.from(te.range),selectionRange:N.from(te.selectionRange),kind:ae.from(te.kind),tags:te.tags?.map(se.from)??[]};return te.children&&(Le.children=te.children.map(Fe)),Le}Re.from=Fe;function Se(te){const Le=new v.$aO(te.name,te.detail,ae.to(te.kind),N.to(te.range),N.to(te.selectionRange));return(0,r.$Lb)(te.tags)&&(Le.tags=te.tags.map(se.to)),te.children&&(Le.children=te.children.map(Se)),Le}Re.to=Se})(re||(e.DocumentSymbol=re={}));var pe;(function(Re){function Fe(te){const Le=new v.$eO(ae.to(te.kind),te.name,te.detail||"",m.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}Re.to=Fe;function Se(te,Le,Ge){if(Le=Le??te._sessionId,Ge=Ge??te._itemId,Le===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ge,name:te.name,detail:te.detail,kind:ae.from(te.kind),uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(se.from)}}Re.from=Se})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Re){function Fe(Se){return new v.$fO(pe.to(Se.from),Se.fromRanges.map(te=>N.to(te)))}Re.to=Fe})(we||(e.CallHierarchyIncomingCall=we={}));var Me;(function(Re){function Fe(Se){return new v.$gO(pe.to(Se.to),Se.fromRanges.map(te=>N.to(te)))}Re.to=Fe})(Me||(e.CallHierarchyOutgoingCall=Me={}));var ze;(function(Re){function Fe(te){return{range:te.range&&N.from(te.range),uri:te.uri}}Re.from=Fe;function Se(te){return new v.$5N(m.URI.revive(te.uri),N.to(te.range))}Re.to=Se})(ze||(e.location=ze={}));var Ae;(function(Re){function Fe(te){const Le=te,Ge=te;return{originSelectionRange:Le.originSelectionRange?N.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ge.uri,range:N.from(Le.targetRange?Le.targetRange:Ge.range),targetSelectionRange:Le.targetSelectionRange?N.from(Le.targetSelectionRange):void 0}}Re.from=Fe;function Se(te){return{targetUri:m.URI.revive(te.uri),targetRange:N.to(te.range),targetSelectionRange:te.targetSelectionRange?N.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?N.to(te.originSelectionRange):void 0}}Re.to=Se})(Ae||(e.DefinitionLink=Ae={}));var De;(function(Re){function Fe(te){return{range:N.from(te.range),contents:ce.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}Re.from=Fe;function Se(te){const Le=te.contents.map(ce.to),Ge=N.to(te.range),_e=te.canIncreaseVerbosity,Je=te.canDecreaseVerbosity;return new v.$9N(Le,Ge,_e,Je)}Re.to=Se})(De||(e.Hover=De={}));var Ce;(function(Re){function Fe(te){return{range:N.from(te.range),expression:te.expression}}Re.from=Fe;function Se(te){return new v.$4O(N.to(te.range),te.expression)}Re.to=Se})(Ce||(e.EvaluatableExpression=Ce={}));var H;(function(Re){function Fe(te){if(te instanceof v.$5O)return{type:"text",range:N.from(te.range),text:te.text};if(te instanceof v.$6O)return{type:"variable",range:N.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof v.$7O)return{type:"expression",range:N.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function Se(te){switch(te.type){case"text":return{range:N.to(te.range),text:te.text};case"variable":return{range:N.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:N.to(te.range),expression:te.expression}}}Re.to=Se})(H||(e.InlineValue=H={}));var G;(function(Re){function Fe(te){return{frameId:te.frameId,stoppedLocation:N.from(te.stoppedLocation)}}Re.from=Fe;function Se(te){return new v.$8O(te.frameId,N.to(te.stoppedLocation))}Re.to=Se})(G||(e.InlineValueContext=G={}));var Z;(function(Re){function Fe(te){return{range:N.from(te.range),kind:te.kind}}Re.from=Fe;function Se(te){return new v.$0N(N.to(te.range),te.kind)}Re.to=Se})(Z||(e.DocumentHighlight=Z={}));var x;(function(Re){function Fe(te){return{uri:te.uri,highlights:te.highlights.map(Z.from)}}Re.from=Fe;function Se(te){return new v.$$N(m.URI.revive(te.uri),te.highlights.map(Z.to))}Re.to=Se})(x||(e.MultiDocumentHighlight=x={}));var de;(function(Re){function Fe(Se){switch(Se){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Re.to=Fe})(de||(e.CompletionTriggerKind=de={}));var Ee;(function(Re){function Fe(Se){return{triggerKind:de.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Fe})(Ee||(e.CompletionContext=Ee={}));var Te;(function(Re){function Fe(te){switch(te){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Re.from=Fe;function Se(te){switch(te){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Re.to=Se})(Te||(e.CompletionItemTag=Te={}));var He;(function(Re){const Fe=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function Se(Ge){return Fe.get(Ge)??s.CompletionItemKind.Property}Re.from=Se;const te=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Le(Ge){return te.get(Ge)??v.CompletionItemKind.Property}Re.to=Le})(He||(e.CompletionItemKind=He={}));var Ke;(function(Re){function Fe(Se,te){const Le=new v.$oO(Se.label);return Le.insertText=Se.insertText,Le.kind=He.to(Se.kind),Le.tags=Se.tags?.map(Te.to),Le.detail=Se.detail,Le.documentation=T.$7k(Se.documentation)?ce.to(Se.documentation):Se.documentation,Le.sortText=Se.sortText,Le.filterText=Se.filterText,Le.preselect=Se.preselect,Le.commitCharacters=Se.commitCharacters,f.$Rt.isIRange(Se.range)?Le.range=N.to(Se.range):typeof Se.range=="object"&&(Le.range={inserting:N.to(Se.range.insert),replacing:N.to(Se.range.replace)}),Le.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Le.insertText=new v.$4N(Se.insertText):(Le.insertText=Se.insertText,Le.textEdit=Le.range instanceof v.$SN?new v.$ZN(Le.range,Le.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Le.additionalTextEdits=Se.additionalTextEdits.map(Ge=>ve.to(Ge))),Le.command=te&&Se.command?te.fromInternal(Se.command):void 0,Le}Re.to=Fe})(Ke||(e.CompletionItem=Ke={}));var et;(function(Re){function Fe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:ce.fromStrict(te.documentation)}}Re.from=Fe;function Se(te){return{label:te.label,documentation:T.$7k(te.documentation)?ce.to(te.documentation):te.documentation}}Re.to=Se})(et||(e.ParameterInformation=et={}));var nt;(function(Re){function Fe(te){return{label:te.label,documentation:ce.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(et.from):[],activeParameter:te.activeParameter}}Re.from=Fe;function Se(te){return{label:te.label,documentation:T.$7k(te.documentation)?ce.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(et.to):[],activeParameter:te.activeParameter}}Re.to=Se})(nt||(e.SignatureInformation=nt={}));var st;(function(Re){function Fe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.from):[]}}Re.from=Fe;function Se(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(nt.to):[]}}Re.to=Se})(st||(e.SignatureHelp=st={}));var rt;(function(Re){function Fe(Se,te){const Le=new v.$nO(B.to(te.position),typeof te.label=="string"?te.label:te.label.map(at.to.bind(void 0,Se)),te.kind&&gt.to(te.kind));return Le.textEdits=te.textEdits&&te.textEdits.map(ve.to),Le.tooltip=T.$7k(te.tooltip)?ce.to(te.tooltip):te.tooltip,Le.paddingLeft=te.paddingLeft,Le.paddingRight=te.paddingRight,Le}Re.to=Fe})(rt||(e.InlayHint=rt={}));var at;(function(Re){function Fe(Se,te){const Le=new v.$mO(te.label);return Le.tooltip=T.$7k(te.tooltip)?ce.to(te.tooltip):te.tooltip,s.Command.is(te.command)&&(Le.command=Se.fromInternal(te.command)),te.location&&(Le.location=ze.to(te.location)),Le}Re.to=Fe})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Re){function Fe(te){return te}Re.from=Fe;function Se(te){return te}Re.to=Se})(gt||(e.InlayHintKind=gt={}));var dt;(function(Re){function Fe(te){return{range:N.from(te.range),url:te.target,tooltip:te.tooltip}}Re.from=Fe;function Se(te){let Le;if(te.url)try{Le=typeof te.url=="string"?m.URI.parse(te.url,!0):m.URI.revive(te.url)}catch{}const Ge=new v.$tO(N.to(te.range),Le);return Ge.tooltip=te.tooltip,Ge}Re.to=Se})(dt||(e.DocumentLink=dt={}));var ct;(function(Re){function Fe(te){const Le=new v.$wO(te.label);return te.textEdit&&(Le.textEdit=ve.to(te.textEdit)),te.additionalTextEdits&&(Le.additionalTextEdits=te.additionalTextEdits.map(Ge=>ve.to(Ge))),Le}Re.to=Fe;function Se(te){return{label:te.label,textEdit:te.textEdit?ve.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Le=>ve.from(Le)):void 0}}Re.from=Se})(ct||(e.ColorPresentation=ct={}));var Pe;(function(Re){function Fe(te){return new v.$uO(te[0],te[1],te[2],te[3])}Re.to=Fe;function Se(te){return[te.red,te.green,te.blue,te.alpha]}Re.from=Se})(Pe||(e.Color=Pe={}));var Be;(function(Re){function Fe(te){return{range:N.from(te.range)}}Re.from=Fe;function Se(te){return new v.$dO(N.to(te.range))}Re.to=Se})(Be||(e.SelectionRange=Be={}));var Qe;(function(Re){function Fe(Se){switch(Se){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var Ne;(function(Re){function Fe(te){switch(te){case v.TextEditorLineNumbersStyle.Off:return p.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return p.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return p.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return p.RenderLineNumbersType.On}}Re.from=Fe;function Se(te){switch(te){case p.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case p.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case p.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case p.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Re.to=Se})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var je;(function(Re){function Fe(te){if(te===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(te===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Re.from=Fe;function Se(te){if(te===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(te===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Re.to=Se})(je||(e.EndOfLine=je={}));var ue;(function(Re){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(ue||(e.ProgressLocation=ue={}));var he;(function(Re){function Fe(te){const Le={start:te.start+1,end:te.end+1};return te.kind&&(Le.kind=le.from(te.kind)),Le}Re.from=Fe;function Se(te){const Le={start:te.start-1,end:te.end-1};return te.kind&&(Le.kind=le.to(te.kind)),Le}Re.to=Se})(he||(e.FoldingRange=he={}));var le;(function(Re){function Fe(te){if(te)switch(te){case v.FoldingRangeKind.Comment:return s.$Su.Comment;case v.FoldingRangeKind.Imports:return s.$Su.Imports;case v.FoldingRangeKind.Region:return s.$Su.Region}}Re.from=Fe;function Se(te){if(te)switch(te.value){case s.$Su.Comment.value:return v.FoldingRangeKind.Comment;case s.$Su.Imports.value:return v.FoldingRangeKind.Imports;case s.$Su.Region.value:return v.FoldingRangeKind.Region}}Re.to=Se})(le||(e.FoldingRangeKind=le={}));var Xe;(function(Re){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?N.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.$7F.id:void 0}}Re.from=Fe})(Xe||(e.TextEditorOpenOptions=Xe={}));var tt;(function(Re){function Fe(Ge){return Ge instanceof v.$RO?Ge.toJSON():typeof Ge=="string"?Ge:Se(Ge)||te(Ge)?new v.$RO(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Re.from=Fe;function Se(Ge){const _e=Ge;return _e?m.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function te(Ge){const _e=Ge;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Le(Ge){return typeof Ge=="string"?Ge:new v.$RO(m.URI.revive(Ge.baseUri),Ge.pattern)}Re.to=Le})(tt||(e.GlobPattern=tt={}));var ut;(function(Re){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const te=Se;return{language:te.language,scheme:te.scheme,pattern:tt.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Re.from=Fe})(ut||(e.LanguageSelector=ut={}));var mt;(function(Re){function Fe(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Le=>Array.isArray(Le)&&Le.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&m.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(_e=>_e instanceof v.$SN)))}Re.is=Fe;function Se(te){return{documents:te.documents.map(Le=>Le.map(Ge=>({uri:m.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>N.from(_e))})))}}Re.from=Se})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Re){function Fe(te){return{start:te.start,end:te.end}}Re.from=Fe;function Se(te){return new v.$iP(te.start,te.end)}Re.to=Se})(Dt||(e.NotebookRange=Dt={}));var Ft;(function(Re){function Fe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Re.to=Fe;function Se(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Re.from=Se})(Ft||(e.NotebookCellExecutionSummary=Ft={}));var Ht;(function(Re){function Fe(Se){if(Se===S.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(Se===S.NotebookCellExecutionState.Pending)return;if(Se===S.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Fe})(Ht||(e.NotebookCellExecutionState=Ht={}));var ti;(function(Re){function Fe(te){switch(te){case v.NotebookCellKind.Markup:return S.CellKind.Markup;case v.NotebookCellKind.Code:default:return S.CellKind.Code}}Re.from=Fe;function Se(te){switch(te){case S.CellKind.Markup:return v.NotebookCellKind.Markup;case S.CellKind.Code:default:return v.NotebookCellKind.Code}}Re.to=Se})(ti||(e.NotebookCellKind=ti={}));var oi;(function(Re){function Fe(te){const Le={metadata:te.metadata??Object.create(null),cells:[]};for(const Ge of te.cells)v.$jP.validate(Ge),Le.cells.push(Ot.from(Ge));return Le}Re.from=Fe;function Se(te){const Le=new v.$kP(te.cells.map(Ot.to));return(0,a.$sg)(te.metadata)||(Le.metadata=te.metadata),Le}Re.to=Se})(oi||(e.NotebookData=oi={}));var Ot;(function(Re){function Fe(te){return{cellKind:ti.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ft.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Ct.from):[]}}Re.from=Fe;function Se(te){return new v.$jP(ti.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Ct.to):void 0,te.metadata,te.internalMetadata?Ft.to(te.internalMetadata):void 0)}Re.to=Se})(Ot||(e.NotebookCellData=Ot={}));var it;(function(Re){function Fe(te){return{mime:te.mime,valueBytes:h.$Oe.wrap(te.data)}}Re.from=Fe;function Se(te){return new v.$lP(te.valueBytes.buffer,te.mime)}Re.to=Se})(it||(e.NotebookCellOutputItem=it={}));var Ct;(function(Re){function Fe(te){return{outputId:te.id,items:te.items.map(it.from),metadata:te.metadata}}Re.from=Fe;function Se(te){const Le=te.items.map(it.to);return new v.$mP(Le,te.outputId,te.metadata)}Re.to=Se})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(Re){function Fe(Le){return te(Le)?{include:tt.from(Le.include)??void 0,exclude:tt.from(Le.exclude)??void 0}:tt.from(Le)??void 0}Re.from=Fe;function Se(Le){return te(Le)?{include:tt.to(Le.include),exclude:tt.to(Le.exclude)}:tt.to(Le)}Re.to=Se;function te(Le){const Ge=Le;return Ge?!(0,a.$og)(Ge.include)&&!(0,a.$og)(Ge.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var bt;(function(Re){function Fe(Se,te,Le){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===v.NotebookCellStatusBarAlignment.Left?S.CellStatusbarAlignment.Left:S.CellStatusbarAlignment.Right,command:te.toInternal(Ge,Le),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Fe})(bt||(e.NotebookStatusBarItem=bt={}));var St;(function(Re){function Fe(Se,te,Le){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:te.toInternal(Ge,Le),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Fe})(St||(e.NotebookKernelSourceAction=St={}));var ii;(function(Re){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Fe})(ii||(e.NotebookDocumentContentOptions=ii={}));var ni;(function(Re){function Fe(te){return{uri:te.uri,provides:te.provides}}Re.from=Fe;function Se(te){return new v.$oP(m.URI.revive(te.uri),te.provides)}Re.to=Se})(ni||(e.NotebookRendererScript=ni={}));var qt;(function(Re){function Fe(te){return{message:ce.fromStrict(te.message)||"",type:A.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:N.from(te.location.range),uri:te.location.uri},stackTrace:te.stackTrace?.map(Le=>({label:Le.label,position:Le.position&&B.from(Le.position),uri:Le.uri&&m.URI.revive(Le.uri).toJSON()}))}}Re.from=Fe;function Se(te){const Le=new v.$uP(typeof te.message=="string"?te.message:ce.to(te.message));return Le.actualOutput=te.actual,Le.expectedOutput=te.expected,Le.contextValue=te.contextValue,Le.location=te.location?ze.to(te.location):void 0,Le}Re.to=Se})(qt||(e.TestMessage=qt={}));var pt;(function(Re){Re.namespace=A.$dJ,Re.denamespace=A.$eJ})(pt||(e.TestTag=pt={}));var Bt;(function(Re){function Fe(te){const Le=(0,d.$kQ)(te).controllerId;return{extId:I.$$I.fromExtHostTestItem(te,Le).toString(),label:te.label,uri:m.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ge=>pt.namespace(Le,Ge.id)),range:f.$Rt.lift(N.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&ce.fromStrict(te.error)||null}}Re.from=Fe;function Se(te){return{parent:void 0,error:void 0,id:I.$$I.fromString(te.extId).localId,label:te.label,uri:m.URI.revive(te.uri),tags:(te.tags||[]).map(Le=>{const{tagId:Ge}=pt.denamespace(Le);return new v.$vP(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Re.toPlain=Se})(Bt||(e.TestItem=Bt={})),function(Re){function Fe(te){return{id:te.id}}Re.from=Fe;function Se(te){return new v.$vP(te.id)}Re.to=Se}(pt||(e.TestTag=pt={}));var ri;(function(Re){const Fe=(te,Le)=>{const Ge=te.value;if(!Ge)return;const _e={...Bt.toPlain(Ge.item),parent:Le,taskStates:Ge.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(qt.to)})),children:[]};if(te.children)for(const Je of te.children.values()){const ft=Fe(Je,_e);ft&&_e.children.push(ft)}return _e};function Se(te){const Le=new u.$0I;for(const Je of te.items)Le.insert(I.$$I.fromString(Je.item.extId).path,Je);const Ge=[Le.nodes],_e=[];for(;Ge.length;)for(const Je of Ge.pop())Je.value?_e.push(Je):Je.children&&Ge.push(Je.children.values());return{completedAt:te.completedAt,results:_e.map(Je=>Fe(Je)).filter(a.$ng)}}Re.to=Se})(ri||(e.TestResults=ri={}));var ai;(function(Re){function Fe(Ge){return{covered:Ge.covered,total:Ge.total}}function Se(Ge){return"line"in Ge?B.from(Ge):N.from(Ge)}function te(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:Se(Ge.location),type:A.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(_e=>({count:_e.executed,location:_e.location&&Se(_e.location),label:_e.label})):void 0}:{type:A.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:Se(Ge.location)}}Re.fromDetails=te;function Le(Ge,_e,Je){return v.$yP(Je.statementCoverage),v.$yP(Je.branchCoverage),v.$yP(Je.declarationCoverage),{id:_e,uri:Je.uri,statement:Fe(Je.statementCoverage),branch:Je.branchCoverage&&Fe(Je.branchCoverage),declaration:Je.declarationCoverage&&Fe(Je.declarationCoverage),testIds:Je instanceof v.$zP&&Je.fromTests.length?Je.fromTests.map(ft=>I.$$I.fromExtHostTestItem(ft,Ge).toString()):void 0}}Re.fromFile=Le})(ai||(e.TestCoverage=ai={}));var xe;(function(Re){function Fe(Se){switch(Se){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Re.to=Fe})(xe||(e.CodeActionTriggerKind=xe={}));var ci;(function(Re){function Fe(te){const Le=new v.$DP(ae.to(te.kind),te.name,te.detail||"",m.URI.revive(te.uri),N.to(te.range),N.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}Re.to=Fe;function Se(te,Le,Ge){if(Le=Le??te._sessionId,Ge=Ge??te._itemId,Le===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ge,kind:ae.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:N.from(te.range),selectionRange:N.from(te.selectionRange),tags:te.tags?.map(se.from)}}Re.from=Se})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(Re){function Fe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Fe})(di||(e.ViewBadge=di={}));var fi;(function(Re){function Fe(Ge,_e,Je){const ft=_e.fileData;return ft?new v.$JO(new v.$KO(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.$db)(()=>Je(ft.id)))):Ge===k.$bt.uriList&&_e.uriListData?new v.$IO(Le(_e.uriListData)):new v.$IO(_e.asString)}Re.to=Fe;async function Se(Ge,_e){const Je=await _e.asString();if(Ge===k.$bt.uriList)return{asString:Je,fileData:void 0,uriListData:te(Je)};const ft=_e.asFile();return{asString:Je,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Re.from=Se;function te(Ge){return C.$wu.split(Ge).map(_e=>{if(_e.startsWith("#"))return _e;try{return m.URI.parse(_e)}catch{}return _e})}function Le(Ge){return C.$wu.create(Ge.map(_e=>typeof _e=="string"?_e:m.URI.revive(_e)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(Re){function Fe(te,Le){const Ge=te.items.map(([_e,Je])=>[_e,fi.to(_e,Je,Le)]);return new v.$LO(Ge)}Re.toDataTransfer=Fe;async function Se(te){const Le={items:[]},Ge=[];for(const[_e,Je]of te)Ge.push((async()=>{Le.items.push([_e,await fi.from(_e,Je)])})());return await Promise.all(Ge),Le}Re.from=Se})(vt||(e.DataTransfer=vt={}));var jt;(function(Re){function Fe(te,Le){return{kind:"reply",agentId:te.participant??Le?.agentId??"",subCommand:te.command??Le?.command,message:te.prompt,title:te.label}}Re.from=Fe;function Se(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Re.to=Se})(jt||(e.ChatFollowup=jt={}));var Nt;(function(Re){function Fe(te){switch(te){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Re.to=Fe;function Se(te){switch(te){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Re.from=Se})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var Gt;(function(Re){function Fe(te){let Le="",Ge;te.content.type==="text"?Le=te.content.value:Ge=new v.$8P(te.content.name,te.content.value,te.content.isError);const _e=Nt.to(te.role),Je=new v.$9P(_e,Le,te.name);return Ge!==void 0&&(Je.content2=Ge),Je}Re.to=Fe;function Se(te){const Le=Nt.from(te.role),Ge=te.name;let _e;return te.content2 instanceof v.$8P?_e={type:"function_result",name:te.content2.name,value:te.content2.content,isError:te.content2.isError}:_e={type:"text",value:te.content},{role:Le,name:Ge,content:_e}}Re.from=Se})(Gt||(e.LanguageModelChatMessage=Gt={}));var si;(function(Re){function Fe(te){return{kind:"markdownContent",content:ce.from(te.value)}}Re.from=Fe;function Se(te){return new v.$QP(ce.to(te.content))}Re.to=Se})(si||(e.ChatResponseMarkdownPart=si={}));var Jt;(function(Re){function Fe(te){return{kind:"markdownVuln",content:ce.from(te.value),vulnerabilities:te.vulnerabilities}}Re.from=Fe;function Se(te){return new v.$RP(ce.to(te.content),te.vulnerabilities)}Re.to=Se})(Jt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Jt={}));var li;(function(Re){function Fe(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}Re.from=Fe;function Se(te){return new v.$SP(te.agentId,te.command)}Re.to=Se})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Wt;(function(Re){function Fe(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data,buttons:Se.buttons}}Re.from=Fe})(Wt||(e.ChatResponseConfirmationPart=Wt={}));var Kt;(function(Re){function Fe(te){const{value:Le,baseUri:Ge}=te;function _e(Je,ft){return Je.map(At=>{const Xt=m.URI.joinPath(ft,At.name);return{label:At.name,uri:Xt,children:At.children&&_e(At.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,P.$eh)(Ge),uri:Ge,children:_e(Le,Ge)}}}Re.from=Fe;function Se(te){const Le=(0,c.$di)(te.treeData);function Ge(ft){return ft.map(At=>({name:At.label,children:At.children&&Ge(At.children)}))}const _e=Le.uri,Je=Le.children?Ge(Le.children):[];return new v.$UP(Je,_e)}Re.to=Se})(Kt||(e.ChatResponseFilesPart=Kt={}));var Zt;(function(Re){function Fe(te){const Le=Ge=>m.URI.isUri(Ge);return{kind:"inlineReference",name:te.title,inlineReference:Le(te.value)?te.value:L.from(te.value)}}Re.from=Fe;function Se(te){const Le=(0,c.$di)(te);return new v.$VP(m.URI.isUri(Le.inlineReference)?Le.inlineReference:L.to(Le.inlineReference),te.name)}Re.to=Se})(Zt||(e.ChatResponseAnchorPart=Zt={}));var Mt;(function(Re){function Fe(te){return{kind:"progressMessage",content:ce.from(te.value)}}Re.from=Fe;function Se(te){return new v.$WP(te.content.value)}Re.to=Se})(Mt||(e.ChatResponseProgressPart=Mt={}));var wt;(function(Re){function Fe(te){return{kind:"warning",content:ce.from(te.value)}}Re.from=Fe;function Se(te){return new v.$YP(te.content.value)}Re.to=Se})(wt||(e.ChatResponseWarningPart=wt={}));var It;(function(Re){function Fe(Se){return{kind:"progressTask",content:ce.from(Se.value)}}Re.from=Fe})(It||(e.ChatTask=It={}));var Qt;(function(Re){function Fe(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?ce.from(Se):void 0}}Re.from=Fe})(Qt||(e.ChatTaskResult=Qt={}));var Pt;(function(Re){function Fe(te,Le,Ge){return{kind:"command",command:Le.toInternal(te.value,Ge)??{command:te.value.command,title:te.value.title}}}Re.from=Fe;function Se(te,Le){return new v.$ZP(Le.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Re.to=Se})(Pt||(e.ChatResponseCommandButtonPart=Pt={}));var mi;(function(Re){function Fe(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Le=>ve.from(Le))}}Re.from=Fe;function Se(te){return new v.$3P(m.URI.revive(te.uri),te.edits.map(Le=>ve.to(Le)))}Re.to=Se})(mi||(e.ChatResponseTextEditPart=mi={}));var xt;(function(Re){function Fe(te){const Le=w.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:m.URI.isUri(te.iconPath)?{light:m.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&m.URI.isUri(te.iconPath.light)&&m.URI.isUri(te.iconPath.dark)?{light:m.URI.revive(te.iconPath.light),dark:m.URI.revive(te.iconPath.dark)}:void 0;return"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:m.URI.isUri(te.value.value)||!te.value.value?te.value.value:L.from(te.value.value)},iconPath:Le,options:te.options}:{kind:"reference",reference:m.URI.isUri(te.value)?te.value:L.from(te.value),iconPath:Le,options:te.options}}Re.from=Fe;function Se(te){const Le=(0,c.$di)(te),Ge=_e=>m.URI.isUri(_e)?_e:L.to(_e);return new v.$1P("variableName"in Le.reference?{variableName:Le.reference.variableName,value:Le.reference.value&&Ge(Le.reference.value)}:Ge(Le.reference))}Re.to=Se})(xt||(e.ChatResponseReferencePart=xt={}));var ki;(function(Re){function Fe(Se){return{kind:"codeCitation",value:Se.value,license:Se.license,snippet:Se.snippet}}Re.from=Fe})(ki||(e.ChatResponseCodeCitationPart=ki={}));var wi;(function(Re){function Fe(Le,Ge,_e){return Le instanceof v.$QP?si.from(Le):Le instanceof v.$VP?Zt.from(Le):Le instanceof v.$1P?xt.from(Le):Le instanceof v.$WP?Mt.from(Le):Le instanceof v.$UP?Kt.from(Le):Le instanceof v.$ZP?Pt.from(Le,Ge,_e):Le instanceof v.$3P?mi.from(Le):Le instanceof v.$RP?Jt.from(Le):Le instanceof v.$SP?li.from(Le):Le instanceof v.$YP?wt.from(Le):Le instanceof v.$TP?Wt.from(Le):Le instanceof v.$2P?ki.from(Le):{kind:"markdownContent",content:ce.from("")}}Re.from=Fe;function Se(Le,Ge){switch(Le.kind){case"reference":return xt.to(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Le,Ge)}}Re.to=Se;function te(Le,Ge){switch(Le.kind){case"markdownContent":return si.to(Le);case"inlineReference":return Zt.to(Le);case"progressMessage":return;case"treeData":return Kt.to(Le);case"command":return Pt.to(Le,Ge)}}Re.toContent=te})(wi||(e.ChatResponsePart=wi={}));var Oi;(function(Re){function Fe(Se,te){const Le=Se.variables.variables.filter(_e=>_e.isTool).map(_e=>_e.id),Ge=Se.variables.variables.filter(_e=>!_e.isTool);return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,references:Ge.map(Ni.to),location:Tt.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData,location2:te,requestedTools:Le}}Re.to=Fe})(Oi||(e.ChatAgentRequest=Oi={}));var Tt;(function(Re){function Fe(te){switch(te){case g.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Re.to=Fe;function Se(te){switch(te){case v.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Re.from=Se})(Tt||(e.ChatLocation=Tt={}));var Ni;(function(Re){function Fe(Se){const te=Se.value;if(!te)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,m.$wc)(te)?m.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,m.$wc)(te.uri)?L.to((0,c.$di)(te)):te,modelDescription:Se.modelDescription}}Re.to=Fe})(Ni||(e.ChatAgentValueReference=Ni={}));var ui;(function(Re){function Fe(Se,te,Le){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:te.toInternal(Se.command,Le)}}Re.from=Fe})(ui||(e.ChatAgentCompletionItem=ui={}));var Rt;(function(Re){function Fe(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata,nextQuestion:Se.nextQuestion}}Re.to=Fe})(Rt||(e.ChatAgentResult=Rt={}));var Ti;(function(Re){function Fe(Se,te,Le){if(te.action.kind==="vote")return;const Ge=Rt.to(Se);if(te.action.kind==="command"){const _e=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Le.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Ge}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:jt.to(te.action.followup)},result:Ge}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:Ge}:{action:te.action,result:Ge}}Re.to=Fe})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var Ii;(function(Re){function Fe(te){return{...te,string:te.toString()}}Re.from=Fe;function Se(te){const Le={...te,toString:()=>te.string};return delete Le.string,Le}Re.to=Se})(Ii||(e.LanguageModelToolResult=Ii={}));var Si;(function(Re){function Fe(Se,te,Le){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:te.toInternal(Se,Le)}Re.from=Fe})(Si||(e.TerminalQuickFix=Si={}));var ji;(function(Re){function Fe(Se){return{kind:$i.to(Se.kind)}}Re.to=Fe})(ji||(e.PartialAcceptInfo=ji={}));var $i;(function(Re){function Fe(Se){switch(Se){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Re.to=Fe})($i||(e.PartialAcceptTriggerKind=$i={}));var Vt;(function(Re){function Fe(Se,te){return{id:te,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}Re.from=Fe})(Vt||(e.DebugTreeItem=Vt={}));var Pi;(function(Re){function Fe(Se){return{name:Se.name,description:Se.description,parametersSchema:Se.parametersSchema}}Re.to=Fe})(Pi||(e.LanguageModelToolDescription=Pi={}))}),define(ke[294],Ie([1,0,6,19,15,53]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0;let T=class{constructor(b,c){this.a=b.getProxy(r.$ON.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>c.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,c,k){const y=new R.$2w(C.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,k?.isRefactoring??!1)}};e.$Vpc=T,e.$Vpc=T=Ze([Ve(0,h.$oQ)],T)}),define(ke[295],Ie([1,0,18,7,52,4,39,3,44,42,17,2,23,6,15,9,156,257,25]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0,w=We(w),a=We(a);class i{constructor(n,d,l,g,E){this.j=n,this.k=d,this.l=l,this.m=g,this.n=E,this.b=c.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(g){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,g),E}};const n=this;this.b.reset();const l=(g,E)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,g),S={report:I=>{D?.then(A=>{A&&(a.$iO.isMarkdownString(I.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(I),A):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(I),A))})}};Promise.all([D,E?.(S)]).then(([I,A])=>{I!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(A),I)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){d(this.markdown);const E=new a.$QP(g),D=w.ChatResponseMarkdownPart.from(E);return l(D),this},markdownWithVulnerabilities(g,E){d(this.markdown),E&&(0,f.$jH)(n.j,"chatParticipantAdditions");const D=new a.$RP(g,E),S=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return l(S),this},filetree(g,E){d(this.filetree);const D=new a.$UP(g,E),S=w.ChatResponseFilesPart.from(D);return l(S),this},anchor(g,E){d(this.anchor);const D=new a.$VP(g,E),S=w.ChatResponseAnchorPart.from(D);return l(S),this},button(g){d(this.anchor);const E=new a.$ZP(g),D=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(D),this},progress(g,E){d(this.progress);const D=new a.$XP(g,E),S=E?w.ChatTask.from(D):w.ChatResponseProgressPart.from(D);return l(S,E),this},warning(g){d(this.progress),(0,f.$jH)(n.j,"chatParticipantAdditions");const E=new a.$YP(g),D=w.ChatResponseWarningPart.from(E);return l(D),this},reference(g,E){return this.reference2(g,E)},reference2(g,E,D){if(d(this.reference),"variableName"in g&&(0,f.$jH)(n.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const S=n.k.variables.variables.find(I=>I.name===g.variableName);if(S){let I;if(S.references?.length)I=S.references.map(A=>({kind:"reference",reference:{variableName:g.variableName,value:A.reference}}));else{const A=new a.$1P(g,E,D);I=[w.ChatResponseReferencePart.from(A)]}return I.forEach(A=>l(A)),this}}else{const S=new a.$1P(g,E,D),I=w.ChatResponseReferencePart.from(S);l(I)}return this},codeCitation(g,E,D){d(this.codeCitation),(0,f.$jH)(n.j,"chatParticipantAdditions");const S=new a.$2P(g,E,D),I=w.ChatResponseCodeCitationPart.from(S);l(I)},textEdit(g,E){d(this.textEdit),(0,f.$jH)(n.j,"chatParticipantAdditions");const D=new a.$3P(g,E),S=w.ChatResponseTextEditPart.from(D);return l(S),this},detectedParticipant(g,E){d(this.detectedParticipant),(0,f.$jH)(n.j,"chatParticipantAdditions");const D=new a.$SP(g,E),S=w.ChatResponseDetectedParticipantPart.from(D);return l(S),this},confirmation(g,E,D,S){d(this.confirmation),(0,f.$jH)(n.j,"chatParticipantAdditions");const I=new a.$TP(g,E,D,S),A=w.ChatResponseConfirmationPart.from(I);return l(A),this},push(g){if(d(this.push),(g instanceof a.$3P||g instanceof a.$RP||g instanceof a.$SP||g instanceof a.$YP||g instanceof a.$TP||g instanceof a.$2P)&&(0,f.$jH)(n.j,"chatParticipantAdditions"),g instanceof a.$1P)this.reference2(g.value,g.iconPath,g.options);else{const E=w.ChatResponsePart.from(g,n.m,n.n);l(E)}return this}}}return this.g}}class s extends O.$Vc{static{this.b=0}static{this.j=0}constructor(n,d,l,g){super(),this.t=d,this.u=l,this.w=g,this.c=new Map,this.m=new Map,this.n=this.B(new O.$5c),this.s=this.B(new O.$5c),this.g=n.getProxy(P.$ON.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const g=s.b++,E=new t(n,d,this.g,g,l);return this.c.set(g,E),this.g.$registerAgent(g,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,g){const E=s.b++,D=new t(n,d,this.g,E,g);return this.c.set(E,D),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),D.apiAgent}registerChatParticipantDetectionProvider(n){const d=s.j++;return this.m.set(d,n),this.g.$registerChatParticipantDetectionProvider(d),(0,O.$Tc)(()=>{this.m.delete(d),this.g.$unregisterChatParticipantDetectionProvider(d)})}async $detectChatParticipant(n,d,l,g,E){const{request:D,location:S,history:I}=await this.y(d,l),A=this.m.get(n);if(A)return A.provideParticipantDetection(w.ChatAgentRequest.to(D,S),{history:I},{participants:g.participants,location:w.ChatLocation.to(g.location)},E)}async y(n,d){const l=(0,b.$di)(n),g=await this.z(l.agentId,d);let E;if(l.locationData?.type===m.ChatAgentLocation.Editor){const D=this.w.getDocument(l.locationData.document);E=new a.$6P(D,w.Selection.to(l.locationData.selection),w.Range.to(l.locationData.wholeRange))}else if(l.locationData?.type===m.ChatAgentLocation.Notebook){const D=this.w.getDocument(l.locationData.sessionInputUri);E=new a.$7P(D)}else l.locationData?.type,m.ChatAgentLocation.Terminal;return{request:l,location:E,history:g}}async $invokeAgent(n,d,l,g){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let D;try{const{request:S,location:I,history:A}=await this.y(d,l);let $=this.n.get(S.sessionId);$||($=new O.$Uc,this.n.set(S.sessionId,$)),D=new i(E.extension,S,this.g,this.u.converter,$);const v=E.invoke(w.ChatAgentRequest.to(S,I),{history:A},D.apiObject,g);return await(0,h.$uh)(Promise.resolve(v).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(L){const F=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.t.error(`[${E.extension.identifier.value}] [@${E.id}] ${F}`,E.extension),{errorDetails:{message:F},timings:D?.timings,nextQuestion:M.nextQuestion}}let N;return M?.errorDetails&&(N={...M.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.$jH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:D?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),g)}catch(S){return this.t.error(S,E.extension),S instanceof a.$cQ&&S.cause&&(S=S.cause),{errorDetails:{message:(0,C.$rj)(S),responseIsIncomplete:!0}}}finally{D?.close()}}async z(n,d){const l=[];for(const g of d.history){const E=w.ChatAgentResult.to(g.result),D=n===g.request.agentId?E:{...E,metadata:void 0},S=g.request.variables.variables.filter(A=>!A.isTool).map(w.ChatAgentValueReference.to);l.push(new a.$4P(g.request.message,g.request.command,S,g.request.agentId));const I=(0,r.$Hb)(g.response.map(A=>w.ChatResponsePart.toContent(A,this.u.converter)));l.push(new a.$5P(I,D,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.n.deleteAndDispose(n)}async $provideFollowups(n,d,l,g,E){const D=this.c.get(d);if(!D)return Promise.resolve([]);const S=(0,b.$di)(n),I=await this.z(D.id,g),A=w.ChatAgentResult.to(l);return(await D.provideFollowups(A,{history:I},E)).filter($=>{const v=!$.participant||T.Iterable.some(this.c.values(),M=>M.id===$.participant&&u.$sn.equals(M.extension.identifier,D.extension.identifier));return v||this.t.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),v}).map($=>w.ChatFollowup.from($,S))}$acceptFeedback(n,d,l,g){const E=this.c.get(n);if(!E)return;const D=w.ChatAgentResult.to(d);let S;switch(l){case p.ChatAgentVoteDirection.Down:S=a.ChatResultFeedbackKind.Unhelpful;break;case p.ChatAgentVoteDirection.Up:S=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(g?{result:D,kind:S,reportIssue:g}:{result:D,kind:S}))}$acceptAction(n,d,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.u.converter);E&&g.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const g=this.c.get(n);if(!g)return[];let E=this.s.get(n);return E?E.clear():(E=new O.$Uc,this.s.set(n,E)),(await g.invokeCompletionProvider(d,l)).map(S=>w.ChatAgentCompletionItem.from(S,this.u.converter,E))}async $provideWelcomeMessage(n,d,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$Wpc=s;class t{constructor(n,d,l,g,E){this.extension=n,this.id=d,this.w=l,this.x=g,this.y=E,this.m=new R.$me,this.n=new R.$me}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,d,l);return g?g.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(g=>typeof g=="string"?g:w.MarkdownString.from(g)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$PO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(E){g.c=E,l()},get requestHandler(){return g.y},set requestHandler(E){(0,k.$pg)(typeof E=="function","Invalid request handler"),g.y=E},get followupProvider(){return g.b},set followupProvider(E){g.b=E,l()},get isDefault(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.d},set isDefault(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.d=E,l()},get helpTextPrefix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.g=E,l()},get helpTextVariablesPrefix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.j=E,l()},get helpTextPostfix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.k=E,l()},get isSecondary(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.l=E,l()},get supportIssueReporting(){return(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(E){(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.o=E,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(E){if((0,f.$jH)(g.extension,"chatParticipantAdditions"),g.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,E.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,f.$jH)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.s=E,l()},get welcomeMessageProvider(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$iH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){g.t=E,l()},get requester(){return g.t},set supportsSlowReferences(E){(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.u=E,l()},get supportsSlowReferences(){return(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,d,l,g){return this.y(n,d,l,g)}}}),define(ke[296],Ie([1,0,13,3,51,6,15,9,25]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,T=We(T),O=We(O);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$ON.MainThreadChatVariables)}async $resolveVariable(u,P,w,a){const m=this.b.get(u);if(m)try{if(m.resolver.resolve2){(0,b.$jH)(m.extension,"chatParticipantAdditions");const p=new k(P,this.c),f=await m.resolver.resolve2(m.data.name,{prompt:w},p.apiObject,a);if(f&&f[0])return f[0].value}else{const p=await m.resolver.resolve(m.data.name,{prompt:w},a);if(p&&p[0])return p[0].value}}catch(p){(0,r.$1)(p)}}registerVariableResolver(u,P,w,a,m,p,f,i,s){const t=c.a++,o=s?C.ThemeIcon.fromId(s):void 0;return this.b.set(t,{extension:u,data:{id:P,name:w,description:a,modelDescription:m,icon:o},resolver:f}),this.c.$registerVariable(t,{id:P,name:w,description:a,modelDescription:m,isSlow:p,fullName:i,icon:o}),(0,h.$Tc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Xpc=c;class k{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const m=new O.$WP(a),p=T.ChatResponseProgressPart.from(m);return w(p),this},reference(a){P(this.reference);const m=new O.$1P(a),p=T.ChatResponseReferencePart.from(m);return w(p),this},push(a){return P(this.push),a instanceof O.$1P?w(T.ChatResponseReferencePart.from(a)):a instanceof O.$WP&&w(T.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ke[297],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=w,b=We(b),k=We(k),y=We(y);function w(a,m,p){const f=a.getProxy(u.$ON.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$un,m.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===T.MarshalledId.CommentController){const I=this.b.get(S.handle);return I?I.value:S}else if(S&&S.$mid===T.MarshalledId.CommentThread){const I=S,A=this.b.get(I.commentControlHandle);if(!A)return I;const $=A.getCommentThread(I.commentThreadHandle);return $?$.value:I}else if(S&&(S.$mid===T.MarshalledId.CommentThreadReply||S.$mid===T.MarshalledId.CommentThreadInstance)){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const A=I.getCommentThread(S.thread.commentThreadHandle);return A?S.$mid===T.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:S.text}:S}else if(S&&S.$mid===T.MarshalledId.CommentNode){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const A=I.getCommentThread(S.thread.commentThreadHandle);if(!A)return S;const $=S.commentUniqueId,v=A.getCommentByUniqueId($);return v||S}else if(S&&S.$mid===T.MarshalledId.CommentThreadNode){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const A=I.getCommentThread(S.thread.commentThreadHandle);if(!A)return S;const $=S.text,v=S.commentUniqueId,M=A.getCommentByUniqueId(v);return M?(typeof M.body=="string"?M.body=$:M.body=new y.$iO($),M):S}return S}})}createCommentController(S,I,A){const $=i.a++,v=new t(S,$,I,A);this.b.set(v.handle,v);const M=this.c.get(S.identifier)||[];return M.push(v),this.c.set(S.identifier,M),v.value}async $createCommentThreadTemplate(S,I,A,$){const v=this.b.get(S);v&&v.$createCommentThreadTemplate(I,A,$)}async $setActiveComment(S,I){const A=this.b.get(S);A&&A.$setActiveComment(I??void 0)}async $updateCommentThreadTemplate(S,I,A){const $=this.b.get(S);$&&$.$updateCommentThreadTemplate(I,A)}$deleteCommentThread(S,I){this.b.get(S)?.$deleteCommentThread(I)}async $provideCommentingRanges(S,I,A){const $=this.b.get(S);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const v=await p.ensureDocumentData(O.URI.revive(I));return(0,r.$yh)(async()=>{const M=await $.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>k.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(S,I,A,$,v){const M=this.b.get(S);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,r.$yh)(()=>{const N=M.getCommentThread(I);if(N){const L=N.getCommentByUniqueId($.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,d(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(S){this.n=S}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(S){(S===void 0!=(this.p===void 0)||!S||!this.p||!S.isEqual(this.p))&&(this.p=S,this.b.range=S,this.c.fire())}get range(){return this.p}set canReply(S){this.d!==S&&(this.d=S,this.b.canReply=S,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(S){this.e=S,this.b.label=S,this.c.fire()}get contextValue(){return this.f}set contextValue(S){this.f=S,this.b.contextValue=S,this.c.fire()}get comments(){return this.q}set comments(S){this.q=S,this.b.comments=S,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(S){this.g=S,this.b.collapsibleState=S,this.c.fire()}get state(){return this.h}set state(S){this.h=S,typeof S=="object"?((0,P.$jH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=S.resolved,this.b.applicability=S.applicability):this.b.state=S,this.c.fire()}get isDisposed(){return this.j}constructor(S,I,A,$,v,M,N,L,F){this.m=I,this.n=A,this.o=$,this.p=v,this.q=M,this.extensionDescription=N,this.r=L,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${S}.${this.handle}`),f.$createCommentThread(I,this.handle,this.n,this.o,k.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),N.identifier,this.r,F),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{f.$deleteCommentThread(I,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(j){B.range=j},get comments(){return B.comments},set comments(j){B.comments=j},get collapsibleState(){return B.collapsibleState},set collapsibleState(j){B.collapsibleState=j},get canReply(){return B.canReply},set canReply(j){B.canReply=j},get contextValue(){return B.contextValue},set contextValue(j){B.contextValue=j},get label(){return B.label},set label(j){B.label=j},get state(){return B.state},set state(j){B.state=j},reveal:(j,U)=>B.reveal(j,U),hide:()=>B.hide(),dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const S=A=>Object.prototype.hasOwnProperty.call(this.b,A),I={};S("range")&&(I.range=k.Range.from(this.p)),S("label")&&(I.label=this.label),S("contextValue")&&(I.contextValue=this.contextValue??null),S("comments")&&(I.comments=this.q.map(A=>o(this,A,this.k,this.extensionDescription))),S("collapsibleState")&&(I.collapseState=l(this.g)),S("canReply")&&(I.canReply=this.canReply),S("state")&&(I.state=g(this.h)),S("applicability")&&(I.applicability=E(this.h)),S("isTemplate")&&(I.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(S){for(const I of this.k){const A=I[0],$=I[1];if(S===$)return A}}async reveal(S,I){(0,P.$jH)(this.extensionDescription,"commentReveal");let A;S&&S.body!==void 0?A=S:I=I??S;let $=A?this.k.get(A):void 0;$??=this.k.get(this.q[0]);let v=!0,M=!1;return I?.focus===y.CommentThreadFocus.Reply?(M=!0,v=!1):I?.focus===y.CommentThreadFocus.Comment&&(v=!1),f.$revealCommentThread(this.m,this.handle,$,{preserveFocus:v,focusReply:M})}async hide(){return f.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(S=>S.dispose())}}Ze([(0,h.$_h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(S){this.b=S,S?.resourceHints&&(0,P.$jH)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,S?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(S){this.c=S,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!S})}get options(){return this.d}set options(S){this.d=S,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$jH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$jH)(this.h,"activeComment"),this.f?.value}constructor(S,I,A,$){this.h=S,this.i=I,this.j=A,this.k=$,this.a=new Map,f.$registerCommentController(this.handle,A,$,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(M){v.options=M},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(M){v.commentingRangeProvider=M},get reactionHandler(){return v.reactionHandler},set reactionHandler(M){v.reactionHandler=M},get activeCommentThread(){return v.activeCommentThread},createCommentThread(M,N,L){return v.createCommentThread(M,N,L).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(S,I,A){I===void 0&&(0,P.$jH)(this.h,"fileComments");const $=new s(this.id,this.handle,void 0,S,I,A,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(S){if(!S){this.e=void 0,this.f=void 0;return}const I=this.a.get(S.commentThreadHandle);I&&(this.e=S.uniqueIdInThread?I.getCommentByUniqueId(S.uniqueIdInThread):void 0,this.f=I)}$createCommentThreadTemplate(S,I,A){const $=new s(this.id,this.handle,void 0,O.URI.revive(S),k.Range.to(I),[],this.h,!0,A);return $.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(S,I){const A=this.a.get(S);A&&(A.range=k.Range.to(I))}$deleteCommentThread(S){this.a.get(S)?.dispose(),this.a.delete(S)}getCommentThread(S){return this.a.get(S)}dispose(){this.a.forEach(S=>{S.dispose()}),this.g.forEach(S=>S.dispose())}}function o(D,S,I,A){let $=I.get(S);return $||($=++D.commentHandle,I.set(S,$)),S.state!==void 0&&(0,P.$jH)(A,"commentsDraftState"),S.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$jH)(A,"commentReactor"),{mode:S.mode,contextValue:S.contextValue,uniqueIdInThread:$,body:typeof S.body=="string"?S.body:k.MarkdownString.from(S.body),userName:S.author.name,userIconPath:S.author.iconPath,label:S.label,commentReactions:S.reactions?S.reactions.map(v=>n(v)):void 0,state:S.state,timestamp:S.timestamp?.toJSON()}}function n(D){return{label:D.label,iconPath:D.iconPath?k.$nQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(S=>S.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?O.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(S=>({name:S}))}}function l(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function g(D){let S;if(typeof D=="object"?S=D.resolved:S=D,S!==void 0)switch(S){case y.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function E(D){let S;if(typeof D=="object"&&(S=D.applicability),S!==void 0)switch(S){case y.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(ke[298],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0,b=We(b),y=We(y),u=We(u);class P{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new k.$Hpc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,T.$hh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const g=this.b(n,d.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new P(d,l);return this.a.set(g,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$QN(()=>this.a.delete(n))}}class p{constructor(n,d,l,g,E){this.d=d,this.f=l,this.g=g,this.h=E,this.b=new m,this.c=new w,this.a=n.getProxy(y.$ON.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,g){const E=new C.$Uc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$eqc)(n),d,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$cqc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),f(l)&&E.add(l.onDidChangeCustomDocument(D=>{const S=this.i(d,D.document.uri);if(s(D)){const I=S.addEdit(D);this.a.$onDidEdit(D.document.uri,d,I,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$eqc)(n),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$cqc)(n))),u.$QN.from(E,new u.$QN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,g,E){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const S=O.URI.revive(n),I=await D.provider.openCustomDocument(S,{backupId:l,untitledDocumentData:g?.buffer},E);let A;return f(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,I,A),{editable:f(D.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=O.URI.revive(n),{document:E}=this.i(d,g);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,g,E,D){const S=this.b.get(l);if(!S)throw new Error(`No provider found for '${l}'`);const I=b.ViewColumn.to(E),A=this.g.createNewWebview(d,g.contentOptions,S.extension),$=this.h.createNewWebviewPanel(d,l,g.title,I,g.options,A,g.active),v=O.URI.revive(n);switch(S.type){case a.Custom:{const{document:M}=this.i(l,v);return S.provider.resolveCustomEditor(M,$,D)}case a.Text:{const M=this.d.getDocument(v);return S.provider.resolveCustomTextEditor(M,$,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const D=O.URI.revive(d),S=this.d.getDocument(D);await g.provider.moveCustomTextEditor(S,E,r.CancellationToken.None)}async $undo(n,d,l,g){return this.i(d,n).undo(l,g)}async $redo(n,d,l,g){return this.i(d,n).redo(l,g)}async $revert(n,d,l){const g=this.i(d,n);await this.j(d).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,d,l){const g=this.i(d,n);await this.j(d).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,d,l,g){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,O.URI.revive(l),g)}async $backup(n,d,l){const g=this.i(d,n),D=await this.j(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(D),D.id}i(n,d){const l=this.c.get(n,O.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$hqc=p;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===R.Schemas.file||o.scheme===R.Schemas.untitled?o.fsPath:o.toString();return(0,h.$uj)(n)+""}}),define(ke[299],Ie([1,0,8,147,2,6,9,15,4,11,28,62]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0,O=We(O);class P{#e;#t;#i;constructor(m,p,f,i,s,t,o,n){this.d=m,this.e=p,this.f=f,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,f),this.#i=new k.$Bc(d=>t.getComparisonKey(d)),this.#e=o,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,p){if(!m){this.clear();return}this.j();let f=[];if(C.URI.isUri(m)){if(!p){this.delete(m);return}this.#i.set(m,p.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(P.k);for(const o of m){const[n,d]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this.g){o=[];const d=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===d[l]&&o.push({...O.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(2687,null,n.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(d=>({...O.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,o]),s+=o.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,p){this.j();for(const[f,i]of this)m.call(p,f,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const p=this.#i.get(m);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,p){return m[0].toString()<p[0].toString()?-1:m[0].toString()>p[0].toString()?1:0}}e.$Opc=P;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const p=new k.$Bc;for(const f of m)p.set(f,f);return{uris:Object.freeze(Array.from(p.values()))}}constructor(m,p,f,i){this.j=p,this.k=f,this.l=i,this.g=new Map,this.h=new b.$qe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,u._mapper),this.f=m.getProxy(R.$ON.MainThreadDiagnostics)}createDiagnosticCollection(m,p){const{g:f,f:i,h:s,j:t,k:o,l:n}=this,d=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,E)}dispose(){i.dispose()}};let l;if(!p)p="_generated_diagnostic_collection_name_#"+u.c++,l=p;else if(!f.has(p))l=p;else{this.j.warn(`DiagnosticCollection with name '${p}' does already exist.`);do l=p+u.c++;while(f.has(l))}return new class extends P{constructor(){super(p,l,u.e,u.d,E=>n.getDocument(E)?.version,o.extUri,d,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const p=new Map,f=[];for(const i of this.g.values())i.forEach((s,t)=>{let o=p.get(s.toString());typeof o>"u"&&(o=f.length,p.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}m(m){let p=[];for(const f of this.g.values())f.has(m)&&(p=p.concat(f.get(m)));return p}$acceptMarkersChange(m){if(!this.n){const p="_generated_mirror",f=new P(p,p,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(p,f),this.n=f}for(const[p,f]of m)this.n.set(C.URI.revive(p),f.map(O.Diagnostic.to))}};e.$Ppc=w,e.$Ppc=w=u=Ze([Ve(1,c.$bk),Ve(2,y.$Npc)],w)}),define(ke[300],Ie([1,0,2,13,9,15,80,53]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class b{constructor(k,y,u,P={timeout:1500,errors:3}){this.c=k,this.d=y,this.f=u,this.g=P,this.a=new T.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(y,u,P)=>{const a={dispose:this.a.push([y,u,k])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(k,y){const u=r.URI.revive(k);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(P)break;const p=this.d.getDocument(u),f=await this.h(m,{document:p,reason:R.TextDocumentSaveReason.to(y)});a.push(f)}}finally{clearTimeout(w)}return a}h([k,y,u],P){const w=this.b.get(k);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,k,y,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(k);this.b.set(k,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,y,u,P){const w=[],a=Date.now(),{document:m,reason:p}=P,{version:f}=m,i=Object.freeze({document:m,reason:p,waitUntil(s){if(Object.isFrozen(w))throw(0,h.$8)("waitUntil can not be called async");w.push(Promise.resolve(s))}});try{y.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(w),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof C.$ZN))for(const{newText:n,newEol:d,range:l}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:n,eol:d&&R.EndOfLine.from(d)}});if(t.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(new O.$2w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$3qc=b}),define(ke[301],Ie([1,0,4,3,2,6,167,15,17,24,9]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,O=We(O);class y{constructor(P,w){this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Uc,this.h=new Map,this.f=P.getProxy(R.$ON.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const p=C.URI.revive(m);return(0,b.$qg)(this.g.getDocument(p))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(P){const w=C.URI.revive(P),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,a){const m=C.URI.revive(P),p=this.g.getDocument(m);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),p.onEvents(w);let f;w.isUndoing?f=k.TextDocumentChangeReason.Undo:w.isRedoing&&(f=k.TextDocumentChangeReason.Redo),this.c.fire((0,c.$go)({document:p.document,contentChanges:w.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(P,w){(0,T.$qQ)(P,w)}}e.$Qpc=y}),define(ke[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=e.$iqc=void 0,c=We(c),e.$iqc=(0,T.$Gi)("IExtHostEditorTabs");class y{constructor(m,p,f){this.e=f,this.d=p,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,p={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(p)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new k.$EP(R.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new k.$FP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new k.$GP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new k.$HP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new k.$IP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new k.$JP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new k.$KP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new k.$LP;case O.TabInputKind.InteractiveEditorInput:return new k.$MP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new k.$NP;case O.TabInputKind.MultiDiffEditorInput:return new k.$OP(this.b.input.diffEditors.map(m=>new k.$FP(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class u{constructor(m,p){this.c=[],this.d="",this.b=m,this.e=p;for(const f of m.tabs)f.isActive&&(this.d=f.id),this.c.push(new y(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,p={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(f=>f.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(f=>f.apiObject))}};this.a=Object.freeze(p)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===O.TabModelOperationKind.TAB_OPEN){const f=new y(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,f),m.tabDto.isActive&&(this.d=f.tabId),f}else if(m.kind===O.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(m.kind===O.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,f),f}const p=this.c.find(f=>f.tabId===m.tabDto.id);if(!p)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),p.acceptDtoUpdate(m.tabDto),p}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$me,this.c=new h.$me,this.e=[],this.a=m.getProxy(O.$ON.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,p={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(f=>f.apiObject))},get activeTabGroup(){const f=m.d;return(0,C.$qg)(m.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?w(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(p)}return this.f}$acceptEditorTabModel(m){const p=new Set(this.e.map(d=>d.groupId)),f=new Set(m.map(d=>d.groupId)),i=(0,r.$d)(p,f),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],o=[];this.e=m.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):o.push(l.apiObject),l});const n=(0,C.$qg)(m.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const p=this.e.find(f=>f.groupId===m.groupId);if(!p)throw new Error("Update Group IPC call received before group creation.");p.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[p.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const p=this.e.find(i=>i.groupId===m.groupId);if(!p)throw new Error("Update Tabs IPC call received before group creation.");const f=p.acceptTabOperation(m);switch(m.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(m){for(const p of this.e)for(const f of p.tabs)if(f.apiObject===m)return f}h(m){return this.e.find(p=>p.apiObject===m)}async i(m,p){const f=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,p)}async j(m,p){const f=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,p)}};e.$jqc=P,e.$jqc=P=Ze([Ve(0,b.$oQ)],P);function w(a){return a.tabs!==void 0}}),define(ke[302],Ie([1,0,2,6,27,3,9,15,204,12,26,21,25,85]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,C=We(C),O=We(O);class w{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const f=this.a.indexOf(p);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),f=[];let i,s,t=b.State.LastKnownState,o=b.State.LastKnownState;for(const n of p){let d=i?(0,c.$If)(i,n):0;for(d===0?s=b.State.Start:s=o;d<n.length;d++)d+1===n.length?(t=o,o=b.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(d),o]),f.push([s,n.toLowerCase().charCodeAt(d),o]),s=o;i=n,o=t}f.push([b.State.BeforeColon,k.CharCode.Colon,b.State.AfterColon]),f.push([b.State.AfterColon,k.CharCode.Slash,b.State.End]),this.b=new b.$J4(f)}}provideDocumentLinks(p){this.c();const f=[],i=b.$K4.computeLinks({getLineContent(s){return p.lineAt(s-1).text},getLineCount(){return p.lineCount}},this.b);for(const s of i){const t=O.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor(p,f){this.i=f,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(h.$ON.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,f,i,s={}){if(a.j(i),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const t=this.h++;this.b.add(f),this.d.add(f),this.c.set(t,i);let o=C.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=C.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$jH)(p,"fsChunks"),o+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,P.$7k)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(t,f,o,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=i.onDidChangeFile(l=>{const g=[];for(const E of l){const{uri:D,type:S}=E;if(D.scheme!==f)continue;let I;switch(S){case T.FileChangeType.Changed:I=C.FileChangeType.UPDATED;break;case T.FileChangeType.Created:I=C.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:I=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:D,type:I})}this.a.$onFileSystemChange(t,g)});return(0,R.$Tc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=p;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat(p,f){return Promise.resolve(this.l(p).stat(r.URI.revive(f))).then(i=>a.k(i))}$readdir(p,f){return Promise.resolve(this.l(p).readDirectory(r.URI.revive(f)))}$readFile(p,f){return Promise.resolve(this.l(p).readFile(r.URI.revive(f))).then(i=>y.$Oe.wrap(i))}$writeFile(p,f,i,s){return Promise.resolve(this.l(p).writeFile(r.URI.revive(f),i.buffer,s))}$delete(p,f,i){return Promise.resolve(this.l(p).delete(r.URI.revive(f),i))}$rename(p,f,i,s){return Promise.resolve(this.l(p).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy(p,f,i,s){const t=this.l(p);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir(p,f){return Promise.resolve(this.l(p).createDirectory(r.URI.revive(f)))}$watch(p,f,i,s){const t=this.l(p).watch(r.URI.revive(i),s);this.f.set(f,t)}$unwatch(p,f){const i=this.f.get(f);i&&(i.dispose(),this.f.delete(f))}$open(p,f,i){const s=this.l(p);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close(p,f){const i=this.l(p);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read(p,f,i,s){const t=this.l(p);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$Oe.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write(p,f,i,s){const t=this.l(p);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}l(p){const f=this.c.get(p);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.$6qc=a}),define(ke[303],Ie([1,0,4,38,2,6,15,9,27,50]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,T=We(T);class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,m,p,f,i){this.a=Math.random(),this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,h.$Bk)(f),t=typeof f=="string",o=i?.correlate,n=p(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=O.$QN.from(this.i(w,m,f,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,m,p,f){const i=O.$QN.from();if(typeof m=="string"||p?.ignoreChangeEvents&&p?.ignoreCreateEvents&&p?.ignoreDeleteEvents)return i;const s=w.getProxy(R.$ON.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$xk)||m.pattern.includes(h.$yk))&&(t=!0);let o;return f&&(p?.ignoreChangeEvents||p?.ignoreCreateEvents||p?.ignoreDeleteEvents)&&(o=b.FileChangeFilter.UPDATED|b.FileChangeFilter.ADDED|b.FileChangeFilter.DELETED,p?.ignoreChangeEvents&&(o&=~b.FileChangeFilter.UPDATED),p?.ignoreCreateEvents&&(o&=~b.FileChangeFilter.ADDED),p?.ignoreDeleteEvents&&(o&=~b.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,m.baseUri,{recursive:t,excludes:p?.excludes??[],filter:o},!!f),O.$QN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$U(()=>this.a.created.map(C.URI.revive)),this.c=new c.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new c.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,m){this.j=w,this.k=a,this.l=m,this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.g=new r.$oe,this.h=new r.$oe,this.i=new r.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,m,p){return new k(this.j,w,a,this.a.event,T.GlobPattern.from(m),p)}$onFileEvent(w){this.a.fire(new y(w))}$onDidRunFileOperation(w,a){switch(w){case b.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))}));break;case b.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;case b.FileOperation.CREATE:case b.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(m,p,f)=>{const i=function(t){m.call(p,t)};return i.extension=w,a.event(i,void 0,f)}}async $onWillRunFileOperation(w,a,m,p){switch(w){case b.FileOperation.MOVE:return await this.n(this.g,{files:a.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},m,p);case b.FileOperation.DELETE:return await this.n(this.i,{files:a.map(f=>C.URI.revive(f.target))},m,p);case b.FileOperation.CREATE:case b.FileOperation.COPY:return await this.n(this.h,{files:a.map(f=>C.URI.revive(f.target))},m,p)}}async n(w,a,m,p){const f=new Set,i=[];if(await w.fireAsync(a,p,async(t,o)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof O.$3N&&(i.push([o.extension,d]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",o.extension.identifier)}),p.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.$7qc=u}),define(ke[304],Ie([1,0,18,7,20,13,133,3,24,42,12,17,2,30,197,87,144,8,23,15,9,25,118,6]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0,a=We(a),i=We(i),n=We(n);class d{constructor(H,G){this.d=H,this.e=G}async provideDocumentSymbols(H,G){const Z=this.d.getDocument(H),x=await this.e.provideDocumentSymbols(Z,G);if(!(0,r.$Kb)(x))return x[0]instanceof s.$aO?x.map(i.DocumentSymbol.from):d.f(x)}static f(H){H=H.slice(0).sort((x,de)=>{let Ee=x.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(x.location.range.end)),Ee});const G=[],Z=[];for(const x of H){const de={name:x.name||"!!MISSING: name!!",kind:i.SymbolKind.from(x.kind),tags:x.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:i.Range.from(x.location.range),selectionRange:i.Range.from(x.location.range),children:[]};for(;;){if(Z.length===0){Z.push(de),G.push(de);break}const Ee=Z[Z.length-1];if(P.$Rt.containsRange(Ee.range,de.range)&&!P.$Rt.equalsRange(Ee.range,de.range)){Ee.children?.push(de),Z.push(de);break}Z.pop()}}return G}}class l{constructor(H,G,Z,x,de,Ee){this.f=H,this.g=G,this.h=Z,this.j=x,this.k=de,this.l=Ee,this.d=new o.$Hpc("CodeLens"),this.e=new Map}async provideCodeLenses(H,G){const Z=this.f.getDocument(H),x=await this.h.provideCodeLenses(Z,G);if(!x||G.isCancellationRequested)return;const de=this.d.add(x),Ee=new O.$Uc;this.e.set(de,Ee);const Te={cacheId:de,lenses:[]};for(let He=0;He<x.length;He++)Te.lenses.push({cacheId:[de,He],range:i.Range.from(x[He].range),command:this.g.toInternal(x[He].command,Ee)});return Te}async resolveCodeLens(H,G){const Z=H.cacheId&&this.d.get(...H.cacheId);if(!Z)return;let x;if(typeof this.h.resolveCodeLens!="function"||Z.isResolved?x=Z:x=await this.h.resolveCodeLens(Z,G),x||(x=Z),G.isCancellationRequested)return;const de=H.cacheId&&this.e.get(H.cacheId[0]);if(de){if(!x.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Ee),this.l.error(Ee);return}return H.command=this.g.toInternal(x.command,de),H}}releaseCodeLenses(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}}function g(Ce){return Array.isArray(Ce)?Ce.map(i.DefinitionLink.from):Ce?[i.DefinitionLink.from(Ce)]:[]}class E{constructor(H,G){this.d=H,this.e=G}async provideDefinition(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideDefinition(x,de,Z);return g(Ee)}}class D{constructor(H,G){this.d=H,this.e=G}async provideDeclaration(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideDeclaration(x,de,Z);return g(Ee)}}class S{constructor(H,G){this.d=H,this.e=G}async provideImplementation(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideImplementation(x,de,Z);return g(Ee)}}class I{constructor(H,G){this.d=H,this.e=G}async provideTypeDefinition(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideTypeDefinition(x,de,Z);return g(Ee)}}class A{static{this.f=10}constructor(H,G){this.g=H,this.h=G,this.d=0,this.e=new Map}async provideHover(H,G,Z,x){const de=this.g.getDocument(H),Ee=i.Position.to(G);let Te;if(Z&&Z.verbosityRequest){const nt=Z.verbosityRequest.previousHover.id,st=this.e.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:Z.verbosityRequest.verbosityDelta,previousHover:st};Te=await this.h.provideHover(de,Ee,x,rt)}else Te=await this.h.provideHover(de,Ee,x);if(!Te||(0,r.$Kb)(Te.contents))return;Te.range||(Te.range=de.getWordRangeAtPosition(Ee)),Te.range||(Te.range=new s.$SN(Ee,Ee));const He=i.Hover.from(Te),Ke=this.d;if(this.e.size===A.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ke,Te),this.d+=1,{...He,id:Ke}}releaseHover(H){this.e.delete(H)}}class ${constructor(H,G){this.d=H,this.e=G}async provideEvaluatableExpression(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideEvaluatableExpression(x,de,Z);if(Ee)return i.EvaluatableExpression.from(Ee)}}class v{constructor(H,G){this.d=H,this.e=G}async provideInlineValues(H,G,Z,x){const de=this.d.getDocument(H),Ee=await this.e.provideInlineValues(de,i.Range.to(G),i.InlineValueContext.to(Z),x);if(Array.isArray(Ee))return Ee.map(Te=>i.InlineValue.from(Te))}}class M{constructor(H,G){this.d=H,this.e=G}async provideDocumentHighlights(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideDocumentHighlights(x,de,Z);if(Array.isArray(Ee))return Ee.map(i.DocumentHighlight.from)}}class N{constructor(H,G){this.d=H,this.e=G}async provideMultiDocumentHighlights(H,G,Z,x){const de=this.d.getDocument(H),Ee=Z.map(Ke=>this.d.getDocument(Ke)),Te=i.Position.to(G),He=await this.e.provideMultiDocumentHighlights(de,Te,Ee,x);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class L{constructor(H,G){this.d=H,this.e=G}async provideLinkedEditingRanges(H,G,Z){const x=this.d.getDocument(H),de=i.Position.to(G),Ee=await this.e.provideLinkedEditingRanges(x,de,Z);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,r.$Hb)(Ee.ranges.map(i.Range.from)),wordPattern:Ee.wordPattern}}}class F{constructor(H,G){this.d=H,this.e=G}async provideReferences(H,G,Z,x){const de=this.d.getDocument(H),Ee=i.Position.to(G),Te=await this.e.provideReferences(de,Ee,Z,x);if(Array.isArray(Te))return Te.map(i.location.from)}}class B{static{this.d=1e3}constructor(H,G,Z,x,de,Ee,Te){this.g=H,this.h=G,this.j=Z,this.k=x,this.l=de,this.m=Ee,this.n=Te,this.e=new o.$Hpc("CodeAction"),this.f=new Map}async provideCodeActions(H,G,Z,x){const de=this.g.getDocument(H),Ee=w.$Tt.isISelection(G)?i.Selection.to(G):i.Range.to(G),Te=[];for(const rt of this.j.getDiagnostics(H))if(Ee.intersection(rt.range)&&Te.push(rt)>B.d)break;const He={diagnostics:Te,only:Z.only?new s.$cO(Z.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Z.trigger)},Ke=await this.k.provideCodeActions(de,Ee,He,x);if(!(0,r.$Lb)(Ke)||x.isCancellationRequested)return;const et=this.e.add(Ke),nt=new O.$Uc;this.f.set(et,nt);const st=[];for(let rt=0;rt<Ke.length;rt++){const at=Ke[rt];if(at)if(B.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{He.only&&(at.kind?He.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];st.push({cacheId:[et,rt],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$iH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$iH)(this.m,"codeActionRanges")?(0,r.$Hb)(gt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:et,actions:st}}async resolveCodeAction(H,G){const[Z,x]=H,de=this.e.get(Z,x);if(!de||B.o(de))return{};if(!this.k.resolveCodeAction)return{};const Ee=await this.k.resolveCodeAction(de,G)??de;let Te;Ee.edit&&(Te=i.WorkspaceEdit.from(Ee.edit,void 0));let He;if(Ee.command){const Ke=this.f.get(Z);Ke&&(He=this.h.toInternal(Ee.command,Ke))}return{edit:Te,command:He}}releaseCodeActions(H){this.f.get(H)?.dispose(),this.f.delete(H),this.e.delete(H)}static o(H){return typeof H.command=="string"&&typeof H.title=="string"}}class j{constructor(H,G,Z,x,de){this.e=H,this.f=G,this.g=Z,this.h=x,this.j=de,this.d=new o.$Hpc("DocumentPasteEdit")}async prepareDocumentPaste(H,G,Z,x){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(H),Ee=G.map(Ke=>i.Range.to(Ke)),Te=i.DataTransfer.toDataTransfer(Z,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(de,Ee,Te,x),x.isCancellationRequested)return;const He=Array.from(Te).filter(([,Ke])=>!(Ke instanceof s.$IO));return i.DataTransfer.from(He)}async providePasteEdits(H,G,Z,x,de,Ee){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(G),He=Z.map(st=>i.Range.to(st)),Ke=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolvePasteFileData(this.h,H,st)).buffer),et=await this.g.provideDocumentPasteEdits(Te,He,Ke,{only:de.only?new s.$NO(de.only):void 0,triggerKind:de.triggerKind},Ee);if(!et||Ee.isCancellationRequested)return[];const nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,p.localize)(2690,null,this.j.displayName||this.j.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(H,G){const[Z,x]=H,de=this.d.get(Z,x);if(!de||!this.g.resolveDocumentPasteEdit)return{};const Ee=await this.g.resolveDocumentPasteEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(H){this.d.delete(H)}}class U{constructor(H,G){this.d=H,this.e=G}async provideDocumentFormattingEdits(H,G,Z){const x=this.d.getDocument(H),de=await this.e.provideDocumentFormattingEdits(x,G,Z);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class z{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeFormattingEdits(H,G,Z,x){const de=this.d.getDocument(H),Ee=i.Range.to(G),Te=await this.e.provideDocumentRangeFormattingEdits(de,Ee,Z,x);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(H,G,Z,x){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(H),Ee=G.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(de,Ee,Z,x);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class ee{constructor(H,G){this.d=H,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,Z,x,de){const Ee=this.d.getDocument(H),Te=i.Position.to(G),He=await this.e.provideOnTypeFormattingEdits(Ee,Te,Z,x,de);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class V{constructor(H,G){this.e=H,this.f=G,this.d=new o.$Hpc("WorkspaceSymbols")}async provideWorkspaceSymbols(H,G){const Z=await this.e.provideWorkspaceSymbols(H,G);if(!(0,r.$Lb)(Z))return{symbols:[]};const x=this.d.add(Z),de={cacheId:x,symbols:[]};for(let Ee=0;Ee<Z.length;Ee++){const Te=Z[Ee];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}de.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[x,Ee]})}return de}async resolveWorkspaceSymbol(H,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const Z=this.d.get(...H.cacheId);if(Z){const x=await this.e.resolveWorkspaceSymbol(Z,G);return x&&(0,b.$io)(H,i.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(H){this.d.delete(H)}}class W{static supportsResolving(H){return typeof H.prepareRename=="function"}constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideRenameEdits(H,G,Z,x){const de=this.d.getDocument(H),Ee=i.Position.to(G);try{const Te=await this.e.provideRenameEdits(de,Ee,Z,x);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=W.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(H,G,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(H),de=i.Position.to(G);try{const Ee=await this.e.prepareRename(x,de,Z);let Te,He;if(s.$SN.isRange(Ee)?(Te=Ee,He=x.getText(Ee)):(0,y.$hg)(Ee)&&(Te=Ee.range,He=Ee.placeholder),!Te||!He)return;if(Te.start.line>de.line||Te.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(Ee){const Te=W.g(Ee);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class J{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(H,G,Z){this.e=H,this.f=G,this.g=Z}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(H,G,Z,x){const de=this.e.getDocument(H),Ee=i.Range.to(G);try{const Te=J.d[Z],He=await this.f.provideNewSymbolNames(de,Ee,Te,x);return He?He.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Te){this.g.error(J.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class _{constructor(H,G){this.resultId=H,this.tokens=G}}class ce{constructor(H,G){this.f=H,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(H,G,Z){const x=this.f.getDocument(H),de=G!==0?this.d.get(G):null;let Ee=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,de.resultId,Z):await this.g.provideDocumentSemanticTokens(x,Z);return de&&this.d.delete(G),Ee?(Ee=ce.h(Ee),this.o(ce.n(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(H){this.d.delete(H)}static h(H){return ce.j(H)?ce.k(H)?H:new s.$bP(new Uint32Array(H.data),H.resultId):ce.l(H)?ce.m(H)?H:new s.$dP(H.edits.map(G=>new s.$cP(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static j(H){return H&&!!H.data}static k(H){return H.data instanceof Uint32Array}static l(H){return H&&Array.isArray(H.edits)}static m(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(H,G){if(!ce.j(G)||!H||!H.tokens)return G;const Z=H.tokens,x=Z.length,de=G.data,Ee=de.length;let Te=0;const He=Math.min(x,Ee);for(;Te<He&&Z[Te]===de[Te];)Te++;if(Te===x&&Te===Ee)return new s.$dP([],G.resultId);let Ke=0;const et=He-Te;for(;Ke<et&&Z[x-Ke-1]===de[Ee-Ke-1];)Ke++;return new s.$dP([{start:Te,deleteCount:x-Te-Ke,data:de.subarray(Te,Ee-Ke)}],G.resultId)}o(H,G){if(ce.j(H)){const Z=this.e++;return this.d.set(Z,new _(H.resultId,H.data)),(0,m.$3db)({id:Z,type:"full",data:H.data})}if(ce.l(H)){const Z=this.e++;return ce.j(G)?this.d.set(Z,new _(G.resultId,G.data)):this.d.set(Z,new _(H.resultId)),(0,m.$3db)({id:Z,type:"delta",deltas:(H.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeSemanticTokens(H,G,Z){const x=this.d.getDocument(H),de=await this.e.provideDocumentRangeSemanticTokens(x,i.Range.to(G),Z);return de?this.f(de):null}f(H){return(0,m.$3db)({id:0,type:"full",data:H.data})}}class ye{static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}constructor(H,G,Z,x,de){this.f=H,this.g=G,this.h=Z,this.j=x,this.k=de,this.d=new o.$Hpc("CompletionItem"),this.e=new Map}async provideCompletionItems(H,G,Z,x){const de=this.f.getDocument(H),Ee=i.Position.to(G),Te=de.getWordRangeAtPosition(Ee)||new s.$SN(Ee,Ee),He=Te.with({end:Ee}),Ke=new c.$ge,et=await this.h.provideCompletionItems(de,Ee,x,i.CompletionContext.to(Z));if(!et||x.isCancellationRequested)return;const nt=Array.isArray(et)?new s.$pO(et):et,st=ye.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new O.$Uc;this.e.set(st,rt);const at=[],gt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Te),insert:i.Range.from(He)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let dt=0;dt<nt.items.length;dt++){const ct=nt.items[dt],Pe=this.l(ct,[st,dt],He,Te);at.push(Pe)}return gt}async resolveCompletionItem(H,G){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...H);if(!Z)return;const x=this.l(Z,H),de=await this.h.resolveCompletionItem(Z,G);if(!de)return;const Ee=this.l(de,H);return(x[n.ISuggestDataDtoField.insertText]!==Ee[n.ISuggestDataDtoField.insertText]||x[n.ISuggestDataDtoField.insertTextRules]!==Ee[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[n.ISuggestDataDtoField.commandIdent]!==Ee[n.ISuggestDataDtoField.commandIdent]||x[n.ISuggestDataDtoField.commandId]!==Ee[n.ISuggestDataDtoField.commandId]||!(0,b.$jo)(x[n.ISuggestDataDtoField.commandArguments],Ee[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[n.ISuggestDataDtoField.documentation]:Ee[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:Ee[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:Ee[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:Ee[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:Ee[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:Ee[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:Ee[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:Ee[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G,Z,x){const de=this.e.get(G[0]);if(!de)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(H.command,de),Te={x:G,[n.ISuggestDataDtoField.label]:H.label,[n.ISuggestDataDtoField.kind]:H.kind!==void 0?i.CompletionItemKind.from(H.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:H.tags&&H.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:H.detail,[n.ISuggestDataDtoField.documentation]:typeof H.documentation>"u"?void 0:i.MarkdownString.fromStrict(H.documentation),[n.ISuggestDataDtoField.sortText]:H.sortText!==H.label?H.sortText:void 0,[n.ISuggestDataDtoField.filterText]:H.filterText!==H.label?H.filterText:void 0,[n.ISuggestDataDtoField.preselect]:H.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:H.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:H.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:H.additionalTextEdits&&H.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:Ee?.$ident,[n.ISuggestDataDtoField.commandId]:Ee?.id,[n.ISuggestDataDtoField.commandArguments]:Ee?.$ident?void 0:Ee?.arguments};H.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te[n.ISuggestDataDtoField.insertText]=H.textEdit.newText):typeof H.insertText=="string"?Te[n.ISuggestDataDtoField.insertText]=H.insertText:H.insertText instanceof s.$4N&&(Te[n.ISuggestDataDtoField.insertText]=H.insertText.value,Te[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return H.textEdit?He=H.textEdit.range:H.range&&(He=H.range),s.$SN.isRange(He)?Te[n.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!Z?.isEqual(He.inserting)||!x?.isEqual(He.replacing))&&(Te[n.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class ge{async provideInlineCompletions(H,G,Z,x){}async provideInlineEdits(H,G,Z,x){}disposeCompletions(H){}handleDidShowCompletionItem(H,G,Z){}handlePartialAccept(H,G,Z,x){}}class Y extends ge{constructor(H,G,Z,x){super(),this.f=H,this.g=G,this.h=Z,this.j=x,this.d=new oe,this.e=(0,t.$iH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$iH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(H,G,Z,x){const de=this.g.getDocument(H),Ee=i.Position.to(G),Te=await this.h.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},x);if(!Te||x.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Ke=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],et=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new O.$Uc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new O.$Uc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}async provideInlineEdits(H,G,Z,x){if(!this.h.provideInlineEdits)return;(0,t.$jH)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(H),Ee=i.Range.to(G),Te=await this.h.provideInlineEdits(de,Ee,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind],userPrompt:Z.userPrompt},x);if(!Te||x.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Ke=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],et=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new O.$Uc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new O.$Uc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(H){this.d.disposeReferenceId(H)?.dispose()}handleDidShowCompletionItem(H,G,Z){const x=this.d.get(H)?.items[G];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,Z)}handlePartialAccept(H,G,Z,x){const de=this.d.get(H)?.items[G];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,Z),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(x)))}}class q{async provideInlineEdits(H,G,Z){const x=this.f.getDocument(H),de=await this.g.provideInlineEdit(x,{triggerKind:this.e[G.triggerKind]},Z);if(!de||Z.isCancellationRequested)return;let Ee;const Te=this.d.createReferenceId({dispose(){Ee?.dispose()},item:de});let He;de.accepted&&(Ee||(Ee=new O.$Uc),He=this.h.toInternal(de.accepted,Ee));let Ke;return de.rejected&&(Ee||(Ee=new O.$Uc),Ke=this.h.toInternal(de.rejected,Ee)),{pid:Te,text:de.text,range:i.Range.from(de.range),accepted:He,rejected:Ke}}disposeEdit(H){this.d.disposeReferenceId(H)?.dispose()}constructor(H,G,Z,x){this.f=G,this.g=Z,this.h=x,this.d=new oe,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class oe{constructor(){this.d=new Map,this.e=1}createReferenceId(H){const G=this.e++;return this.d.set(G,H),G}disposeReferenceId(H){const G=this.d.get(H);return this.d.delete(H),G}get(H){return this.d.get(H)}}class ve{constructor(H,G){this.e=H,this.f=G,this.d=new o.$Hpc("SignatureHelp")}async provideSignatureHelp(H,G,Z,x){const de=this.e.getDocument(H),Ee=i.Position.to(G),Te=this.g(Z),He=await this.f.provideSignatureHelp(de,Ee,x,Te);if(He){const Ke=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Ke}}}g(H){let G;if(H.activeSignatureHelp){const Z=i.SignatureHelp.to(H.activeSignatureHelp),x=this.d.get(H.activeSignatureHelp.id,0);x?(G=x,G.activeSignature=Z.activeSignature,G.activeParameter=Z.activeParameter):G=Z}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this.d.delete(H)}}class ie{constructor(H,G,Z,x,de){this.f=H,this.g=G,this.h=Z,this.j=x,this.k=de,this.d=new o.$Hpc("InlayHints"),this.e=new Map}async provideInlayHints(H,G,Z){const x=this.f.getDocument(H),de=i.Range.to(G),Ee=await this.h.provideInlayHints(x,de,Z);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(Z.isCancellationRequested)return;const Te=this.d.add(Ee);this.e.set(Te,new O.$Uc);const He={hints:[],cacheId:Te};for(let Ke=0;Ke<Ee.length;Ke++)this.l(Ee[Ke],de)&&He.hints.push(this.m(Ee[Ke],[Te,Ke]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),He}async resolveInlayHint(H,G){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...H);if(!Z)return;const x=await this.h.resolveInlayHint(Z,G);if(x&&this.l(x))return this.m(x,H)}releaseHints(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G){return H.label.length===0||Array.isArray(H.label)&&H.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(G&&!G.contains(H.position))}m(H,G){const Z=this.e.get(G[0]);if(!Z)throw Error("DisposableStore is missing...");const x={label:"",cacheId:G,tooltip:i.MarkdownString.fromStrict(H.tooltip),position:i.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(i.TextEdit.from),kind:H.kind&&i.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};if(typeof H.label=="string")x.label=H.label;else{const de=[];x.label=de;for(const Ee of H.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:Ee.value,tooltip:i.MarkdownString.fromStrict(Ee.tooltip)};s.$5N.isLocation(Ee.location)&&(Te.location=i.location.from(Ee.location)),Ee.command&&(Te.command=this.g.toInternal(Ee.command,Z)),de.push(Te)}}return x}}class ae{constructor(H,G){this.e=H,this.f=G,this.d=new o.$Hpc("DocumentLink")}async provideLinks(H,G){const Z=this.e.getDocument(H),x=await this.f.provideDocumentLinks(Z,G);if(!(!Array.isArray(x)||x.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(ae.g).map(i.DocumentLink.from)};{const de=this.d.add(x),Ee={links:[],cacheId:de};for(let Te=0;Te<x.length;Te++){if(!ae.g(x[Te]))continue;const He=i.DocumentLink.from(x[Te]);He.cacheId=[de,Te],Ee.links.push(He)}return Ee}}}static g(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...H);if(!Z)return;const x=await this.f.resolveDocumentLink(Z,G);if(!(!x||!ae.g(x)))return i.DocumentLink.from(x)}releaseLinks(H){this.d.delete(H)}}class se{constructor(H,G){this.d=H,this.e=G}async provideColors(H,G){const Z=this.d.getDocument(H),x=await this.e.provideDocumentColors(Z,G);return Array.isArray(x)?x.map(Ee=>({color:i.Color.from(Ee.color),range:i.Range.from(Ee.range)})):[]}async provideColorPresentations(H,G,Z){const x=this.d.getDocument(H),de=i.Range.to(G.range),Ee=i.Color.to(G.color),Te=await this.e.provideColorPresentations(Ee,{document:x,range:de},Z);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class X{constructor(H,G){this.d=H,this.e=G}async provideFoldingRanges(H,G,Z){const x=this.d.getDocument(H),de=await this.e.provideFoldingRanges(x,G,Z);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class re{constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideSelectionRanges(H,G,Z){const x=this.d.getDocument(H),de=G.map(i.Position.to),Ee=await this.e.provideSelectionRanges(x,de,Z);if(!(0,r.$Lb)(Ee))return[];if(Ee.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<de.length;He++){const Ke=[];Te.push(Ke);let et=de[He],nt=Ee[He];for(;;){if(!nt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(nt)),!nt.parent)break;et=nt.range,nt=nt.parent}}return Te}}class pe{constructor(H,G){this.f=H,this.g=G,this.d=new T.$tQ(""),this.e=new Map}async prepareSession(H,G,Z){const x=this.f.getDocument(H),de=i.Position.to(G),Ee=await this.g.prepareCallHierarchy(x,de,Z);if(!Ee)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Te,He)):[this.h(Te,Ee)]}async provideCallsTo(H,G,Z){const x=this.j(H,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(x,Z);if(de)return de.map(Ee=>({from:this.h(H,Ee.from),fromRanges:Ee.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(H,G,Z){const x=this.j(H,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(x,Z);if(de)return de.map(Ee=>({to:this.h(H,Ee.to),fromRanges:Ee.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),x=i.CallHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(x._itemId,G),x}j(H,G){return this.e.get(H)?.get(G)}}class we{constructor(H,G){this.f=H,this.g=G,this.d=new T.$tQ(""),this.e=new Map}async prepareSession(H,G,Z){const x=this.f.getDocument(H),de=i.Position.to(G),Ee=await this.g.prepareTypeHierarchy(x,de,Z);if(!Ee)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Te,He)):[this.h(Te,Ee)]}async provideSupertypes(H,G,Z){const x=this.j(H,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(x,Z);if(de)return de.map(Ee=>this.h(H,Ee))}async provideSubtypes(H,G,Z){const x=this.j(H,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(x,Z);if(de)return de.map(Ee=>this.h(H,Ee))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),x=i.TypeHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(x._itemId,G),x}j(H,G){return this.e.get(H)?.get(G)}}class Me{constructor(H,G,Z,x,de){this.e=H,this.f=G,this.g=Z,this.h=x,this.j=de,this.d=new o.$Hpc("DocumentDropEdit")}async provideDocumentOnDropEdits(H,G,Z,x,de){const Ee=this.f.getDocument(G),Te=i.Position.to(Z),He=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolveDocumentOnDropFileData(this.h,H,st)).buffer),Ke=await this.g.provideDocumentDropEdits(Ee,Te,He,de);if(!Ke)return;const et=(0,r.$2b)(Ke),nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,p.localize)(2691,null,this.j.displayName||this.j.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(H,G){const[Z,x]=H,de=this.d.get(Z,x);if(!de||!this.g.resolveDocumentDropEdit)return{};const Ee=await this.g.resolveDocumentDropEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releaseDropEdits(H){this.d.delete(H)}}class ze{constructor(H,G){this.d=H,this.e=G}async provideMappedEdits(H,G,Z,x){const de=u.URI.revive(H),Ee=this.d.getDocument(de),Te=Z.documents.map(et=>et.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(Ee,G,He,x);return Ke?i.WorkspaceEdit.from(Ke):null}}class Ae{constructor(H,G){this.adapter=H,this.extension=G}}class De{static{this.d=0}constructor(H,G,Z,x,de,Ee,Te,He){this.g=G,this.h=Z,this.j=x,this.k=de,this.l=Ee,this.m=Te,this.n=He,this.f=new Map,this.e=H.getProxy(n.$ON.MainThreadLanguageFeatures)}o(H,G){return i.DocumentSelector.from(H,this.g,G)}p(H){return new s.$QN(()=>{this.f.delete(H),this.e.$unregister(H)})}q(){return De.d++}async s(H,G,Z,x,de,Ee=!1){const Te=this.f.get(H);if(!Te||!(Te.adapter instanceof G))return x;const He=Date.now();Ee||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const Ke=Z(Te.adapter,Te.extension);return Promise.resolve(Ke).catch(et=>{(0,R.$4)(et)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Te.extension.identifier,et))}).finally(()=>{Ee||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.$vh)(Ke,de):Ke}t(H,G){const Z=this.q();return this.f.set(Z,new Ae(H,G)),Z}static u(H){return H.displayName||H.name}static w(H){return H.identifier.value}registerDocumentSymbolProvider(H,G,Z,x){const de=this.t(new d(this.h,Z),H),Ee=x&&x.label||De.u(H);return this.e.$registerDocumentSymbolProvider(de,this.o(G,H),Ee),this.p(de)}$provideDocumentSymbols(H,G,Z){return this.s(H,d,x=>x.provideDocumentSymbols(u.URI.revive(G),Z),void 0,Z)}registerCodeLensProvider(H,G,Z){const x=this.q(),de=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new Ae(new l(this.h,this.j.converter,Z,H,this.n,this.l),H)),this.e.$registerCodeLensSupport(x,this.o(G,H),de);let Ee=this.p(x);if(de!==void 0){const Te=Z.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(de));Ee=s.$QN.from(Ee,Te)}return Ee}$provideCodeLenses(H,G,Z){return this.s(H,l,x=>x.provideCodeLenses(u.URI.revive(G),Z),void 0,Z)}$resolveCodeLens(H,G,Z){return this.s(H,l,x=>x.resolveCodeLens(G,Z),void 0,void 0)}$releaseCodeLenses(H,G){this.s(H,l,Z=>Promise.resolve(Z.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(H,G,Z){const x=this.t(new E(this.h,Z),H);return this.e.$registerDefinitionSupport(x,this.o(G,H)),this.p(x)}$provideDefinition(H,G,Z,x){return this.s(H,E,de=>de.provideDefinition(u.URI.revive(G),Z,x),[],x)}registerDeclarationProvider(H,G,Z){const x=this.t(new D(this.h,Z),H);return this.e.$registerDeclarationSupport(x,this.o(G,H)),this.p(x)}$provideDeclaration(H,G,Z,x){return this.s(H,D,de=>de.provideDeclaration(u.URI.revive(G),Z,x),[],x)}registerImplementationProvider(H,G,Z){const x=this.t(new S(this.h,Z),H);return this.e.$registerImplementationSupport(x,this.o(G,H)),this.p(x)}$provideImplementation(H,G,Z,x){return this.s(H,S,de=>de.provideImplementation(u.URI.revive(G),Z,x),[],x)}registerTypeDefinitionProvider(H,G,Z){const x=this.t(new I(this.h,Z),H);return this.e.$registerTypeDefinitionSupport(x,this.o(G,H)),this.p(x)}$provideTypeDefinition(H,G,Z,x){return this.s(H,I,de=>de.provideTypeDefinition(u.URI.revive(G),Z,x),[],x)}registerHoverProvider(H,G,Z,x){const de=this.t(new A(this.h,Z),H);return this.e.$registerHoverProvider(de,this.o(G,H)),this.p(de)}$provideHover(H,G,Z,x,de){return this.s(H,A,Ee=>Ee.provideHover(u.URI.revive(G),Z,x,de),void 0,de)}$releaseHover(H,G){this.s(H,A,Z=>Promise.resolve(Z.releaseHover(G)),void 0,void 0)}registerEvaluatableExpressionProvider(H,G,Z,x){const de=this.t(new $(this.h,Z),H);return this.e.$registerEvaluatableExpressionProvider(de,this.o(G,H)),this.p(de)}$provideEvaluatableExpression(H,G,Z,x){return this.s(H,$,de=>de.provideEvaluatableExpression(u.URI.revive(G),Z,x),void 0,x)}registerInlineValuesProvider(H,G,Z,x){const de=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new v(this.h,Z),H);this.e.$registerInlineValuesProvider(Ee,this.o(G,H),de);let Te=this.p(Ee);if(de!==void 0){const He=Z.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(de));Te=s.$QN.from(Te,He)}return Te}$provideInlineValues(H,G,Z,x,de){return this.s(H,v,Ee=>Ee.provideInlineValues(u.URI.revive(G),Z,x,de),void 0,de)}registerDocumentHighlightProvider(H,G,Z){const x=this.t(new M(this.h,Z),H);return this.e.$registerDocumentHighlightProvider(x,this.o(G,H)),this.p(x)}registerMultiDocumentHighlightProvider(H,G,Z){const x=this.t(new N(this.h,Z),H);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(G,H)),this.p(x)}$provideDocumentHighlights(H,G,Z,x){return this.s(H,M,de=>de.provideDocumentHighlights(u.URI.revive(G),Z,x),void 0,x)}$provideMultiDocumentHighlights(H,G,Z,x,de){return this.s(H,N,Ee=>Ee.provideMultiDocumentHighlights(u.URI.revive(G),Z,x.map(Te=>u.URI.revive(Te)),de),void 0,de)}registerLinkedEditingRangeProvider(H,G,Z){const x=this.t(new L(this.h,Z),H);return this.e.$registerLinkedEditingRangeProvider(x,this.o(G,H)),this.p(x)}$provideLinkedEditingRanges(H,G,Z,x){return this.s(H,L,async de=>{const Ee=await de.provideLinkedEditingRanges(u.URI.revive(G),Z,x);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?De.y(Ee.wordPattern):void 0}},void 0,x)}registerReferenceProvider(H,G,Z){const x=this.t(new F(this.h,Z),H);return this.e.$registerReferenceSupport(x,this.o(G,H)),this.p(x)}$provideReferences(H,G,Z,x,de){return this.s(H,F,Ee=>Ee.provideReferences(u.URI.revive(G),Z,x,de),void 0,de)}registerCodeActionProvider(H,G,Z,x){const de=new O.$Uc,Ee=this.t(new B(this.h,this.j.converter,this.k,Z,this.l,H,this.m),H);return this.e.$registerCodeActionSupport(Ee,this.o(G,H),{providedKinds:x?.providedCodeActionKinds?.map(Te=>Te.value),documentation:x?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,de)}))},De.u(H),De.w(H),!!Z.resolveCodeAction),de.add(this.p(Ee)),de}$provideCodeActions(H,G,Z,x,de){return this.s(H,B,Ee=>Ee.provideCodeActions(u.URI.revive(G),Z,x,de),void 0,de)}$resolveCodeAction(H,G,Z){return this.s(H,B,x=>x.resolveCodeAction(G,Z),{},void 0)}$releaseCodeActions(H,G){this.s(H,B,Z=>Promise.resolve(Z.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(H,G,Z){const x=this.t(new U(this.h,Z),H);return this.e.$registerDocumentFormattingSupport(x,this.o(G,H),H.identifier,H.displayName||H.name),this.p(x)}$provideDocumentFormattingEdits(H,G,Z,x){return this.s(H,U,de=>de.provideDocumentFormattingEdits(u.URI.revive(G),Z,x),void 0,x)}registerDocumentRangeFormattingEditProvider(H,G,Z){const x=typeof Z.provideDocumentRangesFormattingEdits=="function",de=this.t(new z(this.h,Z),H);return this.e.$registerRangeFormattingSupport(de,this.o(G,H),H.identifier,H.displayName||H.name,x),this.p(de)}$provideDocumentRangeFormattingEdits(H,G,Z,x,de){return this.s(H,z,Ee=>Ee.provideDocumentRangeFormattingEdits(u.URI.revive(G),Z,x,de),void 0,de)}$provideDocumentRangesFormattingEdits(H,G,Z,x,de){return this.s(H,z,Ee=>Ee.provideDocumentRangesFormattingEdits(u.URI.revive(G),Z,x,de),void 0,de)}registerOnTypeFormattingEditProvider(H,G,Z,x){const de=this.t(new ee(this.h,Z),H);return this.e.$registerOnTypeFormattingSupport(de,this.o(G,H),x,H.identifier),this.p(de)}$provideOnTypeFormattingEdits(H,G,Z,x,de,Ee){return this.s(H,ee,Te=>Te.provideOnTypeFormattingEdits(u.URI.revive(G),Z,x,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(H,G){const Z=this.t(new V(G,this.l),H);return this.e.$registerNavigateTypeSupport(Z,typeof G.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(H,G,Z){return this.s(H,V,x=>x.provideWorkspaceSymbols(G,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(H,G,Z){return this.s(H,V,x=>x.resolveWorkspaceSymbol(G,Z),void 0,void 0)}$releaseWorkspaceSymbols(H,G){this.s(H,V,Z=>Z.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(H,G,Z){const x=this.t(new W(this.h,Z,this.l),H);return this.e.$registerRenameSupport(x,this.o(G,H),W.supportsResolving(Z)),this.p(x)}$provideRenameEdits(H,G,Z,x,de){return this.s(H,W,Ee=>Ee.provideRenameEdits(u.URI.revive(G),Z,x,de),void 0,de)}$resolveRenameLocation(H,G,Z,x){return this.s(H,W,de=>de.resolveRenameLocation(u.URI.revive(G),Z,x),void 0,x)}registerNewSymbolNamesProvider(H,G,Z){const x=this.t(new J(this.h,Z,this.l),H);return this.e.$registerNewSymbolNamesProvider(x,this.o(G,H)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(H){return this.s(H,J,G=>G.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(H,G,Z,x,de){return this.s(H,J,Ee=>Ee.provideNewSymbolNames(u.URI.revive(G),Z,x,de),void 0,de)}registerDocumentSemanticTokensProvider(H,G,Z,x){const de=this.t(new ce(this.h,Z),H),Ee=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(G,H),x,Ee);let Te=this.p(de);if(Ee){const He=Z.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(Ee));Te=s.$QN.from(Te,He)}return Te}$provideDocumentSemanticTokens(H,G,Z,x){return this.s(H,ce,de=>de.provideDocumentSemanticTokens(u.URI.revive(G),Z,x),null,x)}$releaseDocumentSemanticTokens(H,G){this.s(H,ce,Z=>Z.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,G,Z,x){const de=this.t(new ne(this.h,Z),H);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(G,H),x),this.p(de)}$provideDocumentRangeSemanticTokens(H,G,Z,x){return this.s(H,ne,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(G),Z,x),null,x)}registerCompletionItemProvider(H,G,Z,x){const de=this.t(new ye(this.h,this.j.converter,Z,this.m,H),H);return this.e.$registerCompletionsProvider(de,this.o(G,H),x,ye.supportsResolving(Z),H.identifier),this.p(de)}$provideCompletionItems(H,G,Z,x,de){return this.s(H,ye,Ee=>Ee.provideCompletionItems(u.URI.revive(G),Z,x,de),void 0,de)}$resolveCompletionItem(H,G,Z){return this.s(H,ye,x=>x.resolveCompletionItem(G,Z),void 0,Z)}$releaseCompletionItems(H,G){this.s(H,ye,Z=>Z.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(H,G,Z,x){const de=new Y(H,this.h,Z,this.j.converter),Ee=this.t(de,H);return this.e.$registerInlineCompletionsSupport(Ee,this.o(G,H),de.supportsHandleEvents,f.$sn.toKey(H.identifier.value),x?.yieldTo?.map(Te=>f.$sn.toKey(Te))||[]),this.p(Ee)}$provideInlineCompletions(H,G,Z,x,de){return this.s(H,ge,Ee=>Ee.provideInlineCompletions(u.URI.revive(G),Z,x,de),void 0,de)}$provideInlineEdits(H,G,Z,x,de){return this.s(H,ge,Ee=>Ee.provideInlineEdits(u.URI.revive(G),Z,x,de),void 0,de)}$handleInlineCompletionDidShow(H,G,Z,x){this.s(H,ge,async de=>{de.handleDidShowCompletionItem(G,Z,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(H,G,Z,x,de){this.s(H,ge,async Ee=>{Ee.handlePartialAccept(G,Z,x,de)},void 0,void 0)}$freeInlineCompletionsList(H,G){this.s(H,ge,async Z=>{Z.disposeCompletions(G)},void 0,void 0)}registerInlineEditProvider(H,G,Z){const x=new q(H,this.h,Z,this.j.converter),de=this.t(x,H);return this.e.$registerInlineEditProvider(de,this.o(G,H),H.identifier),this.p(de)}$provideInlineEdit(H,G,Z,x){return this.s(H,q,de=>de.provideInlineEdits(u.URI.revive(G),Z,x),void 0,x)}$freeInlineEdit(H,G){this.s(H,q,async Z=>{Z.disposeEdit(G)},void 0,void 0)}registerSignatureHelpProvider(H,G,Z,x){const de=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,Ee=this.t(new ve(this.h,Z),H);return this.e.$registerSignatureHelpProvider(Ee,this.o(G,H),de),this.p(Ee)}$provideSignatureHelp(H,G,Z,x,de){return this.s(H,ve,Ee=>Ee.provideSignatureHelp(u.URI.revive(G),Z,x,de),void 0,de)}$releaseSignatureHelp(H,G){this.s(H,ve,Z=>Z.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(H,G,Z){const x=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ie(this.h,this.j.converter,Z,this.l,H),H);this.e.$registerInlayHintsProvider(de,this.o(G,H),typeof Z.resolveInlayHint=="function",x,De.u(H));let Ee=this.p(de);if(x!==void 0){const Te=Z.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(x));Ee=s.$QN.from(Ee,Te)}return Ee}$provideInlayHints(H,G,Z,x){return this.s(H,ie,de=>de.provideInlayHints(u.URI.revive(G),Z,x),void 0,x)}$resolveInlayHint(H,G,Z){return this.s(H,ie,x=>x.resolveInlayHint(G,Z),void 0,Z)}$releaseInlayHints(H,G){this.s(H,ie,Z=>Z.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(H,G,Z){const x=this.t(new ae(this.h,Z),H);return this.e.$registerDocumentLinkProvider(x,this.o(G,H),typeof Z.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(H,G,Z){return this.s(H,ae,x=>x.provideLinks(u.URI.revive(G),Z),void 0,Z,G.scheme==="output")}$resolveDocumentLink(H,G,Z){return this.s(H,ae,x=>x.resolveLink(G,Z),void 0,void 0,!0)}$releaseDocumentLinks(H,G){this.s(H,ae,Z=>Z.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(H,G,Z){const x=this.t(new se(this.h,Z),H);return this.e.$registerDocumentColorProvider(x,this.o(G,H)),this.p(x)}$provideDocumentColors(H,G,Z){return this.s(H,se,x=>x.provideColors(u.URI.revive(G),Z),[],Z)}$provideColorPresentations(H,G,Z,x){return this.s(H,se,de=>de.provideColorPresentations(u.URI.revive(G),Z,x),void 0,x)}registerFoldingRangeProvider(H,G,Z){const x=this.q(),de=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new Ae(new X(this.h,Z),H)),this.e.$registerFoldingRangeProvider(x,this.o(G,H),H.identifier,de);let Ee=this.p(x);if(de!==void 0){const Te=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));Ee=s.$QN.from(Ee,Te)}return Ee}$provideFoldingRanges(H,G,Z,x){return this.s(H,X,de=>de.provideFoldingRanges(u.URI.revive(G),Z,x),void 0,x)}registerSelectionRangeProvider(H,G,Z){const x=this.t(new re(this.h,Z,this.l),H);return this.e.$registerSelectionRangeProvider(x,this.o(G,H)),this.p(x)}$provideSelectionRanges(H,G,Z,x){return this.s(H,re,de=>de.provideSelectionRanges(u.URI.revive(G),Z,x),[],x)}registerCallHierarchyProvider(H,G,Z){const x=this.t(new pe(this.h,Z),H);return this.e.$registerCallHierarchyProvider(x,this.o(G,H)),this.p(x)}$prepareCallHierarchy(H,G,Z,x){return this.s(H,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),Z,x)),void 0,x)}$provideCallHierarchyIncomingCalls(H,G,Z,x){return this.s(H,pe,de=>de.provideCallsTo(G,Z,x),void 0,x)}$provideCallHierarchyOutgoingCalls(H,G,Z,x){return this.s(H,pe,de=>de.provideCallsFrom(G,Z,x),void 0,x)}$releaseCallHierarchy(H,G){this.s(H,pe,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(H,G,Z){const x=this.t(new we(this.h,Z),H);return this.e.$registerTypeHierarchyProvider(x,this.o(G,H)),this.p(x)}$prepareTypeHierarchy(H,G,Z,x){return this.s(H,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),Z,x)),void 0,x)}$provideTypeHierarchySupertypes(H,G,Z,x){return this.s(H,we,de=>de.provideSupertypes(G,Z,x),void 0,x)}$provideTypeHierarchySubtypes(H,G,Z,x){return this.s(H,we,de=>de.provideSubtypes(G,Z,x),void 0,x)}$releaseTypeHierarchy(H,G){this.s(H,we,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(H,G,Z,x){const de=this.q();return this.f.set(de,new Ae(new Me(this.e,this.h,Z,de,H),H)),this.e.$registerDocumentOnDropEditProvider(de,this.o(G,H),(0,t.$iH)(H,"documentPaste")&&x?{supportsResolve:!!Z.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(H,G,Z,x,de,Ee){return this.s(H,Me,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(G,u.URI.revive(Z),x,de,Ee)),void 0,void 0)}$resolveDropEdit(H,G,Z){return this.s(H,Me,x=>x.resolveDropEdit(G,Z),{},void 0)}$releaseDocumentOnDropEdits(H,G){this.s(H,Me,Z=>Promise.resolve(Z.releaseDropEdits(G)),void 0,void 0)}registerMappedEditsProvider(H,G,Z){const x=this.t(new ze(this.h,Z),H);return this.e.$registerMappedEditsProvider(x,this.o(G,H),H.displayName??H.name),this.p(x)}$provideMappedEdits(H,G,Z,x,de){return this.s(H,ze,Ee=>Promise.resolve(Ee.provideMappedEdits(G,Z,x,de)),null,de)}registerDocumentPasteEditProvider(H,G,Z,x){const de=this.q();return this.f.set(de,new Ae(new j(this.e,this.h,Z,de,H),H)),this.e.$registerPasteEditProvider(de,this.o(G,H),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,supportsResolve:!!Z.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(H,G,Z,x,de){return this.s(H,j,Ee=>Ee.prepareDocumentPaste(u.URI.revive(G),Z,x,de),void 0,de)}$providePasteEdits(H,G,Z,x,de,Ee,Te){return this.s(H,j,He=>He.providePasteEdits(G,u.URI.revive(Z),x,de,Ee,Te),void 0,Te)}$resolvePasteEdit(H,G,Z){return this.s(H,j,x=>x.resolvePasteEdit(G,Z),{},void 0)}$releasePasteEdits(H,G){this.s(H,j,Z=>Promise.resolve(Z.releasePasteEdits(G)),void 0,void 0)}static y(H){return{pattern:H.source,flags:H.flags}}static z(H){return{decreaseIndentPattern:De.y(H.decreaseIndentPattern),increaseIndentPattern:De.y(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?De.y(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?De.y(H.unIndentedLinePattern):void 0}}static B(H){return{beforeText:De.y(H.beforeText),afterText:H.afterText?De.y(H.afterText):void 0,previousLineText:H.previousLineText?De.y(H.previousLineText):void 0,action:H.action}}static C(H){return H.map(De.B)}static D(H){return{open:H.open,close:H.close,notIn:H.notIn?H.notIn.map(G=>s.SyntaxTokenType.toString(G)):void 0}}static E(H){return H.map(De.D)}setLanguageConfiguration(H,G,Z){const{wordPattern:x}=Z;if(x&&(0,k.$sf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(G,x):this.h.setWordDefinitionFor(G,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const de=this.q(),Ee={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?De.y(Z.wordPattern):void 0,indentationRules:Z.indentationRules?De.z(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?De.C(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs?De.E(Z.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,G,Ee),this.p(de)}$setWordDefinitions(H){for(const G of H)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$Rpc=De}),define(ke[305],Ie([1,0,3,44,6,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,R=We(R);class T{constructor(b){this.a=new Map,this.c=new Map,this.b=b.getProxy(C.$ON.MainThreadLanguageModelTools),this.b.$getTools().then(c=>{for(const k of c)this.c.set(k.name,(0,h.$di)(k))})}async invokeTool(b,c,k){const y=await this.b.$invokeTool(b,c,k);return R.LanguageModelToolResult.to(y)}async $acceptToolDelta(b){b.added&&this.c.set(b.added.name,b.added),b.removed&&this.c.delete(b.removed)}get tools(){return Array.from(this.c.values()).map(b=>R.LanguageModelToolDescription.to(b))}async $invokeTool(b,c,k){const y=this.a.get(b);if(!y)throw new Error(`Unknown tool ${b}`);const u=await y.tool.invoke(c,k);return R.LanguageModelToolResult.from(u)}registerTool(b,c,k){return this.a.set(c,{extension:b,tool:k}),this.b.$registerTool(c),(0,r.$Tc)(()=>{this.a.delete(c),this.b.$unregisterTool(c)})}}e.$jrc=T}),define(ke[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,159,25]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=e.$yqc=void 0,p=We(p),f=We(f),e.$yqc=(0,y.$Gi)("IExtHostLanguageModels");class o{constructor(g,E){this.option=g,this.stream=new r.$0h,this.stream=E??new r.$0h}}class n{constructor(){this.a=new Map,this.b=new r.$0h,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return r.$7h.map(g.b.asyncIterable,E=>{if(E instanceof f.$$P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let E=this.a.get(g.index);E||(this.a.size===0?E=new o(g.index,this.b):E=new o(g.index),this.a.set(g.index,E));let D;g.part.type==="text"?D=new f.$$P(g.part.value):D=new f.$0P(g.part.name,g.part.parameters),E.stream.emitOne(D)}reject(g){this.c=!0;for(const E of this.d())E.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(g,E,D){this.j=E,this.k=D,this.c=new T.$me,this.d=new T.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new k.$un,this.i=new Map,this.s=new Set,this.b=g.getProxy(w.$ON.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,E,D,S){const I=t.a++;this.f.set(I,{extension:g.identifier,provider:D,languageModelId:E});let A;S.auth&&(A={providerLabel:g.displayName||g.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(I,`${k.$sn.toKey(g.identifier)}/${I}/${E}`,{extension:g.identifier,id:E,vendor:S.vendor??k.$sn.toKey(g.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:A,targetExtensions:S.extensions});const $=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new k.$sn(v),M,N)});return(0,b.$Tc)(()=>{this.f.delete(I),this.b.$unregisterProvider(I),$?.dispose()})}async $startChatRequest(g,E,D,S,I,A){const $=this.f.get(g);if(!$)throw new Error("Provider not found");const v=new P.$Dw(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof f.$0P?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.$$P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${$.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let M;if($.provider.provideLanguageModelResponse2)M=Promise.resolve($.provider.provideLanguageModelResponse2(S.map(p.LanguageModelChatMessage.to),I,k.$sn.toKey(D),v,A));else{const N=new P.$Dw(async L=>{v.report({index:L.index,part:new f.$$P(L.part)})});M=Promise.resolve($.provider.provideLanguageModelResponse(S.map(p.LanguageModelChatMessage.to),I?.modelOptions??{},k.$sn.toKey(D),N,A))}M.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,R.$2)(N))})}$provideTokenLength(g,E,D){const S=this.f.get(g);return S?Promise.resolve(S.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:E,metadata:D}of g.added)this.g.set(E,{metadata:D,apiObjects:new k.$un});if(g.removed)for(const E of g.removed){this.g.delete(E);for(const[D,S]of this.i)S.languageModelId===E&&(S.res.reject(new R.$5),this.i.delete(D))}g.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,E){const D=await this.b.$selectChatModels({...E,extension:g.identifier}),S=[],I=this;for(const A of D){const $=this.g.get(A);if(!$)continue;this.o(g.identifier,$.metadata)&&await this.q($.metadata);let v=$.apiObjects.get(g.identifier);v||(v={id:A,vendor:$.metadata.vendor,family:$.metadata.family,version:$.metadata.version,name:$.metadata.name,maxInputTokens:$.metadata.maxInputTokens,countTokens(M,N){if(!I.g.has(A))throw f.$cQ.NotFound(A);return I.r(A,M,N??h.CancellationToken.None)},sendRequest(M,N,L){if(!I.g.has(A))throw f.$cQ.NotFound(A);return I.l(g,A,M,N??{},L??h.CancellationToken.None)}},Object.freeze(v),$.apiObjects.set(g.identifier,v)),S.push(v)}return S}async l(g,E,D,S,I){const A=this.m(g,D),$=g.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw f.$cQ.NotFound(`Language model '${E}' is unknown.`);if(this.o($,v)&&(!await this.n(g,{identifier:v.extension,displayName:v.auth.providerLabel},S.justification,!1)||!this.h.get($)?.has(v.extension)))throw f.$cQ.NoPermissions(`Language model '${E}' cannot be used by '${$.value}'.`);try{const M=Math.random()*1e6|0,N=new n;this.i.set(M,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest($,E,M,A,S,I)}catch(L){throw this.i.delete(M),L}return N.apiObject}catch(M){throw M.name===f.$cQ.name?M:new f.$cQ(`Language model '${E}' errored: ${(0,C.$rj)(M)}`,"Unknown",M)}}m(g,E){const D=[];for(const S of E)S.role===f.LanguageModelChatMessageRole.System&&(0,s.$jH)(g,"languageModelSystem"),S.content2 instanceof f.$8P&&(0,s.$jH)(g,"lmTools"),D.push(p.LanguageModelChatMessage.from(S));return D}async $acceptResponsePart(g,E){const D=this.i.get(g);D&&D.res.handleFragment(E)}async $acceptResponseDone(g,E){const D=this.i.get(g);D&&(this.i.delete(g),E?D.res.reject((0,R.$3)(E)):D.res.resolve())}async n(g,E,D,S){const I=i.$QM+E.identifier.value;if(await this.k.getSession(g,I,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0;if(S)return!1;try{const $=D?(0,c.localize)(2692,null,E.displayName,D):void 0;return await this.k.getSession(g,I,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(g,E){return!!E.auth&&!k.$sn.equals(E.extension,g)}async q(g){if(g.auth)for(const E of this.s)try{await this.n(E,{identifier:g.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(g,E,D){if(!this.g.get(g))throw f.$cQ.NotFound(`Language model '${g}' is unknown.`);const I=O.Iterable.find(this.f.values(),A=>A.languageModelId===g);return I?I.provider.provideTokenCount(E,D):this.b.$countTokens(g,typeof E=="string"?E:p.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(g){const E=new Array;for(const{from:D,to:S,enabled:I}of g){const A=this.h.get(D)??new k.$tn;if(A.has(S)!==I){I?A.add(S):A.delete(S),this.h.set(D,A);const v={from:D,to:S};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(g){this.s.add(g);const E=this,D=T.Event.signal(T.Event.filter(this.c.event,I=>k.$sn.equals(I.from,g.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(D,S)},canSendRequest(I){let A;e:for(const[v,M]of E.g)for(const N of M.apiObjects.values())if(N===I){A=M.metadata;break e}if(!A)return;if(!E.o(g.identifier,A))return!0;const $=E.h.get(g.identifier);if($)return $.has(A.extension)}}}};e.$zqc=d,e.$zqc=d=t=Ze([Ve(0,m.$oQ),Ve(1,u.$bk),Ve(2,a.$Tpc)],d)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[306],Ie([1,0,6,15,9,43,7,3,25]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,h=We(h),R=Ut(R);class c{constructor(y,u,P,w){this.c=u,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(r.$ON.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const P=this.c.getDocumentData(y);if(!P)throw new Error(`document '${y.toString()}' NOT found`);return P.document}async tokenAtPosition(y,u){const P=y.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(y.uri,w),m={type:C.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new C.$SN(u.line,u.character,u.line,u.character)};if(!a)return m;const p={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!p.range.contains(u)||P!==y.version?m:p}createLanguageStatusItem(y,u,P){const w=this.f++,a=this.a,m=this.g,p=`${y.identifier.value}/${u}`;if(m.has(p))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add(p);const f={selector:P,id:u,name:y.displayName??y.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new O.$Uc,t=()=>{if(i?.dispose(),!m.has(p)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,T.$Ih)(()=>{s.clear(),this.a.$setLanguageStatus(w,{id:p,name:f.name??y.displayName??y.name,source:y.displayName??y.name,selector:h.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===C.LanguageStatusSeverity.Error?R.default.Error:f.severity===C.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(w),m.delete(p)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,b.$jH)(y,"languageStatusText"),f.text=n,t()},get text2(){return(0,b.$jH)(y,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.$krc=c}),define(ke[307],Ie([1,0,14,2,15,9,126]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=void 0,C=We(C),T=We(T);class O{constructor(y,u,P,w){this.start=y,this.deletedCount=u,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new R.$iP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,P){this.notebook=y,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(C.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(w){y.g=w},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(P)}return this.f}setOutputs(y){this.a=y.map(C.NotebookCellOutput.to)}setOutputItems(y,u,P){const w=P.map(C.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===y);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(m=>T.$QL(m.mime)))){const m=new Map,p=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),p.push(f.mime)),i.push(f.data)}),a.items.length=0,p.forEach(f=>{const i=T.$RL(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$8qc=b;class c{static{this.a=0}constructor(y,u,P,w,a){this.k=y,this.l=u,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===r.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(P){return P=y.n(P),y.b[P].apiCell},getCells(P){return(P?y.p(P):y.b).map(a=>a.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,P){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const p of y.rawEvents)p.kind===T.NotebookCellsChangeType.ModelChange?this.r(p.changes,!1,w.contentChanges):p.kind===T.NotebookCellsChangeType.Move?this.s(p.index,p.length,p.newIdx,w.contentChanges):p.kind===T.NotebookCellsChangeType.Output?(this.t(p.index,p.outputs),a.push({cell:this.b[p.index].apiCell,outputs:this.b[p.index].apiCell.outputs})):p.kind===T.NotebookCellsChangeType.OutputItem?(this.u(p.index,p.outputId,p.append,p.outputItems),a.push({cell:this.b[p.index].apiCell,outputs:this.b[p.index].apiCell.outputs})):p.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v(p.index,p.language),a.push({cell:this.b[p.index].apiCell,document:this.b[p.index].apiCell.document})):p.kind===T.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[p.index].apiCell,document:this.b[p.index].apiCell.document}):p.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w(p.index,p.mime):p.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x(p.index,p.metadata),a.push({cell:this.b[p.index].apiCell,metadata:this.b[p.index].apiCell.metadata})):p.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(p.index,p.internalMetadata),a.push({cell:this.b[p.index].apiCell,executionSummary:this.b[p.index].apiCell.executionSummary}));const m=new Map;for(let p=0;p<a.length;p++){const f=a[p],i=m.get(f.cell);if(i===void 0){const s=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else w.cellChanges[i]={...w.cellChanges[i],...f}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,P=y.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),y.with({start:u,end:P})}p(y){y=this.o(y);const u=[];for(let P=y.start;P<y.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,P){if(this.j)return;const w=[],a=[],m=[];if(y.reverse().forEach(p=>{const i=p[2].map(o=>{const n=new b(this,this.l,o);return u||a.push(b.asModelAddData(o)),n}),s=new O(p[0],p[1],[],i),t=this.b.splice(p[0],p[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);w.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),P)for(const p of w)P.push(p.asApiEvent())}s(y,u,P,w){const a=this.b.splice(y,u);this.b.splice(P,0,...a);const m=[new O(y,u,a.map(p=>p.apiCell),[]),new O(P,0,[],a)];for(const p of m)w.push(p.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,P,w){this.b[y].setOutputItems(u,P,w)}v(y,u){const P=this.b[y];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(y,u){const P=this.b[y];P.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$9qc=c}),define(ke[308],Ie([1,0,4,2,15,9,53]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0;class O{constructor(c,k,y,u={timeout:1500,errors:3}){this.b=c,this.c=k,this.d=y,this.f=u,this.a=new r.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(k,y,u)=>{const P=function(a){k.call(y,a)};return P.extension=c,this.a.event(P,void 0,u)}}async $participateInSave(c,k,y){const u=h.URI.revive(c),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:C.TextDocumentSaveReason.to(k)},y,async(m,p)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof R.$3N?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const m of w){const{edits:p}=C.WorkspaceEdit.from(m);a.edits=a.edits.concat(p)}return this.d.$tryApplyWorkspaceEdit(new T.$2w(a))}}e.$mrc=O}),define(ke[168],Ie([1,0,13,15,9]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,h=We(h),C=We(C);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,b,c,k,y,u){this.id=O,this.f=b,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=k,this.c=u}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(b){this.selections=[b]},get selections(){return O.a},set selections(b){if(!Array.isArray(b)||!b.every(C.$iP.isNotebookRange))throw(0,r.$7)("selections");O.a=b,O.g(b)},get visibleRanges(){return O.b},revealRange(b,c){O.f.$tryRevealRange(O.id,h.NotebookRange.from(b),c??C.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(h.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$0qc=R}),define(ke[309],Ie([1,0,4,11,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=void 0,C=We(C);let R=class{constructor(O,b){this.c=O,this.d=b,this.a=new r.$me,this.b=new r.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,b);const c=this.d.getEditorById(O);b.visibleRanges&&c._acceptVisibleRanges(b.visibleRanges.ranges.map(C.NotebookRange.to)),b.selections&&c._acceptSelections(b.selections.selections.map(C.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const b in O)this.d.getEditorById(b)._acceptViewColumn(C.ViewColumn.to(O[b]))}};e.$orc=R,e.$orc=R=Ze([Ve(0,h.$bk)],R)}),define(ke[310],Ie([1,0,4,6,168]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;class R{constructor(O,b){this.c=b,this.a=new Map,this.b=O.getProxy(h.$ON.MainThreadNotebookRenderers)}$postRendererMessage(O,b,c){const k=this.c.getEditorById(O);this.a.get(b)?.fire({editor:k.apiEditor,message:c})}createRendererMessaging(O,b){if(!O.contributes?.notebookRenderer?.some(k=>k.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(k,y,u)=>this.d(b).event(k,y,u),postMessage:(k,y)=>{C.$0qc.apiEditorsToExtHost.has(k)&&([k,y]=[y,k]);const u=y&&C.$0qc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,b,k)}}}d(O){let b=this.a.get(O);return b||(b=new r.$me({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(O)}}),this.a.set(O,b),b)}}e.$rrc=R}),define(ke[311],Ie([1,0,15,89,20,59,13]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0;class O{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,P){const w=this.b++,{title:a,location:m,cancellable:p}=u,f={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:p},y.isUnderDevelopment?void 0:y.identifier.value).catch(T.$1),this.d(w,P,!!p)}d(y,u,P){let w;P&&(w=new C.$xe,this.c.set(y,w));const a=p=>{this.a.$progressEnd(p),this.c.delete(p),w?.dispose()};let m;try{m=u(new c(this.a,y),P&&w?w.token:C.CancellationToken.None)}catch(p){throw a(y),p}return m.then(p=>a(y),p=>a(y)),m}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$vrc=O;function b(k,y){return k.message=y.message,typeof y.increment=="number"&&(typeof k.increment=="number"?k.increment+=y.increment:k.increment=y.increment),k}class c extends h.$Dw{constructor(y,u){super(P=>this.throttledReport(P)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Ze([(0,R.$ai)(100,(k,y)=>b(k,y),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[312],Ie([1,0,2,6,7,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;class T{static{this.a=0}constructor(b,c){this.d=c,this.c=new Map,this.b=b.getProxy(h.$ON.MainThreadQuickDiff)}$provideOriginalResource(b,c,k){const y=r.URI.revive(c),u=this.c.get(b);return u?(0,C.$yh)(()=>u.provideOriginalResource(y,k)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(b,c,k,y){const u=T.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from(b,this.d),k,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$wrc=T});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[313],Ie([1,0,20,4,3,6,2,9,13,18,43,51,25,15]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=w,k=Ut(k);function w(a,m,p){const f=a.getProxy(R.$ON.MainThreadQuickOpen);class i{constructor(D,S){this.e=new Map,this.f=0,this.a=D,this.b=S}showQuickPick(D,S,I,A=r.CancellationToken.None){this.c=void 0;const $=Promise.resolve(S),v=++this.f,M=f.$show(v,{title:I?.title,placeHolder:I?.placeHolder,matchOnDescription:I?.matchOnDescription,matchOnDetail:I?.matchOnDetail,ignoreFocusLost:I?.ignoreFocusOut,canPickMany:I?.canPickMany},A),N={},L=M.then(()=>N);return Promise.race([L,$]).then(F=>{if(F===N)return;const B=(0,u.$iH)(D,"quickPickItemTooltip");return $.then(j=>{const U=[];for(let z=0;z<j.length;z++){const ee=j[z];if(typeof ee=="string")U.push({label:ee,handle:z});else if(ee.kind===O.QuickPickItemKind.Separator)U.push({type:"separator",label:ee.label});else{ee.tooltip&&!B&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const V=ee.iconPath?d(ee.iconPath):void 0;U.push({label:ee.label,iconPath:V?.iconPath,iconClass:V?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:B?P.MarkdownString.fromStrict(ee.tooltip):void 0,handle:z})}}return I&&typeof I.onDidSelectItem=="function"&&(this.c=z=>{I.onDidSelectItem(j[z])}),f.$setItems(v,U),M.then(z=>{if(typeof z=="number")return j[z];if(Array.isArray(z))return z.map(ee=>j[ee])})})}).then(void 0,F=>{if(!(0,b.$4)(F))return f.$setError(v,F),Promise.reject(F)})}$onItemSelected(D){this.c?.(D)}showInput(D,S=r.CancellationToken.None){return this.d=D?.validateInput,f.$input(D,typeof this.d=="function",S).then(void 0,I=>{if(!(0,b.$4)(I))return Promise.reject(I)})}async $validateInput(D){if(!this.d)return;const S=await this.d(D);if(!S||typeof S=="string")return S;let I;switch(S.severity){case O.InputBoxValidationSeverity.Info:I=k.default.Info;break;case O.InputBoxValidationSeverity.Warning:I=k.default.Warning;break;case O.InputBoxValidationSeverity.Error:I=k.default.Error;break;default:I=S.message?k.default.Error:k.default.Ignore;break}return{content:S.message,severity:I}}async showWorkspaceFolderPick(D,S=r.CancellationToken.None){const I=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!I)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find($=>$.uri.toString()===I.uri.toString())}createQuickPick(D){const S=new l(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(D){const S=new g(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(D,S){this.e.get(D)?._fireDidChangeValue(S)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,S){const I=this.e.get(D);I instanceof l&&I._fireDidChangeActive(S)}$onDidChangeSelection(D,S){const I=this.e.get(D);I instanceof l&&I._fireDidChangeSelection(S)}$onDidTriggerButton(D,S){this.e.get(D)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(D,S,I){const A=this.e.get(D);A instanceof l&&A._fireDidTriggerItemButton(S,I)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,S){this.x=D,this.y=S,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$me,this.q=new h.$me,this.r=new h.$me,this.s=new h.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const S=(0,u.$iH)(this.x,"quickInputButtonLocation");!S&&D.some(I=>I.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((I,A)=>{const $=I===O.$fP.Back?-1:A;this.o.set($,I)}),this.z({buttons:D.map((I,A)=>({...d(I.iconPath),tooltip:I.tooltip,handle:I===O.$fP.Back?-1:A,location:S?I.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const S=this.o.get(D);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(D){if(!this.v){for(const S of Object.keys(D)){const I=D[S];this.u[S]=I===void 0?null:I}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof O.$PO)return{id:E.id};const D=n(E),S=o(E);return{dark:typeof D=="string"?T.URI.file(D):D,light:typeof S=="string"?T.URI.file(S):S}}function o(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const D=t(E);let S,I;return"id"in D?I=y.ThemeIcon.asClassName(D):S=D,{iconPath:S,iconClass:I}}class l extends s{constructor(D,S){super(D,S),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$me,this.L=[],this.M=new h.$me,this.N=new h.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,$)=>{this.C.set($,A),this.D.set(A,$)});const S=(0,u.$iH)(this.x,"quickPickItemTooltip"),I=[];for(let A=0;A<D.length;A++){const $=D[A];if($.kind===O.QuickPickItemKind.Separator)I.push({type:"separator",label:$.label});else{$.tooltip&&!S&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const v=$.iconPath?d($.iconPath):void 0;I.push({handle:A,label:$.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,tooltip:S?P.MarkdownString.fromStrict($.tooltip):void 0,buttons:$.buttons?.map((M,N)=>({...d(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:I})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(D){const S=(0,c.$Hb)(D.map(I=>this.C.get(I)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(D){const S=(0,c.$Hb)(D.map(I=>this.C.get(I)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(D,S){const I=this.C.get(D);if(!I||!I.buttons||!I.buttons.length)return;const A=I.buttons[S];A&&this.N.fire({button:A,item:I})}}class g extends s{constructor(D,S){super(D,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:k.default.Error}):this.z({validationMessage:D.message,severity:D.severity??k.default.Error}):this.z({validationMessage:void 0,severity:k.default.Ignore})}}return new i(m,p)}}),define(ke[314],Ie([1,0,2,4,59,3,7,6,18,135,11,23,40,51,15,25,14,10]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$zrc=e.$yrc=void 0;function i(N){return N instanceof r.URI}function s(N,L){return N.scheme===m.Schemas.file&&L.scheme===m.Schemas.file&&p.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function n(N){const L=o(N.icon),F=N.labels?.map(B=>({title:B.title,icon:o(B.icon)}));return{...N,icon:L,labels:F}}function d(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const F=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,B=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,c.$Nr)(F,B)}function l(N,L){let F=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(F=d(N,L),F!==0)return F;if(N.light&&L.light)F=d(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(F!==0)return F;if(N.dark&&L.dark)F=d(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return F}function g(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let F=0;F<N.arguments.length;F++){const B=N.arguments[F],j=L.arguments[F];if(B!==j&&!(i(B)&&i(j)&&s(B,j)))return B<j?-1:1}return 0}function E(N,L){let F=(0,c.$Nr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(F!==0)return F;if(N.command&&L.command)F=g(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(F!==0)return F;if(N.decorations&&L.decorations)F=l(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)F=(0,c.$Nr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)F=(0,c.$Nr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return F}function D(N,L){for(let F=0;F<N.length;F++)if(N[F]!==L[F])return!1;return!0}function S(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function I(N,L){return(0,b.$ub)(N,L,S)}class A{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,a.$jH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,a.$jH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,a.$jH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,F,B,j,U){this.k=L,this.m=j,this.n=U,this.d="",this.e=new h.$me,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=B}showValidationMessage(L,F){(0,a.$jH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,F)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$yrc=A;class ${static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,F,B,j,U,z,ee){this.s=L,this.t=F,this.u=B,this.v=j,this.w=U,this.multiDiffEditorEnableViewChanges=z,this.x=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=$.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,F){const B=this.h.get(L);return B?(0,T.$yh)(()=>this.t.executeCommand(B.command,...B.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),B=(0,b.$Db)(this.p,L,E).map(z=>{const ee=z.toInsert.map(V=>{const W=this.e++;this.g.set(W,V);const J=V.resourceUri;let _;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"||V.command.command==="vscode.changes"){const re=new R.$Uc;_=this.t.converter.toInternal(V.command,re),this.j.set(W,re)}else this.h.set(W,V.command);const ce=(0,a.$iH)(this.x,"scmMultiDiffEditor"),ne=ce?V.multiDiffEditorOriginalUri:void 0,ye=ce?V.multiFileDiffEditorModifiedUri:void 0,ge=t(V.decorations),Y=V.decorations&&t(V.decorations.light)||ge,q=V.decorations&&t(V.decorations.dark)||ge,oe=[Y,q],ve=V.decorations&&V.decorations.tooltip||"",ie=V.decorations&&!!V.decorations.strikeThrough,ae=V.decorations&&!!V.decorations.faded,se=V.contextValue||"";return{rawResource:[W,J,oe,ve,ie,ae,se,_,ne,ye],handle:W}});return{start:z.start,deleteCount:z.deleteCount,toInsert:ee}}),j=B.map(({start:z,deleteCount:ee,toInsert:V})=>[z,ee,V.map(W=>W.rawResource)]),U=B.reverse();for(const{start:z,deleteCount:ee,toInsert:V}of U){const W=V.map(_=>_.handle),J=this.o.splice(z,ee,...W);for(const _ of J)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.p=L,j}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let F;(0,a.$iH)(this.y,"quickDiffProvider")&&(F=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:F})}get historyProvider(){return(0,a.$jH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,a.$jH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new R.$Uc,this.p=L;const F=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:F})}get actionButton(){return(0,a.$jH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,a.$jH)(this.y,"scmActionButton"),this.q.value=new R.$Uc,this.s=L;const F=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(B=>B.map(j=>this.z.converter.toInternal(j,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:F??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&I(this.u,L))return;this.t.value=new R.$Uc,this.u=L;const F=(L||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:F})}get selected(){return this.v}constructor(L,F,B,j,U,z,ee){this.y=L,this.z=j,this.A=U,this.B=z,this.C=ee,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.n=void 0,this.o=new R.$Wc,this.p=void 0,this.q=new R.$Wc,this.t=new R.$Wc,this.u=void 0,this.v=!1,this.w=new h.$me,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=B;const V=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:ee?`rootUri=${encodeURIComponent(ee.toString())}`:void 0});this.f=new A(L,F,this.#e,this.x,V),this.#e.$registerSourceControl(this.x,U,z,ee,V)}createResourceGroup(L,F,B){const j=(0,a.$iH)(this.y,"scmMultiDiffEditor")&&B?.multiDiffEditorEnableViewChanges===!0,U=new $(this.#e,this.z,this.x,L,F,j,this.y),z=h.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,z),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const L=[],F=[];for(const[B,j]of this.D){j.dispose();const U=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});h.Event.once(B.onDidDispose)(()=>{this.E.delete(B),U.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),L.push([B.handle,B.id,B.label,B.features,B.multiDiffEditorEnableViewChanges]);const z=B._takeResourceStateSnapshot();z.length>0&&F.push([B.handle,z]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,L,F),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(F=>{const B=F._takeResourceStateSnapshot();B.length!==0&&L.push([F.handle,B])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ze([(0,C.$_h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ze([(0,C.$_h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{f=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,F,B,j){this.m=F,this.n=B,this.o=j,this.g=new Map,this.h=new y.$un,this.j=new h.$me,this.e=L.getProxy(O.$ON.MainThreadSCM),this.f=L.getProxy(O.$ON.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===u.MarshalledId.ScmResource){const z=this.g.get(U.sourceControlHandle);if(!z)return U;const ee=z.getResourceGroup(U.groupHandle);return ee?ee.getResourceState(U.handle):U}else if(U&&U.$mid===u.MarshalledId.ScmResourceGroup){const z=this.g.get(U.sourceControlHandle);return z?z.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===u.MarshalledId.ScmProvider){const z=this.g.get(U.handle);return z||U}return U}})}createSourceControl(L,F,B,j){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,F,B,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const U=f.d++,z=new v(L,this.n,this.e,this.m,F,B,j);this.g.set(U,z);const ee=this.h.get(L.identifier)||[];return ee.push(z),this.h.set(L.identifier,ee),z}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const F=this.h.get(L.identifier),B=F&&F[F.length-1];return B&&B.inputBox}$provideOriginalResource(L,F,B){const j=r.URI.revive(F);this.o.trace("ExtHostSCM#$provideOriginalResource",L,j.toString());const U=this.g.get(L);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$yh)(()=>U.quickDiffProvider.provideOriginalResource(j,B)).then(z=>z||null)}$onInputBoxValueChange(L,F){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const B=this.g.get(L);return B&&B.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(L,F,B,j){this.o.trace("ExtHostSCM#$executeResourceCommand",L,F,B);const U=this.g.get(L);if(!U)return Promise.resolve(void 0);const z=U.getResourceGroup(F);return z?z.$executeResourceCommand(B,j):Promise.resolve(void 0)}$validateInput(L,F,B){this.o.trace("ExtHostSCM#$validateInput",L);const j=this.g.get(L);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,T.$yh)(()=>j.inputBox.validateInput(F,B)).then(U=>{if(!U)return Promise.resolve(void 0);const z=w.MarkdownString.fromStrict(U.message);return z?Promise.resolve([z,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,F,B,j){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,B,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,F,B){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(F,B)??void 0}async $provideHistoryItems(L,F,B,j){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(F,B,j))?.map(ee=>n(ee))??void 0}async $provideHistoryItems2(L,F,B){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(F,B))?.map(z=>n(z))??void 0}async $provideHistoryItemSummary(L,F,B,j){const U=this.g.get(L)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const z=await U.provideHistoryItemSummary(F,B,j);return z?n(z):void 0}async $provideHistoryItemChanges(L,F,B,j){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(F,B,j)??void 0}};e.$zrc=M,e.$zrc=M=f=Ze([Ve(3,k.$bk)],M)}),define(ke[315],Ie([1,0,6,15,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=void 0;class R{static{this.a=0}constructor(O,b){this.d=b,this.c=new Map,this.b=O.getProxy(r.$ON.MainThreadShare)}async $provideShare(O,b,c){return await this.c.get(O)?.provideShare({selection:h.Range.to(b.selection),resourceUri:C.URI.revive(b.resourceUri)},c)??void 0}registerShareProvider(O,b){const c=R.a++;return this.c.set(c,b),this.b.$registerShareProvider(c,h.DocumentSelector.from(O,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$Arc=R}),define(ke[316],Ie([1,0,9,6,8,3,15,17]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$QO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$QO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,w,a,m,p=r.StatusBarAlignment.Left,f){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=u,this.#t=P,m&&a){this.c=(0,r.$sO)(a.identifier,m);const i=w.get(this.c);i&&(p=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=m,this.g=p,this.h=this.u(f)}u(u){if((0,O.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!b.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,C.localize)(2698,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=b.b.get(this.o.id));const a=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Crc=b;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(2699,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$QN(()=>{const w=this.b.indexOf(P);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class k{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$ON.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,w,a){return new b(this.a,this.b,this.e,u,P,w,a)}setStatusBarMessage(u,P){const w=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>w.dispose(),P):typeof P<"u"&&P.then(()=>w.dispose(),()=>w.dispose()),new r.$QN(()=>{w.dispose(),clearTimeout(a)})}}e.$Drc=k}),define(ke[169],Ie([1,0,30,158,73,120,74,15,2]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=e.$BQ=e.$AQ=void 0,r=We(r),O=We(O);const c=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(o(d,l))}}}},k=(i,s)=>i===s,y={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:R.TestItemEventOp.SetProp,update:i(s)}),P=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.$Rt.lift(O.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:R.TestItemEventOp.DocumentSynced}),y.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:c(i,s,y.label,u(t=>({label:t}))),description:c(i,void 0,y.description,u(t=>({description:t}))),sortText:c(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,y.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,y.busy,u(t=>({busy:t}))),error:c(i,void 0,y.error,u(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],y.tags,(t,o)=>({op:R.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),w=i=>{const s=C.$$I.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,b.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,T.$eJ)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=w(t.item);(0,h.$kQ)(o).parent=s,s=o}return s};e.$AQ=a;class m{constructor(s,t,o,n){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$jQ)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof p?void 0:d.parent}},children:{value:(0,R.$iQ)(d,h.$kQ,m),enumerable:!0,writable:!1},...P(d,o)})}}e.$BQ=m;class p extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.$CQ=p;class f extends R.$eQ{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:h.$kQ,getChildren:n=>n.children,root:new p(s,t),toITestItem:O.TestItem.from})}}e.$DQ=f}),define(ke[34],Ie([1,0,17,9,15,24,6,18,11,44,30,57,2,3,5,19,169,21,53,52,42,91,94,32]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=e.$MQ=e.$LQ=e.$KQ=e.$JQ=void 0,h=We(h),C=We(C);let d=class{#e;#t;#i;constructor(I,A,$){this.b=new Map,this.c=new Map,this.#e=I.getProxy(T.$ON.MainThreadCommands),this.d=A,this.#i=$,this.#t=I.getProxy(T.$ON.MainThreadTelemetry),this.converter=new l(this,v=>{const M=this.c.get(v);return M?.result===E.Void?M:void 0},A),this.f=[{processArgument(v){return(0,c.$di)(v)}},{processArgument(v){return(0,R.$ho)(v,function(M){if(k.$Rt.isIRange(M))return C.Range.to(M);if(y.$Qt.isIPosition(M))return C.Position.to(M);if(k.$Rt.isIRange(M.range)&&u.URI.isUri(M.uri))return C.location.to(M);if(M instanceof p.$Oe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const A=this.registerCommand(!1,I.id,async(...$)=>{const v=I.args.map((N,L)=>{if(!N.validate($[L]))throw new Error(`Invalid argument '${N.name}' when running '${I.id}', received: ${typeof $[L]=="object"?JSON.stringify($[L],null,"	"):$[L]} `);return N.convert($[L])}),M=await this.executeCommand(I.internalId,...v);return I.result.convert(M,$,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new h.$QN(()=>{A.dispose(),this.c.delete(I.id)})}registerCommand(I,A,$,v,M,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:$,thisArg:v,metadata:M,extension:N}),I&&this.#e.$registerCommand(A),new h.$QN(()=>{this.b.delete(A)&&I&&this.#e.$unregisterCommand(A)})}executeCommand(I,...A){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,A,!0)}async g(I,A,$){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,A,!1);{let v=!1;const M=(0,R.$ho)(A,function(N){if(N instanceof h.$RN)return C.Position.from(N);if(N instanceof h.$SN)return C.Range.from(N);if(N instanceof h.$5N)return C.location.from(N);if(h.$iP.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,p.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,p.$Oe.wrap(N);if(N instanceof p.$Oe)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(I,v?new f.$2w(M):M,$);return(0,c.$di)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(I,A,!1);throw N}}}async h(I,A,$){const v=this.b.get(I);if(!v)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=v;if(L?.args)for(let B=0;B<L.args.length;B++)try{(0,r.$wg)(A[B],L.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${L.args[B].name}' - ${L.args[B].description}`)}const F=s.$ge.create();try{return await M.apply(N,A)}catch(B){if(I===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...A);j&&(I=j.command)}if(this.d.error(B,I,v.extension?.identifier),!$)throw B;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,B);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$rj)(B)),this.id=I,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,I,F.elapsed())}}j(I,A,$){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new t.$yp(A),duration:$})}$executeContributedCommand(I,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const $=this.b.get(I);return $?(A=A.map(v=>this.f.reduce((M,N)=>N.processArgument(M,$.extension?.identifier),v)),this.h(I,A,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(A=>(I&&(A=A.filter($=>$[0]!=="_")),A))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[A,$]of this.b){const{metadata:v}=$;v&&(I[A]=v)}return Promise.resolve(I)}};e.$JQ=d,e.$JQ=d=Ze([Ve(0,a.$oQ),Ve(1,b.$bk),Ve(2,o.$IQ)],d),e.$KQ=(0,w.$Gi)("IExtHostCommands");class l{constructor(I,A,$){this.d=I,this.f=A,this.g=$,this.delegatingCommandId=`__vsc${(0,n.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,A){if(!I)return;const $={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return $;const v=this.f(I.command);if(v)$.id=v.internalId,$.arguments=v.args.map((M,N)=>M.convert(I.arguments&&I.arguments[N]));else if((0,O.$Lb)(I.arguments)){const M=`${I.command} /${++this.c}`;this.b.set(M,I),A.add((0,P.$Tc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),$.$ident=M,$.id=this.delegatingCommandId,$.arguments=[M],this.g.trace("CommandsConverter#CREATE",I.command,M)}return $}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const A=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$LQ=l;class g{static{this.Uri=new g("uri","Uri of a text document",I=>u.URI.isUri(I),I=>I)}static{this.Position=new g("position","A position in a text document",I=>h.$RN.isPosition(I),C.Position.from)}static{this.Range=new g("range","A range in a text document",I=>h.$SN.isRange(I),C.Range.from)}static{this.Selection=new g("selection","A selection in a text document",I=>h.$TN.isSelection(I),C.Selection.from)}static{this.Number=new g("number","",I=>typeof I=="number",I=>I)}static{this.String=new g("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=g.Arr(g.String)}static Arr(I){return new g(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,A=>Array.isArray(A)&&A.every($=>I.validate($)),A=>A.map($=>I.convert($)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",I=>I instanceof h.$eO,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",I=>I instanceof h.$DP,C.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",I=>I instanceof m.$BQ,C.TestItem.from)}constructor(I,A,$,v){this.name=I,this.description=A,this.validate=$,this.convert=v}optional(){return new g(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,A){return new g(I??this.name,A??this.description,this.validate,this.convert)}}e.$MQ=g;class E{static{this.Void=new E("no result",I=>I)}constructor(I,A){this.description=I,this.convert=A}}e.$NQ=E;class D{constructor(I,A,$,v,M){this.id=I,this.internalId=A,this.description=$,this.args=v,this.result=M}}e.$OQ=D}),define(ke[317],Ie([1,0,18,14,2,87,144,35,34,15,9]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,R=We(R),c=We(c),k=We(k);const y=[new b.$OQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new b.$OQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.$Kb)(a))return;class p extends k.$_N{static to(i){const s=new p(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new k.$5N(m[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map(p.to):[],s}}return a.map(p.to)})),new b.$OQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$MQ.Uri,new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$OQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$MQ.Uri,b.$MQ.Range,new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$OQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$MQ.Uri,b.$MQ.Position,new b.$MQ("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$OQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new b.$OQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new b.$OQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new b.$OQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new b.$OQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$MQ.Uri,new b.$MQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>k.$RN.isPosition(m)),a=>a.map(c.Position.from))],new b.$NQ("A promise that resolves to an array of ranges.",a=>a.map(m=>{let p;for(const f of m.reverse())p=new k.$dO(c.Range.to(f),p);return p}))),new b.$OQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$MQ.String.with("query","Search string")],new b.$NQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new b.$OQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new b.$OQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$MQ.CallHierarchyItem],new b.$NQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new b.$OQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$MQ.CallHierarchyItem],new b.$NQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new b.$OQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new b.$OQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("newName","The new symbol name")],new b.$NQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new b.$OQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$MQ.Uri,b.$MQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$NQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new b.$OQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$MQ.Uri],new b.$NQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new k.$_O(a.tokenTypes,a.tokenModifiers)})),new b.$OQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$MQ.Uri],new b.$NQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,T.$4db)(a);if(m.type==="full")return new k.$bP(m.data,void 0)})),new b.$OQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$MQ.Uri,b.$MQ.Range.optional()],new b.$NQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new k.$_O(a.tokenTypes,a.tokenModifiers)})),new b.$OQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$MQ.Uri,b.$MQ.Range],new b.$NQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,T.$4db)(a);if(m.type==="full")return new k.$bP(m.data,void 0)})),new b.$OQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$MQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$NQ("A promise that resolves to a CompletionList-instance.",(a,m,p)=>{if(!a)return new k.$pO([]);const f=a.suggestions.map(i=>c.CompletionItem.to(i,p));return new k.$pO(f,a.incomplete)})),new b.$OQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$NQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new b.$OQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$MQ.Uri,b.$MQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$NQ("A promise that resolves to an array of CodeLens-instances.",(a,m,p)=>P(f=>new k.$hO(c.Range.to(f.range),f.command&&p.fromInternal(f.command)))(a))),new b.$OQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$MQ.Uri,new b.$MQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>k.$SN.isRange(a),a=>k.$TN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),b.$MQ.String.with("kind","Code action kind to return code actions for").optional(),b.$MQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$NQ("A promise that resolves to an array of Command-instances.",(a,m,p)=>P(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(f.command)}else{const i=new k.$bO(f.title,f.kind?new k.$cO(f.kind):void 0);return f.edit&&(i.edit=c.WorkspaceEdit.to(f.edit)),f.command&&(i.command=p.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new b.$OQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new k.$vO(c.Range.to(m.range),c.Color.to(m.color))):[])),new b.$OQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$MQ("color","The color to show and insert",a=>a instanceof k.$uO,c.Color.from),new b.$MQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new b.$NQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new b.$OQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$MQ.Uri,b.$MQ.Range],new b.$NQ("A promise that resolves to an array of Inlay objects",(a,m,p)=>a.map(c.InlayHint.to.bind(void 0,p)))),new b.$OQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(c.FoldingRange.to)})),new b.$OQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$NQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new b.$OQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$MQ.Uri,b.$MQ.Range,new b.$MQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof k.$SN,a=>c.InlineValueContext.from(a))],new b.$NQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new b.$OQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$MQ("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,h.$Qg)(a,h.Schemas.http,h.Schemas.https),a=>a),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),b.$MQ.String.with("label","").optional()],b.$NQ.Void),new b.$OQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$MQ.Uri.with("resource","Resource to open"),b.$MQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],b.$NQ.Void),new b.$OQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$MQ.Uri.with("left","Left-hand side resource of the diff editor"),b.$MQ.Uri.with("right","Right-hand side resource of the diff editor"),b.$MQ.String.with("title","Human readable title for the diff editor").optional(),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],b.$NQ.Void),new b.$OQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$MQ.String.with("title","Human readable title for the changes editor"),new b.$MQ("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[p,f,i]=m;if(!C.URI.isUri(p)||!C.URI.isUri(f)&&f!==void 0&&f!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$NQ.Void),new b.$OQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$MQ.TypeHierarchyItem],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$MQ.TypeHierarchyItem],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$MQ.TestItem],b.$NQ.Void),new b.$OQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$MQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$NQ.Void),new b.$OQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$MQ.String.with("name","The context key name"),new b.$MQ("value","The context key value",()=>!0,a=>a)],b.$NQ.Void),new b.$OQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$MQ.Uri,b.$MQ.StringArray,new b.$MQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new b.$NQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new b.$OQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$MQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:k.$TN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],b.$NQ.Void)];class u{static register(m){y.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",O.$Fj)}}e.$Spc=u;function P(a){return m=>{if(Array.isArray(m))return m.map(a)}}function w(a){if(!Array.isArray(a))return;const m=[];for(const p of a)R.$Ou(p)?m.push(c.DefinitionLink.to(p)):m.push(c.location.to(p));return m}}),define(ke[318],Ie([1,0,2,34]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0;class C{constructor(T,O,b,c,k){this.a=O,this.b=b,this.c=c;const y=new h.$OQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$MQ("showOptions","Show Options",u=>!0,u=>u),new h.$MQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$MQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$MQ("title","Interactive editor title",u=>!0,u=>u)],new h.$NQ("Notebook and input URI",u=>{if(k.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return k.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return k.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(T,O,b,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:b,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$hrc=C}),define(ke[319],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=void 0,e.$qrc=g,P=We(P);let s=class{constructor(D,S,I,A,$){this.m=S,this.n=I,this.o=A,this.q=$,this.b=new O.$Bc,this.c=new O.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$ON.MainThreadNotebookKernels);const v=new u.$OQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$MQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],u.$NQ.Void),M=new u.$OQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$MQ.Uri],new u.$NQ("A promise that resolves to an array of variables",(N,L)=>N.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(M)}createNotebookController(D,S,I,A,$,v){for(const ne of this.j.values())if(ne.controller.id===S&&c.$sn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${S}`);const L=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${D.identifier}'`);let F=!1;const B=new R.$me,j=new R.$me,U={id:g(D.identifier,S),notebookType:I,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let z=$??L,ee,V;this.a.$addKernel(M,U).catch(ne=>{console.log(ne),F=!0});let W=0;const J=()=>{if(F)return;const ne=++W;Promise.resolve().then(()=>{ne===W&&this.a.$updateKernel(M,U)})},_=new O.$Bc,ce={get id(){return S},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ne){U.label=ne??D.displayName??D.name,J()},get detail(){return U.detail??""},set detail(ne){U.detail=ne,J()},get description(){return U.description??""},set description(ne){U.description=ne,J()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ne){U.supportedLanguages=ne,J()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){U.supportsExecutionOrder=ne,J()},get rendererScripts(){return U.preloads?U.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ne){z=ne??L},get interruptHandler(){return ee},set interruptHandler(ne){ee=ne,U.supportsInterrupt=!!ne,J()},set variableProvider(ne){(0,p.$jH)(D,"notebookVariableProvider"),V=ne,U.hasVariableProvider=!!ne,ne?.onDidChangeVariables(ye=>N.a.$variablesUpdated(ye.uri)),J()},get variableProvider(){return V},createNotebookCellExecution(ne){if(F)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,g(D.identifier,this.id))},createNotebookExecution(ne){if((0,p.$jH)(D,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,g(D.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${M}], DISPOSED`),F=!0,this.j.delete(M),B.dispose(),j.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ne,ye){ye===w.NotebookControllerAffinity2.Hidden&&(0,p.$jH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,ne.uri,ye)},onDidReceiveMessage:j.event,postMessage(ne,ye){return(0,p.$jH)(D,"notebookMessaging"),N.a.$postMessage(M,ye&&N.n.getIdByEditor(ye),ne)},asWebviewUri(ne){return(0,p.$jH)(D,"notebookMessaging"),(0,a.$PDb)(ne,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:ce,onDidReceiveMessage:j,onDidChangeSelection:B,associatedNotebooks:_}),ce}getIdByController(D){for(const[S,I]of this.j)if(I.controller===D)return g(I.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,S){const I=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(I,S);const $={dispose:()=>{this.f.delete(I),A.a.$removeKernelDetectionTask(I)}};return this.f.set(I,$),$}registerKernelSourceActionProvider(D,S,I){const A=this.i++,$=typeof I.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,I),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,S);let M;return $!==void 0&&(M=I.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent($))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),M?.dispose()}}}async $provideKernelSourceActions(D,S){const I=this.h.get(D);if(I){const A=new T.$Uc;return(await I.provideNotebookKernelSourceActions(S)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,S,I){const A=this.j.get(D);if(A){const $=this.n.getNotebookDocument(b.URI.revive(S));I?A.associatedNotebooks.set($.uri,!0):A.associatedNotebooks.delete($.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,$.uri.toString(),I),A.onDidChangeSelection.fire({selected:I,notebook:$.apiNotebook})}}async $executeCells(D,S,I){const A=this.j.get(D);if(!A)return;const $=this.n.getNotebookDocument(b.URI.revive(S)),v=[];for(const M of I){const N=$.getCell(M);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,$.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,$.apiNotebook,A.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,S,I){const A=this.j.get(D);if(!A)return;const $=this.n.getNotebookDocument(b.URI.revive(S));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,$.apiNotebook);else for(const v of I){const M=$.getCell(v);M&&this.b.get(M.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get($.uri);this.c.delete($.uri),I.length&&Array.isArray(v)&&v.length&&v.forEach(M=>M.dispose())}}async $provideVariables(D,S,I,A,$,v,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(b.URI.revive(I)),F=N.controller.variableProvider;if(!F)return;let B;if(A!==void 0){if(B=this.s[A],!B)return}else this.s={};const j=$==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,U=F.provideVariables(L.apiNotebook,B,j,v,M);let z=0;for await(const ee of U){if(M.isCancellationRequested)return;const V={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[V.id]=ee.variable,this.a.$receiveVariable(S,V),z++>=i.$4K)return}}$acceptKernelMessageFromRenderer(D,S,I){const A=this.j.get(D);if(!A)return;const $=this.n.getEditorById(S);A.onDidReceiveMessage.fire(Object.freeze({editor:$.apiEditor,message:I}))}$cellExecutionChanged(D,S,I){const $=this.n.getNotebookDocument(b.URI.revive(D)).getCell(S);if($){const v=I?P.NotebookCellExecutionState.to(I):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:$.apiCell,state:v})}}_createNotebookCellExecution(D,S){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const $=new o(S,A,this.a);this.b.set(A.uri,$);const v=$.onDidChangeState(()=>{$.state===t.Resolved&&($.dispose(),v.dispose(),this.b.delete(A.uri))});return $.asApiObject()}_createNotebookExecution(D,S){const I=this.n.getNotebookDocument(D.uri),A=D.getCells().find(M=>{const N=I.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const $=new d(S,I,this.a),v=$.onDidChangeState(()=>{$.state===n.Resolved&&($.dispose(),v.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[$,v]),$.asApiObject()}};e.$prc=s,e.$prc=s=Ze([Ve(4,k.$bk)],s);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class o extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(D,S,I){super(),this.m=S,this.n=I,this.b=o.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$xe),this.h=new l(10,A=>this.s(A)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const S=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new f.$2w(S))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let S=this.m;if(D&&(S=this.m.notebook.getCellFromApiCell(D)),!S)throw new Error("INVALID cell");return S.handle}y(D){return D.map(S=>{const I=w.$mP.ensureUniqueMimeTypes(S.items,!0);return I===S.items?P.NotebookCellOutput.from(S):P.NotebookCellOutput.from({items:I,id:S.id,metadata:S.metadata})})}async z(D,S,I){const A=this.w(S),$=this.y((0,r.$2b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:I,outputs:$})}async C(D,S,I){return D=w.$mP.ensureUniqueMimeTypes((0,r.$2b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:S.id,append:I})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(I){D.j=I,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(I){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,A,$){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=$?{message:$.message,stack:$.stack,location:$?.location?{startLineNumber:$.location.start.line,startColumn:$.location.start.character,endLineNumber:$.location.end.line,endColumn:$.location.end.character}:void 0,uri:$.uri}:void 0;D.n.$completeExecution(D.b,new f.$2w({runEndTime:A,lastRunSuccess:I,error:v}))},clearOutput(I){return D.t(),D.z([],I,!1)},appendOutput(I,A){return D.t(),D.z(I,A,!0)},replaceOutput(I,A){return D.t(),D.z(I,A,!1)},appendOutputItems(I,A){return D.t(),D.C(I,A,!0)},replaceOutputItems(I,A){return D.t(),D.C(I,A,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(D,S,I){super(),this.h=S,this.j=I,this.b=d.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,S){this.f=D,this.g=S,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$4h,this.b=Date.now(),(0,h.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>D.complete())}}function g(E,D){return`${E.value}/${D}`}}),define(ke[48],Ie([1,0,4,6,5,2,19,3,9,8,13,242,20,32,243,244,51,7,15,34,40]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=e.$wqc=e.$vqc=e.$uqc=void 0,e.$uqc=(0,C.$Gi)("IExtHostTerminalService");class t extends O.$Vc{constructor($,v,M,N){super(),this.u=$,this._id=v,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(F,B=!0){L.C(),L.u.$sendText(L._id,F,B)},show(F){L.C(),L.u.$show(L._id,F)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??v?.cwd??void 0,env:$.env??void 0,icon:D($.iconPath)??void 0,color:m.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z($.location,v?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,v,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(L)?L.id:void 0,location:v?.location||this.z($,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,v){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in $?{viewColumn:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,v){this.j=Object.freeze({code:$,reason:v})}setDimensions($,v){return $===this.f&&v===this.h||$===0||v===0?!1:(this.f=$,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(v=>{v!==$&&(this.b=Promise.resolve($))})}}e.$vqc=t;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new r.$me,this.onProcessData=this.a.event,this.b=new r.$me,this.d=new r.$me,this.onDidChangeProperty=this.d.event,this.f=new r.$me,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,v){this.g.setDimensions?.({columns:$,rows:v})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends O.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,v,M){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$me,this.onDidCloseTerminal=this.H.event,this.I=new r.$me,this.onDidOpenTerminal=this.I.event,this.J=new r.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$me,this.onDidChangeTerminalState=this.M.event,this.N=new r.$me,this.onDidChangeShell=this.N.event,this.O=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(h.$ON.MainThreadTerminalService),this.y=new a.$5xb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:N=>{const L=F=>{const B=F;return this.getTerminalById(B.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let F=0;F<N.length&&N[F].$mid===s.MarshalledId.TerminalContext;F++)N[F]=L(N[F]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,v){const M=new t(this.a,(0,P.$3g)(),$,$.name),N=new o($.pty);return M.createExtensionTerminal($.location,v,this.R($,v).resolvedExtHostIdentifier,D($.iconPath),S($.color)).then(L=>{const F=this.S(L,N);this.h[L]=F}),this.f.push(M),M.value}R($,v){if(v=v||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const M=$.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(v.resolvedExtHostIdentifier=N._id)}}else $.location&&typeof $.location!="object"?v.location=$.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal($,v){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const N=new o(v),L=this.S($,N);this.h[$]=L}async $acceptActiveTerminalChanged($){const v=this.b;if($===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById($);M&&(this.b=M,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,v){const M=this.getTerminalById($);M&&this.O.fire({terminal:M.value,data:v})}async $acceptTerminalDimensions($,v,M){const N=this.getTerminalById($);N&&N.setDimensions(v,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand($,v){const M=this.getTerminalById($);M&&this.P.fire({terminal:M.value,...v})}async $acceptTerminalMaximumDimensions($,v,M){this.g.get($)?.resize(v,M)}async $acceptTerminalTitleChange($,v){const M=this.getTerminalById($);M&&(M.name=v)}async $acceptTerminalClosed($,v,M){const N=this.X(this.f,$);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(v,M),this.H.fire(L.value)}}$acceptTerminalOpened($,v,M,N){if(v){const B=this.X(this.f,v);if(B!==null){this.f[B]._id=$,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},F=new t(this.a,$,L,M);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId($,v){this.getTerminalById($)?._setProcessId(v)}async $startExtensionTerminal($,v){const M=this.getTerminalById($);if(!M)return{message:(0,c.localize)(2701,null,$)};M.isOpen||await new Promise(L=>{const F=this.onDidOpenTerminal(async B=>{B===M.value&&(F.dispose(),L())})});const N=this.g.get($);N?N.startSendingEvents(v):this.j[$]={initialDimensions:v}}S($,v){const M=new O.$Uc;M.add(v.onProcessReady(L=>this.a.$sendProcessReady($,L.pid,L.cwd,L.windowsPty))),M.add(v.onDidChangeProperty(L=>this.a.$sendProcessProperty($,L))),this.y.startBuffering($,v.onProcessData),M.add(v.onProcessExit(L=>this.U($,L))),this.g.set($,v);const N=this.j[$];return N&&v instanceof o&&(v.startSendingEvents(N.initialDimensions),delete this.j[$]),M}$acceptProcessAckDataEvent($,v){this.g.get($)?.acknowledgeDataEvent(v)}$acceptProcessInput($,v){this.g.get($)?.input(v)}$acceptTerminalInteraction($){const v=this.getTerminalById($);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection($,v){this.getTerminalById($)?.setSelection(v)}$acceptProcessResize($,v,M){try{this.g.get($)?.resize(v,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown($,v){this.g.get($)?.shutdown(v)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(v=>this.a.$sendProcessProperty($,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(v=>this.a.$sendProcessProperty($,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new b.$QN(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,v,M){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,M),this.a.$registerProfileProvider(v,$.identifier.value),new b.$QN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider($,v,M){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,M),this.a.$registerQuickFixProvider($,v),new b.$QN(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,v){const M=new u.$xe().token;if(M.isCancellationRequested)return;const N=this.D.get($);if(!N)return;const L=await N.provideTerminalQuickFixes(v,M);if(L===null||Array.isArray(L)&&L.length===0)return;const F=new O.$Uc;if(this.w.value=F,!Array.isArray(L))return L?f.TerminalQuickFix.from(L,this.Q.converter,F):void 0;const B=[];for(const j of L){const U=f.TerminalQuickFix.from(j,this.Q.converter,F);U&&B.push(U)}return B}async $createContributedProfileTerminal($,v){const M=new u.$xe().token;let N=await this.C.get($)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks($,v){const M=this.getTerminalById($);if(!M)return[];this.F.delete($),this.G.get($)?.dispose(!0);const L=new u.$xe;this.G.set($,L);const F=[],B={terminal:M.value,line:v},j=[];for(const ee of this.z)j.push(p.Promises.withAsyncBody(async V=>{L.token.onCancellationRequested(()=>V({provider:ee,links:[]}));const W=await ee.provideTerminalLinks(B,L.token)||[];L.token.isCancellationRequested||V({provider:ee,links:W})}));const U=await Promise.all(j);if(L.token.isCancellationRequested)return[];const z=new Map;for(const ee of U)ee&&ee.links.length>0&&F.push(...ee.links.map(V=>{const W={id:n++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return z.set(W.id,{provider:ee.provider,link:V}),W}));return this.F.set($,z),F}$activateLink($,v){const M=this.F.get($)?.get(v);M&&M.provider.handleTerminalLink(M.link)}U($,v){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const M=this.h[$];M&&(M.dispose(),delete this.h[$]),this.a.$sendProcessExit($,v)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const v=this.f.findIndex(M=>M.value===$);return v>=0?v:null}W($,v){const M=this.X($,v);return M!==null?$[M]:null}X($,v){const M=$.findIndex(N=>N._id===v);return M>=0?M:null}getEnvironmentVariableCollection($){let v=this.n.get($.identifier.value);return v||(v=this.B(new l),this.Z($.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y($,v){const M=(0,y.$Is)(v.map),N=(0,y.$Js)(v.descriptionMap);this.a.$setEnvironmentVariableCollection($,v.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections($){$.forEach(v=>{const M=v[0],N=this.B(new l(v[1]));this.Z(M,N)})}$acceptDefaultProfile($,v){const M=this.s;this.s=$,this.u=v,M?.path!==$.path&&this.N.fire($.path)}Z($,v){this.n.set($,v),this.B(v.onDidChangeCollection(()=>{this.Y($,v)}))}};e.$wqc=d,e.$wqc=d=Ze([Ve(1,i.$KQ),Ve(2,T.$oQ)],d);class l extends O.$Vc{get persistent(){return this.b}set persistent($){this.b=$,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor($){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$me,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const v=this.j($);let M=this.a.get(v);return M||(M=new g(this,$),this.a.set(v,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace($,v,M,N){this.g($,{value:v,type:b.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append($,v,M,N){this.g($,{value:v,type:b.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend($,v,M,N){this.g($,{value:v,type:b.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g($,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h($,v.scope),N=this.map.get(M),L=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const F=this.h($,v.scope),B={variable:$,...v,options:L};this.map.set(F,B),this.f.fire()}}get($,v){const M=this.h($,v),N=this.map.get(M);return N?I(N):void 0}h($,v){const M=this.j(v);return M.length?`${$}:::${M}`:$}j($){return this.m($?.workspaceFolder)??""}m($){return $?$.uri.toString():void 0}getVariableMap($){const v=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j($)&&v.set(N.variable,I(N));return v}delete($,v){const M=this.h($,v);this.map.delete(M),this.f.fire()}clear($){if($?.workspaceFolder){for(const[v,M]of this.map)M.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(v);this.n($)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription($,v){const M=this.j(v),N=this.descriptionMap.get(M);if(!N||N.description!==$){let L;typeof $=="string"?L=$:L=$?.value.split(`

`)[0];const F={description:L,scope:v};this.descriptionMap.set(M,F),this.f.fire()}}getDescription($){const v=this.j($);return this.descriptionMap.get(v)?.description}n($){const v=this.j($);this.descriptionMap.delete(v)}}class g{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,v){this.b=$,this.d=v,this.a=new r.$me}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,v,M){this.b.replace($,v,M,this.d)}append($,v,M){this.b.append($,v,M,this.d)}prepend($,v,M){this.b.prepend($,v,M,this.d)}get($){return this.b.get($,this.d)}forEach($,v){this.b.getVariableMap(this.d).forEach((M,N)=>$.call(v,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor($,v){super(!1,$,v)}createTerminal($,v,M){throw new k.$_}createTerminalFromOptions($,v){throw new k.$_}};e.$xqc=E,e.$xqc=E=Ze([Ve(0,i.$KQ),Ve(1,T.$oQ)],E);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function S(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function I(A){const $={...A};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[170],Ie([1,0,9,3,5,6,19,48,4,2,7]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=void 0,e.$Hrc=(0,C.$Gi)("IExtHostTerminalShellIntegration");let y=class extends h.$Vc{constructor(m,p){super(),this.h=p,this.b=new Map,this.c=new b.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(R.$ON.MainThreadTerminalShellIntegration),this.B((0,h.$Tc)(()=>{for(const[f,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const p=this.h.getTerminalById(m);if(!p)return;const f=p.value;let i=this.b.get(m);i||(i=new u(p.value,this.f),this.b.set(m,i),i.store.add(p.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),p.shellIntegration=i.value),this.c.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,p,f,i,s){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:p,confidence:f,isTrusted:i};this.b.get(m)?.startShellExecution(t,c.URI.revive(s))}$shellExecutionEnd(m,p,f,i,s){const t={value:p,confidence:f,isTrusted:i};this.b.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,p){this.b.get(m)?.emitData(p)}$cwdChange(m,p){this.b.get(m)?.setCwd(c.URI.revive(p))}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$Irc=y,e.$Irc=y=Ze([Ve(0,T.$oQ),Ve(1,O.$uqc)],y);class u extends h.$Vc{get currentExecution(){return this.a}constructor(m,p){super(),this.j=m,this.m=p,this.b=!1,this.store=this.B(new h.$Uc),this.f=this.B(new b.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$me),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f.c,!0).value;return f.b=!0,n}}}startShellExecution(m,p,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P(m,p??this.c);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,p){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:p}),this.a=void 0)}setCwd(m){let p=!1;c.URI.isUri(this.c)?p=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&(p=!0),p&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,p){this.c=m,this.cwd=p,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return k.$7h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new k.$Fh);const m=this.a;return new k.$7h(async f=>{this.b.push(f),await m.wait()})}emitData(m){for(const p of this.b)p.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[171],Ie([1,0,65,13,133,15,9]),function($e,e,r,h,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=void 0,R=We(R);class O{static{this.c=new C.$tQ("TextEditorDecorationType")}constructor(u,P,w){const a=O.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$vQ=O;class b{constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let w=null;if(u instanceof T.$RN)w=new T.$SN(u,u);else if(u instanceof T.$SN)w=u;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(u,P){this.k(),this.l(new T.$SN(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof T.$SN)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,w){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,h.$7)("endOfLine");this.h=u}}class c{constructor(u,P,w,a){this.c=u,this.d=P,this._accept(w),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(p){m.n(p)},get indentSize(){return m.g},set indentSize(p){m.p(p)},get insertSpaces(){return m.j},set insertSpaces(p){m.s(p)},get cursorStyle(){return m.k},set cursorStyle(p){m.t(p)},get lineNumbers(){return m.l},set lineNumbers(p){m.u(p)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$wQ=c;class k{constructor(u,P,w,a,m,p,f,i){this.id=u,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,p,w),this.e=f,this.f=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$9("document")},get selection(){return s.c&&s.c[0]},set selection(t){if(!(t instanceof T.$TN))throw(0,h.$7)("selection");s.c=[t],s.l()},get selections(){return s.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof T.$TN)))throw(0,h.$7)("selections");s.c=t,s.l()},get visibleRanges(){return s.e},set visibleRanges(t){throw new h.$9("visibleRanges")},get options(){return s.d.value},set options(t){s.g||s.d.assign(t)},get viewColumn(){return s.f},set viewColumn(t){throw new h.$9("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new b(a.value,o);return t(n),s.m(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!o||Array.isArray(o)&&o.length===0)d=s.c.map(l=>R.Range.from(l));else if(o instanceof T.$RN){const{lineNumber:l,column:g}=R.Position.from(o);d=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(o instanceof T.$SN)d=[R.Range.from(o)];else{d=[];for(const l of o)if(l instanceof T.$SN)d.push(R.Range.from(l));else{const{lineNumber:g,column:E}=R.Position.from(l);d.push({startLineNumber:g,startColumn:E,endLineNumber:g,endColumn:E})}}return P.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,o){const n=o.length===0;n&&!s.h.has(t.key)||(n?s.h.delete(t.key):s.h.add(t.key),s.n(()=>{if(R.$lQ(o))return P.$trySetDecorations(u,t.key,R.$mQ(o));{const d=new Array(4*o.length);for(let l=0,g=o.length;l<g;l++){const E=o[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return P.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,o){s.n(()=>P.$tryRevealRange(u,R.Range.from(t),o||T.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){P.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map(m=>m.range);w.sort((m,p)=>m.end.line===p.end.line?m.end.character===p.end.character?m.start.line===p.start.line?m.start.character-p.start.character:m.start.line-p.start.line:m.end.character-p.end.character:m.end.line-p.end.line);for(let m=0,p=w.length-1;m<p;m++){const f=w[m].end;if(w[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$xQ=k}),define(ke[63],Ie([1,0,65,4,3,2,5,6,167,19,171,15,11,28,14,39,50]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0,r=We(r),y=We(y);class p{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,t){this.h=s,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Bc,this.d=new h.$me,this.e=new h.$me,this.f=new h.$me,this.g=new h.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=R.URI.revive(d),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=R.URI.revive(d.uri);let g=this.c.get(l);if(g&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new p(new b.$rQ(this.h.getProxy(O.$ON.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=R.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const g=this.c.get(l).value,E=new k.$xQ(d.id,this.h.getProxy(O.$ON.MainThreadTextEditors),this.i,new m.$U(()=>g.document),d.selections.map(y.Selection.to),d.options,d.visibleRanges.map(D=>y.Range.to(D)),typeof d.editorPosition=="number"?y.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,C.$Qc)(t),(0,C.$Qc)(n),s.removedDocuments&&this.e.fire(t),s.addedDocuments&&this.d.fire(o),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const t=this.b.get(this.a);return s?t:t?.value}allEditors(){return[...this.b.values()]}};e.$yQ=f,e.$yQ=f=Ze([Ve(0,c.$oQ),Ve(1,u.$bk)],f),e.$zQ=(0,T.$Gi)("IExtHostDocumentsAndEditors")}),define(ke[98],Ie([1,0,7,21,20,4,79,60,3,40,17,2,32,5,11,6,34,63,19,169,15,9,264,73,120,74,25]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Rqc=e.$Qqc=e.$Pqc=e.$Oqc=void 0,s=We(s);let E=0;const D=new WeakMap;e.$Oqc=(0,P.$Gi)("IExtHostTesting");let S=class extends b.$Vc{constructor(W,J,_,ce){super(),this.C=J,this.D=_,this.F=ce,this.f=this.B(new R.$me),this.g=new Map,this.w=this.B(new R.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=W.getProxy(a.$ON.MainThreadTesting),this.m=new B(this.h),this.j=new v(this.h,J),_.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case c.MarshalledId.TestItemContext:{const ye=ne,ge=ye.tests[ye.tests.length-1].item.extId;return this.g.get(n.$$I.root(ge))?.collection.tree.get(ge)?.actual??(0,i.$AQ)(ne)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ye,message:ge}=ne,Y=ye.item.extId;return{test:this.g.get(n.$$I.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$AQ)({$mid:c.MarshalledId.TestItemContext,tests:[ye]}),message:s.TestMessage.to(ge)}}default:return ne}}}),_.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await _.executeCommand(o.TestCommandId.GetExplorerSelection),ye=ge=>{const Y=this.g.get(n.$$I.root(ge));if(Y)return n.$$I.isRoot(ge)?Y.controller:Y.collection.tree.get(ge)?.actual};return{include:ne?.include.map(ye).filter(k.$ng)||[],exclude:ne?.exclude.map(ye).filter(k.$ng)||[]}})}createTestController(W,J,_,ce){if(this.g.has(J))throw new Error(`Attempt to insert a duplicate controller with ID "${J}"`);const ne=new b.$Uc,ye=ne.add(new i.$DQ(J,_,this.F));ye.root.label=_;const ge=new Map,Y=new Set,q=this.h,oe=()=>{let ae=0;ce&&(ae|=l.TestControllerCapability.Refresh);const se=ie.relatedCodeProvider;return se&&(se?.provideRelatedTests&&(ae|=l.TestControllerCapability.TestRelatedToCode),se?.provideRelatedCode&&(ae|=l.TestControllerCapability.CodeRelatedToTest)),ae},ve={items:ye.root.children,get label(){return _},set label(ae){_=ae,ye.root.label=ae,q.$updateController(J,{label:_})},get refreshHandler(){return ce},set refreshHandler(ae){ce=ae,q.$updateController(J,{capabilities:oe()})},get id(){return J},get relatedCodeProvider(){return ie.relatedCodeProvider},set relatedCodeProvider(ae){(0,g.$jH)(W,"testRelatedCode"),ie.relatedCodeProvider=ae,q.$updateController(J,{capabilities:oe()})},createRunProfile:(ae,se,X,re,pe,we)=>{let Me=(0,O.$uj)(ae);for(;ge.has(Me);)Me++;return new U(this.h,ge,Y,this.w.event,J,Me,ae,se,X,re,pe,we)},createTestItem(ae,se,X){return new i.$BQ(J,ae,se,X)},createTestRun:(ae,se,X=!0)=>this.j.createTestRun(W,J,ye,ae,se,X),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const se=ae instanceof Array?ae:[ae];this.h.$markTestRetired(se.map(X=>n.$$I.fromExtHostTestItem(X,J).toString()))}},set resolveHandler(ae){ye.resolveHandler=ae},get resolveHandler(){return ye.resolveHandler},dispose:()=>{ne.dispose()}},ie={controller:ve,collection:ye,profiles:ge,extension:W,activeProfiles:Y};return q.$registerTestController(J,_,oe()),ne.add((0,b.$Tc)(()=>q.$unregisterTestController(J))),this.g.set(J,ie),ne.add((0,b.$Tc)(()=>this.g.delete(J))),ne.add(ye.onDidGenerateDiff(ae=>q.$publishDiff(J,ae.map(l.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(W,J=C.CancellationToken.None){const _=M(W);if(!_)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(_.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:W.preserveFocus??!0,group:z[_.kind],targets:[{testIds:W.include?.map(ne=>n.$$I.fromExtHostTestItem(ne,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:_.profileId,controllerId:_.controllerId}],exclude:W.exclude?.map(ne=>ne.id)},J)}registerTestFollowupProvider(W){return this.y.add(W),{dispose:()=>{this.y.delete(W)}}}async $getTestsRelatedToCode(W,J,_){const ce=this.F.getDocument(y.URI.revive(W));if(!ce)return[];const ne=s.Position.to(J),ye=[];return await Promise.all([...this.g.values()].map(async ge=>{let Y;try{Y=await ge.relatedCodeProvider?.provideRelatedTests?.(ce.document,ne,_)}catch(q){_.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${ge.controller.label}`,q)}if(Y){for(const q of Y)ye.push(n.$$I.fromExtHostTestItem(q,ge.controller.id).toString());ge.collection.flushDiff()}})),ye}async $getCodeRelatedToTest(W,J){const _=this.g.get(n.$$I.root(W));if(!_)return[];const ce=_.collection.tree.get(W);return ce?(await _.relatedCodeProvider?.provideRelatedCode?.(ce.actual,J))?.map(s.location.from)??[]:[]}$syncTests(){for(const{collection:W}of this.g.values())W.flushDiff();return Promise.resolve()}async $getCoverageDetails(W,J,_){return(await this.j.getCoverageDetails(W,J,_))?.map(s.TestCoverage.fromDetails)}async $disposeRun(W){this.j.disposeTestRun(W)}$configureRunProfile(W,J){this.g.get(W)?.profiles.get(J)?.configureHandler?.()}$setDefaultRunProfiles(W){const J=new Map;for(const[_,ce]of Object.entries(W)){const ne=this.g.get(_);if(!ne)continue;const ye=new Map,ge=ce.filter(q=>!ne.activeProfiles.has(q)),Y=[...ne.activeProfiles].filter(q=>!ce.includes(q));for(const q of ge)ye.set(q,!0),ne.activeProfiles.add(q);for(const q of Y)ye.set(q,!1),ne.activeProfiles.delete(q);ye.size&&J.set(_,ye)}this.w.fire(J)}async $refreshTests(W,J){await this.g.get(W)?.controller.refreshHandler?.(J)}$publishTestResults(W){this.results=Object.freeze(W.map(J=>{const _=s.TestResults.to(J);return D.set(_,J.id),_}).concat(this.results).sort((J,_)=>_.completedAt-J.completedAt).slice(0,32)),this.f.fire()}async $expandTest(W,J){const _=this.g.get(n.$$I.fromString(W).controllerId)?.collection;_&&(await _.expand(W,J<0?1/0:J),_.flushDiff())}$acceptDiff(W){this.m.applyDiff(W.map(J=>l.TestsDiffOp.deserialize({asCanonicalUri:_=>_},J)))}async $runControllerTests(W,J){return Promise.all(W.map(_=>this.G(_,!1,J)))}async $startContinuousRun(W,J){const _=new C.$xe(J),ce=await Promise.all(W.map(ne=>this.G(ne,!0,_.token)));return!J.isCancellationRequested&&!ce.some(ne=>ne.error)&&await new Promise(ne=>J.onCancellationRequested(ne)),_.dispose(!0),ce}async $provideTestFollowups(W,J){const _=this.results.find(ye=>D.get(ye)===W.resultId),ce=_&&ee(n.$$I.fromString(W.extId),_?.results);if(!ce)return[];let ne=[];return await Promise.all([...this.y].map(async ye=>{try{const ge=await ye.provideFollowup(_,ce,W.taskIndex,W.messageIndex,J);ge&&(ne=ne.concat(ge))}catch(ge){this.C.error("Error thrown while providing followup for test message",ge)}})),J.isCancellationRequested?[]:ne.map(ye=>{const ge=E++;return this.z.set(ge,ye),{title:ye.title,id:ge}})}$disposeTestFollowups(W){for(const J of W)this.z.delete(J)}$executeTestFollowup(W){const J=this.z.get(W);return J?this.D.executeCommand(J.command,...J.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(W,J){W===void 0?this.j.cancelAllRuns():this.j.cancelRunById(W,J)}getMetadataForRun(W){for(const J of this.j.trackers){const _=J.getTaskIdForRun(W);if(_)return{taskId:_,runId:J.id}}}async G(W,J,_){const ce=this.g.get(W.controllerId);if(!ce)return{};const{collection:ne,profiles:ye,extension:ge}=ce,Y=ye.get(W.profileId);if(!Y)return{};const q=W.testIds.map(ae=>ne.tree.get(ae)).filter(k.$ng),oe=W.excludeExtIds.map(ae=>ce.collection.tree.get(ae)).filter(k.$ng).filter(ae=>q.some(se=>se.fullId.compare(ae.fullId)===n.TestPosition.IsChild));if(!q.length)return{};const ve=new t.$tP(q.some(ae=>ae.actual instanceof i.$CQ)?void 0:q.map(ae=>ae.actual),oe.map(ae=>ae.actual),Y,J),ie=(0,l.$bJ)(W)&&this.j.prepareForMainThreadTestRun(ge,ve,N.fromInternal(W,ce.collection),Y,_);try{return await Y.runHandler(ve,_),{}}catch(ae){return{error:String(ae)}}finally{ie&&ie.hasRunningTasks&&!_.isCancellationRequested&&await R.Event.toPromise(ie.onEnd)}}};e.$Pqc=S,e.$Pqc=S=Ze([Ve(0,f.$oQ),Ve(1,w.$bk),Ve(2,m.$KQ),Ve(3,p.$zQ)],S);const I=1e4;var A;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(A||(A={}));class $ extends b.$Vc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(W,J,_,ce,ne,ye){super(),this.C=W,this.D=J,this.F=_,this.G=ce,this.H=ne,this.f=A.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new R.$me),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new C.$xe(ye));const ge=this.B(new r.$Sh(()=>this.I(),I));this.B(this.m.token.onCancellationRequested(()=>ge.schedule()));const Y=new R.$me;this.y=Y.event,this.B((0,b.$Tc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(W){for(const[J,{run:_}]of this.h)if(_===W)return J}cancel(W){W?this.h.get(W)?.cts.cancel():this.f===A.Running?(this.m.cancel(),this.f=A.Cancelling):this.f===A.Cancelling&&this.I()}async getCoverageDetails(W,J,_){const[,ce]=n.$$I.fromString(W).path,ne=this.z.get(W);if(!ne)return[];const{report:ye,extIds:ge}=ne,Y=this.h.get(ce);if(!Y)throw new Error("unreachable: run task was not found");let q;if(J&&ye instanceof t.$zP){const ve=ge.indexOf(J);if(ve===-1)return[];q=ye.fromTests[ve]}return await(q?this.G?.loadDetailedCoverageForTest?.(Y.run,ye,q,_):this.G?.loadDetailedCoverage?.(Y.run,ye,_))??[]}createRun(W){const J=this.C.id,_=this.C.controllerId,ce=(0,u.$3g)(),ne=oe=>(ve,...ie)=>{if(ge){this.F.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.L(ve),oe(ve,...ie)},ye=(oe,ve)=>{const ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(oe.uri&&oe.range){const ae={range:s.Range.from(oe.range),uri:oe.uri};for(const se of ie)se.location=se.location||ae}this.D.$appendTestMessagesInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),ie)};let ge=!1;const Y=this.B(new C.$xe(this.m.token)),q={isPersisted:this.C.isPersisted,token:Y.token,name:W,onDidDispose:this.y,addCoverage:oe=>{if(ge)return;const ve=oe instanceof t.$zP?oe.fromTests:[];if(ve.length){(0,g.$jH)(this.H,"attributableCoverage");for(const se of ve)this.L(se)}const ie=oe.uri.toString(),ae=new n.$$I([J,ce,ie]).toString();this.z.set(ae,{report:oe,extIds:ve.map(se=>n.$$I.fromExtHostTestItem(se,_).toString())}),this.D.$appendCoverage(J,ce,s.TestCoverage.fromFile(_,ae,oe))},enqueued:ne(oe=>{this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Queued)}),skipped:ne(oe=>{this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Skipped)}),started:ne(oe=>{this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Running)}),errored:ne((oe,ve,ie)=>{ye(oe,ve),this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Errored,ie)}),failed:ne((oe,ve,ie)=>{ye(oe,ve),this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Failed,ie)}),passed:ne((oe,ve)=>{this.D.$updateTestStateInRun(J,ce,n.$$I.fromExtHostTestItem(oe,this.C.controllerId).toString(),l.TestResultState.Passed,ve)}),appendOutput:(oe,ve,ie)=>{ge||(ie&&this.L(ie),this.D.$appendOutputToRun(J,ce,h.$Oe.fromString(oe),ve&&s.location.from(ve),ie&&n.$$I.fromExtHostTestItem(ie,_).toString()))},end:()=>{ge||(ge=!0,this.D.$finishedTestRunTask(J,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:q,cts:Y}),this.D.$startedTestRunTask(J,{id:ce,ctrlId:this.C.controllerId,name:W||this.H.displayName||this.H.identifier.value,running:!0}),q}I(){for(const{run:W}of this.h.values())W.end()}J(){this.f!==A.Ended&&(this.f=A.Ended,this.w.fire())}L(W){if(!(W instanceof i.$BQ))throw new d.$gQ(W.id);if(this.j.has(n.$$I.fromExtHostTestItem(W,this.C.controllerId).toString()))return;const J=[],_=this.C.colllection.root;for(;;){const ce=s.TestItem.from(W);if(J.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),W===_))break;W=W.parent||_}this.D.$addTestsToRun(this.C.controllerId,this.C.id,J)}dispose(){this.J(),super.dispose()}}class v{get trackers(){return this.f.values()}constructor(W,J){this.h=W,this.j=J,this.f=new Map,this.g=new Map}getCoverageDetails(W,J,_){const ce=n.$$I.root(W);return this.g.get(ce)?.getCoverageDetails(W,J,_)||[]}disposeTestRun(W){this.g.get(W)?.dispose(),this.g.delete(W);for(const[J,{id:_}]of this.f)_===W&&this.f.delete(J)}prepareForMainThreadTestRun(W,J,_,ce,ne){return this.k(J,_,ce,W,ne)}cancelRunById(W,J){this.g.get(W)?.cancel(J)}cancelAllRuns(){for(const W of this.f.values())W.cancel()}createTestRun(W,J,_,ce,ne,ye){const ge=this.f.get(ce);if(ge)return ge.createRun(ne);const Y=N.fromPublic(J,_,ce,ye),q=M(ce);this.h.$startedExtensionTestRun({controllerId:J,continuous:!!ce.continuous,profile:q&&{group:z[q.kind],id:q.profileId},exclude:ce.exclude?.map(ve=>n.$$I.fromExtHostTestItem(ve,_.root.id).toString())??[],id:Y.id,include:ce.include?.map(ve=>n.$$I.fromExtHostTestItem(ve,_.root.id).toString())??[_.root.id],preserveFocus:ce.preserveFocus??!0,persist:ye});const oe=this.k(ce,Y,ce.profile,W);return R.Event.once(oe.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),oe.createRun(ne)}k(W,J,_,ce,ne){const ye=new $(J,this.h,this.j,_,ce,ne);return this.f.set(W,ye),this.g.set(ye.id,ye),ye}}e.$Qqc=v;const M=V=>{if(V.profile){if(!(V.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class N{static fromPublic(W,J,_,ce){return new N(W,(0,u.$3g)(),ce,J)}static fromInternal(W,J){return new N(W.controllerId,W.runId,!0,J)}constructor(W,J,_,ce){this.controllerId=W,this.id=J,this.isPersisted=_,this.colllection=ce}}e.$Rqc=N;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(W){this.k=W,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(W){this.f.add(W)}update(W){Object.assign(W.revived,s.TestItem.toPlain(W.item)),this.f.has(W)||this.g.add(W)}remove(W){if(this.f.has(W)){this.f.delete(W);return}this.g.delete(W);const J=n.$$I.parentId(W.item.extId);if(J&&this.j.has(J.toString())){this.j.add(W.item.extId);return}this.h.add(W)}getChangeEvent(){const{f:W,g:J,h:_}=this;return{get added(){return[...W].map(ce=>ce.revived)},get updated(){return[...J].map(ce=>ce.revived)},get removed(){return[..._].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class F extends l.$hJ{constructor(){super(...arguments),this.z=new R.$me,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(W){return this.g.get(W)}getMirroredTestDataByReference(W){return this.g.get(W.id)}y(W,J){return{...W,revived:s.TestItem.toPlain(W.item),depth:J?J.depth+1:0,children:new Set}}x(){return new L(this.z)}}class B{constructor(W){this.g=W}checkout(){this.f||(this.f=this.h());const W=this.f;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(J=>J.revived)},dispose:(0,T.$db)(()=>{--W.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(W){return this.f?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.f?.tests.apply(W)}h(){const W=new F({asCanonicalUri:J=>J});return this.g.$subscribeToDiffs(),{observers:0,tests:W}}}const j=(V,W,J,_)=>{J?Object.assign(J,_):W.$updateTestRunConfig(V.controllerId,V.profileId,_)};class U{#e;#t;#i;#n;#s;get label(){return this.g}set label(W){W!==this.g&&(this.g=W,j(this,this.#e,this.#n,{label:W}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(W){W!==this.h&&(this.h=W,j(this,this.#e,this.#n,{supportsContinuousRun:W}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(W){W!==this.isDefault&&(W?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,j(this,this.#e,this.#n,{tag:W?s.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this.f}set configureHandler(W){W!==this.f&&(this.f=W,j(this,this.#e,this.#n,{hasConfigurationHandler:!!W}))}get onDidChangeDefault(){return R.Event.chain(this.#i,W=>W.map(J=>J.get(this.controllerId)?.get(this.profileId)).filter(k.$ng))}constructor(W,J,_,ce,ne,ye,ge,Y,q,oe=!1,ve=void 0,ie=!1){this.controllerId=ne,this.profileId=ye,this.g=ge,this.kind=Y,this.runHandler=q,this._tag=ve,this.h=ie,this.#e=W,this.#s=J,this.#t=_,this.#i=ce,J.set(ye,this);const ae=z[Y];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);oe&&_.add(ye),this.#n={profileId:ye,controllerId:ne,tag:ve?s.TestTag.namespace(this.controllerId,ve.id):null,label:ge,group:ae,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:ie},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Sqc=U;const z={[t.TestRunProfileKind.Coverage]:l.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:l.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:l.TestRunProfileBitset.Run};function ee(V,W){for(let J=0;J<V.path.length;J++){const _=W.find(ce=>ce.id===V.path[J]);if(!_)return;if(J===V.path.length-1)return _;W=_.children}}}),define(ke[320],Ie([1,0,18,4,3,6,171,15,9]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,r=We(r),O=We(O);class c extends C.$Vc{constructor(y,u){super(),this.m=u,this.a=new h.$me,this.b=new h.$me,this.c=new h.$me,this.f=new h.$me,this.g=new h.$me,this.h=new h.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(R.$ON.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(P=>P.value)}async showTextDocument(y,u,P){let w;typeof u=="number"?w={position:O.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?w={position:O.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?O.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(y.uri,w),m=a&&this.m.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new T.$vQ(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const P=this.m.getEditor(y);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(O.Selection.to);P._acceptSelections(w)}if(u.visibleRanges){const w=r.$Hb(u.visibleRanges.map(O.Range.to));P._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:O.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=b.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(O.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Hb(u.visibleRanges.map(O.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(y){for(const u in y){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const w=O.ViewColumn.to(y[u]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Zpc=c}),define(ke[321],Ie([1,0,2,5,6,3,9,15,23,40,17]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrc=e.$Krc=void 0,e.$Krc=(0,h.$Gi)("IExtHostTimeline");class y{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$ON.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,p)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&b.$sn.equals(p,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(w,a,m,p){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),m,p)}registerTimelineProvider(w,a,m,p){const f=new R.$Uc,i=this.d(a.id,p,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(o,n,d){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(o,n,d);if(l==null)return;const g=i(o,n);return{...l,source:a.id,items:l.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}d(w,a,m){return(p,f)=>{let i;if(f?.cacheResults){let s=this.c.get(w);s===void 0&&(s=new Map,this.c.set(w,s));const t=u(p);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${w}|${s.id??s.timestamp}`;i?.set(n,s);let d,l,g;s.iconPath&&(t instanceof T.$PO?g={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return T.$iO.isMarkdownString(o.tooltip)?E=O.MarkdownString.from(o.tooltip):(0,k.$fg)(o.tooltip)?E=o.tooltip:T.$iO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=O.MarkdownString.from(o.detail)):(0,k.$fg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=o.detail),{...o,id:o.id??void 0,handle:n,source:w,command:s.command?a.toInternal(s.command,m):void 0,icon:d,iconDark:l,themeIcon:g,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,R.$Tc)(()=>{for(const p of this.c.values())p.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Lrc=y;function u(P){return P?.toString()}}),define(ke[322],Ie([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,210,25]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=void 0,c=We(c);function p(s,t){if((0,k.$fg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends T.$Vc{constructor(t,o,n){super(),this.f=t,this.g=o,this.h=n,this.a=new Map,this.b=new a.$T_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>d(g)?this.r(g):g):l})}registerTreeDataProvider(t,o,n){const d=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>d.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=o.dragAndDropController?.dropMimeTypes??[],l=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,E=!!o.dragAndDropController?.handleDrop,D=this.m(t,o,n),S={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:E,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},I=this.f.$registerTreeViewDataProvider(t,S),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$jH)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$jH)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message($){(0,P.$7k)($)&&(0,m.$jH)(n,"treeViewMarkdownMessage"),D.message=$},get title(){return D.title},set title($){D.title=$},get description(){return D.description},set description($){D.description=$},get badge(){return D.badge},set badge($){$!==void 0&&c.ViewBadge.isViewBadge($)?D.badge={value:Math.floor(Math.abs($.value)),tooltip:$.tooltip}:$===void 0&&(D.badge=void 0)},reveal:($,v)=>D.reveal($,v),dispose:async()=>{await I,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,o){const n=this.a.get(t);return n?n.getChildren(o):Promise.reject(new O.$EG(t))}async $handleDrop(t,o,n,d,l,g,E,D){const S=this.a.get(t);if(!S)return Promise.reject(new O.$EG(t));const I=u.DataTransfer.toDataTransfer(n,async A=>(await this.f.$resolveDropFileData(t,o,A)).buffer);return E===t&&D&&await this.j(I,S,D,l,g),S.onDrop(I,d,l)}async j(t,o,n,d,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((E,D)=>{E&&t.set(D,E)});else if(l&&o.handleDrag){const E=o.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,o,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new O.$EG(t));const g=await this.j(new c.$LO,l,o,d,n);if(!(!g||d.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$EG(t);return o.hasResolve}$resolve(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);return d.resolveTreeItem(o,n)}$setExpanded(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);d.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);d.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.a.get(t);if(!n){if(!o)return;throw new O.$EG(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.a.get(t);if(!n)throw new O.$EG(t);n.setCheckboxState(o)}m(t,o,n){const d=this.B(new i(t,o,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$Mrc=f;class i extends T.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,n,d,l,g){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$xe,g.contributes&&g.contributes.views)for(const I in g.contributes.views)for(const A of g.contributes.views[I])A.id===t&&(this.P=A.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(I=>{Array.isArray(I)&&I.length===0||this.F.fire({message:!1,element:I})}));let E,D;const S=R.Event.debounce(this.F.event,(I,A)=>(I||(I={message:!1,elements:[]}),A.element!==!1&&(E||(E=new Promise($=>D=$),this.G=this.G.then(()=>E)),Array.isArray(A.element)?I.elements.push(...A.element):I.elements.push(A.element)),A.message&&(I.message=!0),I),200,!0);this.B(S(({message:I,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const $=D;return E=null,this.$(A).then(()=>$())})),I&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(o)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,k.$og)(o.select)?!0:o.select,d=(0,k.$og)(o.focus)?!1:o.focus,l=(0,k.$og)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:g.map(D=>D.item)},{select:n,focus:d,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,y.$ub)(this.s,t);this.s=t;const d=this.t!==o;this.t=o,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const d=[];for(const l of t){const g=this.getExtensionElement(l);g&&d.push(g)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,n){const d=o?this.getExtensionElement(o):void 0;if(!(!d&&o||!this.g?.handleDrop))return(0,b.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,o)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(n=>this.W(o,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,b.$yh)(()=>this.f.getParent(t))}W(t,o){const n=this.m.get(t);return n?Promise.resolve(n):(0,b.$yh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,o,!0)).then(d=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.m.get(n):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new w.$xe(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const l=(0,y.$Hb)(d||[]),g=await Promise.all((0,y.$Hb)(l).map(D=>this.f.getTreeItem(D)));if(o.token.isCancellationRequested)return;const E=g.map((D,S)=>D?this.db(l[S],D,n):null);return(0,y.$Hb)(E)}finally{o.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$xe,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const o=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!o.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(E=>g&&g.parent&&E&&E.item.handle===g.parent.item.handle)===-1;){const E=this.j.get(g.parent.item.handle);g=E?this.m.get(E):void 0}g&&!g.parent&&o.add(l.item.handle)}const d=[];return o.forEach(l=>{const g=this.j.get(l);if(g){const E=this.m.get(g);E&&(!E.parent||!o.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const o={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(o[n]=d.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const n=this.m.get(o);if(n)return this.rb(o),(0,b.$yh)(()=>this.f.getTreeItem(o)).then(d=>{if(d){const l=this.ib(o,d,n.parent);return this.pb(o,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,o,n){const d=this.ib(t,o,n);if(o.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(2702,null,o.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$iO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,n,d;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:o===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$GO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,n){this.hb(o);const d=this.B(new T.$Uc),l=this.kb(t,o,n),g=this.lb(o);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:p(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(d,o.command),contextValue:o.contextValue,icon:g,iconDark:this.mb(o)||g,themeIcon:this.jb(o),collapsibleState:(0,k.$og)(o.collapsibleState)?c.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$PO?t.iconPath:void 0}kb(t,{id:o,label:n,resourceUri:d},l,g){if(o)return`${i.b}/${o}`;const E=p(n,this.N),D=l?l.item.handle:i.a;let S=E?E.label:d?(0,h.$eh)(d):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const I=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let $,v=0;do{if($=`${D}/${v}:${S}`,g||!this.j.has($)||I===$)break;v++}while(v<=A.length);return $}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$PO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$PO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,n,d){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,o);const l=this.X(d)||[],g=l.filter(E=>E.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[323],Ie([1,0,4,3,2,32,15,96,6,9]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0,T=We(T),b=We(b),c=We(c);class k extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,m,p){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$me),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=m,this.#i=p.viewType,this.#s=p.panelOptions,this.#o=p.viewColumn,this.#r=p.title,this.#l=p.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:T.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends h.$Vc{static c(){return(0,R.$3g)()}constructor(w,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=w.getProxy(b.$ON.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,m,p,f={}){const i=typeof p=="object"?p.viewColumn:p,s={viewColumn:T.ViewColumn.from(i),preserveFocus:typeof p=="object"&&!!p.preserveFocus},t=(0,O.$cqc)(w),o=y.c();this.f.$createWebviewPanel((0,O.$eqc)(w),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,O.$fqc)(w,this.m,f),serializeBuffersForPostMessage:t},s);const n=this.j.createNewWebview(o,f,w);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((m,p)=>{const f=w[m],i=w[p];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const p=this.getWebviewPanel(m);if(!p)continue;const f=w[m];p._updateViewState({active:f.active,visible:f.visible,viewColumn:T.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,O.$cqc)(w)}),new c.$QN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,m,p){const f=this.h.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.j.createNewWebview(w,m.webviewOptions,s),o=this.createNewWebviewPanel(w,a,m.title,p,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(w,a,m,p,f,i,s){const t=new k(w,this.f,i,{viewType:a,title:m,viewColumn:p,panelOptions:f,active:s});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$gqc=y;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ke[324],Ie([1,0,4,3,96,15,6,9]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=void 0,T=We(T),O=We(O);class b extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,P,w,a,m){super(),this.#s=!1,this.#l=this.B(new r.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$me),this.onDidDispose=this.#u.event,this.#i=P,this.#a=w,this.#e=y,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(T.$ON.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,P,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:y}),this.a.$registerWebviewViewProvider((0,C.$eqc)(y),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$cqc)(y)}),new O.$QN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,P,w,a){const m=this.b.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:p,extension:f}=m,i=this.d.createNewWebview(y,{},f),s=new b(y,this.a,u,P,i,!0);this.c.set(y,s),await p.resolveWebviewView(s,{state:w},a)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$Prc=c}),define(ke[325],Ie([1,0,75,14,11,228,27,10]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=void 0;let b=class{constructor(y,u){y.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:O.$l})}};e.$usc=b,e.$usc=b=Ze([Ve(0,r.$$pc),Ve(1,C.$bk)],b);class c{constructor(y){this.b=y,this.a=new R.$wr(this.b)}async stat(y){const u=await this.a.stat(y);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(y){return this.a.readdir(y)}createDirectory(y){return this.a.mkdir(y)}readFile(y){return this.a.readFile(y)}writeFile(y,u,P){return this.a.writeFile(y,u,{...P,unlock:!1,atomic:!1})}delete(y,u){return this.a.delete(y,{...u,useTrash:!1,atomic:!1})}rename(y,u,P){return this.a.rename(y,u,P)}copy(y,u,P){return this.a.copy(y,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(y,u){throw new Error("Method not implemented.")}}}),define(ke[326],Ie([1,0,16,66,32,34,3,6,2,19]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=void 0;let k=class extends T.$Vc{constructor(u,P){super();const w=u.getProxy(O.$ON.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=b.URI.file((0,r.$kc)((0,h.tmpdir)(),(0,C.$3g)()));return await w.$download(a,m),m})}};e.$ssc=k,e.$ssc=k=Ze([Ve(0,c.$oQ),Ve(1,R.$KQ)],k)}),define(ke[327],Ie([1,0,45,16,2,97,3,14,7,33]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0,r=We(r),h=We(h);class k extends R.$aqc{constructor(){super(...arguments),this.i=null}async g(o){const n=await super.g(o);if(n.scheme!==O.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let g;l===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await y(g);const E=h.$kc(g,"vscode.lock"),D=await a(this.d,E,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),C.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Esc=k;async function y(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class w extends T.$Vc{constructor(o,n){super(),this.b=o,this.c=n,this.a=this.B(new b.$Rh),this.a.cancelAndSet(async()=>{const d=await m(o,n);(!d||d.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,o,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await m(t,o);return!d||d.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new w(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function p(t,o){let n;try{n=await r.promises.stat(o)}catch(d){return t.error(d),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,b.$Hh)(Math.min(100,D)),await p(t,o)===0)return s(t,o);D=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const d=await p(t,o),l=Date.now()-d;if(l<=P)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.$Hh)(2e3);const g=await p(t,o),E=Date.now()-g;return E<=P?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(ke[328],Ie([1,0,32,19,48,34]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0;let T=class extends C.$wqc{constructor(b,c){super(!0,b,c)}createTerminal(b,c,k){return this.createTerminalFromOptions({name:b,shellPath:c,shellArgs:k})}createTerminalFromOptions(b,c){const k=new C.$vqc(this.a,(0,r.$3g)(),b,b.name);return this.f.push(k),k.create(b,this.R(b,c)),k.value}};e.$Zrc=T,e.$Zrc=T=Ze([Ve(0,R.$KQ),Ve(1,h.$oQ)],T)}),define(ke[329],Ie([1,0,4,36,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.OutputChannelUpdateMode=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0,e.$WM="text/x-code-output",e.$XM="output",e.$YM="Log",e.$ZM="text/x-code-log-output",e.$1M="log",e.$2M="workbench.panel.output",e.$3M=new C.$Xj("inOutput",!1),e.$4M=new C.$Xj("activeLogOutput",!1),e.$5M=new C.$Xj("activeLogOutput.levelSettable",!1),e.$6M=new C.$Xj("activeLogOutput.level",""),e.$7M=new C.$Xj("activeLogOutput.levelIsDefault",!1),e.$8M=new C.$Xj("outputView.scrollLock",!1),e.$9M=(0,R.$Gi)("outputService");var T;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$0M={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new r.$me,this.onDidRegisterChannel=this.b.event,this.c=new r.$me,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(k=>c.push(k)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$so.add(e.$0M.OutputChannels,new O),e.$$M=new C.$Xj("activeOutputChannel","")}),define(ke[172],Ie([1,0,6,5,19,23,11,329,75,29,62,213,21,17,27,4,3]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=e.$src=void 0;class p extends T.$hk{get disposed(){return this.n}constructor(t,o,n,d,l){super(),this.id=t,this.name=o,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Oe.fromString(o).byteLength,(0,T.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends p{appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,d,l,g){this.i=o,this.j=n,this.k=d,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$ON.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,y.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,n]of this.g)n.visible=o===this.h}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof o=="object"&&o.log,l=(0,P.$fg)(o)?o:void 0;if((0,P.$fg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const E=this.i.environment.extensionLogLevel?.find(([S])=>R.$sn.equals(n.identifier,S))?.[1];E&&(g=(0,T.$sk)(E));const D=d?this.o(t,g,n):this.n(t,l,n);return D.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),d?this.r(t,g??this.m.getLevel(),D):this.q(t,D)}async n(t,o,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,o,n.identifier.value);return new p(E,t,g,this.a,n)}async o(t,o,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,D=this.l.createLogger(g,{id:E,name:t,logLevel:o,extensionId:n.identifier.value});return new f(E,t,D,this.a,n)}p(t){let o=this.d.get(t.identifier.value);if(!o){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$rl)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return o}q(t,o){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),o.then(g=>g.append(l))},appendLine(l){d(),o.then(g=>g.appendLine(l))},clear(){d(),o.then(l=>l.clear())},replace(l){d(),o.then(g=>g.replace(l))},show(l,g){d(),o.then(E=>E.show(l,g))},hide(){d(),o.then(l=>l.hide())},dispose(){n=!0,o.then(l=>l.dispose())}}}r(t,o,n){const d=new m.$Uc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new a.$me);function E(D){o=D,g.fire(D)}return n.then(D=>{d.add(D),D.logLevel!==o&&E(D.logLevel),d.add(D.onDidChangeLogLevel(S=>E(S)))}),{...this.q(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(D,...S){l(),n.then(I=>I.trace(D,...S))},debug(D,...S){l(),n.then(I=>I.debug(D,...S))},info(D,...S){l(),n.then(I=>I.info(D,...S))},warn(D,...S){l(),n.then(I=>I.warn(D,...S))},error(D,...S){l(),n.then(I=>I.error(D,...S))},dispose(){d.dispose()}}}};e.$src=i,e.$src=i=Ze([Ve(0,C.$oQ),Ve(1,c.$EQ),Ve(2,b.$$pc),Ve(3,k.$Npc),Ve(4,T.$ck),Ve(5,T.$bk)],i),e.$trc=(0,h.$Gi)("IExtHostOutputService")}),define(ke[173],Ie([1,0,5,7]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=void 0,e.$Xm=(0,r.$Gi)("remoteAgentService"),e.$Ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let R=1/0;for(let O=0;O<this.maxSampleCount;O++){const b=await C.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,h.$Hh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(R):T=this.initial.reduce((O,b)=>O+b,0)/this.initial.length,this.lastMeasurement={initial:T,current:R,average:this.average.reduce((O,b)=>O+b,0)/this.average.length,high:typeof T>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[330],Ie([1,0,8,70,36,47,46,3,4,173,10,24,7,153]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=void 0,e.$hL=Object.freeze({id:"application",order:100,title:(0,r.localize)(3962,null),type:"object"}),e.$iL=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(3963,null),type:"object"}),e.$jL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(3964,null),type:"object",order:7}),e.$kL=Object.freeze({id:"problems",title:(0,r.localize)(3965,null),type:"object",order:101}),e.$lL=Object.freeze({id:"window",order:8,title:(0,r.localize)(3966,null),type:"object"}),e.$mL={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new w;C.$so.add(e.$mL.ConfigurationMigration,a);let m=class extends O.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.a=s,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const t of this.b.getWorkspace().folders)await this.f(t,s)}async f(s,t){await Promise.all([t.map(o=>this.g(o,s?.uri))])}async g(s,t){const o=this.a.inspect(s.key,{resource:t}),n=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const g=o[d];if(!g)continue;const E=[];if(g.value!==void 0){const D=await this.h(s,d,g.value,t,void 0);for(const S of D??[])E.push([S,[]])}for(const{identifiers:D,value:S}of g.overrides??[])if(S!==void 0){const I=await this.h(s,d,S,t,D);for(const A of I??[])E.push([A,D])}E.length&&await Promise.allSettled(E.map(async([[D,S],I])=>this.a.updateValue(D,S.value,{resource:t,overrideIdentifiers:I},l)))}}async h(s,t,o,n,d){const l=E=>{const S=this.a.inspect(E,{resource:n})[t];if(S)return d?S.overrides?.find(({identifiers:I})=>(0,y.$jo)(I,d))?.value:S.value},g=await s.migrateFn(o,l);return Array.isArray(g)?g:[[s.key,g]]}};e.$nL=m,e.$nL=m=Ze([Ve(0,T.$aj),Ve(1,R.$Pi)],m);let p=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!k.$j&&(await this.b.getEnvironment())?.os!==k.OperatingSystem.Windows)return;C.$so.as(h.$xo.Configuration).registerConfiguration({...e.$jL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(3967,null)},default:[],markdownDescription:(0,r.localize)(3968,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(3969,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$oL=p,e.$oL=p=Ze([Ve(0,c.$Xm)],p),e.$pL="window.newWindowProfile";let f=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.c=s,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==T.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$pL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=C.$so.as(h.$xo.Configuration),t={...e.$lL,properties:{[e.$pL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,r.localize)(3970,null)],description:(0,r.localize)(3971,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[t],remove:[this.a]}):s.registerConfiguration(t),this.a=t}h(){const s=this.f.getValue(e.$pL);this.b=s?this.c.profiles.find(t=>t.name===s):void 0}j(){const s=this.f.getValue(e.$pL);if(!s)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;s!==t?.name&&this.f.updateValue(e.$pL,t?.name)}};e.$qL=f,e.$qL=f=Ze([Ve(0,P.$Nl),Ve(1,T.$aj)],f)}),define(ke[331],Ie([1,0,38,14,16,22,8,330,70,5,36]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$sL=e.$rL=void 0,e.$tL=a,e.$uL=m,r=We(r),e.$rL=(0,c.$Gi)("editorResolverService"),e.$sL="workbench.editorAssociations";const y=k.$so.as(b.$xo.Configuration),u={...O.$iL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(12105,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var P;(function(p){p.builtin="builtin",p.option="option",p.exclusive="exclusive",p.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function(p){p[p.ABORT=1]="ABORT",p[p.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a(p){switch(p){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m(p,f){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof p=="string"&&p.indexOf(C.$hc.sep)>=0?`${f.scheme}:${f.path}`:(0,R.$eh)(f);return r.$Ak(typeof p=="string"?p.toLowerCase():p,t.toLowerCase())}}),define(ke[332],Ie([1,0,31,14,16,10,22,2,5,247,47,161,173]),function($e,e,r,h,C,R,T,O,b,c,k,y,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0,e.$qN=(0,b.$Gi)("pathService");let w=P=class{constructor(m,p,f,i){this.d=m,this.e=p,this.f=f,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,p,f){return typeof p=="string"||typeof p>"u"?this.a.then(i=>this.h(m,i,p)):this.h(m,p,f)}h(m,p,f){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$Dg)(f??(0,T.$eh)(m),p===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,p){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const f=(0,c.$nN)(p.getWorkspace());if(f)return f;const i=p.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=p.getWorkspace().configuration;return s?s.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===R.OperatingSystem.Windows?C.$gc:C.$hc)}async fileURI(m){let p="";if(await this.a===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(p=m.substring(2),m="/"):(p=m.substring(2,i),m=m.substring(i)||"/")}return O.URI.from({scheme:h.Schemas.file,authority:p,path:m,query:"",fragment:""})}};e.$rN=w,e.$rN=w=P=Ze([Ve(1,u.$Xm),Ve(2,y.$_M),Ve(3,k.$Pi)],w)}),define(ke[333],Ie([1,0,8,59,4,60,3,2,46,217,11,71,154,92,47,161,25,20,17,24,35]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.OnPortForward=e.$eN=e.$dN=e.TunnelSource=e.TunnelCloseReason=e.$bN=e.$aN=void 0,e.$cN=l,e.$fN=D,e.$gN=S,e.$hN=I,e.$iN=$,r=We(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$aN="onTunnel",e.$bN=new s.$Xj("forwardedPortsViewEnabled",!1,r.localize(12488,null));function l(N){const L=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(L)return{host:L[1]?.substring(0,L[1].length-1)||"localhost",port:Number(L[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$dN={source:E.User,description:r.localize(12489,null)},e.$eN={source:E.Auto,description:r.localize(12490,null)};function D(N,L,F){const B=N.get(I(L,F));if(B)return B;if((0,P.$Ow)(L))for(const j of P.$Nw){const U=I(j,F);if(N.has(U))return N.get(U)}else if((0,P.$Qw)(L))for(const j of P.$Pw){const U=I(j,F);if(N.has(U))return N.get(U)}}function S(N,L,F){const B=D(N,L,F);if(B)return B;const j=(0,P.$Qw)(L)?"localhost":(0,P.$Ow)(L)?"0.0.0.0":void 0;if(j)return D(N,j,F)}function I(N,L){return N+":"+L}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function $(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends T.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(L){super(),this.r=L,this.j=[],this.n=new C.$me,this.onDidChangeAttributes=this.n.event,this.B(L.onDidChangeConfiguration(F=>{(F.affectsConfiguration(v.c)||F.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(L,F,B){let j=this.w(L,F,B,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const z=this.j[j];z.key===L?(U.onAutoForward=z.onAutoForward??U.onAutoForward,U.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:U.elevateIfNeeded,U.label=z.label??U.label,U.requireLocalPort=z.requireLocalPort,U.protocol=z.protocol):(U.onAutoForward=U.onAutoForward??z.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:z.elevateIfNeeded,U.label=U.label??z.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??z.protocol),j=this.w(L,F,B,this.j,j+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(L){return L.start!==void 0&&L.end!==void 0}u(L){return L.host!==void 0&&L.port!==void 0&&(0,f.$fg)(L.host)&&(0,f.$jg)(L.port)}w(L,F,B,j,U){if(U>=j.length)return-1;const z=!(0,P.$Ow)(F)&&!(0,P.$Qw)(F),V=j.slice(U).findIndex(W=>(0,f.$jg)(W.key)?z?!1:W.key===L:this.t(W.key)?z?!1:L>=W.key.start&&L<=W.key.end:this.u(W.key)?L===W.key.port&&F===W.key.host:B?W.key.test(B):!1);return V>=0?V+U:-1}y(){const L=this.r.getValue(v.c);if(!L||!(0,f.$hg)(L))return[];const F=[];for(const j in L){if(j===void 0)continue;const U=L[j];let z;if(Number(j))z=Number(j);else if((0,f.$fg)(j))if(v.g.test(j)){const ee=j.match(v.g);z={start:Number(ee[1]),end:Number(ee[2])}}else if(v.h.test(j)){const ee=j.match(v.h);z={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(j)}catch{}ee&&(z=ee)}z&&F.push({key:z,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const B=this.r.getValue(v.f);return B&&(this.m={elevateIfNeeded:B.elevateIfNeeded,label:B.label,onAutoForward:B.onAutoForward,requireLocalPort:B.requireLocalPort,protocol:B.protocol}),this.z(F)}z(L){function F(B,j){return(0,f.$jg)(B.key)?B.key:j.t(B.key)?B.key.start:j.u(B.key)?B.key.port:Number.MAX_VALUE}return L.sort((B,j)=>F(B,this)-F(j,this))}C(){return this.m}static providedActionToAction(L){switch(L){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(L,F,B){const U=this.r.inspect(v.c).userRemoteValue;let z;!U||!(0,f.$hg)(U)?z={}:z=(0,i.$fo)(U),z[`${L}`]||(z[`${L}`]={});for(const ee in F)z[`${L}`][ee]=F[ee];return this.r.updateValue(v.c,z,B)}}e.$jN=v;let M=class extends T.$Vc{constructor(L,F,B,j,U,z,ee,V,W,J){super(),this.H=L,this.I=F,this.J=B,this.L=j,this.M=U,this.N=z,this.O=ee,this.P=V,this.Q=W,this.R=J,this.c=new Map,this.g=new C.$me,this.onForwardPort=this.g.event,this.h=new C.$me,this.onClosePort=this.h.event,this.j=new C.$me,this.onPortName=this.j.event,this.n=new C.$me,this.onCandidatesChanged=this.n.event,this.t=new C.$me,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new C.$me,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(B),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ce=await this.getAttributes(_.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of _)if(ne.localAddress){const ye=I(ne.tunnelRemoteHost,ne.tunnelRemotePort),ge=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(ye,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ce?.get(ne.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ce?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,name:ce?.get(ne.tunnelRemotePort)?.label,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:ne.privacy,source:e.$dN}),this.f.set(ye,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ce=I(_.tunnelRemoteHost,_.tunnelRemotePort);if(!S(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!S(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!S(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const ne=S(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),ye=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ce,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:ye?.protocol??P.TunnelProtocol.Http,localUri:await this.X(_.localAddress,ye),localPort:_.tunnelLocalPort,name:ye?.label,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:_.privacy,source:e.$dN})}await this.cb(),this.f.set(ce,_),this.g.fire(this.forwarded.get(ce))})),this.B(this.H.onTunnelClosed(_=>this.W(_,g.Other))),this.U()}S(){return this.Q.extensions.find(L=>L.activationEvents?.includes(e.$aN))?(this.R.createKey(e.$bN.key,!0),!0):!1}U(){if(this.S())return;const L=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&L.dispose()}))}async W(L,F){const B=I(L.host,L.port);this.forwarded.has(B)&&(this.forwarded.delete(B),await this.cb(),this.h.fire(L))}X(L,F){if(L.startsWith("http"))return O.URI.parse(L);const B=F?.protocol??"http";return O.URI.parse(`${B}://${L}`)}async Y(L){const F=this.N.getWorkspace(),B=F.configuration?(0,R.$uj)(F.configuration.path):F.folders.length>0?(0,R.$uj)(F.folders[0].uri.path):void 0;if(B===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${L}.${this.L.remoteAuthority}.${B}`}async Z(){return this.Y(o)}async $(){return this.Y(n)}async ab(){const L=this.I.get(o,u.StorageScope.WORKSPACE);if(L)return this.I.remove(o,u.StorageScope.WORKSPACE),await this.cb(),L;const F=await this.Z();if(F)return this.I.get(F,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const L=await this.s;if(L&&L!==this.y){const F=JSON.parse(L)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(B=>B.remotePort).join(", ")}`);for(const B of F){const j=S(this.detected,B.remoteHost,B.remotePort);B.source.source!==E.Extension&&!j||B.source.source===E.Extension&&j?await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,elevateIfNeeded:!0,source:B.source}):B.source.source===E.Extension&&!j&&this.D.set(I(B.remoteHost,B.remotePort),B)}}}if(this.z=!0,this.C.fire(),!this.w){const L=await this.Z();this.w=this.B(new T.$Uc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async F=>{F.key===L&&(this.s=Promise.resolve(this.I.get(L,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const L=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(F=>F.startsWith(n));for(const F of L){const B=this.I.getNumber(F,u.StorageScope.PROFILE);if(B&&B<Date.now()){this.s=Promise.resolve(void 0);const j=F.replace(n,o);this.I.remove(F,u.StorageScope.PROFILE),this.I.remove(j,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const L=Array.from(this.forwarded.values()),F=L.map(z=>({remoteHost:z.remoteHost,remotePort:z.remotePort,localPort:z.localPort,name:z.name,localAddress:z.localAddress,localUri:z.localUri,protocol:z.protocol,source:z.source}));let B;L.length>0&&(B=JSON.stringify(F));const j=await this.Z(),U=await this.$();!B&&j&&U?(this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(U,u.StorageScope.PROFILE)):B!==this.y&&j&&U&&(this.I.store(j,B,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(U,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=B}}async eb(L,F,B){if(!L.tunnelLocalPort||!B?.requireLocalPort||L.tunnelLocalPort===F)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const U=r.localize(12491,null,F,L.tunnelRemotePort,L.tunnelLocalPort);return this.P.info(U)}async forward(L,F){return!this.z&&this.L.remoteAuthority&&await C.Event.toPromise(this.C.event),this.fb(L,F)}async fb(L,F){await this.Q.activateByEvent(e.$aN);const B=S(this.forwarded,L.remote.host,L.remote.port);F=F??(F!==null?(await this.getAttributes([L.remote]))?.get(L.remote.port):void 0);const j=L.local!==void 0?L.local:L.remote.port;let U;if(B)return this.hb(B,L,F);{const z=this.L.remoteAuthority,ee=z?{getAddress:async()=>(await this.M.resolveAuthority(z)).authority}:void 0,V=I(L.remote.host,L.remote.port);this.c.set(V,!0),L=this.gb(V,L);const W=await this.H.openTunnel(ee,L.remote.host,L.remote.port,void 0,j,L.elevateIfNeeded?L.elevateIfNeeded:F?.elevateIfNeeded,L.privacy,F?.protocol);if(typeof W=="string")U=W;else if(W&&W.localAddress){const J=S(this.m??new Map,L.remote.host,L.remote.port),_=W.protocol?W.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:F?.protocol??P.TunnelProtocol.Http,ce={remoteHost:W.tunnelRemoteHost,remotePort:W.tunnelRemotePort,localPort:W.tunnelLocalPort,name:F?.label??L.name,closeable:!0,localAddress:W.localAddress,protocol:_,localUri:await this.X(W.localAddress,F),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:L.source??e.$dN,privacy:W.privacy};return this.forwarded.set(V,ce),this.f.set(V,W),this.c.delete(V),await this.cb(),await this.eb(W,j,F),this.g.fire(ce),W}this.c.delete(V)}return U}gb(L,F){const B=this.D.has(L)?this.D:this.F.has(L)?this.F:void 0;if(B){const j=B.get(L);B.delete(L),j&&(F.name=j.name??F.name,F.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??F.local,F.privacy=F.privacy)}return F}async hb(L,F,B){const j=B?.label??F.name;let U;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(U||(U={}));let z=U.None;switch(j!==L.name&&(L.name=j,z=U.Fire),(B?.protocol||L.protocol!==P.TunnelProtocol.Http)&&B?.protocol!==L.protocol&&(F.source=L.source,z=U.Reopen),F.privacy&&L.privacy!==F.privacy&&(z=U.Reopen),z){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(L.remoteHost,L.remotePort,g.User),await this.fb(F,B)}return S(this.f,F.remote.host,F.remote.port)}async name(L,F,B){const j=S(this.forwarded,L,F),U=I(L,F);if(j){j.name=B,await this.cb(),this.j.fire({host:L,port:F});return}else this.detected.has(U)&&(this.detected.get(U).name=B,this.j.fire({host:L,port:F}))}async close(L,F,B){const j=I(L,F),U=this.forwarded.get(j);return B===g.AutoForwardEnd&&U&&U.source.source===E.Auto&&this.F.set(j,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(L,F),this.W({host:L,port:F},B)}address(L,F){const B=I(L,F);return(this.forwarded.get(B)||this.detected.get(B))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(L){if(L)for(const F of L){const B=S(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),j=typeof F.localAddress=="string"?F.localAddress:I(F.localAddress.host,F.localAddress.port);this.detected.set(I(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:j,protocol:P.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(12492,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,j,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(L){this.r=L}async setCandidates(L){let F=L;this.r&&(F=await this.r(L));const B=this.ib(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(B.values()).map(j=>j.port).join(", ")}`),this.n.fire(B)}ib(L){const F=this.m??new Map,B=new Map;return this.m=B,L.forEach(j=>{const U=I(j.host,j.port);B.set(U,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),F.has(U)&&F.delete(U);const z=S(this.forwarded,j.host,j.port);z&&(z.runningProcess=j.detail,z.hasRunningProcess=!0,z.pid=j.pid)}),F.forEach((j,U)=>{const z=l(U);if(!z)return;const ee=S(this.forwarded,z.host,z.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const V=S(this.detected,z.host,z.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const L=Array.from(this.forwarded.values()),F=await this.getAttributes(L.map(B=>({port:B.remotePort,host:B.remoteHost})),!1);if(F)for(const B of L){const j=F.get(B.remotePort);(j?.protocol||B.protocol!==P.TunnelProtocol.Http)&&j?.protocol!==B.protocol&&await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,source:B.source},j),j&&j.label&&j.label!==B.name&&await this.name(B.remoteHost,B.remotePort,j.label)}}async getAttributes(L,F=!0){const B=new Map,j=new Map;L.forEach(W=>{const J=S(this.m??new Map,P.$Nw[0],W.port)??W;if(J){B.set(W.port,J);const _=$(J)?J.pid:void 0;j.has(_)||j.set(_,[]),j.get(_)?.push(W.port)}});const U=new Map;if(L.forEach(W=>{const J=this.configPortsAttributes.getAttributes(W.port,W.host,B.get(W.port)?.detail);J&&U.set(W.port,J)}),this.G.length===0||!F)return U.size>0?U:void 0;const z=await Promise.all(this.G.flatMap(W=>Array.from(j.entries()).map(J=>{const _=J[1],ce=B.get(_[0]);return W.providePortAttributes(_,ce?.pid,ce?.detail,p.CancellationToken.None)}))),ee=new Map;if(z.forEach(W=>W.forEach(J=>{J&&ee.set(J.port,J)})),!U&&!ee)return;const V=new Map;return L.forEach(W=>{const J=U.get(W.port),_=ee.get(W.port);V.set(W.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??v.providedActionToAction(_?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),V}addAttributesProvider(L){this.G.push(L)}};e.$kN=M,Ze([(0,h.$_h)(1e3)],M.prototype,"cb",null),e.$kN=M=Ze([Ve(0,P.$Iw),Ve(1,u.$jq),Ve(2,b.$aj),Ve(3,a.$_M),Ve(4,y.$Sl),Ve(5,w.$Pi),Ve(6,k.$bk),Ve(7,c.$bx),Ve(8,m.$fH),Ve(9,s.$Yj)],M)}),define(ke[99],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$4L=e.$3L=e.TextSearchCompleteMessageType=e.$2L=e.$1L=void 0,e.$5L=y;class h{constructor(P,w){this.line=P,this.character=w}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,w){return new h(0,0)}with(P){return new h(0,0)}}e.$1L=h;class C{constructor(P,w,a,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(P,w),this.end=new h(a,m)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new C(0,0,0,0)}with(P){return new C(0,0,0,0)}}e.$2L=C;var R;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}));class T{constructor(P,w,a){this.uri=P,this.ranges=w,this.previewText=a}}e.$3L=T;class O{constructor(P,w,a){this.uri=P,this.text=w,this.lineNumber=a}}e.$4L=O;var b;(function(u){u[u.None=1]="None",u[u.FilesExclude=2]="FilesExclude",u[u.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(b||(e.ExcludeSettingOptions=b={}));var c;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(c||(e.TextSearchCompleteMessageTypeNew=c={}));function k(u){return"uri"in u&&"ranges"in u&&"preview"in u}function y(u){if(k(u)){const P=(0,r.$2b)(u.ranges).map(w=>({sourceRange:w,previewRange:w}));return new T(u.uri,P,u.preview.text)}else return new O(u.uri,u.text,u.lineNumber)}}),define(ke[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function($e,e,r,h,C,R,T,O,b,c,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$qM=e.$jM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$gM=e.$fM=e.$eM=e.$dM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TextSearchCompleteMessageType=void 0,e.$aM=p,e.$bM=f,e.$cM=i,e.$hM=D,e.$iM=S,e.$kM=$,e.$lM=v,e.$mM=M,e.$nM=N,e.$oM=L,e.$pM=F,e.$rM=j,e.$tM=ee,e.$uM=V,h=We(h),C=We(C),R=We(R),b=We(b),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return k.TextSearchCompleteMessageType}}),e.$6L="workbench.view.search",e.$7L="workbench.panel.search",e.$8L="workbench.view.search",e.$9L="search-result",e.$0L="search.exclude",e.$$L=2e4;const u="\u27EA ",P=" characters skipped \u27EB",w=(u.length+P.length+5)*2;e.$_L=(0,O.$Gi)("searchService");var a;(function(J){J[J.file=0]="file",J[J.text=1]="text",J[J.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.aiText=3]="aiText"})(m||(e.QueryType=m={}));function p(J){return!!J.preview}function f(J){return!!J.resource}function i(J){return!!J.message}var s;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(_){this.resource=_,this.results=[]}}e.$dM=t;class o{constructor(_,ce,ne,ye){this.ranges=ce,this.webviewIndex=ye;const ge=Array.isArray(ce)?ce:[ce];if(ne&&ne.matchLines===1&&n(ge)){_=(0,T.$$f)(_,ne.matchLines);let Y="",q=0,oe=0;const ve=Math.floor(ne.charsPerLine/5),ie=[];for(const ae of ge){const se=Math.max(ae.startColumn-ve,0),X=ae.startColumn+ne.charsPerLine;if(se>oe+ve+w){const re=u+(se-oe)+P;Y+=re+_.slice(se,X),q+=se-(oe+re.length)}else Y+=_.slice(oe,X);ie.push(new l(0,ae.startColumn-q,ae.endColumn-q)),oe=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const Y=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:_,matches:(0,r.$1b)(ce,q=>new d(q.startLineNumber-Y,q.startColumn,q.endLineNumber-Y,q.endColumn))}}}}e.$eM=o;function n(J){const _=J[0].startLineNumber;for(const ce of J)if(ce.startLineNumber!==_||ce.endLineNumber!==_)return!1;return!0}class d{constructor(_,ce,ne,ye){this.startLineNumber=_,this.startColumn=ce,this.endLineNumber=ne,this.endColumn=ye}}e.$fM=d;class l extends d{constructor(_,ce,ne){super(_,ce,_,ne)}}e.$gM=l;var g;(function(J){J.List="list",J.Tree="tree"})(g||(e.ViewMode=g={}));var E;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(J,_=!0){const ce=J&&J.files&&J.files.exclude,ne=_&&J&&J.search&&J.search.exclude;if(!ce&&!ne)return;if(!ce||!ne)return ce||ne||void 0;let ye=Object.create(null);return ye=C.$io(ye,C.$fo(ce)),ye=C.$io(ye,C.$fo(ne),!0),ye}function S(J,_){return J.excludePattern&&h.$Ak(J.excludePattern,_)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&h.$Ak(J.includePattern,_)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ce=>{const ne=ce.folder.fsPath;if(R.$Fg(_,ne)){const ye=b.$mc(ne,_);return!ce.includePattern||!!h.$Ak(ce.includePattern,ye)}else return!1}):!1:!0}var I;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(I||(e.SearchErrorCode=I={}));class A extends Error{constructor(_,ce){super(_),this.code=ce}}e.$jM=A;function $(J){const _=J.message;if((0,c.$4)(J))return new A(_,I.canceled);try{const ce=JSON.parse(_);return new A(ce.message,ce.code)}catch{return new A(_,I.other)}}function v(J){const _={message:J.message,code:J.code};return new Error(JSON.stringify(_))}function M(J){return J.type==="error"?!0:J.type==="success"}function N(J){return J.type==="success"}function L(J){return!!J.path}function F(J,_,ce=!0){const ne=J.searchPath?J.searchPath:J.relativePath;return ce?(0,T.$8f)(ne,_):h.$Ak(_,ne)}class B{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$qM=B;function j(J,_){const ce={...J||{},..._||{}};return Object.keys(ce).filter(ne=>{const ye=ce[ne];return typeof ye=="boolean"&&ye})}class U{constructor(_,ce){this.c=null,this.a={..._.excludePattern||{},...ce.excludePattern||{}},this.b=h.$Bk(this.a);let ne=_.includePattern;ce.includePattern&&(ne?ne={...ne,...ce.includePattern}:ne=ce.includePattern),ne&&(this.c=h.$Bk(ne))}matchesExcludesSync(_,ce,ne){return!!(this.b&&this.b(_,ce,ne))}includedInQuerySync(_,ce,ne){return!(this.b&&this.b(_,ce,ne)||this.c&&!this.c(_,ce,ne))}includedInQuery(_,ce,ne){const ye=this.b(_,ce,ne),ge=()=>this.c?!!this.c(_,ce,ne):!0;return(0,y.$sh)(ye)?ye.then(Y=>Y?!1:ge()):ge()}hasSiblingExcludeClauses(){return z(this.a)}}e.$sM=U;function z(J){for(const _ in J)if(typeof J[_]!="boolean")return!0;return!1}function ee(J){if(!J)return;let _;return ce=>(_||(_=(J()||Promise.resolve([])).then(ne=>ne?W(ne):{})),_.then(ne=>!!ne[ce]))}function V(J){if(!J)return;let _;return ce=>{if(!_){const ne=J();_=ne?W(ne):{}}return!!_[ce]}}function W(J){const _={};for(const ce of J)_[ce]=!0;return _}}),define(ke[49],Ie([1,0,18,7,20,4,3,84,14,134,22,12,2,8,27,5,11,231,47,62,29,19,15,9,72,37,6,44]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=e.$5pc=void 0;function D(L,F,B){return new k.$9g(j=>$(j,B)).isEqual(L,F)}function S(L,F,B){return D(L.uri,F.uri,B)?0:(0,y.$zf)(L.uri.toString(),F.uri.toString())}function I(L,F,B){return L.index!==F.index?L.index<F.index?-1:1:D(L.uri,F.uri,B)?(0,y.$zf)(L.name,F.name):(0,y.$zf)(L.uri.toString(),F.uri.toString())}function A(L,F,B,j){const U=L.slice(0).sort((ee,V)=>B(ee,V,j)),z=F.slice(0).sort((ee,V)=>B(ee,V,j));return(0,r.$Eb)(U,z,(ee,V)=>B(ee,V,j))}function $(L,F){const B=F.getCapabilities(L.scheme);return!(B&&B&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends f.$Zi{static toExtHostWorkspace(F,B,j,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:V,configuration:W,transient:J,isUntitled:_}=F,ce=[],ne=B;B?V.forEach((q,oe)=>{const ve=u.URI.revive(q.uri),ie=v.o(j||B,ve,U);ie?(ie.name=q.name,ie.index=q.index,ce.push(ie)):ce.push({uri:ve,name:q.name,index:oe})}):ce.push(...V.map(({uri:q,name:oe,index:ve})=>({uri:u.URI.revive(q),name:oe,index:ve}))),ce.sort((q,oe)=>q.index<oe.index?-1:1);const ye=new v(z,ee,ce,!!J,W?u.URI.revive(W):null,!!_,q=>$(q,U)),{added:ge,removed:Y}=A(ne?ne.workspaceFolders:[],ye.workspaceFolders,S,U);return{workspace:ye,added:ge,removed:Y}}static o(F,B,j){for(let U=0;U<F.folders.length;U++){const z=F.workspaceFolders[U];if(D(z.uri,B,j))return z}}constructor(F,B,j,U,z,ee,V){super(F,j.map(W=>new f.$1i(W)),U,z,V),this.t=B,this.u=ee,this.q=[],this.s=O.$Mi.forUris(V,()=>!0),j.forEach(W=>{this.q.push(W),this.s.set(W.uri,W)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,B){return B&&this.s.get(F)&&(F=(0,k.$gh)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let M=class{constructor(F,B,j,U,z){this.c=new R.$me,this.onDidChangeWorkspace=this.c.event,this.g=new R.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$oe,this.C=new Map,this.h=U,this.s=j,this.t=z,this.j=new c.$Om,this.k=new h.$Fh,this.o=F.getProxy(g.$ON.MainThreadWorkspace),this.q=F.getProxy(g.$ON.MainThreadMessageService);const ee=B.workspace;this.l=ee?new v(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,V=>$(V,j)):void 0}$initializeWorkspace(F,B){this.v=B,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:b.Schemas.untitled,path:(0,k.$eh)((0,k.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,j,...U){const z=[];if(Array.isArray(U)&&U.forEach(_=>{u.URI.isUri(_.uri)&&!z.some(ce=>D(ce.uri,_.uri,this.s))&&z.push({uri:_.uri,name:_.name||(0,k.$dh)(_.uri)})}),this.n||[B,j].some(_=>typeof _!="number"||_<0)||j===0&&z.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(B+j>ee.length)return!1;const V=ee.slice(0);V.splice(B,j,...z.map(_=>({uri:_.uri,name:_.name||(0,k.$dh)(_.uri),index:void 0})));for(let _=0;_<V.length;_++){const ce=V[_];if(V.some((ne,ye)=>ye!==_&&D(ce.uri,ne.uri,this.s)))return!1}V.forEach((_,ce)=>_.index=ce);const{added:W,removed:J}=A(ee,V,I,this.s);if(W.length===0&&J.length===0)return!1;if(this.o){const _=F.displayName||F.name;this.o.$updateWorkspaceFolders(_,B,j,z).then(void 0,ce=>{this.n=void 0;const ne={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(p.Severity.Error,(0,P.localize)(2705,null,_,ce.toString()),ne,[])})}return this.y(V),!0}getWorkspaceFolder(F,B){if(this.x)return this.x.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,B){let j,U="";if(typeof F=="string"?(j=u.URI.file(F),U=F):typeof F<"u"&&(j=F,U=F.fsPath),!j)return U;const z=this.getWorkspaceFolder(j,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let ee=(0,k.$jh)(z.uri,j);return B&&z.name&&(ee=`${z.name}/${ee}`),ee}y(F){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:j,removed:U}=v.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(F,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ee="",V=!0;return B===null?V=!1:B!==void 0&&(typeof B=="string"?ee=B:ee=B.pattern),this.z(F,void 0,{exclude:ee,maxResults:j,useDefaultExcludes:V,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},z)}findFiles2(F,B={},j,U=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,F,B,U)}async z(F,B,j,U=C.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const z=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ee={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:z,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let V;if(F){const{includePattern:W,folder:J}=N(o.GlobPattern.from(F));V=J,ee.includePattern=W}else{const{includePattern:W,folder:J}=N(o.GlobPattern.from(B));V=J,ee.filePattern=W}return this.o.$startFileSearch(V??null,ee,U).then(W=>Array.isArray(W)?W.map(J=>u.URI.revive(J)):[])}async findTextInFiles(F,B,j,U,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),V=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:W,folder:J}=N(o.GlobPattern.from(B.include)),_=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ce={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof B.useSearchExclude=="boolean"?!B.useSearchExclude:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:W,excludePattern:_},ne=!1;if(this.u[ee]=ye=>{if(ne)return;const ge=u.URI.revive(ye.resource);ye.results.forEach(Y=>{const q=(0,E.$di)(Y);(0,l.$aM)(q)?j({uri:ge,preview:{text:q.preview.text,matches:(0,r.$1b)(q.preview.matches,oe=>new n.$SN(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.$1b)(q.ranges,oe=>new n.$SN(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):j({uri:ge,text:q.text,lineNumber:q.lineNumber})})},z.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(F,J??null,ce,ee,z);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(F,B){this.u[B]?.(F)}async save(F){const B=await this.o.$save(F,{saveAs:!1});return u.URI.revive(B)}async saveAs(F){const B=await this.o.$save(F,{saveAs:!0});return u.URI.revive(B)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}lookupAuthorization(F){return this.o.$lookupAuthorization(F)}lookupKerberosAuthorization(F){return this.o.$lookupKerberosAuthorization(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,B){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,B);const j=this.t.transformOutgoingScheme(F),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,T.$Tc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,B){this.h.info("Getting edit session identifier for workspaceFolder",F);const j=await this.resolveWorkspaceFolder(u.URI.revive(F));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(j,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(F,B,j,U){this.h.info("Getting edit session identifier for workspaceFolder",F);const z=await this.resolveWorkspaceFolder(u.URI.revive(F));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ee=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ee),!ee)return;const V=await ee.provideEditSessionIdentityMatch?.(B,j,U);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(F){return(B,j,U)=>{const z=function(V){B.call(j,V)};return z.extension=F,this.B.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(F,B,j){const U=await this.resolveWorkspaceFolder(u.URI.revive(F));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},B,async(z,ee)=>{const V=Date.now();await Promise.resolve(z),Date.now()-V>j&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(F,B){if(this.C.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.C.set(F,B);const j=this.t.transformOutgoingScheme(F),U=this.A++;return this.o.$registerCanonicalUriProvider(U,j),(0,T.$Tc)(()=>{this.C.delete(F),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(F,B,j){const U=this.C.get(F.scheme);if(!U)return;const z=await U.provideCanonicalUri?.(u.URI.revive(F),B,j);if(z)return z}async $provideCanonicalUri(F,B,j){return this.provideCanonicalUri(u.URI.revive(F),{targetScheme:B},j)}};e.$5pc=M,e.$5pc=M=Ze([Ve(0,t.$oQ),Ve(1,s.$EQ),Ve(2,i.$Npc),Ve(3,m.$bk),Ve(4,d.$3pc)],M),e.$6pc=(0,a.$Gi)("IExtHostWorkspace");function N(L){let F,B;return L&&(typeof L=="string"?F=L:(F=L.pattern,B=u.URI.revive(L.baseUri))),{includePattern:F,folder:B}}}),define(ke[41],Ie([1,0,24,4,49,6,9,46,233,70,17,7,5,19,11,2]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=e.$7pc=void 0;function m(d,l){if(l){const g=l.split(".");let E=d;for(let D=0;E&&D<g.length;D++)E=E[g[D]];return E}}function p(d){return d instanceof a.URI}function f(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if(p(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(l,g,E){this.a=l.getProxy(R.$ON.MainThreadConfiguration),this.c=g,this.b=E,this.d=new y.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,g))}};e.$7pc=o,e.$7pc=o=Ze([Ve(0,P.$oQ),Ve(1,C.$6pc),Ve(2,w.$bk)],o);class n{constructor(l,g,E,D){this.a=new h.$me,this.b=l,this.f=D,this.c=g,this.e=b.$So.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$So.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,E))}getConfiguration(l,g,E){const D=t(g)||{},S=this.g(l?m(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,E?.identifier);function I($){if($==null)return null;if(typeof $=="boolean")return $?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch($){case T.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has($){return typeof m(S,$)<"u"},get:($,v)=>{this.h(l?`${l}.${$}`:$,D,E?.identifier);let M=m(S,$);if(typeof M>"u")M=v;else{let N;const L=(F,B)=>{if((0,k.$hg)(F)){let j;const U=()=>{N=N||(0,r.$fo)(S),j=j||m(N,B)};return new Proxy(F,{get:(z,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return U(),()=>j;if(N)return j=j||m(N,B),j[ee];const V=z[ee];return typeof ee=="string"?L(V,`${B}.${ee}`):V},set:(z,ee,V)=>(U(),j&&(j[ee]=V),!0),deleteProperty:(z,ee)=>(U(),j&&delete j[ee],!0),defineProperty:(z,ee,V)=>(U(),j&&Object.defineProperty(j,ee,V),!0)})}return Array.isArray(F)?(0,r.$fo)(F):F};M=L(M,$)}return M},update:($,v,M,N)=>{$=l?`${l}.${$}`:$;const L=I(M);return v!==void 0?this.b.$updateConfigurationOption(L,$,v,D,N):this.b.$removeConfigurationOption(L,$,D,N)},inspect:$=>{$=l?`${l}.${$}`:$;const v=this.e.inspect($,D,this.c.workspace);if(v)return{key:$,defaultValue:(0,r.$fo)(v.policy?.value??v.default?.value),globalValue:(0,r.$fo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$fo)(v.workspace?.value),workspaceFolderValue:(0,r.$fo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$fo)(v.default?.override),globalLanguageValue:(0,r.$fo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$fo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$fo)(v.workspaceFolder?.override),languageIds:(0,r.$fo)(v.overrideIdentifiers)}}};return typeof S=="object"&&(0,r.$io)(A,S,!1),Object.freeze(A)}g(l){const g=E=>(0,k.$hg)(E)?new Proxy(E,{get:(D,S)=>g(D[S]),set:(D,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(D,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(D,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return g(l)}h(l,g,E){const D=c.$Ho.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),S=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof g?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){g?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const E=new b.$Uo(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,S)=>E.affectsConfiguration(D,t(S))})}k(l){return l.reduce((g,E)=>(g.set(E[0],E[1]),g),new Map)}}e.$8pc=n,e.$9pc=(0,u.$Gi)("IExtHostConfiguration")}),define(ke[100],Ie([1,0,2,7,4,6,9,49,63,41,20,48,19,29,5,14,10,11,95,273,13]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=e.$Erc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=We(T),m=We(m);var t;(function(N){function L(B){if(B!=null)return B}N.from=L;function F(B){if(B!=null)return B}N.to=F})(t||(t={}));var o;(function(N){function L(B){if(B!=null)return B}N.from=L;function F(B){if(B!=null)return B}N.to=F})(o||(o={}));var n;(function(N){function L(B){if(B!=null)return B}N.from=L;function F(B){if(B!=null)return B}N.to=F})(n||(n={}));var d;(function(N){function L(j){if(j){const U=j;return U&&!!U.process}else return!1}N.is=L;function F(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=n.from(j.options)),U}N.from=F;function B(j){if(j!=null)return new T.$CO(j.process,j.args,j.options)}N.to=B})(d||(d={}));var l;(function(N){function L(B){if(B!=null)return B}N.from=L;function F(B){if(B!=null)return B}N.to=F})(l||(l={}));var g;(function(N){function L(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}N.is=L;function F(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=l.from(j.options)),U}N.from=F;function B(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new T.$DO(j.commandLine,j.options):new T.$DO(j.command,j.args?j.args:[],j.options)}N.to=B})(g||(g={}));var E;(function(N){function L(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}N.is=L;function F(j){return{customExecution:"customExecution"}}N.from=F;function B(j,U){return U.get(j)}N.to=B})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(F,B){let j;return F.scope!==void 0&&typeof F.scope!="number"?j=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===T.TaskScope.Workspace&&B&&B.workspaceFile?j=B.workspaceFile:j=i.$ZI),{id:F._id,workspaceFolder:j}}N.from=L})(D||(e.TaskHandleDTO=D={}));var S;(function(N){function L(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=L})(S||(S={}));var I;(function(N){function L(j,U){if(j==null)return[];const z=[];for(const ee of j){const V=F(ee,U);V&&z.push(V)}return z}N.fromMany=L;function F(j,U){if(j==null)return;let z;j.execution instanceof T.$CO?z=d.from(j.execution):j.execution instanceof T.$DO?z=g.from(j.execution):j.execution&&j.execution instanceof T.$EO&&(z=E.from(j.execution));const ee=t.from(j.definition);let V;return j.scope?typeof j.scope=="number"?V=j.scope:V=j.scope.uri:V=T.TaskScope.Workspace,!ee||!V?void 0:{_id:j._id,definition:ee,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:V},execution:z,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:o.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}N.from=F;async function B(j,U,z){if(j==null)return;let ee;d.is(j.execution)?ee=d.to(j.execution):g.is(j.execution)?ee=g.to(j.execution):E.is(j.execution)&&(ee=E.to(j._id,z));const V=t.to(j.definition);let W;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?W=j.source.scope:W=await U.resolveWorkspaceFolder(r.URI.revive(j.source.scope)):W=T.TaskScope.Workspace),!V||!W)return;const J=new T.$FO(V,W,j.name,j.source.label,ee,j.problemMatchers);return j.isBackground!==void 0&&(J.isBackground=j.isBackground),j.group!==void 0&&(J.group=T.$BO.from(j.group._id),J.group&&j.group.isDefault&&(J.group=new T.$BO(J.group.id,J.group.label),j.group.isDefault===!0&&(J.group.isDefault=j.group.isDefault))),j.presentationOptions&&(J.presentationOptions=o.to(j.presentationOptions)),j._id&&(J._id=j._id),j.detail&&(J.detail=j.detail),J}N.to=B})(I||(e.TaskDTO=I={}));var A;(function(N){function L(B){return B}N.from=L;function F(B){if(B)return Object.assign(Object.create(null),B)}N.to=F})(A||(A={}));class ${#e;constructor(L,F,B){this._id=F,this.a=B,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let v=class{constructor(L,F,B,j,U,z,ee,V){this.q=new C.$me,this.r=new C.$me,this.s=new C.$me,this.u=new C.$me,this.a=L.getProxy(R.$ON.MainThreadTask),this.b=B,this.c=j,this.d=U,this.e=z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,F,B){if(!B)return new T.$QN(()=>{});const j=this.x();return this.j.set(j,{type:F,provider:B,extension:L}),this.a.$registerTaskProvider(j,F),new T.$QN(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(L,F){this.a.$registerTaskSystem(L,F)}fetchTasks(L){return this.a.$fetchTasks(A.from(L)).then(async F=>{const B=[];for(const j of F){const U=await I.to(j,this.b,this.m);U&&B.push(U)}return B})}get taskExecutions(){const L=[];return this.k.forEach(F=>L.push(F)),L}terminateTask(L){if(!(L instanceof $))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,F,B){const j=this.m.get(L.id);j&&(this.o.set(L.id,j),this.e.attachPtyToTerminal(F,await j.callback(B))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const F=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const F=await this.z(L.id);this.s.fire({execution:F,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const F=await this.z(L.id);this.u.fire({execution:F,exitCode:L.exitCode})}$provideTasks(L,F){const B=this.j.get(L);if(!B)return Promise.reject(new Error("no handler found"));const j=[],U=(0,h.$yh)(()=>B.provider.provideTasks(k.CancellationToken.None)).then(z=>this.v(F,j,B,z));return new Promise(z=>{U.then(ee=>{Promise.all(j).then(()=>{z(ee)})})})}async $resolveTask(L,F){const B=this.j.get(L);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const j=await I.to(F,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await B.provider.resolveTask(j,k.CancellationToken.None);if(!U)return;this.A(U,B);const z=I.from(U,B.extension);if(!z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(z.execution)&&await this.y(z,U,!0),await this.w(z)}x(){return this.h++}async y(L,F,B){const j=await this.a.$createTaskId(L);!B&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,F.execution)),this.m.set(j,F.execution)}async z(L,F){if(typeof L=="string"){const U=this.l.get(L);if(!U)throw new s.$bb("Unexpected: The specified task is missing an execution");return U}const B=this.l.get(L.id);if(B)return B;let j;return F?j=Promise.resolve(new $(this,L.id,F)):j=I.to(L.task,this.b,this.m).then(U=>{if(!U)throw new s.$bb("Unexpected: Task does not exist.");return new $(this,L.id,U)}),this.l.set(L.id,j),j.then(U=>(this.k.set(L.id,U),U))}A(L,F){L._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const B=this.n.values();let j=B.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=B.next()}};e.$Erc=v,e.$Erc=v=Ze([Ve(0,u.$oQ),Ve(1,P.$EQ),Ve(2,O.$6pc),Ve(3,b.$zQ),Ve(4,c.$9pc),Ve(5,y.$uqc),Ve(6,p.$bk),Ve(7,f.$Jpc)],v);let M=class extends v{constructor(L,F,B,j,U,z,ee,V){super(L,F,B,j,U,z,ee,V),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$i(m.Platform.Web)})}async executeTask(L,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=I.from(F,L);if(B===void 0)throw new Error("Task is not valid");if(E.is(B.execution))await this.y(B,F,!1);else throw new s.$_;const j=await this.z(await this.a.$getTaskExecution(B),F);return this.a.$executeTask(B).catch(U=>{throw new Error(U)}),j}v(L,F,B,j){const U=[];if(j)for(const z of j){if(this.A(z,B),!z.definition||!L[z.definition.type]){const V=z.source?z.source:"No task source";this.f.warn(`The task [${V}, ${z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=I.from(z,B.extension);ee&&E.is(ee.execution)?(U.push(ee),F.push(this.y(ee,z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:B.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,F,B){}};e.$Frc=M,e.$Frc=M=Ze([Ve(0,u.$oQ),Ve(1,P.$EQ),Ve(2,O.$6pc),Ve(3,b.$zQ),Ve(4,c.$9pc),Ve(5,y.$uqc),Ve(6,p.$bk),Ve(7,f.$Jpc)],M),e.$Grc=(0,w.$Gi)("IExtHostTask")}),define(ke[334],Ie([1,0,37,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=void 0,e.$AM=C,e.$CM=R;function C(T){return"cellResults"in T}e.$BM="rawCell#";function R(T,O){let b=-1;const c=[];let k=[];return T.forEach(u=>{u.range.startLineNumber!==b&&k.length>0&&(c.push([...k]),k=[]),k.push(u),b=u.range.endLineNumber}),k.length>0&&c.push([...k]),c.map(u=>{const P=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=w;m<=a;m++)P.push(O.getLineContent(m));return new r.$eM(P.join(`
`)+`
`,u.map(m=>new h.$Rt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[335],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,168,24,14,37,263,334,331]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0,y=We(y),a=We(a),m=We(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,S,I,A,$,v,M){this.q=I,this.r=A,this.s=$,this.t=v,this.u=M,this.f=new Map,this.g=new T.$Bc,this.h=new Map,this.j=new C.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Hpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$ON.MainThreadNotebook),this.c=D.getProxy(P.$ON.MainThreadNotebookDocuments),this.d=D.getProxy(P.$ON.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===O.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,F=N.cell.handle,j=this.g.get(L)?.getCell(F);if(j)return j.apiCell}if(N&&N.$mid===O.MarshalledId.NotebookActionContext){const L=N.uri,F=this.g.get(L);if(F)return F.apiNotebook}return N}}),g.C(S)}getEditorById(D){const S=this.h.get(D);if(!S)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(D){for(const[S,I]of this.h)if(I.apiEditor===D)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,S){const I=this.g.get(D);if(!I&&!S)throw new Error(`NO notebook document for '${D}'`);return I}static w(D,S){if(!S)return;const I=S.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(S.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:S.displayName,filenamePattern:I,priority:S.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,S,I){const A=g.a++,$=typeof I.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(A,I),this.b.$registerNotebookCellStatusBarItemProvider(A,$,S);let v;return $!==void 0&&(v=I.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent($))),new m.$QN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,$),v?.dispose()})}async createNotebookDocument(D){const S=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return k.URI.revive(S)}async openNotebookDocument(D){const S=this.g.get(D);if(S)return S.apiNotebook;const I=await this.c.$tryOpenNotebook(D),A=this.g.get(k.URI.revive(I));return(0,c.$qg)(A?.apiNotebook)}async showNotebookDocument(D,S){k.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let I;typeof S=="object"?I={position:a.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(a.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:I={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,I),$=A&&this.h.get(A)?.apiEditor;if($)return $;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,S,I,A){const $=this.f.get(D),v=k.URI.revive(S),M=this.g.get(v);if(!M||!$)return;const N=M.getCellFromIndex(I);if(!N)return;const L=await $.provideCellStatusBarItems(N.apiCell,A);if(!L)return;const F=new R.$Uc,B=this.p.add([F]),U=(Array.isArray(L)?L:[L]).map(z=>a.NotebookStatusBarItem.from(z,this.i,F));return{cacheId:B,items:U}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,S,I,A,$){if((0,b.$df)(S))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:S,serializer:I,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},S,a.NotebookDocumentContentOptions.from(A),g.w(D,$)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,S,I){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const $=await A.serializer.deserializeNotebook(S.buffer,I);return new p.$2w(a.NotebookData.from($))}async $notebookToData(D,S,I){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const $=await A.serializer.serializeNotebook(a.NotebookData.to(S.value),I);return h.$Oe.wrap($)}async $saveNotebook(D,S,I,A,$){const v=k.URI.revive(S),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${I}, ${v.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new y.$wl((0,r.localize)(2696,null,this.A(v)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,s.$no)(N.apiNotebook.metadata,z=>!(M.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of N.apiNotebook.getCells()){const ee=new m.$jP(z.kind,z.document.getText(),z.document.languageId,z.mime,M.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);ee.metadata=(0,s.$no)(z.metadata,V=>!(M.options?.transientCellMetadata??{})[V]),L.cells.push(ee)}if(await this.z(v,A),$.isCancellationRequested)throw new Error("canceled");const F=await M.serializer.serializeNotebook(L,$);if($.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${I} ${v.toString()}`),await this.s.value.writeFile(v,F),this.D(`Finished write versionId: ${I} ${v.toString()}`);const B=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v),U={name:B.basename(v),isFile:(j.type&y.FileType.File)!==0,isDirectory:(j.type&y.FileType.Directory)!==0,isSymbolicLink:(j.type&y.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&y.FilePermission.Locked),etag:y.$Hl({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${I}, ${v.toString()})`),U}async $searchInNotebooks(D,S,I,A,$){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const M=new T.$Cc;await(async(j,U,z)=>{await Promise.all(j.map(async ee=>await Promise.all(ee.filenamePatterns.map(V=>{const W={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:o.QueryType.File,filePattern:V};return this.t.doInternalFileSearchWithCustomCallback(W,U,J=>{J.forEach(_=>{M.has(_)||A.some(ne=>ee.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ye=>(0,l.$uL)(ye,_)))||M.add(_)})}).catch(J=>{if(J.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw J})}))))})(I,$,S);const L=new T.$Bc;let F=!1;const B=Array.from(M).map(async j=>{const U=[];try{if($.isCancellationRequested)return;if(S.maxResults&&[...L.values()].reduce((W,J)=>W+J.cellResults.length,0)>S.maxResults){F=!0;return}const z=[],ee=this.g.get(j);if(ee)ee.apiNotebook.getCells().forEach(J=>z.push({input:J.document.getText(),outputs:J.outputs.flatMap(_=>_.items.map(ce=>ce.data.toString()))}));else{const W=await this.s.value.readFile(j),J=h.$Oe.fromString(W.toString()),_=await v.deserializeNotebook(J.buffer,$);if($.isCancellationRequested)return;a.NotebookData.from(_).cells.forEach(ne=>z.push({input:ne.source,outputs:ne.outputs.flatMap(ye=>ye.items.map(ge=>ge.valueBytes.toString()))}))}if($.isCancellationRequested)return;z.forEach((W,J)=>{const _=S.contentPattern.pattern,ce=new n.$x1b(W.input,void 0,W.outputs),ne=ce.findInInputs(_),ye=ce.findInOutputs(_),ge=ye.flatMap(Y=>(0,d.$CM)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(ne.length>0||ye.length>0){const Y={index:J,contentResults:(0,d.$CM)(ne,ce.inputTextBuffer),webviewResults:ge};U.push(Y)}});const V={resource:j,cellResults:U};L.set(j,V);return}catch{return}});return await Promise.all(B),{limitHit:F,results:[...L.values()]}}async z(D,S){const I=await this.s.value.stat(D);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==y.$Gl&&typeof I.mtime=="number"&&typeof I.size=="number"&&S.mtime<I.mtime&&S.etag!==y.$Hl({mtime:S.mtime,size:I.size}))throw new y.$wl((0,r.localize)(2697,null),y.FileOperationResult.FILE_MODIFIED_SINCE,S)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,S,I){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const A=new i.$0qc(S,this.d,D,I.visibleRanges.map(a.NotebookRange.to),I.selections.map(a.NotebookRange.to),typeof I.viewColumn=="number"?a.ViewColumn.to(I.viewColumn):void 0);this.h.set(S,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const I of D.value.removedDocuments){const A=k.URI.revive(I),$=this.g.get(A);$&&($.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire($.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const I=[];for(const A of D.value.addedDocuments){const $=k.URI.revive(A.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const v=new f.$9qc(this.c,this.q,this.r,$,A);I.push(...A.cells.map(M=>f.$8qc.asModelAddData(M))),this.g.get($)?.dispose(),this.g.set($,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const I of D.value.addedEditors){if(this.h.has(I.id))return;const A=k.URI.revive(I.documentUri),$=this.g.get(A);$&&this.B($,I.id,I)}const S=[];if(D.value.removedEditors)for(const I of D.value.removedEditors){const A=this.h.get(I);A&&(this.h.delete(I),this.k?.id===A.id&&(this.k=void 0),S.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const I=new Set;this.l.forEach(A=>I.add(A.id));for(const A of this.h.values()){const $=I.has(A.id);A._acceptVisibility($)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const S=w.$MQ.String.with("notebookType","A notebook type"),I=new w.$OQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new w.$MQ("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>h.$Oe.wrap($))],new w.$NQ("Notebook Data",$=>a.NotebookData.to($.value))),A=new w.$OQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new w.$MQ("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new p.$2w(a.NotebookData.from($)))],new w.$NQ("Bytes",$=>$.buffer));D.registerApiCommand(I),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$grc=g}),define(ke[336],Ie([1,0,16,20,52,38,22,42,37]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,r=We(r),R=We(R),T=We(T);class c{constructor(u,P,w){this.k=u,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$Bk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$Bk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((w,a)=>{const m=p=>{this.f++,u(p)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(p=>{const f=p.toString(),i=r.$oc(f);this.j&&this.j(f,i)||this.v(m,{base:p,basename:i})}),Promise.all(P.map(p=>this.p(p,m))).then(p=>{w({limitHit:this.e,stats:p[0]||void 0})},p=>{a(new Error((0,C.$rj)(p)))})})}async p(u,P){const w=new h.$xe,a=this.q(u),m=this.r(),p=new b.$sM(this.k,u),f=!p.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=O.$ge.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),o=O.$ge.create();return this.g&&!this.e||(s&&s.forEach(n=>{const d=r.$hc.relative(u.folder.path,n.path);if(f){const l=r.$oc(n.path);this.v(P,{base:u.folder,relativePath:d,basename:l});return}this.s(m,u.folder,d,P)}),this.g&&!this.e)?null:(this.u(m,p,P),{providerTime:t,postProcessTime:o.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const P=(0,b.$rM)(this.k.includePattern,u.includePattern),w=(0,b.$rM)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,w,a){if(w===this.a){const p=r.$oc(this.a);this.v(a,{base:P,relativePath:this.a,basename:p})}function m(p){const f=r.$oc(p),i=r.$nc(p);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:P,relativePath:p,basename:f})}m(w)}u({rootEntries:u,pathToEntries:P},w,a){const m=this,p=this.a;function f(i){const s=(0,b.$uM)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,p!==l?s:void 0))continue;const g=P[d];if(g)f(g);else{if(d===p)continue;m.v(a,n)}if(m.e)break}}f(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class k{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,w,a){const m=this.c(u.cacheKey),p=new c(u,P,m&&m.token);let f=0;const i=s=>{f+=s.length,w(s.map(t=>this.d(t)))};return this.e(p,k.a,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:T.$hh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,w,a){const m=a.onCancellationRequested(()=>{u.cancel()}),p=i=>{i&&(f.push(i),P>0&&f.length>=P&&(w(f),f=[]))};let f=[];return u.search(p).then(i=>(f.length&&w(f),m.dispose(),i),i=>(f.length&&w(f),m.dispose(),Promise.reject(i)))}}e.$$qc=k}),define(ke[337],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,46,11,152,47,160,332,37]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0,e.$tN=I,r=We(r),h=We(h),C=We(C),b=We(b),k=We(k),w=We(w);let o=class{constructor($,v,M,N,L,F){this.a=$,this.b=v,this.c=M,this.d=N,this.e=L,this.f=F}text($,v,M={}){$=this.g($,M);const N=this.a.getValue(),L=v&&v.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.i(v?.map(f.$2i),M),type:t.QueryType.Text,contentPattern:$,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:N.search.usePCRE2||L||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}g($,v){const M=this.a.getValue();$.isRegExp&&($.pattern=$.pattern.replace(/\r?\n/g,"\\n"));const N={...$,wordSeparators:M.editor.wordSeparators};return this.k($,v)&&(N.isCaseSensitive=!0),this.l($)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file($,v={}){return{...this.i($,v),type:t.QueryType.File,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey,shouldGlobMatchFilePattern:v.shouldGlobSearch}}h($,v){return $?($=Array.isArray($)?$.map(E):E($),v?this.parseSearchPaths($):{pattern:d(...Array.isArray($)?$:[$])}):{}}i($=[],v={}){const M=this.h(v.includePattern,v.expandPatterns),N=this.h(v.excludePattern,v.expandPatterns),L=$.length>1,F=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(U=>this.r(U,v,N)):$.map(U=>this.t(U,v,N,L))).filter(U=>!!U),B={_reason:v._reason,folderQueries:F,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:M.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const U=r.$Hb(this.c.groups.flatMap(V=>V.editors.map(W=>W.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const z=U.filter(V=>(0,t.$iM)(B,V.fsPath)),ee=this.j(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ee)),{...B,...ee}}const j=v.extraFileResources&&v.extraFileResources.filter(U=>(0,t.$iM)(B,U.fsPath));return B.extraFileResources=j&&j.length?j:void 0,B}j($){const v=[],M=new T.$Bc,N={};let L=!1;return $.forEach(F=>{if(F.scheme===O.Schemas.walkThrough)return;if((0,c.$lh)(F)){const j=this.b.getWorkspaceFolder(F)?.uri??this.f.extUri.dirname(F);let U=M.get(j);U||(L=!0,U={folder:j,includePattern:{}},v.push(U),M.set(j,U));const z=b.$mc(j.fsPath,F.fsPath);(0,y.$qg)(U.includePattern)[z.replace(/\\/g,"/")]=!0}else F.fsPath&&(L=!0,N[F.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}k($,v){if(v.isSmartCase){if($.isRegExp){if(k.$9f($.pattern,!0))return!0}else if(k.$9f($.pattern))return!0}return!!$.isCaseSensitive}l($){return $.isMultiline||$.isRegExp&&(0,P.$pD)($.pattern)||$.pattern.indexOf(`
`)>=0?!0:!!$.isMultiline}parseSearchPaths($){const v=ee=>b.$jc(ee)||/^\.\.?([\/\\]|$)/.test(ee),N=(Array.isArray($)?$:l($)).map(ee=>{const V=this.e.resolvedUserHome;return V?(0,R.$7w)(ee,V.scheme===O.Schemas.file?V.fsPath:V.path):ee}),L=h.$c(N,ee=>v(ee)?"searchPaths":"exprSegments"),F=(L.exprSegments||[]).map(ee=>k.$of(ee,"/")).map(ee=>k.$of(ee,"\\")).map(ee=>(ee[0]==="."&&(ee="*"+ee),g(ee))),B={},j=this.n(L.searchPaths||[]);j&&j.length&&(B.searchPaths=j);const U=F.flat(),z=d(...U);return z&&(B.pattern=z),B}m($,v){return v.disregardExcludeSettings?void 0:(0,t.$hM)($,!v.disregardSearchExcludeSettings)}n($){if(!$||!$.length)return[];const v=$.flatMap(N=>{let{pathPortion:L,globPortion:F}=n(N);return F&&(F=D(F)),this.o(L).flatMap(j=>this.q(j,F))}),M=new Map;return v.forEach(N=>{const L=N.searchPath.toString(),F=M.get(L);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):M.set(L,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(M.values())}o($){if(b.$jc($)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==O.Schemas.file?[{searchPath:v[0].uri.with({path:$})}]:[{searchPath:u.URI.file(b.$ic($))}]}if(this.b.getWorkbenchState()===f.WorkbenchState.FOLDER){const v=this.b.getWorkspace().folders[0].uri;if($=E($),$.startsWith("../")||$===".."){const N=b.$hc.resolve(v.path,$);return[{searchPath:v.with({path:N})}]}const M=D($);return[{searchPath:v,pattern:M}]}else{if($==="./"||$===".\\")return[];{const v=$.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(L=>{const F=v.match(new RegExp(`^${k.$if(L.name)}(?:/(.*)|$)`));return F?{match:F,folder:L}:null}).filter(y.$ng);if(N.length)return N.map(L=>{const F=L.match[1];return{searchPath:L.folder.uri,pattern:F&&D(F)}});{const L=$.match(/\.[\/\\](.+)[\/\\]?/),F=L?L[1]:$,B=w.localize(12498,null,F);throw new Error(B)}}}}q($,v){const M=$.pattern&&v?`${$.pattern}/${v}`:$.pattern||v,N=[{searchPath:$.searchPath,pattern:M}];return M&&!M.endsWith("**")&&N.push({searchPath:$.searchPath,pattern:M+"/**"}),N}r($,v,M){const N=this.t((0,f.$2i)($.searchPath),v,M,!1);return N?{...N,includePattern:$.pattern}:null}t($,v,M,N){let L;const F=u.URI.isUri($)?$:$.uri;if(M.searchPaths){const ee=M.searchPaths.filter(V=>(0,c.$ah)(V.searchPath,F))[0];if(ee&&!ee.pattern)return null;ee&&(L=ee.pattern)}const B=this.a.getValue({resource:F}),U={...this.m(B,v)||{},...L||{}},z=u.URI.isUri($)?(0,c.$eh)($):$.name;return{folder:F,folderName:N?z:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!B.search.followSymlinks}}};e.$sN=o,e.$sN=o=Ze([Ve(0,a.$aj),Ve(1,f.$Pi),Ve(2,i.$xE),Ve(3,m.$bk),Ve(4,s.$qN),Ve(5,p.$Ll)],o);function n(A){const $=A.match(/[\*\{\}\(\)\[\]\?]/);if($){const v=$.index,M=A.substr(0,v).match(/[/|\\][^/\\]*$/);if(M){let N=A.substr(0,M.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:A.substr((M.index||0)+1)}}}return{pathPortion:A}}function d(...A){return A.length?A.reduce(($,v)=>($[v]=!0,$),Object.create(null)):void 0}function l(A){return C.$zk(A,",").map($=>$.trim()).filter($=>!!$.length)}function g(A){return[`**/${A}/**`,`**/${A}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function E(A){return A.replace(/\\/g,"/")}function D(A){return E(A).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(A){return A.replace(/([?*[\]])/g,"[$1]")}function I(A,$){A=r.$Mb(A,N=>N.toString());const v=[],M=$.getWorkspace();return A&&A.forEach(N=>{let L;if($.getWorkbenchState()===f.WorkbenchState.FOLDER)L=(0,c.$jh)(M.folders[0].uri,N),L&&L!=="."&&(L="./"+L);else{const F=$.getWorkspaceFolder(N);if(F){const B=F.name;if(M.folders.filter(U=>U.name===B).length===1){const U=(0,c.$jh)(F.uri,N);U===""?L=`./${F.name}`:L=`./${F.name}/${U}`}else L=N.fsPath}}L&&v.push(S(L))}),v}}),define(ke[338],Ie([1,0,22,2,20,13,5,337,37,47,7]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kyb=u,e.$Lyb=a,r=We(r),R=We(R);const y=7e3;function u(m,p){const f=p.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const E=g.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?s.push(E):i.push(E)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,k.$zh)(),n=g=>o({activationEvent:g}),d=Promise.all(i.map(g=>P(m,g,n))).then(()=>{}),l=w(m,p.identifier,s,n);return Promise.all([d,l]).then(()=>{o(void 0)}),t}async function P(m,p,f){for(const i of m.folders)if(await m.exists(r.$hh(h.URI.revive(i),p))){f(`workspaceContains:${p}`);return}}async function w(m,p,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new C.$xe,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},y);let n=!1;try{n=await t}catch(d){R.$4(d)||R.$Z(d)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,p,f,i){const s=m.get(T.$Fi),t=m.get(b.$_L),n=s.createInstance(O.$sN).file(p.map(d=>(0,c.$2i)(h.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,49,25,162,13,23,21,249,9,71,5,29,97,19,114,76,48,128,4,338,124,251,14,122,42,10,123]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g,E,D,S,I,A,$,v,M,N,L,F,B,j,U){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Kqc=e.$Jqc=e.$Iqc=e.$Hqc=void 0,r=We(r),h=We(h),C=We(C),f=We(f),e.$Hqc=(0,d.$Gi)("IHostUtils");let ee=z=class extends O.$Vc{constructor(Y,q,oe,ve,ie,ae,se,X,re,pe,we,Me,ze){super(),this.Y=Me,this.Z=ze,this.a=this.B(new $.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=oe,this.f=se,this.j=ve,this.m=ie,this.s=ae,this.t=re,this.u=pe,this.w=we,this.y=this.g.getProxy(y.$ON.MainThreadWorkspace),this.z=this.g.getProxy(y.$ON.MainThreadTelemetry),this.C=this.g.getProxy(y.$ON.MainThreadExtensionService),this.D=new T.$Fh,this.F=new T.$Fh,this.G=new T.$Fh,this.H=new T.$Fh,this.I=new ye(this.f.extensions.activationEvents),this.L=new p.$4dc(this.I,this.f.extensions.allExtensions);const Ae=new i.$tn(this.f.extensions.myExtensions);this.J=new p.$4dc(this.I,ce(this.L,Ae)),j.$u&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new w.$qqc(this.g,this.s),this.N=new M.$Aqc(this.g),this.O=X,this.h=this.q.add(Y.createChild(new D.$Ei([w.$rqc,this.M],[M.$Bqc,this.N]))),this.P=this.B(new P.$pqc(this.J,this.L,{onExtensionActivationError:(De,Ce,H)=>{this.C.$onExtensionActivationError(De,f.$2(Ce),H)},actualActivateExtension:async(De,Ce)=>{if(p.$4dc.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Ce),new P.$oqc;const H=this.J.getExtensionDescription(De);return this.fb(H,Ce)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){f.$Z(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this.eb(ie))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const oe=this.$();Promise.race([(0,T.$Hh)(5e3),oe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$sn(q.identifier.value),extensionLocation:c.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const oe=this.P.getActivatedExtension(Y);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const oe=await this.R.get(q);return c.URI.file(oe)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new ne(Y))),this.Q}async db(Y){const q=b.$Mi.forUris(oe=>R.$$g.ignorePathCasing(oe));return await Promise.all(Y.map(async oe=>{if(this.wb(oe)){const ve=await this.cb(oe.extensionLocation);q.set(ve,oe)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const oe=this.P.getActivatedExtension(Y);if(!oe)return q;try{typeof oe.module.deactivate=="function"&&(q=Promise.resolve(oe.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{oe.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(oe=>{const ve=oe.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Y,q,"success",ve),oe},oe=>{throw this.gb(Y,q,"failure"),oe})}gb(Y,q,oe,ve){const ie=W(Y,q);this.z.$publicLog2("extensionActivationTimes",{...ie,...ve||{},outcome:oe})}hb(Y,q){const oe=W(Y,q);this.z.$publicLog2("activatePlugin",oe);const ve=this.wb(Y);if(!ve)return Promise.resolve(new P.$nqc(P.$kqc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ie=new O.$Uc,ae=new P.$lqc(q.startup);return Promise.all([this.xb(Y,(0,R.$hh)(Y.extensionLocation,ve),ae),this.ib(Y,ie)]).then(se=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),z.jb(this.s,Y.identifier,se[0],se[1],ie,ae))).then(se=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),se))}ib(Y,q){const oe=this.Z.createLanguageModelAccessInformation(Y),ve=q.add(new t.$tqc(Y,this.M)),ie=q.add(new t.$sqc(Y.identifier.value,!1,this.M)),ae=q.add(new N.$Cqc(Y,this.N)),se=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,X=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ve.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const re=this;let pe,we;const Me=(0,m.$iH)(Y,"ipc")?this.f.messagePorts?.get(i.$sn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:ie,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return oe},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(ze){return h.$kc(Y.extensionLocation.fsPath,ze)},get storagePath(){return re.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return re.O.globalValue(Y).fsPath},get logPath(){return h.$kc(re.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(re.f.logsLocation,Y.identifier.value)},get storageUri(){return re.O.workspaceValue(Y)},get globalStorageUri(){return re.O.globalValue(Y)},get extensionMode(){return se},get extension(){return pe===void 0&&(pe=new _(re,Y.identifier,Y,X,!1)),pe},get extensionRuntime(){return(0,m.$jH)(Y,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!we){if(!Me)return;const ze=$.Event.buffer($.Event.fromDOMEventEmitter(Me,"message",Ae=>Ae.data));Me.start(),we={onDidReceiveMessage:ze,postMessage:Me.postMessage.bind(Me)}}return we}})})}static jb(Y,q,oe,ve,ie,ae){return oe=oe||{activate:void 0,deactivate:void 0},this.kb(Y,q,oe,ve,ae).then(se=>new P.$mqc(!1,null,ae.build(),oe,se,(0,O.$Tc)(()=>{ie.dispose(),(0,O.$Qc)(ve.subscriptions)})))}static kb(Y,q,oe,ve,ie){if(typeof oe.activate=="function")try{ie.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const ae=typeof global=="object"?global:self,se=oe.activate.apply(ae,[ve]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(se).then(X=>(ie.activateResolveStop(),X))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(oe)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,oe=>{this.s.error(oe)})}mb(Y,q=0){const ve=Date.now();(0,j.$C)(()=>{for(let ie=q;ie<Y.length;ie+=1){const ae=Y[ie];for(const se of ae.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,ie);break}else this.lb(ae,se)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),oe=this.J.getAllExtensionDescriptions();if(q)this.mb(oe);else for(const ve of oe)if(ve.activationEvents)for(const ie of ve.activationEvents)ie==="onStartupFinished"&&this.lb(ve,ie)})}ob(){const Y=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const q=this.j.workspace?this.j.workspace.folders:[],oe=this.pb(q),ve=this.rb(),ie=Promise.all([ve,Y,oe]).then(()=>{});return Promise.race([ie,(0,T.$Hh)(1e4)]).then(()=>{this.nb()}),ie}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const oe=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(ae=>ae.uri),forceUsingSearch:oe||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,se,X)=>this.y.$checkExists(ae,se,X)},ie=await(0,v.$Kyb)(ve,q);if(ie)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ie.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(r.localize(2688,null));const oe=await this.xb(null,q,new P.$lqc(!1));if(!oe||typeof oe.run!="function")throw new Error(r.localize(2689,null,q.toString()));return new Promise((ve,ie)=>{const ae=(re,pe)=>{re?(j.$u&&this.s.error("Test runner called back with error",re),ie(re)):(j.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof pe=="number"&&pe>0?1:0))},se=(0,R.$8g)(q),X=oe.run(se,ae);X&&X.then&&X.then(()=>{j.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(re=>{j.$u&&this.s.error("Test runner finished with error",re),ie(re instanceof Error&&re.stack?re.stack:String(re))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,O.$Tc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new o.$YN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const oe=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this.S[oe]}}async $resolveAuthority(Y,q){const oe=B.$ge.create(!1),ve=()=>`[resolveAuthority(${(0,n.$Wl)(Y)},${q})][${oe.elapsed()}ms] `,ie=G=>this.s.info(`${ve()}${G}`),ae=G=>this.s.warn(`${ve()}${G}`),se=(G,Z=void 0)=>this.s.error(`${ve()}${G}`,Z),X=G=>{if(G instanceof o.$YN)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},re=async G=>{ie(`activating resolver for ${G}...`);const{resolver:Z,authorityPrefix:x}=await this.ub(G);if(!Z)throw se(`no resolver for ${x}`),new o.$YN(`No remote extension installed to resolve ${x}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:x,remoteAuthority:G}},pe=Y.split(/@|%40/g).reverse();ie(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(re)).catch(async G=>{if(!(G instanceof o.$YN)||G._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return ae(`resolving nested authorities failed: ${G.message}`),[await re(Y)]})}catch(G){return X(G)}const Me=new T.$Rh;Me.cancelAndSet(()=>ie("waiting..."),1e3);let ze,Ae;for(const[G,{authorityPrefix:Z,resolver:x,remoteAuthority:de}]of we.entries())try{if(G===we.length-1)ie("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${Z}`),ze=await x.resolve(de,{resolveAttempt:q,execServer:Ae}),C.mark(`code/extHost/didResolveAuthorityOK/${Z}`),ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,o.$XN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ie(`invoking resolveExecServer() for ${de}`),C.mark(`code/extHost/willResolveExecServer/${Z}`),Ae=await x.resolveExecServer?.(de,{resolveAttempt:q,execServer:Ae}),!Ae)throw new o.$YN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${Z}`),se("returned an error",Ee),Me.dispose(),X(Ee)}Me.dispose();const De={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Ce={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ie(`returned ${o.$XN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let H;if(o.$XN.isManagedResolvedAuthority(ze)){const G=q;this.Y.setFactory(G,ze.makeConnection),H={authority:Y,connectTo:new n.$Tl(G),connectionToken:ze.connectionToken}}else H={authority:Y,connectTo:new n.$Ul(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:H,options:Ce,tunnelInformation:De}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Wl)(Y)})`);const{resolver:oe}=await this.ub(Y);if(!oe)return null;const ve=c.URI.revive(q);if(typeof oe.getCanonicalURI>"u")return ve;const ie=await(0,T.$yh)(()=>oe.getCanonicalURI(ve));return ie||ve}async $startExtensionHost(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:q,myExtensions:oe}=V(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===m.ActivationKind.Immediate?this.D.wait().then(oe=>this.ab(Y,!1)):this.G.wait().then(oe=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:q,myExtensions:oe}=V(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=s.$Oe.alloc(Y),oe=Math.random()%256;for(let ve=0;ve<Y;ve++)q.writeUInt8(oe,ve);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$Iqc=ee,e.$Iqc=ee=z=Ze([Ve(0,d.$Fi),Ve(1,e.$Hqc),Ve(2,E.$oQ),Ve(3,a.$6pc),Ve(4,u.$9pc),Ve(5,k.$bk),Ve(6,l.$EQ),Ve(7,g.$_pc),Ve(8,S.$rGb),Ve(9,I.$uqc),Ve(10,F.$Eqc),Ve(11,U.$Fqc),Ve(12,A.$yqc)],ee);function V(ge,Y,q,oe){ge.addActivationEvents(oe.addActivationEvents);const ve=new p.$4dc(ge,Y.getAllExtensionDescriptions());ve.deltaExtensions(oe.toAdd,oe.toRemove);const ie=new i.$tn(q.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of oe.myToRemove)ie.delete(se);for(const se of oe.myToAdd)ie.add(se);const ae=ce(ve,ie);return{globalRegistry:ve,myExtensions:ae}}function W(ge,Y){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function J(ge){return ge.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Jqc=(0,d.$Gi)("IExtHostExtensionService");class _{#e;#t;#i;constructor(Y,q,oe,ve,ie){this.#e=Y,this.#t=q,this.#i=oe.identifier,this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=h.$ic((0,R.$8g)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ve,this.isFromDifferentExtensionHost=ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Kqc=_;function ce(ge,Y){return ge.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class ne{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Lqc=ne;class ye{constructor(Y){this.a=new i.$un,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(ke[339],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,r=We(r);let a=class{constructor(s,t,o,n,d,l,g){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new p(this.c,t,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,t,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this.a.set(t,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(t=>s.alternativeModuleName(t))}};e.$Wrc=a,e.$Wrc=a=Ze([Ve(2,k.$Fi),Ve(3,R.$9pc),Ve(4,y.$Jqc),Ve(5,c.$EQ),Ve(6,u.$bk)],a);let m=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&w.a.size){const t=(0,P.$if)(this.c(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const t=this.b.exec(this.c(s));if(!t)return;const[,o,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),o+l+d}c(s){return s.replace(/\\/g,"/")}};m=w=Ze([Ve(0,c.$EQ)],m);class p{constructor(s,t,o,n,d){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new O.$un}load(s,t){const o=this.d.findSubstr(t);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(T.$dH,this.e,this.f)}return this.b}}let f=class{constructor(s,t,o){this.e=s,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(C.$ON.MainThreadTelemetry);const n=o.getProxy(C.$ON.MainThreadWindow);this.c=(d,l)=>{const g=h.URI.parse(d);return l?this.g(d,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,d,{}):this.g(d,l)}}load(s,t,o){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=o(s),this.c}g(s,t){return this.i(),this.b(s,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Ze([Ve(2,b.$oQ)],f)}),define(ke[64],Ie([1,0,50,3,16,55,5,63,77,54,9,49,267,41]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0,C=We(C),R=We(R),e.$Mqc=(0,T.$Gi)("IExtHostVariableResolverProvider");class w extends u.$sR{constructor(p,f,i,s,t,o,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof k.$FP||g.input instanceof k.$KP)return g.input.modified;if(g.input instanceof k.$EP||g.input instanceof k.$JP||g.input instanceof k.$HP)return g.input.uri}}}super({getFolderUri:l=>{const g=o.folders.filter(E=>E.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return C.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const g=f.getWorkspaceFolder(l);if(g)return C.$ic(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>p.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let a=class extends h.$Vc{constructor(p,f,i,s,t){super(),this.b=p,this.c=f,this.g=i,this.h=s,this.j=t,this.a=new r.$U(async()=>{const o=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,o,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Nqc=a,e.$Nqc=a=Ze([Ve(0,c.$Jqc),Ve(1,y.$6pc),Ve(2,O.$zQ),Ve(3,P.$9pc),Ve(4,b.$iqc)],a)}),define(ke[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,49,157,119,258,41,64,51,34,15,18,98]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=e.$Wqc=e.$Vqc=e.$Uqc=e.$Tqc=void 0,t=We(t),e.$Tqc=(0,O.$Gi)("IExtHostDebugService");let d=class extends R.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,$,v,M,N,L,F,B){super(),this.Y=$,this.Z=v,this.$=M,this.ab=N,this.bb=L,this.cb=F,this.db=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$me),this.z=this.B(new h.$me),this.C=this.B(new h.$me),this.F=this.B(new h.$me),this.u=A.getProxy(b.$ON.MainThreadDebugService),this.I=this.B(new h.$me),this.L=this.B(new h.$me),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(U=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(A,$){const v=this.gb($);if(!v)return;const M=await this.Q.get(A)?.getTreeItem?.(v);return M?this.eb(A,M):void 0}registerDebugVisualizationTree(A,$,v){const M=T.$sn.toKey(A.identifier),N=this.ub(M,$);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete($)})}async $getVisualizerTreeItemChildren(A,$){const v=this.S.get($)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,$){const v=this.S.get(A);if(!v)return;const M=await this.Q.get(v.provider)?.editItem?.(v.item,$);return this.eb(v.provider,M||v.item)}$disposeVisualizedTree(A){const $=this.S.get(A);if(!$)return;const v=[$.children];for(const M of v)if(M)for(const N of M)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,$){let v=this.R.get($);return v||(v=this.O++,this.R.set($,v),this.S.set(v,{provider:A,item:$})),t.DebugTreeItem.from($,v)}asDebugSourceUri(A,$){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let M=`debug:${encodeURIComponent(v.path||"")}`,N="?";return $&&(M+=`${N}session=${encodeURIComponent($.id)}`,N="&"),M+=`${N}ref=${v.sourceReference}`,C.URI.parse(M)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const $=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const M=v.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,m.$dI)(N)&&$.push(N.type)}this.u.$registerDebugTypes($)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach($=>A.push($)),A}async $resolveDebugVisualizer(A,$){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:M,provider:N,extensionId:L}=v;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,$)||M,v.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(A){const $=this.W.get(A);if(!$)throw new Error(`No debug visualizer found with id '${A}'`);const v=$.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const $=this.w.get(A.sessionId);return $&&{session:$.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,$,v,M){const N=this.gb(v),L=this.ub(A,$),F=this.P.get(L);if(!N||!F)return[];const B=await F.provideDebugVisualization(N,M);return B?B.map(j=>{const U=++this.X;this.W.set(U,{v:j,provider:F,extensionId:A});const z=j.iconPath?this.wb(j.iconPath):void 0;return{id:U,name:j.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.vb(A,j.visualization)}}):[]}$disposeDebugVisualizers(A){for(const $ of A)this.W.delete($)}registerDebugVisualizationProvider(A,$,v){if(!A.contributes?.debugVisualizers?.some(L=>L.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const M=T.$sn.toKey(A.identifier),N=this.ub(M,$);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(M,$),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizer(M,$),this.P.delete($)})}addBreakpoints(A){const $=A.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb($,[],[]);const v=[],M=new Map;for(const N of $)if(N instanceof u.$UO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),v.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$VO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const $=A.filter(L=>this.H.delete(L.id));this.rb([],$,[]);const v=$.filter(L=>L instanceof u.$UO).map(L=>L.id),M=$.filter(L=>L instanceof u.$VO).map(L=>L.id),N=$.filter(L=>L instanceof u.$WO).map(L=>L.id);return this.u.$unregisterBreakpoints(v,M,N)}startDebugging(A,$,v){const M=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,$,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,$,v){if(!$)return new u.$QN(()=>{});const M=this.f++;return this.g.push({type:A,handle:M,provider:$}),this.u.$registerDebugConfigurationProvider(A,v,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$QN(()=>{this.g=this.g.filter(N=>N.provider!==$),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(A,$,v){if(!v)return new u.$QN(()=>{});if(!this.nb(A,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.kb($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:$,handle:M,factory:v}),this.u.$registerDebugAdapterDescriptorFactory($,M),new u.$QN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(A,$){if(!$)return new u.$QN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:$}),new u.$QN(()=>{this.n=this.n.filter(M=>M.factory!==$)})}async $runInTerminal(A,$){return Promise.resolve(void 0)}async $substituteVariables(A,$){let v;const M=await this.tb(A);return M&&(v={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,$)}hb(A,$){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,$){const v=this,M=await this.sb($);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),F=this.hb(L,M);if(!F)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const B=F;return this.M.set(A,B),this.ob(M).then(j=>(j&&this.N.set(A,j),B.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const z=U,ee={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const V=await this.U.sign(z.arguments.value);ee.body={signature:V},B.sendResponse(ee)}else throw new Error("no signer")}catch(V){ee.success=!1,ee.message=V.message,B.sendResponse(ee)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(U),U=(0,m.$iI)(U,!0),v.u.$acceptDAMessage(A,U)}),B.onError(U=>{j&&j.onError&&j.onError(U),this.u.$acceptDAError(A,U.name,U.message,U.stack)}),B.onExit(U=>{j&&j.onExit&&j.onExit(U??void 0,void 0),this.u.$acceptDAExit(A,U??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),B.startSession()))})}$sendDAMessage(A,$){$=(0,m.$hI)($,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage($),this.M.get(A)?.sendMessage($)}$stopDASession(A){const $=this.N.get(A);this.N.delete(A),$&&$.onWillStopSession&&$.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const $=[],v=[],M=[];if(A.added)for(const N of A.added){const L=N.id;if(L&&!this.H.has(L)){let F;if(N.type==="function")F=new u.$VO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")F=new u.$WO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const B=C.URI.revive(N.uri);F=new u.$UO(new u.$5N(B,new u.$RN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$SO)(F,L),this.H.set(L,F),$.push(F)}}if(A.removed)for(const N of A.removed){const L=this.H.get(N);L&&(this.H.delete(N),v.push(L))}if(A.changed){for(const N of A.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof u.$VO&&N.type==="function"){const F=L;F.enabled=N.enabled,F.condition=N.condition,F.hitCondition=N.hitCondition,F.logMessage=N.logMessage,F.functionName=N.functionName}else if(L instanceof u.$UO&&N.type==="source"){const F=L;F.enabled=N.enabled,F.condition=N.condition,F.hitCondition=N.hitCondition,F.logMessage=N.logMessage,F.location=new u.$5N(C.URI.revive(N.uri),new u.$RN(N.line,N.character))}M.push(L)}}}this.rb($,v,M)}async $acceptStackFrameFocus(A){let $;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?$=new u.$3O(v.api,A.threadId):$=new u.$2O(v.api,A.threadId,A.frameId)}this.J=$,this.L.fire(this.J)}$provideDebugConfigurations(A,$,v){return(0,r.$yh)(async()=>{const M=this.mb(A);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb($);return M.provideDebugConfigurations(N,v)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(A,$,v,M){return(0,r.$yh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb($);return N.resolveDebugConfiguration(L,v,M)})}$resolveDebugConfigurationWithSubstitutedVariables(A,$,v,M){return(0,r.$yh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb($);return N.resolveDebugConfigurationWithSubstitutedVariables(L,v,M)})}async $provideDebugAdapter(A,$){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb($);return this.pb(v,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const $=await this.sb(A);this.y.fire($.api)}async $acceptDebugSessionTerminated(A){const $=await this.sb(A);$&&(this.z.fire($.api),this.w.delete($.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,$){(await this.sb(A))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(A,$){const M={session:(await this.sb(A)).api,event:$.event,body:$.body};this.F.fire(M)}jb(A){if(A instanceof u.$XO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$YO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$ZO)return{type:"pipeServer",path:A.path};if(A instanceof u.$1O)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const $=this.j.filter(v=>v.type===A);if($.length>0)return $[0].factory}lb(A){const $=this.j.filter(v=>v.handle===A);if($.length>0)return $[0].factory}mb(A){const $=this.g.filter(v=>v.handle===A);if($.length>0)return $[0].provider}nb(A,$){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const M of v)if(M.label&&M.type&&M.type===$)return!0}}return!1}ob(A){const v=A.configuration.type,M=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$yh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,o.$Hb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,$){const v=$.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$YO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$yh)(()=>A.createDebugAdapterDescriptor($.api,this.qb($,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb($,M))}qb(A,$){}rb(A,$,v){(A.length>0||$.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:$,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const $=this.w.get(A);if($)return $}else{let $=this.w.get(A.id);if(!$){const v=await this.tb(A.folderUri),M=A.parent?this.w.get(A.parent):void 0;$=new l(this.u,A.id,A.type,A.name,v,A.configuration,M?.api),this.w.set($.id,$),this.u.$sessionCached($.id)}return $}throw new Error("cannot find session")}tb(A){if(A){const $=C.URI.revive(A);return this.Y.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}ub(A,$){return`${A}\0${$}`}vb(A,$){if($){if("title"in $&&"command"in $)return{type:a.DebugVisualizationType.Command};if("treeId"in $)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${$.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const $=this.xb(A);let v,M;return"id"in $?M=i.ThemeIcon.asClassName($):v=$,{iconPath:v,iconClass:M}}xb(A){if(A instanceof u.$PO)return{id:A.id};const $=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof $=="string"?C.URI.file($):$,light:typeof v=="string"?C.URI.file(v):v}}};e.$Uqc=d,e.$Uqc=d=Ze([Ve(0,y.$oQ),Ve(1,P.$6pc),Ve(2,k.$Jqc),Ve(3,p.$9pc),Ve(4,c.$iqc),Ve(5,f.$Mqc),Ve(6,s.$KQ),Ve(7,n.$Oqc)],d);class l{constructor(A,$,v,M,N,L,F){this.f=A,this.g=$,this.h=v,this.j=M,this.k=N,this.l=L,this.m=F}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name($){A.j=$,A.f.$setDebugSessionName(A.g,$)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest($,v){return A.f.$customDebugAdapterRequest(A.g,$,v)},getDebugProtocolBreakpoint($){return A.f.$getDebugProtocolBreakpoint(A.g,$.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$Vqc=l;class g{constructor(A){this.value=Object.freeze({append($){A.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$Wqc=g;class E{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach($=>$.onError?$.onError(A):void 0)}onExit(A,$){this.d.forEach(v=>v.onExit?v.onExit(A,$):void 0)}}class D extends w.$eub{constructor(A){super(),this.h=A,A.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends d{constructor(A,$,v,M,N,L,F,B){super(A,$,v,M,N,L,F,B)}};e.$Xqc=S,e.$Xqc=S=Ze([Ve(0,y.$oQ),Ve(1,P.$6pc),Ve(2,k.$Jqc),Ve(3,p.$9pc),Ve(4,c.$iqc),Ve(5,f.$Mqc),Ve(6,s.$KQ),Ve(7,n.$Oqc)],S)}),define(ke[340],Ie([1,0,13,61,2,6,288,11,88,114,29,226,19,72,54,94]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0,r=We(r),h=We(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(O.$bk),o=i.get(u.$oQ).getProxy(R.$ON.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const d=r.$2(n);o.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(O.$bk),t=i.get(u.$oQ),o=i.get(w.$Jqc),n=i.get(a.$IQ),d=t.getProxy(R.$ON.MainThreadExtensionService),l=t.getProxy(R.$ON.MainThreadErrors),g=await o.getExtensionPathIndex(),E=new WeakMap;function D(A,$){if(E.has(A))return E.get(A).stack;let v="",M,N;for(const F of $)v+=`
	at ${F.toString()}`,N=F.getFileName(),!M&&N&&(M=g.findSubstr(C.URI.file(N)));const L=`${A.name||"Error"}: ${A.message||""}${v}`;return E.set(A,{extensionIdentifier:M?.identifier,stack:L}),L}const S=Symbol("prepareStackTrace wrapped");let I=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return I},set(A){if(A===D||!A||A[S]){I=A||D;return}I=function($,v){return D($,v),A.call(Error,$,v)},Object.assign(I,{[S]:!0})}}),r.setUnexpectedErrorHandler(A=>{s.error(A);const $=r.$2(A),v=E.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError($);return}d.$onExtensionRuntimeError(v.extensionIdentifier,$);const M=n.onExtensionError(v.extensionIdentifier,A);s.trace("forwarded error to extension?",M,v)})}}e.$Xrc=m;class p{constructor(i,s,t,o,n){this.a=t,this.b=new T.$_dc(i,null,o),s=p.e(s,this.b);const d=new c.$Ei(...(0,b.$Vs)());d.set(k.$EQ,{_serviceBrand:void 0,...s,messagePorts:n}),d.set(u.$oQ,new u.$pQ(this.b)),d.set(P.$3pc,new P.$4pc(o)),d.set(w.$Hqc,t);const l=new y.$zr(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(O.$bk)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(g=>g.get(w.$Jqc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$ON.MainThreadExtensionService);return C.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=C.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=C.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>C.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$Yrc=p}),define(ke[341],Ie([1,0,7,10,8,219,150,101,77,54,19,48,9,64,49,259,260,41,34,98]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=void 0,h=We(h),C=We(C);let s=class extends O.$Uqc{constructor(l,g,E,D,S,I,A,$,v){super(l,g,E,D,I,A,$,v),this.Ab=S,this.yb=new n}hb(l,g){switch(l.type){case"server":return new a.$4rc(l);case"pipeServer":return new a.$5rc(l);case"executable":return new a.$6rc(l,g.type)}return super.hb(l,g)}qb(l,g){const E=a.$6rc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(E)return new u.$XO(E.command,E.args,E.options)}ib(){return new T.$_hc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(B=>{this.yb.onTerminalClosed(B)})));const E=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),S=this.Ab.getDefaultShellArgs(!0),I=l.title||C.localize(2718,null),A=JSON.stringify({shell:D,shellArgs:S});let $=await this.yb.checkout(A,I),v,M=!1;if($)v=l.cwd;else{const B={shellPath:D,shellArgs:S,cwd:l.cwd,name:I,iconPath:new u.$PO("debug")};M=!0,$=this.Ab.createTerminalFromOptions(B,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert($,A)}$.show(!0);const N=await $.processId;M?await new Promise(B=>setTimeout(B,1e3)):($.state.isInteractedWith&&($.sendText(""),await(0,r.$Hh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?$.sendText("cls"):D.indexOf("bash")>=0?$.sendText("clear"):h.$j?$.sendText("cls"):$.sendText("clear")));const L=(0,m.$8rc)(D,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);$.sendText(L);const F=this.onDidTerminateDebugSession(B=>{B.id===g&&(this.yb.free($),F.dispose())});return N}else if(l.kind==="external")return o(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$9rc=s,e.$9rc=s=Ze([Ve(0,k.$oQ),Ve(1,w.$6pc),Ve(2,c.$Jqc),Ve(3,p.$9pc),Ve(4,y.$uqc),Ve(5,b.$iqc),Ve(6,P.$Mqc),Ve(7,f.$KQ),Ve(8,i.$Oqc)],s);let t;function o(d,l){if(!t)if(h.$j)t=new R.$Tgc;else if(h.$k)t=new R.$Ugc;else if(h.$l)t=new R.$Vgc;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,E=!1){const S=[...this.b.entries()].map(([I,A])=>(0,r.$th)(async $=>{if(I.name!==g||A.lastUsedAt!==-1&&await(0,m.$7rc)(await I.processId))return null;const v=Date.now();return A.lastUsedAt+n.a>v||$.isCancellationRequested?null:A.config!==l?(E&&I.dispose(),null):(A.lastUsedAt=v,I)}));return await(0,r.$Lh)(S,I=>!!I)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(ke[342],Ie([1,0,16,2,109,49,63,41,47,48,19,29,100,14,11,95,22,66,64]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=void 0,r=We(r),m=We(m);let i=class extends u.$Erc{constructor(t,o,n,d,l,g,E,D,S){super(t,o,n,d,l,g,E,D),this.C=n,this.D=S,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,o);return this.a.$executeTask(d).catch(()=>{}),g}else{const d=u.TaskDTO.from(o,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,o,!1);const l=await this.z(await this.a.$getTaskExecution(d),o);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,o,n,d){const l=[];if(d)for(const g of d){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(g,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&o.push(this.y(E,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=h.URI.file((0,p.homedir)());o=new b.$1i({uri:n,name:m.$eh(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),D=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const S of o.variables)d.variables[S]=await E.resolveAsync(D,S);if(o.process!==void 0){let S;if(o.process.path!==void 0){S=o.process.path.split(r.$uc);for(let I=0;I<S.length;I++)S[I]=await E.resolveAsync(D,S[I])}d.process=await C.win32.findExecutable(await E.resolveAsync(D,o.process.name),o.process.cwd!==void 0?await E.resolveAsync(D,o.process.cwd):void 0,S)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return C.win32.findExecutable(t,o,n)}};e.$1rc=i,e.$1rc=i=Ze([Ve(0,k.$oQ),Ve(1,y.$EQ),Ve(2,R.$6pc),Ve(3,T.$zQ),Ve(4,O.$9pc),Ve(5,c.$uqc),Ve(6,w.$bk),Ve(7,a.$Jpc),Ve(8,f.$Mqc)],i)}),define(ke[343],Ie([1,0,66,64]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=void 0;class C extends h.$Nqc{m(){return(0,r.homedir)()}}e.$Gsc=C}),define(ke[174],Ie([1,0,18,7,20,52,14,16,22,2,37]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=e.$arc=e.$_qc=void 0,e.$brc=a,O=We(O),b=We(b);class y{constructor(f,i,s){this.d=f,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,i){const s=this.g.folderQueries||[],t=new C.$xe(i);return new Promise((o,n)=>{this.a=new P(f);let d=!1;const l=(g,E)=>{if(!d&&!this.b){const D=this.h(g);a(g)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),g=this.j(g,this.g.maxResults-this.c));const S=this.h(g);this.c+=S,(S>0||!a(g))&&this.a.add(g,E)}};Promise.all(s.map((g,E)=>this.k(g,D=>l(D,E),t.token))).then(g=>{t.dispose(),this.a.flush();const E=g.some(D=>!!D&&!!D.limitHit);o({limitHit:this.b||E,messages:g.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},g=>{t.dispose();const E=(0,R.$rj)(g);n(new Error(E))})})}h(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async k(f,i,s){const t=new k.$sM(this.g,f),o=[],n={report:g=>{if(!this.l(g))return;const E=f.folder.scheme===T.Schemas.file?(0,k.$tM)(()=>this.e.readdir(b.$gh(g.uri))):void 0,D=b.$jh(f.folder,g.uri);if(D){const S=t.includedInQuery(D,O.$oc(D),E);(0,h.$sh)(S)?o.push(S.then(I=>{I&&i(g)})):S&&i(g)}}},d=this.n(f);let l;return this.d.query.type===k.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,s),o.length&&await Promise.all(o),l}l(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const i=(0,k.$rM)(this.g.includePattern,f.includePattern),s=(0,k.$rM)(this.g.excludePattern,f.excludePattern),t={folder:c.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??k.$$L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$_qc=y;function u(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class P{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(f,i){this.d&&(this.b!==i||!b.$ah(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:f.uri,results:[]}),this.d.results.push(w(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$arc=P;function w(p){return a(p)?{preview:{matches:(0,r.$1b)(p.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:p.preview.text},ranges:(0,r.$1b)(p.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function a(p){return!!p.preview}class m{static{this.a=4e3}static{this.b=50}constructor(f,i){this.g=f,this.h=i,this.c=0,this.d=[],this.e=0}addItem(f,i){f&&this.j(f,i)}addItems(f,i){f&&this.k(f,i)}j(f,i){this.d.push(f),this.e+=i,this.l()}k(f,i){this.d=this.d.concat(f),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$crc=m}),define(ke[102],Ie([1,0,3,6,5,336,19,72,11,2,174]),function($e,e,r,h,C,R,T,O,b,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=e.$drc=void 0,e.$frc=u,e.$drc=(0,C.$Gi)("IExtHostSearch");let y=class{constructor(a,m,p){this.n=a,this.o=m,this.q=p,this.c=this.n.getProxy(h.$ON.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$$qc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const p=this.d++;return this.e.set(p,m),this.c.$registerTextSearchProvider(p,this.s(a)),(0,r.$Tc)(()=>{this.g.delete(a),this.e.delete(p),this.c.$unregisterProvider(p)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const p=this.d++;return this.h.set(p,m),this.c.$registerAITextSearchProvider(p,this.s(a)),(0,r.$Tc)(()=>{this.i.delete(a),this.h.delete(p),this.c.$unregisterProvider(p)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const p=this.d++;return this.j.set(p,m),this.c.$registerFileSearchProvider(p,this.s(a)),(0,r.$Tc)(()=>{this.k.delete(a),this.j.delete(p),this.c.$unregisterProvider(p)})}$provideFileSearchResults(a,m,p,f){const i=u(p),s=this.j.get(a);if(s)return this.l.fileSearch(i,s,t=>{this.c.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,p){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,p,f){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u(p);return this.t(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,p,f){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u(p);return this.v(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}t(a,m){return new k.$_qc({query:a,provider:m},{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"textSearchProvider")}v(a,m){return new k.$_qc({query:a,provider:m},{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"aiTextSearchProvider")}};e.$erc=y,e.$erc=y=Ze([Ve(0,T.$oQ),Ve(1,O.$3pc),Ve(2,b.$bk)],y);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[344],Ie([1,0,7,20,13,4,3,14,43,2,113,202,203,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,166,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,172,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,48,170,98,320,293,321,322,76,15,9,283,72,284,96,323,324,165,49,119,93,25,99]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g,E,D,S,I,A,$,v,M,N,L,F,B,j,U,z,ee,V,W,J,_,ce,ne,ye,ge,Y,q,oe,ve,ie,ae,se,X,re,pe,we,Me,ze,Ae,De,Ce,H,G,Z,x,de,Ee,Te,He,Ke,et,nt,st,rt,at,gt,dt,ct,Pe,Be,Qe,Ne,je,ue,he,le,Xe,tt,ut,mt,Dt,Ft,Ht,ti,oi,Ot,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=hi,C=We(C),b=Ut(b),u=We(u),a=We(a),he=We(he),le=We(le);function hi(bt){const St=bt.get(ge.$EQ),ii=bt.get(ye.$Npc),ni=bt.get(ce.$$pc),qt=bt.get(J.$Jqc),pt=bt.get(ti.$6pc),Bt=bt.get(gt.$IQ),ri=bt.get($.$9pc),ai=bt.get(tt.$3pc),xe=bt.get(de.$oQ),ci=bt.get(st.$rqc),di=bt.get(rt.$_pc),fi=bt.get(m.$ck),vt=bt.get(m.$bk),jt=bt.get(ue.$rGb),Nt=bt.get(n.$Jpc),Gt=bt.get(Ht.$Rrc),si=bt.get(He.$Bqc),Jt=bt.get(ee.$iqc),li=bt.get(X.$Fqc),Wt=bt.get(d.$Tpc),Kt=bt.get(ie.$yqc);xe.set(s.$PN.ExtHostFileSystemInfo,ii),xe.set(s.$PN.ExtHostLogLevelServiceShape,fi),xe.set(s.$PN.ExtHostWorkspace,pt),xe.set(s.$PN.ExtHostConfiguration,ri),xe.set(s.$PN.ExtHostExtensionService,qt),xe.set(s.$PN.ExtHostStorage,ci),xe.set(s.$PN.ExtHostTunnelService,jt),xe.set(s.$PN.ExtHostWindow,Gt),xe.set(s.$PN.ExtHostSecretState,si),xe.set(s.$PN.ExtHostTelemetry,Bt),xe.set(s.$PN.ExtHostEditorTabs,Jt),xe.set(s.$PN.ExtHostManagedSockets,li),xe.set(s.$PN.ExtHostAuthentication,Wt),xe.set(s.$PN.ExtHostChatProvider,Kt);const Zt=xe.set(s.$PN.ExtHostDecorations,bt.get(N.$Zqc)),Mt=xe.set(s.$PN.ExtHostDocumentsAndEditors,bt.get(z.$zQ)),wt=xe.set(s.$PN.ExtHostCommands,bt.get(I.$KQ)),It=xe.set(s.$PN.ExtHostTerminalService,bt.get(dt.$uqc)),Qt=xe.set(s.$PN.ExtHostTerminalShellIntegration,bt.get(ct.$Hrc)),Pt=xe.set(s.$PN.ExtHostDebugService,bt.get(M.$Tqc)),mi=xe.set(s.$PN.ExtHostSearch,bt.get(Te.$drc)),xt=xe.set(s.$PN.ExtHostTask,bt.get(at.$Grc)),ki=xe.set(s.$PN.ExtHostOutputService,bt.get(Ce.$trc)),wi=xe.set(s.$PN.ExtHostLocalization,bt.get(se.$Eqc)),Oi=xe.set(s.$PN.ExtHostUrls,new ut.$Orc(xe)),Tt=xe.set(s.$PN.ExtHostDocuments,new U.$Qpc(xe,Mt)),Ni=xe.set(s.$PN.ExtHostDocumentContentProviders,new B.$2qc(xe,Mt,vt)),ui=xe.set(s.$PN.ExtHostDocumentSaveParticipant,new j.$3qc(vt,Tt,xe.getProxy(s.$ON.MainThreadBulkEdits))),Rt=xe.set(s.$PN.ExtHostNotebook,new pe.$grc(xe,wt,Mt,Tt,ni,mi,vt)),Ti=xe.set(s.$PN.ExtHostNotebookDocuments,new Me.$nrc(Rt)),Ii=xe.set(s.$PN.ExtHostNotebookEditors,new ze.$orc(vt,Rt)),Si=xe.set(s.$PN.ExtHostNotebookKernels,new Ae.$prc(xe,St,Rt,wt,vt)),ji=xe.set(s.$PN.ExtHostNotebookRenderers,new De.$rrc(xe,Rt)),$i=xe.set(s.$PN.ExtHostNotebookDocumentSaveParticipant,new we.$mrc(vt,Rt,xe.getProxy(s.$ON.MainThreadBulkEdits))),Vt=xe.set(s.$PN.ExtHostEditors,new Be.$Zpc(xe,Mt)),Pi=xe.set(s.$PN.ExtHostTreeViews,new je.$Mrc(xe.getProxy(s.$ON.MainThreadTreeViews),wt,vt)),Re=xe.set(s.$PN.ExtHostEditorInsets,new S.$1pc(xe.getProxy(s.$ON.MainThreadEditorInsets),Vt,St.remote)),Fe=xe.set(s.$PN.ExtHostDiagnostics,new L.$Ppc(xe,vt,ii,Mt)),Se=xe.set(s.$PN.ExtHostLanguages,new ae.$krc(xe,Tt,wt.converter,ai)),te=xe.set(s.$PN.ExtHostLanguageFeatures,new oe.$Rpc(xe,ai,Tt,wt,Fe,vt,Nt,Bt)),Le=xe.set(s.$PN.ExtHostFileSystem,new _.$6qc(xe,te)),Ge=xe.set(s.$PN.ExtHostFileSystemEventService,new ne.$7qc(xe,vt,Mt)),_e=xe.set(s.$PN.ExtHostQuickOpen,(0,x.$xrc)(xe,pt,wt)),Je=xe.set(s.$PN.ExtHostSCM,new Ee.$zrc(xe,wt,Tt,vt)),ft=xe.set(s.$PN.ExtHostQuickDiff,new Z.$wrc(xe,ai)),At=xe.set(s.$PN.ExtHostShare,new Ke.$Arc(xe,ai)),Xt=xe.set(s.$PN.ExtHostComments,(0,A.$2pc)(xe,wt,Tt)),_t=xe.set(s.$PN.ExtHostProgress,new G.$vrc(xe.getProxy(s.$ON.MainThreadProgress))),zt=xe.set(s.$PN.ExtHostLabelService,new q.$irc(xe)),ei=xe.set(s.$PN.ExtHostTheming,new Qe.$Jrc(xe)),rn=xe.set(s.$PN.ExtHostTimeline,new Ne.$Lrc(xe,wt)),Vi=xe.set(s.$PN.ExtHostWebviews,new mt.$dqc(xe,St.remote,pt,vt,Nt)),Bi=xe.set(s.$PN.ExtHostWebviewPanels,new Dt.$gqc(xe,Vi,pt)),Hi=xe.set(s.$PN.ExtHostCustomEditors,new v.$hqc(xe,Tt,di,Vi,Bi)),Gi=xe.set(s.$PN.ExtHostWebviewViews,new Ft.$Prc(xe,Vi)),Ci=xe.set(s.$PN.ExtHostTesting,bt.get(Pe.$Oqc)),sn=xe.set(s.$PN.ExtHostUriOpeners,new Xe.$Nrc(xe)),on=xe.set(s.$PN.ExtHostProfileContentHandlers,new H.$urc(xe));xe.set(s.$PN.ExtHostInteractive,new Y.$hrc(xe,Rt,Mt,wt,vt));const Mi=xe.set(s.$PN.ExtHostChatAgents2,new g.$Wpc(xe,vt,wt,Tt)),an=xe.set(s.$PN.ExtHostChatVariables,new E.$Xpc(xe)),zi=xe.set(s.$PN.ExtHostLanguageModelTools,new ve.$jrc(xe)),Qi=xe.set(s.$PN.ExtHostAiRelatedInformation,new t.$Ipc(xe)),yn=xe.set(s.$PN.ExtHostAiEmbeddingVector,new W.$5qc(xe)),cn=xe.set(s.$PN.ExtHostStatusBar,new nt.$Drc(xe,wt.converter)),Ki=xe.set(s.$PN.ExtHostSpeech,new et.$Brc(xe)),Ai=xe.set(s.$PN.ExtHostEmbeddings,new V.$4qc(xe)),Sn=Object.values(s.$PN);xe.assertRegistered(Sn);const Dn=new l.$Vpc(xe,Mt),ln=new D.$Ypc(xe),Ji=new re.$lrc(xe,vt),Zi=new F.$1qc(xe);return o.$Spc.register(wt),function(qe,vi,Xi){function lt(fe){return(be,Ue,ht)=>{const Et=fe(Lt=>{try{be.call(Ue,Lt)}catch(gi){C.$1(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),Bt.onExtensionError(qe.identifier,gi)}});return ht?.push(Et),Et}}const kt=function(){let fe=!qe.isUnderDevelopment;function be(){fe||(vt.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(ht){if(Array.isArray(ht))ht.forEach(Ue);else if(typeof ht=="string")be();else{const Et=ht;typeof Et.scheme>"u"&&be(),typeof Et.exclusive=="boolean"&&(0,it.$jH)(qe,"documentFiltersExclusive")}return ht}}(),Yi={getSession(fe,be,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,it.$jH)(qe,"authLearnMore"),Wt.getSession(qe,fe,be,Ue)},getAccounts(fe){return Wt.getAccounts(fe)},async hasSession(fe,be){return(0,it.$jH)(qe,"authSession"),!!await Wt.getSession(qe,fe,be,{silent:!0})},get onDidChangeSessions(){return lt(Wt.onDidChangeSessions)},registerAuthenticationProvider(fe,be,Ue,ht){return Wt.registerAuthenticationProvider(fe,be,Ue,ht)}},un={registerCommand(fe,be,Ue){return wt.registerCommand(!0,fe,be,Ue,void 0,qe)},registerTextEditorCommand(fe,be,Ue){return wt.registerCommand(!0,fe,(...ht)=>{const Et=Vt.getActiveTextEditor();if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return Et.edit(Lt=>{be.apply(Ue,[Et,Lt,...ht])}).then(Lt=>{Lt||vt.warn("Edits from command "+fe+" were not applied.")},Lt=>{vt.warn("An error occurred while running command "+fe,Lt)})},void 0,void 0,qe)},registerDiffInformationCommand:(fe,be,Ue)=>((0,it.$jH)(qe,"diffCommand"),wt.registerCommand(!0,fe,async(...ht)=>{const Et=Mt.activeEditor(!0);if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Lt=await Vt.getDiffInformation(Et.id);be.apply(Ue,[Lt,...ht])},void 0,void 0,qe)),executeCommand(fe,...be){return wt.executeCommand(fe,...be)},getCommands(fe=!1){return wt.getCommands(fe)}},Ei={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return lt(It.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$jH)(qe,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$jH)(qe,"telemetry"),lt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,gt.$HQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,be){return gt.$GQ.validateSender(fe),Bt.instantiateLogger(qe,fe,be)},openExternal(fe,be){return Gt.openUri(fe,{allowTunneling:!!St.remote.authority,allowContributedOpeners:be?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===St.environment.appUriScheme)return Oi.createAppUri(fe);try{return await Gt.asExternalUri(fe,{allowTunneling:!!St.remote.authority})}catch(be){if((0,O.$Pg)(fe,O.Schemas.http)||(0,O.$Pg)(fe,O.Schemas.https))return fe;throw be}},get remoteName(){return(0,p.$jn)(St.remote.authority)},get remoteAuthority(){return(0,it.$jH)(qe,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return lt(vt.onDidChangeLogLevel)},get appQuality(){return(0,it.$jH)(qe,"resolvers"),St.quality},get appCommit(){return(0,it.$jH)(qe,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Ei);const Ui={createTestController(fe,be,Ue){return Ci.createTestController(qe,fe,be,Ue)},createTestObserver(){return(0,it.$jH)(qe,"testObserver"),Ci.createTestObserver()},runTests(fe){return(0,it.$jH)(qe,"testObserver"),Ci.runTests(fe)},registerTestFollowupProvider(fe){return(0,it.$jH)(qe,"testObserver"),Ci.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,it.$jH)(qe,"testObserver"),lt(Ci.onResultsChanged)},get testResults(){return(0,it.$jH)(qe,"testObserver"),Ci.results}},qi=St.remote.isRemote?le.ExtensionKind.Workspace:le.ExtensionKind.UI,pi={getExtension(fe,be){(0,it.$iH)(qe,"extensionsAny")||(be=!1);const Ue=vi.mine.getExtensionDescription(fe);if(Ue)return new J.$Kqc(qt,qe.identifier,Ue,qi,!1);if(be){const ht=vi.all.getExtensionDescription(fe);if(ht)return new J.$Kqc(qt,qe.identifier,ht,qi,!0)}},get all(){const fe=[];for(const be of vi.mine.getAllExtensionDescriptions())fe.push(new J.$Kqc(qt,qe.identifier,be,qi,!1));return fe},get allAcrossExtensionHosts(){(0,it.$jH)(qe,"extensionsAny");const fe=new w.$tn(vi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),be=[];for(const Ue of vi.all.getAllExtensionDescriptions()){const ht=!fe.has(Ue.identifier);be.push(new J.$Kqc(qt,qe.identifier,Ue,qi,ht))}return be},get onDidChange(){return(0,it.$iH)(qe,"extensionsAny")?lt(R.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):lt(vi.mine.onDidChange)}},Wi={createDiagnosticCollection(fe){return Fe.createDiagnosticCollection(qe.identifier,fe)},get onDidChangeDiagnostics(){return lt(Fe.onDidChangeDiagnostics)},getDiagnostics:fe=>Fe.getDiagnostics(fe),getLanguages(){return Se.getLanguages()},setTextDocumentLanguage(fe,be){return Se.changeLanguage(fe.uri,be)},match(fe,be){const Ue=he.LanguageSelector.from(fe);let ht;return(0,y.$Au)(Ue)&&(ht=Rt.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Lt=>Lt.document===be))?.apiNotebook),(0,y.$zu)(Ue,be.uri,be.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(fe,be,Ue){return te.registerCodeActionProvider(qe,kt(fe),be,Ue)},registerDocumentPasteEditProvider(fe,be,Ue){return(0,it.$jH)(qe,"documentPaste"),te.registerDocumentPasteEditProvider(qe,kt(fe),be,Ue)},registerCodeLensProvider(fe,be){return te.registerCodeLensProvider(qe,kt(fe),be)},registerDefinitionProvider(fe,be){return te.registerDefinitionProvider(qe,kt(fe),be)},registerDeclarationProvider(fe,be){return te.registerDeclarationProvider(qe,kt(fe),be)},registerImplementationProvider(fe,be){return te.registerImplementationProvider(qe,kt(fe),be)},registerTypeDefinitionProvider(fe,be){return te.registerTypeDefinitionProvider(qe,kt(fe),be)},registerHoverProvider(fe,be){return te.registerHoverProvider(qe,kt(fe),be,qe.identifier)},registerEvaluatableExpressionProvider(fe,be){return te.registerEvaluatableExpressionProvider(qe,kt(fe),be,qe.identifier)},registerInlineValuesProvider(fe,be){return te.registerInlineValuesProvider(qe,kt(fe),be,qe.identifier)},registerDocumentHighlightProvider(fe,be){return te.registerDocumentHighlightProvider(qe,kt(fe),be)},registerMultiDocumentHighlightProvider(fe,be){return te.registerMultiDocumentHighlightProvider(qe,kt(fe),be)},registerLinkedEditingRangeProvider(fe,be){return te.registerLinkedEditingRangeProvider(qe,kt(fe),be)},registerReferenceProvider(fe,be){return te.registerReferenceProvider(qe,kt(fe),be)},registerRenameProvider(fe,be){return te.registerRenameProvider(qe,kt(fe),be)},registerNewSymbolNamesProvider(fe,be){return(0,it.$jH)(qe,"newSymbolNamesProvider"),te.registerNewSymbolNamesProvider(qe,kt(fe),be)},registerDocumentSymbolProvider(fe,be,Ue){return te.registerDocumentSymbolProvider(qe,kt(fe),be,Ue)},registerWorkspaceSymbolProvider(fe){return te.registerWorkspaceSymbolProvider(qe,fe)},registerDocumentFormattingEditProvider(fe,be){return te.registerDocumentFormattingEditProvider(qe,kt(fe),be)},registerDocumentRangeFormattingEditProvider(fe,be){return te.registerDocumentRangeFormattingEditProvider(qe,kt(fe),be)},registerOnTypeFormattingEditProvider(fe,be,Ue,...ht){return te.registerOnTypeFormattingEditProvider(qe,kt(fe),be,[Ue].concat(ht))},registerDocumentSemanticTokensProvider(fe,be,Ue){return te.registerDocumentSemanticTokensProvider(qe,kt(fe),be,Ue)},registerDocumentRangeSemanticTokensProvider(fe,be,Ue){return te.registerDocumentRangeSemanticTokensProvider(qe,kt(fe),be,Ue)},registerSignatureHelpProvider(fe,be,Ue,...ht){return typeof Ue=="object"?te.registerSignatureHelpProvider(qe,kt(fe),be,Ue):te.registerSignatureHelpProvider(qe,kt(fe),be,typeof Ue>"u"?[]:[Ue,...ht])},registerCompletionItemProvider(fe,be,...Ue){return te.registerCompletionItemProvider(qe,kt(fe),be,Ue)},registerInlineCompletionItemProvider(fe,be,Ue){return be.handleDidShowCompletionItem&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),be.handleDidPartiallyAcceptCompletionItem&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),Ue&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),te.registerInlineCompletionsProvider(qe,kt(fe),be,Ue)},registerInlineEditProvider(fe,be){return(0,it.$jH)(qe,"inlineEdit"),te.registerInlineEditProvider(qe,kt(fe),be)},registerDocumentLinkProvider(fe,be){return te.registerDocumentLinkProvider(qe,kt(fe),be)},registerColorProvider(fe,be){return te.registerColorProvider(qe,kt(fe),be)},registerFoldingRangeProvider(fe,be){return te.registerFoldingRangeProvider(qe,kt(fe),be)},registerSelectionRangeProvider(fe,be){return te.registerSelectionRangeProvider(qe,fe,be)},registerCallHierarchyProvider(fe,be){return te.registerCallHierarchyProvider(qe,fe,be)},registerTypeHierarchyProvider(fe,be){return te.registerTypeHierarchyProvider(qe,fe,be)},setLanguageConfiguration:(fe,be)=>te.setLanguageConfiguration(qe,fe,be),getTokenInformationAtPosition(fe,be){return(0,it.$jH)(qe,"tokenInformation"),Se.tokenAtPosition(fe,be)},registerInlayHintsProvider(fe,be){return te.registerInlayHintsProvider(qe,fe,be)},createLanguageStatusItem(fe,be){return Se.createLanguageStatusItem(qe,fe,be)},registerDocumentDropEditProvider(fe,be,Ue){return te.registerDocumentOnDropEditProvider(qe,fe,be,(0,it.$iH)(qe,"documentPaste")?Ue:void 0)}},hn={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(fe,be,Ue){c.URI.isUri(fe)&&fe.scheme===O.Schemas.vscodeRemote&&!fe.authority&&Nt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await(c.URI.isUri(fe)?Promise.resolve(xi.openTextDocument(fe)):Promise.resolve(fe));return Vt.showTextDocument(ht,be,Ue)},createTextEditorDecorationType(fe){return Vt.createTextEditorDecorationType(qe,fe)},onDidChangeActiveTextEditor(fe,be,Ue){return lt(Vt.onDidChangeActiveTextEditor)(fe,be,Ue)},onDidChangeVisibleTextEditors(fe,be,Ue){return lt(Vt.onDidChangeVisibleTextEditors)(fe,be,Ue)},onDidChangeTextEditorSelection(fe,be,Ue){return lt(Vt.onDidChangeTextEditorSelection)(fe,be,Ue)},onDidChangeTextEditorOptions(fe,be,Ue){return lt(Vt.onDidChangeTextEditorOptions)(fe,be,Ue)},onDidChangeTextEditorVisibleRanges(fe,be,Ue){return lt(Vt.onDidChangeTextEditorVisibleRanges)(fe,be,Ue)},onDidChangeTextEditorViewColumn(fe,be,Ue){return lt(Vt.onDidChangeTextEditorViewColumn)(fe,be,Ue)},onDidCloseTerminal(fe,be,Ue){return lt(It.onDidCloseTerminal)(fe,be,Ue)},onDidOpenTerminal(fe,be,Ue){return lt(It.onDidOpenTerminal)(fe,be,Ue)},onDidChangeActiveTerminal(fe,be,Ue){return lt(It.onDidChangeActiveTerminal)(fe,be,Ue)},onDidChangeTerminalDimensions(fe,be,Ue){return(0,it.$jH)(qe,"terminalDimensions"),lt(It.onDidChangeTerminalDimensions)(fe,be,Ue)},onDidChangeTerminalState(fe,be,Ue){return lt(It.onDidChangeTerminalState)(fe,be,Ue)},onDidWriteTerminalData(fe,be,Ue){return(0,it.$jH)(qe,"terminalDataWriteEvent"),lt(It.onDidWriteTerminalData)(fe,be,Ue)},onDidExecuteTerminalCommand(fe,be,Ue){return(0,it.$jH)(qe,"terminalExecuteCommandEvent"),lt(It.onDidExecuteTerminalCommand)(fe,be,Ue)},onDidChangeTerminalShellIntegration(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidChangeTerminalShellIntegration)(fe,be,Ue)},onDidStartTerminalShellExecution(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidStartTerminalShellExecution)(fe,be,Ue)},onDidEndTerminalShellExecution(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidEndTerminalShellExecution)(fe,be,Ue)},get state(){return Gt.getState()},onDidChangeWindowState(fe,be,Ue){return lt(Gt.onDidChangeWindowState)(fe,be,Ue)},showInformationMessage(fe,...be){return Ji.showMessage(qe,b.default.Info,fe,be[0],be.slice(1))},showWarningMessage(fe,...be){return Ji.showMessage(qe,b.default.Warning,fe,be[0],be.slice(1))},showErrorMessage(fe,...be){return Ji.showMessage(qe,b.default.Error,fe,be[0],be.slice(1))},showQuickPick(fe,be,Ue){return _e.showQuickPick(qe,fe,be,Ue)},showWorkspaceFolderPick(fe){return _e.showWorkspaceFolderPick(fe)},showInputBox(fe,be){return _e.showInput(fe,be)},showOpenDialog(fe){return Zi.showOpenDialog(qe,fe)},showSaveDialog(fe){return Zi.showSaveDialog(fe)},createStatusBarItem(fe,be,Ue){let ht,Et,Lt;return typeof fe=="string"?(ht=fe,Et=be,Lt=Ue):(Et=fe,Lt=be),cn.createStatusBarEntry(qe,ht,Et,Lt)},setStatusBarMessage(fe,be){return cn.setStatusBarMessage(fe,be)},withScmProgress(fe){return Nt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),_t.withProgress(qe,{location:le.ProgressLocation.SourceControl},(be,Ue)=>fe({report(ht){}}))},withProgress(fe,be){return _t.withProgress(qe,fe,be)},createOutputChannel(fe,be){return ki.createOutputChannel(fe,be,qe)},createWebviewPanel(fe,be,Ue,ht){return Bi.createWebviewPanel(qe,fe,be,Ue,ht)},createWebviewTextEditorInset(fe,be,Ue,ht){return(0,it.$jH)(qe,"editorInsets"),Re.createWebviewEditorInset(fe,be,Ue,ht,qe)},createTerminal(fe,be,Ue){return typeof fe=="object"?"pty"in fe?It.createExtensionTerminal(fe):It.createTerminalFromOptions(fe):It.createTerminal(fe,be,Ue)},registerTerminalLinkProvider(fe){return It.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,be){return It.registerProfileProvider(qe,fe,be)},registerTerminalQuickFixProvider(fe,be){return(0,it.$jH)(qe,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(fe,qe.identifier.value,be)},registerTreeDataProvider(fe,be){return Pi.registerTreeDataProvider(fe,be,qe)},createTreeView(fe,be){return Pi.createTreeView(fe,be,qe)},registerWebviewPanelSerializer:(fe,be)=>Bi.registerWebviewPanelSerializer(qe,fe,be),registerCustomEditorProvider:(fe,be,Ue={})=>Hi.registerCustomEditorProvider(qe,fe,be,Ue),registerFileDecorationProvider(fe){return Zt.registerFileDecorationProvider(fe,qe)},registerUriHandler(fe){return Oi.registerUriHandler(qe,fe)},createQuickPick(){return _e.createQuickPick(qe)},createInputBox(){return _e.createInputBox(qe)},get activeColorTheme(){return ei.activeColorTheme},onDidChangeActiveColorTheme(fe,be,Ue){return lt(ei.onDidChangeActiveColorTheme)(fe,be,Ue)},registerWebviewViewProvider(fe,be,Ue){return Gi.registerWebviewViewProvider(qe,fe,be,Ue?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,be,Ue){return lt(Rt.onDidChangeActiveNotebookEditor)(fe,be,Ue)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorSelection)(fe,be,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorVisibleRanges)(fe,be,Ue)},showNotebookDocument(fe,be){return Rt.showNotebookDocument(fe,be)},registerExternalUriOpener(fe,be,Ue){return(0,it.$jH)(qe,"externalUriOpener"),sn.registerExternalUriOpener(qe.identifier,fe,be,Ue)},registerProfileContentHandler(fe,be){return(0,it.$jH)(qe,"profileContentHandlers"),on.registerProfileContentHandler(qe,fe,be)},registerQuickDiffProvider(fe,be,Ue,ht){return(0,it.$jH)(qe,"quickDiffProvider"),ft.registerQuickDiffProvider(kt(fe),be,Ue,ht)},get tabGroups(){return Jt.tabGroups},registerShareProvider(fe,be){return(0,it.$jH)(qe,"shareProvider"),At.registerShareProvider(kt(fe),be)}},xi={get rootPath(){return Nt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(fe){throw new C.$9("rootPath")},getWorkspaceFolder(fe){return pt.getWorkspaceFolder(fe)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(fe){throw new C.$9("name")},get workspaceFile(){return pt.workspaceFile},set workspaceFile(fe){throw new C.$9("workspaceFile")},updateWorkspaceFolders:(fe,be,...Ue)=>pt.updateWorkspaceFolders(qe,fe,be||0,...Ue),onDidChangeWorkspaceFolders:function(fe,be,Ue){return lt(pt.onDidChangeWorkspace)(fe,be,Ue)},asRelativePath:(fe,be)=>pt.getRelativePath(fe,be),findFiles:(fe,be,Ue,ht)=>pt.findFiles(fe,be,Ue,qe.identifier,ht),findFiles2:(fe,be,Ue)=>((0,it.$jH)(qe,"findFiles2"),pt.findFiles2(fe,be,qe.identifier,Ue)),findFiles2New:(fe,be,Ue)=>{(0,it.$jH)(qe,"findFiles2New");const ht={exclude:be?.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||be?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useDefaultSearchExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:be?.maxResults,useIgnoreFiles:be?.useIgnoreFiles?.local,useGlobalIgnoreFiles:be?.useIgnoreFiles?.global,useParentIgnoreFiles:be?.useIgnoreFiles?.parent,followSymlinks:be?.followSymlinks};return pt.findFiles2(fe&&fe.length>0?fe[0]:void 0,ht,qe.identifier,Ue)},findTextInFiles:(fe,be,Ue,ht)=>{(0,it.$jH)(qe,"findTextInFiles");let Et,Lt;return typeof be=="object"?(Et=be,Lt=Ue):(Et={},Lt=be,ht=Ue),pt.findTextInFiles(fe,Et||{},Lt,qe.identifier,ht)},findTextInFilesNew:(fe,be,Ue)=>{(0,it.$jH)(qe,"findTextInFilesNew"),(0,it.$jH)(qe,"textSearchProviderNew");let ht={};be&&(ht={include:be.include&&be.include.length>0?be.include[0]:void 0,exclude:be.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||be.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useSearchExclude:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:be.maxResults,useIgnoreFiles:be.useIgnoreFiles?.local,useGlobalIgnoreFiles:be.useIgnoreFiles?.global,useParentIgnoreFiles:be.useIgnoreFiles?.parent,followSymlinks:be.followSymlinks,encoding:be.encoding,previewOptions:be.previewOptions?{matchLines:be.previewOptions?.numMatchLines??100,charsPerLine:be.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:be.surroundingContext,afterContext:be.surroundingContext});const Et=Promise.resolve(void 0);return{results:new r.$7h(async gi=>{const Fi=async en=>(gi.emitOne((0,Ct.$5L)(en)),en);await Et.then(en=>pt.findTextInFiles(fe,ht,Fi,qe.identifier,Ue))}),complete:Et.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:fe=>pt.save(fe),saveAs:fe=>pt.saveAs(fe),saveAll:fe=>pt.saveAll(fe),applyEdit(fe,be){return Dn.applyWorkspaceEdit(fe,qe,be)},createFileSystemWatcher:(fe,be,Ue,ht)=>{let Et;return typeof be=="boolean"?Et={ignoreCreateEvents:!!be,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ht,correlate:!1}:be&&((0,it.$jH)(qe,"createFileSystemWatcher"),Et={...be,correlate:!0}),Ge.createFileSystemWatcher(pt,qe,fe,Et)},get textDocuments(){return Tt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new C.$9("textDocuments")},openTextDocument(fe){let be;const Ue=fe;if(typeof fe=="string")be=Promise.resolve(c.URI.file(fe));else if(c.URI.isUri(fe))be=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")be=Tt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return be.then(ht=>(vt.trace(`openTextDocument from ${qe.identifier}`),ht.scheme===O.Schemas.vscodeRemote&&!ht.authority&&Nt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(ht).then(Et=>Et.document)))},onDidOpenTextDocument:(fe,be,Ue)=>lt(Tt.onDidAddDocument)(fe,be,Ue),onDidCloseTextDocument:(fe,be,Ue)=>lt(Tt.onDidRemoveDocument)(fe,be,Ue),onDidChangeTextDocument:(fe,be,Ue)=>lt(Tt.onDidChangeDocument)(fe,be,Ue),onDidSaveTextDocument:(fe,be,Ue)=>lt(Tt.onDidSaveDocument)(fe,be,Ue),onWillSaveTextDocument:(fe,be,Ue)=>lt(ui.getOnWillSaveTextDocumentEvent(qe))(fe,be,Ue),get notebookDocuments(){return Rt.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,be){let Ue;if(c.URI.isUri(fe))Ue=fe,await Rt.openNotebookDocument(fe);else if(typeof fe=="string")Ue=c.URI.revive(await Rt.createNotebookDocument({viewType:fe,content:be}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,be,Ue){return lt(Ti.onDidSaveNotebookDocument)(fe,be,Ue)},onDidChangeNotebookDocument(fe,be,Ue){return lt(Ti.onDidChangeNotebookDocument)(fe,be,Ue)},onWillSaveNotebookDocument(fe,be,Ue){return lt($i.getOnWillSaveNotebookDocumentEvent(qe))(fe,be,Ue)},get onDidOpenNotebookDocument(){return lt(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,be,Ue,ht){return Rt.registerNotebookSerializer(qe,fe,be,Ue,(0,it.$iH)(qe,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(fe,be,Ue)=>lt(Xi.onDidChangeConfiguration)(fe,be,Ue),getConfiguration(fe,be){return be=arguments.length===1?void 0:be,Xi.getConfiguration(fe,be,qe)},registerTextDocumentContentProvider(fe,be){return Ni.registerTextDocumentContentProvider(fe,be)},registerTaskProvider:(fe,be)=>(Nt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),xt.registerTaskProvider(qe,fe,be)),registerFileSystemProvider(fe,be,Ue){return(0,T.$Sc)(Le.registerFileSystemProvider(qe,fe,be,Ue),ni.addFileSystemProvider(fe,be,Ue))},get fs(){return ni.value},registerFileSearchProvider:(fe,be)=>((0,it.$jH)(qe,"fileSearchProvider"),mi.registerFileSearchProvider(fe,be)),registerTextSearchProvider:(fe,be)=>((0,it.$jH)(qe,"textSearchProvider"),mi.registerTextSearchProvider(fe,be)),registerAITextSearchProvider:(fe,be)=>((0,it.$jH)(qe,"aiTextSearchProvider"),(0,it.$jH)(qe,"textSearchProvider"),mi.registerAITextSearchProvider(fe,be)),registerFileSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"aiTextSearchProviderNew"),(0,it.$jH)(qe,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(fe,be)=>((0,it.$jH)(qe,"resolvers"),qt.registerRemoteAuthorityResolver(fe,be)),registerResourceLabelFormatter:fe=>((0,it.$jH)(qe,"resolvers"),zt.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,it.$jH)(qe,"resolvers"),qt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,be,Ue)=>lt(Ge.onDidCreateFile)(fe,be,Ue),onDidDeleteFiles:(fe,be,Ue)=>lt(Ge.onDidDeleteFile)(fe,be,Ue),onDidRenameFiles:(fe,be,Ue)=>lt(Ge.onDidRenameFile)(fe,be,Ue),onWillCreateFiles:(fe,be,Ue)=>lt(Ge.getOnWillCreateFileEvent(qe))(fe,be,Ue),onWillDeleteFiles:(fe,be,Ue)=>lt(Ge.getOnWillDeleteFileEvent(qe))(fe,be,Ue),onWillRenameFiles:(fe,be,Ue)=>lt(Ge.getOnWillRenameFileEvent(qe))(fe,be,Ue),openTunnel:fe=>((0,it.$jH)(qe,"tunnels"),jt.openTunnel(qe,fe).then(be=>{if(!be)throw new Error("cannot open tunnel");return be})),get tunnels(){return(0,it.$jH)(qe,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(fe,be,Ue)=>((0,it.$jH)(qe,"tunnels"),lt(jt.onDidChangeTunnels)(fe,be,Ue)),registerPortAttributesProvider:(fe,be)=>((0,it.$jH)(qe,"portsAttributes"),jt.registerPortsAttributesProvider(fe,be)),registerTunnelProvider:(fe,be)=>((0,it.$jH)(qe,"tunnelFactory"),jt.registerTunnelProvider(fe,be)),registerTimelineProvider:(fe,be)=>((0,it.$jH)(qe,"timeline"),rn.registerTimelineProvider(fe,be,qe.identifier,wt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:fe=>((0,it.$jH)(qe,"workspaceTrust"),pt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,be,Ue)=>lt(pt.onDidGrantWorkspaceTrust)(fe,be,Ue),registerEditSessionIdentityProvider:(fe,be)=>((0,it.$jH)(qe,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(fe,be)),onWillCreateEditSessionIdentity:(fe,be,Ue)=>((0,it.$jH)(qe,"editSessionIdentityProvider"),lt(pt.getOnWillCreateEditSessionIdentityEvent(qe))(fe,be,Ue)),registerCanonicalUriProvider:(fe,be)=>((0,it.$jH)(qe,"canonicalUriProvider"),pt.registerCanonicalUriProvider(fe,be)),getCanonicalUri:(fe,be,Ue)=>((0,it.$jH)(qe,"canonicalUriProvider"),pt.provideCanonicalUri(fe,be,Ue))},dn={get inputBox(){return Nt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),Je.getLastInputBox(qe)},createSourceControl(fe,be,Ue){return Je.createSourceControl(qe,fe,be,Ue)}},fn={createCommentController(fe,be){return Xt.createCommentController(qe,fe,be)}},kn={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(fe,be){return(0,it.$jH)(qe,"debugVisualization"),Pt.registerDebugVisualizationProvider(qe,fe,be)},registerDebugVisualizationTreeProvider(fe,be){return(0,it.$jH)(qe,"debugVisualization"),Pt.registerDebugVisualizationTree(qe,fe,be)},onDidStartDebugSession(fe,be,Ue){return lt(Pt.onDidStartDebugSession)(fe,be,Ue)},onDidTerminateDebugSession(fe,be,Ue){return lt(Pt.onDidTerminateDebugSession)(fe,be,Ue)},onDidChangeActiveDebugSession(fe,be,Ue){return lt(Pt.onDidChangeActiveDebugSession)(fe,be,Ue)},onDidReceiveDebugSessionCustomEvent(fe,be,Ue){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(fe,be,Ue)},onDidChangeBreakpoints(fe,be,Ue){return lt(Pt.onDidChangeBreakpoints)(fe,be,Ue)},onDidChangeActiveStackItem(fe,be,Ue){return lt(Pt.onDidChangeActiveStackItem)(fe,be,Ue)},registerDebugConfigurationProvider(fe,be,Ue){return Pt.registerDebugConfigurationProvider(fe,be,Ue||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,be){return Pt.registerDebugAdapterDescriptorFactory(qe,fe,be)},registerDebugAdapterTrackerFactory(fe,be){return Pt.registerDebugAdapterTrackerFactory(fe,be)},startDebugging(fe,be,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Pt.startDebugging(fe,be,{parentSession:Ue}):Pt.startDebugging(fe,be,Ue||{})},stopDebugging(fe){return Pt.stopDebugging(fe)},addBreakpoints(fe){return Pt.addBreakpoints(fe)},removeBreakpoints(fe){return Pt.removeBreakpoints(fe)},asDebugSourceUri(fe,be){return Pt.asDebugSourceUri(fe,be)}},gn={registerTaskProvider:(fe,be)=>xt.registerTaskProvider(qe,fe,be),fetchTasks:fe=>xt.fetchTasks(fe),executeTask:fe=>xt.executeTask(qe,fe),get taskExecutions(){return xt.taskExecutions},onDidStartTask:(fe,be,Ue)=>lt(xt.onDidStartTask)(fe,be,Ue),onDidEndTask:(fe,be,Ue)=>lt(xt.onDidEndTask)(fe,be,Ue),onDidStartTaskProcess:(fe,be,Ue)=>lt(xt.onDidStartTaskProcess)(fe,be,Ue),onDidEndTaskProcess:(fe,be,Ue)=>lt(xt.onDidEndTaskProcess)(fe,be,Ue)},mn={createNotebookController(fe,be,Ue,ht,Et){return Si.createNotebookController(qe,fe,be,Ue,ht,(0,it.$iH)(qe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(fe,be)=>Rt.registerNotebookCellStatusBarItemProvider(qe,fe,be),createRendererMessaging(fe){return ji.createRendererMessaging(qe,fe)},createNotebookControllerDetectionTask(fe){return(0,it.$jH)(qe,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(qe,fe)},registerKernelSourceActionProvider(fe,be){return(0,it.$jH)(qe,"notebookKernelSource"),Si.registerKernelSourceActionProvider(qe,fe,be)},onDidChangeNotebookCellExecutionState(fe,be,Ue){return(0,it.$jH)(qe,"notebookCellExecutionState"),lt(Si.onDidChangeNotebookCellExecutionState)(fe,be,Ue)}},In={t(...fe){if(typeof fe[0]=="string"){const be=fe.shift(),Ue=!fe||typeof fe[0]!="object"?fe:fe[0];return wi.getMessage(qe.identifier.value,{message:be,args:Ue})}return wi.getMessage(qe.identifier.value,fe[0])},get bundle(){return wi.getBundle(qe.identifier.value)},get uri(){return wi.getBundleUri(qe.identifier.value)}},Pn={_version:1,transferActiveChat(fe){return(0,it.$jH)(qe,"interactive"),Mi.transferActiveChat(fe)}},$n={getRelatedInformation(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),Qi.getRelatedInformation(qe,fe,be)},registerRelatedInformationProvider(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(qe,fe,be)},registerEmbeddingVectorProvider(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),yn.registerEmbeddingVectorProvider(qe,fe,be)}},_i={_version:1,registerChatResponseProvider(fe,be,Ue){return(0,it.$jH)(qe,"chatProvider"),Kt.registerLanguageModel(qe,fe,be,Ue)},registerChatVariableResolver(fe,be,Ue,ht,Et,Lt,gi,Fi){return(0,it.$jH)(qe,"chatVariableResolver"),an.registerVariableResolver(qe,fe,be,Ue,ht,Et,Lt,gi,Fi?.id)},registerMappedEditsProvider(fe,be){return(0,it.$jH)(qe,"mappedEditsProvider"),te.registerMappedEditsProvider(qe,fe,be)},createChatParticipant(fe,be){return Mi.createChatAgent(qe,fe,be)},createDynamicChatParticipant(fe,be,Ue){return(0,it.$jH)(qe,"chatParticipantPrivate"),Mi.createDynamicChatAgent(qe,fe,be,Ue)},registerChatParticipantDetectionProvider(fe){return(0,it.$jH)(qe,"chatParticipantAdditions"),Mi.registerChatParticipantDetectionProvider(fe)}},pn={selectChatModels:fe=>Kt.selectLanguageModels(qe,fe??{}),onDidChangeChatModels:(fe,be,Ue)=>Kt.onDidChangeProviders(fe,be,Ue),registerChatModelProvider:(fe,be,Ue)=>((0,it.$jH)(qe,"chatProvider"),Kt.registerLanguageModel(qe,fe,be,Ue)),get embeddingModels(){return(0,it.$jH)(qe,"embeddings"),Ai.embeddingsModels},onDidChangeEmbeddingModels:(fe,be,Ue)=>((0,it.$jH)(qe,"embeddings"),Ai.onDidChange(fe,be,Ue)),registerEmbeddingsProvider(fe,be){return(0,it.$jH)(qe,"embeddings"),Ai.registerEmbeddingsProvider(qe,fe,be)},async computeEmbeddings(fe,be,Ue){return(0,it.$jH)(qe,"embeddings"),Ai.computeEmbeddings(fe,be,Ue)},registerTool(fe,be){return(0,it.$jH)(qe,"lmTools"),zi.registerTool(qe,fe,be)},invokeTool(fe,be,Ue){return(0,it.$jH)(qe,"lmTools"),zi.invokeTool(fe,be,Ue)},get tools(){return(0,it.$jH)(qe,"lmTools"),zi.tools}},bn={registerSpeechProvider(fe,be){return(0,it.$jH)(qe,"speech"),Ki.registerProvider(qe.identifier,fe,be)}};return{version:St.version,ai:$n,authentication:Yi,commands:un,comments:fn,chat:_i,debug:kn,env:Ei,extensions:pi,interactive:Pn,l10n:In,languages:Wi,lm:pn,notebooks:mn,scm:dn,speech:bn,tasks:gn,tests:Ui,window:hn,workspace:xi,Breakpoint:le.$TO,TerminalOutputAnchor:le.TerminalOutputAnchor,ChatResultFeedbackKind:le.ChatResultFeedbackKind,ChatVariableLevel:le.ChatVariableLevel,ChatCompletionItem:le.$PP,CallHierarchyIncomingCall:le.$fO,CallHierarchyItem:le.$eO,CallHierarchyOutgoingCall:le.$gO,CancellationError:C.$5,CancellationTokenSource:h.$xe,CandidatePortSource:s.CandidatePortSource,CodeAction:le.$bO,CodeActionKind:le.$cO,CodeActionTriggerKind:le.CodeActionTriggerKind,CodeLens:le.$hO,Color:le.$uO,ColorInformation:le.$vO,ColorPresentation:le.$wO,ColorThemeKind:le.ColorThemeKind,CommentMode:le.CommentMode,CommentState:le.CommentState,CommentThreadCollapsibleState:le.CommentThreadCollapsibleState,CommentThreadState:le.CommentThreadState,CommentThreadApplicability:le.CommentThreadApplicability,CommentThreadFocus:le.CommentThreadFocus,CompletionItem:le.$oO,CompletionItemKind:le.CompletionItemKind,CompletionItemTag:le.CompletionItemTag,CompletionList:le.$pO,CompletionTriggerKind:le.CompletionTriggerKind,ConfigurationTarget:le.ConfigurationTarget,CustomExecution:le.$EO,DebugAdapterExecutable:le.$XO,DebugAdapterInlineImplementation:le.$1O,DebugAdapterNamedPipeServer:le.$ZO,DebugAdapterServer:le.$YO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:le.DebugConsoleMode,DebugVisualization:le.$eP,DecorationRangeBehavior:le.DecorationRangeBehavior,Diagnostic:le.$7N,DiagnosticRelatedInformation:le.$6N,DiagnosticSeverity:le.DiagnosticSeverity,DiagnosticTag:le.DiagnosticTag,Disposable:le.$QN,DocumentHighlight:le.$0N,DocumentHighlightKind:le.DocumentHighlightKind,MultiDocumentHighlight:le.$$N,DocumentLink:le.$tO,DocumentSymbol:le.$aO,EndOfLine:le.EndOfLine,EnvironmentVariableMutatorType:le.EnvironmentVariableMutatorType,EvaluatableExpression:le.$4O,InlineValueText:le.$5O,InlineValueVariableLookup:le.$6O,InlineValueEvaluatableExpression:le.$7O,InlineCompletionTriggerKind:le.InlineCompletionTriggerKind,EventEmitter:R.$me,ExtensionKind:le.ExtensionKind,ExtensionMode:le.ExtensionMode,ExternalUriOpenerPriority:le.ExternalUriOpenerPriority,FileChangeType:le.FileChangeType,FileDecoration:le.$gP,FileDecoration2:le.$gP,FileSystemError:le.$0O,FileType:a.FileType,FilePermission:a.FilePermission,FoldingRange:le.$$O,FoldingRangeKind:le.FoldingRangeKind,FunctionBreakpoint:le.$VO,InlineCompletionItem:le.$qO,InlineCompletionList:le.$rO,Hover:le.$8N,VerboseHover:le.$9N,HoverVerbosityAction:le.HoverVerbosityAction,IndentAction:u.IndentAction,Location:le.$5N,MarkdownString:le.$iO,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:le.$jO,PortAutoForwardAction:le.PortAutoForwardAction,Position:le.$RN,ProcessExecution:le.$CO,ProgressLocation:le.ProgressLocation,QuickInputButtonLocation:le.QuickInputButtonLocation,QuickInputButtons:le.$fP,Range:le.$SN,RelativePattern:le.$RO,Selection:le.$TN,SelectionRange:le.$dO,SemanticTokens:le.$bP,SemanticTokensBuilder:le.$aP,SemanticTokensEdit:le.$cP,SemanticTokensEdits:le.$dP,SemanticTokensLegend:le.$_O,ShellExecution:le.$DO,ShellQuoting:le.ShellQuoting,SignatureHelp:le.$lO,SignatureHelpTriggerKind:le.SignatureHelpTriggerKind,SignatureInformation:le.$kO,SnippetString:le.$4N,SourceBreakpoint:le.$UO,StandardTokenType:le.StandardTokenType,StatusBarAlignment:le.StatusBarAlignment,SymbolInformation:le.$_N,SymbolKind:le.SymbolKind,SymbolTag:le.SymbolTag,Task:le.$FO,TaskGroup:le.$BO,TaskPanelKind:le.TaskPanelKind,TaskRevealKind:le.TaskRevealKind,TaskScope:le.TaskScope,TerminalLink:le.$xO,TerminalQuickFixTerminalCommand:le.$zO,TerminalQuickFixOpener:le.$yO,TerminalLocation:le.TerminalLocation,TerminalProfile:le.$AO,TerminalExitReason:le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:le.TextDocumentSaveReason,TextEdit:le.$ZN,SnippetTextEdit:le.$2N,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:le.TextEditorLineNumbersStyle,TextEditorRevealType:le.TextEditorRevealType,TextEditorSelectionChangeKind:le.TextEditorSelectionChangeKind,SyntaxTokenType:le.SyntaxTokenType,TextDocumentChangeReason:le.TextDocumentChangeReason,ThemeColor:le.$QO,ThemeIcon:le.$PO,TreeItem:le.$GO,TreeItemCheckboxState:le.TreeItemCheckboxState,TreeItemCollapsibleState:le.TreeItemCollapsibleState,TypeHierarchyItem:le.$DP,UIKind:Ot.UIKind,Uri:c.URI,ViewColumn:le.ViewColumn,WorkspaceEdit:le.$3N,DocumentPasteTriggerKind:le.DocumentPasteTriggerKind,DocumentDropEdit:le.$MO,DocumentDropOrPasteEditKind:le.$NO,DocumentPasteEdit:le.$OO,InlayHint:le.$nO,InlayHintLabelPart:le.$mO,InlayHintKind:le.InlayHintKind,RemoteAuthorityResolverError:le.$YN,ResolvedAuthority:le.$WN,ManagedResolvedAuthority:le.$XN,SourceControlInputBoxValidationType:le.SourceControlInputBoxValidationType,ExtensionRuntime:le.ExtensionRuntime,TimelineItem:le.$qP,NotebookRange:le.$iP,NotebookCellKind:le.NotebookCellKind,NotebookCellExecutionState:le.NotebookCellExecutionState,NotebookCellData:le.$jP,NotebookData:le.$kP,NotebookRendererScript:le.$oP,NotebookCellStatusBarAlignment:le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:le.NotebookEditorRevealType,NotebookCellOutput:le.$mP,NotebookCellOutputItem:le.$lP,NotebookCellStatusBarItem:le.$nP,NotebookControllerAffinity:le.NotebookControllerAffinity,NotebookControllerAffinity2:le.NotebookControllerAffinity2,NotebookEdit:le.$1N,NotebookKernelSourceAction:le.$pP,NotebookVariablesRequestKind:le.NotebookVariablesRequestKind,PortAttributes:le.$sP,LinkedEditingRanges:le.$rP,TestResultState:le.TestResultState,TestRunRequest:le.$tP,TestMessage:le.$uP,TestMessage2:le.$uP,TestMessageStackFrame:le.$wP,TestTag:le.$vP,TestRunProfileKind:le.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:le.$LO,DataTransferItem:le.$HO,TestCoverageCount:le.$xP,FileCoverage:le.$zP,FileCoverage2:le.$zP,StatementCoverage:le.$AP,BranchCoverage:le.$BP,DeclarationCoverage:le.$CP,WorkspaceTrustState:le.WorkspaceTrustState,LanguageStatusSeverity:le.LanguageStatusSeverity,QuickPickItemKind:le.QuickPickItemKind,InputBoxValidationSeverity:le.InputBoxValidationSeverity,TabInputText:le.$EP,TabInputTextDiff:le.$FP,TabInputTextMerge:le.$GP,TabInputCustom:le.$HP,TabInputNotebook:le.$JP,TabInputNotebookDiff:le.$KP,TabInputWebview:le.$IP,TabInputTerminal:le.$LP,TabInputInteractiveWindow:le.$MP,TabInputChat:le.$NP,TabInputTextMultiDiff:le.$OP,TelemetryTrustedValue:f.$yp,LogLevel:m.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:le.InteractiveSessionVoteDirection,ChatCopyKind:le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:le.$2O,DebugThread:le.$3O,RelatedInformationType:le.RelatedInformationType,SpeechToTextStatus:le.SpeechToTextStatus,TextToSpeechStatus:le.TextToSpeechStatus,PartialAcceptTriggerKind:le.PartialAcceptTriggerKind,KeywordRecognitionStatus:le.KeywordRecognitionStatus,ChatResponseMarkdownPart:le.$QP,ChatResponseFileTreePart:le.$UP,ChatResponseAnchorPart:le.$VP,ChatResponseProgressPart:le.$WP,ChatResponseProgressPart2:le.$XP,ChatResponseReferencePart:le.$1P,ChatResponseReferencePart2:le.$1P,ChatResponseCodeCitationPart:le.$2P,ChatResponseWarningPart:le.$YP,ChatResponseTextEditPart:le.$3P,ChatResponseMarkdownWithVulnerabilitiesPart:le.$RP,ChatResponseCommandButtonPart:le.$ZP,ChatResponseDetectedParticipantPart:le.$SP,ChatResponseConfirmationPart:le.$TP,ChatResponseReferencePartStatusKind:le.ChatResponseReferencePartStatusKind,ChatRequestTurn:le.$4P,ChatResponseTurn:le.$5P,ChatLocation:le.ChatLocation,ChatRequestEditorData:le.$6P,ChatRequestNotebookData:le.$7P,LanguageModelChatMessageRole:le.LanguageModelChatMessageRole,LanguageModelChatMessage:le.$9P,LanguageModelChatMessageFunctionResultPart:le.$8P,LanguageModelChatResponseTextPart:le.$$P,LanguageModelChatResponseFunctionUsePart:le.$0P,LanguageModelError:le.$cQ,NewSymbolName:le.$9O,NewSymbolNameTag:le.NewSymbolNameTag,NewSymbolNameTriggerKind:le.NewSymbolNameTriggerKind,InlineEdit:le.$dQ,InlineEditTriggerKind:le.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$4L,TextSearchMatchNew:Ct.$3L,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(ke[345],Ie([1,0,88,172,49,166,41,34,63,48,100,101,102,125,76,95,165,75,62,124,94,77,164,11,64,122,123,127,128,170,98]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d,l,g,E,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Us)(l.$Eqc,l.$Dqc,r.InstantiationType.Delayed),(0,r.$Us)(n.$ck,o.$Trc,r.InstantiationType.Delayed),(0,r.$Us)(a.$Jpc,a.$Kpc,r.InstantiationType.Delayed),(0,r.$Us)(O.$KQ,O.$JQ,r.InstantiationType.Eager),(0,r.$Us)(E.$Tpc,E.$Upc,r.InstantiationType.Eager),(0,r.$Us)(D.$yqc,D.$zqc,r.InstantiationType.Eager),(0,r.$Us)(T.$9pc,T.$7pc,r.InstantiationType.Eager),(0,r.$Us)(p.$$pc,p.$0pc,r.InstantiationType.Eager),(0,r.$Us)(I.$Oqc,I.$Pqc,r.InstantiationType.Eager),(0,r.$Us)(y.$Tqc,y.$Xqc,r.InstantiationType.Eager),(0,r.$Us)(R.$Zqc,R.$Yqc,r.InstantiationType.Eager),(0,r.$Us)(b.$zQ,b.$yQ,r.InstantiationType.Eager),(0,r.$Us)(g.$Fqc,g.$Gqc,r.InstantiationType.Eager),(0,r.$Us)(f.$Npc,f.$Mpc,r.InstantiationType.Eager),(0,r.$Us)(h.$trc,h.$src,r.InstantiationType.Delayed),(0,r.$Us)(u.$drc,u.$erc,r.InstantiationType.Eager),(0,r.$Us)(P.$rqc,P.$qqc,r.InstantiationType.Eager),(0,r.$Us)(k.$Grc,k.$Frc,r.InstantiationType.Eager),(0,r.$Us)(c.$uqc,c.$xqc,r.InstantiationType.Eager),(0,r.$Us)(S.$Hrc,S.$Irc,r.InstantiationType.Eager),(0,r.$Us)(w.$rGb,w.$sGb,r.InstantiationType.Eager),(0,r.$Us)(m.$Rrc,m.$Qrc,r.InstantiationType.Eager),(0,r.$Us)(C.$6pc,C.$5pc,r.InstantiationType.Eager),(0,r.$Us)(i.$Bqc,i.$Aqc,r.InstantiationType.Eager),(0,r.$Us)(s.$IQ,s.$FQ,r.InstantiationType.Eager),(0,r.$Us)(t.$iqc,t.$jqc,r.InstantiationType.Eager),(0,r.$Us)(d.$Mqc,d.$Nqc,r.InstantiationType.Eager)}),define(ke[129],Ie([1,0,18,11,37,99]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=void 0,e.$0rc=T,e.$$rc=O,R=We(R);function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}function O(y,u,P,w){const a=(0,r.$1b)(P,b),m=new C.$eM(u,a,w),p=m.preview.matches;return{ranges:(0,r.$1b)(a,c),uri:y,preview:{text:m.preview.text,matches:(0,r.$1b)(p,c)}}}function b(y){return new C.$fM(y.start.line,y.start.character,y.end.line,y.end.character)}function c(y){return new R.$2L(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let k=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$_rc=k,e.$_rc=k=Ze([Ve(1,h.$bk)],k)}),define(ke[346],Ie([1,0,56,16,81,31,10,12,129,347]),function($e,e,r,h,C,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asc=y,e.$bsc=m,e.$csc=f,r=We(r),h=We(h),R=We(R),O=We(O);const k=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(i,s,t,o,n){const d=u(i,s,t,o,n),l=s.folder.fsPath;return{cmd:r.spawn(k,d.args,{cwd:l}),rgDiskPath:k,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,s,t,o,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([s],t,!1).forEach(g=>{const E=(0,b.$0rc)(g);if(d.push("-g",E),T.$k){const D=(0,C.$pm)(E);D!==E&&d.push("-g",D)}});const l=P([s],o,void 0,!1);return l.globArgs.forEach(g=>{const E=`!${(0,b.$0rc)(g)}`;if(d.push("-g",E),T.$k){const D=(0,C.$pm)(E);D!==E&&d.push("-g",D)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,s,t,o=!0){const n=[];let d={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},s||{}),E=a(g,o?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,s,t=!0){const o=[];return i.forEach(n=>{const d=Object.assign({},s||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);o.push(...l.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=p(s?m(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),o.push(f(d))):l&&l.when&&(n[d]=l)}),{globArgs:o,siblingClauses:n}}function m(i,s){return h.$jc(s)?s:h.$kc(i,s)}function p(i){return i=O.$of(i,"\\"),O.$of(i,"/")}function f(i){return R.$Bg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[348],Ie([1,0,56,45,16,349,18,52,38,81,31,10,42,12,17,33,37,346,137]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=e.$dsc=void 0,r=We(r),h=We(h),C=We(C),T=We(T),b=We(b),c=We(c),y=We(y),P=We(P),w=We(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$Bk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,f.$Ur)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$Bk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const E=Object.assign({},g.excludePattern||{},this.a.excludePattern||{}),D=g.folder.fsPath;l.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==D).forEach(S=>{(0,k.$Fg)(S,D)&&(E[C.$mc(D,S)]=!0)}),this.t.set(D,new o(E,D))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,E,D,S,I){if(this.m=u.$ge.create(!1),this.l)return I(null,this.j);g.forEach(A=>{const $=C.$oc(A.fsPath);this.u&&this.u(A.fsPath,$)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$ge.create(!1),this.w(l,(A,$)=>{this.x(this.y,this,A,E,D,S,v=>{if(v){const M=(0,O.$rj)(v);console.error(M),this.q.push(M),$(v,void 0)}else $(null,void 0)})},(A,$)=>{this.m.stop();const v=A?T.$Hb(A)[0]:null;I(v,this.j)})}w(l,g,E){const D=new Array(l.length),S=new Array(l.length);let I=!1,A=0;if(l.length===0)return E(null,[]);l.forEach(($,v)=>{g($,(M,N)=>{if(M?(I=!0,D[v]=null,S[v]=M):(D[v]=N,S[v]=null),++A===l.length)return E(I?S:null,D)})})}x(l,g,...E){try{l.apply(g,E)}catch(D){E[E.length-1](D)}}y(l,g,E,D,S){const I=l.folder.fsPath,A=y.$k,$=()=>F&&F.kill();i.add($);let v=z=>{i.delete($),v=()=>{},S(z)},M="";const N=this.D(),L=(0,p.$asc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),F=L.cmd,B=!Object.keys(L.siblingClauses).length,j=L.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${L.rgDiskPath} ${j}
 - cwd: ${L.cwd}`;L.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(L.rgArgs.siblingClauses)}`),D({message:U}),this.s=0,this.z(F,"utf8",D,(z,ee,V)=>{if(z){v(z);return}if(this.j){v();return}const J=(M+(A?c.$om(ee||""):ee)).split(`
`);if(V){const _=J.length;J[_-1]=J[_-1].trim(),J[_-1]||J.pop()}else M=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=J.length,B){for(const _ of J)if(this.J(E,{base:I,relativePath:_,searchPath:this.N(l,_)}),this.j){$();break}(V||this.j)&&v();return}this.G(l,N,I,J,E),V&&(this.H(N,I,E),v())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),E=g.getBasenameTerms(),D=g.getPathTerms(),S=["-L","."];if(E.length||D.length){S.push("-not","(","(");for(const I of E)S.push("-name",I),S.push("-o");for(const I of D)S.push("-path",I),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),r.spawn("find",S,{cwd:l.folder.fsPath})}readStdout(l,g,E){let D="";this.z(l,g,()=>{},(S,I,A)=>{if(S){E(S);return}D+=I,A&&E(null,D)})}z(l,g,E,D){let S=($,v,M)=>{($||M)&&(S=()=>{},this.r?.stop()),D($,v,M)},I=!1;l.stdout?(this.A(l.stdout,g,S),l.stdout.once("data",()=>I=!0)):E({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",$=>{S($)}),l.on("close",$=>{let v;!I&&(v=this.C(A,g))&&n(v)?S(new Error(`command failed with error code ${$}: ${this.C(A,g)}`)):(this.g&&$===0&&(this.j=!0),S(null,"",!0))})}A(l,g,E){const D=new R.StringDecoder(g);return l.on("data",S=>{E(null,D.write(S))}),D}B(l){const g=[];return l.on("data",E=>{g.push(E)}),g}C(l,g){const E=new R.StringDecoder(g);return l.map(D=>E.write(D)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},E,D,S){D.indexOf(this.b)!==-1&&this.J(S,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const I=A=>{const $=C.$oc(A),v=C.$nc(A);let M=g[v];M||(M=g[v]=[],I(v)),M.push({base:E,relativePath:A,basename:$,searchPath:this.N(l,A)})};D.forEach(I)}H({rootEntries:l,pathToEntries:g},E,D){const S=this,I=this.t.get(E),A=this.b;function $(v){S.o++;const M=(0,m.$uM)(()=>v.map(N=>N.basename));for(let N=0,L=v.length;N<L;N++){const F=v[N],{relativePath:B,basename:j}=F;if(I.test(B,j,A!==j?M:void 0))continue;const U=g[B];if(U)$(U);else{if(S.p++,B===A)continue;S.J(D,F)}if(S.j)break}}$(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,E,D,S){const I=l.folder,A=(0,m.$uM)(()=>E);this.w(E,($,v)=>{if(this.l||this.j)return v(null);const M=g?[g,$].join(C.sep):$;if(this.t.get(l.folder.fsPath).test(M,$,this.a.filePattern!==$?A:void 0))return v(null);const N=[I.fsPath,M].join(C.sep);h.lstat(N,(L,F)=>{if(L||this.l||this.j)return v(null);this.L(N,F,(B,j)=>B||this.l||this.j?v(null):j.isDirectory()?(this.o++,this.M(N,F,(U,z)=>U||this.l||this.j||(z=z||"",this.v[z])?v(null):(this.v[z]=!0,a.Promises.readdir(N).then(ee=>{if(this.l||this.j)return v(null);this.I(l,M,ee,D,V=>v(V||null))},ee=>{v(null)})))):(this.p++,M===this.b||this.h&&w.$jg(j.size)&&j.size>this.h||this.J(D,{base:I.fsPath,relativePath:M,searchPath:this.N(l,M)}),v(null,void 0)))})},$=>{const v=$&&T.$Hb($);return S(v&&v.length>0?v[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,C.$oc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$pM)(l,this.c);if(this.b)return(0,m.$pM)(l,this.b,!1)}return!0}L(l,g,E){return g.isSymbolicLink()?h.stat(l,E):E(null,g)}M(l,g,E){return g.isSymbolicLink()?h.realpath(l,(D,S)=>D?E(D):E(null,S)):E(null,l)}N(l,g){return l.folderName?C.$kc(l.folderName,g):g}}e.$dsc=s;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new s(l)}search(l,g,E){this.c.walk(this.a,this.b,this.d,l,g,(D,S)=>{E(D,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$esc=t;class o{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,E;Object.keys(l).filter(D=>l[D]).forEach(D=>{C.$jc(D)?(g=g||b.$wk(),g[D]=l[D]):(E=E||b.$wk(),E[D]=l[D])}),this.a=g&&b.$Bk(g,{trimForExclusions:!0}),this.b=E&&b.$Bk(E,{trimForExclusions:!0})}test(l,g,E){return this.b&&this.b(l,g,E)||this.a&&this.a(C.$kc(this.c,l),g,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$Dk(this.a)),this.b&&l.push(...b.$Dk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$Ek(this.a)),this.b&&l.push(...b.$Ek(this.b)),l}}function n(d){const l=d.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return P.$0f(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(ke[350],Ie([1,0,105,21,139,20,18,131]),function($e,e,r,h,C,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XE=e.$WE=e.$OE=e.DecodeStreamErrorKind=e.$NE=e.$ME=e.$LE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$KE=b,e.$PE=m,e.$QE=p,e.$RE=f,e.$SE=i,e.$TE=s,e.$UE=D,e.$VE=S,e.$GE="utf8",e.$HE="utf8bom",e.$IE="utf16be",e.$JE="utf16le";function b(I){return[e.$GE,e.$HE,e.$IE,e.$JE].some(A=>A===I)}e.$LE=[254,255],e.$ME=[255,254],e.$NE=[239,187,191];const c=512,k=512,y=512*8,u=512*128;var P;(function(I){I[I.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class w extends Error{constructor(A,$){super(A),this.decodeStreamErrorKind=$}}e.$OE=w;class a{static async create(A){let $;if(A!==e.$GE)$=(await(0,C.$uq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(A));else{const v=new TextDecoder;$={write(M){return v.decode(M,{stream:!0})},end(){return v.decode()}}}return new a($)}constructor(A){this.a=A}write(A){return this.a.write(A)}end(){return this.a.end()}}function m(I,A){const $=A.minBytesRequiredForDetection??A.guessEncoding?y:k;return new Promise((v,M)=>{const N=(0,r.$Ce)(z=>z.join("")),L=[];let F=0,B;const j=new R.$xe,U=async()=>{try{const z=await S({buffer:h.$Oe.concat(L),bytesRead:F},A.guessEncoding,A.candidateGuessEncodings);if(z.seemsBinary&&A.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",P.STREAM_IS_BINARY);z.encoding=await A.overwriteEncoding(z.encoding),B=await a.create(z.encoding);const ee=B.write(h.$Oe.concat(L).buffer);N.write(ee),L.length=0,F=0,v({stream:N,detected:z})}catch(z){j.cancel(),N.destroy(),M(z)}};(0,r.$Ge)(I,{onData:async z=>{B?N.write(B.write(z.buffer)):(L.push(z),F+=z.byteLength,F>=$&&(I.pause(),await U(),setTimeout(()=>I.resume())))},onError:z=>N.error(z),onEnd:async()=>{B||await U(),N.end(B?.end())}},j.token)})}async function p(I,A,$){const M=(await(0,C.$uq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(A),$);let N=!1,L=!1;return{read(){if(L)return null;const F=I.read();if(typeof F!="string"){if(L=!0,!N&&$?.addBOM)switch(A){case e.$GE:case e.$HE:return h.$Oe.wrap(Uint8Array.from(e.$NE));case e.$IE:return h.$Oe.wrap(Uint8Array.from(e.$LE));case e.$JE:return h.$Oe.wrap(Uint8Array.from(e.$ME))}const B=M.end();return B&&B.length>0?(N=!0,h.$Oe.wrap(B)):null}return N=!0,h.$Oe.wrap(M.write(F))}}}async function f(I){return(await(0,C.$uq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(I))}function i(I){return I===e.$HE||I===null?e.$GE:I}function s(I,A){if(!I||A<e.$LE.length)return null;const $=I.readUInt8(0),v=I.readUInt8(1);if($===e.$LE[0]&&v===e.$LE[1])return e.$IE;if($===e.$ME[0]&&v===e.$ME[1])return e.$JE;if(A<e.$NE.length)return null;const M=I.readUInt8(2);return $===e.$NE[0]&&v===e.$NE[1]&&M===e.$NE[2]?e.$HE:null}const t=["ascii","utf-16","utf-32"];async function o(I,A){const $=await(0,C.$uq)("jschardet",O.$R?"dist/jschardet.js":"dist/jschardet.min.js"),v=I.slice(0,u),M=E(v.buffer);A&&(A=(0,T.$Hb)(A.map(F=>g(F))),A.length===0&&(A=void 0));const N=$.detect(M,A?{detectEncodings:A}:void 0);if(!N||!N.encoding)return null;const L=N.encoding.toLowerCase();return 0<=t.indexOf(L)?null:l(N.encoding)}const n={ibm866:"cp866",big5:"cp950"};function d(I){return I.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function l(I){const A=d(I);return n[A]||A}function g(I){const A=d(I);return e.$XE[A].guessableName}function E(I){let A="";for(let $=0;$<I.length;$++)A+=String.fromCharCode(I[$]);return A}function D(I){switch(I){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const A=I.match(/windows(\d+)/);return A?"windows-"+A[1]:I}}}function S({buffer:I,bytesRead:A},$,v){let M=s(I,A),N=!1;if(M!==e.$IE&&M!==e.$JE&&I){let L=!0,F=!0,B=!1;for(let j=0;j<A&&j<c;j++){const U=j%2===1,z=I.readUInt8(j)===0;if(z&&(B=!0),L&&(U&&!z||!U&&z)&&(L=!1),F&&(U&&z||!U&&!z)&&(F=!1),z&&!L&&!F)break}B&&(L?M=e.$JE:F?M=e.$IE:N=!0)}return $&&!N&&!M&&I?o(I.slice(0,A),v).then(L=>({seemsBinary:!1,encoding:L})):{seemsBinary:N,encoding:M}}e.$WE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$XE=(()=>{const I={};for(const A in e.$WE)e.$WE[A].guessableName&&(I[A]=e.$WE[A]);return I})()}),define(ke[175],Ie([1,0,350,33,174]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0,h=We(h);class R extends C.$_qc{constructor(O,b,c=h,k="searchProcess"){super({query:O,provider:b},{readdir:y=>c.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,r.$UE)(y)},k)}}e.$msc=R}),define(ke[176],Ie([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=e.$fsc=void 0,e.$hsc=o,e.$isc=d,e.$jsc=g,e.$ksc=E,e.$lsc=S,r=We(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,$){this.a=A,this.b=$}provideTextSearchResults(A,$,v,M){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...$,folder:$.folder.toString()})}`),new Promise((N,L)=>{M.onCancellationRequested(()=>J());const F={...$,numThreads:this.b},B=o(A,F),j=$.folder.fsPath,U=B.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.a.appendLine(`${a} ${U}
 - cwd: ${j}`);let z=r.spawn(a,B,{cwd:j});z.on("error",ge=>{console.error(ge),this.a.appendLine("Error: "+(ge&&ge.message)),L((0,k.$lM)(new k.$jM(ge&&ge.message,k.SearchErrorCode.rgProcessError)))});let ee=!1;const V=new i($.maxResults,$.folder,$.previewOptions);V.on("result",ge=>{ee=!0,ce="",v.report(ge)});let W=!1;const J=()=>{W=!0,z?.kill(),V?.cancel()};let _=!1;V.on("hitLimit",()=>{_=!0,J()});let ce="";z.stdout.on("data",ge=>{V.handleData(ge),ee||(ce+=ge)});let ne=!1;z.stdout.once("data",()=>ne=!0);let ye="";z.stderr.on("data",ge=>{const Y=ge.toString();this.a.appendLine(Y),ye.length+Y.length<1e6&&(ye+=Y)}),z.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(ee?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),W)N({limitHit:_});else{V.flush(),z=null;let ge;ye&&!ne&&(ge=p(ye))?L((0,k.$lM)(new k.$jM(ge.message,ge.code))):N({limitHit:_})}})})}}e.$fsc=m;function p(I){const A=I.split(`
`),$=A[0].trim();if(A.some(M=>M.startsWith("regex parse error")))return new k.$jM(f(A),k.SearchErrorCode.regexParseError);const v=$.match(/grep config error: unknown encoding: (.*)/);if(v)return new k.$jM(`Unknown encoding: ${v[1]}`,k.SearchErrorCode.unknownEncoding);if($.startsWith("error parsing glob"))return new k.$jM($.charAt(0).toUpperCase()+$.substr(1),k.SearchErrorCode.globParseError);if($.startsWith("the literal"))return new k.$jM($.charAt(0).toUpperCase()+$.substr(1),k.SearchErrorCode.invalidLiteral);if($.startsWith("PCRE2: error compiling pattern"))return new k.$jM($,k.SearchErrorCode.regexParseError)}function f(I){const A=["Regex parse error"],$=I.filter(v=>v.startsWith("PCRE2:"));if($.length>=1){const v=$[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const M=v.split(":")[1];A.push(":"+M)}}return A.join("")}class i extends h.EventEmitter{constructor(A,$,v){super(),this.g=A,this.h=$,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new C.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,$){return super.on(A,$),this}handleData(A){if(this.b)return;const $=typeof A=="string"?A:this.d.write(A);this.k($)}k(A){let $=A.indexOf(`
`);const v=this.a+A;if($>=0)$+=this.a.length;else{this.a=v;return}let M=0;for(;$>=0;)this.m(v.substring(M,$).trim()),M=$+1,$=v.indexOf(`
`,M);this.a=v.substring(M)}m(A){if(this.b||!A)return;let $;try{$=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if($.type==="match"){const v=s($.data.path),M=c.URI.joinPath(this.h,v),N=this.n($.data,M);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if($.type==="context"){const v=s($.data.path),M=c.URI.joinPath(this.h,v);this.o($.data,M).forEach(L=>this.p(L))}}n(A,$){const v=A.line_number-1,M=s(A.lines),N=Buffer.from(M);let L=0,F=0,B=v;A.submatches.length===0&&A.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Hb)(A.submatches.map((U,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=s(U.match),V=N.slice(L,U.start).toString(),W=t(V),J=W.numLines>0?W.lastLineLength:W.lastLineLength+F,_=t(ee),ce=W.numLines+B,ne=_.numLines+ce,ye=_.numLines>0?_.lastLineLength:_.lastLineLength+J;return L=U.end,F=ye,B=ne,new y.$2L(ce,J,ne,ye)}));return(0,w.$$rc)($,M,j,this.j)}o(A,$){const v=s(A.lines),M=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,L)=>({text:N,uri:$,lineNumber:M+L}))}p(A){this.emit("result",A)}}e.$gsc=i;function s(I){return I.bytes?Buffer.from(I.bytes,"base64").toString():I.text}function t(I){const A=/\n/g;let $=0,v=-1,M;for(;M=A.exec(I);)$++,v=M.index;const N=v>=0?I.length-v-1:I.length;return{numLines:$,lastLineLength:N}}function o(I,A){const $=["--hidden","--no-require-git"];$.push(I.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:M}=(0,T.$c)(A.includes,L=>L.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const L=new Set;M.forEach(F=>{L.add(F)}),$.push("-g","!*"),L.forEach(F=>{n(F).map(w.$0rc).forEach(B=>{$.push("-g",B)})})}v&&v.length&&v.forEach(L=>{$.push("-g",L)}),A.excludes.map(w.$0rc).forEach(L=>$.push("-g",`!${L}`)),A.maxFileSize&&$.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||$.push("--no-ignore-parent"):$.push("--no-ignore"),A.followSymlinks&&$.push("--follow"),A.encoding&&A.encoding!=="utf8"&&$.push("--encoding",A.encoding),A.numThreads&&$.push("--threads",`${A.numThreads}`),I.pattern==="--"&&(I.isRegExp=!0,I.pattern="\\-\\-"),I.isMultiline&&!I.isRegExp&&(I.pattern=(0,b.$if)(I.pattern),I.isRegExp=!0),A.usePCRE2&&$.push("--pcre2"),$.push("--crlf"),I.isRegExp&&(I.pattern=d(I.pattern),$.push("--engine","auto"));let N;if(I.isWordMatch){const F=(0,b.$rf)(I.pattern,!!I.isRegExp,{wholeWord:I.isWordMatch}).source.replace(/\\\//g,"/");$.push("--regexp",F)}else if(I.isRegExp){let L=g(I.pattern);L=E(L),$.push("--regexp",L)}else N=I.pattern,$.push("--fixed-strings");return $.push("--no-config"),A.useGlobalIgnoreFiles||$.push("--no-ignore-global"),$.push("--json"),I.isMultiline&&$.push("--multiline"),A.beforeContext&&$.push("--before-context",A.beforeContext+""),A.afterContext&&$.push("--after-context",A.afterContext+""),$.push("--"),N&&$.push(N),$.push("."),$}function n(I){return S(I).flatMap($=>{const v=(0,O.$zk)($,"/");return v.map((M,N)=>v.slice(0,N+1).join("/"))})}function d(I){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;I.match(A);)I=I.replace(A,"$1\\x{$2}");const $=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;I.match($);)I=I.replace($,"$1\\x{$2}");return I}const l=I=>I.type==="Assertion"&&I.kind==="lookbehind";function g(I){let A;try{A=new u.RegExpParser().parsePattern(I)}catch{return I}let $="",v=0;const M=(F,B,j)=>{$+=I.slice(v,F)+j,v=B},N=[];return new u.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const B=N[0];if(!B)M(F.start,F.end,"\\r?\\n");else if(!N.some(l))if(B.type==="CharacterClass")if(B.negate){const j=I.slice(B.start+2,F.start)+I.slice(F.end,B.end-1);B.parent?.type==="Quantifier"?M(B.start,B.end,j?`[^${j}]`:"."):M(B.start,B.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=I.slice(B.start+1,F.start)+I.slice(F.end,B.end-1);M(B.start,B.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else B.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){l(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(A),$+=I.slice(v),$}function E(I){return I.replace(/\n/g,"\\r?\\n")}function D(I){let A=!1,$=!1,v="",M="";for(let N=0;N<I.length;N++){const L=I[N];switch(L){case"\\":$?(A?M+="\\"+L:v+="\\"+L,$=!1):$=!0;break;case"{":if($)A?M+=L:v+=L,$=!1;else{if(A)return{strInBraces:v+"{"+M+"{"+I.substring(N+1)};A=!0}break;case"}":if($)A?M+=L:v+=L,$=!1;else{if(A)return{fixedStart:v,strInBraces:M,fixedEnd:I.substring(N+1)};v+=L}break;default:A?M+=($?"\\":"")+L:v+=($?"\\":"")+L,$=!1;break}}return{strInBraces:v+(A?"{"+M:"")}}function S(I){const{fixedStart:A,strInBraces:$,fixedEnd:v}=D(I);if(A===void 0||v===void 0)return[$];let M=(0,O.$zk)($,",");M.length||(M=[""]);const N=S(v);return M.flatMap(L=>{const F=A+L;return N.map(B=>F+B)})}}),define(ke[351],Ie([1,0,20,176,89,14]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class T{constructor(c,k){this.b=c,this.c=k,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,k,y,u){const P=await this.c(),w=new h.$fsc(this.b,P),a={...k,numThreads:P};if(k.folder.scheme===R.Schemas.vscodeUserData){const m={...a,folder:k.folder.with({scheme:R.Schemas.file})},p=new C.$Dw(f=>y.report({...f,uri:f.uri.with({scheme:k.folder.scheme})}));return this.d(u,f=>w.provideTextSearchResults(c,m,p,f))}else return this.d(u,m=>w.provideTextSearchResults(c,a,y,m))}async d(c,k){const y=O(c);this.a.add(y);const u=await k(y.token);return this.a.delete(y),u}e(){this.a.forEach(c=>c.cancel())}}e.$psc=T;function O(b){const c=new r.$xe;return b.onCancellationRequested(()=>c.cancel()),c}}),define(ke[352],Ie([1,0,33,176,175]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsc=void 0,r=We(r);class R{constructor(b,c){this.a=b,this.b=c}search(b,c,k){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const y={appendLine(P){k({message:P})}},u=new C.$msc(this.a,new h.$fsc(y,this.b),r);return new Promise((P,w)=>u.search(a=>{c(a.map(T))},b).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$nsc=R;function T(O){return{path:O.resource&&O.resource.fsPath,results:O.results,numMatches:(O.results||[]).reduce((b,c)=>{if(c.ranges){const k=c;return b+(Array.isArray(k.ranges)?k.ranges.length:1)}else return b+1},0)}}}),define(ke[353],Ie([1,0,18,7,13,4,137,16,42,2,27,37,348,352]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=void 0,r=We(r);class w{static{this.a=512}constructor(s="searchProcess",t){this.d=s,this.f=t,this.b=Object.create(null)}fileSearch(s){let t;const o=p(s),n=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$th)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$esc,o,g=>n.fire(g),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=p(s),n=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$th)(d=>this.g(o,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(s,t,o){s.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new P.$nsc(s,n).search(o,t,t)}h(){return{maxFileSize:16*k.$Jl.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.$esc,s,o,n,w.a,t)}doFileSearchWithEngine(s,t,o,n,d=w.a,l){let g=0;const E=S=>{Array.isArray(S)?(g+=S.length,o(S.map(I=>this.j(I)))):S.relativePath?(g++,o(this.j(S))):o(S)};if(t.sortByScore){let S=this.n(t,E,n);if(!S){const I=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new s(I,l);S=this.k(A,t,o,E,n)}return new Promise((I,A)=>{S.then(([$,v])=>{const M=v.map(N=>this.j(N));this.q(M,o,d),I($)},A)})}const D=new s(t,l);return this.s(D,E,d,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}j(s){return{path:s.base?(0,O.$kc)(s.base,s.relativePath):s.relativePath}}k(s,t,o,n,d){const l=new R.$me;let g=(0,h.$th)(D=>{let S=[];const I=A=>{Array.isArray(A)?S=A:(n(A),l.fire(A))};return this.s(s,I,-1,D).then(A=>[A,S])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const D={promise:g,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=D,g.then(()=>{D.resolved=!0},S=>{delete E.resultsToSearchCache[t.filePattern||""]}),g=this.t(g)}return g.then(([D,S])=>{const I=E?E.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&b.$ge.create(!1);return this.o(t,S,I,d).then($=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:$.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&S.length>t.maxResults},$]})})}l(s){const t=this.b[s];return t||(this.b[s]=new a)}n(s,t,o){const n=s.cacheKey&&this.b[s.cacheKey];if(!n)return;const d=this.r(n,s.filePattern||"",t,o);if(d)return d.then(([l,g,E])=>{const D=b.$ge.create(!1);return this.o(s,g,n.scorerCache,o).then(S=>{const I=D.elapsed(),A={fromCache:!0,detailStats:E,type:this.d,resultCount:g.length,sortingTime:I};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:A,messages:[]},S]})})}o(s,t,o,n){const d=(0,T.$Ur)(s.filePattern||""),l=(E,D)=>(0,T.$Tr)(E,D,d,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:y.$$L;return r.$Gb(t,l,g,1e4,n)}q(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}r(s,t,o,n){const d=b.$ge.create(!1),l=t.indexOf(O.sep)>=0;let g;for(const I in s.resultsToSearchCache)if(t.startsWith(I)){if(l&&I.indexOf(O.sep)<0&&I!=="")continue;const A=s.resultsToSearchCache[I];g={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!g)return null;const E=d.elapsed(),D=b.$ge.create(!1),S=g.event(o);return n&&n.onCancellationRequested(()=>{S.dispose()}),g.promise.then(([I,A])=>{if(n&&n.isCancellationRequested)throw(0,C.$6)();const $=[],v=(0,T.$Ur)(t).normalizedLowercase;for(const M of A)(0,y.$pM)(M,v)&&$.push(M);return[I,$,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(s,t,o,n){return new Promise((d,l)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(t(g),g=[])):t(E))},E=>{t(E)},(E,D)=>{g.length&&t(g),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}t(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.$osc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,O.$oc)(i.relativePath)}getItemDescription(i){return(0,O.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function p(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>c.URI.revive(s))}}function f(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(ke[354],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,175]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0,R=We(R);let p=class extends k.$erc{constructor(i,s,t,o,n){super(i,t,n),this.D=o,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Uc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$_rc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$psc(d,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this.F(),o.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$_rc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$psc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$osc("fileSearchProvider",this.getNumThreadsCached)))}G(i,s){const t=this.d++;return this.y=s,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,k.$frc)(t);if(i===this.x){const d=Date.now();return this.H(i,s,n,o).then(l=>{const g=Date.now()-d;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=d=>{if((0,u.$oM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>C.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,o,s)}async H(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this.c.$handleFileMatch(i,s,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,s){return new m.$msc(i,s,void 0,"textSearchProvider")}};e.$qsc=p,e.$qsc=p=Ze([Ve(0,c.$oQ),Ve(1,b.$EQ),Ve(2,y.$3pc),Ve(3,O.$9pc),Ve(4,T.$bk)],p)}),define(ke[130],Ie([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=l,e.$zi=g,e.$Bi=S,e.$Ci=I;const a=3e4;class m{traceSocketEvent($,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,$,v)}constructor($,v=""){this.f=!0,this.debugLabel=v,this.socket=$,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,O.$Z)(N)}},this.socket.on("error",this.a);let M;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>$.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData($){const v=M=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,M),$(T.$Oe.wrap(M))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose($){const v=M=>{$({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd($){const v=()=>{$()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write($){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,$),this.socket.write($.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,O.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,O.$Z)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise(($,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),$();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),$()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$vi=m;var p;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class i extends c.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent($,v){this.socket.traceSocketEvent($,v)}constructor($,v,M,N){super(),this.f=this.B(new b.$me),this.g=this.B(new b.$me),this.h=!1,this.j={state:f.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=$,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:M?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,M,N,this.f,(L,F)=>this.m(L,F))),this.B(this.a.onError(L=>{console.error(L),(0,O.$Z)(L),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:L})})),this.b=new w.$qi,this.B(this.socket.onData(L=>this.n(L))),this.B(this.socket.onClose(async L=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(L)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData($){return this.f.event($)}onClose($){return this.g.event($)}onEnd($){return this.socket.onEnd($)}write($){let v=0;for(;v<$.byteLength;)this.a.writeMessage($.slice(v,Math.min(v+p.MaxWebSocketMessageLength,$.byteLength)),{compressed:!0,opcode:2}),v+=p.MaxWebSocketMessageLength}m($,{compressed:v,opcode:M}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,$);let N=p.MinHeaderByteSize;$.byteLength<126?N+=0:$.byteLength<2**16?N+=2:N+=8;const L=T.$Oe.alloc(N),F=v?64:0,B=M&15;if(L.writeUInt8(128|F|B,0),$.byteLength<126)L.writeUInt8($.byteLength,1);else if($.byteLength<2**16){L.writeUInt8(126,1);let j=1;L.writeUInt8($.byteLength>>>8&255,++j),L.writeUInt8($.byteLength>>>0&255,++j)}else{L.writeUInt8(127,1);let j=1;L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8($.byteLength>>>24&255,++j),L.writeUInt8($.byteLength>>>16&255,++j),L.writeUInt8($.byteLength>>>8&255,++j),L.writeUInt8($.byteLength>>>0&255,++j)}this.socket.write(T.$Oe.concat([L,$]))}end(){this.h=!0,this.socket.end()}n($){if($.byteLength!==0){for(this.b.acceptChunk($);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),M=v.readUInt8(0),N=(M&128)>>>7,L=(M&64)>>>6,F=M&15,B=v.readUInt8(1),j=(B&128)>>>7,U=B&127;this.j.state=f.ReadHeader,this.j.readLen=p.MinHeaderByteSize+(j?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!L),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),M=v.readUInt8(1),N=(M&128)>>>7;let L=M&127,F=1;L===126?L=v.readUInt8(++F)*2**8+v.readUInt8(++F):L===127&&(L=v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F));let B=0;N&&(B=v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F)),this.j.state=f.ReadBody,this.j.readLen=L,this.j.mask=B,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=p.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=i;class s extends c.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor($,v,M,N,L,F){super(),this.n=$,this.r=L,this.s=F,this.a=this.B(new b.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,M,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage($,v){this.g.push({data:$,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:$,options:v}=this.g.shift();if(this.f&&v.compressed){const M=await this.w(this.f,$);this.s(M,v)}else this.s($,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w($,v){return new Promise((M,N)=>{$.write(v),$.flush(L=>M(L))})}acceptFrame($,v,M){this.h.push({data:$,isCompressed:v,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const $=this.h.shift();if(this.b&&$.isCompressed){const v=await this.C(this.b,$.data,$.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire($.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C($,v,M){return new Promise((N,L)=>{$.write(v),M&&$.write(T.$Oe.fromByteArray([0,0,255,255])),$.flush(F=>N(F))})}}class t extends c.$Vc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor($,v,M,N){super(),this.h=$,this.j=v,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,L),this.g.push(T.$Oe.wrap(L))}),M&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write($){this.j&&this.f.push($.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,$),this.b.write($.buffer)}flush($){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,$(v)})}}class o extends c.$Vc{constructor($,v){super(),this.g=$,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(T.$Oe.wrap(M))})}write($){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,$.buffer),this.b.write($.buffer)}flush($){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),$(v)})}}function n(A,$){if($===0)return;const v=A.byteLength>>>2;for(let j=0;j<v;j++){const U=A.readUInt32BE(j*4);A.writeUInt32BE(U^$,j*4)}const M=v*4,N=A.byteLength-M,L=$>>>24&255,F=$>>>16&255,B=$>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(M)^L,M),N>=2&&A.writeUInt8(A.readUInt8(M+1)^F,M+1),N>=3&&A.writeUInt8(A.readUInt8(M+2)^B,M+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const d={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function l(){const A=(0,u.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const $=process.platform!=="darwin"&&e.$xi?e.$xi:(0,C.tmpdir)(),v=(0,k.$kc)($,`vscode-ipc-${A}.sock`);return E(v),v}function g(A,$,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${$}-sock`;const L=v.substr(0,4),F=$.substr(0,6);let B;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?B=(0,k.$kc)(e.$xi,`vscode-${N}-${L}-${F}.sock`):B=(0,k.$kc)(A,`${L}-${F}.sock`),E(B),B}function E(A){const $=d[y.$v];typeof $=="number"&&A.length>=$&&console.warn(`WARNING: IPC handle "${A}" is longer than ${$} chars, try a shorter --user-data-dir`)}class D extends P.$ki{static b($){const v=b.Event.fromNodeEventEmitter($,"connection");return b.Event.map(v,M=>({protocol:new w.$ri(new m(M,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(M,"close"))}))}constructor($){super(D.b($)),this.d=$}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=D;function S(A){return new Promise(($,v)=>{const M=(0,h.createServer)();M.on("error",v),M.listen(A,()=>{M.removeListener("error",v),$(new D(M))})})}function I(A,$){return new Promise((v,M)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",M),v(w.$si.fromSocket(new m(N,`ipc-client${$}`),$))});N.once("error",M)})}}),define(ke[355],Ie([1,0,67,66,192,130,7,3,10,46,11,115,235,237,117,92,21]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0,r=We(r),h=We(h);async function p(o,n,d,l,g){let E;for(let D=3;D&&(E?.dispose(),E=await new f(o,n,d,l,g).waitForReady(),!(g&&C.$6g[g]||!C.$6g[E.tunnelLocalPort]));D--);return E}class f extends O.$Vc{constructor(n,d,l,g,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new T.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Qw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,C.$7g)(n,2,1e3,d),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const d=(0,a.$Ow)(this.tunnelRemoteHost)||(0,a.$Qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$4l)(this.a,d,this.tunnelRemotePort),g=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof R.$vi?g.socket.destroy():g.end()}),g instanceof R.$vi?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(m.$Oe.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$7hc=f;let i=class extends a.$Tw{constructor(n,d,l,g,E){super(d,E),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,a.$Rw)(n,this.t,b.OS,h.release())}F(n,d,l,g,E,D,S,I){const A=this.D(d,l);if(A)return++A.refcount,A.value;if((0,a.$Kw)(n))return this.G(n,d,l,E,D,S,I);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const $={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=p($,g,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$8hc=i,e.$8hc=i=Ze([Ve(0,P.$Xl),Ve(1,k.$bk),Ve(2,w.$1l),Ve(3,y.$uk),Ve(4,c.$aj)],i);let s=class extends i{constructor(n,d,l,g,E){super(n,d,l,g,E)}};e.$9hc=s,e.$9hc=s=Ze([Ve(0,P.$Xl),Ve(1,k.$bk),Ve(2,w.$1l),Ve(3,y.$uk),Ve(4,c.$aj)],s);let t=class extends O.$Vc{constructor(n,d,l,g,E){super(),this.b=n,this.c=d,this.f=l,this.g=g,this.h=E,this.a=new Map}async openTunnel(n,d,l,g,E,D,S,I,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${D}.`),!this.a.has(n)){const $=new s(this.b,this.c,this.g,this.f,this.h);this.B($),this.a.set(n,$),$.onTunnelClosed(async()=>{(await $.tunnels).length===0&&($.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,g,E,D,S,I,A)}};e.$0hc=t,e.$0hc=t=Ze([Ve(0,P.$Xl),Ve(1,k.$bk),Ve(2,y.$uk),Ve(3,w.$1l),Ve(4,c.$aj)],t)}),define(ke[356],Ie([1,0,130,253,45,34,2,11,47]),function($e,e,r,h,C,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.$PQ=void 0,h=We(h),C=We(C);class c{constructor(u,P,w){this.b=u,this.c=P,this.f=w,this.a=h.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const w=(m,p)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify(p||null),f=>f&&this.c.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let p;switch(m.type){case"open":p=await this.i(m);break;case"openExternal":p=await this.j(m);break;case"status":p=await this.l(m);break;case"extensionManagement":p=await this.k(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,p)}catch(m){const p=m instanceof Error?m.message:JSON.stringify(m);w(500,p),this.c.error("Error while processing pipe request",m)}})}async i(u){const{fileURIs:P,folderURIs:w,forceNewWindow:a,diffMode:m,mergeMode:p,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:T.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,b.$_i)(E)?n.push({workspaceUri:T.URI.parse(E)}):n.push({fileUri:T.URI.parse(E)})}catch{}const d=t?T.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:p,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!f,waitMarkerFileURI:d,remoteAuthority:o};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(u){for(const P of u.uris){const w=T.URI.parse(P),a=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map(m=>/\.vsix$/i.test(m)?T.URI.parse(m):m),w={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&C.existsSync(this.f)&&C.unlinkSync(this.f)}}e.$PQ=c;let k=class extends c{constructor(u,P){super(u,P,(0,r.$yi)())}};e.$QQ=k,e.$QQ=k=Ze([Ve(0,R.$KQ),Ve(1,O.$bk)],k)}),define(ke[357],Ie([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=void 0,r=We(r);class a extends C.$Wrc{j(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(d,l,g){return d=o(d),f.a.has(d)?f.a.get(d).load(d,b.URI.file((0,u.$rr)(l.filename)),E=>s.apply(this,[E,l,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,o(n),d);const o=n=>{for(const d of f.b){const l=d(n);if(l){n=l;break}}return n}}}class m extends T.$Iqc{constructor(){super(...arguments),this.extensionRuntime=k.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$tsc);const f=this.h.invokeFunction(h.$Src);if(this.h.createInstance(O.$ssc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(y.$QQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$usc),await this.h.createInstance(a,f,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$rsc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(f){return f.main}async xb(f,i,s){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const o=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=$e.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$vsc=m}),define(ke[358],Ie([1,0,45,56,21,4,3,134,10,22,2,33,68,11,234,71,117,92,355,29,19,76,333]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=void 0,e.$wsc=n,e.$xsc=d,e.$ysc=l,e.$zsc=g,e.$Asc=D,e.$Bsc=S,e.$Csc=I,r=We(r),c=We(c),y=We(y);function n(v){const M=v.trim().split(`
`),N=[];return M.forEach(F=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);B&&B.length>=3&&N.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),N.reduce((F,B)=>(F[B.socket]=B,F),{})}function d(...v){const M=[].concat(...v.map(g));return[...new Map(M.filter(N=>N.st==="0A").map(N=>{const L=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(L[0]),port:parseInt(L[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let M="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)M+=parseInt(v.substr(N,2),16),N!==0&&(M+=".");else for(let N=0;N<v.length;N+=8){const L=v.substring(N,N+8);let F="";for(let B=8;B>=2;B-=2)F+=L.substring(B-2,B),(B===6||B===2)&&(F=parseInt(F,16).toString(16),M+=`${F}`,F="",N+B!==v.length-6&&(M+=":"))}return M}function g(v){const M=v.trim().split(`
`),N=M.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return M.map(F=>F.trim().split(/\s+/).reduce((B,j,U)=>(B[N[U]||U]=j,B),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function D(v){const M=v.trim().split(`
`),N=[];return M.forEach(L=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(L);F&&F.length>=4&&N.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),N}async function S(v,M,N){const L=N.reduce((B,j)=>(B[j.pid]=j,B),{}),F=[];return v.forEach(({socket:B,ip:j,port:U})=>{const z=M[B]?M[B].pid:void 0,ee=z?L[z]?.cmd:void 0;z&&ee&&!E(ee)&&F.push({host:j,port:U,detail:ee,pid:z})}),F}function I(v,M,N){const L=new Map,F=D(M);for(const B of v){const j=N.get(B.port);if(j){L.set(B.port,j);continue}const U=F.find(z=>z.cmd.includes(`${B.port}`));if(U){let z=U,ee;do ee=F.find(V=>V.ppid===z.pid),ee&&(z=ee);while(ee);L.set(B.port,{host:B.ip,port:B.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else L.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return L}let A=class extends t.$sGb{constructor(M,N,L,F){super(M,N,L),this.D=N,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(M){if(M&&this.C)return;this.C=M;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const L=new O.$Pm;let F=0;for(;this.C;){const B=new Date().getTime(),j=(await this.I()).filter(ee=>(0,p.$Ow)(ee.host)||(0,p.$Qw)(ee.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(ee=>ee.port).join(", ")}`);const U=new Date().getTime()-B;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),F++>3&&L.update(U),(!N||JSON.stringify(N)!==JSON.stringify(j))&&(N=j,await this.a.$onFoundNewCandidates(N));const z=this.G(L.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${z} ms.`),await new Promise(ee=>setTimeout(()=>ee(),z))}}G(M){return Math.max(M*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(M=>M.port).join(", ")}`)}async I(){let M="",N="";try{M=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const L=d(M,N),F=await new Promise(J=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,ce,ne)=>{J(ce)})}),B=n(F),j=await y.Promises.readdir("/proc"),U=[];for(const J of j)try{const _=Number(J),ce=c.$hh(k.URI.file("/proc"),J);if((await r.promises.stat(ce.fsPath)).isDirectory()&&!isNaN(_)){const ye=await r.promises.readlink(c.$hh(ce,"cwd").fsPath),ge=await r.promises.readFile(c.$hh(ce,"cmdline").fsPath,"utf8");U.push({pid:_,cwd:ye,cmd:ge})}}catch{}const z=[],ee=L.filter(J=>{const _=B[J.socket];return _||z.push(J),_}),V=S(ee,B,U);let W;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const J=await new Promise(_=>{(0,h.exec)("ps -F -A -l | grep root",(ce,ne,ye)=>{_(ne)})});this.z=I(z,J,this.z),W=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.map(_=>_.port).join(", ")}`)}return V.then(J=>W?J.concat(W):J)}w(M){return async N=>{const L=new f.$7hc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(B,j,U,z){const ee=await M.makeConnection();return $.connect(ee,j,U,z)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Tl(0),connectionToken:M.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await L.waitForReady();const F=new R.$me;return{localAddress:(0,o.$cN)(L.localAddress)??L.localAddress,remoteAddress:{port:L.tunnelRemotePort,host:L.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{L.dispose(),F.fire(),F.dispose()}}}}};e.$Dsc=A,e.$Dsc=A=Ze([Ve(0,s.$oQ),Ve(1,i.$EQ),Ve(2,P.$bk),Ve(3,m.$1l)],A);class $ extends w.$Mxb{static connect(M,N,L,F){const B=new T.$Uc,j={onClose:B.add(new R.$me),onData:B.add(new R.$me),onEnd:B.add(new R.$me)};B.add(M.onDidReceiveMessage(z=>j.onData.fire(C.$Oe.wrap(z)))),B.add(M.onDidEnd(()=>j.onEnd.fire())),B.add(M.onDidClose(z=>j.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:z,hadError:!!z})));const U=new $(M,F,j);return U.B(B),(0,w.$Lxb)(U,N,L,F,j)}constructor(M,N,L){super(N,L),this.n=M}write(M){this.n.send(M.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[359],Ie([1,0,88,328,342,341,354,357,358,101,54,102,100,48,76,97,327,287,11,343,64,248,112,117,150]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p,f,i,s,t,o,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Us)(k.$Jqc,O.$vsc,r.InstantiationType.Eager),(0,r.$Us)(f.$ck,p.$Fsc,r.InstantiationType.Delayed),(0,r.$Us)(f.$bk,new o.$Di(t.$Vrc,[!1],!0)),(0,r.$Us)(n.$1l,d.$_hc,r.InstantiationType.Delayed),(0,r.$Us)(a.$_pc,m.$Esc,r.InstantiationType.Eager),(0,r.$Us)(c.$Tqc,R.$9rc,r.InstantiationType.Eager),(0,r.$Us)(y.$drc,T.$qsc,r.InstantiationType.Eager),(0,r.$Us)(u.$Grc,C.$1rc,r.InstantiationType.Eager),(0,r.$Us)(P.$uqc,h.$Zrc,r.InstantiationType.Eager),(0,r.$Us)(w.$rGb,b.$Dsc,r.InstantiationType.Eager),(0,r.$Us)(s.$Mqc,i.$Gsc,r.InstantiationType.Eager)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[369],Ie([1,0,370,67,7,21,13,61,108,33,68,130,113,232,340,254,269,93,345,359]),function($e,e,r,h,C,R,T,O,b,c,k,y,u,P,w,a,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ut(r),h=We(h),O=We(O),P=Ut(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,D=E._load;E._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(E){process.exit=function(D){if(E)i(D);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,S){D==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),s(D,S)}}let o=function(E){i()};function n(){const E=(0,m.$hn)(process.env);if(E.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,S)=>{const I=A=>{const $=A[0],v=new k.$ti;$.on("message",M=>v.fire(R.$Oe.wrap(M.data))),$.on("close",()=>{o("renderer closed the MessagePort")}),$.start(),D({onMessage:v.event,send:M=>$.postMessage(M.buffer)})};process.parentPort.on("message",A=>I(A.ports))});if(E.type===m.ExtHostConnectionType.Socket)return new Promise((D,S)=>{let I=null;const A=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),$=k.ProtocolConstants.ReconnectionGraceTime,v=k.ProtocolConstants.ReconnectionShortGraceTime,M=new C.$Th(()=>o("renderer disconnected for too long (1)"),$),N=new C.$Th(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(F,B)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const j=R.$Oe.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new y.$vi(B,"extHost-socket");else{const z=R.$Oe.wrap(Buffer.from(F.inflateBytes,"base64"));U=new y.$wi(new y.$vi(B,"extHost-socket"),F.permessageDeflate,z,!1)}I?(M.cancel(),N.cancel(),I.beginAcceptReconnection(U,j),I.endAcceptReconnection(),I.sendResume()):(clearTimeout(A),I=new k.$ui({socket:U,initialChunk:j}),I.sendResume(),I.onDidDispose(()=>o("renderer disconnected")),D(I),I.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;M.isScheduled()&&N.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(L)});{const D=E.pipeName;return new Promise((S,I)=>{const A=h.createConnection(D,()=>{A.removeListener("error",I);const $=new k.$ui({socket:new y.$vi(A,"extHost-renderer")});$.sendResume(),S($)});A.once("error",I),A.on("close",()=>{o("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new k.$ti,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(D=>{(0,p.$Dn)(D,p.MessageType.Terminate)?(this.b=!0,this.d.dispose(),o("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||E.send(D)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(D=>{const S=E.onMessage(I=>{S.dispose();const A=JSON.parse(I.toString()),$=A.commit,v=P.default.commit;if($&&v&&$!==v&&i(p.ExtensionHostExitCode.VersionMismatch),A.parentPid){let M=0;setInterval(function(){try{process.kill(A.parentPid,0),M=0}catch(L){L&&L.code==="EPERM"?(M++,M>=3&&o(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):o(`parent process ${A.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(L){(0,T.$Z)(L)}}E.send((0,p.$Cn)(p.MessageType.Initialized)),D({protocol:E,initData:A})});E.send((0,p.$Cn)(p.MessageType.Ready))})}async function g(){const E=[];process.on("unhandledRejection",(M,N)=>{E.push(N),setTimeout(()=>{const L=E.indexOf(N);L>=0&&N.catch(F=>{E.splice(L,1),(0,T.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,T.$Z)(M))})},1e3)}),process.on("rejectionHandled",M=>{const N=E.indexOf(M);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(M){(0,T.$Y)(M)||(0,T.$Z)(M)}),O.mark("code/extHost/willConnectToRenderer");const D=await d();O.mark("code/extHost/didConnectToRenderer");const S=await l(D);O.mark("code/extHost/didWaitForInitData");const{initData:I}=S;t(!!I.environment.extensionTestsLocationURI),I.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,I.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,b.$qr)(N)}};let $=null;I.remote.authority&&f.transformURIs&&($=(0,a.$Ys)(I.remote.authority));const v=new w.$Yrc(S.protocol,I,A,$);o=M=>v.terminate(M)}g().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d4c4e690b9f1e70291da9a46c5c8ac5ebfbda81a/core/vs/workbench/api/node/extensionHostProcess.js.map
