/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ne=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(ve){for(var e=[],v=0,P=ve.length;v<P;v++)e[v]=Ne[ve[v]];return e};define(Ne[71],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=P,e.$_h=I,e.$ai=T;function v(A){return(O,$,o)=>{let k=null,y=null;if(typeof o.value=="function"?(k="value",y=o.value):typeof o.get=="function"&&(k="get",y=o.get),!y)throw new Error("not supported");o[k]=A(y,$)}}function P(A,O,$){let o=null,k=null;if(typeof $.value=="function"?(o="value",k=$.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(o="get",k=$.get),!k)throw new Error("not supported");const y=`$memoize$${O}`;$[o]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,a)}),this[y]}}function I(A,O,$){return v((o,k)=>{const y=`$debounce$${k}`,a=`$debounce$result$${k}`;return function(...S){this[a]||(this[a]=$?$():void 0),clearTimeout(this[y]),O&&(this[a]=O(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{o.apply(this,S),this[a]=$?$():void 0},A)}})}function T(A,O,$){return v((o,k)=>{const y=`$throttle$timer$${k}`,a=`$throttle$result$${k}`,S=`$throttle$lastRun$${k}`,d=`$throttle$pending$${k}`;return function(...r){if(this[a]||(this[a]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),O&&(this[a]=O(this[a],...r)),this[d])return;const s=this[S]+A;s<=Date.now()?(this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=$?$():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=$?$():void 0},s-Date.now()))}})}});var Gn=this&&this.__createBinding||(Object.create?function(ve,e,v,P){P===void 0&&(P=v);var I=Object.getOwnPropertyDescriptor(e,v);(!I||("get"in I?!e.__esModule:I.writable||I.configurable))&&(I={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(ve,P,I)}:function(ve,e,v,P){P===void 0&&(P=v),ve[P]=e[v]}),Kn=this&&this.__setModuleDefault||(Object.create?function(ve,e){Object.defineProperty(ve,"default",{enumerable:!0,value:e})}:function(ve,e){ve.default=e}),Ve=this&&this.__importStar||function(ve){if(ve&&ve.__esModule)return ve;var e={};if(ve!=null)for(var v in ve)v!=="default"&&Object.prototype.hasOwnProperty.call(ve,v)&&Gn(e,ve,v);return Kn(e,ve),e};define(Ne[136],Me([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=I,e.$9c=T,e.$0c=A,e.$$c=O,e.$_c=$,e.$ad=o,v=Ve(v);const P=(S,d)=>S===d;e.$7c=P;function I(S=e.$7c){return(d,r)=>v.$ub(d,r,S)}function T(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function A(){return(S,d)=>S.equals(d)}function O(S,d,r){if(r!==void 0){const s=S;return s==null||d===void 0||d===null?d===s:r(s,d)}else{const s=S;return(c,l)=>c==null||l===void 0||l===null?l===c:s(c,l)}}function $(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let r=0;r<S.length;r++)if(!$(S[r],d[r]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=S,s=d,c=Object.keys(r),l=Object.keys(s),i=new Set(l);if(c.length!==l.length)return!1;for(const n of c)if(!i.has(n)||!$(r[n],s[n]))return!1;return!0}return!1}function o(S){return JSON.stringify(a(S))}let k=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,r=Object.create(null);for(const s of Object.keys(d).sort())r[s]=a(d[s]);return r}else{let d=y.get(S);return d===void 0&&(d=k++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Ne[96],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=e.$tQ=void 0;class v{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$tQ=v,e.$uQ=new v("id#")}),define(Ne[137],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=A,e.$Yn=y,e.$Zn=a,e.$1n=S,e.$2n=d,e.$3n=r,e.$4n=s,e.$5n=c,e.$6n=l,e.$7n=i,e.$8n=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(t,g=!1){let u=0;const p=t.length;let m="",h=0,E=P.Unknown,D=v.None;function w(M){let W=0,G=0;for(;W<M;){const q=t.charCodeAt(u);if(q>=k._0&&q<=k._9)G=G*16+q-k._0;else if(q>=k.A&&q<=k.F)G=G*16+q-k.A+10;else if(q>=k.a&&q<=k.f)G=G*16+q-k.a+10;else break;u++,W++}return W<M&&(G=-1),G}function C(M){u=M,m="",h=0,E=P.Unknown,D=v.None}function R(){const M=u;if(t.charCodeAt(u)===k._0)u++;else for(u++;u<t.length&&o(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===k.dot)if(u++,u<t.length&&o(t.charCodeAt(u)))for(u++;u<t.length&&o(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(M,u);let W=u;if(u<t.length&&(t.charCodeAt(u)===k.E||t.charCodeAt(u)===k.e))if(u++,(u<t.length&&t.charCodeAt(u)===k.plus||t.charCodeAt(u)===k.minus)&&u++,u<t.length&&o(t.charCodeAt(u))){for(u++;u<t.length&&o(t.charCodeAt(u));)u++;W=u}else D=v.UnexpectedEndOfNumber;return t.substring(M,W)}function f(){let M="",W=u;for(;;){if(u>=p){M+=t.substring(W,u),D=v.UnexpectedEndOfString;break}const G=t.charCodeAt(u);if(G===k.doubleQuote){M+=t.substring(W,u),u++;break}if(G===k.backslash){if(M+=t.substring(W,u),u++,u>=p){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case k.doubleQuote:M+='"';break;case k.backslash:M+="\\";break;case k.slash:M+="/";break;case k.b:M+="\b";break;case k.f:M+="\f";break;case k.n:M+=`
`;break;case k.r:M+="\r";break;case k.t:M+="	";break;case k.u:{const J=w(4);J>=0?M+=String.fromCharCode(J):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}W=u;continue}if(G>=0&&G<=31)if($(G)){M+=t.substring(W,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return M}function b(){if(m="",D=v.None,h=u,u>=p)return h=p,E=P.EOF;let M=t.charCodeAt(u);if(O(M)){do u++,m+=String.fromCharCode(M),M=t.charCodeAt(u);while(O(M));return E=P.Trivia}if($(M))return u++,m+=String.fromCharCode(M),M===k.carriageReturn&&t.charCodeAt(u)===k.lineFeed&&(u++,m+=`
`),E=P.LineBreakTrivia;switch(M){case k.openBrace:return u++,E=P.OpenBraceToken;case k.closeBrace:return u++,E=P.CloseBraceToken;case k.openBracket:return u++,E=P.OpenBracketToken;case k.closeBracket:return u++,E=P.CloseBracketToken;case k.colon:return u++,E=P.ColonToken;case k.comma:return u++,E=P.CommaToken;case k.doubleQuote:return u++,m=f(),E=P.StringLiteral;case k.slash:{const W=u-1;if(t.charCodeAt(u+1)===k.slash){for(u+=2;u<p&&!$(t.charCodeAt(u));)u++;return m=t.substring(W,u),E=P.LineCommentTrivia}if(t.charCodeAt(u+1)===k.asterisk){u+=2;const G=p-1;let q=!1;for(;u<G;){if(t.charCodeAt(u)===k.asterisk&&t.charCodeAt(u+1)===k.slash){u+=2,q=!0;break}u++}return q||(u++,D=v.UnexpectedEndOfComment),m=t.substring(W,u),E=P.BlockCommentTrivia}return m+=String.fromCharCode(M),u++,E=P.Unknown}case k.minus:if(m+=String.fromCharCode(M),u++,u===p||!o(t.charCodeAt(u)))return E=P.Unknown;case k._0:case k._1:case k._2:case k._3:case k._4:case k._5:case k._6:case k._7:case k._8:case k._9:return m+=R(),E=P.NumericLiteral;default:for(;u<p&&L(M);)u++,M=t.charCodeAt(u);if(h!==u){switch(m=t.substring(h,u),m){case"true":return E=P.TrueKeyword;case"false":return E=P.FalseKeyword;case"null":return E=P.NullKeyword}return E=P.Unknown}return m+=String.fromCharCode(M),u++,E=P.Unknown}}function L(M){if(O(M)||$(M))return!1;switch(M){case k.closeBrace:case k.closeBracket:case k.openBrace:case k.openBracket:case k.doubleQuote:case k.colon:case k.comma:case k.slash:return!1}return!0}function N(){let M;do M=b();while(M>=P.LineCommentTrivia&&M<=P.Trivia);return M}return{setPosition:C,getPosition:()=>u,scan:g?N:b,getToken:()=>E,getTokenValue:()=>m,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>D}}function O(t){return t===k.space||t===k.tab||t===k.verticalTab||t===k.formFeed||t===k.nonBreakingSpace||t===k.ogham||t>=k.enQuad&&t<=k.zeroWidthSpace||t===k.narrowNoBreakSpace||t===k.mathematicalSpace||t===k.ideographicSpace||t===k.byteOrderMark}function $(t){return t===k.lineFeed||t===k.carriageReturn||t===k.lineSeparator||t===k.paragraphSeparator}function o(t){return t>=k._0&&t<=k._9}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function y(t,g){const u=[],p=new Object;let m;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(w,C,R,f){h.value=w,h.offset=C,h.length=R,h.type=f,h.colonOffset=void 0,m=h}try{i(t,{onObjectBegin:(w,C)=>{if(g<=w)throw p;m=void 0,E=g>w,u.push("")},onObjectProperty:(w,C,R)=>{if(g<C||(D(w,C,R,"property"),u[u.length-1]=w,g<=C+R))throw p},onObjectEnd:(w,C)=>{if(g<=w)throw p;m=void 0,u.pop()},onArrayBegin:(w,C)=>{if(g<=w)throw p;m=void 0,u.push(0)},onArrayEnd:(w,C)=>{if(g<=w)throw p;m=void 0,u.pop()},onLiteralValue:(w,C,R)=>{if(g<C||(D(w,C,R,n(w)),g<=C+R))throw p},onSeparator:(w,C,R)=>{if(g<=C)throw p;if(w===":"&&m&&m.type==="property")m.colonOffset=C,E=!1,m=void 0;else if(w===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(E=!0,u[u.length-1]=""),m=void 0}}})}catch(w){if(w!==p)throw w}return{path:u,previousNode:m,isAtPropertyKey:E,matches:w=>{let C=0;for(let R=0;C<w.length&&R<u.length;R++)if(w[C]===u[R]||w[C]==="*")C++;else if(w[C]!=="**")return!1;return C===w.length}}}function a(t,g=[],u=T.DEFAULT){let p=null,m=[];const h=[];function E(w){Array.isArray(m)?m.push(w):p!==null&&(m[p]=w)}return i(t,{onObjectBegin:()=>{const w={};E(w),h.push(m),m=w,p=null},onObjectProperty:w=>{p=w},onObjectEnd:()=>{m=h.pop()},onArrayBegin:()=>{const w=[];E(w),h.push(m),m=w,p=null},onArrayEnd:()=>{m=h.pop()},onLiteralValue:E,onError:(w,C,R)=>{g.push({error:w,offset:C,length:R})}},u),m[0]}function S(t,g=[],u=T.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(w){p.type==="property"&&(p.length=w-p.offset,p=p.parent)}function h(w){return p.children.push(w),w}i(t,{onObjectBegin:w=>{p=h({type:"object",offset:w,length:-1,parent:p,children:[]})},onObjectProperty:(w,C,R)=>{p=h({type:"property",offset:C,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:w,offset:C,length:R,parent:p})},onObjectEnd:(w,C)=>{p.length=w+C-p.offset,p=p.parent,m(w+C)},onArrayBegin:(w,C)=>{p=h({type:"array",offset:w,length:-1,parent:p,children:[]})},onArrayEnd:(w,C)=>{p.length=w+C-p.offset,p=p.parent,m(w+C)},onLiteralValue:(w,C,R)=>{h({type:n(w),offset:C,length:R,parent:p,value:w}),m(C+R)},onSeparator:(w,C,R)=>{p.type==="property"&&(w===":"?p.colonOffset=C:w===","&&m(C))},onError:(w,C,R)=>{g.push({error:w,offset:C,length:R})}},u);const D=p.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let u=t;for(const p of g)if(typeof p=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===p){u=h.children[1],m=!0;break}if(!m)return}else{const m=p;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const g=Object.create(null);for(const u of t.children){const p=u.children[1];p&&(g[u.children[0].value]=s(p))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(c(t,g,u)){const p=t.children;if(Array.isArray(p))for(let m=0;m<p.length&&p[m].offset<=g;m++){const h=l(p[m],g,u);if(h)return h}return t}}function i(t,g,u=T.DEFAULT){const p=A(t,!1);function m(ce){return ce?()=>ce(p.getTokenOffset(),p.getTokenLength()):()=>!0}function h(ce){return ce?pe=>ce(pe,p.getTokenOffset(),p.getTokenLength()):()=>!0}const E=m(g.onObjectBegin),D=h(g.onObjectProperty),w=m(g.onObjectEnd),C=m(g.onArrayBegin),R=m(g.onArrayEnd),f=h(g.onLiteralValue),b=h(g.onSeparator),L=m(g.onComment),N=h(g.onError),M=u&&u.disallowComments,W=u&&u.allowTrailingComma;function G(){for(;;){const ce=p.scan();switch(p.getTokenError()){case v.InvalidUnicode:q(I.InvalidUnicode);break;case v.InvalidEscapeCharacter:q(I.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:q(I.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:M||q(I.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:q(I.UnexpectedEndOfString);break;case v.InvalidCharacter:q(I.InvalidCharacter);break}switch(ce){case P.LineCommentTrivia:case P.BlockCommentTrivia:M?q(I.InvalidCommentToken):L();break;case P.Unknown:q(I.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return ce}}}function q(ce,pe=[],ae=[]){if(N(ce),pe.length+ae.length>0){let Se=p.getToken();for(;Se!==P.EOF;){if(pe.indexOf(Se)!==-1){G();break}else if(ae.indexOf(Se)!==-1)break;Se=G()}}}function J(ce){const pe=p.getTokenValue();return ce?f(pe):D(pe),G(),!0}function K(){switch(p.getToken()){case P.NumericLiteral:{let ce=0;try{ce=JSON.parse(p.getTokenValue()),typeof ce!="number"&&(q(I.InvalidNumberFormat),ce=0)}catch{q(I.InvalidNumberFormat)}f(ce);break}case P.NullKeyword:f(null);break;case P.TrueKeyword:f(!0);break;case P.FalseKeyword:f(!1);break;default:return!1}return G(),!0}function oe(){return p.getToken()!==P.StringLiteral?(q(I.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(J(!1),p.getToken()===P.ColonToken?(b(":"),G(),_()||q(I.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):q(I.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function me(){E(),G();let ce=!1;for(;p.getToken()!==P.CloseBraceToken&&p.getToken()!==P.EOF;){if(p.getToken()===P.CommaToken){if(ce||q(I.ValueExpected,[],[]),b(","),G(),p.getToken()===P.CloseBraceToken&&W)break}else ce&&q(I.CommaExpected,[],[]);oe()||q(I.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),ce=!0}return w(),p.getToken()!==P.CloseBraceToken?q(I.CloseBraceExpected,[P.CloseBraceToken],[]):G(),!0}function le(){C(),G();let ce=!1;for(;p.getToken()!==P.CloseBracketToken&&p.getToken()!==P.EOF;){if(p.getToken()===P.CommaToken){if(ce||q(I.ValueExpected,[],[]),b(","),G(),p.getToken()===P.CloseBracketToken&&W)break}else ce&&q(I.CommaExpected,[],[]);_()||q(I.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),ce=!0}return R(),p.getToken()!==P.CloseBracketToken?q(I.CloseBracketExpected,[P.CloseBracketToken],[]):G(),!0}function _(){switch(p.getToken()){case P.OpenBracketToken:return le();case P.OpenBraceToken:return me();case P.StringLiteral:return J(!0);default:return K()}}return G(),p.getToken()===P.EOF?u.allowEmptyContent?!0:(q(I.ValueExpected,[],[]),!1):_()?(p.getToken()!==P.EOF&&q(I.EndOfFileExpected,[],[]),!0):(q(I.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ne[138],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=v;function v(T){let A=!1;const O=new Map,$=new Map;if(I(T,r=>{if(T===r)return!0;const s=JSON.stringify(r);if(s.length<30)return!0;const c=O.get(s);if(!c){const l={schemas:[r]};return O.set(s,l),$.set(r,l),!0}return c.schemas.push(r),$.set(r,c),A=!0,!1}),O.clear(),!A)return JSON.stringify(T);let k="$defs";for(;T.hasOwnProperty(k);)k+="_";const y=[];function a(r){return JSON.stringify(r,(s,c)=>{if(c!==r){const l=$.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${k}/${l.id}`}}return c})}const S=a(T),d=[];for(let r=0;r<y.length;r++)d.push(`"_${r}":${a(y[r])}`);return d.length?`${S.substring(0,S.length-1)},"${k}":{${d.join(",")}}}`:S}function P(T){return typeof T=="object"&&T!==null}function I(T,A){if(!T||typeof T!="object")return;const O=(...S)=>{for(const d of S)P(d)&&y.push(d)},$=(...S)=>{for(const d of S)if(P(d))for(const r in d){const s=d[r];P(s)&&y.push(s)}},o=(...S)=>{for(const d of S)if(Array.isArray(d))for(const r of d)P(r)&&y.push(r)},k=S=>{if(Array.isArray(S))for(const d of S)P(d)&&y.push(d);else P(S)&&y.push(S)},y=[T];let a=y.pop();for(;a;)A(a)&&(O(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),$(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),o(a.anyOf,a.allOf,a.oneOf,a.prefixItems),k(a.items)),a=y.pop()}}),function(ve,e){typeof define=="function"&&define.amd?define(Ne[139],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(de,we){for(var he=0;he<we.length;he++){var Z=we[he];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(de,Z.key,Z)}}function v(de,we,he){return we&&e(de.prototype,we),he&&e(de,he),Object.defineProperty(de,"prototype",{writable:!1}),de}function P(de,we){if(de){if(typeof de=="string")return I(de,we);var he=Object.prototype.toString.call(de).slice(8,-1);if(he==="Object"&&de.constructor&&(he=de.constructor.name),he==="Map"||he==="Set")return Array.from(de);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(de,we)}}function I(de,we){(we==null||we>de.length)&&(we=de.length);for(var he=0,Z=new Array(we);he<we;he++)Z[he]=de[he];return Z}function T(de,we){var he=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(he)return(he=he.call(de)).next.bind(he);if(Array.isArray(de)||(he=P(de))||we&&de&&typeof de.length=="number"){he&&(de=he);var Z=0;return function(){return Z>=de.length?{done:!0}:{done:!1,value:de[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=A();function O(de){ve.defaults=de}var $=/[&<>"']/,o=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(we){return a[we]};function d(de,we){if(we){if($.test(de))return de.replace(o,S)}else if(k.test(de))return de.replace(y,S);return de}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(de){return de.replace(r,function(we,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(de,we){de=typeof de=="string"?de:de.source,we=we||"";var he={replace:function(x,be){return be=be.source||be,be=be.replace(c,"$1"),de=de.replace(x,be),he},getRegex:function(){return new RegExp(de,we)}};return he}var i=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(de,we,he){if(de){var Z;try{Z=decodeURIComponent(s(he)).replace(i,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}we&&!n.test(he)&&(he=h(we,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var g={},u=/^[^:]+:\/*[^/]*$/,p=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(de,we){g[" "+de]||(u.test(de)?g[" "+de]=de+"/":g[" "+de]=C(de,"/",!0)),de=g[" "+de];var he=de.indexOf(":")===-1;return we.substring(0,2)==="//"?he?we:de.replace(p,"$1")+we:we.charAt(0)==="/"?he?we:de.replace(m,"$1")+we:de+we}var E={exec:function(){}};function D(de){for(var we=1,he,Z;we<arguments.length;we++){he=arguments[we];for(Z in he)Object.prototype.hasOwnProperty.call(he,Z)&&(de[Z]=he[Z])}return de}function w(de,we){var he=de.replace(/\|/g,function(be,$e,Ae){for(var Ue=!1,ke=$e;--ke>=0&&Ae[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),Z=he.split(/ \|/),x=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>we)Z.splice(we);else for(;Z.length<we;)Z.push("");for(;x<Z.length;x++)Z[x]=Z[x].trim().replace(/\\\|/g,"|");return Z}function C(de,we,he){var Z=de.length;if(Z===0)return"";for(var x=0;x<Z;){var be=de.charAt(Z-x-1);if(be===we&&!he)x++;else if(be!==we&&he)x++;else break}return de.slice(0,Z-x)}function R(de,we){if(de.indexOf(we[1])===-1)return-1;for(var he=de.length,Z=0,x=0;x<he;x++)if(de[x]==="\\")x++;else if(de[x]===we[0])Z++;else if(de[x]===we[1]&&(Z--,Z<0))return x;return-1}function f(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(de,we){if(we<1)return"";for(var he="";we>1;)we&1&&(he+=de),we>>=1,de+=de;return he+de}function L(de,we,he,Z){var x=we.href,be=we.title?d(we.title):null,$e=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ae={type:"link",raw:he,href:x,title:be,text:$e,tokens:Z.inlineTokens($e)};return Z.state.inLink=!1,Ae}return{type:"image",raw:he,href:x,title:be,text:d($e)}}function N(de,we){var he=de.match(/^(\s+)(?:```)/);if(he===null)return we;var Z=he[1];return we.split(`
`).map(function(x){var be=x.match(/^\s+/);if(be===null)return x;var $e=be[0];return $e.length>=Z.length?x.slice(Z.length):x}).join(`
`)}var M=function(){function de(he){this.options=he||ve.defaults}var we=de.prototype;return we.space=function(Z){var x=this.rules.block.newline.exec(Z);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(Z){var x=this.rules.block.code.exec(Z);if(x){var be=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?be:C(be,`
`)}}},we.fences=function(Z){var x=this.rules.block.fences.exec(Z);if(x){var be=x[0],$e=N(be,x[3]||"");return{type:"code",raw:be,lang:x[2]?x[2].trim():x[2],text:$e}}},we.heading=function(Z){var x=this.rules.block.heading.exec(Z);if(x){var be=x[2].trim();if(/#$/.test(be)){var $e=C(be,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(be=$e.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:be,tokens:this.lexer.inline(be)}}},we.hr=function(Z){var x=this.rules.block.hr.exec(Z);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(Z){var x=this.rules.block.blockquote.exec(Z);if(x){var be=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},we.list=function(Z){var x=this.rules.block.list.exec(Z);if(x){var be,$e,Ae,Ue,ke,Pe,Te,z,j,Q,V,re,ge=x[1].trim(),Ce=ge.length>1,ze={type:"list",raw:"",ordered:Ce,start:Ce?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Ce?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Ce?ge:"[*+-]");for(var He=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(re=!1,!(!(x=He.exec(Z))||this.rules.block.hr.test(Z)));){if(be=x[0],Z=Z.substring(be.length),z=x[2].split(`
`,1)[0],j=Z.split(`
`,1)[0],this.options.pedantic?(Ue=2,V=z.trimLeft()):(Ue=x[2].search(/[^ ]/),Ue=Ue>4?1:Ue,V=z.slice(Ue),Ue+=x[1].length),Pe=!1,!z&&/^ *$/.test(j)&&(be+=j+`
`,Z=Z.substring(j.length+1),re=!0),!re)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");Z&&(Q=Z.split(`
`,1)[0],z=Q,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(z)||et.test(z)||_e.test(z)||tt.test(Z)));){if(z.search(/[^ ]/)>=Ue||!z.trim())V+=`
`+z.slice(Ue);else if(!Pe)V+=`
`+z;else break;!Pe&&!z.trim()&&(Pe=!0),be+=Q+`
`,Z=Z.substring(Q.length+1)}ze.loose||(Te?ze.loose=!0:/\n *\n *$/.test(be)&&(Te=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(V),$e&&(Ae=$e[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:be,task:!!$e,checked:Ae,loose:!1,text:V}),ze.raw+=be}ze.items[ze.items.length-1].raw=be.trimRight(),ze.items[ze.items.length-1].text=V.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var ft=ze.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=ft.every(function(st){for(var ct=st.raw.split(""),mt=0,$t=T(ct),qe;!(qe=$t()).done;){var je=qe.value;if(je===`
`&&(mt+=1),mt>1)return!0}return!1});!ze.loose&&ft.length&&lt&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},we.html=function(Z){var x=this.rules.block.html.exec(Z);if(x){var be={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);be.type="paragraph",be.text=$e,be.tokens=this.lexer.inline($e)}return be}},we.def=function(Z){var x=this.rules.block.def.exec(Z);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var be=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:x[0],href:x[2],title:x[3]}}},we.table=function(Z){var x=this.rules.block.table.exec(Z);if(x){var be={type:"table",header:w(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=x[0];var $e=be.align.length,Ae,Ue,ke,Pe;for(Ae=0;Ae<$e;Ae++)/^ *-+: *$/.test(be.align[Ae])?be.align[Ae]="right":/^ *:-+: *$/.test(be.align[Ae])?be.align[Ae]="center":/^ *:-+ *$/.test(be.align[Ae])?be.align[Ae]="left":be.align[Ae]=null;for($e=be.rows.length,Ae=0;Ae<$e;Ae++)be.rows[Ae]=w(be.rows[Ae],be.header.length).map(function(Te){return{text:Te}});for($e=be.header.length,Ue=0;Ue<$e;Ue++)be.header[Ue].tokens=this.lexer.inline(be.header[Ue].text);for($e=be.rows.length,Ue=0;Ue<$e;Ue++)for(Pe=be.rows[Ue],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return be}}},we.lheading=function(Z){var x=this.rules.block.lheading.exec(Z);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(Z){var x=this.rules.block.paragraph.exec(Z);if(x){var be=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:be,tokens:this.lexer.inline(be)}}},we.text=function(Z){var x=this.rules.block.text.exec(Z);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(Z){var x=this.rules.inline.escape.exec(Z);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},we.tag=function(Z){var x=this.rules.inline.tag.exec(Z);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},we.link=function(Z){var x=this.rules.inline.link.exec(Z);if(x){var be=x[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var $e=C(be.slice(0,-1),"\\");if((be.length-$e.length)%2===0)return}else{var Ae=R(x[2],"()");if(Ae>-1){var Ue=x[0].indexOf("!")===0?5:4,ke=Ue+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);z&&(Pe=z[1],Te=z[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(be)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),L(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(Z,x){var be;if((be=this.rules.inline.reflink.exec(Z))||(be=this.rules.inline.nolink.exec(Z))){var $e=(be[2]||be[1]).replace(/\s+/g," ");if($e=x[$e.toLowerCase()],!$e||!$e.href){var Ae=be[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return L(be,$e,be[0],this.lexer)}},we.emStrong=function(Z,x,be){be===void 0&&(be="");var $e=this.rules.inline.emStrong.lDelim.exec(Z);if($e&&!($e[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=$e[1]||$e[2]||"";if(!Ae||Ae&&(be===""||this.rules.inline.punctuation.exec(be))){var Ue=$e[0].length-1,ke,Pe,Te=Ue,z=0,j=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*Z.length+Ue);($e=j.exec(x))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Pe=ke.length,$e[3]||$e[4]){Te+=Pe;continue}else if(($e[5]||$e[6])&&Ue%3&&!((Ue+Pe)%3)){z+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+z),Math.min(Ue,Pe)%2){var Q=Z.slice(1,Ue+$e.index+Pe);return{type:"em",raw:Z.slice(0,Ue+$e.index+Pe+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var V=Z.slice(2,Ue+$e.index+Pe-1);return{type:"strong",raw:Z.slice(0,Ue+$e.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},we.codespan=function(Z){var x=this.rules.inline.code.exec(Z);if(x){var be=x[2].replace(/\n/g," "),$e=/[^ ]/.test(be),Ae=/^ /.test(be)&&/ $/.test(be);return $e&&Ae&&(be=be.substring(1,be.length-1)),be=d(be,!0),{type:"codespan",raw:x[0],text:be}}},we.br=function(Z){var x=this.rules.inline.br.exec(Z);if(x)return{type:"br",raw:x[0]}},we.del=function(Z){var x=this.rules.inline.del.exec(Z);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(Z,x){var be=this.rules.inline.autolink.exec(Z);if(be){var $e,Ae;return be[2]==="@"?($e=d(this.options.mangle?x(be[1]):be[1]),Ae="mailto:"+$e):($e=d(be[1]),Ae=$e),{type:"link",raw:be[0],text:$e,href:Ae,tokens:[{type:"text",raw:$e,text:$e}]}}},we.url=function(Z,x){var be;if(be=this.rules.inline.url.exec(Z)){var $e,Ae;if(be[2]==="@")$e=d(this.options.mangle?x(be[0]):be[0]),Ae="mailto:"+$e;else{var Ue;do Ue=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ue!==be[0]);$e=d(be[0]),be[1]==="www."?Ae="http://"+$e:Ae=$e}return{type:"link",raw:be[0],text:$e,href:Ae,tokens:[{type:"text",raw:$e,text:$e}]}}},we.inlineText=function(Z,x){var be=this.rules.inline.text.exec(Z);if(be){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):d(be[0]):be[0]:$e=d(this.options.smartypants?x(be[0]):be[0]),{type:"text",raw:be[0],text:$e}}},de}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=l(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=l(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=l(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=l(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=l(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=D({},W),W.gfm=D({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=l(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=D({},W.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=l(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=l(W._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=l(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=l(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=l(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=l(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=l(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=l(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=l(G.reflink).replace("label",G._label).replace("ref",W._label).getRegex(),G.nolink=l(G.nolink).replace("ref",W._label).getRegex(),G.reflinkSearch=l(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=D({},G),G.pedantic=D({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=D({},G.normal,{escape:l(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),G.gfm.url=l(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=D({},G.gfm,{br:l(G.br).replace("{2,}","*").getRegex(),text:l(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(de){var we="",he,Z,x=de.length;for(he=0;he<x;he++)Z=de.charCodeAt(he),Math.random()>.5&&(Z="x"+Z.toString(16)),we+="&#"+Z+";";return we}var K=function(){function de(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ve.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:W.normal,inline:G.normal};this.options.pedantic?(Z.block=W.pedantic,Z.inline=G.pedantic):this.options.gfm&&(Z.block=W.gfm,this.options.breaks?Z.inline=G.breaks:Z.inline=G.gfm),this.tokenizer.rules=Z}de.lex=function(Z,x){var be=new de(x);return be.lex(Z)},de.lexInline=function(Z,x){var be=new de(x);return be.inlineTokens(Z)};var we=de.prototype;return we.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(Z,x){var be=this;x===void 0&&(x=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Te,z,j){return z+"    ".repeat(j.length)});for(var $e,Ae,Ue,ke;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return($e=Te.call({lexer:be},Z,x))?(Z=Z.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.space(Z)){Z=Z.substring($e.raw.length),$e.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push($e);continue}if($e=this.tokenizer.code(Z)){Z=Z.substring($e.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e);continue}if($e=this.tokenizer.fences(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.heading(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.hr(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.blockquote(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.list(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.html(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.def(Z)){Z=Z.substring($e.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.lheading(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,z=Z.slice(1),j=void 0;be.options.extensions.startBlock.forEach(function(Q){j=Q.call({lexer:this},z),typeof j=="number"&&j>=0&&(Te=Math.min(Te,j))}),Te<1/0&&Te>=0&&(Ue=Z.substring(0,Te+1))}(),this.state.top&&($e=this.tokenizer.paragraph(Ue))){Ae=x[x.length-1],ke&&Ae.type==="paragraph"?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e),ke=Ue.length!==Z.length,Z=Z.substring($e.raw.length);continue}if($e=this.tokenizer.text(Z)){Z=Z.substring($e.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+$e.raw,Ae.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push($e);continue}if(Z){var Pe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},we.inline=function(Z,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:Z,tokens:x}),x},we.inlineTokens=function(Z,x){var be=this;x===void 0&&(x=[]);var $e,Ae,Ue,ke=Z,Pe,Te,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)j.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Te||(z=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return($e=V.call({lexer:be},Z,x))?(Z=Z.substring($e.raw.length),x.push($e),!0):!1}))){if($e=this.tokenizer.escape(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.tag(Z)){Z=Z.substring($e.raw.length),Ae=x[x.length-1],Ae&&$e.type==="text"&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.link(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring($e.raw.length),Ae=x[x.length-1],Ae&&$e.type==="text"&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if($e=this.tokenizer.emStrong(Z,ke,z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.codespan(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.br(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.del(Z)){Z=Z.substring($e.raw.length),x.push($e);continue}if($e=this.tokenizer.autolink(Z,J)){Z=Z.substring($e.raw.length),x.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(Z,J))){Z=Z.substring($e.raw.length),x.push($e);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,re=Z.slice(1),ge=void 0;be.options.extensions.startInline.forEach(function(Ce){ge=Ce.call({lexer:this},re),typeof ge=="number"&&ge>=0&&(V=Math.min(V,ge))}),V<1/0&&V>=0&&(Ue=Z.substring(0,V+1))}(),$e=this.tokenizer.inlineText(Ue,q)){Z=Z.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(z=$e.raw.slice(-1)),Te=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=$e.raw,Ae.text+=$e.text):x.push($e);continue}if(Z){var Q="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return x},v(de,null,[{key:"rules",get:function(){return{block:W,inline:G}}}]),de}(),oe=function(){function de(he){this.options=he||ve.defaults}var we=de.prototype;return we.code=function(Z,x,be){var $e=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(Z,$e);Ae!=null&&Ae!==Z&&(be=!0,Z=Ae)}return Z=Z.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(be?Z:d(Z,!0))+`</code></pre>
`:"<pre><code>"+(be?Z:d(Z,!0))+`</code></pre>
`},we.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},we.html=function(Z){return Z},we.heading=function(Z,x,be,$e){if(this.options.headerIds){var Ae=this.options.headerPrefix+$e.slug(be);return"<h"+x+' id="'+Ae+'">'+Z+"</h"+x+`>
`}return"<h"+x+">"+Z+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Z,x,be){var $e=x?"ol":"ul",Ae=x&&be!==1?' start="'+be+'"':"";return"<"+$e+Ae+`>
`+Z+"</"+$e+`>
`},we.listitem=function(Z){return"<li>"+Z+`</li>
`},we.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Z){return"<p>"+Z+`</p>
`},we.table=function(Z,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+x+`</table>
`},we.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},we.tablecell=function(Z,x){var be=x.header?"th":"td",$e=x.align?"<"+be+' align="'+x.align+'">':"<"+be+">";return $e+Z+("</"+be+`>
`)},we.strong=function(Z){return"<strong>"+Z+"</strong>"},we.em=function(Z){return"<em>"+Z+"</em>"},we.codespan=function(Z){return"<code>"+Z+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Z){return"<del>"+Z+"</del>"},we.link=function(Z,x,be){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return be;var $e='<a href="'+d(Z)+'"';return x&&($e+=' title="'+x+'"'),$e+=">"+be+"</a>",$e},we.image=function(Z,x,be){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return be;var $e='<img src="'+Z+'" alt="'+be+'"';return x&&($e+=' title="'+x+'"'),$e+=this.options.xhtml?"/>":">",$e},we.text=function(Z){return Z},de}(),me=function(){function de(){}var we=de.prototype;return we.strong=function(Z){return Z},we.em=function(Z){return Z},we.codespan=function(Z){return Z},we.del=function(Z){return Z},we.html=function(Z){return Z},we.text=function(Z){return Z},we.link=function(Z,x,be){return""+be},we.image=function(Z,x,be){return""+be},we.br=function(){return""},de}(),le=function(){function de(){this.seen={}}var we=de.prototype;return we.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Z,x){var be=Z,$e=0;if(this.seen.hasOwnProperty(be)){$e=this.seen[Z];do $e++,be=Z+"-"+$e;while(this.seen.hasOwnProperty(be))}return x||(this.seen[Z]=$e,this.seen[be]=0),be},we.slug=function(Z,x){x===void 0&&(x={});var be=this.serialize(Z);return this.getNextSafeSlug(be,x.dryrun)},de}(),_=function(){function de(he){this.options=he||ve.defaults,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new le}de.parse=function(Z,x){var be=new de(x);return be.parse(Z)},de.parseInline=function(Z,x){var be=new de(x);return be.parseInline(Z)};var we=de.prototype;return we.parse=function(Z,x){x===void 0&&(x=!0);var be="",$e,Ae,Ue,ke,Pe,Te,z,j,Q,V,re,ge,Ce,ze,He,_e,tt,nt,et,rt=Z.length;for($e=0;$e<rt;$e++){if(V=Z[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){be+=et||"";continue}switch(V.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(V.tokens),V.depth,s(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(j="",z="",ke=V.header.length,Ae=0;Ae<ke;Ae++)z+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(j+=this.renderer.tablerow(z),Q="",ke=V.rows.length,Ae=0;Ae<ke;Ae++){for(Te=V.rows[Ae],z="",Pe=Te.length,Ue=0;Ue<Pe;Ue++)z+=this.renderer.tablecell(this.parseInline(Te[Ue].tokens),{header:!1,align:V.align[Ue]});Q+=this.renderer.tablerow(z)}be+=this.renderer.table(j,Q);continue}case"blockquote":{Q=this.parse(V.tokens),be+=this.renderer.blockquote(Q);continue}case"list":{for(re=V.ordered,ge=V.start,Ce=V.loose,ke=V.items.length,Q="",Ae=0;Ae<ke;Ae++)He=V.items[Ae],_e=He.checked,tt=He.task,ze="",He.task&&(nt=this.renderer.checkbox(_e),Ce?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=nt+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=nt+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(He.tokens,Ce),Q+=this.renderer.listitem(ze,tt,_e);be+=this.renderer.list(Q,re,ge);continue}case"html":{be+=this.renderer.html(V.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(Q=V.tokens?this.parseInline(V.tokens):V.text;$e+1<rt&&Z[$e+1].type==="text";)V=Z[++$e],Q+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);be+=x?this.renderer.paragraph(Q):Q;continue}default:{var ft='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return be},we.parseInline=function(Z,x){x=x||this.renderer;var be="",$e,Ae,Ue,ke=Z.length;for($e=0;$e<ke;$e++){if(Ae=Z[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ue=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){be+=Ue||"";continue}switch(Ae.type){case"escape":{be+=x.text(Ae.text);break}case"html":{be+=x.html(Ae.text);break}case"link":{be+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{be+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{be+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{be+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{be+=x.codespan(Ae.text);break}case"br":{be+=x.br();break}case"del":{be+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{be+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return be},de}();function ce(de,we,he){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof we=="function"&&(he=we,we=null),we=D({},ce.defaults,we||{}),f(we),he){var Z=we.highlight,x;try{x=K.lex(de,we)}catch(ke){return he(ke)}var be=function(Pe){var Te;if(!Pe)try{we.walkTokens&&ce.walkTokens(x,we.walkTokens),Te=_.parse(x,we)}catch(z){Pe=z}return we.highlight=Z,Pe?he(Pe):he(null,Te)};if(!Z||Z.length<3||(delete we.highlight,!x.length))return be();var $e=0;ce.walkTokens(x,function(ke){ke.type==="code"&&($e++,setTimeout(function(){Z(ke.text,ke.lang,function(Pe,Te){if(Pe)return be(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),$e--,$e===0&&be()})},0))}),$e===0&&be();return}function Ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=K.lex(de,we);if(we.walkTokens){if(we.async)return Promise.all(ce.walkTokens(Ue,we.walkTokens)).then(function(){return _.parse(Ue,we)}).catch(Ae);ce.walkTokens(Ue,we.walkTokens)}return _.parse(Ue,we)}catch(ke){Ae(ke)}}ce.options=ce.setOptions=function(de){return D(ce.defaults,de),O(ce.defaults),ce},ce.getDefaults=A,ce.defaults=ve.defaults,ce.use=function(){for(var de=arguments.length,we=new Array(de),he=0;he<de;he++)we[he]=arguments[he];var Z=D.apply(void 0,[{}].concat(we)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},be;we.forEach(function($e){if($e.extensions&&(be=!0,$e.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=x.renderers?x.renderers[Ue.name]:null;ke?x.renderers[Ue.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),z=0;z<Pe;z++)Te[z]=arguments[z];var j=Ue.renderer.apply(this,Te);return j===!1&&(j=ke.apply(this,Te)),j}:x.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Ue.level]?x[Ue.level].unshift(Ue.tokenizer):x[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?x.startBlock?x.startBlock.push(Ue.start):x.startBlock=[Ue.start]:Ue.level==="inline"&&(x.startInline?x.startInline.push(Ue.start):x.startInline=[Ue.start]))}Ue.childTokens&&(x.childTokens[Ue.name]=Ue.childTokens)})),$e.renderer&&function(){var Ue=ce.defaults.renderer||new oe,ke=function(z){var j=Ue[z];Ue[z]=function(){for(var Q=arguments.length,V=new Array(Q),re=0;re<Q;re++)V[re]=arguments[re];var ge=$e.renderer[z].apply(Ue,V);return ge===!1&&(ge=j.apply(Ue,V)),ge}};for(var Pe in $e.renderer)ke(Pe);Z.renderer=Ue}(),$e.tokenizer&&function(){var Ue=ce.defaults.tokenizer||new M,ke=function(z){var j=Ue[z];Ue[z]=function(){for(var Q=arguments.length,V=new Array(Q),re=0;re<Q;re++)V[re]=arguments[re];var ge=$e.tokenizer[z].apply(Ue,V);return ge===!1&&(ge=j.apply(Ue,V)),ge}};for(var Pe in $e.tokenizer)ke(Pe);Z.tokenizer=Ue}(),$e.walkTokens){var Ae=ce.defaults.walkTokens;Z.walkTokens=function(Ue){var ke=[];return ke.push($e.walkTokens.call(this,Ue)),Ae&&(ke=ke.concat(Ae.call(this,Ue))),ke}}be&&(Z.extensions=x),ce.setOptions(Z)})},ce.walkTokens=function(de,we){for(var he=[],Z=function(){var Ae=be.value;switch(he=he.concat(we.call(ce,Ae)),Ae.type){case"table":{for(var Ue=T(Ae.header),ke;!(ke=Ue()).done;){var Pe=ke.value;he=he.concat(ce.walkTokens(Pe.tokens,we))}for(var Te=T(Ae.rows),z;!(z=Te()).done;)for(var j=z.value,Q=T(j),V;!(V=Q()).done;){var re=V.value;he=he.concat(ce.walkTokens(re.tokens,we))}break}case"list":{he=he.concat(ce.walkTokens(Ae.items,we));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(ge){he=he.concat(ce.walkTokens(Ae[ge],we))}):Ae.tokens&&(he=he.concat(ce.walkTokens(Ae.tokens,we)))}},x=T(de),be;!(be=x()).done;)Z();return he},ce.parseInline=function(de,we){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");we=D({},ce.defaults,we||{}),f(we);try{var he=K.lexInline(de,we);return we.walkTokens&&ce.walkTokens(he,we.walkTokens),_.parseInline(he,we)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Z.message+"",!0)+"</pre>";throw Z}},ce.Parser=_,ce.parser=_.parse,ce.Renderer=oe,ce.TextRenderer=me,ce.Lexer=K,ce.lexer=K.lex,ce.Tokenizer=M,ce.Slugger=le,ce.parse=ce;var pe=ce.options,ae=ce.setOptions,Se=ce.use,Oe=ce.walkTokens,X=ce.parseInline,B=ce,te=_.parse,ye=K.lex;ve.Lexer=K,ve.Parser=_,ve.Renderer=oe,ve.Slugger=le,ve.TextRenderer=me,ve.Tokenizer=M,ve.getDefaults=A,ve.lexer=ye,ve.marked=ce,ve.options=pe,ve.parse=B,ve.parseInline=X,ve.parser=te,ve.setOptions=ae,ve.use=Se,ve.walkTokens=Oe,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ne[140],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=v;function v(r){const s=T(r);if(s&&s.length>0)return new Uint32Array(s)}let P=0;const I=new Uint32Array(10);function T(r){if(P=0,A(r,y,$.InitialConsonant),P>0||(A(r,a,$.Vowel),P>0)||(A(r,S,$.FinalConsonant),P>0)||(A(r,d,$.CompatibilityJamo),P))return I.subarray(0,P);if(r>=44032&&r<=55203){const s=r-44032,c=s%588,l=Math.floor(s/588),i=Math.floor(c/28),n=c%28-1;if(l<y.length?A(l,y,0):$.InitialConsonant+l-$.CompatibilityJamo<d.length&&A($.InitialConsonant+l,d,$.CompatibilityJamo),i<a.length?A(i,a,0):$.Vowel+i-$.CompatibilityJamo<d.length&&A($.Vowel+i-$.CompatibilityJamo,d,$.CompatibilityJamo),n>=0&&(n<S.length?A(n,S,0):$.FinalConsonant+n-$.CompatibilityJamo<d.length&&A($.FinalConsonant+n-$.CompatibilityJamo,d,$.CompatibilityJamo)),P>0)return I.subarray(0,P)}}function A(r,s,c){r>=c&&r<c+s.length&&O(s[r-c])}function O(r){r!==o.NUL&&(I[P++]=r&255,r>>8&&(I[P++]=r>>8&255),r>>16&&(I[P++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var o;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(o||(o={}));var k;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(k||(k={}));const y=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,k.hk,k.ho,k.hl,o.y,o.n,k.nj,k.np,k.nl,o.b,o.m,k.ml,o.l]),S=new Uint16Array([o.r,o.R,k.rt,o.s,k.sw,k.sg,o.e,o.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,o.a,o.q,k.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),d=new Uint16Array([o.r,o.R,k.rt,o.s,k.sw,k.sg,o.e,o.E,o.f,k.fr,k.fa,k.fq,k.ft,k.fx,k.fv,k.fg,o.a,o.q,o.Q,k.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,k.hk,k.ho,k.hl,o.y,o.n,k.nj,k.np,k.nl,o.b,o.m,k.ml,o.l])}),define(Ne[141],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0,e.$Mm=v,e.rot=P,e.$Rm=O;function v($,o,k){return Math.min(Math.max($,o),k)}function P($,o){return(o+$%o)%o}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Om=I;class T{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pm=T;class A{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const k=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Qm=A;function O($,o,k,y,a,S,d,r){const s=d-k,c=r-y,l=a-k,i=S-y,n=$-k,t=o-y,g=s*s+c*c,u=s*l+c*i,p=s*n+c*t,m=l*l+i*i,h=l*n+i*t,E=1/(g*m-u*u),D=(m*p-u*h)*E,w=(g*h-u*p)*E;return D>=0&&w>=0&&D+w<1}}),define(Ne[142],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=T,e.$dd=a;class v{constructor(d,r,s){this.owner=d,this.debugNameSource=r,this.referenceFn=s}getDebugName(d){return T(d,this)}}e.$bd=v;const P=new Map,I=new WeakMap;function T(S,d){const r=I.get(S);if(r)return r;const s=A(S,d);if(s){let c=P.get(s)??0;c++,P.set(s,c);const l=c===1?s:`${s}#${c}`;return I.set(S,l),l}}function A(S,d){const r=I.get(S);if(r)return r;const s=d.owner?k(d.owner)+".":"";let c;const l=d.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return s+c}else return s+l;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return s+c;if(d.owner!==void 0){const n=O(d.owner,S);if(n!==void 0)return s+n}}function O(S,d){for(const r in S)if(S[r]===d)return r}const $=new Map,o=new WeakMap;function k(S){const d=o.get(S);if(d)return d;const r=y(S);let s=$.get(r)??0;s++,$.set(r,s);const c=s===1?r:`${r}#${s}`;return o.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(Ne[143],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=P,e.$Md=I;let v;function P(r){v=r}function I(){return v}class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([O(S("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[O(" "),o(k(s.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),o(k(s.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),o(k(s.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(s,c){console.log(...this.b([$("observable value changed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(s){if(s.size!==0)return o(" (changed deps: "+[...s].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleDerivedRecomputed(s,c){const l=this.d.get(s);console.log(...this.b([$("derived recomputed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(l),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(s,c){console.log(...this.b([$("observable from event triggered"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleAutorunTriggered(s){const c=this.d.get(s);console.log(...this.b([$("autorun"),o(s.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let c=s.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),o(c,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=T;function A(r){const s=new Array,c=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,s.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(r);const n=[l,...s];return n.push(...c),n}function O(r){return o(r,{color:"black"})}function $(r){return o(d(`${r}: `,10),{color:"black",bold:!0})}function o(r,s={color:"black"}){function c(i){return Object.entries(i).reduce((n,[t,g])=>`${n}${t}:${g};`,"")}const l={color:s.color};return s.strikeThrough&&(l["text-decoration"]="line-through"),s.bold&&(l["font-weight"]="bold"),{text:r,style:c(l)}}function k(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,s):a(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,s){let c="[ ",l=!0;for(const i of r){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${k(i,s-c.length)}`}return c+=" ]",c}function a(r,s){let c="{ ",l=!0;for(const[i,n]of Object.entries(r)){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${i}: ${k(n,s-c.length)}`}return c+=" }",c}function S(r,s){let c="";for(let l=1;l<=s;l++)c+=r;return c}function d(r,s){for(;r.length<s;)r+=" ";return r}}),define(Ne[144],Me([1,0,136,142,143]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=A,e.$Xd=$,e.$Yd=k,e.$2d=S,e.$3d=r,e.$4d=s,e.$5d=c,e.$7d=i,e.$9d=t;let T;function A(u){T=u}let O;function $(u){O=u}let o;function k(u){o=u}class y{get TChange(){return null}reportChanges(){this.get()}read(p){return p?p.readObservable(this):this.get()}map(p,m){const h=m===void 0?void 0:p,E=m===void 0?p:m;return o({owner:h,debugName:()=>{const D=(0,P.$dd)(E);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(C)return`${this.debugName}.${C[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return o({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},p=>this.read(p).read(p))}recomputeInitiallyAndOnChange(p,m){return p.add(T(this,m)),this}keepObserved(p){return p.add(O(this)),this}get a(){return this.get()}}e.$Zd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver(p){const m=this.b.size;this.b.add(p),m===0&&this.c()}removeObserver(p){this.b.delete(p)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=a;function S(u,p){const m=new l(u,p);try{u(m)}finally{m.finish()}}let d;function r(u){if(d)u(d);else{const p=new l(u,void 0);d=p;try{u(p)}finally{p.finish(),d=void 0}}}async function s(u,p){const m=new l(u,p);try{await u(m)}finally{m.finish()}}function c(u,p,m){u?p(u):S(p,m)}class l{constructor(p,m){this._fn=p,this.b=m,this.a=[],(0,I.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,P.$dd)(this._fn)}updateObserver(p,m){this.a.push({observer:p,observable:m}),p.beginUpdate(m)}finish(){const p=this.a;for(let m=0;m<p.length;m++){const{observer:h,observable:E}=p[m];h.endUpdate(E)}this.a=null,(0,I.$Md)()?.handleEndTransaction()}}e.$6d=l;function i(u,p){let m;return typeof u=="string"?m=new P.$bd(void 0,u,void 0):m=new P.$bd(u,void 0,void 0),new n(m,p,v.$7c)}class n extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(p,m,h){super(),this.e=p,this.g=h,this.d=m}get(){return this.d}set(p,m,h){if(h===void 0&&this.g(this.d,p))return;let E;m||(m=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(p),(0,I.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:p,change:h,didChange:!0,hadValue:!0});for(const w of this.b)m.updateObserver(w,this),w.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(p){this.d=p}}e.$8d=n;function t(u,p){let m;return typeof u=="string"?m=new P.$bd(void 0,u,void 0):m=new P.$bd(u,void 0,void 0),new g(m,p,v.$7c)}class g extends n{h(p){this.d!==p&&(this.d&&this.d.dispose(),this.d=p)}dispose(){this.d?.dispose()}}e.$0d=g}),function(){function ve(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function A($){T.push($,Date.now())}function O(){const $=[];for(let o=0;o<T.length;o+=2)$.push({name:T[o],startTime:T[o+1]});return $}return{mark:A,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(I+A.startTime)});return T}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function v(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=v(P))}(),define(Ne[145],Me([1,0,40]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0;const P=Symbol("unset");class I{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,o,k){this.d($,y=>y._value=o,k)}mutate($,o){this.d($,k=>k._value=o(k._value===P?void 0:k._value))}mutatePath($,o){this.d($,()=>{},k=>o(k))}delete($){const o=this.c($);if(!o)return;let k=o.length-1;const y=o[k].node._value;if(y!==P){for(this.b--,o[k].node._value=P;k>0;k--){const{node:a,part:S}=o[k];if(a.children?.size||a._value!==P)break;o[k-1].node.children.delete(S)}return y}}*deleteRecursive($){const o=this.c($);if(!o)return;const k=o[o.length-1].node;for(let y=o.length-1;y>0;y--){const a=o[y-1];if(a.node.children.delete(o[y].part),a.node.children.size>0||a.node._value!==P)break}for(const y of T(k))y._value!==P&&(this.b--,yield y._value)}find($){let o=this.a;for(const k of $){const y=o.children?.get(k);if(!y)return;o=y}return o._value===P?void 0:o._value}hasKeyOrParent($){let o=this.a;for(const k of $){const y=o.children?.get(k);if(!y)return!1;if(y._value!==P)return!0;o=y}return!1}hasKeyOrChildren($){let o=this.a;for(const k of $){const y=o.children?.get(k);if(!y)return!1;o=y}return!0}hasKey($){let o=this.a;for(const k of $){const y=o.children?.get(k);if(!y)return!1;o=y}return o._value!==P}c($){const o=[{part:"",node:this.a}];let k=0;for(const y of $){const a=o[k].node.children?.get(y);if(!a)return;o.push({part:y,node:a}),k++}return o}d($,o,k){let y=this.a;for(const d of $){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const r=new A;y.children.set(d,r),y=r}else{const r=new A;y.children=new Map([[d,r]]),y=r}k?.(y)}const a=y._value===P?0:1;o(y);const S=y._value===P?0:1;this.b+=S-a}*values(){for(const{_value:$}of T(this.a))$!==P&&(yield $)}}e.$0I=I;function*T(O){const $=[O];for(;$.length>0;){const o=$.pop();if(yield o,o.children)for(const k of o.children.values())$.push(k)}}class A{constructor(){this._value=P}get value(){return this._value===P?void 0:this._value}set value($){this._value=$===void 0?P:$}}}),define(Ne[146],Me([1,0,48,19]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=O,e.$Er=$,e.$Fr=o,e.$Gr=k,e.$Hr=y,e.$Ir=a,e.$Jr=S,e.$Kr=d,e.$Lr=r,e.$Mr=s,e.$Nr=h,e.$Or=E,e.$Pr=D;const I=new v.$U(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),T=new v.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(w,C,R=!1){const f=w||"",b=C||"",L=I.value.collator.compare(f,b);return I.value.collatorIsNumeric&&L===0&&f!==b?f<b?-1:1:L}function $(w,C){const R=T.value.collator;return w=w||"",C=C||"",n(R,w,C)}function o(w,C){const R=T.value.collator;return w=w||"",C=C||"",p(w,C)||n(R,w,C)}function k(w,C){const R=T.value.collator;return w=w||"",C=C||"",u(w,C)||n(R,w,C)}function y(w,C){return w=w||"",C=C||"",w===C?0:w<C?-1:1}function a(w,C){const[R,f]=l(w),[b,L]=l(C);let N=I.value.collator.compare(f,L);if(N===0){if(I.value.collatorIsNumeric&&f!==L)return f<L?-1:1;if(N=I.value.collator.compare(R,b),I.value.collatorIsNumeric&&N===0&&R!==b)return R<b?-1:1}return N}function S(w,C){w=w||"",C=C||"";const R=i(w),f=i(C),b=T.value.collator,L=A.value.collator;return n(L,R,f)||n(b,w,C)}function d(w,C){w=w||"",C=C||"";const R=i(w),f=i(C),b=T.value.collator,L=A.value.collator;return n(L,R,f)||p(w,C)||n(b,w,C)}function r(w,C){w=w||"",C=C||"";const R=i(w),f=i(C),b=T.value.collator,L=A.value.collator;return n(L,R,f)||u(w,C)||n(b,w,C)}function s(w,C){w=w||"",C=C||"";const R=i(w).toLowerCase(),f=i(C).toLowerCase();return R!==f?R<f?-1:1:w!==C?w<C?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function l(w,C=!1){const R=w?c.exec(w):[];let f=[R&&R[1]||"",R&&R[3]||""];return C&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(w){const C=w?c.exec(w):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(w,C,R){const f=w.compare(C,R);return f!==0?f:C.length!==R.length?C.length<R.length?-1:1:0}function t(w){const C=w.charAt(0);return C.toLocaleUpperCase()!==C}function g(w){const C=w.charAt(0);return C.toLocaleLowerCase()!==C}function u(w,C){return t(w)&&g(C)?-1:g(w)&&t(C)?1:0}function p(w,C){return g(w)&&t(C)?-1:t(w)&&g(C)?1:0}function m(w,C,R=!1){return R||(w=w&&w.toLowerCase(),C=C&&C.toLowerCase()),w===C?0:w<C?-1:1}function h(w,C,R=!1){const f=w.split(P.sep),b=C.split(P.sep),L=f.length-1,N=b.length-1;let M,W;for(let G=0;;G++){if(M=L===G,W=N===G,M&&W)return O(f[G],b[G],R);if(M)return-1;if(W)return 1;const q=m(f[G],b[G],R);if(q!==0)return q}}function E(w,C,R){const f=w.toLowerCase(),b=C.toLowerCase(),L=D(w,C,R);if(L)return L;const N=f.endsWith(R),M=b.endsWith(R);if(N!==M)return N?-1:1;const W=O(f,b);return W!==0?W:f.localeCompare(b)}function D(w,C,R){const f=w.toLowerCase(),b=C.toLowerCase(),L=f.startsWith(R),N=b.startsWith(R);if(L!==N)return L?-1:1;if(L&&N){if(f.length<b.length)return-1;if(f.length>b.length)return 1}return 0}}),define(Ne[72],Me([1,0,19]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0,e.$ct=T,e.$dt=A,e.$et=O,e.$ft=o,e.$bt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(k){const y=(0,v.$pc)(k),a=P[y.toLowerCase()];return a!==void 0?a:A(k)}function A(k){const y=(0,v.$pc)(k);return I[y.toLowerCase()]}function O(k){for(const y in I)if(I[y]===k)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function o(k,y){const a=$.exec(k);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:k}}),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var P in v)(typeof exports=="object"?exports:ve)[P]=v[P]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function v(P){if(e[P])return e[P].exports;var I=e[P]={i:P,l:!1,exports:{}};return ve[P].call(I.exports,I,I.exports,v),I.l=!0,I.exports}return v.m=ve,v.c=e,v.d=function(P,I,T){v.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:T})},v.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},v.t=function(P,I){if(1&I&&(P=v(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var T=Object.create(null);if(v.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var A in P)v.d(T,A,function(O){return P[O]}.bind(null,A));return T},v.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return v.d(I,"a",I),I},v.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},v.p="",v(v.s=0)}([function(ve,e,v){(function(P){var I;e=ve.exports=Se,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],$=e.src=[],o=0,k=o++;$[k]="0|[1-9]\\d*";var y=o++;$[y]="[0-9]+";var a=o++;$[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=o++;$[S]="("+$[k]+")\\.("+$[k]+")\\.("+$[k]+")";var d=o++;$[d]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var r=o++;$[r]="(?:"+$[k]+"|"+$[a]+")";var s=o++;$[s]="(?:"+$[y]+"|"+$[a]+")";var c=o++;$[c]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var l=o++;$[l]="(?:-?("+$[s]+"(?:\\."+$[s]+")*))";var i=o++;$[i]="[0-9A-Za-z-]+";var n=o++;$[n]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=o++,g="v?"+$[S]+$[c]+"?"+$[n]+"?";$[t]="^"+g+"$";var u="[v=\\s]*"+$[d]+$[l]+"?"+$[n]+"?",p=o++;$[p]="^"+u+"$";var m=o++;$[m]="((?:<|>)?=?)";var h=o++;$[h]=$[y]+"|x|X|\\*";var E=o++;$[E]=$[k]+"|x|X|\\*";var D=o++;$[D]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[c]+")?"+$[n]+"?)?)?";var w=o++;$[w]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[l]+")?"+$[n]+"?)?)?";var C=o++;$[C]="^"+$[m]+"\\s*"+$[D]+"$";var R=o++;$[R]="^"+$[m]+"\\s*"+$[w]+"$";var f=o++;$[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=o++;$[b]="(?:~>?)";var L=o++;$[L]="(\\s*)"+$[b]+"\\s+",O[L]=new RegExp($[L],"g");var N=o++;$[N]="^"+$[b]+$[D]+"$";var M=o++;$[M]="^"+$[b]+$[w]+"$";var W=o++;$[W]="(?:\\^)";var G=o++;$[G]="(\\s*)"+$[W]+"\\s+",O[G]=new RegExp($[G],"g");var q=o++;$[q]="^"+$[W]+$[D]+"$";var J=o++;$[J]="^"+$[W]+$[w]+"$";var K=o++;$[K]="^"+$[m]+"\\s*("+u+")$|^$";var oe=o++;$[oe]="^"+$[m]+"\\s*("+g+")$|^$";var me=o++;$[me]="(\\s*)"+$[m]+"\\s*("+u+"|"+$[D]+")",O[me]=new RegExp($[me],"g");var le=o++;$[le]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var _=o++;$[_]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var ce=o++;$[ce]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)I(pe,$[pe]),O[pe]||(O[pe]=new RegExp($[pe]));function ae(j,Q){if(j instanceof Se)return j;if(typeof j!="string"||j.length>T||!(Q?O[p]:O[t]).test(j))return null;try{return new Se(j,Q)}catch{return null}}function Se(j,Q){if(j instanceof Se){if(j.loose===Q)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Se))return new Se(j,Q);I("SemVer",j,Q),this.loose=Q;var V=j.trim().match(Q?O[p]:O[t]);if(!V)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<A)return ge}return re}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=ae,e.valid=function(j,Q){var V=ae(j,Q);return V?V.version:null},e.clean=function(j,Q){var V=ae(j.trim().replace(/^[=v]+/,""),Q);return V?V.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof Se||(j=new Se(j,this.loose)),this.compareMain(j)||this.comparePre(j)},Se.prototype.compareMain=function(j){return j instanceof Se||(j=new Se(j,this.loose)),X(this.major,j.major)||X(this.minor,j.minor)||X(this.patch,j.patch)},Se.prototype.comparePre=function(j){if(j instanceof Se||(j=new Se(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Q=0;do{var V=this.prerelease[Q],re=j.prerelease[Q];if(I("prerelease compare",Q,V,re),V===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(V===void 0)return-1;if(V!==re)return X(V,re)}while(++Q)},Se.prototype.inc=function(j,Q){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Q,V,re){typeof V=="string"&&(re=V,V=void 0);try{return new Se(j,V).inc(Q,re).version}catch{return null}},e.diff=function(j,Q){if(de(j,Q))return null;var V=ae(j),re=ae(Q);if(V.prerelease.length||re.prerelease.length){for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return ge},e.compareIdentifiers=X;var Oe=/^[0-9]+$/;function X(j,Q){var V=Oe.test(j),re=Oe.test(Q);return V&&re&&(j=+j,Q=+Q),V&&!re?-1:re&&!V?1:j<Q?-1:j>Q?1:0}function B(j,Q,V){return new Se(j,V).compare(new Se(Q,V))}function te(j,Q,V){return B(j,Q,V)>0}function ye(j,Q,V){return B(j,Q,V)<0}function de(j,Q,V){return B(j,Q,V)===0}function we(j,Q,V){return B(j,Q,V)!==0}function he(j,Q,V){return B(j,Q,V)>=0}function Z(j,Q,V){return B(j,Q,V)<=0}function x(j,Q,V,re){var ge;switch(Q){case"===":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j===V;break;case"!==":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j!==V;break;case"":case"=":case"==":ge=de(j,V,re);break;case"!=":ge=we(j,V,re);break;case">":ge=te(j,V,re);break;case">=":ge=he(j,V,re);break;case"<":ge=ye(j,V,re);break;case"<=":ge=Z(j,V,re);break;default:throw new TypeError("Invalid operator: "+Q)}return ge}function be(j,Q){if(j instanceof be){if(j.loose===Q)return j;j=j.value}if(!(this instanceof be))return new be(j,Q);I("comparator",j,Q),this.loose=Q,this.parse(j),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,Q){return X(Q,j)},e.major=function(j,Q){return new Se(j,Q).major},e.minor=function(j,Q){return new Se(j,Q).minor},e.patch=function(j,Q){return new Se(j,Q).patch},e.compare=B,e.compareLoose=function(j,Q){return B(j,Q,!0)},e.rcompare=function(j,Q,V){return B(Q,j,V)},e.sort=function(j,Q){return j.sort(function(V,re){return e.compare(V,re,Q)})},e.rsort=function(j,Q){return j.sort(function(V,re){return e.rcompare(V,re,Q)})},e.gt=te,e.lt=ye,e.eq=de,e.neq=we,e.gte=he,e.lte=Z,e.cmp=x,e.Comparator=be;var $e={};function Ae(j,Q){if(j instanceof Ae)return j.loose===Q?j:new Ae(j.raw,Q);if(j instanceof be)return new Ae(j.value,Q);if(!(this instanceof Ae))return new Ae(j,Q);if(this.loose=Q,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function Ue(j){return!j||j.toLowerCase()==="x"||j==="*"}function ke(j,Q,V,re,ge,Ce,ze,He,_e,tt,nt,et,rt){return((Q=Ue(V)?"":Ue(re)?">="+V+".0.0":Ue(ge)?">="+V+"."+re+".0":">="+Q)+" "+(He=Ue(_e)?"":Ue(tt)?"<"+(+_e+1)+".0.0":Ue(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+He)).trim()}function Pe(j,Q){for(var V=0;V<j.length;V++)if(!j[V].test(Q))return!1;if(Q.prerelease.length){for(V=0;V<j.length;V++)if(I(j[V].semver),j[V].semver!==$e&&j[V].semver.prerelease.length>0){var re=j[V].semver;if(re.major===Q.major&&re.minor===Q.minor&&re.patch===Q.patch)return!0}return!1}return!0}function Te(j,Q,V){try{Q=new Ae(Q,V)}catch{return!1}return Q.test(j)}function z(j,Q,V,re){var ge,Ce,ze,He,_e;switch(j=new Se(j,re),Q=new Ae(Q,re),V){case">":ge=te,Ce=Z,ze=ye,He=">",_e=">=";break;case"<":ge=ye,Ce=he,ze=te,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(j,Q,re))return!1;for(var tt=0;tt<Q.set.length;++tt){var nt=Q.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===$e&&(ft=new be(">=0.0.0")),et=et||ft,rt=rt||ft,ge(ft.semver,et.semver,re)?et=ft:ze(ft.semver,rt.semver,re)&&(rt=ft)}),et.operator===He||et.operator===_e||(!rt.operator||rt.operator===He)&&Ce(j,rt.semver)||rt.operator===_e&&ze(j,rt.semver))return!1}return!0}be.prototype.parse=function(j){var Q=this.loose?O[K]:O[oe],V=j.match(Q);if(!V)throw new TypeError("Invalid comparator: "+j);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new Se(V[2],this.loose):this.semver=$e},be.prototype.toString=function(){return this.value},be.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===$e||(typeof j=="string"&&(j=new Se(j,this.loose)),x(j,this.operator,this.semver,this.loose))},be.prototype.intersects=function(j,Q){if(!(j instanceof be))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(j.value,Q),Te(this.value,V,Q);if(j.operator==="")return V=new Ae(this.value,Q),Te(j.semver,V,Q);var re=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ce=this.semver.version===j.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),He=x(this.semver,"<",j.semver,Q)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=x(this.semver,">",j.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return re||ge||Ce&&ze||He||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(j){var Q=this.loose;j=j.trim(),I("range",j,Q);var V=Q?O[_]:O[le];j=j.replace(V,ke),I("hyphen replace",j),j=j.replace(O[me],"$1$2$3"),I("comparator trim",j,O[me]),j=(j=(j=j.replace(O[L],"$1~")).replace(O[G],"$1^")).split(/\s+/).join(" ");var re=Q?O[K]:O[oe],ge=j.split(" ").map(function(Ce){return function(ze,He){return I("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){I("caret",et,rt);var ft=rt?O[J]:O[q];return et.replace(ft,function(lt,st,ct,mt,$t){var qe;return I("caret",et,lt,st,ct,mt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?qe=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":$t?(I("replaceCaret pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+$t+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+$t+" <"+(+st+1)+".0.0"):(I("no pr"),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+" <"+(+st+1)+".0.0"),I("caret return",qe),qe})}(nt,tt)}).join(" ")}(ze,He),I("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?O[M]:O[N];return et.replace(ft,function(lt,st,ct,mt,$t){var qe;return I("tilde",et,lt,st,ct,mt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?qe=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":$t?(I("replaceTilde pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0"):qe=">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0",I("tilde return",qe),qe})}(nt,tt)}).join(" ")}(ze,He),I("tildes",ze),ze=function(_e,tt){return I("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?O[R]:O[C];return et.replace(ft,function(lt,st,ct,mt,$t,qe){I("xRange",et,lt,st,ct,mt,$t,qe);var je=Ue(ct),ne=je||Ue(mt),ee=ne||Ue($t);return st==="="&&ee&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&ee?(ne&&(mt=0),ee&&($t=0),st===">"?(st=">=",ne?(ct=+ct+1,mt=0,$t=0):ee&&(mt=+mt+1,$t=0)):st==="<="&&(st="<",ne?ct=+ct+1:mt=+mt+1),lt=st+ct+"."+mt+"."+$t):ne?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":ee&&(lt=">="+ct+"."+mt+".0 <"+ct+"."+(+mt+1)+".0"),I("xRange return",lt),lt})}(nt,tt)}).join(" ")}(ze,He),I("xrange",ze),ze=function(_e,tt){return I("replaceStars",_e,tt),_e.trim().replace(O[ce],"")}(ze,He),I("stars",ze),ze}(Ce,Q)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ce){return!!Ce.match(re)})),ge=ge.map(function(Ce){return new be(Ce,Q)})},Ae.prototype.intersects=function(j,Q){if(!(j instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(re){return j.set.some(function(ge){return ge.every(function(Ce){return re.intersects(Ce,Q)})})})})},e.toComparators=function(j,Q){return new Ae(j,Q).set.map(function(V){return V.map(function(re){return re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new Se(j,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Pe(this.set[Q],j))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(j,Q,V){var re=null,ge=null;try{var Ce=new Ae(Q,V)}catch{return null}return j.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==-1||(ge=new Se(re=ze,V)))}),re},e.minSatisfying=function(j,Q,V){var re=null,ge=null;try{var Ce=new Ae(Q,V)}catch{return null}return j.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==1||(ge=new Se(re=ze,V)))}),re},e.validRange=function(j,Q){try{return new Ae(j,Q).range||"*"}catch{return null}},e.ltr=function(j,Q,V){return z(j,Q,"<",V)},e.gtr=function(j,Q,V){return z(j,Q,">",V)},e.outside=z,e.prerelease=function(j,Q){var V=ae(j,Q);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(j,Q,V){return j=new Ae(j,V),Q=new Ae(Q,V),j.intersects(Q)},e.coerce=function(j){if(j instanceof Se)return j;if(typeof j!="string")return null;var Q=j.match(O[f]);return Q==null?null:ae((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,v(1))},function(ve,e){var v,P,I=ve.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function O(s){if(v===setTimeout)return setTimeout(s,0);if((v===T||!v)&&setTimeout)return v=setTimeout,setTimeout(s,0);try{return v(s,0)}catch{try{return v.call(null,s,0)}catch{return v.call(this,s,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:T}catch{v=T}try{P=typeof clearTimeout=="function"?clearTimeout:A}catch{P=A}})();var $,o=[],k=!1,y=-1;function a(){k&&$&&(k=!1,$.length?o=$.concat(o):y=-1,o.length&&S())}function S(){if(!k){var s=O(a);k=!0;for(var c=o.length;c;){for($=o,o=[];++y<c;)$&&$[y].run();y=-1,c=o.length}$=null,k=!1,function(l){if(P===clearTimeout)return clearTimeout(l);if((P===A||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(l);try{P(l)}catch{try{return P.call(null,l)}catch{return P.call(this,l)}}}(s)}}function d(s,c){this.fun=s,this.array=c}function r(){}I.nextTick=function(s){var c=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)c[l-1]=arguments[l];o.push(new d(s,c)),o.length!==1||k||O(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(s){return[]},I.binding=function(s){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(s){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ne[147],Me([1,0,6,4]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.$ht=e.$gt=e.ScrollbarVisibility=void 0;var I;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class T{constructor(d,r,s,c,l,i,n){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,s=s|0,c=c|0,l=l|0,i=i|0,n=n|0),this.rawScrollLeft=c,this.rawScrollTop=n,r<0&&(r=0),c+r>s&&(c=s-r),c<0&&(c=0),l<0&&(l=0),n+l>i&&(n=i-l),n<0&&(n=0),this.width=r,this.scrollWidth=s,this.scrollLeft=c,this.height=l,this.scrollHeight=i,this.scrollTop=n}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new T(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new T(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const s=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,l=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,n=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$gt=T;class A extends P.$Vc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$me),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new T(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const s=this.g.withScrollDimensions(d,r);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let c;r?c=new k(this.h.from,s,this.h.startTime,this.h.duration):c=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=c}else{const s=this.g.withScrollPosition(d);this.h=k.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,r)))}}e.$ht=A;class O{constructor(d,r,s){this.scrollLeft=d,this.scrollTop=r,this.isDone=s}}e.$it=O;function $(S,d){const r=d-S;return function(s){return S+r*a(s)}}function o(S,d,r){return function(s){return s<r?S(s/r):d((s-r)/(1-r))}}class k{constructor(d,r,s,c){this.from=d,this.to=r,this.duration=c,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,s){if(Math.abs(d-r)>2.5*s){let l,i;return d<r?(l=d+.75*s,i=r-.75*s):(l=d-.75*s,i=r+.75*s),o($(d,l),$(i,r),.33)}return $(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const s=this.c(r),c=this.d(r);return new O(s,c,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,s){return k.start(d,r,s)}static start(d,r,s){s=s+10;const c=Date.now()-10;return new k(d,r,c,s)}}e.$jt=k;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Ne[148],Me([1,0,13,4]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=I,e.$Ae=T,e.$Be=A,e.$Ce=O,e.$De=o,e.$Ee=k,e.$Fe=y,e.$Ge=a,e.$He=S,e.$Ie=d,e.$Je=r,e.$Ke=s,e.$Le=c,e.$Me=l,e.$Ne=i;function I(n){const t=n;return t?typeof t.read=="function":!1}function T(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(n){const t=n;return t?T(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(n,t){return new $(n,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Z)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const p=u.indexOf(g);p>=0&&u.splice(p,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(n,t){const g=[];let u;for(;(u=n.read())!==null;)g.push(u);return t(g)}function k(n,t,g){const u=[];let p;for(;(p=n.read())!==null&&u.length<g;)u.push(p);return p===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof p<"u"){const m=p;return p=void 0,m}return n.read()}}}function y(n,t){return new Promise((g,u)=>{const p=[];a(n,{onData:m=>{t&&p.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t(p):void 0)}})})}function a(n,t,g){n.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),n.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),n.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(n,t){return new Promise((g,u)=>{const p=new P.$Uc,m=[],h=w=>{if(m.push(w),m.length>t)return p.dispose(),n.pause(),g({stream:n,buffer:m,ended:!1})},E=w=>(p.dispose(),u(w)),D=()=>(p.dispose(),g({stream:n,buffer:m,ended:!0}));p.add((0,P.$Tc)(()=>n.removeListener("error",E))),n.on("error",E),p.add((0,P.$Tc)(()=>n.removeListener("end",D))),n.on("end",D),p.add((0,P.$Tc)(()=>n.removeListener("data",h))),n.on("data",h)})}function d(n,t){const g=O(t);return g.end(n),g}function r(){const n=O(()=>{throw new Error("not supported")});return n.end(),n}function s(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function c(n,t,g){const u=O(g);return a(n,{onData:p=>u.write(t.data(p)),onError:p=>u.error(t.error?t.error(p):p),onEnd:()=>u.end()}),u}function l(n,t,g){let u=!1;return{read:()=>{const p=t.read();return u?p:(u=!0,p!==null?g([n,p]):n)}}}function i(n,t,g){let u=!1;const p=O(g);return a(t,{onData:m=>u?p.write(m):(u=!0,p.write(g([n,m]))),onError:m=>p.error(m),onEnd:()=>{u||(u=!0,p.write(n)),p.end()}}),p}}),define(Ne[22],Me([1,0,48,148]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=o,e.$Qe=k,e.$Re=y,e.$Se=a,e.$Te=S,e.$Ue=d,e.$Ve=r,e.$We=s,e.$Xe=c,e.$Ye=l,e.$Ze=i,e.$1e=n,e.$2e=t,e.$3e=g,e.$4e=u,e.$5e=p,e.$6e=m,e.$7e=h,e.$8e=E,e.$9e=C,P=Ve(P);const I=typeof Buffer<"u",T=new v.$U(()=>new Uint8Array(256));let A,O;class ${static alloc(f){return I?new $(Buffer.allocUnsafe(f)):new $(new Uint8Array(f))}static wrap(f){return I&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new $(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(f)):(A||(A=new TextEncoder),new $(A.encode(f)))}static fromByteArray(f){const b=$.alloc(f.length);for(let L=0,N=f.length;L<N;L++)b.buffer[L]=f[L];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let M=0,W=f.length;M<W;M++)b+=f[M].byteLength}const L=$.alloc(b);let N=0;for(let M=0,W=f.length;M<W;M++){const G=f[M];L.set(G,N),N+=G.byteLength}return L}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=$.alloc(this.byteLength);return f.set(this),f}toString(){return I?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(f,b){return new $(this.buffer.subarray(f,b))}set(f,b){if(f instanceof $)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,b){S(this.buffer,f,b)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,b){r(this.buffer,f,b)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,b){c(this.buffer,f,b)}indexOf(f,b=0){return o(this.buffer,f instanceof $?f.buffer:f,b)}}e.$Oe=$;function o(R,f,b=0){const L=f.byteLength,N=R.byteLength;if(L===0)return 0;if(L===1)return R.indexOf(f[0]);if(L>N-b)return-1;const M=T.value;M.fill(f.length);for(let J=0;J<f.length;J++)M[f[J]]=f.length-J-1;let W=b+f.length-1,G=W,q=-1;for(;W<N;)if(R[W]===f[G]){if(G===0){q=W;break}W--,G--}else W+=Math.max(f.length-G,M[R[W]]),G=f.length-1;return q}function k(R,f){return R[f+0]<<0>>>0|R[f+1]<<8>>>0}function y(R,f,b){R[b+0]=f&255,f=f>>>8,R[b+1]=f&255}function a(R,f){return R[f]*2**24+R[f+1]*2**16+R[f+2]*2**8+R[f+3]}function S(R,f,b){R[b+3]=f,f=f>>>8,R[b+2]=f,f=f>>>8,R[b+1]=f,f=f>>>8,R[b]=f}function d(R,f){return R[f+0]<<0>>>0|R[f+1]<<8>>>0|R[f+2]<<16>>>0|R[f+3]<<24>>>0}function r(R,f,b){R[b+0]=f&255,f=f>>>8,R[b+1]=f&255,f=f>>>8,R[b+2]=f&255,f=f>>>8,R[b+3]=f&255}function s(R,f){return R[f]}function c(R,f,b){R[b]=f}function l(R){return P.$De(R,f=>$.concat(f))}function i(R){return P.$Ke(R)}function n(R){return P.$Fe(R,f=>$.concat(f))}async function t(R){return R.ended?$.concat(R.buffer):$.concat([...R.buffer,await n(R.stream)])}function g(R){return P.$Ie(R,f=>$.concat(f))}function u(R){return P.$Le(R,{data:f=>typeof f=="string"?$.fromString(f):$.wrap(f)},f=>$.concat(f))}function p(R){return P.$Ce(f=>$.concat(f),R)}function m(R,f){return P.$Me(R,f,b=>$.concat(b))}function h(R,f){return P.$Ne(R,f,b=>$.concat(b))}function E(R){let f=0,b=0,L=0;const N=new Uint8Array(Math.floor(R.length/4*3)),M=G=>{switch(b){case 3:N[L++]=f|G,b=0;break;case 2:N[L++]=f|G>>>2,f=G<<6,b=3;break;case 1:N[L++]=f|G>>>4,f=G<<4,b=2;break;default:f=G<<2,b=1}};for(let G=0;G<R.length;G++){const q=R.charCodeAt(G);if(q>=65&&q<=90)M(q-65);else if(q>=97&&q<=122)M(q-97+26);else if(q>=48&&q<=57)M(q-48+52);else if(q===43||q===45)M(62);else if(q===47||q===95)M(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${R[G]}`)}}const W=L;for(;b>0;)M(0);return $.wrap(N).slice(0,W)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:R},f=!0,b=!1){const L=b?w:D;let N="";const M=R.byteLength%3;let W=0;for(;W<R.byteLength-M;W+=3){const G=R[W+0],q=R[W+1],J=R[W+2];N+=L[G>>>2],N+=L[(G<<4|q>>>4)&63],N+=L[(q<<2|J>>>6)&63],N+=L[J&63]}if(M===1){const G=R[W+0];N+=L[G>>>2],N+=L[G<<4&63],f&&(N+="==")}else if(M===2){const G=R[W+0],q=R[W+1];N+=L[G>>>2],N+=L[(G<<4|q>>>4)&63],N+=L[q<<2&63],f&&(N+="=")}return N}}),define(Ne[149],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ne[34],Me([1,0,97]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=I;var P;(function(A){function O($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=O})(P||(e.ThemeColor=P={}));function I(A){return{id:A}}var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(l){const i=O.exec(l.id);if(!i)return $(v.$6j.error);const[,n,t]=i,g=["codicon","codicon-"+n];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=$;function o(l){return $(l).join(" ")}A.asClassName=o;function k(l){return"."+$(l).join(".")}A.asCSSSelector=k;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||P.isThemeColor(l.color))}A.isThemeIcon=y;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(l){const i=a.exec(l);if(!i)return;const[,n]=i;return{id:n}}A.fromString=S;function d(l){return{id:l}}A.fromId=d;function r(l,i){let n=l.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}A.modify=r;function s(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}A.getModifier=s;function c(l,i){return l.id===i.id&&l.color?.id===i.color?.id}A.isEqual=c})(T||(e.ThemeIcon=T={}))}),define(Ne[51],Me([1,0,27,19,20,12,14]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=O,e.$zg=$,e.$Ag=o,e.$Bg=k,e.$Cg=y,e.$Dg=r,e.$Eg=s,e.$Fg=c,e.$Gg=l,e.$Hg=i,e.$Ig=n,e.$Jg=t,e.$Kg=g,e.$Lg=u,e.$Mg=p,e.$Ng=m,e.$Og=D;function O(w){return w===v.CharCode.Slash||w===v.CharCode.Backslash}function $(w){return w.replace(/[\\/]/g,P.$hc.sep)}function o(w){return w.indexOf("/")===-1&&(w=$(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function k(w,C=P.$hc.sep){if(!w)return"";const R=w.length,f=w.charCodeAt(0);if(O(f)){if(O(w.charCodeAt(1))&&!O(w.charCodeAt(2))){let L=3;const N=L;for(;L<R&&!O(w.charCodeAt(L));L++);if(N!==L&&!O(w.charCodeAt(L+1))){for(L+=1;L<R;L++)if(O(w.charCodeAt(L)))return w.slice(0,L+1).replace(/[\\/]/g,C)}}return C}else if(l(f)&&w.charCodeAt(1)===v.CharCode.Colon)return O(w.charCodeAt(2))?w.slice(0,2)+C:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<R;b++)if(O(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function y(w){if(!I.$j||!w||w.length<5)return!1;let C=w.charCodeAt(0);if(C!==v.CharCode.Backslash||(C=w.charCodeAt(1),C!==v.CharCode.Backslash))return!1;let R=2;const f=R;for(;R<w.length&&(C=w.charCodeAt(R),C!==v.CharCode.Backslash);R++);return!(f===R||(C=w.charCodeAt(R+1),isNaN(C)||C===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(w,C=I.$j){const R=C?a:S;return!(!w||w.length===0||/^\s+$/.test(w)||(R.lastIndex=0,R.test(w))||C&&d.test(w)||w==="."||w===".."||C&&w[w.length-1]==="."||C&&w.length!==w.trim().length||w.length>255)}function s(w,C,R){const f=w===C;return!R||f?f:!w||!C?!1:(0,T.$Gf)(w,C)}function c(w,C,R,f=P.sep){if(w===C)return!0;if(!w||!C||C.length>w.length)return!1;if(R){if(!(0,T.$Hf)(w,C))return!1;if(C.length===w.length)return!0;let L=C.length;return C.charAt(C.length-1)===f&&L--,w.charAt(L)===f}return C.charAt(C.length-1)!==f&&(C+=f),w.indexOf(C)===0}function l(w){return w>=v.CharCode.A&&w<=v.CharCode.Z||w>=v.CharCode.a&&w<=v.CharCode.z}function i(w,C){return I.$j&&w.endsWith(":")&&(w+=P.sep),(0,P.$jc)(w)||(w=(0,P.$kc)(C,w)),w=(0,P.$ic)(w),n(w)}function n(w){return I.$j?(w=(0,T.$of)(w,P.sep),w.endsWith(":")&&(w+=P.sep)):(w=(0,T.$of)(w,P.sep),w||(w=P.sep)),w}function t(w){const C=(0,P.$ic)(w);return I.$j?w.length>3?!1:g(C)&&(w.length===2||C.charCodeAt(2)===v.CharCode.Backslash):C===P.$hc.sep}function g(w,C=I.$j){return C?l(w.charCodeAt(0))&&w.charCodeAt(1)===v.CharCode.Colon:!1}function u(w,C=I.$j){return g(w,C)?w[0]:void 0}function p(w,C,R){return C.length>w.length?-1:w===C?0:(R&&(w=w.toLowerCase(),C=C.toLowerCase()),w.indexOf(C))}function m(w){const C=w.split(":");let R,f,b;for(const L of C){const N=Number(L);(0,A.$jg)(N)?f===void 0?f=N:b===void 0&&(b=N):R=R?[R,L].join(":"):L}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,C,R=8){let f="";for(let L=0;L<R;L++){let N;L===0&&I.$j&&!C&&(R===3||R===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let b;return C?b=`${C}-${f}`:b=f,w?(0,P.$kc)(w,b):b}}),define(Ne[150],Me([1,0,27,28,140,12]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.FuzzyScore=e.$Jk=e.$Ik=void 0,e.or=A,e.$Kk=$,e.$Lk=o,e.$Mk=a,e.$Nk=D,e.$Ok=w,e.$Pk=N,e.$Qk=M,e.$Rk=W,e.$Sk=G,e.$Tk=te,e.$Vk=he,e.$Wk=be,e.$Xk=$e,T=Ve(T);function A(...ke){return function(Pe,Te){for(let z=0,j=ke.length;z<j;z++){const Q=ke[z](Pe,Te);if(Q)return Q}return null}}e.$Ik=O.bind(void 0,!1),e.$Jk=O.bind(void 0,!0);function O(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let z;return ke?z=T.$Hf(Te,Pe):z=Te.indexOf(Pe)===0,z?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function o(ke,Pe){return k(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function k(ke,Pe,Te,z){if(Te===ke.length)return[];if(z===Pe.length)return null;if(ke[Te]===Pe[z]){let j=null;return(j=k(ke,Pe,Te+1,z+1))?t({start:z,end:z+1},j):null}return k(ke,Pe,Te,z+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function a(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function S(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function d(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>r.add(ke.charCodeAt(0)));function s(ke){return d(ke)||r.has(ke)}function c(ke,Pe){return ke===Pe||s(ke)&&s(Pe)}const l=new Map;function i(ke){if(l.has(ke))return l.get(ke);let Pe;const Te=(0,I.$Gk)(ke);return Te&&(Pe=Te),l.set(ke,Pe),Pe}function n(ke){return y(ke)||a(ke)||S(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function g(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const z=ke.charCodeAt(Te);if(a(z)||S(z)||Te>0&&!n(ke.charCodeAt(Te-1)))return Te}return ke.length}function u(ke,Pe,Te,z){if(Te===ke.length)return[];if(z===Pe.length)return null;if(ke[Te]!==Pe[z].toLowerCase())return null;{let j=null,Q=z+1;for(j=u(ke,Pe,Te+1,z+1);!j&&(Q=g(Pe,Q))<Pe.length;)j=u(ke,Pe,Te+1,Q),Q++;return j===null?null:t({start:z,end:z+1},j)}}function p(ke){let Pe=0,Te=0,z=0,j=0,Q=0;for(let ze=0;ze<ke.length;ze++)Q=ke.charCodeAt(ze),a(Q)&&Pe++,y(Q)&&Te++,n(Q)&&z++,S(Q)&&j++;const V=Pe/ke.length,re=Te/ke.length,ge=z/ke.length,Ce=j/ke.length;return{upperPercent:V,lowerPercent:re,alphaPercent:ge,numericPercent:Ce}}function m(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function h(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:z,numericPercent:j}=ke;return Te>.2&&Pe<.8&&z>.6&&j<.2}function E(ke){let Pe=0,Te=0,z=0,j=0;for(let Q=0;Q<ke.length;Q++)z=ke.charCodeAt(Q),a(z)&&Pe++,y(z)&&Te++,d(z)&&j++;return(Pe===0||Te===0)&&j===0?ke.length<=30:Pe<=5}function D(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=p(Pe);if(!h(Te)){if(!m(Te))return null;Pe=Pe.toLowerCase()}let z=null,j=0;for(ke=ke.toLowerCase();j<Pe.length&&(z=u(ke,Pe,0,j))===null;)j=g(Pe,j+1);return z}function w(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let z=null,j=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();j<Pe.length&&(z=C(ke,Pe,0,j,Te),z===null);)j=R(Pe,j+1);return z}function C(ke,Pe,Te,z,j){let Q=0;if(Te===ke.length)return[];if(z===Pe.length)return null;if(!c(ke.charCodeAt(Te),Pe.charCodeAt(z))){const ge=i(ke.charCodeAt(Te));if(!ge)return null;for(let Ce=0;Ce<ge.length;Ce++)if(!c(ge[Ce],Pe.charCodeAt(z+Ce)))return null;Q+=ge.length-1}let V=null,re=z+Q+1;if(V=C(ke,Pe,Te+1,re,j),!j)for(;!V&&(re=R(Pe,re))<Pe.length;)V=C(ke,Pe,Te+1,re,j),re++;if(!V)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(z)){const ge=i(ke.charCodeAt(Te));if(!ge)return V;for(let Ce=0;Ce<ge.length;Ce++)if(ge[Ce]!==Pe.charCodeAt(z+Ce))return V}return t({start:z,end:z+Q+1},V)}function R(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(s(ke.charCodeAt(Te))||Te>0&&s(ke.charCodeAt(Te-1)))return Te;return ke.length}const f=A(e.$Jk,D,$),b=A(e.$Jk,D,o),L=new P.$Ec(1e4);function N(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let z=L.get(ke);z||(z=new RegExp(T.$pf(ke),"i"),L.set(ke,z));const j=z.exec(Pe);return j?[{start:j.index,end:j.index+j[0].length}]:Te?b(ke,Pe):f(ke,Pe)}function M(ke,Pe){const Te=he(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?G(Te):null}function W(ke,Pe,Te,z,j,Q){const V=Math.min(13,ke.length);for(;Te<V;Te++){const re=he(ke,Pe,Te,z,j,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,Q]}function G(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let z=ke.length-1;z>1;z--){const j=ke[z]+Te,Q=Pe[Pe.length-1];Q&&Q.end===j?Q.end=j+1:Pe.push({start:j,end:j+1})}return Pe}const q=128;function J(){const ke=[],Pe=[];for(let Te=0;Te<=q;Te++)Pe[Te]=0;for(let Te=0;Te<=q;Te++)ke.push(Pe.slice(0));return ke}function K(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const oe=K(2*q),me=K(2*q),le=J(),_=J(),ce=J(),pe=!1;function ae(ke,Pe,Te,z,j){function Q(re,ge,Ce=" "){for(;re.length<ge;)re=Ce+re;return re}let V=` |   |${z.split("").map(re=>Q(re,3)).join("|")}
`;for(let re=0;re<=Te;re++)re===0?V+=" |":V+=`${Pe[re-1]}|`,V+=ke[re].slice(0,j+1).map(ge=>Q(ge.toString(),3)).join("|")+`
`;return V}function Se(ke,Pe,Te,z){ke=ke.substr(Pe),Te=Te.substr(z),console.log(ae(_,ke,ke.length,Te,Te.length)),console.log(ae(ce,ke,ke.length,Te,Te.length)),console.log(ae(le,ke,ke.length,Te,Te.length))}function Oe(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Zf(Te)}}function X(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function B(ke,Pe,Te){return Pe[ke]!==Te[ke]}function te(ke,Pe,Te,z,j,Q,V=!1){for(;Pe<Te&&j<Q;)ke[Pe]===z[j]&&(V&&(oe[Pe]=j),Pe+=1),j+=1;return Pe===Te}var ye;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(de||(e.FuzzyScore=de={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Uk=we;function he(ke,Pe,Te,z,j,Q,V=we.default){const re=ke.length>q?q:ke.length,ge=z.length>q?q:z.length;if(Te>=re||Q>=ge||re-Te>ge-Q||!te(Pe,Te,re,j,Q,ge,!0))return;Z(re,ge,Te,Q,Pe,j);let Ce=1,ze=1,He=Te,_e=Q;const tt=[!1];for(Ce=1,He=Te;He<re;Ce++,He++){const lt=oe[He],st=me[He],ct=He+1<re?me[He+1]:ge;for(ze=lt-Q+1,_e=lt;_e<ct;ze++,_e++){let mt=Number.MIN_SAFE_INTEGER,$t=!1;_e<=st&&(mt=x(ke,Pe,He,Te,z,j,_e,ge,Q,le[Ce-1][ze-1]===0,tt));let qe=0;mt!==Number.MAX_SAFE_INTEGER&&($t=!0,qe=mt+_[Ce-1][ze-1]);const je=_e>lt,ne=je?_[Ce][ze-1]+(le[Ce][ze-1]>0?-5:0):0,ee=_e>lt+1&&le[Ce][ze-1]>0,Y=ee?_[Ce][ze-2]+(le[Ce][ze-2]>0?-5:0):0;if(ee&&(!je||Y>=ne)&&(!$t||Y>=qe))_[Ce][ze]=Y,ce[Ce][ze]=ye.LeftLeft,le[Ce][ze]=0;else if(je&&(!$t||ne>=qe))_[Ce][ze]=ne,ce[Ce][ze]=ye.Left,le[Ce][ze]=0;else if($t)_[Ce][ze]=qe,ce[Ce][ze]=ye.Diag,le[Ce][ze]=le[Ce-1][ze-1]+1;else throw new Error("not possible")}}if(pe&&Se(ke,Te,z,Q),!tt[0]&&!V.firstMatchCanBeWeak)return;Ce--,ze--;const nt=[_[Ce][ze],Q];let et=0,rt=0;for(;Ce>=1;){let lt=ze;do{const st=ce[Ce][lt];if(st===ye.LeftLeft)lt=lt-2;else if(st===ye.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Te+Ce-1]===j[Q+ze-1]&&!B(lt+Q-1,z,j)&&et+1>le[Ce][lt]&&(lt=ze),lt===ze?et++:et=1,rt||(rt=lt),Ce--,ze=lt-1,nt.push(ze)}ge-Q===re&&V.boostFullMatch&&(nt[0]+=2);const ft=rt-re;return nt[0]-=ft,nt}function Z(ke,Pe,Te,z,j,Q){let V=ke-1,re=Pe-1;for(;V>=Te&&re>=z;)j[V]===Q[re]&&(me[V]=re,V--),re--}function x(ke,Pe,Te,z,j,Q,V,re,ge,Ce,ze){if(Pe[Te]!==Q[V])return Number.MIN_SAFE_INTEGER;let He=1,_e=!1;return V===Te-z?He=ke[Te]===j[V]?7:5:B(V,j,Q)&&(V===0||!B(V-1,j,Q))?(He=ke[Te]===j[V]?7:5,_e=!0):Oe(Q,V)&&(V===0||!Oe(Q,V-1))?He=5:(Oe(Q,V-1)||X(Q,V-1))&&(He=5,_e=!0),He>1&&Te===z&&(ze[0]=!0),_e||(_e=B(V,j,Q)||Oe(Q,V-1)||X(Q,V-1)),Te===z?V>ge&&(He-=_e?3:5):Ce?He+=_e?2:0:He+=_e?0:1,V+1===re&&(He-=_e?3:5),He}function be(ke,Pe,Te,z,j,Q,V){return Ae(ke,Pe,Te,z,j,Q,!0,V)}function $e(ke,Pe,Te,z,j,Q,V){return Ae(ke,Pe,Te,z,j,Q,!1,V)}function Ae(ke,Pe,Te,z,j,Q,V,re){let ge=he(ke,Pe,Te,z,j,Q,re);if(ge&&!V)return ge;if(ke.length>=3){const Ce=Math.min(7,ke.length-1);for(let ze=Te+1;ze<Ce;ze++){const He=Ue(ke,ze);if(He){const _e=he(He,He.toLowerCase(),Te,z,j,Q,re);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function Ue(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],z=ke[Pe+1];if(Te!==z)return ke.slice(0,Pe)+z+Te+ke.slice(Pe+2)}}),define(Ne[98],Me([1,0,150,12,34]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=$,e.$Zk=k,e.$1k=a,e.$2k=S,e.$3k=r,e.$4k=s;const T="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${A.source}`,"g");function $(c){return c.replace(O,(l,i)=>i?l:`\\${l}`)}const o=new RegExp(`\\\\${A.source}`,"g");function k(c){return c.replace(o,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(c){return c.indexOf(T)===-1?c:c.replace(y,(l,i,n,t)=>n?l:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){d.lastIndex=0;let l="";const i=[];let n=0;for(;;){const t=d.lastIndex,g=d.exec(c),u=c.substring(t,g?.index);if(u.length>0){l+=u;for(let p=0;p<u.length;p++)i.push(n)}if(!g)break;n+=g[0].length}return{text:l,iconOffsets:i}}function s(c,l,i=!1){const{text:n,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Pk)(c,n,i);const g=(0,P.$nf)(n," "),u=n.length-g.length,p=(0,v.$Pk)(c,g,i);if(p)for(const m of p){const h=t[m.start+u]+u;m.start+=h,m.end+=h}return p}}),define(Ne[35],Me([1,0,12]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var P;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(P||(P={})),function(I){const T="error",A="warning",O="warn",$="info",o="ignore";function k(a){return a?v.$Gf(T,a)?I.Error:v.$Gf(A,a)||v.$Gf(O,a)?I.Warning:v.$Gf($,a)?I.Info:I.Ignore:I.Ignore}I.fromValue=k;function y(a){switch(a){case I.Error:return T;case I.Warning:return A;case I.Info:return $;default:return o}}I.toString=y}(P||(P={})),e.default=P}),define(Ne[58],Me([1,0,17,27,12]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class T{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return r-s}value(){return this.b[this.c]}}e.$Ii=T;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===P.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,I.$Af)(d,this.b,0,d.length,this.c,this.d):(0,I.$Cf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=A;class O{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const s=this.b.charCodeAt(r);if(!(s===P.CharCode.Slash||this.f&&s===P.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===P.CharCode.Slash||this.f&&r===P.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,I.$Af)(d,this.b,0,d.length,this.d,this.e):(0,I.$Cf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=O;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class o{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new O(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,I.$Bf)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,I.$Bf)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,I.$zf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,I.$zf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Li=o;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,r=()=>!1){return new a(new o(d,r))}static forPaths(d=!1){return new a(new O(void 0,!d))}static forStrings(){return new a(new T)}static forConfigKeys(){return new a(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const s=r.slice(0);(0,v.$Wb)(s);for(const c of s)this.set(c,d)}else{const s=d.slice(0);(0,v.$Wb)(s);for(const c of s)this.set(c[0],c[1])}}set(d,r){const s=this.b.reset(d);let c;this.c||(this.c=new k,this.c.segment=s.value());const l=[];for(c=this.c;;){const n=s.cmp(c.segment);if(n>0)c.left||(c.left=new k,c.left.segment=s.value()),l.push([y.Left,c]),c=c.left;else if(n<0)c.right||(c.right=new k,c.right.segment=s.value()),l.push([y.Right,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new k,c.mid.segment=s.value()),l.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=r,c.key=d;for(let n=l.length-1;n>=0;n--){const t=l[n][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[n][0],p=l[n+1][0];if(u===y.Right&&p===y.Right)l[n][1]=t.rotateLeft();else if(u===y.Left&&p===y.Left)l[n][1]=t.rotateRight();else if(u===y.Right&&p===y.Left)t.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=t.rotateLeft();else if(u===y.Left&&p===y.Right)t.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case y.Left:l[n-1][1].left=l[n][1];break;case y.Right:l[n-1][1].right=l[n][1];break;case y.Mid:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let s=this.c;for(;s;){const c=r.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const s=this.b.reset(d),c=[];let l=this.c;for(;l;){const i=s.cmp(l.segment);if(i>0)c.push([y.Left,l]),l=l.left;else if(i<0)c.push([y.Right,l]),l=l.right;else if(s.hasNext())s.next(),c.push([y.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:n,value:t,segment:g}=i;this.e(i.key,!1),l.key=n,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(c.length>0){const[n,t]=c[c.length-1];switch(n){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let s=this.c,c;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(d){return this.g(d,!1)}g(d,r){const s=this.b.reset(d);let c=this.c;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,s]of this)d(s,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Mi=a}),define(Ne[36],Me([1,0,22,2,37]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=T,e.$ci=A,e.$di=$;function T(o){return JSON.stringify(o,O)}function A(o){let k=JSON.parse(o);return k=$(k),k}function O(o,k){return k instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function $(o,k=0){if(!o||k>200)return o;if(typeof o=="object"){switch(o.$mid){case I.MarshalledId.Uri:return P.URI.revive(o);case I.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case I.MarshalledId.Date:return new Date(o.source)}if(o instanceof v.$Oe||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let y=0;y<o.length;++y)o[y]=$(o[y],k+1);else for(const y in o)Object.hasOwnProperty.call(o,y)&&(o[y]=$(o[y],k+1))}return o}}),define(Ne[15],Me([1,0,13,20,12,2,19]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=$,e.$Qg=o,e.$Ug=y,v=Ve(v),P=Ve(P),A=Ve(A);var O;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(O||(e.Schemas=O={}));function $(d,r){return T.URI.isUri(d)?(0,I.$Gf)(d.scheme,r):(0,I.$Hf)(d,r+":")}function o(d,...r){return r.some(s=>$(d,s))}e.$Rg="vscode-tkn",e.$Sg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=y(r,s)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,O.vscodeRemoteResource)}set(r,s,c){this.a[r]=s,this.b[r]=c}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(t){return v.$Z(t),r}const s=r.authority;let c=this.a[s];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this.b[s],i=this.c[s];let n=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(n+=`&${e.$Sg}=${encodeURIComponent(i)}`),T.URI.from({scheme:P.$p?this.d:O.vscodeRemoteResource,authority:`${c}:${l}`,path:this.g,query:n})}}e.$Tg=new k;function y(d,r){return A.$hc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class a{static{this.a=e.$Zg}asBrowserUri(r){const s=this.b(r,ve);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===O.vscodeRemote?e.$Tg.rewrite(r):r.scheme===O.file&&(P.$n||P.$r===`${O.vscodeFileResource}://${a.a}`)?r.with({scheme:O.vscodeFileResource,authority:r.authority||a.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,ve);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===O.vscodeFileResource?r.with({scheme:O.file,authority:r.authority!==a.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return T.URI.isUri(r)?r:T.URI.parse(s.toUrl(r))}}e.$1g=new a;var S;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function c(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:T.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const t=n?.get(s);if(t)return r.get(t)}d.getHeadersFromQuery=c;function l(i,n,t){if(!globalThis.crossOriginIsolated)return;const g=n&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,g):i[s]=g}d.addSearchParam=l})(S||(e.COI=S={}))}),define(Ne[23],Me([1,0,27,51,15,19,20,12,2]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=o,e.$qh=y,e.$rh=S,P=Ve(P),T=Ve(T);function o(d){return(0,$.$xc)(d,!0)}class k{constructor(r){this.a=r}compare(r,s,c=!1){return r===s?0:(0,O.$zf)(this.getComparisonKey(r,c),this.getComparisonKey(s,c))}isEqual(r,s,c=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,c)===this.getComparisonKey(s,c)}getComparisonKey(r,s=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,s,c=!1){if(r.scheme===s.scheme){if(r.scheme===I.Schemas.file)return P.$Fg(o(r),o(s),this.a(r))&&r.query===s.query&&(c||r.fragment===s.fragment);if((0,e.$mh)(r.authority,s.authority))return P.$Fg(r.path,s.path,this.a(r),"/")&&r.query===s.query&&(c||r.fragment===s.fragment)}return!1}joinPath(r,...s){return $.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.$eh)(r)||r.authority}basename(r){return T.$hc.basename(r.path)}extname(r){return T.$hc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===I.Schemas.file?s=$.URI.file(T.$nc(o(r))).path:(s=T.$hc.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===I.Schemas.file?s=$.URI.file(T.$ic(o(r))).path:s=T.$hc.normalize(r.path),r.with({path:s})}relativePath(r,s){if(r.scheme!==s.scheme||!(0,e.$mh)(r.authority,s.authority))return;if(r.scheme===I.Schemas.file){const i=T.$mc(o(r),o(s));return A.$j?P.$zg(i):i}let c=r.path||"/";const l=s.path||"/";if(this.a(r)){let i=0;for(const n=Math.min(c.length,l.length);i<n&&!(c.charCodeAt(i)!==l.charCodeAt(i)&&c.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);c=l.substr(0,i)+c.substr(i)}return T.$hc.relative(c,l)}resolvePath(r,s){if(r.scheme===I.Schemas.file){const c=$.URI.file(T.$lc(o(r),s));return r.with({authority:c.authority,path:c.path})}return s=P.$Ag(s),r.with({path:T.$hc.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||r!==void 0&&s!==void 0&&(0,O.$Gf)(r,s)}hasTrailingPathSeparator(r,s=T.sep){if(r.scheme===I.Schemas.file){const c=o(r);return c.length>P.$Bg(c).length&&c[c.length-1]===s}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=T.sep){return(0,e.$nh)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=T.sep){let c=!1;if(r.scheme===I.Schemas.file){const l=o(r);c=l!==void 0&&l.length===P.$Bg(l).length&&l[l.length-1]===s}else{s="/";const l=r.path;c=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!c&&!(0,e.$nh)(r,s)?r.with({path:r.path+"/"}):r}}e.$9g=k,e.$0g=new k(()=>!1),e.$$g=new k(d=>d.scheme===I.Schemas.file?!A.$l:!0),e.$_g=new k(d=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function y(d,r){const s=[];for(let c=0;c<d.length;c++){const l=r(d[c]);d.some((i,n)=>n===c?!1:(0,e.$bh)(l,r(i)))||s.push(d[c])}return s}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,g]=n.split(":");t&&g&&c.set(t,g)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=r})(a||(e.DataUri=a={}));function S(d,r,s){if(r){let c=d.path;return c&&c[0]!==T.$hc.sep&&(c=T.$hc.sep+c),d.with({scheme:s,authority:r,path:c})}return d.with({scheme:s})}}),define(Ne[10],Me([1,0,21,13,6,4,23,20,149,48]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=k,e.$th=y,e.$uh=a,e.$vh=S,e.$wh=d,e.$xh=r,e.$yh=s,e.$zh=c,e.$Hh=E,e.$Ih=D,e.$Jh=w,e.$Kh=C,e.$Lh=R,e.$1h=le,e.$9h=de;function k(he){return!!he&&typeof he.then=="function"}function y(he){const Z=new v.$xe,x=he(Z.token),be=new Promise(($e,Ae)=>{const Ue=Z.token.onCancellationRequested(()=>{Ue.dispose(),Ae(new P.$5)});Promise.resolve(x).then(ke=>{Ue.dispose(),Z.dispose(),$e(ke)},ke=>{Ue.dispose(),Z.dispose(),Ae(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then($e,Ae){return be.then($e,Ae)}catch($e){return this.then(void 0,$e)}finally($e){return be.finally($e)}}}function a(he,Z,x){return new Promise((be,$e)=>{const Ae=Z.onCancellationRequested(()=>{Ae.dispose(),be(x)});he.then(be,$e).finally(()=>Ae.dispose())})}function S(he,Z){return new Promise((x,be)=>{const $e=Z.onCancellationRequested(()=>{$e.dispose(),be(new P.$5)});he.then(x,be).finally(()=>$e.dispose())})}async function d(he){let Z=-1;const x=he.map((be,$e)=>be.then(Ae=>(Z=$e,Ae)));try{return await Promise.race(x)}finally{he.forEach((be,$e)=>{$e!==Z&&be.cancel()})}}function r(he,Z,x){let be;const $e=setTimeout(()=>{be?.(void 0),x?.()},Z);return Promise.race([he.finally(()=>clearTimeout($e)),new Promise(Ae=>be=Ae)])}function s(he){return new Promise((Z,x)=>{const be=he();k(be)?be.then(Z,x):Z(be)})}function c(){let he,Z;return{promise:new Promise((be,$e)=>{he=be,Z=$e}),resolve:he,reject:Z}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const x=()=>{if(this.b=null,this.f)return;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(x,x).then(be)})}return new Promise((x,be)=>{this.b.then(x,be)})}return this.a=Z(),new Promise((x,be)=>{this.a.then($e=>{this.a=null,x($e)},$e=>{this.a=null,be($e)})})}dispose(){this.f=!0}}e.$Ah=l;class i{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Bh=i;class n{constructor(){this.a=new Map}queue(Z,x){const $e=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(Z)===$e&&this.a.delete(Z)});return this.a.set(Z,$e),$e}}e.$Ch=n;const t=(he,Z)=>{let x=!0;const be=setTimeout(()=>{x=!1,Z()},he);return{isTriggered:()=>x,dispose:()=>{clearTimeout(be),x=!1}}},g=he=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,he())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class u{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,x=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise(($e,Ae)=>{this.d=$e,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$he?g(be):t(x,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=u;class p{constructor(Z){this.a=new u(Z),this.b=new l}trigger(Z,x){return this.a.trigger(()=>this.b.queue(Z),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=p;class m{constructor(){this.a=!1,this.b=new Promise((Z,x)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=m;class h extends m{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Gh=h;function E(he,Z){return Z?new Promise((x,be)=>{const $e=setTimeout(()=>{Ae.dispose(),x()},he),Ae=Z.onCancellationRequested(()=>{clearTimeout($e),Ae.dispose(),be(new P.$5)})}):y(x=>E(he,x))}function D(he,Z=0,x){const be=setTimeout(()=>{he(),x&&$e.dispose()},Z),$e=(0,T.$Tc)(()=>{clearTimeout(be),x?.deleteAndLeak($e)});return x?.add($e),$e}function w(he){const Z=[];let x=0;const be=he.length;function $e(){return x<be?he[x++]():null}function Ae(Ue){Ue!=null&&Z.push(Ue);const ke=$e();return ke?ke.then(Ae):Promise.resolve(Z)}return Promise.resolve(null).then(Ae)}function C(he,Z=be=>!!be,x=null){let be=0;const $e=he.length,Ae=()=>{if(be>=$e)return Promise.resolve(x);const Ue=he[be++];return Promise.resolve(Ue()).then(Pe=>Z(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function R(he,Z=be=>!!be,x=null){if(he.length===0)return Promise.resolve(x);let be=he.length;const $e=()=>{be=-1;for(const Ae of he)Ae.cancel?.()};return new Promise((Ae,Ue)=>{for(const ke of he)ke.then(Pe=>{--be>=0&&Z(Pe)?($e(),Ae(Pe)):be===0&&Ae(x)}).catch(Pe=>{--be>=0&&($e(),Ue(Pe))})})}class f{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new I.$me}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,be)=>{this.g.push({factory:Z,c:x,e:be}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const x=Z.factory();x.then(Z.c,Z.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=f;class b extends f{constructor(){super(1)}}e.$Nh=b;class L{constructor(){this.a=new _,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Oh=L;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ae;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,x=A.$0g){const be=x.getComparisonKey(Z);return this.a.get(be)?.size??0}queueFor(Z,x,be=A.$0g){const $e=be.getComparisonKey(Z);let Ae=this.a.get($e);if(!Ae){Ae=new b;const Ue=this.f++,ke=I.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$5c),this.d.set(Ue,ke),this.a.set($e,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=N;class M{constructor(Z,x){this.b=!1,this.a=-1,typeof Z=="function"&&typeof x=="number"&&this.setIfNotSet(Z,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,x){if(this.b)throw new P.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},x)}setIfNotSet(Z,x){if(this.b)throw new P.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},x))}}e.$Qh=M;class W{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,x,be=globalThis){if(this.f)throw new P.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=be.setInterval(()=>{Z()},x);this.d=(0,T.$Tc)(()=>{be.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=W;class G{constructor(Z,x){this.b=-1,this.a=Z,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=G;class q{constructor(Z,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=Z,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=q;class J extends G{constructor(Z,x){super(Z,x),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Uh=J;class K extends T.$Vc{constructor(Z,x){super(),this.g=Z,this.h=x,this.a=[],this.b=this.B(new T.$Wc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of Z)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(he,Z)=>{(0,O.$C)(()=>{if(x)return;const be=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Xh=(he,Z,x)=>{const be=he.requestIdleCallback(Z,typeof x=="number"?{timeout:x}:void 0);let $e=!1;return{dispose(){$e||($e=!0,he.cancelIdleCallback(be))}}},e.$Wh=he=>(0,e.$Xh)(globalThis,he)}();class oe{constructor(Z,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(be){this.l=be}finally{this.g=!0}},this.f=(0,e.$Xh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=oe;class me extends oe{constructor(Z){super(globalThis,Z)}}e.$Zh=me;async function le(he,Z,x){let be;for(let $e=0;$e<x;$e++)try{return await he()}catch(Ae){be=Ae,await E(Z)}throw be}class _{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,x,be){return this.a={taskId:Z,cancel:()=>be?.(),promise:x},x.then(()=>this.d(Z),()=>this.d(Z)),x}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:x,resolve:be,reject:$e}=c();this.b={run:Z,promise:x,promiseResolve:be,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=_;class ce{constructor(Z,x=()=>Date.now()){this.d=Z,this.f=x,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$3h=ce;var pe;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(pe||(pe={}));class ae{get isRejected(){return this.d?.outcome===pe.Rejected}get isResolved(){return this.d?.outcome===pe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===pe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,x)=>{this.a=Z,this.b=x})}complete(Z){return new Promise(x=>{this.a(Z),this.d={outcome:pe.Resolved,value:Z},x()})}error(Z){return new Promise(x=>{this.b(Z),this.d={outcome:pe.Rejected,value:Z},x()})}cancel(){return this.error(new P.$5)}}e.$4h=ae;var Se;(function(he){async function Z(be){let $e;const Ae=await Promise.all(be.map(Ue=>Ue.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Ae}he.settled=Z;function x(be){return new Promise(async($e,Ae)=>{try{await be($e,Ae)}catch(Ue){Ae(Ue)}})}he.withAsyncBody=x})(Se||(e.Promises=Se={}));class Oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=Oe;class X{constructor(Z){this.b=Z,this.a=new o.$U(()=>new Oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=X;var B;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(B||(B={}));class te{static fromArray(Z){return new te(x=>{x.emitMany(Z)})}static fromPromise(Z){return new te(async x=>{x.emitMany(await Z)})}static fromPromises(Z){return new te(async x=>{await Promise.all(Z.map(async be=>x.emitOne(await be)))})}static merge(Z){return new te(async x=>{await Promise.all(Z.map(async be=>{for await(const $e of be)x.emitOne($e)}))})}static{this.EMPTY=te.fromArray([])}constructor(Z,x){this.a=B.Initial,this.b=[],this.d=null,this.f=x,this.g=new I.$me,queueMicrotask(async()=>{const be={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(Z(be)),this.k()}catch($e){this.l($e)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,x){return new te(async be=>{for await(const $e of Z)be.emitOne(x($e))})}map(Z){return te.map(this,Z)}static filter(Z,x){return new te(async be=>{for await(const $e of Z)x($e)&&be.emitOne($e)})}filter(Z){return te.filter(this,Z)}static coalesce(Z){return te.filter(Z,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(Z){const x=[];for await(const be of Z)x.push(be);return x}toPromise(){return te.toPromise(this)}h(Z){this.a===B.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===B.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(Z){this.a===B.Initial&&(this.a=B.DoneError,this.d=Z,this.g.fire())}}e.$7h=te;class ye extends te{constructor(Z,x){super(x),this.m=Z}cancel(){this.m.cancel()}}e.$8h=ye;function de(he){const Z=new v.$xe,x=he(Z.token);return new ye(Z,async be=>{const $e=Z.token.onCancellationRequested(()=>{$e.dispose(),Z.dispose(),be.reject(new P.$5)});try{for await(const Ae of x){if(Z.token.isCancellationRequested)return;be.emitOne(Ae)}$e.dispose(),Z.dispose()}catch(Ae){$e.dispose(),Z.dispose(),be.reject(Ae)}})}class we{constructor(Z){this.a=new ae,this.b=new te($e=>{if(x){$e.reject(x);return}return be&&$e.emitMany(be),this.d=Ae=>$e.reject(Ae),this.f=Ae=>$e.emitOne(Ae),this.a.p},Z);let x,be;this.f=$e=>{be||(be=[]),be.push($e)},this.d=$e=>{x||(x=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$0h=we}),define(Ne[41],Me([1,0,17,10,27,51,28,19,20,12]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=void 0,e.$wk=k,e.$zk=r,e.$Ak=L,e.$Bk=N,e.$Ck=M,e.$Dk=W,e.$Ek=G,e.$Fk=oe;function k(){return Object.create(null)}e.$xk="**",e.$yk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(me,le){switch(me){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${le?`|${y}${a}+`:""})*?`}}function r(me,le){if(!me)return[];const _=[];let ce=!1,pe=!1,ae="";for(const Se of me){switch(Se){case le:if(!ce&&!pe){_.push(ae),ae="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ae+=Se}return ae&&_.push(ae),_}function s(me){if(!me)return"";let le="";const _=r(me,e.$yk);if(_.every(ce=>ce===e.$xk))le=".*";else{let ce=!1;_.forEach((pe,ae)=>{if(pe===e.$xk){if(ce)return;le+=d(2,ae===_.length-1)}else{let Se=!1,Oe="",X=!1,B="";for(const te of pe){if(te!=="}"&&Se){Oe+=te;continue}if(X&&(te!=="]"||!B)){let ye;te==="-"?ye=te:(te==="^"||te==="!")&&!B?ye="^":te===e.$yk?ye="":ye=(0,o.$if)(te),B+=ye;continue}switch(te){case"{":Se=!0;continue;case"[":X=!0;continue;case"}":{const de=`(?:${r(Oe,",").map(we=>s(we)).join("|")})`;le+=de,Se=!1,Oe="";break}case"]":{le+="["+B+"]",X=!1,B="";break}case"?":le+=a;continue;case"*":le+=d(1);continue;default:le+=(0,o.$if)(te)}}ae<_.length-1&&(_[ae+1]!==e.$xk||ae+2<_.length)&&(le+=y)}ce=pe===e.$xk})}return le}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.$Ec(1e4),p=function(){return!1},m=function(){return null};function h(me,le){if(!me)return m;let _;typeof me!="string"?_=me.pattern:_=me,_=_.trim();const ce=`${_}_${!!le.trimForExclusions}`;let pe=u.get(ce);if(pe)return E(pe,me);let ae;return c.test(_)?pe=w(_.substr(4),_):(ae=l.exec(D(_,le)))?pe=C(ae[1],_):(le.trimForExclusions?n:i).test(_)?pe=R(_,le):(ae=t.exec(D(_,le)))?pe=f(ae[1].substr(1),_,!0):(ae=g.exec(D(_,le)))?pe=f(ae[1],_,!1):pe=b(_),u.set(ce,pe),E(pe,me)}function E(me,le){if(typeof le=="string")return me;const _=function(ce,pe){return(0,T.$Fg)(ce,le.base,!$.$l)?me((0,o.$nf)(ce.substr(le.base.length),O.sep),pe):null};return _.allBasenames=me.allBasenames,_.allPaths=me.allPaths,_.basenames=me.basenames,_.patterns=me.patterns,_}function D(me,le){return le.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function w(me,le){return function(_,ce){return typeof _=="string"&&_.endsWith(me)?le:null}}function C(me,le){const _=`/${me}`,ce=`\\${me}`,pe=function(Se,Oe){return typeof Se!="string"?null:Oe?Oe===me?le:null:Se===me||Se.endsWith(_)||Se.endsWith(ce)?le:null},ae=[me];return pe.basenames=ae,pe.patterns=[le],pe.allBasenames=ae,pe}function R(me,le){const _=K(me.slice(1,-1).split(",").map(Oe=>h(Oe,le)).filter(Oe=>Oe!==m),me),ce=_.length;if(!ce)return m;if(ce===1)return _[0];const pe=function(Oe,X){for(let B=0,te=_.length;B<te;B++)if(_[B](Oe,X))return me;return null},ae=_.find(Oe=>!!Oe.allBasenames);ae&&(pe.allBasenames=ae.allBasenames);const Se=_.reduce((Oe,X)=>X.allPaths?Oe.concat(X.allPaths):Oe,[]);return Se.length&&(pe.allPaths=Se),pe}function f(me,le,_){const ce=O.sep===O.$hc.sep,pe=ce?me:me.replace(S,O.sep),ae=O.sep+pe,Se=O.$hc.sep+me;let Oe;return _?Oe=function(X,B){return typeof X=="string"&&(X===pe||X.endsWith(ae)||!ce&&(X===me||X.endsWith(Se)))?le:null}:Oe=function(X,B){return typeof X=="string"&&(X===pe||!ce&&X===me)?le:null},Oe.allPaths=[(_?"*/":"./")+me],Oe}function b(me){try{const le=new RegExp(`^${s(me)}$`);return function(_){return le.lastIndex=0,typeof _=="string"&&le.test(_)?me:null}}catch{return m}}function L(me,le,_){return!me||typeof le!="string"?!1:N(me)(le,void 0,_)}function N(me,le={}){if(!me)return p;if(typeof me=="string"||M(me)){const _=h(me,le);if(_===m)return p;const ce=function(pe,ae){return!!_(pe,ae)};return _.allBasenames&&(ce.allBasenames=_.allBasenames),_.allPaths&&(ce.allPaths=_.allPaths),ce}return q(me,le)}function M(me){const le=me;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}function W(me){return me.allBasenames||[]}function G(me){return me.allPaths||[]}function q(me,le){const _=K(Object.getOwnPropertyNames(me).map(Oe=>J(Oe,me[Oe],le)).filter(Oe=>Oe!==m)),ce=_.length;if(!ce)return m;if(!_.some(Oe=>!!Oe.requiresSiblings)){if(ce===1)return _[0];const Oe=function(te,ye){let de;for(let we=0,he=_.length;we<he;we++){const Z=_[we](te,ye);if(typeof Z=="string")return Z;(0,P.$sh)(Z)&&(de||(de=[]),de.push(Z))}return de?(async()=>{for(const we of de){const he=await we;if(typeof he=="string")return he}return null})():null},X=_.find(te=>!!te.allBasenames);X&&(Oe.allBasenames=X.allBasenames);const B=_.reduce((te,ye)=>ye.allPaths?te.concat(ye.allPaths):te,[]);return B.length&&(Oe.allPaths=B),Oe}const pe=function(Oe,X,B){let te,ye;for(let de=0,we=_.length;de<we;de++){const he=_[de];he.requiresSiblings&&B&&(X||(X=(0,O.$oc)(Oe)),te||(te=X.substr(0,X.length-(0,O.$pc)(Oe).length)));const Z=he(Oe,X,te,B);if(typeof Z=="string")return Z;(0,P.$sh)(Z)&&(ye||(ye=[]),ye.push(Z))}return ye?(async()=>{for(const de of ye){const we=await de;if(typeof we=="string")return we}return null})():null},ae=_.find(Oe=>!!Oe.allBasenames);ae&&(pe.allBasenames=ae.allBasenames);const Se=_.reduce((Oe,X)=>X.allPaths?Oe.concat(X.allPaths):Oe,[]);return Se.length&&(pe.allPaths=Se),pe}function J(me,le,_){if(le===!1)return m;const ce=h(me,_);if(ce===m)return m;if(typeof le=="boolean")return ce;if(le){const pe=le.when;if(typeof pe=="string"){const ae=(Se,Oe,X,B)=>{if(!B||!ce(Se,Oe))return null;const te=pe.replace("$(basename)",()=>X),ye=B(te);return(0,P.$sh)(ye)?ye.then(de=>de?me:null):ye?me:null};return ae.requiresSiblings=!0,ae}}return ce}function K(me,le){const _=me.filter(Oe=>!!Oe.basenames);if(_.length<2)return me;const ce=_.reduce((Oe,X)=>{const B=X.basenames;return B?Oe.concat(B):Oe},[]);let pe;if(le){pe=[];for(let Oe=0,X=ce.length;Oe<X;Oe++)pe.push(le)}else pe=_.reduce((Oe,X)=>{const B=X.patterns;return B?Oe.concat(B):Oe},[]);const ae=function(Oe,X){if(typeof Oe!="string")return null;if(!X){let te;for(te=Oe.length;te>0;te--){const ye=Oe.charCodeAt(te-1);if(ye===I.CharCode.Slash||ye===I.CharCode.Backslash)break}X=Oe.substr(te)}const B=ce.indexOf(X);return B!==-1?pe[B]:null};ae.basenames=ce,ae.patterns=pe,ae.allBasenames=ce;const Se=me.filter(Oe=>!Oe.basenames);return Se.push(ae),Se}function oe(me,le){return(0,v.$ub)(me,le,(_,ce)=>typeof _=="string"&&typeof ce=="string"?_===ce:typeof _!="string"&&typeof ce!="string"?_.base===ce.base&&_.pattern===ce.pattern:!1)}}),define(Ne[59],Me([1,0,13,98,23,12,2]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.MarkdownStringTextNewlineStyle=void 0,e.$6k=o,e.$7k=k,e.$8k=y,e.$9k=a,e.$0k=S,e.$$k=d,e.$_k=r,e.$al=s;var O;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class ${constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=O.Paragraph){return this.value+=a(this.supportThemeIcons?(0,P.$Yk)(l):l).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(l,i){const n=new RegExp((0,T.$if)(i),"g");return l.replace(n,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$5k=$;function o(c){return k(c)?!c.value:Array.isArray(c)?c.every(o):!0}function k(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,I.$ah)(A.URI.from(c.baseUri),A.URI.from(l.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,l){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${l}`,c,`${"`".repeat(n)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(c){const l=[],i=c.split("|").map(t=>t.trim());c=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),g=/width=(\d+)/.exec(n),u=t?t[1]:"",p=g?g[1]:"",m=isFinite(parseInt(p)),h=isFinite(parseInt(u));m&&l.push(`width="${p}"`),h&&l.push(`height="${u}"`)}return{href:c,dimensions:l}}}),define(Ne[99],Me([1,0,17,51,19,20,23,12]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4w=$,e.$5w=k,e.$6w=a,e.$7w=S,e.$8w=c,e.$9w=i,e.$0w=n,e.$$w=t,e.$_w=g,e.$ax=u;function $(m,h){const{os:E,tildify:D,relative:w}=h;if(w){const f=o(m,w,E);if(typeof f=="string")return f}let C=m.fsPath;if(E===T.OperatingSystem.Windows&&!T.$j?C=C.replace(/\//g,"\\"):E!==T.OperatingSystem.Windows&&T.$j&&(C=C.replace(/\\/g,"/")),E!==T.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let b;m.scheme!==D.userHome.scheme&&m.path[0]===I.$hc.sep&&m.path[1]!==I.$hc.sep?b=D.userHome.with({path:m.path}).fsPath:b=C,C=a(b,f,E)}return(E===T.OperatingSystem.Windows?I.$gc:I.$hc).normalize(k(C,E===T.OperatingSystem.Windows))}function o(m,h,E){const D=E===T.OperatingSystem.Windows?I.$gc:I.$hc,w=E===T.OperatingSystem.Linux?A.$0g:A.$_g,C=h.getWorkspace(),R=(0,v.$Ob)(C.folders);if(!R)return;m.scheme!==R.uri.scheme&&m.path[0]===I.$hc.sep&&m.path[1]!==I.$hc.sep&&(m=R.uri.with({path:m.path}));const f=h.getWorkspaceFolder(m);if(!f)return;let b;if(w.isEqual(f.uri,m)?b="":b=w.relativePath(f.uri,m)??"",b&&(b=D.normalize(b)),C.folders.length>1&&!h.noPrefix){const L=f.name?f.name:w.basenameOrAuthority(f.uri);b=b?`${L} \u2022 ${b}`:L}return b}function k(m,h=T.$j){return(0,P.$Kg)(m,h)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function a(m,h,E=T.OS){if(E===T.OperatingSystem.Windows||!m||!h)return m;let D=y.original===h?y.normalized:void 0;D||(D=h,T.$j&&(D=(0,P.$zg)(D)),D=`${(0,O.$of)(D,I.$hc.sep)}${I.$hc.sep}`,y={original:h,normalized:D});let w=m;return T.$j&&(w=(0,P.$zg)(w)),(E===T.OperatingSystem.Linux?w.startsWith(D):(0,O.$Hf)(w,D))?`~/${w.substr(D.length)}`:m}function S(m,h){return m.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",r="\\\\",s="~";function c(m,h=I.sep){const E=new Array(m.length);let D=!1;for(let w=0;w<m.length;w++){const C=m[w];if(C===""){E[w]=`.${h}`;continue}if(!C){E[w]=C;continue}D=!0;let R="",f=C;f.indexOf(r)===0?(R=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(h)===0?(R=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(s)===0&&(R=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const b=f.split(h);for(let L=1;D&&L<=b.length;L++)for(let N=b.length-L;D&&N>=0;N--){D=!1;let M=b.slice(N,N+L).join(h);for(let W=0;!D&&W<m.length;W++)if(W!==w&&m[W]&&m[W].indexOf(M)>-1){const G=N+L===b.length,q=N>0&&m[W].indexOf(h)>-1?h+M:M,J=m[W].endsWith(q);D=!G||J}if(!D){let W="";(b[0].endsWith(":")||R!=="")&&(N===1&&(N=0,L++,M=b[0]+h+M),N>0&&(W=b[0]+h),W=R+W),N>0&&(W=W+d+h),W=W+M,N+L<b.length&&(W=W+h+d),E[w]=W}}D&&(E[w]=C)}return E}var l;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(m,h=Object.create(null)){const E=[];let D=!1,w="";for(const C of m)if(C==="$"||D&&C==="{")w&&E.push({value:w,type:l.TEXT}),w="",D=!0;else if(C==="}"&&D){const R=h[w];if(typeof R=="string")R.length&&E.push({value:R,type:l.VARIABLE});else if(R){const f=E[E.length-1];(!f||f.type!==l.SEPARATOR)&&E.push({value:R.label,type:l.SEPARATOR})}w="",D=!1}else w+=C;return w&&!D&&E.push({value:w,type:l.TEXT}),E.filter((C,R)=>{if(C.type===l.SEPARATOR){const f=E[R-1],b=E[R+1];return[f,b].every(L=>L&&(L.type===l.VARIABLE||L.type===l.TEXT)&&L.value.length>0)}return!0}).map(C=>C.value).join("")}function n(m,h){return T.$k||h?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):m.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(m,h){return T.$k||h?m.replace(/\(&&\w\)|&&/g,""):T.$j?m.replace(/&&|&/g,E=>E==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const h=m.lastIndexOf(" [",m.length-2);if(h!==-1){const E=p(m.substring(0,h)),D=m.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return p(m)}function p(m){const h=m.indexOf("/")!==-1?I.$hc:I.$gc,E=h.basename(m),D=h.dirname(m);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Ne[151],Me([1,0,22,37,2]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=$,e.$Qn=k,e.$Rn=y;function T(a){return a.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:T(I.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:T(I.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:I.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Nn=A,e.$On=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function O(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof I.URI)return S.transformOutgoing(a);for(const r in a)if(Object.hasOwnProperty.call(a,r)){const s=O(a[r],S,d+1);s!==null&&(a[r]=s)}}return null}function $(a,S){const d=O(a,S,0);return d===null?a:d}function o(a,S,d,r){if(!a||r>200)return null;if(typeof a=="object"){if(a.$mid===P.MarshalledId.Uri)return d?I.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Oe)return null;for(const s in a)if(Object.hasOwnProperty.call(a,s)){const c=o(a[s],S,d,r+1);c!==null&&(a[s]=c)}}return null}function k(a,S){const d=o(a,S,!1,0);return d===null?a:d}function y(a,S){const d=o(a,S,!0,0);return d===null?a:d}}),define(Ne[38],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=P;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(I){return v.test(I)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(O){for(let $=0;$<O.length;$++)O[$]=Math.floor(Math.random()*256);return O};const T=new Uint8Array(16),A=[];for(let O=0;O<256;O++)A.push(O.toString(16).padStart(2,"0"));return function(){I(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let $=0,o="";return o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o+="-",o+=A[T[$++]],o+=A[T[$++]],o+="-",o+=A[T[$++]],o+=A[T[$++]],o+="-",o+=A[T[$++]],o+=A[T[$++]],o+="-",o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o+=A[T[$++]],o}}()}),define(Ne[152],Me([1,0,17,40,38]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.$uu=void 0,e.$su=T,e.$tu=A,e.$vu=o;function T(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,a,S){const d={id:(0,I.$3g)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class O{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return P.Iterable.some(this,([d,r])=>r.asFile())&&S.push("files"),k($(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return $(a)}}e.$uu=O;function $(y){return y.toLowerCase()}function o(y,a){return k($(y),a.map($))}function k(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,r,s]=S;return s==="*"?a.some(c=>c.startsWith(r+"/")):!1}e.$wu=Object.freeze({create:y=>(0,v.$Mb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$wu.split(y).filter(a=>!a.startsWith("#"))})}),define(Ne[153],Me([1,0,10,6,4,36,14]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=$;var O;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function $(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var o;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(o||(e.StorageState=o={}));class k extends I.$Vc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new P.$pe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new v.$Eh(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,r)=>this.w(r,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===o.Closed)return;let r=!1;(0,A.$og)(d)?r=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),r=!0),r&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const r=this.f.get(S);return(0,A.$og)(r)?d:r}getBoolean(S,d){const r=this.get(S);return(0,A.$og)(r)?d:r==="true"}getNumber(S,d){const r=this.get(S);return(0,A.$og)(r)?d:parseInt(r,10)}getObject(S,d){const r=this.get(S);return(0,A.$og)(r)?d:(0,T.$ci)(r)}async set(S,d,r=!1){if(this.c===o.Closed)return;if((0,A.$og)(d))return this.delete(S,r);const s=(0,A.$hg)(d)||Array.isArray(d)?(0,T.$bi)(d):String(d);if(this.f.get(S)!==s)return this.f.set(S,s),this.j.set(S,s),this.h.delete(S),this.b.fire({key:S,external:r}),this.D()}async delete(S,d=!1){if(!(this.c===o.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===o.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$fq=k;class y{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,r)=>this.a.set(r,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$gq=y}),define(Ne[154],Me([1,0,27]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Cu=I;var P;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function I(T){let A=0,O=0,$=0,o=P.Unknown;for(let k=0,y=T.length;k<y;k++){const a=T.charCodeAt(k);a===v.CharCode.CarriageReturn?(A===0&&(O=k),A++,k+1<y&&T.charCodeAt(k+1)===v.CharCode.LineFeed?(o|=P.CRLF,k++):o|=P.Invalid,$=k+1):a===v.CharCode.LineFeed&&(o|=P.LF,A===0&&(O=k),A++,$=k+1)}return A===0&&(O=T.length),[A,O,T.length-$,o]}}),define(Ne[155],Me([1,0,12,20,22]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=void 0,e.$fu=k,e.$gu=y,v=Ve(v),P=Ve(P),I=Ve(I);let T;function A(){return T||(T=new TextDecoder("UTF-16LE")),T}let O;function $(){return O||(O=new TextDecoder("UTF-16BE")),O}let o;function k(){return o||(o=P.$E()?A():$()),o}function y(d,r,s){const c=new Uint16Array(d.buffer,r,s);return s>0&&(c[0]===65279||c[0]===65534)?a(d,r,s):A().decode(c)}function a(d,r,s){const c=[];let l=0;for(let i=0;i<s;i++){const n=I.$Qe(d,r);r+=2,c[l++]=String.fromCharCode(n)}return c.join("")}class S{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return k().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||v.$Kf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<s;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$hu=S}),define(Ne[156],Me([1,0,22,155]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=void 0,e.$ju=A,v=Ve(v);function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(o,k,y,a){this.oldPosition=o,this.oldText=k,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(o){return 4+2*o.length}static c(o,k,y){const a=k.length;v.$Te(o,a,y),y+=4;for(let S=0;S<a;S++)v.$Re(o,k.charCodeAt(S),y),y+=2;return y}static d(o,k){const y=v.$Se(o,k);return k+=4,(0,P.$gu)(o,k,y)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(o,k){return v.$Te(o,this.oldPosition,k),k+=4,v.$Te(o,this.newPosition,k),k+=4,k=T.c(o,this.oldText,k),k=T.c(o,this.newText,k),k}static read(o,k,y){const a=v.$Se(o,k);k+=4;const S=v.$Se(o,k);k+=4;const d=T.d(o,k);k+=T.a(d);const r=T.d(o,k);return k+=T.a(r),y.push(new T(a,d,S,r)),k}}e.$iu=T;function A($,o){return $===null||$.length===0?o:new O($,o).compress()}class O{constructor(o,k){this.a=o,this.c=k,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let o=0,k=0,y=this.n(o),a=this.l(k);for(;o<this.f||k<this.h;){if(y===null){this.k(a),a=this.l(++k);continue}if(a===null){this.m(y),y=this.n(++o);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++k);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++o);continue}if(a.oldPosition<y.newPosition){const[c,l]=O.r(a,y.newPosition-a.oldPosition);this.k(c),a=l;continue}if(y.newPosition<a.oldPosition){const[c,l]=O.q(y,a.oldPosition-y.newPosition);this.m(c),y=l;continue}let r,s;if(a.oldEnd===y.newEnd)r=y,s=a,y=this.n(++o),a=this.l(++k);else if(a.oldEnd<y.newEnd){const[c,l]=O.q(y,a.oldLength);r=c,s=a,y=l,a=this.l(++k)}else{const[c,l]=O.r(a,y.newLength);r=y,s=c,y=this.n(++o),a=l}this.d[this.e++]=new T(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const S=O.s(this.d);return O.t(S)}k(o){this.d[this.e++]=O.o(this.g,o),this.j+=o.newLength-o.oldLength}l(o){return o<this.h?this.c[o]:null}m(o){this.d[this.e++]=O.p(this.j,o),this.g+=o.newLength-o.oldLength}n(o){return o<this.f?this.a[o]:null}static o(o,k){return new T(k.oldPosition-o,k.oldText,k.newPosition,k.newText)}static p(o,k){return new T(k.oldPosition,k.oldText,k.newPosition+o,k.newText)}static q(o,k){const y=o.newText.substr(0,k),a=o.newText.substr(k);return[new T(o.oldPosition,o.oldText,o.newPosition,y),new T(o.oldEnd,"",o.newPosition+k,a)]}static r(o,k){const y=o.oldText.substr(0,k),a=o.oldText.substr(k);return[new T(o.oldPosition,y,o.newPosition,o.newText),new T(o.oldPosition+k,a,o.newEnd,"")]}static s(o){if(o.length===0)return o;const k=[];let y=0,a=o[0];for(let S=1;S<o.length;S++){const d=o[S];a.oldEnd===d.oldPosition?a=new T(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(k[y++]=a,a=d)}return k[y++]=a,k}static t(o){if(o.length===0)return o;const k=[];let y=0;for(let a=0;a<o.length;a++){const S=o[a];S.oldText!==S.newText&&(k[y++]=S)}return k}}}),define(Ne[157],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0,e.$ot={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ne[158],Me([1,0,41,19]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=I,e.$Au=T;function I(A,O,$,o,k,y){if(Array.isArray(A)){let a=0;for(const S of A){const d=I(S,O,$,o,k,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof A=="string")return o?A==="*"?5:A===$?10:0:0;if(A){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:r,notebookType:s}=A;if(!o&&!r)return 0;s&&k&&(O=k);let c=0;if(d)if(d===O.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===$)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(s)if(s===y)c=10;else if(s==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,P.$ic)(S.base)},l===O.fsPath||(0,v.$Ak)(l,O.fsPath))c=10;else return 0}return c}else return 0}}function T(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(T):!!A.notebookType}}),define(Ne[159],Me([1,0,27,160]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.IndentAction=void 0;var I;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(o){if(this.e=null,this.f=!1,this.open=o.open,this.close=o.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(o.notIn))for(let k=0,y=o.notIn.length;k<y;k++)switch(o.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(o){switch(o){case P.StandardTokenType.Other:return!0;case P.StandardTokenType.Comment:return this.c;case P.StandardTokenType.String:return this.b;case P.StandardTokenType.RegEx:return this.d}}shouldAutoClose(o,k){if(o.getTokenCount()===0)return!0;const y=o.findTokenIndexAtOffset(k-2),a=o.getStandardTokenType(y);return this.isOK(a)}g(o,k){for(let y=o;y<=k;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$1u=T;class A{constructor(o){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of o)O(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),O(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),O(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),O(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&O(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$2u=A;function O($,o,k){$.has(o)?$.get(o).push(k):$.set(o,[k])}}),define(Ne[161],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=e.NodeColor=e.$eD=void 0,e.$gD=I,e.$hD=T,e.$iD=o,e.$jD=k,e.$kD=y,e.$lD=a,e.$mD=S,e.$nD=d;class v{constructor(s,c){this.piece=s,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$fD)return I(this.right);let s=this;for(;s.parent!==e.$fD&&s.parent.left!==s;)s=s.parent;return s.parent===e.$fD?e.$fD:s.parent}prev(){if(this.left!==e.$fD)return T(this.left);let s=this;for(;s.parent!==e.$fD&&s.parent.right!==s;)s=s.parent;return s.parent===e.$fD?e.$fD:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$eD=v;var P;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(P||(e.NodeColor=P={})),e.$fD=new v(null,P.Black),e.$fD.parent=e.$fD,e.$fD.left=e.$fD,e.$fD.right=e.$fD,e.$fD.color=P.Black;function I(r){for(;r.left!==e.$fD;)r=r.left;return r}function T(r){for(;r.right!==e.$fD;)r=r.right;return r}function A(r){return r===e.$fD?0:r.size_left+r.piece.length+A(r.right)}function O(r){return r===e.$fD?0:r.lf_left+r.piece.lineFeedCnt+O(r.right)}function $(){e.$fD.parent=e.$fD}function o(r,s){const c=s.right;c.size_left+=s.size_left+(s.piece?s.piece.length:0),c.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=c.left,c.left!==e.$fD&&(c.left.parent=s),c.parent=s.parent,s.parent===e.$fD?r.root=c:s.parent.left===s?s.parent.left=c:s.parent.right=c,c.left=s,s.parent=c}function k(r,s){const c=s.left;s.left=c.right,c.right!==e.$fD&&(c.right.parent=s),c.parent=s.parent,s.size_left-=c.size_left+(c.piece?c.piece.length:0),s.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),s.parent===e.$fD?r.root=c:s===s.parent.right?s.parent.right=c:s.parent.left=c,c.right=s,s.parent=c}function y(r,s){let c,l;if(s.left===e.$fD?(l=s,c=l.right):s.right===e.$fD?(l=s,c=l.left):(l=I(s.right),c=l.right),l===r.root){r.root=c,c.color=P.Black,s.detach(),$(),r.root.parent=e.$fD;return}const i=l.color===P.Red;if(l===l.parent.left?l.parent.left=c:l.parent.right=c,l===s?(c.parent=l.parent,d(r,c)):(l.parent===s?c.parent=l:c.parent=l.parent,d(r,c),l.left=s.left,l.right=s.right,l.parent=s.parent,l.color=s.color,s===r.root?r.root=l:s===s.parent.left?s.parent.left=l:s.parent.right=l,l.left!==e.$fD&&(l.left.parent=l),l.right!==e.$fD&&(l.right.parent=l),l.size_left=s.size_left,l.lf_left=s.lf_left,d(r,l)),s.detach(),c.parent.left===c){const t=A(c),g=O(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const u=t-c.parent.size_left,p=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(r,c.parent,u,p)}}if(d(r,c.parent),i){$();return}let n;for(;c!==r.root&&c.color===P.Black;)c===c.parent.left?(n=c.parent.right,n.color===P.Red&&(n.color=P.Black,c.parent.color=P.Red,o(r,c.parent),n=c.parent.right),n.left.color===P.Black&&n.right.color===P.Black?(n.color=P.Red,c=c.parent):(n.right.color===P.Black&&(n.left.color=P.Black,n.color=P.Red,k(r,n),n=c.parent.right),n.color=c.parent.color,c.parent.color=P.Black,n.right.color=P.Black,o(r,c.parent),c=r.root)):(n=c.parent.left,n.color===P.Red&&(n.color=P.Black,c.parent.color=P.Red,k(r,c.parent),n=c.parent.left),n.left.color===P.Black&&n.right.color===P.Black?(n.color=P.Red,c=c.parent):(n.left.color===P.Black&&(n.right.color=P.Black,n.color=P.Red,o(r,n),n=c.parent.left),n.color=c.parent.color,c.parent.color=P.Black,n.left.color=P.Black,k(r,c.parent),c=r.root));c.color=P.Black,$()}function a(r,s){for(d(r,s);s!==r.root&&s.parent.color===P.Red;)if(s.parent===s.parent.parent.left){const c=s.parent.parent.right;c.color===P.Red?(s.parent.color=P.Black,c.color=P.Black,s.parent.parent.color=P.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,o(r,s)),s.parent.color=P.Black,s.parent.parent.color=P.Red,k(r,s.parent.parent))}else{const c=s.parent.parent.left;c.color===P.Red?(s.parent.color=P.Black,c.color=P.Black,s.parent.parent.color=P.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,k(r,s)),s.parent.color=P.Black,s.parent.parent.color=P.Red,o(r,s.parent.parent))}r.root.color=P.Black}function S(r,s,c,l){for(;s!==r.root&&s!==e.$fD;)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}function d(r,s){let c=0,l=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,c=A(s.left)-s.size_left,l=O(s.left)-s.lf_left,s.size_left+=c,s.lf_left+=l;s!==r.root&&(c!==0||l!==0);)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}}}),define(Ne[100],Me([1,0,27,101,32,52,161,102]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yD=e.$xD=e.$wD=void 0,e.$uD=y,e.$vD=a;const $=65535;function o(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class k{constructor(i,n,t,g,u){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const n=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const p=l.charCodeAt(g);p===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(n[t++]=g+2,g++):n[t++]=g+1:p===v.CharCode.LineFeed&&(n[t++]=g+1)}return i?o(n):n}function a(l,i){l.length=0,l[0]=0;let n=1,t=0,g=0,u=0,p=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[n++]=h+2,h++):(t++,l[n++]=h+1):D===v.CharCode.LineFeed?(g++,l[n++]=h+1):p&&D!==v.CharCode.Tab&&(D<32||D>126)&&(p=!1)}const m=new k(o(l),t,g,u,p);return l.length=0,m}class S{constructor(i,n,t,g,u){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$wD=S;class d{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$xD=d;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$fD&&i.iterate(i.root,t=>(t!==A.$fD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,n=!0;continue}}if(n){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class c{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$fD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let g=null;for(let u=0,p=i.length;u<p;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const m=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,m)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=$,t=n-Math.floor(n/3),g=t*2;let u="",p=0;const m=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if(p<=t||p+D<g)return u+=E,p+=D,!0;const w=u.replace(/\r\n|\r|\n/g,i);return m.push(new d(w,y(w))),u=E,p=D,!0}),p>0){const h=u.replace(/\r\n|\r|\n/g,i);m.push(new d(h,y(h)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,g=>{if(g===A.$fD)return!0;const u=this.R(g),p=u.length,m=i.G(n),h=i.G(n+p),E=i.getValueInRange2(m,h);return n+=p,u===E})}getOffsetAt(i,n){let t=0,g=this.root;for(;g!==A.$fD;)if(g.left!==A.$fD&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+n-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const g=i;for(;n!==A.$fD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const u=this.A(n,i-n.size_left);if(t+=n.lf_left+u.index,u.index===0){const p=this.getOffsetAt(t+1,1),m=g-p;return new P.$Qt(t+1,m+1)}return new P.$Qt(t+1,u.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$fD){const u=this.getOffsetAt(t+1,1),p=g-i-u;return new P.$Qt(t+1,p+1)}else n=n.right;return new P.$Qt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return n?n!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,n):u}getValueInRange2(i,n){if(i.node===n.node){const m=i.node,h=this.a[m.piece.bufferIndex].buffer,E=this.u(m.piece.bufferIndex,m.piece.start);return h.substring(E+i.remainder,E+n.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let p=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.$fD;){const m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){p+=m.substring(h,h+n.remainder);break}else p+=m.substr(h,t.piece.length);t=t.next()}return p}getLinesContent(){const i=[];let n=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.$fD)return!0;const p=u.piece;let m=p.length;if(m===0)return!0;const h=this.a[p.bufferIndex].buffer,E=this.a[p.bufferIndex].lineStarts,D=p.start.line,w=p.end.line;let C=E[D]+p.start.column;if(g&&(h.charCodeAt(C)===v.CharCode.LineFeed&&(C++,m--),i[n++]=t,t="",g=!1,m===0))return!0;if(D===w)return!this.f&&h.charCodeAt(C+m-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(C,m-1)):t+=h.substr(C,m),!0;t+=this.f?h.substring(C,Math.max(C,E[D+1]-this.e)):h.substring(C,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let R=D+1;R<w;R++)t=this.f?h.substring(E[R],E[R+1]-this.e):h.substring(E[R],E[R+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&h.charCodeAt(E[w]+p.end.column-1)===v.CharCode.CarriageReturn?(g=!0,p.end.column===0?n--:t=h.substr(E[w],p.end.column-1)):t=h.substr(E[w],p.end.column),!0}),g&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(g)}else{const n=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(g)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===A.$fD)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],g=this.u(n.node.piece.bufferIndex,n.node.piece.start),u=g+n.remainder,p=g+n.node.piece.length;return t.buffer.substring(u,p)}}findMatchesInNode(i,n,t,g,u,p,m,h,E,D,w){const C=this.a[i.piece.bufferIndex],R=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,u),b=this.u(i.piece.bufferIndex,p);let L;const N={line:0,column:0};let M,W;n._wordSeparators?(M=C.buffer.substring(f,b),W=G=>G+f,n.reset(0)):(M=C.buffer,W=G=>G,n.reset(f));do if(L=n.next(M),L){if(W(L.index)>=b)return D;this.s(i,W(L.index)-R,N);const G=this.t(i.piece.bufferIndex,u,N),q=N.line===u.line?N.column-u.column+g:N.column+1,J=q+L[0].length;if(w[D++]=(0,O.$qD)(new I.$Rt(t+G,q,t+G,J),L,h),W(L.index)+L[0].length>=b||D>=E)return D}while(L);return D}findMatchesLineByLine(i,n,t,g){const u=[];let p=0;const m=new O.$tD(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const w=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,m,i.startLineNumber,i.startColumn,D,w,n,t,g,p,u),u;let C=i.startLineNumber,R=h.node;for(;R!==E.node;){const b=this.t(R.piece.bufferIndex,D,R.piece.end);if(b>=1){const N=this.a[R.piece.bufferIndex].lineStarts,M=this.u(R.piece.bufferIndex,R.piece.start),W=N[D.line+b],G=C===i.startLineNumber?i.startColumn:1;if(p=this.findMatchesInNode(R,m,C,G,D,this.s(R,W-M),n,t,g,p,u),p>=g)return u;C+=b}const L=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(L,i.endColumn-1);return p=this.n(n,m,N,i.endLineNumber,L,p,u,t,g),u}if(p=this.n(n,m,this.getLineContent(C).substr(L),C,L,p,u,t,g),p>=g)return u;C++,h=this.H(C,1),R=h.node,D=this.s(h.node,h.remainder)}if(C===i.endLineNumber){const b=C===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(C).substring(b,i.endColumn-1);return p=this.n(n,m,L,i.endLineNumber,b,p,u,t,g),u}const f=C===i.startLineNumber?i.startColumn:1;return p=this.findMatchesInNode(E.node,m,C,f,D,w,n,t,g,p,u),u}n(i,n,t,g,u,p,m,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const C=i.simpleSearch,R=C.length,f=t.length;let b=-R;for(;(b=t.indexOf(C,b+R))!==-1;)if((!D||(0,O.$sD)(D,t,f,b,R))&&(m[p++]=new T.$iw(new I.$Rt(g,b+1+u,g,b+1+R+u),null),p>=E))return p;return p}let w;n.reset(0);do if(w=n.next(t),w&&(m[p++]=(0,O.$qD)(new I.$Rt(g,w.index+1+u,g,w.index+1+w[0].length+u),w,h),p>=E))return p;while(w);return p}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$fD){const{node:g,remainder:u,nodeStartOffset:p}=this.G(i),m=g.piece,h=m.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&p+m.length===i&&n.length<$){this.F(g,n),this.y();return}if(p===i)this.o(n,g),this.h.validate(i);else if(p+g.piece.length>i){const D=[];let w=new S(m.bufferIndex,E,m.end,this.t(m.bufferIndex,E,m.end),this.u(h,m.end)-this.u(h,E));if(this.K()&&this.M(n)&&this.I(g,u)===10){const b={line:w.start.line+1,column:0};w=new S(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(g,u-1)===13){const b=this.s(g,u-1);this.C(g,b),n="\r"+n,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const C=this.w(n);w.length>0&&this.S(g,w);let R=g;for(let f=0;f<C.length;f++)R=this.S(R,C[f]);this.v(D)}else this.q(n,g)}else{const g=this.w(n);let u=this.T(null,g[0]);for(let p=1;p<g.length;p++)u=this.S(u,g[p])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$fD)return;const t=this.G(i),g=this.G(i+n),u=t.node,p=g.node;if(u===p){const C=this.s(u,t.remainder),R=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(n===u.piece.length){const f=u.next();(0,A.$kD)(this,u),this.N(f),this.y();return}this.D(u,R),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+n){this.C(u,C),this.O(u),this.y();return}this.E(u,C,R),this.y();return}const m=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&m.push(u);const E=this.s(p,g.remainder);this.D(p,E),p.piece.length===0&&m.push(p);const D=u.next();for(let C=D;C!==A.$fD&&C!==p;C=C.next())m.push(C);const w=u.piece.length===0?u.prev():u;this.v(m),this.O(w),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const p=n.piece,m={line:p.start.line+1,column:0},h=new S(p.bufferIndex,m,p.end,this.t(p.bufferIndex,m,p.end),p.length-1);n.piece=h,i+=`
`,(0,A.$mD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const g=this.w(i);let u=this.T(n,g[g.length-1]);for(let p=g.length-2;p>=0;p--)u=this.T(u,g[p]);this.N(u),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),g=this.S(n,t[0]);let u=g;for(let p=1;p<t.length;p++)u=this.S(u,t[p]);this.N(g)}s(i,n,t){const g=i.piece,u=i.piece.bufferIndex,p=this.a[u].lineStarts,h=p[g.start.line]+g.start.column+n;let E=g.start.line,D=g.end.line,w=0,C=0,R=0;for(;E<=D&&(w=E+(D-E)/2|0,R=p[w],w!==D);)if(C=p[w+1],h<R)D=w-1;else if(h>=C)E=w+1;else break;return t?(t.line=w,t.column=h-R,null):{line:w,column:h-R}}t(i,n,t){if(t.column===0)return t.line-n.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-n.line;const u=g[t.line+1],p=g[t.line]+t.column;if(u>p+1)return t.line-n.line;const m=p-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$kD)(this,i[n])}w(i){if(i.length>$){const D=[];for(;i.length>$;){const C=i.charCodeAt($-1);let R;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(R=i.substring(0,$-1),i=i.substring($-1)):(R=i.substring(0,$),i=i.substring($));const f=y(R);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:R.length-f[f.length-1]},f.length-1,R.length)),this.a.push(new d(R,f))}const w=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new d(i,w)),D}let n=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let D=0;D<t.length;D++)t[D]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,m=u-this.a[0].lineStarts[p],h={line:p,column:m},E=new S(0,g,h,this.t(0,g,h),u-n);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const p=this.B(t,i-u.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(h+p,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return m.substring(h+p,h+E-n)}}else{let p=0;const m=i;for(;t!==A.$fD;)if(t.left!==A.$fD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return p+=t.size_left,this.h.set({node:t,nodeStartOffset:p,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(w+h,w+E-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,p+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$fD;){const p=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=p.substring(h,h+m-n),g}else{const m=this.u(t.piece.bufferIndex,t.piece.start);g+=p.substr(m,t.piece.length)}t=t.next()}return g}y(){let i=this.root,n=1,t=0;for(;i!==A.$fD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,g=this.s(i,n),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const p=this.t(i.piece.bufferIndex,t.start,g);if(p!==u)return{index:p,remainder:0}}return{index:u,remainder:g.column}}B(i,n){if(n<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+n+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),p=n,m=this.u(t.bufferIndex,p),h=this.t(t.bufferIndex,t.start,p),E=h-g,D=m-u,w=t.length+D;i.piece=new S(t.bufferIndex,t.start,p,h,w),(0,A.$mD)(this,i,D,E)}D(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),p=n,m=this.t(t.bufferIndex,p,t.end),h=this.u(t.bufferIndex,p),E=m-g,D=u-h,w=t.length+D;i.piece=new S(t.bufferIndex,p,t.end,m,w),(0,A.$mD)(this,i,D,E)}E(i,n,t){const g=i.piece,u=g.start,p=g.end,m=g.length,h=g.lineFeedCnt,E=n,D=this.t(g.bufferIndex,g.start,E),w=this.u(g.bufferIndex,n)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,w),(0,A.$mD)(this,i,w-m,D-h);const C=new S(g.bufferIndex,t,p,this.t(g.bufferIndex,t,p),this.u(g.bufferIndex,p)-this.u(g.bufferIndex,t)),R=this.S(i,C);this.N(R)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=n;const u=y(n,!1);for(let R=0;R<u.length;R++)u[R]+=g;if(t){const R=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-R}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const p=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[p],h={line:p,column:m},E=i.piece.length+n.length,D=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,h),C=w-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,w,E),this.g=h,(0,A.$mD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;n!==A.$fD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){g+=n.size_left;const u={node:n,remainder:i-n.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=n.size_left+n.piece.length,g+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,g=0;for(;t!==A.$fD;)if(t.left!==A.$fD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),p=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+n-1,p),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+n-1<=t.piece.length)return{node:t,remainder:u+n-1,nodeStartOffset:g};n-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$fD;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),p=this.J(t);return{node:t,remainder:Math.min(n-1,u),nodeStartOffset:p}}else if(t.piece.length>=n-1){const u=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:u}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$fD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,g=n.start.line,u=t[g]+n.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$fD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const p=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,m,p),(0,A.$mD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},E=n.piece.length-1,D=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new S(n.piece.bufferIndex,h,n.piece.end,D,E),(0,A.$mD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w=this.w(`\r
`);this.S(i,w[0]);for(let C=0;C<t.length;C++)(0,A.$kD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$kD)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},p=g.length-1,m=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,m,p),(0,A.$mD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$fD)return n(A.$fD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$fD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return n.buffer.substring(g,u)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,g)}S(i,n){const t=new A.$eD(n,A.NodeColor.Red);if(t.left=A.$fD,t.right=A.$fD,t.parent=A.$fD,t.size_left=0,t.lf_left=0,this.root===A.$fD)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$fD)i.right=t,t.parent=i;else{const u=(0,A.$gD)(i.right);u.left=t,t.parent=u}return(0,A.$lD)(this,t),t}T(i,n){const t=new A.$eD(n,A.NodeColor.Red);if(t.left=A.$fD,t.right=A.$fD,t.parent=A.$fD,t.size_left=0,t.lf_left=0,this.root===A.$fD)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$fD)i.left=t,t.parent=i;else{const g=(0,A.$hD)(i.left);g.right=t,t.parent=g}return(0,A.$lD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$yD=c}),define(Ne[162],Me([1,0,6,12,32,52,100,154,156,4]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zD=void 0,P=Ve(P);class k extends o.$Vc{constructor(a,S,d,r,s,c,l){super(),this.m=this.B(new v.$me),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=r,this.h=s,this.c=new A.$yD(a,d,l)}equals(a){return!(a instanceof k)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,r=this.getPositionAt(a),s=this.getPositionAt(d);return new I.$Rt(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(a,S=T.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=T.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),r=this.getOffsetAt(a.endLineNumber,a.endColumn);let s=0;const c=this.n(S),l=this.getEOL();if(c.length!==l.length){const i=c.length-l.length,n=a.endLineNumber-a.startLineNumber;s=i*n}return r-d+s}getCharacterCountInRange(a,S=T.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=a.startLineNumber,s=a.endLineNumber;for(let c=r;c<=s;c++){const l=this.getLineContent(c),i=c===r?a.startColumn-1:0,n=c===s?a.endColumn-1:l.length;for(let t=i;t<n;t++)P.$Kf(l.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(s-r),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=P.$vf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=P.$xf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let r=this.g,s=this.h,c=this.j,l=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let b=!0;c||(b=!P.$Vf(E.text),c=b),!r&&b&&(r=P.$Uf(E.text)),!s&&b&&(s=P.$Xf(E.text))}let w="",C=0,R=0,f=0;if(E.text){let b;[C,R,f,b]=(0,O.$Cu)(E.text);const L=this.getEOL(),N=L===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;b===O.StringEOL.Unknown||b===N?w=E.text:w=E.text.replace(/\r\n|\r|\n/g,L)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:w,eolCount:C,firstLineLength:R,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(k.u);let n=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),w=i[h+1].range.getStartPosition();if(w.isBeforeOrEqual(D)){if(w.isBefore(D))throw new Error("Overlapping ranges are not allowed!");n=!0}}l&&(i=this.s(i));const t=d||S?k._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let w=D.startLineNumber;w<=D.endLineNumber;w++){let C="";w===D.startLineNumber&&(C=this.getLineContent(E.range.startLineNumber),P.$vf(C)!==-1)||g.push({lineNumber:w,oldContent:C})}}let u=null;if(d){let h=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],w=t[E],C=this.getValueInRange(D.range),R=D.rangeOffset+h;h+=D.text.length-C.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:w,text:C,textChange:new $.$iu(D.rangeOffset,C,R,D.text)}}n||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=r,this.h=s,this.j=c;const p=this.t(i);let m=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),m=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const w=g[h].oldContent,C=this.getLineContent(D);C.length===0||C===w||P.$vf(C)!==-1||m.push(D)}}return this.m.fire(),new T.$mw(u,p,m)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,r=a[a.length-1].range,s=new I.$Rt(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let c=d.startLineNumber,l=d.startColumn;const i=[];for(let p=0,m=a.length;p<m;p++){const h=a[p],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new I.$Rt(c,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,l=E.endColumn}const n=i.join(""),[t,g,u]=(0,O.$Cu)(n);return{sortIndex:0,identifier:a[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,T.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(k.w);const S=[];for(let d=0;d<a.length;d++){const r=a[d],s=r.range.startLineNumber,c=r.range.startColumn,l=r.range.endLineNumber,i=r.range.endColumn;if(s===l&&c===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new I.$Rt(s,c,l,i);S.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,r){return this.c.findMatchesLineByLine(a,S,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,r=a.startColumn,[s,c,l]=(0,O.$Cu)(S);let i;if(S.length>0){const n=s+1;n===1?i=new I.$Rt(d,r,d,r+c):i=new I.$Rt(d,r,d+n-1,l+1)}else i=new I.$Rt(d,r,d,r);return i}static _getInverseEditRanges(a){const S=[];let d=0,r=0,s=null;for(let c=0,l=a.length;c<l;c++){const i=a[c];let n,t;s?s.range.endLineNumber===i.range.startLineNumber?(n=d,t=r+(i.range.startColumn-s.range.endColumn)):(n=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new I.$Rt(n,t,n,t+i.firstLineLength):g=new I.$Rt(n,t,n+u-1,i.lastLineLength+1)}else g=new I.$Rt(n,t,n,t);d=g.endLineNumber,r=g.endColumn,S.push(g),s=i}return S}static u(a,S){const d=I.$Rt.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=I.$Rt.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$zD=k}),define(Ne[163],Me([1,0,27,12,52,100,162]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=void 0,P=Ve(P);class O{constructor(k,y,a,S,d,r,s,c,l){this.a=k,this.b=y,this.c=a,this.d=S,this.e=d,this.f=r,this.g=s,this.h=c,this.j=l}k(k){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?k===I.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(k){const y=this.k(k),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,r=a.length;d<r;d++){const s=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,T.$uD)(s);a[d]=new T.$xD(s,c)}const S=new A.$zD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(k){return this.a[0].buffer.substr(0,k).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(k){if(k.length===0)return;this.a.length===0&&P.$6f(k)&&(this.b=P.$5f,k=k.substr(1));const y=k.charCodeAt(k.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(k.substr(0,k.length-1),!1),this.c=!0,this.d=y):(this.m(k,!1),this.c=!1,this.d=y)}m(k,y){!y&&k.length===0||(this.c?this.n(String.fromCharCode(this.d)+k):this.n(k))}n(k){const y=(0,T.$vD)(this.e,k);this.a.push(new T.$xD(k,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=P.$Uf(k)),this.k||(this.k=P.$Xf(k)))}finish(k=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,k)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const k=this.a[this.a.length-1];k.buffer+=String.fromCharCode(this.d);const y=(0,T.$uD)(k.buffer);k.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$AD=$}),define(Ne[103],Me([1,0,22,20]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3db=$,e.$4db=k,P=Ve(P);var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function T(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],r=y[a+1],s=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=s,y[a+2]=r,y[a+3]=d}}function A(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return P.$E()||T(a),v.$Oe.wrap(a)}function O(y){const a=y.buffer;if(P.$E()||T(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(y){const a=new Uint32Array(o(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=I.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=I.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return A(a)}function o(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function k(y){const a=O(y);let S=0;const d=a[S++];if(a[S++]===I.Full){const l=a[S++],i=a.subarray(S,S+l);return S+=l,{id:d,type:"full",data:i}}const s=a[S++],c=[];for(let l=0;l<s;l++){const i=a[S++],n=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[l]={start:i,deleteCount:n,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Ne[164],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_=e.$T_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$T_=v;class P{constructor(T){this.identifier=T}}e.$U_=P}),define(Ne[165],Me([1,0,6,4,9]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=k,I=Ve(I);class T extends P.$Vc{constructor(a,S="",d="",r=!0,s){super(),this.j=this.B(new v.$me),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=r,this.D=s}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$lj=T;class A extends P.$Vc{constructor(){super(...arguments),this.f=this.B(new v.$me),this.onWillRun=this.f.event,this.m=this.B(new v.$me),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(r){d=r}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$mj=A;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new O,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=O;class ${get actions(){return this.a}constructor(a,S,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=r,this.a=d}async run(){}}e.$oj=$;class o extends T{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,I.localize(39,null),void 0,!1)}}e.$pj=o;function k(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Ne[166],Me([1,0,9]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=o,e.$4m=k,e.$5m=y;const P=60,I=P*60,T=I*24,A=T*7,O=T*30,$=T*365;function o(a,S,d,r){typeof a!="number"&&(a=a.getTime());const s=Math.round((new Date().getTime()-a)/1e3);if(s<-30)return(0,v.localize)(40,null,o(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,v.localize)(41,null);let c;return s<P?(c=s,S?c===1?d?(0,v.localize)(42,null,c):(0,v.localize)(43,null,c):d?(0,v.localize)(44,null,c):(0,v.localize)(45,null,c):c===1?d?(0,v.localize)(46,null,c):(0,v.localize)(47,null,c):d?(0,v.localize)(48,null,c):(0,v.localize)(49,null,c)):s<I?(c=Math.floor(s/P),S?c===1?d?(0,v.localize)(50,null,c):(0,v.localize)(51,null,c):d?(0,v.localize)(52,null,c):(0,v.localize)(53,null,c):c===1?d?(0,v.localize)(54,null,c):(0,v.localize)(55,null,c):d?(0,v.localize)(56,null,c):(0,v.localize)(57,null,c)):s<T?(c=Math.floor(s/I),S?c===1?d?(0,v.localize)(58,null,c):(0,v.localize)(59,null,c):d?(0,v.localize)(60,null,c):(0,v.localize)(61,null,c):c===1?d?(0,v.localize)(62,null,c):(0,v.localize)(63,null,c):d?(0,v.localize)(64,null,c):(0,v.localize)(65,null,c)):s<A?(c=Math.floor(s/T),S?c===1?(0,v.localize)(66,null,c):(0,v.localize)(67,null,c):c===1?(0,v.localize)(68,null,c):(0,v.localize)(69,null,c)):s<O?(c=Math.floor(s/A),S?c===1?d?(0,v.localize)(70,null,c):(0,v.localize)(71,null,c):d?(0,v.localize)(72,null,c):(0,v.localize)(73,null,c):c===1?d?(0,v.localize)(74,null,c):(0,v.localize)(75,null,c):d?(0,v.localize)(76,null,c):(0,v.localize)(77,null,c)):s<$?(c=Math.floor(s/O),S?c===1?d?(0,v.localize)(78,null,c):(0,v.localize)(79,null,c):d?(0,v.localize)(80,null,c):(0,v.localize)(81,null,c):c===1?d?(0,v.localize)(82,null,c):(0,v.localize)(83,null,c):d?(0,v.localize)(84,null,c):(0,v.localize)(85,null,c)):(c=Math.floor(s/$),S?c===1?d?(0,v.localize)(86,null,c):(0,v.localize)(87,null,c):d?(0,v.localize)(88,null,c):(0,v.localize)(89,null,c):c===1?d?(0,v.localize)(90,null,c):(0,v.localize)(91,null,c):d?(0,v.localize)(92,null,c):(0,v.localize)(93,null,c))}function k(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(94,null,a):(0,v.localize)(95,null,a):d<P?S?(0,v.localize)(96,null,Math.round(a)/1e3):(0,v.localize)(97,null,Math.round(a)/1e3):d<I?S?(0,v.localize)(98,null,Math.round(a/(1e3*P))):(0,v.localize)(99,null,Math.round(a/(1e3*P))):d<T?S?(0,v.localize)(100,null,Math.round(a/(1e3*I))):(0,v.localize)(101,null,Math.round(a/(1e3*I))):(0,v.localize)(102,null,Math.round(a/(1e3*T)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ne[42],Me([1,0,17,14,9]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=$,e.$sj=o,e.$tj=k,v=Ve(v),P=Ve(P),I=Ve(I);function T(y,a){return a&&(y.stack||y.stacktrace)?I.localize(103,null,O(y),A(y.stack)||A(y.stacktrace)):O(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function O(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(104,null,y.message):y.message||I.localize(105,null)}function $(y=null,a=!1){if(!y)return I.localize(106,null);if(Array.isArray(y)){const S=v.$Hb(y),d=$(S[0],a);return S.length>1?I.localize(107,null,d,S.length):d}if(P.$fg(y))return y;if(y.detail){const S=y.detail;if(S.error)return T(S.error,a);if(S.exception)return T(S.exception,a)}return y.stack?T(y,a):y.message?y.message:I.localize(108,null)}function o(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function k(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Ne[167],Me([1,0,27,13,9]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var T;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...k){switch(k.length){case 1:return(0,I.localize)(1684,null,k[0]);case 2:return(0,I.localize)(1685,null,k[0],k[1]);case 3:return(0,I.localize)(1686,null,k[0],k[1],k[2]);default:return}}const O=(0,I.localize)(1687,null),$=(0,I.localize)(1688,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return y.isTripleEq?"===":"==";case T.NotEq:return y.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return y.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return y.lexeme;case T.QuotedStr:return y.lexeme;case T.Error:return y.lexeme;case T.EOF:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(T.LParen);break;case v.CharCode.CloseParen:this.k(T.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:a})}else this.k(T.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(T.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?T.LtEq:T.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?T.GtEq:T.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(T.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(T.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:T.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=o.b.get(a);S?this.k(S):this.f.push({type:T.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const r=this.c.charCodeAt(y);if(a)a=!1;else if(r===v.CharCode.Slash&&!S){y++;break}else r===v.CharCode.OpenSquareBracket?S=!0:r===v.CharCode.Backslash?a=!0:r===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&o.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=o}),define(Ne[104],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:3},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ne[73],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class v{constructor(I,T=[],A=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Di=v}),define(Ne[60],Me([1,0,73]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Us=T,e.$Vs=A;const P=[];var I;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function T(O,$,o){$ instanceof v.$Di||($=new v.$Di($,[],!!o)),P.push([O,$])}function A(){return P}}),define(Ne[168],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;class v{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$xr=v;class P{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const O=this.lookupOrInsertNode(T),$=this.lookupOrInsertNode(A);O.outgoing.set($.key,$),$.incoming.set(O.key,O)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const O of this.a.values())O.outgoing.delete(A),O.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let O=this.a.get(A);return O||(O=new v(A,T),this.a.set(A,O)),O}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,O]of this.a)T.push(`${A}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const O=new Set([T]),$=this.c(A,O);if($)return $}}c(T,A){for(const[O,$]of T.outgoing){if(A.has(O))return[...A,O].join(" -> ");A.add(O);const o=this.c($,A);if(o)return o;A.delete(O)}}}e.$yr=P}),define(Ne[3],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=I,e.$Hi=T;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function O($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=O})(v||(e._util=v={})),e.$Fi=I("instantiationService");function P(A,O,$){O[v.DI_TARGET]===O?O[v.DI_DEPENDENCIES].push({id:A,index:$}):(O[v.DI_DEPENDENCIES]=[{id:A,index:$}],O[v.DI_TARGET]=O)}function I(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const O=function($,o,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(O,$,k)};return O.toString=()=>A,v.serviceIds.set(A,O),O}function T(A){return A}}),define(Ne[43],Me([1,0,14,2,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=T,e.$cj=A,e.$dj=$,e.$ej=o,e.$fj=k,e.$gj=y,e.$hj=a,e.$ij=d,e.$jj=r,e.$kj=s,v=Ve(v),e.$aj=(0,I.$Gi)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof P.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof P.URI)}var O;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function $(c){switch(c){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function o(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function k(c,l){const i=Object.create(null);for(const n in c)y(i,n,c[n],l);return i}function y(c,l,i,n){const t=l.split("."),g=t.pop();let u=c;for(let p=0;p<t.length;p++){const m=t[p];let h=u[m];switch(typeof h){case"undefined":h=u[m]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is null`);return}break;default:n(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(c,l){const i=l.split(".");S(c,i)}function S(c,l){const i=l.shift();if(l.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const n=c[i];typeof n=="object"&&!Array.isArray(n)&&(S(n,l),Object.keys(n).length===0&&delete c[i])}}function d(c,l,i){function n(u,p){let m=u;for(const h of p){if(typeof m!="object"||m===null)return;m=m[h]}return m}const t=l.split("."),g=n(c,t);return typeof g>"u"?i:g}function r(c,l,i){Object.keys(l).forEach(n=>{n!=="__proto__"&&(n in c?v.$hg(c[n])&&v.$hg(l[n])?r(c[n],l[n],i):i&&(c[n]=l[n]):c[n]=l[n])})}function s(c){return c.replace(/[\[\]]/g,"")}}),define(Ne[31],Me([1,0,27,20,12,167,3,9,13]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=k,e.$Fj=p,e.$Gj=m,e.$Zj=ae;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",P.$k),o.set("isLinux",P.$l),o.set("isWindows",P.$j),o.set("isWeb",P.$p),o.set("isMacNative",P.$k&&!P.$p),o.set("isEdge",P.$I),o.set("isFirefox",P.$G),o.set("isChrome",P.$F),o.set("isSafari",P.$H);function k(X,B){if(o.get(X)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(X,B)}const y=Object.prototype.hasOwnProperty;var a;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,O.localize)(1664,null),r=(0,O.localize)(1665,null),s=(0,O.localize)(1666,null),c=(0,O.localize)(1667,null),l=(0,O.localize)(1668,null),i=(0,O.localize)(1669,null),n=(0,O.localize)(1670,null),t=(0,O.localize)(1671,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=S){this.k=B,this.d=new T.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ye=this.D(),de=ye.type===T.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:ye.offset,lexeme:T.$Bj.getLexeme(ye),additionalInfo:de}),g.c}return te}catch(te){if(te!==g.c)throw te;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(T.TokenType.Or);){const te=this.o();B.push(te)}return B.length===1?B[0]:u.or(...B)}o(){const B=[this.s()];for(;this.y(T.TokenType.And);){const te=this.s();B.push(te)}return B.length===1?B[0]:u.and(...B)}s(){if(this.y(T.TokenType.Neg)){const B=this.D();switch(B.type){case T.TokenType.True:return this.z(),E.INSTANCE;case T.TokenType.False:return this.z(),D.INSTANCE;case T.TokenType.LParen:{this.z();const te=this.l();return this.A(T.TokenType.RParen,c),te?.negate()}case T.TokenType.Str:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case T.TokenType.True:return this.z(),u.true();case T.TokenType.False:return this.z(),u.false();case T.TokenType.LParen:{this.z();const te=this.l();return this.A(T.TokenType.RParen,c),te}case T.TokenType.Str:{const te=B.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==T.TokenType.RegexStr)throw this.B("REGEX",de);const we=de.lexeme,he=we.lastIndexOf("/"),Z=he===we.length-1?void 0:this.w(we.substring(he+1));let x;try{x=new RegExp(we.substring(1,he),Z)}catch{throw this.B("REGEX",de)}return J.create(te,x)}switch(de.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const we=[de.lexeme];this.z();let he=this.D(),Z=0;for(let Ue=0;Ue<de.lexeme.length;Ue++)de.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?Z++:de.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&Z--;for(;!this.E()&&he.type!==T.TokenType.And&&he.type!==T.TokenType.Or;){switch(he.type){case T.TokenType.LParen:Z++;break;case T.TokenType.RParen:Z--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let Ue=0;Ue<he.lexeme.length;Ue++)he.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?Z++:de.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&Z--}if(Z<0)break;we.push(T.$Bj.getLexeme(he)),this.z(),he=this.D()}const x=we.join(""),be=x.lastIndexOf("/"),$e=be===x.length-1?void 0:this.w(x.substring(be+1));let Ae;try{Ae=new RegExp(x.substring(1,be),$e)}catch{throw this.B("REGEX",de)}return u.regex(te,Ae)}case T.TokenType.QuotedStr:{const we=de.lexeme;this.z();let he=null;if(!(0,I.$df)(we)){const Z=we.indexOf("/"),x=we.lastIndexOf("/");if(Z!==x&&Z>=0){const be=we.slice(Z+1,x),$e=we[x+1]==="i"?"i":"";try{he=new RegExp(be,$e)}catch{throw this.B("REGEX",de)}}}if(he===null)throw this.B("REGEX",de);return J.create(te,he)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,s);const de=this.u();return u.notIn(te,de)}switch(this.D().type){case T.TokenType.Eq:{this.z();const de=this.u();if(this.x().type===T.TokenType.QuotedStr)return u.equals(te,de);switch(de){case"true":return u.has(te);case"false":return u.not(te);default:return u.equals(te,de)}}case T.TokenType.NotEq:{this.z();const de=this.u();if(this.x().type===T.TokenType.QuotedStr)return u.notEquals(te,de);switch(de){case"true":return u.not(te);case"false":return u.has(te);default:return u.notEquals(te,de)}}case T.TokenType.Lt:return this.z(),G.create(te,this.u());case T.TokenType.LtEq:return this.z(),q.create(te,this.u());case T.TokenType.Gt:return this.z(),M.create(te,this.u());case T.TokenType.GtEq:return this.z(),W.create(te,this.u());case T.TokenType.In:return this.z(),u.in(te,this.u());default:return u.has(te)}}case T.TokenType.EOF:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),B.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,te){if(this.C(B))return this.z();throw this.B(te,this.D())}B(B,te,ye){const de=(0,O.localize)(1672,null,B,T.$Bj.getLexeme(te)),we=te.offset,he=T.$Bj.getLexeme(te);return this.h.push({message:de,offset:we,lexeme:he,additionalInfo:ye}),g.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$Dj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(B){return w.create(B)}static equals(B,te){return C.create(B,te)}static notEquals(B,te){return b.create(B,te)}static regex(B,te){return J.create(B,te)}static in(B,te){return R.create(B,te)}static notIn(B,te){return f.create(B,te)}static not(B){return L.create(B)}static and(...B){return me.create(B,null,!0)}static or(...B){return le.create(B,null,!0)}static greater(B,te){return M.create(B,te)}static greaterEquals(B,te){return W.create(B,te)}static smaller(B,te){return G.create(B,te)}static smallerEquals(B,te){return q.create(B,te)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ej=u;function p(X){const B=new g({regexParsingWithErrorRecovery:!1});return X.map(te=>(B.parse(te),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,O.localize)(1673,null,ye.additionalInfo):(0,O.localize)(1674,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}function m(X,B){const te=X?X.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!te&&!ye?!0:!te||!ye?!1:te.equals(ye)}function h(X,B){return X.cmp(B)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Hj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return E.INSTANCE}}e.$Ij=D;class w{static create(B,te=null){const ye=o.get(B);return typeof ye=="boolean"?ye?D.INSTANCE:E.INSTANCE:new w(B,te)}constructor(B,te){this.key=B,this.c=te,this.type=a.Defined}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=o.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:E.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Jj=w;class C{static create(B,te,ye=null){if(typeof te=="boolean")return te?w.create(B,ye):L.create(B,ye);const de=o.get(B);return typeof de=="boolean"?te===(de?"true":"false")?D.INSTANCE:E.INSTANCE:new C(B,te,ye)}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.Equals}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const te=B?"true":"false";return this.d===te?D.INSTANCE:E.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Kj=C;class R{static create(B,te){return new R(B,te)}constructor(B,te){this.d=B,this.f=te,this.type=a.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const te=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(te)?te.includes(ye):typeof ye=="string"&&typeof te=="object"&&te!==null?y.call(te,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Lj=R;class f{static create(B,te){return new f(B,te)}constructor(B,te){this.d=B,this.f=te,this.type=a.NotIn,this.c=R.create(B,te)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=f;class b{static create(B,te,ye=null){if(typeof te=="boolean")return te?L.create(B,ye):w.create(B,ye);const de=o.get(B);return typeof de=="boolean"?te===(de?"true":"false")?E.INSTANCE:D.INSTANCE:new b(B,te,ye)}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const te=B?"true":"false";return this.d===te?E.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Nj=b;class L{static create(B,te=null){const ye=o.get(B);return typeof ye=="boolean"?ye?E.INSTANCE:D.INSTANCE:new L(B,te)}constructor(B,te){this.c=B,this.d=te,this.type=a.Not}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=o.get(this.c);return typeof B=="boolean"?B?E.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Oj=L;function N(X,B){if(typeof X=="string"){const te=parseFloat(X);isNaN(te)||(X=te)}return typeof X=="string"||typeof X=="number"?B(X):E.INSTANCE}class M{static create(B,te,ye=null){return N(te,de=>new M(B,de,ye))}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.Greater}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Pj=M;class W{static create(B,te,ye=null){return N(te,de=>new W(B,de,ye))}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Qj=W;class G{static create(B,te,ye=null){return N(te,de=>new G(B,de,ye))}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Rj=G;class q{static create(B,te,ye=null){return N(te,de=>new q(B,de,ye))}constructor(B,te,ye){this.c=B,this.d=te,this.f=ye,this.type=a.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Sj=q;class J{static create(B,te){return new J(B,te)}constructor(B,te){this.d=B,this.f=te,this.type=a.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const te=this.f?this.f.source:"",ye=B.f?B.f.source:"";return te<ye?-1:te>ye?1:0}equals(B){if(B.type===this.type){const te=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&te===ye}return!1}substituteConstants(){return this}evaluate(B){const te=B.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Tj=J;class K{static create(B){return new K(B)}constructor(B){this.c=B,this.type=a.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new K(this.c.map(B))}negate(){return this.c}}e.$Uj=K;function oe(X){let B=null;for(let te=0,ye=X.length;te<ye;te++){const de=X[te].substituteConstants();if(X[te]!==de&&B===null){B=[];for(let we=0;we<te;we++)B[we]=X[we]}B!==null&&(B[te]=de)}return B===null?X:B}class me{static create(B,te,ye){return me.d(B,te,ye)}constructor(B,te){this.expr=B,this.c=te,this.type=a.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let te=0,ye=this.expr.length;te<ye;te++){const de=h(this.expr[te],B.expr[te]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let te=0,ye=this.expr.length;te<ye;te++)if(!this.expr[te].equals(B.expr[te]))return!1;return!0}return!1}substituteConstants(){const B=oe(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let te=0,ye=this.expr.length;te<ye;te++)if(!this.expr[te].evaluate(B))return!1;return!0}static d(B,te,ye){const de=[];let we=!1;for(const he of B)if(he){if(he.type===a.True){we=!0;continue}if(he.type===a.False)return E.INSTANCE;if(he.type===a.And){de.push(...he.expr);continue}de.push(he)}if(de.length===0&&we)return D.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(h);for(let he=1;he<de.length;he++)de[he-1].equals(de[he])&&(de.splice(he,1),he--);if(de.length===1)return de[0];for(;de.length>1;){const he=de[de.length-1];if(he.type!==a.Or)break;de.pop();const Z=de.pop(),x=de.length===0,be=le.create(he.expr.map($e=>me.create([$e,Z],null,ye)),null,x);be&&(de.push(be),de.sort(h))}if(de.length===1)return de[0];if(ye){for(let he=0;he<de.length;he++)for(let Z=he+1;Z<de.length;Z++)if(de[he].negate().equals(de[Z]))return E.INSTANCE;if(de.length===1)return de[0]}return new me(de,te)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const te of this.expr)B.push(...te.keys());return B}map(B){return new me(this.expr.map(te=>te.map(B)),null)}negate(){if(!this.c){const B=[];for(const te of this.expr)B.push(te.negate());this.c=le.create(B,this,!0)}return this.c}}e.$Vj=me;class le{static create(B,te,ye){return le.d(B,te,ye)}constructor(B,te){this.expr=B,this.c=te,this.type=a.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let te=0,ye=this.expr.length;te<ye;te++){const de=h(this.expr[te],B.expr[te]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let te=0,ye=this.expr.length;te<ye;te++)if(!this.expr[te].equals(B.expr[te]))return!1;return!0}return!1}substituteConstants(){const B=oe(this.expr);return B===this.expr?this:le.create(B,this.c,!1)}evaluate(B){for(let te=0,ye=this.expr.length;te<ye;te++)if(this.expr[te].evaluate(B))return!0;return!1}static d(B,te,ye){let de=[],we=!1;if(B){for(let he=0,Z=B.length;he<Z;he++){const x=B[he];if(x){if(x.type===a.False){we=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){de=de.concat(x.expr);continue}de.push(x)}}if(de.length===0&&we)return E.INSTANCE;de.sort(h)}if(de.length!==0){if(de.length===1)return de[0];for(let he=1;he<de.length;he++)de[he-1].equals(de[he])&&(de.splice(he,1),he--);if(de.length===1)return de[0];if(ye){for(let he=0;he<de.length;he++)for(let Z=he+1;Z<de.length;Z++)if(de[he].negate().equals(de[Z]))return D.INSTANCE;if(de.length===1)return de[0]}return new le(de,te)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const te of this.expr)B.push(...te.keys());return B}map(B){return new le(this.expr.map(te=>te.map(B)),null)}negate(){if(!this.c){const B=[];for(const te of this.expr)B.push(te.negate());for(;B.length>1;){const te=B.shift(),ye=B.shift(),de=[];for(const we of Oe(te))for(const he of Oe(ye))de.push(me.create([we,he],null,!1));B.unshift(le.create(de,null,!1))}this.c=le.create(B,this,!0)}return this.c}}e.$Wj=le;class _ extends w{static{this.d=[]}static all(){return _.d.values()}constructor(B,te,ye){super(B,null),this.f=te,typeof ye=="object"?_.d.push({...ye,key:B}):ye!==!0&&_.d.push({key:B,description:ye,type:te!=null?typeof te:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return C.create(this.key,B)}notEqualsTo(B){return b.create(this.key,B)}}e.$Xj=_,e.$Yj=(0,A.$Gi)("contextKeyService");function ce(X,B){return X<B?-1:X>B?1:0}function pe(X,B,te,ye){return X<te?-1:X>te?1:B<ye?-1:B>ye?1:0}function ae(X,B){if(X.type===a.False||B.type===a.True)return!0;if(X.type===a.Or)return B.type===a.Or?Se(X.expr,B.expr):!1;if(B.type===a.Or){for(const te of B.expr)if(ae(X,te))return!0;return!1}if(X.type===a.And){if(B.type===a.And)return Se(B.expr,X.expr);for(const te of X.expr)if(ae(te,B))return!0;return!1}return X.equals(B)}function Se(X,B){let te=0,ye=0;for(;te<X.length&&ye<B.length;){const de=X[te].cmp(B[ye]);if(de<0)return!1;de===0&&te++,ye++}return te===X.length}function Oe(X){return X.type===a.Or?X.expr:[X]}}),define(Ne[169],Me([1,0,31,3]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$vt=e.AccessibilitySupport=e.$ut=void 0,e.$wt=T,e.$ut=(0,P.$Gi)("accessibilityService");var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.$vt=new v.$Xj("accessibilityModeEnabled",!1);function T(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$xt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ne[105],Me([1,0,17,25,20,147,280,157,170,9,169]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=Ve(v),P=Ve(P),I=Ve(I),o=Ve(o);var y;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(ee){this.c=ee}hasChanged(ee){return this.c[ee]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(ee,Y,Ze,xe){this.id=ee,this.name=Y,this.defaultValue=Ze,this.schema=xe}applyUpdate(ee,Y){return s(ee,Y)}compute(ee,Y,Ze){return Ze}}class r{constructor(ee,Y){this.newValue=ee,this.didChange=Y}}e.ApplyUpdateResult=r;function s(ne,ee){if(typeof ne!="object"||typeof ee!="object"||!ne||!ee)return new r(ee,ne!==ee);if(Array.isArray(ne)||Array.isArray(ee)){const Ze=Array.isArray(ne)&&Array.isArray(ee)&&v.$ub(ne,ee);return new r(ee,!Ze)}let Y=!1;for(const Ze in ee)if(ee.hasOwnProperty(Ze)){const xe=s(ne[Ze],ee[Ze]);xe.didChange&&(ne[Ze]=xe.newValue,Y=!0)}return new r(ne,Y)}class c{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return this.defaultValue}}class l{constructor(ee,Y,Ze,xe){this.id=ee,this.name=Y,this.defaultValue=Ze,this.schema=xe}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Y,Ze){return Ze}}function i(ne,ee){return typeof ne>"u"?ee:ne==="false"?!1:!!ne}class n extends l{constructor(ee,Y,Ze,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ze),super(ee,Y,Ze,xe)}validate(ee){return i(ee,this.defaultValue)}}function t(ne,ee,Y,Ze){if(typeof ne>"u")return ee;let xe=parseInt(ne,10);return isNaN(xe)?ee:(xe=Math.max(Y,xe),xe=Math.min(Ze,xe),xe|0)}class g extends l{static clampedInt(ee,Y,Ze,xe){return t(ee,Y,Ze,xe)}constructor(ee,Y,Ze,xe,ht,wt=void 0){typeof wt<"u"&&(wt.type="integer",wt.default=Ze,wt.minimum=xe,wt.maximum=ht),super(ee,Y,Ze,wt),this.minimum=xe,this.maximum=ht}validate(ee){return g.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function u(ne,ee,Y,Ze){if(typeof ne>"u")return ee;const xe=p.float(ne,ee);return p.clamp(xe,Y,Ze)}class p extends l{static clamp(ee,Y,Ze){return ee<Y?Y:ee>Ze?Ze:ee}static float(ee,Y){if(typeof ee=="number")return ee;if(typeof ee>"u")return Y;const Ze=parseFloat(ee);return isNaN(Ze)?Y:Ze}constructor(ee,Y,Ze,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Ze),super(ee,Y,Ze,ht),this.validationFn=xe}validate(ee){return this.validationFn(p.float(ee,this.defaultValue))}}class m extends l{static string(ee,Y){return typeof ee!="string"?Y:ee}constructor(ee,Y,Ze,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ze),super(ee,Y,Ze,xe)}validate(ee){return m.string(ee,this.defaultValue)}}function h(ne,ee,Y,Ze){return typeof ne!="string"?ee:Ze&&ne in Ze?Ze[ne]:Y.indexOf(ne)===-1?ee:ne}class E extends l{constructor(ee,Y,Ze,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Ze),super(ee,Y,Ze,ht),this.c=xe}validate(ee){return h(ee,this.defaultValue,this.c)}}class D extends d{constructor(ee,Y,Ze,xe,ht,wt,Lt=void 0){typeof Lt<"u"&&(Lt.type="string",Lt.enum=ht,Lt.default=xe),super(ee,Y,Ze,Lt),this.c=ht,this.d=wt}validate(ee){return typeof ee!="string"?this.defaultValue:this.c.indexOf(ee)===-1?this.defaultValue:this.d(ee)}}function w(ne){switch(ne){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",k.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null)],default:"auto",tags:["accessibility"],description:o.localize(300,null)})}validate(ee){switch(ee){case"auto":return k.AccessibilitySupport.Unknown;case"off":return k.AccessibilitySupport.Disabled;case"on":return k.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Y,Ze){return Ze===k.AccessibilitySupport.Unknown?ee.accessibilitySupport:Ze}}class R extends d{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(301,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(302,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertSpace:i(Y.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Y.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function b(ne){switch(ne){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var L;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function N(ne){switch(ne){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function M(ne){switch(ne){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class W extends c{constructor(){super(je.editorClassName)}compute(ee,Y,Ze){const xe=["monaco-editor"];return Y.get(je.extraEditorClassName)&&xe.push(Y.get(je.extraEditorClassName)),ee.extraEditorClassName&&xe.push(ee.extraEditorClassName),Y.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Y.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Y.get(je.showUnused)&&xe.push("showUnused"),Y.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class G extends n{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(303,null)})}compute(ee,Y,Ze){return Ze&&ee.emptySelectionClipboard}}class q extends d{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(304,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(305,null),o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(309,null),o.localize(310,null),o.localize(311,null)],description:o.localize(312,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(313,null),included:I.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(314,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(315,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{cursorMoveOnType:i(Y.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":h(Y.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":h(Y.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Y.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Y.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Y.loop,this.defaultValue.loop)}}}class J extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",J.OFF,{anyOf:[{type:"boolean",description:o.localize(316,null)},{type:"string",description:o.localize(317,null)}],description:o.localize(318,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?J.OFF:ee==="true"?J.ON:ee:ee?J.ON:J.OFF}}e.EditorFontLigatures=J;class K extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:o.localize(319,null)},{type:"string",description:o.localize(320,null)}],description:o.localize(321,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?K.OFF:ee==="true"?K.TRANSLATE:ee:ee?K.TRANSLATE:K.OFF}compute(ee,Y,Ze){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class oe extends c{constructor(){super(je.fontInfo)}compute(ee,Y,Ze){return ee.fontInfo}}class me extends l{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(322,null)})}validate(ee){const Y=p.float(ee,this.defaultValue);return Y===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(Y,6,100)}compute(ee,Y,Ze){return ee.fontInfo.fontSize}}class le extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:le.d,maximum:le.e,errorMessage:o.localize(323,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:le.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(324,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(g.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,le.d,le.e))}}class _ extends d{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Y={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(325,null),o.localize(326,null),o.localize(327,null)]},Ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(328,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(329,null),...Y},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(330,null),...Y},"editor.gotoLocation.multipleDeclarations":{description:o.localize(331,null),...Y},"editor.gotoLocation.multipleImplementations":{description:o.localize(332,null),...Y},"editor.gotoLocation.multipleReferences":{description:o.localize(333,null),...Y},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ze,description:o.localize(334,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ze,description:o.localize(335,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ze,description:o.localize(336,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ze,description:o.localize(337,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ze,description:o.localize(338,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{multiple:h(Y.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Y.multipleDefinitions??h(Y.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Y.multipleTypeDefinitions??h(Y.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Y.multipleDeclarations??h(Y.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Y.multipleImplementations??h(Y.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Y.multipleReferences??h(Y.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Y.multipleTests??h(Y.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Y.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Y.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Y.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Y.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Y.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:m.string(Y.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ce extends d{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(339,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(340,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(341,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(342,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(343,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),delay:g.clampedInt(Y.delay,this.defaultValue.delay,0,1e4),sticky:i(Y.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Y.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Y.above,this.defaultValue.above)}}}var pe;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class ae extends c{constructor(){super(je.layoutInfo)}compute(ee,Y,Ze){return ae.computeLayout(Y,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Y=ee.height/ee.lineHeight,Ze=Math.floor(ee.paddingTop/ee.lineHeight);let xe=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(xe=Math.max(xe,Y-1));const ht=(Ze+ee.viewLineCount+xe)/(ee.pixelRatio*ee.height),wt=Math.floor(ee.viewLineCount/ht);return{typicalViewportLineCount:Y,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:wt}}static c(ee,Y){const Ze=ee.outerWidth,xe=ee.outerHeight,ht=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:pe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const wt=Y.stableMinimapLayoutInput,Lt=wt&&ee.outerHeight===wt.outerHeight&&ee.lineHeight===wt.lineHeight&&ee.typicalHalfwidthCharacterWidth===wt.typicalHalfwidthCharacterWidth&&ee.pixelRatio===wt.pixelRatio&&ee.scrollBeyondLastLine===wt.scrollBeyondLastLine&&ee.paddingTop===wt.paddingTop&&ee.paddingBottom===wt.paddingBottom&&ee.minimap.enabled===wt.minimap.enabled&&ee.minimap.side===wt.minimap.side&&ee.minimap.size===wt.minimap.size&&ee.minimap.showSlider===wt.minimap.showSlider&&ee.minimap.renderCharacters===wt.minimap.renderCharacters&&ee.minimap.maxColumn===wt.minimap.maxColumn&&ee.minimap.scale===wt.minimap.scale&&ee.verticalScrollbarWidth===wt.verticalScrollbarWidth&&ee.isViewportWrapping===wt.isViewportWrapping,Qt=ee.lineHeight,ei=ee.typicalHalfwidthCharacterWidth,ti=ee.scrollBeyondLastLine,oi=ee.minimap.renderCharacters;let At=ht>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Ye=ee.minimap.maxColumn,Ct=ee.minimap.size,hi=ee.minimap.side,pt=ee.verticalScrollbarWidth,Dt=ee.viewLineCount,ii=ee.remainingWidth,ni=ee.isViewportWrapping,jt=oi?2:3;let gt=Math.floor(ht*xe);const Ut=gt/ht;let ri=!1,ai=!1,Ke=jt*At,ci=At/ht,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Gt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Bt,desiredRatio:Ht,minimapLineCount:Kt}=ae.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:ti,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:xe,lineHeight:Qt,pixelRatio:ht});if(Dt/Kt>1)ri=!0,ai=!0,At=1,Ke=1,ci=At/ht;else{let bt=!1,kt=At+1;if(Ct==="fit"){const Vt=Math.ceil((li+Dt+Bt)*Ke);ni&&Lt&&ii<=Y.stableFitRemainingWidth?(bt=!0,kt=Y.stableFitMaxMinimapScale):bt=Vt>gt}if(Ct==="fill"||bt){ri=!0;const Vt=At;Ke=Math.min(Qt*ht,Math.max(1,Math.floor(1/Ht))),ni&&Lt&&ii<=Y.stableFitRemainingWidth&&(kt=Y.stableFitMaxMinimapScale),At=Math.min(kt,Math.max(1,Math.floor(Ke/jt))),At>Vt&&(di=Math.min(2,At/Vt)),ci=At/ht/di,gt=Math.ceil(Math.max(Gt,li+Dt+Bt)*Ke),ni?(Y.stableMinimapLayoutInput=ee,Y.stableFitRemainingWidth=ii,Y.stableFitMaxMinimapScale=At):(Y.stableMinimapLayoutInput=null,Y.stableFitRemainingWidth=0)}}}const fi=Math.floor(Ye*ci),vt=Math.min(fi,Math.max(0,Math.floor((ii-pt-2)*ci/(ei+ci)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(ht*vt);const Nt=Ft/ht;Ft=Math.floor(Ft*di);const Wt=oi?pe.Text:pe.Blocks,si=hi==="left"?0:Ze-vt-pt;return{renderMinimap:Wt,minimapLeft:si,minimapWidth:vt,minimapHeightIsEditorHeight:ri,minimapIsSampling:ai,minimapScale:At,minimapLineHeight:Ke,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:gt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Ut}}static computeLayout(ee,Y){const Ze=Y.outerWidth|0,xe=Y.outerHeight|0,ht=Y.lineHeight|0,wt=Y.lineNumbersDigitCount|0,Lt=Y.typicalHalfwidthCharacterWidth,Qt=Y.maxDigitWidth,ei=Y.pixelRatio,ti=Y.viewLineCount,oi=ee.get(je.wordWrapOverride2),At=oi==="inherit"?ee.get(je.wordWrapOverride1):oi,Ye=At==="inherit"?ee.get(je.wordWrap):At,Ct=ee.get(je.wordWrapColumn),hi=Y.isDominatedByLongLines,pt=ee.get(je.glyphMargin),Dt=ee.get(je.lineNumbers).renderType!==Ue.Off,ii=ee.get(je.lineNumbersMinChars),ni=ee.get(je.scrollBeyondLastLine),jt=ee.get(je.padding),gt=ee.get(je.minimap),Ut=ee.get(je.scrollbar),ri=Ut.verticalScrollbarSize,ai=Ut.verticalHasArrows,Ke=Ut.arrowSize,ci=Ut.horizontalScrollbarSize,di=ee.get(je.folding),fi=ee.get(je.showFoldingControls)!=="never";let vt=ee.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let Ft=0;if(Dt){const mi=Math.max(wt,ii);Ft=Math.round(mi*Qt)}let Nt=0;pt&&(Nt=ht*Y.glyphMarginDecorationLaneCount);let Wt=0,si=Wt+Nt,Gt=si+Ft,li=Gt+vt;const Bt=Ze-Nt-Ft-vt;let Ht=!1,Kt=!1,Mt=-1;At==="inherit"&&hi?(Ht=!0,Kt=!0):Ye==="on"||Ye==="bounded"?Kt=!0:Ye==="wordWrapColumn"&&(Mt=Ct);const bt=ae.c({outerWidth:Ze,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Lt,pixelRatio:ei,scrollBeyondLastLine:ni,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:gt,verticalScrollbarWidth:ri,viewLineCount:ti,remainingWidth:Bt,isViewportWrapping:Kt},Y.memory||new S);bt.renderMinimap!==pe.None&&bt.minimapLeft===0&&(Wt+=bt.minimapWidth,si+=bt.minimapWidth,Gt+=bt.minimapWidth,li+=bt.minimapWidth);const kt=Bt-bt.minimapWidth,Vt=Math.max(1,Math.floor((kt-ri-2)/Lt)),It=ai?Ke:0;return Kt&&(Mt=Math.max(1,Vt),Ye==="bounded"&&(Mt=Math.min(Mt,Ct))),{width:Ze,height:xe,glyphMarginLeft:Wt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount,lineNumbersLeft:si,lineNumbersWidth:Ft,decorationsLeft:Gt,decorationsWidth:vt,contentLeft:li,contentWidth:kt,minimap:bt,viewportColumn:Vt,isWordWrapMinified:Ht,isViewportWrapping:Kt,wrappingColumn:Mt,verticalScrollbarWidth:ri,horizontalScrollbarHeight:ci,overviewRuler:{top:It,width:ri,height:xe-2*It,right:0}}}}e.EditorLayoutInfoComputer=ae;class Se extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(344,null),o.localize(345,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(346,null)}})}validate(ee){return h(ee,"simple",["simple","advanced"])}compute(ee,Y,Ze){return Y.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?"advanced":Ze}}var Oe;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(Oe||(e.ShowLightbulbIconMode=Oe={}));class X extends d{constructor(){const ee={enabled:Oe.On};super(je.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Oe.Off,Oe.OnCode,Oe.On],default:ee.enabled,enumDescriptions:[o.localize(347,null),o.localize(348,null),o.localize(349,null)],description:o.localize(350,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:h(ee.enabled,this.defaultValue.enabled,[Oe.Off,Oe.OnCode,Oe.On])}}}class B extends d{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(351,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(352,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(353,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(354,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Y.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Y.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Y.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends d{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(355,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(356,null),o.localize(357,null,I.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(358,null,I.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(359,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(360,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(361,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(362,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return typeof Y.enabled=="boolean"&&(Y.enabled=Y.enabled?"on":"off"),{enabled:h(Y.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Y.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),padding:i(Y.padding,this.defaultValue.padding)}}}class ye extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):g.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Y,Ze){return Ze<0?g.clampedInt(-Ze*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ze}}class de extends p{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>p.clamp(ee,0,150),{markdownDescription:o.localize(363,null)})}compute(ee,Y,Ze){return ee.fontInfo.lineHeight}}class we extends d{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(364,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(365,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(366,null),o.localize(367,null),o.localize(368,null)],default:ee.size,description:o.localize(369,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(370,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(371,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(372,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(373,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(374,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(375,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(376,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(377,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(378,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),autohide:i(Y.autohide,this.defaultValue.autohide),size:h(Y.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Y.side,this.defaultValue.side,["right","left"]),showSlider:h(Y.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Y.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Y.scale,1,1,3),maxColumn:g.clampedInt(Y.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Y.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Y.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:p.clamp(Y.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:p.clamp(Y.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ne){return ne==="ctrlCmd"?I.$k?"metaKey":"ctrlKey":"altKey"}class Z extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(379,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(380,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{top:g.clampedInt(Y.top,0,0,1e3),bottom:g.clampedInt(Y.bottom,0,0,1e3)}}}class x extends d{constructor(){const ee={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(381,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(382,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),cycle:i(Y.cycle,this.defaultValue.cycle)}}}class be extends c{constructor(){super(je.pixelRatio)}compute(ee,Y,Ze){return ee.pixelRatio}}class $e extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ae extends d{constructor(){const ee={other:"on",comments:"off",strings:"off"},Y=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(383,null),o.localize(384,null),o.localize(385,null)]}];super(je.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Y,default:ee.strings,description:o.localize(386,null)},comments:{anyOf:Y,default:ee.comments,description:o.localize(387,null)},other:{anyOf:Y,default:ee.other,description:o.localize(388,null)}},default:ee,markdownDescription:o.localize(389,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const ei=ee?"on":"off";return{comments:ei,strings:ei,other:ei}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Y,comments:Ze,strings:xe}=ee,ht=["on","inline","off"];let wt,Lt,Qt;return typeof Y=="boolean"?wt=Y?"on":"off":wt=h(Y,this.defaultValue.other,ht),typeof Ze=="boolean"?Lt=Ze?"on":"off":Lt=h(Ze,this.defaultValue.comments,ht),typeof xe=="boolean"?Qt=xe?"on":"off":Qt=h(xe,this.defaultValue.strings,ht),{other:wt,comments:Lt,strings:Qt}}}var Ue;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(390,null),o.localize(391,null),o.localize(392,null),o.localize(393,null)],default:"on",description:o.localize(394,null)})}validate(ee){let Y=this.defaultValue.renderType,Ze=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Y=Ue.Custom,Ze=ee):ee==="interval"?Y=Ue.Interval:ee==="relative"?Y=Ue.Relative:ee==="on"?Y=Ue.On:Y=Ue.Off),{renderType:Y,renderFn:Ze}}}function Pe(ne){const ee=ne.get(je.renderValidationDecorations);return ee==="editable"?ne.get(je.readOnly):ee!=="on"}class Te extends d{constructor(){const ee=[],Y={type:"number",description:o.localize(395,null)};super(je.rulers,"rulers",ee,{type:"array",items:{anyOf:[Y,{type:["object"],properties:{column:Y,color:{type:"string",description:o.localize(396,null),format:"color-hex"}}}]},default:ee,description:o.localize(397,null)})}validate(ee){if(Array.isArray(ee)){const Y=[];for(const Ze of ee)if(typeof Ze=="number")Y.push({column:g.clampedInt(Ze,0,0,1e4),color:null});else if(Ze&&typeof Ze=="object"){const xe=Ze;Y.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Y.sort((Ze,xe)=>Ze.column-xe.column),Y}return this.defaultValue}}class z extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function j(ne,ee){if(typeof ne!="string")return ee;switch(ne){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class Q extends d{constructor(){const ee={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(398,null),o.localize(399,null),o.localize(400,null)],default:"auto",description:o.localize(401,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(402,null),o.localize(403,null),o.localize(404,null)],default:"auto",description:o.localize(405,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(406,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(407,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(408,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(409,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee,Ze=g.clampedInt(Y.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Y.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Y.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Y.vertical,this.defaultValue.vertical),horizontal:j(Y.horizontal,this.defaultValue.horizontal),useShadows:i(Y.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Y.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Y.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Y.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Y.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ze,horizontalSliderSize:g.clampedInt(Y.horizontalSliderSize,Ze,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Y.verticalSliderSize,xe,0,1e3),scrollByPage:i(Y.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Y.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(410,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(411,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(412,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(413,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(414,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(415,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(416,null)}})}applyUpdate(ee,Y){let Ze=!1;Y.allowedCharacters&&ee&&(P.$jo(ee.allowedCharacters,Y.allowedCharacters)||(ee={...ee,allowedCharacters:Y.allowedCharacters},Ze=!0)),Y.allowedLocales&&ee&&(P.$jo(ee.allowedLocales,Y.allowedLocales)||(ee={...ee,allowedLocales:Y.allowedLocales},Ze=!0));const xe=super.applyUpdate(ee,Y);return Ze?new r(xe.newValue,!0):xe}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{nonBasicASCII:He(Y.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Y.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Y.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:He(Y.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:He(Y.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ee.allowedLocales,this.defaultValue.allowedLocales)}}c(ee,Y){if(typeof ee!="object"||!ee)return Y;const Ze={};for(const[xe,ht]of Object.entries(ee))ht===!0&&(Ze[xe]=!0);return Ze}}class re extends d{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(417,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(418,null),o.localize(419,null),o.localize(420,null)],description:o.localize(421,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(422,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(423,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),mode:h(Y.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Y.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily)}}}class ge extends d{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(424,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(425,null),o.localize(426,null),o.localize(427,null)],description:o.localize(428,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(429,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showToolbar:h(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ce extends d{constructor(){const ee={enabled:O.$ot.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$ot.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(430,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(431,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Y.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(432,null),o.localize(433,null),o.localize(434,null)],default:ee.bracketPairs,description:o.localize(435,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(436,null),o.localize(437,null),o.localize(438,null)],default:ee.bracketPairsHorizontal,description:o.localize(439,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(440,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(441,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(442,null),o.localize(443,null),o.localize(444,null)],default:ee.highlightActiveIndentation,description:o.localize(445,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{bracketPairs:He(Y.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:He(Y.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Y.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Y.indentation,this.defaultValue.indentation),highlightActiveIndentation:He(Y.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function He(ne,ee,Y){const Ze=Y.indexOf(ne);return Ze===-1?ee:Y[Ze]}class _e extends d{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(446,null),o.localize(447,null)],default:ee.insertMode,description:o.localize(448,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(449,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(450,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(451,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(452,null),o.localize(453,null),o.localize(454,null),o.localize(455,null)],default:ee.selectionMode,markdownDescription:o.localize(456,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(457,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(458,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(459,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(460,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(461,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(462,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(463,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(464,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(465,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(466,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(467,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(468,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(469,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(470,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(471,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(472,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(473,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(474,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(475,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(476,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(477,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(478,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(479,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(480,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(481,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(482,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(483,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(484,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(485,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(486,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(487,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(488,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(489,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(490,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(491,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(492,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(493,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertMode:h(Y.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Y.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Y.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Y.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Y.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Y.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Y.showIcons,this.defaultValue.showIcons),showStatusBar:i(Y.showStatusBar,this.defaultValue.showStatusBar),preview:i(Y.preview,this.defaultValue.preview),previewMode:h(Y.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Y.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Y.showMethods,this.defaultValue.showMethods),showFunctions:i(Y.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Y.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Y.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Y.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Y.showFields,this.defaultValue.showFields),showVariables:i(Y.showVariables,this.defaultValue.showVariables),showClasses:i(Y.showClasses,this.defaultValue.showClasses),showStructs:i(Y.showStructs,this.defaultValue.showStructs),showInterfaces:i(Y.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Y.showModules,this.defaultValue.showModules),showProperties:i(Y.showProperties,this.defaultValue.showProperties),showEvents:i(Y.showEvents,this.defaultValue.showEvents),showOperators:i(Y.showOperators,this.defaultValue.showOperators),showUnits:i(Y.showUnits,this.defaultValue.showUnits),showValues:i(Y.showValues,this.defaultValue.showValues),showConstants:i(Y.showConstants,this.defaultValue.showConstants),showEnums:i(Y.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Y.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Y.showKeywords,this.defaultValue.showKeywords),showWords:i(Y.showWords,this.defaultValue.showWords),showColors:i(Y.showColors,this.defaultValue.showColors),showFiles:i(Y.showFiles,this.defaultValue.showFiles),showReferences:i(Y.showReferences,this.defaultValue.showReferences),showFolders:i(Y.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Y.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Y.showSnippets,this.defaultValue.showSnippets),showUsers:i(Y.showUsers,this.defaultValue.showUsers),showIssues:i(Y.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(494,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(495,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const ee=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(496,null),type:"string"},{description:o.localize(497,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Y=[];for(const Ze of ee)if(typeof Ze=="string")try{Intl.Segmenter.supportedLocalesOf(Ze).length>0&&Y.push(Ze)}catch{}return Y}return this.defaultValue}}var et;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(498,null),o.localize(499,null),o.localize(500,null),o.localize(501,null)],description:o.localize(502,null),default:"same"}})}validate(ee){switch(ee){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(ee,Y,Ze){return Y.get(je.accessibilitySupport)===k.AccessibilitySupport.Enabled?et.None:Ze}}class ft extends c{constructor(){super(je.wrappingInfo)}compute(ee,Y,Ze){const xe=Y.get(je.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(503,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(504,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(505,null),o.localize(506,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showDropSelector:h(Y.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(507,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(508,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(509,null),o.localize(510,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showPasteSelector:h(Y.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$k?mt:I.$l?$t:ct,fontWeight:"normal",fontSize:I.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var je;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.placeholder=88]="placeholder",ne[ne.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=90]="quickSuggestions",ne[ne.quickSuggestionsDelay=91]="quickSuggestionsDelay",ne[ne.readOnly=92]="readOnly",ne[ne.readOnlyMessage=93]="readOnlyMessage",ne[ne.renameOnType=94]="renameOnType",ne[ne.renderControlCharacters=95]="renderControlCharacters",ne[ne.renderFinalNewline=96]="renderFinalNewline",ne[ne.renderLineHighlight=97]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=99]="renderValidationDecorations",ne[ne.renderWhitespace=100]="renderWhitespace",ne[ne.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ne[ne.roundedSelection=102]="roundedSelection",ne[ne.rulers=103]="rulers",ne[ne.scrollbar=104]="scrollbar",ne[ne.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=106]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=107]="scrollPredominantAxis",ne[ne.selectionClipboard=108]="selectionClipboard",ne[ne.selectionHighlight=109]="selectionHighlight",ne[ne.selectOnLineNumbers=110]="selectOnLineNumbers",ne[ne.showFoldingControls=111]="showFoldingControls",ne[ne.showUnused=112]="showUnused",ne[ne.snippetSuggestions=113]="snippetSuggestions",ne[ne.smartSelect=114]="smartSelect",ne[ne.smoothScrolling=115]="smoothScrolling",ne[ne.stickyScroll=116]="stickyScroll",ne[ne.stickyTabStops=117]="stickyTabStops",ne[ne.stopRenderingLineAfter=118]="stopRenderingLineAfter",ne[ne.suggest=119]="suggest",ne[ne.suggestFontSize=120]="suggestFontSize",ne[ne.suggestLineHeight=121]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ne[ne.suggestSelection=123]="suggestSelection",ne[ne.tabCompletion=124]="tabCompletion",ne[ne.tabIndex=125]="tabIndex",ne[ne.unicodeHighlighting=126]="unicodeHighlighting",ne[ne.unusualLineTerminators=127]="unusualLineTerminators",ne[ne.useShadowDOM=128]="useShadowDOM",ne[ne.useTabStops=129]="useTabStops",ne[ne.wordBreak=130]="wordBreak",ne[ne.wordSegmenterLocales=131]="wordSegmenterLocales",ne[ne.wordSeparators=132]="wordSeparators",ne[ne.wordWrap=133]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=136]="wordWrapColumn",ne[ne.wordWrapOverride1=137]="wordWrapOverride1",ne[ne.wordWrapOverride2=138]="wordWrapOverride2",ne[ne.wrappingIndent=139]="wrappingIndent",ne[ne.wrappingStrategy=140]="wrappingStrategy",ne[ne.showDeprecated=141]="showDeprecated",ne[ne.inlayHints=142]="inlayHints",ne[ne.editorClassName=143]="editorClassName",ne[ne.pixelRatio=144]="pixelRatio",ne[ne.tabFocusMode=145]="tabFocusMode",ne[ne.layoutInfo=146]="layoutInfo",ne[ne.wrappingInfo=147]="wrappingInfo",ne[ne.defaultColorDecorators=148]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new n(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(511,null)})),acceptSuggestionOnEnter:qe(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(512,null),""],markdownDescription:o.localize(513,null)})),accessibilitySupport:qe(new C),accessibilityPageSize:qe(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(514,null),tags:["accessibility"]})),ariaLabel:qe(new m(je.ariaLabel,"ariaLabel",o.localize(515,null))),ariaRequired:qe(new n(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new n(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(516,null),tags:["accessibility"]})),autoClosingBrackets:qe(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(517,null),o.localize(518,null),""],description:o.localize(519,null)})),autoClosingComments:qe(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(520,null),o.localize(521,null),""],description:o.localize(522,null)})),autoClosingDelete:qe(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(523,null),""],description:o.localize(524,null)})),autoClosingOvertype:qe(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(525,null),""],description:o.localize(526,null)})),autoClosingQuotes:qe(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(527,null),o.localize(528,null),""],description:o.localize(529,null)})),autoIndent:qe(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[o.localize(530,null),o.localize(531,null),o.localize(532,null),o.localize(533,null),o.localize(534,null)],description:o.localize(535,null)})),automaticLayout:qe(new n(je.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(536,null),o.localize(537,null),o.localize(538,null),""],description:o.localize(539,null)})),bracketPairColorization:qe(new Ce),bracketPairGuides:qe(new ze),stickyTabStops:qe(new n(je.stickyTabStops,"stickyTabStops",!1,{description:o.localize(540,null)})),codeLens:qe(new n(je.codeLens,"codeLens",!0,{description:o.localize(541,null)})),codeLensFontFamily:qe(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(542,null)})),codeLensFontSize:qe(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(543,null)})),colorDecorators:qe(new n(je.colorDecorators,"colorDecorators",!0,{description:o.localize(544,null)})),colorDecoratorActivatedOn:qe(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(545,null),o.localize(546,null),o.localize(547,null)],description:o.localize(548,null)})),colorDecoratorsLimit:qe(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(549,null)})),columnSelection:qe(new n(je.columnSelection,"columnSelection",!1,{description:o.localize(550,null)})),comments:qe(new R),contextmenu:qe(new n(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new n(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(551,null)})),cursorBlinking:qe(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:o.localize(552,null)})),cursorSmoothCaretAnimation:qe(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(553,null),o.localize(554,null),o.localize(555,null)],description:o.localize(556,null)})),cursorStyle:qe(new D(je.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:o.localize(557,null)})),cursorSurroundingLines:qe(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(558,null)})),cursorSurroundingLinesStyle:qe(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(559,null),o.localize(560,null)],markdownDescription:o.localize(561,null)})),cursorWidth:qe(new g(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(562,null)})),disableLayerHinting:qe(new n(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new n(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new n(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new n(je.dragAndDrop,"dragAndDrop",!0,{description:o.localize(563,null)})),emptySelectionClipboard:qe(new G),dropIntoEditor:qe(new lt),stickyScroll:qe(new B),experimentalWhitespaceRendering:qe(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(564,null),o.localize(565,null),o.localize(566,null)],description:o.localize(567,null)})),extraEditorClassName:qe(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new p(je.fastScrollSensitivity,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:o.localize(568,null)})),find:qe(new q),fixedOverflowWidgets:qe(new n(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new n(je.folding,"folding",!0,{description:o.localize(569,null)})),foldingStrategy:qe(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(570,null),o.localize(571,null)],description:o.localize(572,null)})),foldingHighlight:qe(new n(je.foldingHighlight,"foldingHighlight",!0,{description:o.localize(573,null)})),foldingImportsByDefault:qe(new n(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(574,null)})),foldingMaximumRegions:qe(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(575,null)})),unfoldOnClickAfterEndOfLine:qe(new n(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(576,null)})),fontFamily:qe(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(577,null)})),fontInfo:qe(new oe),fontLigatures2:qe(new J),fontSize:qe(new me),fontWeight:qe(new le),fontVariations:qe(new K),formatOnPaste:qe(new n(je.formatOnPaste,"formatOnPaste",!1,{description:o.localize(578,null)})),formatOnType:qe(new n(je.formatOnType,"formatOnType",!1,{description:o.localize(579,null)})),glyphMargin:qe(new n(je.glyphMargin,"glyphMargin",!0,{description:o.localize(580,null)})),gotoLocation:qe(new _),hideCursorInOverviewRuler:qe(new n(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(581,null)})),hover:qe(new ce),inDiffEditor:qe(new n(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new p(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>p.clamp(ne,-5,20),{description:o.localize(582,null)})),lightbulb:qe(new X),lineDecorationsWidth:qe(new ye),lineHeight:qe(new de),lineNumbers:qe(new ke),lineNumbersMinChars:qe(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new n(je.linkedEditing,"linkedEditing",!1,{description:o.localize(583,null)})),links:qe(new n(je.links,"links",!0,{description:o.localize(584,null)})),matchBrackets:qe(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(585,null)})),minimap:qe(new we),mouseStyle:qe(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new p(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:o.localize(586,null)})),mouseWheelZoom:qe(new n(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.$k?o.localize(587,null):o.localize(588,null)})),multiCursorMergeOverlapping:qe(new n(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(589,null)})),multiCursorModifier:qe(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[o.localize(590,null),o.localize(591,null)],markdownDescription:o.localize(592,null)})),multiCursorPaste:qe(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(593,null),o.localize(594,null)],markdownDescription:o.localize(595,null)})),multiCursorLimit:qe(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(596,null)})),occurrencesHighlight:qe(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(597,null),o.localize(598,null),o.localize(599,null)],markdownDescription:o.localize(600,null)})),overviewRulerBorder:qe(new n(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(601,null)})),overviewRulerLanes:qe(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new Z),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(602,null),o.localize(603,null)],description:o.localize(604,null)})),placeholder:qe(new $e),definitionLinkOpensInPeek:qe(new n(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(605,null)})),quickSuggestions:qe(new Ae),quickSuggestionsDelay:qe(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(606,null)})),readOnly:qe(new n(je.readOnly,"readOnly",!1)),readOnlyMessage:qe(new z),renameOnType:qe(new n(je.renameOnType,"renameOnType",!1,{description:o.localize(607,null),markdownDeprecationMessage:o.localize(608,null)})),renderControlCharacters:qe(new n(je.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(609,null),restricted:!0})),renderFinalNewline:qe(new E(je.renderFinalNewline,"renderFinalNewline",I.$l?"dimmed":"on",["off","on","dimmed"],{description:o.localize(610,null)})),renderLineHighlight:qe(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(611,null)],description:o.localize(612,null)})),renderLineHighlightOnlyWhenFocus:qe(new n(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(613,null)})),renderValidationDecorations:qe(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(614,null),o.localize(615,null),o.localize(616,null),""],description:o.localize(617,null)})),revealHorizontalRightPadding:qe(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new n(je.roundedSelection,"roundedSelection",!0,{description:o.localize(618,null)})),rulers:qe(new Te),scrollbar:qe(new Q),scrollBeyondLastColumn:qe(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(619,null)})),scrollBeyondLastLine:qe(new n(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(620,null)})),scrollPredominantAxis:qe(new n(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(621,null)})),selectionClipboard:qe(new n(je.selectionClipboard,"selectionClipboard",!0,{description:o.localize(622,null),included:I.$l})),selectionHighlight:qe(new n(je.selectionHighlight,"selectionHighlight",!0,{description:o.localize(623,null)})),selectOnLineNumbers:qe(new n(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(624,null),o.localize(625,null),o.localize(626,null)],description:o.localize(627,null)})),showUnused:qe(new n(je.showUnused,"showUnused",!0,{description:o.localize(628,null)})),showDeprecated:qe(new n(je.showDeprecated,"showDeprecated",!0,{description:o.localize(629,null)})),inlayHints:qe(new te),snippetSuggestions:qe(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(630,null),o.localize(631,null),o.localize(632,null),o.localize(633,null)],description:o.localize(634,null)})),smartSelect:qe(new tt),smoothScrolling:qe(new n(je.smoothScrolling,"smoothScrolling",!1,{description:o.localize(635,null)})),stopRenderingLineAfter:qe(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new _e),inlineSuggest:qe(new re),inlineEdit:qe(new ge),inlineCompletionsAccessibilityVerbose:qe(new n(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(636,null)})),suggestFontSize:qe(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(637,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(638,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new n(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(639,null)})),suggestSelection:qe(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(640,null),o.localize(641,null),o.localize(642,null)],description:o.localize(643,null)})),tabCompletion:qe(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(644,null),o.localize(645,null),o.localize(646,null)],description:o.localize(647,null)})),tabIndex:qe(new g(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new V),unusualLineTerminators:qe(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(648,null),o.localize(649,null),o.localize(650,null)],description:o.localize(651,null)})),useShadowDOM:qe(new n(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new n(je.useTabStops,"useTabStops",!0,{description:o.localize(652,null)})),wordBreak:qe(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(653,null),o.localize(654,null)],description:o.localize(655,null)})),wordSegmenterLocales:qe(new nt),wordSeparators:qe(new m(je.wordSeparators,"wordSeparators",$.$pt,{description:o.localize(656,null)})),wordWrap:qe(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(657,null),o.localize(658,null),o.localize(659,null),o.localize(660,null)],description:o.localize(661,null)})),wordWrapBreakAfterCharacters:qe(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new g(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(662,null)})),wordWrapOverride1:qe(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new W),defaultColorDecorators:qe(new n(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(663,null)})),pixelRatio:qe(new be),tabFocusMode:qe(new n(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(664,null)})),layoutInfo:qe(new ae),wrappingInfo:qe(new ft),wrappingIndent:qe(new rt),wrappingStrategy:qe(new Se)}}),define(Ne[106],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,v.$Gi)("environmentService"),e.$Oi=(0,v.$Hi)(e.$Ni)}),define(Ne[29],Me([1,0,58,19,12,14,2,9,3,20,15,48]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Gl=e.FileKind=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.FileOperationResult=e.$yl=e.$xl=e.$wl=e.$ul=e.FileChangeType=e.$tl=e.FileOperation=e.$nl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$bl=void 0,e.$cl=a,e.$dl=s,e.$el=l,e.$fl=i,e.$gl=n,e.$hl=t,e.$il=g,e.$jl=u,e.$kl=p,e.$ll=m,e.$ml=h,e.$ol=w,e.$pl=C,e.$ql=R,e.$rl=f,e.$sl=b,e.$vl=G,e.$Hl=le,e.$Il=_,e.$Kl=pe,e.$bl=(0,$.$Gi)("fileService");function a(ae){return ae.create===!0}var S;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(ae){const Se=ae;return!!Se&&typeof Se.onDidChange=="function"}var c;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function l(ae){return!!(ae.capabilities&c.FileReadWrite)}function i(ae){return!!(ae.capabilities&c.FileFolderCopy)}function n(ae){return!!(ae.capabilities&c.FileClone)}function t(ae){return!!(ae.capabilities&c.FileOpenReadWriteClose)}function g(ae){return!!(ae.capabilities&c.FileReadStream)}function u(ae){return l(ae)?!!(ae.capabilities&c.FileAtomicRead):!1}function p(ae){return l(ae)?!!(ae.capabilities&c.FileAtomicWrite):!1}function m(ae){return!!(ae.capabilities&c.FileAtomicDelete)}function h(ae){return!!(ae.capabilities&c.Readonly)}var E;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(Se,Oe){const X=new D(Se.toString(),Oe);return R(X,Oe),X}constructor(Se,Oe){super(Se),this.code=Oe}}e.$nl=D;function w(ae,Se){return D.create(ae,Se)}function C(ae){return ae||w((0,O.localize)(1856,null),E.Unknown)}function R(ae,Se){return ae.name=Se?`${Se} (FileSystemError)`:"FileSystemError",ae}function f(ae){if(!ae)return E.Unknown;if(ae instanceof D)return ae.code;const Se=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Se)return E.Unknown;switch(Se[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function b(ae){if(ae instanceof q)return ae.fileOperationResult;switch(f(ae)){case E.FileNotFound:return oe.FILE_NOT_FOUND;case E.FileIsADirectory:return oe.FILE_IS_DIRECTORY;case E.FileNotADirectory:return oe.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return oe.FILE_WRITE_LOCKED;case E.NoPermissions:return oe.FILE_PERMISSION_DENIED;case E.FileExists:return oe.FILE_MOVE_CONFLICT;case E.FileTooLarge:return oe.FILE_TOO_LARGE;default:return oe.FILE_OTHER_ERROR}}var L;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(Se,Oe,X){this.resource=Se,this.operation=Oe,this.target=X}isOperation(Se){return this.operation===Se}}e.$tl=N;var M;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class W{static{this.a=null}constructor(Se,Oe){this.c=Oe,this.b=void 0,this.d=new y.$U(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawAdded.map(B=>[B,!0])),X}),this.f=new y.$U(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(B=>[B,!0])),X}),this.g=new y.$U(()=>{const X=v.$Mi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(B=>[B,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Se){switch(X.type){case M.ADDED:this.rawAdded.push(X.resource);break;case M.UPDATED:this.rawUpdated.push(X.resource);break;case M.DELETED:this.rawDeleted.push(X.resource);break}this.b!==W.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Se,...Oe){return this.h(Se,{includeChildren:!1},...Oe)}affects(Se,...Oe){return this.h(Se,{includeChildren:!0},...Oe)}h(Se,Oe,...X){if(!Se)return!1;const B=X.length>0;return!!((!B||X.includes(M.ADDED))&&(this.d.value.get(Se)||Oe.includeChildren&&this.d.value.findSuperstr(Se))||(!B||X.includes(M.UPDATED))&&(this.f.value.get(Se)||Oe.includeChildren&&this.f.value.findSuperstr(Se))||(!B||X.includes(M.DELETED))&&(this.g.value.findSubstr(Se)||Oe.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$ul=W;function G(ae,Se,Oe){return!ae||!Se||ae===Se||Se.length>ae.length?!1:(Se.charAt(Se.length-1)!==P.sep&&(Se+=P.sep),Oe?(0,I.$Hf)(ae,Se):ae.indexOf(Se)===0)}class q extends Error{constructor(Se,Oe,X){super(Se),this.fileOperationResult=Oe,this.options=X}}e.$wl=q;class J extends q{constructor(Se,Oe,X,B){super(Se,Oe,B),this.fileOperationResult=Oe,this.size=X}}e.$xl=J;class K extends q{constructor(Se,Oe,X){super(Se,oe.FILE_NOT_MODIFIED_SINCE,X),this.stat=Oe}}e.$yl=K;var oe;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(oe||(e.FileOperationResult=oe={})),e.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bl="files.associations",e.$Cl="files.exclude",e.$Dl="files.readonlyInclude",e.$El="files.readonlyExclude",e.$Fl="files.readonlyFromPermissions";var me;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Gl="";function le(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function _(ae,Se){if(!Se.hasProvider(A.URI.from({scheme:ae.scheme})))return new Promise(Oe=>{const X=Se.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ae.scheme&&B.added&&(X.dispose(),Oe())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Se){return(0,T.$jg)(Se)||(Se=0),Se<ce.KB?(0,O.localize)(1857,null,Se.toFixed(0)):Se<ce.MB?(0,O.localize)(1858,null,(Se/ce.KB).toFixed(2)):Se<ce.GB?(0,O.localize)(1859,null,(Se/ce.MB).toFixed(2)):Se<ce.TB?(0,O.localize)(1860,null,(Se/ce.GB).toFixed(2)):(0,O.localize)(1861,null,(Se/ce.TB).toFixed(2))}}e.$Jl=ce;function pe(ae){const Se=typeof ae=="string"||ae?.scheme===k.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===k.Schemas.file?1024*ce.MB:Se?10*ce.MB:o.$p?50*ce.MB:1024*ce.MB}}),define(Ne[74],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class v{constructor(...I){this.a=new Map;for(const[T,A]of I)this.set(T,A)}set(I,T){const A=this.a.get(I);return this.a.set(I,T),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Ei=v}),define(Ne[171],Me([1,0,10,13,4,73,168,3,74,172]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;const k=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class a{constructor(s=new $.$Ei,c=!1,l,i=k){this.i=s,this.j=c,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Fi,this),this._globalGraph=i?l?._globalGraph??new A.$yr(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Qc)(this.h),this.h.clear();for(const s of this.g)(0,I.$Pc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,c){this.m();const l=this,i=new class extends a{dispose(){l.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(s,...c){this.m();const l=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,P.$8)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,l.stop()}}createInstance(s,...c){this.m();let l,i;return s instanceof T.$Di?(l=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(c),l)):(l=d.traceCreation(this.l,s),i=this.o(s,c,l)),l.stop(),i}o(s,c=[],l){const i=O._util.getServiceDependencies(s).sort((g,u)=>g.index-u.index),n=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${g.id}.`,!1),n.push(u)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(s,c.concat(n))}q(s,c){if(this.i.get(s)instanceof T.$Di)this.i.set(s,c);else if(this.k)this.k.q(s,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const c=this.i.get(s);return!c&&this.k?this.k.r(s):c}s(s,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const l=this.r(s);return l instanceof T.$Di?this.u(s,l,c.branch(s,!0)):(c.branch(s,!1),l)}u(s,c,l){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,c,l)}finally{this.t.delete(s)}}v(s,c,l){const i=new A.$yr(u=>u.id.toString());let n=0;const t=[{id:s,desc:c,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),n++>1e3)throw new y(i);for(const p of O._util.getServiceDependencies(u.desc.ctor)){const m=this.r(p.id);if(m||this.y(`[createInstance] ${s} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(p.id)),m instanceof T.$Di){const h={id:p.id,desc:m,_trace:u._trace.branch(p.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:p}of u){if(this.r(p.id)instanceof T.$Di){const h=this.w(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.q(p.id,h)}i.removeNode(p)}}return this.r(s)}w(s,c,l=[],i,n){if(this.i.get(s)instanceof T.$Di)return this.x(s,c,l,i,n,this.g);if(this.k)return this.k.w(s,c,l,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(s,c,l=[],i,n,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(s);const u=new Map,p=new v.$Zh(()=>{const m=g.o(c,l,n);for(const[h,E]of u){const D=m[h];if(typeof D=="function")for(const w of E)w.disposable=D.apply(m,w.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,h){if(!p.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=u.get(h);return w||(w=new o.$6c,u.set(h,w)),(R,f,b)=>{if(p.isInitialized)return p.value[h](R,f,b);{const L={listener:[R,f,b],disposable:void 0},N=w.push(L);return(0,I.$Tc)(()=>{N(),L.disposable?.dispose()})}}}if(h in m)return m[h];const E=p.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),m[h]=D),D},set(m,h,E){return p.value[h]=E,!0},getPrototypeOf(m){return c.prototype}})}else{const g=this.o(c,l,n);return t.add(g),g}}y(s,c){if(c&&console.warn(s),this.j)throw new Error(s)}}e.$zr=a;var S;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,c){return s?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,c){return s?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(s,c){this.type=s,this.name=c,this.g=Date.now(),this.h=[]}branch(s,c){const l=new d(S.Branch,s.toString());return this.h.push([s,c,l]),l}stop(){const s=Date.now()-this.g;d.f+=s;let c=!1;function l(n,t){const g=[],u=new Array(n+1).join("	");for(const[p,m,h]of t.h)if(m&&h){c=!0,g.push(`${u}CREATES -> ${p}`);const E=l(n+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${p}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||c)&&d.all.add(i.join(`
`))}}e.$Ar=d}),define(Ne[11],Me([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=r,e.log=c,e.$pk=D,e.$qk=w,e.$rk=C,e.$sk=R,v=Ve(v),e.$bk=(0,S.$Gi)("logService"),e.$ck=(0,S.$Gi)("loggerService");function d(){return new Date().toISOString()}function r(f){return(0,k.$jg)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$ek=s.Info;function c(f,b,L){switch(b){case s.Trace:f.trace(L);break;case s.Debug:f.debug(L);break;case s.Info:f.info(L);break;case s.Warning:f.warn(L);break;case s.Error:f.error(L);break;case s.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(f,b=!1){let L="";for(let N=0;N<f.length;N++){let M=f[N];if(M instanceof Error&&(M=(0,P.$rj)(M,b)),typeof M=="object")try{M=JSON.stringify(M)}catch{}L+=(N>0?" ":"")+M}return L}class i extends A.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new I.$me),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==s.Off&&this.b<=b}}e.$gk=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...L){this.f(s.Trace)&&this.g(s.Trace,l([b,...L],!0))}debug(b,...L){this.f(s.Debug)&&this.g(s.Debug,l([b,...L]))}info(b,...L){this.f(s.Info)&&this.g(s.Info,l([b,...L]))}warn(b,...L){this.f(s.Warning)&&this.g(s.Warning,l([b,...L]))}error(b,...L){if(this.f(s.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(s.Error,l(N))}else this.g(s.Error,l([b,...L]))}flush(){}}e.$hk=n;class t extends i{constructor(b=e.$ek){super(),this.setLevel(b),this.g=!$.$j}trace(b,...L){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}debug(b,...L){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}info(b,...L){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}warn(b,...L){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...L):console.warn(`[main ${d()}]`,b,...L))}error(b,...L){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...L):console.error(`[main ${d()}]`,b,...L))}flush(){}}e.$ik=t;class g extends i{constructor(b=e.$ek,L=!0){super(),this.g=L,this.setLevel(b)}trace(b,...L){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...L):console.log(b,...L))}debug(b,...L){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...L):console.log(b,...L))}info(b,...L){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...L):console.log(b,...L))}warn(b,...L){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...L):console.log(b,...L))}error(b,...L){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...L):console.error(b,...L))}flush(){}}e.$jk=g;class u extends i{constructor(b,L=e.$ek){super(),this.g=b,this.setLevel(L)}trace(b,...L){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(b),...L])}debug(b,...L){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(b),...L])}info(b,...L){this.f(s.Info)&&this.g.log(s.Info,[this.h(b),...L])}warn(b,...L){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(b),...L])}error(b,...L){this.f(s.Error)&&this.g.log(s.Error,[this.h(b),...L])}h(b){return typeof b=="string"?b:(0,P.$rj)(b,this.f(s.Trace))}flush(){}}e.$kk=u;class p extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const L of this.g)L.setLevel(b);super.setLevel(b)}trace(b,...L){for(const N of this.g)N.trace(b,...L)}debug(b,...L){for(const N of this.g)N.debug(b,...L)}info(b,...L){for(const N of this.g)N.info(b,...L)}warn(b,...L){for(const N of this.g)N.warn(b,...L)}error(b,...L){for(const N of this.g)N.error(b,...L)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$lk=p;class m extends A.$Vc{constructor(b,L,N){if(super(),this.h=b,this.j=L,this.b=new O.$Bc,this.c=this.B(new I.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$me),this.onDidChangeVisibility=this.g.event,N)for(const M of N)this.b.set(M.resource,{logger:void 0,info:M})}m(b){return(0,k.$fg)(b)?[...this.b.values()].find(L=>L.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,L){const N=this.n(b),M=(0,k.$fg)(b)?b:L?.id??(0,T.$uj)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const G=L?.logLevel==="always"?s.Trace:L?.logLevel;W||(W=this.s(N,G??this.getLogLevel(N)??this.h,{...L,id:M}));const q={logger:W,info:{resource:N,id:M,logLevel:G,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(q.info),this.b.set(N,q),W}n(b){return(0,k.$fg)(b)?(0,o.$hh)(this.j,`${b}.log`):b}setLogLevel(b,L){if(y.URI.isUri(b)){const N=b,M=L,W=this.b.get(N);W&&M!==W.info.logLevel&&(W.info.logLevel=M===this.h?void 0:M,W.logger?.setLevel(M),this.b.set(W.info.resource,W),this.f.fire([N,M]))}else{this.h=b;for(const[N,M]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,L){const N=this.m(b);N&&L!==!N.info.hidden&&(N.info.hidden=!L,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,L]))}getLogLevel(b){let L;return b&&(L=this.b.get(b)?.info.logLevel),L??this.h}registerLogger(b){const L=this.b.get(b.resource);L?L.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const L=this.b.get(b);L&&(L.logger&&L.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=m;class h{constructor(){this.onDidChangeLogLevel=new I.$me().event}setLevel(b){}getLevel(){return s.Info}trace(b,...L){}debug(b,...L){}info(b,...L){}warn(b,...L){}error(b,...L){}critical(b,...L){}dispose(){}flush(){}}e.$nk=h;class E extends h{}e.$ok=E;function D(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const b=R(f.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ek}function w(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function C(f){switch(f){case s.Trace:return{original:"Trace",value:v.localize(1950,null)};case s.Debug:return{original:"Debug",value:v.localize(1951,null)};case s.Info:return{original:"Info",value:v.localize(1952,null)};case s.Warning:return{original:"Warning",value:v.localize(1953,null)};case s.Error:return{original:"Error",value:v.localize(1954,null)};case s.Off:return{original:"Off",value:v.localize(1955,null)}}}function R(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$tk=new a.$Xj("logLevel",w(s.Info))}),define(Ne[173],Me([1,0,4,11]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class I extends v.$Vc{constructor(A,O=[]){super(),this.a=new P.$lk([A,...O]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...O){this.a.trace(A,...O)}debug(A,...O){this.a.debug(A,...O)}info(A,...O){this.a.info(A,...O)}warn(A,...O){this.a.warn(A,...O)}error(A,...O){this.a.error(A,...O)}flush(){this.a.flush()}}e.$OR=I});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[107],Me([1,0,35,9,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=_t(v);var T;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function o(d,r){return r-d}$.compare=o;const k=Object.create(null);k[$.Error]=(0,P.localize)(1956,null),k[$.Warning]=(0,P.localize)(1957,null),k[$.Info]=(0,P.localize)(1958,null);function y(d){return k[d]||""}$.toString=y;function a(d){switch(d){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=a;function S(d){switch(d){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=S}(A||(e.MarkerSeverity=A={}));var O;(function($){const o="";function k(a){return y(a,!0)}$.makeKey=k;function y(a,S){const d=[o];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(o),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(o),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(o),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(o),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(o),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(o),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(o),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(o),d.push(o),d.join("\xA6")}$.makeKeyOptionalMessage=y})(O||(e.IMarkerData=O={})),e.$Ju=(0,I.$Gi)("markerService")});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[174],Me([1,0,6,35,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$xw=e.Severity=void 0,e.$yw=O,P=_t(P),e.Severity=P.default,e.$xw=(0,I.$Gi)("notificationService");var T;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function O(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class o{constructor(){this.progress=new k,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$zw=o;class k{infinite(){}done(){}total(a){}worked(a){}}e.$Aw=k}),define(Ne[108],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,v.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ve,e,v,P){var I=arguments.length,T=I<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,v):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ve,e,v,P);else for(var O=ve.length-1;O>=0;O--)(A=ve[O])&&(T=(I<3?A(T):I>3?A(e,v,T):A(e,v))||T);return I>3&&T&&Object.defineProperty(e,v,T),T},We=this&&this.__param||function(ve,e){return function(v,P){e(v,P,ve)}};define(Ne[76],Me([1,0,10,21,4,3]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.ProgressLocation=e.$Bw=void 0,e.$Bw=(0,T.$Gi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Cw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$Dw=O;class ${get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$Ew=$;let o=class extends I.$Vc{constructor(a,S){super(),this.a=new v.$4h,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,I.$Tc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$Fw=o,e.$Fw=o=Je([We(1,e.$Bw)],o);class k extends I.$Vc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new I.$Uc)}start(a){this.stop();const S=++this.a,d=new P.$xe;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,I.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Tc)(()=>d.cancel())),this.b.add((0,I.$Tc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$Gw=k,e.$Hw=(0,T.$Gi)("editorProgressService")}),define(Ne[30],Me([1,0,61,14]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,v=Ve(v),P=Ve(P);class I{constructor(){this.a=new Map}add(A,O){v.ok(P.$fg(A)),v.ok(P.$hg(O)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,O)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$so=new I}),define(Ne[77],Me([1,0,6,138,30]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,I=Ve(I),e.$to={JSONContribution:"base.contributions.json"};function T($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class A{constructor(){this.b=new v.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,k){this.a[T(o)]=k,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(o){const k=this.a[o];return k?(0,P.$9j)(k):void 0}hasSchemaContent(o){return!!this.a[o]}}const O=new A;I.$so.add(e.$to.JSONContribution,O)}),define(Ne[53],Me([1,0,17,6,14,9,43,77,30]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=r,e.$Jo=s,e.$Ko=c,e.$Lo=i,e.$Mo=n,e.$No=t,e.$Oo=g,I=Ve(I),T=Ve(T);var o;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$xo={Configuration:"base.contributions.configuration"};var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const y=$.$so.as(O.$to.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new P.$me,this.onDidSchemaChange=this.j.event,this.k=new P.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:T.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(p,m=!0){this.registerConfigurations([p],m)}registerConfigurations(p,m=!0){const h=new Set;this.r(p,m,h),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(p){const m=new Set;this.s(p,m),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:m})}updateConfigurations({add:p,remove:m}){const h=new Set;this.s(m,h),this.r(p,!1,h),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(p){const m=new Set;this.l(p,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}l(p,m){this.a.push(...p);const h=[];for(const{overrides:E,source:D}of p)for(const w in E){m.add(w);const C=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),R=E[w];if(C.configurationDefaultOverrides.push({value:R,source:D}),e.$Ho.test(w)){const f=this.o(w,R,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f,this.n(w,f,D),h.push(...r(w))}else{const f=this.p(w,R,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f;const b=this.e[w];b&&(this.A(w,b),this.w(w,b))}}this.q(h)}deregisterDefaultConfigurations(p){const m=new Set;this.m(p,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}m(p,m){for(const h of p){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of p)for(const D in h){const w=this.b.get(D);if(!w)continue;const C=w.configurationDefaultOverrides.findIndex(R=>E?R.source?.id===E.id:R.value===h[D]);if(C!==-1){if(w.configurationDefaultOverrides.splice(C,1),w.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Ho.test(D)){let R;for(const f of w.configurationDefaultOverrides)R=this.o(D,f.value,f.source,R);R&&!I.$sg(R.value)?(w.configurationDefaultOverrideValue=R,this.n(D,R,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let R;for(const b of w.configurationDefaultOverrides)R=this.p(D,b.value,b.source,R);w.configurationDefaultOverrideValue=R;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}m.add(D)}}this.y()}n(p,m,h){const E={type:"object",default:m.value,description:T.localize(1654,null,(0,A.$kj)(p)),$ref:e.$Eo,defaultDefaultValue:m.value,source:h,defaultValueSource:h};this.e[p]=E,this.c.properties[p]=E}o(p,m,h,E){const D=E?.value||{},w=E?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(m)){const R=m[C];if(I.$hg(R)&&(I.$mg(D[C])||I.$hg(D[C]))){if(D[C]={...D[C]??{},...R},h)for(const b in R)w.set(`${C}.${b}`,h)}else D[C]=R,h?w.set(C,h):w.delete(C)}return{value:D,source:w}}p(p,m,h,E){const D=this.e[p],w=E?.value??D?.defaultDefaultValue;let C=h;if(I.$hg(m)&&(D!==void 0&&D.type==="object"||D===void 0&&(I.$mg(w)||I.$hg(w)))){if(C=E?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in m)h&&C.set(`${p}.${f}`,h);m={...I.$hg(w)?w:{},...m}}return{value:m,source:C}}deltaConfiguration(p){let m=!1;const h=new Set;p.removedDefaults&&(this.m(p.removedDefaults,h),m=!0),p.addedDefaults&&(this.l(p.addedDefaults,h),m=!0),p.removedConfigurations&&this.s(p.removedConfigurations,h),p.addedConfigurations&&this.r(p.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...p){this.j.fire()}registerOverrideIdentifiers(p){this.q(p),this.j.fire()}q(p){for(const m of p)this.i.add(m);this.y()}r(p,m,h){p.forEach(E=>{this.u(E,m,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s(p,m){const h=E=>{if(E.properties)for(const D in E.properties){m.add(D);const w=this.e[D];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of p){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(p,m=!0,h,E,D=k.WINDOW,w){D=I.$og(p.scope)?D:p.scope;const C=p.properties;if(C)for(const f in C){const b=C[f];if(m&&i(f,b)){delete C[f];continue}if(b.source=h,b.defaultDefaultValue=C[f].default,this.A(f,b),e.$Ho.test(f)?b.scope=void 0:(b.scope=I.$og(b.scope)?D:b.scope,b.restricted=I.$og(b.restricted)?!!E?.includes(f):b.restricted),C[f].hasOwnProperty("included")&&!C[f].included){this.g[f]=C[f],delete C[f];continue}else this.e[f]=C[f],C[f].policy?.name&&this.f.set(C[f].policy.name,f);!C[f].deprecationMessage&&C[f].markdownDeprecationMessage&&(C[f].deprecationMessage=C[f].markdownDeprecationMessage),w.add(f)}const R=p.allOf;if(R)for(const f of R)this.u(f,m,h,E,D,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const p=new Map;for(const[m,h]of this.b)h.configurationDefaultOverrideValue&&p.set(m,h.configurationDefaultOverrideValue);return p}v(p){const m=h=>{const E=h.properties;if(E)for(const w in E)this.w(w,E[w]);h.allOf?.forEach(m)};m(p)}w(p,m){switch(e.$yo.properties[p]=m,m.scope){case k.APPLICATION:e.$zo.properties[p]=m;break;case k.MACHINE:e.$Ao.properties[p]=m;break;case k.MACHINE_OVERRIDABLE:e.$Bo.properties[p]=m;break;case k.WINDOW:e.$Co.properties[p]=m;break;case k.RESOURCE:e.$Do.properties[p]=m;break;case k.LANGUAGE_OVERRIDABLE:e.$Do.properties[p]=m,this.h.properties[p]=m;break}}x(p,m){switch(delete e.$yo.properties[p],m.scope){case k.APPLICATION:delete e.$zo.properties[p];break;case k.MACHINE:delete e.$Ao.properties[p];break;case k.MACHINE_OVERRIDABLE:delete e.$Bo.properties[p];break;case k.WINDOW:delete e.$Co.properties[p];break;case k.RESOURCE:case k.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[p],delete this.h.properties[p];break}}y(){for(const p of this.i.values()){const m=`[${p}]`,h={type:"object",description:T.localize(1655,null),errorMessage:T.localize(1656,null),$ref:e.$Eo};this.A(m,h),e.$yo.properties[m]=h,e.$zo.properties[m]=h,e.$Ao.properties[m]=h,e.$Bo.properties[m]=h,e.$Co.properties[m]=h,e.$Do.properties[m]=h}}z(){const p={type:"object",description:T.localize(1657,null),errorMessage:T.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=p,e.$zo.patternProperties[e.$Go]=p,e.$Ao.patternProperties[e.$Go]=p,e.$Bo.patternProperties[e.$Go]=p,e.$Co.patternProperties[e.$Go]=p,e.$Do.patternProperties[e.$Go]=p,this.j.fire()}A(p,m){const h=this.b.get(p)?.configurationDefaultOverrideValue;let E,D;h&&(!m.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),I.$mg(E)&&(E=m.defaultDefaultValue,D=void 0),I.$mg(E)&&(E=c(m.type)),m.default=E,m.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Go=`^(${S})+$`,e.$Ho=new RegExp(e.$Go);function r(u){const p=[];if(e.$Ho.test(u)){let m=d.exec(u);for(;m?.length;){const h=m[1].trim();h&&p.push(h),m=d.exec(u)}}return(0,v.$Mb)(p)}function s(u){return u.reduce((p,m)=>`${p}[${m}]`,"")}function c(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new a;$.$so.add(e.$xo.Configuration,l);function i(u,p){return u.trim()?e.$Ho.test(u)?T.localize(1660,null,u):l.getConfigurationProperties()[u]!==void 0?T.localize(1661,null,u):p.policy?.name&&l.getPolicyConfigurations().get(p.policy?.name)!==void 0?T.localize(1662,null,u,p.policy?.name,l.getPolicyConfigurations().get(p.policy?.name)):null:T.localize(1659,null)}function n(){const u=[],p=l.getConfigurationProperties();for(const m of Object.keys(p))u.push([m,p[m].scope]);return u.push(["launch",k.RESOURCE]),u.push(["task",k.RESOURCE]),u}function t(u){const p={};for(const m of u){const h=m.properties;if(I.$hg(h))for(const E in h)p[E]=h[E];m.allOf&&Object.assign(p,t(m.allOf))}return p}function g(u){switch(u){case"application":return k.APPLICATION;case"machine":return k.MACHINE;case"resource":return k.RESOURCE;case"machine-overridable":return k.MACHINE_OVERRIDABLE;case"language-overridable":return k.LANGUAGE_OVERRIDABLE;default:return k.WINDOW}}}),define(Ne[175],Me([1,0,17,6,137,4,28,25,14,2,43,53,29,30]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=n,v=Ve(v),I=Ve(I),O=Ve(O),$=Ve($);function d(p){return Object.isFrozen(p)?p:O.$go(p)}class r{static createEmptyModel(m){return new r({},[],[],void 0,m)}constructor(m,h,E,D,w){this.b=m,this.c=h,this.d=E,this.raw=D,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map(h=>{if(h instanceof r)return h;const E=new s("",this.f);return E.parseRaw(h),E.configurationModel});this.g=m.reduce((h,E)=>E===h?E:h.merge(E),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,k.$ij)(this.contents,m):this.contents}inspect(m,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(m))},get override(){return h?d(E.rawConfiguration.getOverrideValue(m,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(m):E.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:w,identifiers:C,keys:R}of E.rawConfiguration.overrides){const f=new r(w,R,[],void 0,E.f).getValue(m);f!==void 0&&D.push({identifiers:C,value:f})}return D.length?d(D):void 0}}}getOverrideValue(m,h){const E=this.j(h);return E?m?(0,k.$ij)(E,m):E:void 0}getKeysForOverrideIdentifier(m){const h=[];for(const E of this.overrides)E.identifiers.includes(m)&&h.push(...E.keys);return v.$Mb(h)}getAllOverrideIdentifiers(){const m=[];for(const h of this.overrides)m.push(...h.identifiers);return v.$Mb(m)}override(m){let h=this.a.get(m);return h||(h=this.h(m),this.a.set(m,h)),h}merge(...m){const h=O.$fo(this.contents),E=O.$fo(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const C of m)if(w.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(h,C.contents);for(const R of C.overrides){const[f]=E.filter(b=>v.$ub(b.identifiers,R.identifiers));f?(this.i(f.contents,R.contents),f.keys.push(...R.keys),f.keys=v.$Mb(f.keys)):E.push(O.$fo(R))}for(const R of C.keys)D.indexOf(R)===-1&&D.push(R)}return new r(h,D,E,w.every(C=>C instanceof r)?void 0:w,this.f)}h(m){const h=this.j(m);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[D];const C=h[D];C&&(typeof w=="object"&&typeof C=="object"?(w=O.$fo(w),this.i(w,C)):w=C),E[D]=w}return new r(E,this.keys,this.overrides,void 0,this.f)}i(m,h){for(const E of Object.keys(h)){if(E in m&&$.$hg(m[E])&&$.$hg(h[E])){this.i(m[E],h[E]);continue}m[E]=O.$fo(h[E])}}j(m){let h=null,E=null;const D=w=>{w&&(E?this.i(E,w):E=O.$fo(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===m?h=w.contents:w.identifiers.includes(m)&&D(w.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,h){this.k(m,h,!0)}setValue(m,h){this.k(m,h,!1)}removeValue(m){const h=this.keys.indexOf(m);h!==-1&&(this.keys.splice(h,1),(0,k.$hj)(this.contents,m),y.$Ho.test(m)&&this.overrides.splice(this.overrides.findIndex(E=>v.$ub(E.identifiers,(0,y.$Io)(m))),1))}k(m,h,E){if((0,k.$gj)(this.contents,m,h,D=>this.f.error(D)),E=E||this.keys.indexOf(m)===-1,E&&this.keys.push(m),y.$Ho.test(m)){const D=(0,y.$Io)(m),w={identifiers:D,keys:Object.keys(this.contents[m]),contents:(0,k.$fj)(this.contents[m],R=>this.f.error(R))},C=this.overrides.findIndex(R=>v.$ub(R.identifiers,D));C!==-1?this.overrides[C]=w:this.overrides.push(w)}}}e.$Po=r;class s{constructor(m,h){this.f=m,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,h){if(!$.$og(m)){const E=this.h(m);this.parseRaw(E,h)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,h){this.a=m;const{contents:E,keys:D,overrides:w,restricted:C,hasExcludedProperties:R}=this.i(m,h);this.b=new r(E,D,w,R?[m]:void 0,this.g),this.c=C||[]}h(m){let h={},E=null,D=[];const w=[],C=[];function R(b){Array.isArray(D)?D.push(b):E!==null&&(D[E]=b)}const f={onObjectBegin:()=>{const b={};R(b),w.push(D),D=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const b=[];R(b),w.push(D),D=b,E=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:R,onError:(b,L,N)=>{C.push({error:b,offset:L,length:N})}};if(m)try{I.$7n(m,f),h=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return h}i(m,h){const E=S.$so.as(y.$xo.Configuration).getConfigurationProperties(),D=this.j(m,E,!0,h);m=D.raw;const w=(0,k.$fj)(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),C=Object.keys(m),R=this.l(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:w,keys:C,overrides:R,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,h,E,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:w};const C={},R=[];for(const f in m)if(y.$Ho.test(f)&&E){const b=this.j(m[f],h,!1,D);C[f]=b.raw,w=w||b.hasExcludedProperties,R.push(...b.restricted)}else{const b=h[f],L=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&R.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(L===void 0||D.scopes===void 0||D.scopes.includes(L))&&!(D.skipRestricted&&b?.restricted))?C[f]=m[f]:w=!0}return{raw:C,restricted:R,hasExcludedProperties:w}}l(m,h){const E=[];for(const D of Object.keys(m))if(y.$Ho.test(D)){const w={};for(const C in m[D])w[C]=m[D][C];E.push({identifiers:(0,y.$Io)(D),keys:Object.keys(w),contents:(0,k.$fj)(w,h)})}return E}}e.$Qo=s;class c extends T.$Vc{constructor(m,h,E,D,w){super(),this.c=m,this.f=h,this.g=D,this.h=w,this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),w),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(a.FileOperation.CREATE)||C.isOperation(a.FileOperation.COPY)||C.isOperation(a.FileOperation.DELETE)||C.isOperation(a.FileOperation.WRITE))&&E.isEqual(C.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=c;class l{constructor(m,h,E,D,w,C,R,f,b,L,N,M,W){this.a=m,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=w,this.f=C,this.g=R,this.h=f,this.i=b,this.j=L,this.k=N,this.l=M,this.m=W}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,h,E,D,w,C,R,f,b,L){this.j=m,this.l=h,this.m=E,this.n=D,this.p=w,this.q=C,this.r=R,this.s=f,this.t=b,this.u=L,this.h=null,this.i=new A.$Bc,this.v=null}getValue(m,h,E){return this.w(m,h,E).getValue(m)}updateValue(m,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=r.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(m):D.setValue(m,h),E.resource||(this.h=null)}inspect(m,h,E){const D=this.w(m,h,E),w=this.A(h.resource,E),C=h.resource?this.t.get(h.resource)||this.s:this.s,R=new Set;for(const f of D.overrides)for(const b of f.identifiers)D.getOverrideValue(m,b)!==void 0&&R.add(b);return new l(m,h,D.getValue(m),R.size?[...R]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,w||void 0,C)}keys(m){const h=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,h){this.r.set(m,h),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,h){const E=[];if(!h){const{added:D,updated:w,removed:C}=g(this.j,m);h=[...D,...w,...C]}for(const D of h)for(const w of(0,y.$Io)(D)){const C=this.j.getKeysForOverrideIdentifier(w),R=m.getKeysForOverrideIdentifier(w),f=[...R.filter(b=>C.indexOf(b)===-1),...C.filter(b=>R.indexOf(b)===-1),...C.filter(b=>!O.$jo(this.j.override(w).getValue(b),m.override(w).getValue(b)))];E.push([w,f])}return this.updateDefaultConfiguration(m),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(m){const{added:h,updated:E,removed:D}=g(this.l,m),w=[...h,...E,...D];return w.length&&this.updatePolicyConfiguration(m),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.applicationConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateApplicationConfiguration(m),{keys:C,overrides:w}}compareAndUpdateLocalUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.localUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateLocalUserConfiguration(m),{keys:C,overrides:w}}compareAndUpdateRemoteUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.remoteUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateRemoteUserConfiguration(m),{keys:C,overrides:w}}compareAndUpdateWorkspaceConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.workspaceConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateWorkspaceConfiguration(m),{keys:C,overrides:w}}compareAndUpdateFolderConfiguration(m,h){const E=this.folderConfigurations.get(m),{added:D,updated:w,removed:C,overrides:R}=g(E,h),f=[...D,...w,...C];return(f.length||!E)&&this.updateFolderConfiguration(m,h),{keys:f,overrides:R}}compareAndDeleteFolderConfiguration(m){const h=this.folderConfigurations.get(m);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:E,updated:D,removed:w,overrides:C}=g(h,void 0);return{keys:[...E,...D,...w],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},h){let E=this.y();if(h&&m){const D=h.getFolder(m);D&&(E=this.z(D.uri)||E);const w=this.t.get(m);w&&(E=E.merge(w))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let h=this.i.get(m);if(!h){const E=this.y(),D=this.r.get(m);D?(h=E.merge(D),this.i.set(m,h)):h=E}return h}A(m,h){if(h&&m){const E=h.getFolder(m);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,h)=>{const{contents:E,overrides:D,keys:w}=this.r.get(h);return m.push([h,{contents:E,overrides:D,keys:w}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach(h=>m.add(h)),this.userConfiguration.keys.forEach(h=>m.add(h)),this.q.keys.forEach(h=>m.add(h)),this.r.forEach(h=>h.keys.forEach(E=>m.add(E))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>m.add(E))),[...m.values()]}D(m){const h=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(m).forEach(D=>h.add(D))),[...h.values()]}static parse(m,h){const E=this.E(m.defaults,h),D=this.E(m.policy,h),w=this.E(m.application,h),C=this.E(m.user,h),R=this.E(m.workspace,h),f=m.folders.reduce((b,L)=>(b.set(o.URI.revive(L[0]),this.E(L[1],h)),b),new A.$Bc);return new i(E,D,w,C,r.createEmptyModel(h),R,f,r.createEmptyModel(h),new A.$Bc,h)}static E(m,h){return new r(m.contents,m.keys,m.overrides,void 0,h)}}e.$So=i;function n(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const m=new Set,h=new Map;for(const D of p)D.keys.forEach(w=>m.add(w)),D.overrides.forEach(([w,C])=>{const R=(0,A.$yc)(h,w,new Set);C.forEach(f=>R.add(f))});const E=[];return h.forEach((D,w)=>E.push([w,[...D.values()]])),{keys:[...m.values()],overrides:E}}class t{constructor(m,h,E,D,w){this.change=m,this.f=h,this.g=E,this.h=D,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of m.keys)this.affectedKeys.add(C);for(const[,C]of m.overrides)for(const R of C)this.affectedKeys.add(R);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,h){const E=this.a+m,D=this.d.indexOf(E);if(D<0)return!1;const w=D+E.length;if(w>=this.d.length)return!1;const C=this.d.charCodeAt(w);if(C!==this.b&&C!==this.c)return!1;if(h){const R=this.previousConfiguration?this.previousConfiguration.getValue(m,h,this.f?.workspace):void 0,f=this.g.getValue(m,h,this.h);return!O.$jo(R,f)}return!0}}e.$Uo=t;function g(p,m){const{added:h,removed:E,updated:D}=u(m?.rawConfiguration,p?.rawConfiguration),w=[],C=p?.getAllOverrideIdentifiers()||[],R=m?.getAllOverrideIdentifiers()||[];if(m){const f=R.filter(b=>!C.includes(b));for(const b of f)w.push([b,m.getKeysForOverrideIdentifier(b)])}if(p){const f=C.filter(b=>!R.includes(b));for(const b of f)w.push([b,p.getKeysForOverrideIdentifier(b)])}if(m&&p){for(const f of C)if(R.includes(f)){const b=u({contents:p.getOverrideValue(void 0,f)||{},keys:p.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});w.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:E,updated:D,overrides:w}}function u(p,m){const h=p?m?p.keys.filter(w=>m.keys.indexOf(w)===-1):[...p.keys]:[],E=m?p?m.keys.filter(w=>p.keys.indexOf(w)===-1):[...m.keys]:[],D=[];if(p&&m){for(const w of m.keys)if(p.keys.indexOf(w)!==-1){const C=(0,k.$ij)(m.contents,w),R=(0,k.$ij)(p.contents,w);O.$jo(C,R)||D.push(w)}}return{added:h,removed:E,updated:D}}}),define(Ne[109],Me([1,0,13,3]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.RemoteAuthorityResolverErrorCode=e.$Ul=e.$Tl=e.RemoteConnectionType=e.$Sl=void 0,e.$Wl=o,e.$Sl=(0,P.$Gi)("remoteAuthorityResolverService");var I;(function(k){k[k.WebSocket=0]="WebSocket",k[k.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class T{constructor(y){this.id=y,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.$Tl=T;class A{constructor(y,a){this.host=y,this.port=a,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ul=A;var O;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound",k.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class $ extends v.$bb{static isNotAvailable(y){return y instanceof $&&y._code===O.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===O.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===O.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===O.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,a=O.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===O.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Vl=$;function o(k){const y=k.indexOf("+");return y===-1?k:k.substring(0,y)}}),define(Ne[62],Me([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=P,e.$jn=I,e.$kn=T,e.$ln=A;function P($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const o=$.indexOf("+");return o<0?$:$.substr(0,o)}function T($){const{host:o,port:k}=O($);if(typeof k>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:k}}function A($,o){let{host:k,port:y}=O($);return typeof y>"u"&&(y=o),{host:k,port:y}}function O($){const o=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Ne[18],Me([1,0,12,3,62]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=T,e.$vn=y,e.$wn=a,e.$xn=S,e.$yn=d,e.$zn=r,e.$An=s,v=Ve(v),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function T(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var O;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const n=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Gf(n,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$sn=$;class o{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$tn=o;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,i){this.c.set($.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=k;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,l){if(l){const i=`onResolveRemoteAuthority:${(0,I.$jn)(l)}`;return!!c.activationEvents?.includes(i)}return!1}function r(c){return c.map(l=>{const[i,n]=l.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function s(c){return c.map(l=>l.split("@")[0])}e.$Bn=(0,P.$Gi)("IBuiltinExtensionsScannerService")}),define(Ne[110],Me([1,0,20,9,18,3]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=O,e.$hp=$,e.$ip=o,e.$jp=k,e.$kp=y,e.$lp=a,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function O(t){switch(t){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function $(t){switch(t){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function o(t,g){switch(t){case v.Platform.Windows:return g==="x64"?I.TargetPlatform.WIN32_X64:g==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?I.TargetPlatform.LINUX_X64:g==="arm64"?I.TargetPlatform.LINUX_ARM64:g==="arm"?I.TargetPlatform.LINUX_ARMHF:I.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?I.TargetPlatform.ALPINE_X64:g==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?I.TargetPlatform.DARWIN_X64:g==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case v.Platform.Web:return I.TargetPlatform.WEB}}function k(t,g){return g===I.TargetPlatform.WEB&&!t.includes(I.TargetPlatform.WEB)}function y(t,g,u){return k(g,u)?!1:t===I.TargetPlatform.UNDEFINED||t===I.TargetPlatform.UNIVERSAL?!0:t===I.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$mp=(0,T.$Gi)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(c||(e.ExtensionGalleryErrorCode=c={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$np=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$op=n,e.$pp=(0,T.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,T.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,T.$Gi)("IExtensionTipsService"),e.$up=(0,P.localize2)(1771,"Extensions"),e.$vp=(0,P.localize2)(1772,"Preferences")}),define(Ne[111],Me([1,0,13,18]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,O){this.a.set(A,O)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const O=Object.create(null);for(const $ of A){const o=this.readActivationEvents($);o.length>0&&(O[P.$sn.toKey($.identifier)]=o)}return O}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const O=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<O.length;$++)O[$]==="onUri"&&(O[$]=`onUri:${P.$sn.toKey(A.identifier)}`);if(!A.contributes)return O;for(const $ in A.contributes){const o=this.a.get($);if(!o)continue;const k=A.contributes[$],y=Array.isArray(k)?k:[k];try{o(y,O)}catch(a){(0,v.$Z)(a)}}return O}}e.$1G=I,e.$2G=new I});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[176],Me([1,0,23,35,9,281,18,104]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=k,e.$2p=y,e.$3p=a,e.$4p=S,e.$5p=d,e.$6p=r,e.$7p=s,e.$8p=c,P=_t(P),I=Ve(I),T=Ve(T);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function k(n){return n=n.trim(),n==="*"||$.test(n)}function y(n){if(!k(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(n){if(!n)return null;const t=n.majorBase,g=n.majorMustEqual,u=n.minorBase;let p=n.minorMustEqual;const m=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||(p=!1),h=!1);let E=0;if(n.preRelease){const D=o.exec(n.preRelease);if(D){const[,w,C,R]=D;E=Date.UTC(Number(w),Number(C)-1,Number(R))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:p,patchBase:m,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:E}}function S(n,t,g){let u;typeof n=="string"?u=a(y(n)):u=n;let p;t instanceof Date?p=t.getTime():typeof t=="string"&&(p=new Date(t).getTime());let m;if(typeof g=="string"?m=a(y(g)):m=g,!u||!m)return!1;const h=u.majorBase,E=u.minorBase,D=u.patchBase;let w=m.majorBase,C=m.minorBase,R=m.patchBase;const f=m.notBefore;let b=m.majorMustEqual,L=m.minorMustEqual,N=m.patchMustEqual;return m.isMinimum?h>w?!0:h<w?!1:E>C?!0:E<C||p&&p<f?!1:D>=R:(h===1&&w===0&&(!b||!L||!N)&&(w=1,C=0,R=0,b=!0,L=!1,N=!1),h<w?!1:h>w?!b:E<C?!1:E>C?!L:D<R?!1:D>R?!N:!(p&&p<f))}function d(n,t,g,u,p,m){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([P.default.Error,I.localize(1823,null)]),h;if(typeof u.name!="string")return h.push([P.default.Error,I.localize(1824,null,"name")]),h;if(typeof u.version!="string")return h.push([P.default.Error,I.localize(1825,null,"version")]),h;if(!u.engines)return h.push([P.default.Error,I.localize(1826,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([P.default.Error,I.localize(1827,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([P.default.Error,I.localize(1828,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([P.default.Error,I.localize(1829,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([P.default.Error,I.localize(1830,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([P.default.Warning,I.localize(1831,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([P.default.Error,I.localize(1832,null,"main")]),h;{const w=(0,v.$hh)(g,u.main);(0,v.$bh)(w,g)||h.push([P.default.Warning,I.localize(1833,null,w.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([P.default.Error,I.localize(1834,null,"browser")]),h;{const w=(0,v.$hh)(g,u.browser);(0,v.$bh)(w,g)||h.push([P.default.Warning,I.localize(1835,null,w.path,g.path)])}}if(!T.valid(u.version))return h.push([P.default.Error,I.localize(1836,null)]),h;const E=[];if(!r(n,t,u,p,E))for(const w of E)h.push([P.default.Error,w]);if(m&&u.enabledApiProposals?.length){const w=[];if(!c([...u.enabledApiProposals],w))for(const C of w)h.push([P.default.Error,C])}return h}function r(n,t,g,u,p){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(n,t,g.engines.vscode,p)}function s(n,t,g){return n==="*"||l(t,g,n)}function c(n,t){if(n.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??O.allApiProposals,p=[],m=(0,A.$zn)(n);for(const{proposalName:h,version:E}of m){const D=u[h];D&&E&&D.version!==E&&p.push(I.localize(1837,null,h))}return g?.push(...p),p.length===0}function l(n,t,g,u=[]){const p=a(y(g));if(!p)return u.push(I.localize(1838,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(I.localize(1839,null,g)),!1}else if(!p.majorMustEqual)return u.push(I.localize(1840,null,g)),!1;return S(n,t,p)?!0:(u.push(I.localize(1841,null,n,g)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,g=n.length;t<g;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Ne[177],Me([1,0,22,13,4,9,53,3,11,30]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=a,e.$_p=S,e.$aq=d,e.$bq=r,e.$cq=s,e.$dq=c,e.$9p=(0,O.$Gi)("requestService");class k{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends I.$Vc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,T.localize)(2041,null),when:$.$tk.isEqualTo((0,$.$qk)($.LogLevel.Trace)).serialize()})}async c(t,g,u){const p=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${p} - begin`,g.type,new k(g.headers??{}));try{const m=await u();return this.a.trace(`${p} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${p} - error`,g.type,(0,P.$0)(m)),m}}}e.$0p=y;function a(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function S(n){return n.res.statusCode===204}async function d(n){return S(n)?null:(await(0,v.$1e)(n.stream)).toString()}async function r(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);return d(n)}async function s(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);if(S(n))return null;const g=(await(0,v.$1e)(n.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function c(n){i(n)}let l;function i(n){const t=o.$so.as(A.$xo.Configuration),g=l;l={id:"http",order:15,title:(0,T.localize)(2042,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,T.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(2048,null),(0,T.localize)(2049,null),(0,T.localize)(2050,null),(0,T.localize)(2051,null)],default:"override",description:(0,T.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(2054,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ne[178],Me([1,0,20,78,38]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=A,e.$xp=O;function T($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,o,k,y,a,S,d,r,s,c){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=d,l["common.devDeviceId"]=r,l.sessionID=(0,I.$3g)()+Date.now(),l.commitHash=y,l.version=a,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=P.$ec,l["common.nodeArch"]=k,l["common.product"]=c||"desktop",s&&(l["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=T(o);return t&&(l["common.platformDetail"]=t),l}function O($){const o=P.env.USERDNSDOMAIN;if(!o)return!1;const k=o.toLowerCase();return $.some(y=>k===y)}}),define(Ne[112],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,v.$Gi)("telemetryService"),e.$bm=(0,v.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var P;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var I;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ne[63],Me([1,0,25,14,62,178,112]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=k,e.$Gp=y,e.$Hp=a,e.$Ip=S,e.$Jp=r,e.$Kp=c,e.$Lp=l,e.$Mp=t;class O{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$yp=O;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=$,e.$Ap=new $;class o{async publicLog(u,p,m){}async publicLogError(u,p,m){}}e.$Bp=o,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function k(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(A.$jm),p=g.getValue(A.$km);if(g.getValue(A.$lm)===!1||p===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(g){const u={},p={},m={};s(g,m);for(let h in m){h=h.length>150?h.substr(h.length-149):h;const E=m[h];typeof E=="number"?p[h]=E:typeof E=="boolean"?p[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:p}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const u=(0,I.$jn)(g);return d.has(u)?u:"other"}function s(g,u,p=0,m){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=m?m+h:h;Array.isArray(E)?u[D]=(0,v.$ko)(E):E instanceof Date?u[D]=E.toISOString():(0,P.$hg)(E)?p<2?s(E,u,p+1,D+"."):u[D]=(0,v.$ko)(E):u[D]=E}}function c(g,u){const p=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,T.$xp)(p)||m}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let p=g;const m=[];for(const w of u)for(;;){const C=w.exec(g);if(!C)break;m.push([C.index,w.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(p="";;){const w=E.exec(g);if(!w)break;const C=m.some(([R,f])=>w.index<f&&R<E.lastIndex);!h.test(w[0])&&!C&&(p+=g.substring(D,w.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&(p+=g.substr(D)),p}function n(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of u)if(p.regex.test(g))return`<REDACTED: ${p.label}>`;return g}function t(g,u){return(0,v.$ho)(g,p=>{if(p instanceof O||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let m=p.replaceAll("%20"," ");m=i(m,u);for(const h of u)m=m.replace(h,"");return m=n(m),m}})}}),define(Ne[179],Me([1,0,12,110,18,20,2,13,78,63]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=k,e.$Pp=d,e.$Qp=r,e.$Rp=s,e.$Sp=c,e.$Tp=l,e.$Up=i,e.$Vp=n,e.$Xp=t,e.$Yp=u;function k(p,m){return p.uuid&&m.uuid?p.uuid===m.uuid:p.id===m.id?!0:(0,v.$Bf)(p.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(m){const h=m.manifest?m.manifest.version:m.version,E=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new a(m.identifier,h,E)}static parse(m){const h=y.exec(m);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(m,h,E=I.TargetPlatform.UNDEFINED){this.identifier=m,this.version=h,this.targetPlatform=E,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof a?k(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Op=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(p){const m=S.exec(p);return m&&m[1]?[s(m[1]),m[2]]:[s(p),void 0]}function r(p,m){return`${p}.${m}`}function s(p){return p.toLowerCase()}function c(p,m){return s(r(p??I.$on,m))}function l(p,m){const h=[],E=D=>{for(const w of h)if(w.some(C=>k(m(C),m(D))))return w;return null};for(const D of p){const w=E(D);w?w.push(D):h.push([D])}return h}function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}function n(p){return{id:new o.$yp(p.identifier.id),name:new o.$yp(p.name),version:p.version,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),isSigned:p.isSigned,...p.telemetryData}}e.$Wp=new I.$sn("pprice.better-merge");function t(p,m){const h=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(w=>!k(w.identifier,{id:D}))){const w=p.filter(C=>k(C.identifier,{id:D}));w.length===1&&(h.push(w[0]),E.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g(p,m){if(!T.$l)return!1;let h;try{h=(await p.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await p.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,O.$0)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(p,m){const h=await g(p,m),E=(0,P.$ip)(h?"alpine":T.$v,$.$fc);return m.debug("ComputeTargetPlatform:",E),E}}),define(Ne[180],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=v,e.$Js=P,e.$Ks=I,e.$Ls=T,e.$Ms=A,e.$Ns=O;function v($){return[...$.entries()]}function P($){return $?[...$.entries()]:[]}function I($){return new Map($)}function T($){return new Map($??[])}function A($){return Array.from($.entries()).map(o=>[o[0],v(o[1].map),P(o[1].descriptionMap)])}function O($){return new Map($.map(o=>[o[0],{map:I(o[1]),descriptionMap:T(o[2])}]))}}),define(Ne[181],Me([1,0,3,31,30]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ss=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$rs=void 0,e.$rs=new P.$Xj("terminalTabFocusMode",!1,!0);var T;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var O;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(O||(e.PosixShellType=O={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var k;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(k||(e.TerminalIpcChannels=k={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ss=(0,v.$Gi)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ts={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}I.$so.add(e.$ts.Backend,new n),e.$us=(0,v.$Gi)("localPtyService"),e.$vs=(0,v.$Gi)("terminalLogService")}),define(Ne[182],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5xb=void 0;class v{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,T,A=5){const O=T($=>{const o=typeof $=="string"?$:$.data;let k=this.a.get(I);if(k){k.data.push(o);return}const y=setTimeout(()=>this.flushBuffer(I),A);k={data:[o],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),O.dispose()}},this.a.set(I,k)});return O}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const T=this.a.get(I);T&&(this.a.delete(I),this.b(I,T.data.join("")))}}e.$5xb=v}),define(Ne[183],Me([1,0,10,97,282,34,6,14,2,9,77,30]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mx=e.$Lx=e.$Kx=e.$Jx=e.$Ix=e.$Hx=e.IconFontDefinition=e.IconContribution=e.$Ex=void 0,e.$Fx=s,e.$Gx=c,y=Ve(y),e.$Ex={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,p){let m=u.defaults;for(;T.ThemeIcon.isThemeIcon(m);){const h=r.getIcon(m.id);if(!h)return;m=h.defaults}return m}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g(p){return{weight:p.weight,style:p.style,src:p.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u(p){const m=h=>(0,O.$fg)(h)?h:void 0;if(p&&Array.isArray(p.src)&&p.src.every(h=>(0,O.$fg)(h.format)&&(0,O.$fg)(h.location)))return{weight:m(p.weight),style:m(p.style),src:p.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new A.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(2351,null)},fontCharacter:{type:"string",description:(0,o.localize)(2352,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,p,m){const h=this.b[g];if(h){if(p&&!h.description){h.description=p,this.d.properties[g].markdownDescription=`${p} $(${g})`;const w=this.e.enum.indexOf(g);w!==-1&&(this.e.enumDescriptions[w]=p),this.a.fire()}return h}const E={id:g,description:p,defaults:u,deprecationMessage:m};this.b[g]=E;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),p&&(D.markdownDescription=`${p}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const p=this.f[g];return p||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;T.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(h=>this.b[h]);for(const h of m.filter(E=>!!E.description).sort(g))p.push(`|<i class="${u(h)}"></i>|${h.id}|${T.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const h of m.filter(E=>!T.ThemeIcon.isThemeIcon(E.defaults)).sort(g))p.push(`|<i class="${u(h)}"></i>|${h.id}|`);return p.join(`
`)}}const r=new d;y.$so.add(e.$Ex.IconContribution,r);function s(t,g,u,p){return r.registerIcon(t,g,u,p)}function c(){return r}function l(){const t=(0,I.$2j)();for(const g in t){const u="\\"+t[g].toString(16);r.registerIcon(g,{fontCharacter:u})}}l(),e.$Hx="vscode://schemas/icons";const i=y.$so.as(k.$to.JSONContribution);i.registerSchema(e.$Hx,r.getIconSchema());const n=new v.$Sh(()=>i.notifySchemaChanged(e.$Hx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Ix=s("widget-close",P.$6j.close,(0,o.localize)(2353,null)),e.$Jx=s("goto-previous-location",P.$6j.arrowUp,(0,o.localize)(2354,null)),e.$Kx=s("goto-next-location",P.$6j.arrowDown,(0,o.localize)(2355,null)),e.$Lx=T.ThemeIcon.modify(P.$6j.sync,"spin"),e.$Mx=T.ThemeIcon.modify(P.$6j.loading,"spin")}),define(Ne[184],Me([1,0,6,4,20,2,43,3,11]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Pw=e.$Nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Jw=e.$Iw=void 0,e.$Kw=y,e.$Lw=S,e.$Mw=d,e.$Ow=r,e.$Qw=s,e.$Rw=c,e.$Iw=(0,O.$Gi)("tunnelService"),e.$Jw=(0,O.$Gi)("sharedTunnelsService");var o;(function(n){n.Http="http",n.Https="https"})(o||(e.TunnelProtocol=o={}));var k;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(k||(e.TunnelPrivacyId=k={}));function y(n){return!!n.forwardPort}var a;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const p=S(T.URI.parse(u));if(p)return p}}}e.$Nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Nw.indexOf(n)>=0}e.$Pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(n){return e.$Pw.indexOf(n)>=0}function c(n,t,g,u){if(g===I.OperatingSystem.Windows)return!1;if(g===I.OperatingSystem.Macintosh&&s(t)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(p?.length===4&&parseInt(p[1])>=18)return!1}return n<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sw=l;let i=class extends P.$Vc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$me,this.onTunnelOpened=this.a.event,this.b=new v.$me,this.onTunnelClosed=this.b.event,this.c=new v.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const p=Array.from(u.values());for(const m of p){const h=await m.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,p,m){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:p,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(s(t)||r(t))&&(t=e.$Nw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,p,m,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const w=this.g??t;if(!w)return;if(g||(g="localhost"),p||(p=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(w,g,u,p,m,h,E,D);return C?C.then(R=>{if(R){if(typeof R=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),R}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(R);return(R.tunnelRemoteHost!==g||R.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&R.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const p=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),p}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const p=u.get(g);p.refcount=0,await this.y(t,g,p)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const p=u.get(g),m=p?await p.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];r(t)?(u.push(...e.$Nw),u.push(...e.$Pw)):s(t)&&u.push(...e.$Pw);const p=u.map(m=>this.f.get(m));for(const m of p){const h=m?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,u,p,m,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${p}.`);const D=u;this.n.add(D);const w=p===void 0?u:p,C={elevationRequired:m?this.isPortPrivileged(w):!1},R={remoteAddress:{host:g,port:u},localAddressPort:p,privacy:h,public:h?h!==k.Private:void 0,protocol:E},f=t.forwardPort(R,C);return f?(this.z(g,u,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Tw=i,e.$Tw=i=Je([We(0,$.$bk),We(1,A.$aj)],i)}),define(Ne[113],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,v.$Gi)("IUriIdentityService")}),define(Ne[185],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Uw=void 0,e.$Uw=(0,v.$Gi)("editSessionIdentityService");var P;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Ne[186],Me([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=P,e.$mN=I,e.$nN=T,e.$oN=A,e.$pN=O;function P($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(o=>P(o.uri))?$.folders[0].uri:void 0;if($.configuration&&P($.configuration))return $.configuration}function T($){return I($)?.scheme}function A($){return I($)?.authority}function O($){return I($)!==void 0}}),define(Ne[49],Me([1,0,9,19,58,23,2,3,15]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=o,e.$Ri=k,e.$Ui=y,e.$Vi=a,e.$Wi=S,e.$Xi=r,e.$Yi=s,e.$2i=i,e.$7i=n,e.$8i=t,e.$0i=g,e.$$i=u,e.$_i=p,e.$Pi=(0,O.$Gi)("contextService");function o(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.uri)}function k(m){return typeof m?.id=="string"&&!o(m)&&!a(m)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function y(m,h){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,P.$oc)(m)}:h?e.$Si:e.$Ti;const E=m;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.configPath)}function S(m){const h=m;if(h?.uri)return{id:h.id,uri:A.URI.revive(h.uri)};const E=m;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function s(m){const h=m;return!!(h&&typeof h=="object"&&A.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,w,C){this.h=h,this.j=D,this.k=w,this.l=C,this.c=I.$Mi.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=I.$Mi.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=c;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,T.$hh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=l;function i(m){return new l({uri:m,index:0,name:(0,T.$dh)(m)},{uri:m.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,v.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function n(m,h){return T.$$g.isEqualOrParent(m,h.untitledWorkspacesHome)}function t(m){let h;return A.URI.isUri(m)?h=m:h=m.configuration,h?.scheme===$.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.$9i}function u(m,h){return!n(m,h)&&!t(m)}function p(m){return(typeof m=="string"?(0,P.$pc)(m):(0,T.$fh)(m))===e.$4i}}),define(Ne[114],Me([1,0,75,6,4,23,2,9,106,29,3,11,49,28,113,10,38,12,14]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=n,e.$Ol=t,e.$Pl=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&A.URI.isUri(h.location)&&A.URI.isUri(h.globalStorageHome)&&A.URI.isUri(h.settingsResource)&&A.URI.isUri(h.keybindingsResource)&&A.URI.isUri(h.tasksResource)&&A.URI.isUri(h.snippetsHome)&&A.URI.isUri(h.extensionsResource))}e.$Nl=(0,k.$Gi)("IUserDataProfilesService");function t(m,h){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:h}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:h}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:h}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:h}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:h}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:h}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:h}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:h}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,h,E,D,w,C){return{id:m,name:h,location:E,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:C&&w?.useDefaultFlags?.globalState?C.globalStorageHome:(0,T.$hh)(E,"globalStorage"),settingsResource:C&&w?.useDefaultFlags?.settings?C.settingsResource:(0,T.$hh)(E,"settings.json"),keybindingsResource:C&&w?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,T.$hh)(E,"keybindings.json"),tasksResource:C&&w?.useDefaultFlags?.tasks?C.tasksResource:(0,T.$hh)(E,"tasks.json"),snippetsHome:C&&w?.useDefaultFlags?.snippets?C.snippetsHome:(0,T.$hh)(E,"snippets"),extensionsResource:C&&w?.useDefaultFlags?.extensions?C.extensionsResource:(0,T.$hh)(E,"extensions.json"),cacheHome:(0,T.$hh)(D,m),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let u=class extends I.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,w){super(),this.t=h,this.u=E,this.w=D,this.y=w,this.f=!0,this.h=this.B(new P.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$Bc,workspaces:new S.$Bc,emptyWindows:new Map},this.profilesHome=(0,T.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,l.$fg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}E.push(g((0,T.$eh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},h))}}catch(C){this.y.error(C)}const D=new S.$Bc,w=new Map;if(E.length)try{const C=this.Q();if(C.workspaces)for(const[R,f]of Object.entries(C.workspaces)){const b=A.URI.parse(R),L=E.find(N=>N.id===f);L&&D.set(b,L)}if(C.emptyWindows)for(const[R,f]of Object.entries(C.emptyWindows)){const b=E.find(L=>L.id===f);b&&w.set(R,b)}}catch(C){this.y.error(C)}this.z={profiles:E,workspaces:D,emptyWindows:w}}return this.z}D(){const h=g("__default__profile__",(0,O.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$if)(E)}\\s(\\d+)`);let w=0;for(const R of this.profiles){const f=D.exec(R.name),b=f?parseInt(f[1]):0;w=b>w?b:w}const C=`${E} ${w+1}`;return this.createProfile((0,v.$uj)((0,s.$3g)()).toString(16),C,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$uj)((0,s.$3g)()).toString(16),h,E,D)}async createProfile(h,E,D,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(h,E,D);return w&&await this.setProfileForWorkspace(w,C),C}async F(h,E,D){if(!(0,l.$fg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(E);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===E||b.id===h))throw new Error(`Profile with ${E} name already exists`);const R=g(h,E,(0,T.$hh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(R.location);const f=[];return this.j.fire({profile:R,join(b){f.push(b)}}),await r.Promises.settled(f),this.I([R],[],[]),R}finally{this.r.delete(E)}})(),this.r.set(E,w)),w}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(w=>w.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(w){(0,o.$sl)(w)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Qi)(h)?this.s.folders.get(h.uri):(0,a.$Vi)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Qi)(h)?h.uri:(0,a.$Vi)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const w=[...this.profiles,...h],C=[],R=this.s.profiles;this.s.profiles=[];for(let f of w){if(f.isDefault||E.some(L=>f.id===L.id))continue;f=D.find(L=>f.id===L.id)??f;const b=R.find(L=>f.id===L.id);if(f.isTransient)this.s.profiles.push(f);else{if(b){for(const[L,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:L},f);break}for(const[L,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:L},f);break}for(const[L,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:L},f);break}}C.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Qi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Vi)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const w=this.G(h);A.URI.isUri(w)?(this.C.workspaces.delete(w),E&&this.C.workspaces.set(w,E)):(this.C.emptyWindows.delete(w),E&&this.C.emptyWindows.set(w,E)),this.M()}}M(){const h={};for(const[D,w]of this.C.workspaces.entries())h[D.toString()]=w.id;const E={};for(const[D,w]of this.C.emptyWindows.entries())E[D.toString()]=w.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[C,R]of Object.entries(h.workspaces)){const f=A.URI.parse(R);E[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const w={};if(h.emptyWindows)for(const[C,R]of Object.entries(h.emptyWindows)){const f=A.URI.parse(R);w[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:w}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ql=u,e.$Ql=u=Je([We(0,$.$Ni),We(1,o.$bl),We(2,d.$Ll),We(3,y.$bk)],u);class p extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Rl=p}),define(Ne[187],Me([1,0,10,6,4,64,14,153,3,114]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=S,e.$mq=r,e.$oq=c,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,$.$Gi)("storageService");var k;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(l){const i=l.get(e.$iq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends I.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new P.$pe),this.c=this.B(new P.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$me),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return P.Event.filter(this.b.event,g=>g.scope===i&&(n===void 0||g.key===n),t)}n(){this.j.value=(0,v.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:g}=n;if(t===e.$iq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,g,u=!1){if((0,A.$og)(n)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,n,u)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===n&&t.push(u);return t}z(i,n,t,g=!1){const u=this.J(n);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(n)?.set(e.$iq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(n)?.set(e.$iq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?S(n):Object.create(null)}isNew(i){return this.getBoolean(e.$hq,i)===!0}async flush(i=k.NONE){this.f.fire({reason:i});const n=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case k.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,n=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,n,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(k.NONE),(0,o.$Ml)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const g=new Set;for(const[u,p]of i)g.add(u),n.get(u)!==p&&this.u(t,{key:u,external:!0});for(const[u]of n.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$lq=d;function r(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$nq=s;async function c(l,i,n,t,g,u){const p=b=>{try{return JSON.parse(b)}catch{return b}},m=new Map,h=new Map;l.forEach((b,L)=>{m.set(L,b),h.set(L,p(b))});const E=new Map,D=new Map;i.forEach((b,L)=>{E.set(L,b),D.set(L,p(b))});const w=new Map,C=new Map;n.forEach((b,L)=>{w.set(L,b),C.set(L,p(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const R=[];if(m.forEach((b,L)=>{R.push({key:L,value:b})}),console.table(R),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];E.forEach((L,N)=>{b.push({key:N,value:L})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const f=[];w.forEach((b,L)=>{f.push({key:L,value:b})}),console.table(f),console.groupEnd(),console.log(C)}}),define(Ne[79],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class v{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const T=this.c++;return this.b.set(T,I),this.e(),T}get(I,T){return this.b.has(I)?this.b.get(I)[T]:void 0}delete(I){this.b.delete(I),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hpc=v}),define(Ne[50],Me([1,0,15,23,29,3]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new P.$9g($=>{const o=this.b.get($.scheme);return!(o===void 0||o&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,o){o===null?this.b.delete($.scheme):this.b.set($.scheme,o)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Mpc=A,e.$Npc=(0,T.$Gi)("IExtHostFileSystemInfo")}),define(Ne[26],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0,e.$EQ=(0,v.$Gi)("IExtHostInitDataService")}),define(Ne[188],Me([1,0,9,11,173,26]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0;let A=class extends I.$OR{constructor($,o,k){const y=k.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",a=k.remote.isRemote?(0,v.localize)(2693,null):$?(0,v.localize)(2694,null):(0,v.localize)(2695,null);super(o.createLogger(y,{name:a}))}};e.$Vrc=A,e.$Vrc=A=Je([We(1,P.$ck),We(2,T.$EQ)],A)}),define(Ne[189],Me([1,0,10]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=e.$sqc=void 0;class P{constructor(A,O,$){this.h=new Map,this.a=A,this.b=O,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(o=>(this.f=o,this)),this.g=this.c.onDidChangeStorage(o=>{o.shared===this.b&&o.key===this.a&&(this.f=o.value)}),this.i=new v.$Sh(()=>{const o=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const k of o.values())k.complete()}catch(k){for(const y of o.values())y.error(k)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,O){let $=this.f[A];return typeof $>"u"&&($=O),$}update(A,O){this.f[A]=O;const $=this.h.get(A);if($!==void 0)return $.p;const o=new v.$4h;return this.h.set(A,o),this.i.isScheduled()||this.i.schedule(),o.p}dispose(){this.g.dispose()}}e.$sqc=P;class I extends P{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,O){super(A.identifier.value,!0,O),this.j=A}}e.$tqc=I}),define(Ne[190],Me([1,0,6,2]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=void 0;class I{constructor(A){this.c=A,this.a=new v.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,O,$,o){const y=this.c.getNotebookDocument(P.URI.revive(A)).acceptModelChanged(O.value,$,o);this.b.fire(y)}$acceptDirtyStateChanged(A,O){this.c.getNotebookDocument(P.URI.revive(A)).acceptDirty(O)}$acceptModelSaved(A){const O=this.c.getNotebookDocument(P.URI.revive(A));this.a.fire(O.apiNotebook)}}e.$nrc=I}),define(Ne[16],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0,e.$oQ=(0,v.$Gi)("IExtHostRpcService");class P{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$pQ=P}),define(Ne[191],Me([1,0,18,6,4]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;class T{#e;constructor(O,$){this.disposables=new I.$Uc,this.a=v.$sn.toKey(O.identifier),this.#e=$,this.onDidChange=P.Event.map(P.Event.filter(this.#e.onDidChangePassword,o=>o.extensionId===this.a),o=>({key:o.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,$){return this.#e.store(this.a,O,$)}delete(O){return this.#e.delete(this.a,O)}}e.$Cqc=T}),define(Ne[65],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=e.$3pc=void 0,e.$3pc=(0,v.$Gi)("IURITransformerService");class P{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$4pc=P});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[115],Me([1,0,9,14,2,4,3,30,29,15,42,165,35]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$sG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$iG=e.EditorInputCapabilities=e.$hG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=void 0,e.$$F=r,e.$_F=s,e.$aG=c,e.$bG=l,e.$cG=i,e.$dG=n,e.$eG=t,e.$fG=g,e.$gG=u,e.$jG=w,e.$kG=R,e.$lG=f,e.$mG=b,e.$nG=L,e.$oG=N,e.$pG=M,e.$qG=W,e.$rG=me,e.$tG=ce,e.$uG=ae,e.$vG=Se,e.$wG=Oe,a=_t(a),e.$6F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$7F={id:"default",displayName:(0,v.localize)(4042,null),providerDisplayName:(0,v.localize)(4043,null)},e.$8F="workbench.editor.sidebysideEditor",e.$9F="workbench.editors.textDiffEditor",e.$0F="workbench.editors.binaryResourceDiffEditor";var S;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(X){const B=X;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function s(X){const B=X;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function c(X,B,te){for(const ye of te.visibleEditorPanes)if(ye.group.id===B&&X.matches(ye.input))return ye.getViewState()}function l(X){if(w(X))return!1;const B=X;return I.URI.isUri(B?.resource)}function i(X){if(w(X))return!1;const B=X;return B?.original!==void 0&&B.modified!==void 0}function n(X){if(w(X))return!1;const B=X;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function t(X){if(w(X)||i(X))return!1;const B=X;return B?.primary!==void 0&&B.secondary!==void 0}function g(X){if(w(X))return!1;const B=X;return B?B.resource===void 0||B.resource.scheme===o.Schemas.untitled||B.forceUntitled===!0:!1}function u(X){if(w(X))return!1;const B=X;return I.URI.isUri(B?.base?.resource)&&I.URI.isUri(B?.input1?.resource)&&I.URI.isUri(B?.input2?.resource)&&I.URI.isUri(B?.result?.resource)}var p;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var m;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class h{constructor(){this.a=new Map}registerSource(B,te){let ye=this.a.get(B);return ye||(ye={source:B,label:te},this.a.set(B,ye)),ye.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$hG=new h;var E;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends T.$Vc{}e.$iG=D;function w(X){return X instanceof D}function C(X){const B=X;return I.URI.isUri(B?.preferredResource)}function R(X){const B=X;return w(B?.primary)&&w(B?.secondary)}function f(X){const B=X;return w(B?.modified)&&w(B?.original)}function b(X,B,te,ye,de){return Oe(ye,[(0,y.$qj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(4044,null),run:()=>{const we={...te,limits:{size:Number.MAX_VALUE}};X.openEditor(B,we)}}),(0,y.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(4045,null),run:()=>de.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function L(X){return w(X?.editor)}function N(X){const B=X;return L(X)&&B?.group!==void 0}function M(X){const B=X;return typeof B?.groupId=="number"&&w(B.editor)}function W(X){return typeof X?.groupId=="number"}var G;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var q;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var J;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(J||(e.SideBySideEditor=J={}));class K{getOriginalUri(B,te){if(!B)return;if(u(B))return e.$sG.getOriginalUri(B.result,te);if(te?.supportSideBySide){const{primary:de,secondary:we}=this.a(B);if(de&&we){if(te?.supportSideBySide===J.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===J.ANY)return this.getOriginalUri(de,{filterByScheme:te.filterByScheme})??this.getOriginalUri(we,{filterByScheme:te.filterByScheme});B=te.supportSideBySide===J.PRIMARY?de:we}}if(i(B)||n(B)||t(B)||u(B))return;const ye=C(B)?B.preferredResource:B.resource;return!ye||!te||!te.filterByScheme?ye:this.b(ye,te.filterByScheme)}a(B){return R(B)||t(B)?{primary:B.primary,secondary:B.secondary}:f(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,te){if(!B)return;if(u(B))return e.$sG.getCanonicalUri(B.result,te);if(te?.supportSideBySide){const{primary:de,secondary:we}=this.a(B);if(de&&we){if(te?.supportSideBySide===J.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===J.ANY)return this.getCanonicalUri(de,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:te.filterByScheme});B=te.supportSideBySide===J.PRIMARY?de:we}}if(i(B)||n(B)||t(B)||u(B))return;const ye=B.resource;return!ye||!te||!te.filterByScheme?ye:this.b(ye,te.filterByScheme)}b(B,te){if(Array.isArray(te)){if(te.some(ye=>B.scheme===ye))return B}else if(te===B.scheme)return B}}var oe;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(oe||(e.EditorCloseMethod=oe={}));function me(X,B,te,ye){if(!X.isSticky(B))return!1;switch(ye.preventPinnedEditorClose){case"keyboardAndMouse":return te===oe.MOUSE||te===oe.KEYBOARD;case"mouse":return te===oe.MOUSE;case"keyboard":return te===oe.KEYBOARD}return!1}e.$sG=new K;var le;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class _{constructor(){this.c=new Map,this.d=new Map}start(B){const te=this.a=B.get(A.$Fi);for(const[ye,de]of this.c)this.e(ye,de,te);this.c.clear()}e(B,te,ye){const de=ye.createInstance(te);this.d.set(B,de)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,P.$qg)(this.b)}registerEditorSerializer(B,te){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,te,this.a):this.c.set(B,te),(0,T.$Tc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}O.$so.add(e.$6F.EditorFactory,new _);async function ce(X,B,te){return!X||!X.length?[]:await Promise.all(X.map(async ye=>{const de=I.URI.revive(ye.fileUri);if(!de){te.info("Cannot resolve the path because it is not valid.",ye);return}if(!await B.canHandleResource(de)){te.info("Cannot resolve the path because it cannot be handled",ye);return}let he=ye.exists,Z=ye.type;if(typeof he!="boolean"||typeof Z!="number")try{Z=(await B.stat(de)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(be){te.error(be),he=!1}if(!he&&ye.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ye);return}if(Z===$.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ye);return}const x={...ye.options,pinned:!0};return he?{resource:de,options:x}:{resource:de,options:x,forceUntitled:!0}}))}var pe;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function ae(X){const B=X;if(!B)return!1;const te=B;if(te.modified)return ae(te.modified);const ye=B;return!!(ye.contributionsState&&ye.viewState&&Array.isArray(ye.cursorState))}function Se(X){return(0,k.$sj)(X)}function Oe(X,B,te){const ye=(0,k.$tj)(X,B);return ye.forceMessage=te?.forceMessage,ye.forceSeverity=te?.forceSeverity,ye.allowDialog=te?.allowDialog,ye}}),define(Ne[192],Me([1,0,6,9,3,4,28,30,25,97,183]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$CG=e.ViewContentGroups=e.$AG=e.ViewContainerLocation=e.Extensions=e.$zG=e.$yG=e.$xG=void 0,e.$BG=S,e.$xG="views",e.$yG=(0,P.localize)(4205,null),e.$zG=(0,k.$Fx)("default-view-icon",o.$6j.window,(0,P.localize)(4206,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$AG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends T.$Vc{constructor(){super(...arguments),this.c=this.B(new v.$me),this.onDidRegister=this.c.event,this.f=this.B(new v.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,p,m){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$yc)(this.g,p,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:p}),E}deregisterViewContainer(u){for(const p of this.g.keys()){const m=this.g.get(p),h=m?.indexOf(u);if(h!==-1){m?.splice(h,1),m.length===0&&this.g.delete(p),this.f.fire({viewContainer:u,viewContainerLocation:p});return}}}get(u){return this.all.filter(p=>p.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(p=>this.getViewContainerLocation(p)===u)}}O.$so.add(y.ViewContainersRegistry,new d);var r;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(g,u){const p=g.group??r.More,m=u.group??r.More;return p!==m?p.localeCompare(m):(g.order??5)-(u.order??5)}class c extends T.$Vc{constructor(){super(...arguments),this.c=this.B(new v.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ic}registerViews(u,p){this.registerViews2([{views:u,viewContainer:p}])}registerViews2(u){u.forEach(({views:p,viewContainer:m})=>this.r(p,m)),this.c.fire(u)}deregisterViews(u,p){const m=this.s(u,p);m.length&&this.f.fire({views:m,viewContainer:p})}moveViews(u,p){for(const m of this.m.keys())if(m!==p){const h=this.s(u,m);h.length&&(this.r(h,p),this.g.fire({views:h,from:m,to:p}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const p of this.j){const m=(this.m.get(p)||[]).filter(h=>h.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const p of this.j)if((this.m.get(p)||[]).filter(h=>h.id===u)[0])return p;return null}registerViewWelcomeContent(u,p){return this.n.add(u,p),this.h.fire(u),(0,T.$Tc)(()=>{this.n.delete(u,p),this.h.fire(u)})}registerViewWelcomeContent2(u,p){const m=new Map;for(const[h,E]of p)this.n.add(u,E),m.set(h,(0,T.$Tc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const p=[];return this.n.forEach(u,m=>p.push(m)),p.sort(s)}r(u,p){let m=this.m.get(p);m||(m=[],this.m.set(p,m),this.j.push(p));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,P.localize)(4207,null,h.id));m.push(h)}}s(u,p){const m=this.m.get(p);if(!m)return[];const h=[],E=[];for(const D of m)u.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(p,E):(this.m.delete(p),this.j.splice(this.j.indexOf(p),1))),h}}O.$so.add(y.ViewsRegistry,new c),e.$CG=(0,I.$Gi)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(u,p){this.c=!1,this.d=!1,(0,$.$io)(this,u),this.d=!!p,this.resolve=async m=>{if(p&&!this.c){const h=await p(m);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$DG=n;class t extends Error{constructor(u){super((0,P.localize)(4208,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$EG=t}),define(Ne[193],Me([1,0,9,31]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG=new P.$Xj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(4679,null)}),e.$JG=new P.$Xj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,v.localize)(4680,null)}),e.$KG=new P.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(4681,null)}),e.$LG=new P.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(4682,null)}),e.$MG=new P.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(4683,null)}),e.$NG=new P.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4684,null)}),e.$OG=new P.$Xj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(4685,null)}),e.$PG=new P.$Xj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(4686,null)}),e.$QG=new P.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(4687,null)}),e.$RG=new P.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(4688,null)}),e.$SG=new P.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(4689,null)}),e.$TG=new P.$Xj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(4690,null)}),e.$UG=new P.$Xj("inChat",!1,{type:"boolean",description:(0,v.localize)(4691,null)}),e.$VG=new P.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(4692,null)}),e.$WG=new P.$Xj("chatCursorAtTop",!1),e.$XG=new P.$Xj("chatInputHasAgent",!1),e.$YG=new P.$Xj("chatLocation",void 0),e.$ZG=new P.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(4693,null)})}),define(Ne[116],Me([1,0,283,10,21,6,40,4,36,144,12,31,18,3,11,108,177,187,193]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.ChatAgentLocation=void 0,e.$6H=p,e.$7H=m;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(n||(e.ChatAgentLocation=n={})),e.$1H=(0,S.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new T.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=l.$VG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const C=this,R=D.slashCommands;D={...D,get slashCommands(){return R.filter(b=>!b.when||C.f.contextMatchesRules(y.$Ej.deserialize(b.when)))}};const f={data:D};return this.b.set(E,f),(0,O.$Tc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const w=this.b.get(E);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return w.data.isDefault&&this.e.set(!0),w.impl=D,this.d.fire(new g(w.data,D)),(0,O.$Tc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const w={data:E,impl:D};return this.b.set(E.id,w),this.d.fire(new g(E,D)),(0,O.$Tc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,w){return await this.g.get(E)?.(D,w)??[]}updateAgent(E,D){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);w.data.metadata={...w.data.metadata,...D},this.d.fire(new g(w.data,w.impl))}getDefaultAgent(E){return(0,v.$fb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=A.Iterable.find(this.b.values(),w=>p(w.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(w=>w.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,w,C,R){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,w,C,R)}async getFollowups(E,D,w,C,R){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,w,C,R):[]}registerChatParticipantDetectionProvider(E,D){return this.i.set(E,D),(0,O.$Tc)(()=>{this.i.delete(E)})}async detectAgentOrCommand(E,D,w,C){const R=A.Iterable.first(this.i.values());if(!R)return;const f=this.getAgents().reduce((M,W)=>{M.push({participant:W.id,description:void 0});for(const G of W.slashCommands)M.push({participant:W.id,command:G.name,description:void 0});return M},[]),b=await R.provideParticipantDetection(E,D,{...w,participants:f},C);if(!b)return;const L=this.getAgent(b.participant);if(!L)return;if(!b.command)return{agent:L};const N=L?.slashCommands.find(M=>M.name===b.command);if(N)return{agent:L,command:N}}};e.$2H=t,e.$2H=t=Je([We(0,y.$Yj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,w,C){return this.d.invoke(E,D,w,C)}async provideFollowups(E,D,w,C){return this.d.provideFollowups?this.d.provideFollowups(E,D,w,C):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$3H=g,e.$4H=(0,S.$Gi)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,w,C){if(this.g=D,this.h=w,this.i=C,this.e=(0,o.$7d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const R=C.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(R??"{}"),void 0)}catch{C.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,P.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},I.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$cq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const w=D.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),w=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&w}l(E,D){return this.e.map(C=>C[E.toLowerCase()]).map(C=>C?C.some(R=>(0,k.$Gf)(R,R.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$5H=u,e.$5H=u=i=Je([We(0,r.$uk),We(1,s.$9p),We(2,d.$bk),We(3,c.$jq)],u);function p(h){return`${h.extensionId.value}.${h.id}`}function m(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$sn("")),(0,$.$di)(E)}}),define(Ne[194],Me([1,0,2,32,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=e.$wH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$uH=T,e.$vH=A;function T(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof v.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(P.$Rt.isIRange)}function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(T)}var O;(function(k){k[k.Complete=1]="Complete",k[k.Partial=2]="Partial",k[k.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var $;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})($||(e.ChatAgentVoteDirection=$={}));var o;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(o||(e.ChatCopyKind=o={})),e.$wH=(0,I.$Gi)("IChatService"),e.$xH="accessibility.voice.keywordActivation"}),define(Ne[195],Me([1,0,6,10,9]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eub=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new v.$me,this.o=new v.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,$,o,k){const y={command:O};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof k=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:O,message:(0,I.localize)(5685,null,k,O)};S(d)}},k)}return o&&this.f.set(y.seq,o),y.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,$){return O.type!=="event"||$.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,P.$Hh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const $=O,o=this.f.get($.request_seq);o&&(this.f.delete($.request_seq),o($));break}}}}u(O,$){$.type=O,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach(($,o)=>O.set(o,$)),await(0,P.$Hh)(500),O.forEach(($,o)=>{$({type:"response",seq:0,request_seq:o,success:!1,command:"canceled",message:"canceled"}),this.f.delete(o)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$eub=T}),define(Ne[80],Me([1,0,2,9,31,3]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RK=e.MemoryRangeType=e.State=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0,e.$QK=$,e.$SK=k,P=Ve(P),e.$EJ="workbench.view.debug",e.$FJ="workbench.debug.variablesView",e.$GJ="workbench.debug.watchExpressionsView",e.$HJ="workbench.debug.callStackView",e.$IJ="workbench.debug.loadedScriptsView",e.$JJ="workbench.debug.breakPointsView",e.$KJ="workbench.debug.disassemblyView",e.$LJ="workbench.panel.repl",e.$MJ="workbench.panel.repl.view",e.$NJ=new I.$Xj("debugType",void 0,{type:"string",description:P.localize(5686,null)}),e.$OJ=new I.$Xj("debugConfigurationType",void 0,{type:"string",description:P.localize(5687,null)}),e.$PJ=new I.$Xj("debugState","inactive",{type:"string",description:P.localize(5688,null)}),e.$QJ="debugUx",e.$RJ=new I.$Xj(e.$QJ,"default",{type:"string",description:P.localize(5689,null)}),e.$SJ=new I.$Xj("hasDebugged",!1,{type:"boolean",description:P.localize(5690,null)}),e.$TJ=new I.$Xj("inDebugMode",!1,{type:"boolean",description:P.localize(5691,null)}),e.$UJ=new I.$Xj("inDebugRepl",!1,{type:"boolean",description:P.localize(5692,null)}),e.$VJ=new I.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:P.localize(5693,null)}),e.$WJ=new I.$Xj("inBreakpointWidget",!1,{type:"boolean",description:P.localize(5694,null)}),e.$XJ=new I.$Xj("breakpointsFocused",!0,{type:"boolean",description:P.localize(5695,null)}),e.$YJ=new I.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:P.localize(5696,null)}),e.$ZJ=new I.$Xj("watchExpressionsExist",!1,{type:"boolean",description:P.localize(5697,null)}),e.$1J=new I.$Xj("variablesFocused",!0,{type:"boolean",description:P.localize(5698,null)}),e.$2J=new I.$Xj("expressionSelected",!1,{type:"boolean",description:P.localize(5699,null)}),e.$3J=new I.$Xj("breakpointInputFocused",!1,{type:"boolean",description:P.localize(5700,null)}),e.$4J=new I.$Xj("callStackItemType",void 0,{type:"string",description:P.localize(5701,null)}),e.$5J=new I.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:P.localize(5702,null)}),e.$6J=new I.$Xj("callStackItemStopped",!1,{type:"boolean",description:P.localize(5703,null)}),e.$7J=new I.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:P.localize(5704,null)}),e.$8J=new I.$Xj("watchItemType",void 0,{type:"string",description:P.localize(5705,null)}),e.$9J=new I.$Xj("canViewMemory",void 0,{type:"boolean",description:P.localize(5706,null)}),e.$0J=new I.$Xj("breakpointItemType",void 0,{type:"string",description:P.localize(5707,null)}),e.$$J=new I.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:P.localize(5708,null)}),e.$_J=new I.$Xj("breakpointHasModes",!1,{type:"boolean",description:P.localize(5709,null)}),e.$aK=new I.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:P.localize(5710,null)}),e.$bK=new I.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:P.localize(5711,null)}),e.$cK=new I.$Xj("loadedScriptsItemType",void 0,{type:"string",description:P.localize(5712,null)}),e.$dK=new I.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:P.localize(5713,null)}),e.$eK=new I.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:P.localize(5714,null)}),e.$fK=new I.$Xj("stepBackSupported",!1,{type:"boolean",description:P.localize(5715,null)}),e.$gK=new I.$Xj("restartFrameSupported",!1,{type:"boolean",description:P.localize(5716,null)}),e.$hK=new I.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:P.localize(5717,null)}),e.$iK=new I.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:P.localize(5718,null)}),e.$jK=new I.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:P.localize(5719,null)}),e.$kK=new I.$Xj("breakpointsExist",!1,{type:"boolean",description:P.localize(5720,null)}),e.$lK=new I.$Xj("debuggersAvailable",!1,{type:"boolean",description:P.localize(5721,null)}),e.$mK=new I.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:P.localize(5722,null)}),e.$nK=new I.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:P.localize(5723,null)}),e.$oK=new I.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:P.localize(5724,null)}),e.$pK=new I.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:P.localize(5725,null)}),e.$qK=new I.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:P.localize(5726,null)}),e.$rK=new I.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:P.localize(5727,null)}),e.$sK=new I.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:P.localize(5728,null)}),e.$tK=new I.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:P.localize(5729,null)}),e.$uK=new I.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:P.localize(5730,null)}),e.$vK=new I.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:P.localize(5731,null)}),e.$wK=new I.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:P.localize(5732,null)}),e.$xK=new I.$Xj("variableIsReadonly",!1,{type:"boolean",description:P.localize(5733,null)}),e.$yK=new I.$Xj("variableValue",!1,{type:"string",description:P.localize(5734,null)}),e.$zK=new I.$Xj("variableType",!1,{type:"string",description:P.localize(5735,null)}),e.$AK=new I.$Xj("variableInterfaces",!1,{type:"array",description:P.localize(5736,null)}),e.$BK=new I.$Xj("variableName",!1,{type:"string",description:P.localize(5737,null)}),e.$CK=new I.$Xj("variableLanguage",!1,{type:"string",description:P.localize(5738,null)}),e.$DK=new I.$Xj("variableExtensionId",!1,{type:"string",description:P.localize(5739,null)}),e.$EK=new I.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:P.localize(5740,null)}),e.$FK=new I.$Xj("multiSessionRepl",!1,{type:"boolean",description:P.localize(5741,null)}),e.$GK=new I.$Xj("multiSessionDebug",!1,{type:"boolean",description:P.localize(5742,null)}),e.$HK=new I.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:P.localize(5743,null)}),e.$IK=new I.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:P.localize(5744,null)}),e.$JK=new I.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:P.localize(5745,null)}),e.$KK=new I.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:P.localize(5746,null)});const A=i=>P.localize(5747,null,i);e.$LK=A,e.$MK="editor.contrib.debug",e.$NK="editor.contrib.breakpoint",e.$OK="debug",e.$PK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:P.localize(5748,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function $(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var o;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$RK="vscode-debug-memory";function k(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$TK=(0,T.$Gi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var c;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(c||(e.IDebugVisualizationTreeItem=c={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(Ne[196],Me([1,0,12,2,19,25,15,32,21,17]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=void 0,e.$_H=y,e.$aI=a,e.$bI=S,e.$cI=d,e.$dI=r,e.$eI=s,e.$fI=c,e.$gI=i,e.$hI=g,e.$iI=u,e.$jI=m,e.$kI=E;const k=/{([^}]+)}/g;function y(w,C,R){return w.replace(k,function(f,b){return C&&b.length>0&&b[0]!=="_"?f:R&&R.hasOwnProperty(b)?R[b]:f})}function a(w){const C={};for(const R of Object.keys(w))R.startsWith("!")||(C[R]=w[R]);return C}function S(w){return w.configuration.request==="attach"&&!d(w)&&(!w.parentSession||S(w.parentSession))}function d(w){let C=w.configuration.type;if(C)return C==="vslsShare"&&(C=w.configuration.adapterProxy.configuration.type),(0,v.$Gf)(C,"extensionhost")||(0,v.$Gf)(C,"pwa-extensionhost")?w:w.parentSession?d(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function s(w,C,R){let f,b=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=L.exec(w);){const M=N.index+1,W=M+N[0].length;if(M<=C&&W>=R){f=N[0],b=M;break}}if(f){const M=/(\w|\p{L})+/gu;let W=null;for(;(W=M.exec(f))&&!(W.index+1+b+W[0].length>=R););W&&(f=f.substring(0,M.lastIndex))}return f?{start:b,end:b+f.length-1}:{start:0,end:0}}async function c(w,C,R,f){if(w.evaluatableExpressionProvider.has(C)){const b=w.evaluatableExpressionProvider.ordered(C),L=(0,o.$Hb)(await Promise.all(b.map(async N=>{try{return await N.provideEvaluatableExpression(C,R,f??$.CancellationToken.None)}catch{return}})));if(L.length>0){let N=L[0].expression;const M=L[0].range;return N||(N=C.getLineContent(R.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:N}}}else{const b=C.getLineContent(R.lineNumber),{start:L,end:N}=s(b,R.column,R.column),M=b.substring(L-1,N);return{matchingExpression:M,range:new O.$Rt(R.lineNumber,L,R.lineNumber,L+M.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function n(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return P.URI.parse(w.path);if((0,I.$jc)(w.path))return P.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const C=P.URI.revive(w.path);if(C)return C.scheme===A.Schemas.file?C.fsPath:C.toString()}return w.path}function g(w,C){const R=C?n:t,f=(0,T.$fo)(w);return p(f,(b,L)=>{b&&L&&(L.path=R(L))}),f}function u(w,C){const R=C?n:t,f=(0,T.$fo)(w);return p(f,(b,L)=>{!b&&L&&(L.path=R(L))}),f}function p(w,C){switch(w.type){case"event":{const R=w;switch(R.event){case"output":C(!1,R.body.source);break;case"loadedSource":C(!1,R.body.source);break;case"breakpoint":C(!1,R.body.breakpoint.source);break;default:break}break}case"request":{const R=w;switch(R.command){case"setBreakpoints":C(!0,R.arguments.source);break;case"breakpointLocations":C(!0,R.arguments.source);break;case"source":C(!0,R.arguments.source);break;case"gotoTargets":C(!0,R.arguments.source);break;case"launchVSCode":R.arguments.args.forEach(f=>C(!1,f));break;default:break}break}case"response":{const R=w;if(R.success&&R.body)switch(R.command){case"stackTrace":R.body.stackFrames.forEach(f=>C(!1,f.source));break;case"loadedSources":R.body.sources.forEach(f=>C(!1,f));break;case"scopes":R.body.scopes.forEach(f=>C(!1,f.source));break;case"setFunctionBreakpoints":R.body.breakpoints.forEach(f=>C(!1,f.source));break;case"setBreakpoints":R.body.breakpoints.forEach(f=>C(!1,f.source));break;case"disassemble":R.body?.instructions.forEach(b=>C(!1,b.location));break;default:break}break}}}function m(w){return w.filter(C=>!C.presentation?.hidden).sort((C,R)=>C.presentation?R.presentation?C.presentation.group?R.presentation.group?C.presentation.group!==R.presentation.group?C.presentation.group.localeCompare(R.presentation.group):h(C.presentation.order,R.presentation.order):-1:R.presentation.group?1:h(C.presentation.order,R.presentation.order):-1:R.presentation?1:0)}function h(w,C){return typeof w!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:w-C}async function E(w,C){const R=w.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(R!=="none"&&(await C.saveAll(),R==="allEditorsInActiveGroup")){const f=C.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await C.save({editor:f.input,groupId:f.group.id})}await w.reloadConfiguration()}const D=(w,C)=>!w||!C?w===C:w.name===C.name&&w.path===C.path&&w.sourceReference===C.sourceReference;e.$lI=D}),define(Ne[197],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.CellExecutionUpdateType=void 0;var P;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.$2K=(0,v.$Gi)("INotebookExecutionService")}),define(Ne[198],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=e.ProxyKernelState=e.$4K=void 0,e.$4K=100;var P;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(P||(e.ProxyKernelState=P={})),e.$5K=(0,v.$Gi)("INotebookKernelService"),e.$6K=(0,v.$Gi)("INotebookKernelHistoryService")}),define(Ne[199],Me([1,0,4,32,52,163,102]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x1b=void 0;class O extends v.$Vc{constructor(o,k,y){super(),this._source=o,this.b=k,this.c=y,this.a=void 0}f(o){const k=o.getLineCount();return new P.$Rt(1,1,k,this.g(o,k))}g(o,k){if(k<1||k>o.getLineCount())throw new Error("Illegal value for lineNumber");return o.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const o=new T.$AD;o.acceptChunk(this._source);const k=o.finish(!0),{textBuffer:y,disposable:a}=k.create(I.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(o=>{const k=new T.$AD;k.acceptChunk(o);const y=k.finish(!0),{textBuffer:a,disposable:S}=y.create(I.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(o){const y=new A.$oD(o,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(o){const y=new A.$oD(o,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$x1b=O}),define(Ne[54],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(T){T.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var P;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class I{static fromExtHostTestItem(A,O,$=A.parent){if(A._isRoot)return new I([O]);const o=[A.id];for(let k=$;k&&k.id!==O;k=k.parent)o.push(k.id);return o.push(O),new I(o.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const O=A.indexOf(v.Delimiter);return O===-1?A:A.slice(0,O)}static fromString(A){return new I(A.split(v.Delimiter))}static join(A,O){return new I([...A.path,O])}static joinToString(A,O){return A.toString()+v.Delimiter+O}static parentId(A){const O=A.lastIndexOf(v.Delimiter);return O===-1?void 0:A.slice(0,O)}static localId(A){const O=A.lastIndexOf(v.Delimiter);return O===-1?A:A.slice(O+v.Delimiter.length)}static isChild(A,O){return O[A.length]===v.Delimiter&&O.startsWith(A)}static compare(A,O){return A===O?P.IsSame:I.isChild(A,O)?P.IsChild:I.isChild(O,A)?P.IsParent:P.Disconnected}static getLengthOfCommonPrefix(A,O){if(A===0)return 0;let $=0;for(;$<A-1;){for(let o=1;o<A;o++){const k=O(o-1),y=O(o);if(k.path[$]!==y.path[$])return $}$++}return $}constructor(A,O=A.length){if(this.path=A,this.d=O,A.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let O=0;O<A.d&&O<this.d;O++)if(A.path[O]!==this.path[O])return P.Disconnected;return A.d>this.d?P.IsChild:A.d<this.d?P.IsParent:P.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$$I=I}),define(Ne[55],Me([1,0,2,101,32,54]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$gJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$_I=e.TestResultState=void 0;var A;(function(J){J[J.Unset=0]="Unset",J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$_I={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var O;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var $;(function(J){J[J.Refresh=2]="Refresh",J[J.CodeRelatedToTest=4]="CodeRelatedToTest",J[J.TestRelatedToCode=8]="TestRelatedToCode"})($||(e.TestControllerCapability=$={}));var o;(function(J){J[J.Run=2]="Run",J[J.Debug=4]="Debug",J[J.Coverage=8]="Coverage",J[J.HasNonDefaultProfile=16]="HasNonDefaultProfile",J[J.HasConfigurable=32]="HasConfigurable",J[J.SupportsContinuousRun=64]="SupportsContinuousRun"})(o||(e.TestRunProfileBitset=o={})),e.$aJ=[o.Run,o.Debug,o.Coverage,o.HasNonDefaultProfile,o.HasConfigurable,o.SupportsContinuousRun];const k=J=>"runId"in J;e.$bJ=k;var y;(function(J){J.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),J.deserialize=(K,oe)=>({range:I.$Rt.lift(oe.range),uri:K.asCanonicalUri(v.URI.revive(oe.uri))})})(y||(e.IRichLocation=y={}));var a;(function(J){J[J.Error=0]="Error",J[J.Output=1]="Output"})(a||(e.TestMessageType=a={}));var S;(function(J){J.serialize=K=>({label:K.label,uri:K.uri?.toJSON(),position:K.position?.toJSON()}),J.deserialize=(K,oe)=>({label:oe.label,uri:oe.uri?K.asCanonicalUri(v.URI.revive(oe.uri)):void 0,position:oe.position?P.$Qt.lift(oe.position):void 0})})(S||(e.ITestMessageStackFrame=S={}));var d;(function(J){J.serialize=K=>({message:K.message,type:a.Error,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&y.serialize(K.location),stackTrace:K.stackTrace?.map(S.serialize)}),J.deserialize=(K,oe)=>({message:oe.message,type:a.Error,expected:oe.expected,actual:oe.actual,contextValue:oe.contextValue,location:oe.location&&y.deserialize(K,oe.location),stackTrace:oe.stackTrace&&oe.stackTrace.map(me=>S.deserialize(K,me))})})(d||(e.ITestErrorMessage=d={}));const r=(J,K)=>`${K?"s":"e"}${J}`;e.$cJ=r;var s;(function(J){J.serialize=K=>({message:K.message,type:a.Output,offset:K.offset,length:K.length,location:K.location&&y.serialize(K.location)}),J.deserialize=(K,oe)=>({message:oe.message,type:a.Output,offset:oe.offset,length:oe.length,location:oe.location&&y.deserialize(K,oe.location)})})(s||(e.ITestOutputMessage=s={}));var c;(function(J){J.serialize=K=>K.type===a.Error?d.serialize(K):s.serialize(K),J.deserialize=(K,oe)=>oe.type===a.Error?d.deserialize(K,oe):s.deserialize(K,oe),J.isDiffable=K=>K.type===a.Error&&K.actual!==void 0&&K.expected!==void 0})(c||(e.ITestMessage=c={}));var l;(function(J){J.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),J.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(c.serialize)}),J.deserialize=(K,oe)=>({state:oe.state,duration:oe.duration,messages:oe.messages.map(me=>c.deserialize(K,me))})})(l||(e.ITestTaskState=l={}));const i="\0",n=(J,K)=>J+i+K;e.$dJ=n;const t=J=>{const K=J.indexOf(i);return{ctrlId:J.slice(0,K),tagId:J.slice(K+1)}};e.$eJ=t;var g;(function(J){J.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),J.deserialize=(K,oe)=>({extId:oe.extId,label:oe.label,tags:oe.tags,busy:oe.busy,children:void 0,uri:oe.uri?K.asCanonicalUri(v.URI.revive(oe.uri)):void 0,range:oe.range?I.$Rt.lift(oe.range):null,description:oe.description,error:oe.error,sortText:oe.sortText})})(g||(e.ITestItem=g={}));var u;(function(J){J[J.NotExpandable=0]="NotExpandable",J[J.Expandable=1]="Expandable",J[J.BusyExpanding=2]="BusyExpanding",J[J.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var p;(function(J){J.serialize=K=>({expand:K.expand,item:g.serialize(K.item)}),J.deserialize=(K,oe)=>({controllerId:T.$$I.root(oe.item.extId),expand:oe.expand,item:g.deserialize(K,oe.item)})})(p||(e.InternalTestItem=p={}));var m;(function(J){J.serialize=K=>{let oe;return K.item&&(oe={},K.item.label!==void 0&&(oe.label=K.item.label),K.item.tags!==void 0&&(oe.tags=K.item.tags),K.item.busy!==void 0&&(oe.busy=K.item.busy),K.item.uri!==void 0&&(oe.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(oe.range=K.item.range?.toJSON()),K.item.description!==void 0&&(oe.description=K.item.description),K.item.error!==void 0&&(oe.error=K.item.error),K.item.sortText!==void 0&&(oe.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:oe}},J.deserialize=K=>{let oe;return K.item&&(oe={},K.item.label!==void 0&&(oe.label=K.item.label),K.item.tags!==void 0&&(oe.tags=K.item.tags),K.item.busy!==void 0&&(oe.busy=K.item.busy),K.item.range!==void 0&&(oe.range=K.item.range?I.$Rt.lift(K.item.range):null),K.item.description!==void 0&&(oe.description=K.item.description),K.item.error!==void 0&&(oe.error=K.item.error),K.item.sortText!==void 0&&(oe.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:oe}}})(m||(e.ITestItemUpdate=m={}));const h=(J,K)=>{K.expand!==void 0&&(J.expand=K.expand),K.item!==void 0&&(J.item=J.item?Object.assign(J.item,K.item):K.item)};e.$fJ=h;var E;(function(J){J.serializeWithoutMessages=K=>({...p.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(l.serializeWithoutMessages)}),J.serialize=K=>({...p.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(l.serialize)}),J.deserialize=(K,oe)=>({...p.deserialize(K,oe),ownComputedState:oe.ownComputedState,computedState:oe.computedState,tasks:oe.tasks.map(me=>l.deserialize(K,me)),retired:!0})})(E||(e.TestResultItem=E={}));var D;(function(J){J.empty=()=>({covered:0,total:0}),J.sum=(K,oe)=>{K.covered+=oe.covered,K.total+=oe.total}})(D||(e.ICoverageCount=D={}));var w;(function(J){J.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testIds:K.testIds,uri:K.uri.toJSON()}),J.deserialize=(K,oe)=>({id:oe.id,statement:oe.statement,branch:oe.branch,declaration:oe.declaration,testIds:oe.testIds,uri:K.asCanonicalUri(v.URI.revive(oe.uri))}),J.empty=(K,oe)=>({id:K,uri:oe,statement:D.empty()})})(w||(e.IFileCoverage=w={}));function C(J){return{...J,location:J.location?.toJSON()}}function R(J){return J.location=J.location?P.$Qt.isIPosition(J.location)?P.$Qt.lift(J.location):I.$Rt.lift(J.location):void 0,J}e.$gJ=3;var f;(function(J){J[J.Declaration=0]="Declaration",J[J.Statement=1]="Statement",J[J.Branch=2]="Branch"})(f||(e.DetailType=f={}));var b;(function(J){J.serialize=K=>K.type===f.Declaration?N.serialize(K):M.serialize(K),J.deserialize=K=>K.type===f.Declaration?N.deserialize(K):M.deserialize(K)})(b||(e.CoverageDetails=b={}));var L;(function(J){J.serialize=C,J.deserialize=R})(L||(e.IBranchCoverage=L={}));var N;(function(J){J.serialize=C,J.deserialize=R})(N||(e.IDeclarationCoverage=N={}));var M;(function(J){J.serialize=K=>({...C(K),branches:K.branches?.map(L.serialize)}),J.deserialize=K=>({...R(K),branches:K.branches?.map(L.deserialize)})})(M||(e.IStatementCoverage=M={}));var W;(function(J){J[J.Add=0]="Add",J[J.Update=1]="Update",J[J.DocumentSynced=2]="DocumentSynced",J[J.Remove=3]="Remove",J[J.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",J[J.Retire=5]="Retire",J[J.AddTag=6]="AddTag",J[J.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var G;(function(J){J.deserialize=(K,oe)=>oe.op===W.Add?{op:oe.op,item:p.deserialize(K,oe.item)}:oe.op===W.Update?{op:oe.op,item:m.deserialize(oe.item)}:oe.op===W.DocumentSynced?{op:oe.op,uri:K.asCanonicalUri(v.URI.revive(oe.uri)),docv:oe.docv}:oe,J.serialize=K=>K.op===W.Add?{op:K.op,item:p.serialize(K.item)}:K.op===W.Update?{op:K.op,item:m.serialize(K.item)}:K})(G||(e.TestsDiffOp=G={}));class q{constructor(K){this.l=K,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(K){const oe=this.x();for(const me of K)switch(me.op){case W.Add:this.p(p.deserialize(this.l,me.item),oe);break;case W.Update:this.q(m.deserialize(me.item),oe);break;case W.Remove:this.v(me.itemId,oe);break;case W.Retire:this.w(me.itemId);break;case W.IncrementPendingExtHosts:this.updatePendingRoots(me.amount);break;case W.AddTag:this.f.set(me.tag.id,me.tag);break;case W.RemoveTag:this.f.delete(me.id);break}oe.complete?.()}p(K,oe){const me=T.$$I.parentId(K.item.extId)?.toString();let le;if(!me)le=this.y(K),this.h.add(le),this.g.set(K.item.extId,le);else if(this.g.has(me)){const _=this.g.get(me);_.children.add(K.item.extId),le=this.y(K,_),this.g.set(K.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return oe.add?.(le),K.expand===u.BusyExpanding&&this.j++,le}q(K,oe){const me=this.g.get(K.extId);if(me)return K.expand!==void 0&&(me.expand===u.BusyExpanding&&this.j--,K.expand===u.BusyExpanding&&this.j++),(0,e.$fJ)(me,K),oe.update?.(me),me}v(K,oe){const me=this.g.get(K);if(!me)return;const le=T.$$I.parentId(me.item.extId)?.toString();le?this.g.get(le).children.delete(me.item.extId):this.h.delete(me);const _=[[K]];for(;_.length;)for(const ce of _.pop()){const pe=this.g.get(ce);pe&&(_.push(pe.children),this.g.delete(ce),oe.remove?.(pe,pe!==me),pe.expand===u.BusyExpanding&&this.j--)}}w(K){}updatePendingRoots(K){this.k+=K}x(){return{}}}e.$hJ=q}),define(Ne[200],Me([1,0,98,9,55]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$VGb=e.$UGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var O;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const $={[I.TestResultState.Errored]:(0,P.localize)(10787,null),[I.TestResultState.Failed]:(0,P.localize)(10788,null),[I.TestResultState.Passed]:(0,P.localize)(10789,null),[I.TestResultState.Queued]:(0,P.localize)(10790,null),[I.TestResultState.Running]:(0,P.localize)(10791,null),[I.TestResultState.Skipped]:(0,P.localize)(10792,null),[I.TestResultState.Unset]:(0,P.localize)(10793,null)},o=(y,a)=>(0,P.localize)(10794,null,(0,v.$1k)(y),$[a]);e.$UGb=o,e.$VGb={[I.TestRunProfileBitset.Debug]:(0,P.localize)(10795,null),[I.TestRunProfileBitset.Run]:(0,P.localize)(10796,null),[I.TestRunProfileBitset.Coverage]:(0,P.localize)(10797,null)};var k;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(k||(e.TestCommandId=k={}))}),define(Ne[81],Me([1,0,10,6,4,61,55,54]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.TestItemEventOp=void 0;var $;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const o=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:o,label:o,description:o,error:o,sortText:o,tags:(l,i)=>!(l.length!==i.length||l.some(n=>!i.includes(n)))}),a=(l,i)=>{let n;for(const[t,g]of y)g(l[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class S extends I.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new P.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===A.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===A.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,A.$fJ)(n.item,i.item);return}if(n.op===A.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,A.$fJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,n-1):g.wait().then(()=>this.L(t,n-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case $.RemoveChild:this.O(O.$$I.joinToString(i.fullId,n.id));break;case $.Upsert:this.z(n.item,i);break;case $.Bulk:for(const t of n.ops)this.w(i,t);break;case $.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,T.$fd)(n)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=O.$$I.fromExtHostTestItem(i,this.root.id,n?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==n?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,n),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,n);return}if(u.actual===i){this.H(i,u,n);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const p=this.s.getChildren(u.actual),m=u.actual,h=a(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete h.tags),this.w(u,{op:$.SetProp,update:h})),this.I(i,u,n);for(const[D,w]of p)this.s.getChildren(i).get(w.id)||this.O(O.$$I.joinToString(t,w.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,n,t){const g=new Set(n.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.$dJ)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$dJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$dJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(n,u),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[g,u]of this.s.getChildren(i))this.z(u,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:n=A.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const p=this.expand(O.$$I.joinToString(i.fullId,u.id),n);(0,v.$sh)(p)&&t.push(p)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Fh;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Fh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$sh)(g)?g.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,p]of this.s.getChildren(g.actual))t.push(this.tree.get(O.$$I.joinToString(g.fullId,p.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$eQ=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$fQ=d;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gQ=r;class s extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$hQ=s;const c=(l,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const p of t.values())g.call(u,p,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,p=new Set(t.keys()),m={op:$.Bulk,ops:[]};for(const h of g){if(!(h instanceof n))throw new r(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new s(h.id,E,l.controllerId);if(u.has(h.id))throw new d(h.id);u.set(h.id,h),p.delete(h.id),m.ops.push({op:$.Upsert,item:h})}for(const h of p.keys())m.ops.push({op:$.RemoveChild,id:h});l.listener?.(m),t=u},add(g){if(!(g instanceof n))throw new r(g.id);t.set(g.id,g),l.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$iQ=c}),define(Ne[117],Me([1,0,81]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0;const P=new WeakMap,I=(A,O)=>{const $={controllerId:O};return P.set(A,$),$};e.$jQ=I;const T=A=>{const O=P.get(A);if(!O)throw new v.$gQ(A?.id||"<unknown>");return O};e.$kQ=T}),define(Ne[82],Me([1,0,27,15,2]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ODb=e.$NDb=e.$MDb=void 0,e.$PDb=T,e.$QDb=O,e.$MDb="vscode-cdn.net",e.$NDb=`vscode-resource.${e.$MDb}`,e.$ODb=`'self' https://*.${e.$MDb}`;function T($,o){return $.scheme===P.Schemas.http||$.scheme===P.Schemas.https?$:(o&&o.authority&&o.isRemote&&$.scheme===P.Schemas.file&&($=I.URI.from({scheme:P.Schemas.vscodeRemote,authority:o.authority,path:$.path})),I.URI.from({scheme:P.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$NDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,o=>{const k=o.charCodeAt(0);return k>=v.CharCode.a&&k<=v.CharCode.z||k>=v.CharCode.A&&k<=v.CharCode.Z||k>=v.CharCode.Digit0&&k<=v.CharCode.Digit9?o:"-"+k.toString(16).padStart(4,"0")})}function O($){return $.replace(/-([0-9a-f]{4})/g,(o,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ne[201],Me([1,0,6,4,82]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0;class T{constructor(O,$,o){this.d=O,this.e=$,this.f=o,this.a=0,this.b=new P.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const k=$.getVisibleTextEditors();for(const y of this.c.values())k.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,$,o,k,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,r=new v.$me,s=new v.$me,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,I.$PDb)(i,S.f)}get cspSource(){return I.$ODb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return S.d.$postMessage(d,i)}},l=new class{constructor(){this.editor=O,this.line=$,this.height=o,this.webview=c,this.onDidDispose=s.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,$+1,o,k||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:O,inset:l,onDidReceiveMessage:r}),l}$onDidDispose(O){const $=this.c.get(O);$&&$.inset.dispose()}$onDidReceiveMessage(O,$){this.c.get(O)?.onDidReceiveMessage.fire($)}}e.$1pc=T}),define(Ne[118],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0,e.$QM="__",e.$RM=(0,v.$Gi)("IAuthenticationService"),e.$SM=(0,v.$Gi)("IAuthenticationExtensionsService")}),define(Ne[202],Me([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=e.VariableKind=e.$cR=void 0,e.$cR=(0,v.$Gi)("configurationResolverService");var P;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class I extends Error{constructor(A,O){super(O),this.variable=A}}e.$dR=I}),define(Ne[203],Me([1,0,19,78,14,25,20,99,9,202,12]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=void 0,v=Ve(v),P=Ve(P),I=Ve(I),T=Ve(T);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,r,s){this.h=new Map,this.a=S,this.b=d,this.g=r,s&&(this.c=s.then(c=>this.i(c)))}i(S){if(A.$j){const d=Object.create(null);return Object.keys(S).forEach(r=>{d[r.toLowerCase()]=S[r]}),d}return S}resolveWithEnvironment(S,d,r){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(S,d){const r={env:await this.c,userHome:await this.g};return this.l(r,S?S.uri:void 0,d)}async j(S,d,r,s){const c=T.$fo(d);A.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):A.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):A.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,c,r,s)}async resolveAnyAsync(S,d,r){return this.j(S,d,r)}async resolveAnyMap(S,d,r){const s=new Map;return{newConfig:await this.j(S,d,r,s),resolvedVariables:s}}resolveWithInteractionReplace(S,d,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,r,s,c){if(I.$fg(r))return this.m(S,d,r,s,c);if(Array.isArray(r))return Promise.all(r.map(l=>this.l(S,d,l,s,c)));if(I.$hg(r)){const l=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(S,d,n,s,c),await this.l(S,d,r[n],s,c)]));for(const[n,t]of i)l[n]=t;return l}return r}m(S,d,r,s,c){return(0,k.$yf)(r,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let n=await this.o(S,l,i,d,s);return c?.set(i,n),n!==l&&I.$fg(n)&&n.match(y.VARIABLE_REGEXP)&&(n=await this.m(S,d,n,s,c)),n})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,r,s,c){let l;const i=r.split(":");i.length>1&&(r=i[0],l=i[1]);const n=u=>{const p=this.a.getFilePath();if(p)return(0,O.$5w)(p);throw new o.$dR(u,(0,$.localize)(12038,null,d))},t=u=>{const p=n(u);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,O.$5w)(m)}throw new o.$dR(u,(0,$.localize)(12039,null,d,v.$oc(p)))},g=u=>{if(l){const p=this.a.getFolderUri(l);if(p)return p;throw new o.$dR(u,(0,$.localize)(12040,null,d,l))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new o.$dR(u,(0,$.localize)(12041,null,d)):new o.$dR(u,(0,$.localize)(12042,null,d))};switch(r){case"env":if(l){if(S.env){const u=S.env[A.$j?l.toLowerCase():l];if(I.$fg(u))return u}return""}throw new o.$dR(o.VariableKind.Env,(0,$.localize)(12043,null,d));case"config":if(l){const u=this.a.getConfigurationValue(s,l);if(I.$og(u))throw new o.$dR(o.VariableKind.Config,(0,$.localize)(12044,null,d,l));if(I.$hg(u))throw new o.$dR(o.VariableKind.Config,(0,$.localize)(12045,null,d,l));return u}throw new o.$dR(o.VariableKind.Config,(0,$.localize)(12046,null,d));case"command":return this.p(o.VariableKind.Command,d,l,c,"command");case"input":return this.p(o.VariableKind.Input,d,l,c,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new o.$dR(o.VariableKind.ExtensionInstallFolder,(0,$.localize)(12047,null,d,l));return this.n(u.extensionLocation)}throw new o.$dR(o.VariableKind.ExtensionInstallFolder,(0,$.localize)(12048,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,O.$5w)(this.n(g(o.VariableKind.WorkspaceFolder)));case"cwd":return s||l?(0,O.$5w)(this.n(g(o.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$5w)(v.$oc(this.n(g(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new o.$dR(o.VariableKind.UserHome,(0,$.localize)(12049,null,d))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new o.$dR(o.VariableKind.LineNumber,(0,$.localize)(12050,null,d))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new o.$dR(o.VariableKind.SelectedText,(0,$.localize)(12051,null,d))}case"file":return n(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$oc(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||l?v.$mc(this.n(g(o.VariableKind.RelativeFile)),n(o.VariableKind.RelativeFile)):n(o.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$nc(n(o.VariableKind.RelativeFileDirname));if(s||l){const p=v.$mc(this.n(g(o.VariableKind.RelativeFileDirname)),u);return p.length===0?".":p}return u}case"fileDirname":return v.$nc(n(o.VariableKind.FileDirname));case"fileExtname":return v.$pc(n(o.VariableKind.FileExtname));case"fileBasename":return v.$oc(n(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$oc(n(o.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$pc(u).length)}case"fileDirnameBasename":return v.$oc(v.$nc(n(o.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||d}case"execInstallFolder":{const u=this.a.getAppRoot();return u||d}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${r}:${l}`:r;return this.p(o.VariableKind.Unknown,d,u,c,void 0)}catch{return d}}}}p(S,d,r,s,c){if(r&&s){const l=c===void 0?s[r]:s[c+":"+r];if(typeof l=="string")return l;throw new o.$dR(S,(0,$.localize)(12052,null,d))}return d}}e.$sR=y}),define(Ne[119],Me([1,0,3,115]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$xE=void 0,e.$yE=o,e.$zE=a,e.$AE=S,e.$xE=(0,v.$Gi)("editorGroupsService");var I;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var T;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var O;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function o(d){const r=d;return(0,P.$jG)(r?.editor)&&(0,P.$jG)(r?.replacement)}var k;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k||(e.GroupsOrder=k={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Ne[204],Me([1,0,3,119]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=e.$DE=e.$CE=e.$BE=void 0,e.$FE=I,e.$BE=(0,v.$Gi)("editorService"),e.$CE=-1,e.$DE=-2,e.$EE=-3;function I(T){const A=T;return typeof T=="number"||(0,P.$zE)(A)}}),define(Ne[205],Me([1,0,3,106]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$_M=(0,v.$Hi)(P.$Ni)}),define(Ne[120],Me([1,0,18,6,19,4,10]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=e.$4dc=e.$3dc=void 0,I=Ve(I);class O{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$3dc=O;class ${static isHostExtension(l,i,n){if(i.getExtensionDescription(l))return!1;const t=n.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new P.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$un,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=s(this.e,i),this.e=this.e.concat(l);const n=$.l(this.e);return this.e=s(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,n)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(p){this.d.has(p)||(this.d.add(p),this.e.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this.c.has(p)?this.c.get(p).push(m):this.c.set(p,[m])}getArcs(p){return this.c.has(p)?this.c.get(p):[]}hasOnlyGoodArcs(p,m){const h=i.getArcs(p);for(let E=0;E<h.length;E++)if(!m.has(h[E]))return!1;return!0}getNodes(){return this.e}},n=new v.$un;for(const p of l)if(n.set(p.identifier,p),p.extensionDependencies)for(const m of p.extensionDependencies)i.addArc(v.$sn.toKey(p.identifier),v.$sn.toKey(m));const t=new Set;i.getNodes().filter(p=>i.getArcs(p).length===0).forEach(p=>t.add(p));const g=i.getNodes().filter(p=>!t.has(p));let u;do{u=!1;for(let p=0;p<g.length;p++){const m=g[p];i.hasOnlyGoodArcs(m,t)&&(g.splice(p,1),p--,t.add(m),u=!0)}}while(u);return g.map(p=>n.get(p))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new o(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$4dc=$;class o{constructor(l,i){this.versionId=l,this.extensions=i}}e.$5dc=o;class k{constructor(l){this.d=new S,this.c=new $(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,n){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$6dc=k;class y extends T.$Vc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$7dc=y;class a{constructor(l){this.name=l;const i=(0,A.$zh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new a(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};l.resolve((0,T.$Tc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function r(c,l){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,n=l.isBuiltin?d.Builtin:l.isUnderDevelopment?d.Dev:d.User;if(i!==n)return i-n;const t=I.$hc.basename(c.extensionLocation.path),g=I.$hc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function s(c,l){const i=new v.$tn(l);return c.filter(n=>!i.has(n.identifier))}}),define(Ne[83],Me([1,0,22]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=A,e.$Dn=O;var P;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(P||(e.UIKind=P={}));var I;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var T;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(o){const k=v.$Oe.alloc(1);switch(o){case T.Initialized:k.writeUInt8(1,0);break;case T.Ready:k.writeUInt8(2,0);break;case T.Terminate:k.writeUInt8(3,0);break}return k}function O(o,k){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return k===T.Initialized;case 2:return k===T.Ready;case 3:return k===T.Terminate;default:return!1}}var $;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ne[66],Me([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$GQ=e.$FQ=void 0,e.$HQ=s;let d=class extends a.$Vc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new P.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=I.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:o.$Dp,name:(0,S.localize)(2700,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,T.$dk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=I.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,n){const t=this.getTelemetryDetails(),g=new r(i,n,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this.f=l,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$jn)((0,o.$Jp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const g=n.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$FQ=d,e.$FQ=d=Je([We(0,A.$EQ),We(1,T.$ck)],d);class r{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,t,g,u,p){this.g=n,this.h=t,this.i=g,this.j=u,this.a=new P.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,o.$Mp)(i,[]),this.c&&(i=(0,k.$io)(i,this.c)),this.b||(i=(0,k.$io)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,o.$Mp)(n,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$GQ=r;function s(c){const l=Date.now()-new Date(c).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$IQ=(0,v.$Gi)("IExtHostTelemetry")}),define(Ne[24],Me([1,0,6,2,179,111,18,3]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.ActivationKind=e.$lH=e.$kH=e.$hH=e.ExtensionHostStartup=e.$gH=e.$fH=e.$eH=e.$dH=void 0,e.$iH=a,e.$jH=S,e.$mH=c,e.$nH=l,e.$dH=Object.freeze({identifier:new A.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$eH="extensions.webWorker",e.$fH=(0,O.$Gi)("extensionService");class ${constructor(t){this.dependency=t}}e.$gH=$;var o;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class k{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$2G.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const p=[],m=[],h=[],E=[],D=y(this.d),w=y(g),C=(N,M)=>N.extensionLocation.toString()===M.extensionLocation.toString()||N.isBuiltin===M.isBuiltin||N.isUserBuiltin===M.isUserBuiltin||N.isUnderDevelopment===M.isUnderDevelopment;for(const N of this.d){const M=w.get(N.identifier);if(!M){p.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,M)){p.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const M=D.get(N.identifier);if(!M){m.push(N);continue}if(!C(M,N)){p.push(M.identifier),D.delete(M.identifier);continue}}const R=new A.$tn(this.e),f=new A.$tn(u);for(const N of this.e)f.has(N)||h.push(N);for(const N of u)R.has(N)||E.push(N);const b=T.$2G.createActivationEventsMap(m),L={versionId:t,toRemove:p,toAdd:m,addActivationEvents:b,myToRemove:h,myToAdd:E};return this.delta(L),L}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:p,myToAdd:m}=t,h=new A.$tn(g),E=new A.$tn(p);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$sn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=T.$2G.readActivationEvents(g);for(const p of u)t.add(p)}return t}}e.$hH=k;function y(n){const t=new A.$un;for(const g of n)t.set(g.identifier,g);return t}function a(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function S(n,t){if(!a(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class d{constructor(t,g,u,p){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=p}}e.$kH=d;class r{constructor(t,g){this.description=t,this.value=g}}e.$lH=r;var s;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function c(n){return{type:n.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,I.$Sp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function l(n,t){const g=(0,I.$Qp)(n.manifest.publisher,n.manifest.name);return{id:g,identifier:new A.$sn(g),isBuiltin:n.type===A.ExtensionType.System,isUserBuiltin:n.type===A.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$oH=i}),define(Ne[206],Me([1,0,13,4,120,18,24,11,10]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.$mqc=e.$lqc=e.$kqc=void 0,v=Ve(v);class o{static{this.NONE=new o(!1,-1,-1,-1)}constructor(l,i,n,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$kqc=o;class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new o(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$lqc=k;class y{constructor(l,i,n,t,g,u){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=g,this.disposable=u}}e.$mqc=y;class a extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,P.$Vc.None)}}e.$nqc=a;class S extends y{constructor(){super(!1,null,o.NONE,{activate:void 0,deactivate:void 0},void 0,P.$Vc.None)}}e.$oqc=S;class d extends y{constructor(l){super(!0,l,o.NONE,{activate:void 0,deactivate:void 0},void 0,P.$Vc.None)}}let r=class{constructor(l,i,n,t){this.g=t,this.a=l,this.b=i,this.c=n,this.d=new T.$un,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this.d)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const n=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const n=this.a.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`),u=this.k(l,null,[],new d(g));return this.c.onExtensionActivationError(l.id,g,new A.$gH(l.id.value)),u}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const u=this.d.get(g);if(u){n.push(u);continue}if(this.l(g)){n.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:l.reason}));continue}const p=this.a.getExtensionDescription(g);if(p){if(!p.main&&!p.browser)continue;n.push(this.j({id:p.identifier,reason:l.reason}));continue}const m=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${g}'`),E=this.k(l,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new A.$gH(g)),E}return this.k(l,i.displayName,n,null)}k(l,i,n,t){const g=new s(l.id,i,l.reason,n,t,this.c,this.g);return this.d.set(l.id,g),g}l(l){return I.$4dc.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$pqc=r,e.$pqc=r=Je([We(3,O.$bk)],r);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,n,t,g,u,p){this.c=l,this.d=i,this.f=n,this.g=t,this.h=g,this.j=u,this.k=p,this.a=new $.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new d(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new d(i),this.b&&v.$4(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};s=Je([We(6,O.$bk)],s)});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[121],Me([1,0,9,13,35,110,77,30,18,108,111,104]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=void 0,v=Ve(v),I=_t(I);const a=O.$so.as(A.$to.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(I.default.Error,t)}warn(t){this.d(I.default.Warning,t)}info(t){this.d(I.default.Info,t)}}e.$0G=S;class d{static a(t){const g=new $.$tn;for(let u=0,p=t.length;u<p;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const u=this.a(t),p=this.a(g),m=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!p.has(E.description.identifier));return new d(m,h)}constructor(t,g){this.added=t,this.removed=g}}e.$$G=d;class r{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,P.$Z)(t)}}}e.$_G=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(12207,null),v.localize(12208,null)]},c="vscode://schemas/vscode-extensions";e.$aH={properties:{engines:{type:"object",description:v.localize(12209,null),properties:{vscode:{type:"string",description:v.localize(12210,null),default:"^1.22.0"}}},publisher:{description:v.localize(12211,null),type:"string"},displayName:{description:v.localize(12212,null),type:"string"},categories:{description:v.localize(12213,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$rn},{type:"string",const:"Languages",deprecationMessage:v.localize(12214,null)}]}},galleryBanner:{type:"object",description:v.localize(12215,null),properties:{color:{description:v.localize(12216,null),type:"string"},theme:{description:v.localize(12217,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(12218,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12219,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(12220,null)},enabledApiProposals:{markdownDescription:v.localize(12221,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(12222,null),type:"string",enum:["none"],enumDescriptions:[v.localize(12223,null)]},activationEvents:{description:v.localize(12224,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(12225,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(12226,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(12227,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(12228,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(12229,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(12230,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(12231,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(12232,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(12233,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(12234,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(12235,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(12236,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(12237,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(12238,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(12239,null)},{label:"onUri",body:"onUri",description:v.localize(12240,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(12241,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(12242,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(12243,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(12244,null)},{label:"onRenderer",description:v.localize(12245,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(12246,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(12247,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(12248,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(12249,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(12250,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(12251,null)},{label:"*",description:v.localize(12252,null),body:"*"}]}},badges:{type:"array",description:v.localize(12253,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(12254,null)},href:{type:"string",description:v.localize(12255,null)},description:{type:"string",description:v.localize(12256,null)}}}},markdown:{type:"string",description:v.localize(12257,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(12258,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(12259,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$_o}},extensionPack:{description:v.localize(12260,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$_o}},extensionKind:{description:v.localize(12261,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(12262,null)},{body:["workspace"],description:v.localize(12263,null)},{body:["ui","workspace"],description:v.localize(12264,null)},{body:["workspace","ui"],description:v.localize(12265,null)},{body:[],description:v.localize(12266,null)}]},capabilities:{description:v.localize(12267,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(12268,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(12269,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12270,null),v.localize(12271,null),v.localize(12272,null)]},description:{type:"string",markdownDescription:v.localize(12273,null)}}},untrustedWorkspaces:{description:v.localize(12274,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(12275,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12276,null),v.localize(12277,null),v.localize(12278,null)]},restrictedConfigurations:{description:v.localize(12279,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(12280,null)}}}}},sponsor:{description:v.localize(12281,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(12282,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(12283,null),type:"string"},"vscode:uninstall":{description:v.localize(12284,null),type:"string"}}},icon:{type:"string",description:v.localize(12285,null)},l10n:{type:"string",description:v.localize(12286,null)},pricing:{type:"string",markdownDescription:v.localize(12287,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&k.$2G.register(t.extensionPoint,t.activationEventsGenerator),e.$aH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$aH),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$bH=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$so.add(i.ExtensionsRegistry,new l),e.$cH=O.$so.as(i.ExtensionsRegistry),a.registerSchema(c,e.$aH),a.registerSchema(o.$vk,{properties:{extensionEnabledApiProposals:{description:v.localize(12288,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Ne[207],Me([1,0,6,40,4,12,9,18,3,11,24,121]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.ChatMessageRole=void 0;var a;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$pH=(0,$.$Gi)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(4698,null)}}};e.$qH=y.$cH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(4699,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(r,s)=>{for(const c of r)s.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(s,c){this.e=s,this.f=c,this.a=new I.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$qH.setHandler(l=>{this.c.clear();for(const n of l){if(!(0,k.$iH)(n.description,"chatProvider")){n.collector.error((0,A.localize)(4700,null));continue}for(const t of P.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,A.localize)(4701,null,t.vendor));continue}if((0,T.$df)(t.vendor)){n.collector.error((0,A.localize)(4702,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,A.localize)(4703,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const c=[];for(const[l,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>O.$sn.equals(n,s.extension)))&&c.push(l);return this.f.trace("[LM] selected language models",s,c),c}registerLanguageModelChat(s,c){if(this.f.trace("[LM] registering language model chat",s,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,c),this.d.fire({added:[{identifier:s,metadata:c.metadata}]}),(0,I.$Tc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,c.metadata))})}async sendChatRequest(s,c,l,i,n){const t=this.b.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(l,c,i,n)}computeTokenLength(s,c,l){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(c,l)}};e.$rH=d,e.$rH=d=Je([We(0,k.$fH),We(1,o.$bk)],d)}),define(Ne[208],Me([1,0,9,14,25,121,31,6]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=void 0,v=Ve(v),P=Ve(P),I=Ve(I);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(9826,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(9827,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(9828,null),default:""}}};var o;(function(a){function S(d,r,s){if(!d)return;const c=P.$fg(d.type)?d.type:void 0;if(!c||c.length===0){s.error(v.localize(9829,null));return}const l=[];if(Array.isArray(d.required))for(const i of d.required)P.$fg(i)&&l.push(i);return{extensionId:r.value,taskType:c,required:l,properties:d.properties?I.$fo(d.properties):{},when:d.when?A.$Ej.deserialize(d.when):void 0}}a.from=S})(o||(o={}));const k=T.$cH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,S)=>{for(const d of a)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(9830,null),type:"array",items:$}});class y{constructor(){this.d=new O.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{k.setHandler((r,s)=>{this.c=void 0;try{for(const c of s.removed){const l=c.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of s.added){const l=c.value;for(const i of l){const n=o.from(i,c.description.identifier,c.collector);n&&(this.a[n.taskType]=n)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=I.$fo(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},S.push(r)}this.c={oneOf:S}}return this.c}}e.$YI=new y}),define(Ne[209],Me([1,0,9,14,23,25,31,208,43]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$9I=e.JsonSchemaVersion=e.ExecutionEngine=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$3I=e.ShellQuoting=e.$2I=e.$1I=e.$ZI=void 0,v=Ve(v),P=Ve(P),I=Ve(I),T=Ve(T),e.$ZI="settings",e.$1I=new A.$Xj("taskRunning",!1,v.localize(9831,null)),e.$2I=v.localize2(9833,"Tasks");var o;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(o||(e.ShellQuoting=o={})),e.$3I="$customized",function(q){function J(K){if(!K)return q.Strong;switch(K.toLowerCase()){case"escape":return q.Escape;case"strong":return q.Strong;case"weak":return q.Weak;default:return q.Strong}}q.from=J}(o||(e.ShellQuoting=o={}));var k;(function(q){q.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var y;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(y||(e.RevealKind=y={})),function(q){function J(K){switch(K.toLowerCase()){case"always":return q.Always;case"silent":return q.Silent;case"never":return q.Never;default:return q.Always}}q.fromString=J}(y||(e.RevealKind=y={}));var a;(function(q){q[q.Never=1]="Never",q[q.OnProblem=2]="OnProblem",q[q.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(q){function J(K){switch(K.toLowerCase()){case"always":return q.Always;case"never":return q.Never;case"onproblem":return q.OnProblem;default:return q.OnProblem}}q.fromString=J}(a||(e.RevealProblemKind=a={}));var S;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(S||(e.PanelKind=S={})),function(q){function J(K){switch(K.toLowerCase()){case"shared":return q.Shared;case"dedicated":return q.Dedicated;case"new":return q.New;default:return q.Shared}}q.fromString=J}(S||(e.PanelKind=S={}));var d;(function(q){q.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(q){q[q.Shell=1]="Shell",q[q.Process=2]="Process",q[q.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(q){function J(oe){switch(oe.toLowerCase()){case"shell":return q.Shell;case"process":return q.Process;case"customExecution":return q.CustomExecution;default:return q.Process}}q.fromString=J;function K(oe){switch(oe){case q.Shell:return"shell";case q.Process:return"process";case q.CustomExecution:return"customExecution";default:return"process"}}q.toString=K}(r||(e.RuntimeType=r={}));var s;(function(q){function J(K){return P.$fg(K)?K:K.value}q.value=J})(s||(e.CommandString=s={}));var c;(function(q){q.Clean={_id:"clean",isDefault:!1},q.Build={_id:"build",isDefault:!1},q.Rebuild={_id:"rebuild",isDefault:!1},q.Test={_id:"test",isDefault:!1};function J(oe){return oe===q.Clean._id||oe===q.Build._id||oe===q.Rebuild._id||oe===q.Test._id}q.is=J;function K(oe){if(oe!==void 0)return P.$fg(oe)?J(oe)?{_id:oe,isDefault:!1}:void 0:oe}q.from=K})(c||(e.TaskGroup=c={}));var l;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(q){q.Workspace="workspace",q.Extension="extension",q.InMemory="inMemory",q.WorkspaceFile="workspaceFile",q.User="user";function J(K){switch(K){case q.User:return $.ConfigurationTarget.USER;case q.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}q.toConfigurationTarget=J})(i||(e.TaskSourceKind=i={}));var n;(function(q){q.parallel="parallel",q.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(q){q[q.default=1]="default",q[q.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(q){q.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(J,K,oe,me,le,_){this._label="",this._id=J,K&&(this._label=K),oe&&(this.type=oe),this.runOptions=me,this.configurationProperties=le,this._source=_}getDefinition(J){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const J={folder:this.d(),id:this._id};return JSON.stringify(J)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(J,K=!1){if(J===void 0)return!1;if(P.$fg(J))return J===this._label||J===this.configurationProperties.identifier||K&&J===this._id;const oe=this.getDefinition(!0);return oe!==void 0&&oe._key===J._key}getQualifiedLabel(){const J=this.getWorkspaceFolder();return J?`${this._label} (${J.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(J){this.c===void 0&&(this.c=[]),J&&(this.c=this.c.concat(J))}get taskLoadMessages(){return this.c}}e.$4I=u;class p extends u{constructor(J,K,oe,me,le,_,ce,pe){super(J,oe,void 0,ce,pe,K),this.command={},this._source=K,this.hasDefinedMatchers=_,le&&(this.command=le)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(J=!1){if(J&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case r.Shell:K="shell";break;case r.Process:K="process";break;case r.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(J){return J instanceof p}getMapKey(){const J=this._source.config.workspaceFolder;return J?`${J.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const J=this.d();if(!J)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const oe={type:e.$3I,folder:J,id:K};return JSON.stringify(oe)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(J){return new p(J._id,J._source,J._label,J.type,J.command,J.hasDefinedMatchers,J.runOptions,J.configurationProperties)}}e.$5I=p;class m extends u{constructor(J,K,oe,me,le,_,ce){super(J,oe,me,_,ce,K),this._source=K,this.configures=le}static is(J){return J instanceof m}f(J){return J}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const J=this.d();if(!J)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const oe={type:e.$3I,folder:J,id:K};return JSON.stringify(oe)}}e.$6I=m;class h extends u{constructor(J,K,oe,me,le,_,ce,pe,ae){super(J,oe,me,pe,ae,K),this.defines=le,this.hasDefinedMatchers=ce,this.command=_,this.icon=ae.icon,this.hide=ae.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(J){return J instanceof h}getMapKey(){const J=this._source.workspaceFolder;return J?`${this._source.scope.toString()}|${J.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const J={type:"contributed",scope:this._source.scope,id:this._id};return J.folder=this.d(),JSON.stringify(J)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(J){return new h(J._id,J._source,J._label,J.type,J.defines,J.command,J.hasDefinedMatchers,J.runOptions,J.configurationProperties)}}e.$7I=h;class E extends u{constructor(J,K,oe,me,le,_){super(J,oe,me,le,_,K),this._source=K}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(J){return J instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(J){return new E(J._id,J._source,J._label,J.type,J.runOptions,J.configurationProperties)}}e.$8I=E;var D;(function(q){q[q.Process=1]="Process",q[q.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(q){q._default=q.Terminal}(D||(e.ExecutionEngine=D={}));var w;(function(q){q[q.V0_1_0=1]="V0_1_0",q[q.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class C{constructor(J){this.c=new Map;for(let K=0;K<J.length;K++)this.c.set(J[K].uri.toString(),K)}compare(J,K){const oe=J.getWorkspaceFolder(),me=K.getWorkspaceFolder();if(oe&&me){let le=this.c.get(oe.uri.toString());le=le===void 0?0:le+1;let _=this.c.get(me.uri.toString());return _=_===void 0?0:_+1,le===_?J._label.localeCompare(K._label):le-_}else return!oe&&me?-1:oe&&!me?1:0}}e.$9I=C;var R;(function(q){q.DependsOnStarted="dependsOnStarted",q.AcquiredInput="acquiredInput",q.Start="start",q.ProcessStarted="processStarted",q.Active="active",q.Inactive="inactive",q.Changed="changed",q.Terminated="terminated",q.ProcessEnded="processEnded",q.End="end"})(R||(e.TaskEventKind=R={}));var f;(function(q){q.SingleRun="singleRun",q.Background="background"})(f||(e.TaskRunType=f={}));var b;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.FolderOpen=2]="FolderOpen",q[q.ConfigurationChange=3]="ConfigurationChange",q[q.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(q){function J(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?f.Background:f.SingleRun,group:pe.configurationProperties.group,__task:pe}}function K(pe,ae,Se){return{...J(pe),kind:R.Start,terminalId:ae,resolvedVariables:Se}}q.start=K;function oe(pe,ae,Se){return{...J(pe),kind:R.ProcessStarted,terminalId:ae,processId:Se}}q.processStarted=oe;function me(pe,ae,Se){return{...J(pe),kind:R.ProcessEnded,terminalId:ae,exitCode:Se}}q.processEnded=me;function le(pe,ae,Se){return{...J(pe),kind:R.Terminated,exitReason:Se,terminalId:ae}}q.terminated=le;function _(pe,ae,Se){return{...J(ae),kind:pe,terminalId:Se}}q.general=_;function ce(){return{kind:R.Changed}}q.changed=ce})(L||(e.TaskEvent=L={}));var N;(function(q){function J(oe){const me=Object.keys(oe).sort();let le="";for(const _ of me){let ce=oe[_];ce instanceof Object?ce=J(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),le+=_+","+ce+","}return le}function K(oe){const le={_key:J(oe),type:oe.taskType};return Object.assign(le,oe),le}q.create=K})(N||(e.KeyedTaskIdentifier=N={}));var M;(function(q){q.AutoDetect="task.autoDetect",q.SaveBeforeRun="task.saveBeforeRun",q.ShowDecorations="task.showDecorations",q.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",q.SlowProviderWarning="task.slowProviderWarning",q.QuickOpenHistory="task.quickOpen.history",q.QuickOpenDetail="task.quickOpen.detail",q.QuickOpenSkip="task.quickOpen.skip",q.QuickOpenShowAll="task.quickOpen.showAll",q.AllowAutomaticTasks="task.allowAutomaticTasks",q.Reconnection="task.reconnection",q.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var W;(function(q){q.Tasks="tasks",q.SuppressTaskName="tasks.suppressTaskName",q.Windows="tasks.windows",q.Osx="tasks.osx",q.Linux="tasks.linux",q.ShowOutput="tasks.showOutput",q.IsShellCommand="tasks.isShellCommand",q.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var G;(function(q){function J(K,oe){const me=O.$YI.get(K.type);if(me===void 0){const pe=T.$fo(K);return delete pe._key,N.create(pe)}const le=Object.create(null);le.type=me.taskType;const _=new Set;me.required.forEach(pe=>_.add(pe));const ce=me.properties;for(const pe of Object.keys(ce)){const ae=K[pe];if(ae!=null)le[pe]=ae;else if(_.has(pe)){const Se=ce[pe];if(Se.default!==void 0)le[pe]=T.$fo(Se.default);else switch(Se.type){case"boolean":le[pe]=!1;break;case"number":case"integer":le[pe]=0;break;case"string":le[pe]="";break;default:oe.error(v.localize(9832,null,JSON.stringify(K,void 0,0),pe));return}}}return N.create(le)}q.createTaskIdentifier=J})(G||(e.TaskDefinition=G={}))}),define(Ne[210],Me([1,0,13]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,O)=>{this.b=A,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Z)(A))}then(A,O){return this.j().then(A,O)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$8dc=P;class I extends P{constructor(){super(),this.h=!0,this.i=new v.$5}}e.$9dc=I}),define(Ne[39],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$Yw=void 0,e.$Zw=I,e.$1w=T;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Yw=v;const P=[];function I(O){const $=new v(O);return P[$.nid]=$,$}function T(O){return P[O].sid}class A{constructor($){this.value=$}}e.$2w=A}),define(Ne[5],Me([1,0,39]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$NN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var T;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var O;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var o;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var k;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(k||(e.CandidatePortSource=k={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$NN=y;var a;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$ON={MainThreadAuthentication:(0,v.$Zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Zw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Zw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Zw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Zw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Zw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Zw)("MainThreadCommands"),MainThreadComments:(0,v.$Zw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Zw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Zw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Zw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Zw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Zw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Zw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Zw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Zw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Zw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Zw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Zw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Zw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Zw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Zw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Zw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Zw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Zw)("MainThreadSCM"),MainThreadSearch:(0,v.$Zw)("MainThreadSearch"),MainThreadShare:(0,v.$Zw)("MainThreadShare"),MainThreadTask:(0,v.$Zw)("MainThreadTask"),MainThreadWindow:(0,v.$Zw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Zw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Zw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Zw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Zw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Zw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Zw)("MainThreadAiEmbeddingVector")},e.$PN={ExtHostCommands:(0,v.$Zw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Zw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Zw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Zw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Zw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Zw)("ExtHostSCM"),ExtHostSearch:(0,v.$Zw)("ExtHostSearch"),ExtHostTask:(0,v.$Zw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Zw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Zw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Zw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Zw)("ExtHostProgress"),ExtHostComments:(0,v.$Zw)("ExtHostComments"),ExtHostSecretState:(0,v.$Zw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Zw)("ExtHostStorage"),ExtHostUrls:(0,v.$Zw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Zw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Zw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Zw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Zw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Zw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Zw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Zw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Zw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Zw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Zw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Zw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Zw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Zw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Zw)("ExtHostLocalization")}}),define(Ne[84],Me([1,0,3,11,5,16]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=void 0,I=Ve(I),e.$Jpc=(0,v.$Gi)("IExtHostApiDeprecationService");let A=class{constructor($,o){this.c=o,this.a=new Set,this.b=$.getProxy(I.$ON.MainThreadTelemetry)}report($,o,k){const y=this.d($,o);this.a.has(y)||(this.a.add(y),o.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${k}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:o.identifier.value,apiId:$}))}d($,o){return`${$}-${o.identifier.value}`}};e.$Kpc=A,e.$Kpc=A=Je([We(0,T.$oQ),We(1,P.$bk)],A),e.$Lpc=Object.freeze(new class{report(O,$,o){}})}),define(Ne[211],Me([1,0,5]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class P{constructor(T){const A=T.getProxy(v.$ON.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(O){return A.$writeText(O)}})}}e.$Ypc=P}),define(Ne[212],Me([1,0,25,5,26,16]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;let A=class{constructor(k,y){this.a=k.getProxy(P.$ON.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(k,y){const a=this,S=console[k];Object.defineProperty(console,k,{set:()=>{},get:()=>function(){a.e(k,y,S,arguments)}})}e(k,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(S,this.b)}),this.c&&this.f(k,a,S)}};e.$Urc=A,e.$Urc=A=Je([We(0,T.$oQ),We(1,I.$EQ)],A);const O=1e5;function $(o,k){const y=[];if(o.length)for(let a=0;a<o.length;a++){let S=o[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(k){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$ko)(y);return a.length>O?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ne[213],Me([1,0,2,5,24]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0;class T{constructor(O){this.a=O.getProxy(P.$ON.MainThreadDialogs)}showOpenDialog(O,$){return $?.allowUIResources&&(0,I.$jH)(O,"showLocal"),this.a.$showOpenDialog($).then(o=>o?o.map(k=>v.URI.revive(k)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then($=>$?v.URI.revive($):void 0)}}e.$1qc=T}),define(Ne[214],Me([1,0,21,6,4,5]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class A{constructor($){this.b=new Map,this.c=new P.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(T.$ON.MainThreadEmbeddings)}registerEmbeddingsProvider($,o,k){if(this.d.has(o))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,o),this.b.set(y,{id:o,provider:k}),(0,I.$Tc)(()=>{this.d.delete(o),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,o,k){k??=v.CancellationToken.None;let y=!1;typeof o=="string"&&(o=[o],y=!0);const a=await this.a.$computeEmbeddings($,o,k);if(a.length!==o.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings($,o,k){const y=this.b.get($);if(!y)return[];const a=await y.provider.provideEmbeddings(o,k);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$4qc=A}),define(Ne[215],Me([1,0,4,5]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(P.$ON.MainThreadLabelService)}$registerResourceLabelFormatter(A){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,A),(0,v.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$irc=I}),define(Ne[85],Me([1,0,20,12,2,3,11,5,26,16]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=e.$Dqc=void 0;let k=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(O.$ON.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:r,comment:s}=S;if(this.c)return(0,P.$ff)(d,r??{});let c=d;s&&s.length>0&&(c+=`/${Array.isArray(s)?s.join(""):s}`);const l=this.d.get(a)?.contents[c];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,P.$ff)(l??d,r??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),s=JSON.parse(r);S=a.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${r.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return I.URI.revive(S)}return a.l10n?I.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Dqc=k,e.$Dqc=k=Je([We(0,$.$EQ),We(1,o.$oQ),We(2,A.$bk)],k),e.$Eqc=(0,T.$Gi)("IExtHostLocalizationService")}),define(Ne[216],Me([1,0,11,5,26,16,2,36]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;let $=class extends v.$mk{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,O.$di)(S))),this.r=y.getProxy(P.$ON.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(A.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new o(this.r,y,a,S)}};e.$Trc=$,e.$Trc=$=Je([We(0,T.$oQ),We(1,I.$EQ)],$);class o extends v.$hk{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ne[86],Me([1,0,5,3,4,16,22]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=e.$Fqc=void 0,e.$Fqc=(0,P.$Gi)("IExtHostManagedSockets");let O=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$ON.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new I.$Uc;return this.d.set(a,new o(a,S,d)),d.add((0,I.$Tc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(r=>{this.a.$onDidManagedSocketClose(a,r?.stack??r?.message),d.dispose()})),d.add(S.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(a,A.$Oe.wrap(r)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Gqc=O,e.$Gqc=O=Je([We(0,T.$oQ)],O);class ${constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class o extends I.$Vc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Ne[217],Me([1,0,5,11,24]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;function T(O){return O&&O.title}let A=class{constructor($,o){this.b=o,this.a=$.getProxy(v.$ON.MainThreadMessageService)}showMessage($,o,k,y,a){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof y=="string"||T(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,I.$jH)($,"resolvers");const r=[];let s=!1;for(let c=0;c<d.length;c++){const l=d[c];if(typeof l=="string")r.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:n}=l;r.push({title:i,isCloseAffordance:!!n,handle:c}),n&&(s?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,l):s=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,l)}return this.a.$showMessage(o,k,S,r).then(c=>{if(typeof c=="number")return d[c]})}};e.$lrc=A,e.$lrc=A=Je([We(1,P.$bk)],A)}),define(Ne[218],Me([1,0,4,14,2,24,5]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0;class O{constructor(o){this.b=new Map,this.a=o.getProxy(A.$ON.MainThreadProfileContentHandlers)}registerProfileContentHandler(o,k,y){if((0,T.$jH)(o,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,y),this.a.$registerProfileContentHandler(k,y.name,y.description,o.identifier.value),(0,v.$Tc)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(o,k,y,a){const S=this.b.get(o);if(!S)throw new Error(`Unknown handler with id: ${o}`);return S.saveProfile(k,y,a)}async $readProfile(o,k,y){const a=this.b.get(o);if(!a)throw new Error(`Unknown handler with id: ${o}`);return a.readProfile((0,P.$fg)(k)?k:I.URI.revive(k),y)}}e.$urc=O}),define(Ne[87],Me([1,0,5,6,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=void 0;class T{constructor(O){this.b=new P.$me,this.onDidChangePassword=this.b.event,this.a=O.getProxy(v.$ON.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,$){return this.a.$getPassword(O,$)}store(O,$,o){return this.a.$setPassword(O,$,o)}delete(O,$){return this.a.$deletePassword(O,$)}}e.$Aqc=T,e.$Bqc=(0,I.$Gi)("IExtHostSecretState")}),define(Ne[219],Me([1,0,21,4,5]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=void 0;class T{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(I.$ON.MainThreadSpeech)}async $createSpeechToTextSession(O,$,o){const k=this.c.get(O);if(!k)return;const y=new P.$Uc,a=new v.$xe;this.d.set($,a);const S=await k.provideSpeechToTextSession(a.token,o?{language:o}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,$,o){const k=this.c.get(O);if(!k)return;const y=new P.$Uc,a=new v.$xe;this.d.set($,a);const S=await k.provideTextToSpeechSession(a.token,o?{language:o}:void 0);S&&(this.f.set($,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(O,$){this.f.get(O)?.synthesize($)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,$){const o=this.c.get(O);if(!o)return;const k=new P.$Uc,y=new v.$xe;this.d.set($,y);const a=await o.provideKeywordRecognitionSession(y.token);a&&(k.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),k.add(y.token.onCancellationRequested(()=>k.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,$,o){const k=T.a++;return this.c.set(k,o),this.b.$registerProvider(k,$,{extension:O,displayName:O.value}),(0,P.$Tc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}}e.$Brc=T}),define(Ne[88],Me([1,0,5,6,3]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0;class T{constructor(O,$){this.c=$,this.b=new P.$me,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(v.$ON.MainThreadStorage)}registerExtensionStorageKeysToSync(O,$){this.a.$registerExtensionStorageKeysToSync(O,$)}async initializeExtensionStorage(O,$,o){const k=await this.a.$initializeExtensionStorage(O,$);let y;return k&&(y=this.d(O,$,k)),y||o}setValue(O,$,o){return this.a.$setValue(O,$,o)}$acceptValue(O,$,o){const k=this.d(O,$,o);k&&this.b.fire({shared:O,key:$,value:k})}d(O,$,o){try{return JSON.parse(o)}catch(k){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${O}): ${k}`)}}}e.$qqc=T,e.$rqc=(0,I.$Gi)("IExtHostStorage")}),define(Ne[220],Me([1,0,4,15,2,5]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=void 0;class A{static{this.a=new Set([P.Schemas.http,P.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(T.$ON.MainThreadUriOpeners)}registerExternalUriOpener($,o,k,y){if(this.c.has(o))throw new Error(`Opener with id '${o}' already registered`);const a=y.schemes.find(S=>!A.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(o,k),this.b.$registerUriOpener(o,y.schemes,$,y.label),(0,v.$Tc)(()=>{this.c.delete(o),this.b.$unregisterUriOpener(o)})}async $canOpenUri($,o,k){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const a=I.URI.revive(o);return y.canOpenExternalUri(a,k)}async $openUri($,o,k){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(I.URI.revive(o.resolvedUri),{sourceUri:I.URI.revive(o.sourceUri)},k)}}e.$Nrc=A}),define(Ne[221],Me([1,0,5,2,4,13,18]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=void 0;class O{static{this.a=0}constructor(o){this.c=new A.$tn,this.d=new Map,this.b=o.getProxy(v.$ON.MainThreadUrls)}registerUriHandler(o,k){const y=o.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=O.a++;return this.c.add(y),this.d.set(a,k),this.b.$registerUriHandler(a,y,o.displayName||o.name),(0,I.$Tc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(o,k){const y=this.d.get(o);if(!y)return Promise.resolve(void 0);try{y.handleUri(P.URI.revive(k))}catch(a){(0,T.$Z)(a)}return Promise.resolve(void 0)}async createAppUri(o){return P.URI.revive(await this.b.$createAppUri(o))}}e.$Orc=O}),define(Ne[222],Me([1,0,22,5]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4tb=T,e.$5tb=O,P=Ve(P);class I{constructor(){this.buffers=[]}add(o){let k=this.buffers.indexOf(o);return k<0&&(k=this.buffers.length,this.buffers.push(o)),k}}function T($,o){if(o.serializeBuffersForPostMessage){const k=new I,a=JSON.stringify($,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(r)};if(ArrayBuffer.isView(r)){const s=A(r);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(r.buffer),view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),S=k.buffers.map(d=>{const r=new Uint8Array(d);return v.$Oe.wrap(r)});return{message:a,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return P.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return P.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return P.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return P.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return P.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return P.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return P.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return P.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return P.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return P.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return P.WebviewMessageArrayBufferViewType.BigUint64Array}}function O($,o){const k=o.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=o.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:s}=r,c=k[s];if(r.view)switch(r.view.type){case P.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case P.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse($,y),arrayBuffers:k}}}),define(Ne[67],Me([1,0,6,4,15,25,2,176,222,82,5]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$bqc=void 0,e.$cqc=a,e.$eqc=r,e.$fqc=s,T=Ve(T),k=Ve(k);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,g,u,p,m,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$me,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=g,this.#n=u,this.#s=p,this.#r=m,this.#u=a(m),this.#d=S(m),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,o.$PDb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===I.Schemas.https||n.scheme===I.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+o.$ODb}return o.$ODb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),T.$jo(this.#o,n)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,$.$4tb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,h,E,D)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$PDb)(w,{isRemote:t,authority:g}).toString();return`${p}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,h,E,D)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$PDb)(w,{isRemote:t,authority:g}).toString();return`${p}${C}${D}`})}}e.$bqc=y;function a(i){try{const n=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function S(i){try{const n=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class d extends P.$Vc{constructor(n,t,g,u,p){super(),this.c=t,this.f=g,this.g=u,this.h=p,this.b=new Map,this.a=n.getProxy(k.$ON.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,g){const u=this.j(n);if(u){const{message:p}=(0,$.$5tb)(t,g.value);u._onMessageEmitter.fire(p)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,g){const u=new y(n,this.a,c(t),this.c,this.f,g,this.h);this.b.set(n,u);const p=u._onDidDispose(()=>{p.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$dqc=d;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,n)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>A.URI.from(n))}}function l(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ne[122],Me([1,0,6,15,12,2,3,16,5]),function(ve,e,v,P,I,T,A,O,$){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=e.$Qrc=void 0;let k=class{static{o=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$me,this.onDidChangeWindowState=this.c.event,this.d=o.a,this.b=a.getProxy($.$ON.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=T.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,I.$df)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,I.$df)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return T.URI.from(d)}};e.$Qrc=k,e.$Qrc=k=o=Je([We(0,O.$oQ)],k),e.$Rrc=(0,A.$Gi)("IExtHostWindow")}),define(Ne[223],Me([1,0,212,26,16]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6tc=void 0;let T=class extends v.$Urc{constructor(O,$){super(O,$)}f(O,$,o){$.apply(console,o)}};e.$6tc=T,e.$6tc=T=Je([We(0,I.$oQ),We(1,P.$EQ)],T)}),define(Ne[224],Me([1,0,10,22,21,27,13,6,4,37,151,210,39]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.ResponsiveState=e.RequestInitiator=void 0,e.$0dc=l,e.$$dc=i,A=Ve(A);function d(L,N){try{return JSON.stringify(L,N)}catch{return"null"}}const r="$$ref$$",s={[r]:-1};class c{constructor(N,M){this.jsonString=N,this.referencedBuffers=M}}function l(L,N=null,M=!1){const W=[];return{jsonString:(M?d:JSON.stringify)(L,(q,J)=>{if(typeof J>"u")return s;if(typeof J=="object"){if(J instanceof P.$Oe){const K=W.push(J)-1;return{[r]:K}}if(N)return N(q,J)}return J}),referencedBuffers:W}}function i(L,N,M){return JSON.parse(L,(W,G)=>{if(G){const q=G[r];if(typeof q=="number")return N[q];if(M&&G.$mid===o.MarshalledId.Uri)return M.transformIncoming(G)}return G})}function n(L,N){return JSON.stringify(L,N)}function t(L){return L?(N,M)=>M&&M.$mid===o.MarshalledId.Uri?L.transformOutgoing(M):M:null}var g;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const p=()=>{},m=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends $.$Vc{static{S=m}static{this.a=3*1e3}constructor(N,M=null,W=null){super(),this[S]=!0,this.b=this.B(new O.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=M,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let G=0,q=a.$Yw.count;G<q;G++)this.m[G]=null,this.s[G]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(G=>this.L(G)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const M=this.w[N];delete this.w[N],M.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,k.$Qn)(N,this.g):N}getProxy(N){const{nid:M,sid:W}=N;return this.s[M]||(this.s[M]=this.J(M,W)),this.s[M]}J(N,M){const W={get:(G,q)=>(typeof q=="string"&&!G[q]&&q.charCodeAt(0)===T.CharCode.DollarSign&&(G[q]=(...J)=>this.U(N,q,J)),q===h?M:G[q])};return new Proxy(Object.create(null),W)}set(N,M){return this.m[N.nid]=M,M}assertRegistered(N){for(let M=0,W=N.length;M<W;M++){const G=N[M];if(!this.m[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}L(N){if(this.j)return;const M=N.byteLength,W=w.read(N,0),G=W.readUInt8(),q=W.readUInt32();switch(G){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:J,method:K,args:oe}=R.deserializeRequestJSONArgs(W);this.g&&(oe=(0,k.$Qn)(oe,this.g)),this.M(M,q,J,K,oe,G===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:J,method:K,args:oe}=R.deserializeRequestMixedArgs(W);this.g&&(oe=(0,k.$Qn)(oe,this.g)),this.M(M,q,J,K,oe,G===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(M,q,g.LocalSide,"ack"),this.G(q);break}case f.Cancel:{this.N(M,q);break}case f.ReplyOKEmpty:{this.O(M,q,void 0);break}case f.ReplyOKJSON:{let J=R.deserializeReplyOKJSON(W);this.g&&(J=(0,k.$Qn)(J,this.g)),this.O(M,q,J);break}case f.ReplyOKJSONWithBuffers:{const J=R.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(M,q,J);break}case f.ReplyOKVSBuffer:{const J=R.deserializeReplyOKVSBuffer(W);this.O(M,q,J);break}case f.ReplyErrError:{let J=R.deserializeReplyErrError(W);this.g&&(J=(0,k.$Qn)(J,this.g)),this.P(M,q,J);break}case f.ReplyErrEmpty:{this.P(M,q,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,M,W,G,q,J){this.f?.logIncoming(N,M,g.OtherSide,`receiveRequest ${(0,a.$1w)(W)}.${G}(`,q);const K=String(M);let oe,me;if(J){const _=new I.$xe;q.push(_.token),oe=this.Q(W,G,q),me=()=>_.cancel()}else oe=this.Q(W,G,q),me=p;this.u[K]=me;const le=R.serializeAcknowledged(M);this.f?.logOutgoing(le.byteLength,M,g.OtherSide,"ack"),this.c.send(le),oe.then(_=>{delete this.u[K];const ce=R.serializeReplyOK(M,_,this.h);this.f?.logOutgoing(ce.byteLength,M,g.OtherSide,"reply:",_),this.c.send(ce)},_=>{delete this.u[K];const ce=R.serializeReplyErr(M,_);this.f?.logOutgoing(ce.byteLength,M,g.OtherSide,"replyErr:",_),this.c.send(ce)})}N(N,M){this.f?.logIncoming(N,M,g.OtherSide,"receiveCancel");const W=String(M);this.u[W]?.()}O(N,M,W){this.f?.logIncoming(N,M,g.LocalSide,"receiveReply:",W);const G=String(M);if(!this.w.hasOwnProperty(G))return;const q=this.w[G];delete this.w[G],q.resolveOk(W)}P(N,M,W){this.f?.logIncoming(N,M,g.LocalSide,"receiveReplyErr:",W);const G=String(M);if(!this.w.hasOwnProperty(G))return;const q=this.w[G];delete this.w[G];let J;W&&(W.$isError?(J=new Error,J.name=W.name,J.message=W.message,J.stack=W.stack):J=W),q.resolveErr(J)}Q(N,M,W){try{return Promise.resolve(this.S(N,M,W))}catch(G){return Promise.reject(G)}}S(N,M,W){const G=this.m[N];if(!G)throw new Error("Unknown actor "+(0,a.$1w)(N));const q=G[M];if(typeof q!="function")throw new Error("Unknown method "+M+" on actor "+(0,a.$1w)(N));return q.apply(G,W)}U(N,M,W){if(this.j)return new y.$9dc;let G=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(G=W.pop()),G&&G.isCancellationRequested)return Promise.reject(A.$6());const q=R.serializeRequestArguments(W,this.h),J=++this.t,K=String(J),oe=new y.$8dc,me=new $.$Uc;G&&me.add(G.onCancellationRequested(()=>{const _=R.serializeCancel(J);this.f?.logOutgoing(_.byteLength,J,g.LocalSide,"cancel"),this.c.send(R.serializeCancel(J))})),this.w[K]=new D(oe,me),this.F(J);const le=R.serializeRequest(J,N,M,q,!!G);return this.f?.logOutgoing(le.byteLength,J,g.LocalSide,`request: ${(0,a.$1w)(N)}.${M}(`,W),this.c.send(le),oe}}e.$_dc=E;class D{constructor(N,M){this.a=N,this.b=M}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class w{static alloc(N,M,W){const G=new w(P.$Oe.alloc(W+1+4),0);return G.writeUInt8(N),G.writeUInt32(M),G}static read(N,M){return new w(N,M)}get buffer(){return this.a}constructor(N,M){this.a=N,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+N);return this.b+=N,M}static sizeMixedArray(N){let M=0;M+=1;for(let W=0,G=N.length;W<G;W++){const q=N[W];switch(M+=1,q.type){case b.String:M+=this.sizeLongString(q.value);break;case b.VSBuffer:M+=this.sizeVSBuffer(q.value);break;case b.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(q.value);for(let J=0;J<q.buffers.length;++J)M+=this.sizeVSBuffer(q.buffers[J]);break;case b.Undefined:break}}return M}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let M=0,W=N.length;M<W;M++){const G=N[M];switch(G.type){case b.String:this.writeUInt8(b.String),this.writeLongString(G.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(G.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let q=0;q<G.buffers.length;++q)this.writeBuffer(G.buffers[q]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const M=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case b.String:M[W]=this.readLongString();break;case b.VSBuffer:M[W]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const q=this.readUInt32(),J=this.readLongString(),K=[];for(let oe=0;oe<q;++oe)K.push(this.readVSBuffer());M[W]=new a.$2w(i(J,K,null));break}case b.Undefined:M[W]=void 0;break}return M}}var C;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(C||(C={}));class R{static a(N){for(let M=0,W=N.length;M<W;M++)if(N[M]instanceof P.$Oe||N[M]instanceof a.$2w||typeof N[M]>"u")return!0;return!1}static serializeRequestArguments(N,M){if(this.a(N)){const W=[];for(let G=0,q=N.length;G<q;G++){const J=N[G];if(J instanceof P.$Oe)W[G]={type:b.VSBuffer,value:J};else if(typeof J>"u")W[G]={type:b.Undefined};else if(J instanceof a.$2w){const{jsonString:K,referencedBuffers:oe}=l(J.value,M);W[G]={type:b.SerializedObjectWithBuffers,value:P.$Oe.fromString(K),buffers:oe}}else W[G]={type:b.String,value:P.$Oe.fromString(n(J,M))}}return{type:C.Mixed,args:W}}return{type:C.Simple,args:n(N,M)}}static serializeRequest(N,M,W,G,q){switch(G.type){case C.Simple:return this.b(N,M,W,G.args,q);case C.Mixed:return this.c(N,M,W,G.args,q)}}static b(N,M,W,G,q){const J=P.$Oe.fromString(W),K=P.$Oe.fromString(G);let oe=0;oe+=w.sizeUInt8(),oe+=w.sizeShortString(J),oe+=w.sizeLongString(K);const me=w.alloc(q?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,oe);return me.writeUInt8(M),me.writeShortString(J),me.writeLongString(K),me.buffer}static deserializeRequestJSONArgs(N){const M=N.readUInt8(),W=N.readShortString(),G=N.readLongString();return{rpcId:M,method:W,args:JSON.parse(G)}}static c(N,M,W,G,q){const J=P.$Oe.fromString(W);let K=0;K+=w.sizeUInt8(),K+=w.sizeShortString(J),K+=w.sizeMixedArray(G);const oe=w.alloc(q?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,K);return oe.writeUInt8(M),oe.writeShortString(J),oe.writeMixedArray(G),oe.buffer}static deserializeRequestMixedArgs(N){const M=N.readUInt8(),W=N.readShortString(),G=N.readMixedArray(),q=new Array(G.length);for(let J=0,K=G.length;J<K;J++){const oe=G[J];typeof oe=="string"?q[J]=JSON.parse(oe):q[J]=oe}return{rpcId:M,method:W,args:q}}static serializeAcknowledged(N){return w.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return w.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,M,W){if(typeof M>"u")return this.d(N);if(M instanceof P.$Oe)return this.e(N,M);if(M instanceof a.$2w){const{jsonString:G,referencedBuffers:q}=l(M.value,W,!0);return this.g(N,G,q)}else return this.f(N,d(M,W))}static d(N){return w.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,M){let W=0;W+=w.sizeVSBuffer(M);const G=w.alloc(f.ReplyOKVSBuffer,N,W);return G.writeVSBuffer(M),G.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,M){const W=P.$Oe.fromString(M);let G=0;G+=w.sizeLongString(W);const q=w.alloc(f.ReplyOKJSON,N,G);return q.writeLongString(W),q.buffer}static g(N,M,W){const G=P.$Oe.fromString(M);let q=0;q+=w.sizeUInt32,q+=w.sizeLongString(G);for(const K of W)q+=w.sizeVSBuffer(K);const J=w.alloc(f.ReplyOKJSONWithBuffers,N,q);J.writeUInt32(W.length),J.writeLongString(G);for(const K of W)J.writeBuffer(K);return J.buffer}static deserializeReplyOKJSON(N){const M=N.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(N,M){const W=N.readUInt32(),G=N.readLongString(),q=[];for(let J=0;J<W;++J)q.push(N.readVSBuffer());return new a.$2w(i(G,q,M))}static serializeReplyErr(N,M){const W=M?d(A.$2(M),null):void 0;if(typeof W!="string")return this.h(N);const G=P.$Oe.fromString(W);let q=0;q+=w.sizeLongString(G);const J=w.alloc(f.ReplyErrError,N,q);return J.writeLongString(G),J.buffer}static deserializeReplyErrError(N){const M=N.readLongString();return JSON.parse(M)}static h(N){return w.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(b||(b={}))}),define(Ne[225],Me([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8tc=void 0;const v=function(T){const A=O=>{globalThis.removeEventListener("message",A);const $=O.data;Object.defineProperties(globalThis,{postMessage:{value(o,k){$.postMessage(o,k)}},onmessage:{get(){return $.onmessage},set(o){$.onmessage=o}}}),$.addEventListener("message",o=>{globalThis.dispatchEvent(new MessageEvent("message",{data:o.data,ports:o.ports?[...o.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class P extends EventTarget{constructor(T,A,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${A}'))`,o=new Blob([$],{type:"application/javascript"}),k=URL.createObjectURL(o),y=new MessageChannel,a=k,S={type:"_newWorker",id:a,port:y.port2,url:k,options:O};T(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{T({type:"_terminateWorker",id:a}),URL.revokeObjectURL(k),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),y.port1.start()}}e.$8tc=P}),define(Ne[226],Me([1,0,22,28,15,60,3]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$vL=void 0,e.$wL=k,e.$xL=y,e.$vL=(0,A.$Gi)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${O.join("")}]+`),o=7;function k(S){if(S.scheme!==I.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const r=parseInt(S.fragment.substring(0,d).replace($,""),o),s=(0,v.$8e)(S.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:S.with({scheme:s,fragment:null})}}function y(S,d){const r=d.toString(o),c=`${r.length<O.length?O[r.length-1]:"z"}${r}s${(0,v.$9e)(v.$Oe.fromString(S.scheme),!0,!0)}`;return S.with({scheme:I.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new P.$Bc}getNotebook(d){if(d.scheme===I.Schemas.vscodeNotebookCell){const r=k(d);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$yL=a,(0,T.$Us)(e.$vL,a,T.InstantiationType.Delayed)}),define(Ne[89],Me([1,0,22,41,40,72,15,19,20,31,226]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$PL=e.CellStatusbarAlignment=e.$OL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$LL=e.$KL=e.$IL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HL=e.$GL=e.$FL=e.$EL=e.CellKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=void 0,e.$JL=u,e.$ML=h,e.$NL=E,e.$QL=C,e.$RL=f,P=Ve(P),e.$zL="workbench.editor.notebook",e.$AL="workbench.editor.notebookTextDiffEditor",e.$BL="workbench.editor.interactive",e.$CL="workbench.editor.repl",e.$DL="replNotebook.input.execute";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$EL=["application/json","application/javascript","text/html","image/svg+xml",T.$bt.latex,T.$bt.markdown,"image/png","image/jpeg",T.$bt.text],e.$FL=[T.$bt.latex,T.$bt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$bt.text],e.$GL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HL="_notAvailable";var a;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var c;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var l;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function oe(ae,Se){return(0,k.$xL)(ae,Se)}K.generate=oe;function me(ae){return(0,k.$wL)(ae)}K.parse=me;function le(ae,Se){return ae.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${ae.scheme!==A.Schemas.file?ae.scheme:""}`})}K.generateCellOutputUri=le;function _(ae){if(ae.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ae.fragment);if(!Se)return;const Oe=Se[1]&&Se[1]!==""?Se[1]:void 0,X=Se[2];return{outputId:Oe,notebook:ae.with({scheme:X||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=_;function ce(ae,Se,Oe){return K.generate(ae,Se).with({scheme:Oe})}K.generateCellPropertyUri=ce;function pe(ae,Se){if(ae.scheme===Se)return K.parse(ae.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(n||(e.CellUri=n={}));const t=K=>$.$j?K.replace(/\//g,"\\"):K;class g{constructor(oe=[],me=e.$EL){this.e=me,this.d=[...new Set(oe)].map(le=>({pattern:le,matches:P.$Bk(t(le))}))}sort(oe){const me=new Map(I.Iterable.map(oe,_=>[_,t(_)]));let le=[];for(const{matches:_}of this.d)for(const[ce,pe]of me)if(_(pe)){le.push(ce),me.delete(ce);break}return me.size&&(le=le.concat([...me.keys()].sort((_,ce)=>this.e.indexOf(_)-this.e.indexOf(ce)))),le}prioritize(oe,me){const le=this.f(oe);if(le===-1){this.d.unshift({pattern:oe,matches:P.$Bk(t(oe))});return}const _=new Set(me.map(pe=>this.f(pe,le)));_.delete(-1);const ce=Array.from(_).sort();this.d.splice(le+1,0,...ce.map(pe=>this.d[pe]));for(let pe=ce.length-1;pe>=0;pe--)this.d.splice(ce[pe],1)}toArray(){return this.d.map(oe=>oe.pattern)}f(oe,me=this.d.length){const le=t(oe);for(let _=0;_<me;_++)if(this.d[_].matches(le))return _;return-1}}e.$IL=g;function u(K,oe,me,le=(_,ce)=>_===ce){const _=[];function ce(Se,Oe,X){if(Oe===0&&X.length===0)return;const B=_[_.length-1];B&&B.start+B.deleteCount===Se?(B.deleteCount+=Oe,B.toInsert.push(...X)):_.push({start:Se,deleteCount:Oe,toInsert:X})}let pe=0,ae=0;for(;;){if(pe===K.length){ce(pe,0,oe.slice(ae));break}if(ae===oe.length){ce(pe,K.length-pe,[]);break}const Se=K[pe],Oe=oe[ae];if(le(Se,Oe)){pe+=1,ae+=1;continue}me(Oe)?(ce(pe,1,[]),pe+=1):(ce(pe,0,[Oe]),ae+=1)}return _}e.$KL=new o.$Xj("notebookEditorCursorAtBoundary","none"),e.$LL=new o.$Xj("notebookEditorCursorAtLineBoundary","none");var p;(function(K){K.default="default",K.option="option"})(p||(e.NotebookEditorPriority=p={}));var m;(function(K){K.Cells="cells",K.Text="text",K.None="none"})(m||(e.NotebookFindScopeType=m={}));function h(K){const oe=K;return!!((typeof oe.include=="string"||P.$Ck(oe.include))&&(typeof oe.exclude=="string"||P.$Ck(oe.exclude)))}function E(K,oe,me){if(Array.isArray(K.viewType)&&K.viewType.indexOf(oe)>=0||K.viewType===oe)return!0;if(K.filenamePattern){const le=h(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,_=h(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(P.$Ak(le,(0,O.$oc)(me.fsPath).toLowerCase()))return!(_&&P.$Ak(_,(0,O.$oc)(me.fsPath).toLowerCase()))}return!1}e.$OL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class w{static{this.d="notebook/"}static create(oe){return`${w.d}${oe}`}static parse(oe){if(oe.startsWith(w.d))return oe.substring(w.d.length)}}e.$PL=w;function C(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const R=new TextDecoder;function f(K){const oe=[];let me=!1;for(const pe of K)(oe.length===0||me)&&(oe.push(pe),me=!0);let le=N(oe);const _=v.$Oe.concat(oe.map(pe=>v.$Oe.wrap(pe))),ce=J(_);return le=le||ce.byteLength!==_.byteLength,{data:ce,didCompression:le}}e.$SL="\x1B[A";const b=e.$SL.split("").map(K=>K.charCodeAt(0)),L=10;function N(K){let oe=!1;return K.forEach((me,le)=>{if(le===0||me.length<e.$SL.length)return;const _=K[le-1],ce=me.subarray(0,e.$SL.length);if(ce[0]===b[0]&&ce[1]===b[1]&&ce[2]===b[2]){const pe=_.lastIndexOf(L);if(pe===-1)return;oe=!0,K[le-1]=_.subarray(0,pe),K[le]=me.subarray(e.$SL.length)}}),oe}function M(K){let oe=K;do K=oe,oe=K.replace(/[^\n]\x08/gm,"");while(oe.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const oe=K.match(/^(.*)\r+/m)[1];let me=K.match(/\r+(.*)$/m)[1];me=me+oe.slice(me.length,oe.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,me)}return K}const G=8,q=13;function J(K){return!K.buffer.includes(G)&&!K.buffer.includes(q)?K:v.$Oe.fromString(W(M(R.decode(K.buffer))))}}),define(Ne[7],Me([1,0,17,13,59,28,72,12,14,2,38,18,29,109,89]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d){"use strict";var r,s,c,l,i,n,t,g,u,p,m,h,E,D,w,C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$dQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.LanguageModelChatMessageRole=e.$7P=e.$6P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$CP=e.$BP=e.$AP=e.$zP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.TestRunProfileKind=e.TestResultState=e.$sP=e.$rP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$qP=e.NotebookVariablesRequestKind=e.$pP=e.$oP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$nP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.ColorThemeKind=e.$hP=e.$gP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$fP=e.QuickInputButtonLocation=e.$eP=e.DebugConsoleMode=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$$O=e.$0O=e.FileChangeType=e.$9O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$8O=e.$7O=e.$6O=e.$5O=e.InlineCompletionTriggerKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$RO=e.ConfigurationTarget=e.$QO=e.$PO=e.$OO=e.$NO=e.DocumentPasteTriggerKind=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$GO=e.ViewBadge=e.ProgressLocation=e.$FO=e.$EO=e.TaskScope=e.ShellQuoting=e.$DO=e.$CO=e.$BO=e.TaskPanelKind=e.TaskRevealKind=e.$AO=e.TerminalLocation=e.$zO=e.$yO=e.$xO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$wO=e.$vO=e.$uO=e.$tO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$nO=e.$mO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.LanguageStatusSeverity=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.CodeActionTriggerKind=e.$aO=e.$_N=e.SymbolTag=e.SymbolKind=e.$$N=e.$0N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.DiagnosticSeverity=e.DiagnosticTag=e.$4N=e.$3N=e.FileEditType=e.$2N=e.$1N=e.$ZN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YN=e.$XN=e.$WN=e.$TN=e.$SN=e.$RN=e.$QN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$UN=q,e.$VN=J,e.$sO=wt,e.$SO=Ui,e.$yP=Rn;function f(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const De=se.length===1?[]:se[1];return Reflect.construct(U,De,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[De,...Ge]=se;return Reflect.construct(U,Ge,De.constructor)}}})}var b;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var L;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let N=r=class{static from(...F){let se=F;return new r(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$QN=N,e.$QN=N=r=Je([f],N);let M=s=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isBefore(se)&&(se=Ge)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isAfter(se)&&(se=Ge)}return se}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;const{line:se,character:De}=F;return typeof se=="number"&&typeof De=="number"}static of(F){if(F instanceof s)return F;if(this.isPosition(F))return new s(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,se){if(F<0)throw(0,P.$7)("line must be non-negative");if(se<0)throw(0,P.$7)("character must be non-negative");this.c=F,this.e=se}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,se=0){if(F===null||se===null)throw(0,P.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&se===0?this:new s(this.line+De,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,P.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),De===this.line&&se===this.character?this:new s(De,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$RN=M,e.$RN=M=s=Je([f],M);let W=c=class{static isRange(F){return F instanceof c?!0:F?M.isPosition(F.start)&&M.isPosition(F.end):!1}static of(F){if(F instanceof c)return F;if(this.isRange(F))return new c(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,se,De,Ge){let it,dt;if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ge=="number"?(it=new M(F,se),dt=new M(De,Ge)):M.isPosition(F)&&M.isPosition(se)&&(it=M.of(F),dt=M.of(se)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(F){return c.isRange(F)?this.contains(F.start)&&this.contains(F.end):M.isPosition(F)?!(M.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const se=M.Max(F.start,this.c),De=M.Min(F.end,this.e);if(!se.isAfter(De))return new c(se,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=M.Min(F.start,this.c),De=M.Max(F.end,this.end);return new c(se,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,se=this.end){if(F===null||se===null)throw(0,P.$7)();let De;return F?M.isPosition(F)?De=F:(De=F.start||this.start,se=F.end||this.end):De=this.start,De.isEqual(this.c)&&se.isEqual(this.end)?this:new c(De,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return q(this)}};e.$SN=W,e.$SN=W=c=Je([f],W);let G=l=class extends W{static isSelection(F){return F instanceof l?!0:F?W.isRange(F)&&M.isPosition(F.anchor)&&M.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,se,De,Ge){let it,dt;if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ge=="number"?(it=new M(F,se),dt=new M(De,Ge)):M.isPosition(F)&&M.isPosition(se)&&(it=M.of(F),dt=M.of(se)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return J(this)}};e.$TN=G,e.$TN=G=l=Je([f],G);function q(U){return U.isEmpty?`[${U.start.line}:${U.start.character})`:`[${U.start.line}:${U.start.character} -> ${U.end.line}:${U.end.character})`}function J(U){let F=q(U);return U.isEmpty||(U.active.isEqual(U.start)?F=`|${F}`:F=`${F}|`),F}const K=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,P.$7)("connectionToken")};class oe{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se,De){if(typeof F!="string"||F.length===0)throw(0,P.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,P.$7)("port");typeof De<"u"&&K(De),this.host=F,this.port=Math.round(se),this.connectionToken=De}}e.$WN=oe;class me{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se){this.makeConnection=F,this.connectionToken=se,typeof se<"u"&&K(se)}}e.$XN=me;class le extends Error{static NotAvailable(F,se){return new le(F,S.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new le(F,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=S.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=se,this._detail=De,Object.setPrototypeOf(this,le.prototype)}}e.$YN=le;var _;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ce;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let pe=i=class{static isTextEdit(F){return F instanceof i?!0:F?W.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new i(F,se)}static insert(F,se){return i.replace(new W(F,F),se)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const se=new i(new W(new M(0,0),new M(0,0)),"");return se.newEol=F,se}get range(){return this.c}set range(F){if(F&&!W.isRange(F))throw(0,P.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,P.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,P.$7)("newEol");this.f=F}constructor(F,se){this.c=F,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZN=pe,e.$ZN=pe=i=Je([f],pe);let ae=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?yi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new n(F,se)}static insertCells(F,se){return new n(new yi(F,F),se)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,se){const De=new n(new yi(F,F),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(F){const se=new n(new yi(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};e.$1N=ae,e.$1N=ae=n=Je([f],ae);class Se{static isSnippetTextEdit(F){return F instanceof Se?!0:F?W.isRange(F.range)&&B.isSnippetString(F.snippet):!1}static replace(F,se){return new Se(F,se)}static insert(F,se){return Se.replace(new W(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.$2N=Se;var Oe;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Oe||(e.FileEditType=Oe={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,se,De,Ge){this.c.push({_type:Oe.File,from:F,to:se,options:De,metadata:Ge})}createFile(F,se,De){this.c.push({_type:Oe.File,from:void 0,to:F,options:se,metadata:De})}deleteFile(F,se,De){this.c.push({_type:Oe.File,from:F,to:void 0,options:se,metadata:De})}e(F,se,De){this.c.push({_type:Oe.Cell,metadata:De,uri:F,edit:{editType:d.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(F,se,De,Ge){const it=se.start,dt=se.end;(it!==dt||De.length>0)&&this.c.push({_type:Oe.CellReplace,uri:F,index:it,count:dt-it,cells:De,metadata:Ge})}g(F,se,De,Ge){this.c.push({_type:Oe.Cell,metadata:Ge,uri:F,edit:{editType:d.CellEditType.Metadata,index:se,metadata:De}})}replace(F,se,De,Ge){this.c.push({_type:Oe.Text,uri:F,edit:new pe(se,De),metadata:Ge})}insert(F,se,De,Ge){this.replace(F,new W(se,se),De,Ge)}delete(F,se,De){this.replace(F,se,"",De)}has(F){return this.c.some(se=>se._type===Oe.Text&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const De of se){if(!De)continue;let Ge,it;Array.isArray(De)?(Ge=De[0],it=De[1]):Ge=De,ae.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(F,Ge.range.start,Ge.newCellMetadata,it):Ge.newNotebookMetadata?this.e(F,Ge.newNotebookMetadata,it):this.f(F,Ge.range,Ge.newCells,it):Se.isSnippetTextEdit(Ge)?this.c.push({_type:Oe.Snippet,uri:F,range:Ge.range,edit:Ge.snippet,metadata:it}):this.c.push({_type:Oe.Text,uri:F,edit:Ge,metadata:it})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case Oe.Text:case Oe.Snippet:case Oe.Cell:case Oe.CellReplace:Ge.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,v.$Ib)(this.c)}}get(F){const se=[];for(const De of this.c)De._type===Oe.Text&&De.uri.toString()===F.toString()&&se.push(De.edit);return se}entries(){const F=new T.$Bc;for(const se of this.c)if(se._type===Oe.Text){let De=F.get(se.uri);De||(De=[se.uri,[]],F.set(se.uri,De)),De[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3N=X,e.$3N=X=Je([f],X);let B=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=t.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this.e++){if(typeof F=="function"){const De=new t;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=t.c(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this.e++){const De=F.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const De=new t;De.e=this.e,se(De),this.e=De.e,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$4N=B,e.$4N=B=t=Je([f],B);var te;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var ye;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ye||(e.DiagnosticSeverity=ye={}));let de=g=class{static isLocation(F){return F instanceof g?!0:F?W.isRange(F.range)&&o.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(W.isRange(se))this.range=W.of(se);else if(M.isPosition(se))this.range=new W(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5N=de,e.$5N=de=g=Je([f],de);let we=class{static is(F){return F?typeof F.message=="string"&&F.location&&W.isRange(F.location.range)&&o.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};e.$6N=we,e.$6N=we=Je([f],we);let he=class{constructor(F,se,De=ye.Error){if(!W.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=De}toJSON(){return{severity:ye[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,v.$ub)(F.tags,se.tags)&&(0,v.$ub)(F.relatedInformation,se.relatedInformation,we.isEqual)}};e.$7N=he,e.$7N=he=Je([f],he);let Z=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};e.$8N=Z,e.$8N=Z=Je([f],Z);let x=class extends Z{constructor(F,se,De,Ge){super(F,se),this.canIncreaseVerbosity=De,this.canDecreaseVerbosity=Ge}};e.$9N=x,e.$9N=x=Je([f],x);var be;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(be||(e.HoverVerbosityAction=be={}));var $e;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})($e||(e.DocumentHighlightKind=$e={}));let Ae=class{constructor(F,se=$e.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:$e[this.kind]}}};e.$0N=Ae,e.$0N=Ae=Je([f],Ae);let Ue=class{constructor(F,se){this.uri=F,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$$N=Ue,e.$$N=Ue=Je([f],Ue);var ke;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Pe;(function(U){U[U.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Te=u=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,De,Ge,it){this.name=F,this.kind=se,this.containerName=it,typeof De=="string"&&(this.containerName=De),Ge instanceof de?this.location=Ge:De instanceof W&&(this.location=new de(Ge,De)),u.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$_N=Te,e.$_N=Te=u=Je([f],Te);let z=p=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(p.validate)}constructor(F,se,De,Ge,it){this.name=F,this.detail=se,this.kind=De,this.range=Ge,this.selectionRange=it,this.children=[],p.validate(this)}};e.$aO=z,e.$aO=z=p=Je([f],z);var j;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let Q=class{constructor(F,se){this.title=F,this.kind=se}};e.$bO=Q,e.$bO=Q=Je([f],Q);let V=class{static{m=this}static{this.c="."}constructor(F){this.value=F}append(F){return new m(this.value?this.value+m.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+m.c)}};e.$cO=V,e.$cO=V=m=Je([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let re=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$dO=re,e.$dO=re=Je([f],re);class ge{constructor(F,se,De,Ge,it,dt){this.kind=F,this.name=se,this.detail=De,this.uri=Ge,this.range=it,this.selectionRange=dt}}e.$eO=ge;class Ce{constructor(F,se){this.fromRanges=se,this.from=F}}e.$fO=Ce;class ze{constructor(F,se){this.fromRanges=se,this.to=F}}e.$gO=ze;var He;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(He||(e.LanguageStatusSeverity=He={}));let _e=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};e.$hO=_e,e.$hO=_e=Je([f],_e);let tt=h=class{#e;static isMarkdownString(F){return F instanceof h?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){this.#e=new I.$5k(F,{supportThemeIcons:se})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,se){return this.#e.appendCodeblock(se??"",F),this}};e.$iO=tt,e.$iO=tt=h=Je([f],tt);let nt=class{constructor(F,se){this.label=F,this.documentation=se}};e.$jO=nt,e.$jO=nt=Je([f],nt);let et=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};e.$kO=et,e.$kO=et=Je([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$lO=rt,e.$lO=rt=Je([f],rt);var ft;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(ft||(e.SignatureHelpTriggerKind=ft={}));var lt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(F){this.value=F}};e.$mO=st,e.$mO=st=Je([f],st);let ct=class{constructor(F,se,De){this.position=F,this.label=se,this.kind=De}};e.$nO=ct,e.$nO=ct=Je([f],ct);var mt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(mt||(e.CompletionTriggerKind=mt={}));var $t;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})($t||(e.CompletionItemKind=$t={}));var qe;(function(U){U[U.Deprecated=1]="Deprecated"})(qe||(e.CompletionItemTag=qe={}));let je=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&$t[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$oO=je,e.$oO=je=Je([f],je);let ne=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};e.$pO=ne,e.$pO=ne=Je([f],ne);let ee=class{constructor(F,se,De){this.insertText=F,this.range=se,this.command=De}};e.$qO=ee,e.$qO=ee=Je([f],ee);let Y=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$rO=Y,e.$rO=Y=Je([f],Y);var Ze;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(Ze||(e.PartialAcceptTriggerKind=Ze={}));var xe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function wt(U,F){return`${y.$sn.toKey(U)}.${F}`}var Lt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Lt||(e.TextEditorLineNumbersStyle=Lt={}));var Qt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ei||(e.TextEditorRevealType=ei={}));var ti;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ti||(e.TextEditorSelectionChangeKind=ti={}));var oi;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var At;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(At||(e.DecorationRangeBehavior=At={})),function(U){function F(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(ti||(e.TextEditorSelectionChangeKind=ti={}));var Ye;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(U){function F(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(Ye||(e.SyntaxTokenType=Ye={}));let Ct=class{constructor(F,se){if(se&&!o.URI.isUri(se))throw(0,P.$7)("target");if(!W.isRange(F)||F.isEmpty)throw(0,P.$7)("range");this.range=F,this.target=se}};e.$tO=Ct,e.$tO=Ct=Je([f],Ct);let hi=class{constructor(F,se,De,Ge){this.red=F,this.green=se,this.blue=De,this.alpha=Ge}};e.$uO=hi,e.$uO=hi=Je([f],hi);let pt=class{constructor(F,se){if(se&&!(se instanceof hi))throw(0,P.$7)("color");if(!W.isRange(F)||F.isEmpty)throw(0,P.$7)("range");this.range=F,this.color=se}};e.$vO=pt,e.$vO=pt=Je([f],pt);let Dt=class{constructor(F){if(!F||typeof F!="string")throw(0,P.$7)("label");this.label=F}};e.$wO=Dt,e.$wO=Dt=Je([f],Dt);var ii;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var ni;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ni||(e.SourceControlInputBoxValidationType=ni={}));var jt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var gt;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Ut{constructor(F,se,De){if(this.startIndex=F,this.length=se,this.tooltip=De,typeof F!="number"||F<0)throw(0,P.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,P.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,P.$7)("tooltip")}}e.$xO=Ut;class ri{constructor(F){this.uri=F}}e.$yO=ri;class ai{constructor(F){this.terminalCommand=F}}e.$zO=ai;var Ke;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Ke||(e.TerminalLocation=Ke={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,P.$7)("options")}}e.$AO=ci;var di;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(F){switch(F){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,P.$7)("name");this.c=F}get id(){return this.c}};e.$BO=vt,e.$BO=vt=E=Je([f],vt);function Ft(U){let F="";for(let se=0;se<U.length;se++)F+=U[se].replace(/,/g,",,")+",";return F}let Nt=class{constructor(F,se,De){if(typeof F!="string")throw(0,P.$7)("process");this.e=[],this.c=F,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=De):this.f=se)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,P.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const se of this.e)F.push(se);return Ft(F)}};e.$CO=Nt,e.$CO=Nt=Je([f],Nt);let Wt=class{constructor(F,se,De){if(this.f=[],Array.isArray(se)){if(!F)throw(0,P.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,P.$7)("command");this.e=F,this.f=se,this.g=De}else{if(typeof F!="string")throw(0,P.$7)("commandLine");this.c=F,this.g=se}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,P.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,P.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)F.push(typeof se=="string"?se:se.value);return Ft(F)}};e.$DO=Wt,e.$DO=Wt=Je([f],Wt);var si;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(si||(e.ShellQuoting=si={}));var Gt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class li{constructor(F){this.c=F}computeId(){return"customExecution"+(0,k.$3g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$EO=li;let Bt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,se,De,Ge,it,dt){this.k=!1,this.l=this.definition=F;let Et;typeof se=="string"?(this.o=this.name=se,this.w=this.source=De,this.execution=Ge,Et=it,this.k=!0):se===Gt.Global||se===Gt.Workspace?(this.target=se,this.o=this.name=De,this.w=this.source=Ge,this.execution=it,Et=dt):(this.target=se,this.o=this.name=De,this.w=this.source=Ge,this.execution=it,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,k.$3g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,P.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,P.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const se=this.l.type;(D.g===se||D.e===se||D.f===se||D.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,P.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$FO=Bt,e.$FO=Bt=D=Je([f],Bt);var Ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Ht||(e.ProgressLocation=Ht={}));var Kt;(function(U){function F(se){const De=se;return(0,$.$jg)(De.value)?De.tooltip&&!(0,$.$fg)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}U.isViewBadge=F})(Kt||(e.ViewBadge=Kt={}));let Mt=w=class{static isTreeItem(F,se){const De=F;if(De.checkboxState!==void 0){const Ge=(0,$.$jg)(De.checkboxState)?De.checkboxState:(0,$.$hg)(De.checkboxState)&&(0,$.$jg)(De.checkboxState.state)?De.checkboxState.state:void 0,it=!(0,$.$jg)(De.checkboxState)&&(0,$.$hg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==kt.Checked&&Ge!==kt.Unchecked||it!==void 0&&!(0,$.$fg)(it))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof w)return!0;if(De.label!==void 0&&!(0,$.$fg)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,$.$fg)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,$.$fg)(De.iconPath)&&!o.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,$.$fg)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,$.$fg)(Ge.light)&&!o.URI.isUri(Ge.light)&&!(0,$.$fg)(Ge.dark)&&!o.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,$.$fg)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!o.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,$.$fg)(De.tooltip)&&!(De.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<bt.None&&De.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,$.$fg)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,se=bt.None){this.collapsibleState=se,o.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$GO=Mt,e.$GO=Mt=w=Je([f],Mt);var bt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var kt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$HO=Vt,e.$HO=Vt=Je([f],Vt);class It extends Vt{}e.$IO=It;class mi extends It{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$JO=mi;class Xt{constructor(F,se,De,Ge){this.name=F,this.uri=se,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$KO=Xt;let ki=class{#e=new Map;constructor(F){for(const[se,De]of F??[]){const Ge=this.#e.get(this.#t(se));Ge?Ge.push(De):this.#e.set(this.#t(se),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,se){this.#e.set(this.#t(F),[se])}forEach(F,se){for(const[De,Ge]of this.#e)for(const it of Ge)F.call(se,it,De,this)}*[Symbol.iterator](){for(const[F,se]of this.#e)for(const De of se)yield[F,De]}#t(F){return F.toLowerCase()}};e.$LO=ki,e.$LO=ki=Je([f],ki);let wi=class{constructor(F,se,De){this.insertText=F,this.title=se,this.kind=De}};e.$MO=wi,e.$MO=wi=Je([f],wi);var Oi;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(Oi||(e.DocumentPasteTriggerKind=Oi={}));class Ot{static{this.c="."}constructor(F){this.value=F}append(...F){return new Ot((this.value?[this.value,...F]:F).join(Ot.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Ot.c)}}e.$NO=Ot,Ot.Empty=new Ot("");class Mi{constructor(F,se,De){this.title=se,this.insertText=F,this.kind=De}}e.$OO=Mi;let ui=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$PO=ui,e.$PO=ui=Je([f],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Rt=class{constructor(F){this.id=F}};e.$QO=Rt,e.$QO=Rt=Je([f],Rt);var Ti;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let Ii=class{get base(){return this.c}set base(F){this.c=F,this.e=o.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!o.URI.isUri(F)&&!o.URI.isUri(F.uri)))throw(0,P.$7)("base");if(typeof se!="string")throw(0,P.$7)("pattern");typeof F=="string"?this.baseUri=o.URI.file(F):o.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RO=Ii,e.$RO=Ii=Je([f],Ii);const Di=new WeakMap;function Ui(U,F){Di.set(U,F)}let pi=class{constructor(F,se,De,Ge,it){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Di.get(this)??(0,k.$3g)()),this.c}};e.$TO=pi,e.$TO=pi=Je([f],pi);let qt=class extends pi{constructor(F,se,De,Ge,it,dt){if(super(se,De,Ge,it,dt),F===null)throw(0,P.$7)("location");this.location=F}};e.$UO=qt,e.$UO=qt=Je([f],qt);let Ci=class extends pi{constructor(F,se,De,Ge,it,dt){super(se,De,Ge,it,dt),this.functionName=F}};e.$VO=Ci,e.$VO=Ci=Je([f],Ci);let Ee=class extends pi{constructor(F,se,De,Ge,it,dt,Et,Zt){if(super(Ge,it,dt,Et,Zt),!se)throw(0,P.$7)("dataId");this.label=F,this.dataId=se,this.canPersist=De}};e.$WO=Ee,e.$WO=Ee=Je([f],Ee);let Re=class{constructor(F,se,De){this.command=F,this.args=se||[],this.options=De}};e.$XO=Re,e.$XO=Re=Je([f],Re);let fe=class{constructor(F,se){this.port=F,this.host=se}};e.$YO=fe,e.$YO=fe=Je([f],fe);let H=class{constructor(F){this.path=F}};e.$ZO=H,e.$ZO=H=Je([f],H);let Ie=class{constructor(F){this.implementation=F}};e.$1O=Ie,e.$1O=Ie=Je([f],Ie);class Be{constructor(F,se,De){this.session=F,this.threadId=se,this.frameId=De}}e.$2O=Be;class Xe{constructor(F,se){this.session=F,this.threadId=se}}e.$3O=Xe;let Qe=class{constructor(F,se){this.range=F,this.expression=se}};e.$4O=Qe,e.$4O=Qe=Je([f],Qe);var ut;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let Pt=class{constructor(F,se){this.range=F,this.text=se}};e.$5O=Pt,e.$5O=Pt=Je([f],Pt);let Jt=class{constructor(F,se,De=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=De}};e.$6O=Jt,e.$6O=Jt=Je([f],Jt);let Yt=class{constructor(F,se){this.range=F,this.expression=se}};e.$7O=Yt,e.$7O=Yt=Je([f],Yt);let zt=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};e.$8O=zt,e.$8O=zt=Je([f],zt);var xt;(function(U){U[U.AIGenerated=1]="AIGenerated"})(xt||(e.NewSymbolNameTag=xt={}));var rn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(F,se){this.newSymbolName=F,this.tags=se}}e.$9O=Vi;var zi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(zi||(e.FileChangeType=zi={}));let Qi=C=class extends Error{static FileExists(F){return new C(F,a.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(F){return new C(F,a.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(F){return new C(F,a.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(F){return new C(F,a.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(F){return new C(F,a.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(F){return new C(F,a.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(F,se=a.FileSystemProviderErrorCode.Unknown,De){super(o.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,a.$ql)(this,se),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$0O=Qi,e.$0O=Qi=C=Je([f],Qi);let Hi=class{constructor(F,se,De){this.start=F,this.end=se,this.kind=De}};e.$$O=Hi,e.$$O=Hi=Je([f],Hi);var Pi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var sn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Li;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var an;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var ji;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));var Gi;(function(U){U[U.Reply=1]="Reply",U[U.Comment=2]="Comment"})(Gi||(e.CommentThreadFocus=Gi={}));class En{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.$_O=En;function cn(U){return typeof U>"u"||(0,$.$gg)(U)}class Ki{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let se=0,De=F.tokenTypes.length;se<De;se++)this.k.set(F.tokenTypes[se],se);for(let se=0,De=F.tokenModifiers.length;se<De;se++)this.l.set(F.tokenModifiers[se],se)}}push(F,se,De,Ge,it){if(typeof F=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(F,se,De,Ge,it);if(W.isRange(F)&&typeof se=="string"&&cn(De))return this.o(F,se,De);throw(0,P.$7)()}o(F,se,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Ge=F.start.line,it=F.start.character,dt=F.end.character-F.start.character,Et=this.k.get(se);let Zt=0;if(De)for(const bi of De){if(!this.l.has(bi))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this.l.get(bi);Zt|=1<<Ei>>>0}this.q(Ge,it,dt,Et,Zt)}q(F,se,De,Ge,it){if(this.f&&(F<this.c||F===this.c&&se<this.e)){this.f=!1;const Zt=this.g.length/5|0;let bi=0,Ei=0;for(let Si=0;Si<Zt;Si++){let Ai=this.g[5*Si],tn=this.g[5*Si+1];Ai===0?(Ai=bi,tn+=Ei):Ai+=bi,this.g[5*Si]=Ai,this.g[5*Si+1]=tn,bi=Ai,Ei=tn}}let dt=F,Et=se;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=it,this.c=F,this.e=se}static r(F){const se=[],De=F.length/5|0;for(let Et=0;Et<De;Et++)se[Et]=Et;se.sort((Et,Zt)=>{const bi=F[5*Et],Ei=F[5*Zt];if(bi===Ei){const Si=F[5*Et+1],Ai=F[5*Zt+1];return Si-Ai}return bi-Ei});const Ge=new Uint32Array(F.length);let it=0,dt=0;for(let Et=0;Et<De;Et++){const Zt=5*se[Et],bi=F[Zt+0],Ei=F[Zt+1],Si=F[Zt+2],Ai=F[Zt+3],tn=F[Zt+4],Hn=bi-it,Mr=Hn===0?Ei-dt:Ei,nn=5*Et;Ge[nn+0]=Hn,Ge[nn+1]=Mr,Ge[nn+2]=Si,Ge[nn+3]=Ai,Ge[nn+4]=tn,it=bi,dt=Ei}return Ge}build(F){return this.f?new Ri(new Uint32Array(this.g),F):new Ri(Ki.r(this.g),F)}}e.$aP=Ki;class Ri{constructor(F,se){this.resultId=se,this.data=F}}e.$bP=Ri;class Dn{constructor(F,se,De){this.start=F,this.deleteCount=se,this.data=De}}e.$cP=Dn;class Sn{constructor(F,se){this.resultId=se,this.edits=F}}e.$dP=Sn;var ln;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Ji{constructor(F){this.name=F}}e.$eP=Ji;var Zi;(function(U){U[U.Title=1]="Title",U[U.Inline=2]="Inline"})(Zi||(e.QuickInputButtonLocation=Zi={}));let Fe=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$fP=Fe,e.$fP=Fe=Je([f],Fe);var vi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Xi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var ot;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ot||(e.ExtensionKind=ot={}));class St{static validate(F){if(typeof F.badge=="string"){let se=(0,O.$Qf)(F.badge,0);if(se<F.badge.length&&(se+=(0,O.$Qf)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ui.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,De){this.badge=F,this.tooltip=se,this.color=De}}e.$gP=St;let Yi=class{constructor(F){this.kind=F}};e.$hP=Yi,e.$hP=Yi=Je([f],Yi);var un;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class yi{static isNotebookRange(F){return F instanceof yi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,se){if(F<0)throw(0,P.$7)("start must be positive");if(se<0)throw(0,P.$7)("end must be positive");F<=se?(this.c=F,this.e=se):(this.c=se,this.e=F)}with(F){let se=this.c,De=this.e;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(De=F.end),se===this.c&&De===this.e?this:new yi(se,De)}}e.$iP=yi;class Bi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>Bi.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,De,Ge,it,dt,Et){this.kind=F,this.value=se,this.languageId=De,this.mime=Ge,this.outputs=it??[],this.metadata=dt,this.executionSummary=Et,Bi.validate(this)}}e.$jP=Bi;class qi{constructor(F){this.cells=F}}e.$kP=qi;class $i{static isNotebookCellOutputItem(F){return F instanceof $i?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return $i.json(se,"application/vnd.code.notebook.error")}static stdout(F){return $i.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return $i.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new $i(F,se)}static#e=new TextEncoder;static text(F,se=A.$bt.text){const De=$i.#e.encode(String(F));return new $i(De,se)}static json(F,se="text/x-json"){const De=JSON.stringify(F,void 0,"	");return $i.text(De,se)}constructor(F,se){this.data=F,this.mime=se;const De=(0,A.$ft)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$lP=$i;class Wi{static isNotebookCellOutput(F){return F instanceof Wi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const De=new Set,Ge=new Set;for(let it=0;it<F.length;it++){const dt=F[it],Et=(0,A.$ft)(dt.mime);if(!De.has(Et)||(0,d.$QL)(Et)){De.add(Et);continue}Ge.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ge.size===0?F:F.filter((it,dt)=>!Ge.has(dt))}constructor(F,se,De){this.items=Wi.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,k.$3g)(),this.metadata=se??De)}}e.$mP=Wi;var hn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(F,se){this.text=F,this.alignment=se}}e.$nP=kn;var gn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(F,se=[]){this.uri=F,this.provides=(0,v.$2b)(se)}}e.$oP=In;class Cn{constructor(F){this.label=F}}e.$pP=Cn;var pn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(pn||(e.NotebookVariablesRequestKind=pn={}));let _i=class{constructor(F,se){this.label=F,this.timestamp=se}};e.$qP=_i,e.$qP=_i=Je([f],_i);var $n;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})($n||(e.ExtensionMode=$n={}));var bn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(bn||(e.ExtensionRuntime=bn={}));var ie;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ie||(e.StandardTokenType=ie={}));class ue{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.$rP=ue;class Le{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$sP=Le;var at;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(at||(e.TestResultState=at={}));var yt;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(yt||(e.TestRunProfileKind=yt={}));let Tt=class{constructor(F=void 0,se=void 0,De=void 0,Ge=!1,it=!0){this.include=F,this.exclude=se,this.profile=De,this.continuous=Ge,this.preserveFocus=it}};e.$tP=Tt,e.$tP=Tt=Je([f],Tt);let gi=R=class{static diff(F,se,De){const Ge=new R(F);return Ge.expectedOutput=se,Ge.actualOutput=De,Ge}constructor(F){this.message=F}};e.$uP=gi,e.$uP=gi=R=Je([f],gi);let Fi=class{constructor(F){this.id=F}};e.$vP=Fi,e.$vP=Fi=Je([f],Fi);class en{constructor(F,se,De){this.label=F,this.uri=se,this.position=De}}e.$wP=en;class wn{constructor(F,se){this.covered=F,this.total=se,Rn(this)}}e.$xP=wn;function Rn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Pn{static fromDetails(F,se){const De=new wn(0,0),Ge=new wn(0,0),it=new wn(0,0);for(const Et of se)if("branches"in Et){De.total+=1,De.covered+=Et.executed?1:0;for(const Zt of Et.branches)Ge.total+=1,Ge.covered+=Zt.executed?1:0}else it.total+=1,it.covered+=Et.executed?1:0;const dt=new Pn(F,De,Ge.total>0?Ge:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}constructor(F,se,De,Ge,it=[]){this.uri=F,this.statementCoverage=se,this.branchCoverage=De,this.declarationCoverage=Ge,this.fromTests=it}}e.$zP=Pn;class Jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,De=[]){this.executed=F,this.location=se,this.branches=De}}e.$AP=Jn;class Zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,De){this.executed=F,this.location=se,this.label=De}}e.$BP=Zn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,De){this.name=F,this.executed=se,this.location=De}}e.$CP=Xn;var An;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var On;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var Tn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(F,se,De,Ge,it,dt){this.kind=F,this.name=se,this.detail=De,this.uri=Ge,this.range=it,this.selectionRange=dt}}e.$DP=Yn;class xn{constructor(F){this.uri=F}}e.$EP=xn;class _n{constructor(F,se){this.original=F,this.modified=se}}e.$FP=_n;class er{constructor(F,se,De,Ge){this.base=F,this.input1=se,this.input2=De,this.result=Ge}}e.$GP=er;class tr{constructor(F,se){this.uri=F,this.viewType=se}}e.$HP=tr;class ir{constructor(F){this.viewType=F}}e.$IP=ir;class nr{constructor(F,se){this.uri=F,this.notebookType=se}}e.$JP=nr;class rr{constructor(F,se,De){this.original=F,this.modified=se,this.notebookType=De}}e.$KP=rr;class sr{constructor(){}}e.$LP=sr;class or{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.$MP=or;class ar{constructor(){}}e.$NP=ar;class cr{constructor(F){this.textDiffs=F}}e.$OP=cr;var Nn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Nn||(e.InteractiveSessionVoteDirection=Nn={}));var Mn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Mn||(e.ChatCopyKind=Mn={}));var Ln;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class lr{constructor(F,se,De){this.id=F,this.label=se,this.values=De}}e.$PP=lr;var Fn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Un;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Un||(e.ChatResultFeedbackKind=Un={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$QP=ur;class hr{constructor(F,se){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F,this.vulnerabilities=se}}e.$RP=hr;class dr{constructor(F,se){this.participant=F,this.command=se}}e.$SP=dr;class fr{constructor(F,se,De,Ge){this.title=F,this.message=se,this.data=De,this.buttons=Ge}}e.$TP=fr;class gr{constructor(F,se){this.value=F,this.baseUri=se}}e.$UP=gr;class mr{constructor(F,se){this.value=F,this.title=se}}e.$VP=mr;class pr{constructor(F){this.value=F}}e.$WP=pr;class $r{constructor(F,se){this.value=F,this.task=se}}e.$XP=$r;class br{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$YP=br;class wr{constructor(F){this.value=F}}e.$ZP=wr;class vr{constructor(F,se,De){this.value=F,this.iconPath=se,this.options=De}}e.$1P=vr;class yr{constructor(F,se,De){this.value=F,this.license=se,this.snippet=De}}e.$2P=yr;class Er{constructor(F,se){this.uri=F,this.edits=Array.isArray(se)?se:[se]}}e.$3P=Er;class Dr{constructor(F,se,De,Ge){this.prompt=F,this.command=se,this.references=De,this.participant=Ge}}e.$4P=Dr;class Sr{constructor(F,se,De,Ge){this.response=F,this.result=se,this.participant=De,this.command=Ge}}e.$5P=Sr;var zn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var jn;(function(U){U[U.Complete=1]="Complete",U[U.Partial=2]="Partial",U[U.Omitted=3]="Omitted"})(jn||(e.ChatResponseReferencePartStatusKind=jn={}));class kr{constructor(F,se,De){this.document=F,this.selection=se,this.wholeRange=De}}e.$6P=kr;class Ir{constructor(F){this.cell=F}}e.$7P=Ir;var vn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Cr{constructor(F,se,De){this.name=F,this.content=se,this.isError=De??!1}}e.$8P=Cr;class yn{static User(F,se){const De=new yn(vn.User,typeof F=="string"?F:"",se);return De.content2=F,De}static Assistant(F,se){return new yn(vn.Assistant,F,se)}constructor(F,se,De){this.role=F,this.content=se,this.content2=se,this.name=De}}e.$9P=yn;class Pr{constructor(F,se){this.name=F,this.parameters=se}}e.$0P=Pr;class Rr{constructor(F){this.value=F}}e.$$P=Rr;class Ar{constructor(F){this.content=F}}e.$_P=Ar;class Or{constructor(F,se){this.content=F,this.name=se}}e.$aQ=Or;class Tr{constructor(F,se){this.content=F,this.name=se}}e.$bQ=Tr;class Ni extends Error{static NotFound(F){return new Ni(F,Ni.NotFound.name)}static NoPermissions(F){return new Ni(F,Ni.NoPermissions.name)}static Blocked(F){return new Ni(F,Ni.Blocked.name)}constructor(F,se,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=se??""}}e.$cQ=Ni;var Bn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Bn||(e.RelatedInformationType=Bn={}));var qn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(qn||(e.SpeechToTextStatus=qn={}));var Wn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Vn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Nr{constructor(F,se){this.text=F,this.range=se}}e.$dQ=Nr;var Qn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Qn||(e.InlineEditTriggerKind=Qn={}))}),define(Ne[227],Me([1,0,5,7]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$ON.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,O,$){if(this.a.size===0)throw new Error("No related information providers registered");const o=this.a.get(A);if(!o)throw new Error("related information provider not found");return await o.provideRelatedInformation(O,$)??[]}getRelatedInformation(A,O,$){return this.c.$getAiRelatedInformation(O,$)}registerRelatedInformationProvider(A,O,$){const o=this.b;return this.b++,this.a.set(o,$),this.c.$registerAiRelatedInformationProvider(o,O),new P.$QN(()=>{this.c.$unregisterAiRelatedInformationProvider(o),this.a.delete(o)})}}e.$Ipc=I}),define(Ne[90],Me([1,0,6,5,7,18,118,3,16]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,O.$Gi)("IExtHostAuthentication");let o=class{constructor(a){this.b=new Map,this.c=new v.$me,this.onDidChangeSessions=this.c.event,this.d=new k,this.a=a.getProxy(P.$ON.MainThreadAuthentication)}async getSession(a,S,d,r={}){const s=T.$sn.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const l=a.displayName||a.name;return this.a.$getSession(S,d,s,l,r)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,r){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:r??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,r?.supportsMultipleAccounts??!1),new I.$QN(()=>{s.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const r=this.b.get(a);if(r)return await r.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const r=this.b.get(a);if(r)return await r.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(A.$QM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$Upc=o,e.$Upc=o=Je([We(0,$.$oQ)],o);class k{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const r=S().finally(()=>this.a.delete(a));return this.a.set(a,r),r}}}),define(Ne[123],Me([1,0,2,5,7,3,16,11,17,12,19,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(P.$ON.MainThreadDecorations)}registerFileDecorationProvider(r,s){const c=a.c++;this.f.set(c,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(c,s.identifier.value);const l=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const n=(0,$.$2b)(i);if(n.length<=a.d){this.g.$onDidChange(c,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,n.length);const t=n.map(p=>({uri:p,rank:(0,o.$jf)(p.path,"/")})),g=(0,$.$zb)(t,(p,m)=>p.rank-m.rank||(0,o.$zf)(p.uri.path,m.uri.path)),u=[];e:for(const p of g){let m;for(const h of p){const E=(0,k.$nc)(h.uri.path);if(m!==E&&(m=E,u.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,u)});return new I.$QN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,s,c){if(!this.f.has(r))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(s.map(async t=>{try{const{uri:g,id:u}=t,p=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!p)return;try{I.$gP.validate(p),p.badge&&typeof p.badge!="string"&&(0,y.$jH)(n,"codiconDecoration"),l[u]=[p.propagate,p.tooltip,p.badge,p.color]}catch(m){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${m}`)}}catch(g){this.h.error(g)}})),l}};e.$Yqc=S,e.$Yqc=S=a=Je([We(0,A.$oQ),We(1,O.$bk)],S),e.$Zqc=(0,T.$Gi)("IExtHostDecorations")}),define(Ne[228],Me([1,0,13,2,7,5,15,21,12]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;class o{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(T.$ON.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=o.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let r;d=a.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const c=this.$provideTextDocumentContent(S,s).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(s);if(!i)return;const n=(0,$.$tf)(l);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(s,l)}).catch(v.$Z).finally(()=>{r===c&&(r=void 0)});r=c})}return new I.$QN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(P.URI.revive(a),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$2qc=o}),define(Ne[124],Me([1,0,61,15,12,284,170,7,17]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,e.$qQ=k;const o=new Map;function k(d,r){r?o.set(d,r):o.delete(d)}function y(d){return o.get(d)}class a extends T.$tw{constructor(r,s,c,l,i,n,t){super(s,c,l,i),this.c=r,this.m=n,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===P.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,c){return r.y(s,c)},[Symbol.for("debug.description")](){return`TextDocument(${r.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,v.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,v.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const c=this.g,l=s.start.line,i=s.end.line,n=[];n.push(this.f[l].substring(s.start.character));for(let t=l+1;t<i;t++)n.push(this.f[t]);return n.push(this.f[i].substring(0,s.end.character)),n.join(c)}t(r){let s;if(r instanceof O.$RN?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new S(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),c=this.f[s.index].length;return new O.$RN(s.index,Math.min(s.remainder,c))}w(r){if(!(r instanceof O.$SN))throw new Error("Invalid argument");const s=this.x(r.start),c=this.x(r.end);return s===r.start&&c===r.end?r:new O.$SN(s.line,s.character,c.line,c.character)}x(r){if(!(r instanceof O.$RN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:c}=r,l=!1;if(s<0)s=0,c=0,l=!0;else if(s>=this.f.length)s=this.f.length-1,c=this.f[s].length,l=!0;else{const i=this.f[s].length;c<0?(c=0,l=!0):c>i&&(c=i,l=!0)}return l?new O.$RN(s,c):r}y(r,s){const c=this.x(r);if(!s)s=y(this.m);else if((0,I.$sf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const l=(0,A.$tt)(c.character+1,(0,A.$rt)(s),this.f[c.line],0);if(l)return new O.$SN(c.line,l.startColumn-1,c.line,l.endColumn-1)}}e.$rQ=a;class S{constructor(r,s,c){this.a=r,this.b=s,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$SN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$SN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sQ=S}),define(Ne[229],Me([1,0,5,7]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$ON.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,O,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const o=this.a.get(A);if(!o)throw new Error("Embedding vector provider not found");const k=await o.provideEmbeddingVector(O,$);if(!k)throw new Error("Embedding vector provider returned undefined");return k}registerEmbeddingVectorProvider(A,O,$){const o=this.b;return this.b++,this.a.set(o,$),this.c.$registerAiEmbeddingVectorProvider(O,o),new P.$QN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(o),this.a.delete(o)})}}e.$5qc=I}),define(Ne[68],Me([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=void 0,P=Ve(P);let d=S=class{constructor(s,c){this.b=new Map,this.c=new k.$Ph,this.a=s.getProxy(v.$ON.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let n;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await l.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===P.FilePermission.Readonly?1:void 0}}catch(n){S.e(n)}},async readDirectory(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(n){return S.e(n)}},async createDirectory(i){try{const n=l.b.get(i.scheme);return n&&!n.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(n.impl,n.extUri,i)):await l.a.$mkdir(i)}catch(n){return S.e(n)}},async readFile(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(n){return S.e(n)}},async writeFile(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,T.$Oe.wrap(n))}catch(t){return S.e(t)}},async delete(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return S.e(t)}},async rename(i,n,t){try{return await l.a.$rename(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,n,t){try{return await l.a.$copy(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const n=c.getCapabilities(i);if(typeof n=="number")return!(n&P.FileSystemProviderCapabilities.Readonly)}})}async d(s,c,l){const i=[];for(;!c.isEqual(l,c.dirname(l));)try{if(!((await s.stat(l)).type&P.FileType.Directory))throw I.$0O.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(P.$rl(n)!==P.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(c.basename(l)),l=c.dirname(l)}for(let n=i.length-1;n>=0;n--){l=c.joinPath(l,i[n]);try{await s.createDirectory(l)}catch(t){if(P.$rl(t)!==P.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof I.$0O)throw s;if(s instanceof P.$nl)switch(s.code){case P.FileSystemProviderErrorCode.FileExists:throw I.$0O.FileExists(s.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$0O.FileNotFound(s.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$0O.FileNotADirectory(s.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$0O.FileIsADirectory(s.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$0O.NoPermissions(s.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$0O.Unavailable(s.message);default:throw new I.$0O(s.message,s.name)}if(!(s instanceof Error))throw new I.$0O(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw I.$0O.Unavailable(s.message);switch(s.name){case P.FileSystemProviderErrorCode.FileExists:throw I.$0O.FileExists(s.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$0O.FileNotFound(s.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$0O.FileNotADirectory(s.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$0O.FileIsADirectory(s.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$0O.NoPermissions(s.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$0O.Unavailable(s.message);default:throw new I.$0O(s.message,s.name)}}addFileSystemProvider(s,c,l){return this.b.set(s,{impl:c,extUri:l?.isCaseSensitive?y.$0g:y.$_g,isReadonly:!!l?.isReadonly}),(0,o.$Tc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$0g}};e.$0pc=d,e.$0pc=d=S=Je([We(0,O.$oQ),We(1,$.$Npc)],d),e.$$pc=(0,A.$Gi)("IExtHostConsumerFileSystem")}),define(Ne[91],Me([1,0,3,26,11,68,2]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=e.$_pc=void 0,e.$_pc=(0,v.$Gi)("IExtensionStoragePaths");let O=class{constructor(o,k,y){this.d=k,this.f=y,this.a=o.workspace??void 0,this.b=o.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(o){return A.URI.joinPath(this.b.workspaceStorageHome,o)}async h(){if(!this.a)return Promise.resolve(void 0);const o=this.a.id,k=await this.g(o);try{return await this.f.value.stat(k),this.d.trace("[ExtHostStorage] storage dir already exists",k),k}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",k),await this.f.value.createDirectory(k),await this.f.value.writeFile(A.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),k}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(o){if(this.c)return A.URI.joinPath(this.c,o.identifier.value)}globalValue(o){return A.URI.joinPath(this.b.globalStorageHome,o.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$aqc=O,e.$aqc=O=Je([We(0,P.$EQ),We(1,I.$bk),We(2,T.$$pc)],O)}),define(Ne[230],Me([1,0,7,16,6]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0;let T=class{constructor(O){this.a=new v.$hP(v.ColorThemeKind.Dark),this.b=new I.$me}get activeColorTheme(){return this.a}$onColorThemeChange(O){let $;switch(O){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$hP($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Jrc=T,e.$Jrc=T=Je([We(0,P.$oQ)],T)}),define(Ne[92],Me([1,0,21,6,4,9,3,11,184,5,26,16,7]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sGb=e.$rGb=e.TunnelDtoConverter=void 0,T=Ve(T),a=Ve(a);class S extends $.$Sw{}var d;(function(s){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=c;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=l})(d||(e.TunnelDtoConverter=d={})),e.$rGb=(0,A.$Gi)("IExtHostTunnelService");let r=class extends I.$Vc{constructor(c,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new P.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(o.$ON.MainThreadTunnelService)}async openTunnel(c,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,c.displayName);if(i){const n=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,l){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:l}),this.a.$registerPortsAttributesProvider(c,i),new a.$QN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,l,i,n,t){const g=[];for(const p of c){const m=this.r.get(p);if(!m)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await m.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{E=await m.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:E,port:h}})))}const u=g.filter(p=>!!p.providedAttributes);return u.length>0?u.map(p=>({autoForwardAction:p.providedAttributes.autoForwardAction,port:p.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await c.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,I.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,l){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let n=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:T.localize(2703,null),themeIcon:"lock"},{id:"public",label:T.localize(2704,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,I.$Tc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,l){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(l&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:n,disposeListener:t}),d.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const l=await Promise.all(c.map(n=>this.f(n.host,n.port,n.detail??""))),i=c.filter((n,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$sGb=r,e.$sGb=r=Je([We(0,y.$oQ),We(1,k.$EQ),We(2,O.$bk)],r)}),define(Ne[8],Me([1,0,17,22,152,231,59,28,139,36,72,25,145,23,34,14,2,105,32,160,93,52,107,76,117,115,116,207,80,89,54,55,204,7]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h,E,D,w,C,R,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$lQ=ce,e.$mQ=ae,e.$nQ=Se,A=Ve(A),l=Ve(l),i=Ve(i),n=Ve(n),E=Ve(E),w=Ve(w),b=Ve(b);var L;(function(Ee){function Re(H){const{selectionStartLineNumber:Ie,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:Qe}=H,ut=new b.$RN(Ie-1,Be-1),Pt=new b.$RN(Xe-1,Qe-1);return new b.$TN(ut,Pt)}Ee.to=Re;function fe(H){const{anchor:Ie,active:Be}=H;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ee.from=fe})(L||(e.Selection=L={}));var N;(function(Ee){function Re(H){if(!H)return;const{start:Ie,end:Be}=H;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ee.from=Re;function fe(H){if(!H)return;const{startLineNumber:Ie,startColumn:Be,endLineNumber:Xe,endColumn:Qe}=H;return new b.$SN(Ie-1,Be-1,Xe-1,Qe-1)}Ee.to=fe})(N||(e.Range=N={}));var M;(function(Ee){function Re(H){return{uri:H.uri,range:N.from(H.range)}}Ee.from=Re;function fe(H){return new b.$5N(s.URI.revive(H.uri),N.to(H.range))}Ee.to=fe})(M||(e.Location=M={}));var W;(function(Ee){function Re(fe){switch(fe){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}Ee.to=Re})(W||(e.TokenType=W={}));var G;(function(Ee){function Re(H){return new b.$RN(H.lineNumber-1,H.column-1)}Ee.to=Re;function fe(H){return{lineNumber:H.line+1,column:H.character+1}}Ee.from=fe})(G||(e.Position=G={}));var q;(function(Ee){function Re(Ie,Be,Xe){return(0,v.$Hb)((0,v.$2b)(Ie).map(Qe=>fe(Qe,Be,Xe)))}Ee.from=Re;function fe(Ie,Be,Xe){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:Xe?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:H(Ie.scheme,Be),pattern:xe.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:Xe?.isBuiltin}}function H(Ie,Be){return Be&&typeof Ie=="string"?Be.transformOutgoingScheme(Ie):Ie}})(q||(e.DocumentSelector=q={}));var J;(function(Ee){function Re(H){switch(H){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}Ee.from=Re;function fe(H){switch(H){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}Ee.to=fe})(J||(e.DiagnosticTag=J={}));var K;(function(Ee){function Re(H){let Ie;return H.code&&((0,r.$fg)(H.code)||(0,r.$jg)(H.code)?Ie=String(H.code):Ie={value:String(H.code.value),target:H.code.target}),{...N.from(H.range),message:H.message,source:H.source,code:Ie,severity:me.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(oe.from),tags:Array.isArray(H.tags)?(0,v.$Hb)(H.tags.map(J.from)):void 0}}Ee.from=Re;function fe(H){const Ie=new b.$7N(N.to(H),H.message,me.to(H.severity));return Ie.source=H.source,Ie.code=(0,r.$fg)(H.code)?H.code:H.code?.value,Ie.relatedInformation=H.relatedInformation&&H.relatedInformation.map(oe.to),Ie.tags=H.tags&&(0,v.$Hb)(H.tags.map(J.to)),Ie}Ee.to=fe})(K||(e.Diagnostic=K={}));var oe;(function(Ee){function Re(H){return{...N.from(H.location.range),message:H.message,resource:H.location.uri}}Ee.from=Re;function fe(H){return new b.$6N(new b.$5N(H.resource,N.to(H)),H.message)}Ee.to=fe})(oe||(e.DiagnosticRelatedInformation=oe={}));var me;(function(Ee){function Re(H){switch(H){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ee.from=Re;function fe(H){switch(H){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Ee.to=fe})(me||(e.DiagnosticSeverity=me={}));var le;(function(Ee){function Re(H){return typeof H=="number"&&H>=b.ViewColumn.One?H-1:H===b.ViewColumn.Beside?f.$DE:f.$CE}Ee.from=Re;function fe(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=fe})(le||(e.ViewColumn=le={}));function _(Ee){return typeof Ee.range<"u"}function ce(Ee){return Ee.length===0?!0:!!_(Ee[0])}var pe;(function(Ee){function Re(Qe){return Qe.map(Ee.from)}Ee.fromMany=Re;function fe(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function H(Qe){let ut;if(fe(Qe)){const{language:zt,value:xt}=Qe;ut={value:"```"+zt+`
`+xt+"\n```\n"}}else b.$iO.isMarkdownString(Qe)?ut={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ut={value:Qe}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const Jt=zt=>{try{let xt=s.URI.parse(zt,!0);xt=xt.with({query:Ie(xt.query,Pt)}),Pt[zt]=xt}catch{}return""},Yt=new $.marked.Renderer;return Yt.link=Jt,Yt.image=zt=>typeof zt=="string"?Jt(A.$al(zt).href):"",(0,$.marked)(ut.value,{renderer:Yt}),ut}Ee.from=H;function Ie(Qe,ut){if(!Qe)return Qe;let Pt;try{Pt=(0,o.$ci)(Qe)}catch{}if(!Pt)return Qe;let Jt=!1;return Pt=(0,y.$ho)(Pt,Yt=>{if(s.URI.isUri(Yt)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[zt]=Yt,Jt=!0,zt}else return}),Jt?JSON.stringify(Pt):Qe}function Be(Qe){const ut=new b.$iO(Qe.value,Qe.supportThemeIcons);return ut.isTrusted=Qe.isTrusted,ut.supportHtml=Qe.supportHtml,ut.baseUri=Qe.baseUri?s.URI.from(Qe.baseUri):void 0,ut}Ee.to=Be;function Xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Ee.from(Qe)}Ee.fromStrict=Xe})(pe||(e.MarkdownString=pe={}));function ae(Ee){return ce(Ee)?Ee.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?pe.fromMany(Re.hoverMessage):Re.hoverMessage?pe.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):Ee.map(Re=>({range:N.from(Re)}))}function Se(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?s.URI.file(Ee):Ee}var Oe;(function(Ee){function Re(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?Se(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ee.from=Re})(Oe||(e.ThemableDecorationAttachmentRenderOptions=Oe={}));var X;(function(Ee){function Re(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Se(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Oe.from(fe.before):void 0,after:fe.after?Oe.from(fe.after):void 0}}Ee.from=Re})(X||(e.ThemableDecorationRenderOptions=X={}));var B;(function(Ee){function Re(fe){if(typeof fe>"u")return fe;switch(fe){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Re})(B||(e.DecorationRangeBehavior=B={}));var te;(function(Ee){function Re(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?B.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?X.from(fe.light):void 0,dark:fe.dark?X.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Se(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Oe.from(fe.before):void 0,after:fe.after?Oe.from(fe.after):void 0}}Ee.from=Re})(te||(e.DecorationRenderOptions=te={}));var ye;(function(Ee){function Re(H){return{text:H.newText,eol:H.newEol&&je.from(H.newEol),range:N.from(H.range)}}Ee.from=Re;function fe(H){const Ie=new b.$ZN(N.to(H.range),H.text);return Ie.newEol=typeof H.eol>"u"?void 0:je.to(H.eol),Ie}Ee.to=fe})(ye||(e.TextEdit=ye={}));var de;(function(Ee){function Re(H,Ie){const Be={edits:[]};if(H instanceof b.$3N){const Xe=new O.$Cc;for(const Qe of H._allEntries())Qe._type===b.FileEditType.File&&s.URI.isUri(Qe.to)&&Qe.from===void 0&&Xe.add(Qe.to);for(const Qe of H._allEntries())if(Qe._type===b.FileEditType.File){let ut;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ut={type:"base64",value:(0,P.$9e)(P.$Oe.wrap(Qe.options.contents))}:ut={type:"dataTransferItem",id:Qe.options.contents._itemId}),Be.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ut},metadata:Qe.metadata})}else Qe._type===b.FileEditType.Text?Be.edits.push({resource:Qe.uri,textEdit:ye.from(Qe.edit),versionId:Xe.has(Qe.uri)?void 0:Ie?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===b.FileEditType.Snippet?Be.edits.push({resource:Qe.uri,textEdit:{range:N.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(Qe.uri)?void 0:Ie?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===b.FileEditType.Cell?Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:w.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return Be}Ee.from=Re;function fe(H){const Ie=new b.$3N,Be=new O.$Bc;for(const Xe of H.edits)if(Xe.textEdit){const Qe=Xe,ut=s.URI.revive(Qe.resource),Pt=N.to(Qe.textEdit.range),Jt=Qe.textEdit.text,Yt=Qe.textEdit.insertAsSnippet;let zt;Yt?zt=b.$2N.replace(Pt,new b.$4N(Jt)):zt=b.$ZN.replace(Pt,Jt);const xt=Be.get(ut);xt?xt.push(zt):Be.set(ut,[zt])}else Ie.renameFile(s.URI.revive(Xe.oldResource),s.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Qe]of Be)Ie.set(Xe,Qe);return Ie}Ee.to=fe})(de||(e.WorkspaceEdit=de={}));var we;(function(Ee){const Re=Object.create(null);Re[b.SymbolKind.File]=n.SymbolKind.File,Re[b.SymbolKind.Module]=n.SymbolKind.Module,Re[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,Re[b.SymbolKind.Package]=n.SymbolKind.Package,Re[b.SymbolKind.Class]=n.SymbolKind.Class,Re[b.SymbolKind.Method]=n.SymbolKind.Method,Re[b.SymbolKind.Property]=n.SymbolKind.Property,Re[b.SymbolKind.Field]=n.SymbolKind.Field,Re[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,Re[b.SymbolKind.Enum]=n.SymbolKind.Enum,Re[b.SymbolKind.Interface]=n.SymbolKind.Interface,Re[b.SymbolKind.Function]=n.SymbolKind.Function,Re[b.SymbolKind.Variable]=n.SymbolKind.Variable,Re[b.SymbolKind.Constant]=n.SymbolKind.Constant,Re[b.SymbolKind.String]=n.SymbolKind.String,Re[b.SymbolKind.Number]=n.SymbolKind.Number,Re[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,Re[b.SymbolKind.Array]=n.SymbolKind.Array,Re[b.SymbolKind.Object]=n.SymbolKind.Object,Re[b.SymbolKind.Key]=n.SymbolKind.Key,Re[b.SymbolKind.Null]=n.SymbolKind.Null,Re[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,Re[b.SymbolKind.Struct]=n.SymbolKind.Struct,Re[b.SymbolKind.Event]=n.SymbolKind.Event,Re[b.SymbolKind.Operator]=n.SymbolKind.Operator,Re[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function fe(Ie){return typeof Re[Ie]=="number"?Re[Ie]:n.SymbolKind.Property}Ee.from=fe;function H(Ie){for(const Be in Re)if(Re[Be]===Ie)return Number(Be);return b.SymbolKind.Property}Ee.to=H})(we||(e.SymbolKind=we={}));var he;(function(Ee){function Re(H){switch(H){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}Ee.from=Re;function fe(H){switch(H){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}Ee.to=fe})(he||(e.SymbolTag=he={}));var Z;(function(Ee){function Re(H){return{name:H.name,kind:we.from(H.kind),tags:H.tags&&H.tags.map(he.from),containerName:H.containerName,location:Ue.from(H.location)}}Ee.from=Re;function fe(H){const Ie=new b.$_N(H.name,we.to(H.kind),H.containerName,Ue.to(H.location));return Ie.tags=H.tags&&H.tags.map(he.to),Ie}Ee.to=fe})(Z||(e.WorkspaceSymbol=Z={}));var x;(function(Ee){function Re(H){const Ie={name:H.name||"!!MISSING: name!!",detail:H.detail,range:N.from(H.range),selectionRange:N.from(H.selectionRange),kind:we.from(H.kind),tags:H.tags?.map(he.from)??[]};return H.children&&(Ie.children=H.children.map(Re)),Ie}Ee.from=Re;function fe(H){const Ie=new b.$aO(H.name,H.detail,we.to(H.kind),N.to(H.range),N.to(H.selectionRange));return(0,v.$Lb)(H.tags)&&(Ie.tags=H.tags.map(he.to)),H.children&&(Ie.children=H.children.map(fe)),Ie}Ee.to=fe})(x||(e.DocumentSymbol=x={}));var be;(function(Ee){function Re(H){const Ie=new b.$eO(we.to(H.kind),H.name,H.detail||"",s.URI.revive(H.uri),N.to(H.range),N.to(H.selectionRange));return Ie._sessionId=H._sessionId,Ie._itemId=H._itemId,Ie}Ee.to=Re;function fe(H,Ie,Be){if(Ie=Ie??H._sessionId,Be=Be??H._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,name:H.name,detail:H.detail,kind:we.from(H.kind),uri:H.uri,range:N.from(H.range),selectionRange:N.from(H.selectionRange),tags:H.tags?.map(he.from)}}Ee.from=fe})(be||(e.CallHierarchyItem=be={}));var $e;(function(Ee){function Re(fe){return new b.$fO(be.to(fe.from),fe.fromRanges.map(H=>N.to(H)))}Ee.to=Re})($e||(e.CallHierarchyIncomingCall=$e={}));var Ae;(function(Ee){function Re(fe){return new b.$gO(be.to(fe.to),fe.fromRanges.map(H=>N.to(H)))}Ee.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Ue;(function(Ee){function Re(H){return{range:H.range&&N.from(H.range),uri:H.uri}}Ee.from=Re;function fe(H){return new b.$5N(s.URI.revive(H.uri),N.to(H.range))}Ee.to=fe})(Ue||(e.location=Ue={}));var ke;(function(Ee){function Re(H){const Ie=H,Be=H;return{originSelectionRange:Ie.originSelectionRange?N.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Be.uri,range:N.from(Ie.targetRange?Ie.targetRange:Be.range),targetSelectionRange:Ie.targetSelectionRange?N.from(Ie.targetSelectionRange):void 0}}Ee.from=Re;function fe(H){return{targetUri:s.URI.revive(H.uri),targetRange:N.to(H.range),targetSelectionRange:H.targetSelectionRange?N.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?N.to(H.originSelectionRange):void 0}}Ee.to=fe})(ke||(e.DefinitionLink=ke={}));var Pe;(function(Ee){function Re(H){return{range:N.from(H.range),contents:pe.fromMany(H.contents),canIncreaseVerbosity:H.canIncreaseVerbosity,canDecreaseVerbosity:H.canDecreaseVerbosity}}Ee.from=Re;function fe(H){const Ie=H.contents.map(pe.to),Be=N.to(H.range),Xe=H.canIncreaseVerbosity,Qe=H.canDecreaseVerbosity;return new b.$9N(Ie,Be,Xe,Qe)}Ee.to=fe})(Pe||(e.Hover=Pe={}));var Te;(function(Ee){function Re(H){return{range:N.from(H.range),expression:H.expression}}Ee.from=Re;function fe(H){return new b.$4O(N.to(H.range),H.expression)}Ee.to=fe})(Te||(e.EvaluatableExpression=Te={}));var z;(function(Ee){function Re(H){if(H instanceof b.$5O)return{type:"text",range:N.from(H.range),text:H.text};if(H instanceof b.$6O)return{type:"variable",range:N.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof b.$7O)return{type:"expression",range:N.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Re;function fe(H){switch(H.type){case"text":return{range:N.to(H.range),text:H.text};case"variable":return{range:N.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:N.to(H.range),expression:H.expression}}}Ee.to=fe})(z||(e.InlineValue=z={}));var j;(function(Ee){function Re(H){return{frameId:H.frameId,stoppedLocation:N.from(H.stoppedLocation)}}Ee.from=Re;function fe(H){return new b.$8O(H.frameId,N.to(H.stoppedLocation))}Ee.to=fe})(j||(e.InlineValueContext=j={}));var Q;(function(Ee){function Re(H){return{range:N.from(H.range),kind:H.kind}}Ee.from=Re;function fe(H){return new b.$0N(N.to(H.range),H.kind)}Ee.to=fe})(Q||(e.DocumentHighlight=Q={}));var V;(function(Ee){function Re(H){return{uri:H.uri,highlights:H.highlights.map(Q.from)}}Ee.from=Re;function fe(H){return new b.$$N(s.URI.revive(H.uri),H.highlights.map(Q.to))}Ee.to=fe})(V||(e.MultiDocumentHighlight=V={}));var re;(function(Ee){function Re(fe){switch(fe){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}Ee.to=Re})(re||(e.CompletionTriggerKind=re={}));var ge;(function(Ee){function Re(fe){return{triggerKind:re.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ee.to=Re})(ge||(e.CompletionContext=ge={}));var Ce;(function(Ee){function Re(H){switch(H){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}Ee.from=Re;function fe(H){switch(H){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}Ee.to=fe})(Ce||(e.CompletionItemTag=Ce={}));var ze;(function(Ee){const Re=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function fe(Be){return Re.get(Be)??n.CompletionItemKind.Property}Ee.from=fe;const H=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ie(Be){return H.get(Be)??b.CompletionItemKind.Property}Ee.to=Ie})(ze||(e.CompletionItemKind=ze={}));var He;(function(Ee){function Re(fe,H){const Ie=new b.$oO(fe.label);return Ie.insertText=fe.insertText,Ie.kind=ze.to(fe.kind),Ie.tags=fe.tags?.map(Ce.to),Ie.detail=fe.detail,Ie.documentation=A.$7k(fe.documentation)?pe.to(fe.documentation):fe.documentation,Ie.sortText=fe.sortText,Ie.filterText=fe.filterText,Ie.preselect=fe.preselect,Ie.commitCharacters=fe.commitCharacters,l.$Rt.isIRange(fe.range)?Ie.range=N.to(fe.range):typeof fe.range=="object"&&(Ie.range={inserting:N.to(fe.range.insert),replacing:N.to(fe.range.replace)}),Ie.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof fe.insertTextRules<"u"&&fe.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?Ie.insertText=new b.$4N(fe.insertText):(Ie.insertText=fe.insertText,Ie.textEdit=Ie.range instanceof b.$SN?new b.$ZN(Ie.range,Ie.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=fe.additionalTextEdits.map(Be=>ye.to(Be))),Ie.command=H&&fe.command?H.fromInternal(fe.command):void 0,Ie}Ee.to=Re})(He||(e.CompletionItem=He={}));var _e;(function(Ee){function Re(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:pe.fromStrict(H.documentation)}}Ee.from=Re;function fe(H){return{label:H.label,documentation:A.$7k(H.documentation)?pe.to(H.documentation):H.documentation}}Ee.to=fe})(_e||(e.ParameterInformation=_e={}));var tt;(function(Ee){function Re(H){return{label:H.label,documentation:pe.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(_e.from):[],activeParameter:H.activeParameter}}Ee.from=Re;function fe(H){return{label:H.label,documentation:A.$7k(H.documentation)?pe.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(_e.to):[],activeParameter:H.activeParameter}}Ee.to=fe})(tt||(e.SignatureInformation=tt={}));var nt;(function(Ee){function Re(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.from):[]}}Ee.from=Re;function fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.to):[]}}Ee.to=fe})(nt||(e.SignatureHelp=nt={}));var et;(function(Ee){function Re(fe,H){const Ie=new b.$nO(G.to(H.position),typeof H.label=="string"?H.label:H.label.map(rt.to.bind(void 0,fe)),H.kind&&ft.to(H.kind));return Ie.textEdits=H.textEdits&&H.textEdits.map(ye.to),Ie.tooltip=A.$7k(H.tooltip)?pe.to(H.tooltip):H.tooltip,Ie.paddingLeft=H.paddingLeft,Ie.paddingRight=H.paddingRight,Ie}Ee.to=Re})(et||(e.InlayHint=et={}));var rt;(function(Ee){function Re(fe,H){const Ie=new b.$mO(H.label);return Ie.tooltip=A.$7k(H.tooltip)?pe.to(H.tooltip):H.tooltip,n.Command.is(H.command)&&(Ie.command=fe.fromInternal(H.command)),H.location&&(Ie.location=Ue.to(H.location)),Ie}Ee.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(Ee){function Re(H){return H}Ee.from=Re;function fe(H){return H}Ee.to=fe})(ft||(e.InlayHintKind=ft={}));var lt;(function(Ee){function Re(H){return{range:N.from(H.range),url:H.target,tooltip:H.tooltip}}Ee.from=Re;function fe(H){let Ie;if(H.url)try{Ie=typeof H.url=="string"?s.URI.parse(H.url,!0):s.URI.revive(H.url)}catch{}const Be=new b.$tO(N.to(H.range),Ie);return Be.tooltip=H.tooltip,Be}Ee.to=fe})(lt||(e.DocumentLink=lt={}));var st;(function(Ee){function Re(H){const Ie=new b.$wO(H.label);return H.textEdit&&(Ie.textEdit=ye.to(H.textEdit)),H.additionalTextEdits&&(Ie.additionalTextEdits=H.additionalTextEdits.map(Be=>ye.to(Be))),Ie}Ee.to=Re;function fe(H){return{label:H.label,textEdit:H.textEdit?ye.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Ie=>ye.from(Ie)):void 0}}Ee.from=fe})(st||(e.ColorPresentation=st={}));var ct;(function(Ee){function Re(H){return new b.$uO(H[0],H[1],H[2],H[3])}Ee.to=Re;function fe(H){return[H.red,H.green,H.blue,H.alpha]}Ee.from=fe})(ct||(e.Color=ct={}));var mt;(function(Ee){function Re(H){return{range:N.from(H.range)}}Ee.from=Re;function fe(H){return new b.$dO(N.to(H.range))}Ee.to=fe})(mt||(e.SelectionRange=mt={}));var $t;(function(Ee){function Re(fe){switch(fe){case m.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}Ee.to=Re})($t||(e.TextDocumentSaveReason=$t={}));var qe;(function(Ee){function Re(H){switch(H){case b.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}Ee.from=Re;function fe(H){switch(H){case c.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}Ee.to=fe})(qe||(e.TextEditorLineNumbersStyle=qe={}));var je;(function(Ee){function Re(H){if(H===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(H===b.EndOfLine.LF)return t.EndOfLineSequence.LF}Ee.from=Re;function fe(H){if(H===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(H===t.EndOfLineSequence.LF)return b.EndOfLine.LF}Ee.to=fe})(je||(e.EndOfLine=je={}));var ne;(function(Ee){function Re(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Re})(ne||(e.ProgressLocation=ne={}));var ee;(function(Ee){function Re(H){const Ie={start:H.start+1,end:H.end+1};return H.kind&&(Ie.kind=Y.from(H.kind)),Ie}Ee.from=Re;function fe(H){const Ie={start:H.start-1,end:H.end-1};return H.kind&&(Ie.kind=Y.to(H.kind)),Ie}Ee.to=fe})(ee||(e.FoldingRange=ee={}));var Y;(function(Ee){function Re(H){if(H)switch(H){case b.FoldingRangeKind.Comment:return n.$Su.Comment;case b.FoldingRangeKind.Imports:return n.$Su.Imports;case b.FoldingRangeKind.Region:return n.$Su.Region}}Ee.from=Re;function fe(H){if(H)switch(H.value){case n.$Su.Comment.value:return b.FoldingRangeKind.Comment;case n.$Su.Imports.value:return b.FoldingRangeKind.Imports;case n.$Su.Region.value:return b.FoldingRangeKind.Region}}Ee.to=fe})(Y||(e.FoldingRangeKind=Y={}));var Ze;(function(Ee){function Re(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?N.from(fe.selection):void 0,override:typeof fe.override=="boolean"?m.$7F.id:void 0}}Ee.from=Re})(Ze||(e.TextEditorOpenOptions=Ze={}));var xe;(function(Ee){function Re(Be){return Be instanceof b.$RO?Be.toJSON():typeof Be=="string"?Be:fe(Be)||H(Be)?new b.$RO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ee.from=Re;function fe(Be){const Xe=Be;return Xe?s.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function H(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ie(Be){return typeof Be=="string"?Be:new b.$RO(s.URI.revive(Be.baseUri),Be.pattern)}Ee.to=Ie})(xe||(e.GlobPattern=xe={}));var ht;(function(Ee){function Re(fe){if(fe){if(Array.isArray(fe))return fe.map(Re);if(typeof fe=="string")return fe;{const H=fe;return{language:H.language,scheme:H.scheme,pattern:xe.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ee.from=Re})(ht||(e.LanguageSelector=ht={}));var wt;(function(Ee){function Re(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&s.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof b.$SN)))}Ee.is=Re;function fe(H){return{documents:H.documents.map(Ie=>Ie.map(Be=>({uri:s.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>N.from(Xe))})))}}Ee.from=fe})(wt||(e.MappedEditsContext=wt={}));var Lt;(function(Ee){function Re(H){return{start:H.start,end:H.end}}Ee.from=Re;function fe(H){return new b.$iP(H.start,H.end)}Ee.to=fe})(Lt||(e.NotebookRange=Lt={}));var Qt;(function(Ee){function Re(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ee.to=Re;function fe(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ee.from=fe})(Qt||(e.NotebookCellExecutionSummary=Qt={}));var ei;(function(Ee){function Re(fe){if(fe===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(fe===w.NotebookCellExecutionState.Pending)return;if(fe===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ee.to=Re})(ei||(e.NotebookCellExecutionState=ei={}));var ti;(function(Ee){function Re(H){switch(H){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}Ee.from=Re;function fe(H){switch(H){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}Ee.to=fe})(ti||(e.NotebookCellKind=ti={}));var oi;(function(Ee){function Re(H){const Ie={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)b.$jP.validate(Be),Ie.cells.push(At.from(Be));return Ie}Ee.from=Re;function fe(H){const Ie=new b.$kP(H.cells.map(At.to));return(0,r.$sg)(H.metadata)||(Ie.metadata=H.metadata),Ie}Ee.to=fe})(oi||(e.NotebookData=oi={}));var At;(function(Ee){function Re(H){return{cellKind:ti.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Qt.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ct.from):[]}}Ee.from=Re;function fe(H){return new b.$jP(ti.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ct.to):void 0,H.metadata,H.internalMetadata?Qt.to(H.internalMetadata):void 0)}Ee.to=fe})(At||(e.NotebookCellData=At={}));var Ye;(function(Ee){function Re(H){return{mime:H.mime,valueBytes:P.$Oe.wrap(H.data)}}Ee.from=Re;function fe(H){return new b.$lP(H.valueBytes.buffer,H.mime)}Ee.to=fe})(Ye||(e.NotebookCellOutputItem=Ye={}));var Ct;(function(Ee){function Re(H){return{outputId:H.id,items:H.items.map(Ye.from),metadata:H.metadata}}Ee.from=Re;function fe(H){const Ie=H.items.map(Ye.to);return new b.$mP(Ie,H.outputId,H.metadata)}Ee.to=fe})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(Ee){function Re(Ie){return H(Ie)?{include:xe.from(Ie.include)??void 0,exclude:xe.from(Ie.exclude)??void 0}:xe.from(Ie)??void 0}Ee.from=Re;function fe(Ie){return H(Ie)?{include:xe.to(Ie.include),exclude:xe.to(Ie.exclude)}:xe.to(Ie)}Ee.to=fe;function H(Ie){const Be=Ie;return Be?!(0,r.$og)(Be.include)&&!(0,r.$og)(Be.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var pt;(function(Ee){function Re(fe,H,Ie){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:H.toInternal(Be,Ie),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ee.from=Re})(pt||(e.NotebookStatusBarItem=pt={}));var Dt;(function(Ee){function Re(fe,H,Ie){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:H.toInternal(Be,Ie),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ee.from=Re})(Dt||(e.NotebookKernelSourceAction=Dt={}));var ii;(function(Ee){function Re(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ee.from=Re})(ii||(e.NotebookDocumentContentOptions=ii={}));var ni;(function(Ee){function Re(H){return{uri:H.uri,provides:H.provides}}Ee.from=Re;function fe(H){return new b.$oP(s.URI.revive(H.uri),H.provides)}Ee.to=fe})(ni||(e.NotebookRendererScript=ni={}));var jt;(function(Ee){function Re(H){return{message:pe.fromStrict(H.message)||"",type:R.TestMessageType.Error,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:N.from(H.location.range),uri:H.location.uri},stackTrace:H.stackTrace?.map(Ie=>({label:Ie.label,position:Ie.position&&G.from(Ie.position),uri:Ie.uri&&s.URI.revive(Ie.uri).toJSON()}))}}Ee.from=Re;function fe(H){const Ie=new b.$uP(typeof H.message=="string"?H.message:pe.to(H.message));return Ie.actualOutput=H.actual,Ie.expectedOutput=H.expected,Ie.contextValue=H.contextValue,Ie.location=H.location?Ue.to(H.location):void 0,Ie}Ee.to=fe})(jt||(e.TestMessage=jt={}));var gt;(function(Ee){Ee.namespace=R.$dJ,Ee.denamespace=R.$eJ})(gt||(e.TestTag=gt={}));var Ut;(function(Ee){function Re(H){const Ie=(0,p.$kQ)(H).controllerId;return{extId:C.$$I.fromExtHostTestItem(H,Ie).toString(),label:H.label,uri:s.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>gt.namespace(Ie,Be.id)),range:l.$Rt.lift(N.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&pe.fromStrict(H.error)||null}}Ee.from=Re;function fe(H){return{parent:void 0,error:void 0,id:C.$$I.fromString(H.extId).localId,label:H.label,uri:s.URI.revive(H.uri),tags:(H.tags||[]).map(Ie=>{const{tagId:Be}=gt.denamespace(Ie);return new b.$vP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ee.toPlain=fe})(Ut||(e.TestItem=Ut={})),function(Ee){function Re(H){return{id:H.id}}Ee.from=Re;function fe(H){return new b.$vP(H.id)}Ee.to=fe}(gt||(e.TestTag=gt={}));var ri;(function(Ee){const Re=(H,Ie)=>{const Be=H.value;if(!Be)return;const Xe={...Ut.toPlain(Be.item),parent:Ie,taskStates:Be.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ut=>ut.type===R.TestMessageType.Error).map(jt.to)})),children:[]};if(H.children)for(const Qe of H.children.values()){const ut=Re(Qe,Xe);ut&&Xe.children.push(ut)}return Xe};function fe(H){const Ie=new a.$0I;for(const Qe of H.items)Ie.insert(C.$$I.fromString(Qe.item.extId).path,Qe);const Be=[Ie.nodes],Xe=[];for(;Be.length;)for(const Qe of Be.pop())Qe.value?Xe.push(Qe):Qe.children&&Be.push(Qe.children.values());return{completedAt:H.completedAt,results:Xe.map(Qe=>Re(Qe)).filter(r.$ng)}}Ee.to=fe})(ri||(e.TestResults=ri={}));var ai;(function(Ee){function Re(Be){return{covered:Be.covered,total:Be.total}}function fe(Be){return"line"in Be?G.from(Be):N.from(Be)}function H(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:fe(Be.location),type:R.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&fe(Xe.location),label:Xe.label})):void 0}:{type:R.DetailType.Declaration,name:Be.name,count:Be.executed,location:fe(Be.location)}}Ee.fromDetails=H;function Ie(Be,Xe,Qe){return b.$yP(Qe.statementCoverage),b.$yP(Qe.branchCoverage),b.$yP(Qe.declarationCoverage),{id:Xe,uri:Qe.uri,statement:Re(Qe.statementCoverage),branch:Qe.branchCoverage&&Re(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Re(Qe.declarationCoverage),testIds:Qe instanceof b.$zP&&Qe.fromTests.length?Qe.fromTests.map(ut=>C.$$I.fromExtHostTestItem(ut,Be).toString()):void 0}}Ee.fromFile=Ie})(ai||(e.TestCoverage=ai={}));var Ke;(function(Ee){function Re(fe){switch(fe){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}Ee.to=Re})(Ke||(e.CodeActionTriggerKind=Ke={}));var ci;(function(Ee){function Re(H){const Ie=new b.$DP(we.to(H.kind),H.name,H.detail||"",s.URI.revive(H.uri),N.to(H.range),N.to(H.selectionRange));return Ie._sessionId=H._sessionId,Ie._itemId=H._itemId,Ie}Ee.to=Re;function fe(H,Ie,Be){if(Ie=Ie??H._sessionId,Be=Be??H._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,kind:we.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:N.from(H.range),selectionRange:N.from(H.selectionRange),tags:H.tags?.map(he.from)}}Ee.from=fe})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(Ee){function Re(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ee.from=Re})(di||(e.ViewBadge=di={}));var fi;(function(Ee){function Re(Be,Xe,Qe){const ut=Xe.fileData;return ut?new b.$JO(new b.$KO(ut.name,s.URI.revive(ut.uri),ut.id,(0,T.$db)(()=>Qe(ut.id)))):Be===k.$bt.uriList&&Xe.uriListData?new b.$IO(Ie(Xe.uriListData)):new b.$IO(Xe.asString)}Ee.to=Re;async function fe(Be,Xe){const Qe=await Xe.asString();if(Be===k.$bt.uriList)return{asString:Qe,fileData:void 0,uriListData:H(Qe)};const ut=Xe.asFile();return{asString:Qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Ee.from=fe;function H(Be){return I.$wu.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return s.URI.parse(Xe)}catch{}return Xe})}function Ie(Be){return I.$wu.create(Be.map(Xe=>typeof Xe=="string"?Xe:s.URI.revive(Xe)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(Ee){function Re(H,Ie){const Be=H.items.map(([Xe,Qe])=>[Xe,fi.to(Xe,Qe,Ie)]);return new b.$LO(Be)}Ee.toDataTransfer=Re;async function fe(H){const Ie={items:[]},Be=[];for(const[Xe,Qe]of H)Be.push((async()=>{Ie.items.push([Xe,await fi.from(Xe,Qe)])})());return await Promise.all(Be),Ie}Ee.from=fe})(vt||(e.DataTransfer=vt={}));var Ft;(function(Ee){function Re(H,Ie){return{kind:"reply",agentId:H.participant??Ie?.agentId??"",subCommand:H.command??Ie?.command,message:H.prompt,title:H.label}}Ee.from=Re;function fe(H){return{prompt:H.message,label:H.title,participant:H.agentId,command:H.subCommand}}Ee.to=fe})(Ft||(e.ChatFollowup=Ft={}));var Nt;(function(Ee){function Re(H){switch(H){case E.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}Ee.to=Re;function fe(H){switch(H){case b.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Ee.from=fe})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var Wt;(function(Ee){function Re(H){let Ie="",Be;H.content.type==="text"?Ie=H.content.value:Be=new b.$8P(H.content.name,H.content.value,H.content.isError);const Xe=Nt.to(H.role),Qe=new b.$9P(Xe,Ie,H.name);return Be!==void 0&&(Qe.content2=Be),Qe}Ee.to=Re;function fe(H){const Ie=Nt.from(H.role),Be=H.name;let Xe;return H.content2 instanceof b.$8P?Xe={type:"function_result",name:H.content2.name,value:H.content2.content,isError:H.content2.isError}:Xe={type:"text",value:H.content},{role:Ie,name:Be,content:Xe}}Ee.from=fe})(Wt||(e.LanguageModelChatMessage=Wt={}));var si;(function(Ee){function Re(H){return{kind:"markdownContent",content:pe.from(H.value)}}Ee.from=Re;function fe(H){return new b.$QP(pe.to(H.content))}Ee.to=fe})(si||(e.ChatResponseMarkdownPart=si={}));var Gt;(function(Ee){function Re(H){return{kind:"markdownVuln",content:pe.from(H.value),vulnerabilities:H.vulnerabilities}}Ee.from=Re;function fe(H){return new b.$RP(pe.to(H.content),H.vulnerabilities)}Ee.to=fe})(Gt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Gt={}));var li;(function(Ee){function Re(H){return{kind:"agentDetection",agentId:H.participant,command:H.command}}Ee.from=Re;function fe(H){return new b.$SP(H.agentId,H.command)}Ee.to=fe})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Bt;(function(Ee){function Re(fe){return{kind:"confirmation",title:fe.title,message:fe.message,data:fe.data,buttons:fe.buttons}}Ee.from=Re})(Bt||(e.ChatResponseConfirmationPart=Bt={}));var Ht;(function(Ee){function Re(H){const{value:Ie,baseUri:Be}=H;function Xe(Qe,ut){return Qe.map(Pt=>{const Jt=s.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:Jt,children:Pt.children&&Xe(Pt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$eh)(Be),uri:Be,children:Xe(Ie,Be)}}}Ee.from=Re;function fe(H){const Ie=(0,o.$di)(H.treeData);function Be(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&Be(Pt.children)}))}const Xe=Ie.uri,Qe=Ie.children?Be(Ie.children):[];return new b.$UP(Qe,Xe)}Ee.to=fe})(Ht||(e.ChatResponseFilesPart=Ht={}));var Kt;(function(Ee){function Re(H){const Ie=Be=>s.URI.isUri(Be);return{kind:"inlineReference",name:H.title,inlineReference:Ie(H.value)?H.value:M.from(H.value)}}Ee.from=Re;function fe(H){const Ie=(0,o.$di)(H);return new b.$VP(s.URI.isUri(Ie.inlineReference)?Ie.inlineReference:M.to(Ie.inlineReference),H.name)}Ee.to=fe})(Kt||(e.ChatResponseAnchorPart=Kt={}));var Mt;(function(Ee){function Re(H){return{kind:"progressMessage",content:pe.from(H.value)}}Ee.from=Re;function fe(H){return new b.$WP(H.content.value)}Ee.to=fe})(Mt||(e.ChatResponseProgressPart=Mt={}));var bt;(function(Ee){function Re(H){return{kind:"warning",content:pe.from(H.value)}}Ee.from=Re;function fe(H){return new b.$YP(H.content.value)}Ee.to=fe})(bt||(e.ChatResponseWarningPart=bt={}));var kt;(function(Ee){function Re(fe){return{kind:"progressTask",content:pe.from(fe.value)}}Ee.from=Re})(kt||(e.ChatTask=kt={}));var Vt;(function(Ee){function Re(fe){return{kind:"progressTaskResult",content:typeof fe=="string"?pe.from(fe):void 0}}Ee.from=Re})(Vt||(e.ChatTaskResult=Vt={}));var It;(function(Ee){function Re(H,Ie,Be){return{kind:"command",command:Ie.toInternal(H.value,Be)??{command:H.value.command,title:H.value.title}}}Ee.from=Re;function fe(H,Ie){return new b.$ZP(Ie.fromInternal(H.command)??{command:H.command.id,title:H.command.title})}Ee.to=fe})(It||(e.ChatResponseCommandButtonPart=It={}));var mi;(function(Ee){function Re(H){return{kind:"textEdit",uri:H.uri,edits:H.edits.map(Ie=>ye.from(Ie))}}Ee.from=Re;function fe(H){return new b.$3P(s.URI.revive(H.uri),H.edits.map(Ie=>ye.to(Ie)))}Ee.to=fe})(mi||(e.ChatResponseTextEditPart=mi={}));var Xt;(function(Ee){function Re(H){const Ie=d.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:s.URI.isUri(H.iconPath)?{light:s.URI.revive(H.iconPath)}:H.iconPath&&"light"in H.iconPath&&"dark"in H.iconPath&&s.URI.isUri(H.iconPath.light)&&s.URI.isUri(H.iconPath.dark)?{light:s.URI.revive(H.iconPath.light),dark:s.URI.revive(H.iconPath.dark)}:void 0;return"variableName"in H.value?{kind:"reference",reference:{variableName:H.value.variableName,value:s.URI.isUri(H.value.value)||!H.value.value?H.value.value:M.from(H.value.value)},iconPath:Ie,options:H.options}:{kind:"reference",reference:s.URI.isUri(H.value)?H.value:M.from(H.value),iconPath:Ie,options:H.options}}Ee.from=Re;function fe(H){const Ie=(0,o.$di)(H),Be=Xe=>s.URI.isUri(Xe)?Xe:M.to(Xe);return new b.$1P("variableName"in Ie.reference?{variableName:Ie.reference.variableName,value:Ie.reference.value&&Be(Ie.reference.value)}:Be(Ie.reference))}Ee.to=fe})(Xt||(e.ChatResponseReferencePart=Xt={}));var ki;(function(Ee){function Re(fe){return{kind:"codeCitation",value:fe.value,license:fe.license,snippet:fe.snippet}}Ee.from=Re})(ki||(e.ChatResponseCodeCitationPart=ki={}));var wi;(function(Ee){function Re(Ie,Be,Xe){return Ie instanceof b.$QP?si.from(Ie):Ie instanceof b.$VP?Kt.from(Ie):Ie instanceof b.$1P?Xt.from(Ie):Ie instanceof b.$WP?Mt.from(Ie):Ie instanceof b.$UP?Ht.from(Ie):Ie instanceof b.$ZP?It.from(Ie,Be,Xe):Ie instanceof b.$3P?mi.from(Ie):Ie instanceof b.$RP?Gt.from(Ie):Ie instanceof b.$SP?li.from(Ie):Ie instanceof b.$YP?bt.from(Ie):Ie instanceof b.$TP?Bt.from(Ie):Ie instanceof b.$2P?ki.from(Ie):{kind:"markdownContent",content:pe.from("")}}Ee.from=Re;function fe(Ie,Be){switch(Ie.kind){case"reference":return Xt.to(Ie);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return H(Ie,Be)}}Ee.to=fe;function H(Ie,Be){switch(Ie.kind){case"markdownContent":return si.to(Ie);case"inlineReference":return Kt.to(Ie);case"progressMessage":return;case"treeData":return Ht.to(Ie);case"command":return It.to(Ie,Be)}}Ee.toContent=H})(wi||(e.ChatResponsePart=wi={}));var Oi;(function(Ee){function Re(fe,H){const Ie=fe.variables.variables.filter(Xe=>Xe.isTool).map(Xe=>Xe.id),Be=fe.variables.variables.filter(Xe=>!Xe.isTool);return{prompt:fe.message,command:fe.command,attempt:fe.attempt??0,enableCommandDetection:fe.enableCommandDetection??!0,references:Be.map(Mi.to),location:Ot.to(fe.location),acceptedConfirmationData:fe.acceptedConfirmationData,rejectedConfirmationData:fe.rejectedConfirmationData,location2:H,requestedTools:Ie}}Ee.to=Re})(Oi||(e.ChatAgentRequest=Oi={}));var Ot;(function(Ee){function Re(H){switch(H){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}Ee.to=Re;function fe(H){switch(H){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}Ee.from=fe})(Ot||(e.ChatLocation=Ot={}));var Mi;(function(Ee){function Re(fe){const H=fe.value;if(!H)throw new Error("Invalid value reference");return{id:fe.id,name:fe.name,range:fe.range&&[fe.range.start,fe.range.endExclusive],value:(0,s.$wc)(H)?s.URI.revive(H):H&&typeof H=="object"&&"uri"in H&&"range"in H&&(0,s.$wc)(H.uri)?M.to((0,o.$di)(H)):H,modelDescription:fe.modelDescription}}Ee.to=Re})(Mi||(e.ChatAgentValueReference=Mi={}));var ui;(function(Ee){function Re(fe,H,Ie){return{id:fe.id,label:fe.label,fullName:fe.fullName,icon:fe.icon?.id,value:fe.values[0].value,insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation,command:H.toInternal(fe.command,Ie)}}Ee.from=Re})(ui||(e.ChatAgentCompletionItem=ui={}));var Rt;(function(Ee){function Re(fe){return{errorDetails:fe.errorDetails,metadata:fe.metadata,nextQuestion:fe.nextQuestion}}Ee.to=Re})(Rt||(e.ChatAgentResult=Rt={}));var Ti;(function(Ee){function Re(fe,H,Ie){if(H.action.kind==="vote")return;const Be=Rt.to(fe);if(H.action.kind==="command"){const Xe=H.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ie.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Be}}else return H.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(H.action.followup)},result:Be}:H.action.kind==="inlineChat"?{action:{kind:"editor",accepted:H.action.action==="accepted"},result:Be}:{action:H.action,result:Be}}Ee.to=Re})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var Ii;(function(Ee){function Re(H){return{...H,string:H.toString()}}Ee.from=Re;function fe(H){const Ie={...H,toString:()=>H.string};return delete Ie.string,Ie}Ee.to=fe})(Ii||(e.LanguageModelToolResult=Ii={}));var Di;(function(Ee){function Re(fe,H,Ie){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:H.toInternal(fe,Ie)}Ee.from=Re})(Di||(e.TerminalQuickFix=Di={}));var Ui;(function(Ee){function Re(fe){return{kind:pi.to(fe.kind)}}Ee.to=Re})(Ui||(e.PartialAcceptInfo=Ui={}));var pi;(function(Ee){function Re(fe){switch(fe){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}Ee.to=Re})(pi||(e.PartialAcceptTriggerKind=pi={}));var qt;(function(Ee){function Re(fe,H){return{id:H,label:fe.label,description:fe.description,canEdit:fe.canEdit,collapsibleState:fe.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:fe.contextValue}}Ee.from=Re})(qt||(e.DebugTreeItem=qt={}));var Ci;(function(Ee){function Re(fe){return{name:fe.name,description:fe.description,parametersSchema:fe.parametersSchema}}Ee.to=Re})(Ci||(e.LanguageModelToolDescription=Ci={}))}),define(Ne[232],Me([1,0,5,16,8,39]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0;let A=class{constructor($,o){this.a=$.getProxy(v.$ON.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>o.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,o,k){const y=new T.$2w(I.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,k?.isRefactoring??!1)}};e.$Vpc=A,e.$Vpc=A=Je([We(0,P.$oQ)],A)}),define(Ne[233],Me([1,0,17,10,42,6,40,4,36,69,14,2,18,5,8,7,116,194,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0,d=Ve(d),r=Ve(r);class i{constructor(u,p,m,h,E){this.j=u,this.k=p,this.l=m,this.m=h,this.n=E,this.b=o.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const m=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),w={report:C=>{D?.then(R=>{R&&(r.$iO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(C),R):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(C),R))})}};Promise.all([D,E?.(w)]).then(([C,R])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(R),C)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){p(this.markdown);const E=new r.$QP(h),D=d.ChatResponseMarkdownPart.from(E);return m(D),this},markdownWithVulnerabilities(h,E){p(this.markdown),E&&(0,l.$jH)(u.j,"chatParticipantAdditions");const D=new r.$RP(h,E),w=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return m(w),this},filetree(h,E){p(this.filetree);const D=new r.$UP(h,E),w=d.ChatResponseFilesPart.from(D);return m(w),this},anchor(h,E){p(this.anchor);const D=new r.$VP(h,E),w=d.ChatResponseAnchorPart.from(D);return m(w),this},button(h){p(this.anchor);const E=new r.$ZP(h),D=d.ChatResponseCommandButtonPart.from(E,u.m,u.n);return m(D),this},progress(h,E){p(this.progress);const D=new r.$XP(h,E),w=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return m(w,E),this},warning(h){p(this.progress),(0,l.$jH)(u.j,"chatParticipantAdditions");const E=new r.$YP(h),D=d.ChatResponseWarningPart.from(E);return m(D),this},reference(h,E){return this.reference2(h,E)},reference2(h,E,D){if(p(this.reference),"variableName"in h&&(0,l.$jH)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const w=u.k.variables.variables.find(C=>C.name===h.variableName);if(w){let C;if(w.references?.length)C=w.references.map(R=>({kind:"reference",reference:{variableName:h.variableName,value:R.reference}}));else{const R=new r.$1P(h,E,D);C=[d.ChatResponseReferencePart.from(R)]}return C.forEach(R=>m(R)),this}}else{const w=new r.$1P(h,E,D),C=d.ChatResponseReferencePart.from(w);m(C)}return this},codeCitation(h,E,D){p(this.codeCitation),(0,l.$jH)(u.j,"chatParticipantAdditions");const w=new r.$2P(h,E,D),C=d.ChatResponseCodeCitationPart.from(w);m(C)},textEdit(h,E){p(this.textEdit),(0,l.$jH)(u.j,"chatParticipantAdditions");const D=new r.$3P(h,E),w=d.ChatResponseTextEditPart.from(D);return m(w),this},detectedParticipant(h,E){p(this.detectedParticipant),(0,l.$jH)(u.j,"chatParticipantAdditions");const D=new r.$SP(h,E),w=d.ChatResponseDetectedParticipantPart.from(D);return m(w),this},confirmation(h,E,D,w){p(this.confirmation),(0,l.$jH)(u.j,"chatParticipantAdditions");const C=new r.$TP(h,E,D,w),R=d.ChatResponseConfirmationPart.from(C);return m(R),this},push(h){if(p(this.push),(h instanceof r.$3P||h instanceof r.$RP||h instanceof r.$SP||h instanceof r.$YP||h instanceof r.$TP||h instanceof r.$2P)&&(0,l.$jH)(u.j,"chatParticipantAdditions"),h instanceof r.$1P)this.reference2(h.value,h.iconPath,h.options);else{const E=d.ChatResponsePart.from(h,u.m,u.n);m(E)}return this}}}return this.g}}class n extends O.$Vc{static{this.b=0}static{this.j=0}constructor(u,p,m,h){super(),this.t=p,this.u=m,this.w=h,this.c=new Map,this.m=new Map,this.n=this.B(new O.$5c),this.s=this.B(new O.$5c),this.g=u.getProxy(S.$ON.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,p,m){const h=n.b++,E=new t(u,p,this.g,h,m);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,p,{},void 0),E.apiAgent}createDynamicChatAgent(u,p,m,h){const E=n.b++,D=new t(u,p,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,p,{isSticky:!0},m),D.apiAgent}registerChatParticipantDetectionProvider(u){const p=n.j++;return this.m.set(p,u),this.g.$registerChatParticipantDetectionProvider(p),(0,O.$Tc)(()=>{this.m.delete(p),this.g.$unregisterChatParticipantDetectionProvider(p)})}async $detectChatParticipant(u,p,m,h,E){const{request:D,location:w,history:C}=await this.y(p,m),R=this.m.get(u);if(R)return R.provideParticipantDetection(d.ChatAgentRequest.to(D,w),{history:C},{participants:h.participants,location:d.ChatLocation.to(h.location)},E)}async y(u,p){const m=(0,$.$di)(u),h=await this.z(m.agentId,p);let E;if(m.locationData?.type===s.ChatAgentLocation.Editor){const D=this.w.getDocument(m.locationData.document);E=new r.$6P(D,d.Selection.to(m.locationData.selection),d.Range.to(m.locationData.wholeRange))}else if(m.locationData?.type===s.ChatAgentLocation.Notebook){const D=this.w.getDocument(m.locationData.sessionInputUri);E=new r.$7P(D)}else m.locationData?.type,s.ChatAgentLocation.Terminal;return{request:m,location:E,history:h}}async $invokeAgent(u,p,m,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let D;try{const{request:w,location:C,history:R}=await this.y(p,m);let f=this.n.get(w.sessionId);f||(f=new O.$Uc,this.n.set(w.sessionId,f)),D=new i(E.extension,w,this.g,this.u.converter,f);const b=E.invoke(d.ChatAgentRequest.to(w,C),{history:R},D.apiObject,h);return await(0,P.$uh)(Promise.resolve(b).then(L=>{if(L?.metadata)try{JSON.stringify(L.metadata)}catch(M){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${M.message}`;return this.t.error(`[${E.extension.identifier.value}] [@${E.id}] ${W}`,E.extension),{errorDetails:{message:W},timings:D?.timings,nextQuestion:L.nextQuestion}}let N;return L?.errorDetails&&(N={...L.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$jH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:D?.timings,metadata:L?.metadata,nextQuestion:L?.nextQuestion}}),h)}catch(w){return this.t.error(w,E.extension),w instanceof r.$cQ&&w.cause&&(w=w.cause),{errorDetails:{message:(0,I.$rj)(w),responseIsIncomplete:!0}}}finally{D?.close()}}async z(u,p){const m=[];for(const h of p.history){const E=d.ChatAgentResult.to(h.result),D=u===h.request.agentId?E:{...E,metadata:void 0},w=h.request.variables.variables.filter(R=>!R.isTool).map(d.ChatAgentValueReference.to);m.push(new r.$4P(h.request.message,h.request.command,w,h.request.agentId));const C=(0,v.$Hb)(h.response.map(R=>d.ChatResponsePart.toContent(R,this.u.converter)));m.push(new r.$5P(C,D,h.request.agentId,h.request.command))}return m}$releaseSession(u){this.n.deleteAndDispose(u)}async $provideFollowups(u,p,m,h,E){const D=this.c.get(p);if(!D)return Promise.resolve([]);const w=(0,$.$di)(u),C=await this.z(D.id,h),R=d.ChatAgentResult.to(m);return(await D.provideFollowups(R,{history:C},E)).filter(f=>{const b=!f.participant||A.Iterable.some(this.c.values(),L=>L.id===f.participant&&a.$sn.equals(L.extension.identifier,D.extension.identifier));return b||this.t.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),b}).map(f=>d.ChatFollowup.from(f,w))}$acceptFeedback(u,p,m,h){const E=this.c.get(u);if(!E)return;const D=d.ChatAgentResult.to(p);let w;switch(m){case c.ChatAgentVoteDirection.Down:w=r.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:w=r.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:w,reportIssue:h}:{result:D,kind:w}))}$acceptAction(u,p,m){const h=this.c.get(u);if(!h||m.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to(p,m,this.u.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,p,m){const h=this.c.get(u);if(!h)return[];let E=this.s.get(u);return E?E.clear():(E=new O.$Uc,this.s.set(u,E)),(await h.invokeCompletionProvider(p,m)).map(w=>d.ChatAgentCompletionItem.from(w,this.u.converter,E))}async $provideWelcomeMessage(u,p,m){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to(p),m)}async $provideSampleQuestions(u,p,m){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to(p),m)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$Wpc=n;class t{constructor(u,p,m,h,E){this.extension=u,this.id=p,this.w=m,this.x=h,this.y=E,this.m=new T.$me,this.n=new T.$me}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,p){return this.q?await this.q.provider.provideCompletionItems(u,p)??[]:[]}async provideFollowups(u,p,m){if(!this.b)return[];const h=await this.b.provideFollowups(u,p,m);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,p){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(u,p);return m?m.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(u,p){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(u,p);return m||[]}get apiAgent(){let u=!1,p=!1;const m=()=>{u||p||(p=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$PO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),p=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,m()},get requestHandler(){return h.y},set requestHandler(E){(0,k.$pg)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,m()},get isDefault(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.d=E,m()},get helpTextPrefix(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.g=E,m()},get helpTextVariablesPrefix(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.j=E,m()},get helpTextPostfix(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.k=E,m()},get isSecondary(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.l=E,m()},get supportIssueReporting(){return(0,l.$jH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$jH)(h.extension,"chatParticipantPrivate"),h.o=E,m()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$jH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$jH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$jH)(h.extension,"defaultChatParticipant"),h.s=E,m()},get welcomeMessageProvider(){return(0,l.$jH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$iH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,m()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$jH)(h.extension,"chatParticipantPrivate"),h.u=E,m()},get supportsSlowReferences(){return(0,l.$jH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,p,m,h){return this.y(u,p,m,h)}}}),define(Ne[234],Me([1,0,13,4,34,5,8,7,24]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,A=Ve(A),O=Ve(O);class o{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(T.$ON.MainThreadChatVariables)}async $resolveVariable(a,S,d,r){const s=this.b.get(a);if(s)try{if(s.resolver.resolve2){(0,$.$jH)(s.extension,"chatParticipantAdditions");const c=new k(S,this.c),l=await s.resolver.resolve2(s.data.name,{prompt:d},c.apiObject,r);if(l&&l[0])return l[0].value}else{const c=await s.resolver.resolve(s.data.name,{prompt:d},r);if(c&&c[0])return c[0].value}}catch(c){(0,v.$1)(c)}}registerVariableResolver(a,S,d,r,s,c,l,i,n){const t=o.a++,g=n?I.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:r,modelDescription:s,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:d,description:r,modelDescription:s,isSlow:c,fullName:i,icon:g}),(0,P.$Tc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Xpc=o;class k{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(r){if(a.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,r),s}};const a=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){S(this.progress);const s=new O.$WP(r),c=A.ChatResponseProgressPart.from(s);return d(c),this},reference(r){S(this.reference);const s=new O.$1P(r),c=A.ChatResponseReferencePart.from(s);return d(c),this},push(r){return S(this.push),r instanceof O.$1P?d(A.ChatResponseReferencePart.from(r)):r instanceof O.$WP&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ne[235],Me([1,0,10,71,6,4,37,2,93,18,8,7,5,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=d,$=Ve($),k=Ve(k),y=Ve(y);function d(r,s,c){const l=r.getProxy(a.$ON.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new o.$un,s.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===A.MarshalledId.CommentController){const C=this.b.get(w.handle);return C?C.value:w}else if(w&&w.$mid===A.MarshalledId.CommentThread){const C=w,R=this.b.get(C.commentControlHandle);if(!R)return C;const f=R.getCommentThread(C.commentThreadHandle);return f?f.value:C}else if(w&&(w.$mid===A.MarshalledId.CommentThreadReply||w.$mid===A.MarshalledId.CommentThreadInstance)){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const R=C.getCommentThread(w.thread.commentThreadHandle);return R?w.$mid===A.MarshalledId.CommentThreadInstance?R.value:{thread:R.value,text:w.text}:w}else if(w&&w.$mid===A.MarshalledId.CommentNode){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const R=C.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const f=w.commentUniqueId,b=R.getCommentByUniqueId(f);return b||w}else if(w&&w.$mid===A.MarshalledId.CommentThreadNode){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const R=C.getCommentThread(w.thread.commentThreadHandle);if(!R)return w;const f=w.text,b=w.commentUniqueId,L=R.getCommentByUniqueId(b);return L?(typeof L.body=="string"?L.body=f:L.body=new y.$iO(f),L):w}return w}})}createCommentController(w,C,R){const f=i.a++,b=new t(w,f,C,R);this.b.set(b.handle,b);const L=this.c.get(w.identifier)||[];return L.push(b),this.c.set(w.identifier,L),b.value}async $createCommentThreadTemplate(w,C,R,f){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(C,R,f)}async $setActiveComment(w,C){const R=this.b.get(w);R&&R.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(w,C,R){const f=this.b.get(w);f&&f.$updateCommentThreadTemplate(C,R)}$deleteCommentThread(w,C){this.b.get(w)?.$deleteCommentThread(C)}async $provideCommentingRanges(w,C,R){const f=this.b.get(w);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const b=await c.ensureDocumentData(O.URI.revive(C));return(0,v.$yh)(async()=>{const L=await f.commentingRangeProvider.provideCommentingRanges(b.document,R);let N;return Array.isArray(L)?N={ranges:L,fileComments:!1}:L?N={ranges:L.ranges||[],fileComments:L.enableFileComments||!1}:N=L??void 0,N}).then(L=>{let N;return L&&(N={ranges:L.ranges.map(M=>k.Range.from(M)),fileComments:L.fileComments}),N})}$toggleReaction(w,C,R,f,b){const L=this.b.get(w);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,v.$yh)(()=>{const N=L.getCommentThread(C);if(N){const M=N.getCommentByUniqueId(f.uniqueIdInThread);if(L!==void 0&&M&&L.reactionHandler)return L.reactionHandler(M,p(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,S.$jH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,C,R,f,b,L,N,M,W){this.m=C,this.n=R,this.o=f,this.p=b,this.q=L,this.extensionDescription=N,this.r=M,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Wc,this.l.value=new T.$Uc,this.n===void 0&&(this.n=`${w}.${this.handle}`),l.$createCommentThread(C,this.handle,this.n,this.o,k.Range.from(this.p),this.q.map(q=>g(this,q,this.k,this.extensionDescription)),N.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(C,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(q){G.range=q},get comments(){return G.comments},set comments(q){G.comments=q},get collapsibleState(){return G.collapsibleState},set collapsibleState(q){G.collapsibleState=q},get canReply(){return G.canReply},set canReply(q){G.canReply=q},get contextValue(){return G.contextValue},set contextValue(q){G.contextValue=q},get label(){return G.label},set label(q){G.label=q},get state(){return G.state},set state(q){G.state=q},reveal:(q,J)=>G.reveal(q,J),hide:()=>G.hide(),dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Uc);const w=R=>Object.prototype.hasOwnProperty.call(this.b,R),C={};w("range")&&(C.range=k.Range.from(this.p)),w("label")&&(C.label=this.label),w("contextValue")&&(C.contextValue=this.contextValue??null),w("comments")&&(C.comments=this.q.map(R=>g(this,R,this.k,this.extensionDescription))),w("collapsibleState")&&(C.collapseState=m(this.g)),w("canReply")&&(C.canReply=this.canReply),w("state")&&(C.state=h(this.h)),w("applicability")&&(C.applicability=E(this.h)),w("isTemplate")&&(C.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(w){for(const C of this.k){const R=C[0],f=C[1];if(w===f)return R}}async reveal(w,C){(0,S.$jH)(this.extensionDescription,"commentReveal");let R;w&&w.body!==void 0?R=w:C=C??w;let f=R?this.k.get(R):void 0;f??=this.k.get(this.q[0]);let b=!0,L=!1;return C?.focus===y.CommentThreadFocus.Reply?(L=!0,b=!1):C?.focus===y.CommentThreadFocus.Comment&&(b=!1),l.$revealCommentThread(this.m,this.handle,f,{preserveFocus:b,focusReply:L})}async hide(){return l.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Je([(0,P.$_h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,S.$jH)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$jH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$jH)(this.h,"activeComment"),this.f?.value}constructor(w,C,R,f){this.h=w,this.i=C,this.j=R,this.k=f,this.a=new Map,l.$registerCommentController(this.handle,R,f,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(L){b.options=L},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(L){b.commentingRangeProvider=L},get reactionHandler(){return b.reactionHandler},set reactionHandler(L){b.reactionHandler=L},get activeCommentThread(){return b.activeCommentThread},createCommentThread(L,N,M){return b.createCommentThread(L,N,M).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,C,R){C===void 0&&(0,S.$jH)(this.h,"fileComments");const f=new n(this.id,this.handle,void 0,w,C,R,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const C=this.a.get(w.commentThreadHandle);C&&(this.e=w.uniqueIdInThread?C.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(w,C,R){const f=new n(this.id,this.handle,void 0,O.URI.revive(w),k.Range.to(C),[],this.h,!0,R);return f.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(w,C){const R=this.a.get(w);R&&(R.range=k.Range.to(C))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function g(D,w,C,R){let f=C.get(w);return f||(f=++D.commentHandle,C.set(w,f)),w.state!==void 0&&(0,S.$jH)(R,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,S.$jH)(R,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:f,body:typeof w.body=="string"?w.body:k.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>u(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?k.$nQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(w=>w.name):D.reactors}}function p(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?O.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(w=>({name:w}))}}function m(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(D){let w;if(typeof D=="object"?w=D.resolved:w=D,w!==void 0)switch(w){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(D){let w;if(typeof D=="object"&&(w=D.applicability),w!==void 0)switch(w){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Ne[236],Me([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0,$=Ve($),y=Ve(y),a=Ve(a);class S{constructor(u,p){this.document=u,this.b=p,this.a=1,this.c=new k.$Hpc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,p){await this.f(u).undo(),p||this.disposeBackup()}async redo(u,p){await this.f(u).redo(),p||this.disposeBackup()}disposeEdits(u){for(const p of u)this.c.delete(p)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,A.$hh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const p=this.c.get(u,0);if(!p)throw new Error("No edit found");return p}}class d{constructor(){this.a=new Map}get(u,p){return this.a.get(this.b(u,p))}add(u,p,m){const h=this.b(u,p.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${p.uri}`);const E=new S(p,m);return this.a.set(h,E),E}delete(u,p){const m=this.b(u,p.uri);this.a.delete(m)}b(u,p){return`${u}@@@${p}`}}var r;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(u,p,m){return this.b(u,{type:r.Text,extension:p,provider:m})}addCustomProvider(u,p,m){return this.b(u,{type:r.Custom,extension:p,provider:m})}get(u){return this.a.get(u)}b(u,p){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,p),new a.$QN(()=>this.a.delete(u))}}class c{constructor(u,p,m,h,E){this.d=p,this.f=m,this.g=h,this.h=E,this.b=new s,this.c=new d,this.a=u.getProxy(y.$ON.MainThreadCustomEditors)}registerCustomEditorProvider(u,p,m,h){const E=new I.$Uc;return i(m)?(E.add(this.b.addTextProvider(p,u,m)),this.a.$registerTextEditorProvider((0,o.$eqc)(u),p,h.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,o.$cqc)(u))):(E.add(this.b.addCustomProvider(p,u,m)),l(m)&&E.add(m.onDidChangeCustomDocument(D=>{const w=this.i(p,D.document.uri);if(n(D)){const C=w.addEdit(D);this.a.$onDidEdit(D.document.uri,p,C,D.label)}else this.a.$onContentChange(D.document.uri,p)})),this.a.$registerCustomEditorProvider((0,o.$eqc)(u),p,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,o.$cqc)(u))),a.$QN.from(E,new a.$QN(()=>{this.a.$unregisterEditorProvider(p)}))}async $createCustomDocument(u,p,m,h,E){const D=this.b.get(p);if(!D)throw new Error(`No provider found for '${p}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${p}'`);const w=O.URI.revive(u),C=await D.provider.openCustomDocument(w,{backupId:m,untitledDocumentData:h?.buffer},E);let R;return l(D.provider)&&this.f&&(R=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(p,C,R),{editable:l(D.provider)}}async $disposeCustomDocument(u,p){const m=this.b.get(p);if(!m)throw new Error(`No provider found for '${p}'`);if(m.type!==r.Custom)throw new Error(`Invalid provider type for '${p}'`);const h=O.URI.revive(u),{document:E}=this.i(p,h);this.c.delete(p,E),E.dispose()}async $resolveCustomEditor(u,p,m,h,E,D){const w=this.b.get(m);if(!w)throw new Error(`No provider found for '${m}'`);const C=$.ViewColumn.to(E),R=this.g.createNewWebview(p,h.contentOptions,w.extension),f=this.h.createNewWebviewPanel(p,m,h.title,C,h.options,R,h.active),b=O.URI.revive(u);switch(w.type){case r.Custom:{const{document:L}=this.i(m,b);return w.provider.resolveCustomEditor(L,f,D)}case r.Text:{const L=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(L,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,p,m){this.i(p,u).disposeEdits(m)}async $onMoveCustomEditor(u,p,m){const h=this.b.get(m);if(!h)throw new Error(`No provider found for '${m}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=O.URI.revive(p),w=this.d.getDocument(D);await h.provider.moveCustomTextEditor(w,E,v.CancellationToken.None)}async $undo(u,p,m,h){return this.i(p,u).undo(m,h)}async $redo(u,p,m,h){return this.i(p,u).redo(m,h)}async $revert(u,p,m){const h=this.i(p,u);await this.j(p).revertCustomDocument(h.document,m),h.disposeBackup()}async $onSave(u,p,m){const h=this.i(p,u);await this.j(p).saveCustomDocument(h.document,m),h.disposeBackup()}async $onSaveAs(u,p,m,h){const E=this.i(p,u);return this.j(p).saveCustomDocumentAs(E.document,O.URI.revive(m),h)}async $backup(u,p,m){const h=this.i(p,u),D=await this.j(p).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},m);return h.updateBackup(D),D.id}i(u,p){const m=this.c.get(u,O.URI.revive(p));if(!m)throw new Error("No custom document found");return m}j(u){const m=this.b.get(u)?.provider;if(!m||!l(m))throw new Error("Custom document is not editable");return m}}e.$hqc=c;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function n(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===T.Schemas.file||g.scheme===T.Schemas.untitled?g.fsPath:g.toString();return(0,P.$uj)(u)+""}}),define(Ne[237],Me([1,0,9,107,2,5,7,8,6,11,28,50]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0,O=Ve(O);class S{#e;#t;#i;constructor(s,c,l,i,n,t,g,u){this.d=s,this.e=c,this.f=l,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,l),this.#i=new k.$Bc(p=>t.getComparisonKey(p)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,c){if(!s){this.clear();return}this.j();let l=[];if(I.URI.isUri(s)){if(!c){this.delete(s);return}this.#i.set(s,c.slice()),l=[s]}else if(Array.isArray(s)){l=[];let t;s=[...s].sort(S.k);for(const g of s){const[u,p]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),p)this.#i.get(u)?.push(...p);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let n=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const p=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const h of u)if(h.severity===p[m]&&g.push({...O.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:P.MarkerSeverity.Info,message:(0,v.localize)(2687,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(p=>({...O.Diagnostic.from(p),modelVersionId:this.h(t)}));if(i.push([t,g]),n+=g.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,c){this.j();for(const[l,i]of this)s.call(c,l,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const c=this.#i.get(s);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,c){return s[0].toString()<c[0].toString()?-1:s[0].toString()>c[0].toString()?1:0}}e.$Opc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(s){const c=new k.$Bc;for(const l of s)c.set(l,l);return{uris:Object.freeze(Array.from(c.values()))}}constructor(s,c,l,i){this.j=c,this.k=l,this.l=i,this.g=new Map,this.h=new $.$qe({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=s.getProxy(T.$ON.MainThreadDiagnostics)}createDiagnosticCollection(s,c){const{g:l,f:i,h:n,j:t,k:g,l:u}=this,p=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,E)}dispose(){i.dispose()}};let m;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,m=c;else if(!l.has(c))m=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do m=c+a.c++;while(l.has(m))}return new class extends S{constructor(){super(c,m,a.e,a.d,E=>u.getDocument(E)?.version,g.extUri,p,n),l.set(m,this)}dispose(){super.dispose(),l.delete(m)}}}getDiagnostics(s){if(s)return this.m(s);{const c=new Map,l=[];for(const i of this.g.values())i.forEach((n,t)=>{let g=c.get(n.toString());typeof g>"u"&&(g=l.length,c.set(n.toString(),g),l.push([n,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(s){let c=[];for(const l of this.g.values())l.has(s)&&(c=c.concat(l.get(s)));return c}$acceptMarkersChange(s){if(!this.n){const c="_generated_mirror",l=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,l),this.n=l}for(const[c,l]of s)this.n.set(I.URI.revive(c),l.map(O.Diagnostic.to))}};e.$Ppc=d,e.$Ppc=d=a=Je([We(1,o.$bk),We(2,y.$Npc)],d)}),define(Ne[238],Me([1,0,2,13,7,8,172,39]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class ${constructor(k,y,a,S={timeout:1500,errors:3}){this.c=k,this.d=y,this.f=a,this.g=S,this.a=new A.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(y,a,S)=>{const r={dispose:this.a.push([y,a,k])};return Array.isArray(S)&&S.push(r),r}}async $participateInSave(k,y){const a=v.URI.revive(k);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(S)break;const c=this.d.getDocument(a),l=await this.h(s,{document:c,reason:T.TextDocumentSaveReason.to(y)});r.push(l)}}finally{clearTimeout(d)}return r}h([k,y,a],S){const d=this.b.get(k);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,k,y,S).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,y,a,S){const d=[],r=Date.now(),{document:s,reason:c}=S,{version:l}=s,i=Object.freeze({document:s,reason:c,waitUntil(n){if(Object.isFrozen(d))throw(0,P.$8)("waitUntil can not be called async");d.push(Promise.resolve(n))}});try{y.apply(a,[i])}catch(n){return Promise.reject(n)}return Object.freeze(d),new Promise((n,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(g),n(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(n=>{const t={edits:[]};for(const g of n)if(Array.isArray(g)&&g.every(u=>u instanceof I.$ZN))for(const{newText:u,newEol:p,range:m}of g)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&T.Range.from(m),text:u,eol:p&&T.EndOfLine.from(p)}});if(t.edits.length!==0)return l===s.version?this.f.$tryApplyWorkspaceEdit(new O.$2w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$3qc=$}),define(Ne[239],Me([1,0,6,4,2,5,124,8,14,25,7]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,O=Ve(O);class y{constructor(S,d){this.a=new v.$me,this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.$Uc,this.h=new Map,this.f=S.getProxy(T.$ON.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const c=I.URI.revive(s);return(0,$.$qg)(this.g.getDocument(c))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>I.URI.revive(d))}$acceptModelLanguageChanged(S,d){const r=I.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(S){const d=I.URI.revive(S),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,d){const r=I.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,r){const s=I.URI.revive(S),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(d);let l;d.isUndoing?l=k.TextDocumentChangeReason.Undo:d.isRedoing&&(l=k.TextDocumentChangeReason.Redo),this.c.fire((0,o.$go)({document:c.document,contentChanges:d.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,d){(0,A.$qQ)(S,d)}}e.$Qpc=y}),define(Ne[70],Me([1,0,240,6,14,2,3,5,16,8,7]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=e.$iqc=void 0,o=Ve(o),e.$iqc=(0,A.$Gi)("IExtHostEditorTabs");class y{constructor(s,c,l){this.e=l,this.d=c,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new k.$EP(T.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new k.$FP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new k.$GP(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new k.$HP(T.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new k.$IP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new k.$JP(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new k.$KP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new k.$LP;case O.TabInputKind.InteractiveEditorInput:return new k.$MP(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new k.$NP;case O.TabInputKind.MultiDiffEditorInput:return new k.$OP(this.b.input.diffEditors.map(s=>new k.$FP(T.URI.revive(s.original),T.URI.revive(s.modified))));default:return}}}class a{constructor(s,c){this.c=[],this.d="",this.b=s,this.e=c;for(const l of s.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return o.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(l=>l.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(l=>l.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===O.TabModelOperationKind.TAB_OPEN){const l=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,l),s.tabDto.isActive&&(this.d=l.tabId),l}else if(s.kind===O.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(s.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(s.kind===O.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(s.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,l),l}const c=this.c.find(l=>l.tabId===s.tabDto.id);if(!c)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(s.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(s){this.b=new P.$me,this.c=new P.$me,this.e=[],this.a=s.getProxy(O.$ON.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,c={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(l=>l.apiObject))},get activeTabGroup(){const l=s.d;return(0,I.$qg)(s.e.find(n=>n.groupId===l)?.apiObject)},close:async(l,i)=>{const n=Array.isArray(l)?l:[l];return n.length?d(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(s){const c=new Set(this.e.map(p=>p.groupId)),l=new Set(s.map(p=>p.groupId)),i=(0,v.$d)(c,l),n=this.e.filter(p=>i.removed.includes(p.groupId)).map(p=>p.apiObject),t=[],g=[];this.e=s.map(p=>{const m=new a(p,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,I.$qg)(s.find(p=>p.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:n,changed:g}))}$acceptTabGroupUpdate(s){const c=this.e.find(l=>l.groupId===s.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const c=this.e.find(i=>i.groupId===s.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const l=c.acceptTabOperation(s);switch(s.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(s){for(const c of this.e)for(const l of c.tabs)if(l.apiObject===s)return l}h(s){return this.e.find(c=>c.apiObject===s)}async i(s,c){const l=[];for(const i of s){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");l.push(n.tabId)}return this.a.$closeTab(l,c)}async j(s,c){const l=[];for(const i of s){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");l.push(n.groupId)}return this.a.$closeGroup(l,c)}};e.$jqc=S,e.$jqc=S=Je([We(0,$.$oQ)],S);function d(r){return r.tabs!==void 0}}),define(Ne[241],Me([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,I=Ve(I),O=Ve(O);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const l=this.a.indexOf(c);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),l=[];let i,n,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const u of c){let p=i?(0,o.$If)(i,u):0;for(p===0?n=$.State.Start:n=g;p<u.length;p++)p+1===u.length?(t=g,g=$.State.BeforeColon):g+=1,l.push([n,u.toUpperCase().charCodeAt(p),g]),l.push([n,u.toLowerCase().charCodeAt(p),g]),n=g;i=u,g=t}l.push([$.State.BeforeColon,k.CharCode.Colon,$.State.AfterColon]),l.push([$.State.AfterColon,k.CharCode.Slash,$.State.End]),this.b=new $.$J4(l)}}provideDocumentLinks(c){this.c();const l=[],i=$.$K4.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of i){const t=O.DocumentLink.to(n);t.target&&l.push(t)}return l}}class r{constructor(c,l){this.i=l,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(P.$ON.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,l,i,n={}){if(r.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=I.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(g+=I.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(g+=I.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$jH)(c,"fsChunks"),g+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;n.isReadonly&&(0,S.$7k)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${l}`),console.error(m)});const p=i.onDidChangeFile(m=>{const h=[];for(const E of m){const{uri:D,type:w}=E;if(D.scheme!==l)continue;let C;switch(w){case A.FileChangeType.Changed:C=I.FileChangeType.UPDATED;break;case A.FileChangeType.Created:C=I.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:C=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:C})}this.a.$onFileSystemChange(t,h)});return(0,T.$Tc)(()=>{p.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:l,ctime:i,mtime:n,size:t,permissions:g}=c;return{type:l,ctime:i,mtime:n,size:t,permissions:g}}$stat(c,l){return Promise.resolve(this.l(c).stat(v.URI.revive(l))).then(i=>r.k(i))}$readdir(c,l){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(l)))}$readFile(c,l){return Promise.resolve(this.l(c).readFile(v.URI.revive(l))).then(i=>y.$Oe.wrap(i))}$writeFile(c,l,i,n){return Promise.resolve(this.l(c).writeFile(v.URI.revive(l),i.buffer,n))}$delete(c,l,i){return Promise.resolve(this.l(c).delete(v.URI.revive(l),i))}$rename(c,l,i,n){return Promise.resolve(this.l(c).rename(v.URI.revive(l),v.URI.revive(i),n))}$copy(c,l,i,n){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),n))}$mkdir(c,l){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(l)))}$watch(c,l,i,n){const t=this.l(c).watch(v.URI.revive(i),n);this.f.set(l,t)}$unwatch(c,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(c,l,i){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(l),i))}$close(c,l){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(c,l,i,n){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Oe.alloc(n);return Promise.resolve(t.read(l,i,g.buffer,0,n)).then(u=>g.slice(0,u))}$write(c,l,i,n){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,n.buffer,0,n.byteLength))}l(c){const l=this.c.get(c);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$6qc=r}),define(Ne[242],Me([1,0,6,41,2,5,8,7,29,48]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,A=Ve(A);class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,s,c,l,i){this.a=Math.random(),this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,P.$Bk)(l),t=typeof l=="string",g=i?.correlate,u=c(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(g&&typeof p.session>"u")){if(!i?.ignoreCreateEvents)for(const m of p.created){const h=I.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const m of p.changed){const h=I.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const m of p.deleted){const h=I.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=O.$QN.from(this.i(d,s,l,i,i?.correlate),this.b,this.c,this.d,u)}i(d,r,s,c,l){const i=O.$QN.from();if(typeof s=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const n=d.getProxy(T.$ON.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(P.$xk)||s.pattern.includes(P.$yk))&&(t=!0);let g;return l&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,s.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!l),O.$QN.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new o.$U(()=>this.a.created.map(I.URI.revive)),this.c=new o.$U(()=>this.a.changed.map(I.URI.revive)),this.d=new o.$U(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,r,s){this.j=d,this.k=r,this.l=s,this.a=new v.$me,this.b=new v.$me,this.c=new v.$me,this.d=new v.$me,this.g=new v.$oe,this.h=new v.$oe,this.i=new v.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,s,c){return new k(this.j,d,r,this.a.event,A.GlobPattern.from(s),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,r){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(s=>I.URI.revive(s.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(s=>I.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(s,c,l)=>{const i=function(t){s.call(c,t)};return i.extension=d,r.event(i,void 0,l)}}async $onWillRunFileOperation(d,r,s,c){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:r.map(l=>({oldUri:I.URI.revive(l.source),newUri:I.URI.revive(l.target)}))},s,c);case $.FileOperation.DELETE:return await this.n(this.i,{files:r.map(l=>I.URI.revive(l.target))},s,c);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:r.map(l=>I.URI.revive(l.target))},s,c)}}async n(d,r,s,c){const l=new Set,i=[];if(await d.fireAsync(r,c,async(t,g)=>{const u=Date.now(),p=await Promise.resolve(t);p instanceof O.$3N&&(i.push([g.extension,p]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>s&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(g)}return{edit:n,extensionNames:Array.from(l)}}}e.$7qc=a}),define(Ne[243],Me([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0,r=Ve(r),i=Ve(i),u=Ve(u);class p{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const Q=this.d.getDocument(z),V=await this.e.provideDocumentSymbols(Q,j);if(!(0,v.$Kb)(V))return V[0]instanceof n.$aO?V.map(i.DocumentSymbol.from):p.f(V)}static f(z){z=z.slice(0).sort((V,re)=>{let ge=V.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(V.location.range.end)),ge});const j=[],Q=[];for(const V of z){const re={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(Q.length===0){Q.push(re),j.push(re);break}const ge=Q[Q.length-1];if(S.$Rt.containsRange(ge.range,re.range)&&!S.$Rt.equalsRange(ge.range,re.range)){ge.children?.push(re),Q.push(re);break}Q.pop()}}return j}}class m{constructor(z,j,Q,V,re,ge){this.f=z,this.g=j,this.h=Q,this.j=V,this.k=re,this.l=ge,this.d=new g.$Hpc("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const Q=this.f.getDocument(z),V=await this.h.provideCodeLenses(Q,j);if(!V||j.isCancellationRequested)return;const re=this.d.add(V),ge=new O.$Uc;this.e.set(re,ge);const Ce={cacheId:re,lenses:[]};for(let ze=0;ze<V.length;ze++)Ce.lenses.push({cacheId:[re,ze],range:i.Range.from(V[ze].range),command:this.g.toInternal(V[ze].command,ge)});return Ce}async resolveCodeLens(z,j){const Q=z.cacheId&&this.d.get(...z.cacheId);if(!Q)return;let V;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?V=Q:V=await this.h.resolveCodeLens(Q,j),V||(V=Q),j.isCancellationRequested)return;const re=z.cacheId&&this.e.get(z.cacheId[0]);if(re){if(!V.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return z.command=this.g.toInternal(V.command,re),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function h(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDefinition(V,re,Q);return h(ge)}}class D{constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDeclaration(V,re,Q);return h(ge)}}class w{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideImplementation(V,re,Q);return h(ge)}}class C{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideTypeDefinition(V,re,Q);return h(ge)}}class R{static{this.f=10}constructor(z,j){this.g=z,this.h=j,this.d=0,this.e=new Map}async provideHover(z,j,Q,V){const re=this.g.getDocument(z),ge=i.Position.to(j);let Ce;if(Q&&Q.verbosityRequest){const tt=Q.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:Q.verbosityRequest.verbosityDelta,previousHover:nt};Ce=await this.h.provideHover(re,ge,V,et)}else Ce=await this.h.provideHover(re,ge,V);if(!Ce||(0,v.$Kb)(Ce.contents))return;Ce.range||(Ce.range=re.getWordRangeAtPosition(ge)),Ce.range||(Ce.range=new n.$SN(ge,ge));const ze=i.Hover.from(Ce),He=this.d;if(this.e.size===R.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(He,Ce),this.d+=1,{...ze,id:He}}releaseHover(z){this.e.delete(z)}}class f{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(V,re,Q);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,Q,V){const re=this.d.getDocument(z),ge=await this.e.provideInlineValues(re,i.Range.to(j),i.InlineValueContext.to(Q),V);if(Array.isArray(ge))return ge.map(Ce=>i.InlineValue.from(Ce))}}class L{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDocumentHighlights(V,re,Q);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class N{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,Q,V){const re=this.d.getDocument(z),ge=Q.map(He=>this.d.getDocument(He)),Ce=i.Position.to(j),ze=await this.e.provideMultiDocumentHighlights(re,Ce,ge,V);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class M{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,Q){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(V,re,Q);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Hb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class W{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,Q,V){const re=this.d.getDocument(z),ge=i.Position.to(j),Ce=await this.e.provideReferences(re,ge,Q,V);if(Array.isArray(Ce))return Ce.map(i.location.from)}}class G{static{this.d=1e3}constructor(z,j,Q,V,re,ge,Ce){this.g=z,this.h=j,this.j=Q,this.k=V,this.l=re,this.m=ge,this.n=Ce,this.e=new g.$Hpc("CodeAction"),this.f=new Map}async provideCodeActions(z,j,Q,V){const re=this.g.getDocument(z),ge=d.$Tt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ce=[];for(const et of this.j.getDiagnostics(z))if(ge.intersection(et.range)&&Ce.push(et)>G.d)break;const ze={diagnostics:Ce,only:Q.only?new n.$cO(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},He=await this.k.provideCodeActions(re,ge,ze,V);if(!(0,v.$Lb)(He)||V.isCancellationRequested)return;const _e=this.e.add(He),tt=new O.$Uc;this.f.set(_e,tt);const nt=[];for(let et=0;et<He.length;et++){const rt=He[et];if(rt)if(G.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$iH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$iH)(this.m,"codeActionRanges")?(0,v.$Hb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(z,j){const[Q,V]=z,re=this.e.get(Q,V);if(!re||G.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,j)??re;let Ce;ge.edit&&(Ce=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const He=this.f.get(Q);He&&(ze=this.h.toInternal(ge.command,He))}return{edit:Ce,command:ze}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class q{constructor(z,j,Q,V,re){this.e=z,this.f=j,this.g=Q,this.h=V,this.j=re,this.d=new g.$Hpc("DocumentPasteEdit")}async prepareDocumentPaste(z,j,Q,V){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(z),ge=j.map(He=>i.Range.to(He)),Ce=i.DataTransfer.toDataTransfer(Q,()=>{throw new T.$$});if(await this.g.prepareDocumentPaste(re,ge,Ce,V),V.isCancellationRequested)return;const ze=Array.from(Ce).filter(([,He])=>!(He instanceof n.$IO));return i.DataTransfer.from(ze)}async providePasteEdits(z,j,Q,V,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ce=this.f.getDocument(j),ze=Q.map(nt=>i.Range.to(nt)),He=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,z,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ce,ze,He,{only:re.only?new n.$NO(re.only):void 0,triggerKind:re.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(2690,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,j){const[Q,V]=z,re=this.d.get(Q,V);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class J{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,Q){const V=this.d.getDocument(z),re=await this.e.provideDocumentFormattingEdits(V,j,Q);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class K{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,Q,V){const re=this.d.getDocument(z),ge=i.Range.to(j),Ce=await this.e.provideDocumentRangeFormattingEdits(re,ge,Q,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,Q,V){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(z),ge=j.map(i.Range.to),Ce=await this.e.provideDocumentRangesFormattingEdits(re,ge,Q,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}}class oe{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,Q,V,re){const ge=this.d.getDocument(z),Ce=i.Position.to(j),ze=await this.e.provideOnTypeFormattingEdits(ge,Ce,Q,V,re);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class me{constructor(z,j){this.e=z,this.f=j,this.d=new g.$Hpc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const Q=await this.e.provideWorkspaceSymbols(z,j);if(!(0,v.$Lb)(Q))return{symbols:[]};const V=this.d.add(Q),re={cacheId:V,symbols:[]};for(let ge=0;ge<Q.length;ge++){const Ce=Q[ge];if(!Ce||!Ce.name){this.f.warn("INVALID SymbolInformation",Ce);continue}re.symbols.push({...i.WorkspaceSymbol.from(Ce),cacheId:[V,ge]})}return re}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const Q=this.d.get(...z.cacheId);if(Q){const V=await this.e.resolveWorkspaceSymbol(Q,j);return V&&(0,$.$io)(z,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class le{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,Q){this.d=z,this.e=j,this.f=Q}async provideRenameEdits(z,j,Q,V){const re=this.d.getDocument(z),ge=i.Position.to(j);try{const Ce=await this.e.provideRenameEdits(re,ge,Q,V);return Ce?i.WorkspaceEdit.from(Ce):void 0}catch(Ce){const ze=le.g(Ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ce)}}async resolveRenameLocation(z,j,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(z),re=i.Position.to(j);try{const ge=await this.e.prepareRename(V,re,Q);let Ce,ze;if(n.$SN.isRange(ge)?(Ce=ge,ze=V.getText(ge)):(0,y.$hg)(ge)&&(Ce=ge.range,ze=ge.placeholder),!Ce||!ze)return;if(Ce.start.line>re.line||Ce.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ce),text:ze}}catch(ge){const Ce=le.g(ge);return Ce?{rejectReason:Ce,range:void 0,text:void 0}:Promise.reject(ge)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class _{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(z,j,Q){this.e=z,this.f=j,this.g=Q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,j,Q,V){const re=this.e.getDocument(z),ge=i.Range.to(j);try{const Ce=_.d[Q],ze=await this.f.provideNewSymbolNames(re,ge,Ce,V);return ze?ze.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Ce){this.g.error(_.h(Ce)??JSON.stringify(Ce,null,"	"));return}}static h(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ce{constructor(z,j){this.resultId=z,this.tokens=j}}class pe{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,Q){const V=this.f.getDocument(z),re=j!==0?this.d.get(j):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,re.resultId,Q):await this.g.provideDocumentSemanticTokens(V,Q);return re&&this.d.delete(j),ge?(ge=pe.h(ge),this.o(pe.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return pe.j(z)?pe.k(z)?z:new n.$bP(new Uint32Array(z.data),z.resultId):pe.l(z)?pe.m(z)?z:new n.$dP(z.edits.map(j=>new n.$cP(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!pe.j(j)||!z||!z.tokens)return j;const Q=z.tokens,V=Q.length,re=j.data,ge=re.length;let Ce=0;const ze=Math.min(V,ge);for(;Ce<ze&&Q[Ce]===re[Ce];)Ce++;if(Ce===V&&Ce===ge)return new n.$dP([],j.resultId);let He=0;const _e=ze-Ce;for(;He<_e&&Q[V-He-1]===re[ge-He-1];)He++;return new n.$dP([{start:Ce,deleteCount:V-Ce-He,data:re.subarray(Ce,ge-He)}],j.resultId)}o(z,j){if(pe.j(z)){const Q=this.e++;return this.d.set(Q,new ce(z.resultId,z.data)),(0,s.$3db)({id:Q,type:"full",data:z.data})}if(pe.l(z)){const Q=this.e++;return pe.j(j)?this.d.set(Q,new ce(j.resultId,j.data)):this.d.set(Q,new ce(z.resultId)),(0,s.$3db)({id:Q,type:"delta",deltas:(z.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class ae{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,Q){const V=this.d.getDocument(z),re=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(j),Q);return re?this.f(re):null}f(z){return(0,s.$3db)({id:0,type:"full",data:z.data})}}class Se{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,Q,V,re){this.f=z,this.g=j,this.h=Q,this.j=V,this.k=re,this.d=new g.$Hpc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,Q,V){const re=this.f.getDocument(z),ge=i.Position.to(j),Ce=re.getWordRangeAtPosition(ge)||new n.$SN(ge,ge),ze=Ce.with({end:ge}),He=new o.$ge,_e=await this.h.provideCompletionItems(re,ge,V,i.CompletionContext.to(Q));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$pO(_e):_e,nt=Se.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new O.$Uc;this.e.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ce),insert:i.Range.from(ze)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:He.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],ze,Ce);rt.push(ct)}return ft}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...z);if(!Q)return;const V=this.l(Q,z),re=await this.h.resolveCompletionItem(Q,j);if(!re)return;const ge=this.l(re,z);return(V[u.ISuggestDataDtoField.insertText]!==ge[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==ge[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==ge[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==ge[u.ISuggestDataDtoField.commandId]||!(0,$.$jo)(V[u.ISuggestDataDtoField.commandArguments],ge[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:ge[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:ge[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:ge[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:ge[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:ge[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:ge[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:ge[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:ge[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,Q,V){const re=this.e.get(j[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(z.command,re),Ce={x:j,[u.ISuggestDataDtoField.label]:z.label,[u.ISuggestDataDtoField.kind]:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:z.detail,[u.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),[u.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[u.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[u.ISuggestDataDtoField.preselect]:z.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:ge?.$ident,[u.ISuggestDataDtoField.commandId]:ge?.id,[u.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ce[u.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ce[u.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof n.$4N&&(Ce[u.ISuggestDataDtoField.insertText]=z.insertText.value,Ce[u.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return z.textEdit?ze=z.textEdit.range:z.range&&(ze=z.range),n.$SN.isRange(ze)?Ce[u.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!Q?.isEqual(ze.inserting)||!V?.isEqual(ze.replacing))&&(Ce[u.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ce}}class Oe{async provideInlineCompletions(z,j,Q,V){}async provideInlineEdits(z,j,Q,V){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,Q){}handlePartialAccept(z,j,Q,V){}}class X extends Oe{constructor(z,j,Q,V){super(),this.f=z,this.g=j,this.h=Q,this.j=V,this.d=new te,this.e=(0,t.$iH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$iH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,Q,V){const re=this.g.getDocument(z),ge=i.Position.to(j),Ce=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,He=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new O.$Uc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:He.map(et=>(tt||(tt=new O.$Uc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(z,j,Q,V){if(!this.h.provideInlineEdits)return;(0,t.$jH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(z),ge=i.Range.to(j),Ce=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind],userPrompt:Q.userPrompt},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,He=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new O.$Uc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:He.map(et=>(tt||(tt=new O.$Uc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,Q){const V=this.d.get(z)?.items[j];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,Q)}handlePartialAccept(z,j,Q,V){const re=this.d.get(z)?.items[j];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,Q),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(V)))}}class B{async provideInlineEdits(z,j,Q){const V=this.f.getDocument(z),re=await this.g.provideInlineEdit(V,{triggerKind:this.e[j.triggerKind]},Q);if(!re||Q.isCancellationRequested)return;let ge;const Ce=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let ze;re.accepted&&(ge||(ge=new O.$Uc),ze=this.h.toInternal(re.accepted,ge));let He;return re.rejected&&(ge||(ge=new O.$Uc),He=this.h.toInternal(re.rejected,ge)),{pid:Ce,text:re.text,range:i.Range.from(re.range),accepted:ze,rejected:He}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,Q,V){this.f=j,this.g=Q,this.h=V,this.d=new te,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class ye{constructor(z,j){this.e=z,this.f=j,this.d=new g.$Hpc("SignatureHelp")}async provideSignatureHelp(z,j,Q,V){const re=this.e.getDocument(z),ge=i.Position.to(j),Ce=this.g(Q),ze=await this.f.provideSignatureHelp(re,ge,V,Ce);if(ze){const He=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:He}}}g(z){let j;if(z.activeSignatureHelp){const Q=i.SignatureHelp.to(z.activeSignatureHelp),V=this.d.get(z.activeSignatureHelp.id,0);V?(j=V,j.activeSignature=Q.activeSignature,j.activeParameter=Q.activeParameter):j=Q}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class de{constructor(z,j,Q,V,re){this.f=z,this.g=j,this.h=Q,this.j=V,this.k=re,this.d=new g.$Hpc("InlayHints"),this.e=new Map}async provideInlayHints(z,j,Q){const V=this.f.getDocument(z),re=i.Range.to(j),ge=await this.h.provideInlayHints(V,re,Q);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(Q.isCancellationRequested)return;const Ce=this.d.add(ge);this.e.set(Ce,new O.$Uc);const ze={hints:[],cacheId:Ce};for(let He=0;He<ge.length;He++)this.l(ge[He],re)&&ze.hints.push(this.m(ge[He],[Ce,He]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),ze}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...z);if(!Q)return;const V=await this.h.resolveInlayHint(Q,j);if(V&&this.l(V))return this.m(V,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const Q=this.e.get(j[0]);if(!Q)throw Error("DisposableStore is missing...");const V={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")V.label=z.label;else{const re=[];V.label=re;for(const ge of z.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ce={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$5N.isLocation(ge.location)&&(Ce.location=i.location.from(ge.location)),ge.command&&(Ce.command=this.g.toInternal(ge.command,Q)),re.push(Ce)}}return V}}class we{constructor(z,j){this.e=z,this.f=j,this.d=new g.$Hpc("DocumentLink")}async provideLinks(z,j){const Q=this.e.getDocument(z),V=await this.f.provideDocumentLinks(Q,j);if(!(!Array.isArray(V)||V.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(we.g).map(i.DocumentLink.from)};{const re=this.d.add(V),ge={links:[],cacheId:re};for(let Ce=0;Ce<V.length;Ce++){if(!we.g(V[Ce]))continue;const ze=i.DocumentLink.from(V[Ce]);ze.cacheId=[re,Ce],ge.links.push(ze)}return ge}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...z);if(!Q)return;const V=await this.f.resolveDocumentLink(Q,j);if(!(!V||!we.g(V)))return i.DocumentLink.from(V)}releaseLinks(z){this.d.delete(z)}}class he{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const Q=this.d.getDocument(z),V=await this.e.provideDocumentColors(Q,j);return Array.isArray(V)?V.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(z,j,Q){const V=this.d.getDocument(z),re=i.Range.to(j.range),ge=i.Color.to(j.color),Ce=await this.e.provideColorPresentations(ge,{document:V,range:re},Q);if(Array.isArray(Ce))return Ce.map(i.ColorPresentation.from)}}class Z{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,Q){const V=this.d.getDocument(z),re=await this.e.provideFoldingRanges(V,j,Q);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class x{constructor(z,j,Q){this.d=z,this.e=j,this.f=Q}async provideSelectionRanges(z,j,Q){const V=this.d.getDocument(z),re=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(V,re,Q);if(!(0,v.$Lb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ce=[];for(let ze=0;ze<re.length;ze++){const He=[];Ce.push(He);let _e=re[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ce}}class be{constructor(z,j){this.f=z,this.g=j,this.d=new A.$tQ(""),this.e=new Map}async prepareSession(z,j,Q){const V=this.f.getDocument(z),re=i.Position.to(j),ge=await this.g.prepareCallHierarchy(V,re,Q);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideCallsTo(z,j,Q){const V=this.j(z,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(V,Q);if(re)return re.map(ge=>({from:this.h(z,ge.from),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}async provideCallsFrom(z,j,Q){const V=this.j(z,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(V,Q);if(re)return re.map(ge=>({to:this.h(z,ge.to),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}releaseSession(z){this.e.delete(z)}h(z,j){const Q=this.e.get(z),V=i.CallHierarchyItem.from(j,z,Q.size.toString(36));return Q.set(V._itemId,j),V}j(z,j){return this.e.get(z)?.get(j)}}class $e{constructor(z,j){this.f=z,this.g=j,this.d=new A.$tQ(""),this.e=new Map}async prepareSession(z,j,Q){const V=this.f.getDocument(z),re=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(V,re,Q);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideSupertypes(z,j,Q){const V=this.j(z,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(V,Q);if(re)return re.map(ge=>this.h(z,ge))}async provideSubtypes(z,j,Q){const V=this.j(z,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(V,Q);if(re)return re.map(ge=>this.h(z,ge))}releaseSession(z){this.e.delete(z)}h(z,j){const Q=this.e.get(z),V=i.TypeHierarchyItem.from(j,z,Q.size.toString(36));return Q.set(V._itemId,j),V}j(z,j){return this.e.get(z)?.get(j)}}class Ae{constructor(z,j,Q,V,re){this.e=z,this.f=j,this.g=Q,this.h=V,this.j=re,this.d=new g.$Hpc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,j,Q,V,re){const ge=this.f.getDocument(j),Ce=i.Position.to(Q),ze=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,nt)).buffer),He=await this.g.provideDocumentDropEdits(ge,Ce,ze,re);if(!He)return;const _e=(0,v.$2b)(He),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(2691,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,j){const[Q,V]=z,re=this.d.get(Q,V);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class Ue{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,Q,V){const re=a.URI.revive(z),ge=this.d.getDocument(re),Ce=Q.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),ze={documents:Ce,selections:Ce[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(ge,j,ze,V);return He?i.WorkspaceEdit.from(He):null}}class ke{constructor(z,j){this.adapter=z,this.extension=j}}class Pe{static{this.d=0}constructor(z,j,Q,V,re,ge,Ce,ze){this.g=j,this.h=Q,this.j=V,this.k=re,this.l=ge,this.m=Ce,this.n=ze,this.f=new Map,this.e=z.getProxy(u.$ON.MainThreadLanguageFeatures)}o(z,j){return i.DocumentSelector.from(z,this.g,j)}p(z){return new n.$QN(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Pe.d++}async s(z,j,Q,V,re,ge=!1){const Ce=this.f.get(z);if(!Ce||!(Ce.adapter instanceof j))return V;const ze=Date.now();ge||this.l.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const He=Q(Ce.adapter,Ce.extension);return Promise.resolve(He).catch(_e=>{(0,T.$4)(_e)||(this.l.error(`[${Ce.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ce.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),I.CancellationToken.isCancellationToken(re)?(0,P.$vh)(He,re):He}t(z,j){const Q=this.q();return this.f.set(Q,new ke(z,j)),Q}static u(z){return z.displayName||z.name}static w(z){return z.identifier.value}registerDocumentSymbolProvider(z,j,Q,V){const re=this.t(new p(this.h,Q),z),ge=V&&V.label||Pe.u(z);return this.e.$registerDocumentSymbolProvider(re,this.o(j,z),ge),this.p(re)}$provideDocumentSymbols(z,j,Q){return this.s(z,p,V=>V.provideDocumentSymbols(a.URI.revive(j),Q),void 0,Q)}registerCodeLensProvider(z,j,Q){const V=this.q(),re=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new ke(new m(this.h,this.j.converter,Q,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(V,this.o(j,z),re);let ge=this.p(V);if(re!==void 0){const Ce=Q.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(re));ge=n.$QN.from(ge,Ce)}return ge}$provideCodeLenses(z,j,Q){return this.s(z,m,V=>V.provideCodeLenses(a.URI.revive(j),Q),void 0,Q)}$resolveCodeLens(z,j,Q){return this.s(z,m,V=>V.resolveCodeLens(j,Q),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,m,Q=>Promise.resolve(Q.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,Q){const V=this.t(new E(this.h,Q),z);return this.e.$registerDefinitionSupport(V,this.o(j,z)),this.p(V)}$provideDefinition(z,j,Q,V){return this.s(z,E,re=>re.provideDefinition(a.URI.revive(j),Q,V),[],V)}registerDeclarationProvider(z,j,Q){const V=this.t(new D(this.h,Q),z);return this.e.$registerDeclarationSupport(V,this.o(j,z)),this.p(V)}$provideDeclaration(z,j,Q,V){return this.s(z,D,re=>re.provideDeclaration(a.URI.revive(j),Q,V),[],V)}registerImplementationProvider(z,j,Q){const V=this.t(new w(this.h,Q),z);return this.e.$registerImplementationSupport(V,this.o(j,z)),this.p(V)}$provideImplementation(z,j,Q,V){return this.s(z,w,re=>re.provideImplementation(a.URI.revive(j),Q,V),[],V)}registerTypeDefinitionProvider(z,j,Q){const V=this.t(new C(this.h,Q),z);return this.e.$registerTypeDefinitionSupport(V,this.o(j,z)),this.p(V)}$provideTypeDefinition(z,j,Q,V){return this.s(z,C,re=>re.provideTypeDefinition(a.URI.revive(j),Q,V),[],V)}registerHoverProvider(z,j,Q,V){const re=this.t(new R(this.h,Q),z);return this.e.$registerHoverProvider(re,this.o(j,z)),this.p(re)}$provideHover(z,j,Q,V,re){return this.s(z,R,ge=>ge.provideHover(a.URI.revive(j),Q,V,re),void 0,re)}$releaseHover(z,j){this.s(z,R,Q=>Promise.resolve(Q.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(z,j,Q,V){const re=this.t(new f(this.h,Q),z);return this.e.$registerEvaluatableExpressionProvider(re,this.o(j,z)),this.p(re)}$provideEvaluatableExpression(z,j,Q,V){return this.s(z,f,re=>re.provideEvaluatableExpression(a.URI.revive(j),Q,V),void 0,V)}registerInlineValuesProvider(z,j,Q,V){const re=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,Q),z);this.e.$registerInlineValuesProvider(ge,this.o(j,z),re);let Ce=this.p(ge);if(re!==void 0){const ze=Q.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(re));Ce=n.$QN.from(Ce,ze)}return Ce}$provideInlineValues(z,j,Q,V,re){return this.s(z,b,ge=>ge.provideInlineValues(a.URI.revive(j),Q,V,re),void 0,re)}registerDocumentHighlightProvider(z,j,Q){const V=this.t(new L(this.h,Q),z);return this.e.$registerDocumentHighlightProvider(V,this.o(j,z)),this.p(V)}registerMultiDocumentHighlightProvider(z,j,Q){const V=this.t(new N(this.h,Q),z);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(j,z)),this.p(V)}$provideDocumentHighlights(z,j,Q,V){return this.s(z,L,re=>re.provideDocumentHighlights(a.URI.revive(j),Q,V),void 0,V)}$provideMultiDocumentHighlights(z,j,Q,V,re){return this.s(z,N,ge=>ge.provideMultiDocumentHighlights(a.URI.revive(j),Q,V.map(Ce=>a.URI.revive(Ce)),re),void 0,re)}registerLinkedEditingRangeProvider(z,j,Q){const V=this.t(new M(this.h,Q),z);return this.e.$registerLinkedEditingRangeProvider(V,this.o(j,z)),this.p(V)}$provideLinkedEditingRanges(z,j,Q,V){return this.s(z,M,async re=>{const ge=await re.provideLinkedEditingRanges(a.URI.revive(j),Q,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe.y(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(z,j,Q){const V=this.t(new W(this.h,Q),z);return this.e.$registerReferenceSupport(V,this.o(j,z)),this.p(V)}$provideReferences(z,j,Q,V,re){return this.s(z,W,ge=>ge.provideReferences(a.URI.revive(j),Q,V,re),void 0,re)}registerCodeActionProvider(z,j,Q,V){const re=new O.$Uc,ge=this.t(new G(this.h,this.j.converter,this.k,Q,this.l,z,this.m),z);return this.e.$registerCodeActionSupport(ge,this.o(j,z),{providedKinds:V?.providedCodeActionKinds?.map(Ce=>Ce.value),documentation:V?.documentation?.map(Ce=>({kind:Ce.kind.value,command:this.j.converter.toInternal(Ce.command,re)}))},Pe.u(z),Pe.w(z),!!Q.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(z,j,Q,V,re){return this.s(z,G,ge=>ge.provideCodeActions(a.URI.revive(j),Q,V,re),void 0,re)}$resolveCodeAction(z,j,Q){return this.s(z,G,V=>V.resolveCodeAction(j,Q),{},void 0)}$releaseCodeActions(z,j){this.s(z,G,Q=>Promise.resolve(Q.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,Q){const V=this.t(new J(this.h,Q),z);return this.e.$registerDocumentFormattingSupport(V,this.o(j,z),z.identifier,z.displayName||z.name),this.p(V)}$provideDocumentFormattingEdits(z,j,Q,V){return this.s(z,J,re=>re.provideDocumentFormattingEdits(a.URI.revive(j),Q,V),void 0,V)}registerDocumentRangeFormattingEditProvider(z,j,Q){const V=typeof Q.provideDocumentRangesFormattingEdits=="function",re=this.t(new K(this.h,Q),z);return this.e.$registerRangeFormattingSupport(re,this.o(j,z),z.identifier,z.displayName||z.name,V),this.p(re)}$provideDocumentRangeFormattingEdits(z,j,Q,V,re){return this.s(z,K,ge=>ge.provideDocumentRangeFormattingEdits(a.URI.revive(j),Q,V,re),void 0,re)}$provideDocumentRangesFormattingEdits(z,j,Q,V,re){return this.s(z,K,ge=>ge.provideDocumentRangesFormattingEdits(a.URI.revive(j),Q,V,re),void 0,re)}registerOnTypeFormattingEditProvider(z,j,Q,V){const re=this.t(new oe(this.h,Q),z);return this.e.$registerOnTypeFormattingSupport(re,this.o(j,z),V,z.identifier),this.p(re)}$provideOnTypeFormattingEdits(z,j,Q,V,re,ge){return this.s(z,oe,Ce=>Ce.provideOnTypeFormattingEdits(a.URI.revive(j),Q,V,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(z,j){const Q=this.t(new me(j,this.l),z);return this.e.$registerNavigateTypeSupport(Q,typeof j.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(z,j,Q){return this.s(z,me,V=>V.provideWorkspaceSymbols(j,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(z,j,Q){return this.s(z,me,V=>V.resolveWorkspaceSymbol(j,Q),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,me,Q=>Q.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,Q){const V=this.t(new le(this.h,Q,this.l),z);return this.e.$registerRenameSupport(V,this.o(j,z),le.supportsResolving(Q)),this.p(V)}$provideRenameEdits(z,j,Q,V,re){return this.s(z,le,ge=>ge.provideRenameEdits(a.URI.revive(j),Q,V,re),void 0,re)}$resolveRenameLocation(z,j,Q,V){return this.s(z,le,re=>re.resolveRenameLocation(a.URI.revive(j),Q,V),void 0,V)}registerNewSymbolNamesProvider(z,j,Q){const V=this.t(new _(this.h,Q,this.l),z);return this.e.$registerNewSymbolNamesProvider(V,this.o(j,z)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this.s(z,_,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,j,Q,V,re){return this.s(z,_,ge=>ge.provideNewSymbolNames(a.URI.revive(j),Q,V,re),void 0,re)}registerDocumentSemanticTokensProvider(z,j,Q,V){const re=this.t(new pe(this.h,Q),z),ge=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(j,z),V,ge);let Ce=this.p(re);if(ge){const ze=Q.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(ge));Ce=n.$QN.from(Ce,ze)}return Ce}$provideDocumentSemanticTokens(z,j,Q,V){return this.s(z,pe,re=>re.provideDocumentSemanticTokens(a.URI.revive(j),Q,V),null,V)}$releaseDocumentSemanticTokens(z,j){this.s(z,pe,Q=>Q.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,Q,V){const re=this.t(new ae(this.h,Q),z);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(j,z),V),this.p(re)}$provideDocumentRangeSemanticTokens(z,j,Q,V){return this.s(z,ae,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(j),Q,V),null,V)}registerCompletionItemProvider(z,j,Q,V){const re=this.t(new Se(this.h,this.j.converter,Q,this.m,z),z);return this.e.$registerCompletionsProvider(re,this.o(j,z),V,Se.supportsResolving(Q),z.identifier),this.p(re)}$provideCompletionItems(z,j,Q,V,re){return this.s(z,Se,ge=>ge.provideCompletionItems(a.URI.revive(j),Q,V,re),void 0,re)}$resolveCompletionItem(z,j,Q){return this.s(z,Se,V=>V.resolveCompletionItem(j,Q),void 0,Q)}$releaseCompletionItems(z,j){this.s(z,Se,Q=>Q.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,Q,V){const re=new X(z,this.h,Q,this.j.converter),ge=this.t(re,z);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,z),re.supportsHandleEvents,l.$sn.toKey(z.identifier.value),V?.yieldTo?.map(Ce=>l.$sn.toKey(Ce))||[]),this.p(ge)}$provideInlineCompletions(z,j,Q,V,re){return this.s(z,Oe,ge=>ge.provideInlineCompletions(a.URI.revive(j),Q,V,re),void 0,re)}$provideInlineEdits(z,j,Q,V,re){return this.s(z,Oe,ge=>ge.provideInlineEdits(a.URI.revive(j),Q,V,re),void 0,re)}$handleInlineCompletionDidShow(z,j,Q,V){this.s(z,Oe,async re=>{re.handleDidShowCompletionItem(j,Q,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,Q,V,re){this.s(z,Oe,async ge=>{ge.handlePartialAccept(j,Q,V,re)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,Oe,async Q=>{Q.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,Q){const V=new B(z,this.h,Q,this.j.converter),re=this.t(V,z);return this.e.$registerInlineEditProvider(re,this.o(j,z),z.identifier),this.p(re)}$provideInlineEdit(z,j,Q,V){return this.s(z,B,re=>re.provideInlineEdits(a.URI.revive(j),Q,V),void 0,V)}$freeInlineEdit(z,j){this.s(z,B,async Q=>{Q.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,Q,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this.t(new ye(this.h,Q),z);return this.e.$registerSignatureHelpProvider(ge,this.o(j,z),re),this.p(ge)}$provideSignatureHelp(z,j,Q,V,re){return this.s(z,ye,ge=>ge.provideSignatureHelp(a.URI.revive(j),Q,V,re),void 0,re)}$releaseSignatureHelp(z,j){this.s(z,ye,Q=>Q.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,Q){const V=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new de(this.h,this.j.converter,Q,this.l,z),z);this.e.$registerInlayHintsProvider(re,this.o(j,z),typeof Q.resolveInlayHint=="function",V,Pe.u(z));let ge=this.p(re);if(V!==void 0){const Ce=Q.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(V));ge=n.$QN.from(ge,Ce)}return ge}$provideInlayHints(z,j,Q,V){return this.s(z,de,re=>re.provideInlayHints(a.URI.revive(j),Q,V),void 0,V)}$resolveInlayHint(z,j,Q){return this.s(z,de,V=>V.resolveInlayHint(j,Q),void 0,Q)}$releaseInlayHints(z,j){this.s(z,de,Q=>Q.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,Q){const V=this.t(new we(this.h,Q),z);return this.e.$registerDocumentLinkProvider(V,this.o(j,z),typeof Q.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(z,j,Q){return this.s(z,we,V=>V.provideLinks(a.URI.revive(j),Q),void 0,Q,j.scheme==="output")}$resolveDocumentLink(z,j,Q){return this.s(z,we,V=>V.resolveLink(j,Q),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,we,Q=>Q.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,Q){const V=this.t(new he(this.h,Q),z);return this.e.$registerDocumentColorProvider(V,this.o(j,z)),this.p(V)}$provideDocumentColors(z,j,Q){return this.s(z,he,V=>V.provideColors(a.URI.revive(j),Q),[],Q)}$provideColorPresentations(z,j,Q,V){return this.s(z,he,re=>re.provideColorPresentations(a.URI.revive(j),Q,V),void 0,V)}registerFoldingRangeProvider(z,j,Q){const V=this.q(),re=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new ke(new Z(this.h,Q),z)),this.e.$registerFoldingRangeProvider(V,this.o(j,z),z.identifier,re);let ge=this.p(V);if(re!==void 0){const Ce=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$QN.from(ge,Ce)}return ge}$provideFoldingRanges(z,j,Q,V){return this.s(z,Z,re=>re.provideFoldingRanges(a.URI.revive(j),Q,V),void 0,V)}registerSelectionRangeProvider(z,j,Q){const V=this.t(new x(this.h,Q,this.l),z);return this.e.$registerSelectionRangeProvider(V,this.o(j,z)),this.p(V)}$provideSelectionRanges(z,j,Q,V){return this.s(z,x,re=>re.provideSelectionRanges(a.URI.revive(j),Q,V),[],V)}registerCallHierarchyProvider(z,j,Q){const V=this.t(new be(this.h,Q),z);return this.e.$registerCallHierarchyProvider(V,this.o(j,z)),this.p(V)}$prepareCallHierarchy(z,j,Q,V){return this.s(z,be,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),Q,V)),void 0,V)}$provideCallHierarchyIncomingCalls(z,j,Q,V){return this.s(z,be,re=>re.provideCallsTo(j,Q,V),void 0,V)}$provideCallHierarchyOutgoingCalls(z,j,Q,V){return this.s(z,be,re=>re.provideCallsFrom(j,Q,V),void 0,V)}$releaseCallHierarchy(z,j){this.s(z,be,Q=>Promise.resolve(Q.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,Q){const V=this.t(new $e(this.h,Q),z);return this.e.$registerTypeHierarchyProvider(V,this.o(j,z)),this.p(V)}$prepareTypeHierarchy(z,j,Q,V){return this.s(z,$e,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),Q,V)),void 0,V)}$provideTypeHierarchySupertypes(z,j,Q,V){return this.s(z,$e,re=>re.provideSupertypes(j,Q,V),void 0,V)}$provideTypeHierarchySubtypes(z,j,Q,V){return this.s(z,$e,re=>re.provideSubtypes(j,Q,V),void 0,V)}$releaseTypeHierarchy(z,j){this.s(z,$e,Q=>Promise.resolve(Q.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,Q,V){const re=this.q();return this.f.set(re,new ke(new Ae(this.e,this.h,Q,re,z),z)),this.e.$registerDocumentOnDropEditProvider(re,this.o(j,z),(0,t.$iH)(z,"documentPaste")&&V?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(z,j,Q,V,re,ge){return this.s(z,Ae,Ce=>Promise.resolve(Ce.provideDocumentOnDropEdits(j,a.URI.revive(Q),V,re,ge)),void 0,void 0)}$resolveDropEdit(z,j,Q){return this.s(z,Ae,V=>V.resolveDropEdit(j,Q),{},void 0)}$releaseDocumentOnDropEdits(z,j){this.s(z,Ae,Q=>Promise.resolve(Q.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(z,j,Q){const V=this.t(new Ue(this.h,Q),z);return this.e.$registerMappedEditsProvider(V,this.o(j,z),z.displayName??z.name),this.p(V)}$provideMappedEdits(z,j,Q,V,re){return this.s(z,Ue,ge=>Promise.resolve(ge.provideMappedEdits(j,Q,V,re)),null,re)}registerDocumentPasteEditProvider(z,j,Q,V){const re=this.q();return this.f.set(re,new ke(new q(this.e,this.h,Q,re,z),z)),this.e.$registerPasteEditProvider(re,this.o(j,z),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(z,j,Q,V,re){return this.s(z,q,ge=>ge.prepareDocumentPaste(a.URI.revive(j),Q,V,re),void 0,re)}$providePasteEdits(z,j,Q,V,re,ge,Ce){return this.s(z,q,ze=>ze.providePasteEdits(j,a.URI.revive(Q),V,re,ge,Ce),void 0,Ce)}$resolvePasteEdit(z,j,Q){return this.s(z,q,V=>V.resolvePasteEdit(j,Q),{},void 0)}$releasePasteEdits(z,j){this.s(z,q,Q=>Promise.resolve(Q.releasePasteEdits(j)),void 0,void 0)}static y(z){return{pattern:z.source,flags:z.flags}}static z(z){return{decreaseIndentPattern:Pe.y(z.decreaseIndentPattern),increaseIndentPattern:Pe.y(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Pe.y(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Pe.y(z.unIndentedLinePattern):void 0}}static B(z){return{beforeText:Pe.y(z.beforeText),afterText:z.afterText?Pe.y(z.afterText):void 0,previousLineText:z.previousLineText?Pe.y(z.previousLineText):void 0,action:z.action}}static C(z){return z.map(Pe.B)}static D(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(z){return z.map(Pe.D)}setLanguageConfiguration(z,j,Q){const{wordPattern:V}=Q;if(V&&(0,k.$sf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(j,V):this.h.setWordDefinitionFor(j,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const re=this.q(),ge={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Pe.y(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Pe.z(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Pe.C(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Pe.E(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,j,ge),this.p(re)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Rpc=Pe}),define(Ne[244],Me([1,0,4,36,5,8]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,T=Ve(T);class A{constructor($){this.a=new Map,this.c=new Map,this.b=$.getProxy(I.$ON.MainThreadLanguageModelTools),this.b.$getTools().then(o=>{for(const k of o)this.c.set(k.name,(0,P.$di)(k))})}async invokeTool($,o,k){const y=await this.b.$invokeTool($,o,k);return T.LanguageModelToolResult.to(y)}async $acceptToolDelta($){$.added&&this.c.set($.added.name,$.added),$.removed&&this.c.delete($.removed)}get tools(){return Array.from(this.c.values()).map($=>T.LanguageModelToolDescription.to($))}async $invokeTool($,o,k){const y=this.a.get($);if(!y)throw new Error(`Unknown tool ${$}`);const a=await y.tool.invoke(o,k);return T.LanguageModelToolResult.from(a)}registerTool($,o,k){return this.a.set(o,{extension:$,tool:k}),this.b.$registerTool(o),(0,v.$Tc)(()=>{this.a.delete(o),this.b.$unregisterTool(o)})}}e.$jrc=A}),define(Ne[94],Me([1,0,10,21,42,13,6,40,4,9,18,3,11,76,5,90,16,8,7,118,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=e.$yqc=void 0,c=Ve(c),l=Ve(l),e.$yqc=(0,y.$Gi)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$0h,this.stream=E??new v.$0h}}class u{constructor(){this.a=new Map,this.b=new v.$0h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$7h.map(h.b.asyncIterable,E=>{if(E instanceof l.$$P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new l.$$P(h.part.value):D=new l.$0P(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let p=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new A.$me,this.d=new A.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new k.$un,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$ON.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,w){const C=t.a++;this.f.set(C,{extension:h.identifier,provider:D,languageModelId:E});let R;w.auth&&(R={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${k.$sn.toKey(h.identifier)}/${C}/${E}`,{extension:h.identifier,id:E,vendor:w.vendor??k.$sn.toKey(h.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:R,targetExtensions:w.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:L,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new k.$sn(b),L,N)});return(0,$.$Tc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),f?.dispose()})}async $startChatRequest(h,E,D,w,C,R){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const b=new S.$Dw(async N=>{if(R.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(N.part instanceof l.$0P?M={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$$P&&(M={type:"text",value:N.part.value}),!M){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:M})});let L;if(f.provider.provideLanguageModelResponse2)L=Promise.resolve(f.provider.provideLanguageModelResponse2(w.map(c.LanguageModelChatMessage.to),C,k.$sn.toKey(D),b,R));else{const N=new S.$Dw(async M=>{b.report({index:M.index,part:new l.$$P(M.part)})});L=Promise.resolve(f.provider.provideLanguageModelResponse(w.map(c.LanguageModelChatMessage.to),C?.modelOptions??{},k.$sn.toKey(D),N,R))}L.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,T.$2)(N))})}$provideTokenLength(h,E,D){const w=this.f.get(h);return w?Promise.resolve(w.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new k.$un});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,w]of this.i)w.languageModelId===E&&(w.res.reject(new T.$5),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),w=[],C=this;for(const R of D){const f=this.g.get(R);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let b=f.apiObjects.get(h.identifier);b||(b={id:R,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(L,N){if(!C.g.has(R))throw l.$cQ.NotFound(R);return C.r(R,L,N??P.CancellationToken.None)},sendRequest(L,N,M){if(!C.g.has(R))throw l.$cQ.NotFound(R);return C.l(h,R,L,N??{},M??P.CancellationToken.None)}},Object.freeze(b),f.apiObjects.set(h.identifier,b)),w.push(b)}return w}async l(h,E,D,w,C){const R=this.m(h,D),f=h.identifier,b=this.g.get(E)?.metadata;if(!b||!this.g.has(E))throw l.$cQ.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,b)&&(!await this.n(h,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get(f)?.has(b.extension)))throw l.$cQ.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const L=Math.random()*1e6|0,N=new u;this.i.set(L,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,L,R,w,C)}catch(M){throw this.i.delete(L),M}return N.apiObject}catch(L){throw L.name===l.$cQ.name?L:new l.$cQ(`Language model '${E}' errored: ${(0,I.$rj)(L)}`,"Unknown",L)}}m(h,E){const D=[];for(const w of E)w.role===l.LanguageModelChatMessageRole.System&&(0,n.$jH)(h,"languageModelSystem"),w.content2 instanceof l.$8P&&(0,n.$jH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(w));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,T.$3)(E)):D.res.resolve())}async n(h,E,D,w){const C=i.$QM+E.identifier.value;if(await this.k.getSession(h,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(w)return!1;try{const f=D?(0,o.localize)(2692,null,E.displayName,D):void 0;return await this.k.getSession(h,C,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!k.$sn.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw l.$cQ.NotFound(`Language model '${h}' is unknown.`);const C=O.Iterable.find(this.f.values(),R=>R.languageModelId===h);return C?C.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:w,enabled:C}of h){const R=this.h.get(D)??new k.$tn;if(R.has(w)!==C){C?R.add(w):R.delete(w),this.h.set(D,R);const b={from:D,to:w};E.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=A.Event.signal(A.Event.filter(this.c.event,C=>k.$sn.equals(C.from,h.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,w)},canSendRequest(C){let R;e:for(const[b,L]of E.g)for(const N of L.apiObjects.values())if(N===C){R=L.metadata;break e}if(!R)return;if(!E.o(h.identifier,R))return!0;const f=E.h.get(h.identifier);if(f)return f.has(R.extension)}}}};e.$zqc=p,e.$zqc=p=t=Je([We(0,s.$oQ),We(1,a.$bk),We(2,r.$Tpc)],p)});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[245],Me([1,0,5,8,7,35,10,4,24]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,P=Ve(P),T=_t(T);class o{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$ON.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=P.Position.from(a),r=await this.a.$tokensAtPosition(y.uri,d),s={type:I.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new I.$SN(a.line,a.character,a.line,a.character)};if(!r)return s;const c={range:P.Range.to(r.range),type:P.TokenType.to(r.type)};return!c.range.contains(a)||S!==y.version?s:c}createLanguageStatusItem(y,a,S){const d=this.f++,r=this.a,s=this.g,c=`${y.identifier.value}/${a}`;if(s.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);s.add(c);const l={selector:S,id:a,name:y.displayName??y.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new O.$Uc,t=()=>{if(i?.dispose(),!s.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Ih)(()=>{n.clear(),this.a.$setLanguageStatus(d,{id:c,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:P.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===I.LanguageStatusSeverity.Error?T.default.Error:l.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:l.command&&this.d.toInternal(l.command,n),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(d),s.delete(c)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,$.$jH)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,$.$jH)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$krc=o}),define(Ne[246],Me([1,0,15,2,8,7,89]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=void 0,I=Ve(I),A=Ve(A);class O{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new T.$iP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=P.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(I.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(I.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(I.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===y);if(r&&(a||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(s=>A.$QL(s.mime)))){const s=new Map,c=[];r.items.forEach(l=>{let i;s.has(l.mime)?i=s.get(l.mime):(i=[],s.set(l.mime,i),c.push(l.mime)),i.push(l.data)}),r.items.length=0,c.forEach(l=>{const i=A.$RL(s.get(l));r.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$8qc=$;class o{static{this.a=0}constructor(y,a,S,d,r){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=o.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(r=>r.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},r=[];for(const c of y.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const s=new Map;for(let c=0;c<r.length;c++){const l=r[c],i=s.get(l.cell);if(i===void 0){const n=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});s.set(l.cell,n-1)}else d.cellChanges[i]={...d.cellChanges[i],...l}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],r=[],s=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const u=new $(this,this.l,g);return a||r.push($.asModelAddData(g)),u}),n=new O(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)s.push(g.uri),n.deletedItems.push(g.apiCell);d.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const r=this.b.splice(y,a);this.b.splice(S,0,...r);const s=[new O(y,a,r.map(c=>c.apiCell),[]),new O(S,0,[],r)];for(const c of s)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$9qc=o}),define(Ne[247],Me([1,0,6,2,8,7,39]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0;class O{constructor(o,k,y,a={timeout:1500,errors:3}){this.b=o,this.c=k,this.d=y,this.f=a,this.a=new v.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(o){return(k,y,a)=>{const S=function(r){k.call(y,r)};return S.extension=o,this.a.event(S,void 0,a)}}async $participateInSave(o,k,y){const a=P.URI.revive(o),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:I.TextDocumentSaveReason.to(k)},y,async(s,c)=>{const l=Date.now(),i=await await Promise.resolve(s);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof T.$3N?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const s of d){const{edits:c}=I.WorkspaceEdit.from(s);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new A.$2w(r))}}e.$mrc=O}),define(Ne[125],Me([1,0,13,8,7]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,P=Ve(P),I=Ve(I);class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,$,o,k,y,a){this.id=O,this.f=$,this.notebookData=o,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=k,this.c=a}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection($){this.selections=[$]},get selections(){return O.a},set selections($){if(!Array.isArray($)||!$.every(I.$iP.isNotebookRange))throw(0,v.$7)("selections");O.a=$,O.g($)},get visibleRanges(){return O.b},revealRange($,o){O.f.$tryRevealRange(O.id,P.NotebookRange.from($),o??I.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(P.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$0qc=T}),define(Ne[248],Me([1,0,6,11,8]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=void 0,I=Ve(I);let T=class{constructor(O,$){this.c=O,this.d=$,this.a=new v.$me,this.b=new v.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,$);const o=this.d.getEditorById(O);$.visibleRanges&&o._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&o._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:o.apiEditor,visibleRanges:o.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:o.apiEditor,selections:o.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const $ in O)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(O[$]))}};e.$orc=T,e.$orc=T=Je([We(0,P.$bk)],T)}),define(Ne[249],Me([1,0,6,5,125]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;class T{constructor(O,$){this.c=$,this.a=new Map,this.b=O.getProxy(P.$ON.MainThreadNotebookRenderers)}$postRendererMessage(O,$,o){const k=this.c.getEditorById(O);this.a.get($)?.fire({editor:k.apiEditor,message:o})}createRendererMessaging(O,$){if(!O.contributes?.notebookRenderer?.some(k=>k.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(k,y,a)=>this.d($).event(k,y,a),postMessage:(k,y)=>{I.$0qc.apiEditorsToExtHost.has(k)&&([k,y]=[y,k]);const a=y&&I.$0qc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,$,k)}}}d(O){let $=this.a.get(O);return $||($=new v.$me({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(O)}}),this.a.set(O,$),$)}}e.$rrc=T}),define(Ne[250],Me([1,0,8,76,21,71,13]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0;class O{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:r,location:s,cancellable:c}=a,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(s),title:r,source:l,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$1),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new I.$xe,this.c.set(y,d));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let s;try{s=a(new o(this.a,y),S&&d?d.token:I.CancellationToken.None)}catch(c){throw r(y),c}return s.then(c=>r(y),c=>r(y)),s}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$vrc=O;function $(k,y){return k.message=y.message,typeof y.increment=="number"&&(typeof k.increment=="number"?k.increment+=y.increment:k.increment=y.increment),k}class o extends P.$Dw{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,T.$ai)(100,(k,y)=>$(k,y),()=>Object.create(null))],o.prototype,"throttledReport",null)}),define(Ne[251],Me([1,0,2,5,10,8]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;class A{static{this.a=0}constructor($,o){this.d=o,this.c=new Map,this.b=$.getProxy(P.$ON.MainThreadQuickDiff)}$provideOriginalResource($,o,k){const y=v.URI.revive(o),a=this.c.get($);return a?(0,I.$yh)(()=>a.provideOriginalResource(y,k)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,o,k,y){const a=A.a++;return this.c.set(a,o),this.b.$registerQuickDiffProvider(a,T.DocumentSelector.from($,this.d),k,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$wrc=A});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[252],Me([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=d,k=_t(k);function d(r,s,c){const l=r.getProxy(T.$ON.MainThreadQuickOpen);class i{constructor(D,w){this.e=new Map,this.f=0,this.a=D,this.b=w}showQuickPick(D,w,C,R=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(w),b=++this.f,L=l.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},R),N={},M=L.then(()=>N);return Promise.race([M,f]).then(W=>{if(W===N)return;const G=(0,a.$iH)(D,"quickPickItemTooltip");return f.then(q=>{const J=[];for(let K=0;K<q.length;K++){const oe=q[K];if(typeof oe=="string")J.push({label:oe,handle:K});else if(oe.kind===O.QuickPickItemKind.Separator)J.push({type:"separator",label:oe.label});else{oe.tooltip&&!G&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const me=oe.iconPath?p(oe.iconPath):void 0;J.push({label:oe.label,iconPath:me?.iconPath,iconClass:me?.iconClass,description:oe.description,detail:oe.detail,picked:oe.picked,alwaysShow:oe.alwaysShow,tooltip:G?S.MarkdownString.fromStrict(oe.tooltip):void 0,handle:K})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=K=>{C.onDidSelectItem(q[K])}),l.$setItems(b,J),L.then(K=>{if(typeof K=="number")return q[K];if(Array.isArray(K))return K.map(oe=>q[oe])})})}).then(void 0,W=>{if(!(0,$.$4)(W))return l.$setError(b,W),Promise.reject(W)})}$onItemSelected(D){this.c?.(D)}showInput(D,w=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",w).then(void 0,C=>{if(!(0,$.$4)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const w=await this.d(D);if(!w||typeof w=="string")return w;let C;switch(w.severity){case O.InputBoxValidationSeverity.Info:C=k.default.Info;break;case O.InputBoxValidationSeverity.Warning:C=k.default.Warning;break;case O.InputBoxValidationSeverity.Error:C=k.default.Error;break;default:C=w.message?k.default.Error:k.default.Ignore;break}return{content:w.message,severity:C}}async showWorkspaceFolderPick(D,w=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const R=await this.a.getWorkspaceFolders2();if(R)return R.find(f=>f.uri.toString()===C.uri.toString())}createQuickPick(D){const w=new m(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(D){const w=new h(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(D,w){this.e.get(D)?._fireDidChangeValue(w)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,w){const C=this.e.get(D);C instanceof m&&C._fireDidChangeActive(w)}$onDidChangeSelection(D,w){const C=this.e.get(D);C instanceof m&&C._fireDidChangeSelection(w)}$onDidTriggerButton(D,w){this.e.get(D)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(D,w,C){const R=this.e.get(D);R instanceof m&&R._fireDidTriggerItemButton(w,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class n{static{this.a=1}constructor(D,w){this.x=D,this.y=w,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.$me,this.q=new P.$me,this.r=new P.$me,this.s=new P.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const w=(0,a.$iH)(this.x,"quickInputButtonLocation");!w&&D.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((C,R)=>{const f=C===O.$fP.Back?-1:R;this.o.set(f,C)}),this.z({buttons:D.map((C,R)=>({...p(C.iconPath),tooltip:C.tooltip,handle:C===O.$fP.Back?-1:R,location:w?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const w=this.o.get(D);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const w of Object.keys(D)){const C=D[w];this.u[w]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof O.$PO)return{id:E.id};const D=u(E),w=g(E);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof w=="string"?A.URI.file(w):w}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function p(E){const D=t(E);let w,C;return"id"in D?C=y.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:C}}class m extends n{constructor(D,w){super(D,w),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.$me,this.L=[],this.M=new P.$me,this.N=new P.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((R,f)=>{this.C.set(f,R),this.D.set(R,f)});const w=(0,a.$iH)(this.x,"quickPickItemTooltip"),C=[];for(let R=0;R<D.length;R++){const f=D[R];if(f.kind===O.QuickPickItemKind.Separator)C.push({type:"separator",label:f.label});else{f.tooltip&&!w&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=f.iconPath?p(f.iconPath):void 0;C.push({handle:R,label:f.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:w?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((L,N)=>({...p(L.iconPath),tooltip:L.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(D){const w=(0,o.$Hb)(D.map(C=>this.C.get(C)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(D){const w=(0,o.$Hb)(D.map(C=>this.C.get(C)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(D,w){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const R=C.buttons[w];R&&this.N.fire({button:R,item:C})}}class h extends n{constructor(D,w){super(D,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:k.default.Error}):this.z({validationMessage:D.message,severity:D.severity??k.default.Error}):this.z({validationMessage:void 0,severity:k.default.Ignore})}}return new i(s,c)}}),define(Ne[253],Me([1,0,2,6,71,4,10,5,17,146,11,18,37,34,8,24,15,20]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$zrc=e.$yrc=void 0;function i(N){return N instanceof v.URI}function n(N,M){return N.scheme===s.Schemas.file&&M.scheme===s.Schemas.file&&c.$l?N.toString()===M.toString():N.toString().toLowerCase()===M.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const M=N;return{light:M.light,dark:M.dark}}}else return}function u(N){const M=g(N.icon),W=N.labels?.map(G=>({title:G.title,icon:g(G.icon)}));return{...N,icon:M,labels:W}}function p(N,M){if(!N.iconPath&&!M.iconPath)return 0;if(N.iconPath){if(!M.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,G=typeof M.iconPath=="string"?M.iconPath:v.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,o.$Nr)(W,G)}function m(N,M){let W=0;if(N.strikeThrough!==M.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==M.faded)return N.faded?1:-1;if(N.tooltip!==M.tooltip)return(N.tooltip||"").localeCompare(M.tooltip||"");if(W=p(N,M),W!==0)return W;if(N.light&&M.light)W=p(N.light,M.light);else{if(N.light)return 1;if(M.light)return-1}if(W!==0)return W;if(N.dark&&M.dark)W=p(N.dark,M.dark);else{if(N.dark)return 1;if(M.dark)return-1}return W}function h(N,M){if(N.command!==M.command)return N.command<M.command?-1:1;if(N.title!==M.title)return N.title<M.title?-1:1;if(N.tooltip!==M.tooltip){if(N.tooltip!==void 0&&M.tooltip!==void 0)return N.tooltip<M.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(N.arguments===M.arguments)return 0;if(N.arguments)if(M.arguments){if(N.arguments.length!==M.arguments.length)return N.arguments.length-M.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const G=N.arguments[W],q=M.arguments[W];if(G!==q&&!(i(G)&&i(q)&&n(G,q)))return G<q?-1:1}return 0}function E(N,M){let W=(0,o.$Nr)(N.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&M.command)W=h(N.command,M.command);else{if(N.command)return 1;if(M.command)return-1}if(W!==0)return W;if(N.decorations&&M.decorations)W=m(N.decorations,M.decorations);else{if(N.decorations)return 1;if(M.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)W=(0,o.$Nr)(N.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)W=(0,o.$Nr)(N.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return W}function D(N,M){for(let W=0;W<N.length;W++)if(N[W]!==M[W])return!1;return!0}function w(N,M){return N.command===M.command&&N.title===M.title&&N.tooltip===M.tooltip&&(N.arguments&&M.arguments?D(N.arguments,M.arguments):N.arguments===M.arguments)}function C(N,M){return(0,$.$ub)(N,M,w)}class R{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.m,M),this.o(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.m,M),this.f=M}get validateInput(){return(0,r.$jH)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,r.$jH)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.m,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.m,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.m,M))}get document(){return(0,r.$jH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(M,W,G,q,J){this.k=M,this.m=q,this.n=J,this.d="",this.e=new P.$me,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=G}showValidationMessage(M,W){(0,r.$jH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,M,W)}$onInputBoxValueChange(M){this.o(M)}o(M){this.d=M,this.e.fire(M)}}e.$yrc=R;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(M){this.w=M,this.s.$updateGroupLabel(this.u,this.handle,M)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(M){this.q=M,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,W,G,q,J,K,oe){this.s=M,this.t=W,this.u=G,this.v=q,this.w=J,this.multiDiffEditorEnableViewChanges=K,this.x=oe,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new P.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,W){const G=this.h.get(M);return G?(0,A.$yh)(()=>this.t.executeCommand(G.command,...G.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(E),G=(0,$.$Db)(this.p,M,E).map(K=>{const oe=K.toInsert.map(me=>{const le=this.e++;this.g.set(le,me);const _=me.resourceUri;let ce;if(me.command)if(me.command.command==="vscode.open"||me.command.command==="vscode.diff"||me.command.command==="vscode.changes"){const x=new T.$Uc;ce=this.t.converter.toInternal(me.command,x),this.j.set(le,x)}else this.h.set(le,me.command);const pe=(0,r.$iH)(this.x,"scmMultiDiffEditor"),ae=pe?me.multiDiffEditorOriginalUri:void 0,Se=pe?me.multiFileDiffEditorModifiedUri:void 0,Oe=t(me.decorations),X=me.decorations&&t(me.decorations.light)||Oe,B=me.decorations&&t(me.decorations.dark)||Oe,te=[X,B],ye=me.decorations&&me.decorations.tooltip||"",de=me.decorations&&!!me.decorations.strikeThrough,we=me.decorations&&!!me.decorations.faded,he=me.contextValue||"";return{rawResource:[le,_,te,ye,de,we,he,ce,ae,Se],handle:le}});return{start:K.start,deleteCount:K.deleteCount,toInsert:oe}}),q=G.map(({start:K,deleteCount:oe,toInsert:me})=>[K,oe,me.map(le=>le.rawResource)]),J=G.reverse();for(const{start:K,deleteCount:oe,toInsert:me}of J){const le=me.map(ce=>ce.handle),_=this.o.splice(K,oe,...le);for(const ce of _)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=M,q}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let W;(0,r.$iH)(this.y,"quickDiffProvider")&&(W=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:W})}get historyProvider(){return(0,r.$jH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,r.$jH)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new T.$Uc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.m=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new T.$Uc,this.p=M;const W=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,r.$jH)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,r.$jH)(this.y,"scmActionButton"),this.q.value=new T.$Uc,this.s=M;const W=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(G=>G.map(q=>this.z.converter.toInternal(q,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&C(this.u,M))return;this.t.value=new T.$Uc,this.u=M;const W=(M||[]).map(G=>this.z.converter.toInternal(G,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(M,W,G,q,J,K,oe){this.y=M,this.z=q,this.A=J,this.B=K,this.C=oe,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Wc,this.n=void 0,this.o=new T.$Wc,this.p=void 0,this.q=new T.$Wc,this.t=new T.$Wc,this.u=void 0,this.v=!1,this.w=new P.$me,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=G;const me=v.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${J}/scm${this.x}/input`,query:oe?`rootUri=${encodeURIComponent(oe.toString())}`:void 0});this.f=new R(M,W,this.#e,this.x,me),this.#e.$registerSourceControl(this.x,J,K,oe,me)}createResourceGroup(M,W,G){const q=(0,r.$iH)(this.y,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,J=new f(this.#e,this.z,this.x,M,W,q,this.y),K=P.Event.once(J.onDidDispose)(()=>this.D.delete(J));return this.D.set(J,K),this.eventuallyAddResourceGroups(),J}eventuallyAddResourceGroups(){const M=[],W=[];for(const[G,q]of this.D){q.dispose();const J=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});P.Event.once(G.onDidDispose)(()=>{this.E.delete(G),J.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.x,G.handle)}),M.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const K=G._takeResourceStateSnapshot();K.length>0&&W.push([G.handle,K]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.x,M,W),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(W=>{const G=W._takeResourceStateSnapshot();G.length!==0&&M.push([W.handle,G])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,I.$_h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$_h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let L=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(M,W,G,q){this.m=W,this.n=G,this.o=q,this.g=new Map,this.h=new y.$un,this.j=new P.$me,this.e=M.getProxy(O.$ON.MainThreadSCM),this.f=M.getProxy(O.$ON.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:J=>{if(J&&J.$mid===a.MarshalledId.ScmResource){const K=this.g.get(J.sourceControlHandle);if(!K)return J;const oe=K.getResourceGroup(J.groupHandle);return oe?oe.getResourceState(J.handle):J}else if(J&&J.$mid===a.MarshalledId.ScmResourceGroup){const K=this.g.get(J.sourceControlHandle);return K?K.getResourceGroup(J.groupHandle):J}else if(J&&J.$mid===a.MarshalledId.ScmProvider){const K=this.g.get(J.handle);return K||J}return J}})}createSourceControl(M,W,G,q){this.o.trace("ExtHostSCM#createSourceControl",M.identifier.value,W,G,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const J=l.d++,K=new b(M,this.n,this.e,this.m,W,G,q);this.g.set(J,K);const oe=this.h.get(M.identifier)||[];return oe.push(K),this.h.set(M.identifier,oe),K}getLastInputBox(M){this.o.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const W=this.h.get(M.identifier),G=W&&W[W.length-1];return G&&G.inputBox}$provideOriginalResource(M,W,G){const q=v.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",M,q.toString());const J=this.g.get(M);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$yh)(()=>J.quickDiffProvider.provideOriginalResource(q,G)).then(K=>K||null)}$onInputBoxValueChange(M,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",M);const G=this.g.get(M);return G&&G.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(M,W,G,q){this.o.trace("ExtHostSCM#$executeResourceCommand",M,W,G);const J=this.g.get(M);if(!J)return Promise.resolve(void 0);const K=J.getResourceGroup(W);return K?K.$executeResourceCommand(G,q):Promise.resolve(void 0)}$validateInput(M,W,G){this.o.trace("ExtHostSCM#$validateInput",M);const q=this.g.get(M);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$yh)(()=>q.inputBox.validateInput(W,G)).then(J=>{if(!J)return Promise.resolve(void 0);const K=d.MarkdownString.fromStrict(J.message);return K?Promise.resolve([K,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,W,G,q){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,G,q)??void 0}async $resolveHistoryItemGroupCommonAncestor2(M,W,G){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,G)??void 0}async $provideHistoryItems(M,W,G,q){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(W,G,q))?.map(oe=>u(oe))??void 0}async $provideHistoryItems2(M,W,G){return(await this.g.get(M)?.historyProvider?.provideHistoryItems2(W,G))?.map(K=>u(K))??void 0}async $provideHistoryItemSummary(M,W,G,q){const J=this.g.get(M)?.historyProvider;if(typeof J?.provideHistoryItemSummary!="function")return;const K=await J.provideHistoryItemSummary(W,G,q);return K?u(K):void 0}async $provideHistoryItemChanges(M,W,G,q){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(W,G,q)??void 0}};e.$zrc=L,e.$zrc=L=l=Je([We(3,k.$bk)],L)}),define(Ne[254],Me([1,0,5,8,2]),function(ve,e,v,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=void 0;class T{static{this.a=0}constructor(O,$){this.d=$,this.c=new Map,this.b=O.getProxy(v.$ON.MainThreadShare)}async $provideShare(O,$,o){return await this.c.get(O)?.provideShare({selection:P.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},o)??void 0}registerShareProvider(O,$){const o=T.a++;return this.c.set(o,$),this.b.$registerShareProvider(o,P.DocumentSelector.from(O,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(o),this.c.delete(o)}}}}e.$Arc=T}),define(Ne[255],Me([1,0,7,5,9,4,8,14]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$QO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$QO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,r,s,c=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new T.$Uc,this.#e=a,this.#t=S,s&&r){this.c=(0,v.$sO)(r.identifier,s);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=r,this.f=s,this.g=c,this.h=this.u(l)}u(a){if((0,O.$jg)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!$.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new T.$Uc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,I.localize)(2698,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,r,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Crc=$;class o{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(2699,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$QN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class k{constructor(a,S){this.e=new Map,this.a=a.getProxy(P.$ON.MainThreadStatusBar),this.b=S,this.c=new o(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,r){return new $(this.a,this.b,this.e,a,S,d,r)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let r;return typeof S=="number"?r=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$QN(()=>{d.dispose(),clearTimeout(r)})}}e.$Drc=k}),define(Ne[126],Me([1,0,32,117,54,81,55,8,2]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=e.$BQ=e.$AQ=void 0,v=Ve(v),O=Ve(O);const o=(i,n,t,g)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(p){if(!t(u,p)){const m=u;u=p,i.listener?.(g(p,m))}}}},k=(i,n)=>i===n,y={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(g=>t.id===g.id)))},a=i=>n=>({op:T.TestItemEventOp.SetProp,update:i(n)}),S=(i,n)=>({range:(()=>{let t;const g=a(u=>({range:v.$Rt.lift(O.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:T.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:o(i,n,y.label,a(t=>({label:t}))),description:o(i,void 0,y.description,a(t=>({description:t}))),sortText:o(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:o(i,!1,y.canResolveChildren,t=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(i,!1,y.busy,a(t=>({busy:t}))),error:o(i,void 0,y.error,a(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:o(i,[],y.tags,(t,g)=>({op:T.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:g.map(O.TestTag.from)}))}),d=i=>{const n=I.$$I.fromString(i.extId),t=new s(n.controllerId,n.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>O.TestTag.to({id:(0,A.$eJ)(g).tagId})),t},r=i=>{let n;for(const t of i.tests){const g=d(t.item);(0,P.$kQ)(g).parent=n,n=g}return n};e.$AQ=r;class s{constructor(n,t,g,u){if(t.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const p=(0,P.$jQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof c?void 0:p.parent}},children:{value:(0,T.$iQ)(p,P.$kQ,s),enumerable:!0,writable:!1},...S(p,g)})}}e.$BQ=s;class c extends s{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$CQ=c;class l extends T.$eQ{constructor(n,t,g){super({controllerId:n,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:P.$kQ,getChildren:u=>u.children,root:new c(n,t),toITestItem:O.TestItem.from})}}e.$DQ=l}),define(Ne[33],Me([1,0,14,7,8,25,5,17,11,36,32,101,2,4,3,16,126,22,39,42,69,63,66,38]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=e.$MQ=e.$LQ=e.$KQ=e.$JQ=void 0,P=Ve(P),I=Ve(I);let p=class{#e;#t;#i;constructor(C,R,f){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$ON.MainThreadCommands),this.d=R,this.#i=f,this.#t=C.getProxy(A.$ON.MainThreadTelemetry),this.converter=new m(this,b=>{const L=this.c.get(b);return L?.result===E.Void?L:void 0},R),this.f=[{processArgument(b){return(0,o.$di)(b)}},{processArgument(b){return(0,T.$ho)(b,function(L){if(k.$Rt.isIRange(L))return I.Range.to(L);if(y.$Qt.isIPosition(L))return I.Position.to(L);if(k.$Rt.isIRange(L.range)&&a.URI.isUri(L.uri))return I.location.to(L);if(L instanceof c.$Oe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const R=this.registerCommand(!1,C.id,async(...f)=>{const b=C.args.map((N,M)=>{if(!N.validate(f[M]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof f[M]=="object"?JSON.stringify(f[M],null,"	"):f[M]} `);return N.convert(f[M])}),L=await this.executeCommand(C.internalId,...b);return C.result.convert(L,f,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new P.$QN(()=>{R.dispose(),this.c.delete(C.id)})}registerCommand(C,R,f,b,L,N){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:f,thisArg:b,metadata:L,extension:N}),C&&this.#e.$registerCommand(R),new P.$QN(()=>{this.b.delete(R)&&C&&this.#e.$unregisterCommand(R)})}executeCommand(C,...R){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,R,!0)}async g(C,R,f){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,R,!1);{let b=!1;const L=(0,T.$ho)(R,function(N){if(N instanceof P.$RN)return I.Position.from(N);if(N instanceof P.$SN)return I.Range.from(N);if(N instanceof P.$5N)return I.location.from(N);if(P.$iP.isNotebookRange(N))return I.NotebookRange.from(N);if(N instanceof ArrayBuffer)return b=!0,c.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return b=!0,c.$Oe.wrap(N);if(N instanceof c.$Oe)return b=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,b?new l.$2w(L):L,f);return(0,o.$di)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,R,!1);throw N}}}async h(C,R,f){const b=this.b.get(C);if(!b)throw new Error("Unknown command");const{callback:L,thisArg:N,metadata:M}=b;if(M?.args)for(let G=0;G<M.args.length;G++)try{(0,v.$wg)(R[G],M.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${M.args[G].name}' - ${M.args[G].description}`)}const W=n.$ge.create();try{return await L.apply(N,R)}catch(G){if(C===this.converter.delegatingCommandId){const q=this.converter.getActualCommand(...R);q&&(C=q.command)}if(this.d.error(G,C,b.extension?.identifier),!f)throw G;if(b.extension?.identifier){const q=this.#i.onExtensionError(b.extension.identifier,G);this.d.trace("forwarded error to extension?",q,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$rj)(G)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,C,W.elapsed())}}j(C,R,f){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$yp(R),duration:f})}$executeContributedCommand(C,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const f=this.b.get(C);return f?(R=R.map(b=>this.f.reduce((L,N)=>N.processArgument(L,f.extension?.identifier),b)),this.h(C,R,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(R=>(C&&(R=R.filter(f=>f[0]!=="_")),R))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[R,f]of this.b){const{metadata:b}=f;b&&(C[R]=b)}return Promise.resolve(C)}};e.$JQ=p,e.$JQ=p=Je([We(0,r.$oQ),We(1,$.$bk),We(2,g.$IQ)],p),e.$KQ=(0,d.$Gi)("IExtHostCommands");class m{constructor(C,R,f){this.d=C,this.f=R,this.g=f,this.delegatingCommandId=`__vsc${(0,u.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,R){if(!C)return;const f={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return f;const b=this.f(C.command);if(b)f.id=b.internalId,f.arguments=b.args.map((L,N)=>L.convert(C.arguments&&C.arguments[N]));else if((0,O.$Lb)(C.arguments)){const L=`${C.command} /${++this.c}`;this.b.set(L,C),R.add((0,S.$Tc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),f.$ident=L,f.id=this.delegatingCommandId,f.arguments=[L],this.g.trace("CommandsConverter#CREATE",C.command,L)}return f}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const R=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$LQ=m;class h{static{this.Uri=new h("uri","Uri of a text document",C=>a.URI.isUri(C),C=>C)}static{this.Position=new h("position","A position in a text document",C=>P.$RN.isPosition(C),I.Position.from)}static{this.Range=new h("range","A range in a text document",C=>P.$SN.isRange(C),I.Range.from)}static{this.Selection=new h("selection","A selection in a text document",C=>P.$TN.isSelection(C),I.Selection.from)}static{this.Number=new h("number","",C=>typeof C=="number",C=>C)}static{this.String=new h("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=h.Arr(h.String)}static Arr(C){return new h(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,R=>Array.isArray(R)&&R.every(f=>C.validate(f)),R=>R.map(f=>C.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",C=>C instanceof P.$eO,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",C=>C instanceof P.$DP,I.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",C=>C instanceof s.$BQ,I.TestItem.from)}constructor(C,R,f,b){this.name=C,this.description=R,this.validate=f,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,R){return new h(C??this.name,R??this.description,this.validate,this.convert)}}e.$MQ=h;class E{static{this.Void=new E("no result",C=>C)}constructor(C,R){this.description=C,this.convert=R}}e.$NQ=E;class D{constructor(C,R,f,b,L){this.id=C,this.internalId=R,this.description=f,this.args=b,this.result=L}}e.$OQ=D}),define(Ne[256],Me([1,0,17,15,2,93,103,31,33,8,7]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,T=Ve(T),o=Ve(o),k=Ve(k);const y=[new $.$OQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of DocumentHighlight-instances.",S(o.DocumentHighlight.to))),new $.$OQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$MQ.Uri],new $.$NQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,v.$Kb)(r))return;class c extends k.$_N{static to(i){const n=new c(i.name,o.SymbolKind.to(i.kind),i.containerName||"",new k.$5N(s[0],o.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=o.Range.to(i.selectionRange),n.children=i.children?i.children.map(c.to):[],n}}return r.map(c.to)})),new $.$OQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$MQ.Uri,new $.$MQ("options","Formatting options",r=>!0,r=>r)],new $.$NQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new $.$OQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$MQ.Uri,$.$MQ.Range,new $.$MQ("options","Formatting options",r=>!0,r=>r)],new $.$NQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new $.$OQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$MQ.Uri,$.$MQ.Position,new $.$MQ("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$MQ("options","Formatting options",r=>!0,r=>r)],new $.$NQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new $.$OQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$OQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new $.$OQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new $.$OQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new $.$OQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new $.$OQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$MQ.Uri,new $.$MQ("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>k.$RN.isPosition(s)),r=>r.map(o.Position.from))],new $.$NQ("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const l of s.reverse())c=new k.$dO(o.Range.to(l),c);return c}))),new $.$OQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$MQ.String.with("query","Search string")],new $.$NQ("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(o.WorkspaceSymbol.to))),new $.$OQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(o.CallHierarchyItem.to))),new $.$OQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$MQ.CallHierarchyItem],new $.$NQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(o.CallHierarchyIncomingCall.to))),new $.$OQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$MQ.CallHierarchyItem],new $.$NQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(o.CallHierarchyOutgoingCall.to))),new $.$OQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:o.Range.to(r.range),placeholder:r.text}})),new $.$OQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$MQ.Uri,$.$MQ.Position,$.$MQ.String.with("newName","The new symbol name")],new $.$NQ("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return o.WorkspaceEdit.to(r)}})),new $.$OQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$MQ.Uri,$.$MQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$NQ("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(o.DocumentLink.to))),new $.$OQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$MQ.Uri],new $.$NQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.$_O(r.tokenTypes,r.tokenModifiers)})),new $.$OQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$MQ.Uri],new $.$NQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$4db)(r);if(s.type==="full")return new k.$bP(s.data,void 0)})),new $.$OQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$MQ.Uri,$.$MQ.Range.optional()],new $.$NQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new k.$_O(r.tokenTypes,r.tokenModifiers)})),new $.$OQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$MQ.Uri,$.$MQ.Range],new $.$NQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$4db)(r);if(s.type==="full")return new k.$bP(s.data,void 0)})),new $.$OQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$MQ.Uri,$.$MQ.Position,$.$MQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$MQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$NQ("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new k.$pO([]);const l=r.suggestions.map(i=>o.CompletionItem.to(i,c));return new k.$pO(l,r.incomplete)})),new $.$OQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$MQ.Uri,$.$MQ.Position,$.$MQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$NQ("A promise that resolves to SignatureHelp.",r=>{if(r)return o.SignatureHelp.to(r)})),new $.$OQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$MQ.Uri,$.$MQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$NQ("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>S(l=>new k.$hO(o.Range.to(l.range),l.command&&c.fromInternal(l.command)))(r))),new $.$OQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$MQ.Uri,new $.$MQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>k.$SN.isRange(r),r=>k.$TN.isSelection(r)?o.Selection.from(r):o.Range.from(r)),$.$MQ.String.with("kind","Code action kind to return code actions for").optional(),$.$MQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$NQ("A promise that resolves to an array of Command-instances.",(r,s,c)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const i=new k.$bO(l.title,l.kind?new k.$cO(l.kind):void 0);return l.edit&&(i.edit=o.WorkspaceEdit.to(l.edit)),l.command&&(i.command=c.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(r))),new $.$OQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$MQ.Uri],new $.$NQ("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new k.$vO(o.Range.to(s.range),o.Color.to(s.color))):[])),new $.$OQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$MQ("color","The color to show and insert",r=>r instanceof k.$uO,o.Color.from),new $.$MQ("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:o.Range.from(r.range)}))],new $.$NQ("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(o.ColorPresentation.to):[])),new $.$OQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$MQ.Uri,$.$MQ.Range],new $.$NQ("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(o.InlayHint.to.bind(void 0,c)))),new $.$OQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$MQ.Uri],new $.$NQ("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(o.FoldingRange.to)})),new $.$OQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$NQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>o.NotebookExclusiveDocumentPattern.to(s))})))),new $.$OQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$MQ.Uri,$.$MQ.Range,new $.$MQ("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof k.$SN,r=>o.InlineValueContext.from(r))],new $.$NQ("A promise that resolves to an array of InlineValue objects",r=>r.map(o.InlineValue.to))),new $.$OQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$MQ("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,P.$Qg)(r,P.Schemas.http,P.Schemas.https),r=>r),new $.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional(),$.$MQ.String.with("label","").optional()],$.$NQ.Void),new $.$OQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$MQ.Uri.with("resource","Resource to open"),$.$MQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional()],$.$NQ.Void),new $.$OQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$MQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$MQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$MQ.String.with("title","Human readable title for the diff editor").optional(),new $.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)]).optional()],$.$NQ.Void),new $.$OQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$MQ.String.with("title","Human readable title for the changes editor"),new $.$MQ("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[c,l,i]=s;if(!I.URI.isUri(c)||!I.URI.isUri(l)&&l!==void 0&&l!==null||!I.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],$.$NQ.Void),new $.$OQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$MQ.Uri,$.$MQ.Position],new $.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new $.$OQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$MQ.TypeHierarchyItem],new $.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new $.$OQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$MQ.TypeHierarchyItem],new $.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new $.$OQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$MQ.TestItem],$.$NQ.Void),new $.$OQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$MQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$NQ.Void),new $.$OQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$MQ.String.with("name","The context key name"),new $.$MQ("value","The context key value",()=>!0,r=>r)],$.$NQ.Void),new $.$OQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$MQ.Uri,$.$MQ.StringArray,new $.$MQ("MappedEditsContext","Mapped Edits Context",r=>o.MappedEditsContext.is(r),r=>o.MappedEditsContext.from(r))],new $.$NQ("A promise that resolves to a workspace edit or null",r=>r?o.WorkspaceEdit.to(r):null)),new $.$OQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$MQ("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?o.Range.from(r.initialRange):void 0,initialSelection:k.$TN.isSelection(r.initialSelection)?o.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?o.Position.from(r.position):void 0}})],$.$NQ.Void)];class a{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",O.$Fj)}}e.$Spc=a;function S(r){return s=>{if(Array.isArray(s))return s.map(r)}}function d(r){if(!Array.isArray(r))return;const s=[];for(const c of r)T.$Ou(c)?s.push(o.DefinitionLink.to(c)):s.push(o.location.to(c));return s}}),define(Ne[257],Me([1,0,2,33]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0;class I{constructor(A,O,$,o,k){this.a=O,this.b=$,this.c=o;const y=new P.$OQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.$MQ("showOptions","Show Options",a=>!0,a=>a),new P.$MQ("resource","Interactive resource Uri",a=>!0,a=>a),new P.$MQ("controllerId","Notebook controller Id",a=>!0,a=>a),new P.$MQ("title","Interactive editor title",a=>!0,a=>a)],new P.$NQ("Notebook and input URI",a=>{if(k.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return k.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return k.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,O,$,o){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$hrc=I}),define(Ne[258],Me([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,39,198]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=void 0,e.$qrc=h,S=Ve(S);let n=class{constructor(D,w,C,R,f){this.m=w,this.n=C,this.o=R,this.q=f,this.b=new O.$Bc,this.c=new O.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$ON.MainThreadNotebookKernels);const b=new a.$OQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$MQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const M=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:M}}else if(N&&"notebookEditor"in N){const M=this.n.getIdByEditor(N.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return N})],a.$NQ.Void),L=new a.$OQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$MQ.Uri],new a.$NQ("A promise that resolves to an array of variables",(N,M)=>N.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(L)}createNotebookController(D,w,C,R,f,b){for(const ae of this.j.values())if(ae.controller.id===w&&o.$sn.equals(D.identifier,ae.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const L=this.k++,N=this;this.q.trace(`NotebookController[${L}], CREATED by ${D.identifier.value}, ${w}`);const M=()=>console.warn(`NO execute handler from notebook controller '${J.id}' of extension: '${D.identifier}'`);let W=!1;const G=new T.$me,q=new T.$me,J={id:h(D.identifier,w),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:R||D.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let K=f??M,oe,me;this.a.$addKernel(L,J).catch(ae=>{console.log(ae),W=!0});let le=0;const _=()=>{if(W)return;const ae=++le;Promise.resolve().then(()=>{ae===le&&this.a.$updateKernel(L,J)})},ce=new O.$Bc,pe={get id(){return w},get notebookType(){return J.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return J.label},set label(ae){J.label=ae??D.displayName??D.name,_()},get detail(){return J.detail??""},set detail(ae){J.detail=ae,_()},get description(){return J.description??""},set description(ae){J.description=ae,_()},get supportedLanguages(){return J.supportedLanguages},set supportedLanguages(ae){J.supportedLanguages=ae,_()},get supportsExecutionOrder(){return J.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){J.supportsExecutionOrder=ae,_()},get rendererScripts(){return J.preloads?J.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ae){K=ae??M},get interruptHandler(){return oe},set interruptHandler(ae){oe=ae,J.supportsInterrupt=!!ae,_()},set variableProvider(ae){(0,c.$jH)(D,"notebookVariableProvider"),me=ae,J.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Se=>N.a.$variablesUpdated(Se.uri)),_()},get variableProvider(){return me},createNotebookCellExecution(ae){if(W)throw new Error("notebook controller is DISPOSED");if(!ce.has(ae.notebook.uri))throw N.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,h(D.identifier,this.id))},createNotebookExecution(ae){if((0,c.$jH)(D,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!ce.has(ae.uri))throw N.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,h(D.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${L}], DISPOSED`),W=!0,this.j.delete(L),G.dispose(),q.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ae,Se){Se===d.NotebookControllerAffinity2.Hidden&&(0,c.$jH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(L,ae.uri,Se)},onDidReceiveMessage:q.event,postMessage(ae,Se){return(0,c.$jH)(D,"notebookMessaging"),N.a.$postMessage(L,Se&&N.n.getIdByEditor(Se),ae)},asWebviewUri(ae){return(0,c.$jH)(D,"notebookMessaging"),(0,r.$PDb)(ae,N.m.remote)}};return this.j.set(L,{extensionId:D.identifier,controller:pe,onDidReceiveMessage:q,onDidChangeSelection:G,associatedNotebooks:ce}),pe}getIdByController(D){for(const[w,C]of this.j)if(C.controller===D)return h(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,w){const C=this.g++,R=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,w);const f={dispose:()=>{this.f.delete(C),R.a.$removeKernelDetectionTask(C)}};return this.f.set(C,f),f}registerKernelSourceActionProvider(D,w,C){const R=this.i++,f=typeof C.onDidChangeNotebookKernelSourceActions=="function"?R:void 0,b=this;this.h.set(R,C),this.q.trace(`NotebookKernelSourceActionProvider[${R}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(R,R,w);let L;return f!==void 0&&(L=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(R),b.a.$removeKernelSourceActionProvider(R,R),L?.dispose()}}}async $provideKernelSourceActions(D,w){const C=this.h.get(D);if(C){const R=new A.$Uc;return(await C.provideNotebookKernelSourceActions(w)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this.o.converter,R))}return[]}$acceptNotebookAssociation(D,w,C){const R=this.j.get(D);if(R){const f=this.n.getNotebookDocument($.URI.revive(w));C?R.associatedNotebooks.set(f.uri,!0):R.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),C),R.onDidChangeSelection.fire({selected:C,notebook:f.apiNotebook})}}async $executeCells(D,w,C){const R=this.j.get(D);if(!R)return;const f=this.n.getNotebookDocument($.URI.revive(w)),b=[];for(const L of C){const N=f.getCell(L);N&&b.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),b.length),await R.controller.executeHandler.call(R.controller,b,f.apiNotebook,R.controller)}catch(L){this.q.error(`NotebookController[${D}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(D,w,C){const R=this.j.get(D);if(!R)return;const f=this.n.getNotebookDocument($.URI.revive(w));if(R.controller.interruptHandler)await R.controller.interruptHandler.call(R.controller,f.apiNotebook);else for(const b of C){const L=f.getCell(b);L&&this.b.get(L.uri)?.cancel()}if(R.controller.interruptHandler){const b=this.c.get(f.uri);this.c.delete(f.uri),C.length&&Array.isArray(b)&&b.length&&b.forEach(L=>L.dispose())}}async $provideVariables(D,w,C,R,f,b,L){const N=this.j.get(D);if(!N)return;const M=this.n.getNotebookDocument($.URI.revive(C)),W=N.controller.variableProvider;if(!W)return;let G;if(R!==void 0){if(G=this.s[R],!G)return}else this.s={};const q=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,J=W.provideVariables(M.apiNotebook,G,q,b,L);let K=0;for await(const oe of J){if(L.isCancellationRequested)return;const me={id:this.r++,name:oe.variable.name,value:oe.variable.value,type:oe.variable.type,interfaces:oe.variable.interfaces,language:oe.variable.language,expression:oe.variable.expression,hasNamedChildren:oe.hasNamedChildren,indexedChildrenCount:oe.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[me.id]=oe.variable,this.a.$receiveVariable(w,me),K++>=i.$4K)return}}$acceptKernelMessageFromRenderer(D,w,C){const R=this.j.get(D);if(!R)return;const f=this.n.getEditorById(w);R.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:C}))}$cellExecutionChanged(D,w,C){const f=this.n.getNotebookDocument($.URI.revive(D)).getCell(w);if(f){const b=C?S.NotebookCellExecutionState.to(C):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:f.apiCell,state:b})}}_createNotebookCellExecution(D,w){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const R=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!R)throw new Error("invalid cell");if(this.b.has(R.uri))throw new Error(`duplicate execution for ${R.uri}`);const f=new g(w,R,this.a);this.b.set(R.uri,f);const b=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),b.dispose(),this.b.delete(R.uri))});return f.asApiObject()}_createNotebookExecution(D,w){const C=this.n.getNotebookDocument(D.uri),R=D.getCells().find(L=>{const N=C.getCellFromApiCell(L);return N&&this.b.has(N.uri)});if(R)throw new Error(`duplicate cell execution for ${R.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const f=new p(w,C,this.a),b=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[f,b]),f.asApiObject()}};e.$prc=n,e.$prc=n=Je([We(4,k.$bk)],n);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,w,C){super(),this.m=w,this.n=C,this.b=g.a++,this.c=new T.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new I.$xe),this.h=new m(10,R=>this.s(R)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const w=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$2w(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let w=this.m;if(D&&(w=this.m.notebook.getCellFromApiCell(D)),!w)throw new Error("INVALID cell");return w.handle}y(D){return D.map(w=>{const C=d.$mP.ensureUniqueMimeTypes(w.items,!0);return C===w.items?S.NotebookCellOutput.from(w):S.NotebookCellOutput.from({items:C,id:w.id,metadata:w.metadata})})}async z(D,w,C){const R=this.w(w),f=this.y((0,v.$2b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:R,append:C,outputs:f})}async C(D,w,C){return D=d.$mP.ensureUniqueMimeTypes((0,v.$2b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:w.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,R,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const b=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new l.$2w({runEndTime:R,lastRunSuccess:C,error:b}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,R){return D.t(),D.z(C,R,!0)},replaceOutput(C,R){return D.t(),D.z(C,R,!1)},appendOutputItems(C,R){return D.t(),D.C(C,R,!0)},replaceOutputItems(C,R){return D.t(),D.C(C,R,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class p extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,w,C){super(),this.h=w,this.j=C,this.b=p.a++,this.c=new T.$me,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(D,w){this.f=D,this.g=w,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new P.$4h,this.b=Date.now(),(0,P.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Ne[56],Me([1,0,6,5,3,2,16,4,7,9,13,180,21,38,181,182,34,10,8,33,37]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=e.$wqc=e.$vqc=e.$uqc=void 0,e.$uqc=(0,I.$Gi)("IExtHostTerminalService");class t extends O.$Vc{constructor(f,b,L,N){super(),this.u=f,this._id=b,this.w=L,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(W,G=!0){M.C(),M.u.$sendText(M._id,W,G)},show(W){M.C(),M.u.$show(M._id,W)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??b?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(f.location,b?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,b,L,N,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(M)?M.id:void 0,location:b?.location||this.z(f,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,b){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in f?{viewColumn:l.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,b){this.j=Object.freeze({code:f,reason:b})}setDimensions(f,b){return f===this.f&&b===this.h||f===0||b===0?!1:(this.f=f,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(b=>{b!==f&&(this.b=Promise.resolve(f))})}}e.$vqc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$me,this.onProcessData=this.a.event,this.b=new v.$me,this.d=new v.$me,this.onDidChangeProperty=this.d.event,this.f=new v.$me,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,b){this.g.setDimensions?.({columns:f,rows:b})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,p=class extends O.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,b,L){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$me,this.onDidCloseTerminal=this.H.event,this.I=new v.$me,this.onDidOpenTerminal=this.I.event,this.J=new v.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$me,this.onDidChangeTerminalState=this.M.event,this.N=new v.$me,this.onDidChangeShell=this.N.event,this.O=new v.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(P.$ON.MainThreadTerminalService),this.y=new r.$5xb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const M=W=>{const G=W;return this.getTerminalById(G.instanceId)?.value};switch(N?.$mid){case n.MarshalledId.TerminalContext:return M(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===n.MarshalledId.TerminalContext;W++)N[W]=M(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,M]of this.g)M.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,b){const L=new t(this.a,(0,S.$3g)(),f,f.name),N=new g(f.pty);return L.createExtensionTerminal(f.location,b,this.R(f,b).resolvedExtHostIdentifier,D(f.iconPath),w(f.color)).then(M=>{const W=this.S(M,N);this.h[M]=W}),this.f.push(L),L.value}R(f,b){if(b=b||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const L=f.location.parentTerminal;if(L){const N=this.f.find(M=>M.value===L);N&&(b.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?b.location=f.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(f,b){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(b),M=this.S(f,N);this.h[f]=M}async $acceptActiveTerminalChanged(f){const b=this.b;if(f===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(f);L&&(this.b=L,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,b){const L=this.getTerminalById(f);L&&this.O.fire({terminal:L.value,data:b})}async $acceptTerminalDimensions(f,b,L){const N=this.getTerminalById(f);N&&N.setDimensions(b,L)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,b){const L=this.getTerminalById(f);L&&this.P.fire({terminal:L.value,...b})}async $acceptTerminalMaximumDimensions(f,b,L){this.g.get(f)?.resize(b,L)}async $acceptTerminalTitleChange(f,b){const L=this.getTerminalById(f);L&&(L.name=b)}async $acceptTerminalClosed(f,b,L){const N=this.X(this.f,f);if(N!==null){const M=this.f.splice(N,1)[0];M.setExitStatus(b,L),this.H.fire(M.value)}}$acceptTerminalOpened(f,b,L,N){if(b){const G=this.X(this.f,b);if(G!==null){this.f[G]._id=f,this.I.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const M={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:T.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new t(this.a,f,M,L);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,b){this.getTerminalById(f)?._setProcessId(b)}async $startExtensionTerminal(f,b){const L=this.getTerminalById(f);if(!L)return{message:(0,o.localize)(2701,null,f)};L.isOpen||await new Promise(M=>{const W=this.onDidOpenTerminal(async G=>{G===L.value&&(W.dispose(),M())})});const N=this.g.get(f);N?N.startSendingEvents(b):this.j[f]={initialDimensions:b}}S(f,b){const L=new O.$Uc;L.add(b.onProcessReady(M=>this.a.$sendProcessReady(f,M.pid,M.cwd,M.windowsPty))),L.add(b.onDidChangeProperty(M=>this.a.$sendProcessProperty(f,M))),this.y.startBuffering(f,b.onProcessData),L.add(b.onProcessExit(M=>this.U(f,M))),this.g.set(f,b);const N=this.j[f];return N&&b instanceof g&&(b.startSendingEvents(N.initialDimensions),delete this.j[f]),L}$acceptProcessAckDataEvent(f,b){this.g.get(f)?.acknowledgeDataEvent(b)}$acceptProcessInput(f,b){this.g.get(f)?.input(b)}$acceptTerminalInteraction(f){const b=this.getTerminalById(f);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(f,b){this.getTerminalById(f)?.setSelection(b)}$acceptProcessResize(f,b,L){try{this.g.get(f)?.resize(b,L)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,b){this.g.get(f)?.shutdown(b)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new $.$QN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,b,L){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,L),this.a.$registerProfileProvider(b,f.identifier.value),new $.$QN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(f,b,L){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,L),this.a.$registerQuickFixProvider(f,b),new $.$QN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,b){const L=new a.$xe().token;if(L.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const M=await N.provideTerminalQuickFixes(b,L);if(M===null||Array.isArray(M)&&M.length===0)return;const W=new O.$Uc;if(this.w.value=W,!Array.isArray(M))return M?l.TerminalQuickFix.from(M,this.Q.converter,W):void 0;const G=[];for(const q of M){const J=l.TerminalQuickFix.from(q,this.Q.converter,W);J&&G.push(J)}return G}async $createContributedProfileTerminal(f,b){const L=new a.$xe().token;let N=await this.C.get(f)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,b);return}this.createTerminalFromOptions(N.options,b)}}async $provideLinks(f,b){const L=this.getTerminalById(f);if(!L)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const M=new a.$xe;this.G.set(f,M);const W=[],G={terminal:L.value,line:b},q=[];for(const oe of this.z)q.push(c.Promises.withAsyncBody(async me=>{M.token.onCancellationRequested(()=>me({provider:oe,links:[]}));const le=await oe.provideTerminalLinks(G,M.token)||[];M.token.isCancellationRequested||me({provider:oe,links:le})}));const J=await Promise.all(q);if(M.token.isCancellationRequested)return[];const K=new Map;for(const oe of J)oe&&oe.links.length>0&&W.push(...oe.links.map(me=>{const le={id:u++,startIndex:me.startIndex,length:me.length,label:me.tooltip};return K.set(le.id,{provider:oe.provider,link:me}),le}));return this.F.set(f,K),W}$activateLink(f,b){const L=this.F.get(f)?.get(b);L&&L.provider.handleTerminalLink(L.link)}U(f,b){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const L=this.h[f];L&&(L.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,b)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const b=this.f.findIndex(L=>L.value===f);return b>=0?b:null}W(f,b){const L=this.X(f,b);return L!==null?f[L]:null}X(f,b){const L=f.findIndex(N=>N._id===b);return L>=0?L:null}getEnvironmentVariableCollection(f){let b=this.n.get(f.identifier.value);return b||(b=this.B(new m),this.Z(f.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(f,b){const L=(0,y.$Is)(b.map),N=(0,y.$Js)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(f,b.persistent,L.length===0?void 0:L,N)}$initEnvironmentVariableCollections(f){f.forEach(b=>{const L=b[0],N=this.B(new m(b[1]));this.Z(L,N)})}$acceptDefaultProfile(f,b){const L=this.s;this.s=f,this.u=b,L?.path!==f.path&&this.N.fire(f.path)}Z(f,b){this.n.set(f,b),this.B(b.onDidChangeCollection(()=>{this.Y(f,b)}))}};e.$wqc=p,e.$wqc=p=Je([We(1,i.$KQ),We(2,A.$oQ)],p);class m extends O.$Vc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$me,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const b=this.j(f);let L=this.a.get(b);return L||(L=new h(this,f),this.a.set(b,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(f,b,L,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:N})}append(f,b,L,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:N})}prepend(f,b,L,N){this.g(f,{value:b,type:$.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:N})}g(f,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(f,b.scope),N=this.map.get(L),M=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==b.value||N.type!==b.type||N.options?.applyAtProcessCreation!==M.applyAtProcessCreation||N.options?.applyAtShellIntegration!==M.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const W=this.h(f,b.scope),G={variable:f,...b,options:M};this.map.set(W,G),this.f.fire()}}get(f,b){const L=this.h(f,b),N=this.map.get(L);return N?C(N):void 0}h(f,b){const L=this.j(b);return L.length?`${f}:::${L}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const b=new Map;for(const[L,N]of this.map)this.j(N.scope)===this.j(f)&&b.set(N.variable,C(N));return b}delete(f,b){const L=this.h(f,b);this.map.delete(L),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[b,L]of this.map)L.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(b);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,b){const L=this.j(b),N=this.descriptionMap.get(L);if(!N||N.description!==f){let M;typeof f=="string"?M=f:M=f?.value.split(`

`)[0];const W={description:M,scope:b};this.descriptionMap.set(L,W),this.f.fire()}}getDescription(f){const b=this.j(f);return this.descriptionMap.get(b)?.description}n(f){const b=this.j(f);this.descriptionMap.delete(b)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,b){this.b=f,this.d=b,this.a=new v.$me}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,b,L){this.b.replace(f,b,L,this.d)}append(f,b,L){this.b.append(f,b,L,this.d)}prepend(f,b,L){this.b.prepend(f,b,L,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,b){this.b.getVariableMap(this.d).forEach((L,N)=>f.call(b,N,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends p{constructor(f,b){super(!1,f,b)}createTerminal(f,b,L){throw new k.$_}createTerminalFromOptions(f,b){throw new k.$_}};e.$xqc=E,e.$xqc=E=Je([We(0,i.$KQ),We(1,A.$oQ)],E);function D(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function w(R){return s.ThemeColor.isThemeColor(R)?R:void 0}function C(R){const f={...R};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ne[127],Me([1,0,7,4,3,5,16,56,6,2,10]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=void 0,e.$Hrc=(0,I.$Gi)("IExtHostTerminalShellIntegration");let y=class extends P.$Vc{constructor(s,c){super(),this.h=c,this.b=new Map,this.c=new $.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(T.$ON.MainThreadTerminalShellIntegration),this.B((0,P.$Tc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const c=this.h.getTerminalById(s);if(!c)return;const l=c.value;let i=this.b.get(s);i||(i=new a(c.value,this.f),this.b.set(s,i),i.store.add(c.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(s,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),c.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(s,c,l,i,n){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.startShellExecution(t,o.URI.revive(n))}$shellExecutionEnd(s,c,l,i,n){const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.endShellExecution(t,n)}$shellExecutionData(s,c){this.b.get(s)?.emitData(c)}$cwdChange(s,c){this.b.get(s)?.setCwd(o.URI.revive(c))}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$Irc=y,e.$Irc=y=Je([We(0,A.$oQ),We(1,O.$uqc)],y);class a extends P.$Vc{get currentExecution(){return this.a}constructor(s,c){super(),this.j=s,this.m=c,this.b=!1,this.store=this.B(new P.$Uc),this.f=this.B(new $.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$me),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(p=>`${p.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(s,c,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(s,c??this.c);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,c){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(s){let c=!1;o.URI.isUri(this.c)?c=!o.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(c=!0),c&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(s,c){this.c=s,this.cwd=c,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return k.$7h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends P.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new k.$Fh);const s=this.a;return new k.$7h(async l=>{this.b.push(l),await s.wait()})}emitData(s){for(const c of this.b)c.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ne[128],Me([1,0,61,13,96,8,7]),function(ve,e,v,P,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=void 0,T=Ve(T);class O{static{this.c=new I.$tQ("TextEditorDecorationType")}constructor(a,S,d){const r=O.c.nextId();a.$registerTextEditorDecorationType(S.identifier,r,T.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){a.$removeTextEditorDecorationType(r)}})}}e.$vQ=O;class ${constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof A.$RN)d=new A.$SN(a,a);else if(a instanceof A.$SN)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new A.$SN(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof A.$SN)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const r=this.c.validateRange(a);this.g.push({range:r,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,P.$7)("endOfLine");this.h=a}}class o{constructor(a,S,d,r){this.c=a,this.d=S,this._accept(d),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(c){s.n(c)},get indentSize(){return s.g},set indentSize(c){s.p(c)},get insertSpaces(){return s.j},set insertSpaces(c){s.s(c)},get cursorStyle(){return s.k},set cursorStyle(c){s.t(c)},get lineNumbers(){return s.l},set lineNumbers(c){s.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const r=this.m(a.tabSize);r==="auto"?(d=!0,S.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,S.tabSize=r)}if(typeof a.indentSize<"u"){const r=this.o(a.indentSize);r==="tabSize"?(d=!0,S.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,S.indentSize=r)}if(typeof a.insertSpaces<"u"){const r=this.q(a.insertSpaces);r==="auto"?(d=!0,S.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,S.insertSpaces=r)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=T.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$wQ=o;class k{constructor(a,S,d,r,s,c,l,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new o(this.j,this.id,c,d),this.e=l,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new P.$9("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof A.$TN))throw(0,P.$7)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$TN)))throw(0,P.$7)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new P.$9("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new P.$9("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(r.value,g);return t(u),n.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let p;if(!g||Array.isArray(g)&&g.length===0)p=n.c.map(m=>T.Range.from(m));else if(g instanceof A.$RN){const{lineNumber:m,column:h}=T.Position.from(g);p=[{startLineNumber:m,startColumn:h,endLineNumber:m,endColumn:h}]}else if(g instanceof A.$SN)p=[T.Range.from(g)];else{p=[];for(const m of g)if(m instanceof A.$SN)p.push(T.Range.from(m));else{const{lineNumber:h,column:E}=T.Position.from(m);p.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,r.value.version,t.value,p,u)},setDecorations(t,g){const u=g.length===0;u&&!n.h.has(t.key)||(u?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(T.$lQ(g))return S.$trySetDecorations(a,t.key,T.$mQ(g));{const p=new Array(4*g.length);for(let m=0,h=g.length;m<h;m++){const E=g[m];p[4*m]=E.start.line+1,p[4*m+1]=E.start.character+1,p[4*m+2]=E.end.line+1,p[4*m+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,p)}}))},revealRange(t,g){n.n(()=>S.$tryRevealRange(a,T.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,T.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(s=>s.range);d.sort((s,c)=>s.end.line===c.end.line?s.end.character===c.end.character?s.start.line===c.start.line?s.start.character-c.start.character:s.start.line-c.start.line:s.end.character-c.end.character:s.end.line-c.end.line);for(let s=0,c=d.length-1;s<c;s++){const l=d[s].end;if(d[s+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=S.edits.map(s=>({range:T.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,r,{setEndOfLine:typeof S.setEndOfLine=="number"?T.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$xQ=k}),define(Ne[57],Me([1,0,61,6,4,2,3,5,124,16,128,8,11,28,15,40,48]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0,v=Ve(v),y=Ve(y);class c{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new S.$Bc,this.d=new P.$me,this.e=new P.$me,this.f=new P.$me,this.g=new P.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],g=[],u=[];if(n.removedDocuments)for(const p of n.removedDocuments){const m=T.URI.revive(p),h=this.c.get(m);h?.unref()&&(this.c.delete(m),t.push(h.value))}if(n.addedDocuments)for(const p of n.addedDocuments){const m=T.URI.revive(p.uri);let h=this.c.get(m);if(h&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);h||(h=new c(new $.$rQ(this.h.getProxy(O.$ON.MainThreadDocuments),m,p.lines,p.EOL,p.versionId,p.languageId,p.isDirty)),this.c.set(m,h),g.push(h.value)),h.ref()}if(n.removedEditors)for(const p of n.removedEditors){const m=this.b.get(p);this.b.delete(p),m&&u.push(m)}if(n.addedEditors)for(const p of n.addedEditors){const m=T.URI.revive(p.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has(p.id),`editor '${p.id}' already exists!`);const h=this.c.get(m).value,E=new k.$xQ(p.id,this.h.getProxy(O.$ON.MainThreadTextEditors),this.i,new s.$U(()=>h.document),p.selections.map(y.Selection.to),p.options,p.visibleRanges.map(D=>y.Range.to(D)),typeof p.editorPosition=="number"?y.ViewColumn.to(p.editorPosition):void 0);this.b.set(p.id,E)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,I.$Qc)(t),(0,I.$Qc)(u),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(g),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(p=>p.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$yQ=l,e.$yQ=l=Je([We(0,o.$oQ),We(1,a.$bk)],l),e.$zQ=(0,A.$Gi)("IExtHostDocumentsAndEditors")}),define(Ne[95],Me([1,0,10,22,21,6,231,75,4,37,14,2,38,3,11,5,33,57,16,126,8,7,200,54,81,55,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Rqc=e.$Qqc=e.$Pqc=e.$Oqc=void 0,n=Ve(n);let E=0;const D=new WeakMap;e.$Oqc=(0,S.$Gi)("IExtHostTesting");let w=class extends $.$Vc{constructor(le,_,ce,pe){super(),this.C=_,this.D=ce,this.F=pe,this.f=this.B(new T.$me),this.g=new Map,this.w=this.B(new T.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=le.getProxy(r.$ON.MainThreadTesting),this.m=new G(this.h),this.j=new b(this.h,_),ce.registerArgumentProcessor({processArgument:ae=>{switch(ae?.$mid){case o.MarshalledId.TestItemContext:{const Se=ae,Oe=Se.tests[Se.tests.length-1].item.extId;return this.g.get(u.$$I.root(Oe))?.collection.tree.get(Oe)?.actual??(0,i.$AQ)(ae)}case o.MarshalledId.TestMessageMenuArgs:{const{test:Se,message:Oe}=ae,X=Se.item.extId;return{test:this.g.get(u.$$I.root(X))?.collection.tree.get(X)?.actual??(0,i.$AQ)({$mid:o.MarshalledId.TestItemContext,tests:[Se]}),message:n.TestMessage.to(Oe)}}default:return ae}}}),ce.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ae=await ce.executeCommand(g.TestCommandId.GetExplorerSelection),Se=Oe=>{const X=this.g.get(u.$$I.root(Oe));if(X)return u.$$I.isRoot(Oe)?X.controller:X.collection.tree.get(Oe)?.actual};return{include:ae?.include.map(Se).filter(k.$ng)||[],exclude:ae?.exclude.map(Se).filter(k.$ng)||[]}})}createTestController(le,_,ce,pe){if(this.g.has(_))throw new Error(`Attempt to insert a duplicate controller with ID "${_}"`);const ae=new $.$Uc,Se=ae.add(new i.$DQ(_,ce,this.F));Se.root.label=ce;const Oe=new Map,X=new Set,B=this.h,te=()=>{let we=0;pe&&(we|=m.TestControllerCapability.Refresh);const he=de.relatedCodeProvider;return he&&(he?.provideRelatedTests&&(we|=m.TestControllerCapability.TestRelatedToCode),he?.provideRelatedCode&&(we|=m.TestControllerCapability.CodeRelatedToTest)),we},ye={items:Se.root.children,get label(){return ce},set label(we){ce=we,Se.root.label=we,B.$updateController(_,{label:ce})},get refreshHandler(){return pe},set refreshHandler(we){pe=we,B.$updateController(_,{capabilities:te()})},get id(){return _},get relatedCodeProvider(){return de.relatedCodeProvider},set relatedCodeProvider(we){(0,h.$jH)(le,"testRelatedCode"),de.relatedCodeProvider=we,B.$updateController(_,{capabilities:te()})},createRunProfile:(we,he,Z,x,be,$e)=>{let Ae=(0,O.$uj)(we);for(;Oe.has(Ae);)Ae++;return new J(this.h,Oe,X,this.w.event,_,Ae,we,he,Z,x,be,$e)},createTestItem(we,he,Z){return new i.$BQ(_,we,he,Z)},createTestRun:(we,he,Z=!0)=>this.j.createTestRun(le,_,Se,we,he,Z),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const he=we instanceof Array?we:[we];this.h.$markTestRetired(he.map(Z=>u.$$I.fromExtHostTestItem(Z,_).toString()))}},set resolveHandler(we){Se.resolveHandler=we},get resolveHandler(){return Se.resolveHandler},dispose:()=>{ae.dispose()}},de={controller:ye,collection:Se,profiles:Oe,extension:le,activeProfiles:X};return B.$registerTestController(_,ce,te()),ae.add((0,$.$Tc)(()=>B.$unregisterTestController(_))),this.g.set(_,de),ae.add((0,$.$Tc)(()=>this.g.delete(_))),ae.add(Se.onDidGenerateDiff(we=>B.$publishDiff(_,we.map(m.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.m.checkout()}async runTests(le,_=I.CancellationToken.None){const ce=L(le);if(!ce)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const pe=this.g.get(ce.controllerId);if(!pe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:le.preserveFocus??!0,group:K[ce.kind],targets:[{testIds:le.include?.map(ae=>u.$$I.fromExtHostTestItem(ae,pe.collection.root.id).toString())??[pe.collection.root.id],profileId:ce.profileId,controllerId:ce.controllerId}],exclude:le.exclude?.map(ae=>ae.id)},_)}registerTestFollowupProvider(le){return this.y.add(le),{dispose:()=>{this.y.delete(le)}}}async $getTestsRelatedToCode(le,_,ce){const pe=this.F.getDocument(y.URI.revive(le));if(!pe)return[];const ae=n.Position.to(_),Se=[];return await Promise.all([...this.g.values()].map(async Oe=>{let X;try{X=await Oe.relatedCodeProvider?.provideRelatedTests?.(pe.document,ae,ce)}catch(B){ce.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Oe.controller.label}`,B)}if(X){for(const B of X)Se.push(u.$$I.fromExtHostTestItem(B,Oe.controller.id).toString());Oe.collection.flushDiff()}})),Se}async $getCodeRelatedToTest(le,_){const ce=this.g.get(u.$$I.root(le));if(!ce)return[];const pe=ce.collection.tree.get(le);return pe?(await ce.relatedCodeProvider?.provideRelatedCode?.(pe.actual,_))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:le}of this.g.values())le.flushDiff();return Promise.resolve()}async $getCoverageDetails(le,_,ce){return(await this.j.getCoverageDetails(le,_,ce))?.map(n.TestCoverage.fromDetails)}async $disposeRun(le){this.j.disposeTestRun(le)}$configureRunProfile(le,_){this.g.get(le)?.profiles.get(_)?.configureHandler?.()}$setDefaultRunProfiles(le){const _=new Map;for(const[ce,pe]of Object.entries(le)){const ae=this.g.get(ce);if(!ae)continue;const Se=new Map,Oe=pe.filter(B=>!ae.activeProfiles.has(B)),X=[...ae.activeProfiles].filter(B=>!pe.includes(B));for(const B of Oe)Se.set(B,!0),ae.activeProfiles.add(B);for(const B of X)Se.set(B,!1),ae.activeProfiles.delete(B);Se.size&&_.set(ce,Se)}this.w.fire(_)}async $refreshTests(le,_){await this.g.get(le)?.controller.refreshHandler?.(_)}$publishTestResults(le){this.results=Object.freeze(le.map(_=>{const ce=n.TestResults.to(_);return D.set(ce,_.id),ce}).concat(this.results).sort((_,ce)=>ce.completedAt-_.completedAt).slice(0,32)),this.f.fire()}async $expandTest(le,_){const ce=this.g.get(u.$$I.fromString(le).controllerId)?.collection;ce&&(await ce.expand(le,_<0?1/0:_),ce.flushDiff())}$acceptDiff(le){this.m.applyDiff(le.map(_=>m.TestsDiffOp.deserialize({asCanonicalUri:ce=>ce},_)))}async $runControllerTests(le,_){return Promise.all(le.map(ce=>this.G(ce,!1,_)))}async $startContinuousRun(le,_){const ce=new I.$xe(_),pe=await Promise.all(le.map(ae=>this.G(ae,!0,ce.token)));return!_.isCancellationRequested&&!pe.some(ae=>ae.error)&&await new Promise(ae=>_.onCancellationRequested(ae)),ce.dispose(!0),pe}async $provideTestFollowups(le,_){const ce=this.results.find(Se=>D.get(Se)===le.resultId),pe=ce&&oe(u.$$I.fromString(le.extId),ce?.results);if(!pe)return[];let ae=[];return await Promise.all([...this.y].map(async Se=>{try{const Oe=await Se.provideFollowup(ce,pe,le.taskIndex,le.messageIndex,_);Oe&&(ae=ae.concat(Oe))}catch(Oe){this.C.error("Error thrown while providing followup for test message",Oe)}})),_.isCancellationRequested?[]:ae.map(Se=>{const Oe=E++;return this.z.set(Oe,Se),{title:Se.title,id:Oe}})}$disposeTestFollowups(le){for(const _ of le)this.z.delete(_)}$executeTestFollowup(le){const _=this.z.get(le);return _?this.D.executeCommand(_.command,..._.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(le,_){le===void 0?this.j.cancelAllRuns():this.j.cancelRunById(le,_)}getMetadataForRun(le){for(const _ of this.j.trackers){const ce=_.getTaskIdForRun(le);if(ce)return{taskId:ce,runId:_.id}}}async G(le,_,ce){const pe=this.g.get(le.controllerId);if(!pe)return{};const{collection:ae,profiles:Se,extension:Oe}=pe,X=Se.get(le.profileId);if(!X)return{};const B=le.testIds.map(we=>ae.tree.get(we)).filter(k.$ng),te=le.excludeExtIds.map(we=>pe.collection.tree.get(we)).filter(k.$ng).filter(we=>B.some(he=>he.fullId.compare(we.fullId)===u.TestPosition.IsChild));if(!B.length)return{};const ye=new t.$tP(B.some(we=>we.actual instanceof i.$CQ)?void 0:B.map(we=>we.actual),te.map(we=>we.actual),X,_),de=(0,m.$bJ)(le)&&this.j.prepareForMainThreadTestRun(Oe,ye,N.fromInternal(le,pe.collection),X,ce);try{return await X.runHandler(ye,ce),{}}catch(we){return{error:String(we)}}finally{de&&de.hasRunningTasks&&!ce.isCancellationRequested&&await T.Event.toPromise(de.onEnd)}}};e.$Pqc=w,e.$Pqc=w=Je([We(0,l.$oQ),We(1,d.$bk),We(2,s.$KQ),We(3,c.$zQ)],w);const C=1e4;var R;(function(me){me[me.Running=0]="Running",me[me.Cancelling=1]="Cancelling",me[me.Ended=2]="Ended"})(R||(R={}));class f extends $.$Vc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(le,_,ce,pe,ae,Se){super(),this.C=le,this.D=_,this.F=ce,this.G=pe,this.H=ae,this.f=R.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new T.$me),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new I.$xe(Se));const Oe=this.B(new v.$Sh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Oe.schedule()));const X=new T.$me;this.y=X.event,this.B((0,$.$Tc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(le){for(const[_,{run:ce}]of this.h)if(ce===le)return _}cancel(le){le?this.h.get(le)?.cts.cancel():this.f===R.Running?(this.m.cancel(),this.f=R.Cancelling):this.f===R.Cancelling&&this.I()}async getCoverageDetails(le,_,ce){const[,pe]=u.$$I.fromString(le).path,ae=this.z.get(le);if(!ae)return[];const{report:Se,extIds:Oe}=ae,X=this.h.get(pe);if(!X)throw new Error("unreachable: run task was not found");let B;if(_&&Se instanceof t.$zP){const ye=Oe.indexOf(_);if(ye===-1)return[];B=Se.fromTests[ye]}return await(B?this.G?.loadDetailedCoverageForTest?.(X.run,Se,B,ce):this.G?.loadDetailedCoverage?.(X.run,Se,ce))??[]}createRun(le){const _=this.C.id,ce=this.C.controllerId,pe=(0,a.$3g)(),ae=te=>(ye,...de)=>{if(Oe){this.F.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.L(ye),te(ye,...de)},Se=(te,ye)=>{const de=ye instanceof Array?ye.map(n.TestMessage.from):[n.TestMessage.from(ye)];if(te.uri&&te.range){const we={range:n.Range.from(te.range),uri:te.uri};for(const he of de)he.location=he.location||we}this.D.$appendTestMessagesInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),de)};let Oe=!1;const X=this.B(new I.$xe(this.m.token)),B={isPersisted:this.C.isPersisted,token:X.token,name:le,onDidDispose:this.y,addCoverage:te=>{if(Oe)return;const ye=te instanceof t.$zP?te.fromTests:[];if(ye.length){(0,h.$jH)(this.H,"attributableCoverage");for(const he of ye)this.L(he)}const de=te.uri.toString(),we=new u.$$I([_,pe,de]).toString();this.z.set(we,{report:te,extIds:ye.map(he=>u.$$I.fromExtHostTestItem(he,ce).toString())}),this.D.$appendCoverage(_,pe,n.TestCoverage.fromFile(ce,we,te))},enqueued:ae(te=>{this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),m.TestResultState.Queued)}),skipped:ae(te=>{this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),m.TestResultState.Skipped)}),started:ae(te=>{this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),m.TestResultState.Running)}),errored:ae((te,ye,de)=>{Se(te,ye),this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),m.TestResultState.Errored,de)}),failed:ae((te,ye,de)=>{Se(te,ye),this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,ce).toString(),m.TestResultState.Failed,de)}),passed:ae((te,ye)=>{this.D.$updateTestStateInRun(_,pe,u.$$I.fromExtHostTestItem(te,this.C.controllerId).toString(),m.TestResultState.Passed,ye)}),appendOutput:(te,ye,de)=>{Oe||(de&&this.L(de),this.D.$appendOutputToRun(_,pe,P.$Oe.fromString(te),ye&&n.location.from(ye),de&&u.$$I.fromExtHostTestItem(de,ce).toString()))},end:()=>{Oe||(Oe=!0,this.D.$finishedTestRunTask(_,pe),--this.g||this.J())}};return this.g++,this.h.set(pe,{run:B,cts:X}),this.D.$startedTestRunTask(_,{id:pe,ctrlId:this.C.controllerId,name:le||this.H.displayName||this.H.identifier.value,running:!0}),B}I(){for(const{run:le}of this.h.values())le.end()}J(){this.f!==R.Ended&&(this.f=R.Ended,this.w.fire())}L(le){if(!(le instanceof i.$BQ))throw new p.$gQ(le.id);if(this.j.has(u.$$I.fromExtHostTestItem(le,this.C.controllerId).toString()))return;const _=[],ce=this.C.colllection.root;for(;;){const pe=n.TestItem.from(le);if(_.unshift(pe),this.j.has(pe.extId)||(this.j.add(pe.extId),le===ce))break;le=le.parent||ce}this.D.$addTestsToRun(this.C.controllerId,this.C.id,_)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(le,_){this.h=le,this.j=_,this.f=new Map,this.g=new Map}getCoverageDetails(le,_,ce){const pe=u.$$I.root(le);return this.g.get(pe)?.getCoverageDetails(le,_,ce)||[]}disposeTestRun(le){this.g.get(le)?.dispose(),this.g.delete(le);for(const[_,{id:ce}]of this.f)ce===le&&this.f.delete(_)}prepareForMainThreadTestRun(le,_,ce,pe,ae){return this.k(_,ce,pe,le,ae)}cancelRunById(le,_){this.g.get(le)?.cancel(_)}cancelAllRuns(){for(const le of this.f.values())le.cancel()}createTestRun(le,_,ce,pe,ae,Se){const Oe=this.f.get(pe);if(Oe)return Oe.createRun(ae);const X=N.fromPublic(_,ce,pe,Se),B=L(pe);this.h.$startedExtensionTestRun({controllerId:_,continuous:!!pe.continuous,profile:B&&{group:K[B.kind],id:B.profileId},exclude:pe.exclude?.map(ye=>u.$$I.fromExtHostTestItem(ye,ce.root.id).toString())??[],id:X.id,include:pe.include?.map(ye=>u.$$I.fromExtHostTestItem(ye,ce.root.id).toString())??[ce.root.id],preserveFocus:pe.preserveFocus??!0,persist:Se});const te=this.k(pe,X,pe.profile,le);return T.Event.once(te.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),te.createRun(ae)}k(le,_,ce,pe,ae){const Se=new f(_,this.h,this.j,ce,pe,ae);return this.f.set(le,Se),this.g.set(Se.id,Se),Se}}e.$Qqc=b;const L=me=>{if(me.profile){if(!(me.profile instanceof J))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return me.profile}};class N{static fromPublic(le,_,ce,pe){return new N(le,(0,a.$3g)(),pe,_)}static fromInternal(le,_){return new N(le.controllerId,le.runId,!0,_)}constructor(le,_,ce,pe){this.controllerId=le,this.id=_,this.isPersisted=ce,this.colllection=pe}}e.$Rqc=N;class M{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(le){this.k=le,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(le){this.f.add(le)}update(le){Object.assign(le.revived,n.TestItem.toPlain(le.item)),this.f.has(le)||this.g.add(le)}remove(le){if(this.f.has(le)){this.f.delete(le);return}this.g.delete(le);const _=u.$$I.parentId(le.item.extId);if(_&&this.j.has(_.toString())){this.j.add(le.item.extId);return}this.h.add(le)}getChangeEvent(){const{f:le,g:_,h:ce}=this;return{get added(){return[...le].map(pe=>pe.revived)},get updated(){return[..._].map(pe=>pe.revived)},get removed(){return[...ce].map(pe=>pe.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class W extends m.$hJ{constructor(){super(...arguments),this.z=new T.$me,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(le){return this.g.get(le)}getMirroredTestDataByReference(le){return this.g.get(le.id)}y(le,_){return{...le,revived:n.TestItem.toPlain(le.item),depth:_?_.depth+1:0,children:new Set}}x(){return new M(this.z)}}class G{constructor(le){this.g=le}checkout(){this.f||(this.f=this.h());const le=this.f;return le.observers++,{onDidChangeTest:le.tests.onDidChangeTests,get tests(){return[...le.tests.rootTests].map(_=>_.revived)},dispose:(0,A.$db)(()=>{--le.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(le){return this.f?.tests.getMirroredTestDataByReference(le)}applyDiff(le){this.f?.tests.apply(le)}h(){const le=new W({asCanonicalUri:_=>_});return this.g.$subscribeToDiffs(),{observers:0,tests:le}}}const q=(me,le,_,ce)=>{_?Object.assign(_,ce):le.$updateTestRunConfig(me.controllerId,me.profileId,ce)};class J{#e;#t;#i;#n;#s;get label(){return this.g}set label(le){le!==this.g&&(this.g=le,q(this,this.#e,this.#n,{label:le}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(le){le!==this.h&&(this.h=le,q(this,this.#e,this.#n,{supportsContinuousRun:le}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(le){le!==this.isDefault&&(le?this.#t.add(this.profileId):this.#t.delete(this.profileId),q(this,this.#e,this.#n,{isDefault:le}))}get tag(){return this._tag}set tag(le){le?.id!==this._tag?.id&&(this._tag=le,q(this,this.#e,this.#n,{tag:le?n.TestTag.namespace(this.controllerId,le.id):null}))}get configureHandler(){return this.f}set configureHandler(le){le!==this.f&&(this.f=le,q(this,this.#e,this.#n,{hasConfigurationHandler:!!le}))}get onDidChangeDefault(){return T.Event.chain(this.#i,le=>le.map(_=>_.get(this.controllerId)?.get(this.profileId)).filter(k.$ng))}constructor(le,_,ce,pe,ae,Se,Oe,X,B,te=!1,ye=void 0,de=!1){this.controllerId=ae,this.profileId=Se,this.g=Oe,this.kind=X,this.runHandler=B,this._tag=ye,this.h=de,this.#e=le,this.#s=_,this.#t=ce,this.#i=pe,_.set(Se,this);const we=K[X];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);te&&ce.add(Se),this.#n={profileId:Se,controllerId:ae,tag:ye?n.TestTag.namespace(this.controllerId,ye.id):null,label:Oe,group:we,isDefault:te,hasConfigurationHandler:!1,supportsContinuousRun:de},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Sqc=J;const K={[t.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function oe(me,le){for(let _=0;_<me.path.length;_++){const ce=le.find(pe=>pe.id===me.path[_]);if(!ce)return;if(_===me.path.length-1)return ce;le=ce.children}}}),define(Ne[259],Me([1,0,17,6,4,5,128,8,7]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,v=Ve(v),O=Ve(O);class o extends I.$Vc{constructor(y,a){super(),this.m=a,this.a=new P.$me,this.b=new P.$me,this.c=new P.$me,this.f=new P.$me,this.g=new P.$me,this.h=new P.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(T.$ON.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:O.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:O.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?O.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(y.uri,d),s=r&&this.m.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new A.$vQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(O.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Hb(a.visibleRanges.map(O.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:O.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=$.TextEditorSelectionChangeKind.fromValue(a.selections.source),r=a.selections.selections.map(O.Selection.to);this.a.fire({textEditor:S.value,selections:r,kind:d})}if(a.visibleRanges){const d=v.$Hb(a.visibleRanges.map(O.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=O.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Zpc=o}),define(Ne[260],Me([1,0,2,3,5,4,7,8,18,37,14]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrc=e.$Krc=void 0,e.$Krc=(0,P.$Gi)("IExtHostTimeline");class y{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(I.$ON.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(s,c)=>{if(s&&s.$mid===o.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&$.$sn.equals(c,this.b.get(s.source)?.extension)){const l=s.uri===void 0?void 0:v.URI.revive(s.uri);return this.c.get(s.source)?.get(a(l))?.get(s.handle)}else return;return s}})}async $getTimeline(d,r,s,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(r),s,c)}registerTimelineProvider(d,r,s,c){const l=new T.$Uc,i=this.d(r.id,c,l).bind(this);let n;r.onDidChange&&(n=r.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:r.id}),this));const t=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(g,u,p){u?.resetCache&&(l.clear(),t.get(r.id)?.clear());const m=await r.provideTimeline(g,u,p);if(m==null)return;const h=i(g,u);return{...m,source:r.id,items:m.items.map(h)}},dispose(){for(const g of t.values())g.get(r.id)?.clear();n?.dispose(),l.dispose()}},s)}d(d,r,s){return(c,l)=>{let i;if(l?.cacheResults){let n=this.c.get(d);n===void 0&&(n=new Map,this.c.set(d,n));const t=a(c);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...g}=n,u=`${d}|${n.id??n.timestamp}`;i?.set(u,n);let p,m,h;n.iconPath&&(t instanceof A.$PO?h={id:t.id,color:t.color}:v.URI.isUri(t)?(p=t,m=t):{light:p,dark:m}=t);let E;return A.$iO.isMarkdownString(g.tooltip)?E=O.MarkdownString.from(g.tooltip):(0,k.$fg)(g.tooltip)?E=g.tooltip:A.$iO.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=O.MarkdownString.from(g.detail)):(0,k.$fg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:d,command:n.command?r.toInternal(n.command,s):void 0,icon:p,iconDark:m,themeIcon:h,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,T.$Tc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Lrc=y;function a(S){return S?.toString()}}),define(Ne[261],Me([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,164,24]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=void 0,o=Ve(o);function c(n,t){if((0,k.$fg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let g;return Array.isArray(n.highlights)&&(g=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:n.label,highlights:g}}}class l extends A.$Vc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new r.$T_;function p(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>p(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(h=>p(h)?this.r(h):h):m})}registerTreeDataProvider(t,g,u){const p=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>p.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const p=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),w={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:p,dragMimeTypes:m,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,w),R={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$jH)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$jH)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$7k)(f)&&(0,s.$jH)(u,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&o.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,b)=>D.reveal(f,b),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(R),R}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new O.$EG(t))}async $handleDrop(t,g,u,p,m,h,E,D){const w=this.a.get(t);if(!w)return Promise.reject(new O.$EG(t));const C=a.DataTransfer.toDataTransfer(u,async R=>(await this.f.$resolveDropFileData(t,g,R)).buffer);return E===t&&D&&await this.j(C,w,D,m,h),w.onDrop(C,p,m)}async j(t,g,u,p,m){const h=this.b.removeDragOperationTransfer(m);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(m&&g.handleDrag){const E=g.handleDrag(u,t,p);this.b.addDragOperationTransfer(m,E),await E}return t}async $handleDrag(t,g,u,p){const m=this.a.get(t);if(!m)return Promise.reject(new O.$EG(t));const h=await this.j(new o.$LO,m,g,p,u);if(!(!h||p.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new O.$EG(t);return g.hasResolve}$resolve(t,g,u){const p=this.a.get(t);if(!p)throw new O.$EG(t);return p.resolveTreeItem(g,u)}$setExpanded(t,g,u){const p=this.a.get(t);if(!p)throw new O.$EG(t);p.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const p=this.a.get(t);if(!p)throw new O.$EG(t);p.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new O.$EG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new O.$EG(t);u.setCheckboxState(g)}m(t,g,u){const p=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,p),p}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$Mrc=l;class i extends A.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,k.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,p,m,h){if(super(),this.I=t,this.J=u,this.L=p,this.M=m,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$xe,h.contributes&&h.contributes.views)for(const C in h.contributes.views)for(const R of h.contributes.views[C])R.id===t&&(this.P=R.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let E,D;const w=T.Event.debounce(this.F.event,(C,R)=>(C||(C={message:!1,elements:[]}),R.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(R.element)?C.elements.push(...R.element):C.elements.push(R.element)),R.message&&(C.message=!0),C),200,!0);this.B(w(({message:C,elements:R})=>{R.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(R).then(()=>f())})),C&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map(p=>p.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,k.$og)(g.select)?!0:g.select,p=(0,k.$og)(g.focus)?!1:g.focus,m=(0,k.$og)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:u,focus:p,expand:m})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:p,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$ub)(this.s,t);this.s=t;const p=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),p&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const p=this.getExtensionElement(u.treeItemHandle);return p?{extensionItem:p,treeItem:await this.f.getTreeItem(p),newState:u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const p=[];for(const m of t){const h=this.getExtensionElement(m);h&&p.push(h)}if(!(!this.g?.handleDrag||p.length===0))return await this.g.handleDrag(p,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const p=g?this.getExtensionElement(g):void 0;if(!(!p&&g||!this.g?.handleDrop))return(0,$.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(p,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const p=this.m.get(u);if(p){const m=await this.f.resolveTreeItem(p.extensionItem,u,g)??p.extensionItem;return this.hb(m),p.item.tooltip=this.eb(m.tooltip),p.item.command=this.fb(p.disposableStore,m.command),p.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then(p=>(u.push(p),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$yh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,$.$yh)(()=>this.f.getTreeItem(t)).then(p=>this.kb(t,p,g,!0)).then(p=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement(p);if(m){const h=this.m.get(m);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${p} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$xe(this.Z.token);try{const u=t?this.m.get(t):void 0,p=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,y.$Hb)(p||[]),h=await Promise.all((0,y.$Hb)(m).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,w)=>D?this.db(m[w],D,u):null);return(0,y.$Hb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new d.$xe,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(m=>this.m.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let h=m;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(m.item.handle)}const p=[];return g.forEach(m=>{const h=this.j.get(m);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&p.push(m)}}),p}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then(p=>{p&&(g[u]=p.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,$.$yh)(()=>this.f.getTreeItem(g)).then(p=>{if(p){const m=this.ib(g,p,u.parent);return this.pb(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}db(t,g,u){const p=this.ib(t,g,u);if(g.id&&this.j.has(p.item.handle))throw new Error((0,v.localize)(2702,null,g.id));return this.ob(t,p),this.qb(p,u),p}eb(t){return o.$iO.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,p;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,p=t.checkboxState.accessibilityInformation),{isChecked:g===o.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:p}}hb(t){if(!o.$GO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const p=this.B(new A.$Uc),m=this.kb(t,g,u),h=this.lb(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(p,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,k.$og)(g.collapsibleState)?o.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:p,dispose(){p.dispose()}}}jb(t){return t.iconPath instanceof o.$PO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:p},m,h){if(g)return`${i.b}/${g}`;const E=c(u,this.N),D=m?m.item.handle:i.a;let w=E?E.label:p?(0,P.$eh)(p):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,R=this.X(m)||[];let f,b=0;do{if(f=`${D}/${b}:${w}`,h||!this.j.has(f)||C===f)break;b++}while(b<=R.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof o.$PO))return typeof t.iconPath=="string"||I.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof o.$PO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return I.URI.isUri(t)?t:I.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,p){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const m=this.X(p)||[],h=m.filter(E=>E.item.handle===u.item.handle)[0];h&&m.splice(m.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ne[262],Me([1,0,6,4,2,38,8,67,5,7]),function(ve,e,v,P,I,T,A,O,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0,A=Ve(A),$=Ve($),o=Ve(o);class k extends P.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,s,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$me),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=s,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends P.$Vc{static c(){return(0,T.$3g)()}constructor(d,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$ON.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,s,c,l={}){const i=typeof c=="object"?c.viewColumn:c,n={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,O.$cqc)(d),g=y.c();this.f.$createWebviewPanel((0,O.$eqc)(d),g,r,{title:s,panelOptions:a(l),webviewOptions:(0,O.$fqc)(d,this.m,l),serializeBuffersForPostMessage:t},n);const u=this.j.createNewWebview(g,l,d);return this.createNewWebviewPanel(g,r,s,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((s,c)=>{const l=d[s],i=d[c];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const s of r){const c=this.getWebviewPanel(s);if(!c)continue;const l=d[s];c._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.$cqc)(d)}),new o.$QN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,s,c){const l=this.h.get(r);if(!l)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=l,t=this.j.createNewWebview(d,s.webviewOptions,n),g=this.createNewWebviewPanel(d,r,s.title,c,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(g,s.state)}createNewWebviewPanel(d,r,s,c,l,i,n){const t=new k(d,this.f,i,{viewType:r,title:s,viewColumn:c,panelOptions:l,active:n});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$gqc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Ne[263],Me([1,0,6,4,67,8,5,7]),function(ve,e,v,P,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=void 0,A=Ve(A),O=Ve(O);class $ extends P.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,r,s){super(),this.#s=!1,this.#l=this.B(new v.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$me),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class o{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$ON.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,I.$eqc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$cqc)(y)}),new O.$QN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,r){const s=this.b.get(a);if(!s)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=s,i=this.d.createNewWebview(y,{},l),n=new $(y,this.a,a,S,i,!0);this.c.set(y,n),await c.resolveWebviewView(n,{state:d},r)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$Prc=o}),define(Ne[264],Me([1,0,6,30,31,3]),function(ve,e,v,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.OutputChannelUpdateMode=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0,e.$WM="text/x-code-output",e.$XM="output",e.$YM="Log",e.$ZM="text/x-code-log-output",e.$1M="log",e.$2M="workbench.panel.output",e.$3M=new I.$Xj("inOutput",!1),e.$4M=new I.$Xj("activeLogOutput",!1),e.$5M=new I.$Xj("activeLogOutput.levelSettable",!1),e.$6M=new I.$Xj("activeLogOutput.level",""),e.$7M=new I.$Xj("activeLogOutput.levelIsDefault",!1),e.$8M=new I.$Xj("outputView.scrollLock",!1),e.$9M=(0,T.$Gi)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$0M={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new v.$me,this.onDidRegisterChannel=this.b.event,this.c=new v.$me,this.onDidRemoveChannel=this.c.event}registerChannel(o){this.a.has(o.id)||(this.a.set(o.id,o),this.b.fire(o.id))}getChannels(){const o=[];return this.a.forEach(k=>o.push(k)),o}getChannel(o){return this.a.get(o)}removeChannel(o){this.a.delete(o),this.c.fire(o)}}P.$so.add(e.$0M.OutputChannels,new O),e.$$M=new I.$Xj("activeOutputChannel","")}),define(Ne[129],Me([1,0,5,3,16,18,11,264,68,26,50,166,22,14,29,6,4]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=e.$src=void 0;class c extends A.$hk{get disposed(){return this.n}constructor(t,g,u,p,m){super(),this.id=t,this.name=g,this.r=u,this.s=p,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Oe.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,p,m,h){this.i=g,this.j=u,this.k=p,this.l=m,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$ON.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const p=typeof g=="object"&&g.log,m=(0,S.$fg)(g)?g:void 0;if((0,S.$fg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([w])=>T.$sn.equals(u.identifier,w))?.[1];E&&(h=(0,A.$sk)(E));const D=p?this.o(t,h,u):this.n(t,m,u);return D.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),p?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const p=await this.c,m=this.k.extUri.joinPath(p,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,m,g,u.identifier.value);return new c(E,t,h,this.a,u)}async o(t,g,u){const p=await this.p(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(p,`${m}.log`),E=`${u.identifier.value}.${m}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch(p){if((0,d.$rl)(p)!==d.FileSystemProviderErrorCode.FileExists)throw p}return u})())}return g}q(t,g){let u=!1;const p=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){p(),g.then(h=>h.append(m))},appendLine(m){p(),g.then(h=>h.appendLine(m))},clear(){p(),g.then(m=>m.clear())},replace(m){p(),g.then(h=>h.replace(m))},show(m,h){p(),g.then(E=>E.show(m,h))},hide(){p(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}r(t,g,u){const p=new s.$Uc,m=()=>{if(p.isDisposed)throw new Error("Channel has been closed")},h=p.add(new r.$me);function E(D){g=D,h.fire(D)}return u.then(D=>{p.add(D),D.logLevel!==g&&E(D.logLevel),p.add(D.onDidChangeLogLevel(w=>E(w)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...w){m(),u.then(C=>C.trace(D,...w))},debug(D,...w){m(),u.then(C=>C.debug(D,...w))},info(D,...w){m(),u.then(C=>C.info(D,...w))},warn(D,...w){m(),u.then(C=>C.warn(D,...w))},error(D,...w){m(),u.then(C=>C.error(D,...w))},dispose(){p.dispose()}}}};e.$src=i,e.$src=i=Je([We(0,I.$oQ),We(1,o.$EQ),We(2,$.$$pc),We(3,k.$Npc),We(4,A.$ck),We(5,A.$bk)],i),e.$trc=(0,P.$Gi)("IExtHostOutputService")}),define(Ne[130],Me([1,0,3,10]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=void 0,e.$Xm=(0,v.$Gi)("remoteAgentService"),e.$Ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let T=1/0;for(let O=0;O<this.maxSampleCount;O++){const $=await I.getRoundTripTime();if($===void 0)return;T=Math.min(T,$/2),await(0,P.$Hh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((O,$)=>O+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((O,$)=>O+$,0)/this.average.length,high:typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ne[265],Me([1,0,9,53,30,49,43,4,6,130,20,25,10,114]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=void 0,e.$hL=Object.freeze({id:"application",order:100,title:(0,v.localize)(3962,null),type:"object"}),e.$iL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(3963,null),type:"object"}),e.$jL=Object.freeze({id:"security",scope:P.ConfigurationScope.APPLICATION,title:(0,v.localize)(3964,null),type:"object",order:7}),e.$kL=Object.freeze({id:"problems",title:(0,v.localize)(3965,null),type:"object",order:101}),e.$lL=Object.freeze({id:"window",order:8,title:(0,v.localize)(3966,null),type:"object"}),e.$mL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;I.$so.add(e.$mL.ConfigurationMigration,r);let s=class extends O.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(g=>this.g(g,n?.uri))])}async g(n,t){const g=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[p,m]of u){const h=g[p];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(n,p,h.value,t,void 0);for(const w of D??[])E.push([w,[]])}for(const{identifiers:D,value:w}of h.overrides??[])if(w!==void 0){const C=await this.h(n,p,w,t,D);for(const R of C??[])E.push([R,D])}E.length&&await Promise.allSettled(E.map(async([[D,w],C])=>this.a.updateValue(D,w.value,{resource:t,overrideIdentifiers:C},m)))}}async h(n,t,g,u,p){const m=E=>{const w=this.a.inspect(E,{resource:u})[t];if(w)return p?w.overrides?.find(({identifiers:C})=>(0,y.$jo)(C,p))?.value:w.value},h=await n.migrateFn(g,m);return Array.isArray(h)?h:[[n.key,h]]}};e.$nL=s,e.$nL=s=Je([We(0,A.$aj),We(1,T.$Pi)],s);let c=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new a.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!k.$j&&(await this.b.getEnvironment())?.os!==k.OperatingSystem.Windows)return;I.$so.as(P.$xo.Configuration).registerConfiguration({...e.$jL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(3967,null)},default:[],markdownDescription:(0,v.localize)(3968,null),scope:P.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(3969,null),scope:P.ConfigurationScope.MACHINE}}})}};e.$oL=c,e.$oL=c=Je([We(0,o.$Xm)],c),e.$pL="window.newWindowProfile";let l=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$pL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=I.$so.as(P.$xo.Configuration),t={...e.$lL,properties:{[e.$pL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(3970,null)],description:(0,v.localize)(3971,null),scope:P.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$pL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$pL);if(!n)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$pL,t?.name)}};e.$qL=l,e.$qL=l=Je([We(0,S.$Nl),We(1,A.$aj)],l)}),define(Ne[266],Me([1,0,41,15,19,23,9,265,53,3,30]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$sL=e.$rL=void 0,e.$tL=r,e.$uL=s,v=Ve(v),e.$rL=(0,o.$Gi)("editorResolverService"),e.$sL="workbench.editorAssociations";const y=k.$so.as($.$xo.Configuration),a={...O.$iL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(12105,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function s(c,l){if(new Set([P.Schemas.extension,P.Schemas.webviewPanel,P.Schemas.vscodeWorkspaceTrust,P.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof c=="string"&&c.indexOf(I.$hc.sep)>=0?`${l.scheme}:${l.path}`:(0,T.$eh)(l);return v.$Ak(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Ne[267],Me([1,0,51,15,19,20,23,2,3,186,49,205,130]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0,e.$qN=(0,$.$Gi)("pathService");let d=S=class{constructor(s,c,l,i){this.d=s,this.e=c,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??s})()}hasValidBasename(s,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(s,i,c)):this.h(s,c,l)}h(s,c,l){return s.scheme===P.Schemas.file||s.scheme===P.Schemas.vscodeRemote?(0,v.$Dg)(l??(0,A.$eh)(s),c===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,c){if(s.remoteAuthority)return P.Schemas.vscodeRemote;const l=(0,o.$nN)(c.getWorkspace());if(l)return l;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=c.getWorkspace().configuration;return n?n.scheme:P.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===T.OperatingSystem.Windows?I.$gc:I.$hc)}async fileURI(s){let c="";if(await this.a===T.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(c=s.substring(2),s="/"):(c=s.substring(2,i),s=s.substring(i)||"/")}return O.URI.from({scheme:P.Schemas.file,authority:c,path:s,query:"",fragment:""})}};e.$rN=d,e.$rN=d=S=Je([We(1,a.$Xm),We(2,y.$_M),We(3,k.$Pi)],d)}),define(Ne[131],Me([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$4L=e.$3L=e.TextSearchCompleteMessageType=e.$2L=e.$1L=void 0,e.$5L=y;class P{constructor(S,d){this.line=S,this.character=d}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,d){return new P(0,0)}with(S){return new P(0,0)}}e.$1L=P;class I{constructor(S,d,r,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new P(S,d),this.end=new P(r,s)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new I(0,0,0,0)}with(S){return new I(0,0,0,0)}}e.$2L=I;var T;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}));class A{constructor(S,d,r){this.uri=S,this.ranges=d,this.previewText=r}}e.$3L=A;class O{constructor(S,d,r){this.uri=S,this.text=d,this.lineNumber=r}}e.$4L=O;var $;(function(a){a[a.None=1]="None",a[a.FilesExclude=2]="FilesExclude",a[a.SearchAndFilesExclude=3]="SearchAndFilesExclude"})($||(e.ExcludeSettingOptions=$={}));var o;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(o||(e.TextSearchCompleteMessageTypeNew=o={}));function k(a){return"uri"in a&&"ranges"in a&&"preview"in a}function y(a){if(k(a)){const S=(0,v.$2b)(a.ranges).map(d=>({sourceRange:d,previewRange:d}));return new A(a.uri,S,a.preview.text)}else return new O(a.uri,a.text,a.lineNumber)}}),define(Ne[44],Me([1,0,17,41,25,51,12,3,19,13,131,10]),function(ve,e,v,P,I,T,A,O,$,o,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$qM=e.$jM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$gM=e.$fM=e.$eM=e.$dM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TextSearchCompleteMessageType=void 0,e.$aM=c,e.$bM=l,e.$cM=i,e.$hM=D,e.$iM=w,e.$kM=f,e.$lM=b,e.$mM=L,e.$nM=N,e.$oM=M,e.$pM=W,e.$rM=q,e.$tM=oe,e.$uM=me,P=Ve(P),I=Ve(I),T=Ve(T),$=Ve($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return k.TextSearchCompleteMessageType}}),e.$6L="workbench.view.search",e.$7L="workbench.panel.search",e.$8L="workbench.view.search",e.$9L="search-result",e.$0L="search.exclude",e.$$L=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$_L=(0,O.$Gi)("searchService");var r;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(s||(e.QueryType=s={}));function c(_){return!!_.preview}function l(_){return!!_.resource}function i(_){return!!_.message}var n;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$dM=t;class g{constructor(ce,pe,ae,Se){this.ranges=pe,this.webviewIndex=Se;const Oe=Array.isArray(pe)?pe:[pe];if(ae&&ae.matchLines===1&&u(Oe)){ce=(0,A.$$f)(ce,ae.matchLines);let X="",B=0,te=0;const ye=Math.floor(ae.charsPerLine/5),de=[];for(const we of Oe){const he=Math.max(we.startColumn-ye,0),Z=we.startColumn+ae.charsPerLine;if(he>te+ye+d){const x=a+(he-te)+S;X+=x+ce.slice(he,Z),B+=he-(te+x.length)}else X+=ce.slice(te,Z);de.push(new m(0,we.startColumn-B,we.endColumn-B)),te=Z}this.preview={text:X,matches:Array.isArray(this.ranges)?de:de[0]}}else{const X=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:ce,matches:(0,v.$1b)(pe,B=>new p(B.startLineNumber-X,B.startColumn,B.endLineNumber-X,B.endColumn))}}}}e.$eM=g;function u(_){const ce=_[0].startLineNumber;for(const pe of _)if(pe.startLineNumber!==ce||pe.endLineNumber!==ce)return!1;return!0}class p{constructor(ce,pe,ae,Se){this.startLineNumber=ce,this.startColumn=pe,this.endLineNumber=ae,this.endColumn=Se}}e.$fM=p;class m extends p{constructor(ce,pe,ae){super(ce,pe,ce,ae)}}e.$gM=m;var h;(function(_){_.List="list",_.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(_,ce=!0){const pe=_&&_.files&&_.files.exclude,ae=ce&&_&&_.search&&_.search.exclude;if(!pe&&!ae)return;if(!pe||!ae)return pe||ae||void 0;let Se=Object.create(null);return Se=I.$io(Se,I.$fo(pe)),Se=I.$io(Se,I.$fo(ae),!0),Se}function w(_,ce){return _.excludePattern&&P.$Ak(_.excludePattern,ce)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&P.$Ak(_.includePattern,ce)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(pe=>{const ae=pe.folder.fsPath;if(T.$Fg(ce,ae)){const Se=$.$mc(ae,ce);return!pe.includePattern||!!P.$Ak(pe.includePattern,Se)}else return!1}):!1:!0}var C;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class R extends Error{constructor(ce,pe){super(ce),this.code=pe}}e.$jM=R;function f(_){const ce=_.message;if((0,o.$4)(_))return new R(ce,C.canceled);try{const pe=JSON.parse(ce);return new R(pe.message,pe.code)}catch{return new R(ce,C.other)}}function b(_){const ce={message:_.message,code:_.code};return new Error(JSON.stringify(ce))}function L(_){return _.type==="error"?!0:_.type==="success"}function N(_){return _.type==="success"}function M(_){return!!_.path}function W(_,ce,pe=!0){const ae=_.searchPath?_.searchPath:_.relativePath;return pe?(0,A.$8f)(ae,ce):P.$Ak(ce,ae)}class G{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$qM=G;function q(_,ce){const pe={..._||{},...ce||{}};return Object.keys(pe).filter(ae=>{const Se=pe[ae];return typeof Se=="boolean"&&Se})}class J{constructor(ce,pe){this.c=null,this.a={...ce.excludePattern||{},...pe.excludePattern||{}},this.b=P.$Bk(this.a);let ae=ce.includePattern;pe.includePattern&&(ae?ae={...ae,...pe.includePattern}:ae=pe.includePattern),ae&&(this.c=P.$Bk(ae))}matchesExcludesSync(ce,pe,ae){return!!(this.b&&this.b(ce,pe,ae))}includedInQuerySync(ce,pe,ae){return!(this.b&&this.b(ce,pe,ae)||this.c&&!this.c(ce,pe,ae))}includedInQuery(ce,pe,ae){const Se=this.b(ce,pe,ae),Oe=()=>this.c?!!this.c(ce,pe,ae):!0;return(0,y.$sh)(Se)?Se.then(X=>X?!1:Oe()):Oe()}hasSiblingExcludeClauses(){return K(this.a)}}e.$sM=J;function K(_){for(const ce in _)if(typeof _[ce]!="boolean")return!0;return!1}function oe(_){if(!_)return;let ce;return pe=>(ce||(ce=(_()||Promise.resolve([])).then(ae=>ae?le(ae):{})),ce.then(ae=>!!ae[pe]))}function me(_){if(!_)return;let ce;return pe=>{if(!ce){const ae=_();ce=ae?le(ae):{}}return!!ce[pe]}}function le(_){const ce={};for(const pe of _)ce[pe]=!0;return ce}}),define(Ne[45],Me([1,0,17,10,21,6,4,58,15,141,23,12,2,9,29,3,11,174,49,50,26,16,8,7,65,44,5,36]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=e.$5pc=void 0;function D(M,W,G){return new k.$9g(q=>f(q,G)).isEqual(M,W)}function w(M,W,G){return D(M.uri,W.uri,G)?0:(0,y.$zf)(M.uri.toString(),W.uri.toString())}function C(M,W,G){return M.index!==W.index?M.index<W.index?-1:1:D(M.uri,W.uri,G)?(0,y.$zf)(M.name,W.name):(0,y.$zf)(M.uri.toString(),W.uri.toString())}function R(M,W,G,q){const J=M.slice(0).sort((oe,me)=>G(oe,me,q)),K=W.slice(0).sort((oe,me)=>G(oe,me,q));return(0,v.$Eb)(J,K,(oe,me)=>G(oe,me,q))}function f(M,W){const G=W.getCapabilities(M.scheme);return!(G&&G&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends l.$Zi{static toExtHostWorkspace(W,G,q,J){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:oe,folders:me,configuration:le,transient:_,isUntitled:ce}=W,pe=[],ae=G;G?me.forEach((B,te)=>{const ye=a.URI.revive(B.uri),de=b.o(q||G,ye,J);de?(de.name=B.name,de.index=B.index,pe.push(de)):pe.push({uri:ye,name:B.name,index:te})}):pe.push(...me.map(({uri:B,name:te,index:ye})=>({uri:a.URI.revive(B),name:te,index:ye}))),pe.sort((B,te)=>B.index<te.index?-1:1);const Se=new b(K,oe,pe,!!_,le?a.URI.revive(le):null,!!ce,B=>f(B,J)),{added:Oe,removed:X}=R(ae?ae.workspaceFolders:[],Se.workspaceFolders,w,J);return{workspace:Se,added:Oe,removed:X}}static o(W,G,q){for(let J=0;J<W.folders.length;J++){const K=W.workspaceFolders[J];if(D(K.uri,G,q))return K}}constructor(W,G,q,J,K,oe,me){super(W,q.map(le=>new l.$1i(le)),J,K,me),this.t=G,this.u=oe,this.q=[],this.s=O.$Mi.forUris(me,()=>!0),q.forEach(le=>{this.q.push(le),this.s.set(le.uri,le)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,G){return G&&this.s.get(W)&&(W=(0,k.$gh)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let L=class{constructor(W,G,q,J,K){this.c=new T.$me,this.onDidChangeWorkspace=this.c.event,this.g=new T.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$oe,this.C=new Map,this.h=J,this.s=q,this.t=K,this.j=new o.$Om,this.k=new P.$Fh,this.o=W.getProxy(h.$ON.MainThreadWorkspace),this.q=W.getProxy(h.$ON.MainThreadMessageService);const oe=G.workspace;this.l=oe?new b(oe.id,oe.name,[],!!oe.transient,oe.configuration?a.URI.revive(oe.configuration):null,!!oe.isUntitled,me=>f(me,q)):void 0}$initializeWorkspace(W,G){this.v=G,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:$.Schemas.untitled,path:(0,k.$eh)((0,k.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,G,q,...J){const K=[];if(Array.isArray(J)&&J.forEach(ce=>{a.URI.isUri(ce.uri)&&!K.some(pe=>D(pe.uri,ce.uri,this.s))&&K.push({uri:ce.uri,name:ce.name||(0,k.$dh)(ce.uri)})}),this.n||[G,q].some(ce=>typeof ce!="number"||ce<0)||q===0&&K.length===0)return!1;const oe=this.x?this.x.workspaceFolders:[];if(G+q>oe.length)return!1;const me=oe.slice(0);me.splice(G,q,...K.map(ce=>({uri:ce.uri,name:ce.name||(0,k.$dh)(ce.uri),index:void 0})));for(let ce=0;ce<me.length;ce++){const pe=me[ce];if(me.some((ae,Se)=>Se!==ce&&D(pe.uri,ae.uri,this.s)))return!1}me.forEach((ce,pe)=>ce.index=pe);const{added:le,removed:_}=R(oe,me,C,this.s);if(le.length===0&&_.length===0)return!1;if(this.o){const ce=W.displayName||W.name;this.o.$updateWorkspaceFolders(ce,G,q,K).then(void 0,pe=>{this.n=void 0;const ae={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(2705,null,ce,pe.toString()),ae,[])})}return this.y(me),!0}getWorkspaceFolder(W,G){if(this.x)return this.x.getWorkspaceFolder(W,G)}async getWorkspaceFolder2(W,G){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,G)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,G){let q,J="";if(typeof W=="string"?(q=a.URI.file(W),J=W):typeof W<"u"&&(q=W,J=W.fsPath),!q)return J;const K=this.getWorkspaceFolder(q,!0);if(!K)return J;typeof G>"u"&&this.x&&(G=this.x.folders.length>1);let oe=(0,k.$jh)(K.uri,q);return G&&K.name&&(oe=`${K.name}/${oe}`),oe}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:G,added:q,removed:J}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=G||void 0,this.n=void 0,this.c.fire(Object.freeze({added:q,removed:J}))}findFiles(W,G,q,J,K=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${J.value}, entryPoint: findFiles`);let oe="",me=!0;return G===null?me=!1:G!==void 0&&(typeof G=="string"?oe=G:oe=G.pattern),this.z(W,void 0,{exclude:oe,maxResults:q,useDefaultExcludes:me,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,G={},q,J=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${q.value}, entryPoint: findFiles2`),this.z(void 0,W,G,J)}async z(W,G,q,J=I.CancellationToken.None){if(J&&J.isCancellationRequested)return Promise.resolve([]);const K=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,oe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof q.useDefaultSearchExcludes=="boolean"?!q.useDefaultSearchExcludes:!1,maxResults:q.maxResults,excludePattern:K,shouldGlobSearch:typeof q.fuzzy=="boolean"?!q.fuzzy:!0,_reason:"startFileSearch"};let me;if(W){const{includePattern:le,folder:_}=N(g.GlobPattern.from(W));me=_,oe.includePattern=le}else{const{includePattern:le,folder:_}=N(g.GlobPattern.from(G));me=_,oe.filePattern=le}return this.o.$startFileSearch(me??null,oe,J).then(le=>Array.isArray(le)?le.map(_=>a.URI.revive(_)):[])}async findTextInFiles(W,G,q,J,K=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${J.value}, entryPoint: findTextInFiles`);const oe=this.j.getNext(),me=typeof G.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:G.previewOptions,{includePattern:le,folder:_}=N(g.GlobPattern.from(G.include)),ce=typeof G.exclude=="string"?G.exclude:G.exclude?G.exclude.pattern:void 0,pe={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useGlobalIgnoreFiles=="boolean"?!G.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof G.useParentIgnoreFiles=="boolean"?!G.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof G.useDefaultExcludes=="boolean"?!G.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof G.useSearchExclude=="boolean"?!G.useSearchExclude:!0,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:me,afterContext:G.afterContext,beforeContext:G.beforeContext,includePattern:le,excludePattern:ce},ae=!1;if(this.u[oe]=Se=>{if(ae)return;const Oe=a.URI.revive(Se.resource);Se.results.forEach(X=>{const B=(0,E.$di)(X);(0,m.$aM)(B)?q({uri:Oe,preview:{text:B.preview.text,matches:(0,v.$1b)(B.preview.matches,te=>new u.$SN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$1b)(B.ranges,te=>new u.$SN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):q({uri:Oe,text:B.text,lineNumber:B.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(W,_??null,pe,oe,K);return delete this.u[oe],Se||{}}catch(Se){throw delete this.u[oe],Se}}$handleTextSearchResult(W,G){this.u[G]?.(W)}async save(W){const G=await this.o.$save(W,{saveAs:!1});return a.URI.revive(G)}async saveAs(W){const G=await this.o.$save(W,{saveAs:!0});return a.URI.revive(G)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}lookupAuthorization(W){return this.o.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this.o.$lookupKerberosAuthorization(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,G){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,G);const q=this.t.transformOutgoingScheme(W),J=this.A++;return this.o.$registerEditSessionIdentityProvider(J,q),(0,A.$Tc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(J)})}async $getEditSessionIdentifier(W,G){this.h.info("Getting edit session identifier for workspaceFolder",W);const q=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const J=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!J),!J)return;const K=await J.provideEditSessionIdentity(q,G);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,G,q,J){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const oe=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!oe),!oe)return;const me=await oe.provideEditSessionIdentityMatch?.(G,q,J);if(this.h.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(W){return(G,q,J)=>{const K=function(me){G.call(q,me)};return K.extension=W,this.B.event(K,void 0,J)}}async $onWillCreateEditSessionIdentity(W,G,q){const J=await this.resolveWorkspaceFolder(a.URI.revive(W));if(J===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:J},G,async(K,oe)=>{const me=Date.now();await Promise.resolve(K),Date.now()-me>q&&this.h.warn("SLOW edit session create-participant",oe.extension.identifier)}),G.isCancellationRequested}registerCanonicalUriProvider(W,G){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,G);const q=this.t.transformOutgoingScheme(W),J=this.A++;return this.o.$registerCanonicalUriProvider(J,q),(0,A.$Tc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(J)})}async provideCanonicalUri(W,G,q){const J=this.C.get(W.scheme);if(!J)return;const K=await J.provideCanonicalUri?.(a.URI.revive(W),G,q);if(K)return K}async $provideCanonicalUri(W,G,q){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:G},q)}};e.$5pc=L,e.$5pc=L=Je([We(0,t.$oQ),We(1,n.$EQ),We(2,i.$Npc),We(3,s.$bk),We(4,p.$3pc)],L),e.$6pc=(0,r.$Gi)("IExtHostWorkspace");function N(M){let W,G;return M&&(typeof M=="string"?W=M:(W=M.pattern,G=a.URI.revive(M.baseUri))),{includePattern:W,folder:G}}}),define(Ne[46],Me([1,0,25,6,45,5,7,43,175,53,14,10,3,16,11,2]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=e.$7pc=void 0;function s(p,m){if(m){const h=m.split(".");let E=p;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c(p){return p instanceof r.URI}function l(p){return p&&p.uri instanceof r.URI&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&p.uri instanceof r.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function t(p){if(c(p))return{resource:p};if(l(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(i(p))return{overrideIdentifier:p.languageId};if(n(p))return{resource:p.uri};if(p===null)return{resource:null}}let g=class{constructor(m,h,E){this.a=m.getProxy(T.$ON.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new u(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(m,h))}};e.$7pc=g,e.$7pc=g=Je([We(0,S.$oQ),We(1,I.$6pc),We(2,d.$bk)],g);class u{constructor(m,h,E,D){this.a=new P.$me,this.b=m,this.f=D,this.c=h,this.e=$.$So.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$So.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(m,h,E){const D=t(h)||{},w=this.g(m?s(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,E?.identifier);function C(f){if(f==null)return null;if(typeof f=="boolean")return f?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const R={has(f){return typeof s(w,f)<"u"},get:(f,b)=>{this.h(m?`${m}.${f}`:f,D,E?.identifier);let L=s(w,f);if(typeof L>"u")L=b;else{let N;const M=(W,G)=>{if((0,k.$hg)(W)){let q;const J=()=>{N=N||(0,v.$fo)(w),q=q||s(N,G)};return new Proxy(W,{get:(K,oe)=>{if(typeof oe=="string"&&oe.toLowerCase()==="tojson")return J(),()=>q;if(N)return q=q||s(N,G),q[oe];const me=K[oe];return typeof oe=="string"?M(me,`${G}.${oe}`):me},set:(K,oe,me)=>(J(),q&&(q[oe]=me),!0),deleteProperty:(K,oe)=>(J(),q&&delete q[oe],!0),defineProperty:(K,oe,me)=>(J(),q&&Object.defineProperty(q,oe,me),!0)})}return Array.isArray(W)?(0,v.$fo)(W):W};L=M(L,f)}return L},update:(f,b,L,N)=>{f=m?`${m}.${f}`:f;const M=C(L);return b!==void 0?this.b.$updateConfigurationOption(M,f,b,D,N):this.b.$removeConfigurationOption(M,f,D,N)},inspect:f=>{f=m?`${m}.${f}`:f;const b=this.e.inspect(f,D,this.c.workspace);if(b)return{key:f,defaultValue:(0,v.$fo)(b.policy?.value??b.default?.value),globalValue:(0,v.$fo)(b.user?.value??b.application?.value),workspaceValue:(0,v.$fo)(b.workspace?.value),workspaceFolderValue:(0,v.$fo)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$fo)(b.default?.override),globalLanguageValue:(0,v.$fo)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$fo)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$fo)(b.workspaceFolder?.override),languageIds:(0,v.$fo)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,v.$io)(R,w,!1),Object.freeze(R)}g(m){const h=E=>(0,k.$hg)(E)?new Proxy(E,{get:(D,w)=>h(D[w]),set:(D,w,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(D,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(D,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(m)}h(m,h,E){const D=o.$Ho.test(m)?o.ConfigurationScope.RESOURCE:this.d.get(m),w=E?`[${E.value}] `:"";if(o.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(o.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,h){const E=new $.$Uo(m,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,w)=>E.affectsConfiguration(D,t(w))})}k(m){return m.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$8pc=u,e.$9pc=(0,a.$Gi)("IExtHostConfiguration")}),define(Ne[132],Me([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=e.$Erc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=Ve(A),s=Ve(s);var t;(function(N){function M(G){if(G!=null)return G}N.from=M;function W(G){if(G!=null)return G}N.to=W})(t||(t={}));var g;(function(N){function M(G){if(G!=null)return G}N.from=M;function W(G){if(G!=null)return G}N.to=W})(g||(g={}));var u;(function(N){function M(G){if(G!=null)return G}N.from=M;function W(G){if(G!=null)return G}N.to=W})(u||(u={}));var p;(function(N){function M(q){if(q){const J=q;return J&&!!J.process}else return!1}N.is=M;function W(q){if(q==null)return;const J={process:q.process,args:q.args};return q.options&&(J.options=u.from(q.options)),J}N.from=W;function G(q){if(q!=null)return new A.$CO(q.process,q.args,q.options)}N.to=G})(p||(p={}));var m;(function(N){function M(G){if(G!=null)return G}N.from=M;function W(G){if(G!=null)return G}N.to=W})(m||(m={}));var h;(function(N){function M(q){if(q){const J=q;return J&&(!!J.commandLine||!!J.command)}else return!1}N.is=M;function W(q){if(q==null)return;const J={};return q.commandLine!==void 0?J.commandLine=q.commandLine:(J.command=q.command,J.args=q.args),q.options&&(J.options=m.from(q.options)),J}N.from=W;function G(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new A.$DO(q.commandLine,q.options):new A.$DO(q.command,q.args?q.args:[],q.options)}N.to=G})(h||(h={}));var E;(function(N){function M(q){if(q){const J=q;return J&&J.customExecution==="customExecution"}else return!1}N.is=M;function W(q){return{customExecution:"customExecution"}}N.from=W;function G(q,J){return J.get(q)}N.to=G})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function M(W,G){let q;return W.scope!==void 0&&typeof W.scope!="number"?q=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&G&&G.workspaceFile?q=G.workspaceFile:q=i.$ZI),{id:W._id,workspaceFolder:q}}N.from=M})(D||(e.TaskHandleDTO=D={}));var w;(function(N){function M(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}N.from=M})(w||(w={}));var C;(function(N){function M(q,J){if(q==null)return[];const K=[];for(const oe of q){const me=W(oe,J);me&&K.push(me)}return K}N.fromMany=M;function W(q,J){if(q==null)return;let K;q.execution instanceof A.$CO?K=p.from(q.execution):q.execution instanceof A.$DO?K=h.from(q.execution):q.execution&&q.execution instanceof A.$EO&&(K=E.from(q.execution));const oe=t.from(q.definition);let me;return q.scope?typeof q.scope=="number"?me=q.scope:me=q.scope.uri:me=A.TaskScope.Workspace,!oe||!me?void 0:{_id:q._id,definition:oe,name:q.name,source:{extensionId:J.identifier.value,label:q.source,scope:me},execution:K,isBackground:q.isBackground,group:w.from(q.group),presentationOptions:g.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}N.from=W;async function G(q,J,K){if(q==null)return;let oe;p.is(q.execution)?oe=p.to(q.execution):h.is(q.execution)?oe=h.to(q.execution):E.is(q.execution)&&(oe=E.to(q._id,K));const me=t.to(q.definition);let le;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?le=q.source.scope:le=await J.resolveWorkspaceFolder(v.URI.revive(q.source.scope)):le=A.TaskScope.Workspace),!me||!le)return;const _=new A.$FO(me,le,q.name,q.source.label,oe,q.problemMatchers);return q.isBackground!==void 0&&(_.isBackground=q.isBackground),q.group!==void 0&&(_.group=A.$BO.from(q.group._id),_.group&&q.group.isDefault&&(_.group=new A.$BO(_.group.id,_.group.label),q.group.isDefault===!0&&(_.group.isDefault=q.group.isDefault))),q.presentationOptions&&(_.presentationOptions=g.to(q.presentationOptions)),q._id&&(_._id=q._id),q.detail&&(_.detail=q.detail),_}N.to=G})(C||(e.TaskDTO=C={}));var R;(function(N){function M(G){return G}N.from=M;function W(G){if(G)return Object.assign(Object.create(null),G)}N.to=W})(R||(R={}));class f{#e;constructor(M,W,G){this._id=W,this.a=G,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let b=class{constructor(M,W,G,q,J,K,oe,me){this.q=new I.$me,this.r=new I.$me,this.s=new I.$me,this.u=new I.$me,this.a=M.getProxy(T.$ON.MainThreadTask),this.b=G,this.c=q,this.d=J,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=oe,this.g=me,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,W,G){if(!G)return new A.$QN(()=>{});const q=this.x();return this.j.set(q,{type:W,provider:G,extension:M}),this.a.$registerTaskProvider(q,W),new A.$QN(()=>{this.j.delete(q),this.a.$unregisterTaskProvider(q)})}registerTaskSystem(M,W){this.a.$registerTaskSystem(M,W)}fetchTasks(M){return this.a.$fetchTasks(R.from(M)).then(async W=>{const G=[];for(const q of W){const J=await C.to(q,this.b,this.m);J&&G.push(J)}return G})}get taskExecutions(){const M=[];return this.k.forEach(W=>M.push(W)),M}terminateTask(M){if(!(M instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,W,G){const q=this.m.get(M.id);q&&(this.o.set(M.id,q),this.e.attachPtyToTerminal(W,await q.callback(G))),this.p=M.id,this.q.fire({execution:await this.z(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){if(!this.l.has(M.id))return;const W=await this.z(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const W=await this.z(M.id);this.s.fire({execution:W,processId:M.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(M){const W=await this.z(M.id);this.u.fire({execution:W,exitCode:M.exitCode})}$provideTasks(M,W){const G=this.j.get(M);if(!G)return Promise.reject(new Error("no handler found"));const q=[],J=(0,P.$yh)(()=>G.provider.provideTasks(k.CancellationToken.None)).then(K=>this.v(W,q,G,K));return new Promise(K=>{J.then(oe=>{Promise.all(q).then(()=>{K(oe)})})})}async $resolveTask(M,W){const G=this.j.get(M);if(!G)return Promise.reject(new Error("no handler found"));if(W.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${G.type}].`);const q=await C.to(W,this.b,this.m);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const J=await G.provider.resolveTask(q,k.CancellationToken.None);if(!J)return;this.A(J,G);const K=C.from(J,G.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(K.execution)&&await this.y(K,J,!0),await this.w(K)}x(){return this.h++}async y(M,W,G){const q=await this.a.$createTaskId(M);!G&&!this.m.has(q)&&(this.n.add(q),this.o.set(q,W.execution)),this.m.set(q,W.execution)}async z(M,W){if(typeof M=="string"){const J=this.l.get(M);if(!J)throw new n.$bb("Unexpected: The specified task is missing an execution");return J}const G=this.l.get(M.id);if(G)return G;let q;return W?q=Promise.resolve(new f(this,M.id,W)):q=C.to(M.task,this.b,this.m).then(J=>{if(!J)throw new n.$bb("Unexpected: Task does not exist.");return new f(this,M.id,J)}),this.l.set(M.id,q),q.then(J=>(this.k.set(M.id,J),J))}A(M,W){M._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const G=this.n.values();let q=G.next();for(;!q.done;)!this.o.has(q.value)&&this.p!==q.value&&(this.m.delete(q.value),this.n.delete(q.value)),q=G.next()}};e.$Erc=b,e.$Erc=b=Je([We(0,a.$oQ),We(1,S.$EQ),We(2,O.$6pc),We(3,$.$zQ),We(4,o.$9pc),We(5,y.$uqc),We(6,c.$bk),We(7,l.$Jpc)],b);let L=class extends b{constructor(M,W,G,q,J,K,oe,me){super(M,W,G,q,J,K,oe,me),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$i(s.Platform.Web)})}async executeTask(M,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const G=C.from(W,M);if(G===void 0)throw new Error("Task is not valid");if(E.is(G.execution))await this.y(G,W,!1);else throw new n.$_;const q=await this.z(await this.a.$getTaskExecution(G),W);return this.a.$executeTask(G).catch(J=>{throw new Error(J)}),q}v(M,W,G,q){const J=[];if(q)for(const K of q){if(this.A(K,G),!K.definition||!M[K.definition.type]){const me=K.source?K.source:"No task source";this.f.warn(`The task [${me}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const oe=C.from(K,G.extension);oe&&E.is(oe.execution)?(J.push(oe),W.push(this.y(oe,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:G.extension}}async w(M){if(E.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,W,G){}};e.$Frc=L,e.$Frc=L=Je([We(0,a.$oQ),We(1,S.$EQ),We(2,O.$6pc),We(3,$.$zQ),We(4,o.$9pc),We(5,y.$uqc),We(6,c.$bk),We(7,l.$Jpc)],L),e.$Grc=(0,d.$Gi)("IExtHostTask")}),define(Ne[268],Me([1,0,44,32]),function(ve,e,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=void 0,e.$AM=I,e.$CM=T;function I(A){return"cellResults"in A}e.$BM="rawCell#";function T(A,O){let $=-1;const o=[];let k=[];return A.forEach(a=>{a.range.startLineNumber!==$&&k.length>0&&(o.push([...k]),k=[]),k.push(a),$=a.range.endLineNumber}),k.length>0&&o.push([...k]),o.map(a=>{const S=[],d=a[0].range.startLineNumber,r=a[a.length-1].range.endLineNumber;for(let s=d;s<=r;s++)S.push(O.getLineContent(s));return new v.$eM(S.join(`
`)+`
`,a.map(s=>new P.$Rt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ne[269],Me([1,0,9,22,6,4,28,37,12,14,2,29,79,5,33,8,7,39,246,125,25,15,44,199,268,266]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0,y=Ve(y),r=Ve(r),s=Ve(s);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,w,C,R,f,b,L){this.q=C,this.r=R,this.s=f,this.t=b,this.u=L,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new I.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$Hpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$ON.MainThreadNotebook),this.c=D.getProxy(S.$ON.MainThreadNotebookDocuments),this.d=D.getProxy(S.$ON.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===O.MarshalledId.NotebookCellActionContext){const M=N.notebookEditor?.notebookUri,W=N.cell.handle,q=this.g.get(M)?.getCell(W);if(q)return q.apiCell}if(N&&N.$mid===O.MarshalledId.NotebookActionContext){const M=N.uri,W=this.g.get(M);if(W)return W.apiNotebook}return N}}),h.C(w)}getEditorById(D){const w=this.h.get(D);if(!w)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(D){for(const[w,C]of this.h)if(C.apiEditor===D)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,w){const C=this.g.get(D);if(!C&&!w)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,w){if(!w)return;const C=w.filenamePattern.map(R=>r.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(w.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:w.displayName,filenamePattern:C,priority:w.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,w,C){const R=h.a++,f=typeof C.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(R,C),this.b.$registerNotebookCellStatusBarItemProvider(R,f,w);let b;return f!==void 0&&(b=C.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(f))),new s.$QN(()=>{this.f.delete(R),this.b.$unregisterNotebookCellStatusBarItemProvider(R,f),b?.dispose()})}async createNotebookDocument(D){const w=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return k.URI.revive(w)}async openNotebookDocument(D){const w=this.g.get(D);if(w)return w.apiNotebook;const C=await this.c.$tryOpenNotebook(D),R=this.g.get(k.URI.revive(C));return(0,o.$qg)(R?.apiNotebook)}async showNotebookDocument(D,w){k.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof w=="object"?C={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:C={preserveFocus:!1};const R=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),f=R&&this.h.get(R)?.apiEditor;if(f)return f;throw R?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,w,C,R){const f=this.f.get(D),b=k.URI.revive(w),L=this.g.get(b);if(!L||!f)return;const N=L.getCellFromIndex(C);if(!N)return;const M=await f.provideCellStatusBarItems(N.apiCell,R);if(!M)return;const W=new T.$Uc,G=this.p.add([W]),J=(Array.isArray(M)?M:[M]).map(K=>r.NotebookStatusBarItem.from(K,this.i,W));return{cacheId:G,items:J}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,w,C,R,f){if((0,$.$df)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:C,options:R}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},w,r.NotebookDocumentContentOptions.from(R),h.w(D,f)),(0,T.$Tc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,w,C){const R=this.y.get(D);if(!R)throw new Error("NO serializer found");const f=await R.serializer.deserializeNotebook(w.buffer,C);return new c.$2w(r.NotebookData.from(f))}async $notebookToData(D,w,C){const R=this.y.get(D);if(!R)throw new Error("NO serializer found");const f=await R.serializer.serializeNotebook(r.NotebookData.to(w.value),C);return P.$Oe.wrap(f)}async $saveNotebook(D,w,C,R,f){const b=k.URI.revive(w),L=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${b.toString()})`),!L)throw new Error("NO serializer found");const N=this.g.get(b);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$wl((0,v.localize)(2696,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,n.$no)(N.apiNotebook.metadata,K=>!(L.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of N.apiNotebook.getCells()){const oe=new s.$jP(K.kind,K.document.getText(),K.document.languageId,K.mime,L.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);oe.metadata=(0,n.$no)(K.metadata,me=>!(L.options?.transientCellMetadata??{})[me]),M.cells.push(oe)}if(await this.z(b,R),f.isCancellationRequested)throw new Error("canceled");const W=await L.serializer.serializeNotebook(M,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${b.toString()}`),await this.s.value.writeFile(b,W),this.D(`Finished write versionId: ${C} ${b.toString()}`);const G=this.s.getFileSystemProviderExtUri(b.scheme),q=await this.s.value.stat(b),J={name:G.basename(b),isFile:(q.type&y.FileType.File)!==0,isDirectory:(q.type&y.FileType.Directory)!==0,isSymbolicLink:(q.type&y.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((q.permissions??0)&y.FilePermission.Locked),etag:y.$Hl({mtime:q.mtime,size:q.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${b.toString()})`),J}async $searchInNotebooks(D,w,C,R,f){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const L=new A.$Cc;await(async(q,J,K)=>{await Promise.all(q.map(async oe=>await Promise.all(oe.filenamePatterns.map(me=>{const le={_reason:K._reason,folderQueries:K.folderQueries,includePattern:K.includePattern,excludePattern:K.excludePattern,maxResults:K.maxResults,type:g.QueryType.File,filePattern:me};return this.t.doInternalFileSearchWithCustomCallback(le,J,_=>{_.forEach(ce=>{L.has(ce)||R.some(ae=>oe.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(Se=>(0,m.$uL)(Se,ce)))||L.add(ce)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(C,f,w);const M=new A.$Bc;let W=!1;const G=Array.from(L).map(async q=>{const J=[];try{if(f.isCancellationRequested)return;if(w.maxResults&&[...M.values()].reduce((le,_)=>le+_.cellResults.length,0)>w.maxResults){W=!0;return}const K=[],oe=this.g.get(q);if(oe)oe.apiNotebook.getCells().forEach(_=>K.push({input:_.document.getText(),outputs:_.outputs.flatMap(ce=>ce.items.map(pe=>pe.data.toString()))}));else{const le=await this.s.value.readFile(q),_=P.$Oe.fromString(le.toString()),ce=await b.deserializeNotebook(_.buffer,f);if(f.isCancellationRequested)return;r.NotebookData.from(ce).cells.forEach(ae=>K.push({input:ae.source,outputs:ae.outputs.flatMap(Se=>Se.items.map(Oe=>Oe.valueBytes.toString()))}))}if(f.isCancellationRequested)return;K.forEach((le,_)=>{const ce=w.contentPattern.pattern,pe=new u.$x1b(le.input,void 0,le.outputs),ae=pe.findInInputs(ce),Se=pe.findInOutputs(ce),Oe=Se.flatMap(X=>(0,p.$CM)(X.matches,X.textBuffer)).map((X,B)=>(X.webviewIndex=B,X));if(ae.length>0||Se.length>0){const X={index:_,contentResults:(0,p.$CM)(ae,pe.inputTextBuffer),webviewResults:Oe};J.push(X)}});const me={resource:q,cellResults:J};M.set(q,me);return}catch{return}});return await Promise.all(G),{limitHit:W,results:[...M.values()]}}async z(D,w){const C=await this.s.value.stat(D);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==y.$Gl&&typeof C.mtime=="number"&&typeof C.size=="number"&&w.mtime<C.mtime&&w.etag!==y.$Hl({mtime:w.mtime,size:C.size}))throw new y.$wl((0,v.localize)(2697,null),y.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,w,C){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const R=new i.$0qc(w,this.d,D,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(w,R)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const R=k.URI.revive(C),f=this.g.get(R);f&&(f.dispose(),this.g.delete(R),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(f.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===R.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const C=[];for(const R of D.value.addedDocuments){const f=k.URI.revive(R.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const b=new l.$9qc(this.c,this.q,this.r,f,R);C.push(...R.cells.map(L=>l.$8qc.asModelAddData(L))),this.g.get(f)?.dispose(),this.g.set(f,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const R=k.URI.revive(C.documentUri),f=this.g.get(R);f&&this.B(f,C.id,C)}const w=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const R=this.h.get(C);R&&(this.h.delete(C),this.k?.id===R.id&&(this.k=void 0),w.push(R))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(R=>this.h.get(R)).filter(R=>!!R);const C=new Set;this.l.forEach(R=>C.add(R.id));for(const R of this.h.values()){const f=C.has(R.id);R._acceptVisibility(f)}this.l=[...this.h.values()].map(R=>R).filter(R=>R.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const w=d.$MQ.String.with("notebookType","A notebook type"),C=new d.$OQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new d.$MQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>P.$Oe.wrap(f))],new d.$NQ("Notebook Data",f=>r.NotebookData.to(f.value))),R=new d.$OQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new d.$MQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$2w(r.NotebookData.from(f)))],new d.$NQ("Bytes",f=>f.buffer));D.registerApiCommand(C),D.registerApiCommand(R)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$grc=h}),define(Ne[270],Me([1,0,19,21,42,41,23,69,44]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,v=Ve(v),T=Ve(T),A=Ve(A);class o{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&T.$Bk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&T.$Bk(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,r)=>{const s=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const l=c.toString(),i=v.$oc(l);this.j&&this.j(l,i)||this.v(s,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,s))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{r(new Error((0,I.$rj)(c)))})})}async p(a,S){const d=new P.$xe,r=this.q(a),s=this.r(),c=new $.$sM(this.k,a),l=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=O.$ge.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),t=i.elapsed(),g=O.$ge.create();return this.g&&!this.e||(n&&n.forEach(u=>{const p=v.$hc.relative(a.folder.path,u.path);if(l){const m=v.$oc(u.path);this.v(S,{base:a.folder,relativePath:p,basename:m});return}this.s(s,a.folder,p,S)}),this.g&&!this.e)?null:(this.u(s,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,$.$rM)(this.k.includePattern,a.includePattern),d=(0,$.$rM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,r){if(d===this.a){const c=v.$oc(this.a);this.v(r,{base:S,relativePath:this.a,basename:c})}function s(c){const l=v.$oc(c),i=v.$nc(c);let n=a[i];n||(n=a[i]=[],s(i)),n.push({base:S,relativePath:c,basename:l})}s(d)}u({rootEntries:a,pathToEntries:S},d,r){const s=this,c=this.a;function l(i){const n=(0,$.$uM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:p,basename:m}=u;if(d.matchesExcludesSync(p,m,c!==m?n:void 0))continue;const h=S[p];if(h)l(h);else{if(p===c)continue;s.v(r,u)}if(s.e)break}}l(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class k{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,r){const s=this.c(a.cacheKey),c=new o(a,S,s&&s.token);let l=0;const i=n=>{l+=n.length,d(n.map(t=>this.d(t)))};return this.e(c,k.a,i,r).then(n=>({limitHit:n.limitHit,stats:n.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:n.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new P.$xe),this.b.get(a)}d(a){return a.relativePath?{resource:A.$hh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,r){const s=r.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(l.push(i),S>0&&l.length>=S&&(d(l),l=[]))};let l=[];return a.search(c).then(i=>(l.length&&d(l),s.dispose(),i),i=>(l.length&&d(l),s.dispose(),Promise.reject(i)))}}e.$$qc=k}),define(Ne[271],Me([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,113,49,119,267,44]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0,e.$tN=C,v=Ve(v),P=Ve(P),I=Ve(I),$=Ve($),k=Ve(k),d=Ve(d);let g=class{constructor(f,b,L,N,M,W){this.a=f,this.b=b,this.c=L,this.d=N,this.e=M,this.f=W}text(f,b,L={}){f=this.g(f,L);const N=this.a.getValue(),M=b&&b.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.i(b?.map(l.$2i),L),type:t.QueryType.Text,contentPattern:f,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:N.search.usePCRE2||M||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}g(f,b){const L=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:L.editor.wordSeparators};return this.k(f,b)&&(N.isCaseSensitive=!0),this.l(f)&&(N.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),N}file(f,b={}){return{...this.i(f,b),type:t.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}h(f,b){return f?(f=Array.isArray(f)?f.map(E):E(f),b?this.parseSearchPaths(f):{pattern:p(...Array.isArray(f)?f:[f])}):{}}i(f=[],b={}){const L=this.h(b.includePattern,b.expandPatterns),N=this.h(b.excludePattern,b.expandPatterns),M=f.length>1,W=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(J=>this.r(J,b,N)):f.map(J=>this.t(J,b,N,M))).filter(J=>!!J),G={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:N.pattern,includePattern:L.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const J=v.$Hb(this.c.groups.flatMap(me=>me.editors.map(le=>le.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(J));const K=J.filter(me=>(0,t.$iM)(G,me.fsPath)),oe=this.j(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...G,...oe}}const q=b.extraFileResources&&b.extraFileResources.filter(J=>(0,t.$iM)(G,J.fsPath));return G.extraFileResources=q&&q.length?q:void 0,G}j(f){const b=[],L=new A.$Bc,N={};let M=!1;return f.forEach(W=>{if(W.scheme===O.Schemas.walkThrough)return;if((0,o.$lh)(W)){const q=this.b.getWorkspaceFolder(W)?.uri??this.f.extUri.dirname(W);let J=L.get(q);J||(M=!0,J={folder:q,includePattern:{}},b.push(J),L.set(q,J));const K=$.$mc(q.fsPath,W.fsPath);(0,y.$qg)(J.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(M=!0,N[W.fsPath]=!0)}),{folderQueries:b,includePattern:N,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}k(f,b){if(b.isSmartCase){if(f.isRegExp){if(k.$9f(f.pattern,!0))return!0}else if(k.$9f(f.pattern))return!0}return!!f.isCaseSensitive}l(f){return f.isMultiline||f.isRegExp&&(0,S.$pD)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const b=oe=>$.$jc(oe)||/^\.\.?([\/\\]|$)/.test(oe),N=(Array.isArray(f)?f:m(f)).map(oe=>{const me=this.e.resolvedUserHome;return me?(0,T.$7w)(oe,me.scheme===O.Schemas.file?me.fsPath:me.path):oe}),M=P.$c(N,oe=>b(oe)?"searchPaths":"exprSegments"),W=(M.exprSegments||[]).map(oe=>k.$of(oe,"/")).map(oe=>k.$of(oe,"\\")).map(oe=>(oe[0]==="."&&(oe="*"+oe),h(oe))),G={},q=this.n(M.searchPaths||[]);q&&q.length&&(G.searchPaths=q);const J=W.flat(),K=p(...J);return K&&(G.pattern=K),G}m(f,b){return b.disregardExcludeSettings?void 0:(0,t.$hM)(f,!b.disregardSearchExcludeSettings)}n(f){if(!f||!f.length)return[];const b=f.flatMap(N=>{let{pathPortion:M,globPortion:W}=u(N);return W&&(W=D(W)),this.o(M).flatMap(q=>this.q(q,W))}),L=new Map;return b.forEach(N=>{const M=N.searchPath.toString(),W=L.get(M);W?N.pattern&&(W.pattern=W.pattern||{},W.pattern[N.pattern]=!0):L.set(M,{searchPath:N.searchPath,pattern:N.pattern?p(N.pattern):void 0})}),Array.from(L.values())}o(f){if($.$jc(f)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==O.Schemas.file?[{searchPath:b[0].uri.with({path:f})}]:[{searchPath:a.URI.file($.$ic(f))}]}if(this.b.getWorkbenchState()===l.WorkbenchState.FOLDER){const b=this.b.getWorkspace().folders[0].uri;if(f=E(f),f.startsWith("../")||f===".."){const N=$.$hc.resolve(b.path,f);return[{searchPath:b.with({path:N})}]}const L=D(f);return[{searchPath:b,pattern:L}]}else{if(f==="./"||f===".\\")return[];{const b=f.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(M=>{const W=b.match(new RegExp(`^${k.$if(M.name)}(?:/(.*)|$)`));return W?{match:W,folder:M}:null}).filter(y.$ng);if(N.length)return N.map(M=>{const W=M.match[1];return{searchPath:M.folder.uri,pattern:W&&D(W)}});{const M=f.match(/\.[\/\\](.+)[\/\\]?/),W=M?M[1]:f,G=d.localize(12498,null,W);throw new Error(G)}}}}q(f,b){const L=f.pattern&&b?`${f.pattern}/${b}`:f.pattern||b,N=[{searchPath:f.searchPath,pattern:L}];return L&&!L.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:L+"/**"}),N}r(f,b,L){const N=this.t((0,l.$2i)(f.searchPath),b,L,!1);return N?{...N,includePattern:f.pattern}:null}t(f,b,L,N){let M;const W=a.URI.isUri(f)?f:f.uri;if(L.searchPaths){const oe=L.searchPaths.filter(me=>(0,o.$ah)(me.searchPath,W))[0];if(oe&&!oe.pattern)return null;oe&&(M=oe.pattern)}const G=this.a.getValue({resource:W}),J={...this.m(G,b)||{},...M||{}},K=a.URI.isUri(f)?(0,o.$eh)(f):f.name;return{folder:W,folderName:N?K:void 0,excludePattern:Object.keys(J).length>0?J:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!G.search.followSymlinks}}};e.$sN=g,e.$sN=g=Je([We(0,r.$aj),We(1,l.$Pi),We(2,i.$xE),We(3,s.$bk),We(4,n.$qN),We(5,c.$Ll)],g);function u(R){const f=R.match(/[\*\{\}\(\)\[\]\?]/);if(f){const b=f.index,L=R.substr(0,b).match(/[/|\\][^/\\]*$/);if(L){let N=R.substr(0,L.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:R.substr((L.index||0)+1)}}}return{pathPortion:R}}function p(...R){return R.length?R.reduce((f,b)=>(f[b]=!0,f),Object.create(null)):void 0}function m(R){return I.$zk(R,",").map(f=>f.trim()).filter(f=>!!f.length)}function h(R){return[`**/${R}/**`,`**/${R}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function E(R){return R.replace(/\\/g,"/")}function D(R){return E(R).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(R){return R.replace(/([?*[\]])/g,"[$1]")}function C(R,f){R=v.$Mb(R,N=>N.toString());const b=[],L=f.getWorkspace();return R&&R.forEach(N=>{let M;if(f.getWorkbenchState()===l.WorkbenchState.FOLDER)M=(0,o.$jh)(L.folders[0].uri,N),M&&M!=="."&&(M="./"+M);else{const W=f.getWorkspaceFolder(N);if(W){const G=W.name;if(L.folders.filter(J=>J.name===G).length===1){const J=(0,o.$jh)(W.uri,N);J===""?M=`./${W.name}`:M=`./${W.name}/${J}`}else M=N.fsPath}}M&&b.push(w(M))}),b}}),define(Ne[272],Me([1,0,23,2,21,13,3,271,44,49,10]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kyb=a,e.$Lyb=r,v=Ve(v),T=Ve(T);const y=7e3;function a(s,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],n=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||s.forceUsingSearch?n.push(E):i.push(E)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,k.$zh)(),u=h=>g({activationEvent:h}),p=Promise.all(i.map(h=>S(s,h,u))).then(()=>{}),m=d(s,c.identifier,n,u);return Promise.all([p,m]).then(()=>{g(void 0)}),t}async function S(s,c,l){for(const i of s.folders)if(await s.exists(v.$hh(P.URI.revive(i),c))){l(`workspaceContains:${c}`);return}}async function d(s,c,l,i){if(l.length===0)return Promise.resolve(void 0);const n=new I.$xe,t=s.checkExists(s.folders,l,n.token),g=setTimeout(async()=>{n.cancel(),s.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch(p){T.$4(p)||T.$Z(p)}n.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function r(s,c,l,i){const n=s.get(A.$Fi),t=s.get($.$_L),u=n.createInstance(O.$sN).file(c.map(p=>(0,o.$2i)(P.URI.revive(p))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then(p=>!!p.limitHit,p=>T.$4(p)?!1:Promise.reject(p))}}),define(Ne[47],Me([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,120,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h,E,D,w,C,R,f,b,L,N,M,W,G,q,J){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=e.$Kqc=e.$Jqc=e.$Iqc=e.$Hqc=void 0,v=Ve(v),P=Ve(P),I=Ve(I),l=Ve(l),e.$Hqc=(0,p.$Gi)("IHostUtils");let oe=K=class extends O.$Vc{constructor(X,B,te,ye,de,we,he,Z,x,be,$e,Ae,Ue){super(),this.Y=Ae,this.Z=Ue,this.a=this.B(new f.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=te,this.f=he,this.j=ye,this.m=de,this.s=we,this.t=x,this.u=be,this.w=$e,this.y=this.g.getProxy(y.$ON.MainThreadWorkspace),this.z=this.g.getProxy(y.$ON.MainThreadTelemetry),this.C=this.g.getProxy(y.$ON.MainThreadExtensionService),this.D=new A.$Fh,this.F=new A.$Fh,this.G=new A.$Fh,this.H=new A.$Fh,this.I=new Se(this.f.extensions.activationEvents),this.L=new c.$4dc(this.I,this.f.extensions.allExtensions);const ke=new i.$tn(this.f.extensions.myExtensions);this.J=new c.$4dc(this.I,pe(this.L,ke)),q.$u&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new d.$qqc(this.g,this.s),this.N=new L.$Aqc(this.g),this.O=Z,this.h=this.q.add(X.createChild(new D.$Ei([d.$rqc,this.M],[L.$Bqc,this.N]))),this.P=this.B(new S.$pqc(this.J,this.L,{onExtensionActivationError:(Pe,Te,z)=>{this.C.$onExtensionActivationError(Pe,l.$2(Te),z)},actualActivateExtension:async(Pe,Te)=>{if(c.$4dc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new S.$oqc;const z=this.J.getExtensionDescription(Pe);return this.fb(z,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){l.$Z(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.eb(de))}catch{}await Promise.all(X)}terminate(X,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const te=this.$();Promise.race([(0,A.$Hh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const B=await this.C.$getExtension(X);return B&&{...B,identifier:new i.$sn(B.identifier.value),extensionLocation:o.URI.revive(B.extensionLocation)}}ab(X,B){return this.P.activateByEvent(X,B)}bb(X,B){return this.P.activateById(X,B)}activateByIdWithErrors(X,B){return this.bb(X,B).then(()=>{const te=this.P.getActivatedExtension(X);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===M.Schemas.file&&this.c.fsRealpath){const B=X.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const te=await this.R.get(B);return o.URI.file(te)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new ae(X))),this.Q}async db(X){const B=$.$Mi.forUris(te=>T.$$g.ignorePathCasing(te));return await Promise.all(X.map(async te=>{if(this.wb(te)){const ye=await this.cb(te.extensionLocation);B.set(ye,te)}})),B}eb(X){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return B;const te=this.P.getActivatedExtension(X);if(!te)return B;try{typeof te.module.deactivate=="function"&&(B=Promise.resolve(te.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(ye)}try{te.disposable.dispose()}catch(ye){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(ye)}return B}async fb(X,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,B).then(te=>{const ye=te.activationTimes;return this.C.$onDidActivateExtension(X.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this.gb(X,B,"success",ye),te},te=>{throw this.gb(X,B,"failure"),te})}gb(X,B,te,ye){const de=le(X,B);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:te})}hb(X,B){const te=le(X,B);this.z.$publicLog2("activatePlugin",te);const ye=this.wb(X);if(!ye)return Promise.resolve(new S.$nqc(S.$kqc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${X.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const de=new O.$Uc,we=new S.$lqc(B.startup);return Promise.all([this.xb(X,(0,T.$hh)(X.extensionLocation,ye),we),this.ib(X,de)]).then(he=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),K.jb(this.s,X.identifier,he[0],he[1],de,we))).then(he=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),he))}ib(X,B){const te=this.Z.createLanguageModelAccessInformation(X),ye=B.add(new t.$tqc(X,this.M)),de=B.add(new t.$sqc(X.identifier.value,!1,this.M)),we=B.add(new N.$Cqc(X,this.N)),he=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,Z=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ye.whenReady,de.whenReady,this.O.whenReady]).then(()=>{const x=this;let be,$e;const Ae=(0,s.$iH)(X,"ipc")?this.f.messagePorts?.get(i.$sn.toKey(X.identifier)):void 0;return Object.freeze({globalState:ye,workspaceState:de,secrets:we,subscriptions:[],get languageModelAccessInformation(){return te},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ue){return P.$kc(X.extensionLocation.fsPath,Ue)},get storagePath(){return x.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return x.O.globalValue(X).fsPath},get logPath(){return P.$kc(x.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return o.URI.joinPath(x.f.logsLocation,X.identifier.value)},get storageUri(){return x.O.workspaceValue(X)},get globalStorageUri(){return x.O.globalValue(X)},get extensionMode(){return he},get extension(){return be===void 0&&(be=new ce(x,X.identifier,X,Z,!1)),be},get extensionRuntime(){return(0,s.$jH)(X,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!$e){if(!Ae)return;const Ue=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",ke=>ke.data));Ae.start(),$e={onDidReceiveMessage:Ue,postMessage:Ae.postMessage.bind(Ae)}}return $e}})})}static jb(X,B,te,ye,de,we){return te=te||{activate:void 0,deactivate:void 0},this.kb(X,B,te,ye,we).then(he=>new S.$mqc(!1,null,we.build(),te,he,(0,O.$Tc)(()=>{de.dispose(),(0,O.$Qc)(ye.subscriptions)})))}static kb(X,B,te,ye,de){if(typeof te.activate=="function")try{de.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${B.value}`);const we=typeof global=="object"?global:self,he=te.activate.apply(we,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(he).then(Z=>(de.activateResolveStop(),Z))}catch(we){return Promise.reject(we)}else return Promise.resolve(te)}lb(X,B){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:B}).then(void 0,te=>{this.s.error(te)})}mb(X,B=0){const ye=Date.now();(0,q.$C)(()=>{for(let de=B;de<X.length;de+=1){const we=X[de];for(const he of we.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ye>50){this.mb(X,de);break}else this.lb(we,he)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const B=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(B)this.mb(te);else for(const ye of te)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.lb(ye,de)})}ob(){const X=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const B=this.j.workspace?this.j.workspace.folders:[],te=this.pb(B),ye=this.rb(),de=Promise.all([ye,X,te]).then(()=>{});return Promise.race([de,(0,A.$Hh)(1e4)]).then(()=>{this.nb()}),de}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(X,B))).then(()=>{})}async qb(X,B){if(this.isActivated(B.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:X.map(we=>we.uri),forceUsingSearch:te||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,he,Z)=>this.y.$checkExists(we,he,Z)},de=await(0,b.$Kyb)(ye,B);if(de)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:de.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:B}=this.f.environment;if(!X||!B)throw new Error(v.localize(2688,null));const te=await this.xb(null,B,new S.$lqc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(2689,null,B.toString()));return new Promise((ye,de)=>{const we=(x,be)=>{x?(q.$u&&this.s.error("Test runner called back with error",x),de(x)):(q.$u&&(be?this.s.info(`Test runner called back with ${be} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof be=="number"&&be>0?1:0))},he=(0,T.$8g)(B),Z=te.run(he,we);Z&&Z.then&&Z.then(()=>{q.$u&&this.s.info("Test runner finished successfully."),ye(0)}).catch(x=>{q.$u&&this.s.error("Test runner finished with error",x),de(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,B){return this.S[X]=B,(0,O.$Tc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:B}=await this.ub(X);return B?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const B=X.indexOf("+");if(B===-1)throw new g.$YN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=X.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(X,B){const te=G.$ge.create(!1),ye=()=>`[resolveAuthority(${(0,u.$Wl)(X)},${B})][${te.elapsed()}ms] `,de=j=>this.s.info(`${ye()}${j}`),we=j=>this.s.warn(`${ye()}${j}`),he=(j,Q=void 0)=>this.s.error(`${ye()}${j}`,Q),Z=j=>{if(j instanceof g.$YN)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},x=async j=>{de(`activating resolver for ${j}...`);const{resolver:Q,authorityPrefix:V}=await this.ub(j);if(!Q)throw he(`no resolver for ${V}`),new g.$YN(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:V,remoteAuthority:j}},be=X.split(/@|%40/g).reverse();de(`activating remote resolvers ${be.join(" -> ")}`);let $e;try{$e=await Promise.all(be.map(x)).catch(async j=>{if(!(j instanceof g.$YN)||j._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return we(`resolving nested authorities failed: ${j.message}`),[await x(X)]})}catch(j){return Z(j)}const Ae=new A.$Rh;Ae.cancelAndSet(()=>de("waiting..."),1e3);let Ue,ke;for(const[j,{authorityPrefix:Q,resolver:V,remoteAuthority:re}]of $e.entries())try{if(j===$e.length-1)de("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${Q}`),Ue=await V.resolve(re,{resolveAttempt:B,execServer:ke}),I.mark(`code/extHost/didResolveAuthorityOK/${Q}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$XN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(de(`invoking resolveExecServer() for ${re}`),I.mark(`code/extHost/willResolveExecServer/${Q}`),ke=await V.resolveExecServer?.(re,{resolveAttempt:B,execServer:ke}),!ke)throw new g.$YN(`Exec server was not available for ${re}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ge){return I.mark(`code/extHost/didResolveAuthorityError/${Q}`),he("returned an error",ge),Ae.dispose(),Z(ge)}Ae.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${g.$XN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let z;if(g.$XN.isManagedResolvedAuthority(Ue)){const j=B;this.Y.setFactory(j,Ue.makeConnection),z={authority:X,connectTo:new u.$Tl(j),connectionToken:Ue.connectionToken}}else z={authority:X,connectTo:new u.$Ul(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:z,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(X,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Wl)(X)})`);const{resolver:te}=await this.ub(X);if(!te)return null;const ye=o.URI.revive(B);if(typeof te.getCanonicalURI>"u")return ye;const de=await(0,A.$yh)(()=>te.getCanonicalURI(ye));return de||ye}async $startExtensionHost(X){X.toAdd.forEach(we=>we.extensionLocation=o.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:te}=me(this.I,this.L,this.J,X),ye=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(te),q.$u&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(X,B){return B===s.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(X,!1)):this.G.wait().then(te=>this.ab(X,!1))}async $activate(X,B){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,B),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(we=>we.extensionLocation=o.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:te}=me(this.I,this.L,this.J,X),ye=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(te),q.$u&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const B=n.$Oe.alloc(X),te=Math.random()%256;for(let ye=0;ye<X;ye++)B.writeUInt8(te,ye);return B}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$Iqc=oe,e.$Iqc=oe=K=Je([We(0,p.$Fi),We(1,e.$Hqc),We(2,E.$oQ),We(3,r.$6pc),We(4,a.$9pc),We(5,k.$bk),We(6,m.$EQ),We(7,h.$_pc),We(8,w.$rGb),We(9,C.$uqc),We(10,W.$Eqc),We(11,J.$Fqc),We(12,R.$yqc)],oe);function me(Oe,X,B,te){Oe.addActivationEvents(te.addActivationEvents);const ye=new c.$4dc(Oe,X.getAllExtensionDescriptions());ye.deltaExtensions(te.toAdd,te.toRemove);const de=new i.$tn(B.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of te.myToRemove)de.delete(he);for(const he of te.myToAdd)de.add(he);const we=pe(ye,de);return{globalRegistry:ye,myExtensions:we}}function le(Oe,X){return{id:Oe.identifier.value,name:Oe.name,extensionVersion:Oe.version,publisherDisplayName:Oe.publisher,activationEvents:Oe.activationEvents?Oe.activationEvents.join(","):null,isBuiltin:Oe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function _(Oe){return Oe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Jqc=(0,p.$Gi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(X,B,te,ye,de){this.#e=X,this.#t=B,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=P.$ic((0,T.$8g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Kqc=ce;function pe(Oe,X){return Oe.getAllExtensionDescriptions().filter(B=>X.has(B.identifier))}class ae{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Lqc=ae;class Se{constructor(X){this.a=new i.$un,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const B of Object.keys(X))this.a.set(B,X[B])}}}),define(Ne[273],Me([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,v=Ve(v);let r=class{constructor(n,t,g,u,p,m,h){this.c=n,this.d=t,this.e=g,this.f=u,this.g=p,this.h=m,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Wrc=r,e.$Wrc=r=Je([We(2,k.$Fi),We(3,T.$9pc),We(4,y.$Jqc),We(5,o.$EQ),We(6,a.$bk)],r);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&d.a.size){const t=(0,S.$if)(this.c(n.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,p="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${p}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,g,u,p]=t,m=d.a.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+p}c(n){return n.replace(/\\/g,"/")}};s=d=Je([We(0,o.$EQ)],s);class c{constructor(n,t,g,u,p){this.c=n,this.d=t,this.e=g,this.f=u,this.g=p,this.nodeModuleName="vscode",this.a=new O.$un}load(n,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach((p,m)=>u+=`	${m} -> ${p.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$dH,this.e,this.f)}return this.b}}let l=class{constructor(n,t,g){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(I.$ON.MainThreadTelemetry);const u=g.getProxy(I.$ON.MainThreadWindow);this.c=(p,m)=>{const h=P.URI.parse(p);return m?this.g(p,m):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,p,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,p,{}):this.g(p,m)}}load(n,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Je([We(2,$.$oQ)],l)}),define(Ne[133],Me([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0,I=Ve(I),T=Ve(T),e.$Mqc=(0,A.$Gi)("IExtHostVariableResolverProvider");class d extends a.$sR{constructor(c,l,i,n,t,g,u){function p(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const h=n.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof k.$FP||h.input instanceof k.$KP)return h.input.modified;if(h.input instanceof k.$EP||h.input instanceof k.$JP||h.input instanceof k.$HP)return h.input.uri}}}super({getFolderUri:m=>{const h=g.folders.filter(E=>E.name===m);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,h)=>t.getConfiguration(void 0,m).get(h),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=p();if(m)return I.$ic(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const m=p();if(m){const h=l.getWorkspaceFolder(m);if(h)return I.$ic(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>c.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(T.env))}}let r=class extends P.$Vc{constructor(c,l,i,n,t){super(),this.b=c,this.c=l,this.g=i,this.h=n,this.j=t,this.a=new v.$U(async()=>{const g=await this.h.getConfigProvider(),p={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{p.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,p,this.m())})}getResolver(){return this.a.value}m(){}};e.$Nqc=r,e.$Nqc=r=Je([We(0,o.$Jqc),We(1,y.$6pc),We(2,O.$zQ),We(3,S.$9pc),We(4,$.$iqc)],r)}),define(Ne[134],Me([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,133,34,33,8,17,95]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=e.$Wqc=e.$Vqc=e.$Uqc=e.$Tqc=void 0,t=Ve(t),e.$Tqc=(0,O.$Gi)("IExtHostDebugService");let p=class extends T.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(R,f,b,L,N,M,W,G){super(),this.Y=f,this.Z=b,this.$=L,this.ab=N,this.bb=M,this.cb=W,this.db=G,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new P.$me),this.z=this.B(new P.$me),this.C=this.B(new P.$me),this.F=this.B(new P.$me),this.u=R.getProxy($.$ON.MainThreadDebugService),this.I=this.B(new P.$me),this.L=this.B(new P.$me),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(q=>{this.B(q.onDidChange(J=>{this.fb(q)})),this.fb(q)})}async $getVisualizerTreeItem(R,f){const b=this.gb(f);if(!b)return;const L=await this.Q.get(R)?.getTreeItem?.(b);return L?this.eb(R,L):void 0}registerDebugVisualizationTree(R,f,b){const L=A.$sn.toKey(R.identifier),N=this.ub(L,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,b),this.u.$registerDebugVisualizerTree(N,!!b.editItem),(0,T.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(R,f){const b=this.S.get(f)?.item;return b?(await this.Q.get(R)?.getChildren?.(b))?.map(N=>this.eb(R,N))||[]:[]}async $editVisualizerTreeItem(R,f){const b=this.S.get(R);if(!b)return;const L=await this.Q.get(b.provider)?.editItem?.(b.item,f);return this.eb(b.provider,L||b.item)}$disposeVisualizedTree(R){const f=this.S.get(R);if(!f)return;const b=[f.children];for(const L of b)if(L)for(const N of L)b.push(this.S.get(N)?.children),this.S.delete(N)}eb(R,f){let b=this.R.get(f);return b||(b=this.O++,this.R.set(f,b),this.S.set(b,{provider:R,item:f})),t.DebugTreeItem.from(f,b)}asDebugSourceUri(R,f){const b=R;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let L=`debug:${encodeURIComponent(b.path||"")}`,N="?";return f&&(L+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),L+=`${N}ref=${b.sourceReference}`,I.URI.parse(L)}else{if(b.path)return I.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(R){const f=[];for(const b of R.getAllExtensionDescriptions())if(b.contributes){const L=b.contributes.debuggers;if(L&&L.length>0)for(const N of L)(0,s.$dI)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const R=[];return this.H.forEach(f=>R.push(f)),R}async $resolveDebugVisualizer(R,f){const b=this.W.get(R);if(!b)throw new Error(`No debug visualizer found with id '${R}'`);let{v:L,provider:N,extensionId:M}=b;if(L.visualization||(L=await N.resolveDebugVisualization?.(L,f)||L,b.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(M,L.visualization)}async $executeDebugVisualizerCommand(R){const f=this.W.get(R);if(!f)throw new Error(`No debug visualizer found with id '${R}'`);const b=f.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(R){const f=this.w.get(R.sessionId);return f&&{session:f.api,variable:R.variable,containerId:R.containerId,frameId:R.frameId,threadId:R.threadId}}async $provideDebugVisualizers(R,f,b,L){const N=this.gb(b),M=this.ub(R,f),W=this.P.get(M);if(!N||!W)return[];const G=await W.provideDebugVisualization(N,L);return G?G.map(q=>{const J=++this.X;this.W.set(J,{v:q,provider:W,extensionId:R});const K=q.iconPath?this.wb(q.iconPath):void 0;return{id:J,name:q.name,iconClass:K?.iconClass,iconPath:K?.iconPath,visualization:this.vb(R,q.visualization)}}):[]}$disposeDebugVisualizers(R){for(const f of R)this.W.delete(f)}registerDebugVisualizationProvider(R,f,b){if(!R.contributes?.debugVisualizers?.some(M=>M.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const L=A.$sn.toKey(R.identifier),N=this.ub(L,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,b),this.u.$registerDebugVisualizer(L,f),(0,T.$Tc)(()=>{this.u.$unregisterDebugVisualizer(L,f),this.P.delete(f)})}addBreakpoints(R){const f=R.filter(N=>{const M=N.id;return this.H.has(M)?!1:(this.H.set(M,N),!0)});this.rb(f,[],[]);const b=[],L=new Map;for(const N of f)if(N instanceof a.$UO){let M=L.get(N.location.uri.toString());M||(M={type:"sourceMulti",uri:N.location.uri,lines:[]},L.set(N.location.uri.toString(),M),b.push(M)),M.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$VO&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(R){const f=R.filter(M=>this.H.delete(M.id));this.rb([],f,[]);const b=f.filter(M=>M instanceof a.$UO).map(M=>M.id),L=f.filter(M=>M instanceof a.$VO).map(M=>M.id),N=f.filter(M=>M instanceof a.$WO).map(M=>M.id);return this.u.$unregisterBreakpoints(b,L,N)}startDebugging(R,f,b){const L=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(R?R.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(R){return this.u.$stopDebugging(R?R.id:void 0)}registerDebugConfigurationProvider(R,f,b){if(!f)return new a.$QN(()=>{});const L=this.f++;return this.g.push({type:R,handle:L,provider:f}),this.u.$registerDebugConfigurationProvider(R,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,L),new a.$QN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(R,f,b){if(!b)return new a.$QN(()=>{});if(!this.nb(R,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:f,handle:L,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(f,L),new a.$QN(()=>{this.j=this.j.filter(N=>N.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(R,f){if(!f)return new a.$QN(()=>{});const b=this.m++;return this.n.push({type:R,handle:b,factory:f}),new a.$QN(()=>{this.n=this.n.filter(L=>L.factory!==f)})}async $runInTerminal(R,f){return Promise.resolve(void 0)}async $substituteVariables(R,f){let b;const L=await this.tb(R);return L&&(b={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,f)}hb(R,f){if(R.type==="implementation")return new D(R.implementation)}ib(){}async $startDASession(R,f){const b=this,L=await this.sb(f);return this.pb(this.kb(L.type),L).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const M=this.jb(N),W=this.hb(M,L);if(!W)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const G=W;return this.M.set(R,G),this.ob(L).then(q=>(q&&this.N.set(R,q),G.onMessage(async J=>{if(J.type==="request"&&J.command==="handshake"){const K=J,oe={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const me=await this.U.sign(K.arguments.value);oe.body={signature:me},G.sendResponse(oe)}else throw new Error("no signer")}catch(me){oe.success=!1,oe.message=me.message,G.sendResponse(oe)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(J),J=(0,s.$iI)(J,!0),b.u.$acceptDAMessage(R,J)}),G.onError(J=>{q&&q.onError&&q.onError(J),this.u.$acceptDAError(R,J.name,J.message,J.stack)}),G.onExit(J=>{q&&q.onExit&&q.onExit(J??void 0,void 0),this.u.$acceptDAExit(R,J??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),G.startSession()))})}$sendDAMessage(R,f){f=(0,s.$hI)(f,!1);const b=this.N.get(R);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f),this.M.get(R)?.sendMessage(f)}$stopDASession(R){const f=this.N.get(R);this.N.delete(R),f&&f.onWillStopSession&&f.onWillStopSession();const b=this.M.get(R);return this.M.delete(R),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(R){const f=[],b=[],L=[];if(R.added)for(const N of R.added){const M=N.id;if(M&&!this.H.has(M)){let W;if(N.type==="function")W=new a.$VO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")W=new a.$WO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const G=I.URI.revive(N.uri);W=new a.$UO(new a.$5N(G,new a.$RN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$SO)(W,M),this.H.set(M,W),f.push(W)}}if(R.removed)for(const N of R.removed){const M=this.H.get(N);M&&(this.H.delete(N),b.push(M))}if(R.changed){for(const N of R.changed)if(N.id){const M=this.H.get(N.id);if(M){if(M instanceof a.$VO&&N.type==="function"){const W=M;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.functionName=N.functionName}else if(M instanceof a.$UO&&N.type==="source"){const W=M;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.location=new a.$5N(I.URI.revive(N.uri),new a.$RN(N.line,N.character))}L.push(M)}}}this.rb(f,b,L)}async $acceptStackFrameFocus(R){let f;if(R){const b=await this.sb(R.sessionId);R.kind==="thread"?f=new a.$3O(b.api,R.threadId):f=new a.$2O(b.api,R.threadId,R.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(R,f,b){return(0,v.$yh)(async()=>{const L=this.mb(R);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return L.provideDebugConfigurations(N,b)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(R,f,b,L){return(0,v.$yh)(async()=>{const N=this.mb(R);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb(f);return N.resolveDebugConfiguration(M,b,L)})}$resolveDebugConfigurationWithSubstitutedVariables(R,f,b,L){return(0,v.$yh)(async()=>{const N=this.mb(R);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(M,b,L)})}async $provideDebugAdapter(R,f){const b=this.lb(R);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb(f);return this.pb(b,L).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(R){const f=await this.sb(R);this.y.fire(f.api)}async $acceptDebugSessionTerminated(R){const f=await this.sb(R);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(R){this.D=R?await this.sb(R):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(R,f){(await this.sb(R))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(R,f){const L={session:(await this.sb(R)).api,event:f.event,body:f.body};this.F.fire(L)}jb(R){if(R instanceof a.$XO)return{type:"executable",command:R.command,args:R.args,options:R.options};if(R instanceof a.$YO)return{type:"server",port:R.port,host:R.host};if(R instanceof a.$ZO)return{type:"pipeServer",path:R.path};if(R instanceof a.$1O)return{type:"implementation",implementation:R.implementation};throw new Error("convertToDto unexpected type")}kb(R){const f=this.j.filter(b=>b.type===R);if(f.length>0)return f[0].factory}lb(R){const f=this.j.filter(b=>b.handle===R);if(f.length>0)return f[0].factory}mb(R){const f=this.g.filter(b=>b.handle===R);if(f.length>0)return f[0].provider}nb(R,f){if(R.contributes){const b=R.contributes.debuggers;if(b&&b.length>0){for(const L of b)if(L.label&&L.type&&L.type===f)return!0}}return!1}ob(R){const b=R.configuration.type,L=this.n.filter(N=>N.type===b||N.type==="*").map(N=>(0,v.$yh)(()=>N.factory.createDebugAdapterTracker(R.api)).then(M=>M,M=>null));return Promise.race([Promise.all(L).then(N=>{const M=(0,g.$Hb)(N);if(M.length>0)return new E(M)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(R,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new a.$YO(b));if(R){const N=await this.Z.getExtensionRegistry();return(0,v.$yh)(()=>R.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(M=>{if(M)return M})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,L))}qb(R,f){}rb(R,f,b){(R.length>0||f.length>0||b.length>0)&&this.I.fire(Object.freeze({added:R,removed:f,changed:b}))}async sb(R){if(R)if(typeof R=="string"){const f=this.w.get(R);if(f)return f}else{let f=this.w.get(R.id);if(!f){const b=await this.tb(R.folderUri),L=R.parent?this.w.get(R.parent):void 0;f=new m(this.u,R.id,R.type,R.name,b,R.configuration,L?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(R){if(R){const f=I.URI.revive(R);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(R,f){return`${R}\0${f}`}vb(R,f){if(f){if("title"in f&&"command"in f)return{type:r.DebugVisualizationType.Command};if("treeId"in f)return{type:r.DebugVisualizationType.Tree,id:`${R}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(R){const f=this.xb(R);let b,L;return"id"in f?L=i.ThemeIcon.asClassName(f):b=f,{iconPath:b,iconClass:L}}xb(R){if(R instanceof a.$PO)return{id:R.id};const f=typeof R=="object"&&"dark"in R?R.dark:R,b=typeof R=="object"&&"light"in R?R.light:R;return{dark:typeof f=="string"?I.URI.file(f):f,light:typeof b=="string"?I.URI.file(b):b}}};e.$Uqc=p,e.$Uqc=p=Je([We(0,y.$oQ),We(1,S.$6pc),We(2,k.$Jqc),We(3,c.$9pc),We(4,o.$iqc),We(5,l.$Mqc),We(6,n.$KQ),We(7,u.$Oqc)],p);class m{constructor(R,f,b,L,N,M,W){this.f=R,this.g=f,this.h=b,this.j=L,this.k=N,this.l=M,this.m=W}get api(){const R=this;return this.d??=Object.freeze({id:R.g,type:R.h,get name(){return R.j},set name(f){R.j=f,R.f.$setDebugSessionName(R.g,f)},parentSession:R.m,workspaceFolder:R.k,configuration:R.l,customRequest(f,b){return R.f.$customDebugAdapterRequest(R.g,f,b)},getDebugProtocolBreakpoint(f){return R.f.$getDebugProtocolBreakpoint(R.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(R){this.j=R}get configuration(){return this.l}}e.$Vqc=m;class h{constructor(R){this.value=Object.freeze({append(f){R.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$Wqc=h;class E{constructor(R){this.d=R}onWillStartSession(){this.d.forEach(R=>R.onWillStartSession?R.onWillStartSession():void 0)}onWillReceiveMessage(R){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(R):void 0)}onDidSendMessage(R){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(R):void 0)}onWillStopSession(){this.d.forEach(R=>R.onWillStopSession?R.onWillStopSession():void 0)}onError(R){this.d.forEach(f=>f.onError?f.onError(R):void 0)}onExit(R,f){this.d.forEach(b=>b.onExit?b.onExit(R,f):void 0)}}class D extends d.$eub{constructor(R){super(),this.h=R,R.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(R){this.h.handleMessage(R)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends p{constructor(R,f,b,L,N,M,W,G){super(R,f,b,L,N,M,W,G)}};e.$Xqc=w,e.$Xqc=w=Je([We(0,y.$oQ),We(1,S.$6pc),We(2,k.$Jqc),We(3,c.$9pc),We(4,o.$iqc),We(5,l.$Mqc),We(6,n.$KQ),We(7,u.$Oqc)],w)}),define(Ne[274],Me([1,0,13,64,2,5,224,11,60,74,26,171,16,65,47,66]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0,v=Ve(v),P=Ve(P);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(O.$bk),g=i.get(a.$oQ).getProxy(T.$ON.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{n.error(u);const p=v.$2(u);g.$onUnexpectedError(p)})}static async installFullHandler(i){const n=i.get(O.$bk),t=i.get(a.$oQ),g=i.get(d.$Jqc),u=i.get(r.$IQ),p=t.getProxy(T.$ON.MainThreadExtensionService),m=t.getProxy(T.$ON.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(R,f){if(E.has(R))return E.get(R).stack;let b="",L,N;for(const W of f)b+=`
	at ${W.toString()}`,N=W.getFileName(),!L&&N&&(L=h.findSubstr(I.URI.file(N)));const M=`${R.name||"Error"}: ${R.message||""}${b}`;return E.set(R,{extensionIdentifier:L?.identifier,stack:M}),M}const w=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(R){if(R===D||!R||R[w]){C=R||D;return}C=function(f,b){return D(f,b),R.call(Error,f,b)},Object.assign(C,{[w]:!0})}}),v.setUnexpectedErrorHandler(R=>{n.error(R);const f=v.$2(R),b=E.get(R);if(!b?.extensionIdentifier){m.$onUnexpectedError(f);return}p.$onExtensionRuntimeError(b.extensionIdentifier,f);const L=u.onExtensionError(b.extensionIdentifier,R);n.trace("forwarded error to extension?",L,b)})}}e.$Xrc=s;class c{constructor(i,n,t,g,u){this.a=t,this.b=new A.$_dc(i,null,g),n=c.e(n,this.b);const p=new o.$Ei(...(0,$.$Vs)());p.set(k.$EQ,{_serviceBrand:void 0,...n,messagePorts:u}),p.set(a.$oQ,new a.$pQ(this.b)),p.set(S.$3pc,new S.$4pc(g)),p.set(d.$Hqc,t);const m=new y.$zr(p,!0);m.invokeFunction(s.installEarlyHandler),this.d=m.invokeFunction(h=>h.get(O.$bk)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=m.invokeFunction(h=>h.get(d.$Jqc)),this.c.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(T.$ON.MainThreadExtensionService);return I.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=I.URI.revive(n.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=I.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>I.URI.revive(n.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=I.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=I.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=I.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=I.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=I.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=I.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Yrc=c}),define(Ne[275],Me([1,0,17,10,21,42,15,19,23,2,44]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=e.$arc=e.$_qc=void 0,e.$brc=r,O=Ve(O),$=Ve($);class y{constructor(l,i,n){this.d=l,this.e=i,this.f=n,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const n=this.g.folderQueries||[],t=new I.$xe(i);return new Promise((g,u)=>{this.a=new S(l);let p=!1;const m=(h,E)=>{if(!p&&!this.b){const D=this.h(h);r(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,p=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const w=this.h(h);this.c+=w,(w>0||!r(h))&&this.a.add(h,E)}};Promise.all(n.map((h,E)=>this.k(h,D=>m(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,T.$rj)(h);u(new Error(E))})})}h(l){return r(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const n=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:n.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,n){const t=new k.$sM(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===A.Schemas.file?(0,k.$tM)(()=>this.e.readdir($.$gh(h.uri))):void 0,D=$.$jh(l.folder,h.uri);if(D){const w=t.includedInQuery(D,O.$oc(D),E);(0,P.$sh)(w)?g.push(w.then(C=>{C&&i(h)})):w&&i(h)}}},p=this.n(l);let m;return this.d.query.type===k.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,p,u,n):m=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),p,u,n),g.length&&await Promise.all(g),m}l(l){if(r(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,k.$rM)(this.g.includePattern,l.includePattern),n=(0,k.$rM)(this.g.excludePattern,l.excludePattern),t={folder:o.URI.from(l.folder),excludes:n,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??k.$$L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$_qc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!$.$ah(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(d(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$arc=S;function d(c){return r(c)?{preview:{matches:(0,v.$1b)(c.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:c.preview.text},ranges:(0,v.$1b)(c.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function r(c){return!!c.preview}class s{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$crc=s}),define(Ne[135],Me([1,0,4,5,3,270,16,65,11,2,275]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=e.$drc=void 0,e.$frc=a,e.$drc=(0,I.$Gi)("IExtHostSearch");let y=class{constructor(r,s,c){this.n=r,this.o=s,this.q=c,this.c=this.n.getProxy(P.$ON.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$$qc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const c=this.d++;return this.e.set(c,s),this.c.$registerTextSearchProvider(c,this.s(r)),(0,v.$Tc)(()=>{this.g.delete(r),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const c=this.d++;return this.h.set(c,s),this.c.$registerAITextSearchProvider(c,this.s(r)),(0,v.$Tc)(()=>{this.i.delete(r),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const c=this.d++;return this.j.set(c,s),this.c.$registerFileSearchProvider(c,this.s(r)),(0,v.$Tc)(()=>{this.k.delete(r),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(r,s,c,l){const i=a(c),n=this.j.get(r);if(n)return this.l.fileSearch(i,n,t=>{this.c.$handleFileMatch(r,s,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,c){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,c,l){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const n=a(c);return this.t(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$provideAITextSearchResults(r,s,c,l){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const n=a(c);return this.v(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$enableExtensionHostSearch(){}t(r,s){return new k.$_qc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(r,s){return new k.$_qc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$erc=y,e.$erc=y=Je([We(0,A.$oQ),We(1,O.$3pc),We(2,$.$bk)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>o.URI.revive(r))}}function S(d){return{...d,folder:o.URI.revive(d.folder)}}});var _t=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[276],Me([1,0,10,21,13,6,4,15,35,2,105,158,159,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,134,123,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,129,218,250,251,252,16,253,135,87,254,219,255,88,91,132,66,56,127,95,259,230,260,261,92,8,7,220,65,221,67,262,263,122,45,80,83,24,131]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h,E,D,w,C,R,f,b,L,N,M,W,G,q,J,K,oe,me,le,_,ce,pe,ae,Se,Oe,X,B,te,ye,de,we,he,Z,x,be,$e,Ae,Ue,ke,Pe,Te,z,j,Q,V,re,ge,Ce,ze,He,_e,tt,nt,et,rt,ft,lt,st,ct,mt,$t,qe,je,ne,ee,Y,Ze,xe,ht,wt,Lt,Qt,ei,ti,oi,At,Ye,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=hi,I=Ve(I),$=_t($),a=Ve(a),r=Ve(r),ee=Ve(ee),Y=Ve(Y);function hi(pt){const Dt=pt.get(Oe.$EQ),ii=pt.get(Se.$Npc),ni=pt.get(pe.$$pc),jt=pt.get(_.$Jqc),gt=pt.get(ti.$6pc),Ut=pt.get(ft.$IQ),ri=pt.get(f.$9pc),ai=pt.get(xe.$3pc),Ke=pt.get(re.$oQ),ci=pt.get(nt.$rqc),di=pt.get(et.$_pc),fi=pt.get(s.$ck),vt=pt.get(s.$bk),Ft=pt.get(ne.$rGb),Nt=pt.get(u.$Jpc),Wt=pt.get(ei.$Rrc),si=pt.get(ze.$Bqc),Gt=pt.get(oe.$iqc),li=pt.get(Z.$Fqc),Bt=pt.get(p.$Tpc),Ht=pt.get(de.$yqc);Ke.set(n.$PN.ExtHostFileSystemInfo,ii),Ke.set(n.$PN.ExtHostLogLevelServiceShape,fi),Ke.set(n.$PN.ExtHostWorkspace,gt),Ke.set(n.$PN.ExtHostConfiguration,ri),Ke.set(n.$PN.ExtHostExtensionService,jt),Ke.set(n.$PN.ExtHostStorage,ci),Ke.set(n.$PN.ExtHostTunnelService,Ft),Ke.set(n.$PN.ExtHostWindow,Wt),Ke.set(n.$PN.ExtHostSecretState,si),Ke.set(n.$PN.ExtHostTelemetry,Ut),Ke.set(n.$PN.ExtHostEditorTabs,Gt),Ke.set(n.$PN.ExtHostManagedSockets,li),Ke.set(n.$PN.ExtHostAuthentication,Bt),Ke.set(n.$PN.ExtHostChatProvider,Ht);const Kt=Ke.set(n.$PN.ExtHostDecorations,pt.get(N.$Zqc)),Mt=Ke.set(n.$PN.ExtHostDocumentsAndEditors,pt.get(K.$zQ)),bt=Ke.set(n.$PN.ExtHostCommands,pt.get(C.$KQ)),kt=Ke.set(n.$PN.ExtHostTerminalService,pt.get(lt.$uqc)),Vt=Ke.set(n.$PN.ExtHostTerminalShellIntegration,pt.get(st.$Hrc)),It=Ke.set(n.$PN.ExtHostDebugService,pt.get(L.$Tqc)),mi=Ke.set(n.$PN.ExtHostSearch,pt.get(Ce.$drc)),Xt=Ke.set(n.$PN.ExtHostTask,pt.get(rt.$Grc)),ki=Ke.set(n.$PN.ExtHostOutputService,pt.get(Te.$trc)),wi=Ke.set(n.$PN.ExtHostLocalization,pt.get(he.$Eqc)),Oi=Ke.set(n.$PN.ExtHostUrls,new ht.$Orc(Ke)),Ot=Ke.set(n.$PN.ExtHostDocuments,new J.$Qpc(Ke,Mt)),Mi=Ke.set(n.$PN.ExtHostDocumentContentProviders,new G.$2qc(Ke,Mt,vt)),ui=Ke.set(n.$PN.ExtHostDocumentSaveParticipant,new q.$3qc(vt,Ot,Ke.getProxy(n.$ON.MainThreadBulkEdits))),Rt=Ke.set(n.$PN.ExtHostNotebook,new be.$grc(Ke,bt,Mt,Ot,ni,mi,vt)),Ti=Ke.set(n.$PN.ExtHostNotebookDocuments,new Ae.$nrc(Rt)),Ii=Ke.set(n.$PN.ExtHostNotebookEditors,new Ue.$orc(vt,Rt)),Di=Ke.set(n.$PN.ExtHostNotebookKernels,new ke.$prc(Ke,Dt,Rt,bt,vt)),Ui=Ke.set(n.$PN.ExtHostNotebookRenderers,new Pe.$rrc(Ke,Rt)),pi=Ke.set(n.$PN.ExtHostNotebookDocumentSaveParticipant,new $e.$mrc(vt,Rt,Ke.getProxy(n.$ON.MainThreadBulkEdits))),qt=Ke.set(n.$PN.ExtHostEditors,new mt.$Zpc(Ke,Mt)),Ci=Ke.set(n.$PN.ExtHostTreeViews,new je.$Mrc(Ke.getProxy(n.$ON.MainThreadTreeViews),bt,vt)),Ee=Ke.set(n.$PN.ExtHostEditorInsets,new w.$1pc(Ke.getProxy(n.$ON.MainThreadEditorInsets),qt,Dt.remote)),Re=Ke.set(n.$PN.ExtHostDiagnostics,new M.$Ppc(Ke,vt,ii,Mt)),fe=Ke.set(n.$PN.ExtHostLanguages,new we.$krc(Ke,Ot,bt.converter,ai)),H=Ke.set(n.$PN.ExtHostLanguageFeatures,new te.$Rpc(Ke,ai,Ot,bt,Re,vt,Nt,Ut)),Ie=Ke.set(n.$PN.ExtHostFileSystem,new ce.$6qc(Ke,H)),Be=Ke.set(n.$PN.ExtHostFileSystemEventService,new ae.$7qc(Ke,vt,Mt)),Xe=Ke.set(n.$PN.ExtHostQuickOpen,(0,V.$xrc)(Ke,gt,bt)),Qe=Ke.set(n.$PN.ExtHostSCM,new ge.$zrc(Ke,bt,Ot,vt)),ut=Ke.set(n.$PN.ExtHostQuickDiff,new Q.$wrc(Ke,ai)),Pt=Ke.set(n.$PN.ExtHostShare,new He.$Arc(Ke,ai)),Jt=Ke.set(n.$PN.ExtHostComments,(0,R.$2pc)(Ke,bt,Ot)),Yt=Ke.set(n.$PN.ExtHostProgress,new j.$vrc(Ke.getProxy(n.$ON.MainThreadProgress))),zt=Ke.set(n.$PN.ExtHostLabelService,new B.$irc(Ke)),xt=Ke.set(n.$PN.ExtHostTheming,new $t.$Jrc(Ke)),rn=Ke.set(n.$PN.ExtHostTimeline,new qe.$Lrc(Ke,bt)),Vi=Ke.set(n.$PN.ExtHostWebviews,new wt.$dqc(Ke,Dt.remote,gt,vt,Nt)),zi=Ke.set(n.$PN.ExtHostWebviewPanels,new Lt.$gqc(Ke,Vi,gt)),Qi=Ke.set(n.$PN.ExtHostCustomEditors,new b.$hqc(Ke,Ot,di,Vi,zi)),Hi=Ke.set(n.$PN.ExtHostWebviewViews,new Qt.$Prc(Ke,Vi)),Pi=Ke.set(n.$PN.ExtHostTesting,pt.get(ct.$Oqc)),sn=Ke.set(n.$PN.ExtHostUriOpeners,new Ze.$Nrc(Ke)),on=Ke.set(n.$PN.ExtHostProfileContentHandlers,new z.$urc(Ke));Ke.set(n.$PN.ExtHostInteractive,new X.$hrc(Ke,Rt,Mt,bt,vt));const Li=Ke.set(n.$PN.ExtHostChatAgents2,new h.$Wpc(Ke,vt,bt,Ot)),an=Ke.set(n.$PN.ExtHostChatVariables,new E.$Xpc(Ke)),ji=Ke.set(n.$PN.ExtHostLanguageModelTools,new ye.$jrc(Ke)),Gi=Ke.set(n.$PN.ExtHostAiRelatedInformation,new t.$Ipc(Ke)),En=Ke.set(n.$PN.ExtHostAiEmbeddingVector,new le.$5qc(Ke)),cn=Ke.set(n.$PN.ExtHostStatusBar,new tt.$Drc(Ke,bt.converter)),Ki=Ke.set(n.$PN.ExtHostSpeech,new _e.$Brc(Ke)),Ri=Ke.set(n.$PN.ExtHostEmbeddings,new me.$4qc(Ke)),Dn=Object.values(n.$PN);Ke.assertRegistered(Dn);const Sn=new m.$Vpc(Ke,Mt),ln=new D.$Ypc(Ke),Ji=new x.$lrc(Ke,vt),Zi=new W.$1qc(Ke);return g.$Spc.register(bt),function(Fe,vi,Xi){function ot(ie){return(ue,Le,at)=>{const yt=ie(Tt=>{try{ue.call(Le,Tt)}catch(gi){I.$1(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),Ut.onExtensionError(Fe.identifier,gi)}});return at?.push(yt),yt}}const St=function(){let ie=!Fe.isUnderDevelopment;function ue(){ie||(vt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")ue();else{const yt=at;typeof yt.scheme>"u"&&ue(),typeof yt.exclusive=="boolean"&&(0,Ye.$jH)(Fe,"documentFiltersExclusive")}return at}}(),Yi={getSession(ie,ue,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$jH)(Fe,"authLearnMore"),Bt.getSession(Fe,ie,ue,Le)},getAccounts(ie){return Bt.getAccounts(ie)},async hasSession(ie,ue){return(0,Ye.$jH)(Fe,"authSession"),!!await Bt.getSession(Fe,ie,ue,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(ie,ue,Le,at){return Bt.registerAuthenticationProvider(ie,ue,Le,at)}},un={registerCommand(ie,ue,Le){return bt.registerCommand(!0,ie,ue,Le,void 0,Fe)},registerTextEditorCommand(ie,ue,Le){return bt.registerCommand(!0,ie,(...at)=>{const yt=qt.getActiveTextEditor();if(!yt){vt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return yt.edit(Tt=>{ue.apply(Le,[yt,Tt,...at])}).then(Tt=>{Tt||vt.warn("Edits from command "+ie+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+ie,Tt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"diffCommand"),bt.registerCommand(!0,ie,async(...at)=>{const yt=Mt.activeEditor(!0);if(!yt){vt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Tt=await qt.getDiffInformation(yt.id);ue.apply(Le,[Tt,...at])},void 0,void 0,Fe)),executeCommand(ie,...ue){return bt.executeCommand(ie,...ue)},getCommands(ie=!1){return bt.getCommands(ie)}},yi={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$jH)(Fe,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$jH)(Fe,"telemetry"),ot(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ft.$HQ)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,ue){return ft.$GQ.validateSender(ie),Ut.instantiateLogger(Fe,ie,ue)},openExternal(ie,ue){return Wt.openUri(ie,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Dt.environment.appUriScheme)return Oi.createAppUri(ie);try{return await Wt.asExternalUri(ie,{allowTunneling:!!Dt.remote.authority})}catch(ue){if((0,O.$Pg)(ie,O.Schemas.http)||(0,O.$Pg)(ie,O.Schemas.https))return ie;throw ue}},get remoteName(){return(0,c.$jn)(Dt.remote.authority)},get remoteAuthority(){return(0,Ye.$jH)(Fe,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return ot(vt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$jH)(Fe,"resolvers"),Dt.quality},get appCommit(){return(0,Ye.$jH)(Fe,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(yi);const Bi={createTestController(ie,ue,Le){return Pi.createTestController(Fe,ie,ue,Le)},createTestObserver(){return(0,Ye.$jH)(Fe,"testObserver"),Pi.createTestObserver()},runTests(ie){return(0,Ye.$jH)(Fe,"testObserver"),Pi.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ye.$jH)(Fe,"testObserver"),Pi.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ye.$jH)(Fe,"testObserver"),ot(Pi.onResultsChanged)},get testResults(){return(0,Ye.$jH)(Fe,"testObserver"),Pi.results}},qi=Dt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,$i={getExtension(ie,ue){(0,Ye.$iH)(Fe,"extensionsAny")||(ue=!1);const Le=vi.mine.getExtensionDescription(ie);if(Le)return new _.$Kqc(jt,Fe.identifier,Le,qi,!1);if(ue){const at=vi.all.getExtensionDescription(ie);if(at)return new _.$Kqc(jt,Fe.identifier,at,qi,!0)}},get all(){const ie=[];for(const ue of vi.mine.getAllExtensionDescriptions())ie.push(new _.$Kqc(jt,Fe.identifier,ue,qi,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.$jH)(Fe,"extensionsAny");const ie=new d.$tn(vi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),ue=[];for(const Le of vi.all.getAllExtensionDescriptions()){const at=!ie.has(Le.identifier);ue.push(new _.$Kqc(jt,Fe.identifier,Le,qi,at))}return ue},get onDidChange(){return(0,Ye.$iH)(Fe,"extensionsAny")?ot(T.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):ot(vi.mine.onDidChange)}},Wi={createDiagnosticCollection(ie){return Re.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return ot(Re.onDidChangeDiagnostics)},getDiagnostics:ie=>Re.getDiagnostics(ie),getLanguages(){return fe.getLanguages()},setTextDocumentLanguage(ie,ue){return fe.changeLanguage(ie.uri,ue)},match(ie,ue){const Le=ee.LanguageSelector.from(ie);let at;return(0,y.$Au)(Le)&&(at=Rt.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Tt=>Tt.document===ue))?.apiNotebook),(0,y.$zu)(Le,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,ue,Le){return H.registerCodeActionProvider(Fe,St(ie),ue,Le)},registerDocumentPasteEditProvider(ie,ue,Le){return(0,Ye.$jH)(Fe,"documentPaste"),H.registerDocumentPasteEditProvider(Fe,St(ie),ue,Le)},registerCodeLensProvider(ie,ue){return H.registerCodeLensProvider(Fe,St(ie),ue)},registerDefinitionProvider(ie,ue){return H.registerDefinitionProvider(Fe,St(ie),ue)},registerDeclarationProvider(ie,ue){return H.registerDeclarationProvider(Fe,St(ie),ue)},registerImplementationProvider(ie,ue){return H.registerImplementationProvider(Fe,St(ie),ue)},registerTypeDefinitionProvider(ie,ue){return H.registerTypeDefinitionProvider(Fe,St(ie),ue)},registerHoverProvider(ie,ue){return H.registerHoverProvider(Fe,St(ie),ue,Fe.identifier)},registerEvaluatableExpressionProvider(ie,ue){return H.registerEvaluatableExpressionProvider(Fe,St(ie),ue,Fe.identifier)},registerInlineValuesProvider(ie,ue){return H.registerInlineValuesProvider(Fe,St(ie),ue,Fe.identifier)},registerDocumentHighlightProvider(ie,ue){return H.registerDocumentHighlightProvider(Fe,St(ie),ue)},registerMultiDocumentHighlightProvider(ie,ue){return H.registerMultiDocumentHighlightProvider(Fe,St(ie),ue)},registerLinkedEditingRangeProvider(ie,ue){return H.registerLinkedEditingRangeProvider(Fe,St(ie),ue)},registerReferenceProvider(ie,ue){return H.registerReferenceProvider(Fe,St(ie),ue)},registerRenameProvider(ie,ue){return H.registerRenameProvider(Fe,St(ie),ue)},registerNewSymbolNamesProvider(ie,ue){return(0,Ye.$jH)(Fe,"newSymbolNamesProvider"),H.registerNewSymbolNamesProvider(Fe,St(ie),ue)},registerDocumentSymbolProvider(ie,ue,Le){return H.registerDocumentSymbolProvider(Fe,St(ie),ue,Le)},registerWorkspaceSymbolProvider(ie){return H.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,ue){return H.registerDocumentFormattingEditProvider(Fe,St(ie),ue)},registerDocumentRangeFormattingEditProvider(ie,ue){return H.registerDocumentRangeFormattingEditProvider(Fe,St(ie),ue)},registerOnTypeFormattingEditProvider(ie,ue,Le,...at){return H.registerOnTypeFormattingEditProvider(Fe,St(ie),ue,[Le].concat(at))},registerDocumentSemanticTokensProvider(ie,ue,Le){return H.registerDocumentSemanticTokensProvider(Fe,St(ie),ue,Le)},registerDocumentRangeSemanticTokensProvider(ie,ue,Le){return H.registerDocumentRangeSemanticTokensProvider(Fe,St(ie),ue,Le)},registerSignatureHelpProvider(ie,ue,Le,...at){return typeof Le=="object"?H.registerSignatureHelpProvider(Fe,St(ie),ue,Le):H.registerSignatureHelpProvider(Fe,St(ie),ue,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(ie,ue,...Le){return H.registerCompletionItemProvider(Fe,St(ie),ue,Le)},registerInlineCompletionItemProvider(ie,ue,Le){return ue.handleDidShowCompletionItem&&(0,Ye.$jH)(Fe,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$jH)(Fe,"inlineCompletionsAdditions"),Le&&(0,Ye.$jH)(Fe,"inlineCompletionsAdditions"),H.registerInlineCompletionsProvider(Fe,St(ie),ue,Le)},registerInlineEditProvider(ie,ue){return(0,Ye.$jH)(Fe,"inlineEdit"),H.registerInlineEditProvider(Fe,St(ie),ue)},registerDocumentLinkProvider(ie,ue){return H.registerDocumentLinkProvider(Fe,St(ie),ue)},registerColorProvider(ie,ue){return H.registerColorProvider(Fe,St(ie),ue)},registerFoldingRangeProvider(ie,ue){return H.registerFoldingRangeProvider(Fe,St(ie),ue)},registerSelectionRangeProvider(ie,ue){return H.registerSelectionRangeProvider(Fe,ie,ue)},registerCallHierarchyProvider(ie,ue){return H.registerCallHierarchyProvider(Fe,ie,ue)},registerTypeHierarchyProvider(ie,ue){return H.registerTypeHierarchyProvider(Fe,ie,ue)},setLanguageConfiguration:(ie,ue)=>H.setLanguageConfiguration(Fe,ie,ue),getTokenInformationAtPosition(ie,ue){return(0,Ye.$jH)(Fe,"tokenInformation"),fe.tokenAtPosition(ie,ue)},registerInlayHintsProvider(ie,ue){return H.registerInlayHintsProvider(Fe,ie,ue)},createLanguageStatusItem(ie,ue){return fe.createLanguageStatusItem(Fe,ie,ue)},registerDocumentDropEditProvider(ie,ue,Le){return H.registerDocumentOnDropEditProvider(Fe,ie,ue,(0,Ye.$iH)(Fe,"documentPaste")?Le:void 0)}},hn={get activeTextEditor(){return qt.getActiveTextEditor()},get visibleTextEditors(){return qt.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(ie,ue,Le){o.URI.isUri(ie)&&ie.scheme===O.Schemas.vscodeRemote&&!ie.authority&&Nt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(o.URI.isUri(ie)?Promise.resolve(xi.openTextDocument(ie)):Promise.resolve(ie));return qt.showTextDocument(at,ue,Le)},createTextEditorDecorationType(ie){return qt.createTextEditorDecorationType(Fe,ie)},onDidChangeActiveTextEditor(ie,ue,Le){return ot(qt.onDidChangeActiveTextEditor)(ie,ue,Le)},onDidChangeVisibleTextEditors(ie,ue,Le){return ot(qt.onDidChangeVisibleTextEditors)(ie,ue,Le)},onDidChangeTextEditorSelection(ie,ue,Le){return ot(qt.onDidChangeTextEditorSelection)(ie,ue,Le)},onDidChangeTextEditorOptions(ie,ue,Le){return ot(qt.onDidChangeTextEditorOptions)(ie,ue,Le)},onDidChangeTextEditorVisibleRanges(ie,ue,Le){return ot(qt.onDidChangeTextEditorVisibleRanges)(ie,ue,Le)},onDidChangeTextEditorViewColumn(ie,ue,Le){return ot(qt.onDidChangeTextEditorViewColumn)(ie,ue,Le)},onDidCloseTerminal(ie,ue,Le){return ot(kt.onDidCloseTerminal)(ie,ue,Le)},onDidOpenTerminal(ie,ue,Le){return ot(kt.onDidOpenTerminal)(ie,ue,Le)},onDidChangeActiveTerminal(ie,ue,Le){return ot(kt.onDidChangeActiveTerminal)(ie,ue,Le)},onDidChangeTerminalDimensions(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(ie,ue,Le)},onDidChangeTerminalState(ie,ue,Le){return ot(kt.onDidChangeTerminalState)(ie,ue,Le)},onDidWriteTerminalData(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(ie,ue,Le)},onDidExecuteTerminalCommand(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(ie,ue,Le)},onDidChangeTerminalShellIntegration(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalShellIntegration"),ot(Vt.onDidChangeTerminalShellIntegration)(ie,ue,Le)},onDidStartTerminalShellExecution(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalShellIntegration"),ot(Vt.onDidStartTerminalShellExecution)(ie,ue,Le)},onDidEndTerminalShellExecution(ie,ue,Le){return(0,Ye.$jH)(Fe,"terminalShellIntegration"),ot(Vt.onDidEndTerminalShellExecution)(ie,ue,Le)},get state(){return Wt.getState()},onDidChangeWindowState(ie,ue,Le){return ot(Wt.onDidChangeWindowState)(ie,ue,Le)},showInformationMessage(ie,...ue){return Ji.showMessage(Fe,$.default.Info,ie,ue[0],ue.slice(1))},showWarningMessage(ie,...ue){return Ji.showMessage(Fe,$.default.Warning,ie,ue[0],ue.slice(1))},showErrorMessage(ie,...ue){return Ji.showMessage(Fe,$.default.Error,ie,ue[0],ue.slice(1))},showQuickPick(ie,ue,Le){return Xe.showQuickPick(Fe,ie,ue,Le)},showWorkspaceFolderPick(ie){return Xe.showWorkspaceFolderPick(ie)},showInputBox(ie,ue){return Xe.showInput(ie,ue)},showOpenDialog(ie){return Zi.showOpenDialog(Fe,ie)},showSaveDialog(ie){return Zi.showSaveDialog(ie)},createStatusBarItem(ie,ue,Le){let at,yt,Tt;return typeof ie=="string"?(at=ie,yt=ue,Tt=Le):(yt=ie,Tt=ue),cn.createStatusBarEntry(Fe,at,yt,Tt)},setStatusBarMessage(ie,ue){return cn.setStatusBarMessage(ie,ue)},withScmProgress(ie){return Nt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Yt.withProgress(Fe,{location:Y.ProgressLocation.SourceControl},(ue,Le)=>ie({report(at){}}))},withProgress(ie,ue){return Yt.withProgress(Fe,ie,ue)},createOutputChannel(ie,ue){return ki.createOutputChannel(ie,ue,Fe)},createWebviewPanel(ie,ue,Le,at){return zi.createWebviewPanel(Fe,ie,ue,Le,at)},createWebviewTextEditorInset(ie,ue,Le,at){return(0,Ye.$jH)(Fe,"editorInsets"),Ee.createWebviewEditorInset(ie,ue,Le,at,Fe)},createTerminal(ie,ue,Le){return typeof ie=="object"?"pty"in ie?kt.createExtensionTerminal(ie):kt.createTerminalFromOptions(ie):kt.createTerminal(ie,ue,Le)},registerTerminalLinkProvider(ie){return kt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,ue){return kt.registerProfileProvider(Fe,ie,ue)},registerTerminalQuickFixProvider(ie,ue){return(0,Ye.$jH)(Fe,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(ie,Fe.identifier.value,ue)},registerTreeDataProvider(ie,ue){return Ci.registerTreeDataProvider(ie,ue,Fe)},createTreeView(ie,ue){return Ci.createTreeView(ie,ue,Fe)},registerWebviewPanelSerializer:(ie,ue)=>zi.registerWebviewPanelSerializer(Fe,ie,ue),registerCustomEditorProvider:(ie,ue,Le={})=>Qi.registerCustomEditorProvider(Fe,ie,ue,Le),registerFileDecorationProvider(ie){return Kt.registerFileDecorationProvider(ie,Fe)},registerUriHandler(ie){return Oi.registerUriHandler(Fe,ie)},createQuickPick(){return Xe.createQuickPick(Fe)},createInputBox(){return Xe.createInputBox(Fe)},get activeColorTheme(){return xt.activeColorTheme},onDidChangeActiveColorTheme(ie,ue,Le){return ot(xt.onDidChangeActiveColorTheme)(ie,ue,Le)},registerWebviewViewProvider(ie,ue,Le){return Hi.registerWebviewViewProvider(Fe,ie,ue,Le?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,ue,Le){return ot(Rt.onDidChangeActiveNotebookEditor)(ie,ue,Le)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,ue,Le){return ot(Ii.onDidChangeNotebookEditorSelection)(ie,ue,Le)},onDidChangeNotebookEditorVisibleRanges(ie,ue,Le){return ot(Ii.onDidChangeNotebookEditorVisibleRanges)(ie,ue,Le)},showNotebookDocument(ie,ue){return Rt.showNotebookDocument(ie,ue)},registerExternalUriOpener(ie,ue,Le){return(0,Ye.$jH)(Fe,"externalUriOpener"),sn.registerExternalUriOpener(Fe.identifier,ie,ue,Le)},registerProfileContentHandler(ie,ue){return(0,Ye.$jH)(Fe,"profileContentHandlers"),on.registerProfileContentHandler(Fe,ie,ue)},registerQuickDiffProvider(ie,ue,Le,at){return(0,Ye.$jH)(Fe,"quickDiffProvider"),ut.registerQuickDiffProvider(St(ie),ue,Le,at)},get tabGroups(){return Gt.tabGroups},registerShareProvider(ie,ue){return(0,Ye.$jH)(Fe,"shareProvider"),Pt.registerShareProvider(St(ie),ue)}},xi={get rootPath(){return Nt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(ie){throw new I.$9("rootPath")},getWorkspaceFolder(ie){return gt.getWorkspaceFolder(ie)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(ie){throw new I.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(ie){throw new I.$9("workspaceFile")},updateWorkspaceFolders:(ie,ue,...Le)=>gt.updateWorkspaceFolders(Fe,ie,ue||0,...Le),onDidChangeWorkspaceFolders:function(ie,ue,Le){return ot(gt.onDidChangeWorkspace)(ie,ue,Le)},asRelativePath:(ie,ue)=>gt.getRelativePath(ie,ue),findFiles:(ie,ue,Le,at)=>gt.findFiles(ie,ue,Le,Fe.identifier,at),findFiles2:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"findFiles2"),gt.findFiles2(ie,ue,Fe.identifier,Le)),findFiles2New:(ie,ue,Le)=>{(0,Ye.$jH)(Fe,"findFiles2New");const at={exclude:ue?.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useDefaultSearchExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:ue?.maxResults,useIgnoreFiles:ue?.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue?.useIgnoreFiles?.global,useParentIgnoreFiles:ue?.useIgnoreFiles?.parent,followSymlinks:ue?.followSymlinks};return gt.findFiles2(ie&&ie.length>0?ie[0]:void 0,at,Fe.identifier,Le)},findTextInFiles:(ie,ue,Le,at)=>{(0,Ye.$jH)(Fe,"findTextInFiles");let yt,Tt;return typeof ue=="object"?(yt=ue,Tt=Le):(yt={},Tt=ue,at=Le),gt.findTextInFiles(ie,yt||{},Tt,Fe.identifier,at)},findTextInFilesNew:(ie,ue,Le)=>{(0,Ye.$jH)(Fe,"findTextInFilesNew"),(0,Ye.$jH)(Fe,"textSearchProviderNew");let at={};ue&&(at={include:ue.include&&ue.include.length>0?ue.include[0]:void 0,exclude:ue.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||ue.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useSearchExclude:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:ue.maxResults,useIgnoreFiles:ue.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue.useIgnoreFiles?.global,useParentIgnoreFiles:ue.useIgnoreFiles?.parent,followSymlinks:ue.followSymlinks,encoding:ue.encoding,previewOptions:ue.previewOptions?{matchLines:ue.previewOptions?.numMatchLines??100,charsPerLine:ue.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:ue.surroundingContext,afterContext:ue.surroundingContext});const yt=Promise.resolve(void 0);return{results:new v.$7h(async gi=>{const Fi=async en=>(gi.emitOne((0,Ct.$5L)(en)),en);await yt.then(en=>gt.findTextInFiles(ie,at,Fi,Fe.identifier,Le))}),complete:yt.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:ie=>gt.save(ie),saveAs:ie=>gt.saveAs(ie),saveAll:ie=>gt.saveAll(ie),applyEdit(ie,ue){return Sn.applyWorkspaceEdit(ie,Fe,ue)},createFileSystemWatcher:(ie,ue,Le,at)=>{let yt;return typeof ue=="boolean"?yt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ye.$jH)(Fe,"createFileSystemWatcher"),yt={...ue,correlate:!0}),Be.createFileSystemWatcher(gt,Fe,ie,yt)},get textDocuments(){return Ot.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new I.$9("textDocuments")},openTextDocument(ie){let ue;const Le=ie;if(typeof ie=="string")ue=Promise.resolve(o.URI.file(ie));else if(o.URI.isUri(ie))ue=Promise.resolve(ie);else if(!Le||typeof Le=="object")ue=Ot.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(vt.trace(`openTextDocument from ${Fe.identifier}`),at.scheme===O.Schemas.vscodeRemote&&!at.authority&&Nt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Ot.ensureDocumentData(at).then(yt=>yt.document)))},onDidOpenTextDocument:(ie,ue,Le)=>ot(Ot.onDidAddDocument)(ie,ue,Le),onDidCloseTextDocument:(ie,ue,Le)=>ot(Ot.onDidRemoveDocument)(ie,ue,Le),onDidChangeTextDocument:(ie,ue,Le)=>ot(Ot.onDidChangeDocument)(ie,ue,Le),onDidSaveTextDocument:(ie,ue,Le)=>ot(Ot.onDidSaveDocument)(ie,ue,Le),onWillSaveTextDocument:(ie,ue,Le)=>ot(ui.getOnWillSaveTextDocumentEvent(Fe))(ie,ue,Le),get notebookDocuments(){return Rt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,ue){let Le;if(o.URI.isUri(ie))Le=ie,await Rt.openNotebookDocument(ie);else if(typeof ie=="string")Le=o.URI.revive(await Rt.createNotebookDocument({viewType:ie,content:ue}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ie,ue,Le){return ot(Ti.onDidSaveNotebookDocument)(ie,ue,Le)},onDidChangeNotebookDocument(ie,ue,Le){return ot(Ti.onDidChangeNotebookDocument)(ie,ue,Le)},onWillSaveNotebookDocument(ie,ue,Le){return ot(pi.getOnWillSaveNotebookDocumentEvent(Fe))(ie,ue,Le)},get onDidOpenNotebookDocument(){return ot(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,ue,Le,at){return Rt.registerNotebookSerializer(Fe,ie,ue,Le,(0,Ye.$iH)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,ue,Le)=>ot(Xi.onDidChangeConfiguration)(ie,ue,Le),getConfiguration(ie,ue){return ue=arguments.length===1?void 0:ue,Xi.getConfiguration(ie,ue,Fe)},registerTextDocumentContentProvider(ie,ue){return Mi.registerTextDocumentContentProvider(ie,ue)},registerTaskProvider:(ie,ue)=>(Nt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(Fe,ie,ue)),registerFileSystemProvider(ie,ue,Le){return(0,A.$Sc)(Ie.registerFileSystemProvider(Fe,ie,ue,Le),ni.addFileSystemProvider(ie,ue,Le))},get fs(){return ni.value},registerFileSearchProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"fileSearchProvider"),mi.registerFileSearchProvider(ie,ue)),registerTextSearchProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"textSearchProvider"),mi.registerTextSearchProvider(ie,ue)),registerAITextSearchProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"aiTextSearchProvider"),(0,Ye.$jH)(Fe,"textSearchProvider"),mi.registerAITextSearchProvider(ie,ue)),registerFileSearchProviderNew:(ie,ue)=>((0,Ye.$jH)(Fe,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(ie,ue)=>((0,Ye.$jH)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(ie,ue)=>((0,Ye.$jH)(Fe,"aiTextSearchProviderNew"),(0,Ye.$jH)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(ie,ue)=>((0,Ye.$jH)(Fe,"resolvers"),jt.registerRemoteAuthorityResolver(ie,ue)),registerResourceLabelFormatter:ie=>((0,Ye.$jH)(Fe,"resolvers"),zt.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.$jH)(Fe,"resolvers"),jt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,ue,Le)=>ot(Be.onDidCreateFile)(ie,ue,Le),onDidDeleteFiles:(ie,ue,Le)=>ot(Be.onDidDeleteFile)(ie,ue,Le),onDidRenameFiles:(ie,ue,Le)=>ot(Be.onDidRenameFile)(ie,ue,Le),onWillCreateFiles:(ie,ue,Le)=>ot(Be.getOnWillCreateFileEvent(Fe))(ie,ue,Le),onWillDeleteFiles:(ie,ue,Le)=>ot(Be.getOnWillDeleteFileEvent(Fe))(ie,ue,Le),onWillRenameFiles:(ie,ue,Le)=>ot(Be.getOnWillRenameFileEvent(Fe))(ie,ue,Le),openTunnel:ie=>((0,Ye.$jH)(Fe,"tunnels"),Ft.openTunnel(Fe,ie).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$jH)(Fe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"tunnels"),ot(Ft.onDidChangeTunnels)(ie,ue,Le)),registerPortAttributesProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"portsAttributes"),Ft.registerPortsAttributesProvider(ie,ue)),registerTunnelProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"tunnelFactory"),Ft.registerTunnelProvider(ie,ue)),registerTimelineProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"timeline"),rn.registerTimelineProvider(ie,ue,Fe.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:ie=>((0,Ye.$jH)(Fe,"workspaceTrust"),gt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,ue,Le)=>ot(gt.onDidGrantWorkspaceTrust)(ie,ue,Le),registerEditSessionIdentityProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(ie,ue)),onWillCreateEditSessionIdentity:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Fe))(ie,ue,Le)),registerCanonicalUriProvider:(ie,ue)=>((0,Ye.$jH)(Fe,"canonicalUriProvider"),gt.registerCanonicalUriProvider(ie,ue)),getCanonicalUri:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"canonicalUriProvider"),gt.provideCanonicalUri(ie,ue,Le))},dn={get inputBox(){return Nt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Qe.getLastInputBox(Fe)},createSourceControl(ie,ue,Le){return Qe.createSourceControl(Fe,ie,ue,Le)}},fn={createCommentController(ie,ue){return Jt.createCommentController(Fe,ie,ue)}},kn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ie,ue){return(0,Ye.$jH)(Fe,"debugVisualization"),It.registerDebugVisualizationProvider(Fe,ie,ue)},registerDebugVisualizationTreeProvider(ie,ue){return(0,Ye.$jH)(Fe,"debugVisualization"),It.registerDebugVisualizationTree(Fe,ie,ue)},onDidStartDebugSession(ie,ue,Le){return ot(It.onDidStartDebugSession)(ie,ue,Le)},onDidTerminateDebugSession(ie,ue,Le){return ot(It.onDidTerminateDebugSession)(ie,ue,Le)},onDidChangeActiveDebugSession(ie,ue,Le){return ot(It.onDidChangeActiveDebugSession)(ie,ue,Le)},onDidReceiveDebugSessionCustomEvent(ie,ue,Le){return ot(It.onDidReceiveDebugSessionCustomEvent)(ie,ue,Le)},onDidChangeBreakpoints(ie,ue,Le){return ot(It.onDidChangeBreakpoints)(ie,ue,Le)},onDidChangeActiveStackItem(ie,ue,Le){return ot(It.onDidChangeActiveStackItem)(ie,ue,Le)},registerDebugConfigurationProvider(ie,ue,Le){return It.registerDebugConfigurationProvider(ie,ue,Le||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,ue){return It.registerDebugAdapterDescriptorFactory(Fe,ie,ue)},registerDebugAdapterTrackerFactory(ie,ue){return It.registerDebugAdapterTrackerFactory(ie,ue)},startDebugging(ie,ue,Le){return!Le||typeof Le=="object"&&"configuration"in Le?It.startDebugging(ie,ue,{parentSession:Le}):It.startDebugging(ie,ue,Le||{})},stopDebugging(ie){return It.stopDebugging(ie)},addBreakpoints(ie){return It.addBreakpoints(ie)},removeBreakpoints(ie){return It.removeBreakpoints(ie)},asDebugSourceUri(ie,ue){return It.asDebugSourceUri(ie,ue)}},gn={registerTaskProvider:(ie,ue)=>Xt.registerTaskProvider(Fe,ie,ue),fetchTasks:ie=>Xt.fetchTasks(ie),executeTask:ie=>Xt.executeTask(Fe,ie),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:(ie,ue,Le)=>ot(Xt.onDidStartTask)(ie,ue,Le),onDidEndTask:(ie,ue,Le)=>ot(Xt.onDidEndTask)(ie,ue,Le),onDidStartTaskProcess:(ie,ue,Le)=>ot(Xt.onDidStartTaskProcess)(ie,ue,Le),onDidEndTaskProcess:(ie,ue,Le)=>ot(Xt.onDidEndTaskProcess)(ie,ue,Le)},mn={createNotebookController(ie,ue,Le,at,yt){return Di.createNotebookController(Fe,ie,ue,Le,at,(0,Ye.$iH)(Fe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,ue)=>Rt.registerNotebookCellStatusBarItemProvider(Fe,ie,ue),createRendererMessaging(ie){return Ui.createRendererMessaging(Fe,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.$jH)(Fe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(Fe,ie)},registerKernelSourceActionProvider(ie,ue){return(0,Ye.$jH)(Fe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(Fe,ie,ue)},onDidChangeNotebookCellExecutionState(ie,ue,Le){return(0,Ye.$jH)(Fe,"notebookCellExecutionState"),ot(Di.onDidChangeNotebookCellExecutionState)(ie,ue,Le)}},In={t(...ie){if(typeof ie[0]=="string"){const ue=ie.shift(),Le=!ie||typeof ie[0]!="object"?ie:ie[0];return wi.getMessage(Fe.identifier.value,{message:ue,args:Le})}return wi.getMessage(Fe.identifier.value,ie[0])},get bundle(){return wi.getBundle(Fe.identifier.value)},get uri(){return wi.getBundleUri(Fe.identifier.value)}},Cn={_version:1,transferActiveChat(ie){return(0,Ye.$jH)(Fe,"interactive"),Li.transferActiveChat(ie)}},pn={getRelatedInformation(ie,ue){return(0,Ye.$jH)(Fe,"aiRelatedInformation"),Gi.getRelatedInformation(Fe,ie,ue)},registerRelatedInformationProvider(ie,ue){return(0,Ye.$jH)(Fe,"aiRelatedInformation"),Gi.registerRelatedInformationProvider(Fe,ie,ue)},registerEmbeddingVectorProvider(ie,ue){return(0,Ye.$jH)(Fe,"aiRelatedInformation"),En.registerEmbeddingVectorProvider(Fe,ie,ue)}},_i={_version:1,registerChatResponseProvider(ie,ue,Le){return(0,Ye.$jH)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,ue,Le)},registerChatVariableResolver(ie,ue,Le,at,yt,Tt,gi,Fi){return(0,Ye.$jH)(Fe,"chatVariableResolver"),an.registerVariableResolver(Fe,ie,ue,Le,at,yt,Tt,gi,Fi?.id)},registerMappedEditsProvider(ie,ue){return(0,Ye.$jH)(Fe,"mappedEditsProvider"),H.registerMappedEditsProvider(Fe,ie,ue)},createChatParticipant(ie,ue){return Li.createChatAgent(Fe,ie,ue)},createDynamicChatParticipant(ie,ue,Le){return(0,Ye.$jH)(Fe,"chatParticipantPrivate"),Li.createDynamicChatAgent(Fe,ie,ue,Le)},registerChatParticipantDetectionProvider(ie){return(0,Ye.$jH)(Fe,"chatParticipantAdditions"),Li.registerChatParticipantDetectionProvider(ie)}},$n={selectChatModels:ie=>Ht.selectLanguageModels(Fe,ie??{}),onDidChangeChatModels:(ie,ue,Le)=>Ht.onDidChangeProviders(ie,ue,Le),registerChatModelProvider:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,ue,Le)),get embeddingModels(){return(0,Ye.$jH)(Fe,"embeddings"),Ri.embeddingsModels},onDidChangeEmbeddingModels:(ie,ue,Le)=>((0,Ye.$jH)(Fe,"embeddings"),Ri.onDidChange(ie,ue,Le)),registerEmbeddingsProvider(ie,ue){return(0,Ye.$jH)(Fe,"embeddings"),Ri.registerEmbeddingsProvider(Fe,ie,ue)},async computeEmbeddings(ie,ue,Le){return(0,Ye.$jH)(Fe,"embeddings"),Ri.computeEmbeddings(ie,ue,Le)},registerTool(ie,ue){return(0,Ye.$jH)(Fe,"lmTools"),ji.registerTool(Fe,ie,ue)},invokeTool(ie,ue,Le){return(0,Ye.$jH)(Fe,"lmTools"),ji.invokeTool(ie,ue,Le)},get tools(){return(0,Ye.$jH)(Fe,"lmTools"),ji.tools}},bn={registerSpeechProvider(ie,ue){return(0,Ye.$jH)(Fe,"speech"),Ki.registerProvider(Fe.identifier,ie,ue)}};return{version:Dt.version,ai:pn,authentication:Yi,commands:un,comments:fn,chat:_i,debug:kn,env:yi,extensions:$i,interactive:Cn,l10n:In,languages:Wi,lm:$n,notebooks:mn,scm:dn,speech:bn,tasks:gn,tests:Bi,window:hn,workspace:xi,Breakpoint:Y.$TO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$PP,CallHierarchyIncomingCall:Y.$fO,CallHierarchyItem:Y.$eO,CallHierarchyOutgoingCall:Y.$gO,CancellationError:I.$5,CancellationTokenSource:P.$xe,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$bO,CodeActionKind:Y.$cO,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$hO,Color:Y.$uO,ColorInformation:Y.$vO,ColorPresentation:Y.$wO,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CommentThreadFocus:Y.CommentThreadFocus,CompletionItem:Y.$oO,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$pO,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$EO,DebugAdapterExecutable:Y.$XO,DebugAdapterInlineImplementation:Y.$1O,DebugAdapterNamedPipeServer:Y.$ZO,DebugAdapterServer:Y.$YO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$eP,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$7N,DiagnosticRelatedInformation:Y.$6N,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$QN,DocumentHighlight:Y.$0N,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$$N,DocumentLink:Y.$tO,DocumentSymbol:Y.$aO,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$4O,InlineValueText:Y.$5O,InlineValueVariableLookup:Y.$6O,InlineValueEvaluatableExpression:Y.$7O,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:T.$me,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$gP,FileDecoration2:Y.$gP,FileSystemError:Y.$0O,FileType:r.FileType,FilePermission:r.FilePermission,FoldingRange:Y.$$O,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$VO,InlineCompletionItem:Y.$qO,InlineCompletionList:Y.$rO,Hover:Y.$8N,VerboseHover:Y.$9N,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:a.IndentAction,Location:Y.$5N,MarkdownString:Y.$iO,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Y.$jO,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$RN,ProcessExecution:Y.$CO,ProgressLocation:Y.ProgressLocation,QuickInputButtonLocation:Y.QuickInputButtonLocation,QuickInputButtons:Y.$fP,Range:Y.$SN,RelativePattern:Y.$RO,Selection:Y.$TN,SelectionRange:Y.$dO,SemanticTokens:Y.$bP,SemanticTokensBuilder:Y.$aP,SemanticTokensEdit:Y.$cP,SemanticTokensEdits:Y.$dP,SemanticTokensLegend:Y.$_O,ShellExecution:Y.$DO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$lO,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$kO,SnippetString:Y.$4N,SourceBreakpoint:Y.$UO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$_N,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$FO,TaskGroup:Y.$BO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$xO,TerminalQuickFixTerminalCommand:Y.$zO,TerminalQuickFixOpener:Y.$yO,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$AO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$ZN,SnippetTextEdit:Y.$2N,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$QO,ThemeIcon:Y.$PO,TreeItem:Y.$GO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$DP,UIKind:At.UIKind,Uri:o.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$3N,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$MO,DocumentDropOrPasteEditKind:Y.$NO,DocumentPasteEdit:Y.$OO,InlayHint:Y.$nO,InlayHintLabelPart:Y.$mO,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$YN,ResolvedAuthority:Y.$WN,ManagedResolvedAuthority:Y.$XN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$qP,NotebookRange:Y.$iP,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$jP,NotebookData:Y.$kP,NotebookRendererScript:Y.$oP,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$mP,NotebookCellOutputItem:Y.$lP,NotebookCellStatusBarItem:Y.$nP,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$1N,NotebookKernelSourceAction:Y.$pP,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$sP,LinkedEditingRanges:Y.$rP,TestResultState:Y.TestResultState,TestRunRequest:Y.$tP,TestMessage:Y.$uP,TestMessage2:Y.$uP,TestMessageStackFrame:Y.$wP,TestTag:Y.$vP,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:Y.$LO,DataTransferItem:Y.$HO,TestCoverageCount:Y.$xP,FileCoverage:Y.$zP,FileCoverage2:Y.$zP,StatementCoverage:Y.$AP,BranchCoverage:Y.$BP,DeclarationCoverage:Y.$CP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$EP,TabInputTextDiff:Y.$FP,TabInputTextMerge:Y.$GP,TabInputCustom:Y.$HP,TabInputNotebook:Y.$JP,TabInputNotebookDiff:Y.$KP,TabInputWebview:Y.$IP,TabInputTerminal:Y.$LP,TabInputInteractiveWindow:Y.$MP,TabInputChat:Y.$NP,TabInputTextMultiDiff:Y.$OP,TelemetryTrustedValue:l.$yp,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$2O,DebugThread:Y.$3O,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$QP,ChatResponseFileTreePart:Y.$UP,ChatResponseAnchorPart:Y.$VP,ChatResponseProgressPart:Y.$WP,ChatResponseProgressPart2:Y.$XP,ChatResponseReferencePart:Y.$1P,ChatResponseReferencePart2:Y.$1P,ChatResponseCodeCitationPart:Y.$2P,ChatResponseWarningPart:Y.$YP,ChatResponseTextEditPart:Y.$3P,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$RP,ChatResponseCommandButtonPart:Y.$ZP,ChatResponseDetectedParticipantPart:Y.$SP,ChatResponseConfirmationPart:Y.$TP,ChatResponseReferencePartStatusKind:Y.ChatResponseReferencePartStatusKind,ChatRequestTurn:Y.$4P,ChatResponseTurn:Y.$5P,ChatLocation:Y.ChatLocation,ChatRequestEditorData:Y.$6P,ChatRequestNotebookData:Y.$7P,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$9P,LanguageModelChatMessageFunctionResultPart:Y.$8P,LanguageModelChatResponseTextPart:Y.$$P,LanguageModelChatResponseFunctionUsePart:Y.$0P,LanguageModelError:Y.$cQ,NewSymbolName:Y.$9O,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$dQ,InlineEditTriggerKind:Y.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$4L,TextSearchMatchNew:Ct.$3L,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(Ne[277],Me([1,0,60,129,45,123,46,33,57,56,132,134,135,88,92,84,122,68,50,87,66,70,216,11,133,85,86,90,94,127,95]),function(ve,e,v,P,I,T,A,O,$,o,k,y,a,S,d,r,s,c,l,i,n,t,g,u,p,m,h,E,D,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Us)(m.$Eqc,m.$Dqc,v.InstantiationType.Delayed),(0,v.$Us)(u.$ck,g.$Trc,v.InstantiationType.Delayed),(0,v.$Us)(r.$Jpc,r.$Kpc,v.InstantiationType.Delayed),(0,v.$Us)(O.$KQ,O.$JQ,v.InstantiationType.Eager),(0,v.$Us)(E.$Tpc,E.$Upc,v.InstantiationType.Eager),(0,v.$Us)(D.$yqc,D.$zqc,v.InstantiationType.Eager),(0,v.$Us)(A.$9pc,A.$7pc,v.InstantiationType.Eager),(0,v.$Us)(c.$$pc,c.$0pc,v.InstantiationType.Eager),(0,v.$Us)(C.$Oqc,C.$Pqc,v.InstantiationType.Eager),(0,v.$Us)(y.$Tqc,y.$Xqc,v.InstantiationType.Eager),(0,v.$Us)(T.$Zqc,T.$Yqc,v.InstantiationType.Eager),(0,v.$Us)($.$zQ,$.$yQ,v.InstantiationType.Eager),(0,v.$Us)(h.$Fqc,h.$Gqc,v.InstantiationType.Eager),(0,v.$Us)(l.$Npc,l.$Mpc,v.InstantiationType.Eager),(0,v.$Us)(P.$trc,P.$src,v.InstantiationType.Delayed),(0,v.$Us)(a.$drc,a.$erc,v.InstantiationType.Eager),(0,v.$Us)(S.$rqc,S.$qqc,v.InstantiationType.Eager),(0,v.$Us)(k.$Grc,k.$Frc,v.InstantiationType.Eager),(0,v.$Us)(o.$uqc,o.$xqc,v.InstantiationType.Eager),(0,v.$Us)(w.$Hrc,w.$Irc,v.InstantiationType.Eager),(0,v.$Us)(d.$rGb,d.$sGb,v.InstantiationType.Eager),(0,v.$Us)(s.$Rrc,s.$Qrc,v.InstantiationType.Eager),(0,v.$Us)(I.$6pc,I.$5pc,v.InstantiationType.Eager),(0,v.$Us)(i.$Bqc,i.$Aqc,v.InstantiationType.Eager),(0,v.$Us)(n.$IQ,n.$FQ,v.InstantiationType.Eager),(0,v.$Us)(t.$iqc,t.$jqc,v.InstantiationType.Eager),(0,v.$Us)(p.$Mqc,p.$Nqc,v.InstantiationType.Eager)}),define(Ne[278],Me([1,0,276,47,2,273,7,10,223]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tc=void 0;class o extends T.$Wrc{j(){}getModule(S,d){for(const r of this.b){const s=r(S);if(s){S=s;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends P.$Iqc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$6tc);const S=this.h.invokeFunction(v.$Src);this.r=this.h.createInstance(o,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,r){d=d.with({path:y(d.path,".js")});const s=S?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const c=I.URI.revive(await this.C.$asBrowserUri(d)),l=await fetch(c.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),n=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(s?`Loading code for extension ${s} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const u={},p={exports:u},m=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),g(p,u,m),p.exports!==u?p.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,O.$Hh)(10)}}e.$7tc=k;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Ne[279],Me([1,0,73,60,11,47,188,91,278]),function(ve,e,v,P,I,T,A,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$Us)(I.$bk,new v.$Di(A.$Vrc,[!0],!0)),(0,P.$Us)(T.$Jqc,$.$7tc,P.InstantiationType.Eager),(0,P.$Us)(O.$_pc,O.$aqc,P.InstantiationType.Eager)}),define(Ne[287],Me([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(ve,e,v,P,I,T,A,O,$,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,O=Ve(O),$=Ve($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function r(g){self.fetch=async function(u,p){return u instanceof Request||S(String(u))&&(u=(await g(k.URI.parse(String(u)))).toString(!0)),d(u,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,p,m,h,E){(async()=>(S(p.toString())&&(p=(await g(k.URI.parse(p.toString()))).toString(!0)),super.open(u,p,m??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,p){if(/^file:/i.test(u.toString()))u=o.$1g.uriToBrowserUri(k.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(C){function R(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const f=fetch.bind(self);self.fetch=function(L,N){return L instanceof Request?f(L,N):f(R(L),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,N,M,W,G){return super.open(L,R(N),M??!0,W,G)}};const b=importScripts.bind(self);self.importScripts=(...L)=>{b(...L.map(R))},b(C)}.toString()}('${u}'))`;p=p||{},p.name=`${name} -> ${p.name||O.$oc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,p)}}else self.Worker=class extends A.$8tc{constructor(g,u){super(a,g,{name:O.$oc(g.toString()),...u})}};const s=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const u=new MessageChannel,p=new P.$me;let m=!1;a(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Oe.wrap(new Uint8Array(E,0,E.byteLength));if((0,I.$Dn)(D,I.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}p.fire(D)},this.protocol={onMessage:p.event,send:h=>{if(!m){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const p=g.onMessage(m=>{p.dispose();const h=JSON.parse(m.toString());g.send((0,I.$Cn)(I.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,I.$Cn)(I.MessageType.Ready))})}let i=g=>y();function n(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(u){n(u)&&l(g.protocol).then(p=>{$.mark("code/extHost/didWaitForInitData");const m=new T.$Yrc(p.protocol,p.initData,s,null,u.data);r(h=>m.asBrowserUri(h)),i=h=>m.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/d4c4e690b9f1e70291da9a46c5c8ac5ebfbda81a/core/vs/workbench/api/worker/extensionHostWorker.js.map
